# Krylov.jl: A Julia basket of hand-picked Krylov methods

| **Documentation** | **CI** | **Coverage** | **DOI** | **Downloads** |
|:-----------------:|:------:|:------------:|:-------:|:-------------:|
| [![docs-stable][docs-stable-img]][docs-stable-url] [![docs-dev][docs-dev-img]][docs-dev-url] | [![build-gh][build-gh-img]][build-gh-url] | [![codecov][codecov-img]][codecov-url] | [![doi][doi-img]][doi-url] | [![downloads][downloads-img]][downloads-url] |

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://JuliaSmoothOptimizers.github.io/Krylov.jl/stable
[docs-dev-img]: https://img.shields.io/badge/docs-dev-purple.svg
[docs-dev-url]: https://JuliaSmoothOptimizers.github.io/Krylov.jl/dev
[build-gh-img]: https://github.com/JuliaSmoothOptimizers/Krylov.jl/actions/workflows/ci.yml/badge.svg
[build-gh-url]: https://github.com/JuliaSmoothOptimizers/Krylov.jl/actions/workflows/ci.yml
[build-cirrus-img]: https://img.shields.io/cirrus/github/JuliaSmoothOptimizers/Krylov.jl?logo=Cirrus%20CI
[build-cirrus-url]: https://cirrus-ci.com/github/JuliaSmoothOptimizers/Krylov.jl
[codecov-img]: https://codecov.io/gh/JuliaSmoothOptimizers/Krylov.jl/branch/main/graph/badge.svg
[codecov-url]: https://app.codecov.io/gh/JuliaSmoothOptimizers/Krylov.jl
[doi-img]: https://joss.theoj.org/papers/10.21105/joss.05187/status.svg
[doi-url]: https://doi.org/10.21105/joss.05187
[downloads-img]: https://img.shields.io/badge/dynamic/json?url=http%3A%2F%2Fjuliapkgstats.com%2Fapi%2Fv1%2Fmonthly_downloads%2FKrylov&query=total_requests&suffix=%2Fmonth&label=Downloads
[downloads-url]: https://juliapkgstats.com/pkg/Krylov

## How to Cite

If you use Krylov.jl in your work, please cite it using the metadata given in [`CITATION.cff`](https://github.com/JuliaSmoothOptimizers/Krylov.jl/blob/main/CITATION.cff).

#### BibTeX

```
@article{montoison-orban-2023,
  author  = {Montoison, Alexis and Orban, Dominique},
  title   = {{Krylov.jl: A Julia basket of hand-picked Krylov methods}},
  journal = {Journal of Open Source Software},
  volume  = {8},
  number  = {89},
  pages   = {5187},
  year    = {2023},
  doi     = {10.21105/joss.05187}
}
```

## Content

This package provides implementations of certain of the most useful Krylov method for a variety of problems:

1. Square or rectangular full-rank systems

<p align="center">
  <b><i>Ax = b</i></b>
</p>

should be solved when **_b_** lies in the range space of **_A_**. This situation occurs when
  * **_A_** is square and nonsingular,
  * **_A_** is tall and has full column rank and **_b_** lies in the range of **_A_**.

2. Linear least-squares problems

<p align="center">
  minimize ‖<b><i>b</i></b> - <b><i>Ax</i></b>‖
</p>

should be solved when **_b_** is not in the range of **_A_** (inconsistent systems), regardless of the shape and rank of **_A_**. This situation mainly occurs when
  * **_A_** is square and singular,
  * **_A_** is tall and thin.

Underdetermined systems are less common but also occur.

If there are infinitely many such **_x_** (because **_A_** is column rank-deficient), one with minimum norm is identified

<p align="center">
  minimize ‖<b><i>x</i></b>‖ &nbsp; subject to &nbsp; <b><i>x</i></b> ∈ argmin ‖<b><i>b</i></b> - <b><i>Ax</i></b>‖.
</p>

3. Linear least-norm problems

<p align="center">
  minimize ‖<b><i>x</i></b>‖ &nbsp; subject to &nbsp; <b><i>Ax = b</i></b>
</p>

should be solved when **_A_** is column rank-deficient but **_b_** is in the range of **_A_** (consistent systems), regardless of the shape of **_A_**.
This situation mainly occurs when
  * **_A_** is square and singular,
  * **_A_** is short and wide.

Overdetermined systems are less common but also occur.

4. Adjoint systems

<p align="center">
  <b><i>Ax = b</i></b> &nbsp; and &nbsp; <b><i>Aᴴy = c</i></b>
</p>

where **_A_** can have any shape.

5. Saddle-point and Hermitian quasi-definite systems

<p align="center">
  [<b><i>M </i></b>&nbsp;&nbsp;&nbsp;<b><i> A</i></b>]&nbsp; [<b><i>x</i></b>]            =           [<b><i>b</i></b>]
  <br>
  [<b><i>Aᴴ</i></b>&nbsp;&nbsp;      <b><i>-N</i></b>]&nbsp; [<b><i>y</i></b>]&nbsp;&nbsp;&nbsp;&nbsp;[<b><i>c</i></b>]
</p>

where **_A_** can have any shape.

6. Generalized saddle-point and non-Hermitian partitioned systems

<p align="center">
  [<b><i>M</i></b>&nbsp;&nbsp;&nbsp;<b><i>A</i></b>]&nbsp; [<b><i>x</i></b>]            =           [<b><i>b</i></b>]
  <br>
  [<b><i>B</i></b>&nbsp;&nbsp;&nbsp;<b><i>N</i></b>]&nbsp; [<b><i>y</i></b>]&nbsp;&nbsp;&nbsp;&nbsp;[<b><i>c</i></b>]
</p>

where **_A_** can have any shape and **_B_** has the shape of **_Aᴴ_**.
**_A_**, **_B_**, **_b_** and **_c_** must be all nonzero.

Krylov solvers are particularly appropriate in situations where such problems must be solved but a factorization is not possible, either because:
* **_A_** is not available explicitly,
* **_A_** would be dense or would consume an excessive amount of memory if it were materialized,
* factors would consume an excessive amount of memory.

Iterative methods are recommended in either of the following situations:
* the problem is sufficiently large that a factorization is not feasible or would be slow,
* an effective preconditioner is known in cases where the problem has unfavorable spectral structure,
* the operator can be represented efficiently as a sparse matrix,
* the operator is *fast*, i.e., can be applied with better complexity than if it were materialized as a matrix. Certain fast operators would materialize as *dense* matrices.

## Features

All solvers in Krylov.jl have in-place version, are compatible with **GPU** and work in any floating-point data type.

Krylov.jl also provides **C and Fortran interfaces** and a shared library (`libkrylov`).
See the [C and Fortran interfaces](https://jso.dev/Krylov.jl/dev/interfaces/overview/) documentation for the API, examples, and build instructions.
Pre-built artifacts are available on the [Releases](https://github.com/JuliaSmoothOptimizers/Krylov.jl/releases) page.

## How to Install

Krylov can be installed and tested through the Julia package manager:

```julia
julia> ]
pkg> add Krylov
pkg> test Krylov
```

## Bug reports and discussions

If you think you found a bug, feel free to open an [issue](https://github.com/JuliaSmoothOptimizers/Krylov.jl/issues).
Focused suggestions and requests can also be opened as issues. Before opening a pull request, start an issue or a discussion on the topic, please.

If you want to ask a question not suited for a bug report, feel free to start a discussion [here](https://github.com/JuliaSmoothOptimizers/Organization/discussions). This forum is for general discussion about this repository and the [JuliaSmoothOptimizers](https://github.com/JuliaSmoothOptimizers) organization, so questions about any of our packages are welcome.

# LibKrylov — C and Fortran interface for Krylov.jl

Exposes the Krylov.jl solvers as a native shared library (`libkrylov`) callable from C, Fortran, and any language with a C FFI.

📖 **Full documentation** (API, examples, return codes, block solvers): <https://jso.dev/Krylov.jl/dev/interfaces/overview/>

Pre-built, self-contained bundles for Linux, macOS and Windows are attached to every [release](https://github.com/JuliaSmoothOptimizers/Krylov.jl/releases). The rest of this file is for building the library from source; see the documentation for how to *use* it.

## Requirements

| Tool | Version |
|------|---------|
| Julia | ≥ 1.12 |
| [JuliaC.jl](https://github.com/JuliaLang/JuliaC.jl) | ≥ 0.3.8 |
| C / Fortran compiler | gcc / clang, gfortran |

[JuliaC.jl](https://github.com/JuliaLang/JuliaC.jl) wraps Julia's `juliac` compiler and adds `--bundle`, which produces a self-contained library that embeds the Julia runtime (no separate Julia installation required at run time).

## Build

All commands run from the **root of the Krylov.jl repository**.

```bash
# Install JuliaC.jl once (installs juliac into ~/.julia/bin)
julia -e 'import Pkg; Pkg.Apps.add(url="https://github.com/JuliaLang/JuliaC.jl", rev="v0.3.8")'
export PATH="$HOME/.julia/bin:$PATH"

# Build the bundle (library + embedded Julia runtime)
juliac \
    --project . \
    --compile-ccallable \
    --trim=safe \
    --bundle interfaces/build \
    --output-lib interfaces/build/lib/libkrylov.so \
    interfaces/src/LibKrylov.jl

# Generate the headers and copy them next to the library
julia --startup-file=no --project=. interfaces/scripts/generate_header.jl
cp interfaces/include/krylov.h   interfaces/build/include/
cp interfaces/include/krylov.f90 interfaces/build/include/

# Copy the SuiteSparse libraries into the bundle.
# juliac --bundle does not trace libraries that Julia dlopen's at startup
# (SparseArrays -> SuiteSparse_jll). Without this the bundle runs only on a
# machine that already has Julia. On Windows the libs are in Sys.BINDIR (bin/).
JLIB="$(julia --startup-file=no -e 'print(joinpath(Sys.BINDIR, "..", "lib", "julia"))')"
for name in amd btf camd ccolamd cholmod colamd klu ldl rbio spqr suitesparseconfig umfpack; do
    cp -a "$JLIB"/lib"$name".* interfaces/build/lib/julia/
done
```

The `--bundle` flag produces a relocatable directory:

```
interfaces/build/
├── lib/
│   ├── libkrylov.so     ← the library
│   └── julia/           ← embedded Julia runtime (no system Julia needed)
└── include/
    ├── krylov.h
    └── krylov.f90
```

> **Windows:** use `--output-lib interfaces/build/bin/libkrylov.dll`; the bundle lands in `build/bin/`, and the SuiteSparse libraries are taken from `Sys.BINDIR` (`bin/`).
> **macOS:** replace `.so` with `.dylib`.

Compiling and linking a C or Fortran program against the bundle is documented in the [building guide](https://jso.dev/Krylov.jl/dev/interfaces/building/).

## Directory structure

```
interfaces/
├── src/
│   ├── LibKrylov.jl          # @ccallable functions (compiled by juliac)
│   ├── c_enums.jl            # option-struct mirrors (KrylovOptions, ...)
│   ├── c_operator.jl         # C callback → Julia mul! operator (incl. block)
│   └── c_stores.jl           # AUTO-GENERATED — typed workspace stores
├── scripts/
│   ├── generate_header.jl    # generates include/krylov.h
│   ├── generate_stores.jl    # regenerates src/c_stores.jl (run when adding solvers)
│   ├── solver_table.jl       # single source of truth for the solver list
│   └── trim_sparsearrays.jl  # CI only — strips SparseArrays from the shipped bundle
├── include/
│   ├── krylov.h              # generated C header — do not edit by hand
│   └── krylov.f90            # Fortran bindings (hand-maintained)
├── examples/
│   ├── C/{basic_cg,preconditioning,least_squares,block_gmres}.c
│   └── Fortran/{basic_cg,block_gmres}.f90
├── test/
│   ├── test_libkrylov.jl     # Julia unit tests (no dlopen)
│   ├── C/
│   │   ├── test_all_solvers.c  # convergence of every solver
│   │   ├── test_api.c          # options, preconditioner, warm start, error codes
│   │   └── test_block.c        # block_gmres / block_minres
│   └── Fortran/
│       ├── test_all_solvers.f90
│       └── test_block.f90      # block_gmres / block_minres
└── README.md
```

function residuals_ls(A, b, shifts, x)
  nshifts = length(shifts)
  r = [ (A' * (b - A * x[i]) - shifts[i] * x[i]) for i = 1 : nshifts ]
  return r
end

@testset "cgls_lanczos_shift" begin
  cgls_lanczos_shift_tol = 1.0e-6

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      for npower = 1 : 4
        (b, A, D, HY, HZ, Acond, rnorm) = test(40, 40, 4, npower, 0)  # No regularization.
        shifts = [1.0; 2.0; 3.0; 4.0; 5.0; 6.0]
        (x, stats) = cgls_lanczos_shift(A, b, shifts)
        r = residuals_ls(A, b, shifts, x)
        resids = map(norm, r) / norm(A' * b)
        @test all(resids .≤ cgls_lanczos_shift_tol)
        @test(stats.solved)
      end

      # Test b == 0
      A, b = zero_rhs(FC=FC)
      (x, stats) = cgls_lanczos_shift(A, b, shifts)
      for xi ∈ x
        @test norm(xi) == 0
      end
      @test stats.status == "x is a zero-residual solution"

      # Not implemented
      # Test with Jacobi (or diagonal) preconditioner
      # A, b, M = square_preconditioned(FC=FC)
      # shifts = [1.0; 2.0; 3.0; 4.0; 5.0; 6.0]
      # (x, stats) = cgls_lanczos_shift(A, b, shifts, M=M)
      # r = residuals(A, b, shifts, x)
      # resids = map(norm, r) / norm(b)
      # @test(all(resids .≤ cgls_lanczos_shift_tol))
      # @test(stats.solved)

      # Test different types for input and output
      A, b = symmetric_definite(FC=FC)
      shifts = [1.0; 2.0; 3.0; 4.0; 5.0; 6.0]
      workspace = CglsLanczosShiftWorkspace(KrylovConstructor(b, TestVector(b)), length(shifts))
      cgls_lanczos_shift!(workspace, A, b, shifts)
      @test workspace.stats.solved
      @test typeof(workspace.x) === Vector{TestVector{FC}}

      A, b, c, D = small_sp(false, FC=FC)
      workspace = CglsWorkspace(KrylovConstructor(TestVector(b), c))
      cgls!(workspace, A, TestVector(b), M=inv(D), λ=1.0)
      @test typeof(workspace.x) === typeof(c)
      workspace = CglsWorkspace(KrylovConstructor(b, TestVector(c)))
      cgls!(workspace, A, b, M=inv(D), λ=1.0)
      @test typeof(workspace.x) === typeof(TestVector(c))

      # test callback function
      A, b = symmetric_definite(FC=FC)
      shifts = [1.0; 2.0; 3.0; 4.0; 5.0; 6.0]
      workspace = CglsLanczosShiftWorkspace(A, b, length(shifts))
      tol = 1.0e-1
      cb_n2 = TestCallbackN2LSShifts(A, b, shifts, tol = tol)
      cgls_lanczos_shift!(workspace, A, b, shifts, atol = 0.0, rtol = 0.0, callback = cb_n2)
      @test workspace.stats.status == "user-requested exit"
      @test cb_n2(workspace)

      @test_throws TypeError cg_lanczos_shift(A, b, shifts, callback = workspace -> "string", history = true)
    end
  end
end

@testset "gpmr" begin
  gpmr_tol = 1.0e-6

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      # Test specific breakdowns
      A, b, c = ssy_mo_breakdown2(FC)
      K = [I A; A' I]
      d = [b; c]
      x, y, stats = gpmr(A, A', b, c)
      r = d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ gpmr_tol)

      A, b, c = ssy_mo_breakdown3(FC)
      K = [I A; A' I]
      d = [b; c]
      x, y, stats = gpmr(A, A', b, c)
      r = d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ gpmr_tol)

      for transpose ∈ (false, true)
        A, B, b, c, M, N = gsp(transpose, FC=FC)
        K = [I A; B I]
        d = [b; c]

        # Test b == 0 or c == 0
        m = length(b)
        b_zero = zeros(m)
        x, y, stats = gpmr(A, B, b_zero, c)
        rhs = [b_zero; c]
        r = rhs - K * [x; y]
        resid = norm(r) / norm(rhs)
        @test(resid ≤ gpmr_tol)

        n = length(c)
        c_zero = zeros(n)
        x, y, stats = gpmr(A, B, b, c_zero)
        rhs = [b; c_zero]
        r = rhs - K * [x; y]
        resid = norm(r) / norm(rhs)
        @test(resid ≤ gpmr_tol)

        # Test reorthogonalization
        x, y, stats = gpmr(A, B, b, c, reorthogonalization=true)
        r =  d - K * [x; y]
        resid = norm(r) / norm(d)
        @test(resid ≤ gpmr_tol)

        M⁻¹ = inv(M)
        N⁻¹ = inv(N)
        H⁻¹ = blockdiag(sparse(M⁻¹), sparse(N⁻¹))
        P⁻¹ = blockdiag(sparse(sqrt(M⁻¹)), sparse(sqrt(N⁻¹)))
        K = [M A; B N]

        # Test left preconditioning
        x, y, stats = gpmr(A, B, b, c, C=M⁻¹, D=N⁻¹)
        r =  d - K * [x; y]
        resid = norm(H⁻¹ * r) / norm(H⁻¹ * d)
        @test(resid ≤ gpmr_tol)

        # Test right preconditioning
        x, y, stats = gpmr(A, B, b, c, E=M⁻¹, F=N⁻¹)
        res = norm(d - K * [x; y])
        resid = norm(r) / norm(d)
        @test(resid ≤ gpmr_tol)

        # Test split preconditioning
        x, y, stats = gpmr(A, B, b, c, C=sqrt(M⁻¹), D=sqrt(N⁻¹), E=sqrt(M⁻¹), F=sqrt(N⁻¹))
        res = norm(d - K * [x; y])
        resid = norm(P⁻¹ * r) / norm(P⁻¹ * d)
        @test(resid ≤ gpmr_tol)

        # Test breakdowns
        A, b, c = ssy_mo_breakdown(transpose, FC=FC)
        λ = one(FC)
        μ = -one(FC)
        K = [I A; A' -I]
        d = [b; c]
        x, y, stats = gpmr(A, A', b, c, λ=λ, μ=μ)
        r =  d - K * [x; y]
        resid = norm(r) / norm(d)
        @test(resid ≤ gpmr_tol)

        # Test inconsistent linear systems
        A, b, c = ssy_mo_breakdown(transpose, FC=FC)
        K = [I A; A' I]
        d = [b; c]
        n, m = size(K)
        p = rank(K)
        @test(p < n)
        x, y, stats = gpmr(A, A', b, c)
        r =  d - K * [x; y]
        Aresid = norm(K' * r) / norm(K' * d)
        @test(Aresid ≤ gpmr_tol)
        @test(stats.inconsistent)
      end

      # Test underdetermined adjoint systems.
      A, b, c = underdetermined_adjoint(FC=FC)
      (x, y, stats) = gpmr(A, A', b, c, λ=zero(FC), μ=zero(FC))
      r = b - A  * y
      s = c - A' * x
      resid = norm([r; s]) / norm([b; c])
      @test(resid ≤ gpmr_tol)

      # Test square adjoint systems.
      A, b, c = square_adjoint(FC=FC)
      (x, y, stats) = gpmr(A, A', b, c, λ=zero(FC), μ=zero(FC))
      r = b - A  * y
      s = c - A' * x
      resid = norm([r; s]) / norm([b; c])
      @test(resid ≤ gpmr_tol)

      # Test overdetermined adjoint systems
      A, b, c = overdetermined_adjoint(FC=FC)
      (x, y, stats) = gpmr(A, A', b, c, λ=zero(FC), μ=zero(FC))
      r = b - A  * y
      s = c - A' * x
      resid = norm([r; s]) / norm([b; c])
      @test(resid ≤ gpmr_tol)

      # Test adjoint ODEs.
      A, b, c = adjoint_ode(FC=FC)
      (x, y, stats) = gpmr(A, A', b, c, λ=0.0, μ=0.0)
      r = b - A  * y
      s = c - A' * x
      resid = norm([r; s]) / norm([b; c])
      @test(resid ≤ gpmr_tol)

      # Test adjoint PDEs.
      A, b, c = adjoint_pde(FC=FC)
      (x, y, stats) = gpmr(A, A', b, c, λ=0.0, μ=0.0)
      r = b - A  * y
      s = c - A' * x
      resid = norm([r; s]) / norm([b; c])
      @test(resid ≤ gpmr_tol)

      # Test saddle-point systems
      A, b, D = saddle_point(FC=FC)
      m, n = size(A)
      c = -b
      D⁻¹ = sparse(inv(D))
      N⁻¹ = eye(n)
      H⁻¹ = blockdiag(D⁻¹, N⁻¹)
      G⁻¹ = blockdiag(N⁻¹, D⁻¹)

      (x, y, stats) = gpmr(A, A', b, c, gsp=true, E=D⁻¹)
      K = [D A; A' spzeros(n, n)]
      d = [b; c]
      r =  d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ gpmr_tol)

      (x, y, stats) = gpmr(A, A', b, c, gsp=true, C=D⁻¹)
      r =  d - K * [x; y]
      resid = norm(H⁻¹ * r) / norm(H⁻¹ * d)
      @test(resid ≤ gpmr_tol)

      (x, y, stats) = gpmr(A, A', b, c, gsp=true)
      K = [eye(m) A; A' spzeros(n, n)]
      d = [b; c]
      r =  d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ gpmr_tol)

      (x, y, stats) = gpmr(A, A', b, c, λ=0.0, μ=1.0, F=D⁻¹)
      K = [spzeros(m, m) A; A' D]
      d = [b; c]
      r =  d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ gpmr_tol)

      (x, y, stats) = gpmr(A, A', b, c, λ=0.0, μ=1.0, D=D⁻¹)
      r =  d - K * [x; y]
      resid = norm(G⁻¹ * r) / norm(G⁻¹ * d)
      @test(resid ≤ gpmr_tol)

      (x, y, stats) = gpmr(A, A', b, c, λ=0.0, μ=1.0)
      K = [spzeros(m, m) A; A' eye(n)]
      d = [b; c]
      r =  d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ gpmr_tol)

      # Test symmetric and quasi-definite systems
      A, b, M, N = sqd(FC=FC)
      m, n = size(A)
      c = -b
      M⁻¹ = sparse(inv(M))
      N⁻¹ = sparse(inv(N))
      H⁻¹ = blockdiag(M⁻¹, N⁻¹)

      (x, y, stats) = gpmr(A, A', b, c, E=M⁻¹, F=N⁻¹, λ=1.0, μ=-1.0)
      K = [M A; A' -N]
      d = [b; c]
      r =  d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ gpmr_tol)

      (x, y, stats) = gpmr(A, A', b, c, C=M⁻¹, D=N⁻¹, λ=1.0, μ=-1.0)
      r =  d - K * [x; y]
      resid = norm(H⁻¹ * r) / norm(H⁻¹ * d)
      @test(resid ≤ gpmr_tol)

      (x, y, stats) = gpmr(A, A', b, c, λ=1.0, μ=-1.0)
      K = [eye(m) A; A' -eye(n)]
      d = [b; c]
      r =  d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ gpmr_tol)

      λ = 12.0; μ =-0.7
      (x, y, stats) = gpmr(A, A', b, c, E=M⁻¹, F=N⁻¹, λ=λ, μ=μ)
      K = [λ*M A; A' μ*N]
      d = [b; c]
      r =  d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ gpmr_tol)

      (x, y, stats) = gpmr(A, A', b, c, C=M⁻¹, D=N⁻¹, λ=λ, μ=μ)
      r =  d - K * [x; y]
      resid = norm(H⁻¹ * r) / norm(H⁻¹ * d)
      @test(resid ≤ gpmr_tol)

      (x, y, stats) = gpmr(A, A', b, c, λ=λ, μ=μ)
      K = [λ*eye(m) A; A' μ*eye(n)]
      d = [b; c]
      r =  d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ gpmr_tol)

      λ = -1e-6; μ =1e-8
      (x, y, stats) = gpmr(A, A', b, c, E=M⁻¹, F=N⁻¹, λ=λ, μ=μ)
      K = [λ*M A; A' μ*N]
      d = [b; c]
      r =  d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ gpmr_tol)

      (x, y, stats) = gpmr(A, A', b, c, C=M⁻¹, D=N⁻¹, λ=λ, μ=μ)
      r =  d - K * [x; y]
      resid = norm(H⁻¹ * r) / norm(H⁻¹ * d)
      @test(resid ≤ gpmr_tol)

      (x, y, stats) = gpmr(A, A', b, c, λ=λ, μ=μ)
      K = [λ*eye(m) A; A' μ*eye(n)]
      d = [b; c]
      r =  d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ gpmr_tol)

      # Test symmetric positive definite systems
      (x, y, stats) = gpmr(A, A', b, c, E=M⁻¹, F=N⁻¹)
      K = [M A; A' N]
      d = [b; c]
      r =  d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ gpmr_tol)

      (x, y, stats) = gpmr(A, A', b, c, C=M⁻¹, D=N⁻¹)
      r =  d - K * [x; y]
      resid = norm(H⁻¹ * r) / norm(H⁻¹ * d)
      @test(resid ≤ gpmr_tol)

      (x, y, stats) = gpmr(A, A', b, c)
      K = [eye(m) A; A' eye(n)]
      d = [b; c]
      r =  d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ gpmr_tol)

      # Test symmetric negative definite systems
      (x, y, stats) = gpmr(A, A', b, c, E=M⁻¹, F=N⁻¹, λ=-1.0, μ=-1.0)
      K = [-M A; A' -N]
      d = [b; c]
      r =  d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ gpmr_tol)

      (x, y, stats) = gpmr(A, A', b, c, C=M⁻¹, D=N⁻¹, λ=-1.0, μ=-1.0)
      r =  d - K * [x; y]
      resid = norm(H⁻¹ * r) / norm(H⁻¹ * d)
      @test(resid ≤ gpmr_tol)

      (x, y, stats) = gpmr(A, A', b, c, λ=-1.0, μ=-1.0)
      K = [-eye(m) A; A' -eye(n)]
      d = [b; c]
      r =  d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ gpmr_tol)

      # Test dimension of additional vectors
      for transpose ∈ (false, true)
        A, b, c, M, N = small_sqd(transpose, FC=FC)
        M⁻¹ = inv(M)
        N⁻¹ = inv(N)
        (x, y, stats) = gpmr(A, A', b, c, E=M⁻¹, F=N⁻¹)
        (x, y, stats) = gpmr(A, A', b, c, C=M⁻¹, D=N⁻¹)
      end

      # Test different types for b and c
      A, b, _ = saddle_point(FC=FC)
      (x, y, stats) = gpmr(A, A', b, -b)
      c = TestVector(-b)
      workspace = GpmrWorkspace(KrylovConstructor(b, c))
      @test typeof(workspace.x) === typeof(b)
      @test typeof(workspace.y) === typeof(c)
      gpmr!(workspace, A, A', b, c)
      xt, yt = workspace.x, workspace.y
      @test typeof(xt) === typeof(b)
      @test typeof(yt) === typeof(c)

      # test callback function
      # Not testing with an interesting callback because workspace.x and workspace.y are not updated
      # until the end of the algorithm (TODO: be able to evaluate workspace.x and workspace.y ?)
      A, b, c = square_adjoint(FC=FC)
      workspace = GpmrWorkspace(A, b; memory = 20)
      gpmr!(workspace, A, A', b, c, callback = workspace -> true)
      @test workspace.stats.status == "user-requested exit"

      @test_throws TypeError gpmr(A, A', b, c, callback = workspace -> "string", history = true)
    end
  end
end

#!/usr/bin/env julia
# generate_stores.jl — generates src/c_stores.jl
# Run: julia --startup-file=no --project=<root> scripts/generate_stores.jl
#
# Re-run whenever new solvers are added to Krylov.jl.

# ---------------------------------------------------------------------------
# Solver table: (c_name, workspace_type_name)
# ---------------------------------------------------------------------------
include(joinpath(@__DIR__, "solver_table.jl"))

# ---------------------------------------------------------------------------
# Precision table: (dtype_int, suffix, T_real, FC, S)
# ---------------------------------------------------------------------------
const DTYPES = [
  (0, "f32",  "Float32", "Float32",    "Vector{Float32}"),
  (1, "f64",  "Float64", "Float64",    "Vector{Float64}"),
  (2, "cf32", "Float32", "ComplexF32", "Vector{ComplexF32}"),
  (3, "cf64", "Float64", "ComplexF64", "Vector{ComplexF64}"),
]

# Combo key: solver_idx * 4 + dtype_idx  (max = 33*4+3 = 135, fits UInt8)
combo_key(si, di) = UInt8(si * 4 + di)
store_name(sname, suffix) = "store_$(sname)_$(suffix)"
solver_idx(si) = si - 1   # 0-based, matches KrylovSolverType enum value

# Solvers that require two RHS vectors (b of size m and c of size n)
const TWO_RHS_SOLVERS = Set(["tricg", "trimr", "bilqr", "trilqr", "usymlq", "usymqr", "usymlqr"])

# gpmr uses (A, B, b, c): fptr_At slot is repurposed as the B operator (n×m)
const GPMR_SOLVER = "gpmr"

# Solver categories for extra KrylovOptions fields (solve-time)
const TAU_NU_SOLVERS = Set(["tricg", "trimr"])

# Least-squares / least-norm solvers and their preconditioners.  Krylov's
# convention is M = E⁻¹ (acts on the m-dimensional data space) and N = F⁻¹ (the
# n-dimensional solution space), so for these solvers the matvec_M callback sees
# length-m vectors and matvec_N length-n.  The normal-equations methods are the
# exception: CGLS/CRLS take a single preconditioner on the n-space (passed as
# matvec_M), and CGNE/CRMR a single one on the n-space (passed as matvec_N).
const LS_MN_RADIUS_SOLVERS = Set(["lsqr", "lsmr"])                     # M(m) + N(n) + λ + radius
const LS_MN_SOLVERS        = Set(["lslq", "craig", "craigmr", "lnlq"]) # M(m) + N(n) + λ
const LS_M_RADIUS_SOLVERS  = Set(["cgls", "crls"])                    # M(n) + λ + radius
const LS_N_SOLVERS         = Set(["cgne", "crmr"])                    # N(n) + λ

# Square (non-symmetric) solvers that accept BOTH a left (M) and a right (N)
# preconditioner — the only family where the C interface exposes matvec_N.
# Mirrors the Krylov.jl solvers whose keyword list contains both :M and :N for
# a square operator.  Symmetric solvers (cg, cr, minres, ...) take M only;
# least-squares / least-norm and gpmr families are handled by their own helpers.
const MN_SOLVERS = Set(["gmres", "fgmres", "fom", "diom", "dqgmres", "bicgstab", "cgs", "bilq", "qmr"])

# ---------------------------------------------------------------------------
# Optional scalar solve-time options, gated per solver (mirrors the Krylov.jl
# keyword lists).  These determine which generated helper a solver routes to,
# so an option is only ever forwarded to a solver that actually accepts it.
# ---------------------------------------------------------------------------
# M + N + restart + reorthogonalization
const GMRES_FAMILY    = Set(["gmres", "fgmres", "fom"])
# M + N + reorthogonalization (limited-memory Arnoldi, no restart)
const DIOM_FAMILY     = Set(["diom", "dqgmres"])
# M + radius + linesearch
const CG_FAMILY       = Set(["cg", "cr"])
# M + linesearch + λ (shift)
const MINRES_FAMILY   = Set(["minres", "minres_qlp"])
# M + λ (shift) — symmetric, no linesearch
const SYM_LAMBDA_SOLVERS = Set(["symmlq", "minares"])

# Solver categories for KrylovWorkspaceOptions fields (construction-time).
# These mirror exactly the Krylov.jl workspace constructors that accept the
# corresponding kwarg, e.g. GmresWorkspace(m, n, S; memory) — see
# src/krylov_workspaces.jl.  A workspace whose constructor does NOT accept the
# kwarg must never be handed it, so these sets gate the generated _do_create!.
const MEMORY_SOLVERS = Set(["gmres", "fgmres", "fom", "diom", "dqgmres", "gpmr"])
const WINDOW_SOLVERS = Set(["minres", "symmlq", "lsqr", "lsmr", "lslq"])

# Defaults used when the user leaves the sentinel 0 (must match Krylov.jl).
const MEMORY_DEFAULT = 20
const WINDOW_DEFAULT = 5

# ---------------------------------------------------------------------------
# Block Krylov solvers (BLOCK_SOLVERS defined in solver_table.jl) — a separate,
# matrix-based API (m×p block RHS).  Workspaces use SV=Vector{FC}, SM=Matrix{FC}.
# ---------------------------------------------------------------------------
const BLOCK_MEMORY_SOLVERS = Set(["block_gmres"])  # only block_gmres takes `memory`
const BLOCK_MN_SOLVERS = Set(["block_gmres"])      # only block_gmres takes a right preconditioner N
const BLOCK_MEMORY_DEFAULT = 5
block_combo_key(si, di) = UInt8(si * 4 + di)
block_store_name(sname, suffix) = "store_$(sname)_$(suffix)"

# ---------------------------------------------------------------------------
# Write c_stores.jl
# ---------------------------------------------------------------------------
out = joinpath(@__DIR__, "..", "src", "c_stores.jl")

open(out, "w") do io
  n_solvers = length(SOLVERS)
  n_combos  = n_solvers * length(DTYPES)

  println(io, """
# c_stores.jl — AUTO-GENERATED by scripts/generate_stores.jl — do not edit.
#
# $(n_solvers) solvers × $(length(DTYPES)) precisions = $(n_combos) typed workspace stores.
# Each store is a Dict{Ptr{Cvoid}, <ConcreteWorkspaceType>} that acts as a
# GC root while keeping types fully concrete for --trim=safe.
#
# Re-generate with:
#   julia --startup-file=no --project=<root> scripts/generate_stores.jl
""")

  # -----------------------------------------------------------------
  # 1. Typed store dicts
  # -----------------------------------------------------------------
  println(io, """
# ---------------------------------------------------------------------------
# Typed workspace stores
# ---------------------------------------------------------------------------
""")
  for (si, (sname, wstype, _)) in enumerate(SOLVERS)
    for (di, (_, suffix, T, FC, S)) in enumerate(DTYPES)
      println(io, "const $(store_name(sname, suffix)) = ",
                  "Dict{Ptr{Cvoid}, Krylov.$(wstype){$(T), $(FC), $(S)}}()")
    end
    println(io)
  end

  # -----------------------------------------------------------------
  # 2. Key index:  handle → UInt8 combo key
  # -----------------------------------------------------------------
  println(io, """
# Single index: handle → combo key (UInt8, max=$(n_combos-1))
const ws_key_store = Dict{Ptr{Cvoid}, UInt8}()
""")

  # -----------------------------------------------------------------
  # 3. Generic typed helpers — compiled once per concrete ws type
  # -----------------------------------------------------------------
  println(io, """
# ---------------------------------------------------------------------------
# Generic typed helpers — specialized per concrete workspace type by the compiler.
# Called from within if-elseif branches where ws has a known concrete type.
# FC is extracted via the where-clause so --trim=safe can infer it statically.
# ---------------------------------------------------------------------------

function _typed_niter(ws)
  Cint(Krylov.iteration_count(ws))
end

function _typed_is_solved(ws)
  Krylov.issolved(ws) ? Cint(1) : Cint(0)
end

function _typed_elapsed_time(ws)
  Cdouble(Krylov.elapsed_time(ws))
end

function _typed_get_x!(ws::Krylov.KrylovWorkspace{T, FC, S}, x_ptr, n) where {T, FC, S}
  x = Krylov.solution(ws, 1)
  copyto!(unsafe_wrap(Vector{FC}, Ptr{FC}(x_ptr), Int(n)), x)
  Cint(0)
end

function _typed_get_y!(ws::Krylov.KrylovWorkspace{T, FC, S}, y_ptr, m) where {T, FC, S}
  Krylov.solution_count(ws) == 2 || return Cint(-2)
  y = Krylov.solution(ws, 2)
  copyto!(unsafe_wrap(Vector{FC}, Ptr{FC}(y_ptr), Int(m)), y)
  Cint(0)
end

function _typed_warm_start!(ws::Krylov.KrylovWorkspace{T, FC, S}, x0_ptr, n) where {T, FC, S}
  # Bypass Krylov.warm_start! to avoid trim-incompatible string interpolation in its
  # error path.  We inline the same logic: allocate Δx if needed, copy x0, set flag.
  hasfield(typeof(ws), :Δx) || return Cint(-2)   # solver does not support warm start
  x0 = unsafe_wrap(Vector{FC}, Ptr{FC}(x0_ptr), Int(n))
  if isempty(ws.Δx)
    ws.Δx = similar(ws.x)
  end
  copyto!(ws.Δx, x0)
  ws.warm_start = true
  Cint(0)
end

# Two-solution warm start (BiLQR, TriLQR, USYMLQR, TriCG, TriMR, GPMR): seeds
# both the primal guess x0 (size of solution(ws, 1)) and the dual guess y0 (size
# of solution(ws, 2)).  Inlined for the same trim-safety reason as above.
# nx / ny are the buffer lengths the caller passed; they must match ws.x / ws.y.
function _typed_warm_start2!(ws::Krylov.KrylovWorkspace{T, FC, S}, x0_ptr, y0_ptr, nx, ny) where {T, FC, S}
  hasfield(typeof(ws), :Δy) || return Cint(-2)   # not a two-solution solver
  (Int(nx) == length(ws.x) && Int(ny) == length(ws.y)) || return Cint(-1)
  x0 = unsafe_wrap(Vector{FC}, Ptr{FC}(x0_ptr), Int(nx))
  y0 = unsafe_wrap(Vector{FC}, Ptr{FC}(y0_ptr), Int(ny))
  isempty(ws.Δx) && (ws.Δx = similar(ws.x))
  isempty(ws.Δy) && (ws.Δy = similar(ws.y))
  copyto!(ws.Δx, x0)
  copyto!(ws.Δy, y0)
  ws.warm_start = true
  Cint(0)
end

# ---------------------------------------------------------------------------
# _opts_kw — build base keyword arguments from a KrylovOptionsC struct.
# NaN sentinels fall back to the Julia solver default (√eps(T); timemax → Inf).
# itmax=0 is always passed explicitly; Krylov.jl interprets 0 as "use default".
# atol/rtol/itmax/verbose/timemax are accepted by EVERY solver, so they live here.
# The NamedTuple type is always the same concrete type — compatible with --trim=safe.
# ---------------------------------------------------------------------------
function _opts_kw(opts::KrylovOptionsC, ::Type{T}) where T
  atol_v = isnan(opts.atol) ? sqrt(eps(T)) : T(opts.atol)
  rtol_v = isnan(opts.rtol) ? sqrt(eps(T)) : T(opts.rtol)
  tmax_v = isnan(opts.timemax) ? Inf : Float64(opts.timemax)
  (atol=atol_v, rtol=rtol_v, itmax=Int(opts.itmax), verbose=Int(opts.verbose), timemax=tmax_v)
end

# ---------------------------------------------------------------------------
# _typed_solve! variants — one per option family
# ---------------------------------------------------------------------------

# Every one/two-RHS _typed_solve* helper shares the same argument list (fptr_M is
# the left preconditioner, fptr_N the right one) so _do_solve! calls any of them
# uniformly.  There is one helper per *option set* (which scalar kwargs a solver
# accepts), so an option is only ever forwarded to a solver that supports it.
# Each call site lists its kwargs as literals → a statically-known concrete
# NamedTuple, required by --trim=safe.

# M only — CAR, CGNE, CRMR (and the catch-all).  fptr_N ignored.
function _typed_solve!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T)
  if fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.n, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; kw...)
  end
  Cint(0)
end

# M + radius + linesearch — CG, CR.
function _typed_solve_cg!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T)
  rad = T(opts.radius); ls = opts.linesearch != 0
  if fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.n, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, radius=rad, linesearch=ls, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; radius=rad, linesearch=ls, kw...)
  end
  Cint(0)
end

# M + linesearch + λ-shift — MINRES, MINRES-QLP.
function _typed_solve_minres!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T)
  λ = T(opts.lambda); ls = opts.linesearch != 0
  if fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.n, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, λ=λ, linesearch=ls, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; λ=λ, linesearch=ls, kw...)
  end
  Cint(0)
end

# M + λ-shift — SYMMLQ, MINARES (symmetric, no linesearch).
function _typed_solve_sym_lambda!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T)
  λ = T(opts.lambda)
  if fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.n, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, λ=λ, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; λ=λ, kw...)
  end
  Cint(0)
end

# M + N — BiCGSTAB, CGS, BiLQ, QMR.  The four NULL/non-NULL combinations are
# spelled out so each krylov_solve! call site is concretely typed (--trim=safe).
function _typed_solve_mn!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T)
  if fptr_M != C_NULL && fptr_N != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, N=N, kw...)
  elseif fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, kw...)
  elseif fptr_N != C_NULL
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; N=N, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; kw...)
  end
  Cint(0)
end

# M + N + reorthogonalization — DIOM, DQGMRES (limited-memory, no restart).
function _typed_solve_mn_reorth!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T)
  ro = opts.reorthogonalization != 0
  if fptr_M != C_NULL && fptr_N != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, N=N, reorthogonalization=ro, kw...)
  elseif fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, reorthogonalization=ro, kw...)
  elseif fptr_N != C_NULL
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; N=N, reorthogonalization=ro, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; reorthogonalization=ro, kw...)
  end
  Cint(0)
end

# M + N + restart + reorthogonalization — GMRES, FGMRES, FOM.
function _typed_solve_gmres!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T)
  rs = opts.restart != 0; ro = opts.reorthogonalization != 0
  if fptr_M != C_NULL && fptr_N != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, N=N, restart=rs, reorthogonalization=ro, kw...)
  elseif fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, restart=rs, reorthogonalization=ro, kw...)
  elseif fptr_N != C_NULL
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; N=N, restart=rs, reorthogonalization=ro, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; restart=rs, reorthogonalization=ro, kw...)
  end
  Cint(0)
end

# Least-squares / least-norm preconditioning follows Krylov's convention:
# M = E⁻¹ acts on the m-dimensional data space, N = F⁻¹ on the n-dimensional
# solution space (so M is sized with ws.m, N with ws.n).  λ is always passed
# (0.0 = none).  M/N combinations are spelled out for --trim=safe.

# λ + radius + M(m) + N(n) — LSQR, LSMR.
function _typed_solve_ls_mn_radius!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T); λ = T(opts.lambda); rad = T(opts.radius)
  if fptr_M != C_NULL && fptr_N != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, N=N, λ=λ, radius=rad, kw...)
  elseif fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, λ=λ, radius=rad, kw...)
  elseif fptr_N != C_NULL
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; N=N, λ=λ, radius=rad, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; λ=λ, radius=rad, kw...)
  end
  Cint(0)
end

# λ + M(m) + N(n) — LSLQ, CRAIG, CRAIGMR, LNLQ (no radius).
function _typed_solve_ls_mn!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T); λ = T(opts.lambda)
  if fptr_M != C_NULL && fptr_N != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, N=N, λ=λ, kw...)
  elseif fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, λ=λ, kw...)
  elseif fptr_N != C_NULL
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; N=N, λ=λ, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; λ=λ, kw...)
  end
  Cint(0)
end

# λ + radius + M(n) — CGLS, CRLS (CG/CR on the normal equations; single
# preconditioner on the n-space, passed via matvec_M).
function _typed_solve_ls_m_radius!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T); λ = T(opts.lambda); rad = T(opts.radius)
  if fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.n, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, λ=λ, radius=rad, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; λ=λ, radius=rad, kw...)
  end
  Cint(0)
end

# λ + N(n) — CGNE, CRMR (single preconditioner on the n-space, via matvec_N).
function _typed_solve_ls_n!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T); λ = T(opts.lambda)
  if fptr_N != C_NULL
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; N=N, λ=λ, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; λ=λ, kw...)
  end
  Cint(0)
end

# TriCG / TriMR: two-RHS + τ and ν (quasi-definite diagonal parameters).
# NaN sentinel → use Krylov.jl defaults (τ=1.0, ν=-1.0).  M/N ignored.
function _typed_solve_tau_nu!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  c  = unsafe_wrap(Vector{FC}, Ptr{FC}(c_ptr), ws.n)
  kw = _opts_kw(opts, T)
  τ  = isnan(opts.tau) ? T(1)  : T(opts.tau)
  ν  = isnan(opts.nu)  ? T(-1) : T(opts.nu)
  Krylov.krylov_solve!(ws, A, b, c; τ=τ, ν=ν, kw...)
  Cint(0)
end

# Basic two-RHS solvers (BiLQR / TriLQR / USYMLQ / USYMQR / USYMLQR).  M/N ignored.
function _typed_solve_two_rhs!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  c  = unsafe_wrap(Vector{FC}, Ptr{FC}(c_ptr), ws.n)
  kw = _opts_kw(opts, T)
  Krylov.krylov_solve!(ws, A, b, c; kw...)
  Cint(0)
end

# GPMR — fptr_At slot is repurposed as B (n×m), distinct from A (m×n).
# GPMR has its own preconditioner family (C, D, E, F), not exposed: M/N ignored.
# It does accept reorthogonalization.
function _typed_solve_gpmr!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_B, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, C_NULL, userdata)
  B  = COperator{FC}(ws.n, ws.m, fptr_B, C_NULL, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  c  = unsafe_wrap(Vector{FC}, Ptr{FC}(c_ptr), ws.n)
  kw = _opts_kw(opts, T)
  Krylov.krylov_solve!(ws, A, B, b, c; reorthogonalization=(opts.reorthogonalization != 0), kw...)
  Cint(0)
end
""")

  # -----------------------------------------------------------------
  # 4. Dispatch functions — big if-elseif on the UInt8 combo key
  # -----------------------------------------------------------------
  println(io, """
# ---------------------------------------------------------------------------
# Dispatch functions — generated if-elseif chains over all $(n_combos) combos.
# Each branch has a statically known concrete type: compatible with --trim=safe.
# ---------------------------------------------------------------------------
""")

  # Helper: emit the if-elseif header for a dispatch function
  function emit_dispatch(io, fname, sig, guard, branches_expr, fallback)
    println(io, "function $(fname)($(sig))")
    println(io, "  $(guard) || return $(fallback)")
    println(io, "  k = ws_key_store[ws_ptr]")
    first = true
    for (si, (sname, _, _)) in enumerate(SOLVERS)
      for (di, (_, suffix, _, _, _)) in enumerate(DTYPES)
        key  = combo_key(si-1, di-1)
        sref = "$(store_name(sname, suffix))[ws_ptr]"
        kw   = first ? "if" : "elseif"
        println(io, "  $(kw) k == 0x$(string(key, base=16, pad=2)); $(branches_expr(sref))")
        first = false
      end
    end
    println(io, "  else; $(fallback); end")
    println(io, "end")
    println(io)
  end

  emit_dispatch(io, "_do_niter", "ws_ptr :: Ptr{Cvoid}",
    "haskey(ws_key_store, ws_ptr)",
    sref -> "_typed_niter($(sref))",
    "Cint(-1)")

  emit_dispatch(io, "_do_is_solved", "ws_ptr :: Ptr{Cvoid}",
    "haskey(ws_key_store, ws_ptr)",
    sref -> "_typed_is_solved($(sref))",
    "Cint(-1)")

  emit_dispatch(io, "_do_elapsed_time", "ws_ptr :: Ptr{Cvoid}",
    "haskey(ws_key_store, ws_ptr)",
    sref -> "_typed_elapsed_time($(sref))",
    "Cdouble(-1.0)")

  emit_dispatch(io, "_do_get_x!", "ws_ptr :: Ptr{Cvoid}, x_ptr :: Ptr{Cvoid}, n :: Cint",
    "haskey(ws_key_store, ws_ptr)",
    sref -> "_typed_get_x!($(sref), x_ptr, n)",
    "Cint(-1)")

  emit_dispatch(io, "_do_get_y!", "ws_ptr :: Ptr{Cvoid}, y_ptr :: Ptr{Cvoid}, m :: Cint",
    "haskey(ws_key_store, ws_ptr)",
    sref -> "_typed_get_y!($(sref), y_ptr, m)",
    "Cint(-1)")

  emit_dispatch(io, "_do_warm_start!", "ws_ptr :: Ptr{Cvoid}, x0_ptr :: Ptr{Cvoid}, n :: Cint",
    "haskey(ws_key_store, ws_ptr)",
    sref -> "_typed_warm_start!($(sref), x0_ptr, n)",
    "Cint(-1)")

  emit_dispatch(io, "_do_warm_start2!", "ws_ptr :: Ptr{Cvoid}, x0_ptr :: Ptr{Cvoid}, y0_ptr :: Ptr{Cvoid}, nx :: Cint, ny :: Cint",
    "haskey(ws_key_store, ws_ptr)",
    sref -> "_typed_warm_start2!($(sref), x0_ptr, y0_ptr, nx, ny)",
    "Cint(-1)")

  # _do_solve! — dispatches to the right helper per solver type
  let sig = join(["ws_ptr :: Ptr{Cvoid}", "fptr_A :: Ptr{Cvoid}", "fptr_At :: Ptr{Cvoid}",
                  "fptr_M :: Ptr{Cvoid}", "fptr_N :: Ptr{Cvoid}", "b_ptr :: Ptr{Cvoid}", "c_ptr :: Ptr{Cvoid}",
                  "userdata :: Ptr{Cvoid}", "opts_ptr :: Ptr{Cvoid}"], ", ")
    println(io, "function _do_solve!($(sig))")
    println(io, "  haskey(ws_key_store, ws_ptr) || return Cint(-1)")
    println(io, "  opts = opts_ptr == C_NULL ? KrylovOptionsC(NaN, NaN, Cint(0), Cint(0), 0.0, NaN, NaN, NaN, 0.0, Cint(0), Cint(0), Cint(0)) : unsafe_load(Ptr{KrylovOptionsC}(opts_ptr))")
    println(io, "  k = ws_key_store[ws_ptr]")
    first = true
    for (si, (sname, _, _)) in enumerate(SOLVERS)
      fn = if sname == GPMR_SOLVER;              "_typed_solve_gpmr!"
           elseif sname in TAU_NU_SOLVERS;       "_typed_solve_tau_nu!"
           elseif sname in TWO_RHS_SOLVERS;      "_typed_solve_two_rhs!"
           elseif sname in GMRES_FAMILY;         "_typed_solve_gmres!"
           elseif sname in DIOM_FAMILY;          "_typed_solve_mn_reorth!"
           elseif sname in MN_SOLVERS;           "_typed_solve_mn!"
           elseif sname in CG_FAMILY;            "_typed_solve_cg!"
           elseif sname in MINRES_FAMILY;        "_typed_solve_minres!"
           elseif sname in SYM_LAMBDA_SOLVERS;   "_typed_solve_sym_lambda!"
           elseif sname in LS_MN_RADIUS_SOLVERS; "_typed_solve_ls_mn_radius!"
           elseif sname in LS_MN_SOLVERS;        "_typed_solve_ls_mn!"
           elseif sname in LS_M_RADIUS_SOLVERS;  "_typed_solve_ls_m_radius!"
           elseif sname in LS_N_SOLVERS;         "_typed_solve_ls_n!"
           else                                  "_typed_solve!"
           end
      for (di, (_, suffix, _, _, _)) in enumerate(DTYPES)
        key  = combo_key(si-1, di-1)
        sref = "$(store_name(sname, suffix))[ws_ptr]"
        kw   = first ? "if" : "elseif"
        println(io, "  $(kw) k == 0x$(string(key, base=16, pad=2)); $(fn)($(sref), fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)")
        first = false
      end
    end
    println(io, "  else; Cint(-1); end")
    println(io, "end")
    println(io)
  end

  # _do_free! — deletes from the right store AND the key index
  println(io, "function _do_free!(ws_ptr :: Ptr{Cvoid})")
  println(io, "  haskey(ws_key_store, ws_ptr) || return Cint(1)")
  println(io, "  k = ws_key_store[ws_ptr]")
  println(io, "  delete!(ws_key_store, ws_ptr)")
  first = true
  for (si, (sname, _, _)) in enumerate(SOLVERS)
    for (di, (_, suffix, _, _, _)) in enumerate(DTYPES)
      key = combo_key(si-1, di-1)
      kw  = first ? "if" : "elseif"
      println(io, "  $(kw) k == 0x$(string(key, base=16, pad=2)); delete!($(store_name(sname, suffix)), ws_ptr)")
      first = false
    end
  end
  println(io, "  end")
  println(io, "  Cint(0)")
  println(io, "end")
  println(io)

  # _do_create! — dispatch on (solver_int, dtype_int), stores in right dict.
  # Construction-time options (memory / window) come from KrylovWorkspaceOptionsC;
  # each branch passes the kwarg ONLY if the corresponding constructor accepts it.
  println(io, "function _do_create!(solver_int :: Cint, m :: Cint, n :: Cint,")
  println(io, "                     dtype_int :: Cint, wopts :: KrylovWorkspaceOptionsC,")
  println(io, "                     ws_out :: Ptr{Ptr{Cvoid}})")
  println(io, "  mem = wopts.memory == 0 ? $(MEMORY_DEFAULT) : Int(wopts.memory)")
  println(io, "  win = wopts.window == 0 ? $(WINDOW_DEFAULT) : Int(wopts.window)")
  first = true
  for (si, (sname, wstype, _)) in enumerate(SOLVERS)
    ctor_kw = if sname in MEMORY_SOLVERS; "; memory = mem"
              elseif sname in WINDOW_SOLVERS; "; window = win"
              else ""
              end
    for (di, (dtype_int, suffix, T, FC, S)) in enumerate(DTYPES)
      key      = combo_key(si-1, di-1)
      kw       = first ? "if" : "elseif"
      sref     = store_name(sname, suffix)
      sidx     = solver_idx(si)
      println(io, "  $(kw) solver_int == Cint($(sidx)) && dtype_int == Cint($(dtype_int))")
      println(io, "    ws = Krylov.$(wstype)(Int(m), Int(n), $(S)$(ctor_kw))")
      println(io, "    r  = Base.pointer_from_objref(ws)")
      println(io, "    $(sref)[r] = ws; ws_key_store[r] = 0x$(string(key, base=16, pad=2))")
      println(io, "    unsafe_store!(ws_out, r)")
      first = false
    end
  end
  println(io, "  else")
  println(io, "    return Cint(-2)  # unknown (solver, dtype) combination")
  println(io, "  end")
  println(io, "  Cint(0)")
  println(io, "end")
  println(io)

  # =======================================================================
  # Block Krylov interface (block_gmres / block_minres)
  # =======================================================================
  n_block = length(BLOCK_SOLVERS) * length(DTYPES)
  println(io, """
# ---------------------------------------------------------------------------
# Block Krylov stores — $(length(BLOCK_SOLVERS)) solvers × $(length(DTYPES)) precisions = $(n_block) combos.
# SV = Vector{FC}, SM = Matrix{FC}.  Keyed separately from the scalar stores.
# ---------------------------------------------------------------------------
""")
  for (sname, wstype, _) in BLOCK_SOLVERS
    for (_, suffix, T, FC, S) in DTYPES
      println(io, "const $(block_store_name(sname, suffix)) = ",
                  "Dict{Ptr{Cvoid}, Krylov.$(wstype){$(T), $(FC), $(S), Matrix{$(FC)}}}()")
    end
    println(io)
  end
  println(io, "const block_ws_key_store = Dict{Ptr{Cvoid}, UInt8}()")
  println(io)

  # Generic typed helpers (specialized per concrete block workspace type)
  println(io, """
# ---------------------------------------------------------------------------
# Generic typed helpers for block workspaces.
# ---------------------------------------------------------------------------
function _typed_block_niter(ws)
  Cint(ws.stats.niter)
end

function _typed_block_is_solved(ws)
  ws.stats.solved ? Cint(1) : Cint(0)
end

function _typed_block_elapsed_time(ws)
  Cdouble(ws.stats.timer)
end

function _typed_block_get_X!(ws::Krylov.BlockKrylovWorkspace{T, FC, SV, SM}, X_ptr, n, p) where {T, FC, SV, SM}
  copyto!(unsafe_wrap(Matrix{FC}, Ptr{FC}(X_ptr), (Int(n), Int(p))), ws.X)
  Cint(0)
end

function _typed_block_warm_start!(ws::Krylov.BlockKrylovWorkspace{T, FC, SV, SM}, X0_ptr, n, p) where {T, FC, SV, SM}
  X0 = unsafe_wrap(Matrix{FC}, Ptr{FC}(X0_ptr), (Int(n), Int(p)))
  if size(ws.ΔX) != (ws.n, ws.p)
    ws.ΔX = SM(undef, ws.n, ws.p)
  end
  copyto!(ws.ΔX, X0)
  ws.warm_start = true
  Cint(0)
end

# Block solve — uses the GENERIC krylov_solve! (dispatch on the workspace type
# picks block_gmres! / block_minres!).  Going through the generic interface is
# what makes the call trim-safe: it forwards every keyword with its default
# (restart=false, ldiv=false, …) as a literal, so allocate_if(restart, …) is
# constant-folded away — a direct block_gmres! call is NOT trim-safe.
# Supports an optional left preconditioner M (applied as Y = M⁻¹X).
# fptr_N is part of the shared signature but ignored: block_minres takes M only.
function _typed_block_solve!(ws::Krylov.BlockKrylovWorkspace{T, FC, SV, SM}, fptr_A, fptr_M, fptr_N, B_ptr, userdata, opts) where {T, FC, SV, SM}
  A  = CBlockOperator{FC}(ws.m, ws.n, fptr_A, userdata)
  B  = unsafe_wrap(Matrix{FC}, Ptr{FC}(B_ptr), (ws.m, ws.p))
  kw = _opts_kw(opts, T)
  if fptr_M != C_NULL
    M = CBlockOperator{FC}(ws.n, ws.n, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, B; M=M, kw...)
  else
    Krylov.krylov_solve!(ws, A, B; kw...)
  end
  Cint(0)
end

# block_gmres accepts BOTH a left (M) and right (N) preconditioner.  As for the
# single-vector _typed_solve_mn!, the four combinations are spelled out to keep
# each krylov_solve! call site concretely typed for --trim=safe.
function _typed_block_solve_mn!(ws::Krylov.BlockKrylovWorkspace{T, FC, SV, SM}, fptr_A, fptr_M, fptr_N, B_ptr, userdata, opts) where {T, FC, SV, SM}
  A  = CBlockOperator{FC}(ws.m, ws.n, fptr_A, userdata)
  B  = unsafe_wrap(Matrix{FC}, Ptr{FC}(B_ptr), (ws.m, ws.p))
  kw = _opts_kw(opts, T)
  rs = opts.restart != 0; ro = opts.reorthogonalization != 0
  if fptr_M != C_NULL && fptr_N != C_NULL
    M = CBlockOperator{FC}(ws.m, ws.m, fptr_M, userdata)
    N = CBlockOperator{FC}(ws.n, ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, B; M=M, N=N, restart=rs, reorthogonalization=ro, kw...)
  elseif fptr_M != C_NULL
    M = CBlockOperator{FC}(ws.m, ws.m, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, B; M=M, restart=rs, reorthogonalization=ro, kw...)
  elseif fptr_N != C_NULL
    N = CBlockOperator{FC}(ws.n, ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, B; N=N, restart=rs, reorthogonalization=ro, kw...)
  else
    Krylov.krylov_solve!(ws, A, B; restart=rs, reorthogonalization=ro, kw...)
  end
  Cint(0)
end
""")

  # Block dispatch helper — emit an if-elseif over block_ws_key_store
  function emit_block_dispatch(io, fname, sig, branches_expr, fallback)
    println(io, "function $(fname)($(sig))")
    println(io, "  haskey(block_ws_key_store, ws_ptr) || return $(fallback)")
    println(io, "  k = block_ws_key_store[ws_ptr]")
    first = true
    for (si, (sname, _, _)) in enumerate(BLOCK_SOLVERS)
      for (di, (_, suffix, _, _, _)) in enumerate(DTYPES)
        key  = block_combo_key(si-1, di-1)
        sref = "$(block_store_name(sname, suffix))[ws_ptr]"
        kw   = first ? "if" : "elseif"
        println(io, "  $(kw) k == 0x$(string(key, base=16, pad=2)); $(branches_expr(sref))")
        first = false
      end
    end
    println(io, "  else; $(fallback); end")
    println(io, "end")
    println(io)
  end

  emit_block_dispatch(io, "_do_block_niter", "ws_ptr :: Ptr{Cvoid}",
    sref -> "_typed_block_niter($(sref))", "Cint(-1)")
  emit_block_dispatch(io, "_do_block_is_solved", "ws_ptr :: Ptr{Cvoid}",
    sref -> "_typed_block_is_solved($(sref))", "Cint(-1)")
  emit_block_dispatch(io, "_do_block_elapsed_time", "ws_ptr :: Ptr{Cvoid}",
    sref -> "_typed_block_elapsed_time($(sref))", "Cdouble(-1.0)")
  emit_block_dispatch(io, "_do_block_get_X!", "ws_ptr :: Ptr{Cvoid}, X_ptr :: Ptr{Cvoid}, n :: Cint, p :: Cint",
    sref -> "_typed_block_get_X!($(sref), X_ptr, n, p)", "Cint(-1)")
  emit_block_dispatch(io, "_do_block_warm_start!", "ws_ptr :: Ptr{Cvoid}, X0_ptr :: Ptr{Cvoid}, n :: Cint, p :: Cint",
    sref -> "_typed_block_warm_start!($(sref), X0_ptr, n, p)", "Cint(-1)")

  # _do_block_solve! — pick block_gmres! / block_minres! per solver
  let sig = join(["ws_ptr :: Ptr{Cvoid}", "fptr_A :: Ptr{Cvoid}", "fptr_M :: Ptr{Cvoid}", "fptr_N :: Ptr{Cvoid}",
                  "B_ptr :: Ptr{Cvoid}", "userdata :: Ptr{Cvoid}", "opts_ptr :: Ptr{Cvoid}"], ", ")
    println(io, "function _do_block_solve!($(sig))")
    println(io, "  haskey(block_ws_key_store, ws_ptr) || return Cint(-1)")
    println(io, "  opts = opts_ptr == C_NULL ? KrylovOptionsC(NaN, NaN, Cint(0), Cint(0), 0.0, NaN, NaN, NaN, 0.0, Cint(0), Cint(0), Cint(0)) : unsafe_load(Ptr{KrylovOptionsC}(opts_ptr))")
    println(io, "  k = block_ws_key_store[ws_ptr]")
    first = true
    for (si, (sname, _, _)) in enumerate(BLOCK_SOLVERS)
      fn = sname in BLOCK_MN_SOLVERS ? "_typed_block_solve_mn!" : "_typed_block_solve!"
      for (di, (_, suffix, _, _, _)) in enumerate(DTYPES)
        key  = block_combo_key(si-1, di-1)
        sref = "$(block_store_name(sname, suffix))[ws_ptr]"
        kw   = first ? "if" : "elseif"
        println(io, "  $(kw) k == 0x$(string(key, base=16, pad=2)); $(fn)($(sref), fptr_A, fptr_M, fptr_N, B_ptr, userdata, opts)")
        first = false
      end
    end
    println(io, "  else; Cint(-1); end")
    println(io, "end")
    println(io)
  end

  # _do_block_free!
  println(io, "function _do_block_free!(ws_ptr :: Ptr{Cvoid})")
  println(io, "  haskey(block_ws_key_store, ws_ptr) || return Cint(1)")
  println(io, "  k = block_ws_key_store[ws_ptr]")
  println(io, "  delete!(block_ws_key_store, ws_ptr)")
  first = true
  for (si, (sname, _, _)) in enumerate(BLOCK_SOLVERS)
    for (di, (_, suffix, _, _, _)) in enumerate(DTYPES)
      key = block_combo_key(si-1, di-1)
      kw  = first ? "if" : "elseif"
      println(io, "  $(kw) k == 0x$(string(key, base=16, pad=2)); delete!($(block_store_name(sname, suffix)), ws_ptr)")
      first = false
    end
  end
  println(io, "  end")
  println(io, "  Cint(0)")
  println(io, "end")
  println(io)

  # _do_block_create! — dispatch on (solver_int, dtype_int); takes block size p
  println(io, "function _do_block_create!(solver_int :: Cint, m :: Cint, n :: Cint, p :: Cint,")
  println(io, "                           dtype_int :: Cint, wopts :: KrylovWorkspaceOptionsC,")
  println(io, "                           ws_out :: Ptr{Ptr{Cvoid}})")
  println(io, "  mem = wopts.memory == 0 ? $(BLOCK_MEMORY_DEFAULT) : Int(wopts.memory)")
  first = true
  for (si, (sname, wstype, _)) in enumerate(BLOCK_SOLVERS)
    ctor_kw = sname in BLOCK_MEMORY_SOLVERS ? "; memory = mem" : ""
    for (di, (dtype_int, suffix, T, FC, S)) in enumerate(DTYPES)
      key  = block_combo_key(si-1, di-1)
      kw   = first ? "if" : "elseif"
      sref = block_store_name(sname, suffix)
      println(io, "  $(kw) solver_int == Cint($(si-1)) && dtype_int == Cint($(dtype_int))")
      println(io, "    ws = Krylov.$(wstype)(Int(m), Int(n), Int(p), $(S), Matrix{$(FC)}$(ctor_kw))")
      println(io, "    r  = Base.pointer_from_objref(ws)")
      println(io, "    $(sref)[r] = ws; block_ws_key_store[r] = 0x$(string(key, base=16, pad=2))")
      println(io, "    unsafe_store!(ws_out, r)")
      first = false
    end
  end
  println(io, "  else")
  println(io, "    return Cint(-2)  # unknown (block solver, dtype) combination")
  println(io, "  end")
  println(io, "  Cint(0)")
  println(io, "end")
end

println("Generated $out")
println("  $(length(SOLVERS)) solvers × $(length(DTYPES)) precisions = $(length(SOLVERS)*length(DTYPES)) combos")
println("  $(length(BLOCK_SOLVERS)) block solvers × $(length(DTYPES)) precisions = $(length(BLOCK_SOLVERS)*length(DTYPES)) combos")

# An implementation of CGS for the solution of the square linear system Ax = b.
#
# This method is described in
#
# P. Sonneveld, CGS, A Fast Lanczos-Type Solver for Nonsymmetric Linear systems.
# SIAM Journal on Scientific and Statistical Computing, 10(1), pp. 36--52, 1989.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Montreal, October 2018.

export cgs, cgs!

"""
    (x, stats) = cgs(A, b::AbstractVector{FC};
                     c::AbstractVector{FC}=b, M=I, N=I,
                     ldiv::Bool=false, atol::T=√eps(T),
                     rtol::T=√eps(T), itmax::Int=0,
                     timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                     callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = cgs(A, b, x0::AbstractVector; kwargs...)

CGS can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above.

Solve the consistent linear system Ax = b of size n using CGS.
CGS requires two initial vectors `b` and `c`.
The relation `bᴴc ≠ 0` must be satisfied and by default `c = b`.

From "Iterative Methods for Sparse Linear Systems (Y. Saad)" :

«The method is based on a polynomial variant of the conjugate gradients algorithm.
Although related to the so-called bi-conjugate gradients (BCG) algorithm,
it does not involve adjoint matrix-vector multiplications, and the expected convergence
rate is about twice that of the BCG algorithm.

The Conjugate Gradient Squared algorithm works quite well in many cases.
However, one difficulty is that, since the polynomials are squared, rounding errors
tend to be more damaging than in the standard BCG algorithm. In particular, very
high variations of the residual vectors often cause the residual norms computed
to become inaccurate.

TFQMR and BICGSTAB were developed to remedy this difficulty.»

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :cgs`.

For an in-place variant that reuses memory across solves, see [`cgs!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `n`;
* `b`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `c`: the second initial vector of length `n` required by the Lanczos biorthogonalization process;
* `M`: linear operator that models a nonsingular matrix of size `n` used for left preconditioning;
* `N`: linear operator that models a nonsingular matrix of size `n` used for right preconditioning;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### Reference

* P. Sonneveld, [*CGS, A Fast Lanczos-Type Solver for Nonsymmetric Linear systems*](https://doi.org/10.1137/0910004), SIAM Journal on Scientific and Statistical Computing, 10(1), pp. 36--52, 1989.
"""
function cgs end

"""
    workspace = cgs!(workspace::CgsWorkspace, A, b; kwargs...)
    workspace = cgs!(workspace::CgsWorkspace, A, b, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`cgs`](@ref).

See [`CgsWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :cgs` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function cgs! end

def_args_cgs = (:(A                    ),
                :(b::AbstractVector{FC}))

def_optargs_cgs = (:(x0::AbstractVector),)

def_kwargs_cgs = (:(; c::AbstractVector{FC} = b    ),
                  :(; M = I                        ),
                  :(; N = I                        ),
                  :(; ldiv::Bool = false           ),
                  :(; atol::T = √eps(T)            ),
                  :(; rtol::T = √eps(T)            ),
                  :(; itmax::Int = 0               ),
                  :(; timemax::Float64 = Inf       ),
                  :(; verbose::Int = 0             ),
                  :(; history::Bool = false        ),
                  :(; callback = workspace -> false),
                  :(; iostream::IO = kstdout       ))

def_kwargs_cgs = extract_parameters.(def_kwargs_cgs)

args_cgs = (:A, :b)
optargs_cgs = (:x0,)
kwargs_cgs = (:c, :M, :N, :ldiv, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function cgs!(workspace :: CgsWorkspace{T,FC,S}, $(def_args_cgs...); $(def_kwargs_cgs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("System must be square")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "CGS: system of size %d\n", n)

    # Check M = Iₙ and N = Iₙ
    MisI = (M === I)
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")
    ktypeof(c) == S || error("ktypeof(c) must be equal to $S")

    # Set up workspace.
    allocate_if(!MisI, workspace, :vw, S, workspace.x)  # The length of vw is n
    allocate_if(!NisI, workspace, :yz, S, workspace.x)  # The length of yz is n
    Δx, x, r, u, p, q, ts, stats = workspace.Δx, workspace.x, workspace.r, workspace.u, workspace.p, workspace.q, workspace.ts, workspace.stats
    warm_start = workspace.warm_start
    rNorms = stats.residuals
    reset!(stats)
    t = s = workspace.ts
    v = MisI ? t : workspace.vw
    w = MisI ? s : workspace.vw
    y = NisI ? p : workspace.yz
    z = NisI ? u : workspace.yz
    r₀ = MisI ? r : workspace.ts

    if warm_start
      kmul!(r₀, A, Δx)
      kaxpby!(n, one(FC), b, -one(FC), r₀)
    else
      kcopy!(n, r₀, b)  # r₀ ← b
    end

    kfill!(x, zero(FC))                 # x₀
    MisI || mulorldiv!(r, M, r₀, ldiv)  # r₀

    # Compute residual norm ‖r₀‖₂.
    rNorm = knorm(n, r)
    history && push!(rNorms, rNorm)
    if rNorm == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    # Compute ρ₀ = ⟨ r̅₀,r₀ ⟩
    ρ = kdot(n, c, r)
    if ρ == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = false, false
      stats.timer = start_time |> ktimer
      stats.status = "Breakdown bᴴc = 0"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start =false
      return workspace
    end

    iter = 0
    itmax == 0 && (itmax = 2*n)

    ε = atol + rtol * rNorm
    (verbose > 0) && @printf(iostream, "%5s  %7s  %5s\n", "k", "‖rₖ‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %.2fs\n", iter, rNorm, start_time |> ktimer)

    kcopy!(n, u, r)      # u₀
    kcopy!(n, p, r)      # p₀
    kfill!(q, zero(FC))  # q₋₁

    # Stopping criterion.
    solved = rNorm ≤ ε
    tired = iter ≥ itmax
    breakdown = false
    status = "unknown"
    user_requested_exit = false
    overtimed = false

    while !(solved || tired || breakdown || user_requested_exit || overtimed)

      NisI || mulorldiv!(y, N, p, ldiv)  # yₖ = N⁻¹pₖ
      kmul!(t, A, y)                     # tₖ = Ayₖ
      MisI || mulorldiv!(v, M, t, ldiv)  # vₖ = M⁻¹tₖ
      σ = kdot(n, c, v)                  # σₖ = ⟨ r̅₀,M⁻¹AN⁻¹pₖ ⟩
      α = ρ / σ                          # αₖ = ρₖ / σₖ
      kcopy!(n, q, u)                    # qₖ = uₖ
      kaxpy!(n, -α, v, q)                # qₖ = qₖ - αₖ * M⁻¹AN⁻¹pₖ
      kaxpy!(n, one(FC), q, u)           # uₖ₊½ = uₖ + qₖ
      NisI || mulorldiv!(z, N, u, ldiv)  # zₖ = N⁻¹uₖ₊½
      kaxpy!(n, α, z, x)                 # xₖ₊₁ = xₖ + αₖ * N⁻¹(uₖ + qₖ)
      kmul!(s, A, z)                     # sₖ = Azₖ
      MisI || mulorldiv!(w, M, s, ldiv)  # wₖ = M⁻¹sₖ
      kaxpy!(n, -α, w, r)                # rₖ₊₁ = rₖ - αₖ * M⁻¹AN⁻¹(uₖ + qₖ)
      ρ_next = kdot(n, c, r)             # ρₖ₊₁ = ⟨ r̅₀,rₖ₊₁ ⟩
      β = ρ_next / ρ                     # βₖ = ρₖ₊₁ / ρₖ
      kcopy!(n, u, r)                    # uₖ₊₁ = rₖ₊₁
      kaxpy!(n, β, q, u)                 # uₖ₊₁ = uₖ₊₁ + βₖ * qₖ
      kaxpby!(n, one(FC), q, β, p)       # pₐᵤₓ = qₖ + βₖ * pₖ
      kaxpby!(n, one(FC), u, β, p)       # pₖ₊₁ = uₖ₊₁ + βₖ * pₐᵤₓ

      # Update ρ.
      ρ = ρ_next # ρₖ ← ρₖ₊₁

      # Update iteration index.
      iter = iter + 1

      # Compute residual norm ‖rₖ‖₂.
      rNorm = knorm(n, r)
      history && push!(rNorms, rNorm)

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      resid_decrease_mach = (rNorm + one(T) ≤ one(T))

      # Update stopping criterion.
      user_requested_exit = callback(workspace) :: Bool
      resid_decrease_lim = rNorm ≤ ε
      solved = resid_decrease_lim || resid_decrease_mach
      tired = iter ≥ itmax
      breakdown = (α == 0 || isnan(α))
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %.2fs\n", iter, rNorm, start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    breakdown           && (status = "breakdown αₖ == 0")
    solved              && (status = "solution good enough given atol and rtol")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update x
    warm_start && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = false
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

export KrylovWorkspace, MinresWorkspace, CgWorkspace, CrWorkspace, SymmlqWorkspace, CgLanczosWorkspace,
CgLanczosShiftWorkspace, MinresQlpWorkspace, DqgmresWorkspace, DiomWorkspace, UsymlqWorkspace,
UsymqrWorkspace, TricgWorkspace, TrimrWorkspace, TrilqrWorkspace, CgsWorkspace, BicgstabWorkspace,
BilqWorkspace, QmrWorkspace, BilqrWorkspace, CglsWorkspace, CglsLanczosShiftWorkspace, CrlsWorkspace, CgneWorkspace,
CrmrWorkspace, LslqWorkspace, LsqrWorkspace, LsmrWorkspace, LnlqWorkspace, CraigWorkspace, CraigmrWorkspace,
GmresWorkspace, FomWorkspace, GpmrWorkspace, UsymlqrWorkspace, FgmresWorkspace, CarWorkspace, MinaresWorkspace

export KrylovConstructor

"""
    KrylovConstructor(vm; vm_empty=vm)
    KrylovConstructor(vm, vn; vm_empty=vm, vn_empty=vn)

Krylov methods require a workspace containing vectors of length `m` and `n` to solve linear problems of size `m × n`.
The `KrylovConstructor` facilitates the allocation of these vectors using `similar`.

For square problems (`m == n`), use the first constructor with a single vector `vm`.
For rectangular problems (`m != n`), use the second constructor with `vm` and `vn`.

#### Input arguments

* `vm`: a vector of length `m`;
* `vn`: a vector of length `n`.

#### Keyword arguments

- `vm_empty`: an empty vector that may be replaced with a vector of length `m`;
- `vn_empty`: an empty vector that may be replaced with a vector of length `n`.

#### Notes

Each pair of vectors (`vm`, `vm_empty`) and (`vn`, `vn_empty`) must have the same type.
Empty vectors `vm_empty` and `vn_empty` reduce storage requirements when features such as warm-start or preconditioners are unused.
These empty vectors will be replaced within a [`KrylovWorkspace`](@ref) only if required, such as when preconditioners are provided.
"""
struct KrylovConstructor{Sm,Sn}
  vm::Sm
  vn::Sn
  vm_empty::Sm
  vn_empty::Sn

  function KrylovConstructor{Sm,Sn}(vm, vn, vm_empty, vn_empty) where {Sm,Sn}
    eltype(Sm) === eltype(Sn) || throw(ArgumentError("KrylovConstructor requires that eltype(Sm) == eltype(Sn), got $(eltype(Sm)) and $(eltype(Sn))"))
    return new{Sm,Sn}(vm, vn, vm_empty, vn_empty)
  end
end

function KrylovConstructor(vm::Sm, vn::Sn; vm_empty::Sm=vm, vn_empty::Sn=vn) where {Sm,Sn}
  return KrylovConstructor{Sm,Sn}(vm, vn, vm_empty, vn_empty)
end

function KrylovConstructor(vm::S; vm_empty::S=vm) where S
  return KrylovConstructor{S,S}(vm, vm, vm_empty, vm_empty)
end

# Krylov.jl v11.x -> Change to KrylovWorkspace{T,FC,Sm,Sn} and delete the alias below
abstract type _KrylovWorkspace{T,FC,Sm,Sn} end

"Abstract type for using Krylov solvers in-place."
const KrylovWorkspace{T,FC,S} = _KrylovWorkspace{T,FC,S,S}

"""
Workspace for the in-place methods [`minres!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = MinresWorkspace(m, n, S; window = 5)
    workspace = MinresWorkspace(A, b; window = 5)
    workspace = MinresWorkspace(kc::KrylovConstructor{S,S}; window = 5)

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`minres`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct MinresWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  Δx         :: S
  x          :: S
  r1         :: S
  r2         :: S
  npc_dir    :: S
  w1         :: S
  w2         :: S
  y          :: S
  v          :: S
  err_vec    :: Vector{T}
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function MinresWorkspace(kc::KrylovConstructor{S,S}; window::Int = 5) where S
  start_allocation_time = time_ns()
  FC = eltype(S)
  T  = real(FC)
  m  = length(kc.vm)
  n  = length(kc.vn)
  Δx = similar(kc.vn_empty)
  x  = similar(kc.vn)
  r1 = similar(kc.vn)
  r2 = similar(kc.vn)
  npc_dir = similar(kc.vn_empty)
  w1 = similar(kc.vn)
  w2 = similar(kc.vn)
  y  = similar(kc.vn)
  v  = similar(kc.vn_empty)
  err_vec = zeros(T, window)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = MinresWorkspace{T,FC,S}(m, n, Δx, x, r1, r2, npc_dir, w1, w2, y, v, err_vec, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function MinresWorkspace(m::Integer, n::Integer, S::Type; window::Int = 5)
  start_allocation_time = time_ns()
  FC = eltype(S)
  T  = real(FC)
  Δx = S(undef, 0)
  x  = S(undef, n)
  r1 = S(undef, n)
  r2 = S(undef, n)
  npc_dir = S(undef, 0)
  w1 = S(undef, n)
  w2 = S(undef, n)
  y  = S(undef, n)
  v  = S(undef, 0)
  err_vec = zeros(T, window)
  S = isconcretetype(S) ? S : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = MinresWorkspace{T,FC,S}(m, n, Δx, x, r1, r2, npc_dir, w1, w2, y, v, err_vec, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function MinresWorkspace(A, b; window::Int = 5)
  m, n = size(A)
  S = ktypeof(b)
  MinresWorkspace(m, n, S; window)
end

"""
Workspace for the in-place methods [`minares!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = MinaresWorkspace(m, n, S)
    workspace = MinaresWorkspace(A, b)
    workspace = MinaresWorkspace(kc::KrylovConstructor{S,S})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`minares`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct MinaresWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  Δx         :: S
  vₖ         :: S
  vₖ₊₁       :: S
  x          :: S
  wₖ₋₂       :: S
  wₖ₋₁       :: S
  dₖ₋₂       :: S
  dₖ₋₁       :: S
  q          :: S
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function MinaresWorkspace(kc::KrylovConstructor{S,S}) where S
  start_allocation_time = time_ns()
  FC   = eltype(S)
  T    = real(FC)
  m    = length(kc.vm)
  n    = length(kc.vn)
  Δx   = similar(kc.vn_empty)
  vₖ   = similar(kc.vn)
  vₖ₊₁ = similar(kc.vn)
  x    = similar(kc.vn)
  wₖ₋₂ = similar(kc.vn)
  wₖ₋₁ = similar(kc.vn)
  dₖ₋₂ = similar(kc.vn)
  dₖ₋₁ = similar(kc.vn)
  q    = similar(kc.vn)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = MinaresWorkspace{T,FC,S}(m, n, Δx, vₖ, vₖ₊₁, x, wₖ₋₂, wₖ₋₁, dₖ₋₂, dₖ₋₁, q, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function MinaresWorkspace(m::Integer, n::Integer, S::Type)
  start_allocation_time = time_ns()
  FC   = eltype(S)
  T    = real(FC)
  Δx   = S(undef, 0)
  vₖ   = S(undef, n)
  vₖ₊₁ = S(undef, n)
  x    = S(undef, n)
  wₖ₋₂ = S(undef, n)
  wₖ₋₁ = S(undef, n)
  dₖ₋₂ = S(undef, n)
  dₖ₋₁ = S(undef, n)
  q    = S(undef, n)
  S = isconcretetype(S) ? S : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = MinaresWorkspace{T,FC,S}(m, n, Δx, vₖ, vₖ₊₁, x, wₖ₋₂, wₖ₋₁, dₖ₋₂, dₖ₋₁, q, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function MinaresWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  MinaresWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`cg!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = CgWorkspace(m, n, S)
    workspace = CgWorkspace(A, b)
    workspace = CgWorkspace(kc::KrylovConstructor{S,S})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`cg`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct CgWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  Δx         :: S
  x          :: S
  r          :: S
  npc_dir    :: S
  p          :: S
  Ap         :: S
  z          :: S
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function CgWorkspace(kc::KrylovConstructor{S,S}) where S
  start_allocation_time = time_ns()
  FC = eltype(S)
  T  = real(FC)
  m  = length(kc.vm)
  n  = length(kc.vn)
  Δx = similar(kc.vn_empty)
  x  = similar(kc.vn)
  r  = similar(kc.vn)
  npc_dir = similar(kc.vn_empty)
  p  = similar(kc.vn)
  Ap = similar(kc.vn)
  z  = similar(kc.vn_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CgWorkspace{T,FC,S}(m, n, Δx, x, r, npc_dir, p, Ap, z, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CgWorkspace(m::Integer, n::Integer, S::Type)
  start_allocation_time = time_ns()
  FC = eltype(S)
  T  = real(FC)
  Δx = S(undef, 0)
  x  = S(undef, n)
  r  = S(undef, n)
  npc_dir = S(undef, 0)
  p  = S(undef, n)
  Ap = S(undef, n)
  z  = S(undef, 0)
  S = isconcretetype(S) ? S : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CgWorkspace{T,FC,S}(m, n, Δx, x, r, npc_dir, p, Ap, z, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CgWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  CgWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`cr!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = CrWorkspace(m, n, S)
    workspace = CrWorkspace(A, b)
    workspace = CrWorkspace(kc::KrylovConstructor{S,S})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`cr`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct CrWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  Δx         :: S
  x          :: S
  r          :: S
  npc_dir    :: S
  p          :: S
  q          :: S
  Ar         :: S
  Mq         :: S
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function CrWorkspace(kc::KrylovConstructor{S,S}) where S
  start_allocation_time = time_ns()
  FC = eltype(S)
  T  = real(FC)
  m  = length(kc.vm)
  n  = length(kc.vn)
  Δx = similar(kc.vn_empty)
  x  = similar(kc.vn)
  r  = similar(kc.vn)
  npc_dir = similar(kc.vn_empty)
  p  = similar(kc.vn)
  q  = similar(kc.vn)
  Ar = similar(kc.vn)
  Mq = similar(kc.vn_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CrWorkspace{T,FC,S}(m, n, Δx, x, r, npc_dir, p, q, Ar, Mq, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CrWorkspace(m::Integer, n::Integer, S::Type)
  start_allocation_time = time_ns()
  FC = eltype(S)
  T  = real(FC)
  Δx = S(undef, 0)
  x  = S(undef, n)
  r  = S(undef, n)
  npc_dir = S(undef, 0)
  p  = S(undef, n)
  q  = S(undef, n)
  Ar = S(undef, n)
  Mq = S(undef, 0)
  S = isconcretetype(S) ? S : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CrWorkspace{T,FC,S}(m, n, Δx, x, r, npc_dir, p, q, Ar, Mq, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CrWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  CrWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`car!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = CarWorkspace(m, n, S)
    workspace = CarWorkspace(A, b)
    workspace = CarWorkspace(kc::KrylovConstructor{S,S})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`car`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct CarWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  Δx         :: S
  x          :: S
  r          :: S
  p          :: S
  s          :: S
  q          :: S
  t          :: S
  u          :: S
  Mu         :: S
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function CarWorkspace(kc::KrylovConstructor{S,S}) where S
  start_allocation_time = time_ns()
  FC = eltype(S)
  T  = real(FC)
  m  = length(kc.vm)
  n  = length(kc.vn)
  Δx = similar(kc.vn_empty)
  x  = similar(kc.vn)
  r  = similar(kc.vn)
  p  = similar(kc.vn)
  s  = similar(kc.vn)
  q  = similar(kc.vn)
  t  = similar(kc.vn)
  u  = similar(kc.vn)
  Mu = similar(kc.vn_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CarWorkspace{T,FC,S}(m, n, Δx, x, r, p, s, q, t, u, Mu, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CarWorkspace(m::Integer, n::Integer, S::Type)
  start_allocation_time = time_ns()
  FC = eltype(S)
  T  = real(FC)
  Δx = S(undef, 0)
  x  = S(undef, n)
  r  = S(undef, n)
  p  = S(undef, n)
  s  = S(undef, n)
  q  = S(undef, n)
  t  = S(undef, n)
  u  = S(undef, n)
  Mu = S(undef, 0)
  S = isconcretetype(S) ? S : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CarWorkspace{T,FC,S}(m, n, Δx, x, r, p, s, q, t, u, Mu, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CarWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  CarWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`symmlq!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = SymmlqWorkspace(m, n, S)
    workspace = SymmlqWorkspace(A, b)
    workspace = SymmlqWorkspace(kc::KrylovConstructor{S,S})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`symmlq`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct SymmlqWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  Δx         :: S
  x          :: S
  Mvold      :: S
  Mv         :: S
  Mv_next    :: S
  w̅          :: S
  v          :: S
  clist      :: Vector{T}
  zlist      :: Vector{T}
  sprod      :: Vector{T}
  warm_start :: Bool
  stats      :: SymmlqStats{T}
end

function SymmlqWorkspace(kc::KrylovConstructor{S,S}; window::Int = 5) where S
  start_allocation_time = time_ns()
  FC      = eltype(S)
  T       = real(FC)
  m       = length(kc.vm)
  n       = length(kc.vn)
  Δx      = similar(kc.vn_empty)
  x       = similar(kc.vn)
  Mvold   = similar(kc.vn)
  Mv      = similar(kc.vn)
  Mv_next = similar(kc.vn)
  w̅       = similar(kc.vn)
  v       = similar(kc.vn_empty)
  clist   = zeros(T, window)
  zlist   = zeros(T, window)
  sprod   = ones(T, window)
  stats = SymmlqStats(0, false, T[], Union{T, Missing}[], T[], Union{T, Missing}[], T(NaN), T(NaN), 0.0, 0.0, "unknown")
  workspace = SymmlqWorkspace{T,FC,S}(m, n, Δx, x, Mvold, Mv, Mv_next, w̅, v, clist, zlist, sprod, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function SymmlqWorkspace(m::Integer, n::Integer, S::Type; window::Int = 5)
  start_allocation_time = time_ns()
  FC      = eltype(S)
  T       = real(FC)
  Δx      = S(undef, 0)
  x       = S(undef, n)
  Mvold   = S(undef, n)
  Mv      = S(undef, n)
  Mv_next = S(undef, n)
  w̅       = S(undef, n)
  v       = S(undef, 0)
  clist   = zeros(T, window)
  zlist   = zeros(T, window)
  sprod   = ones(T, window)
  S = isconcretetype(S) ? S : typeof(x)
  stats = SymmlqStats(0, false, T[], Union{T, Missing}[], T[], Union{T, Missing}[], T(NaN), T(NaN), 0.0, 0.0, "unknown")
  workspace = SymmlqWorkspace{T,FC,S}(m, n, Δx, x, Mvold, Mv, Mv_next, w̅, v, clist, zlist, sprod, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function SymmlqWorkspace(A, b; window::Int = 5)
  m, n = size(A)
  S = ktypeof(b)
  SymmlqWorkspace(m, n, S; window)
end

"""
Workspace for the in-place methods [`cg_lanczos!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = CgLanczosWorkspace(m, n, S)
    workspace = CgLanczosWorkspace(A, b)
    workspace = CgLanczosWorkspace(kc::KrylovConstructor{S,S})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`cg_lanczos`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct CgLanczosWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  Δx         :: S
  x          :: S
  Mv         :: S
  Mv_prev    :: S
  p          :: S
  Mv_next    :: S
  v          :: S
  warm_start :: Bool
  stats      :: LanczosStats{T}
end

function CgLanczosWorkspace(kc::KrylovConstructor{S,S}) where S
  start_allocation_time = time_ns()
  FC      = eltype(S)
  T       = real(FC)
  m       = length(kc.vm)
  n       = length(kc.vn)
  Δx      = similar(kc.vn_empty)
  x       = similar(kc.vn)
  Mv      = similar(kc.vn)
  Mv_prev = similar(kc.vn)
  p       = similar(kc.vn)
  Mv_next = similar(kc.vn)
  v       = similar(kc.vn_empty)
  stats = LanczosStats(0, false, T[], false, T(NaN), T(NaN), 0.0, 0.0, "unknown")
  workspace = CgLanczosWorkspace{T,FC,S}(m, n, Δx, x, Mv, Mv_prev, p, Mv_next, v, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CgLanczosWorkspace(m::Integer, n::Integer, S::Type)
  start_allocation_time = time_ns()
  FC      = eltype(S)
  T       = real(FC)
  Δx      = S(undef, 0)
  x       = S(undef, n)
  Mv      = S(undef, n)
  Mv_prev = S(undef, n)
  p       = S(undef, n)
  Mv_next = S(undef, n)
  v       = S(undef, 0)
  S = isconcretetype(S) ? S : typeof(x)
  stats = LanczosStats(0, false, T[], false, T(NaN), T(NaN), 0.0, 0.0, "unknown")
  workspace = CgLanczosWorkspace{T,FC,S}(m, n, Δx, x, Mv, Mv_prev, p, Mv_next, v, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CgLanczosWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  CgLanczosWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`cg_lanczos_shift!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = CgLanczosShiftWorkspace(m, n, nshifts, S)
    workspace = CgLanczosShiftWorkspace(A, b, nshifts)
    workspace = CgLanczosShiftWorkspace(A, b, shifts)
    workspace = CgLanczosShiftWorkspace(kc::KrylovConstructor{S,S}, nshifts)

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
`nshifts` denotes the length of the vector `shifts` passed to the in-place methods.
Since [`cg_lanczos_shift`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct CgLanczosShiftWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  nshifts    :: Int
  Mv         :: S
  Mv_prev    :: S
  Mv_next    :: S
  v          :: S
  x          :: Vector{S}
  p          :: Vector{S}
  σ          :: Vector{T}
  δhat       :: Vector{T}
  ω          :: Vector{T}
  γ          :: Vector{T}
  rNorms     :: Vector{T}
  converged  :: BitVector
  not_cv     :: BitVector
  stats      :: LanczosShiftStats{T}
end

function CgLanczosShiftWorkspace(kc::KrylovConstructor{S,S}, nshifts::Integer) where S
  start_allocation_time = time_ns()
  FC         = eltype(S)
  T          = real(FC)
  m          = length(kc.vm)
  n          = length(kc.vn)
  Mv         = similar(kc.vn)
  Mv_prev    = similar(kc.vn)
  Mv_next    = similar(kc.vn)
  v          = similar(kc.vn_empty)
  x          = S[similar(kc.vn) for i = 1 : nshifts]
  p          = S[similar(kc.vn) for i = 1 : nshifts]
  σ          = Vector{T}(undef, nshifts)
  δhat       = Vector{T}(undef, nshifts)
  ω          = Vector{T}(undef, nshifts)
  γ          = Vector{T}(undef, nshifts)
  rNorms     = Vector{T}(undef, nshifts)
  indefinite = BitVector(undef, nshifts)
  converged  = BitVector(undef, nshifts)
  not_cv     = BitVector(undef, nshifts)
  stats = LanczosShiftStats(0, false, Vector{T}[T[] for i = 1 : nshifts], indefinite, T(NaN), T(NaN), 0.0, 0.0, "unknown")
  workspace = CgLanczosShiftWorkspace{T,FC,S}(m, n, nshifts, Mv, Mv_prev, Mv_next, v, x, p, σ, δhat, ω, γ, rNorms, converged, not_cv, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CgLanczosShiftWorkspace(m::Integer, n::Integer, nshifts::Integer, S::Type)
  start_allocation_time = time_ns()
  FC         = eltype(S)
  T          = real(FC)
  Mv         = S(undef, n)
  Mv_prev    = S(undef, n)
  Mv_next    = S(undef, n)
  v          = S(undef, 0)
  x          = S[S(undef, n) for i = 1 : nshifts]
  p          = S[S(undef, n) for i = 1 : nshifts]
  σ          = Vector{T}(undef, nshifts)
  δhat       = Vector{T}(undef, nshifts)
  ω          = Vector{T}(undef, nshifts)
  γ          = Vector{T}(undef, nshifts)
  rNorms     = Vector{T}(undef, nshifts)
  indefinite = BitVector(undef, nshifts)
  converged  = BitVector(undef, nshifts)
  not_cv     = BitVector(undef, nshifts)
  S = isconcretetype(S) ? S : typeof(x)
  stats = LanczosShiftStats(0, false, Vector{T}[T[] for i = 1 : nshifts], indefinite, T(NaN), T(NaN), 0.0, 0.0, "unknown")
  workspace = CgLanczosShiftWorkspace{T,FC,S}(m, n, nshifts, Mv, Mv_prev, Mv_next, v, x, p, σ, δhat, ω, γ, rNorms, converged, not_cv, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CgLanczosShiftWorkspace(A, b, nshifts::Integer)
  m, n = size(A)
  S = ktypeof(b)
  CgLanczosShiftWorkspace(m, n, nshifts, S)
end

function CgLanczosShiftWorkspace(A, b, shifts::AbstractVector)
  nshifts = length(shifts)
  CgLanczosShiftWorkspace(A, b, nshifts)
end

"""
Workspace for the in-place methods [`minres_qlp!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = MinresQlpWorkspace(m, n, S)
    workspace = MinresQlpWorkspace(A, b)
    workspace = MinresQlpWorkspace(kc::KrylovConstructor{S,S})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`minres_qlp`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct MinresQlpWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  Δx         :: S
  wₖ₋₁       :: S
  wₖ         :: S
  M⁻¹vₖ₋₁    :: S
  M⁻¹vₖ      :: S
  npc_dir    :: S
  x          :: S
  p          :: S
  vₖ         :: S
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function MinresQlpWorkspace(kc::KrylovConstructor{S,S}) where S
  start_allocation_time = time_ns()
  FC      = eltype(S)
  T       = real(FC)
  m       = length(kc.vm)
  n       = length(kc.vn)
  Δx      = similar(kc.vn_empty)
  wₖ₋₁    = similar(kc.vn)
  wₖ      = similar(kc.vn)
  M⁻¹vₖ₋₁ = similar(kc.vn)
  M⁻¹vₖ   = similar(kc.vn)
  npc_dir = similar(kc.vn_empty)
  x       = similar(kc.vn)
  p       = similar(kc.vn)
  vₖ      = similar(kc.vn_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = MinresQlpWorkspace{T,FC,S}(m, n, Δx, wₖ₋₁, wₖ, M⁻¹vₖ₋₁, M⁻¹vₖ, npc_dir, x, p, vₖ, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function MinresQlpWorkspace(m::Integer, n::Integer, S::Type)
  start_allocation_time = time_ns()
  FC      = eltype(S)
  T       = real(FC)
  Δx      = S(undef, 0)
  wₖ₋₁    = S(undef, n)
  wₖ      = S(undef, n)
  M⁻¹vₖ₋₁ = S(undef, n)
  M⁻¹vₖ   = S(undef, n)
  x       = S(undef, n)
  p       = S(undef, n)
  vₖ      = S(undef, 0)
  npc_dir  = S(undef, 0)
  S = isconcretetype(S) ? S : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = MinresQlpWorkspace{T,FC,S}(m, n, Δx, wₖ₋₁, wₖ, M⁻¹vₖ₋₁, M⁻¹vₖ, npc_dir, x, p, vₖ, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function MinresQlpWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  MinresQlpWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`dqgmres!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = DqgmresWorkspace(m, n, S; memory = 20)
    workspace = DqgmresWorkspace(A, b; memory = 20)
    workspace = DqgmresWorkspace(kc::KrylovConstructor{S,S}; memory = 20)

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`dqgmres`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.
`memory` is set to `n` if the value given is larger than `n`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct DqgmresWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  Δx         :: S
  x          :: S
  t          :: S
  z          :: S
  w          :: S
  P          :: Vector{S}
  V          :: Vector{S}
  c          :: Vector{T}
  s          :: Vector{FC}
  H          :: Vector{FC}
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function DqgmresWorkspace(kc::KrylovConstructor{S,S}; memory::Int = 20) where S
  start_allocation_time = time_ns()
  FC     = eltype(S)
  T      = real(FC)
  m      = length(kc.vm)
  n      = length(kc.vn)
  memory = min(m, memory)
  Δx     = similar(kc.vn_empty)
  x      = similar(kc.vn)
  t      = similar(kc.vn)
  z      = similar(kc.vn_empty)
  w      = similar(kc.vn_empty)
  P      = S[similar(kc.vn) for i = 1 : memory]
  V      = S[similar(kc.vn) for i = 1 : memory]
  c      = Vector{T}(undef, memory)
  s      = Vector{FC}(undef, memory)
  H      = Vector{FC}(undef, memory+1)
  stats  = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = DqgmresWorkspace{T,FC,S}(m, n, Δx, x, t, z, w, P, V, c, s, H, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function DqgmresWorkspace(m::Integer, n::Integer, S::Type; memory::Int = 20)
  start_allocation_time = time_ns()
  memory = min(m, memory)
  FC = eltype(S)
  T  = real(FC)
  Δx = S(undef, 0)
  x  = S(undef, n)
  t  = S(undef, n)
  z  = S(undef, 0)
  w  = S(undef, 0)
  P  = S[S(undef, n) for i = 1 : memory]
  V  = S[S(undef, n) for i = 1 : memory]
  c  = Vector{T}(undef, memory)
  s  = Vector{FC}(undef, memory)
  H  = Vector{FC}(undef, memory+1)
  S = isconcretetype(S) ? S : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = DqgmresWorkspace{T,FC,S}(m, n, Δx, x, t, z, w, P, V, c, s, H, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function DqgmresWorkspace(A, b; memory::Int = 20)
  m, n = size(A)
  S = ktypeof(b)
  DqgmresWorkspace(m, n, S; memory)
end

"""
Workspace for the in-place methods [`diom!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = DiomWorkspace(m, n, S; memory = 20)
    workspace = DiomWorkspace(A, b; memory = 20)
    workspace = DiomWorkspace(kc::KrylovConstructor{S,S}; memory = 20)

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`diom`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.
`memory` is set to `n` if the value given is larger than `n`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct DiomWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  Δx         :: S
  x          :: S
  t          :: S
  z          :: S
  w          :: S
  P          :: Vector{S}
  V          :: Vector{S}
  L          :: Vector{FC}
  H          :: Vector{FC}
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function DiomWorkspace(kc::KrylovConstructor{S,S}; memory::Int = 20) where S
  start_allocation_time = time_ns()
  FC     = eltype(S)
  T      = real(FC)
  m      = length(kc.vm)
  n      = length(kc.vn)
  memory = min(m, memory)
  Δx     = similar(kc.vn_empty)
  x      = similar(kc.vn)
  t      = similar(kc.vn)
  z      = similar(kc.vn_empty)
  w      = similar(kc.vn_empty)
  P      = S[similar(kc.vn) for i = 1 : memory-1]
  V      = S[similar(kc.vn) for i = 1 : memory]
  L      = Vector{FC}(undef, memory-1)
  H      = Vector{FC}(undef, memory)
  stats  = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = DiomWorkspace{T,FC,S}(m, n, Δx, x, t, z, w, P, V, L, H, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function DiomWorkspace(m::Integer, n::Integer, S::Type; memory::Int = 20)
  start_allocation_time = time_ns()
  memory = min(m, memory)
  FC  = eltype(S)
  T   = real(FC)
  Δx = S(undef, 0)
  x  = S(undef, n)
  t  = S(undef, n)
  z  = S(undef, 0)
  w  = S(undef, 0)
  P  = S[S(undef, n) for i = 1 : memory-1]
  V  = S[S(undef, n) for i = 1 : memory]
  L  = Vector{FC}(undef, memory-1)
  H  = Vector{FC}(undef, memory)
  S = isconcretetype(S) ? S : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = DiomWorkspace{T,FC,S}(m, n, Δx, x, t, z, w, P, V, L, H, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function DiomWorkspace(A, b; memory::Int = 20)
  m, n = size(A)
  S = ktypeof(b)
  DiomWorkspace(m, n, S; memory)
end

"""
Workspace for the in-place methods [`usymlq!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = UsymlqWorkspace(m, n, Sm, Sn)
    workspace = UsymlqWorkspace(m, n, S)
    workspace = UsymlqWorkspace(A, b)
    workspace = UsymlqWorkspace(A, b, c)
    workspace = UsymlqWorkspace(kc::KrylovConstructor{Sm,Sn})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`usymlq`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct UsymlqWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m          :: Int
  n          :: Int
  uₖ₋₁       :: Sn
  uₖ         :: Sn
  p          :: Sn
  Δx         :: Sn
  x          :: Sn
  d̅          :: Sn
  vₖ₋₁       :: Sm
  vₖ         :: Sm
  q          :: Sm
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function UsymlqWorkspace(kc::KrylovConstructor{Sm,Sn}) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC   = eltype(Sm)
  T    = real(FC)
  m    = length(kc.vm)
  n    = length(kc.vn)
  uₖ₋₁ = similar(kc.vn)
  uₖ   = similar(kc.vn)
  p    = similar(kc.vn)
  Δx   = similar(kc.vn_empty)
  x    = similar(kc.vn)
  d̅    = similar(kc.vn)
  vₖ₋₁ = similar(kc.vm)
  vₖ   = similar(kc.vm)
  q    = similar(kc.vm)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = UsymlqWorkspace{T,FC,Sm,Sn}(m, n, uₖ₋₁, uₖ, p, Δx, x, d̅, vₖ₋₁, vₖ, q, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function UsymlqWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type)
  start_allocation_time = time_ns()
  FC   = eltype(Sm)
  T    = real(FC)
  uₖ₋₁ = Sn(undef, n)
  uₖ   = Sn(undef, n)
  p    = Sn(undef, n)
  Δx   = Sn(undef, 0)
  x    = Sn(undef, n)
  d̅    = Sn(undef, n)
  vₖ₋₁ = Sm(undef, m)
  vₖ   = Sm(undef, m)
  q    = Sm(undef, m)
  Sm = isconcretetype(Sm) ? Sm : typeof(q)
  Sn = isconcretetype(Sn) ? Sn : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = UsymlqWorkspace{T,FC,Sm,Sn}(m, n, uₖ₋₁, uₖ, p, Δx, x, d̅, vₖ₋₁, vₖ, q, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function UsymlqWorkspace(m::Integer, n::Integer, S::Type)
  UsymlqWorkspace(m, n, S, S)
end

function UsymlqWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  UsymlqWorkspace(m, n, S)
end

function UsymlqWorkspace(A, b, c)
  m, n = size(A)
  Sm = ktypeof(b)
  Sn = ktypeof(c)
  UsymlqWorkspace(m, n, Sm, Sn)
end

"""
Workspace for the in-place methods [`usymqr!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = UsymqrWorkspace(m, n, Sm, Sn)
    workspace = UsymqrWorkspace(m, n, S)
    workspace = UsymqrWorkspace(A, b)
    workspace = UsymqrWorkspace(A, b, c)
    workspace = UsymqrWorkspace(kc::KrylovConstructor{Sm,Sn})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`usymqr`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct UsymqrWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m          :: Int
  n          :: Int
  vₖ₋₁       :: Sm
  vₖ         :: Sm
  q          :: Sm
  Δx         :: Sn
  x          :: Sn
  wₖ₋₂       :: Sn
  wₖ₋₁       :: Sn
  uₖ₋₁       :: Sn
  uₖ         :: Sn
  p          :: Sn
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function UsymqrWorkspace(kc::KrylovConstructor{Sm,Sn}) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC   = eltype(Sm)
  T    = real(FC)
  m    = length(kc.vm)
  n    = length(kc.vn)
  vₖ₋₁ = similar(kc.vm)
  vₖ   = similar(kc.vm)
  q    = similar(kc.vm)
  Δx   = similar(kc.vn_empty)
  x    = similar(kc.vn)
  wₖ₋₂ = similar(kc.vn)
  wₖ₋₁ = similar(kc.vn)
  uₖ₋₁ = similar(kc.vn)
  uₖ   = similar(kc.vn)
  p    = similar(kc.vn)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = UsymqrWorkspace{T,FC,Sm,Sn}(m, n, vₖ₋₁, vₖ, q, Δx, x, wₖ₋₂, wₖ₋₁, uₖ₋₁, uₖ, p, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function UsymqrWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type)
  start_allocation_time = time_ns()
  FC   = eltype(Sm)
  T    = real(FC)
  vₖ₋₁ = Sm(undef, m)
  vₖ   = Sm(undef, m)
  q    = Sm(undef, m)
  Δx   = Sn(undef, 0)
  x    = Sn(undef, n)
  wₖ₋₂ = Sn(undef, n)
  wₖ₋₁ = Sn(undef, n)
  uₖ₋₁ = Sn(undef, n)
  uₖ   = Sn(undef, n)
  p    = Sn(undef, n)
  Sm = isconcretetype(Sm) ? Sm : typeof(q)
  Sn = isconcretetype(Sn) ? Sn : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = UsymqrWorkspace{T,FC,Sm,Sn}(m, n, vₖ₋₁, vₖ, q, Δx, x, wₖ₋₂, wₖ₋₁, uₖ₋₁, uₖ, p, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function UsymqrWorkspace(m::Integer, n::Integer, S::Type)
  UsymqrWorkspace(m, n, S, S)
end

function UsymqrWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  UsymqrWorkspace(m, n, S)
end

function UsymqrWorkspace(A, b, c)
  m, n = size(A)
  Sm = ktypeof(b)
  Sn = ktypeof(c)
  UsymqrWorkspace(m, n, Sm, Sn)
end

"""
Workspace for the in-place methods [`tricg!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = TricgWorkspace(m, n, Sm, Sn)
    workspace = TricgWorkspace(m, n, S)
    workspace = TricgWorkspace(A, b)
    workspace = TricgWorkspace(A, b, c)
    workspace = TricgWorkspace(kc::KrylovConstructor{Sm,Sn})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`tricg`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct TricgWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m          :: Int
  n          :: Int
  y          :: Sn
  N⁻¹uₖ₋₁    :: Sn
  N⁻¹uₖ      :: Sn
  p          :: Sn
  gy₂ₖ₋₁     :: Sn
  gy₂ₖ       :: Sn
  x          :: Sm
  M⁻¹vₖ₋₁    :: Sm
  M⁻¹vₖ      :: Sm
  q          :: Sm
  gx₂ₖ₋₁     :: Sm
  gx₂ₖ       :: Sm
  Δx         :: Sm
  Δy         :: Sn
  uₖ         :: Sn
  vₖ         :: Sm
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function TricgWorkspace(kc::KrylovConstructor{Sm,Sn}) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC      = eltype(Sm)
  T       = real(FC)
  m       = length(kc.vm)
  n       = length(kc.vn)
  y       = similar(kc.vn)
  N⁻¹uₖ₋₁ = similar(kc.vn)
  N⁻¹uₖ   = similar(kc.vn)
  p       = similar(kc.vn)
  gy₂ₖ₋₁  = similar(kc.vn)
  gy₂ₖ    = similar(kc.vn)
  x       = similar(kc.vm)
  M⁻¹vₖ₋₁ = similar(kc.vm)
  M⁻¹vₖ   = similar(kc.vm)
  q       = similar(kc.vm)
  gx₂ₖ₋₁  = similar(kc.vm)
  gx₂ₖ    = similar(kc.vm)
  Δx      = similar(kc.vm_empty)
  Δy      = similar(kc.vn_empty)
  uₖ      = similar(kc.vn_empty)
  vₖ      = similar(kc.vm_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = TricgWorkspace{T,FC,Sm,Sn}(m, n, y, N⁻¹uₖ₋₁, N⁻¹uₖ, p, gy₂ₖ₋₁, gy₂ₖ, x, M⁻¹vₖ₋₁, M⁻¹vₖ, q, gx₂ₖ₋₁, gx₂ₖ, Δx, Δy, uₖ, vₖ, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function TricgWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type)
  start_allocation_time = time_ns()
  FC      = eltype(Sm)
  T       = real(FC)
  y       = Sn(undef, n)
  N⁻¹uₖ₋₁ = Sn(undef, n)
  N⁻¹uₖ   = Sn(undef, n)
  p       = Sn(undef, n)
  gy₂ₖ₋₁  = Sn(undef, n)
  gy₂ₖ    = Sn(undef, n)
  x       = Sm(undef, m)
  M⁻¹vₖ₋₁ = Sm(undef, m)
  M⁻¹vₖ   = Sm(undef, m)
  q       = Sm(undef, m)
  gx₂ₖ₋₁  = Sm(undef, m)
  gx₂ₖ    = Sm(undef, m)
  Δx      = Sm(undef, 0)
  Δy      = Sn(undef, 0)
  uₖ      = Sn(undef, 0)
  vₖ      = Sm(undef, 0)
  Sm = isconcretetype(Sm) ? Sm : typeof(x)
  Sn = isconcretetype(Sn) ? Sn : typeof(y)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = TricgWorkspace{T,FC,Sm,Sn}(m, n, y, N⁻¹uₖ₋₁, N⁻¹uₖ, p, gy₂ₖ₋₁, gy₂ₖ, x, M⁻¹vₖ₋₁, M⁻¹vₖ, q, gx₂ₖ₋₁, gx₂ₖ, Δx, Δy, uₖ, vₖ, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function TricgWorkspace(m::Integer, n::Integer, S::Type)
  TricgWorkspace(m, n, S, S)
end

function TricgWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  TricgWorkspace(m, n, S)
end

function TricgWorkspace(A, b, c)
  m, n = size(A)
  Sm = ktypeof(b)
  Sn = ktypeof(c)
  TricgWorkspace(m, n, Sm, Sn)
end

"""
Workspace for the in-place methods [`trimr!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = TrimrWorkspace(m, n, Sm, Sn)
    workspace = TrimrWorkspace(m, n, S)
    workspace = TrimrWorkspace(A, b)
    workspace = TrimrWorkspace(A, b, c)
    workspace = TrimrWorkspace(kc::KrylovConstructor{Sm,Sn})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`trimr`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct TrimrWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m          :: Int
  n          :: Int
  y          :: Sn
  N⁻¹uₖ₋₁    :: Sn
  N⁻¹uₖ      :: Sn
  p          :: Sn
  gy₂ₖ₋₃     :: Sn
  gy₂ₖ₋₂     :: Sn
  gy₂ₖ₋₁     :: Sn
  gy₂ₖ       :: Sn
  x          :: Sm
  M⁻¹vₖ₋₁    :: Sm
  M⁻¹vₖ      :: Sm
  q          :: Sm
  gx₂ₖ₋₃     :: Sm
  gx₂ₖ₋₂     :: Sm
  gx₂ₖ₋₁     :: Sm
  gx₂ₖ       :: Sm
  Δx         :: Sm
  Δy         :: Sn
  uₖ         :: Sn
  vₖ         :: Sm
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function TrimrWorkspace(kc::KrylovConstructor{Sm,Sn}) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC      = eltype(Sm)
  T       = real(FC)
  m       = length(kc.vm)
  n       = length(kc.vn)
  y       = similar(kc.vn)
  N⁻¹uₖ₋₁ = similar(kc.vn)
  N⁻¹uₖ   = similar(kc.vn)
  p       = similar(kc.vn)
  gy₂ₖ₋₃  = similar(kc.vn)
  gy₂ₖ₋₂  = similar(kc.vn)
  gy₂ₖ₋₁  = similar(kc.vn)
  gy₂ₖ    = similar(kc.vn)
  x       = similar(kc.vm)
  M⁻¹vₖ₋₁ = similar(kc.vm)
  M⁻¹vₖ   = similar(kc.vm)
  q       = similar(kc.vm)
  gx₂ₖ₋₃  = similar(kc.vm)
  gx₂ₖ₋₂  = similar(kc.vm)
  gx₂ₖ₋₁  = similar(kc.vm)
  gx₂ₖ    = similar(kc.vm)
  Δx      = similar(kc.vm_empty)
  Δy      = similar(kc.vn_empty)
  uₖ      = similar(kc.vn_empty)
  vₖ      = similar(kc.vm_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = TrimrWorkspace{T,FC,Sm,Sn}(m, n, y, N⁻¹uₖ₋₁, N⁻¹uₖ, p, gy₂ₖ₋₃, gy₂ₖ₋₂, gy₂ₖ₋₁, gy₂ₖ, x, M⁻¹vₖ₋₁, M⁻¹vₖ, q, gx₂ₖ₋₃, gx₂ₖ₋₂, gx₂ₖ₋₁, gx₂ₖ, Δx, Δy, uₖ, vₖ, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function TrimrWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type)
  start_allocation_time = time_ns()
  FC      = eltype(Sm)
  T       = real(FC)
  y       = Sn(undef, n)
  N⁻¹uₖ₋₁ = Sn(undef, n)
  N⁻¹uₖ   = Sn(undef, n)
  p       = Sn(undef, n)
  gy₂ₖ₋₃  = Sn(undef, n)
  gy₂ₖ₋₂  = Sn(undef, n)
  gy₂ₖ₋₁  = Sn(undef, n)
  gy₂ₖ    = Sn(undef, n)
  x       = Sm(undef, m)
  M⁻¹vₖ₋₁ = Sm(undef, m)
  M⁻¹vₖ   = Sm(undef, m)
  q       = Sm(undef, m)
  gx₂ₖ₋₃  = Sm(undef, m)
  gx₂ₖ₋₂  = Sm(undef, m)
  gx₂ₖ₋₁  = Sm(undef, m)
  gx₂ₖ    = Sm(undef, m)
  Δx      = Sm(undef, 0)
  Δy      = Sn(undef, 0)
  uₖ      = Sn(undef, 0)
  vₖ      = Sm(undef, 0)
  Sm = isconcretetype(Sm) ? Sm : typeof(x)
  Sn = isconcretetype(Sn) ? Sn : typeof(y)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = TrimrWorkspace{T,FC,Sm,Sn}(m, n, y, N⁻¹uₖ₋₁, N⁻¹uₖ, p, gy₂ₖ₋₃, gy₂ₖ₋₂, gy₂ₖ₋₁, gy₂ₖ, x, M⁻¹vₖ₋₁, M⁻¹vₖ, q, gx₂ₖ₋₃, gx₂ₖ₋₂, gx₂ₖ₋₁, gx₂ₖ, Δx, Δy, uₖ, vₖ, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function TrimrWorkspace(m::Integer, n::Integer, S::Type)
  TrimrWorkspace(m, n, S, S)
end

function TrimrWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  TrimrWorkspace(m, n, S)
end

function TrimrWorkspace(A, b, c)
  m, n = size(A)
  Sm = ktypeof(b)
  Sn = ktypeof(c)
  TrimrWorkspace(m, n, Sm, Sn)
end

"""
Workspace for the in-place methods [`trilqr!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = TrilqrWorkspace(m, n, Sm, Sn)
    workspace = TrilqrWorkspace(m, n, S)
    workspace = TrilqrWorkspace(A, b)
    workspace = TrilqrWorkspace(A, b, c)
    workspace = TrilqrWorkspace(kc::KrylovConstructor{Sm,Sn})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`trilqr`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct TrilqrWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m          :: Int
  n          :: Int
  uₖ₋₁       :: Sn
  uₖ         :: Sn
  p          :: Sn
  d̅          :: Sn
  Δx         :: Sn
  x          :: Sn
  vₖ₋₁       :: Sm
  vₖ         :: Sm
  q          :: Sm
  Δy         :: Sm
  y          :: Sm
  wₖ₋₃       :: Sm
  wₖ₋₂       :: Sm
  warm_start :: Bool
  stats      :: AdjointStats{T}
end

function TrilqrWorkspace(kc::KrylovConstructor{Sm,Sn}) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC   = eltype(Sm)
  T    = real(FC)
  m    = length(kc.vm)
  n    = length(kc.vn)
  uₖ₋₁ = similar(kc.vn)
  uₖ   = similar(kc.vn)
  p    = similar(kc.vn)
  d̅    = similar(kc.vn)
  Δx   = similar(kc.vn_empty)
  x    = similar(kc.vn)
  vₖ₋₁ = similar(kc.vm)
  vₖ   = similar(kc.vm)
  q    = similar(kc.vm)
  Δy   = similar(kc.vm_empty)
  y    = similar(kc.vm)
  wₖ₋₃ = similar(kc.vm)
  wₖ₋₂ = similar(kc.vm)
  stats = AdjointStats(0, false, false, T[], T[], 0.0, 0.0, "unknown")
  workspace = TrilqrWorkspace{T,FC,Sm,Sn}(m, n, uₖ₋₁, uₖ, p, d̅, Δx, x, vₖ₋₁, vₖ, q, Δy, y, wₖ₋₃, wₖ₋₂, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function TrilqrWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type)
  start_allocation_time = time_ns()
  FC   = eltype(Sm)
  T    = real(FC)
  uₖ₋₁ = Sn(undef, n)
  uₖ   = Sn(undef, n)
  p    = Sn(undef, n)
  d̅    = Sn(undef, n)
  Δx   = Sn(undef, 0)
  x    = Sn(undef, n)
  vₖ₋₁ = Sm(undef, m)
  vₖ   = Sm(undef, m)
  q    = Sm(undef, m)
  Δy   = Sm(undef, 0)
  y    = Sm(undef, m)
  wₖ₋₃ = Sm(undef, m)
  wₖ₋₂ = Sm(undef, m)
  Sm = isconcretetype(Sm) ? Sm : typeof(y)
  Sn = isconcretetype(Sn) ? Sn : typeof(x)
  stats = AdjointStats(0, false, false, T[], T[], 0.0, 0.0, "unknown")
  workspace = TrilqrWorkspace{T,FC,Sm,Sn}(m, n, uₖ₋₁, uₖ, p, d̅, Δx, x, vₖ₋₁, vₖ, q, Δy, y, wₖ₋₃, wₖ₋₂, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function TrilqrWorkspace(m::Integer, n::Integer, S::Type)
  TrilqrWorkspace(m, n, S, S)
end

function TrilqrWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  TrilqrWorkspace(m, n, S)
end

function TrilqrWorkspace(A, b, c)
  m, n = size(A)
  Sm = ktypeof(b)
  Sn = ktypeof(c)
  TrilqrWorkspace(m, n, Sm, Sn)
end

"""
Workspace for the in-place methods [`cgs!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:s

    workspace = CgsWorkspace(m, n, S)
    workspace = CgsWorkspace(A, b)
    workspace = CgsWorkspace(kc::KrylovConstructor{S,S})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`cgs`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct CgsWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  Δx         :: S
  x          :: S
  r          :: S
  u          :: S
  p          :: S
  q          :: S
  ts         :: S
  yz         :: S
  vw         :: S
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function CgsWorkspace(kc::KrylovConstructor{S,S}) where S
  start_allocation_time = time_ns()
  FC = eltype(S)
  T  = real(FC)
  m  = length(kc.vm)
  n  = length(kc.vn)
  Δx = similar(kc.vn_empty)
  x  = similar(kc.vn)
  r  = similar(kc.vn)
  u  = similar(kc.vn)
  p  = similar(kc.vn)
  q  = similar(kc.vn)
  ts = similar(kc.vn)
  yz = similar(kc.vn_empty)
  vw = similar(kc.vn_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CgsWorkspace{T,FC,S}(m, n, Δx, x, r, u, p, q, ts, yz, vw, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CgsWorkspace(m::Integer, n::Integer, S::Type)
  start_allocation_time = time_ns()
  FC = eltype(S)
  T  = real(FC)
  Δx = S(undef, 0)
  x  = S(undef, n)
  r  = S(undef, n)
  u  = S(undef, n)
  p  = S(undef, n)
  q  = S(undef, n)
  ts = S(undef, n)
  yz = S(undef, 0)
  vw = S(undef, 0)
  S = isconcretetype(S) ? S : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CgsWorkspace{T,FC,S}(m, n, Δx, x, r, u, p, q, ts, yz, vw, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CgsWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  CgsWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`bicgstab!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = BicgstabWorkspace(m, n, S)
    workspace = BicgstabWorkspace(A, b)
    workspace = BicgstabWorkspace(kc::KrylovConstructor{S,S})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`bicgstab`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct BicgstabWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  Δx         :: S
  x          :: S
  r          :: S
  p          :: S
  v          :: S
  s          :: S
  qd         :: S
  yz         :: S
  t          :: S
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function BicgstabWorkspace(kc::KrylovConstructor{S,S}) where S
  start_allocation_time = time_ns()
  FC = eltype(S)
  T  = real(FC)
  m  = length(kc.vm)
  n  = length(kc.vn)
  Δx = similar(kc.vn_empty)
  x  = similar(kc.vn)
  r  = similar(kc.vn)
  p  = similar(kc.vn)
  v  = similar(kc.vn)
  s  = similar(kc.vn)
  qd = similar(kc.vn)
  yz = similar(kc.vn_empty)
  t  = similar(kc.vn_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = BicgstabWorkspace{T,FC,S}(m, n, Δx, x, r, p, v, s, qd, yz, t, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function BicgstabWorkspace(m::Integer, n::Integer, S::Type)
  start_allocation_time = time_ns()
  FC = eltype(S)
  T  = real(FC)
  Δx = S(undef, 0)
  x  = S(undef, n)
  r  = S(undef, n)
  p  = S(undef, n)
  v  = S(undef, n)
  s  = S(undef, n)
  qd = S(undef, n)
  yz = S(undef, 0)
  t  = S(undef, 0)
  S = isconcretetype(S) ? S : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = BicgstabWorkspace{T,FC,S}(m, n, Δx, x, r, p, v, s, qd, yz, t, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function BicgstabWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  BicgstabWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`bilq!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = BilqWorkspace(m, n, S)
    workspace = BilqWorkspace(A, b)
    workspace = BilqWorkspace(kc::KrylovConstructor{S,S})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`bilq`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct BilqWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  uₖ₋₁       :: S
  uₖ         :: S
  q          :: S
  vₖ₋₁       :: S
  vₖ         :: S
  p          :: S
  Δx         :: S
  x          :: S
  d̅          :: S
  t          :: S
  s          :: S
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function BilqWorkspace(kc::KrylovConstructor{S,S}) where S
  start_allocation_time = time_ns()
  FC   = eltype(S)
  T    = real(FC)
  m    = length(kc.vm)
  n    = length(kc.vn)
  uₖ₋₁ = similar(kc.vn)
  uₖ   = similar(kc.vn)
  q    = similar(kc.vn)
  vₖ₋₁ = similar(kc.vn)
  vₖ   = similar(kc.vn)
  p    = similar(kc.vn)
  Δx   = similar(kc.vn_empty)
  x    = similar(kc.vn)
  d̅    = similar(kc.vn)
  t    = similar(kc.vn_empty)
  s    = similar(kc.vn_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = BilqWorkspace{T,FC,S}(m, n, uₖ₋₁, uₖ, q, vₖ₋₁, vₖ, p, Δx, x, d̅, t, s, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function BilqWorkspace(m::Integer, n::Integer, S::Type)
  start_allocation_time = time_ns()
  FC   = eltype(S)
  T    = real(FC)
  uₖ₋₁ = S(undef, n)
  uₖ   = S(undef, n)
  q    = S(undef, n)
  vₖ₋₁ = S(undef, n)
  vₖ   = S(undef, n)
  p    = S(undef, n)
  Δx   = S(undef, 0)
  x    = S(undef, n)
  d̅    = S(undef, n)
  t    = S(undef, 0)
  s    = S(undef, 0)
  S = isconcretetype(S) ? S : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = BilqWorkspace{T,FC,S}(m, n, uₖ₋₁, uₖ, q, vₖ₋₁, vₖ, p, Δx, x, d̅, t, s, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function BilqWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  BilqWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`qmr!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = QmrWorkspace(m, n, S)
    workspace = QmrWorkspace(A, b)
    workspace = QmrWorkspace(kc::KrylovConstructor{S,S})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`qmr`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct QmrWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  uₖ₋₁       :: S
  uₖ         :: S
  q          :: S
  vₖ₋₁       :: S
  vₖ         :: S
  p          :: S
  Δx         :: S
  x          :: S
  wₖ₋₂       :: S
  wₖ₋₁       :: S
  t          :: S
  s          :: S
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function QmrWorkspace(kc::KrylovConstructor{S,S}) where S
  start_allocation_time = time_ns()
  FC   = eltype(S)
  T    = real(FC)
  m    = length(kc.vm)
  n    = length(kc.vn)
  uₖ₋₁ = similar(kc.vn)
  uₖ   = similar(kc.vn)
  q    = similar(kc.vn)
  vₖ₋₁ = similar(kc.vn)
  vₖ   = similar(kc.vn)
  p    = similar(kc.vn)
  Δx   = similar(kc.vn_empty)
  x    = similar(kc.vn)
  wₖ₋₂ = similar(kc.vn)
  wₖ₋₁ = similar(kc.vn)
  t    = similar(kc.vn_empty)
  s    = similar(kc.vn_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = QmrWorkspace{T,FC,S}(m, n, uₖ₋₁, uₖ, q, vₖ₋₁, vₖ, p, Δx, x, wₖ₋₂, wₖ₋₁, t, s, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function QmrWorkspace(m::Integer, n::Integer, S::Type)
  start_allocation_time = time_ns()
  FC   = eltype(S)
  T    = real(FC)
  uₖ₋₁ = S(undef, n)
  uₖ   = S(undef, n)
  q    = S(undef, n)
  vₖ₋₁ = S(undef, n)
  vₖ   = S(undef, n)
  p    = S(undef, n)
  Δx   = S(undef, 0)
  x    = S(undef, n)
  wₖ₋₂ = S(undef, n)
  wₖ₋₁ = S(undef, n)
  t    = S(undef, 0)
  s    = S(undef, 0)
  S = isconcretetype(S) ? S : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = QmrWorkspace{T,FC,S}(m, n, uₖ₋₁, uₖ, q, vₖ₋₁, vₖ, p, Δx, x, wₖ₋₂, wₖ₋₁, t, s, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function QmrWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  QmrWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`bilqr!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = BilqrWorkspace(m, n, S)
    workspace = BilqrWorkspace(A, b)
    workspace = BilqrWorkspace(A, b, c)
    workspace = BilqrWorkspace(kc::KrylovConstructor{S,S})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`bilqr`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct BilqrWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  uₖ₋₁       :: S
  uₖ         :: S
  q          :: S
  vₖ₋₁       :: S
  vₖ         :: S
  p          :: S
  Δx         :: S
  x          :: S
  Δy         :: S
  y          :: S
  d̅          :: S
  wₖ₋₃       :: S
  wₖ₋₂       :: S
  warm_start :: Bool
  stats      :: AdjointStats{T}
end

function BilqrWorkspace(kc::KrylovConstructor{S,S}) where S
  start_allocation_time = time_ns()
  FC   = eltype(S)
  T    = real(FC)
  m    = length(kc.vm)
  n    = length(kc.vn)
  uₖ₋₁ = similar(kc.vn)
  uₖ   = similar(kc.vn)
  q    = similar(kc.vn)
  vₖ₋₁ = similar(kc.vn)
  vₖ   = similar(kc.vn)
  p    = similar(kc.vn)
  Δx   = similar(kc.vn_empty)
  x    = similar(kc.vn)
  Δy   = similar(kc.vn_empty)
  y    = similar(kc.vn)
  d̅    = similar(kc.vn)
  wₖ₋₃ = similar(kc.vn)
  wₖ₋₂ = similar(kc.vn)
  stats = AdjointStats(0, false, false, T[], T[], 0.0, 0.0, "unknown")
  workspace = BilqrWorkspace{T,FC,S}(m, n, uₖ₋₁, uₖ, q, vₖ₋₁, vₖ, p, Δx, x, Δy, y, d̅, wₖ₋₃, wₖ₋₂, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function BilqrWorkspace(m::Integer, n::Integer, S::Type)
  start_allocation_time = time_ns()
  FC   = eltype(S)
  T    = real(FC)
  uₖ₋₁ = S(undef, n)
  uₖ   = S(undef, n)
  q    = S(undef, n)
  vₖ₋₁ = S(undef, n)
  vₖ   = S(undef, n)
  p    = S(undef, n)
  Δx   = S(undef, 0)
  x    = S(undef, n)
  Δy   = S(undef, 0)
  y    = S(undef, n)
  d̅    = S(undef, n)
  wₖ₋₃ = S(undef, n)
  wₖ₋₂ = S(undef, n)
  S = isconcretetype(S) ? S : typeof(x)
  stats = AdjointStats(0, false, false, T[], T[], 0.0, 0.0, "unknown")
  workspace = BilqrWorkspace{T,FC,S}(m, n, uₖ₋₁, uₖ, q, vₖ₋₁, vₖ, p, Δx, x, Δy, y, d̅, wₖ₋₃, wₖ₋₂, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function BilqrWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  BilqrWorkspace(m, n, S)
end

function BilqrWorkspace(A, b, c)
  m, n = size(A)
  S = ktypeof(b)
  BilqrWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`cgls!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = CglsWorkspace(m, n, Sm, Sn)
    workspace = CglsWorkspace(m, n, S)
    workspace = CglsWorkspace(A, b)
    workspace = CglsWorkspace(kc::KrylovConstructor{Sm,Sn})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`cgls`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct CglsWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m     :: Int
  n     :: Int
  x     :: Sn
  p     :: Sn
  s     :: Sn
  r     :: Sm
  q     :: Sm
  Mr    :: Sm
  stats :: SimpleStats{T}
end

function CglsWorkspace(kc::KrylovConstructor{Sm,Sn}) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC = eltype(Sm)
  T  = real(FC)
  m  = length(kc.vm)
  n  = length(kc.vn)
  x  = similar(kc.vn)
  p  = similar(kc.vn)
  s  = similar(kc.vn)
  r  = similar(kc.vm)
  q  = similar(kc.vm)
  Mr = similar(kc.vm_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CglsWorkspace{T,FC,Sm,Sn}(m, n, x, p, s, r, q, Mr, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CglsWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type)
  start_allocation_time = time_ns()
  FC = eltype(Sm)
  T  = real(FC)
  x  = Sn(undef, n)
  p  = Sn(undef, n)
  s  = Sn(undef, n)
  r  = Sm(undef, m)
  q  = Sm(undef, m)
  Mr = Sm(undef, 0)
  Sm = isconcretetype(Sm) ? Sm : typeof(r)
  Sn = isconcretetype(Sn) ? Sn : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CglsWorkspace{T,FC,Sm,Sn}(m, n, x, p, s, r, q, Mr, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CglsWorkspace(m::Integer, n::Integer, S::Type)
  CglsWorkspace(m, n, S, S)
end

function CglsWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  CglsWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`cgls_lanczos_shift!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = CglsLanczosShiftWorkspace(m, n, nshifts, Sm, Sn)
    workspace = CglsLanczosShiftWorkspace(m, n, nshifts, S)
    workspace = CglsLanczosShiftWorkspace(A, b, nshifts)
    workspace = CglsLanczosShiftWorkspace(A, b, shifts)
    workspace = CglsLanczosShiftWorkspace(kc::KrylovConstructor{Sm,Sn}, nshifts)

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
`nshifts` denotes the length of the vector `shifts` passed to the in-place methods.
Since [`cgls_lanczos_shift`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct CglsLanczosShiftWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m         :: Int
  n         :: Int
  nshifts   :: Int
  Mv        :: Sn
  u_prev    :: Sm
  u_next    :: Sm
  u         :: Sm
  v         :: Sn
  x         :: Vector{Sn}
  p         :: Vector{Sn}
  σ         :: Vector{T}
  δhat      :: Vector{T}
  ω         :: Vector{T}
  γ         :: Vector{T}
  rNorms    :: Vector{T}
  converged :: BitVector
  not_cv    :: BitVector
  stats     :: LanczosShiftStats{T}
end

function CglsLanczosShiftWorkspace(kc::KrylovConstructor{Sm,Sn}, nshifts::Integer) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC         = eltype(Sm)
  T          = real(FC)
  m          = length(kc.vm)
  n          = length(kc.vn)
  Mv         = similar(kc.vn)
  u_prev     = similar(kc.vm)
  u_next     = similar(kc.vm)
  u          = similar(kc.vm)
  v          = similar(kc.vn_empty)
  x          = Sn[similar(kc.vn) for i = 1 : nshifts]
  p          = Sn[similar(kc.vn) for i = 1 : nshifts]
  σ          = Vector{T}(undef, nshifts)
  δhat       = Vector{T}(undef, nshifts)
  ω          = Vector{T}(undef, nshifts)
  γ          = Vector{T}(undef, nshifts)
  rNorms     = Vector{T}(undef, nshifts)
  indefinite = BitVector(undef, nshifts)
  converged  = BitVector(undef, nshifts)
  not_cv     = BitVector(undef, nshifts)
  stats = LanczosShiftStats(0, false, Vector{T}[T[] for i = 1 : nshifts], indefinite, T(NaN), T(NaN), 0.0, 0.0, "unknown")
  workspace = CglsLanczosShiftWorkspace{T,FC,Sm,Sn}(m, n, nshifts, Mv, u_prev, u_next, u, v, x, p, σ, δhat, ω, γ, rNorms, converged, not_cv, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CglsLanczosShiftWorkspace(m::Integer, n::Integer, nshifts::Integer, Sm::Type, Sn::Type)
  start_allocation_time = time_ns()
  FC         = eltype(Sm)
  T          = real(FC)
  Mv         = Sn(undef, n)
  u_prev     = Sm(undef, m)
  u_next     = Sm(undef, m)
  u          = Sm(undef, m)
  v          = Sn(undef, 0)
  x          = Sn[Sn(undef, n) for i = 1 : nshifts]
  p          = Sn[Sn(undef, n) for i = 1 : nshifts]
  σ          = Vector{T}(undef, nshifts)
  δhat       = Vector{T}(undef, nshifts)
  ω          = Vector{T}(undef, nshifts)
  γ          = Vector{T}(undef, nshifts)
  rNorms     = Vector{T}(undef, nshifts)
  indefinite = BitVector(undef, nshifts)
  converged  = BitVector(undef, nshifts)
  not_cv     = BitVector(undef, nshifts)
  Sm = isconcretetype(Sm) ? Sm : typeof(u)
  Sn = isconcretetype(Sn) ? Sn : typeof(Mv)
  stats = LanczosShiftStats(0, false, Vector{T}[T[] for i = 1 : nshifts], indefinite, T(NaN), T(NaN), 0.0, 0.0, "unknown")
  workspace = CglsLanczosShiftWorkspace{T,FC,Sm,Sn}(m, n, nshifts, Mv, u_prev, u_next, u, v, x, p, σ, δhat, ω, γ, rNorms, converged, not_cv, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CglsLanczosShiftWorkspace(m::Integer, n::Integer, nshifts::Integer, S::Type)
  CglsLanczosShiftWorkspace(m, n, nshifts, S, S)
end

function CglsLanczosShiftWorkspace(A, b, nshifts::Integer)
  m, n = size(A)
  S = ktypeof(b)
  CglsLanczosShiftWorkspace(m, n, nshifts, S)
end

function CglsLanczosShiftWorkspace(A, b, shifts::AbstractVector)
  nshifts = length(shifts)
  CglsLanczosShiftWorkspace(A, b, nshifts)
end

"""
Workspace for the in-place methods [`crls!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = CrlsWorkspace(m, n, Sm, Sn)
    workspace = CrlsWorkspace(m, n, S)
    workspace = CrlsWorkspace(A, b)
    workspace = CrlsWorkspace(kc::KrylovConstructor{Sm,Sn})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`crls`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct CrlsWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m     :: Int
  n     :: Int
  x     :: Sn
  p     :: Sn
  Ar    :: Sn
  q     :: Sn
  r     :: Sm
  Ap    :: Sm
  s     :: Sm
  Ms    :: Sm
  stats :: SimpleStats{T}
end

function CrlsWorkspace(kc::KrylovConstructor{Sm,Sn}) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC = eltype(Sm)
  T  = real(FC)
  m  = length(kc.vm)
  n  = length(kc.vn)
  x  = similar(kc.vn)
  p  = similar(kc.vn)
  Ar = similar(kc.vn)
  q  = similar(kc.vn)
  r  = similar(kc.vm)
  Ap = similar(kc.vm)
  s  = similar(kc.vm)
  Ms = similar(kc.vm_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CrlsWorkspace{T,FC,Sm,Sn}(m, n, x, p, Ar, q, r, Ap, s, Ms, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CrlsWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type)
  start_allocation_time = time_ns()
  FC = eltype(Sm)
  T  = real(FC)
  x  = Sn(undef, n)
  p  = Sn(undef, n)
  Ar = Sn(undef, n)
  q  = Sn(undef, n)
  r  = Sm(undef, m)
  Ap = Sm(undef, m)
  s  = Sm(undef, m)
  Ms = Sm(undef, 0)
  Sm = isconcretetype(Sm) ? Sm : typeof(r)
  Sn = isconcretetype(Sn) ? Sn : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CrlsWorkspace{T,FC,Sm,Sn}(m, n, x, p, Ar, q, r, Ap, s, Ms, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CrlsWorkspace(m::Integer, n::Integer, S::Type)
  CrlsWorkspace(m, n, S, S)
end

function CrlsWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  CrlsWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`cgne!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = CgneWorkspace(m, n, Sm, Sn)
    workspace = CgneWorkspace(m, n, S)
    workspace = CgneWorkspace(A, b)
    workspace = CgneWorkspace(kc::KrylovConstructor{Sm,Sn})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`cgne`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct CgneWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m     :: Int
  n     :: Int
  x     :: Sn
  p     :: Sn
  Aᴴz   :: Sn
  r     :: Sm
  q     :: Sm
  s     :: Sm
  z     :: Sm
  stats :: SimpleStats{T}
end

function CgneWorkspace(kc::KrylovConstructor{Sm,Sn}) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC  = eltype(Sm)
  T   = real(FC)
  m   = length(kc.vm)
  n   = length(kc.vn)
  x   = similar(kc.vn)
  p   = similar(kc.vn)
  Aᴴz = similar(kc.vn)
  r   = similar(kc.vm)
  q   = similar(kc.vm)
  s   = similar(kc.vm_empty)
  z   = similar(kc.vm_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CgneWorkspace{T,FC,Sm,Sn}(m, n, x, p, Aᴴz, r, q, s, z, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CgneWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type)
  start_allocation_time = time_ns()
  FC  = eltype(Sm)
  T   = real(FC)
  x   = Sn(undef, n)
  p   = Sn(undef, n)
  Aᴴz = Sn(undef, n)
  r   = Sm(undef, m)
  q   = Sm(undef, m)
  s   = Sm(undef, 0)
  z   = Sm(undef, 0)
  Sm = isconcretetype(Sm) ? Sm : typeof(r)
  Sn = isconcretetype(Sn) ? Sn : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CgneWorkspace{T,FC,Sm,Sn}(m, n, x, p, Aᴴz, r, q, s, z, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CgneWorkspace(m::Integer, n::Integer, S::Type)
  CgneWorkspace(m, n, S, S)
end

function CgneWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  CgneWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`crmr!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = CrmrWorkspace(m, n, Sm, Sn)
    workspace = CrmrWorkspace(m, n, S)
    workspace = CrmrWorkspace(A, b)
    workspace = CrmrWorkspace(kc::KrylovConstructor{Sm,Sn})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`crmr`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct CrmrWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m     :: Int
  n     :: Int
  x     :: Sn
  p     :: Sn
  Aᴴr   :: Sn
  r     :: Sm
  q     :: Sm
  Nq    :: Sm
  s     :: Sm
  stats :: SimpleStats{T}
end

function CrmrWorkspace(kc::KrylovConstructor{Sm,Sn}) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC  = eltype(Sm)
  T   = real(FC)
  m   = length(kc.vm)
  n   = length(kc.vn)
  x   = similar(kc.vn)
  p   = similar(kc.vn)
  Aᴴr = similar(kc.vn)
  r   = similar(kc.vm)
  q   = similar(kc.vm)
  Nq  = similar(kc.vm_empty)
  s   = similar(kc.vm_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CrmrWorkspace{T,FC,Sm,Sn}(m, n, x, p, Aᴴr, r, q, Nq, s, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CrmrWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type)
  start_allocation_time = time_ns()
  FC  = eltype(Sm)
  T   = real(FC)
  x   = Sn(undef, n)
  p   = Sn(undef, n)
  Aᴴr = Sn(undef, n)
  r   = Sm(undef, m)
  q   = Sm(undef, m)
  Nq  = Sm(undef, 0)
  s   = Sm(undef, 0)
  Sm = isconcretetype(Sm) ? Sm : typeof(r)
  Sn = isconcretetype(Sn) ? Sn : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CrmrWorkspace{T,FC,Sm,Sn}(m, n, x, p, Aᴴr, r, q, Nq, s, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CrmrWorkspace(m::Integer, n::Integer, S::Type)
  CrmrWorkspace(m, n, S, S)
end
 
function CrmrWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  CrmrWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`lslq!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = LslqWorkspace(m, n, Sm, Sn)
    workspace = LslqWorkspace(m, n, S)
    workspace = LslqWorkspace(A, b)
    workspace = LslqWorkspace(kc::KrylovConstructor{Sm,Sn})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`lslq`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct LslqWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m       :: Int
  n       :: Int
  x       :: Sn
  Nv      :: Sn
  Aᴴu     :: Sn
  w̄       :: Sn
  Mu      :: Sm
  Av      :: Sm
  u       :: Sm
  v       :: Sn
  err_vec :: Vector{T}
  stats   :: LSLQStats{T}
end

function LslqWorkspace(kc::KrylovConstructor{Sm,Sn}; window::Int = 5) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC  = eltype(Sm)
  T   = real(FC)
  m   = length(kc.vm)
  n   = length(kc.vn)
  x   = similar(kc.vn)
  Nv  = similar(kc.vn)
  Aᴴu = similar(kc.vn)
  w̄   = similar(kc.vn)
  Mu  = similar(kc.vm)
  Av  = similar(kc.vm)
  u   = similar(kc.vm_empty)
  v   = similar(kc.vn_empty)
  err_vec = zeros(T, window)
  stats = LSLQStats(0, false, false, T[], T[], T[], false, T[], T[], 0.0, 0.0, "unknown")
  workspace = LslqWorkspace{T,FC,Sm,Sn}(m, n, x, Nv, Aᴴu, w̄, Mu, Av, u, v, err_vec, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function LslqWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type; window::Int = 5)
  start_allocation_time = time_ns()
  FC  = eltype(Sm)
  T   = real(FC)
  x   = Sn(undef, n)
  Nv  = Sn(undef, n)
  Aᴴu = Sn(undef, n)
  w̄   = Sn(undef, n)
  Mu  = Sm(undef, m)
  Av  = Sm(undef, m)
  u   = Sm(undef, 0)
  v   = Sn(undef, 0)
  err_vec = zeros(T, window)
  Sm = isconcretetype(Sm) ? Sm : typeof(Av)
  Sn = isconcretetype(Sn) ? Sn : typeof(x)
  stats = LSLQStats(0, false, false, T[], T[], T[], false, T[], T[], 0.0, 0.0, "unknown")
  workspace = LslqWorkspace{T,FC,Sm,Sn}(m, n, x, Nv, Aᴴu, w̄, Mu, Av, u, v, err_vec, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function LslqWorkspace(m::Integer, n::Integer, S::Type; window::Int = 5)
  LslqWorkspace(m, n, S, S; window)
end

function LslqWorkspace(A, b; window::Int = 5)
  m, n = size(A)
  S = ktypeof(b)
  LslqWorkspace(m, n, S; window)
end

"""
Workspace for the in-place methods [`lsqr!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = LsqrWorkspace(m, n, Sm, Sn)
    workspace = LsqrWorkspace(m, n, S)
    workspace = LsqrWorkspace(A, b)
    workspace = LsqrWorkspace(kc::KrylovConstructor{Sm,Sn})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`lsqr`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct LsqrWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m       :: Int
  n       :: Int
  x       :: Sn
  Nv      :: Sn
  Aᴴu     :: Sn
  w       :: Sn
  Mu      :: Sm
  Av      :: Sm
  u       :: Sm
  v       :: Sn
  err_vec :: Vector{T}
  stats   :: SimpleStats{T}
end

function LsqrWorkspace(kc::KrylovConstructor{Sm,Sn}; window::Int = 5) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC  = eltype(Sm)
  T   = real(FC)
  m   = length(kc.vm)
  n   = length(kc.vn)
  x   = similar(kc.vn)
  Nv  = similar(kc.vn)
  Aᴴu = similar(kc.vn)
  w   = similar(kc.vn)
  Mu  = similar(kc.vm)
  Av  = similar(kc.vm)
  u   = similar(kc.vm_empty)
  v   = similar(kc.vn_empty)
  err_vec = zeros(T, window)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = LsqrWorkspace{T,FC,Sm,Sn}(m, n, x, Nv, Aᴴu, w, Mu, Av, u, v, err_vec, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function LsqrWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type; window::Int = 5)
  start_allocation_time = time_ns()
  FC  = eltype(Sm)
  T   = real(FC)
  x   = Sn(undef, n)
  Nv  = Sn(undef, n)
  Aᴴu = Sn(undef, n)
  w   = Sn(undef, n)
  Mu  = Sm(undef, m)
  Av  = Sm(undef, m)
  u   = Sm(undef, 0)
  v   = Sn(undef, 0)
  err_vec = zeros(T, window)
  Sm = isconcretetype(Sm) ? Sm : typeof(Av)
  Sn = isconcretetype(Sn) ? Sn : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = LsqrWorkspace{T,FC,Sm,Sn}(m, n, x, Nv, Aᴴu, w, Mu, Av, u, v, err_vec, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function LsqrWorkspace(m::Integer, n::Integer, S::Type; window::Int = 5)
  LsqrWorkspace(m, n, S, S; window)
end

function LsqrWorkspace(A, b; window::Int = 5)
  m, n = size(A)
  S = ktypeof(b)
  LsqrWorkspace(m, n, S; window)
end

"""
Workspace for the in-place methods [`lsmr!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = LsmrWorkspace(m, n, Sm, Sn)
    workspace = LsmrWorkspace(m, n, S)
    workspace = LsmrWorkspace(A, b)
    workspace = LsmrWorkspace(kc::KrylovConstructor{Sm,Sn})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`lsmr`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct LsmrWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m       :: Int
  n       :: Int
  x       :: Sn
  Nv      :: Sn
  Aᴴu     :: Sn
  h       :: Sn
  hbar    :: Sn
  Mu      :: Sm
  Av      :: Sm
  u       :: Sm
  v       :: Sn
  err_vec :: Vector{T}
  stats   :: LsmrStats{T}
end

function LsmrWorkspace(kc::KrylovConstructor{Sm,Sn}; window::Int = 5) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC   = eltype(Sm)
  T    = real(FC)
  m    = length(kc.vm)
  n    = length(kc.vn)
  x    = similar(kc.vn)
  Nv   = similar(kc.vn)
  Aᴴu  = similar(kc.vn)
  h    = similar(kc.vn)
  hbar = similar(kc.vn)
  Mu   = similar(kc.vm)
  Av   = similar(kc.vm)
  u    = similar(kc.vm_empty)
  v    = similar(kc.vn_empty)
  err_vec = zeros(T, window)
  stats = LsmrStats(0, false, false, T[], T[], zero(T), zero(T), zero(T), zero(T), zero(T), 0.0, 0.0, "unknown")
  workspace = LsmrWorkspace{T,FC,Sm,Sn}(m, n, x, Nv, Aᴴu, h, hbar, Mu, Av, u, v, err_vec, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function LsmrWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type; window::Int = 5)
  start_allocation_time = time_ns()
  FC   = eltype(Sm)
  T    = real(FC)
  x    = Sn(undef, n)
  Nv   = Sn(undef, n)
  Aᴴu  = Sn(undef, n)
  h    = Sn(undef, n)
  hbar = Sn(undef, n)
  Mu   = Sm(undef, m)
  Av   = Sm(undef, m)
  u    = Sm(undef, 0)
  v    = Sn(undef, 0)
  err_vec = zeros(T, window)
  Sm = isconcretetype(Sm) ? Sm : typeof(Av)
  Sn = isconcretetype(Sn) ? Sn : typeof(x)
  stats = LsmrStats(0, false, false, T[], T[], zero(T), zero(T), zero(T), zero(T), zero(T), 0.0, 0.0, "unknown")
  workspace = LsmrWorkspace{T,FC,Sm,Sn}(m, n, x, Nv, Aᴴu, h, hbar, Mu, Av, u, v, err_vec, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function LsmrWorkspace(m::Integer, n::Integer, S::Type; window::Int = 5)
  LsmrWorkspace(m, n, S, S; window)
end

function LsmrWorkspace(A, b; window::Int = 5)
  m, n = size(A)
  S = ktypeof(b)
  LsmrWorkspace(m, n, S; window)
end

"""
Workspace for the in-place methods [`lnlq!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = LnlqWorkspace(m, n, Sm, Sn)
    workspace = LnlqWorkspace(m, n, S)
    workspace = LnlqWorkspace(A, b)
    workspace = LnlqWorkspace(kc::KrylovConstructor{Sm,Sn})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`lnlq`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct LnlqWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m     :: Int
  n     :: Int
  x     :: Sn
  Nv    :: Sn
  Aᴴu   :: Sn
  y     :: Sm
  w̄     :: Sm
  Mu    :: Sm
  Av    :: Sm
  u     :: Sm
  v     :: Sn
  q     :: Sn
  stats :: LNLQStats{T}
end

function LnlqWorkspace(kc::KrylovConstructor{Sm,Sn}) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC  = eltype(Sm)
  T   = real(FC)
  m   = length(kc.vm)
  n   = length(kc.vn)
  x   = similar(kc.vn)
  Nv  = similar(kc.vn)
  Aᴴu = similar(kc.vn)
  y   = similar(kc.vm)
  w̄   = similar(kc.vm)
  Mu  = similar(kc.vm)
  Av  = similar(kc.vm)
  u   = similar(kc.vm_empty)
  v   = similar(kc.vn_empty)
  q   = similar(kc.vn_empty)
  stats = LNLQStats(0, false, T[], false, T[], T[], 0.0, 0.0, "unknown")
  workspace = LnlqWorkspace{T,FC,Sm,Sn}(m, n, x, Nv, Aᴴu, y, w̄, Mu, Av, u, v, q, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function LnlqWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type)
  start_allocation_time = time_ns()
  FC  = eltype(Sm)
  T   = real(FC)
  x   = Sn(undef, n)
  Nv  = Sn(undef, n)
  Aᴴu = Sn(undef, n)
  y   = Sm(undef, m)
  w̄   = Sm(undef, m)
  Mu  = Sm(undef, m)
  Av  = Sm(undef, m)
  u   = Sm(undef, 0)
  v   = Sn(undef, 0)
  q   = Sn(undef, 0)
  Sm = isconcretetype(Sm) ? Sm : typeof(y)
  Sn = isconcretetype(Sn) ? Sn : typeof(x)
  stats = LNLQStats(0, false, T[], false, T[], T[], 0.0, 0.0, "unknown")
  workspace = LnlqWorkspace{T,FC,Sm,Sn}(m, n, x, Nv, Aᴴu, y, w̄, Mu, Av, u, v, q, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function LnlqWorkspace(m::Integer, n::Integer, S::Type)
  LnlqWorkspace(m, n, S, S)
end

function LnlqWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  LnlqWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`craig!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = CraigWorkspace(m, n, Sm, Sn)
    workspace = CraigWorkspace(m, n, S)
    workspace = CraigWorkspace(A, b)
    workspace = CraigWorkspace(kc::KrylovConstructor{Sm,Sn})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`craig`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct CraigWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m     :: Int
  n     :: Int
  x     :: Sn
  Nv    :: Sn
  Aᴴu   :: Sn
  y     :: Sm
  w     :: Sm
  Mu    :: Sm
  Av    :: Sm
  u     :: Sm
  v     :: Sn
  w2    :: Sn
  stats :: SimpleStats{T}
end

function CraigWorkspace(kc::KrylovConstructor{Sm,Sn}) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC  = eltype(Sm)
  T   = real(FC)
  m   = length(kc.vm)
  n   = length(kc.vn)
  x   = similar(kc.vn)
  Nv  = similar(kc.vn)
  Aᴴu = similar(kc.vn)
  y   = similar(kc.vm)
  w   = similar(kc.vm)
  Mu  = similar(kc.vm)
  Av  = similar(kc.vm)
  u   = similar(kc.vm_empty)
  v   = similar(kc.vn_empty)
  w2  = similar(kc.vn_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CraigWorkspace{T,FC,Sm,Sn}(m, n, x, Nv, Aᴴu, y, w, Mu, Av, u, v, w2, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CraigWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type)
  start_allocation_time = time_ns()
  FC  = eltype(Sm)
  T   = real(FC)
  x   = Sn(undef, n)
  Nv  = Sn(undef, n)
  Aᴴu = Sn(undef, n)
  y   = Sm(undef, m)
  w   = Sm(undef, m)
  Mu  = Sm(undef, m)
  Av  = Sm(undef, m)
  u   = Sm(undef, 0)
  v   = Sn(undef, 0)
  w2  = Sn(undef, 0)
  Sm = isconcretetype(Sm) ? Sm : typeof(y)
  Sn = isconcretetype(Sn) ? Sn : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CraigWorkspace{T,FC,Sm,Sn}(m, n, x, Nv, Aᴴu, y, w, Mu, Av, u, v, w2, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CraigWorkspace(m::Integer, n::Integer, S::Type)
  CraigWorkspace(m, n, S, S)
end

function CraigWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  CraigWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`craigmr!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = CraigmrWorkspace(m, n, S)
    workspace = CraigmrWorkspace(A, b)
    workspace = CraigmrWorkspace(kc::KrylovConstructor{Sm,Sn})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`craigmr`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct CraigmrWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m     :: Int
  n     :: Int
  x     :: Sn
  Nv    :: Sn
  Aᴴu   :: Sn
  d     :: Sm
  y     :: Sm
  Mu    :: Sm
  w     :: Sm
  wbar  :: Sm
  Av    :: Sm
  u     :: Sm
  v     :: Sn
  q     :: Sn
  stats :: SimpleStats{T}
end

function CraigmrWorkspace(kc::KrylovConstructor{Sm,Sn}) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC   = eltype(Sm)
  T    = real(FC)
  m    = length(kc.vm)
  n    = length(kc.vn)
  x    = similar(kc.vn)
  Nv   = similar(kc.vn)
  Aᴴu  = similar(kc.vn)
  d    = similar(kc.vn)
  y    = similar(kc.vm)
  Mu   = similar(kc.vm)
  w    = similar(kc.vm)
  wbar = similar(kc.vm)
  Av   = similar(kc.vm)
  u    = similar(kc.vm_empty)
  v    = similar(kc.vn_empty)
  q    = similar(kc.vn_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CraigmrWorkspace{T,FC,Sm,Sn}(m, n, x, Nv, Aᴴu, d, y, Mu, w, wbar, Av, u, v, q, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CraigmrWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type)
  start_allocation_time = time_ns()
  FC   = eltype(Sm)
  T    = real(FC)
  x    = Sn(undef, n)
  Nv   = Sn(undef, n)
  Aᴴu  = Sn(undef, n)
  d    = Sn(undef, n)
  y    = Sm(undef, m)
  Mu   = Sm(undef, m)
  w    = Sm(undef, m)
  wbar = Sm(undef, m)
  Av   = Sm(undef, m)
  u    = Sm(undef, 0)
  v    = Sn(undef, 0)
  q    = Sn(undef, 0)
  Sm = isconcretetype(Sm) ? Sm : typeof(y)
  Sn = isconcretetype(Sn) ? Sn : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = CraigmrWorkspace{T,FC,Sm,Sn}(m, n, x, Nv, Aᴴu, d, y, Mu, w, wbar, Av, u, v, q, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function CraigmrWorkspace(m::Integer, n::Integer, S::Type)
  CraigmrWorkspace(m, n, S, S)
end

function CraigmrWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  CraigmrWorkspace(m, n, S)
end

"""
Workspace for the in-place methods [`gmres!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = GmresWorkspace(m, n, S; memory = 20)
    workspace = GmresWorkspace(A, b; memory = 20)
    workspace = GmresWorkspace(kc::KrylovConstructor{S,S}; memory = 20)

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`gmres`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.
`memory` is set to `n` if the value given is larger than `n`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct GmresWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  Δx         :: S
  x          :: S
  w          :: S
  p          :: S
  q          :: S
  V          :: Vector{S}
  c          :: Vector{T}
  s          :: Vector{FC}
  z          :: Vector{FC}
  R          :: Vector{FC}
  warm_start :: Bool
  inner_iter :: Int
  stats      :: SimpleStats{T}
end

function GmresWorkspace(kc::KrylovConstructor{S,S}; memory::Int = 20) where S
  start_allocation_time = time_ns()
  FC = eltype(S)
  T  = real(FC)
  m  = length(kc.vm)
  n  = length(kc.vn)
  memory = min(m, memory)
  Δx = similar(kc.vn_empty)
  x  = similar(kc.vn)
  w  = similar(kc.vn)
  p  = similar(kc.vn_empty)
  q  = similar(kc.vn_empty)
  V  = S[similar(kc.vn) for i = 1 : memory]
  c  = Vector{T}(undef, memory)
  s  = Vector{FC}(undef, memory)
  z  = Vector{FC}(undef, memory)
  R  = Vector{FC}(undef, div(memory * (memory+1), 2))
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = GmresWorkspace{T,FC,S}(m, n, Δx, x, w, p, q, V, c, s, z, R, false, 0, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function GmresWorkspace(m::Integer, n::Integer, S::Type; memory::Int = 20)
  start_allocation_time = time_ns()
  memory = min(m, memory)
  FC = eltype(S)
  T  = real(FC)
  Δx = S(undef, 0)
  x  = S(undef, n)
  w  = S(undef, n)
  p  = S(undef, 0)
  q  = S(undef, 0)
  V  = S[S(undef, n) for i = 1 : memory]
  c  = Vector{T}(undef, memory)
  s  = Vector{FC}(undef, memory)
  z  = Vector{FC}(undef, memory)
  R  = Vector{FC}(undef, div(memory * (memory+1), 2))
  S = isconcretetype(S) ? S : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = GmresWorkspace{T,FC,S}(m, n, Δx, x, w, p, q, V, c, s, z, R, false, 0, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function GmresWorkspace(A, b; memory::Int = 20)
  m, n = size(A)
  S = ktypeof(b)
  GmresWorkspace(m, n, S; memory)
end

"""
Workspace for the in-place methods [`fgmres!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = FgmresWorkspace(m, n, S; memory = 20)
    workspace = FgmresWorkspace(A, b; memory = 20)
    workspace = FgmresWorkspace(kc::KrylovConstructor{S,S}; memory = 20)

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`fgmres`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.
`memory` is set to `n` if the value given is larger than `n`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct FgmresWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  Δx         :: S
  x          :: S
  w          :: S
  q          :: S
  V          :: Vector{S}
  Z          :: Vector{S}
  c          :: Vector{T}
  s          :: Vector{FC}
  z          :: Vector{FC}
  R          :: Vector{FC}
  warm_start :: Bool
  inner_iter :: Int
  stats      :: SimpleStats{T}
end

function FgmresWorkspace(kc::KrylovConstructor{S,S}; memory::Int = 20) where S
  start_allocation_time = time_ns()
  FC = eltype(S)
  T  = real(FC)
  m  = length(kc.vm)
  n  = length(kc.vn)
  memory = min(m, memory)
  Δx = similar(kc.vn_empty)
  x  = similar(kc.vn)
  w  = similar(kc.vn)
  q  = similar(kc.vn_empty)
  V  = S[similar(kc.vn) for i = 1 : memory]
  Z  = S[similar(kc.vn) for i = 1 : memory]
  c  = Vector{T}(undef, memory)
  s  = Vector{FC}(undef, memory)
  z  = Vector{FC}(undef, memory)
  R  = Vector{FC}(undef, div(memory * (memory+1), 2))
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = FgmresWorkspace{T,FC,S}(m, n, Δx, x, w, q, V, Z, c, s, z, R, false, 0, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function FgmresWorkspace(m::Integer, n::Integer, S::Type; memory::Int = 20)
  start_allocation_time = time_ns()
  memory = min(m, memory)
  FC = eltype(S)
  T  = real(FC)
  Δx = S(undef, 0)
  x  = S(undef, n)
  w  = S(undef, n)
  q  = S(undef, 0)
  V  = S[S(undef, n) for i = 1 : memory]
  Z  = S[S(undef, n) for i = 1 : memory]
  c  = Vector{T}(undef, memory)
  s  = Vector{FC}(undef, memory)
  z  = Vector{FC}(undef, memory)
  R  = Vector{FC}(undef, div(memory * (memory+1), 2))
  S = isconcretetype(S) ? S : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = FgmresWorkspace{T,FC,S}(m, n, Δx, x, w, q, V, Z, c, s, z, R, false, 0, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function FgmresWorkspace(A, b; memory::Int = 20)
  m, n = size(A)
  S = ktypeof(b)
  FgmresWorkspace(m, n, S; memory)
end

"""
Workspace for the in-place methods [`fom!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = FomWorkspace(m, n, S; memory = 20)
    workspace = FomWorkspace(A, b; memory = 20)
    workspace = FomWorkspace(kc::KrylovConstructor{S,S}; memory = 20)

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`fom`](@ref) only supports square linear operators, `m` and `n` must be equal.
`S` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.
`memory` is set to `n` if the value given is larger than `n`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `S(undef, n)` is not available.
"""
mutable struct FomWorkspace{T,FC,S} <: _KrylovWorkspace{T,FC,S,S}
  m          :: Int
  n          :: Int
  Δx         :: S
  x          :: S
  w          :: S
  p          :: S
  q          :: S
  V          :: Vector{S}
  l          :: Vector{FC}
  z          :: Vector{FC}
  U          :: Vector{FC}
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function FomWorkspace(kc::KrylovConstructor{S,S}; memory::Int = 20) where S
  start_allocation_time = time_ns()
  FC = eltype(S)
  T  = real(FC)
  m  = length(kc.vm)
  n  = length(kc.vn)
  memory = min(m, memory)
  Δx = similar(kc.vn_empty)
  x  = similar(kc.vn)
  w  = similar(kc.vn)
  p  = similar(kc.vn_empty)
  q  = similar(kc.vn_empty)
  V  = S[similar(kc.vn) for i = 1 : memory]
  l  = Vector{FC}(undef, memory)
  z  = Vector{FC}(undef, memory)
  U  = Vector{FC}(undef, div(memory * (memory+1), 2))
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = FomWorkspace{T,FC,S}(m, n, Δx, x, w, p, q, V, l, z, U, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function FomWorkspace(m::Integer, n::Integer, S::Type; memory::Int = 20)
  start_allocation_time = time_ns()
  memory = min(m, memory)
  FC = eltype(S)
  T  = real(FC)
  Δx = S(undef, 0)
  x  = S(undef, n)
  w  = S(undef, n)
  p  = S(undef, 0)
  q  = S(undef, 0)
  V  = S[S(undef, n) for i = 1 : memory]
  l  = Vector{FC}(undef, memory)
  z  = Vector{FC}(undef, memory)
  U  = Vector{FC}(undef, div(memory * (memory+1), 2))
  S = isconcretetype(S) ? S : typeof(x)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = FomWorkspace{T,FC,S}(m, n, Δx, x, w, p, q, V, l, z, U, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function FomWorkspace(A, b; memory::Int = 20)
  m, n = size(A)
  S = ktypeof(b)
  FomWorkspace(m, n, S; memory)
end

"""
Workspace for the in-place methods [`gpmr!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = GpmrWorkspace(m, n, Sm, Sn; memory = 20)
    workspace = GpmrWorkspace(m, n, S; memory = 20)
    workspace = GpmrWorkspace(A, b; memory = 20)
    workspace = GpmrWorkspace(A, b, c; memory = 20)
    workspace = GpmrWorkspace(A, B, b, c; memory = 20)
    workspace = GpmrWorkspace(kc::KrylovConstructor{Sm,Sn}; memory = 20)

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`gpmr`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.
`memory` is set to `n + m` if the value given is larger than `n + m`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct GpmrWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m          :: Int
  n          :: Int
  wA         :: Sn
  wB         :: Sm
  dA         :: Sm
  dB         :: Sn
  Δx         :: Sm
  Δy         :: Sn
  x          :: Sm
  y          :: Sn
  q          :: Sm
  p          :: Sn
  V          :: Vector{Sm}
  U          :: Vector{Sn}
  gs         :: Vector{FC}
  gc         :: Vector{T}
  zt         :: Vector{FC}
  R          :: Vector{FC}
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function GpmrWorkspace(kc::KrylovConstructor{Sm,Sn}; memory::Int = 20) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC = eltype(Sm)
  T  = real(FC)
  m  = length(kc.vm)
  n  = length(kc.vn)
  memory = min(n + m, memory)
  wA = similar(kc.vn_empty)
  wB = similar(kc.vm_empty)
  dA = similar(kc.vm)
  dB = similar(kc.vn)
  Δx = similar(kc.vm_empty)
  Δy = similar(kc.vn_empty)
  x  = similar(kc.vm)
  y  = similar(kc.vn)
  q  = similar(kc.vm_empty)
  p  = similar(kc.vn_empty)
  V  = Sm[similar(kc.vm) for i = 1 : memory]
  U  = Sn[similar(kc.vn) for i = 1 : memory]
  gs = Vector{FC}(undef, 4 * memory)
  gc = Vector{T}(undef, 4 * memory)
  zt = Vector{FC}(undef, 2 * memory)
  R  = Vector{FC}(undef, memory * (2 * memory + 1))
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = GpmrWorkspace{T,FC,Sm,Sn}(m, n, wA, wB, dA, dB, Δx, Δy, x, y, q, p, V, U, gs, gc, zt, R, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function GpmrWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type; memory::Int = 20)
  start_allocation_time = time_ns()
  memory = min(n + m, memory)
  FC = eltype(Sm)
  T  = real(FC)
  wA = Sn(undef, 0)
  wB = Sm(undef, 0)
  dA = Sm(undef, m)
  dB = Sn(undef, n)
  Δx = Sm(undef, 0)
  Δy = Sn(undef, 0)
  x  = Sm(undef, m)
  y  = Sn(undef, n)
  q  = Sm(undef, 0)
  p  = Sn(undef, 0)
  V  = Sm[Sm(undef, m) for i = 1 : memory]
  U  = Sn[Sn(undef, n) for i = 1 : memory]
  gs = Vector{FC}(undef, 4 * memory)
  gc = Vector{T}(undef, 4 * memory)
  zt = Vector{FC}(undef, 2 * memory)
  R  = Vector{FC}(undef, memory * (2 * memory + 1))
  Sm = isconcretetype(Sm) ? Sm : typeof(x)
  Sn = isconcretetype(Sn) ? Sn : typeof(y)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = GpmrWorkspace{T,FC,Sm,Sn}(m, n, wA, wB, dA, dB, Δx, Δy, x, y, q, p, V, U, gs, gc, zt, R, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function GpmrWorkspace(m::Integer, n::Integer, S::Type; memory::Int = 20)
  GpmrWorkspace(m, n, S, S; memory)
end

function GpmrWorkspace(A, b; memory::Int = 20)
  m, n = size(A)
  S = ktypeof(b)
  GpmrWorkspace(m, n, S; memory)
end

function GpmrWorkspace(A, b, c; memory::Int = 20)
  m, n = size(A)
  Sm = ktypeof(b)
  Sn = ktypeof(c)
  GpmrWorkspace(m, n, Sm, Sn; memory)
end

function GpmrWorkspace(A, B, b, c; memory::Int = 20)
  m, n = size(A)
  Sm = ktypeof(b)
  Sn = ktypeof(c)
  GpmrWorkspace(m, n, Sm, Sn; memory)
end

"""
Workspace for the in-place methods [`usymlqr!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = UsymlqrWorkspace(m, n, Sm, Sn)
    workspace = UsymlqrWorkspace(m, n, S)
    workspace = UsymlqrWorkspace(A, b)
    workspace = UsymlqrWorkspace(A, b, c)
    workspace = UsymlqrWorkspace(kc::KrylovConstructor{Sm,Sn})

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
Since [`usymlqr`](@ref) supports rectangular linear operators, `m` and `n` can differ.
`Sm` and `Sn` are the storage types of the workspace vectors of length `m` and `n`, respectively.
If the same storage type can be used for both, a single type `S` may be provided, such as `Vector{Float64}`.

[`KrylovConstructor`](@ref) facilitates the allocation of vectors in the workspace if `Sm(undef, m)` and `Sn(undef, n)` are not available.
"""
mutable struct UsymlqrWorkspace{T,FC,Sm,Sn} <: _KrylovWorkspace{T,FC,Sm,Sn}
  m          :: Int
  n          :: Int
  r          :: Sm
  x          :: Sm
  y          :: Sn
  z          :: Sn
  vₖ₋₁       :: Sm
  vₖ         :: Sm
  uₖ₋₁       :: Sn
  uₖ         :: Sn
  p          :: Sn
  q          :: Sm
  d̅          :: Sm
  wₖ₋₂       :: Sn
  wₖ₋₁       :: Sn
  Δx         :: Sm
  Δy         :: Sn
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function UsymlqrWorkspace(kc::KrylovConstructor{Sm,Sn}) where {Sm,Sn}
  start_allocation_time = time_ns()
  FC = eltype(Sm)
  T  = real(FC)
  m  = length(kc.vm)
  n  = length(kc.vn)
  r       = similar(kc.vm)
  x       = similar(kc.vm)
  y       = similar(kc.vn)
  z       = similar(kc.vn)
  vₖ₋₁    = similar(kc.vm)
  vₖ      = similar(kc.vm)
  uₖ₋₁    = similar(kc.vn)
  uₖ      = similar(kc.vn)
  p       = similar(kc.vn)
  q       = similar(kc.vm)
  d̅       = similar(kc.vm)
  wₖ₋₂    = similar(kc.vn)
  wₖ₋₁    = similar(kc.vn)
  Δx      = similar(kc.vm_empty)
  Δy      = similar(kc.vn_empty)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = UsymlqrWorkspace{T,FC,Sm,Sn}(m, n, r, x, y, z, vₖ₋₁, vₖ, uₖ₋₁, uₖ, p, q, d̅, wₖ₋₂, wₖ₋₁, Δx, Δy, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function UsymlqrWorkspace(m::Integer, n::Integer, Sm::Type, Sn::Type)
  start_allocation_time = time_ns()
  FC      = eltype(Sm)
  T       = real(FC)
  r       = Sm(undef, m)
  x       = Sm(undef, m)
  y       = Sn(undef, n)
  z       = Sn(undef, n)
  vₖ₋₁    = Sm(undef, m)
  vₖ      = Sm(undef, m)
  uₖ₋₁    = Sn(undef, n)
  uₖ      = Sn(undef, n)
  p       = Sn(undef, n)
  q       = Sm(undef, m)
  d̅       = Sm(undef, m)
  wₖ₋₂    = Sn(undef, n)
  wₖ₋₁    = Sn(undef, n)
  Δx      = Sm(undef, 0)
  Δy      = Sn(undef, 0)
  Sm = isconcretetype(Sm) ? Sm : typeof(x)
  Sn = isconcretetype(Sn) ? Sn : typeof(y)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = UsymlqrWorkspace{T,FC,Sm,Sn}(m, n, r, x, y, z, vₖ₋₁, vₖ, uₖ₋₁, uₖ, p, q, d̅, wₖ₋₂, wₖ₋₁, Δx, Δy, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function UsymlqrWorkspace(m::Integer, n::Integer, S::Type)
  UsymlqrWorkspace(m, n, S, S)
end

function UsymlqrWorkspace(A, b)
  m, n = size(A)
  S = ktypeof(b)
  UsymlqrWorkspace(m, n, S)
end

function UsymlqrWorkspace(A, b, c)
  m, n = size(A)
  Sm = ktypeof(b)
  Sn = ktypeof(c)
  UsymlqrWorkspace(m, n, Sm, Sn)
end

# An implementation of block-MINRES for the solution of the square linear system AX = B.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca> -- <amontoison@anl.gov>
# Argonne National Laboratory -- Chicago, October 2024.

export block_minres, block_minres!

"""
    (X, stats) = block_minres(A, b::AbstractMatrix{FC};
                              M=I, ldiv::Bool=false,
                              atol::T=√eps(T), rtol::T=√eps(T), itmax::Int=0,
                              timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                              callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (X, stats) = block_minres(A, B, X0::AbstractMatrix; kwargs...)

Block-MINRES can be warm-started from an initial guess `X0` where `kwargs` are the same keyword arguments as above.

Solve the Hermitian linear system AX = B of size n with p right-hand sides using block-MINRES.

#### Interface

To easily switch between block Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :block_minres`.

For an in-place variant that reuses memory across solves, see [`block_minres!`](@ref).

#### Input arguments

* `A`: a linear operator that models a Hermitian matrix of dimension `n`;
* `B`: a matrix of size `n × p`.

#### Optional argument

* `X0`: a matrix of size `n × p` that represents an initial guess of the solution `X`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2 * div(n,p)`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the block-Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `X`: a dense matrix of size `n × p`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.
"""
function block_minres end

"""
    workspace = block_minres!(workspace::BlockMinresWorkspace, B; kwargs...)
    workspace = block_minres!(workspace::BlockMinresWorkspace, B, X0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`block_minres`](@ref).

See [`BlockMinresWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :block_minres` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the block Krylov method in-place.
"""
function block_minres! end

def_args_block_minres = (:(A                    ),
                         :(B::AbstractMatrix{FC}))

def_optargs_block_minres = (:(X0::AbstractMatrix),)

def_kwargs_block_minres = (:(; M = I                        ),
                           :(; ldiv::Bool = false           ),
                           :(; atol::T = √eps(T)            ),
                           :(; rtol::T = √eps(T)            ),
                           :(; itmax::Int = 0               ),
                           :(; timemax::Float64 = Inf       ),
                           :(; verbose::Int = 0             ),
                           :(; history::Bool = false        ),
                           :(; callback = workspace -> false),
                           :(; iostream::IO = kstdout       ))

def_kwargs_block_minres = mapreduce(extract_parameters, vcat, def_kwargs_block_minres)

args_block_minres = (:A, :B)
optargs_block_minres = (:X0,)
kwargs_block_minres = (:M, :ldiv, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function block_minres!(workspace :: BlockMinresWorkspace{T,FC,SV,SM}, $(def_args_block_minres...); $(def_kwargs_block_minres...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, SV <: AbstractVector{FC}, SM <: AbstractMatrix{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    n, m = size(A)
    s, p = size(B)
    m == n || error("System must be square")
    n == s || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "BLOCK-MINRES: system of size %d with %d right-hand sides\n", n, p)

    # Check M = Iₙ
    MisI = (M === I)
    MisI || error("Block-MINRES doesn't support preconditioning yet.")

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-matrix products."
    ktypeof(B) == SM || error("ktypeof(B) must be equal to $SM")

    # Set up workspace.
    Vₖ₋₁, Vₖ = workspace.Vₖ₋₁, workspace.Vₖ
    ΔX, X, Q, C = workspace.ΔX, workspace.X, workspace.Q, workspace.C
    D, Φ, stats = workspace.D, workspace.Φ, workspace.stats
    wₖ₋₂, wₖ₋₁, wₖ = workspace.wₖ₋₂, workspace.wₖ₋₁, workspace.wₖ
    Hₖ₋₂, Hₖ₋₁ = workspace.Hₖ₋₂, workspace.Hₖ₋₁
    τₖ₋₂, τₖ₋₁ = workspace.τₖ₋₂, workspace.τₖ₋₁
    buffer = workspace.buffer
    warm_start = workspace.warm_start
    RNorms = stats.residuals
    reset!(stats)
    R₀ = warm_start ? Q : B

    # Matrices in the workspace (some of them could be removed in the future)
    Ψₖ = workspace.Ψₖ
    Ωₖ = workspace.Ωₖ
    Ψₖ₊₁ = workspace.Ψₖ₊₁
    Πₖ₋₂ = workspace.Πₖ₋₂
    Γbarₖ₋₁ = workspace.Γbarₖ₋₁
    Γₖ₋₁ = workspace.Γₖ₋₁
    Λbarₖ = workspace.Λbarₖ
    Λₖ = workspace.Λₖ

    # Define the blocks D1 and D2
    D1 = view(D, 1:p, :)
    D2 = view(D, p+1:2p, :)
    trans = FC <: AbstractFloat ? 'T' : 'C'
    Φbarₖ = Φₖ = Φbarₖ₊₁ = Φ

    # Coefficients for mul!
    α = -one(FC)
    β = one(FC)
    γ = one(FC)

    # Initial solution X₀.
    fill!(X, zero(FC))

    # Initial residual R₀.
    if warm_start
      mul!(Q, A, ΔX)
      Q .= B .- Q
    end
    RNorm = norm(R₀)  # ‖R₀‖_F
    history && push!(RNorms, RNorm)

    iter = 0
    itmax == 0 && (itmax = 2*div(n,p))

    ε = atol + rtol * RNorm
    (verbose > 0) && @printf(iostream, "%5s  %7s  %5s\n", "k", "‖Rₖ‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %.2fs\n", iter, RNorm, start_time |> ktimer)

    # Stopping criterion
    status = "unknown"
    solved = RNorm ≤ ε
    tired = iter ≥ itmax
    user_requested_exit = false
    overtimed = false

    # Initial Ψ₁ and V₁
    τ = τₖ₋₂
    copyto!(Vₖ, R₀)
    householder!(Vₖ, Φbarₖ, τ, buffer)

    while !(solved || tired || user_requested_exit || overtimed)
      # Update iteration index.
      iter = iter + 1

      # Continue the block-Lanczos process.
      mul!(Q, A, Vₖ)                          # Q ← AVₖ
      mul!(Ωₖ, Vₖ', Q)                        # Ωₖ = Vₖᴴ * Q
      (iter ≥ 2) && mul!(Q, Vₖ₋₁, Ψₖ', α, β)  # Q ← Q - Vₖ₋₁ * Ψₖᴴ
      mul!(Q, Vₖ, Ωₖ, α, β)                   # Q = Q - Vₖ * Ωₖ

      # Update the QR factorization of Tₖ₊₁.ₖ = Qₖ [ Rₖ ].
      #                                            [ Oᵀ ]
      #
      # [ Ω₁ Ψ₂ᴴ 0  •  •  •  0   ]      [ Λ₁ Γ₁ Π₁ 0  •  •  0  ]
      # [ Ψ₂ Ω₂  •  •        •   ]      [ 0  Λ₂ Γ₂ •  •     •  ]
      # [ 0  •   •  •  •     •   ]      [ •  •  Λ₃ •  •  •  •  ]
      # [ •  •   •  •  •  •  •   ] = Qₖ [ •     •  •  •  •  0  ]
      # [ •      •  •  •  •  0   ]      [ •        •  •  • Πₖ₋₂]
      # [ •         •  •  •  Ψₖᴴ ]      [ •           •  • Γₖ₋₁]
      # [ •            •  Ψₖ Ωₖ  ]      [ 0  •  •  •  •  0  Λₖ ]
      # [ 0  •   •  •  •  0  Ψₖ₊₁]      [ 0  •  •  •  •  •  0  ]
      #
      # If k = 1, we don't have any previous reflection.
      # If k = 2, we apply the last reflection.
      # If k ≥ 3, we only apply the two previous reflections.

      # Apply previous Householder reflections Θₖ₋₂.
      if iter ≥ 3
        D1 .= zero(T)
        D2 .= Ψₖ'
        kormqr!('L', trans, Hₖ₋₂, τₖ₋₂, D, buffer)
        Πₖ₋₂ .= D1
        Γbarₖ₋₁ .= D2
      end

      # Apply previous Householder reflections Θₖ₋₁.
      if iter ≥ 2
        (iter == 2) && (Γbarₖ₋₁ .= Ψₖ')
        D1 .= Γbarₖ₋₁
        D2 .= Ωₖ
        kormqr!('L', trans, Hₖ₋₁, τₖ₋₁, D, buffer)
        Γₖ₋₁ .= D1
        Λbarₖ .= D2
      end

      # Vₖ₊₁ and Ψₖ₊₁ are stored in Q and Ψₖ₊₁.
      τ = τₖ₋₂
      householder!(Q, Ψₖ₊₁, τ, buffer)

      # Compute and apply current Householder reflection θₖ.
      Hₖ = Hₖ₋₂
      τₖ = τₖ₋₂
      (iter == 1) && (Λbarₖ .= Ωₖ)
      Hₖ[1:p,:] .= Λbarₖ
      Hₖ[p+1:2p,:] .= Ψₖ₊₁
      householder!(Hₖ, Λₖ, τₖ, buffer, compact=true)

      # Update Zₖ = (Qₖ)ᴴΨ₁E₁ = (Φ₁, ..., Φₖ, Φbarₖ₊₁)
      D1 .= Φbarₖ
      D2 .= zero(FC)
      kormqr!('L', trans, Hₖ, τₖ, D, buffer)
      Φₖ .= D1

      # Compute the directions Wₖ, the last columns of Wₖ = Vₖ(Rₖ)⁻¹ ⟷ (Rₖ)ᵀ(Wₖ)ᵀ = (Vₖ)ᵀ
      # w₁Λ₁ = v₁
      if iter == 1
        wₖ .= Vₖ
        rdiv!(wₖ, UpperTriangular(Λₖ))
      end
      # w₂Λ₂ = v₂ - w₁Γ₁
      if iter == 2
        @kswap!(wₖ₋₁, wₖ)
        wₖ .= Vₖ
        mul!(wₖ, wₖ₋₁, Γₖ₋₁, α, β)
        rdiv!(wₖ, UpperTriangular(Λₖ))
      end
      # wₖΛₖ = vₖ - wₖ₋₁Γₖ₋₁ - wₖ₋₂Πₖ₋₂
      if iter ≥ 3
        @kswap!(wₖ₋₂, wₖ₋₁)
        @kswap!(wₖ₋₁, wₖ)
        wₖ .= Vₖ
        mul!(wₖ, wₖ₋₂, Πₖ₋₂, α, β)
        mul!(wₖ, wₖ₋₁, Γₖ₋₁, α, β)
        rdiv!(wₖ, UpperTriangular(Λₖ))
      end

      # Update Xₖ = VₖYₖ = WₖZₖ
      # Xₖ = Xₖ₋₁ + wₖ * Φₖ
      mul!(X, wₖ, Φₖ, γ, β)

      # Update residual norm estimate.
      # ‖ M(B - AXₖ) ‖_F = ‖Φbarₖ₊₁‖_F
      Φbarₖ₊₁ .= D2
      RNorm = norm(Φbarₖ₊₁)
      history && push!(RNorms, RNorm)

      # Compute vₖ and vₖ₊₁
      copyto!(Vₖ₋₁, Vₖ)  # vₖ₋₁ ← vₖ
      copyto!(Vₖ, Q)     # vₖ ← vₖ₊₁

      # Swap the pointers for Hᵢ and τᵢ
      if iter ≥ 2
        @kswap!(Hₖ₋₂, Hₖ₋₁)
        @kswap!(τₖ₋₂, τₖ₋₁)
      end
      if iter == 1
        copyto!(Hₖ₋₁, Hₖ)
        copyto!(τₖ₋₁, τₖ)
      end
      copyto!(Ψₖ, Ψₖ₊₁)

      # Update stopping criterion.
      user_requested_exit = callback(workspace) :: Bool
      solved = RNorm ≤ ε
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %.2fs\n", iter, RNorm, start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    solved              && (status = "solution good enough given atol and rtol")
    overtimed           && (status = "time limit exceeded")
    user_requested_exit && (status = "user-requested exit")

    # Update Xₖ
    warm_start && (X .+= ΔX)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

# An implementation of MINRES for the solution of the
# linear system Ax = b, or the linear least-squares problem
#
#  minimize ‖Ax - b‖₂
#
# where A is Hermitian.
#
# MINRES is formally equivalent to applying the conjugate residuals method
# to Ax = b when A is positive definite, but is more general and also applies
# to the case where A is indefinite.
#
# This implementation follows the original implementation by
# Michael Saunders described in
#
# C. C. Paige and M. A. Saunders, Solution of Sparse Indefinite Systems of Linear Equations,
# SIAM Journal on Numerical Analysis, 12(4), pp. 617--629, 1975.
#
# Negative curvature detection follows
# Liu, Yang, and Roosta, MINRES: from negative curvature detection to monotonicity properties,
# SIAM Journal on Optimization, 32(4), pp. 2636--2661, 2022.
#
# M-A. Dahito and D. Orban, The Conjugate Residual Method in Linesearch and Trust-Region Methods.
# SIAM Journal on Optimization, 29(3), pp. 1988--2025, 2019.
#
# Dominique Orban, <dominique.orban@gerad.ca>
# Brussels, Belgium, June 2015.
# Montréal, August 2015.
#

export minres, minres!

"""
    (x, stats) = minres(A, b::AbstractVector{FC};
                        M=I, ldiv::Bool=false, window::Int=5,
                        linesearch::Bool=false, λ::T=zero(T), atol::T=√eps(T),
                        rtol::T=√eps(T), etol::T=√eps(T),
                        conlim::T=1/√eps(T), itmax::Int=0,
                        timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                        callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = minres(A, b, x0::AbstractVector; kwargs...)

MINRES can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above.

Solve the shifted linear least-squares problem

    minimize ‖b - (A + λI)x‖₂²

or the shifted linear system

    (A + λI) x = b

of size n using the MINRES method, where λ ≥ 0 is a shift parameter,
where A is Hermitian.

MINRES is formally equivalent to applying CR to Ax=b when A is positive
definite, but is typically more stable and also applies to the case where
A is indefinite.

MINRES produces monotonic residuals ‖r‖₂ and optimality residuals ‖Aᴴr‖₂.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :minres`.

For an in-place variant that reuses memory across solves, see [`minres!`](@ref).

#### Input arguments

* `A`: a linear operator that models a Hermitian matrix of dimension `n`;
* `b`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning;
* `ldiv`: define whether the preconditioner uses `ldiv!` or `mul!`;
* `window`: number of iterations used to accumulate a lower bound on the error;
* `linesearch`: if `true`, indicate that the solution is to be used in an inexact Newton method with linesearch. If `true` and nonpositive curvature is detected, the behavior depends on the iteration:
 – at iteration k = 1, the solver takes the right-hand side (i.e., the preconditioned negative gradient) as the current solution. The same search direction is returned in `workspace.npc_dir`, and `stats.npcCount` is set to 1;
 – at iteration k > 1, the solver returns the solution from iteration k – 1,
   - if the residual from iteration k is a nonpositive curvature direction but the search direction at iteration k, is not, the residual is stored in `stats.npc_dir` and `stats.npcCount` is set to 1;
   - if both are nonpositive curvature directions, the residual is stored in `stats.npc_dir`, the search direction is stored in `workspace.w1`, and `stats.npcCount` is set to 2. (Note that the MINRES solver starts at iteration 1, so the first iteration is k = 1);
* `λ`: regularization parameter;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `etol`: stopping tolerance based on the lower bound on the error;
* `conlim`: limit on the estimated condition number of `A` beyond which the solution will be abandoned;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### References

* C. C. Paige and M. A. Saunders, [*Solution of Sparse Indefinite Systems of Linear Equations*](https://doi.org/10.1137/0712047), SIAM Journal on Numerical Analysis, 12(4), pp. 617--629, 1975.

* Y. Liu and F. Roosta, [*MINRES: From Negative Curvature Detection to Monotonicity Properties*](https://doi.org/10.1137/21M143666X), SIAM Journal on Optimization, 32(4), pp. 2636--2661, 2022.

* M-A. Dahito and D. Orban, [*The Conjugate Residual Method in Linesearch and Trust-Region Methods*](https://doi.org/10.1137/18M1204255), SIAM Journal on Optimization, 29(3), pp. 1988--2025, 2019.
"""
function minres end

"""
    workspace = minres!(workspace::MinresWorkspace, A, b; kwargs...)
    workspace = minres!(workspace::MinresWorkspace, A, b, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`minres`](@ref).
The keyword argument `window` is the only exception.
It is only supported by [`minres`](@ref) and is required to create a `MinresWorkspace`.
It cannot be changed later.

See [`MinresWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :minres` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function minres! end

def_args_minres = (:(A                    ),
                   :(b::AbstractVector{FC}))

def_optargs_minres = (:(x0::AbstractVector),)

def_kwargs_minres = (:(; M = I                        ),
                     :(; ldiv::Bool = false           ),
                     :(; linesearch::Bool = false     ),
                     :(; λ::T = zero(T)               ),
                     :(; atol::T = √eps(T)            ),
                     :(; rtol::T = √eps(T)            ),
                     :(; etol::T = √eps(T)            ),
                     :(; conlim::T = 1/√eps(T)        ),
                     :(; itmax::Int = 0               ),
                     :(; timemax::Float64 = Inf       ),
                     :(; verbose::Int = 0             ),
                     :(; history::Bool = false        ),
                     :(; callback = workspace -> false),
                     :(; iostream::IO = kstdout       ))

def_kwargs_workspace_minres = (:(; window::Int = 5),)

def_kwargs_minres = extract_parameters.(def_kwargs_minres)
def_kwargs_workspace_minres = extract_parameters.(def_kwargs_workspace_minres)

args_minres = (:A, :b)
optargs_minres = (:x0,)
kwargs_minres = (:M, :ldiv, :linesearch ,:λ, :atol, :rtol, :etol, :conlim, :itmax, :timemax, :verbose, :history, :callback, :iostream)
kwargs_workspace_minres = (:window,)

@eval begin
  function minres!(workspace :: MinresWorkspace{T,FC,S}, $(def_args_minres...); $(def_kwargs_minres...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("System must be square")
    length(b) == n || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "MINRES: system of size %d\n", n)
    (workspace.warm_start && linesearch) && error("warm_start and linesearch cannot be used together")

    # Tests M = Iₙ
    MisI = (M === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")

    # Set up workspace.
    allocate_if(!MisI, workspace, :v, S, workspace.x)  # The length of v is n
    allocate_if(linesearch, workspace, :npc_dir , S, workspace.x)  # The length of npc_dir is n
    Δx, x, r1, r2, w1, w2, y = workspace.Δx, workspace.x, workspace.r1, workspace.r2, workspace.w1, workspace.w2, workspace.y
    err_vec, stats = workspace.err_vec, workspace.stats
    warm_start = workspace.warm_start
    rNorms, ArNorms, Aconds = stats.residuals, stats.Aresiduals, stats.Acond
    reset!(stats)

    v = MisI ? r2 : workspace.v
    if linesearch
      npc_dir = workspace.npc_dir
    end
    ϵM = eps(T)
    ctol = conlim > 0 ? inv(conlim) : zero(T)

    # Initial solution x₀
    kfill!(x, zero(FC))

    if warm_start
      kmul!(r1, A, Δx)
      (λ ≠ 0) && kaxpy!(n, λ, Δx, r1)
      kaxpby!(n, one(FC), b, -one(FC), r1)
    else
      kcopy!(n, r1, b)  # r1 ← b
    end

    # Initialize Lanczos process.
    # β₁ M v₁ = b.
    kcopy!(n, r2, r1)  # r2 ← r1
    MisI || mulorldiv!(v, M, r1, ldiv)

    linesearch && kcopy!(n, npc_dir , v)  # npc_dir  ← v; contain the preconditioned initial residual

    β₁ = kdotr(m, r1, v)
    β₁ < 0 && error("Preconditioner is not positive definite")
    if β₁ == 0
      stats.niter = 1
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      history && push!(rNorms, β₁)
      history && push!(ArNorms, zero(T))
      history && push!(Aconds, zero(T))
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end
    β₁ = sqrt(β₁)
    β = β₁

    oldβ = zero(T)
    δbar = zero(T)
    ϵ = zero(T)
    rNorm = β₁
    history && push!(rNorms, β₁)
    ϕbar = β₁
    rhs1 = β₁
    rhs2 = zero(T)
    γmax = zero(T)
    γmin = T(Inf)
    cs = -one(T)
    sn = zero(T)
    kfill!(w1, zero(FC))
    kfill!(w2, zero(FC))

    ANorm² = zero(T)
    ANorm = zero(T)
    Acond = zero(T)
    history && push!(Aconds, Acond)
    ArNorm = zero(T)
    history && push!(ArNorms, ArNorm)
    xNorm = zero(T)

    xENorm² = zero(T)
    err_lbnd = zero(T)
    window = length(err_vec)
    kfill!(err_vec, zero(T))

    iter = 0
    itmax == 0 && (itmax = 2*n)

    (verbose > 0) && @printf(iostream, "%5s  %7s  %7s  %7s  %8s  %8s  %7s  %7s  %7s  %7s  %5s\n", "k", "‖r‖", "‖Aᴴr‖", "β", "cos", "sin", "‖A‖", "κ(A)", "test1", "test2", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %8.1e  %8.1e  %7.1e  %7.1e  %7s  %7s  %.2fs\n", iter, rNorm, ArNorm, β, cs, sn, ANorm, Acond, "✗ ✗ ✗ ✗", "✗ ✗ ✗ ✗", start_time |> ktimer)

    ε = atol + rtol * β₁
    solved = solved_mach = solved_lim = false
    tired  = iter ≥ itmax
    ill_cond = ill_cond_mach = ill_cond_lim = false
    zero_resid = zero_resid_mach = zero_resid_lim = (rNorm ≤ ε)
    fwd_err = false
    user_requested_exit = false
    overtimed = false
    stats.indefinite = false

    # initialize recurrences to calculate the curvature along search directions
    δ_w = zero(T)
    β_w = zero(T)
    ζ_k = zero(T)
    ζ_km1 = zero(T)

    while !(solved || tired || ill_cond || user_requested_exit || overtimed)
      iter = iter + 1

      # Generate next Lanczos vector.
      kmul!(y, A, v)
      λ ≠ 0 && kaxpy!(n, λ, v, y)              # (y = y + λ * v)
      kdiv!(n, y, β)                           # (y = y / β)
      iter ≥ 2 && kaxpy!(n, -β / oldβ, r1, y)  # (y = y - β / oldβ * r1)

      α = kdotr(n, v, y) / β
      kaxpy!(n, -α / β, r2, y)  # y = y - α / β * r2

      # Compute w.
      δ = cs * δbar + sn * α
      if iter == 1
        w = w2
        kdivcopy!(n, w, v, β)
      else
        w = w1
        iter ≥ 3 && kscal!(n, -ϵ, w)
        kaxpy!(n, -δ, w2, w)
        kaxpy!(n, one(FC) / β, v, w)
      end

      kcopy!(n, r1, r2)  # r1 ← r2
      kcopy!(n, r2, y)   # r2 ← y
      MisI || mulorldiv!(v, M, r2, ldiv)
      oldβ = β
      β = kdotr(n, r2, v)
      β < 0 && error("Preconditioner is not positive definite")
      β = sqrt(β)
      ANorm² = ANorm² + α * α + oldβ * oldβ + β * β

      # Apply rotation to obtain
      #  [ δₖ    ϵₖ₊₁    ] = [ cs  sn ] [ δbarₖ  0    ]
      #  [ γbar  δbarₖ₊₁ ]   [ sn -cs ] [ αₖ     βₖ₊₁ ]
      γbar = sn * δbar - cs * α
      ϵ = sn * β
      δbar = -cs * β
      root = sqrt(γbar * γbar + δbar * δbar)
      ArNorm = ϕbar * root  # = ‖Aᴴrₖ₋₁‖
      history && push!(ArNorms, ArNorm)

      # Compute the next plane rotation (part 1).
      γ = sqrt(γbar * γbar + β * β)
      γ = max(γ, ϵM)
      
      # Final update of w.
      kdiv!(n, w, γ)

      # Check for nonpositive curvature
      if linesearch
        cγ = cs * γbar
        if iter > 1
          # Compute ζ_k (≡ r_k^T * A * r_k), which is the term adapted from M-A. Dahito and D. Orban's paper.
          # This uses the recurrence relation: δ_k = ζ_k + β_k^2 * δ_(k-1),
          # where ζ_k = r_k^T * A * r_k and β_k = ζ_k / ζ_(k-1). (See Roosta's paper.)
          # ζ_km1 is ζ_(k-1) from the previous iteration.
          ζ_km1 = ζ_k
          ζ_k = -cγ * rNorm^2   # ζ_k ← r_k^T * A * r_k
          β_w = (ζ_km1 != 0) ? ζ_k/ζ_km1 : ζ_k  # β_w ← ζ_k / ζ_(k-1)
          δ_w = ζ_k + β_w^2* δ_w  # δ_w ← δ_k = ζ_k + β_k^2 * δ_(k-1)
        end

        if cγ ≥ 0
          # Nonpositive curvature detected.
          (verbose > 0) && @printf(iostream, "nonpositive curvature detected:  cs * γbar = %e\n", cγ)
          stats.solved = true
          stats.npcCount = 1
          w1 = w

          if iter == 1
            kcopy!(n, x, b)
          else
            # Check the w direction to see if it's also a nonpositive curvature direction.
            if δ_w < 0
              # w is also a nonpositive curvature direction, increment npcCount to 2
              stats.npcCount = 2
            end
          end
          stats.niter = iter
          stats.inconsistent = false
          stats.timer = start_time |> ktimer
          stats.status = "nonpositive curvature"
          workspace.warm_start = false
          stats.indefinite = true
          return workspace
        end
      end

      # Compute the next plane rotation (part 2).
      cs = γbar / γ
      sn = β / γ
      ϕ = cs * ϕbar
      ϕbar = sn * ϕbar

      if linesearch
        # compute the residual vector and store it in npc_dir
        kscal!(n, sn * sn, npc_dir)  # npc_dir  = sn * sn * npc_dir 
        # Need to divide by β, since v has not been normalized yet.
        kaxpy!(n, -ϕbar * cs / β, v, npc_dir)  # npc_dir  = npc_dir  - ϕbar * cs * v
      end

      # Update x.
      kaxpy!(n, ϕ, w, x)  # x = x + ϕ * w
      xENorm² = xENorm² + ϕ * ϕ

      # Update directions for x.
      if iter ≥ 2
        @kswap!(w1, w2)
      end

      # Compute lower bound on forward error.
      err_vec[mod(iter, window) + 1] = ϕ
      iter ≥ window && (err_lbnd = knorm(window, err_vec))

      γmax = max(γmax, γ)
      γmin = min(γmin, γ)
      ζ = rhs1 / γ
      rhs1 = rhs2 - δ * ζ
      rhs2 = -ϵ * ζ

      # Estimate various norms.
      ANorm = sqrt(ANorm²)
      xNorm = knorm(n, x)
      ϵA = ANorm * ϵM
      ϵx = ANorm * xNorm * ϵM
      ϵr = ANorm * xNorm * rtol
      d = γbar
      d == 0 && (d = ϵA)

      rNorm = ϕbar

      test1 = rNorm / (ANorm * xNorm)
      test2 = root / ANorm
      history && push!(rNorms, rNorm)

      Acond = γmax / γmin
      history && push!(Aconds, Acond)

      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %8.1e  %8.1e  %7.1e  %7.1e  %7.1e  %7.1e  %.2fs\n", iter, rNorm, ArNorm, β, cs, sn, ANorm, Acond, test1, test2, start_time |> ktimer)

      if iter == 1 && β / β₁ ≤ 10 * ϵM
        # Aᴴb = 0 so x = 0 is a minimum least-squares solution
        stats.niter = 1
        stats.solved, stats.inconsistent = true, true
        stats.timer = start_time |> ktimer
        stats.status = "x is a minimum least-squares solution"
        warm_start && kaxpy!(n, one(FC), Δx, x)
        workspace.warm_start = false
        return workspace
      end

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      ill_cond_mach = (one(T) + inv(Acond) ≤ one(T))
      solved_mach = (one(T) + test2 ≤ one(T))
      zero_resid_mach = (one(T) + test1 ≤ one(T))
      resid_decrease_mach = (rNorm + one(T) ≤ one(T))
      # solved_mach = (ϵx ≥ β₁)

      # Stopping conditions based on user-provided tolerances.
      tired = iter ≥ itmax
      ill_cond_lim = (inv(Acond) ≤ ctol)
      solved_lim = (test2 ≤ ε)
      zero_resid_lim = MisI && (test1 ≤ eps(T))
      resid_decrease_lim = (rNorm ≤ ε)
      iter ≥ window && (fwd_err = err_lbnd ≤ etol * sqrt(xENorm²))

      user_requested_exit = callback(workspace) :: Bool
      zero_resid = zero_resid_mach || zero_resid_lim
      resid_decrease = resid_decrease_mach || resid_decrease_lim
      ill_cond = ill_cond_mach || ill_cond_lim
      solved = solved_mach || solved_lim || zero_resid || fwd_err || resid_decrease
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    ill_cond_mach       && (status = "condition number seems too large for this machine")
    ill_cond_lim        && (status = "condition number exceeds tolerance")
    solved              && (status = "found approximate minimum least-squares solution")
    zero_resid          && (status = "found approximate zero-residual solution")
    fwd_err             && (status = "truncated forward error small enough")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update x
    warm_start && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = !zero_resid
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

function test_warm_start(FC)
  T = real(FC)
  A, b = warm_start(FC=FC)
  c = copy(b)
  n, m = size(A)
  x0 = 1.2 * ones(FC, n)
  y0 = 0.8 * ones(FC, n)
  shifts = [1.0; 2.0; 3.0; 4.0; 5.0]
  nshifts = 5
  tol = 1.0e-6

  J = 5 * Matrix{FC}(I, n, n)
  z0 = -2 * ones(FC, n)
  d = -10 * ones(FC, n)

  # For relevant bipartite methods, it's also important to test asymmetric sizes
  A3x2, b3, c2, M3x3, N2x2 = small_sqd(false; FC)

  # BILQR
  @testset "bilqr" begin
    x, y, stats = bilqr(A, b, c, x0, y0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)
    s = c - A' * y
    resid = norm(s) / norm(c)
    @test(resid ≤ tol)

    workspace = BilqrWorkspace(A, b)
    krylov_solve!(workspace, A, b, c, x0, y0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)
    s = c - A' * workspace.y
    resid = norm(s) / norm(c)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, d, z0, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
    s = d - J' * workspace.y
    resid = norm(s) / norm(d)
    @test(resid ≤ tol)
  end

  # TRILQR
  @testset "trilqr" begin
    x, y, stats = trilqr(A, b, c, x0, y0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)
    s = c - A' * y
    resid = norm(s) / norm(c)
    @test(resid ≤ tol)

    x30, y20, _ = trilqr(A3x2, b3, c2)
    x3, y2, stats = trilqr(A3x2, b3, c2, x30, y20)
    @test_broken x3 ≈ x30 atol=1e-12
    @test y2 ≈ y20 atol=1e-12
    @test_broken stats.niter <= 1
    @test_throws "x0 should have size $(length(x30))" trilqr(A3x2, b3, c2, [1.0], y20)
    @test_throws "y0 should have size $(length(y20))" trilqr(A3x2, b3, c2, x30, [1.0])

    workspace = TrilqrWorkspace(A, b)
    krylov_solve!(workspace, A, b, c, x0, y0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)
    s = c - A' * workspace.y
    resid = norm(s) / norm(c)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, d, z0, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
    s = d - J' * workspace.y
    resid = norm(s) / norm(d)
    @test(resid ≤ tol)
  end

  # TRICG
  @testset "tricg" begin
    x, y, stats = tricg(A, b, b, x0, y0)
    r = [b - x - A * y; b - A' * x + y]
    resid = norm(r) / norm([b; b])
    @test(resid ≤ tol)

    x30, y20, _ = tricg(A3x2, b3, c2)
    x3, y2, stats = tricg(A3x2, b3, c2, x30, y20)
    @test x3 ≈ x30 atol=1e-12
    @test y2 ≈ y20 atol=1e-12
    @test stats.niter <= 1
    @test_throws "x0 should have size $(length(x30))" tricg(A3x2, b3, c2, [1.0], y20)
    @test_throws "y0 should have size $(length(y20))" tricg(A3x2, b3, c2, x30, [1.0])
    workspace = TricgWorkspace(A, b)
    krylov_solve!(workspace, A, b, b, x0, y0)
    r = [b - workspace.x - A * workspace.y; b - A' * workspace.x + workspace.y]
    resid = norm(r) / norm([b; b])
    @test(resid ≤ tol)

    τ = zero(T)
    ν = zero(T)
    krylov_solve!(workspace, J, d, d, z0, z0; τ, ν)
    r = [d - τ * workspace.x - J * workspace.y; d - J' * workspace.x - ν * workspace.y]
    resid = norm(r) / norm([d; d])
    @test(resid ≤ tol)
  end

  # TRIMR
  @testset "trimr" begin
    x, y, stats = trimr(A, b, b, x0, y0)
    r = [b - x - A * y; b - A' * x + y]
    resid = norm(r) / norm([b; b])
    @test(resid ≤ tol)

    x30, y20, _ = trimr(A3x2, b3, c2)
    x3, y2, stats = trimr(A3x2, b3, c2, x30, y20)
    @test x3 ≈ x30 atol=1e-12
    @test y2 ≈ y20 atol=1e-12
    @test stats.niter <= 1
    @test_throws "x0 should have size $(length(x30))" trimr(A3x2, b3, c2, [1.0], y20)
    @test_throws "y0 should have size $(length(y20))" trimr(A3x2, b3, c2, x30, [1.0])
    workspace = TrimrWorkspace(A, b)
    krylov_solve!(workspace, A, b, b, x0, y0)
    r = [b - workspace.x - A * workspace.y; b - A' * workspace.x + workspace.y]
    resid = norm(r) / norm([b; b])
    @test(resid ≤ tol)

    τ = zero(T)
    ν = zero(T)
    krylov_solve!(workspace, J, d, d, z0, z0; τ, ν)
    r = [d - τ * workspace.x - J * workspace.y; d - J' * workspace.x - ν * workspace.y]
    resid = norm(r) / norm([d; d])
    @test(resid ≤ tol)
  end

  # USYMLQR
  @testset "usymlqr" begin
    x, y, stats = usymlqr(A, b, b, x0, y0)
    r = [b - x - A * y; b - A' * x]
    resid = norm(r) / norm([b; b])
    @test(resid ≤ tol)

    workspace = UsymlqrWorkspace(A, b)
    krylov_solve!(workspace, A, b, b, x0, y0)
    r = [b - workspace.x - A * workspace.y; b - A' * workspace.x]
    resid = norm(r) / norm([b; b])
    @test(resid ≤ tol)

    krylov_solve!(workspace, A, b, b, z0, z0)
    r = [b - workspace.x - A * workspace.y; b - A' * workspace.x]
    resid = norm(r) / norm([b; b])
    @test(resid ≤ tol)
  end

  # GPMR
  @testset "gpmr" begin
    x, y, stats = gpmr(A, A', b, b, x0, y0)
    r = [b - x - A * y; b - A' * x - y]
    resid = norm(r) / norm([b; b])
    @test(resid ≤ tol)

    x30, y20, _ = gpmr(A3x2, A3x2', b3, c2)
    x3, y2, stats = gpmr(A3x2, A3x2', b3, c2, x30, y20)
    @test stats.niter <= 1
    @test_throws "x0 should have size $(length(x30))" gpmr(A3x2, A3x2', b3, c2, [1.0], y20)
    @test_throws "y0 should have size $(length(y20))" gpmr(A3x2, A3x2', b3, c2, x30, [1.0])
    workspace = GpmrWorkspace(A, b)
    krylov_solve!(workspace, A, A', b, b, x0, y0)
    r = [b - workspace.x - A * workspace.y; b - A' * workspace.x - workspace.y]
    resid = norm(r) / norm([b; b])
    @test(resid ≤ tol)

    λ = zero(FC)
    μ = zero(FC)
    krylov_solve!(workspace, J, J', d, d, z0, z0; λ, μ)
    r = [d - λ * workspace.x - J * workspace.y; d - J' * workspace.x - μ * workspace.y]
    resid = norm(r) / norm([d; d])
    @test(resid ≤ tol)
  end

  # MINRES-QLP
  @testset "minres_qlp" begin
    x, stats = minres_qlp(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = MinresQlpWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # SYMMLQ
  @testset "symmlq" begin
    x, stats = symmlq(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = SymmlqWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # CG
  @testset "cg" begin
    x, stats = cg(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = CgWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # CR
  @testset "cr" begin
    x, stats = cr(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = CrWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # CAR
  @testset "car" begin
    x, stats = car(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = CarWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # CG-LANCZOS
  @testset "cg_lanczos" begin
    x, stats = cg_lanczos(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = CgLanczosWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # MINRES
  @testset "minres" begin
    x, stats = minres(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = MinresWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # MINARES
  @testset "minares" begin
    x, stats = minares(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = MinaresWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # DIOM
  @testset "diom" begin
    x, stats = diom(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = DiomWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # DQGMRES
  @testset "dqgmres" begin
    x, stats = dqgmres(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = DqgmresWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # FOM
  @testset "fom" begin
    x, stats = fom(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = FomWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # GMRES
  @testset "gmres" begin
    x, stats = gmres(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = GmresWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # FGMRES
  @testset "fgmres" begin
    x, stats = fgmres(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = FgmresWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # BICGSTAB
  @testset "bicgstab" begin
    x, stats = bicgstab(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = BicgstabWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # CGS
  @testset "cgs" begin
    x, stats = cgs(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = CgsWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # BILQ
  @testset "bilq" begin
    x, stats = bilq(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = BilqWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # QMR
  @testset "qmr" begin
    x, stats = qmr(A, b, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = QmrWorkspace(A, b)
    krylov_solve!(workspace, A, b, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # USYMLQ
  @testset "usymlq" begin
    x, stats = usymlq(A, b, c, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = UsymlqWorkspace(A, b)
    krylov_solve!(workspace, A, b, c, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end

  # USYMQR
  @testset "usymqr" begin
    x, stats = usymqr(A, b, c, x0)
    r = b - A * x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    workspace = UsymqrWorkspace(A, b)
    krylov_solve!(workspace, A, b, c, x0)
    r = b - A * workspace.x
    resid = norm(r) / norm(b)
    @test(resid ≤ tol)

    krylov_solve!(workspace, J, d, d, z0)
    r = d - J * workspace.x
    resid = norm(r) / norm(d)
    @test(resid ≤ tol)
  end
end

@testset "warm-start" begin
  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin
      test_warm_start(FC)
    end
  end
end

@testset "Block processes" begin
  m = 250
  n = 500
  k = 20
  p = 4
  s = 4
  verbose = false

  for FC in (Float64, ComplexF64)
    nbits_FC = sizeof(FC)
    nbits_I = sizeof(Int)

    @testset "Data Type: $FC" begin

      @testset "Block Hermitian Lanczos" begin
        A = rand(FC, n, n)
        A = A' * A
        B = rand(FC, n, p)

        @testset "algo = $algo" for algo in ("householder", "gs", "mgs", "givens")
          V, Ψ₁, T = hermitian_lanczos(A, B, k; algo)

          @test norm(V[:,1:p*s]' * V[:,1:p*s] - I) ≤ 1e-4
          @test V[:,1:p] * Ψ₁ ≈ B
          @test A * V[:,1:p*k] ≈ V * T
        end

        @testset "memory" begin
          function storage_block_hermitian_lanczos_bytes(n, p, k)
            nnzT = p*p + (k-1)*p*(2*p+1) + div(p*(p+1), 2)
            memory = 0
            memory += (p*k+1) * nbits_I       # Tₖ₊₁.ₖ -- colptr
            memory += nnzT * nbits_I          # Tₖ₊₁.ₖ -- rowval
            memory += nnzT * nbits_FC         # Tₖ₊₁.ₖ -- nzval
            memory += p*p * nbits_FC          # Ψ₁
            memory += p*p * nbits_FC          # Ωᵢ, Ψᵢ and Ψᵢ₊₁
            memory += n*p * (k+1) * nbits_FC  # Vₖ₊₁
            memory += p*n * nbits_FC          # q
            return memory
          end

          expected_block_hermitian_lanczos_bytes = storage_block_hermitian_lanczos_bytes(n, p, k)
          actual_block_hermitian_lanczos_bytes = @allocated hermitian_lanczos(A, B, k; algo="mgs")
          verbose && println("Block Hermitian Lanczos | $FC")
          verbose && println(expected_block_hermitian_lanczos_bytes, " ≤ ", actual_block_hermitian_lanczos_bytes, " ≤ ", 1.02 * expected_block_hermitian_lanczos_bytes, " ?")
          verbose && println()
          if VERSION < v"1.11.5" || !Sys.isapple()
            @test expected_block_hermitian_lanczos_bytes ≤ actual_block_hermitian_lanczos_bytes ≤ 1.02 * expected_block_hermitian_lanczos_bytes
          end
        end
      end

      @testset "Block Non-Hermitian Lanczos" begin
        A = rand(FC, n, n)
        B = rand(FC, n, p)
        C = rand(FC, n, p)
        V, Ψ₁, T, U, Φ₁ᴴ, Tᴴ = nonhermitian_lanczos(A, B, C, k)

        @test norm(V[:,1:p*s]' * U[:,1:p*s] - I) ≤ 1e-4
        @test norm(U[:,1:p*s]' * V[:,1:p*s] - I) ≤ 1e-4
        @test V[:,1:p] * Ψ₁ ≈ B
        @test U[:,1:p] * Φ₁ᴴ ≈ C
        @test T[1:k*p,1:k*p] ≈ Tᴴ[1:k*p,1:k*p]'
        @test A  * V[:,1:k*p] ≈ V * T
        @test A' * U[:,1:k*p] ≈ U * Tᴴ

        @testset "memory" begin
          # storage_block_nonhermitian_lanczos_bytes(n, p, k) = ...
          #
          #   expected_block_nonhermitian_lanczos_bytes = storage_block_nonhermitian_lanczos_bytes(n, p, k)
          #   actual_block_nonhermitian_lanczos_bytes = @allocated nonhermitian_lanczos(A, B, C, k)
          #   verbose && println("Block non-Hermitian Lanczos")
          #   verbose && println(expected_block_nonhermitian_lanczos_bytes, " ≤ ", actual_block_nonhermitian_lanczos_bytes, " ≤ ", 1.02 * expected_block_nonhermitian_lanczos_bytes, " ?")
          #   verbose && println()
          #   @test expected_block_nonhermitian_lanczos_bytes ≤ actual_block_nonhermitian_lanczos_bytes ≤ 1.02 * expected_block_nonhermitian_lanczos_bytes
        end
      end

      @testset "Block Arnoldi" begin
        A = rand(FC, n, n)
        B = rand(FC, n, p)

        @testset "algo = $algo" for algo in ("householder", "gs", "mgs", "givens")
          @testset "reorthogonalization = $reorthogonalization" for reorthogonalization in (false, true)
            V, Γ, H = arnoldi(A, B, k; algo, reorthogonalization)

            @test norm(V[:,1:p*s]' * V[:,1:p*s] - I) ≤ 1e-4
            @test V[:,1:p] * Γ ≈ B
            @test A * V[:,1:p*k] ≈ V * H
          end
        end

        @testset "memory -- reorthogonalization = $reorthogonalization" for reorthogonalization in (false, true)
          function storage_block_arnoldi_bytes(n, p, k)
            memory = 0
            memory += p*n * (k+1) * nbits_FC    # Vₖ₊₁
            memory += n*p * nbits_FC            # q
            memory += p*k * p*(k+1) * nbits_FC  # Hₖ₊₁.ₖ
            memory += p*p * nbits_FC            # Γ
            memory += p*p * nbits_FC            # Ψᵢⱼ and Ψtmp
            return memory
          end

          expected_block_arnoldi_bytes = storage_block_arnoldi_bytes(n, p, k)
          actual_block_arnoldi_bytes = @allocated arnoldi(A, B, k; algo="mgs", reorthogonalization)
          verbose && println("Block Arnoldi | $FC")
          verbose && println(expected_block_arnoldi_bytes, " ≤ ", actual_block_arnoldi_bytes, " ≤ ", 1.02 * expected_block_arnoldi_bytes, " ?")
          verbose && println()
          if VERSION < v"1.11.5" || !Sys.isapple()
            @test expected_block_arnoldi_bytes ≤ actual_block_arnoldi_bytes ≤ 1.02 * expected_block_arnoldi_bytes
          end
        end
      end

      @testset "Block Golub-Kahan" begin
        A = rand(FC, m, n)
        B = rand(FC, m, p)

        @testset "algo = $algo" for algo in ("householder", "gs", "mgs", "givens")
          V, U, Ψ₁, L = golub_kahan(A, B, k; algo)
          BL = L[1:(k+1)*p,1:k*p]

          @test norm(V[:,1:p*s]' * V[:,1:p*s] - I) ≤ 1e-4
          @test norm(U[:,1:p*s]' * U[:,1:p*s] - I) ≤ 1e-4
          @test U[:,1:p] * Ψ₁ ≈ B
          @test A  * V[:,1:k*p] ≈ U * BL
          @test A' * U ≈ V * L'
          @test A' * A  * V[:,1:k*p] ≈ V * L' * BL
          @test A  * A' * U[:,1:k*p] ≈ U * BL * L[1:k*p,1:k*p]'
        end

        @testset "memory" begin
          function storage_block_golub_kahan_bytes(m, n, p, k)
            nnzL = p*k*(p+1) + div(p*(p+1), 2)
            memory = 0
            memory += (p*(k+1)+1) * nbits_I       # Lₖ₊₁ -- colptr
            memory += nnzL * nbits_I              # Lₖ₊₁ -- rowval
            memory += nnzL * nbits_FC             # Lₖ₊₁ -- nzval
            memory += p*p * nbits_FC              # Ψ₁
            memory += p*p * nbits_FC              # Ψᵢ₊₁, TΩᵢ and TΩᵢ₊₁
            memory += p*(n+m) * (k+1) * nbits_FC  # Vₖ₊₁ and Uₖ₊₁
            memory += p*(n+m) * nbits_FC          # qᵥ and qᵤ
            return memory
          end

          expected_block_golub_kahan_bytes = storage_block_golub_kahan_bytes(m, n, p, k)
          actual_block_golub_kahan_bytes = @allocated golub_kahan(A, B, k; algo="mgs")
          verbose && println("Block Golub-Kahan | $FC")
          verbose && println(expected_block_golub_kahan_bytes, " ≤ ", actual_block_golub_kahan_bytes, " ≤ ", 1.02 * expected_block_golub_kahan_bytes, " ?")
          verbose && println()
          if VERSION < v"1.11.5" || !Sys.isapple()
            @test expected_block_golub_kahan_bytes ≤ actual_block_golub_kahan_bytes ≤ 1.02 * expected_block_golub_kahan_bytes
          end
        end
      end

      @testset "Block Saunders-Simon-Yip" begin
        A = rand(FC, m, n)
        B = rand(FC, m, p)
        C = rand(FC, n, p)

        @testset "algo = $algo" for algo in ("householder", "gs", "mgs", "givens")
          V, Ψ₁, T, U, Φ₁ᴴ, Tᴴ = saunders_simon_yip(A, B, C, k; algo)

          @test norm(V[:,1:p*s]' * V[:,1:p*s] - I) ≤ 1e-4
          @test norm(U[:,1:p*s]' * U[:,1:p*s] - I) ≤ 1e-4
          @test V[:,1:p] * Ψ₁ ≈ B
          @test U[:,1:p] * Φ₁ᴴ ≈ C
          @test T[1:k*p,1:k*p] ≈ Tᴴ[1:k*p,1:k*p]'
          @test A  * U[:,1:k*p] ≈ V * T
          @test A' * V[:,1:k*p] ≈ U * Tᴴ
          @test A' * A  * U[:,1:(k-1)*p] ≈ U * Tᴴ * T[1:k*p,1:(k-1)*p]
          @test A  * A' * V[:,1:(k-1)*p] ≈ V * T * Tᴴ[1:k*p,1:(k-1)*p]
        end

        @testset "memory" begin
          function storage_block_saunders_simon_yip_bytes(m, n, p, k)
            nnzT = p*p + (k-1)*p*(2*p+1) + div(p*(p+1), 2)
            memory = 0
            memory += (p*k+1) * nbits_I           # Tₖ₊₁.ₖ and (Tₖ.ₖ₊₁)ᴴ -- colptr
            memory += nnzT * nbits_I              # Tₖ₊₁.ₖ and (Tₖ.ₖ₊₁)ᴴ -- rowval
            memory += 2 * nnzT * nbits_FC         # Tₖ₊₁.ₖ and (Tₖ.ₖ₊₁)ᴴ -- nzval
            memory += 2 * p*p * nbits_FC          # Ψ₁ and Φ₁ᴴ
            memory += p*p * nbits_FC              # Ωᵢ, Ψᵢ, Ψᵢ₊₁, TΦᵢ and TΦᵢ₊₁
            memory += p*(n+m) * (k+1) * nbits_FC  # Vₖ₊₁ and Uₖ₊₁
            memory += p*(n+m) * nbits_FC          # qᵥ and qᵤ
          end

          expected_block_saunders_simon_yip_bytes = storage_block_saunders_simon_yip_bytes(m, n, p, k)
          actual_block_saunders_simon_yip_bytes = @allocated saunders_simon_yip(A, B, C, k; algo="mgs")
          verbose && println("Block Saunders-Simon-Yip")
          verbose && println(expected_block_saunders_simon_yip_bytes, " ≤ ", actual_block_saunders_simon_yip_bytes, " ≤ ", 1.02 * expected_block_saunders_simon_yip_bytes, " ?")
          verbose && println()
          if VERSION < v"1.11.5" || !Sys.isapple()
            @test expected_block_saunders_simon_yip_bytes ≤ actual_block_saunders_simon_yip_bytes ≤ 1.02 * expected_block_saunders_simon_yip_bytes
          end
        end
      end

      @testset "Block Montoison-Orban" begin
        A = rand(FC, m, n)
        B = rand(FC, n, m)
        D = rand(FC, m, p)
        C = rand(FC, n, p)

        @testset "algo = $algo" for algo in ("householder", "gs", "mgs", "givens")
          @testset "reorthogonalization = $reorthogonalization" for reorthogonalization in (false, true)
            V, Γ, H, U, Λ, F = montoison_orban(A, B, D, C, k; algo, reorthogonalization)

            @test norm(V[:,1:p*s]' * V[:,1:p*s] - I) ≤ 1e-4
            @test norm(U[:,1:p*s]' * U[:,1:p*s] - I) ≤ 1e-4
            @test V[:,1:p] * Γ ≈ D
            @test U[:,1:p] * Λ ≈ C
            @test A * U[:,1:k*p] ≈ V * H
            @test B * V[:,1:k*p] ≈ U * F
            @test B * A * U[:,1:(k-1)*p] ≈ U * F * H[1:k*p,1:(k-1)*p]
            @test A * B * V[:,1:(k-1)*p] ≈ V * H * F[1:k*p,1:(k-1)*p]
          end
        end

        @testset "memory -- reorthogonalization = $reorthogonalization" for reorthogonalization in (false, true)
          function storage_block_montoison_orban_bytes(m, n, p, k)
            memory = 0
            memory += 2 * p*p * nbits_FC            # Γ and Λ
            memory += p*p * nbits_FC                # Ψᵢⱼ, Φᵢⱼ, Ψtmp and Φtmp
            memory += 2 * p*k * p*(k+1) * nbits_FC  # Hₖ₊₁.ₖ and Fₖ₊₁.ₖ
            memory += p*(n+m) * (k+1) * nbits_FC    # Vₖ₊₁ and Uₖ₊₁
            memory += p*(n+m)* nbits_FC             # qᵥ and qᵤ
            return memory
          end

          expected_block_montoison_orban_bytes = storage_block_montoison_orban_bytes(m, n, p, k)
          actual_block_montoison_orban_bytes = @allocated montoison_orban(A, B, D, C, k; algo="mgs", reorthogonalization)
          verbose && println("Block Montoison-Orban | $FC")
          verbose && println(expected_block_montoison_orban_bytes, " ≤ ", actual_block_montoison_orban_bytes, " ≤ ", 1.02 * expected_block_montoison_orban_bytes, " ?")
          verbose && println()
          if VERSION < v"1.11.5" || !Sys.isapple()
            @test expected_block_montoison_orban_bytes ≤ actual_block_montoison_orban_bytes ≤ 1.02 * expected_block_montoison_orban_bytes
          end
        end
      end
    end
  end
end

! krylov.f90 — Fortran interface to Krylov.jl
!
! Usage:
!   Add  use iso_c_binding  and  include 'krylov.f90'  AFTER  implicit none
!   in your program or subroutine.
!
! Example:
!
!   program my_prog
!     use iso_c_binding
!     implicit none
!     include 'krylov.f90'    ! ← here, after implicit none
!     ...
!   end program
!
! Callbacks must match the krylov_matvec abstract interface (or krylov_block_matvec
! for the block solvers) and be passed via c_funloc(my_sub).  Pass c_null_funptr
! for unused callbacks.

  ! Version
  integer(c_int), parameter :: KRYLOV_VERSION_MAJOR = 0
  integer(c_int), parameter :: KRYLOV_VERSION_MINOR = 10
  integer(c_int), parameter :: KRYLOV_VERSION_PATCH = 8

  ! -------------------------------------------------------------------------
  ! Enumerators  (must match krylov.h)
  ! -------------------------------------------------------------------------

  ! KrylovDataType
  integer(c_int), parameter :: KRYLOV_FLOAT32   = 0
  integer(c_int), parameter :: KRYLOV_FLOAT64   = 1
  integer(c_int), parameter :: KRYLOV_COMPLEX32 = 2
  integer(c_int), parameter :: KRYLOV_COMPLEX64 = 3

  ! KrylovDeviceType
  integer(c_int), parameter :: KRYLOV_CPU = 0

  ! KrylovSolverType
  integer(c_int), parameter :: KRYLOV_CG         =  0
  integer(c_int), parameter :: KRYLOV_CR         =  1
  integer(c_int), parameter :: KRYLOV_SYMMLQ     =  2
  integer(c_int), parameter :: KRYLOV_MINRES     =  3
  integer(c_int), parameter :: KRYLOV_MINRES_QLP =  4
  integer(c_int), parameter :: KRYLOV_DIOM       =  5
  integer(c_int), parameter :: KRYLOV_DQGMRES    =  6
  integer(c_int), parameter :: KRYLOV_FOM        =  7
  integer(c_int), parameter :: KRYLOV_GMRES      =  8
  integer(c_int), parameter :: KRYLOV_FGMRES     =  9
  integer(c_int), parameter :: KRYLOV_BICGSTAB   = 10
  integer(c_int), parameter :: KRYLOV_CGS        = 11
  integer(c_int), parameter :: KRYLOV_BILQ       = 12
  integer(c_int), parameter :: KRYLOV_QMR        = 13
  integer(c_int), parameter :: KRYLOV_USYMLQ     = 14
  integer(c_int), parameter :: KRYLOV_USYMQR     = 15
  integer(c_int), parameter :: KRYLOV_TRICG      = 16
  integer(c_int), parameter :: KRYLOV_TRIMR      = 17
  integer(c_int), parameter :: KRYLOV_TRILQR     = 18
  integer(c_int), parameter :: KRYLOV_BILQR      = 19
  integer(c_int), parameter :: KRYLOV_LSLQ       = 20
  integer(c_int), parameter :: KRYLOV_LSQR       = 21
  integer(c_int), parameter :: KRYLOV_LSMR       = 22
  integer(c_int), parameter :: KRYLOV_USYMLQR    = 23
  integer(c_int), parameter :: KRYLOV_CGLS       = 24
  integer(c_int), parameter :: KRYLOV_CRLS       = 25
  integer(c_int), parameter :: KRYLOV_CGNE       = 26
  integer(c_int), parameter :: KRYLOV_CRMR       = 27
  integer(c_int), parameter :: KRYLOV_CRAIG      = 28
  integer(c_int), parameter :: KRYLOV_CRAIGMR    = 29
  integer(c_int), parameter :: KRYLOV_LNLQ       = 30
  integer(c_int), parameter :: KRYLOV_GPMR       = 31
  integer(c_int), parameter :: KRYLOV_CAR        = 32
  integer(c_int), parameter :: KRYLOV_MINARES    = 33

  ! KrylovBlockSolverType  (block_gmres / block_minres)
  integer(c_int), parameter :: KRYLOV_BLOCK_GMRES  = 0
  integer(c_int), parameter :: KRYLOV_BLOCK_MINRES = 1

  ! -------------------------------------------------------------------------
  ! Option types  (must match the structs in krylov.h)
  !
  ! Two separate structs, mirroring when each option is consumed:
  !   * KrylovWorkspaceOptions — construction-time (krylov_workspace_create)
  !   * KrylovOptions          — solve-time        (krylov_solve)
  !
  ! Initialise with krylov_default_workspace_options() / krylov_default_options()
  ! and override only the fields you need.  Sentinel 0 (ints) or NaN (doubles)
  ! means "use the solver default".  Pass the struct via c_loc(opts).
  ! -------------------------------------------------------------------------

  type, bind(c) :: KrylovWorkspaceOptions
    integer(c_int) :: memory   ! 0 → 20 (GMRES / FGMRES / FOM / DIOM / DQGMRES / GPMR)
    integer(c_int) :: window   ! 0 → 5  (MINRES / SYMMLQ / LSQR / LSMR / LSLQ)
  end type KrylovWorkspaceOptions

  type, bind(c) :: KrylovOptions
    real(c_double) :: atol     ! NaN → sqrt(eps(T)) per precision
    real(c_double) :: rtol     ! NaN → sqrt(eps(T)) per precision
    integer(c_int) :: itmax    ! 0   → solver default
    integer(c_int) :: verbose  ! 0   = silent
    real(c_double) :: lambda   ! 0.0 = no regularisation/shift (LSQR / LSMR / CGLS / MINRES / …)
    real(c_double) :: tau      ! NaN → solver default (TriCG / TriMR : 1.0)
    real(c_double) :: nu       ! NaN → solver default (TriCG / TriMR : -1.0)
    real(c_double) :: timemax  ! NaN → Inf (no time limit), seconds ; every solver
    real(c_double) :: radius   ! 0.0 = no trust region (CG / CR / CGLS / CRLS / LSQR / LSMR)
    integer(c_int) :: restart              ! 0/1 restart GMRES(k) / FGMRES / FOM / block_gmres
    integer(c_int) :: reorthogonalization  ! 0/1 reorthogonalize basis (GMRES family, GPMR, block_gmres)
    integer(c_int) :: linesearch           ! 0/1 detect negative curvature (CG / CR / MINRES / MINRES-QLP)
  end type KrylovOptions

  ! -------------------------------------------------------------------------
  ! Callback interface
  !
  ! Declare your matvec subroutine with this exact signature, then pass it
  ! as c_funloc(my_matvec).
  !
  ! Example:
  !
  !   subroutine my_matvec(x_ptr, y_ptr, userdata) bind(c)
  !     use iso_c_binding
  !     type(c_ptr), value :: x_ptr, y_ptr, userdata
  !     real(c_double), pointer :: x(:), y(:)
  !     call c_f_pointer(x_ptr, x, [n])
  !     call c_f_pointer(y_ptr, y, [n])
  !     y = matmul(A, x)
  !   end subroutine
  ! -------------------------------------------------------------------------

  abstract interface
    subroutine krylov_matvec(x_ptr, y_ptr, userdata) bind(c)
      use iso_c_binding
      type(c_ptr), value :: x_ptr    ! read-only input vector
      type(c_ptr), value :: y_ptr    ! output vector
      type(c_ptr), value :: userdata ! opaque user context
    end subroutine krylov_matvec
  end interface

  ! Block matvec: computes Y = A*X (or Y = M\X) for a block of p columns.
  ! X is n×p, Y is m×p, both column-major.  Pass via c_funloc(my_block_matvec).
  abstract interface
    subroutine krylov_block_matvec(x_ptr, y_ptr, p, userdata) bind(c)
      use iso_c_binding
      type(c_ptr),    value :: x_ptr    ! read-only input block (n×p)
      type(c_ptr),    value :: y_ptr    ! output block (m×p)
      integer(c_int), value :: p        ! block size (number of columns)
      type(c_ptr),    value :: userdata ! opaque user context
    end subroutine krylov_block_matvec
  end interface

  ! -------------------------------------------------------------------------
  ! C function interfaces
  ! -------------------------------------------------------------------------

  interface

    ! -----------------------------------------------------------------------
    ! krylov_default_workspace_options / krylov_default_options
    !
    ! Return an option struct with every field set to its "use default"
    ! sentinel.  Always start from these before overriding fields.
    ! -----------------------------------------------------------------------
    function krylov_default_workspace_options() &
        bind(c, name='krylov_default_workspace_options') result(wopts)
      import :: KrylovWorkspaceOptions
      type(KrylovWorkspaceOptions) :: wopts
    end function krylov_default_workspace_options

    function krylov_default_options() &
        bind(c, name='krylov_default_options') result(opts)
      import :: KrylovOptions
      type(KrylovOptions) :: opts
    end function krylov_default_options

    ! -----------------------------------------------------------------------
    ! krylov_get_version — write the library's Krylov.jl version into
    ! major / minor / patch (same values as the KRYLOV_VERSION_* parameters).
    ! -----------------------------------------------------------------------
    subroutine krylov_get_version(major, minor, patch) &
        bind(c, name='krylov_get_version')
      use iso_c_binding
      integer(c_int), intent(out) :: major, minor, patch
    end subroutine krylov_get_version

    ! -----------------------------------------------------------------------
    ! krylov_workspace_create
    !
    ! Creates a workspace for the given solver.
    !
    !   solver  : KrylovSolverType constant (e.g. KRYLOV_CG, KRYLOV_GMRES)
    !   m, n    : operator dimensions
    !   dtype   : KrylovDataType constant (KRYLOV_FLOAT32 / KRYLOV_FLOAT64 / ...)
    !   device  : KrylovDeviceType constant (KRYLOV_CPU)
    !   wopts   : c_loc(KrylovWorkspaceOptions)  or  c_null_ptr for defaults
    !   ws      : receives the opaque workspace handle
    !
    ! Returns 0 on success, -1 on error, -2 on an unknown (solver, dtype) pair.
    ! -----------------------------------------------------------------------
    function krylov_workspace_create(solver, m, n, dtype, device, wopts, ws) &
        bind(c, name='krylov_workspace_create') result(ret)
      use iso_c_binding
      integer(c_int), value       :: solver, m, n, dtype, device
      type(c_ptr),    value       :: wopts   ! c_loc(opts) or c_null_ptr
      type(c_ptr),    intent(out) :: ws
      integer(c_int)              :: ret
    end function krylov_workspace_create

    ! -----------------------------------------------------------------------
    ! krylov_solve
    !
    !   ws         : workspace handle
    !   matvec_A   : callback  y = A*x          (required)
    !   matvec_At  : callback  y = A'*x         (c_null_funptr for CG/GMRES/...)
    !   matvec_M   : left preconditioner; must compute y = M\x (solve M y = x)
    !                (c_null_funptr = no left preconditioner)
    !   matvec_N   : right preconditioner; must compute y = N\x (solve N y = x).
    !                Used only by solvers accepting both sides (GMRES, FGMRES, FOM,
    !                DIOM, DQGMRES, BiCGSTAB, CGS, BiLQ, QMR); ignored otherwise.
    !                (c_null_funptr = no right preconditioner)
    !   b          : first right-hand side pointer (c_loc of your array, size m)
    !   c          : second right-hand side pointer (c_loc of your array, size n)
    !                  c_null_ptr for solvers that only need one RHS
    !   userdata   : forwarded to every callback (c_loc or c_null_ptr)
    !   opts       : c_loc(KrylovOptions)  or  c_null_ptr for all defaults
    !
    ! Returns 0 on success, nonzero on error.
    ! -----------------------------------------------------------------------
    function krylov_solve(ws, matvec_A, matvec_At, matvec_M, matvec_N, &
                          b, c, userdata, opts) &
        bind(c, name='krylov_solve') result(ret)
      use iso_c_binding
      type(c_ptr),    value :: ws
      type(c_funptr), value :: matvec_A    ! y = A*x
      type(c_funptr), value :: matvec_At   ! y = A'*x  or  c_null_funptr
      type(c_funptr), value :: matvec_M    ! y = M\x  (centered/left precond.) or c_null_funptr
      type(c_funptr), value :: matvec_N    ! y = N\x  (right precond.)         or c_null_funptr
      type(c_ptr),    value :: b           ! c_loc(b_array), size m
      type(c_ptr),    value :: c           ! c_loc(c_array), size n  or  c_null_ptr
      type(c_ptr),    value :: userdata    ! c_loc(data)  or  c_null_ptr
      type(c_ptr),    value :: opts        ! c_loc(KrylovOptions) or c_null_ptr
      integer(c_int)        :: ret
    end function krylov_solve

    ! -----------------------------------------------------------------------
    ! krylov_get_x
    !
    ! Copies the primal solution into the buffer pointed to by x.
    ! Pass c_loc(x_array).
    !
    ! Returns 0 on success, nonzero on error.
    ! -----------------------------------------------------------------------
    function krylov_get_x(ws, x, n) &
        bind(c, name='krylov_get_x') result(ret)
      use iso_c_binding
      type(c_ptr),    value :: ws
      type(c_ptr),    value :: x   ! c_loc(x_array)
      integer(c_int), value :: n
      integer(c_int)        :: ret
    end function krylov_get_x

    ! -----------------------------------------------------------------------
    ! krylov_get_y
    !
    ! Copies the second (dual) solution y, for the two-solution solvers (TriCG,
    ! TriMR, USYMLQR, GPMR, BiLQR, TriLQR, CRAIG, CRAIGMR, LNLQ). Its length is
    ! the dual-solution size: n for TriCG/TriMR/USYMLQR, m otherwise.
    ! Returns -2 if the solver has only one solution.
    ! -----------------------------------------------------------------------
    function krylov_get_y(ws, y, m) &
        bind(c, name='krylov_get_y') result(ret)
      use iso_c_binding
      type(c_ptr),    value :: ws
      type(c_ptr),    value :: y   ! c_loc(y_array)
      integer(c_int), value :: m
      integer(c_int)        :: ret
    end function krylov_get_y

    ! -----------------------------------------------------------------------
    ! krylov_is_solved
    !
    ! Returns 1 if converged, 0 if not, -1 on error.
    ! -----------------------------------------------------------------------
    function krylov_is_solved(ws) &
        bind(c, name='krylov_is_solved') result(ret)
      use iso_c_binding
      type(c_ptr),   value :: ws
      integer(c_int)       :: ret
    end function krylov_is_solved

    ! -----------------------------------------------------------------------
    ! krylov_niter
    !
    ! Returns the number of iterations performed, or -1 on error.
    ! -----------------------------------------------------------------------
    function krylov_niter(ws) &
        bind(c, name='krylov_niter') result(ret)
      use iso_c_binding
      type(c_ptr),   value :: ws
      integer(c_int)       :: ret
    end function krylov_niter

    ! -----------------------------------------------------------------------
    ! krylov_elapsed_time
    !
    ! Returns elapsed solve time in seconds, or -1.0 on error.
    ! -----------------------------------------------------------------------
    function krylov_elapsed_time(ws) &
        bind(c, name='krylov_elapsed_time') result(ret)
      use iso_c_binding
      type(c_ptr),    value :: ws
      real(c_double)        :: ret
    end function krylov_elapsed_time

    ! -----------------------------------------------------------------------
    ! krylov_warm_start
    !
    ! Sets the initial guess for the next krylov_solve call.
    ! Pass c_loc(x0_array).
    !
    ! Returns 0 on success, nonzero on error.
    ! -----------------------------------------------------------------------
    function krylov_warm_start(ws, x0, n) &
        bind(c, name='krylov_warm_start') result(ret)
      use iso_c_binding
      type(c_ptr),    value :: ws
      type(c_ptr),    value :: x0   ! c_loc(x0_array)
      integer(c_int), value :: n
      integer(c_int)        :: ret
    end function krylov_warm_start

    ! -----------------------------------------------------------------------
    ! krylov_warm_start2
    !
    ! Sets BOTH initial guesses for the next krylov_solve, for the two-solution
    ! solvers (TriCG, TriMR, GPMR, BiLQR, TriLQR, USYMLQR).
    !   x0 : primal guess, length nx (same size as krylov_get_x)
    !   y0 : dual guess,   length ny (same size as krylov_get_y)
    !
    ! Returns 0, -1 on error, or -2 if the solver has a single solution.
    ! -----------------------------------------------------------------------
    function krylov_warm_start2(ws, x0, y0, nx, ny) &
        bind(c, name='krylov_warm_start2') result(ret)
      use iso_c_binding
      type(c_ptr),    value :: ws
      type(c_ptr),    value :: x0   ! c_loc(x0_array), size nx
      type(c_ptr),    value :: y0   ! c_loc(y0_array), size ny
      integer(c_int), value :: nx, ny
      integer(c_int)        :: ret
    end function krylov_warm_start2

    ! -----------------------------------------------------------------------
    ! krylov_workspace_free
    !
    ! Releases the workspace.  The handle must not be used after this call.
    ! Returns 0 on success, 1 if handle was not found.
    ! -----------------------------------------------------------------------
    function krylov_workspace_free(ws) &
        bind(c, name='krylov_workspace_free') result(ret)
      use iso_c_binding
      type(c_ptr),   value :: ws
      integer(c_int)       :: ret
    end function krylov_workspace_free

    ! -----------------------------------------------------------------------
    ! Block Krylov interface (block_gmres / block_minres)
    !
    ! The right-hand side is an m×p block B and the solution an n×p block X,
    ! both column-major.  Pass blocks via c_loc(your_2d_array).
    ! -----------------------------------------------------------------------

    ! krylov_block_workspace_create
    !   solver : KRYLOV_BLOCK_GMRES / KRYLOV_BLOCK_MINRES
    !   m, n   : operator dimensions ; p : block size (#columns)
    !   wopts  : c_loc(KrylovWorkspaceOptions) or c_null_ptr (memory: block_gmres)
    function krylov_block_workspace_create(solver, m, n, p, dtype, device, wopts, ws) &
        bind(c, name='krylov_block_workspace_create') result(ret)
      use iso_c_binding
      integer(c_int), value       :: solver, m, n, p, dtype, device
      type(c_ptr),    value       :: wopts
      type(c_ptr),    intent(out) :: ws
      integer(c_int)              :: ret
    end function krylov_block_workspace_create

    ! krylov_block_solve
    !   matvec_A : block matvec  Y = A*X        (required)
    !   matvec_M : left preconditioner; must compute Y = M\X (solve M Y = X)
    !              (c_null_funptr = no left preconditioner)
    !   matvec_N : right preconditioner; must compute Y = N\X (solve N Y = X).
    !              Used only by block_gmres; ignored by block_minres.
    !              (c_null_funptr = no right preconditioner)
    !   B        : c_loc(B), m×p column-major
    !   opts     : c_loc(KrylovOptions) or c_null_ptr
    function krylov_block_solve(ws, matvec_A, matvec_M, matvec_N, b, userdata, opts) &
        bind(c, name='krylov_block_solve') result(ret)
      use iso_c_binding
      type(c_ptr),    value :: ws
      type(c_funptr), value :: matvec_A
      type(c_funptr), value :: matvec_M
      type(c_funptr), value :: matvec_N
      type(c_ptr),    value :: b
      type(c_ptr),    value :: userdata
      type(c_ptr),    value :: opts
      integer(c_int)        :: ret
    end function krylov_block_solve

    ! krylov_block_get_X — copies the n×p solution block into c_loc(X)
    function krylov_block_get_X(ws, x, n, p) &
        bind(c, name='krylov_block_get_X') result(ret)
      use iso_c_binding
      type(c_ptr),    value :: ws
      type(c_ptr),    value :: x
      integer(c_int), value :: n, p
      integer(c_int)        :: ret
    end function krylov_block_get_X

    ! krylov_block_is_solved — 1 if converged, 0 if not, -1 on error
    function krylov_block_is_solved(ws) &
        bind(c, name='krylov_block_is_solved') result(ret)
      use iso_c_binding
      type(c_ptr),   value :: ws
      integer(c_int)       :: ret
    end function krylov_block_is_solved

    ! krylov_block_niter — number of iterations performed, or -1 on error
    function krylov_block_niter(ws) &
        bind(c, name='krylov_block_niter') result(ret)
      use iso_c_binding
      type(c_ptr),   value :: ws
      integer(c_int)       :: ret
    end function krylov_block_niter

    ! krylov_block_elapsed_time — block solve time in seconds, or -1.0 on error
    function krylov_block_elapsed_time(ws) &
        bind(c, name='krylov_block_elapsed_time') result(ret)
      use iso_c_binding
      type(c_ptr),    value :: ws
      real(c_double)        :: ret
    end function krylov_block_elapsed_time

    ! krylov_block_warm_start — initial guess (n×p block) for the next solve
    function krylov_block_warm_start(ws, x0, n, p) &
        bind(c, name='krylov_block_warm_start') result(ret)
      use iso_c_binding
      type(c_ptr),    value :: ws
      type(c_ptr),    value :: x0
      integer(c_int), value :: n, p
      integer(c_int)        :: ret
    end function krylov_block_warm_start

    ! krylov_block_workspace_free — release the block workspace.
    ! Returns 0 on success, 1 if the handle was not found.
    function krylov_block_workspace_free(ws) &
        bind(c, name='krylov_block_workspace_free') result(ret)
      use iso_c_binding
      type(c_ptr),   value :: ws
      integer(c_int)       :: ret
    end function krylov_block_workspace_free

  end interface

# An implementation of CGNE for the solution of the consistent
# (under/over-determined or square) linear system
#
#  Ax = b.
#
# The method seeks to solve the minimum-norm problem
#
#  min ‖x‖²  s.t. Ax = b,
#
# and is equivalent to applying the conjugate gradient method
# to the linear system
#
#  AAᴴy = b.
#
# This method is also known as Craig's method, CGME, and other
# names, and is described in
#
# J. E. Craig. The N-step iteration procedures.
# Journal of Mathematics and Physics, 34(1), pp. 64--73, 1955.
#
# which is based on Craig's thesis from MIT:
#
# J. E. Craig. Iterations Procedures for Simultaneous Equations.
# Ph.D. Thesis, Department of Electrical Engineering, MIT, 1954.
#
# Dominique Orban, <dominique.orban@gerad.ca>
# Montréal, QC, April 2015.

export cgne, cgne!

"""
    (x, stats) = cgne(A, b::AbstractVector{FC};
                      N=I, ldiv::Bool=false,
                      λ::T=zero(T), atol::T=√eps(T),
                      rtol::T=√eps(T), itmax::Int=0,
                      timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                      callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

Solve the consistent linear system

    Ax + √λs = b

of size m × n using the Conjugate Gradient (CG) method, where λ ≥ 0 is a regularization
parameter. This method is equivalent to applying CG to the normal equations
of the second kind

    (AAᴴ + λI) y = b

but is more stable. When λ = 0, this method solves the minimum-norm problem

  min ‖x‖₂  s.t. Ax = b.

When λ > 0, it solves the problem

    min ‖(x,s)‖₂  s.t. Ax + √λs = b.

CGNE produces monotonic errors ‖x-x*‖₂ but not residuals ‖r‖₂.
It is formally equivalent to CRAIG, though can be slightly less accurate,
but simpler to implement. Only the x-part of the solution is returned.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :cgne`.

For an in-place variant that reuses memory across solves, see [`cgne!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`.

#### Keyword arguments

* `N`: linear operator that models a Hermitian positive-definite matrix of size `n` used for preconditioning;
* `ldiv`: define whether the preconditioner uses `ldiv!` or `mul!`;
* `λ`: regularization parameter;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `m+n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### References

* J. E. Craig, [*The N-step iteration procedures*](https://doi.org/10.1002/sapm195534164), Journal of Mathematics and Physics, 34(1), pp. 64--73, 1955.
* J. E. Craig, *Iterations Procedures for Simultaneous Equations*, Ph.D. Thesis, Department of Electrical Engineering, MIT, 1954.
"""
function cgne end

"""
    workspace = cgne!(workspace::CgneWorkspace, A, b; kwargs...)

In this call, `kwargs` are keyword arguments of [`cgne`](@ref).

See [`CgneWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :cgne` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function cgne! end

def_args_cgne = (:(A                    ),
                 :(b::AbstractVector{FC}))

def_kwargs_cgne = (:(; N = I                        ),
                   :(; ldiv::Bool = false           ),
                   :(; λ::T = zero(T)               ),
                   :(; atol::T = √eps(T)            ),
                   :(; rtol::T = √eps(T)            ),
                   :(; itmax::Int = 0               ),
                   :(; timemax::Float64 = Inf       ),
                   :(; verbose::Int = 0             ),
                   :(; history::Bool = false        ),
                   :(; callback = workspace -> false),
                   :(; iostream::IO = kstdout       ))

def_kwargs_cgne = extract_parameters.(def_kwargs_cgne)

args_cgne = (:A, :b)
kwargs_cgne = (:N, :ldiv, :λ, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function cgne!(workspace :: CgneWorkspace{T,FC,Sm,Sn}, $(def_args_cgne...); $(def_kwargs_cgne...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "CGNE: system of %d equations in %d variables\n", m, n)

    # Tests N = Iₙ
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == Sm || error("ktypeof(b) must be equal to $Sm")

    # Compute the adjoint of A
    Aᴴ = A'

    # Set up workspace.
    allocate_if(!NisI, workspace, :z, Sm, workspace.r)  # The length of z is m
    allocate_if(λ > 0, workspace, :s, Sm, workspace.r)  # The length of s is m
    x, p, Aᴴz, r, q, s, stats = workspace.x, workspace.p, workspace.Aᴴz, workspace.r, workspace.q, workspace.s, workspace.stats
    rNorms = stats.residuals
    reset!(stats)
    z = NisI ? r : workspace.z

    kfill!(x, zero(FC))
    kcopy!(m, r, b)  # r ← b
    NisI || mulorldiv!(z, N, r, ldiv)
    rNorm = knorm(m, r)  # Marginally faster than norm(r)
    history && push!(rNorms, rNorm)
    if rNorm == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      return workspace
    end
    λ > 0 && kcopy!(m, s, r)  # s ← r
    kmul!(p, Aᴴ, z)

    # Use ‖p‖ to detect inconsistent system.
    # An inconsistent system will necessarily have AAᴴ singular.
    # Because CGNE is equivalent to CG applied to AAᴴy = b, there will be a
    # conjugate direction u such that uᴴAAᴴu = 0, i.e., Aᴴu = 0. In this
    # implementation, p is a substitute for Aᴴu.
    pNorm = knorm(n, p)

    γ = kdotr(m, r, z)  # Faster than γ = dot(r, z)
    iter = 0
    itmax == 0 && (itmax = m + n)

    ɛ_c = atol + rtol * rNorm  # Stopping tolerance for consistent systems.
    ɛ_i = atol + rtol * pNorm  # Stopping tolerance for inconsistent systems.
    (verbose > 0) && @printf(iostream, "%5s  %8s  %5s\n", "k", "‖r‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %8.2e  %.2fs\n", iter, rNorm, start_time |> ktimer)

    status = "unknown"
    solved = rNorm ≤ ɛ_c
    inconsistent = (rNorm > 100 * ɛ_c) && (pNorm ≤ ɛ_i)
    tired = iter ≥ itmax
    user_requested_exit = false
    overtimed = false

    while ! (solved || inconsistent || tired || user_requested_exit || overtimed)
      kmul!(q, A, p)
      λ > 0 && kaxpy!(m, λ, s, q)
      δ = kdotr(n, p, p)   # Faster than dot(p, p)
      λ > 0 && (δ += λ * kdotr(m, s, s))
      α = γ / δ
      kaxpy!(n,  α, p, x)  # Faster than x = x + α * p
      kaxpy!(m, -α, q, r)  # Faster than r = r - α * q
      NisI || mulorldiv!(z, N, r, ldiv)
      γ_next = kdotr(m, r, z)  # Faster than γ_next = dot(r, z)
      β = γ_next / γ
      kmul!(Aᴴz, Aᴴ, z)
      kaxpby!(n, one(FC), Aᴴz, β, p)  # Faster than p = Aᴴz + β * p
      pNorm = knorm(n, p)
      if λ > 0
        kaxpby!(m, one(FC), r, β, s)  # s = r + β * s
      end
      γ = γ_next
      rNorm = sqrt(γ_next)
      history && push!(rNorms, rNorm)
      iter = iter + 1
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %8.2e  %.2fs\n", iter, rNorm, start_time |> ktimer)

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      resid_decrease_mach = (rNorm + one(T) ≤ one(T))

      user_requested_exit = callback(workspace) :: Bool
      resid_decrease_lim = rNorm ≤ ɛ_c
      solved = resid_decrease_lim || resid_decrease_mach
      inconsistent = (rNorm > 100 * ɛ_c) && (pNorm ≤ ɛ_i)
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    inconsistent        && (status = "system probably inconsistent")
    solved              && (status = "solution good enough given atol and rtol")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = inconsistent
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

# An implementation of QMR for the solution of unsymmetric
# and square linear system Ax = b.
#
# This method is described in
#
# R. W. Freund and N. M. Nachtigal
# QMR : a quasi-minimal residual method for non-Hermitian linear systems.
# Numerische mathematik, Vol. 60(1), pp. 315--339, 1991.
#
# R. W. Freund and N. M. Nachtigal
# An implementation of the QMR method based on coupled two-term recurrences.
# SIAM Journal on Scientific Computing, Vol. 15(2), pp. 313--337, 1994.
#
# A. Montoison and D. Orban
# BiLQ: An Iterative Method for Nonsymmetric Linear Systems with a Quasi-Minimum Error Property.
# SIAM Journal on Matrix Analysis and Applications, 41(3), pp. 1145--1166, 2020.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Montreal, May 2019.

export qmr, qmr!

"""
    (x, stats) = qmr(A, b::AbstractVector{FC};
                     c::AbstractVector{FC}=b, M=I, N=I, ldiv::Bool=false, atol::T=√eps(T),
                     rtol::T=√eps(T), itmax::Int=0, timemax::Float64=Inf, verbose::Int=0,
                     history::Bool=false, callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = qmr(A, b, x0::AbstractVector; kwargs...)

QMR can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above.

Solve the square linear system Ax = b of size n using QMR.

QMR is based on the Lanczos biorthogonalization process and requires two initial vectors `b` and `c`.
The relation `bᴴc ≠ 0` must be satisfied and by default `c = b`.
When `A` is Hermitian and `b = c`, QMR is equivalent to MINRES.
QMR requires support for `adjoint(M)` and `adjoint(N)` if preconditioners are provided.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :qmr`.

For an in-place variant that reuses memory across solves, see [`qmr!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `n`;
* `b`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `c`: the second initial vector of length `n` required by the Lanczos biorthogonalization process;
* `M`: linear operator that models a nonsingular matrix of size `n` used for left preconditioning;
* `N`: linear operator that models a nonsingular matrix of size `n` used for right preconditioning;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### References

* R. W. Freund and N. M. Nachtigal, [*QMR : a quasi-minimal residual method for non-Hermitian linear systems*](https://doi.org/10.1007/BF01385726), Numerische mathematik, Vol. 60(1), pp. 315--339, 1991.
* R. W. Freund and N. M. Nachtigal, [*An implementation of the QMR method based on coupled two-term recurrences*](https://doi.org/10.1137/0915022), SIAM Journal on Scientific Computing, Vol. 15(2), pp. 313--337, 1994.
* A. Montoison and D. Orban, [*BiLQ: An Iterative Method for Nonsymmetric Linear Systems with a Quasi-Minimum Error Property*](https://doi.org/10.1137/19M1290991), SIAM Journal on Matrix Analysis and Applications, 41(3), pp. 1145--1166, 2020.
"""
function qmr end

"""
    workspace = qmr!(workspace::QmrWorkspace, A, b; kwargs...)
    workspace = qmr!(workspace::QmrWorkspace, A, b, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`qmr`](@ref).

See [`QmrWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :qmr` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function qmr! end

def_args_qmr = (:(A                    ),
                :(b::AbstractVector{FC}))

def_optargs_qmr = (:(x0::AbstractVector),)

def_kwargs_qmr = (:(; c::AbstractVector{FC} = b    ),
                  :(; M = I                        ),
                  :(; N = I                        ),
                  :(; ldiv::Bool = false           ),
                  :(; atol::T = √eps(T)            ),
                  :(; rtol::T = √eps(T)            ),
                  :(; itmax::Int = 0               ),
                  :(; timemax::Float64 = Inf       ),
                  :(; verbose::Int = 0             ),
                  :(; history::Bool = false        ),
                  :(; callback = workspace -> false),
                  :(; iostream::IO = kstdout       ))

def_kwargs_qmr = extract_parameters.(def_kwargs_qmr)

args_qmr = (:A, :b)
optargs_qmr = (:x0,)
kwargs_qmr = (:c, :M, :N, :ldiv, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function qmr!(workspace :: QmrWorkspace{T,FC,S}, $(def_args_qmr...); $(def_kwargs_qmr...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("System must be square")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "QMR: system of size %d\n", n)

    # Check M = Iₙ and N = Iₙ
    MisI = (M === I)
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")
    ktypeof(c) == S || error("ktypeof(c) must be equal to $S")

    # Compute the adjoint of A, M and N
    Aᴴ = A'
    Mᴴ = M'
    Nᴴ = N'

    # Set up workspace.
    allocate_if(!MisI, workspace, :t, S, workspace.x)  # The length of t is n
    allocate_if(!NisI, workspace, :s, S, workspace.x)  # The length of s is n
    uₖ₋₁, uₖ, q, vₖ₋₁, vₖ, p = workspace.uₖ₋₁, workspace.uₖ, workspace.q, workspace.vₖ₋₁, workspace.vₖ, workspace.p
    Δx, x, wₖ₋₂, wₖ₋₁, stats = workspace.Δx, workspace.x, workspace.wₖ₋₂, workspace.wₖ₋₁, workspace.stats
    warm_start = workspace.warm_start
    rNorms = stats.residuals
    reset!(stats)
    r₀ = warm_start ? q : b
    Mᴴuₖ = MisI ? uₖ : workspace.t
    t = MisI ? q : workspace.t
    Nvₖ = NisI ? vₖ : workspace.s
    s = NisI ? p : workspace.s

    if warm_start
      kmul!(r₀, A, Δx)
      kaxpby!(n, one(FC), b, -one(FC), r₀)
    end
    if !MisI
      mulorldiv!(workspace.t, M, r₀, ldiv)
      r₀ = workspace.t
    end

    # Initial solution x₀ and residual norm ‖r₀‖.
    kfill!(x, zero(FC))
    rNorm = knorm(n, r₀)  # ‖r₀‖ = ‖b₀ - Ax₀‖

    history && push!(rNorms, rNorm)
    if rNorm == 0
      stats.niter = 0
      stats.solved = true
      stats.inconsistent = false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    iter = 0
    itmax == 0 && (itmax = 2*n)

    # Initialize the Lanczos biorthogonalization process.
    cᴴb = kdot(n, c, r₀)  # ⟨c,r₀⟩
    if cᴴb == 0
      stats.niter = 0
      stats.solved = false
      stats.inconsistent = false
      stats.timer = start_time |> ktimer
      stats.status = "Breakdown bᴴc = 0"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    ε = atol + rtol * rNorm
    (verbose > 0) && @printf(iostream, "%5s  %8s  %7s  %5s\n", "k", "αₖ", "‖rₖ‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %8.1e  %7.1e  %.2fs\n", iter, cᴴb, rNorm, start_time |> ktimer)

    βₖ = √(abs(cᴴb))               # β₁γ₁ = cᴴ(b - Ax₀)
    γₖ = cᴴb / βₖ                  # β₁γ₁ = cᴴ(b - Ax₀)
    kfill!(vₖ₋₁, zero(FC))         # v₀ = 0
    kfill!(uₖ₋₁, zero(FC))         # u₀ = 0
    kdivcopy!(n, vₖ, r₀, βₖ)       # v₁ = (b - Ax₀) / β₁
    kdivcopy!(n, uₖ, c, conj(γₖ))  # u₁ = c / γ̄₁
    cₖ₋₂ = cₖ₋₁ = cₖ = zero(T)     # Givens cosines used for the QR factorization of Tₖ₊₁.ₖ
    sₖ₋₂ = sₖ₋₁ = sₖ = zero(FC)    # Givens sines used for the QR factorization of Tₖ₊₁.ₖ
    kfill!(wₖ₋₂, zero(FC))         # Column k-2 of Wₖ = Vₖ(Rₖ)⁻¹
    kfill!(wₖ₋₁, zero(FC))         # Column k-1 of Wₖ = Vₖ(Rₖ)⁻¹
    ζbarₖ = βₖ                     # ζbarₖ is the last component of z̅ₖ = (Qₖ)ᴴβ₁e₁
    τₖ = kdotr(n, vₖ, vₖ)          # τₖ is used for the residual norm estimate

    # Stopping criterion.
    solved    = rNorm ≤ ε
    breakdown = false
    tired     = iter ≥ itmax
    status    = "unknown"
    user_requested_exit = false
    overtimed = false

    while !(solved || tired || breakdown || user_requested_exit || overtimed)
      # Update iteration index.
      iter = iter + 1

      # Continue the Lanczos biorthogonalization process.
      # MANVₖ    = VₖTₖ    + βₖ₊₁vₖ₊₁(eₖ)ᵀ = Vₖ₊₁Tₖ₊₁.ₖ
      # NᴴAᴴMᴴUₖ = Uₖ(Tₖ)ᴴ + γ̄ₖ₊₁uₖ₊₁(eₖ)ᵀ = Uₖ₊₁(Tₖ.ₖ₊₁)ᴴ

      # Forms vₖ₊₁ : q ← MANvₖ
      NisI || mulorldiv!(Nvₖ, N, vₖ, ldiv)
      kmul!(t, A, Nvₖ)
      MisI || mulorldiv!(q, M, t, ldiv)

      # Forms uₖ₊₁ : p ← NᴴAᴴMᴴuₖ
      MisI || mulorldiv!(Mᴴuₖ, Mᴴ, uₖ, ldiv)
      kmul!(s, Aᴴ, Mᴴuₖ)
      NisI || mulorldiv!(p, Nᴴ, s, ldiv)

      kaxpy!(n, -γₖ, vₖ₋₁, q)  # q ← q - γₖ * vₖ₋₁
      kaxpy!(n, -βₖ, uₖ₋₁, p)  # p ← p - β̄ₖ * uₖ₋₁

      αₖ = kdot(n, uₖ, q)  # αₖ = ⟨uₖ,q⟩

      kaxpy!(n, -     αₖ , vₖ, q)  # q ← q - αₖ * vₖ
      kaxpy!(n, -conj(αₖ), uₖ, p)  # p ← p - ᾱₖ * uₖ

      pᴴq = kdot(n, p, q)  # pᴴq  = ⟨p,q⟩
      βₖ₊₁ = √(abs(pᴴq))   # βₖ₊₁ = √(|pᴴq|)
      γₖ₊₁ = pᴴq / βₖ₊₁    # γₖ₊₁ = pᴴq / βₖ₊₁

      # Update the QR factorization of Tₖ₊₁.ₖ = Qₖ [ Rₖ ].
      #                                            [ Oᵀ ]
      # [ α₁ γ₂ 0  •  •  •   0  ]      [ δ₁ λ₁ ϵ₁ 0  •  •  0  ]
      # [ β₂ α₂ γ₃ •         •  ]      [ 0  δ₂ λ₂ •  •     •  ]
      # [ 0  •  •  •  •      •  ]      [ •  •  δ₃ •  •  •  •  ]
      # [ •  •  •  •  •  •   •  ] = Qₖ [ •     •  •  •  •  0  ]
      # [ •     •  •  •  •   0  ]      [ •        •  •  • ϵₖ₋₂]
      # [ •        •  •  •   γₖ ]      [ •           •  • λₖ₋₁]
      # [ •           •  βₖ  αₖ ]      [ •              •  δₖ ]
      # [ 0  •  •  •  •  0  βₖ₊₁]      [ 0  •  •  •  •  •  0  ]
      #
      # If k = 1, we don't have any previous reflection.
      # If k = 2, we apply the last reflection.
      # If k ≥ 3, we only apply the two previous reflections.

      # Apply previous Givens reflections Qₖ₋₂.ₖ₋₁
      if iter ≥ 3
        # [cₖ₋₂  sₖ₋₂] [0 ] = [  ϵₖ₋₂ ]
        # [s̄ₖ₋₂ -cₖ₋₂] [γₖ]   [λbarₖ₋₁]
        ϵₖ₋₂    =  sₖ₋₂ * γₖ
        λbarₖ₋₁ = -cₖ₋₂ * γₖ
      end

      # Apply previous Givens reflections Qₖ₋₁.ₖ
      if iter ≥ 2
        iter == 2 && (λbarₖ₋₁ = γₖ)
        # [cₖ₋₁  sₖ₋₁] [λbarₖ₋₁] = [λₖ₋₁ ]
        # [s̄ₖ₋₁ -cₖ₋₁] [   αₖ  ]   [δbarₖ]
        λₖ₋₁  =      cₖ₋₁  * λbarₖ₋₁ + sₖ₋₁ * αₖ
        δbarₖ = conj(sₖ₋₁) * λbarₖ₋₁ - cₖ₋₁ * αₖ

        # Update sₖ₋₂ and cₖ₋₂.
        sₖ₋₂ = sₖ₋₁
        cₖ₋₂ = cₖ₋₁
      end

      # Compute and apply current Givens reflection Qₖ.ₖ₊₁
      iter == 1 && (δbarₖ = αₖ)
      # [cₖ  sₖ] [δbarₖ] = [δₖ]
      # [s̄ₖ -cₖ] [βₖ₊₁ ]   [0 ]
      (cₖ, sₖ, δₖ) = sym_givens(δbarₖ, βₖ₊₁)

      # Update z̅ₖ₊₁ = Qₖ.ₖ₊₁ [ z̄ₖ ]
      #                      [ 0  ]
      #
      # [cₖ  sₖ] [ζbarₖ] = [   ζₖ  ]
      # [s̄ₖ -cₖ] [  0  ]   [ζbarₖ₊₁]
      ζₖ      =      cₖ  * ζbarₖ
      ζbarₖ₊₁ = conj(sₖ) * ζbarₖ

      # Update sₖ₋₁ and cₖ₋₁.
      sₖ₋₁ = sₖ
      cₖ₋₁ = cₖ

      # Compute the direction wₖ, the last column of Wₖ = Vₖ(Rₖ)⁻¹ ⟷ (Rₖ)ᵀ(Wₖ)ᵀ = (Vₖ)ᵀ.
      # w₁ = v₁ / δ₁
      if iter == 1
        wₖ = wₖ₋₁
        kdivcopy!(n, wₖ, vₖ, δₖ)
      end
      # w₂ = (v₂ - λ₁w₁) / δ₂
      if iter == 2
        wₖ = wₖ₋₂
        kaxpy!(n, -λₖ₋₁, wₖ₋₁, wₖ)
        kaxpy!(n, one(FC), vₖ, wₖ)
        kdiv!(n, wₖ, δₖ)
      end
      # wₖ = (vₖ - λₖ₋₁wₖ₋₁ - ϵₖ₋₂wₖ₋₂) / δₖ
      if iter ≥ 3
        kscal!(n, -ϵₖ₋₂, wₖ₋₂)
        wₖ = wₖ₋₂
        kaxpy!(n, -λₖ₋₁, wₖ₋₁, wₖ)
        kaxpy!(n, one(FC), vₖ, wₖ)
        kdiv!(n, wₖ, δₖ)
      end

      # Compute solution xₖ.
      # xₖ ← xₖ₋₁ + ζₖ * wₖ
      kaxpy!(n, ζₖ, wₖ, x)

      # Compute vₖ₊₁ and uₖ₊₁.
      kcopy!(n, vₖ₋₁, vₖ)  # vₖ₋₁ ← vₖ
      kcopy!(n, uₖ₋₁, uₖ)  # uₖ₋₁ ← uₖ

      if pᴴq ≠ zero(FC)
        kdivcopy!(n, vₖ, q, βₖ₊₁)        # vₖ₊₁ = q / βₖ₊₁
        kdivcopy!(n, uₖ, p, conj(γₖ₊₁))  # uₖ₊₁ = p / γ̄ₖ₊₁
      end

      # Compute τₖ₊₁ = τₖ + ‖vₖ₊₁‖²
      τₖ₊₁ = τₖ + kdotr(n, vₖ, vₖ)

      # Compute ‖rₖ‖ ≤ |ζbarₖ₊₁|√τₖ₊₁
      rNorm = abs(ζbarₖ₊₁) * √τₖ₊₁
      history && push!(rNorms, rNorm)

      # Update directions for x.
      if iter ≥ 2
        @kswap!(wₖ₋₂, wₖ₋₁)
      end

      # Update ζbarₖ, βₖ, γₖ and τₖ.
      ζbarₖ = ζbarₖ₊₁
      βₖ    = βₖ₊₁
      γₖ    = γₖ₊₁
      τₖ    = τₖ₊₁

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      resid_decrease_mach = (rNorm + one(T) ≤ one(T))

      # Update stopping criterion.
      user_requested_exit = callback(workspace) :: Bool
      resid_decrease_lim = rNorm ≤ ε
      solved = resid_decrease_lim || resid_decrease_mach
      tired = iter ≥ itmax
      breakdown = !solved && (pᴴq == 0)
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %8.1e  %7.1e  %.2fs\n", iter, αₖ, rNorm, start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    breakdown           && (status = "Breakdown ⟨uₖ₊₁,vₖ₊₁⟩ = 0")
    solved              && (status = "solution good enough given atol and rtol")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update x
    if !NisI
      copyto!(workspace.s, x)
      mulorldiv!(x, N, workspace.s, ldiv)
    end
    warm_start && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = false
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

@testset "usymlqr" begin
  usymlqr_tol = 1.0e-6

  @testset "Small complex SP" begin
    m = 4
    n = 4
    A = rand(ComplexF64, m, n)
    b = rand(ComplexF64, m)
    c = rand(ComplexF64, n)

    # [I   A] [x] = [b]
    # [Aᴴ  0] [y]   [c]
    (x, y, stats) = usymlqr(A, b, c)
    K = [I A; A' zeros(n,n)]
    d = [b; c]
    r = d - K * [x; y]
    resid = norm(r)
    @test resid ≤ usymlqr_tol

    # [I   A] [x] = [b]
    # [Aᴴ  0] [y]   [0]
    (x, y, stats) = usymlqr(A, b, c, ln=false)
    K = [I A; A' zeros(n,n)]
    d = [b; 0*c]
    r = d - K * [x; y]
    resid = norm(r)
    @test resid ≤ usymlqr_tol

    # [I   A] [x] = [0]
    # [Aᴴ  0] [y]   [c]
    (x, y, stats) = usymlqr(A, b, c, ls=false)
    K = [I A; A' zeros(n,n)]
    d = [0*b; c]
    r = d - K * [x; y]
    resid = norm(r)
    @test resid ≤ usymlqr_tol
  end

  @testset "Data Type: $FC" for FC in (Float64, ComplexF64)
    # Test saddle-point systems
    A, b, D = saddle_point(FC=FC)
    m, n = size(A)
    c = -b
    D⁻¹ = sparse(inv(D))
    N⁻¹ = eye(n)
    H⁻¹ = blockdiag(D⁻¹, N⁻¹)

    (x, y, stats) = usymlqr(A, b, c, ls=true, ln=false)
    K = [eye(m) A; A' zeros(n, n)]
    d = [b; 0*c]
    r =  d - K * [x; y]
    resid = norm(r) / norm(d)
    @test(resid ≤ usymlqr_tol)

    (x, y, stats) = usymlqr(A, b, c, ls=false, ln=true)
    K = [eye(m) A; A' zeros(n, n)]
    d = [0*b; c]
    r =  d - K * [x; y]
    resid = norm(r) / norm(d)
    @test(resid ≤ usymlqr_tol)

    (x, y, stats) = usymlqr(A, b, c)
    K = [eye(m) A; A' zeros(n, n)]
    d = [b; c]
    r =  d - K * [x; y]
    resid = norm(r) / norm(d)
    @test(resid ≤ usymlqr_tol)

    # Test different types for input and output
    d = TestVector(c)
    workspace = UsymlqrWorkspace(KrylovConstructor(b, d))
    usymlqr!(workspace, A, b, d)
    @test typeof(workspace.x) === typeof(b)
    @test typeof(workspace.y) === typeof(d)
    @test workspace.stats.solved
  end
end

export kstdout

"Default I/O stream for all Krylov methods."
const kstdout = Core.stdout

"""
    FloatOrComplex{T}
Union type of `T` and `Complex{T}` where T is an `AbstractFloat`.
"""
const FloatOrComplex{T} = Union{T, Complex{T}} where T <: AbstractFloat

"""
    (c, s, ρ) = sym_givens(a, b)

Numerically stable symmetric Givens reflection.
Given `a` and `b` reals, return `(c, s, ρ)` such that

    [ c  s ] [ a ] = [ ρ ]
    [ s -c ] [ b ] = [ 0 ].
"""
function sym_givens(a :: T, b :: T) where T <: AbstractFloat
  #
  # Modeled after the corresponding Matlab function by M. A. Saunders and S.-C. Choi.
  # http://www.stanford.edu/group/SOL/dissertations/sou-cheng-choi-thesis.pdf
  # D. Orban, Montreal, May 2015.

  if iszero(b)
    c = T(sign(a) + iszero(a)) # In Julia, sign(0) = 0.
    s = zero(T)
    ρ = abs(a)

  elseif iszero(a)
    c = zero(T)
    s = T(sign(b))
    ρ = abs(b)

  elseif abs(b) > abs(a)
    t = a / b
    s = T(sign(b)) / sqrt(oneunit(T) + t * t)
    c = s * t
    ρ = b / s  # Computationally better than ρ = a / c since |c| ≤ |s|.

  else
    t = b / a
    c = T(sign(a)) / sqrt(oneunit(T) + t * t)
    s = c * t
    ρ = a / c  # Computationally better than ρ = b / s since |s| ≤ |c|
  end

  return (c, s, ρ)
end

"""
Numerically stable symmetric Givens reflection.
Given `a` and `b` complexes, return `(c, s, ρ)` with
c real and (s, ρ) complexes such that

    [ c   s ] [ a ] = [ ρ ]
    [ s̅  -c ] [ b ] = [ 0 ].
"""
function sym_givens(a :: Complex{T}, b :: Complex{T}) where T <: AbstractFloat
  #
  # Modeled after the corresponding Fortran function by M. A. Saunders and S.-C. Choi.
  # A. Montoison, Montreal, March 2020.

  abs_a = abs(a)
  abs_b = abs(b)

  if abs_b == 0
    c = one(T)
    s = zero(Complex{T})
    ρ = a

  elseif abs_a == 0
    c = zero(T)
    s = one(Complex{T})
    ρ = b

  elseif abs_b > abs_a
    t = abs_a / abs_b
    c = one(T) / sqrt(one(T) + t * t)
    s = c * conj((b / abs_b) / (a / abs_a))
    c = c * t
    ρ = b / conj(s)

  else
    t = abs_b / abs_a
    c = one(T) / sqrt(one(T) + t * t)
    s = c * t * conj((b / abs_b) / (a / abs_a))
    ρ = a / c
  end

  return (c, s, ρ)
end

sym_givens(a :: Complex{T}, b :: T) where T <: AbstractFloat = sym_givens(a, Complex{T}(b))
sym_givens(a :: T, b :: Complex{T}) where T <: AbstractFloat = sym_givens(Complex{T}(a), b)

"""
    roots = roots_quadratic(q₂, q₁, q₀; nitref)

Find the real roots of the quadratic

    q(x) = q₂ x² + q₁ x + q₀,

where q₂, q₁ and q₀ are real. Care is taken to avoid numerical
cancellation. Optionally, `nitref` steps of iterative refinement
may be performed to improve accuracy. By default, `nitref=1`.
"""
function roots_quadratic(q₂ :: T, q₁ :: T, q₀ :: T;
                         nitref :: Int=1) where T <: AbstractFloat
  # Case where q(x) is linear.
  if q₂ == zero(T)
    if q₁ == zero(T)
      q₀ == zero(T) || error("The quadratic `q` doesn't have real roots.")
      root = zero(T)
    else
      root = -q₀ / q₁
    end
    return (root, root)
  end

  # Case where q(x) is indeed quadratic.
  rhs = √eps(T) * q₁ * q₁
  if abs(q₀ * q₂) > rhs
    ρ = q₁ * q₁ - 4 * q₂ * q₀
    ρ < 0 && return error("The quadratic `q` doesn't have real roots.")
    d = -(q₁ + copysign(sqrt(ρ), q₁)) / 2
    root1 = d / q₂
    root2 = q₀ / d
  else
    # Ill-conditioned quadratic.
    root1 = -q₁ / q₂
    root2 = zero(T)
  end

  # Perform a few Newton iterations to improve accuracy.
  for it = 1 : nitref
    q = (q₂ * root1 + q₁) * root1 + q₀
    dq = 2 * q₂ * root1 + q₁
    dq == zero(T) && continue
    root1 = root1 - q / dq
  end

  for it = 1 : nitref
    q = (q₂ * root2 + q₁) * root2 + q₀
    dq = 2 * q₂ * root2 + q₁
    dq == zero(T) && continue
    root2 = root2 - q / dq
  end
  return (root1, root2)
end

"""
    s = vec2str(x; ndisp)

Display an array in the form

    [ -3.0e-01 -5.1e-01  1.9e-01 ... -2.3e-01 -4.4e-01  2.4e-01 ]

with (ndisp - 1)/2 elements on each side.
"""
function vec2str(x :: AbstractVector{T}; ndisp :: Int=7) where T <: Union{AbstractFloat, Missing}
  n = length(x)
  if n ≤ ndisp
    ndisp = n
    nside = n
  else
    nside = max(1, div(ndisp - 1, 2))
  end
  s = "["
  i = 1
  while i ≤ nside
    if x[i] !== missing
      s *= @sprintf("%8.1e ", x[i])
    else
      s *= " ✗✗✗✗ "
    end
      i += 1
  end
  if i ≤ div(n, 2)
    s *= "... "
  end
  i = max(i, n - nside + 1)
  while i ≤ n
    if x[i] !== missing
      s *= @sprintf("%8.1e ", x[i])
    else
      s *= " ✗✗✗✗ "
    end
    i += 1
  end
  s *= "]"
  return s
end

"""
    S = ktypeof(v)

Return the most relevant storage type `S` based on the type of `v`.
"""
function ktypeof end

function ktypeof(v::S) where S <: DenseVector
  if S.name.name == :ComponentArray
    T = eltype(S)
    return Vector{T}
  else
    return S
  end
end

function ktypeof(v::S) where S <: DenseMatrix
  return S
end

function ktypeof(v::S) where S <: AbstractVector
  if S.name.name == :Zeros || S.name.name == :Ones || S.name.name == :SArray || S.name.name == :MArray || S.name.name == :SizedArray || S.name.name == :FieldArray
    T = eltype(S)
    return Vector{T}  # FillArrays, StaticArrays
  else
    return S  # BlockArrays, PartitionedArrays, etc...
  end
end

function ktypeof(v::S) where S <: SparseVector
  T = eltype(S)
  return Vector{T}
end

function ktypeof(v::S) where S <: AbstractSparseVector
  return S.types[2]  # return `CuVector` for a `CuSparseVector`
end

function ktypeof(v::S) where S <: SubArray
  vp = v.parent
  if isa(vp, DenseMatrix)
    M = typeof(vp)
    return matrix_to_vector(M)  # view of a row or a column of a matrix
  else
    return ktypeof(vp)  # view of a vector
  end
end

"""
    M = vector_to_matrix(S)

Return the dense matrix storage type `M` related to the dense vector storage type `S`.
"""
function vector_to_matrix(::Type{S}) where S <: DenseVector
  T = hasproperty(S, :body) ? S.body : S
  par = T.parameters
  npar = length(par)
  (2 ≤ npar ≤ 3) || error("Type $S is not supported.")
  if npar == 2
    M = T.name.wrapper{par[1], 2}
  else
    M = T.name.wrapper{par[1], 2, par[3]}
  end
  return M
end

"""
    S = matrix_to_vector(M)

Return the dense vector storage type `S` related to the dense matrix storage type `M`.
"""
function matrix_to_vector(::Type{M}) where M <: DenseMatrix
  T = hasproperty(M, :body) ? M.body : M
  par = T.parameters
  npar = length(par)
  (2 ≤ npar ≤ 3) || error("Type $M is not supported.")
  if npar == 2
    S = T.name.wrapper{par[1], 1}
  else
    S = T.name.wrapper{par[1], 1, par[3]}
  end
  return S
end

@inline function allocate_if(bool, workspace, v, ::Type{S}, u) where S
  start_allocation_time = time_ns()
  if bool && isempty(workspace.:($v)::S)
    workspace.:($v)::S = similar(u)
  end
  workspace.stats.allocation_timer += start_allocation_time |> ktimer
  return nothing
end

# @inline allocate_if(bool, workspace, v, ::Type{S}, n::Int) where S = bool && isempty(workspace.:($v)::S) && (workspace.:($v)::S = S(undef, n))

@inline function allocate_if(bool, workspace, v, ::Type{S}, m::Int, n::Int) where S
  start_allocation_time = time_ns()
  if bool && isempty(workspace.:($v)::S)
    workspace.:($v)::S = S(undef, m, n)
  end
  workspace.stats.allocation_timer += start_allocation_time |> ktimer
  return nothing
end

kdisplay(iter, verbose) = (verbose > 0) && (mod(iter, verbose) == 0)

ktimer(start_time::UInt64) = (time_ns() - start_time) / 1e9

kmul!(y, P, x) = mul!(y, P, x)
kldiv!(y, P, x) = ldiv!(y, P, x)
mulorldiv!(y, P, x, ldiv::Bool) = ldiv ? kldiv!(y, P, x) : kmul!(y, P, x)

kdot(n :: Integer, x :: Vector{T}, y :: Vector{T}) where T <: BLAS.BlasReal = BLAS.dot(n, x, 1, y, 1)
kdot(n :: Integer, x :: Vector{T}, y :: Vector{T}) where T <: BLAS.BlasComplex = BLAS.dotc(n, x, 1, y, 1)
kdot(n :: Integer, x :: AbstractVector{T}, y :: AbstractVector{T}) where T <: FloatOrComplex = dot(x, y)

kdotr(n :: Integer, x :: AbstractVector{T}, y :: AbstractVector{T}) where T <: AbstractFloat = kdot(n, x, y)
kdotr(n :: Integer, x :: AbstractVector{Complex{T}}, y :: AbstractVector{Complex{T}}) where T <: AbstractFloat = kdot(n, x, y) |> real

knorm(n :: Integer, x :: Vector{T}) where T <: BLAS.BlasFloat = BLAS.nrm2(n, x, 1)
knorm(n :: Integer, x :: AbstractVector{T}) where T <: FloatOrComplex = norm(x)

knorm_elliptic(n :: Integer, x :: AbstractVector{T}, y :: AbstractVector{T}) where T <: FloatOrComplex = (x === y) ? knorm(n, x) : kdotr(n, x, y) |> sqrt

kscal!(n :: Integer, s :: T, x :: Vector{T}) where T <: BLAS.BlasFloat = BLAS.scal!(n, s, x, 1)
kscal!(n :: Integer, s :: T, x :: AbstractVector{T}) where T <: FloatOrComplex = rmul!(x, s)
kscal!(n :: Integer, s :: T, x :: AbstractVector{Complex{T}}) where T <: AbstractFloat = kscal!(n, Complex{T}(s), x)

kdiv!(n :: Integer, x :: AbstractVector{T}, s :: T) where T <: FloatOrComplex = kscal!(n, one(T) / s, x)
kdiv!(n :: Integer, x :: AbstractVector{Complex{T}}, s :: T) where T <: AbstractFloat = kscal!(n, one(T) / s, x)

kcopy!(n :: Integer, y :: Vector{T}, x :: Vector{T}) where T <: BLAS.BlasFloat = BLAS.blascopy!(n, x, 1, y, 1)
kcopy!(n :: Integer, y :: AbstractVector, x :: AbstractVector) = copyto!(y, x)

kscalcopy!(n :: Integer, y :: AbstractVector{T}, s :: T, x :: AbstractVector{T}) where T <: FloatOrComplex = (y .= s .* x)
kscalcopy!(n :: Integer, y :: AbstractVector{Complex{T}}, s :: T, x :: AbstractVector{Complex{T}}) where T <: AbstractFloat = (y .= s .* x)

kdivcopy!(n :: Integer, y :: AbstractVector{T}, x :: AbstractVector{T}, s :: T) where T <: FloatOrComplex = (y .= x ./ s)
kdivcopy!(n :: Integer, y :: AbstractVector{Complex{T}}, x :: AbstractVector{Complex{T}}, s :: T) where T <: AbstractFloat = (y .= x ./ s)

kaxpy!(n :: Integer, s :: T, x :: Vector{T}, y :: Vector{T}) where T <: BLAS.BlasFloat = BLAS.axpy!(n, s, x, 1, y, 1)
kaxpy!(n :: Integer, s :: T, x :: AbstractVector{T}, y :: AbstractVector{T}) where T <: FloatOrComplex = axpy!(s, x, y)
kaxpy!(n :: Integer, s :: T, x :: AbstractVector{Complex{T}}, y :: AbstractVector{Complex{T}}) where T <: AbstractFloat = kaxpy!(n, Complex{T}(s), x, y)

kaxpby!(n :: Integer, s :: T, x :: Vector{T}, t :: T, y :: Vector{T}) where T <: BLAS.BlasFloat = BLAS.axpby!(n, s, x, 1, t, y, 1)
kaxpby!(n :: Integer, s :: T, x :: AbstractVector{T}, t :: T, y :: AbstractVector{T}) where T <: FloatOrComplex = axpby!(s, x, t, y)
kaxpby!(n :: Integer, s :: T, x :: AbstractVector{Complex{T}}, t :: Complex{T}, y :: AbstractVector{Complex{T}}) where T <: AbstractFloat = kaxpby!(n, Complex{T}(s), x, t, y)
kaxpby!(n :: Integer, s :: Complex{T}, x :: AbstractVector{Complex{T}}, t :: T, y :: AbstractVector{Complex{T}}) where T <: AbstractFloat = kaxpby!(n, s, x, Complex{T}(t), y)
kaxpby!(n :: Integer, s :: T, x :: AbstractVector{Complex{T}}, t :: T, y :: AbstractVector{Complex{T}}) where T <: AbstractFloat = kaxpby!(n, Complex{T}(s), x, Complex{T}(t), y)

kfill!(x :: AbstractArray{T}, val :: T) where T <: FloatOrComplex = fill!(x, val)

kref!(n, x, y, c, s) = reflect!(x, y, c, s)

macro kswap!(x, y)
  quote
    local tmp = $(esc(x))
    $(esc(x)) = $(esc(y))
    $(esc(y)) = tmp
  end
end

"""
    roots = to_boundary(n, x, d, radius; flip, xNorm2, dNorm2)

Given a trust-region radius `radius`, a vector `x` lying inside the
trust-region and a direction `d`, return `σ1` and `σ2` such that

    ‖x + σi d‖ = radius, i = 1, 2

in the Euclidean norm.
`n` is the length of vectors `x` and `d`.
If known, ‖x‖² and ‖d‖² may be supplied with `xNorm2` and `dNorm2`.

If `flip` is set to `true`, `σ1` and `σ2` are computed such that

    ‖x - σi d‖ = radius, i = 1, 2.
"""
function to_boundary(n :: Int, x :: AbstractVector{FC}, d :: AbstractVector{FC}, z::AbstractVector{FC}, radius :: T; flip :: Bool=false, xNorm2 :: T=zero(T), dNorm2 :: T=zero(T), M=I, ldiv :: Bool = false) where {T <: AbstractFloat, FC <: FloatOrComplex{T}}
  radius > 0 || error("radius must be positive")

  if M === I
    # ‖d‖² σ² + (xᴴd + dᴴx) σ + (‖x‖² - Δ²).
    rxd = kdotr(n, x, d)
    dNorm2 == zero(T) && (dNorm2 = kdotr(n, d, d))
    xNorm2 == zero(T) && (xNorm2 = kdotr(n, x, x))
  else
    # (dᴴMd) σ² + (xᴴMd + dᴴMx) σ + (xᴴMx - Δ²).
    mulorldiv!(z, M, x, ldiv)
    rxd = kdot(n, z, d)
    xNorm2 = kdotr(n, z, x)
    mulorldiv!(z, M, d, ldiv)
    dNorm2 = kdotr(n, z, d)
  end
  dNorm2 == zero(T) && error("zero direction")
  flip && (rxd = -rxd)

  radius2 = radius * radius
  (xNorm2 ≤ radius2) || error(@sprintf("outside of the trust region: ‖x‖²=%7.1e, Δ²=%7.1e", xNorm2, radius2))

  # q₂ = ‖d‖², q₁ = xᴴd + dᴴx, q₀ = ‖x‖² - Δ²
  # ‖x‖² ≤ Δ² ⟹ (q₁)² - 4 * q₂ * q₀ ≥ 0
  roots = roots_quadratic(dNorm2, 2 * real(rxd), xNorm2 - radius2)

  return roots  # `σ1` and `σ2`
end

"""
    arguments = extract_parameters(ex::Expr)

Extract the arguments of an expression that is keyword parameter tuple.
Implementation suggested by Mitchell J. O'Sullivan (@mosullivan93).
"""
function extract_parameters(ex::Expr)
  Meta.isexpr(ex, :tuple, 1) &&
  Meta.isexpr((@inbounds p = ex.args[1]), :parameters) &&
  Base.Docs.validcall(p.args[]) || throw(ArgumentError("Given expression is not a kw parameter tuple [e.g. :(; x)]: $ex"))
  return p.args[]
end

"""
    P = permutation_paige(k)

Return the sparse (2k) × (2k) matrix

    [e₁    •    eₖ   ]
    [   e₁    •    eₖ]
"""
function permutation_paige(k)
  P = spzeros(Float64, 2k, 2k)
  for i = 1:k
    P[i,2i-1] = 1.0
    P[i+k,2i] = 1.0
  end
  return P
end

@testset "processes" begin
  m = 250
  n = 500
  k = 20
  s = 5

  for FC in (Float64, ComplexF64)
    R = real(FC)
    nbits_FC = sizeof(FC)
    nbits_R = sizeof(R)
    nbits_I = sizeof(Int)

    @testset "Data Type: $FC" begin

      @testset "Hermitian Lanczos" begin
        A = rand(FC, n, n)
        A = A' * A
        b = rand(FC, n)
        @testset "reorthogonalization = $reorthogonalization" for reorthogonalization in (false, true)
          V, β₁, T = hermitian_lanczos(A, b, k; reorthogonalization)

          @test norm(V[:,1:s]' * V[:,1:s] - I) ≤ 1e-4
          @test β₁ * V[:,1] ≈ b
          @test A * V[:,1:k] ≈ V * T

          storage_hermitian_lanczos_bytes(n, k) = 4k * nbits_I + (3k-1) * nbits_R + n*(k+1) * nbits_FC

          expected_hermitian_lanczos_bytes = storage_hermitian_lanczos_bytes(n, k)
          actual_hermitian_lanczos_bytes = @allocated hermitian_lanczos(A, b, k; reorthogonalization)
          if VERSION < v"1.11.5" || !Sys.isapple()
            @test expected_hermitian_lanczos_bytes ≤ actual_hermitian_lanczos_bytes ≤ 1.02 * expected_hermitian_lanczos_bytes
          end
        end
      end

      @testset "Non-Hermitian Lanczos" begin
        A = rand(FC, n, n)
        b = rand(FC, n)
        c = rand(FC, n)
        V, β₁, T, U, γ₁ᴴ, Tᴴ = nonhermitian_lanczos(A, b, c, k)

        @test norm(V[:,1:s]' * U[:,1:s] - I) ≤ 1e-4
        @test norm(U[:,1:s]' * V[:,1:s] - I) ≤ 1e-4
        @test β₁ * V[:,1] ≈ b
        @test γ₁ᴴ * U[:,1] ≈ c
        @test T[1:k,1:k] ≈ Tᴴ[1:k,1:k]'
        @test A  * V[:,1:k] ≈ V * T
        @test A' * U[:,1:k] ≈ U * Tᴴ

        storage_nonhermitian_lanczos_bytes(n, k) = 4k * nbits_I + (6k-2) * nbits_FC + 2*n*(k+1) * nbits_FC

        expected_nonhermitian_lanczos_bytes = storage_nonhermitian_lanczos_bytes(n, k)
        actual_nonhermitian_lanczos_bytes = @allocated nonhermitian_lanczos(A, b, c, k)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_nonhermitian_lanczos_bytes ≤ actual_nonhermitian_lanczos_bytes ≤ 1.02 * expected_nonhermitian_lanczos_bytes
        end
      end

      @testset "Arnoldi" begin
        A = rand(FC, n, n)
        b = rand(FC, n)
        @testset "reorthogonalization = $reorthogonalization" for reorthogonalization in (false, true)
          V, β, H = arnoldi(A, b, k; reorthogonalization)

          @test norm(V[:,1:s]' * V[:,1:s] - I) ≤ 1e-4
          @test β * V[:,1] ≈ b
          @test A * V[:,1:k] ≈ V * H

          function storage_arnoldi_bytes(n, k)
            return k*(k+1) * nbits_FC + n*(k+1) * nbits_FC
          end

          expected_arnoldi_bytes = storage_arnoldi_bytes(n, k)
          actual_arnoldi_bytes = @allocated arnoldi(A, b, k; reorthogonalization)
          if VERSION < v"1.11.5" || !Sys.isapple()
            @test expected_arnoldi_bytes ≤ actual_arnoldi_bytes ≤ 1.02 * expected_arnoldi_bytes
          end
        end
      end

      @testset "Golub-Kahan" begin
        A = rand(FC, m, n)
        b = rand(FC, m)
        V, U, β₁, L = golub_kahan(A, b, k)
        B = L[1:k+1,1:k]

        @test norm(V[:,1:s]' * V[:,1:s] - I) ≤ 1e-4
        @test norm(U[:,1:s]' * U[:,1:s] - I) ≤ 1e-4
        @test β₁ * U[:,1] ≈ b
        @test A  * V[:,1:k] ≈ U * B
        @test A' * U ≈ V * L'
        @test A' * A  * V[:,1:k] ≈ V * L' * B
        @test A  * A' * U[:,1:k] ≈ U * B * L[1:k,1:k]'

        storage_golub_kahan_bytes(m, n, k) = 3*(k+1) * nbits_I + (2k+1) * nbits_R + (n+m)*(k+1) * nbits_FC

        expected_golub_kahan_bytes = storage_golub_kahan_bytes(m, n, k)
        actual_golub_kahan_bytes = @allocated golub_kahan(A, b, k)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_golub_kahan_bytes ≤ actual_golub_kahan_bytes ≤ 1.02 * expected_golub_kahan_bytes
        end
      end

      @testset "Saunders-Simon-Yip" begin
        A = rand(FC, m, n)
        b = rand(FC, m)
        c = rand(FC, n)
        V, β₁, T, U, γ₁ᴴ, Tᴴ = saunders_simon_yip(A, b, c, k)

        @test norm(V[:,1:s]' * V[:,1:s] - I) ≤ 1e-4
        @test norm(U[:,1:s]' * U[:,1:s] - I) ≤ 1e-4
        @test β₁ * V[:,1] ≈ b
        @test γ₁ᴴ * U[:,1] ≈ c
        @test T[1:k,1:k] ≈ Tᴴ[1:k,1:k]'
        @test A  * U[:,1:k] ≈ V * T
        @test A' * V[:,1:k] ≈ U * Tᴴ
        @test A' * A  * U[:,1:k-1] ≈ U * Tᴴ * T[1:k,1:k-1]
        @test A  * A' * V[:,1:k-1] ≈ V * T * Tᴴ[1:k,1:k-1]

        K = [zeros(FC,m,m) A; A' zeros(FC,n,n)]
        Pₖ = permutation_paige(k)
        Wₖ = [V[:,1:k] zeros(FC,m,k); zeros(FC,n,k) U[:,1:k]] * Pₖ
        Pₖ₊₁ = permutation_paige(k+1)
        Wₖ₊₁ = [V zeros(FC,m,k+1); zeros(FC,n,k+1) U] * Pₖ₊₁
        G = Pₖ₊₁' * [zeros(FC,k+1,k) T; Tᴴ zeros(FC,k+1,k)] * Pₖ
        @test K * Wₖ ≈ Wₖ₊₁ * G

        storage_saunders_simon_yip_bytes(m, n, k) = 4k * nbits_I + (6k-2) * nbits_FC + (n+m)*(k+1) * nbits_FC

        expected_saunders_simon_yip_bytes = storage_saunders_simon_yip_bytes(m, n, k)
        actual_saunders_simon_yip_bytes = @allocated saunders_simon_yip(A, b, c, k)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_saunders_simon_yip_bytes ≤ actual_saunders_simon_yip_bytes ≤ 1.02 * expected_saunders_simon_yip_bytes
        end
      end

      @testset "Montoison-Orban" begin
        A = rand(FC, m, n)
        B = rand(FC, n, m)
        b = rand(FC, m)
        c = rand(FC, n)
        @testset "reorthogonalization = $reorthogonalization" for reorthogonalization in (false, true)
          V, β, H, U, γ, F = montoison_orban(A, B, b, c, k; reorthogonalization)

          @test norm(V[:,1:s]' * V[:,1:s] - I) ≤ 1e-4
          @test norm(U[:,1:s]' * U[:,1:s] - I) ≤ 1e-4
          @test β * V[:,1] ≈ b
          @test γ * U[:,1] ≈ c
          @test A * U[:,1:k] ≈ V * H
          @test B * V[:,1:k] ≈ U * F
          @test B * A * U[:,1:k-1] ≈ U * F * H[1:k,1:k-1]
          @test A * B * V[:,1:k-1] ≈ V * H * F[1:k,1:k-1]

          K = [zeros(FC,m,m) A; B zeros(FC,n,n)]
          Pₖ = permutation_paige(k)
          Wₖ = [V[:,1:k] zeros(FC,m,k); zeros(FC,n,k) U[:,1:k]] * Pₖ
          Pₖ₊₁ = permutation_paige(k+1)
          Wₖ₊₁ = [V zeros(FC,m,k+1); zeros(FC,n,k+1) U] * Pₖ₊₁
          G = Pₖ₊₁' * [zeros(FC,k+1,k) H; F zeros(FC,k+1,k)] * Pₖ
          @test K * Wₖ ≈ Wₖ₊₁ * G

          function storage_montoison_orban_bytes(m, n, k)
            return 2*k*(k+1) * nbits_FC + (n+m)*(k+1) * nbits_FC
          end

          expected_montoison_orban_bytes = storage_montoison_orban_bytes(m, n, k)
          actual_montoison_orban_bytes = @allocated montoison_orban(A, B, b, c, k; reorthogonalization)
          if VERSION < v"1.11.5" || !Sys.isapple()
            @test expected_montoison_orban_bytes ≤ actual_montoison_orban_bytes ≤ 1.02 * expected_montoison_orban_bytes
          end
        end
      end
    end
  end
end

@testset "breakdown" begin
  A0, b0, c0 = Float64[1 0; 0 1], Float64[0; 0], Float64[1; 1]
  A1, b1, c1 = ssy_mo_breakdown()
  A2, b2, c2 = ssy_mo_breakdown2()
  A3, b3, c3 = ssy_mo_breakdown3()

  @testset "Hermitian Lanczos" begin
    @test_throws ErrorException("Exact breakdown β₁ == 0.") hermitian_lanczos(A0, b0, 2)
    hermitian_lanczos(A0, b0, 2, allow_breakdown=true)
  end

  @testset "Non-Hermitian Lanczos" begin
    @test_throws ErrorException("Exact breakdown β₁γ₁ == 0.") nonhermitian_lanczos(A0, b0, c0, 2)
    nonhermitian_lanczos(A0, b0, c0, 2, allow_breakdown=true)
  end

  @testset "Arnoldi" begin
    @test_throws ErrorException("Exact breakdown β == 0.") arnoldi(A0, b0, 2)
    arnoldi(A0, b0, 2, allow_breakdown=true)
  end

  @testset "Golub-Kahan" begin
    @test_throws ErrorException("Exact breakdown β₁ == 0.") golub_kahan(A0, b0, 2)
    golub_kahan(A0, b0, 2, allow_breakdown=true)
  end

  @testset "Saunders-Simon-Yip" begin
    @test_throws ErrorException("Exact breakdown β₁ == 0.") saunders_simon_yip(A0, b0, c0, 2)
    saunders_simon_yip(A0, b0, c0, 2, allow_breakdown=true)
    @test_throws ErrorException("Exact breakdown γ₁ᴴ == 0.") saunders_simon_yip(A0, c0, b0, 2)
    saunders_simon_yip(A0, c0, b0, 2, allow_breakdown=true)
    @test_throws ErrorException("Exact breakdown βᵢ₊₁ == 0 at iteration i = 1.") saunders_simon_yip(A1, b1, c1, 1)
    @test_throws ErrorException("Exact breakdown βᵢ₊₁ == 0 at iteration i = 2.") saunders_simon_yip(A2, b2, c2, 2)
    @test_throws ErrorException("Exact breakdown γᵢ₊₁ == 0 at iteration i = 2.") saunders_simon_yip(A3, b3, c3, 2)
  end

  @testset "Montoison-Orban" begin
    @test_throws ErrorException("Exact breakdown β == 0.") montoison_orban(A0, A0', b0, c0, 2)
    montoison_orban(A0, A0', b0, c0, 2, allow_breakdown=true)
    @test_throws ErrorException("Exact breakdown γ == 0.") montoison_orban(A0, A0', c0, b0, 2)
    montoison_orban(A0, A0', c0, b0, 2, allow_breakdown=true)
    @test_throws ErrorException("Exact breakdown Hᵢ₊₁.ᵢ == 0 at iteration i = 1.") montoison_orban(A1, A1', b1, c1, 1)
    @test_throws ErrorException("Exact breakdown Hᵢ₊₁.ᵢ == 0 at iteration i = 2.") montoison_orban(A2, A2', b2, c2, 2)
    @test_throws ErrorException("Exact breakdown Fᵢ₊₁.ᵢ == 0 at iteration i = 2.") montoison_orban(A3, A3', b3, c3, 2)
  end
end

export hermitian_lanczos, nonhermitian_lanczos, arnoldi, golub_kahan, saunders_simon_yip, montoison_orban

"""
    V, β, T = hermitian_lanczos(A, b, k; allow_breakdown=false, reorthogonalization=false)

#### Input arguments

* `A`: a linear operator that models a Hermitian matrix of dimension `n`;
* `b`: a vector of length `n`;
* `k`: the number of iterations of the Hermitian Lanczos process.

#### Keyword arguments

* `allow_breakdown`: specify whether to continue the process or raise an error when an exact breakdown occurs;
* `reorthogonalization`: reorthogonalize each newly added vector of the Krylov basis against only the two previous vectors (local reorthogonalization).

#### Output arguments

* `V`: a dense `n × (k+1)` matrix;
* `β`: a coefficient such that `βv₁ = b`;
* `T`: a sparse `(k+1) × k` tridiagonal matrix.

#### References

* C. Lanczos, [*An Iteration Method for the Solution of the Eigenvalue Problem of Linear Differential and Integral Operators*](https://doi.org/10.6028/jres.045.026), Journal of Research of the National Bureau of Standards, 45(4), pp. 225--280, 1950.
* H. D. Simon, [*The Lanczos algorithm with partial reorthogonalization*](https://doi.org/10.1090/S0025-5718-1984-0725988-X), Mathematics of computation, 42(165), pp. 115--142, 1984.
"""
function hermitian_lanczos(A, b::AbstractVector{FC}, k::Int;
                           allow_breakdown::Bool=false, reorthogonalization::Bool=false) where FC <: FloatOrComplex
  m, n = size(A)
  R = real(FC)
  S = ktypeof(b)
  M = vector_to_matrix(S)

  colptr = zeros(Int, k+1)
  rowval = zeros(Int, 3k-1)
  nzval = zeros(R, 3k-1)

  colptr[1] = 1
  for i = 1:k
    pos = colptr[i]
    colptr[i+1] = 3i
    if i == 1
      rowval[pos] = i
      rowval[pos+1] = i+1
    else
      rowval[pos] = i-1
      rowval[pos+1] = i
      rowval[pos+2] = i+1
    end
  end

  β₁ = zero(R)
  V = M(undef, n, k+1)
  T = SparseMatrixCSC(k+1, k, colptr, rowval, nzval)

  pαᵢ = 1  # Position of αᵢ in the vector `nzval`
  for i = 1:k
    vᵢ = view(V,:,i)
    vᵢ₊₁ = q = view(V,:,i+1)
    if i == 1
      β₁ = knorm(n, b)
      if β₁ == 0
        !allow_breakdown && error("Exact breakdown β₁ == 0.")
        kfill!(vᵢ, zero(FC))
      else
        kdivcopy!(n, vᵢ, b, β₁)
      end
    end
    kmul!(q, A, vᵢ)
    if i ≥ 2
      vᵢ₋₁ = view(V,:,i-1)
      βᵢ = nzval[pαᵢ-2]  # βᵢ = Tᵢ.ᵢ₋₁
      nzval[pαᵢ-1] = βᵢ  # Tᵢ₋₁.ᵢ = βᵢ
      kaxpy!(n, -βᵢ, vᵢ₋₁, q)
    end
    αᵢ = kdotr(n, vᵢ, q)
    kaxpy!(n, -αᵢ, vᵢ, q)
    if reorthogonalization
      if i ≥ 2
        vᵢ₋₁ = view(V,:,i-1)
        βtmp = kdotr(n, vᵢ₋₁, q)
        nzval[pαᵢ-2] += βtmp
        nzval[pαᵢ-1] += βtmp
        kaxpy!(n, -βtmp, vᵢ₋₁, q)
      end
      αtmp = kdotr(n, vᵢ, q)
      αᵢ += αtmp
      kaxpy!(n, -αtmp, vᵢ, q)
    end
    nzval[pαᵢ] = αᵢ  # Tᵢ.ᵢ = αᵢ
    βᵢ₊₁ = knorm(n, q)
    if βᵢ₊₁ == 0
      !allow_breakdown && error("Exact breakdown βᵢ₊₁ == 0 at iteration i = $i.")
      kfill!(vᵢ₊₁, zero(FC))
    else
      kdivcopy!(n, vᵢ₊₁, q, βᵢ₊₁)
    end
    nzval[pαᵢ+1] = βᵢ₊₁  # Tᵢ₊₁.ᵢ = βᵢ₊₁
    pαᵢ = pαᵢ + 3
  end
  return V, β₁, T
end

"""
    V, β, T, U, γᴴ, Tᴴ = nonhermitian_lanczos(A, b, c, k; allow_breakdown=false)

#### Input arguments

* `A`: a linear operator that models a square matrix of dimension `n`;
* `b`: a vector of length `n`;
* `c`: a vector of length `n`;
* `k`: the number of iterations of the non-Hermitian Lanczos process.

#### Keyword argument

* `allow_breakdown`: specify whether to continue the process or raise an error when an exact breakdown occurs.

#### Output arguments

* `V`: a dense `n × (k+1)` matrix;
* `β`: a coefficient such that `βv₁ = b`;
* `T`: a sparse `(k+1) × k` tridiagonal matrix;
* `U`: a dense `n × (k+1)` matrix;
* `γᴴ`: a coefficient such that `γᴴu₁ = c`;
* `Tᴴ`: a sparse `(k+1) × k` tridiagonal matrix.

#### References

* C. Lanczos, [*An Iteration Method for the Solution of the Eigenvalue Problem of Linear Differential and Integral Operators*](https://doi.org/10.6028/jres.045.026), Journal of Research of the National Bureau of Standards, 45(4), pp. 225--280, 1950.
* H. I. van der Veen and K. Vuik, [*Bi-Lanczos with partial orthogonalization*](https://doi.org/10.1016/0045-7949(94)00565-K), Computers & structures, 56(4), pp. 605--613, 1995.
"""
function nonhermitian_lanczos(A, b::AbstractVector{FC}, c::AbstractVector{FC}, k::Int;
                              allow_breakdown::Bool=false) where FC <: FloatOrComplex
  m, n = size(A)
  Aᴴ = A'
  R = real(FC)
  S = ktypeof(b)
  M = vector_to_matrix(S)

  colptr = zeros(Int, k+1)
  rowval = zeros(Int, 3k-1)
  nzval_T = zeros(FC, 3k-1)
  nzval_Tᴴ = zeros(FC, 3k-1)

  colptr[1] = 1
  for i = 1:k
    pos = colptr[i]
    colptr[i+1] = 3i
    if i == 1
      rowval[pos] = i
      rowval[pos+1] = i+1
    else
      rowval[pos] = i-1
      rowval[pos+1] = i
      rowval[pos+2] = i+1
    end
  end

  β₁ = γ₁ᴴ = zero(R)
  V = M(undef, n, k+1)
  U = M(undef, n, k+1)
  T = SparseMatrixCSC(k+1, k, colptr, rowval, nzval_T)
  Tᴴ = SparseMatrixCSC(k+1, k, colptr, rowval, nzval_Tᴴ)

  pαᵢ = 1  # Position of αᵢ and ᾱᵢ in the vectors `nzval_T` and `nzval_Tᴴ`
  for i = 1:k
    vᵢ = view(V,:,i)
    uᵢ = view(U,:,i)
    vᵢ₊₁ = q = view(V,:,i+1)
    uᵢ₊₁ = p = view(U,:,i+1)
    if i == 1
      cᴴb = kdot(n, c, b)
      if cᴴb == 0
        !allow_breakdown && error("Exact breakdown β₁γ₁ == 0.")
        βᵢ₊₁ = zero(FC)
        γᵢ₊₁ = zero(FC)
        kfill!(vᵢ₊₁, zero(FC))
        kfill!(uᵢ₊₁, zero(FC))
      else
        β₁ = √(abs(cᴴb))
        γ₁ᴴ = conj(cᴴb / β₁)
        kdivcopy!(n, vᵢ, b, β₁)
        kdivcopy!(n, uᵢ, c, γ₁ᴴ)
      end
    end
    kmul!(q, A , vᵢ)
    kmul!(p, Aᴴ, uᵢ)
    if i ≥ 2
      vᵢ₋₁ = view(V,:,i-1)
      uᵢ₋₁ = view(U,:,i-1)
      βᵢ = nzval_T[pαᵢ-2]  # βᵢ = Tᵢ.ᵢ₋₁
      γᵢ = nzval_T[pαᵢ-1]  # γᵢ = Tᵢ₋₁.ᵢ
      kaxpy!(n, -     γᵢ , vᵢ₋₁, q)
      kaxpy!(n, -conj(βᵢ), uᵢ₋₁, p)
    end
    αᵢ = kdot(n, uᵢ, q)
    nzval_T[pαᵢ]  = αᵢ        # Tᵢ.ᵢ  = αᵢ
    nzval_Tᴴ[pαᵢ] = conj(αᵢ)  # Tᴴᵢ.ᵢ = ᾱᵢ
    kaxpy!(n, -     αᵢ , vᵢ, q)
    kaxpy!(n, -conj(αᵢ), uᵢ, p)
    pᴴq = kdot(n, p, q)
    if pᴴq == 0
      !allow_breakdown && error("Exact breakdown βᵢ₊₁γᵢ₊₁ == 0 at iteration i = $i.")
      βᵢ₊₁ = zero(FC)
      γᵢ₊₁ = zero(FC)
      kfill!(vᵢ₊₁, zero(FC))
      kfill!(uᵢ₊₁, zero(FC))
    else
      βᵢ₊₁ = √(abs(pᴴq))
      γᵢ₊₁ = pᴴq / βᵢ₊₁
      kdivcopy!(n, vᵢ₊₁, q, βᵢ₊₁)
      kdivcopy!(n, uᵢ₊₁, p, conj(γᵢ₊₁))
    end
    nzval_T[pαᵢ+1]  = βᵢ₊₁        # Tᵢ₊₁.ᵢ  = βᵢ₊₁
    nzval_Tᴴ[pαᵢ+1] = conj(γᵢ₊₁)  # Tᴴᵢ₊₁.ᵢ = γ̄ᵢ₊₁
    if i ≤ k-1
      nzval_T[pαᵢ+2]  = γᵢ₊₁        # Tᵢ.ᵢ₊₁  = γᵢ₊₁
      nzval_Tᴴ[pαᵢ+2] = conj(βᵢ₊₁)  # Tᴴᵢ.ᵢ₊₁ = β̄ᵢ₊₁
    end
    pαᵢ = pαᵢ + 3
  end
  return V, β₁, T, U, γ₁ᴴ, Tᴴ
end

"""
    V, β, H = arnoldi(A, b, k; allow_breakdown=false, reorthogonalization=false)

#### Input arguments

* `A`: a linear operator that models a square matrix of dimension `n`;
* `b`: a vector of length `n`;
* `k`: the number of iterations of the Arnoldi process.

#### Keyword arguments

* `allow_breakdown`: specify whether to continue the process or raise an error when an exact breakdown occurs;
* `reorthogonalization`: reorthogonalize each newly added vector of the Krylov basis against all previous vectors (full reorthogonalization).

#### Output arguments

* `V`: a dense `n × (k+1)` matrix;
* `β`: a coefficient such that `βv₁ = b`;
* `H`: a dense `(k+1) × k` upper Hessenberg matrix.

#### Reference

* W. E. Arnoldi, [*The principle of minimized iterations in the solution of the matrix eigenvalue problem*](https://doi.org/10.1090/qam/42792), Quarterly of Applied Mathematics, 9, pp. 17--29, 1951.
"""
function arnoldi(A, b::AbstractVector{FC}, k::Int;
                 allow_breakdown::Bool=false, reorthogonalization::Bool=false) where FC <: FloatOrComplex
  m, n = size(A)
  R = real(FC)
  S = ktypeof(b)
  M = vector_to_matrix(S)

  β = zero(R)
  V = M(undef, n, k+1)
  H = zeros(FC, k+1, k)

  for j = 1:k
    vⱼ = view(V,:,j)
    vⱼ₊₁ = q = view(V,:,j+1)
    if j == 1
      β = knorm(n, b)
      if β == 0
        !allow_breakdown && error("Exact breakdown β == 0.")
        kfill!(vⱼ, zero(FC))
      else
        kdivcopy!(n, vⱼ, b, β)
      end
    end
    kmul!(q, A, vⱼ)
    for i = 1:j
      vᵢ = view(V,:,i)
      H[i,j] = kdot(n, vᵢ, q)
      kaxpy!(n, -H[i,j], vᵢ, q)
    end
    if reorthogonalization
      for i = 1:j
        vᵢ = view(V,:,i)
        Htmp = kdot(n, vᵢ, q)
        kaxpy!(n, -Htmp, vᵢ, q)
        H[i,j] += Htmp
      end
    end
    H[j+1,j] = knorm(n, q)
    if H[j+1,j] == 0
      !allow_breakdown && error("Exact breakdown Hᵢ₊₁.ᵢ == 0 at iteration i = $j.")
      kfill!(vⱼ₊₁, zero(FC))
    else
      kdivcopy!(n, vⱼ₊₁, q, H[j+1,j])
    end
  end
  return V, β, H
end

"""
    V, U, β, L = golub_kahan(A, b, k; allow_breakdown=false)

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`;
* `k`: the number of iterations of the Golub-Kahan process.

#### Keyword argument

* `allow_breakdown`: specify whether to continue the process or raise an error when an exact breakdown occurs.

#### Output arguments

* `V`: a dense `n × (k+1)` matrix;
* `U`: a dense `m × (k+1)` matrix;
* `β`: a coefficient such that `βu₁ = b`;
* `L`: a sparse `(k+1) × (k+1)` lower bidiagonal matrix.

#### References

* G. H. Golub and W. Kahan, [*Calculating the Singular Values and Pseudo-Inverse of a Matrix*](https://doi.org/10.1137/0702016), SIAM Journal on Numerical Analysis, 2(2), pp. 225--224, 1965.
* C. C. Paige, [*Bidiagonalization of Matrices and Solution of Linear Equations*](https://doi.org/10.1137/0711019), SIAM Journal on Numerical Analysis, 11(1), pp. 197--209, 1974.
"""
function golub_kahan(A, b::AbstractVector{FC}, k::Int;
                     allow_breakdown::Bool=false) where FC <: FloatOrComplex
  m, n = size(A)
  R = real(FC)
  Aᴴ = A'
  S = ktypeof(b)
  M = vector_to_matrix(S)

  colptr = zeros(Int, k+2)
  rowval = zeros(Int, 2k+1)
  nzval = zeros(R, 2k+1)

  colptr[1] = 1
  for i = 1:k+1
    pos = colptr[i]
    if i ≤ k
      colptr[i+1] = pos + 2
      rowval[pos] = i
      rowval[pos+1] = i+1
    else
      colptr[i+1] = pos + 1
      rowval[pos] = i
    end
  end

  β₁ = zero(R)
  V = M(undef, n, k+1)
  U = M(undef, m, k+1)
  L = SparseMatrixCSC(k+1, k+1, colptr, rowval, nzval)

  pαᵢ = 1  # Position of αᵢ in the vector `nzval`
  for i = 1:k
    uᵢ = view(U,:,i)
    vᵢ = view(V,:,i)
    uᵢ₊₁ = q = view(U,:,i+1)
    vᵢ₊₁ = p = view(V,:,i+1)
    if i == 1
      wᵢ = vᵢ
      β₁ = knorm(m, b)
      if β₁ == 0
        !allow_breakdown && error("Exact breakdown β₁ == 0.")
        kfill!(uᵢ, zero(FC))
      else
        kdivcopy!(m, uᵢ, b, β₁)
      end
      kmul!(wᵢ, Aᴴ, uᵢ)
      αᵢ = knorm(n, wᵢ)
      if αᵢ == 0
        !allow_breakdown && error("Exact breakdown α₁ == 0.")
        kfill!(vᵢ, zero(FC))
      else
        kdivcopy!(n, vᵢ, wᵢ, αᵢ)
      end
      nzval[pαᵢ] = αᵢ  # Lᵢ.ᵢ = αᵢ
    end
    kmul!(q, A, vᵢ)
    αᵢ = nzval[pαᵢ]  # αᵢ = Lᵢ.ᵢ
    kaxpy!(m, -αᵢ, uᵢ, q)
    βᵢ₊₁ = knorm(m, q)
    if βᵢ₊₁ == 0
      !allow_breakdown && error("Exact breakdown βᵢ₊₁ == 0 at iteration i = $i.")
      kfill!(uᵢ₊₁, zero(FC))
    else
      kdivcopy!(m, uᵢ₊₁, q, βᵢ₊₁)
    end
    kmul!(p, Aᴴ, uᵢ₊₁)
    kaxpy!(n, -βᵢ₊₁, vᵢ, p)
    αᵢ₊₁ = knorm(n, p)
    if αᵢ₊₁ == 0
      !allow_breakdown && error("Exact breakdown αᵢ₊₁ == 0 at iteration i = $i.")
      kfill!(vᵢ₊₁, zero(FC))
    else
      kdivcopy!(n, vᵢ₊₁, p, αᵢ₊₁)
    end
    nzval[pαᵢ+1] = βᵢ₊₁  # Lᵢ₊₁.ᵢ   = βᵢ₊₁
    nzval[pαᵢ+2] = αᵢ₊₁  # Lᵢ₊₁.ᵢ₊₁ = αᵢ₊₁
    pαᵢ = pαᵢ + 2
  end
  return V, U, β₁, L
end

"""
    V, β, T, U, γᴴ, Tᴴ = saunders_simon_yip(A, b, c, k; allow_breakdown=false)

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`;
* `c`: a vector of length `n`;
* `k`: the number of iterations of the Saunders-Simon-Yip process.

#### Keyword argument

* `allow_breakdown`: specify whether to continue the process or raise an error when an exact breakdown occurs.

#### Output arguments

* `V`: a dense `m × (k+1)` matrix;
* `β`: a coefficient such that `βv₁ = b`;
* `T`: a sparse `(k+1) × k` tridiagonal matrix;
* `U`: a dense `n × (k+1)` matrix;
* `γᴴ`: a coefficient such that `γᴴu₁ = c`;
* `Tᴴ`: a sparse `(k+1) × k` tridiagonal matrix.

#### Reference

* M. A. Saunders, H. D. Simon, and E. L. Yip, [*Two Conjugate-Gradient-Type Methods for Unsymmetric Linear Equations*](https://doi.org/10.1137/0725052), SIAM Journal on Numerical Analysis, 25(4), pp. 927--940, 1988.
"""
function saunders_simon_yip(A, b::AbstractVector{FC}, c::AbstractVector{FC}, k::Int;
                            allow_breakdown::Bool=false) where FC <: FloatOrComplex
  m, n = size(A)
  Aᴴ = A'
  R = real(FC)
  S = ktypeof(b)
  M = vector_to_matrix(S)

  colptr = zeros(Int, k+1)
  rowval = zeros(Int, 3k-1)
  nzval_T = zeros(FC, 3k-1)
  nzval_Tᴴ = zeros(FC, 3k-1)

  colptr[1] = 1
  for i = 1:k
    pos = colptr[i]
    colptr[i+1] = 3i
    if i == 1
      rowval[pos] = i
      rowval[pos+1] = i+1
    else
      rowval[pos] = i-1
      rowval[pos+1] = i
      rowval[pos+2] = i+1
    end
  end

  β₁ = γ₁ᴴ = zero(R)
  V = M(undef, m, k+1)
  U = M(undef, n, k+1)
  T = SparseMatrixCSC(k+1, k, colptr, rowval, nzval_T)
  Tᴴ = SparseMatrixCSC(k+1, k, colptr, rowval, nzval_Tᴴ)

  pαᵢ = 1  # Position of αᵢ and ᾱᵢ in the vectors `nzval_T` and `nzval_Tᴴ`
  for i = 1:k
    vᵢ = view(V,:,i)
    uᵢ = view(U,:,i)
    vᵢ₊₁ = q = view(V,:,i+1)
    uᵢ₊₁ = p = view(U,:,i+1)
    if i == 1
      β₁ = knorm(m, b)
      if β₁ == 0
        !allow_breakdown && error("Exact breakdown β₁ == 0.")
        kfill!(vᵢ, zero(FC))
      else
        kdivcopy!(m, vᵢ, b, β₁)
      end
      γ₁ᴴ = knorm(n, c)
      if γ₁ᴴ == 0
        !allow_breakdown && error("Exact breakdown γ₁ᴴ == 0.")
        kfill!(uᵢ, zero(FC))
      else
        kdivcopy!(n, uᵢ, c, γ₁ᴴ)
      end
    end
    kmul!(q, A , uᵢ)
    kmul!(p, Aᴴ, vᵢ)
    if i ≥ 2
      vᵢ₋₁ = view(V,:,i-1)
      uᵢ₋₁ = view(U,:,i-1)
      βᵢ = nzval_T[pαᵢ-2]  # βᵢ = Tᵢ.ᵢ₋₁
      γᵢ = nzval_T[pαᵢ-1]  # γᵢ = Tᵢ₋₁.ᵢ
      kaxpy!(m, -γᵢ, vᵢ₋₁, q)
      kaxpy!(n, -βᵢ, uᵢ₋₁, p)
    end
    αᵢ = kdot(m, vᵢ, q)
    nzval_T[pαᵢ]  = αᵢ        # Tᵢ.ᵢ  = αᵢ
    nzval_Tᴴ[pαᵢ] = conj(αᵢ)  # Tᴴᵢ.ᵢ = ᾱᵢ
    kaxpy!(m, -     αᵢ , vᵢ, q)
    kaxpy!(n, -conj(αᵢ), uᵢ, p)
    βᵢ₊₁ = knorm(m, q)
    if βᵢ₊₁ == 0
      !allow_breakdown && error("Exact breakdown βᵢ₊₁ == 0 at iteration i = $i.")
      kfill!(vᵢ₊₁, zero(FC))
    else
      kdivcopy!(m, vᵢ₊₁, q, βᵢ₊₁)
    end
    γᵢ₊₁ = knorm(n, p)
    if γᵢ₊₁ == 0
      !allow_breakdown && error("Exact breakdown γᵢ₊₁ == 0 at iteration i = $i.")
      kfill!(uᵢ₊₁, zero(FC))
    else
      kdivcopy!(n, uᵢ₊₁, p, γᵢ₊₁)
    end
    nzval_T[pαᵢ+1]  = βᵢ₊₁  # Tᵢ₊₁.ᵢ  = βᵢ₊₁
    nzval_Tᴴ[pαᵢ+1] = γᵢ₊₁  # Tᴴᵢ₊₁.ᵢ = γᵢ₊₁
    if i ≤ k-1
      nzval_T[pαᵢ+2]  = γᵢ₊₁  # Tᵢ.ᵢ₊₁  = γᵢ₊₁
      nzval_Tᴴ[pαᵢ+2] = βᵢ₊₁  # Tᴴᵢ.ᵢ₊₁ = βᵢ₊₁
    end
    pαᵢ = pαᵢ + 3
  end
  return V, β₁, T, U, γ₁ᴴ, Tᴴ
end

"""
    V, β, H, U, γ, F = montoison_orban(A, B, b, c, k; allow_breakdown=false, reorthogonalization=false)

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `B`: a linear operator that models a matrix of dimension `n × m`;
* `b`: a vector of length `m`;
* `c`: a vector of length `n`;
* `k`: the number of iterations of the Montoison-Orban process.

#### Keyword arguments

* `allow_breakdown`: specify whether to continue the process or raise an error when an exact breakdown occurs;
* `reorthogonalization`: reorthogonalize each newly added vector of the Krylov basis against all previous vectors (full reorthogonalization).

#### Output arguments

* `V`: a dense `m × (k+1)` matrix;
* `β`: a coefficient such that `βv₁ = b`;
* `H`: a dense `(k+1) × k` upper Hessenberg matrix;
* `U`: a dense `n × (k+1)` matrix;
* `γ`: a coefficient such that `γu₁ = c`;
* `F`: a dense `(k+1) × k` upper Hessenberg matrix.

#### Reference

* A. Montoison and D. Orban, [*GPMR: An Iterative Method for Unsymmetric Partitioned Linear Systems*](https://doi.org/10.1137/21M1459265), SIAM Journal on Matrix Analysis and Applications, 44(1), pp. 293--311, 2023.
"""
function montoison_orban(A, B, b::AbstractVector{FC}, c::AbstractVector{FC}, k::Int;
                         allow_breakdown::Bool=false, reorthogonalization::Bool=false) where FC <: FloatOrComplex
  m, n = size(A)
  R = real(FC)
  S = ktypeof(b)
  M = vector_to_matrix(S)

  β = γ = zero(R)
  V = M(undef, m, k+1)
  U = M(undef, n, k+1)
  H = zeros(FC, k+1, k)
  F = zeros(FC, k+1, k)

  for j = 1:k
    vⱼ = view(V,:,j)
    uⱼ = view(U,:,j)
    vⱼ₊₁ = q = view(V,:,j+1)
    uⱼ₊₁ = p = view(U,:,j+1)
    if j == 1
      β = knorm(m, b)
      if β == 0
        !allow_breakdown && error("Exact breakdown β == 0.")
        kfill!(vⱼ, zero(FC))
      else
        kdivcopy!(m, vⱼ, b, β)
      end
      γ = knorm(n, c)
      if γ == 0
        !allow_breakdown && error("Exact breakdown γ == 0.")
        kfill!(uⱼ, zero(FC))
      else
        kdivcopy!(n, uⱼ, c, γ)
      end
    end
    kmul!(q, A, uⱼ)
    kmul!(p, B, vⱼ)
    for i = 1:j
      vᵢ = view(V,:,i)
      uᵢ = view(U,:,i)
      H[i,j] = kdot(m, vᵢ, q)
      kaxpy!(n, -H[i,j], vᵢ, q)
      F[i,j] = kdot(n, uᵢ, p)
      kaxpy!(m, -F[i,j], uᵢ, p)
    end
    if reorthogonalization
      for i = 1:j
        vᵢ = view(V,:,i)
        uᵢ = view(U,:,i)
        Htmp = kdot(m, vᵢ, q)
        kaxpy!(m, -Htmp, vᵢ, q)
        H[i,j] += Htmp
        Ftmp = kdot(n, uᵢ, p)
        kaxpy!(n, -Ftmp, uᵢ, p)
        F[i,j] += Ftmp
      end
    end
    H[j+1,j] = knorm(m, q)
    if H[j+1,j] == 0
      !allow_breakdown && error("Exact breakdown Hᵢ₊₁.ᵢ == 0 at iteration i = $j.")
      kfill!(vⱼ₊₁, zero(FC))
    else
      kdivcopy!(m, vⱼ₊₁, q, H[j+1,j])
    end
    F[j+1,j] = knorm(n, p)
    if F[j+1,j] == 0
      !allow_breakdown && error("Exact breakdown Fᵢ₊₁.ᵢ == 0 at iteration i = $j.")
      kfill!(uⱼ₊₁, zero(FC))
    else
      kdivcopy!(n, uⱼ₊₁, p, F[j+1,j])
    end
  end
  return V, β, H, U, γ, F
end

@testset "allocations" begin

  for FC in (Float32, Float64, ComplexF32, ComplexF64)
    @testset "Data Type: $FC" begin

      A   = FC.(get_div_grad(18, 18, 18))  # Dimension m x n
      m,n = size(A)
      p   = 5
      k   = div(n, 2)
      Au  = A[1:k,:]          # Dimension k x n
      Ao  = A[:,1:k]          # Dimension m x k
      b   = Ao * ones(FC, k)  # Dimension m
      c   = Au * ones(FC, n)  # Dimension k
      B   = A * Matrix{FC}(I, m, p)  # Dimension m × p
      mem = 100

      T = real(FC)
      shifts = T[1; 2; 3; 4; 5]
      nshifts = 5
      nbits_FC = sizeof(FC)  # 8 bits for ComplexF32 and 16 bits for ComplexF64
      nbits_T = sizeof(T)    # 4 bits for Float32 and 8 bits for Float64

      @testset "SYMMLQ" begin
        # SYMMLQ needs:
        # 5 n-vectors: x, Mvold, Mv, Mv_next, w̅
        storage_symmlq_bytes(n) = nbits_FC * 5 * n

        expected_symmlq_bytes = storage_symmlq_bytes(n)
        symmlq(A, b)  # warmup
        actual_symmlq_bytes = @allocated symmlq(A, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_symmlq_bytes ≤ actual_symmlq_bytes ≤ 1.02 * expected_symmlq_bytes
        end

        workspace = SymmlqWorkspace(A, b)
        symmlq!(workspace, A, b)  # warmup
        inplace_symmlq_bytes = @allocated symmlq!(workspace, A, b)
        @test inplace_symmlq_bytes == 0
      end

      @testset "CG" begin
        # CG needs:
        # 4 n-vectors: x, r, p, Ap
        storage_cg_bytes(n) = nbits_FC * 4 * n

        expected_cg_bytes = storage_cg_bytes(n)
        cg(A, b)  # warmup
        actual_cg_bytes = @allocated cg(A, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_cg_bytes ≤ actual_cg_bytes ≤ 1.02 * expected_cg_bytes
        end

        workspace = CgWorkspace(A, b)
        cg!(workspace, A, b)  # warmup
        inplace_cg_bytes = @allocated cg!(workspace, A, b)
        @test inplace_cg_bytes == 0
      end

      @testset "CG-LANCZOS" begin
        # CG-LANCZOS needs:
        # 5 n-vectors: x, Mv, Mv_prev, p, Mv_next
        storage_cg_lanczos_bytes(n) = nbits_FC * 5 * n

        expected_cg_lanczos_bytes = storage_cg_lanczos_bytes(n)
        cg_lanczos(A, b)  # warmup
        actual_cg_lanczos_bytes = @allocated cg_lanczos(A, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_cg_lanczos_bytes ≤ actual_cg_lanczos_bytes ≤ 1.02 * expected_cg_lanczos_bytes
        end

        workspace = CgLanczosWorkspace(A, b)
        cg_lanczos!(workspace, A, b)  # warmup
        inplace_cg_lanczos_bytes = @allocated cg_lanczos!(workspace, A, b)
        @test inplace_cg_lanczos_bytes == 0
      end

      @testset "CG-LANCZOS-SHIFT" begin
        # CG-LANCZOS-SHIFT needs:
        # - 3 n-vectors: Mv, Mv_prev, Mv_next
        # - 2 (n*nshifts)-matrices: x, p
        # - 5 nshifts-vectors: σ, δhat, ω, γ, rNorms
        # - 3 nshifts-bitVector: indefinite, converged, not_cv
        storage_cg_lanczos_shift_bytes(n, nshifts) = nbits_FC * ((3 * n) + (2 * n * nshifts)) + nbits_T * (5 * nshifts) + (3 * nshifts)
        expected_cg_lanczos_shift_bytes = storage_cg_lanczos_shift_bytes(n, nshifts)
        cg_lanczos_shift(A, b, shifts)  # warmup
        actual_cg_lanczos_shift_bytes = @allocated cg_lanczos_shift(A, b, shifts)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_cg_lanczos_shift_bytes ≤ actual_cg_lanczos_shift_bytes ≤ 1.02 * expected_cg_lanczos_shift_bytes
        end

        workspace = CgLanczosShiftWorkspace(A, b, nshifts)
        cg_lanczos_shift!(workspace, A, b, shifts)  # warmup
        inplace_cg_lanczos_shift_bytes = @allocated cg_lanczos_shift!(workspace, A, b, shifts)
        @test inplace_cg_lanczos_shift_bytes == 0
      end

      @testset "CR" begin
        # CR needs:
        # 5 n-vectors: x, r, p, q, Ar
        storage_cr_bytes(n) = nbits_FC * 5 * n

        expected_cr_bytes = storage_cr_bytes(n)
        cr(A, b)  # warmup
        actual_cr_bytes = @allocated cr(A, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_cr_bytes ≤ actual_cr_bytes ≤ 1.02 * expected_cr_bytes
        end

        workspace = CrWorkspace(A, b)
        cr!(workspace, A, b)  # warmup
        inplace_cr_bytes = @allocated cr!(workspace, A, b)
        @test inplace_cr_bytes == 0
      end

      @testset "CAR" begin
        # CAR needs:
        # 7 n-vectors: x, r, p, s, q, t, u
        storage_car_bytes(n) = nbits_FC * 7 * n

        expected_car_bytes = storage_car_bytes(n)
        car(A, b)  # warmup
        actual_car_bytes = @allocated car(A, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_car_bytes ≤ actual_car_bytes ≤ 1.02 * expected_car_bytes
        end

        workspace = CarWorkspace(A, b)
        car!(workspace, A, b)  # warmup
        inplace_car_bytes = @allocated car!(workspace, A, b)
        @test inplace_car_bytes == 0
      end

      @testset "MINRES" begin
        # MINRES needs:
        # 6 n-vectors: x, r1, r2, w1, w2, y
        storage_minres_bytes(n) = nbits_FC * 6 * n

        expected_minres_bytes = storage_minres_bytes(n)
        minres(A, b)  # warmup
        actual_minres_bytes = @allocated minres(A, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_minres_bytes ≤ actual_minres_bytes ≤ 1.02 * expected_minres_bytes
        end

        workspace = MinresWorkspace(A, b)
        minres!(workspace, A, b)  # warmup
        inplace_minres_bytes = @allocated minres!(workspace, A, b)
        @test inplace_minres_bytes == 0
      end

      @testset "MINRES-QLP" begin
        # MINRES-QLP needs:
        # - 6 n-vectors: wₖ₋₁, wₖ, vₖ₋₁, vₖ, x, p
        storage_minres_qlp_bytes(n) = nbits_FC * 6 * n

        expected_minres_qlp_bytes = storage_minres_qlp_bytes(n)
        minres_qlp(A, b)  # warmup
        actual_minres_qlp_bytes = @allocated minres_qlp(A, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_minres_qlp_bytes ≤ actual_minres_qlp_bytes ≤ 1.02 * expected_minres_qlp_bytes
        end

        workspace = MinresQlpWorkspace(A, b)
        minres_qlp!(workspace, A, b)  # warmup
        inplace_minres_qlp_bytes = @allocated minres_qlp!(workspace, A, b)
        @test inplace_minres_qlp_bytes == 0
      end

      @testset "MINARES" begin
        # MINARES needs:
        # 8 n-vectors: vₖ, vₖ₊₁, x, wₖ₋₂, wₖ₋₁, dₖ₋₂, dₖ₋₁, q
        storage_minares_bytes(n) = nbits_FC * 8 * n

        expected_minares_bytes = storage_minares_bytes(n)
        minares(A, b)  # warmup
        actual_minares_bytes = @allocated minares(A, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_minares_bytes ≤ actual_minares_bytes ≤ 1.02 * expected_minares_bytes
        end

        workspace = MinaresWorkspace(A, b)
        minares!(workspace, A, b)  # warmup
        inplace_minares_bytes = @allocated minares!(workspace, A, b)
        @test inplace_minares_bytes == 0
      end

      @testset "DIOM" begin
        # DIOM needs:
        # - 2 n-vectors: x, t
        # - 1 (n*mem)-matrix: V
        # - 1 n*(mem-1)-matrix: P
        # - 1 (mem-1)-vector: L
        # - 1 mem-vector: H
        storage_diom_bytes(mem, n) = nbits_FC * ((2 * n) + (n * mem) + (n * (mem-1)) + (mem-1) + (mem))

        expected_diom_bytes = storage_diom_bytes(mem, n)
        diom(A, b; memory=mem)  # warmup
        actual_diom_bytes = @allocated diom(A, b; memory=mem)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_diom_bytes ≤ actual_diom_bytes ≤ 1.02 * expected_diom_bytes
        end

        workspace = DiomWorkspace(A, b; memory=mem)
        diom!(workspace, A, b)  # warmup
        inplace_diom_bytes = @allocated diom!(workspace, A, b)
        @test inplace_diom_bytes == 0
      end

      @testset "FOM" begin
        # FOM needs:
        # - 2 n-vectors: x, w
        # - 1 (n*mem)-matrix: V
        # - 2 mem-vectors: l, z
        # - 1 (mem*(mem+1)/2)-vector: U
        storage_fom_bytes(mem, n) = nbits_FC * ((2 * n) + (n * mem) + (2 * mem) + (mem * (mem+1) / 2))

        expected_fom_bytes = storage_fom_bytes(mem, n)
        fom(A, b; memory=mem)  # warmup
        actual_fom_bytes = @allocated fom(A, b; memory=mem)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_fom_bytes ≤ actual_fom_bytes ≤ 1.02 * expected_fom_bytes
        end

        workspace = FomWorkspace(A, b; memory=mem)
        fom!(workspace, A, b)  # warmup
        inplace_fom_bytes = @allocated fom!(workspace, A, b)
        @test inplace_fom_bytes == 0
      end

      @testset "DQGMRES" begin
        # DQGMRES needs:
        # - 2 n-vectors: x, t
        # - 2 (n*mem)-matrices: P, V
        # - 2 mem-vectors: c, s
        # - 1 (mem+1)-vector: H
        storage_dqgmres_bytes(mem, n) = nbits_FC * ((2 * n) + (2 * n * mem) + mem + (mem + 1)) + nbits_T * mem

        expected_dqgmres_bytes = storage_dqgmres_bytes(mem, n)
        dqgmres(A, b; memory=mem)  # warmup
        actual_dqgmres_bytes = @allocated dqgmres(A, b; memory=mem)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_dqgmres_bytes ≤ actual_dqgmres_bytes ≤ 1.02 * expected_dqgmres_bytes
        end

        workspace = DqgmresWorkspace(A, b; memory=mem)
        dqgmres!(workspace, A, b)  # warmup
        inplace_dqgmres_bytes = @allocated dqgmres!(workspace, A, b)
        @test inplace_dqgmres_bytes == 0
      end

      @testset "GMRES" begin
        # GMRES needs:
        # - 2 n-vectors: x, w
        # - 1 n*(mem)-matrix: V
        # - 3 mem-vectors: c, s, z
        # - 1 (mem*(mem+1)/2)-vector: R
        storage_gmres_bytes(mem, n) = nbits_FC * ((2 * n) + (n * mem) + (2 * mem) + (mem * (mem+1) / 2)) + nbits_T * mem

        expected_gmres_bytes = storage_gmres_bytes(mem, n)
        gmres(A, b; memory=mem)  # warmup
        actual_gmres_bytes = @allocated gmres(A, b; memory=mem)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_gmres_bytes ≤ actual_gmres_bytes ≤ 1.02 * expected_gmres_bytes
        end

        workspace = GmresWorkspace(A, b; memory=mem)
        gmres!(workspace, A, b)  # warmup
        inplace_gmres_bytes = @allocated gmres!(workspace, A, b)
        @test inplace_gmres_bytes == 0
      end

      @testset "FGMRES" begin
        # FGMRES needs:
        # - 2 n-vectors: x, w
        # - 2 n*(mem)-matrix: V, Z
        # - 3 mem-vectors: c, s, z
        # - 1 (mem*(mem+1)/2)-vector: R
        storage_fgmres_bytes(mem, n) = nbits_FC * ((2 * n) + (2 * n * mem) + (2 * mem) + (mem * (mem+1) / 2)) + nbits_T * mem

        expected_fgmres_bytes = storage_fgmres_bytes(mem, n)
        fgmres(A, b; memory=mem)  # warmup
        actual_fgmres_bytes = @allocated fgmres(A, b; memory=mem)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_fgmres_bytes ≤ actual_fgmres_bytes ≤ 1.02 * expected_fgmres_bytes
        end

        workspace = FgmresWorkspace(A, b; memory=mem)
        fgmres!(workspace, A, b)  # warmup
        inplace_fgmres_bytes = @allocated fgmres!(workspace, A, b)
        @test inplace_fgmres_bytes == 0
      end

      @testset "CGS" begin
        # CGS needs:
        # 6 n-vectors: x, r, u, p, q, ts
        storage_cgs_bytes(n) = nbits_FC * 6 * n

        expected_cgs_bytes = storage_cgs_bytes(n)
        cgs(A, b)  # warmup
        actual_cgs_bytes = @allocated cgs(A, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_cgs_bytes ≤ actual_cgs_bytes ≤ 1.02 * expected_cgs_bytes
        end

        workspace = CgsWorkspace(A, b)
        cgs!(workspace, A, b)  # warmup
        inplace_cgs_bytes = @allocated cgs!(workspace, A, b)
        @test inplace_cgs_bytes == 0
      end

      @testset "BICGSTAB" begin
        # BICGSTAB needs:
        # 6 n-vectors: x, r, p, v, s, qd
        storage_bicgstab_bytes(n) = nbits_FC * 6 * n

        expected_bicgstab_bytes = storage_bicgstab_bytes(n)
        bicgstab(A, b)  # warmup
        actual_bicgstab_bytes = @allocated bicgstab(A, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_bicgstab_bytes ≤ actual_bicgstab_bytes ≤ 1.02 * expected_bicgstab_bytes
        end

        workspace = BicgstabWorkspace(A, b)
        bicgstab!(workspace, A, b)  # warmup
        inplace_bicgstab_bytes = @allocated bicgstab!(workspace, A, b)
        @test inplace_bicgstab_bytes == 0
      end

      @testset "CGNE" begin
        # CGNE needs:
        # - 3 n-vectors: x, p, Aᴴz
        # - 2 m-vectors: r, q
        storage_cgne_bytes(m, n) = nbits_FC * (3 * n + 2 * m)

        expected_cgne_bytes = storage_cgne_bytes(k, n)
        (x, stats) = cgne(Au, c)  # warmup
        actual_cgne_bytes = @allocated cgne(Au, c)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_cgne_bytes ≤ actual_cgne_bytes ≤ 1.02 * expected_cgne_bytes
        end

        workspace = CgneWorkspace(Au, c)
        cgne!(workspace, Au, c)  # warmup
        inplace_cgne_bytes = @allocated cgne!(workspace, Au, c)
        @test inplace_cgne_bytes == 0
      end

      @testset "CRMR" begin
        # CRMR needs:
        # - 3 n-vectors: x, p, Aᴴr
        # - 2 m-vectors: r, q
        storage_crmr_bytes(m, n) = nbits_FC * (3 * n + 2 * m)

        expected_crmr_bytes = storage_crmr_bytes(k, n)
        (x, stats) = crmr(Au, c)  # warmup
        actual_crmr_bytes = @allocated crmr(Au, c)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_crmr_bytes ≤ actual_crmr_bytes ≤ 1.02 * expected_crmr_bytes
        end

        workspace = CrmrWorkspace(Au, c)
        crmr!(workspace, Au, c)  # warmup
        inplace_crmr_bytes = @allocated crmr!(workspace, Au, c)
        @test inplace_crmr_bytes == 0
      end

      @testset "LNLQ" begin
        # LNLQ needs:
        # - 3 n-vectors: x, v, Aᴴu
        # - 4 m-vectors: y, w̄, u, Av
        storage_lnlq_bytes(m, n) = nbits_FC * (3 * n + 4 * m)

        expected_lnlq_bytes = storage_lnlq_bytes(k, n)
        lnlq(Au, c)  # warmup
        actual_lnlq_bytes = @allocated lnlq(Au, c)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_lnlq_bytes ≤ actual_lnlq_bytes ≤ 1.02 * expected_lnlq_bytes
        end

        workspace = LnlqWorkspace(Au, c)
        lnlq!(workspace, Au, c)  # warmup
        inplace_lnlq_bytes = @allocated lnlq!(workspace, Au, c)
        @test inplace_lnlq_bytes == 0
      end

      @testset "CRAIG" begin
        # CRAIG needs:
        # - 3 n-vectors: x, v, Aᴴu
        # - 4 m-vectors: y, w, u, Av
        storage_craig_bytes(m, n) = nbits_FC * (3 * n + 4 * m)

        expected_craig_bytes = storage_craig_bytes(k, n)
        craig(Au, c)  # warmup
        actual_craig_bytes = @allocated craig(Au, c)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_craig_bytes ≤ actual_craig_bytes ≤ 1.02 * expected_craig_bytes
        end

        workspace = CraigWorkspace(Au, c)
        craig!(workspace, Au, c)  # warmup
        inplace_craig_bytes = @allocated craig!(workspace, Au, c)
        @test inplace_craig_bytes == 0
      end

      @testset "CRAIGMR" begin
        # CRAIGMR needs:
        # - 4 n-vectors: x, v, Aᴴu, d
        # - 5 m-vectors: y, u, w, wbar, Av
        storage_craigmr_bytes(m, n) = nbits_FC * (4 * n + 5 * m)

        expected_craigmr_bytes = storage_craigmr_bytes(k, n)
        craigmr(Au, c)  # warmup
        actual_craigmr_bytes = @allocated craigmr(Au, c)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_craigmr_bytes ≤ actual_craigmr_bytes ≤ 1.02 * expected_craigmr_bytes
        end

        workspace = CraigmrWorkspace(Au, c)
        craigmr!(workspace, Au, c)  # warmup
        inplace_craigmr_bytes = @allocated craigmr!(workspace, Au, c)
        @test inplace_craigmr_bytes == 0
      end

      @testset "CGLS" begin
        # CGLS needs:
        # - 3 n-vectors: x, p, s
        # - 2 m-vectors: r, q
        storage_cgls_bytes(m, n) = nbits_FC * (3 * n + 2 * m)

        expected_cgls_bytes = storage_cgls_bytes(m, k)
        (x, stats) = cgls(Ao, b)  # warmup
        actual_cgls_bytes = @allocated cgls(Ao, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_cgls_bytes ≤ actual_cgls_bytes ≤ 1.02 * expected_cgls_bytes
        end

        workspace = CglsWorkspace(Ao, b)
        cgls!(workspace, Ao, b)  # warmup
        inplace_cgls_bytes = @allocated cgls!(workspace, Ao, b)
        @test inplace_cgls_bytes == 0
      end

      @testset "CGLS-LANCZOS-SHIFT" begin
        # CGLS-LANCZOS-SHIFT needs:
        # - 1 n-vector: Mv
        # - 3 m-vectors: u_prev, u, u_next
        # - 2 (n*nshifts)-matrices: x, p
        # - 5 nshifts-vectors: σ, δhat, ω, γ, rNorms
        # - 3 nshifts-bitVector: converged, indefinite, not_cv
        storage_cgls_lanczos_shift_bytes(m, n, nshifts) = nbits_FC * (1 * n + 3 * m + 2 * n * nshifts) + nbits_T * (5 * nshifts) + (3 * nshifts)

        expected_cgls_lanczos_shift_bytes = storage_cgls_lanczos_shift_bytes(m, k, nshifts)
        (x, stats) = cgls_lanczos_shift(Ao, b, shifts)  # warmup
        actual_cgls_lanczos_shift_bytes = @allocated cgls_lanczos_shift(Ao, b, shifts)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_cgls_lanczos_shift_bytes ≤ actual_cgls_lanczos_shift_bytes ≤ 1.02 * expected_cgls_lanczos_shift_bytes
        end

        workspace = CglsLanczosShiftWorkspace(Ao, b, nshifts)
        cgls_lanczos_shift!(workspace, Ao, b, shifts)  # warmup
        inplace_cgls_lanczos_shift_bytes = @allocated cgls_lanczos_shift!(workspace, Ao, b, shifts)
        @test inplace_cgls_lanczos_shift_bytes == 0
      end

      @testset "LSLQ" begin
        # LSLQ needs:
        # - 4 n-vectors: x_lq, v, Aᴴu, w̄ (= x_cg)
        # - 2 m-vectors: u, Av
        storage_lslq_bytes(m, n) = nbits_FC * (4 * n + 2 * m)

        expected_lslq_bytes = storage_lslq_bytes(m, k)
        (x, stats) = lslq(Ao, b)  # warmup
        actual_lslq_bytes = @allocated lslq(Ao, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_lslq_bytes ≤ actual_lslq_bytes ≤ 1.02 * expected_lslq_bytes
        end

        workspace = LslqWorkspace(Ao, b)
        lslq!(workspace, Ao, b)  # warmup
        inplace_lslq_bytes = @allocated lslq!(workspace, Ao, b)
        @test inplace_lslq_bytes == 0
      end

      @testset "CRLS" begin
        # CRLS needs:
        # - 4 n-vectors: x, p, Ar, q
        # - 3 m-vectors: r, Ap, s
        storage_crls_bytes(m, n) = nbits_FC * (4 * n + 3 * m)

        expected_crls_bytes = storage_crls_bytes(m, k)
        (x, stats) = crls(Ao, b)  # warmup
        actual_crls_bytes = @allocated crls(Ao, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_crls_bytes ≤ actual_crls_bytes ≤ 1.02 * expected_crls_bytes
        end

        workspace = CrlsWorkspace(Ao, b)
        crls!(workspace, Ao, b)  # warmup
        inplace_crls_bytes = @allocated crls!(workspace, Ao, b)
        @test inplace_crls_bytes == 0
      end

      @testset "LSQR" begin
        # LSQR needs:
        # - 4 n-vectors: x, v, w, Aᴴu
        # - 2 m-vectors: u, Av
        storage_lsqr_bytes(m, n) = nbits_FC * (4 * n + 2 * m)

        expected_lsqr_bytes = storage_lsqr_bytes(m, k)
        (x, stats) = lsqr(Ao, b)  # warmup
        actual_lsqr_bytes = @allocated lsqr(Ao, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_lsqr_bytes ≤ actual_lsqr_bytes ≤ 1.02 * expected_lsqr_bytes
        end

        workspace = LsqrWorkspace(Ao, b)
        lsqr!(workspace, Ao, b)  # warmup
        inplace_lsqr_bytes = @allocated lsqr!(workspace, Ao, b)
        @test inplace_lsqr_bytes == 0
      end

      @testset "LSMR" begin
        # LSMR needs:
        # - 5 n-vectors: x, v, h, hbar, Aᴴu
        # - 2 m-vectors: u, Av
        storage_lsmr_bytes(m, n) = nbits_FC * (5 * n + 2 * m)

        expected_lsmr_bytes = storage_lsmr_bytes(m, k)
        (x, stats) = lsmr(Ao, b)  # warmup
        actual_lsmr_bytes = @allocated lsmr(Ao, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_lsmr_bytes ≤ actual_lsmr_bytes ≤ 1.02 * expected_lsmr_bytes
        end

        workspace = LsmrWorkspace(Ao, b)
        lsmr!(workspace, Ao, b)  # warmup
        inplace_lsmr_bytes = @allocated lsmr!(workspace, Ao, b)
        @test inplace_lsmr_bytes == 0
      end

      @testset "BiLQ" begin
        # BILQ needs:
        # - 8 n-vectors: uₖ₋₁, uₖ, vₖ₋₁, vₖ, x, d̅, p, q
        storage_bilq_bytes(n) = nbits_FC * 8 * n

        expected_bilq_bytes = storage_bilq_bytes(n)
        bilq(A, b)  # warmup
        actual_bilq_bytes = @allocated bilq(A, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_bilq_bytes ≤ actual_bilq_bytes ≤ 1.02 * expected_bilq_bytes
        end

        workspace = BilqWorkspace(A, b)
        bilq!(workspace, A, b)  # warmup
        inplace_bilq_bytes = @allocated bilq!(workspace, A, b)
        @test inplace_bilq_bytes == 0
      end

      @testset "QMR" begin
        # QMR needs:
        # - 9 n-vectors: uₖ₋₁, uₖ, vₖ₋₁, vₖ, x, wₖ₋₁, wₖ, p, q
        storage_qmr_bytes(n) = nbits_FC * 9 * n

        expected_qmr_bytes = storage_qmr_bytes(n)
        qmr(A, b)  # warmup
        actual_qmr_bytes = @allocated qmr(A, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_qmr_bytes ≤ actual_qmr_bytes ≤ 1.02 * expected_qmr_bytes
        end

        workspace = QmrWorkspace(A, b)
        qmr!(workspace, A, b)  # warmup
        inplace_qmr_bytes = @allocated qmr!(workspace, A, b)
        @test inplace_qmr_bytes == 0
      end

      @testset "BiLQR" begin
        # BILQR needs:
        # - 11 n-vectors: uₖ₋₁, uₖ, vₖ₋₁, vₖ, x, t, d̅, wₖ₋₁, wₖ, p, q
        storage_bilqr_bytes(n) = nbits_FC * 11 * n

        expected_bilqr_bytes = storage_bilqr_bytes(n)
        bilqr(A, b, b)  # warmup
        actual_bilqr_bytes = @allocated bilqr(A, b, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_bilqr_bytes ≤ actual_bilqr_bytes ≤ 1.02 * expected_bilqr_bytes
        end

        workspace = BilqrWorkspace(A, b)
        bilqr!(workspace, A, b, b)  # warmup
        inplace_bilqr_bytes = @allocated bilqr!(workspace, A, b, b)
        @test inplace_bilqr_bytes == 0
      end

      @testset "USYMLQ" begin
        # USYMLQ needs:
        # - 5 n-vectors: uₖ₋₁, uₖ, x, d̅, p
        # - 3 m-vectors: vₖ₋₁, vₖ, q
        storage_usymlq_bytes(m, n) = nbits_FC * (5 * n + 3 * m)

        expected_usymlq_bytes = storage_usymlq_bytes(k, n)
        usymlq(Au, c, b)  # warmup
        actual_usymlq_bytes = @allocated usymlq(Au, c, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_usymlq_bytes ≤ actual_usymlq_bytes ≤ 1.02 * expected_usymlq_bytes
        end

        workspace = UsymlqWorkspace(Au, c)
        usymlq!(workspace, Au, c, b)  # warmup
        inplace_usymlq_bytes = @allocated usymlq!(workspace, Au, c, b)
        @test inplace_usymlq_bytes == 0
      end

      @testset "USYMQR" begin
        # USYMQR needs:
        # - 6 n-vectors: vₖ₋₁, vₖ, x, wₖ₋₁, wₖ, p
        # - 3 m-vectors: uₖ₋₁, uₖ, q
        storage_usymqr_bytes(m, n) = nbits_FC * (6 * n + 3 * m)

        expected_usymqr_bytes = storage_usymqr_bytes(m, k)
        (x, stats) = usymqr(Ao, b, c) # warmup
        actual_usymqr_bytes = @allocated usymqr(Ao, b, c)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_usymqr_bytes ≤ actual_usymqr_bytes ≤ 1.02 * expected_usymqr_bytes
        end

        workspace = UsymqrWorkspace(Ao, b)
        usymqr!(workspace, Ao, b, c)  # warmup
        inplace_usymqr_bytes = @allocated usymqr!(workspace, Ao, b, c)
        @test inplace_usymqr_bytes == 0
      end

      @testset "TriLQR" begin
        # TRILQR needs:
        # - 6 m-vectors: vₖ₋₁, vₖ, t, wₖ₋₁, wₖ, q
        # - 5 n-vectors: uₖ₋₁, uₖ, x, d̅, p
        storage_trilqr_bytes(m, n) = nbits_FC * (6 * m + 5 * n)

        expected_trilqr_bytes = storage_trilqr_bytes(n, n)
        trilqr(A, b, b)  # warmup
        actual_trilqr_bytes = @allocated trilqr(A, b, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_trilqr_bytes ≤ actual_trilqr_bytes ≤ 1.02 * expected_trilqr_bytes
        end

        workspace = TrilqrWorkspace(A, b)
        trilqr!(workspace, A, b, b)  # warmup
        inplace_trilqr_bytes = @allocated trilqr!(workspace, A, b, b)
        @test inplace_trilqr_bytes == 0
      end

      @testset "TriCG" begin
        # TriCG needs:
        # - 6 n-vectors: yₖ, uₖ₋₁, uₖ, gy₂ₖ₋₁, gy₂ₖ, p
        # - 6 m-vectors: xₖ, vₖ₋₁, vₖ, gx₂ₖ₋₁, gx₂ₖ, q
        storage_tricg_bytes(m, n) = nbits_FC * (6 * n + 6 * m)

        expected_tricg_bytes = storage_tricg_bytes(k, n)
        tricg(Au, c, b)  # warmup
        actual_tricg_bytes = @allocated tricg(Au, c, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_tricg_bytes ≤ actual_tricg_bytes ≤ 1.02 * expected_tricg_bytes
        end

        workspace = TricgWorkspace(Au, c)
        tricg!(workspace, Au, c, b)  # warmup
        inplace_tricg_bytes = @allocated tricg!(workspace, Au, c, b)
        @test inplace_tricg_bytes == 0
      end

      @testset "TriMR" begin
        # TriMR needs:
        # - 8 n-vectors: yₖ, uₖ₋₁, uₖ, gy₂ₖ₋₃, gy₂ₖ₋₂, gy₂ₖ₋₁, gy₂ₖ, p
        # - 8 m-vectors: xₖ, vₖ₋₁, vₖ, gx₂ₖ₋₃, gx₂ₖ₋₂, gx₂ₖ₋₁, gx₂ₖ, q
        storage_trimr_bytes(m, n) = nbits_FC * (8 * n + 8 * m)

        expected_trimr_bytes = storage_trimr_bytes(k, n)
        trimr(Au, c, b)  # warmup
        actual_trimr_bytes = @allocated trimr(Au, c, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_trimr_bytes ≤ actual_trimr_bytes ≤ 1.02 * expected_trimr_bytes
        end

        workspace = TrimrWorkspace(Au, c)
        trimr!(workspace, Au, c, b)  # warmup
        inplace_trimr_bytes = @allocated trimr!(workspace, Au, c, b)
        @test inplace_trimr_bytes == 0
      end

      @testset "USYMLQR" begin
        # USYMLQR needs:
        # - 7 n-vectors: y, z, N⁻¹uₖ₋₁, N⁻¹uₖ, p, wₖ₋₂, wₖ₋₁
        # - 6 m-vectors: x, r, M⁻¹vₖ₋₁, M⁻¹vₖ, q, d̅
        storage_usymlqr(m, n) = 7 * n + 6 * m
        storage_usymlqr_bytes(m, n) = nbits_FC * storage_usymlqr(m, n)

        expected_usymlqr_bytes = storage_usymlqr_bytes(k, n)
        usymlqr(Au, c, b)  # warmup
        actual_usymlqr_bytes = @allocated usymlqr(Au, c, b)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_usymlqr_bytes ≤ actual_usymlqr_bytes ≤ 1.02 * expected_usymlqr_bytes
        end

        workspace = UsymlqrWorkspace(Au, c)
        usymlqr!(workspace, Au, c, b)  # warmup
        inplace_usymlqr_bytes = @allocated usymlqr!(workspace, Au, c, b)
        @test inplace_usymlqr_bytes == 0
      end

      @testset "GPMR" begin
        # GPMR needs:
        # - 2 m-vectors: x, q
        # - 2 n-vectors: y, p
        # - 1 (m*mem)-matrix: V
        # - 1 (n*mem)-matrix: U
        # - 1 (2*mem)-vector: zt
        # - 2 (4*mem)-vectors: gc, gs
        # - 1 (mem*(2mem+1))-vector: R
        storage_gpmr_bytes(mem, m, n) = nbits_FC * ((mem + 2) * (n + m) + mem * (2 * mem + 7)) + nbits_T * 4 * mem

        expected_gpmr_bytes = storage_gpmr_bytes(mem, m, k)
        gpmr(Ao, Au, b, c; memory=mem, itmax=mem)  # warmup
        actual_gpmr_bytes = @allocated gpmr(Ao, Au, b, c; memory=mem, itmax=mem)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_gpmr_bytes ≤ actual_gpmr_bytes ≤ 1.02 * expected_gpmr_bytes
        end

        workspace = GpmrWorkspace(Ao, b; memory=mem)
        gpmr!(workspace, Ao, Au, b, c)  # warmup
        inplace_gpmr_bytes = @allocated gpmr!(workspace, Ao, Au, b, c)
        @test inplace_gpmr_bytes == 0
      end

      @testset "BLOCK-GMRES" begin
        # BLOCK-GMRES needs:
        # - 2 (n*p)-matrices: X, W
        # - 1 (p*p)-matrix: C
        # - 1 (2p*p)-matrix: D
        # - mem p-vectors: τ
        # - mem (n*p)-matrices: V
        # - mem (p*p)-matrices: Z
        # - mem*(mem+1)/2 (p*p)-matrices: R
        # - mem (2p*p)-matrices: H
        # - lwork-vector: buffer
        function storage_block_gmres_bytes(mem, n, p)
          res = (2*n*p + p*p + 2p*p + mem*p + mem*n*p + mem*p*p + (mem*(mem+1)÷2)*p*p + mem*2p*p)
          return nbits_FC * res
        end

        workspace = BlockGmresWorkspace(A, B; memory=mem)
        block_gmres!(workspace, A, B)  # warmup
        inplace_block_gmres_bytes = @allocated block_gmres!(workspace, A, B)
        @test inplace_block_gmres_bytes == 0

        expected_block_gmres_bytes = storage_block_gmres_bytes(mem, n, p) + sizeof(workspace.buffer)
        block_gmres(A, B; memory=mem, itmax=mem)  # warmup
        actual_block_gmres_bytes = @allocated block_gmres(A, B; memory=mem, itmax=mem)
        if VERSION < v"1.11.5" || !Sys.isapple()
          @test expected_block_gmres_bytes ≤ actual_block_gmres_bytes ≤ 1.05 * expected_block_gmres_bytes
        end
      end

      @testset "BLOCK-MINRES" begin
        # BLOCK-MINRES needs:
        # - 2 (n*p)-matrices: X, W
        # - 1 (p*p)-matrix: C
        # - 1 (2p*p)-matrix: D
        # - mem p-vectors: τ
        # - mem (n*p)-matrices: V
        # - mem (p*p)-matrices: Z
        # - mem*(mem+1)/2 (p*p)-matrices: R
        # - mem (2p*p)-matrices: H
        # - lwork-vector: buffer
        function storage_block_minres_bytes(mem, n, p)
          res = (2*n*p + p*p + 2p*p + mem*p + mem*n*p + mem*p*p + (mem*(mem+1)÷2)*p*p + mem*2p*p)
          return nbits_FC * res
        end

        workspace = BlockMinresWorkspace(A, B)
        block_minres!(workspace, A, B)  # warmup
        inplace_block_minres_bytes = @allocated block_minres!(workspace, A, B)
        @test inplace_block_minres_bytes == 0

        expected_block_minres_bytes = storage_block_minres_bytes(mem, n, p) + sizeof(workspace.buffer)
        block_minres(A, B)  # warmup
        # actual_block_minres_bytes = @allocated block_minres(A, B)
        # if VERSION < v"1.11.5" || !Sys.isapple()
        #   @test expected_block_minres_bytes ≤ actual_block_minres_bytes ≤ 1.05 * expected_block_minres_bytes
        # end
      end
    end
  end
end

# An implementation of BiLQ for the solution of unsymmetric
# and square consistent linear system Ax = b.
#
# This method is described in
#
# A. Montoison and D. Orban
# BiLQ: An Iterative Method for Nonsymmetric Linear Systems with a Quasi-Minimum Error Property.
# SIAM Journal on Matrix Analysis and Applications, 41(3), pp. 1145--1166, 2020.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Montreal, February 2019.

export bilq, bilq!

"""
    (x, stats) = bilq(A, b::AbstractVector{FC};
                      c::AbstractVector{FC}=b, transfer_to_bicg::Bool=true,
                      M=I, N=I, ldiv::Bool=false, atol::T=√eps(T),
                      rtol::T=√eps(T), itmax::Int=0, timemax::Float64=Inf,
                      verbose::Int=0, history::Bool=false,
                      callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = bilq(A, b, x0::AbstractVector; kwargs...)

BiLQ can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above.

Solve the square linear system Ax = b of size n using BiLQ.
BiLQ is based on the Lanczos biorthogonalization process and requires two initial vectors `b` and `c`.
The relation `bᴴc ≠ 0` must be satisfied and by default `c = b`.
When `A` is Hermitian and `b = c`, BiLQ is equivalent to SYMMLQ.
BiLQ requires support for `adjoint(M)` and `adjoint(N)` if preconditioners are provided.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :bilq`.

For an in-place variant that reuses memory across solves, see [`bilq!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `n`;
* `b`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `c`: the second initial vector of length `n` required by the Lanczos biorthogonalization process;
* `transfer_to_bicg`: transfer from the BiLQ point to the BiCG point, when it exists. The transfer is based on the residual norm;
* `M`: linear operator that models a nonsingular matrix of size `n` used for left preconditioning;
* `N`: linear operator that models a nonsingular matrix of size `n` used for right preconditioning;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### References

* A. Montoison and D. Orban, [*BiLQ: An Iterative Method for Nonsymmetric Linear Systems with a Quasi-Minimum Error Property*](https://doi.org/10.1137/19M1290991), SIAM Journal on Matrix Analysis and Applications, 41(3), pp. 1145--1166, 2020.
* R. Fletcher, [*Conjugate gradient methods for indefinite systems*](https://doi.org/10.1007/BFb0080116), Numerical Analysis, Springer, pp. 73--89, 1976.
"""
function bilq end

"""
    workspace = bilq!(workspace::BilqWorkspace, A, b; kwargs...)
    workspace = bilq!(workspace::BilqWorkspace, A, b, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`bilq`](@ref).

See [`BilqWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :bilq` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function bilq! end

def_args_bilq = (:(A                    ),
                 :(b::AbstractVector{FC}))

def_optargs_bilq = (:(x0::AbstractVector),)

def_kwargs_bilq = (:(; c::AbstractVector{FC} = b    ),
                   :(; transfer_to_bicg::Bool = true),
                   :(; M = I                        ),
                   :(; N = I                        ),
                   :(; ldiv::Bool = false           ),
                   :(; atol::T = √eps(T)            ),
                   :(; rtol::T = √eps(T)            ),
                   :(; itmax::Int = 0               ),
                   :(; timemax::Float64 = Inf       ),
                   :(; verbose::Int = 0             ),
                   :(; history::Bool = false        ),
                   :(; callback = workspace -> false),
                   :(; iostream::IO = kstdout       ))

def_kwargs_bilq = extract_parameters.(def_kwargs_bilq)

args_bilq = (:A, :b)
optargs_bilq = (:x0,)
kwargs_bilq = (:c, :transfer_to_bicg, :M, :N, :ldiv, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function bilq!(workspace :: BilqWorkspace{T,FC,S}, $(def_args_bilq...); $(def_kwargs_bilq...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("System must be square")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "BILQ: system of size %d\n", n)

    # Check M = Iₙ and N = Iₙ
    MisI = (M === I)
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")
    ktypeof(c) == S || error("ktypeof(c) must be equal to $S")

    # Compute the adjoint of A, M and N
    Aᴴ = A'
    Mᴴ = M'
    Nᴴ = N'

    # Set up workspace.
    allocate_if(!MisI, workspace, :t, S, workspace.x)  # The length of t is n
    allocate_if(!NisI, workspace, :s, S, workspace.x)  # The length of s is n
    uₖ₋₁, uₖ, q, vₖ₋₁, vₖ = workspace.uₖ₋₁, workspace.uₖ, workspace.q, workspace.vₖ₋₁, workspace.vₖ
    p, Δx, x, d̅, stats = workspace.p, workspace.Δx, workspace.x, workspace.d̅, workspace.stats
    warm_start = workspace.warm_start
    rNorms = stats.residuals
    reset!(stats)
    r₀ = warm_start ? q : b
    Mᴴuₖ = MisI ? uₖ : workspace.t
    t = MisI ? q : workspace.t
    Nvₖ = NisI ? vₖ : workspace.s
    s = NisI ? p : workspace.s

    if warm_start
      kmul!(r₀, A, Δx)
      kaxpby!(n, one(FC), b, -one(FC), r₀)
    end
    if !MisI
      mulorldiv!(workspace.t, M, r₀, ldiv)
      r₀ = workspace.t
    end

    # Initial solution x₀ and residual norm ‖r₀‖.
    kfill!(x, zero(FC))
    bNorm = knorm(n, r₀)  # ‖r₀‖ = ‖b₀ - Ax₀‖

    history && push!(rNorms, bNorm)
    if bNorm == 0
      stats.niter = 0
      stats.solved = true
      stats.inconsistent = false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    iter = 0
    itmax == 0 && (itmax = 2*n)

    # Initialize the Lanczos biorthogonalization process.
    cᴴb = kdot(n, c, r₀)  # ⟨c,r₀⟩
    if cᴴb == 0
      stats.niter = 0
      stats.solved = false
      stats.inconsistent = false
      stats.timer = start_time |> ktimer
      stats.status = "Breakdown bᴴc = 0"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    ε = atol + rtol * bNorm
    (verbose > 0) && @printf(iostream, "%5s  %8s  %7s  %5s\n", "k", "αₖ", "‖rₖ‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %8.1e  %7.1e  %.2fs\n", iter, cᴴb, bNorm, start_time |> ktimer)

    βₖ = √(abs(cᴴb))               # β₁γ₁ = cᴴ(b - Ax₀)
    γₖ = cᴴb / βₖ                  # β₁γ₁ = cᴴ(b - Ax₀)
    kfill!(vₖ₋₁, zero(FC))         # v₀ = 0
    kfill!(uₖ₋₁, zero(FC))         # u₀ = 0
    kdivcopy!(n, vₖ, r₀, βₖ)       # v₁ = (b - Ax₀) / β₁
    kdivcopy!(n, uₖ, c, conj(γₖ))  # u₁ = c / γ̄₁
    cₖ₋₁ = cₖ = -one(T)            # Givens cosines used for the LQ factorization of Tₖ
    sₖ₋₁ = sₖ = zero(FC)           # Givens sines used for the LQ factorization of Tₖ
    kfill!(d̅, zero(FC))            # Last column of D̅ₖ = Vₖ(Qₖ)ᴴ
    ζₖ₋₁ = ζbarₖ = zero(FC)        # ζₖ₋₁ and ζbarₖ are the last components of z̅ₖ = (L̅ₖ)⁻¹β₁e₁
    ηₖ₋₁ = ηₖ = ζₖ₋₂ = zero(FC)    # ηₖ₋₁, ηₖ and ζₖ₋₂ are used to update ζₖ₋₁ and ζbarₖ
    δbarₖ₋₁ = δbarₖ = zero(FC)     # Coefficients of Lₖ₋₁ and L̅ₖ modified over the course of two iterations
    norm_vₖ = bNorm / βₖ           # ‖vₖ‖ is used for residual norm estimates

    # Stopping criterion.
    solved_lq = bNorm ≤ ε
    solved_cg = false
    breakdown = false
    tired     = iter ≥ itmax
    status    = "unknown"
    user_requested_exit = false
    overtimed = false

    while !(solved_lq || solved_cg || tired || breakdown || user_requested_exit || overtimed)
      # Update iteration index.
      iter = iter + 1

      # Continue the Lanczos biorthogonalization process.
      # MANVₖ    = VₖTₖ    + βₖ₊₁vₖ₊₁(eₖ)ᵀ = Vₖ₊₁Tₖ₊₁.ₖ
      # NᴴAᴴMᴴUₖ = Uₖ(Tₖ)ᴴ + γ̄ₖ₊₁uₖ₊₁(eₖ)ᵀ = Uₖ₊₁(Tₖ.ₖ₊₁)ᴴ

      # Forms vₖ₊₁ : q ← MANvₖ
      NisI || mulorldiv!(Nvₖ, N, vₖ, ldiv)
      kmul!(t, A, Nvₖ)
      MisI || mulorldiv!(q, M, t, ldiv)

      # Forms uₖ₊₁ : p ← NᴴAᴴMᴴuₖ
      MisI || mulorldiv!(Mᴴuₖ, Mᴴ, uₖ, ldiv)
      kmul!(s, Aᴴ, Mᴴuₖ)
      NisI || mulorldiv!(p, Nᴴ, s, ldiv)

      kaxpy!(n, -γₖ, vₖ₋₁, q)  # q ← q - γₖ * vₖ₋₁
      kaxpy!(n, -βₖ, uₖ₋₁, p)  # p ← p - β̄ₖ * uₖ₋₁

      αₖ = kdot(n, uₖ, q)  # αₖ = ⟨uₖ,q⟩

      kaxpy!(n, -     αₖ , vₖ, q)  # q ← q - αₖ * vₖ
      kaxpy!(n, -conj(αₖ), uₖ, p)  # p ← p - ᾱₖ * uₖ

      pᴴq = kdot(n, p, q)  # pᴴq  = ⟨p,q⟩
      βₖ₊₁ = √(abs(pᴴq))   # βₖ₊₁ = √(|pᴴq|)
      γₖ₊₁ = pᴴq / βₖ₊₁    # γₖ₊₁ = pᴴq / βₖ₊₁

      # Update the LQ factorization of Tₖ = L̅ₖQₖ.
      # [ α₁ γ₂ 0  •  •  •  0 ]   [ δ₁   0    •   •   •    •    0   ]
      # [ β₂ α₂ γ₃ •        • ]   [ λ₁   δ₂   •                 •   ]
      # [ 0  •  •  •  •     • ]   [ ϵ₁   λ₂   δ₃  •             •   ]
      # [ •  •  •  •  •  •  • ] = [ 0    •    •   •   •         •   ] Qₖ
      # [ •     •  •  •  •  0 ]   [ •    •    •   •   •    •    •   ]
      # [ •        •  •  •  γₖ]   [ •         •   •   •    •    0   ]
      # [ 0  •  •  •  0  βₖ αₖ]   [ •    •    •   0  ϵₖ₋₂ λₖ₋₁ δbarₖ]

      if iter == 1
        δbarₖ = αₖ
      elseif iter == 2
        # [δbar₁ γ₂] [c₂  s̄₂] = [δ₁   0  ]
        # [ β₂   α₂] [s₂ -c₂]   [λ₁ δbar₂]
        (cₖ, sₖ, δₖ₋₁) = sym_givens(δbarₖ₋₁, γₖ)
        λₖ₋₁  =      cₖ  * βₖ + sₖ * αₖ
        δbarₖ = conj(sₖ) * βₖ - cₖ * αₖ
      else
        # [0  βₖ  αₖ] [cₖ₋₁   s̄ₖ₋₁   0] = [sₖ₋₁βₖ  -cₖ₋₁βₖ  αₖ]
        #             [sₖ₋₁  -cₖ₋₁   0]
        #             [ 0      0     1]
        #
        # [ λₖ₋₂   δbarₖ₋₁  γₖ] [1   0   0 ] = [λₖ₋₂  δₖ₋₁    0  ]
        # [sₖ₋₁βₖ  -cₖ₋₁βₖ  αₖ] [0   cₖ  s̄ₖ]   [ϵₖ₋₂  λₖ₋₁  δbarₖ]
        #                       [0   sₖ -cₖ]
        (cₖ, sₖ, δₖ₋₁) = sym_givens(δbarₖ₋₁, γₖ)
        ϵₖ₋₂  =   sₖ₋₁ * βₖ
        λₖ₋₁  =  -cₖ₋₁ *      cₖ  * βₖ + sₖ * αₖ
        δbarₖ =  -cₖ₋₁ * conj(sₖ) * βₖ - cₖ * αₖ
      end

      # Compute ζₖ₋₁ and ζbarₖ, last components of the solution of L̅ₖz̅ₖ = β₁e₁
      # [δbar₁] [ζbar₁] = [β₁]
      if iter == 1
        ηₖ = βₖ
      end
      # [δ₁    0  ] [  ζ₁ ] = [β₁]
      # [λ₁  δbar₂] [ζbar₂]   [0 ]
      if iter == 2
        ζₖ₋₁ = ηₖ₋₁ / δₖ₋₁
        ηₖ   = -λₖ₋₁ * ζₖ₋₁
      end
      # [λₖ₋₂  δₖ₋₁    0  ] [ζₖ₋₂ ] = [0]
      # [ϵₖ₋₂  λₖ₋₁  δbarₖ] [ζₖ₋₁ ]   [0]
      #                     [ζbarₖ]
      if iter ≥ 3
        ζₖ₋₂ = ζₖ₋₁
        ζₖ₋₁ = ηₖ₋₁ / δₖ₋₁
        ηₖ   = -ϵₖ₋₂ * ζₖ₋₂ - λₖ₋₁ * ζₖ₋₁
      end

      # Relations for the directions dₖ₋₁ and d̅ₖ, the last two columns of D̅ₖ = Vₖ(Qₖ)ᴴ.
      # [d̅ₖ₋₁ vₖ] [cₖ  s̄ₖ] = [dₖ₋₁ d̅ₖ] ⟷ dₖ₋₁ = cₖ * d̅ₖ₋₁ + sₖ * vₖ
      #           [sₖ -cₖ]             ⟷ d̅ₖ   = s̄ₖ * d̅ₖ₋₁ - cₖ * vₖ
      if iter == 1
        # d̅₁ = v₁
        kcopy!(n, d̅, vₖ)  # d̅ ← vₖ
      else
        # Compute solution xₖ.
        # (xᴸ)ₖ ← (xᴸ)ₖ₋₁ + ζₖ₋₁ * dₖ₋₁
        kaxpy!(n, ζₖ₋₁ * cₖ,  d̅, x)
        kaxpy!(n, ζₖ₋₁ * sₖ, vₖ, x)

        # Compute d̅ₖ.
        # d̅ₖ = s̄ₖ * d̅ₖ₋₁ - cₖ * vₖ
        kaxpby!(n, -cₖ, vₖ, conj(sₖ), d̅)
      end

      # Compute vₖ₊₁ and uₖ₊₁.
      kcopy!(n, vₖ₋₁, vₖ)  # vₖ₋₁ ← vₖ
      kcopy!(n, uₖ₋₁, uₖ)  # uₖ₋₁ ← uₖ

      if pᴴq ≠ 0
        kdivcopy!(n, vₖ, q, βₖ₊₁)        # vₖ₊₁ = q / βₖ₊₁
        kdivcopy!(n, uₖ, p, conj(γₖ₊₁))  # uₖ₊₁ = p / γ̄ₖ₊₁
      end

      # Compute ⟨vₖ,vₖ₊₁⟩ and ‖vₖ₊₁‖
      vₖᴴvₖ₊₁ = kdot(n, vₖ₋₁, vₖ)
      norm_vₖ₊₁ = knorm(n, vₖ)

      # Compute BiLQ residual norm
      # ‖rₖ‖ = √(|μₖ|²‖vₖ‖² + |ωₖ|²‖vₖ₊₁‖² + μ̄ₖωₖ⟨vₖ,vₖ₊₁⟩ + μₖω̄ₖ⟨vₖ₊₁,vₖ⟩)
      if iter == 1
        rNorm_lq = bNorm
      else
        μₖ = βₖ * (sₖ₋₁ * ζₖ₋₂ - cₖ₋₁ * cₖ * ζₖ₋₁) + αₖ * sₖ * ζₖ₋₁
        ωₖ = βₖ₊₁ * sₖ * ζₖ₋₁
        θₖ = conj(μₖ) * ωₖ * vₖᴴvₖ₊₁
        rNorm_lq = sqrt(abs2(μₖ) * norm_vₖ^2 + abs2(ωₖ) * norm_vₖ₊₁^2 + 2 * real(θₖ))
      end
      history && push!(rNorms, rNorm_lq)

      # Compute BiCG residual norm
      # ‖rₖ‖ = |ρₖ| * ‖vₖ₊₁‖
      if transfer_to_bicg && (abs(δbarₖ) > eps(T))
        ζbarₖ = ηₖ / δbarₖ
        ρₖ = βₖ₊₁ * (sₖ * ζₖ₋₁ - cₖ * ζbarₖ)
        rNorm_cg = abs(ρₖ) * norm_vₖ₊₁
      end

      # Update sₖ₋₁, cₖ₋₁, ηₖ₋₁, γₖ, βₖ, δbarₖ₋₁ and norm_vₖ.
      sₖ₋₁    = sₖ
      cₖ₋₁    = cₖ
      ηₖ₋₁    = ηₖ
      γₖ      = γₖ₊₁
      βₖ      = βₖ₊₁
      δbarₖ₋₁ = δbarₖ
      norm_vₖ = norm_vₖ₊₁

      # Update stopping criterion.
      user_requested_exit = callback(workspace) :: Bool
      solved_lq = rNorm_lq ≤ ε
      solved_cg = transfer_to_bicg && (abs(δbarₖ) > eps(T)) && (rNorm_cg ≤ ε)
      tired = iter ≥ itmax
      breakdown = !solved_lq && !solved_cg && (pᴴq == 0)
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %8.1e  %7.1e  %.2fs\n", iter, αₖ, rNorm_lq, start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Compute BICG point
    # (xᶜ)ₖ ← (xᴸ)ₖ + ζbarₖ * d̅ₖ
    if solved_cg
      kaxpy!(n, ζbarₖ, d̅, x)
    end

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    breakdown           && (status = "Breakdown ⟨uₖ₊₁,vₖ₊₁⟩ = 0")
    solved_lq           && (status = "solution xᴸ good enough given atol and rtol")
    solved_cg           && (status = "solution xᶜ good enough given atol and rtol")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update x
    if !NisI
      copyto!(workspace.s, x)
      mulorldiv!(x, N, workspace.s, ldiv)
    end
    warm_start && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved_lq || solved_cg
    stats.inconsistent = false
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

using LinearAlgebra, SparseArrays, Test
using Krylov, LinearOperators

@testset "LinearOperators" begin
  n = 50
  p = 5

  for T in (Float64, ComplexF64)
    A = rand(T, n, n)
    B = rand(T, n, p)
    
    opA = LinearOperator(A)
    x, stats = block_gmres(opA, B)
    @test stats.solved
  end
end

# An implementation of USYMQR for the solution of linear system Ax = b.
#
# This method is described in
#
# M. A. Saunders, H. D. Simon, and E. L. Yip
# Two Conjugate-Gradient-Type Methods for Unsymmetric Linear Equations.
# SIAM Journal on Numerical Analysis, 25(4), pp. 927--940, 1988.
#
# L. Reichel and Q. Ye
# A generalized LSQR algorithm.
# Numerical Linear Algebra with Applications, 15(7), pp. 643--660, 2008.
#
# A. Buttari, D. Orban, D. Ruiz and D. Titley-Peloquin
# A tridiagonalization method for symmetric saddle-point and quasi-definite systems.
# SIAM Journal on Scientific Computing, 41(5), pp. 409--432, 2019.
#
# A. Montoison and D. Orban
# BiLQ: An Iterative Method for Nonsymmetric Linear Systems with a Quasi-Minimum Error Property.
# SIAM Journal on Matrix Analysis and Applications, 41(3), pp. 1145--1166, 2020.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Montreal, November 2018.

export usymqr, usymqr!

"""
    (x, stats) = usymqr(A, b::AbstractVector{FC}, c::AbstractVector{FC};
                        atol::T=√eps(T), rtol::T=√eps(T), itmax::Int=0,
                        timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                        callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = usymqr(A, b, c, x0::AbstractVector; kwargs...)

USYMQR can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above.

USYMQR solves the linear least-squares problem min ‖b - Ax‖² of size m × n.
USYMQR solves Ax = b if it is consistent.

USYMQR is based on the orthogonal tridiagonalization process and requires two initial nonzero vectors `b` and `c`.
The vector `c` is only used to initialize the process and a default value can be `b` or `Aᴴb` depending on the shape of `A`.
The residual norm ‖b - Ax‖ monotonously decreases in USYMQR.
When `A` is Hermitian and `b = c`, QMR is equivalent to MINRES.
USYMQR is considered as a generalization of MINRES.

It can also be applied to under-determined and over-determined problems.
USYMQR finds the minimum-norm solution if problems are inconsistent.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :usymqr`.

For an in-place variant that reuses memory across solves, see [`usymqr!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`;
* `c`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `m+n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### References

* M. A. Saunders, H. D. Simon, and E. L. Yip, [*Two Conjugate-Gradient-Type Methods for Unsymmetric Linear Equations*](https://doi.org/10.1137/0725052), SIAM Journal on Numerical Analysis, 25(4), pp. 927--940, 1988.
* L. Reichel and Q. Ye, [*A generalized LSQR algorithm*](https://doi.org/10.1002/nla.611), Numerical Linear Algebra with Applications, 15(7), pp. 643--660, 2008.
* A. Buttari, D. Orban, D. Ruiz and D. Titley-Peloquin, [*A tridiagonalization method for symmetric saddle-point and quasi-definite systems*](https://doi.org/10.1137/18M1194900), SIAM Journal on Scientific Computing, 41(5), pp. 409--432, 2019.
* A. Montoison and D. Orban, [*BiLQ: An Iterative Method for Nonsymmetric Linear Systems with a Quasi-Minimum Error Property*](https://doi.org/10.1137/19M1290991), SIAM Journal on Matrix Analysis and Applications, 41(3), pp. 1145--1166, 2020.
"""
function usymqr end

"""
    workspace = usymqr!(workspace::UsymqrWorkspace, A, b, c; kwargs...)
    workspace = usymqr!(workspace::UsymqrWorkspace, A, b, c, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`usymqr`](@ref).

See [`UsymqrWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :usymqr` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function usymqr! end

def_args_usymqr = (:(A                    ),
                   :(b::AbstractVector{FC}),
                   :(c::AbstractVector{FC}))

def_optargs_usymqr = (:(x0::AbstractVector),)

def_kwargs_usymqr = (:(; atol::T = √eps(T)            ),
                     :(; rtol::T = √eps(T)            ),
                     :(; itmax::Int = 0               ),
                     :(; timemax::Float64 = Inf       ),
                     :(; verbose::Int = 0             ),
                     :(; history::Bool = false        ),
                     :(; callback = workspace -> false),
                     :(; iostream::IO = kstdout       ))

def_kwargs_usymqr = extract_parameters.(def_kwargs_usymqr)

args_usymqr = (:A, :b, :c)
optargs_usymqr = (:x0,)
kwargs_usymqr = (:atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function usymqr!(workspace :: UsymqrWorkspace{T,FC,Sm,Sn}, $(def_args_usymqr...); $(def_kwargs_usymqr...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    length(b) == m || error("Inconsistent problem size")
    length(c) == n || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "USYMQR: system of %d equations in %d variables\n", m, n)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == Sm || error("ktypeof(b) must be equal to $Sm")
    ktypeof(c) == Sn || error("ktypeof(c) must be equal to $Sn")

    # Compute the adjoint of A
    Aᴴ = A'

    # Set up workspace.
    vₖ₋₁, vₖ, q, Δx, x, p = workspace.vₖ₋₁, workspace.vₖ, workspace.q, workspace.Δx, workspace.x, workspace.p
    wₖ₋₂, wₖ₋₁, uₖ₋₁, uₖ, stats = workspace.wₖ₋₂, workspace.wₖ₋₁, workspace.uₖ₋₁, workspace.uₖ, workspace.stats
    warm_start = workspace.warm_start
    rNorms, AᴴrNorms = stats.residuals, stats.Aresiduals
    reset!(stats)
    r₀ = warm_start ? q : b

    if warm_start
      kmul!(r₀, A, Δx)
      kaxpby!(n, one(FC), b, -one(FC), r₀)
    end

    # Initial solution x₀ and residual norm ‖r₀‖.
    kfill!(x, zero(FC))
    rNorm = knorm(m, r₀)
    history && push!(rNorms, rNorm)
    if rNorm == 0
      stats.niter = 0
      stats.solved = true
      stats.inconsistent = false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    iter = 0
    itmax == 0 && (itmax = m+n)

    ε = atol + rtol * rNorm
    κ = zero(T)
    (verbose > 0) && @printf(iostream, "%5s  %7s  %8s  %5s\n", "k", "‖rₖ‖", "‖Aᴴrₖ₋₁‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %8s  %.2fs\n", iter, rNorm, " ✗ ✗ ✗ ✗", start_time |> ktimer)

    βₖ = knorm(m, r₀)            # β₁ = ‖v₁‖ = ‖r₀‖
    γₖ = knorm(n, c)             # γ₁ = ‖u₁‖ = ‖c‖
    kfill!(vₖ₋₁, zero(FC))       # v₀ = 0
    kfill!(uₖ₋₁, zero(FC))       # u₀ = 0
    kdivcopy!(m, vₖ, r₀, βₖ)     # v₁ = (b - Ax₀) / β₁
    kdivcopy!(n, uₖ, c, γₖ)      # u₁ = c / γ₁
    cₖ₋₂ = cₖ₋₁ = cₖ = one(T)    # Givens cosines used for the QR factorization of Tₖ₊₁.ₖ
    sₖ₋₂ = sₖ₋₁ = sₖ = zero(FC)  # Givens sines used for the QR factorization of Tₖ₊₁.ₖ
    kfill!(wₖ₋₂, zero(FC))       # Column k-2 of Wₖ = Uₖ(Rₖ)⁻¹
    kfill!(wₖ₋₁, zero(FC))       # Column k-1 of Wₖ = Uₖ(Rₖ)⁻¹
    ζbarₖ = βₖ                   # ζbarₖ is the last component of z̅ₖ = (Qₖ)ᴴβ₁e₁

    # Stopping criterion.
    solved = rNorm ≤ ε
    inconsistent = false
    tired = iter ≥ itmax
    status = "unknown"
    user_requested_exit = false
    overtimed = false

    while !(solved || tired || inconsistent || user_requested_exit || overtimed)
      # Update iteration index.
      iter = iter + 1

      # Continue the SSY tridiagonalization process.
      # AUₖ  = VₖTₖ    + βₖ₊₁vₖ₊₁(eₖ)ᵀ = Vₖ₊₁Tₖ₊₁.ₖ
      # AᴴVₖ = Uₖ(Tₖ)ᴴ + γₖ₊₁uₖ₊₁(eₖ)ᵀ = Uₖ₊₁(Tₖ.ₖ₊₁)ᴴ

      kmul!(q, A , uₖ)  # Forms vₖ₊₁ : q ← Auₖ
      kmul!(p, Aᴴ, vₖ)  # Forms uₖ₊₁ : p ← Aᴴvₖ

      if iter ≥ 2
        kaxpy!(m, -γₖ, vₖ₋₁, q) # q ← q - γₖ * vₖ₋₁
        kaxpy!(n, -βₖ, uₖ₋₁, p) # p ← p - βₖ * uₖ₋₁
      end

      αₖ = kdot(m, vₖ, q)  # αₖ = ⟨vₖ,q⟩

      kaxpy!(m, -     αₖ , vₖ, q)  # q ← q - αₖ * vₖ
      kaxpy!(n, -conj(αₖ), uₖ, p)  # p ← p - ᾱₖ * uₖ

      βₖ₊₁ = knorm(m, q)  # βₖ₊₁ = ‖q‖
      γₖ₊₁ = knorm(n, p)  # γₖ₊₁ = ‖p‖

      # Update the QR factorization of Tₖ₊₁.ₖ = Qₖ [ Rₖ ].
      #                                            [ Oᵀ ]
      #
      # [ α₁ γ₂ 0  •  •  •   0  ]      [ δ₁ λ₁ ϵ₁ 0  •  •  0  ]
      # [ β₂ α₂ γ₃ •         •  ]      [ 0  δ₂ λ₂ •  •     •  ]
      # [ 0  •  •  •  •      •  ]      [ •  •  δ₃ •  •  •  •  ]
      # [ •  •  •  •  •  •   •  ] = Qₖ [ •     •  •  •  •  0  ]
      # [ •     •  •  •  •   0  ]      [ •        •  •  • ϵₖ₋₂]
      # [ •        •  •  •   γₖ ]      [ •           •  • λₖ₋₁]
      # [ •           •  βₖ  αₖ ]      [ 0  •  •  •  •  0  δₖ ]
      # [ 0  •  •  •  •  0  βₖ₊₁]      [ 0  •  •  •  •  •  0  ]
      #
      # If k = 1, we don't have any previous reflection.
      # If k = 2, we apply the last reflection.
      # If k ≥ 3, we only apply the two previous reflections.

      # Apply previous Givens reflections Qₖ₋₂.ₖ₋₁
      if iter ≥ 3
        # [cₖ₋₂  sₖ₋₂] [0 ] = [  ϵₖ₋₂ ]
        # [s̄ₖ₋₂ -cₖ₋₂] [γₖ]   [λbarₖ₋₁]
        ϵₖ₋₂    =  sₖ₋₂ * γₖ
        λbarₖ₋₁ = -cₖ₋₂ * γₖ
      end

      # Apply previous Givens reflections Qₖ₋₁.ₖ
      if iter ≥ 2
        iter == 2 && (λbarₖ₋₁ = γₖ)
        # [cₖ₋₁  sₖ₋₁] [λbarₖ₋₁] = [λₖ₋₁ ]
        # [s̄ₖ₋₁ -cₖ₋₁] [   αₖ  ]   [δbarₖ]
        λₖ₋₁  =      cₖ₋₁  * λbarₖ₋₁ + sₖ₋₁ * αₖ
        δbarₖ = conj(sₖ₋₁) * λbarₖ₋₁ - cₖ₋₁ * αₖ
      end

      # Compute and apply current Givens reflection Qₖ.ₖ₊₁
      iter == 1 && (δbarₖ = αₖ)
      # [cₖ  sₖ] [δbarₖ] = [δₖ]
      # [s̄ₖ -cₖ] [βₖ₊₁ ]   [0 ]
      (cₖ, sₖ, δₖ) = sym_givens(δbarₖ, βₖ₊₁)

      # Update z̅ₖ₊₁ = Qₖ.ₖ₊₁ [ z̄ₖ ]
      #                      [ 0  ]
      #
      # [cₖ  sₖ] [ζbarₖ] = [   ζₖ  ]
      # [s̄ₖ -cₖ] [  0  ]   [ζbarₖ₊₁]
      ζₖ      =      cₖ  * ζbarₖ
      ζbarₖ₊₁ = conj(sₖ) * ζbarₖ

      # Compute the direction wₖ, the last column of Wₖ = Uₖ(Rₖ)⁻¹ ⟷ (Rₖ)ᵀ(Wₖ)ᵀ = (Uₖ)ᵀ.
      # w₁ = u₁ / δ₁
      if iter == 1
        wₖ = wₖ₋₁
        kdivcopy!(n, wₖ, uₖ, δₖ)
      end
      # w₂ = (u₂ - λ₁w₁) / δ₂
      if iter == 2
        wₖ = wₖ₋₂
        kaxpy!(n, -λₖ₋₁, wₖ₋₁, wₖ)
        kaxpy!(n, one(FC), uₖ, wₖ)
        kdiv!(n, wₖ, δₖ)
      end
      # wₖ = (uₖ - λₖ₋₁wₖ₋₁ - ϵₖ₋₂wₖ₋₂) / δₖ
      if iter ≥ 3
        kscal!(n, -ϵₖ₋₂, wₖ₋₂)
        wₖ = wₖ₋₂
        kaxpy!(n, -λₖ₋₁, wₖ₋₁, wₖ)
        kaxpy!(n, one(FC), uₖ, wₖ)
        kdiv!(n, wₖ, δₖ)
      end

      # Compute solution xₖ.
      # xₖ ← xₖ₋₁ + ζₖ * wₖ
      kaxpy!(n, ζₖ, wₖ, x)

      # Compute ‖rₖ‖ = |ζbarₖ₊₁|.
      rNorm = abs(ζbarₖ₊₁)
      history && push!(rNorms, rNorm)

      # Compute ‖Aᴴrₖ₋₁‖ = |ζbarₖ| * √(|δbarₖ|² + |λbarₖ|²).
      AᴴrNorm = abs(ζbarₖ) * √(abs2(δbarₖ) + abs2(cₖ₋₁ * γₖ₊₁))
      history && push!(AᴴrNorms, AᴴrNorm)

      # Compute vₖ₊₁ and uₖ₊₁.
      kcopy!(m, vₖ₋₁, vₖ)  # vₖ₋₁ ← vₖ
      kcopy!(n, uₖ₋₁, uₖ)  # uₖ₋₁ ← uₖ

      if βₖ₊₁ ≠ zero(T)
        kdivcopy!(m, vₖ, q, βₖ₊₁)  # vₖ₊₁ = q / βₖ₊₁
      end
      if γₖ₊₁ ≠ zero(T)
        kdivcopy!(n, uₖ, p, γₖ₊₁)  # uₖ₊₁ = p / γₖ₊₁
      end

      # Update directions for x.
      if iter ≥ 2
        @kswap!(wₖ₋₂, wₖ₋₁)
      end

      # Update sₖ₋₂, cₖ₋₂, sₖ₋₁, cₖ₋₁, ζbarₖ, γₖ, βₖ.
      if iter ≥ 2
        sₖ₋₂ = sₖ₋₁
        cₖ₋₂ = cₖ₋₁
      end
      sₖ₋₁  = sₖ
      cₖ₋₁  = cₖ
      ζbarₖ = ζbarₖ₊₁
      γₖ    = γₖ₊₁
      βₖ    = βₖ₊₁

      # Update stopping criterion.
      iter == 1 && (κ = atol + rtol * AᴴrNorm)
      user_requested_exit = callback(workspace) :: Bool
      solved = rNorm ≤ ε
      inconsistent = !solved && AᴴrNorm ≤ κ
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %8.1e  %.2fs\n", iter, rNorm, AᴴrNorm, start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    solved              && (status = "solution good enough given atol and rtol")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update x
    warm_start && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = inconsistent
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

# An implementation of block-GMRES for the solution of the square linear system AX = B.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca> -- <amontoison@anl.gov>
# Argonne National Laboratory -- Chicago, October 2023.

export block_gmres, block_gmres!

"""
    (X, stats) = block_gmres(A, b::AbstractMatrix{FC};
                             memory::Int=5, M=I, N=I, ldiv::Bool=false,
                             restart::Bool=false, reorthogonalization::Bool=false,
                             atol::T=√eps(T), rtol::T=√eps(T), itmax::Int=0,
                             timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                             callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (X, stats) = block_gmres(A, B, X0::AbstractMatrix; kwargs...)

Block-GMRES can be warm-started from an initial guess `X0` where `kwargs` are the same keyword arguments as above.

Solve the linear system AX = B of size n with p right-hand sides using block-GMRES.

#### Interface

To easily switch between block Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :block_gmres`.

For an in-place variant that reuses memory across solves, see [`block_gmres!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `n`;
* `B`: a matrix of size `n × p`.

#### Optional argument

* `X0`: a matrix of size `n × p` that represents an initial guess of the solution `X`.

#### Keyword arguments

* `memory`: if `restart = true`, the restarted version block-GMRES(k) is used with `k = memory`. If `restart = false`, the parameter `memory` should be used as a hint of the number of iterations to limit dynamic memory allocations. Additional storage will be allocated if the number of iterations exceeds `memory`;
* `M`: linear operator that models a nonsingular matrix of size `n` used for left preconditioning;
* `N`: linear operator that models a nonsingular matrix of size `n` used for right preconditioning;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `restart`: restart the method after `memory` iterations;
* `reorthogonalization`: reorthogonalize the new matrices of the block-Krylov basis against all previous matrix;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2 * div(n,p)`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the block-Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `X`: a dense matrix of size `n × p`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.
"""
function block_gmres end

"""
    workspace = block_gmres!(workspace::BlockGmresWorkspace, B; kwargs...)
    workspace = block_gmres!(workspace::BlockGmresWorkspace, B, X0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`block_gmres`](@ref).
The keyword argument `memory` is the only exception.
It is only supported by `block_gmres` and is required to create a `BlockGmresWorkspace`.
It cannot be changed later.

See [`BlockGmresWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :block_gmres` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the block Krylov method in-place.
"""
function block_gmres! end

def_args_block_gmres = (:(A                    ),
                        :(B::AbstractMatrix{FC}))

def_optargs_block_gmres = (:(X0::AbstractMatrix),)

def_kwargs_block_gmres = (:(; M = I                            ),
                          :(; N = I                            ),
                          :(; ldiv::Bool = false               ),
                          :(; restart::Bool = false            ),
                          :(; reorthogonalization::Bool = false),
                          :(; atol::T = √eps(T)                ),
                          :(; rtol::T = √eps(T)                ),
                          :(; itmax::Int = 0                   ),
                          :(; timemax::Float64 = Inf           ),
                          :(; verbose::Int = 0                 ),
                          :(; history::Bool = false            ),
                          :(; callback = workspace -> false    ),
                          :(; iostream::IO = kstdout           ))

def_kwargs_workspace_block_gmres = (:(; memory::Int = 5),)

def_kwargs_block_gmres = extract_parameters.(def_kwargs_block_gmres)
def_kwargs_workspace_block_gmres = extract_parameters.(def_kwargs_workspace_block_gmres)

args_block_gmres = (:A, :B)
optargs_block_gmres = (:X0,)
kwargs_block_gmres = (:M, :N, :ldiv, :restart, :reorthogonalization, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)
kwargs_workspace_block_gmres = (:memory,)

@eval begin
  function block_gmres!(workspace :: BlockGmresWorkspace{T,FC,SV,SM}, $(def_args_block_gmres...); $(def_kwargs_block_gmres...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, SV <: AbstractVector{FC}, SM <: AbstractMatrix{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    n, m = size(A)
    s, p = size(B)
    m == n || error("System must be square")
    n == s || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "BLOCK-GMRES: system of size %d with %d right-hand sides\n", n, p)

    # Check M = Iₙ and N = Iₙ
    MisI = (M === I)
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-matrix products."
    ktypeof(B) == SM || error("ktypeof(B) must be equal to $SM")

    # Set up workspace.
    allocate_if(!MisI  , workspace, :Q , SM, workspace.n, workspace.p)
    allocate_if(!NisI  , workspace, :P , SM, workspace.n, workspace.p)
    allocate_if(restart, workspace, :ΔX, SM, workspace.n, workspace.p)
    ΔX, X, W, V, Z = workspace.ΔX, workspace.X, workspace.W, workspace.V, workspace.Z
    C, D, R, H, τ, stats = workspace.C, workspace.D, workspace.R, workspace.H, workspace.τ, workspace.stats
    Ψtmp = C
    buffer = workspace.buffer
    warm_start = workspace.warm_start
    RNorms = stats.residuals
    reset!(stats)
    Q  = MisI ? W : workspace.Q
    R₀ = MisI ? W : workspace.Q
    Xr = restart ? ΔX : X

    # Define the blocks D1 and D2
    D1 = view(D, 1:p, :)
    D2 = view(D, p+1:2p, :)
    trans = FC <: AbstractFloat ? 'T' : 'C'

    # Coefficients for mul!
    α = -one(FC)
    β = one(FC)
    γ = one(FC)

    # Initial solution X₀.
    fill!(X, zero(FC))

    # Initial residual R₀.
    if warm_start
      mul!(W, A, ΔX)
      W .= B .- W
      restart && (X .+= ΔX)
    else
      copyto!(W, B)
    end
    MisI || mulorldiv!(R₀, M, W, ldiv)  # R₀ = M(B - AX₀)
    RNorm = norm(R₀)                    # ‖R₀‖_F

    history && push!(RNorms, RNorm)
    ε = atol + rtol * RNorm

    mem = length(V)  # Memory
    npass = 0        # Number of pass

    iter = 0        # Cumulative number of iterations
    inner_iter = 0  # Number of iterations in a pass

    itmax == 0 && (itmax = 2*div(n,p))
    inner_itmax = itmax

    (verbose > 0) && @printf(iostream, "%5s  %5s  %7s  %5s\n", "pass", "k", "‖Rₖ‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %5d  %7.1e  %.2fs\n", npass, iter, RNorm, start_time |> ktimer)

    # Stopping criterion
    solved = RNorm ≤ ε
    tired = iter ≥ itmax
    inner_tired = inner_iter ≥ inner_itmax
    status = "unknown"
    user_requested_exit = false
    overtimed = false

    while !(solved || tired || user_requested_exit || overtimed)

      # Initialize workspace.
      nr = 0  # Number of blocks Ψᵢⱼ stored in Rₖ.
      for i = 1 : mem
        fill!(V[i], zero(FC))  # Orthogonal basis of Kₖ(MAN, MR₀).
      end
      for Ψ in R
        fill!(Ψ, zero(FC))  # Upper triangular matrix Rₖ.
      end
      for block in Z
        fill!(block, zero(FC))  # Right-hand of the least squares problem min ‖Hₖ₊₁.ₖYₖ - ΓE₁‖₂.
      end

      if restart
        fill!(Xr, zero(FC))  # Xr === ΔX when restart is set to true
        if npass ≥ 1
          mul!(W, A, X)
          W .= B .- W
          MisI || mulorldiv!(R₀, M, W, ldiv)
        end
      end

      # Initial Γ and V₁
      copyto!(V[1], R₀)
      householder!(V[1], Z[1], τ[1], buffer)

      npass = npass + 1
      inner_iter = 0
      inner_tired = false

      while !(solved || inner_tired || user_requested_exit || overtimed)

        # Update iteration index
        inner_iter = inner_iter + 1

        # Update workspace if more storage is required and restart is set to false
        if !restart && (inner_iter > mem)
          start_allocation_time = time_ns()
          for i = 1 : inner_iter
            push!(R, SM(undef, p, p))
          end
          push!(H, SM(undef, 2p, p))
          push!(τ, SV(undef, p))
          stats.allocation_timer += start_allocation_time |> ktimer
        end

        # Continue the block-Arnoldi process.
        P = NisI ? V[inner_iter] : workspace.P
        NisI || mulorldiv!(P, N, V[inner_iter], ldiv)  # P ← NVₖ
        mul!(W, A, P)                                  # W ← ANVₖ
        MisI || mulorldiv!(Q, M, W, ldiv)              # Q ← MANVₖ
        for i = 1 : inner_iter
          mul!(R[nr+i], V[i]', Q)       # Ψᵢₖ = Vᵢᴴ * Q
          mul!(Q, V[i], R[nr+i], α, β)  # Q = Q - Vᵢ * Ψᵢₖ
        end

        # Reorthogonalization of the block-Krylov basis.
        if reorthogonalization
          for i = 1 : inner_iter
            mul!(Ψtmp, V[i]', Q)       # Ψtmp = Vᵢᴴ * Q
            mul!(Q, V[i], Ψtmp, α, β)  # Q = Q - Vᵢ * Ψtmp
            R[nr+i] .+= Ψtmp
          end
        end

        # Vₖ₊₁ and Ψₖ₊₁.ₖ are stored in Q and C.
        householder!(Q, C, τ[inner_iter], buffer)

        # Update the QR factorization of Hₖ₊₁.ₖ.
        # Apply previous Householder reflections Ωᵢ.
        for i = 1 : inner_iter-1
          D1 .= R[nr+i]
          D2 .= R[nr+i+1]
          kormqr!('L', trans, H[i], τ[i], D, buffer)
          R[nr+i] .= D1
          R[nr+i+1] .= D2
        end

        # Compute and apply current Householder reflection Ωₖ.
        H[inner_iter][1:p,:] .= R[nr+inner_iter]
        H[inner_iter][p+1:2p,:] .= C
        householder!(H[inner_iter], R[nr+inner_iter], τ[inner_iter], buffer, compact=true)

        # Update Zₖ = (Qₖ)ᴴΓE₁ = (Λ₁, ..., Λₖ, Λbarₖ₊₁)
        D1 .= Z[inner_iter]
        D2 .= zero(FC)
        kormqr!('L', trans, H[inner_iter], τ[inner_iter], D, buffer)
        Z[inner_iter] .= D1

        # Update residual norm estimate.
        # ‖ M(B - AXₖ) ‖_F = ‖Λbarₖ₊₁‖_F
        C .= D2
        RNorm = norm(C)
        history && push!(RNorms, RNorm)

        # Update the number of coefficients in Rₖ
        nr = nr + inner_iter

        # Update stopping criterion.
        user_requested_exit = callback(workspace) :: Bool
        solved = RNorm ≤ ε
        inner_tired = restart ? inner_iter ≥ min(mem, inner_itmax) : inner_iter ≥ inner_itmax
        timer = time_ns() - start_time
        overtimed = timer > timemax_ns
        kdisplay(iter+inner_iter, verbose) && @printf(iostream, "%5d  %5d  %7.1e  %.2fs\n", npass, iter+inner_iter, RNorm, start_time |> ktimer)

        # Compute Vₖ₊₁.
        if !(solved || inner_tired || user_requested_exit || overtimed)
          if !restart && (inner_iter ≥ mem)
            start_allocation_time = time_ns()
            push!(V, SM(undef, n, p))
            push!(Z, SM(undef, p, p))
            stats.allocation_timer += start_allocation_time |> ktimer
          end
          copyto!(V[inner_iter+1], Q)
          Z[inner_iter+1] .= D2
        end
      end

      # Compute Yₖ by solving RₖYₖ = Zₖ with a backward substitution by block.
      Y = Z  # Yᵢ = Zᵢ
      for i = inner_iter : -1 : 1
        pos = nr + i - inner_iter         # position of Ψᵢ.ₖ
        for j = inner_iter : -1 : i+1
          mul!(Y[i], R[pos], Y[j], α, β)  # Yᵢ ← Yᵢ - ΨᵢⱼYⱼ
          pos = pos - j + 1               # position of Ψᵢ.ⱼ₋₁
        end
        ldiv!(UpperTriangular(R[pos]), Y[i])  # Yᵢ ← Yᵢ \ Ψᵢᵢ
      end

      # Form Xₖ = NVₖYₖ
      for i = 1 : inner_iter
        mul!(Xr, V[i], Y[i], γ, β)
      end
      if !NisI
        copyto!(workspace.P, Xr)
        mulorldiv!(Xr, N, workspace.P, ldiv)
      end
      restart && (X .+= Xr)

      # Update inner_itmax, iter, tired and overtimed variables.
      inner_itmax = inner_itmax - inner_iter
      iter = iter + inner_iter
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    solved              && (status = "solution good enough given atol and rtol")
    overtimed           && (status = "time limit exceeded")
    user_requested_exit && (status = "user-requested exit")

    # Update Xₖ
    warm_start && !restart && (X .+= ΔX)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

# """
#     Q, R = gs(A)
#
# Gram-Schmidt orthogonalization for a reduced QR decomposition.
#
# #### Input argument
#
# * `A`: an n-by-k matrix, n ≥ k
#
# #### Output arguments
#
# * `Q` an n-by-k orthonormal matrix: QᴴQ = Iₖ
# * `R` an k-by-k upper triangular matrix: QR = A
# """
function gs(A::AbstractMatrix{FC}) where FC <: FloatOrComplex
  n, k = size(A)
  Q = copy(A)
  R = zeros(FC, k, k)
  v = zeros(FC, n)
  gs!(Q, R, v)
end

function gs!(Q::AbstractMatrix{FC}, R::AbstractMatrix{FC}, v::AbstractVector{FC}) where FC <: FloatOrComplex
  n, k = size(Q)
  aⱼ = v
  kfill!(R, zero(FC))
  for j = 1:k
    qⱼ = view(Q,:,j)
    kcopy!(n, aⱼ, qⱼ)
    for i = 1:j-1
      qᵢ = view(Q,:,i)
      R[i,j] = kdot(n, qᵢ, aⱼ)    # rᵢⱼ = ⟨qᵢ , aⱼ⟩
      kaxpy!(n, -R[i,j], qᵢ, qⱼ)  # qⱼ = qⱼ - rᵢⱼqᵢ
    end
    R[j,j] = knorm(n, qⱼ)  # rⱼⱼ = ‖qⱼ‖
    qⱼ ./= R[j,j]           # qⱼ = qⱼ / rⱼⱼ
  end
  return Q, R
end

# """
# Modified Gram-Schmidt orthogonalization for a reduced QR decomposition:
# Q, R = mgs(A)
#
# Input :
# A an n-by-k matrix, n ≥ k
#
# # Q an n-by-k orthonormal matrix: QᴴQ = Iₖ
# # R an k-by-k upper triangular matrix: QR = A
# """
function mgs(A::AbstractMatrix{FC}) where FC <: FloatOrComplex
  n, k = size(A)
  Q = copy(A)
  R = zeros(FC, k, k)
  mgs!(Q, R)
end

function mgs!(Q::AbstractMatrix{FC}, R::AbstractMatrix{FC}) where FC <: FloatOrComplex
  n, k = size(Q)
  kfill!(R, zero(FC))
  for i = 1:k
    qᵢ = view(Q,:,i)
    R[i,i] = knorm(n, qᵢ)  # rᵢᵢ = ‖qᵢ‖
    qᵢ ./= R[i,i]          # qᵢ = qᵢ / rᵢᵢ
    for j = i+1:k
      qⱼ = view(Q,:,j)
      R[i,j] = kdot(n, qᵢ, qⱼ)    # rᵢⱼ = ⟨qᵢ , qⱼ⟩
      kaxpy!(n, -R[i,j], qᵢ, qⱼ)  # qⱼ = qⱼ - rᵢⱼqᵢ
    end
  end
  return Q, R
end

# Reduced QR factorization with Givens reflections:
# Q, R = givens(A)
#
# Input :
# A an n-by-k matrix, n ≥ k
#
# # Q an n-by-k orthonormal matrix: QᴴQ = Iₖ
# # R an k-by-k upper triangular matrix: QR = A
# """
function givens(A::AbstractMatrix{FC}) where FC <: FloatOrComplex
  n, k = size(A)
  nr = n*k - div(k*(k+1), 2)
  T = real(FC)
  Q = copy(A)
  R = zeros(FC, k, k)
  C = zeros(T, nr)
  S = zeros(FC, nr)
  givens!(Q, R, C, S)
end

function givens!(Q::AbstractMatrix{FC}, R::AbstractMatrix{FC}, C::AbstractVector{T}, S::AbstractVector{FC}) where {T <: AbstractFloat, FC <: FloatOrComplex{T}}
  n, k = size(Q)
  kfill!(R, zero(FC))
  pos = 0
  for j = 1:k
    for i = n-1:-1:j
      pos += 1
      C[pos], S[pos], Q[i,j] = sym_givens(Q[i,j], Q[i+1,j])
      if j < k
        reflect!(view(Q, i, j+1:k), view(Q, i+1, j+1:k), C[pos], S[pos])
      end
    end
  end
  for j = 1:k
    for i = 1:j
      R[i,j] = Q[i,j]
    end
  end
  kfill!(Q, zero(FC))
  for i = 1:k
    Q[i,i] = one(FC)
  end
  for j = k:-1:1
    for i = j:n-1
      reflect!(view(Q, i, j:k), view(Q, i+1, j:k), C[pos], S[pos])
      pos -= 1
    end
  end
  return Q, R
end

function reduced_qr!(Q::AbstractMatrix{FC}, R::AbstractMatrix{FC}, algo::String) where FC <: FloatOrComplex
  n, k = size(Q)
  T = real(FC)
  if algo == "gs"
    v = zeros(FC, n)
    gs!(Q, R, v)
  elseif algo == "mgs"
    mgs!(Q, R)
  elseif algo == "givens"
    nr = n*k - div(k*(k+1), 2)
    C = zeros(T, nr)
    S = zeros(FC, nr)
    givens!(Q, R, C, S)
  elseif algo == "householder"
    τ = zeros(FC, k)
    householder!(Q, R, τ)
  else
    error("$algo is not a supported method to perform a reduced QR.")
  end
  return Q, R
end

function reduced_qr(A::AbstractMatrix{FC}, algo::String) where FC <: FloatOrComplex
  if algo == "gs"
    Q, R = gs(A)
  elseif algo == "mgs"
    Q, R = mgs(A)
  elseif algo == "givens"
    Q, R = givens(A)
  elseif algo == "householder"
    Q, R = householder(A)
  else
    error("$algo is not a supported method to perform a reduced QR.")
  end
  return Q, R
end

function copy_triangle(Q::AbstractMatrix{FC}, R::AbstractMatrix{FC}, k::Int) where FC <: FloatOrComplex
  if VERSION < v"1.11"
    for i = 1:k
      for j = i:k
        R[i,j] = Q[i,j]
      end
    end
  else
    copytrito!(R, Q, 'U')
  end
  return R
end

# Reduced QR factorization with Householder reflections:
# Q, R = householder(A)
#
# Input :
# A an n-by-k matrix, n ≥ k
#
# Output :
# Q an n-by-k orthonormal matrix: QᴴQ = Iₖ
# R an k-by-k upper triangular matrix: QR = A
function householder(A::Matrix{FC}; compact::Bool=false) where FC <: FloatOrComplex
  n, k = size(A)
  Q = copy(A)
  τ = zeros(FC, k)
  R = zeros(FC, k, k)
  householder!(Q, R, τ; compact)
end

function householder!(Q::AbstractMatrix{FC}, R::AbstractMatrix{FC}, τ::AbstractVector{FC}; compact::Bool=false) where FC <: FloatOrComplex
  n, k = size(Q)
  kfill!(R, zero(FC))
  kgeqrf!(Q, τ)
  copy_triangle(Q, R, k)
  !compact && korgqr!(Q, τ)
  return Q, R
end

function householder!(Q::AbstractMatrix{FC}, R::AbstractMatrix{FC}, τ::AbstractVector{FC}, buffer::AbstractVector{FC}; compact::Bool=false) where FC <: FloatOrComplex
  n, k = size(Q)
  kfill!(R, zero(FC))
  kgeqrf!(Q, τ, buffer)
  copy_triangle(Q, R, k)
  !compact && korgqr!(Q, τ, buffer)
  return Q, R
end

for (Xgeqrf, Xorgqr, Xormqr, T) in ((:sgeqrf_, :sorgqr_, :sormqr_, :Float32   ),
                                    (:dgeqrf_, :dorgqr_, :dormqr_, :Float64   ),
                                    (:cgeqrf_, :cungqr_, :cunmqr_, :ComplexF32),
                                    (:zgeqrf_, :zungqr_, :zunmqr_, :ComplexF64))
    @eval begin
        function $Xgeqrf(m, n, a, lda, tau, work, lwork, info)
          return ccall((@blasfunc($Xgeqrf), libblastrampoline), Cvoid,
                       (Ref{BlasInt}, Ref{BlasInt}, Ptr{$T}, Ref{BlasInt},
                        Ptr{$T}, Ptr{$T}, Ref{BlasInt}, Ref{BlasInt}),
                        m, n, a, lda, tau, work, lwork, info)
        end

        function kgeqrf_buffer!(A::Matrix{$T}, tau::Vector{$T})
            m, n = size(A)
            work = Ref{$T}(0)
            lda = max(1, stride(A, 2))
            $Xgeqrf(m, n, A, lda, tau, work, -1, 0)
            return work[] |> BlasInt
        end

        function kgeqrf!(A::Matrix{$T}, tau::Vector{$T}, work::Vector{$T})
            m, n = size(A)
            lwork = length(work)
            lda = max(1, stride(A, 2))
            $Xgeqrf(m, n, A, lda, tau, work, lwork, 0)
            return nothing
        end

        function $Xorgqr(m, n, k, a, lda, tau, work, lwork, info)
            return ccall((@blasfunc($Xorgqr), libblastrampoline), Cvoid,
                         (Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$T},
                          Ref{BlasInt}, Ptr{$T}, Ptr{$T}, Ref{BlasInt}, Ref{BlasInt}),
                          m, n, k, a, lda, tau, work, lwork, info)
        end

        function korgqr_buffer!(A::Matrix{$T}, tau::Vector{$T})
            m, n = size(A)
            k = length(tau)
            work = Ref{$T}(0)
            lda = max(1, stride(A, 2))
            $Xorgqr(m, n, k, A, lda, tau, work, -1, 0)
            return work[] |> BlasInt
        end

        function korgqr!(A::Matrix{$T}, tau::Vector{$T}, work::Vector{$T})
            symb = @blasfunc($Xorgqr)
            m, n = size(A)
            k = length(tau)
            lwork = length(work)
            lda = max(1, stride(A, 2))
            $Xorgqr(m, n, k, A, lda, tau, work, lwork, 0)
            return nothing
        end

        function $Xormqr(side, trans, m, n, k, a, lda, tau, c, ldc, work, lwork, info)
            return ccall((@blasfunc($Xormqr), libblastrampoline), Cvoid,
                         (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$T},
                          Ref{BlasInt}, Ptr{$T}, Ptr{$T}, Ref{BlasInt}, Ptr{$T}, Ref{BlasInt},
                          Ref{BlasInt}, Clong, Clong),
                          side, trans, m, n, k, a, lda, tau, c, ldc, work, lwork, info, 1, 1)
        end

        function kormqr_buffer!(side::Char, trans::Char, A::Matrix{$T}, tau::Vector{$T}, C::Matrix{$T})
            m, n = size(A)
            k = length(tau)
            work = Ref{$T}(0)
            lda = max(1, stride(A, 2))
            ldc = max(1, stride(C, 2))
            $Xormqr(side, trans, m, n, k, A, lda, tau, C, ldc, work, -1, 0)
            return work[] |> BlasInt
        end

        function kormqr!(side::Char, trans::Char, A::Matrix{$T}, tau::Vector{$T}, C::Matrix{$T}, work::Vector{$T})
            m, n = size(A)
            k = length(tau)
            lwork = length(work)
            lda = max(1, stride(A, 2))
            ldc = max(1, stride(C, 2))
            $Xormqr(side, trans, m, n, k, A, lda, tau, C, ldc, work, lwork, 0)
            return nothing
        end
    end
end

kgeqrf!(A :: AbstractMatrix{T}, tau :: AbstractVector{T}) where T <: BLAS.BlasFloat = LAPACK.geqrf!(A, tau)
kgeqrf!(A :: AbstractMatrix{T}, tau :: AbstractVector{T}, buffer:: AbstractVector{T}) where T <: BLAS.BlasFloat = LAPACK.geqrf!(A, tau)

korgqr!(A :: AbstractMatrix{T}, tau :: AbstractVector{T}) where T <: BLAS.BlasFloat = LAPACK.orgqr!(A, tau)
korgqr!(A :: AbstractMatrix{T}, tau :: AbstractVector{T}, buffer:: AbstractVector{T}) where T <: BLAS.BlasFloat = LAPACK.orgqr!(A, tau)

kormqr!(side :: Char, trans :: Char, A :: AbstractMatrix{T}, tau :: AbstractVector{T}, C :: AbstractMatrix{T}) where T <: BLAS.BlasFloat = LAPACK.ormqr!(side, trans, A, tau, C)
kormqr!(side :: Char, trans :: Char, A :: AbstractMatrix{T}, tau :: AbstractVector{T}, C :: AbstractMatrix{T}, buffer:: AbstractVector{T}) where T <: BLAS.BlasFloat = LAPACK.ormqr!(side, trans, A, tau, C)

# An implementation of MINRES-QLP.
#
# This method is described in
#
# S.-C. T. Choi, Iterative methods for singular linear equations and least-squares problems.
# Ph.D. thesis, ICME, Stanford University, 2006.
#
# S.-C. T. Choi, C. C. Paige and M. A. Saunders, MINRES-QLP: A Krylov subspace method for indefinite or singular symmetric systems.
# SIAM Journal on Scientific Computing, Vol. 33(4), pp. 1810--1836, 2011.
#
# S.-C. T. Choi and M. A. Saunders, Algorithm 937: MINRES-QLP for symmetric and Hermitian linear equations and least-squares problems.
# ACM Transactions on Mathematical Software, 40(2), pp. 1--12, 2014.
# 
# Negative curvature detection follows
# Liu, Yang, and Roosta, MINRES: from negative curvature detection to monotonicity properties,
# SIAM Journal on Optimization, 32(4), pp. 2636--2661, 2022.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Montreal, September 2019.

export minres_qlp, minres_qlp!

"""
    (x, stats) = minres_qlp(A, b::AbstractVector{FC};
                            M=I, ldiv::Bool=false, Artol::T=√eps(T),
                            linesearch::Bool=false, λ::T=zero(T), atol::T=√eps(T),
                            rtol::T=√eps(T), itmax::Int=0,
                            timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                            callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = minres_qlp(A, b, x0::AbstractVector; kwargs...)

MINRES-QLP can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above.

MINRES-QLP is the only method based on the Lanczos process that returns the minimum-norm
solution on singular inconsistent systems (A + λI)x = b of size n, where λ is a shift parameter.
It is significantly more complex but can be more reliable than MINRES when A is ill-conditioned.

M also indicates the weighted norm in which residuals are measured.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :minres_qlp`.

For an in-place variant that reuses memory across solves, see [`minres_qlp!`](@ref).

#### Input arguments

* `A`: a linear operator that models a Hermitian matrix of dimension `n`;
* `b`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning;
* `ldiv`: define whether the preconditioner uses `ldiv!` or `mul!`;
* `λ`: regularization parameter;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `Artol`: relative stopping tolerance based on the Aᴴ-residual norm;
* `linesearch`: if `true`, indicate that the solution is to be used in an inexact Newton method with linesearch. If `true` and nonpositive curvature is detected, the behavior depends on the iteration:
 – at iteration k = 1, the solver takes the right-hand side (i.e., the preconditioned negative gradient) as the current solution. The same search direction is returned in `workspace.npc_dir`, and `stats.npcCount` is set to 1;
 – at iteration k > 1, the solver returns the solution from iteration k – 1, the residual from iteration k is a nonpositive curvature direction stored in `stats.npc_dir` and `stats.npcCount` is set to 1;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### References

* S.-C. T. Choi, *Iterative methods for singular linear equations and least-squares problems*, Ph.D. thesis, ICME, Stanford University, 2006.
* S.-C. T. Choi, C. C. Paige and M. A. Saunders, [*MINRES-QLP: A Krylov subspace method for indefinite or singular symmetric systems*](https://doi.org/10.1137/100787921), SIAM Journal on Scientific Computing, Vol. 33(4), pp. 1810--1836, 2011.
* S.-C. T. Choi and M. A. Saunders, [*Algorithm 937: MINRES-QLP for symmetric and Hermitian linear equations and least-squares problems*](https://doi.org/10.1145/2527267), ACM Transactions on Mathematical Software, 40(2), pp. 1--12, 2014.
* Y. Liu and F. Roosta, [*MINRES: From Negative Curvature Detection to Monotonicity Properties*](https://doi.org/10.1137/21M143666X), SIAM Journal on Optimization, 32(4), pp. 2636--2661, 2022.

"""
function minres_qlp end

"""
    workspace = minres_qlp!(workspace::MinresQlpWorkspace, A, b; kwargs...)
    workspace = minres_qlp!(workspace::MinresQlpWorkspace, A, b, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`minres_qlp`](@ref).

See [`MinresQlpWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :minres_qlp` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function minres_qlp! end

def_args_minres_qlp = (:(A                    ),
                       :(b::AbstractVector{FC}))

def_optargs_minres_qlp = (:(x0::AbstractVector),)

def_kwargs_minres_qlp = (:(; M = I                        ),
                         :(; ldiv::Bool = false           ),
                         :(; linesearch::Bool = false     ),
                         :(; λ::T = zero(T)               ),
                         :(; atol::T = √eps(T)            ),
                         :(; rtol::T = √eps(T)            ),
                         :(; Artol::T = √eps(T)           ),
                         :(; itmax::Int = 0               ),
                         :(; timemax::Float64 = Inf       ),
                         :(; verbose::Int = 0             ),
                         :(; history::Bool = false        ),
                         :(; callback = workspace -> false),
                         :(; iostream::IO = kstdout       ))

def_kwargs_minres_qlp = extract_parameters.(def_kwargs_minres_qlp)

args_minres_qlp = (:A, :b)
optargs_minres_qlp = (:x0,)
kwargs_minres_qlp = (:M, :ldiv, :linesearch, :λ, :atol, :rtol, :Artol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function minres_qlp!(workspace :: MinresQlpWorkspace{T,FC,S}, $(def_args_minres_qlp...); $(def_kwargs_minres_qlp...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("System must be square")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "MINRES-QLP: system of size %d\n", n)
    (workspace.warm_start && linesearch) && error("warm_start and linesearch cannot be used together")

    # Tests M = Iₙ
    MisI = (M === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")

    # Set up workspace.
    allocate_if(!MisI, workspace, :vₖ, S, workspace.x)  # The length of vₖ is n
    allocate_if(linesearch, workspace, :npc_dir , S, workspace.x)  # The length of npc_dir is n
    if linesearch
      npc_dir = workspace.npc_dir
    end
    wₖ₋₁, wₖ, M⁻¹vₖ₋₁, M⁻¹vₖ = workspace.wₖ₋₁, workspace.wₖ, workspace.M⁻¹vₖ₋₁, workspace.M⁻¹vₖ
    Δx, x, p, stats = workspace.Δx, workspace.x, workspace.p, workspace.stats
    warm_start = workspace.warm_start
    rNorms, ArNorms, Aconds = stats.residuals, stats.Aresiduals, stats.Acond
    reset!(stats)
    vₖ = MisI ? M⁻¹vₖ : workspace.vₖ
    vₖ₊₁ = MisI ? p : M⁻¹vₖ₋₁

    # Initial solution x₀
    kfill!(x, zero(FC))

    if warm_start
      kmul!(M⁻¹vₖ, A, Δx)
      (λ ≠ 0) && kaxpy!(n, λ, Δx, M⁻¹vₖ)
      kaxpby!(n, one(FC), b, -one(FC), M⁻¹vₖ)
    else
      kcopy!(n, M⁻¹vₖ, b)  # M⁻¹vₖ ← b
    end

    # β₁v₁ = Mb
    MisI || mulorldiv!(vₖ, M, M⁻¹vₖ, ldiv)
    βₖ = knorm_elliptic(n, vₖ, M⁻¹vₖ)
    linesearch && kcopy!(n, npc_dir , vₖ)  # npc_dir  ← v; contain the preconditioned initial residual
    if βₖ ≠ 0
      kdiv!(n, M⁻¹vₖ, βₖ)
      MisI || kdiv!(n, vₖ, βₖ)
    end

    rNorm = βₖ
    ANorm² = zero(T)
    ANorm = zero(T)
    μmin = zero(T)
    μmax = zero(T)
    Acond = zero(T)
    history && push!(rNorms, rNorm)
    history && push!(Aconds, Acond)
    if rNorm == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    iter = 0
    itmax == 0 && (itmax = 2*n)

    ε = atol + rtol * rNorm
    κ = zero(T)
    (verbose > 0) && @printf(iostream, "%5s  %7s  %7s  %7s  %7s  %8s  %7s  %7s  %8s  %5s\n", "k", "‖rₖ‖", "‖Arₖ₋₁‖", "βₖ₊₁", "Rₖ.ₖ", "Lₖ.ₖ", "‖A‖", "κ(A)", "backward", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7s  %7.1e  %7s  %8s  %7.1e  %7.1e  %8s  %.2fs\n", iter, rNorm, "✗ ✗ ✗ ✗", βₖ, "✗ ✗ ✗ ✗", " ✗ ✗ ✗ ✗", ANorm, Acond, " ✗ ✗ ✗ ✗", start_time |> ktimer)

    # Set up workspace.
    kfill!(M⁻¹vₖ₋₁, zero(FC))
    ζbarₖ = βₖ
    ξₖ₋₁ = zero(T)
    τₖ₋₂ = τₖ₋₁ = τₖ = zero(T)
    ψbarₖ₋₂ = zero(T)
    μbisₖ₋₂ = μbarₖ₋₁ = zero(T)
    kfill!(wₖ₋₁, zero(FC))
    kfill!(wₖ, zero(FC))
    cₖ₋₂ = cₖ₋₁ = cₖ = one(T)   # Givens cosines used for the QR factorization of Tₖ₊₁.ₖ
    sₖ₋₂ = sₖ₋₁ = sₖ = zero(T)  # Givens sines used for the QR factorization of Tₖ₊₁.ₖ

    # Tolerance for breakdown detection.
    btol = eps(T)^(3/4)

    # Stopping criterion.
    breakdown = false
    solved = zero_resid = zero_resid_lim = rNorm ≤ ε
    zero_resid_mach = false
    inconsistent = false
    ill_cond_mach = false
    tired = iter ≥ itmax
    status = "unknown"
    user_requested_exit = false
    overtimed = false
    stats.indefinite = false

    while !(solved || tired || inconsistent || ill_cond_mach || breakdown || user_requested_exit || overtimed)
      # Update iteration index.
      iter = iter + 1

      # Continue the preconditioned Lanczos process.
      # M(A + λI)Vₖ = Vₖ₊₁Tₖ₊₁.ₖ
      # βₖ₊₁vₖ₊₁ = M(A + λI)vₖ - αₖvₖ - βₖvₖ₋₁

      kmul!(p, A, vₖ)        # p ← Avₖ
      if λ ≠ 0
        kaxpy!(n, λ, vₖ, p)  # p ← p + λvₖ
      end

      if iter ≥ 2
        kaxpy!(n, -βₖ, M⁻¹vₖ₋₁, p)  # p ← p - βₖ * M⁻¹vₖ₋₁
      end

      αₖ = kdotr(n, vₖ, p)  # αₖ = ⟨vₖ,p⟩

      kaxpy!(n, -αₖ, M⁻¹vₖ, p)  # p ← p - αₖM⁻¹vₖ

      MisI || mulorldiv!(vₖ₊₁, M, p, ldiv)  # βₖ₊₁vₖ₊₁ = MAvₖ - γₖvₖ₋₁ - αₖvₖ

      βₖ₊₁ = knorm_elliptic(m, vₖ₊₁, p)

      # βₖ₊₁.ₖ ≠ 0
      if βₖ₊₁ > btol
        kdiv!(m, vₖ₊₁, βₖ₊₁)
        MisI || kdiv!(m, p, βₖ₊₁)
      end

      ANorm² = ANorm² + αₖ * αₖ + βₖ * βₖ + βₖ₊₁ * βₖ₊₁

      # Update the QR factorization of Tₖ₊₁.ₖ = Qₖ [ Rₖ ].
      #                                            [ Oᵀ ]
      #
      # [ α₁ β₂ 0  •  •  •   0  ]      [ λ₁ γ₁ ϵ₁ 0  •  •  0  ]
      # [ β₂ α₂ β₃ •         •  ]      [ 0  λ₂ γ₂ •  •     •  ]
      # [ 0  •  •  •  •      •  ]      [ •  •  λ₃ •  •  •  •  ]
      # [ •  •  •  •  •  •   •  ] = Qₖ [ •     •  •  •  •  0  ]
      # [ •     •  •  •  •   0  ]      [ •        •  •  • ϵₖ₋₂]
      # [ •        •  •  •   βₖ ]      [ •           •  • γₖ₋₁]
      # [ •           •  βₖ  αₖ ]      [ 0  •  •  •  •  0  λₖ ]
      # [ 0  •  •  •  •  0  βₖ₊₁]      [ 0  •  •  •  •  •  0  ]
      #
      # If k = 1, we don't have any previous reflection.
      # If k = 2, we apply the last reflection.
      # If k ≥ 3, we only apply the two previous reflections.

      # Apply previous Givens reflections Qₖ₋₂.ₖ₋₁
      if iter ≥ 3
        # [cₖ₋₂  sₖ₋₂] [0 ] = [  ϵₖ₋₂ ]
        # [sₖ₋₂ -cₖ₋₂] [βₖ]   [γbarₖ₋₁]
        ϵₖ₋₂    =  sₖ₋₂ * βₖ
        γbarₖ₋₁ = -cₖ₋₂ * βₖ
      end
      # Apply previous Givens reflections Qₖ₋₁.ₖ
      if iter ≥ 2
        iter == 2 && (γbarₖ₋₁ = βₖ)
        # [cₖ₋₁  sₖ₋₁] [γbarₖ₋₁] = [γₖ₋₁ ]
        # [sₖ₋₁ -cₖ₋₁] [   αₖ  ]   [λbarₖ]
        γₖ₋₁  = cₖ₋₁ * γbarₖ₋₁ + sₖ₋₁ * αₖ
        λbarₖ = sₖ₋₁ * γbarₖ₋₁ - cₖ₋₁ * αₖ
      end
      iter == 1 && (λbarₖ = αₖ)

      # Check for nonpositive curvature
      if linesearch
        # if the first iteration, we need to check c₁ * λbar₁ = -α₁
        if iter == 1
          cγ = -αₖ
        else
          cγ = cₖ₋₁ * λbarₖ
        end
        if cγ ≥ 0
          if iter == 1
            kcopy!(n, x, b)
          end
          # Nonpositive curvature detected.
          (verbose > 0) && @printf(iostream, "nonpositive curvature detected:  cₖ * λbarₖ = %e\n", cγ)
          stats.solved = true
          stats.npcCount = 1
          stats.niter = iter
          stats.inconsistent = false
          stats.timer = start_time |> ktimer
          stats.status = "nonpositive curvature"
          workspace.warm_start = false
          stats.indefinite = true
          return workspace
        end
      end

      # Compute and apply current Givens reflection Qₖ.ₖ₊₁
      # [cₖ  sₖ] [λbarₖ] = [λₖ]
      # [sₖ -cₖ] [βₖ₊₁ ]   [0 ]
      (cₖ, sₖ, λₖ) = sym_givens(λbarₖ, βₖ₊₁)

      # Compute z̅ₖ₊₁ = [   zₖ  ] = (Qₖ)ᴴβ₁e₁
      #                [ζbarₖ₊₁]
      #
      # [cₖ  sₖ] [ζbarₖ] = [   ζₖ  ]
      # [sₖ -cₖ] [  0  ]   [ζbarₖ₊₁]
      ζₖ      = cₖ * ζbarₖ
      ζbarₖ₊₁ = sₖ * ζbarₖ

      # check for nonpositive curvature
      if linesearch
        kscal!(n, sₖ * sₖ, npc_dir)  # npc_dir  = sₖ * sₖ * npc_dir
        kaxpy!(n, -ζbarₖ₊₁ * cₖ , vₖ₊₁, npc_dir)  # npc_dir  = npc_dir  - ζbarₖ * cₖ * vₖ, this is rₖ
      end
      
      # Update the LQ factorization of Rₖ = LₖPₖ.
      # [ λ₁ γ₁ ϵ₁ 0  •  •  0  ]   [ μ₁   0    •    •     •      •      0  ]
      # [ 0  λ₂ γ₂ •  •     •  ]   [ ψ₁   μ₂   •                        •  ]
      # [ •  •  λ₃ •  •  •  •  ]   [ ρ₁   ψ₂   μ₃   •                   •  ]
      # [ •     •  •  •  •  0  ] = [ 0    •    •    •     •             •  ] Pₖ
      # [ •        •  •  • ϵₖ₋₂]   [ •    •    •    •   μₖ₋₂     •      •  ]
      # [ •           •  • γₖ₋₁]   [ •         •    •   ψₖ₋₂  μbisₖ₋₁   0  ]
      # [ 0  •  •  •  •  0  λₖ ]   [ 0    •    •    0   ρₖ₋₂  ψbarₖ₋₁ μbarₖ]

      if iter == 1
        μbarₖ = λₖ
      elseif iter == 2
        # [μbar₁ γ₁] [cp₂  sp₂] = [μbis₁   0  ]
        # [  0   λ₂] [sp₂ -cp₂]   [ψbar₁ μbar₂]
        (cpₖ, spₖ, μbisₖ₋₁) = sym_givens(μbarₖ₋₁, γₖ₋₁)
        ψbarₖ₋₁ =  spₖ * λₖ
        μbarₖ   = -cpₖ * λₖ
      else
        # [μbisₖ₋₂   0     ϵₖ₋₂] [cpₖ  0   spₖ]   [μₖ₋₂   0     0 ]
        # [ψbarₖ₋₂ μbarₖ₋₁ γₖ₋₁] [ 0   1    0 ] = [ψₖ₋₂ μbarₖ₋₁ θₖ]
        # [  0       0      λₖ ] [spₖ  0  -cpₖ]   [ρₖ₋₂   0     ηₖ]
        (cpₖ, spₖ, μₖ₋₂) = sym_givens(μbisₖ₋₂, ϵₖ₋₂)
        ψₖ₋₂ =  cpₖ * ψbarₖ₋₂ + spₖ * γₖ₋₁
        θₖ   =  spₖ * ψbarₖ₋₂ - cpₖ * γₖ₋₁
        ρₖ₋₂ =  spₖ * λₖ
        ηₖ   = -cpₖ * λₖ

        # [μₖ₋₂   0     0 ] [1   0    0 ]   [μₖ₋₂   0       0  ]
        # [ψₖ₋₂ μbarₖ₋₁ θₖ] [0  cdₖ  sdₖ] = [ψₖ₋₂ μbisₖ₋₁   0  ]
        # [ρₖ₋₂   0     ηₖ] [0  sdₖ -cdₖ]   [ρₖ₋₂ ψbarₖ₋₁ μbarₖ]
        (cdₖ, sdₖ, μbisₖ₋₁) = sym_givens(μbarₖ₋₁, θₖ)
        ψbarₖ₋₁ =  sdₖ * ηₖ
        μbarₖ   = -cdₖ * ηₖ
      end

      # Compute Lₖtₖ = zₖ
      # [ μ₁   0    •    •     •      •      0  ] [τ₁]   [ζ₁]
      # [ ψ₁   μ₂   •                        •  ] [τ₂]   [ζ₂]
      # [ ρ₁   ψ₂   μ₃   •                   •  ] [τ₃]   [ζ₃]
      # [ 0    •    •    •     •             •  ] [••] = [••]
      # [ •    •    •    •   μₖ₋₂     •      •  ] [••]   [••]
      # [ •         •    •   ψₖ₋₂  μbisₖ₋₁   0  ] [••]   [••]
      # [ 0    •    •    0   ρₖ₋₂  ψbarₖ₋₁ μbarₖ] [τₖ]   [ζₖ]
      if iter == 1
        τₖ = ζₖ / μbarₖ
      elseif iter == 2
        τₖ₋₁ = τₖ
        τₖ₋₁ = τₖ₋₁ * μbarₖ₋₁ / μbisₖ₋₁
        ξₖ   = ζₖ
        τₖ   = (ξₖ - ψbarₖ₋₁ * τₖ₋₁) / μbarₖ
      else
        τₖ₋₂ = τₖ₋₁
        τₖ₋₂ = τₖ₋₂ * μbisₖ₋₂ / μₖ₋₂
        τₖ₋₁ = (ξₖ₋₁ - ψₖ₋₂ * τₖ₋₂) / μbisₖ₋₁
        ξₖ   = ζₖ - ρₖ₋₂ * τₖ₋₂
        τₖ   = (ξₖ - ψbarₖ₋₁ * τₖ₋₁) / μbarₖ
      end

      # Compute directions wₖ₋₂, ẘₖ₋₁ and w̄ₖ, last columns of Wₖ = Vₖ(Pₖ)ᴴ
      if iter == 1
        # w̅₁ = v₁
        kcopy!(n, wₖ, vₖ)
      elseif iter == 2
        # [w̅ₖ₋₁ vₖ] [cpₖ  spₖ] = [ẘₖ₋₁ w̅ₖ] ⟷ ẘₖ₋₁ = cpₖ * w̅ₖ₋₁ + spₖ * vₖ
        #           [spₖ -cpₖ]             ⟷ w̅ₖ   = spₖ * w̅ₖ₋₁ - cpₖ * vₖ
        @kswap!(wₖ₋₁, wₖ)
        # Compute w̅ₖ
        kcopy!(n, wₖ, wₖ₋₁)
        kaxpby!(n, -cpₖ, vₖ, spₖ, wₖ)
        # Compute ẘₖ₋₁
        kaxpby!(n, spₖ, vₖ, cpₖ, wₖ₋₁)
      else
        # [ẘₖ₋₂ w̄ₖ₋₁ vₖ] [cpₖ  0   spₖ] [1   0    0 ] = [wₖ₋₂ ẘₖ₋₁ w̄ₖ] ⟷ wₖ₋₂ = cpₖ * ẘₖ₋₂ + spₖ * vₖ
        #                [ 0   1    0 ] [0  cdₖ  sdₖ]                  ⟷ ẘₖ₋₁ = cdₖ * w̄ₖ₋₁ + sdₖ * (spₖ * ẘₖ₋₂ - cpₖ * vₖ)
        #                [spₖ  0  -cpₖ] [0  sdₖ -cdₖ]                  ⟷ w̄ₖ   = sdₖ * w̄ₖ₋₁ - cdₖ * (spₖ * ẘₖ₋₂ - cpₖ * vₖ)
        ẘₖ₋₂ = wₖ₋₁
        w̄ₖ₋₁ = wₖ
        # Update the solution x
        kaxpy!(n, cpₖ * τₖ₋₂, ẘₖ₋₂, x)
        kaxpy!(n, spₖ * τₖ₋₂, vₖ, x)
        # Compute wₐᵤₓ = spₖ * ẘₖ₋₂ - cpₖ * vₖ
        kaxpby!(n, -cpₖ, vₖ, spₖ, ẘₖ₋₂)
        wₐᵤₓ = ẘₖ₋₂
        # Compute ẘₖ₋₁ and w̄ₖ
        kref!(n, w̄ₖ₋₁, wₐᵤₓ, cdₖ, sdₖ)
        @kswap!(wₖ₋₁, wₖ)
      end

      # Update vₖ, M⁻¹vₖ₋₁, M⁻¹vₖ
      MisI || kcopy!(n, vₖ, vₖ₊₁)  # vₖ ← vₖ₊₁
      kcopy!(n, M⁻¹vₖ₋₁, M⁻¹vₖ)    # M⁻¹vₖ₋₁ ← M⁻¹vₖ
      kcopy!(n, M⁻¹vₖ, p)          # M⁻¹vₖ ← p

      # Update ‖rₖ‖ estimate
      # ‖ rₖ ‖ = |ζbarₖ₊₁|
      rNorm = abs(ζbarₖ₊₁)
      history && push!(rNorms, rNorm)

      # Update ‖Arₖ₋₁‖ estimate
      # ‖ Arₖ₋₁ ‖ = |ζbarₖ| * √(|λbarₖ|² + |γbarₖ|²)
      ArNorm = abs(ζbarₖ) * √(abs2(λbarₖ) + abs2(cₖ₋₁ * βₖ₊₁))
      iter == 1 && (κ = atol + Artol * ArNorm)
      history && push!(ArNorms, ArNorm)

      ANorm = sqrt(ANorm²)
      # estimate A condition number
      abs_μbarₖ = abs(μbarₖ)
      if iter == 1
        μmin = abs_μbarₖ
        μmax = abs_μbarₖ
      elseif iter == 2
        μmax = max(μmax, μbisₖ₋₁, abs_μbarₖ)
        μmin = min(μmin, μbisₖ₋₁, abs_μbarₖ)
      else
        μmax = max(μmax, μₖ₋₂, μbisₖ₋₁, abs_μbarₖ)
        μmin = min(μmin, μₖ₋₂, μbisₖ₋₁, abs_μbarₖ)
      end
      Acond = μmax / μmin
      history && push!(Aconds, Acond)
      xNorm = knorm(n, x)
      backward = rNorm / (ANorm * xNorm)

      # Update stopping criterion.
      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      ill_cond_mach = (one(T) + inv(Acond) ≤ one(T))
      resid_decrease_mach = (one(T) + rNorm ≤ one(T))
      zero_resid_mach = (one(T) + backward ≤ one(T))

      # Stopping conditions based on user-provided tolerances.
      tired = iter ≥ itmax
      resid_decrease_lim = (rNorm ≤ ε)
      zero_resid_lim = MisI && (backward ≤ eps(T))
      breakdown = βₖ₊₁ ≤ btol

      user_requested_exit = callback(workspace) :: Bool
      zero_resid = zero_resid_mach | zero_resid_lim
      resid_decrease = resid_decrease_mach | resid_decrease_lim
      solved = resid_decrease | zero_resid
      inconsistent = (ArNorm ≤ κ && abs(μbarₖ) ≤ Artol) || (breakdown && !solved)
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns

      # Update variables
      if iter ≥ 2
        sₖ₋₂ = sₖ₋₁
        cₖ₋₂ = cₖ₋₁
        ξₖ₋₁ = ξₖ
        μbisₖ₋₂ = μbisₖ₋₁
        ψbarₖ₋₂ = ψbarₖ₋₁
      end
      sₖ₋₁ = sₖ
      cₖ₋₁ = cₖ
      μbarₖ₋₁ = μbarₖ
      ζbarₖ = ζbarₖ₊₁
      βₖ = βₖ₊₁
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %7.1e  %8.1e  %7.1e  %7.1e  %8.1e  %.2fs\n", iter, rNorm, ArNorm, βₖ₊₁, λₖ, μbarₖ, ANorm, Acond, backward, start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Finalize the update of x
    if iter ≥ 2
      kaxpy!(n, τₖ₋₁, wₖ₋₁, x)
    end
    if !inconsistent
      kaxpy!(n, τₖ, wₖ, x)
    end

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    ill_cond_mach       && (status = "condition number seems too large for this machine")
    inconsistent        && (status = "found approximate minimum least-squares solution")
    zero_resid          && (status = "found approximate zero-residual solution")
    solved              && (status = "solution good enough given atol and rtol")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update x
    warm_start && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

   # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = inconsistent
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

# Wrappers that turn C function pointers into Julia linear operators.
#
# The C caller passes:
#   void matvec(const double *x, double *y, void *userdata)   -- computes y = A*x
#   void rmatvec(const double *x, double *y, void *userdata)  -- computes y = A'*x
#   void matvec(const double *x, double *y, void *userdata)   -- computes y = M\x  (preconditioner)
#
# We wrap these in a struct that satisfies the Krylov.jl operator protocol:
#   mul!(y, op, x),  mul!(y, op', x)  and  size(op) -> (m, n)
#
# Solvers that only apply A (CG, GMRES, MINRES, ...) only need fptr_A.
# Solvers that also apply A' (LSQR, LSMR, CGLS, ...) also need fptr_At.
# Pass C_NULL for fptr_At when the solver does not require it.

# ---------------------------------------------------------------------------
# C callback signatures (typedef'd in krylov.h)
# ---------------------------------------------------------------------------
# typedef void (*KrylovMatvec)(const void *x, void *y, void *userdata);

# ---------------------------------------------------------------------------
# COperator: wraps C matvec + rmatvec function pointers as a Julia operator
# ---------------------------------------------------------------------------
struct COperator{T}
  m        :: Int
  n        :: Int
  fptr     :: Ptr{Cvoid}   # y = A*x
  fptr_t   :: Ptr{Cvoid}   # y = A'*x  (C_NULL if not needed)
  userdata :: Ptr{Cvoid}
end

Base.size(op::COperator)         = (op.m, op.n)
Base.size(op::COperator, d::Int) = d == 1 ? op.m : op.n
Base.eltype(::COperator{T}) where T = T

function LinearAlgebra.mul!(y::AbstractVector{T}, op::COperator{T}, x::AbstractVector{T}) where T
  GC.@preserve x y begin
    xptr = Base.unsafe_convert(Ptr{Cvoid}, pointer(x))
    yptr = Base.unsafe_convert(Ptr{Cvoid}, pointer(y))
    ccall(op.fptr, Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}), xptr, yptr, op.userdata)
  end
  return y
end

# Adjoint wrapper — returned by adjoint(op), used by solvers that call A'*v
struct COperatorAdjoint{T}
  op :: COperator{T}
end

Base.size(ot::COperatorAdjoint)         = (ot.op.n, ot.op.m)
Base.size(ot::COperatorAdjoint, d::Int) = d == 1 ? ot.op.n : ot.op.m
Base.eltype(::COperatorAdjoint{T}) where T = T

LinearAlgebra.adjoint(op::COperator{T}) where T = COperatorAdjoint{T}(op)
LinearAlgebra.adjoint(ot::COperatorAdjoint{T}) where T = ot.op

function LinearAlgebra.mul!(y::AbstractVector{T}, ot::COperatorAdjoint{T}, x::AbstractVector{T}) where T
  ot.op.fptr_t != C_NULL || error("A' matvec requested but fptr_t is NULL — pass matvec_At to krylov_solve")
  GC.@preserve x y begin
    xptr = Base.unsafe_convert(Ptr{Cvoid}, pointer(x))
    yptr = Base.unsafe_convert(Ptr{Cvoid}, pointer(y))
    ccall(ot.op.fptr_t, Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}), xptr, yptr, ot.op.userdata)
  end
  return y
end

# Preconditioner variant: same layout, but invoked via ldiv! semantics.
# In Krylov.jl you pass ldiv=false and a normal mul! operator, so we use
# a plain mul! here too — the C side is responsible for applying M^{-1}.
struct CPreconditioner{T}
  n        :: Int
  fptr     :: Ptr{Cvoid}
  userdata :: Ptr{Cvoid}
end

Base.size(p::CPreconditioner)         = (p.n, p.n)
Base.size(p::CPreconditioner, d::Int) = p.n
Base.eltype(::CPreconditioner{T}) where T = T

function LinearAlgebra.mul!(y::AbstractVector{T}, p::CPreconditioner{T}, x::AbstractVector{T}) where T
  GC.@preserve x y begin
    xptr = Base.unsafe_convert(Ptr{Cvoid}, pointer(x))
    yptr = Base.unsafe_convert(Ptr{Cvoid}, pointer(y))
    ccall(p.fptr, Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}), xptr, yptr, p.userdata)
  end
  return y
end

# ---------------------------------------------------------------------------
# CBlockOperator: wraps a C block-matvec for the block Krylov solvers.
#
# The block solvers (block_gmres, block_minres) apply the operator to a whole
# block of p columns at once via mul!(Y, op, X) where X is n×p and Y is m×p.
# The C callback receives the column-major buffers and the block width p:
#
#   void KrylovBlockMatvec(const void *X, void *Y, int p, void *userdata);
#
# The same wrapper is reused for the preconditioner M (applied as Y = M⁻¹·X).
# ---------------------------------------------------------------------------
struct CBlockOperator{T}
  m        :: Int
  n        :: Int
  fptr     :: Ptr{Cvoid}
  userdata :: Ptr{Cvoid}
end

Base.size(op::CBlockOperator)         = (op.m, op.n)
Base.size(op::CBlockOperator, d::Int) = d == 1 ? op.m : op.n
Base.eltype(::CBlockOperator{T}) where T = T

function LinearAlgebra.mul!(Y::AbstractMatrix{T}, op::CBlockOperator{T}, X::AbstractMatrix{T}) where T
  p = size(X, 2)
  GC.@preserve X Y begin
    xptr = Base.unsafe_convert(Ptr{Cvoid}, pointer(X))
    yptr = Base.unsafe_convert(Ptr{Cvoid}, pointer(Y))
    ccall(op.fptr, Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Cint, Ptr{Cvoid}), xptr, yptr, Cint(p), op.userdata)
  end
  return Y
end

# ---------------------------------------------------------------------------
# Helpers to build operators from C pointers
# ---------------------------------------------------------------------------
function make_operator(::Type{T}, m::Int, n::Int, fptr::Ptr{Cvoid}, fptr_t::Ptr{Cvoid}, userdata::Ptr{Cvoid}) where T
  return COperator{T}(m, n, fptr, fptr_t, userdata)
end

function make_preconditioner(::Type{T}, n::Int, fptr::Ptr{Cvoid}, userdata::Ptr{Cvoid}) where T
  return CPreconditioner{T}(n, fptr, userdata)
end

# An implementation of BICGSTAB for the solution of unsymmetric and square consistent linear system Ax = b.
#
# This method is described in
#
# H. A. van der Vorst
# Bi-CGSTAB: A fast and smoothly converging variant of Bi-CG for the solution of nonsymmetric linear systems.
# SIAM Journal on Scientific and Statistical Computing, 13(2), pp. 631--644, 1992.
#
# G. L.G. Sleijpen and D. R. Fokkema
# BiCGstab(ℓ) for linear equations involving unsymmetric matrices with complex spectrum.
# Electronic Transactions on Numerical Analysis, 1, pp. 11--32, 1993.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Montréal, October 2020.

export bicgstab, bicgstab!

"""
    (x, stats) = bicgstab(A, b::AbstractVector{FC};
                          c::AbstractVector{FC}=b, M=I, N=I,
                          ldiv::Bool=false, atol::T=√eps(T),
                          rtol::T=√eps(T), itmax::Int=0,
                          timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                          callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = bicgstab(A, b, x0::AbstractVector; kwargs...)

BICGSTAB can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above.

Solve the square linear system Ax = b of size n using BICGSTAB.
BICGSTAB requires two initial vectors `b` and `c`.
The relation `bᴴc ≠ 0` must be satisfied and by default `c = b`.

The Biconjugate Gradient Stabilized method is a variant of BiCG, like CGS,
but using different updates for the Aᴴ-sequence in order to obtain smoother
convergence than CGS.

If BICGSTAB stagnates, we recommend DQGMRES and BiLQ as alternative methods for unsymmetric square systems.

BICGSTAB stops when `itmax` iterations are reached or when `‖rₖ‖ ≤ atol + ‖b‖ * rtol`.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :bicgstab`.

For an in-place variant that reuses memory across solves, see [`bicgstab!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `n`;
* `b`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `c`: the second initial vector of length `n` required by the Lanczos biorthogonalization process;
* `M`: linear operator that models a nonsingular matrix of size `n` used for left preconditioning;
* `N`: linear operator that models a nonsingular matrix of size `n` used for right preconditioning;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### References

* H. A. van der Vorst, [*Bi-CGSTAB: A fast and smoothly converging variant of Bi-CG for the solution of nonsymmetric linear systems*](https://doi.org/10.1137/0913035), SIAM Journal on Scientific and Statistical Computing, 13(2), pp. 631--644, 1992.
* G. L.G. Sleijpen and D. R. Fokkema, [*BiCGstab(ℓ) for linear equations involving unsymmetric matrices with complex spectrum*](https://www.emis.de/journals/ETNA/volumes/1993-2000/vol1/abstract_vol1_pp11-32.html), Electronic Transactions on Numerical Analysis, 1, pp. 11--32, 1993.
"""
function bicgstab end

"""
    workspace = bicgstab!(workspace::BicgstabWorkspace, A, b; kwargs...)
    workspace = bicgstab!(workspace::BicgstabWorkspace, A, b, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`bicgstab`](@ref).

See [`BicgstabWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :bicgstab` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function bicgstab! end

def_args_bicgstab = (:(A                    ),
                     :(b::AbstractVector{FC}))

def_optargs_bicgstab = (:(x0::AbstractVector),)

def_kwargs_bicgstab = (:(; c::AbstractVector{FC} = b    ),
                       :(; M = I                        ),
                       :(; N = I                        ),
                       :(; ldiv::Bool = false           ),
                       :(; atol::T = √eps(T)            ),
                       :(; rtol::T = √eps(T)            ),
                       :(; itmax::Int = 0               ),
                       :(; timemax::Float64 = Inf       ),
                       :(; verbose::Int = 0             ),
                       :(; history::Bool = false        ),
                       :(; callback = workspace -> false),
                       :(; iostream::IO = kstdout       ))

def_kwargs_bicgstab = extract_parameters.(def_kwargs_bicgstab)

args_bicgstab = (:A, :b)
optargs_bicgstab = (:x0,)
kwargs_bicgstab = (:c, :M, :N, :ldiv, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function bicgstab!(workspace :: BicgstabWorkspace{T,FC,S}, $(def_args_bicgstab...); $(def_kwargs_bicgstab...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("System must be square")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "BICGSTAB: system of size %d\n", n)

    # Check M = Iₙ and N = Iₙ
    MisI = (M === I)
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")
    ktypeof(c) == S || error("ktypeof(c) must be equal to $S")

    # Set up workspace.
    allocate_if(!MisI, workspace, :t , S, workspace.x)  # The length of t is n
    allocate_if(!NisI, workspace, :yz, S, workspace.x)  # The length of yz is n
    Δx, x, r, p, v, s, qd, stats = workspace.Δx, workspace.x, workspace.r, workspace.p, workspace.v, workspace.s, workspace.qd, workspace.stats
    warm_start = workspace.warm_start
    rNorms = stats.residuals
    reset!(stats)
    q = d = workspace.qd
    t = MisI ? d : workspace.t
    y = NisI ? p : workspace.yz
    z = NisI ? s : workspace.yz
    r₀ = MisI ? r : workspace.qd

    if warm_start
      kmul!(r₀, A, Δx)
      kaxpby!(n, one(FC), b, -one(FC), r₀)
    else
      kcopy!(n, r₀, b)  # r₀ ← b
    end

    kfill!(x, zero(FC))                 # x₀
    kfill!(s, zero(FC))                 # s₀
    kfill!(v, zero(FC))                 # v₀
    MisI || mulorldiv!(r, M, r₀, ldiv)  # r₀
    kcopy!(n, p, r)                     # p₁

    α = one(FC)  # α₀
    ω = one(FC)  # ω₀
    ρ = one(FC)  # ρ₀

    # Compute residual norm ‖r₀‖₂.
    rNorm = knorm(n, r)
    history && push!(rNorms, rNorm)
    if rNorm == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    iter = 0
    itmax == 0 && (itmax = 2*n)

    ε = atol + rtol * rNorm
    (verbose > 0) && @printf(iostream, "%5s  %7s  %8s  %8s  %5s\n", "k", "‖rₖ‖", "|αₖ|", "|ωₖ|", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %8.1e  %8.1e  %.2fs\n", iter, rNorm, abs(α), abs(ω), start_time |> ktimer)

    next_ρ = kdot(n, c, r)  # ρ₁ = ⟨r̅₀,r₀⟩
    if next_ρ == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = false, false
      stats.timer = start_time |> ktimer
      stats.status = "Breakdown bᴴc = 0"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    # Stopping criterion.
    solved = rNorm ≤ ε
    tired = iter ≥ itmax
    breakdown = false
    status = "unknown"
    user_requested_exit = false
    overtimed = false

    while !(solved || tired || breakdown || user_requested_exit || overtimed)
      # Update iteration index and ρ.
      iter = iter + 1
      ρ = next_ρ

      NisI || mulorldiv!(y, N, p, ldiv)  # yₖ = N⁻¹pₖ
      kmul!(q, A, y)                     # qₖ = Ayₖ
      mulorldiv!(v, M, q, ldiv)          # vₖ = M⁻¹qₖ
      α = ρ / kdot(n, c, v)              # αₖ = ⟨r̅₀,rₖ₋₁⟩ / ⟨r̅₀,vₖ⟩
      kcopy!(n, s, r)                    # sₖ = rₖ₋₁
      kaxpy!(n, -α, v, s)                # sₖ = sₖ - αₖvₖ
      kaxpy!(n, α, y, x)                 # xₐᵤₓ = xₖ₋₁ + αₖyₖ
      NisI || mulorldiv!(z, N, s, ldiv)  # zₖ = N⁻¹sₖ
      kmul!(d, A, z)                     # dₖ = Azₖ
      MisI || mulorldiv!(t, M, d, ldiv)  # tₖ = M⁻¹dₖ
      ω = kdot(n, t, s) / kdot(n, t, t)  # ⟨tₖ,sₖ⟩ / ⟨tₖ,tₖ⟩
      kaxpy!(n, ω, z, x)                 # xₖ = xₐᵤₓ + ωₖzₖ
      kcopy!(n, r, s)                    # rₖ = sₖ
      kaxpy!(n, -ω, t, r)                # rₖ = rₖ - ωₖtₖ
      next_ρ = kdot(n, c, r)             # ρₖ₊₁ = ⟨r̅₀,rₖ⟩
      β = (next_ρ / ρ) * (α / ω)         # βₖ₊₁ = (ρₖ₊₁ / ρₖ) * (αₖ / ωₖ)
      kaxpy!(n, -ω, v, p)                # pₐᵤₓ = pₖ - ωₖvₖ
      kaxpby!(n, one(FC), r, β, p)       # pₖ₊₁ = rₖ₊₁ + βₖ₊₁pₐᵤₓ

      # Compute residual norm ‖rₖ‖₂.
      rNorm = knorm(n, r)
      history && push!(rNorms, rNorm)

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      resid_decrease_mach = (rNorm + one(T) ≤ one(T))

      # Update stopping criterion.
      user_requested_exit = callback(workspace) :: Bool
      resid_decrease_lim = rNorm ≤ ε
      solved = resid_decrease_lim || resid_decrease_mach
      tired = iter ≥ itmax
      breakdown = (α == 0 || isnan(α))
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %8.1e  %8.1e  %.2fs\n", iter, rNorm, abs(α), abs(ω), start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    breakdown           && (status = "breakdown αₖ == 0")
    solved              && (status = "solution good enough given atol and rtol")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update x
    warm_start && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = false
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

"""
    V, Ψ, T = hermitian_lanczos(A, B, k; algo="householder")

#### Input arguments

* `A`: a linear operator that models a Hermitian matrix of dimension `n`;
* `B`: a matrix of size `n × p`;
* `k`: the number of iterations of the block Hermitian Lanczos process.

#### Keyword arguments

* `algo`: the algorithm to perform reduced QR factorizations (`"gs"`, `"mgs"`, `"givens"` or `"householder"`).

#### Output arguments

* `V`: a dense `n × p(k+1)` matrix;
* `Ψ`: a dense `p × p` upper triangular matrix such that `V₁Ψ = B`;
* `T`: a sparse `p(k+1) × pk` block tridiagonal matrix with a bandwidth `p`.
"""
function hermitian_lanczos(A, B::AbstractMatrix{FC}, k::Int; algo::String="householder") where FC <: FloatOrComplex
  m, n = size(A)
  t, p = size(B)

  nnzT = p*p + (k-1)*p*(2*p+1) + div(p*(p+1), 2)
  colptr = zeros(Int, p*k+1)
  rowval = zeros(Int, nnzT)
  nzval = zeros(FC, nnzT)

  colptr[1] = 1
  for j = 1:k*p
    pos = colptr[j]
    for i = max(1, j-p):j+p
      rowval[pos] = i
      pos += 1
    end
    colptr[j+1] = pos
  end

  V = zeros(FC, n, (k+1)*p)
  T = SparseMatrixCSC((k+1)*p, k*p, colptr, rowval, nzval)

  α = -one(FC)
  β = one(FC)
  q = zeros(FC, n, p)
  ψ₁ = zeros(FC, p, p)
  Ωᵢ = Ψᵢ = Ψᵢ₊₁ = zeros(FC, p, p)

  for i = 1:k
    pos1 = (i-1)*p + 1
    pos2 = i*p
    pos3 = pos1 + p
    pos4 = pos2 + p
    vᵢ = view(V,:,pos1:pos2)
    vᵢ₊₁ = view(V,:,pos3:pos4)

    if i == 1
      q .= B
      reduced_qr!(q, ψ₁, algo)
      vᵢ .= q
    end

    mul!(q, A, vᵢ)

    if i ≥ 2
      pos5 = pos1 - p
      pos6 = pos2 - p
      vᵢ₋₁ = view(V,:,pos5:pos6)
      mul!(q, vᵢ₋₁, Ψᵢ', α, β)  # q = q - vᵢ₋₁ * Ψᵢᴴ
    end

    mul!(Ωᵢ, vᵢ', q)       # Ωᵢ = vᵢᴴ * q
    mul!(q, vᵢ, Ωᵢ, α, β)  # q = q - vᵢ * Ωᵢᴴ

    # Store the block Ωᵢ in Tₖ₊₁.ₖ
    for ii = 1:p
      indi = pos1+ii-1
      for jj = 1:p
        indj = pos1+jj-1
        T[indi,indj] = Ωᵢ[ii,jj]
      end
    end

    reduced_qr!(q, Ψᵢ₊₁, algo)
    vᵢ₊₁ .= q

    # Store the block Ψᵢ₊₁ in Tₖ₊₁.ₖ
    for ii = 1:p
      indi = pos3+ii-1
      for jj = 1:p
        indj = pos1+jj-1
        (ii ≤ jj) && (T[indi,indj] = Ψᵢ₊₁[ii,jj])
        (ii ≤ jj) && (i < k) && (T[indj,indi] = conj(Ψᵢ₊₁[ii,jj]))
      end
    end
  end
  return V, ψ₁, T
end

"""
    V, Ψ, T, U, Φᴴ, Tᴴ = nonhermitian_lanczos(A, B, C, k)

#### Input arguments

* `A`: a linear operator that models a square matrix of dimension `n`;
* `B`: a matrix of size `n × p`;
* `C`: a matrix of size `n × p`;
* `k`: the number of iterations of the block non-Hermitian Lanczos process.

#### Output arguments

* `V`: a dense `n × p(k+1)` matrix;
* `Ψ`: a dense `p × p` upper triangular matrix such that `V₁Ψ = B`;
* `T`: a sparse `p(k+1) × pk` block tridiagonal matrix with a bandwidth `p`;
* `U`: a dense `n × p(k+1)` matrix;
* `Φᴴ`: a dense `p × p` upper triangular matrix such that `U₁Φᴴ = C`;
* `Tᴴ`: a sparse `p(k+1) × pk` block tridiagonal matrix with a bandwidth `p`.
"""
function nonhermitian_lanczos(A, B::AbstractMatrix{FC}, C::AbstractMatrix{FC}, k::Int) where FC <: FloatOrComplex
  m, n = size(A)
  t, p = size(B)
  Aᴴ = A'
  pivoting = NoPivot()

  nnzT = p*p + (k-1)*p*(2*p+1) + div(p*(p+1), 2)
  colptr = zeros(Int, p*k+1)
  rowval = zeros(Int, nnzT)
  nzval_T = zeros(FC, nnzT)
  nzval_Tᴴ = zeros(FC, nnzT)

  colptr[1] = 1
  for j = 1:k*p
    pos = colptr[j]
    for i = max(1, j-p):j+p
      rowval[pos] = i
      pos += 1
    end
    colptr[j+1] = pos
  end

  V = zeros(FC, n, (k+1)*p)
  U = zeros(FC, n, (k+1)*p)
  T = SparseMatrixCSC((k+1)*p, k*p, colptr, rowval, nzval_T)
  Tᴴ = SparseMatrixCSC((k+1)*p, k*p, colptr, rowval, nzval_Tᴴ)

  α = -one(FC)
  β = one(FC)
  qᵥ = zeros(FC, n, p)
  qᵤ = zeros(FC, n, p)
  D = Ωᵢ = zeros(FC, p, p)
  Ψ₁ = zeros(FC, p, p)
  Φ₁ᴴ = zeros(FC, p, p)

  local Φᵢ, Ψᵢ

  for i = 1:k
    pos1 = (i-1)*p + 1
    pos2 = i*p
    pos3 = pos1 + p
    pos4 = pos2 + p
    vᵢ = view(V,:,pos1:pos2)
    vᵢ₊₁ = view(V,:,pos3:pos4)
    uᵢ = view(U,:,pos1:pos2)
    uᵢ₊₁ = view(U,:,pos3:pos4)

    if i == 1
      mul!(D, C', B)  # D = Cᴴ * B
      F = lu(D, pivoting)
      Φᵢ, Ψᵢ = F.L, F.U   # Φᵢ = F.P' * Φᵢ with pivoting
      Ψ₁ .= Ψᵢ
      Φ₁ᴴ .= Φᵢ'
      # vᵢ .= (Ψᵢ' \ B')'
      # uᵢ .= (Φᵢ \ C')'
      ldiv!(vᵢ', UpperTriangular(Ψᵢ)', B')
      ldiv!(uᵢ', LowerTriangular(Φᵢ), C')
    end

    mul!(qᵥ, A, vᵢ)
    mul!(qᵤ, Aᴴ, uᵢ)

    if i ≥ 2
      pos5 = pos1 - p
      pos6 = pos2 - p
      vᵢ₋₁ = view(V,:,pos5:pos6)
      uᵢ₋₁ = view(U,:,pos5:pos6)

      mul!(qᵥ, vᵢ₋₁, Φᵢ, α, β)   # qᵥ = qᵥ - vᵢ₋₁ * Φᵢ
      mul!(qᵤ, uᵢ₋₁, Ψᵢ', α, β)  # qᵤ = qᵤ - uᵢ₋₁ * Ψᵢᴴ
    end

    mul!(Ωᵢ, uᵢ', qᵥ)
    mul!(qᵥ, vᵢ, Ωᵢ, α, β)   # qᵥ = qᵥ - vᵢ * Ωᵢ
    mul!(qᵤ, uᵢ, Ωᵢ', α, β)  # qᵤ = qᵤ - uᵢ * Ωᵢᴴ

    # Store the block Ωᵢ in Tₖ₊₁.ₖ
    for ii = 1:p
      indi = pos1+ii-1
      for jj = 1:p
        indj = pos1+jj-1
        T[indi,indj] = Ωᵢ[ii,jj]
        Tᴴ[indi,indj] = conj(Ωᵢ[jj,ii])
      end
    end

    mul!(D, qᵤ', qᵥ)  # D = qᵤᴴ * qᵥ
    F = lu(D, pivoting)
    Φᵢ₊₁, Ψᵢ₊₁ = F.L, F.U  # Φᵢ₊₁ = F.P' * Φᵢ₊₁ with pivoting
    # vᵢ₊₁ .= (Ψᵢ₊₁' \ qᵥ')'
    # uᵢ₊₁ .= (Φᵢ₊₁ \ qᵤ')'
    ldiv!(vᵢ₊₁', UpperTriangular(Ψᵢ₊₁)', qᵥ')
    ldiv!(uᵢ₊₁', LowerTriangular(Φᵢ₊₁), qᵤ')
    Φᵢ = Φᵢ₊₁
    Ψᵢ = Ψᵢ₊₁

    # Store the blocks Ψᵢ₊₁ and Φᵢ₊₁ in Tₖ₊₁.ₖ
    for ii = 1:p
      indi = pos3+ii-1
      for jj = 1:p
        indj = pos1+jj-1
        (ii ≤ jj) && (T[indi,indj] = Ψᵢ₊₁[ii,jj])
        (ii ≤ jj) && (Tᴴ[indi,indj] = conj(Φᵢ₊₁[jj,ii]))
        (ii ≤ jj) && (i < k) && (Tᴴ[indj,indi] = conj(Ψᵢ₊₁[ii,jj]))
        (ii ≤ jj) && (i < k) && (T[indj,indi] = Φᵢ₊₁[jj,ii])
      end
    end
  end
  return V, Ψ₁, T, U, Φ₁ᴴ, Tᴴ
end

"""
    V, Γ, H = arnoldi(A, B, k; algo="householder", reorthogonalization=false)

#### Input arguments

* `A`: a linear operator that models a square matrix of dimension `n`;
* `B`: a matrix of size `n × p`;
* `k`: the number of iterations of the block Arnoldi process.

#### Keyword arguments

* `algo`: the algorithm to perform reduced QR factorizations (`"gs"`, `"mgs"`, `"givens"` or `"householder"`).
* `reorthogonalization`: reorthogonalize each newly added matrix of the block Krylov basis against all previous matrices (full reorthogonalization).

#### Output arguments

* `V`: a dense `n × p(k+1)` matrix;
* `Γ`: a dense `p × p` upper triangular matrix such that `V₁Γ = B`;
* `H`: a dense `p(k+1) × pk` block upper Hessenberg matrix with a lower bandwidth `p`.
"""
function arnoldi(A, B::AbstractMatrix{FC}, k::Int; algo::String="householder", reorthogonalization::Bool=false) where FC <: FloatOrComplex
  m, n = size(A)
  t, p = size(B)

  V = zeros(FC, n, (k+1)*p)
  H = zeros(FC, (k+1)*p, k*p)

  α = -one(FC)
  β = one(FC)
  q = zeros(FC, n, p)
  Γ = zeros(FC, p, p)
  Ψᵢⱼ = Ψtmp = zeros(FC, p, p)

  for j = 1:k
    pos1 = (j-1)*p + 1
    pos2 = j*p
    pos3 = pos1 + p
    pos4 = pos2 + p
    vⱼ = view(V,:,pos1:pos2)
    vⱼ₊₁ = view(V,:,pos3:pos4)

    if j == 1
      q .= B
      reduced_qr!(q, Γ, algo)
      vⱼ .= q
    end

    mul!(q, A, vⱼ)

    for i = 1:j
      pos5 = (i-1)*p + 1
      pos6 = i*p
      vᵢ = view(V,:,pos5:pos6)
      mul!(Ψᵢⱼ, vᵢ', q)       # Ψᵢⱼ = vᵢᴴ * q
      mul!(q, vᵢ, Ψᵢⱼ, α, β)  # q = q - vᵢ * Ψᵢⱼ
      H[pos5:pos6,pos1:pos2] .= Ψᵢⱼ
    end

    if reorthogonalization
      for i = 1:j
        pos5 = (i-1)*p + 1
        pos6 = i*p
        vᵢ = view(V,:,pos5:pos6)
        mul!(Ψtmp, vᵢ', q)       # Ψtmp = vᵢᴴ * q
        mul!(q, vᵢ, Ψtmp, α, β)  # q = q - vᵢ * Ψtmp
        Hᵢⱼ = view(H,pos5:pos6,pos1:pos2)
        Hᵢⱼ .= Hᵢⱼ .+ Ψtmp
      end
    end

    Ψ = view(H, pos3:pos4,pos1:pos2)
    reduced_qr!(q, Ψ, algo)
    vⱼ₊₁ .= q
  end
  return V, Γ, H
end

"""
    V, U, Ψ, L = golub_kahan(A, B, k; algo="householder")

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `B`: a matrix of size `m × p`;
* `k`: the number of iterations of the block Golub-Kahan process.

#### Keyword argument

* `algo`: the algorithm to perform reduced QR factorizations (`"gs"`, `"mgs"`, `"givens"` or `"householder"`).

#### Output arguments

* `V`: a dense `n × p(k+1)` matrix;
* `U`: a dense `m × p(k+1)` matrix;
* `Ψ`: a dense `p × p` upper triangular matrix such that `U₁Ψ = B`;
* `L`: a sparse `p(k+1) × p(k+1)` block lower bidiagonal matrix with a lower bandwidth `p`.
"""
function golub_kahan(A, B::AbstractMatrix{FC}, k::Int; algo::String="householder") where FC <: FloatOrComplex
  m, n = size(A)
  t, p = size(B)
  Aᴴ = A'

  nnzL = p*k*(p+1) + div(p*(p+1), 2)
  colptr = zeros(Int, p*(k+1)+1)
  rowval = zeros(Int, nnzL)
  nzval = zeros(FC, nnzL)

  colptr[1] = 1
  for j = 1:(k+1)*p
    pos = colptr[j]
    for i = j:min((k+1)*p,j+p)
      rowval[pos] = i
      pos += 1
    end
    colptr[j+1] = pos
  end

  V = zeros(FC, n, (k+1)*p)
  U = zeros(FC, m, (k+1)*p)
  L = SparseMatrixCSC((k+1)*p, (k+1)*p, colptr, rowval, nzval)

  α = -one(FC)
  β = one(FC)
  qᵥ = zeros(FC, n, p)
  qᵤ = zeros(FC, m, p)
  Ψ₁ = zeros(FC, p, p)
  Ψᵢ₊₁ = TΩᵢ = TΩᵢ₊₁ = zeros(FC, p, p)

  for i = 1:k
    pos1 = (i-1)*p + 1
    pos2 = i*p
    pos3 = pos1 + p
    pos4 = pos2 + p
    vᵢ = view(V,:,pos1:pos2)
    vᵢ₊₁ = view(V,:,pos3:pos4)
    uᵢ = view(U,:,pos1:pos2)
    uᵢ₊₁ = view(U,:,pos3:pos4)

    if i == 1
      qᵤ .= B
      reduced_qr!(qᵤ, Ψ₁, algo)
      uᵢ .= qᵤ

      mul!(qᵥ, Aᴴ, uᵢ)
      reduced_qr!(qᵥ, TΩᵢ, algo)
      vᵢ .= qᵥ

      # Store the block Ω₁ in Lₖ₊₁.ₖ₊₁
      for ii = 1:p
        indi = pos1+ii-1
        for jj = 1:p
          indj = pos1+jj-1
          (ii ≤ jj) && (L[indj,indi] = conj(TΩᵢ[ii,jj]))
        end
      end
    end

    mul!(qᵤ, A, vᵢ)
    mul!(qᵤ, uᵢ, TΩᵢ', α, β)  # qᵤ = qᵤ - uᵢ * Ωᵢ

    reduced_qr!(qᵤ, Ψᵢ₊₁, algo)
    uᵢ₊₁ .= qᵤ

    # Store the block Ψᵢ₊₁ in Lₖ₊₁.ₖ₊₁
    for ii = 1:p
      indi = pos3+ii-1
      for jj = 1:p
        indj = pos1+jj-1
        (ii ≤ jj) && (L[indi,indj] = Ψᵢ₊₁[ii,jj])
      end
    end

    mul!(qᵥ, Aᴴ, uᵢ₊₁)
    mul!(qᵥ, vᵢ, Ψᵢ₊₁', α, β)  # qᵥ = qᵥ - vᵢ * Ψᵢ₊₁ᴴ

    reduced_qr!(qᵥ, TΩᵢ₊₁, algo)
    vᵢ₊₁ .= qᵥ

    # Store the block Ωᵢ₊₁ in Lₖ₊₁.ₖ₊₁
    for ii = 1:p
      indi = pos3+ii-1
      for jj = 1:p
        indj = pos3+jj-1
        (ii ≤ jj) && (L[indj,indi] = conj(TΩᵢ₊₁[ii,jj]))
      end
    end
  end
  return V, U, Ψ₁, L
end

"""
    V, Ψ, T, U, Φᴴ, Tᴴ = saunders_simon_yip(A, B, C, k; algo="householder")

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `B`: a matrix of size `m × p`;
* `C`: a matrix of size `n × p`;
* `k`: the number of iterations of the block Saunders-Simon-Yip process.

#### Keyword argument

* `algo`: the algorithm to perform reduced QR factorizations (`"gs"`, `"mgs"`, `"givens"` or `"householder"`).

#### Output arguments

* `V`: a dense `m × p(k+1)` matrix;
* `Ψ`: a dense `p × p` upper triangular matrix such that `V₁Ψ = B`;
* `T`: a sparse `p(k+1) × pk` block tridiagonal matrix with a bandwidth `p`;
* `U`: a dense `n × p(k+1)` matrix;
* `Φᴴ`: a dense `p × p` upper triangular matrix such that `U₁Φᴴ = C`;
* `Tᴴ`: a sparse `p(k+1) × pk` block tridiagonal matrix with a bandwidth `p`.
"""
function saunders_simon_yip(A, B::AbstractMatrix{FC}, C::AbstractMatrix{FC}, k::Int; algo::String="householder") where FC <: FloatOrComplex
  m, n = size(A)
  t, p = size(B)
  Aᴴ = A'

  nnzT = p*p + (k-1)*p*(2*p+1) + div(p*(p+1), 2)
  colptr = zeros(Int, p*k+1)
  rowval = zeros(Int, nnzT)
  nzval_T = zeros(FC, nnzT)
  nzval_Tᴴ = zeros(FC, nnzT)

  colptr[1] = 1
  for j = 1:k*p
    pos = colptr[j]
    for i = max(1, j-p):j+p
      rowval[pos] = i
      pos += 1
    end
    colptr[j+1] = pos
  end

  V = zeros(FC, m, (k+1)*p)
  U = zeros(FC, n, (k+1)*p)
  T = SparseMatrixCSC((k+1)*p, k*p, colptr, rowval, nzval_T)
  Tᴴ = SparseMatrixCSC((k+1)*p, k*p, colptr, rowval, nzval_Tᴴ)

  α = -one(FC)
  β = one(FC)
  qᵥ = zeros(FC, m, p)
  qᵤ = zeros(FC, n, p)
  Ψ₁ = zeros(FC, p, p)
  Φ₁ᴴ = zeros(FC, p, p)
  Ωᵢ = Ψᵢ = Ψᵢ₊₁ = TΦᵢ = TΦᵢ₊₁ = zeros(FC, p, p)

  for i = 1:k
    pos1 = (i-1)*p + 1
    pos2 = i*p
    pos3 = pos1 + p
    pos4 = pos2 + p
    vᵢ = view(V,:,pos1:pos2)
    vᵢ₊₁ = view(V,:,pos3:pos4)
    uᵢ = view(U,:,pos1:pos2)
    uᵢ₊₁ = view(U,:,pos3:pos4)

    if i == 1
      qᵥ .= B
      reduced_qr!(qᵥ, Ψ₁, algo)
      vᵢ .= qᵥ
      qᵤ .= C
      reduced_qr!(qᵤ, Φ₁ᴴ, algo)
      uᵢ .= qᵤ
    end

    mul!(qᵥ, A, uᵢ)
    mul!(qᵤ, Aᴴ, vᵢ)

    if i ≥ 2
      pos5 = pos1 - p
      pos6 = pos2 - p
      vᵢ₋₁ = view(V,:,pos5:pos6)
      uᵢ₋₁ = view(U,:,pos5:pos6)

      mul!(qᵥ, vᵢ₋₁, TΦᵢ', α, β)  # qᵥ = qᵥ - vᵢ₋₁ * Φᵢ
      for ii = 1:p
        indi = pos1+ii-1
        for jj = 1:p
          indj = pos5+jj-1
          Ψᵢ[ii,jj] = T[indi,indj]
        end
      end
      mul!(qᵤ, uᵢ₋₁, Ψᵢ', α, β)  # qᵤ = qᵤ - uᵢ₋₁ * Ψᵢᴴ
    end

    mul!(Ωᵢ, vᵢ', qᵥ)
    mul!(qᵥ, vᵢ, Ωᵢ, α, β)   # qᵥ = qᵥ - vᵢ * Ωᵢ
    mul!(qᵤ, uᵢ, Ωᵢ', α, β)  # qᵤ = qᵤ - uᵢ * Ωᵢᴴ

    # Store the block Ωᵢ in Tₖ₊₁.ₖ
    for ii = 1:p
      indi = pos1+ii-1
      for jj = 1:p
        indj = pos1+jj-1
        T[indi,indj] = Ωᵢ[ii,jj]
        Tᴴ[indi,indj] = conj(Ωᵢ[jj,ii])
      end
    end

    reduced_qr!(qᵥ, Ψᵢ₊₁, algo)
    vᵢ₊₁ .= qᵥ

    # Store the block Ψᵢ₊₁ in Tₖ₊₁.ₖ
    for ii = 1:p
      indi = pos3+ii-1
      for jj = 1:p
        indj = pos1+jj-1
        (ii ≤ jj) && (T[indi,indj] = Ψᵢ₊₁[ii,jj])
        (ii ≤ jj) && (i < k) && (Tᴴ[indj,indi] = conj(Ψᵢ₊₁[ii,jj]))
      end
    end

    reduced_qr!(qᵤ, TΦᵢ₊₁, algo)
    uᵢ₊₁ .= qᵤ

    # Store the block Φᵢ₊₁ in Tₖ₊₁.ₖ
    for ii = 1:p
      indi = pos3+ii-1
      for jj = 1:p
        indj = pos1+jj-1
        (ii ≤ jj) && (Tᴴ[indi,indj] = TΦᵢ₊₁[ii,jj])
        (ii ≤ jj) && (i < k) && (T[indj,indi] = conj(TΦᵢ₊₁[ii,jj]))
      end
    end
  end
  return V, Ψ₁, T, U, Φ₁ᴴ, Tᴴ
end

"""
    V, Γ, H, U, Λ, F = montoison_orban(A, B, D, C, k; algo="householder", reorthogonalization=false)

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `B`: a linear operator that models a matrix of dimension `n × m`;
* `D`: a matrix of size `m × p`;
* `C`: a matrix of size `n × p`;
* `k`: the number of iterations of the block Montoison-Orban process.

#### Keyword arguments

* `algo`: the algorithm to perform reduced QR factorizations (`"gs"`, `"mgs"`, `"givens"` or `"householder"`).
* `reorthogonalization`: reorthogonalize each newly added matrix of the block Krylov basis against all previous matrices (full reorthogonalization).

#### Output arguments

* `V`: a dense `m × p(k+1)` matrix;
* `Γ`: a dense `p × p` upper triangular matrix such that `V₁Γ = D`;
* `H`: a dense `p(k+1) × pk` block upper Hessenberg matrix with a lower bandwidth `p`;
* `U`: a dense `n × p(k+1)` matrix;
* `Λ`: a dense `p × p` upper triangular matrix such that `U₁Λ = C`;
* `F`: a dense `p(k+1) × pk` block upper Hessenberg matrix with a lower bandwidth `p`.
"""
function montoison_orban(A, B, D::AbstractMatrix{FC}, C::AbstractMatrix{FC}, k::Int; algo::String="householder", reorthogonalization::Bool=false) where FC <: FloatOrComplex
  m, n = size(A)
  t, p = size(D)

  V = zeros(FC, m, (k+1)*p)
  U = zeros(FC, n, (k+1)*p)
  H = zeros(FC, (k+1)*p, k*p)
  F = zeros(FC, (k+1)*p, k*p)

  α = -one(FC)
  β = one(FC)
  qᵥ = zeros(FC, m, p)
  qᵤ = zeros(FC, n, p)
  Γ = zeros(FC, p, p)
  Λ = zeros(FC, p, p)
  Ψᵢⱼ = Φᵢⱼ = Ψtmp = Φtmp = zeros(FC, p, p)

  for j = 1:k
    pos1 = (j-1)*p + 1
    pos2 = j*p
    pos3 = pos1 + p
    pos4 = pos2 + p
    vⱼ = view(V,:,pos1:pos2)
    vⱼ₊₁ = view(V,:,pos3:pos4)
    uⱼ = view(U,:,pos1:pos2)
    uⱼ₊₁ = view(U,:,pos3:pos4)

    if j == 1
      qᵥ .= D
      reduced_qr!(qᵥ, Γ, algo)
      vⱼ .= qᵥ

      qᵤ .= C
      reduced_qr!(qᵤ, Λ, algo)
      uⱼ .= qᵤ
    end

    mul!(qᵥ, A, uⱼ)
    mul!(qᵤ, B, vⱼ)

    for i = 1:j
      pos5 = (i-1)*p + 1
      pos6 = i*p
      vᵢ = view(V,:,pos5:pos6)
      uᵢ = view(U,:,pos5:pos6)

      mul!(Ψᵢⱼ, vᵢ', qᵥ)       # Ψᵢⱼ = vᵢᴴ * qᵥ
      mul!(qᵥ, vᵢ, Ψᵢⱼ, α, β)  # qᵥ = qᵥ - vᵢ * Ψᵢⱼ
      H[pos5:pos6,pos1:pos2] .= Ψᵢⱼ

      mul!(Φᵢⱼ, uᵢ', qᵤ)       # Φᵢⱼ = uᵢᴴ * qᵤ
      mul!(qᵤ, uᵢ, Φᵢⱼ, α, β)  # qᵤ = qᵤ - uᵢ * Φᵢⱼ
      F[pos5:pos6,pos1:pos2] .= Φᵢⱼ
    end

    if reorthogonalization
      for i = 1:j
        pos5 = (i-1)*p + 1
        pos6 = i*p
        vᵢ = view(V,:,pos5:pos6)
        uᵢ = view(U,:,pos5:pos6)

        mul!(Ψtmp, vᵢ', qᵥ)       # Ψtmp = vᵢᴴ * qᵥ
        mul!(qᵥ, vᵢ, Ψtmp, α, β)  # qᵥ = qᵥ - vᵢ * Ψtmp
        Hᵢⱼ = view(H,pos5:pos6,pos1:pos2)
        Hᵢⱼ .= Hᵢⱼ .+ Ψtmp

        mul!(Φtmp, uᵢ', qᵤ)       # Φtmp = uᵢᴴ * qᵤ
        mul!(qᵤ, uᵢ, Φtmp, α, β)  # qᵤ = qᵤ - uᵢ * Φtmp
        Fᵢⱼ = view(F,pos5:pos6,pos1:pos2)
        Fᵢⱼ .= Fᵢⱼ .+ Φtmp
      end
    end

    Ψ = view(H, pos3:pos4,pos1:pos2)
    reduced_qr!(qᵥ, Ψ, algo)
    vⱼ₊₁ .= qᵥ

    Φ = view(F, pos3:pos4,pos1:pos2)
    reduced_qr!(qᵤ, Φ, algo)
    uⱼ₊₁ .= qᵤ
  end
  return V, Γ, H, U, Λ, F
end

function check_min_norm(A, b, x; λ=0.0)
  (nrow, ncol) = size(A)
  if λ > 0.0
    AI = [A sqrt(λ)*I]
    xI = [x ; (b-A*x)/sqrt(λ)]
  else
    AI = A
    xI = x
  end
  QR = qr(AI')
  xmin = QR.Q * (QR.R' \ b)
  xmin_norm = norm(xmin)
  return (xI, xmin, xmin_norm)
end

@testset "symmlq" begin
  symmlq_tol = 1.0e-6

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      # Symmetric and positive definite system.
      n = 10
      A, b = symmetric_definite(FC=FC)
      (x, stats) = symmlq(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ symmlq_tol * norm(A) * norm(x))
      @test(stats.solved)

      # Symmetric indefinite variant.
      A, b = symmetric_indefinite(FC=FC)
      (x, stats) = symmlq(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ symmlq_tol * norm(A) * norm(x))
      @test(stats.solved)

      # Sparse Laplacian.
      A, b = sparse_laplacian(FC=FC)
      (x, stats) = symmlq(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ symmlq_tol * norm(A) * norm(x))
      @test(stats.solved)

      # System that cause a breakdown with the symmetric Lanczos process.
      A, b = symmetric_breakdown(FC=FC)
      (x, stats) = symmlq(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ symmlq_tol * norm(A) * norm(x))
      @test(stats.solved)

      # Test b == 0
      A, b = zero_rhs(FC=FC)
      (x, stats) = symmlq(A, b)
      @test norm(x) == 0
      @test stats.status == "x is a zero-residual solution"

      # Test error estimate
      A = Matrix(get_div_grad(8, 8, 8))
      b = ones(size(A, 1))
      λest = (1 - 1e-10) * eigmin(A)
      x_exact = A \ b
      (xlq, stats) = symmlq(A, b, λest=λest, transfer_to_cg=false, history=true)
      xcg = cg(A, b)[1]
      err = norm(x_exact - xlq)
      errcg = norm(x_exact - xcg)
      @test( err ≤ stats.errors[end] )
      @test( errcg ≤ stats.errorscg[end])
      (x, stats) = symmlq(A, b, λest=λest, window=1, history=true)
      @test( err ≤ stats.errors[end] )
      @test( errcg ≤ stats.errorscg[end])
      (x, stats) = symmlq(A, b, λest=λest, window=5, history=true)
      @test( err ≤ stats.errors[end] )
      @test( errcg ≤ stats.errorscg[end])

      # Test with Jacobi (or diagonal) preconditioner
      A, b, M = square_preconditioned(FC=FC)
      (x, stats) = symmlq(A, b, M=M)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ symmlq_tol * norm(A) * norm(x))
      @test(stats.solved)

      # test callback function
      workspace = SymmlqWorkspace(A, b)
      tol = 1.0
      cb_n2 = TestCallbackN2(A, b, tol = tol)
      symmlq!(workspace, A, b, atol = 0.0, rtol = 0.0, callback = cb_n2)
      @test workspace.stats.status == "user-requested exit"
      @test cb_n2(workspace)

      @test_throws TypeError symmlq(A, b, callback = workspace -> "string", history = true)
    end
  end
end

# c_stores.jl — AUTO-GENERATED by scripts/generate_stores.jl — do not edit.
#
# 34 solvers × 4 precisions = 136 typed workspace stores.
# Each store is a Dict{Ptr{Cvoid}, <ConcreteWorkspaceType>} that acts as a
# GC root while keeping types fully concrete for --trim=safe.
#
# Re-generate with:
#   julia --startup-file=no --project=<root> scripts/generate_stores.jl

# ---------------------------------------------------------------------------
# Typed workspace stores
# ---------------------------------------------------------------------------

const store_cg_f32 = Dict{Ptr{Cvoid}, Krylov.CgWorkspace{Float32, Float32, Vector{Float32}}}()
const store_cg_f64 = Dict{Ptr{Cvoid}, Krylov.CgWorkspace{Float64, Float64, Vector{Float64}}}()
const store_cg_cf32 = Dict{Ptr{Cvoid}, Krylov.CgWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_cg_cf64 = Dict{Ptr{Cvoid}, Krylov.CgWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_cr_f32 = Dict{Ptr{Cvoid}, Krylov.CrWorkspace{Float32, Float32, Vector{Float32}}}()
const store_cr_f64 = Dict{Ptr{Cvoid}, Krylov.CrWorkspace{Float64, Float64, Vector{Float64}}}()
const store_cr_cf32 = Dict{Ptr{Cvoid}, Krylov.CrWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_cr_cf64 = Dict{Ptr{Cvoid}, Krylov.CrWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_symmlq_f32 = Dict{Ptr{Cvoid}, Krylov.SymmlqWorkspace{Float32, Float32, Vector{Float32}}}()
const store_symmlq_f64 = Dict{Ptr{Cvoid}, Krylov.SymmlqWorkspace{Float64, Float64, Vector{Float64}}}()
const store_symmlq_cf32 = Dict{Ptr{Cvoid}, Krylov.SymmlqWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_symmlq_cf64 = Dict{Ptr{Cvoid}, Krylov.SymmlqWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_minres_f32 = Dict{Ptr{Cvoid}, Krylov.MinresWorkspace{Float32, Float32, Vector{Float32}}}()
const store_minres_f64 = Dict{Ptr{Cvoid}, Krylov.MinresWorkspace{Float64, Float64, Vector{Float64}}}()
const store_minres_cf32 = Dict{Ptr{Cvoid}, Krylov.MinresWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_minres_cf64 = Dict{Ptr{Cvoid}, Krylov.MinresWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_minres_qlp_f32 = Dict{Ptr{Cvoid}, Krylov.MinresQlpWorkspace{Float32, Float32, Vector{Float32}}}()
const store_minres_qlp_f64 = Dict{Ptr{Cvoid}, Krylov.MinresQlpWorkspace{Float64, Float64, Vector{Float64}}}()
const store_minres_qlp_cf32 = Dict{Ptr{Cvoid}, Krylov.MinresQlpWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_minres_qlp_cf64 = Dict{Ptr{Cvoid}, Krylov.MinresQlpWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_diom_f32 = Dict{Ptr{Cvoid}, Krylov.DiomWorkspace{Float32, Float32, Vector{Float32}}}()
const store_diom_f64 = Dict{Ptr{Cvoid}, Krylov.DiomWorkspace{Float64, Float64, Vector{Float64}}}()
const store_diom_cf32 = Dict{Ptr{Cvoid}, Krylov.DiomWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_diom_cf64 = Dict{Ptr{Cvoid}, Krylov.DiomWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_dqgmres_f32 = Dict{Ptr{Cvoid}, Krylov.DqgmresWorkspace{Float32, Float32, Vector{Float32}}}()
const store_dqgmres_f64 = Dict{Ptr{Cvoid}, Krylov.DqgmresWorkspace{Float64, Float64, Vector{Float64}}}()
const store_dqgmres_cf32 = Dict{Ptr{Cvoid}, Krylov.DqgmresWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_dqgmres_cf64 = Dict{Ptr{Cvoid}, Krylov.DqgmresWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_fom_f32 = Dict{Ptr{Cvoid}, Krylov.FomWorkspace{Float32, Float32, Vector{Float32}}}()
const store_fom_f64 = Dict{Ptr{Cvoid}, Krylov.FomWorkspace{Float64, Float64, Vector{Float64}}}()
const store_fom_cf32 = Dict{Ptr{Cvoid}, Krylov.FomWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_fom_cf64 = Dict{Ptr{Cvoid}, Krylov.FomWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_gmres_f32 = Dict{Ptr{Cvoid}, Krylov.GmresWorkspace{Float32, Float32, Vector{Float32}}}()
const store_gmres_f64 = Dict{Ptr{Cvoid}, Krylov.GmresWorkspace{Float64, Float64, Vector{Float64}}}()
const store_gmres_cf32 = Dict{Ptr{Cvoid}, Krylov.GmresWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_gmres_cf64 = Dict{Ptr{Cvoid}, Krylov.GmresWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_fgmres_f32 = Dict{Ptr{Cvoid}, Krylov.FgmresWorkspace{Float32, Float32, Vector{Float32}}}()
const store_fgmres_f64 = Dict{Ptr{Cvoid}, Krylov.FgmresWorkspace{Float64, Float64, Vector{Float64}}}()
const store_fgmres_cf32 = Dict{Ptr{Cvoid}, Krylov.FgmresWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_fgmres_cf64 = Dict{Ptr{Cvoid}, Krylov.FgmresWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_bicgstab_f32 = Dict{Ptr{Cvoid}, Krylov.BicgstabWorkspace{Float32, Float32, Vector{Float32}}}()
const store_bicgstab_f64 = Dict{Ptr{Cvoid}, Krylov.BicgstabWorkspace{Float64, Float64, Vector{Float64}}}()
const store_bicgstab_cf32 = Dict{Ptr{Cvoid}, Krylov.BicgstabWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_bicgstab_cf64 = Dict{Ptr{Cvoid}, Krylov.BicgstabWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_cgs_f32 = Dict{Ptr{Cvoid}, Krylov.CgsWorkspace{Float32, Float32, Vector{Float32}}}()
const store_cgs_f64 = Dict{Ptr{Cvoid}, Krylov.CgsWorkspace{Float64, Float64, Vector{Float64}}}()
const store_cgs_cf32 = Dict{Ptr{Cvoid}, Krylov.CgsWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_cgs_cf64 = Dict{Ptr{Cvoid}, Krylov.CgsWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_bilq_f32 = Dict{Ptr{Cvoid}, Krylov.BilqWorkspace{Float32, Float32, Vector{Float32}}}()
const store_bilq_f64 = Dict{Ptr{Cvoid}, Krylov.BilqWorkspace{Float64, Float64, Vector{Float64}}}()
const store_bilq_cf32 = Dict{Ptr{Cvoid}, Krylov.BilqWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_bilq_cf64 = Dict{Ptr{Cvoid}, Krylov.BilqWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_qmr_f32 = Dict{Ptr{Cvoid}, Krylov.QmrWorkspace{Float32, Float32, Vector{Float32}}}()
const store_qmr_f64 = Dict{Ptr{Cvoid}, Krylov.QmrWorkspace{Float64, Float64, Vector{Float64}}}()
const store_qmr_cf32 = Dict{Ptr{Cvoid}, Krylov.QmrWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_qmr_cf64 = Dict{Ptr{Cvoid}, Krylov.QmrWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_usymlq_f32 = Dict{Ptr{Cvoid}, Krylov.UsymlqWorkspace{Float32, Float32, Vector{Float32}}}()
const store_usymlq_f64 = Dict{Ptr{Cvoid}, Krylov.UsymlqWorkspace{Float64, Float64, Vector{Float64}}}()
const store_usymlq_cf32 = Dict{Ptr{Cvoid}, Krylov.UsymlqWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_usymlq_cf64 = Dict{Ptr{Cvoid}, Krylov.UsymlqWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_usymqr_f32 = Dict{Ptr{Cvoid}, Krylov.UsymqrWorkspace{Float32, Float32, Vector{Float32}}}()
const store_usymqr_f64 = Dict{Ptr{Cvoid}, Krylov.UsymqrWorkspace{Float64, Float64, Vector{Float64}}}()
const store_usymqr_cf32 = Dict{Ptr{Cvoid}, Krylov.UsymqrWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_usymqr_cf64 = Dict{Ptr{Cvoid}, Krylov.UsymqrWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_tricg_f32 = Dict{Ptr{Cvoid}, Krylov.TricgWorkspace{Float32, Float32, Vector{Float32}}}()
const store_tricg_f64 = Dict{Ptr{Cvoid}, Krylov.TricgWorkspace{Float64, Float64, Vector{Float64}}}()
const store_tricg_cf32 = Dict{Ptr{Cvoid}, Krylov.TricgWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_tricg_cf64 = Dict{Ptr{Cvoid}, Krylov.TricgWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_trimr_f32 = Dict{Ptr{Cvoid}, Krylov.TrimrWorkspace{Float32, Float32, Vector{Float32}}}()
const store_trimr_f64 = Dict{Ptr{Cvoid}, Krylov.TrimrWorkspace{Float64, Float64, Vector{Float64}}}()
const store_trimr_cf32 = Dict{Ptr{Cvoid}, Krylov.TrimrWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_trimr_cf64 = Dict{Ptr{Cvoid}, Krylov.TrimrWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_trilqr_f32 = Dict{Ptr{Cvoid}, Krylov.TrilqrWorkspace{Float32, Float32, Vector{Float32}}}()
const store_trilqr_f64 = Dict{Ptr{Cvoid}, Krylov.TrilqrWorkspace{Float64, Float64, Vector{Float64}}}()
const store_trilqr_cf32 = Dict{Ptr{Cvoid}, Krylov.TrilqrWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_trilqr_cf64 = Dict{Ptr{Cvoid}, Krylov.TrilqrWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_bilqr_f32 = Dict{Ptr{Cvoid}, Krylov.BilqrWorkspace{Float32, Float32, Vector{Float32}}}()
const store_bilqr_f64 = Dict{Ptr{Cvoid}, Krylov.BilqrWorkspace{Float64, Float64, Vector{Float64}}}()
const store_bilqr_cf32 = Dict{Ptr{Cvoid}, Krylov.BilqrWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_bilqr_cf64 = Dict{Ptr{Cvoid}, Krylov.BilqrWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_lslq_f32 = Dict{Ptr{Cvoid}, Krylov.LslqWorkspace{Float32, Float32, Vector{Float32}}}()
const store_lslq_f64 = Dict{Ptr{Cvoid}, Krylov.LslqWorkspace{Float64, Float64, Vector{Float64}}}()
const store_lslq_cf32 = Dict{Ptr{Cvoid}, Krylov.LslqWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_lslq_cf64 = Dict{Ptr{Cvoid}, Krylov.LslqWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_lsqr_f32 = Dict{Ptr{Cvoid}, Krylov.LsqrWorkspace{Float32, Float32, Vector{Float32}}}()
const store_lsqr_f64 = Dict{Ptr{Cvoid}, Krylov.LsqrWorkspace{Float64, Float64, Vector{Float64}}}()
const store_lsqr_cf32 = Dict{Ptr{Cvoid}, Krylov.LsqrWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_lsqr_cf64 = Dict{Ptr{Cvoid}, Krylov.LsqrWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_lsmr_f32 = Dict{Ptr{Cvoid}, Krylov.LsmrWorkspace{Float32, Float32, Vector{Float32}}}()
const store_lsmr_f64 = Dict{Ptr{Cvoid}, Krylov.LsmrWorkspace{Float64, Float64, Vector{Float64}}}()
const store_lsmr_cf32 = Dict{Ptr{Cvoid}, Krylov.LsmrWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_lsmr_cf64 = Dict{Ptr{Cvoid}, Krylov.LsmrWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_usymlqr_f32 = Dict{Ptr{Cvoid}, Krylov.UsymlqrWorkspace{Float32, Float32, Vector{Float32}}}()
const store_usymlqr_f64 = Dict{Ptr{Cvoid}, Krylov.UsymlqrWorkspace{Float64, Float64, Vector{Float64}}}()
const store_usymlqr_cf32 = Dict{Ptr{Cvoid}, Krylov.UsymlqrWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_usymlqr_cf64 = Dict{Ptr{Cvoid}, Krylov.UsymlqrWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_cgls_f32 = Dict{Ptr{Cvoid}, Krylov.CglsWorkspace{Float32, Float32, Vector{Float32}}}()
const store_cgls_f64 = Dict{Ptr{Cvoid}, Krylov.CglsWorkspace{Float64, Float64, Vector{Float64}}}()
const store_cgls_cf32 = Dict{Ptr{Cvoid}, Krylov.CglsWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_cgls_cf64 = Dict{Ptr{Cvoid}, Krylov.CglsWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_crls_f32 = Dict{Ptr{Cvoid}, Krylov.CrlsWorkspace{Float32, Float32, Vector{Float32}}}()
const store_crls_f64 = Dict{Ptr{Cvoid}, Krylov.CrlsWorkspace{Float64, Float64, Vector{Float64}}}()
const store_crls_cf32 = Dict{Ptr{Cvoid}, Krylov.CrlsWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_crls_cf64 = Dict{Ptr{Cvoid}, Krylov.CrlsWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_cgne_f32 = Dict{Ptr{Cvoid}, Krylov.CgneWorkspace{Float32, Float32, Vector{Float32}}}()
const store_cgne_f64 = Dict{Ptr{Cvoid}, Krylov.CgneWorkspace{Float64, Float64, Vector{Float64}}}()
const store_cgne_cf32 = Dict{Ptr{Cvoid}, Krylov.CgneWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_cgne_cf64 = Dict{Ptr{Cvoid}, Krylov.CgneWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_crmr_f32 = Dict{Ptr{Cvoid}, Krylov.CrmrWorkspace{Float32, Float32, Vector{Float32}}}()
const store_crmr_f64 = Dict{Ptr{Cvoid}, Krylov.CrmrWorkspace{Float64, Float64, Vector{Float64}}}()
const store_crmr_cf32 = Dict{Ptr{Cvoid}, Krylov.CrmrWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_crmr_cf64 = Dict{Ptr{Cvoid}, Krylov.CrmrWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_craig_f32 = Dict{Ptr{Cvoid}, Krylov.CraigWorkspace{Float32, Float32, Vector{Float32}}}()
const store_craig_f64 = Dict{Ptr{Cvoid}, Krylov.CraigWorkspace{Float64, Float64, Vector{Float64}}}()
const store_craig_cf32 = Dict{Ptr{Cvoid}, Krylov.CraigWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_craig_cf64 = Dict{Ptr{Cvoid}, Krylov.CraigWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_craigmr_f32 = Dict{Ptr{Cvoid}, Krylov.CraigmrWorkspace{Float32, Float32, Vector{Float32}}}()
const store_craigmr_f64 = Dict{Ptr{Cvoid}, Krylov.CraigmrWorkspace{Float64, Float64, Vector{Float64}}}()
const store_craigmr_cf32 = Dict{Ptr{Cvoid}, Krylov.CraigmrWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_craigmr_cf64 = Dict{Ptr{Cvoid}, Krylov.CraigmrWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_lnlq_f32 = Dict{Ptr{Cvoid}, Krylov.LnlqWorkspace{Float32, Float32, Vector{Float32}}}()
const store_lnlq_f64 = Dict{Ptr{Cvoid}, Krylov.LnlqWorkspace{Float64, Float64, Vector{Float64}}}()
const store_lnlq_cf32 = Dict{Ptr{Cvoid}, Krylov.LnlqWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_lnlq_cf64 = Dict{Ptr{Cvoid}, Krylov.LnlqWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_gpmr_f32 = Dict{Ptr{Cvoid}, Krylov.GpmrWorkspace{Float32, Float32, Vector{Float32}}}()
const store_gpmr_f64 = Dict{Ptr{Cvoid}, Krylov.GpmrWorkspace{Float64, Float64, Vector{Float64}}}()
const store_gpmr_cf32 = Dict{Ptr{Cvoid}, Krylov.GpmrWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_gpmr_cf64 = Dict{Ptr{Cvoid}, Krylov.GpmrWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_car_f32 = Dict{Ptr{Cvoid}, Krylov.CarWorkspace{Float32, Float32, Vector{Float32}}}()
const store_car_f64 = Dict{Ptr{Cvoid}, Krylov.CarWorkspace{Float64, Float64, Vector{Float64}}}()
const store_car_cf32 = Dict{Ptr{Cvoid}, Krylov.CarWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_car_cf64 = Dict{Ptr{Cvoid}, Krylov.CarWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

const store_minares_f32 = Dict{Ptr{Cvoid}, Krylov.MinaresWorkspace{Float32, Float32, Vector{Float32}}}()
const store_minares_f64 = Dict{Ptr{Cvoid}, Krylov.MinaresWorkspace{Float64, Float64, Vector{Float64}}}()
const store_minares_cf32 = Dict{Ptr{Cvoid}, Krylov.MinaresWorkspace{Float32, ComplexF32, Vector{ComplexF32}}}()
const store_minares_cf64 = Dict{Ptr{Cvoid}, Krylov.MinaresWorkspace{Float64, ComplexF64, Vector{ComplexF64}}}()

# Single index: handle → combo key (UInt8, max=135)
const ws_key_store = Dict{Ptr{Cvoid}, UInt8}()

# ---------------------------------------------------------------------------
# Generic typed helpers — specialized per concrete workspace type by the compiler.
# Called from within if-elseif branches where ws has a known concrete type.
# FC is extracted via the where-clause so --trim=safe can infer it statically.
# ---------------------------------------------------------------------------

function _typed_niter(ws)
  Cint(Krylov.iteration_count(ws))
end

function _typed_is_solved(ws)
  Krylov.issolved(ws) ? Cint(1) : Cint(0)
end

function _typed_elapsed_time(ws)
  Cdouble(Krylov.elapsed_time(ws))
end

function _typed_get_x!(ws::Krylov.KrylovWorkspace{T, FC, S}, x_ptr, n) where {T, FC, S}
  x = Krylov.solution(ws, 1)
  copyto!(unsafe_wrap(Vector{FC}, Ptr{FC}(x_ptr), Int(n)), x)
  Cint(0)
end

function _typed_get_y!(ws::Krylov.KrylovWorkspace{T, FC, S}, y_ptr, m) where {T, FC, S}
  Krylov.solution_count(ws) == 2 || return Cint(-2)
  y = Krylov.solution(ws, 2)
  copyto!(unsafe_wrap(Vector{FC}, Ptr{FC}(y_ptr), Int(m)), y)
  Cint(0)
end

function _typed_warm_start!(ws::Krylov.KrylovWorkspace{T, FC, S}, x0_ptr, n) where {T, FC, S}
  # Bypass Krylov.warm_start! to avoid trim-incompatible string interpolation in its
  # error path.  We inline the same logic: allocate Δx if needed, copy x0, set flag.
  hasfield(typeof(ws), :Δx) || return Cint(-2)   # solver does not support warm start
  x0 = unsafe_wrap(Vector{FC}, Ptr{FC}(x0_ptr), Int(n))
  if isempty(ws.Δx)
    ws.Δx = similar(ws.x)
  end
  copyto!(ws.Δx, x0)
  ws.warm_start = true
  Cint(0)
end

# Two-solution warm start (BiLQR, TriLQR, USYMLQR, TriCG, TriMR, GPMR): seeds
# both the primal guess x0 (size of solution(ws, 1)) and the dual guess y0 (size
# of solution(ws, 2)).  Inlined for the same trim-safety reason as above.
# nx / ny are the buffer lengths the caller passed; they must match ws.x / ws.y.
function _typed_warm_start2!(ws::Krylov.KrylovWorkspace{T, FC, S}, x0_ptr, y0_ptr, nx, ny) where {T, FC, S}
  hasfield(typeof(ws), :Δy) || return Cint(-2)   # not a two-solution solver
  (Int(nx) == length(ws.x) && Int(ny) == length(ws.y)) || return Cint(-1)
  x0 = unsafe_wrap(Vector{FC}, Ptr{FC}(x0_ptr), Int(nx))
  y0 = unsafe_wrap(Vector{FC}, Ptr{FC}(y0_ptr), Int(ny))
  isempty(ws.Δx) && (ws.Δx = similar(ws.x))
  isempty(ws.Δy) && (ws.Δy = similar(ws.y))
  copyto!(ws.Δx, x0)
  copyto!(ws.Δy, y0)
  ws.warm_start = true
  Cint(0)
end

# ---------------------------------------------------------------------------
# _opts_kw — build base keyword arguments from a KrylovOptionsC struct.
# NaN sentinels fall back to the Julia solver default (√eps(T); timemax → Inf).
# itmax=0 is always passed explicitly; Krylov.jl interprets 0 as "use default".
# atol/rtol/itmax/verbose/timemax are accepted by EVERY solver, so they live here.
# The NamedTuple type is always the same concrete type — compatible with --trim=safe.
# ---------------------------------------------------------------------------
function _opts_kw(opts::KrylovOptionsC, ::Type{T}) where T
  atol_v = isnan(opts.atol) ? sqrt(eps(T)) : T(opts.atol)
  rtol_v = isnan(opts.rtol) ? sqrt(eps(T)) : T(opts.rtol)
  tmax_v = isnan(opts.timemax) ? Inf : Float64(opts.timemax)
  (atol=atol_v, rtol=rtol_v, itmax=Int(opts.itmax), verbose=Int(opts.verbose), timemax=tmax_v)
end

# ---------------------------------------------------------------------------
# _typed_solve! variants — one per option family
# ---------------------------------------------------------------------------

# Every one/two-RHS _typed_solve* helper shares the same argument list (fptr_M is
# the left preconditioner, fptr_N the right one) so _do_solve! calls any of them
# uniformly.  There is one helper per *option set* (which scalar kwargs a solver
# accepts), so an option is only ever forwarded to a solver that supports it.
# Each call site lists its kwargs as literals → a statically-known concrete
# NamedTuple, required by --trim=safe.

# M only — CAR, CGNE, CRMR (and the catch-all).  fptr_N ignored.
function _typed_solve!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T)
  if fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.n, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; kw...)
  end
  Cint(0)
end

# M + radius + linesearch — CG, CR.
function _typed_solve_cg!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T)
  rad = T(opts.radius); ls = opts.linesearch != 0
  if fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.n, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, radius=rad, linesearch=ls, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; radius=rad, linesearch=ls, kw...)
  end
  Cint(0)
end

# M + linesearch + λ-shift — MINRES, MINRES-QLP.
function _typed_solve_minres!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T)
  λ = T(opts.lambda); ls = opts.linesearch != 0
  if fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.n, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, λ=λ, linesearch=ls, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; λ=λ, linesearch=ls, kw...)
  end
  Cint(0)
end

# M + λ-shift — SYMMLQ, MINARES (symmetric, no linesearch).
function _typed_solve_sym_lambda!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T)
  λ = T(opts.lambda)
  if fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.n, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, λ=λ, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; λ=λ, kw...)
  end
  Cint(0)
end

# M + N — BiCGSTAB, CGS, BiLQ, QMR.  The four NULL/non-NULL combinations are
# spelled out so each krylov_solve! call site is concretely typed (--trim=safe).
function _typed_solve_mn!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T)
  if fptr_M != C_NULL && fptr_N != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, N=N, kw...)
  elseif fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, kw...)
  elseif fptr_N != C_NULL
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; N=N, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; kw...)
  end
  Cint(0)
end

# M + N + reorthogonalization — DIOM, DQGMRES (limited-memory, no restart).
function _typed_solve_mn_reorth!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T)
  ro = opts.reorthogonalization != 0
  if fptr_M != C_NULL && fptr_N != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, N=N, reorthogonalization=ro, kw...)
  elseif fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, reorthogonalization=ro, kw...)
  elseif fptr_N != C_NULL
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; N=N, reorthogonalization=ro, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; reorthogonalization=ro, kw...)
  end
  Cint(0)
end

# M + N + restart + reorthogonalization — GMRES, FGMRES, FOM.
function _typed_solve_gmres!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T)
  rs = opts.restart != 0; ro = opts.reorthogonalization != 0
  if fptr_M != C_NULL && fptr_N != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, N=N, restart=rs, reorthogonalization=ro, kw...)
  elseif fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, restart=rs, reorthogonalization=ro, kw...)
  elseif fptr_N != C_NULL
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; N=N, restart=rs, reorthogonalization=ro, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; restart=rs, reorthogonalization=ro, kw...)
  end
  Cint(0)
end

# Least-squares / least-norm preconditioning follows Krylov's convention:
# M = E⁻¹ acts on the m-dimensional data space, N = F⁻¹ on the n-dimensional
# solution space (so M is sized with ws.m, N with ws.n).  λ is always passed
# (0.0 = none).  M/N combinations are spelled out for --trim=safe.

# λ + radius + M(m) + N(n) — LSQR, LSMR.
function _typed_solve_ls_mn_radius!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T); λ = T(opts.lambda); rad = T(opts.radius)
  if fptr_M != C_NULL && fptr_N != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, N=N, λ=λ, radius=rad, kw...)
  elseif fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, λ=λ, radius=rad, kw...)
  elseif fptr_N != C_NULL
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; N=N, λ=λ, radius=rad, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; λ=λ, radius=rad, kw...)
  end
  Cint(0)
end

# λ + M(m) + N(n) — LSLQ, CRAIG, CRAIGMR, LNLQ (no radius).
function _typed_solve_ls_mn!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T); λ = T(opts.lambda)
  if fptr_M != C_NULL && fptr_N != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, N=N, λ=λ, kw...)
  elseif fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.m, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, λ=λ, kw...)
  elseif fptr_N != C_NULL
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; N=N, λ=λ, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; λ=λ, kw...)
  end
  Cint(0)
end

# λ + radius + M(n) — CGLS, CRLS (CG/CR on the normal equations; single
# preconditioner on the n-space, passed via matvec_M).
function _typed_solve_ls_m_radius!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T); λ = T(opts.lambda); rad = T(opts.radius)
  if fptr_M != C_NULL
    M = CPreconditioner{FC}(ws.n, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, b; M=M, λ=λ, radius=rad, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; λ=λ, radius=rad, kw...)
  end
  Cint(0)
end

# λ + N(n) — CGNE, CRMR (single preconditioner on the n-space, via matvec_N).
function _typed_solve_ls_n!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  kw = _opts_kw(opts, T); λ = T(opts.lambda)
  if fptr_N != C_NULL
    N = CPreconditioner{FC}(ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, b; N=N, λ=λ, kw...)
  else
    Krylov.krylov_solve!(ws, A, b; λ=λ, kw...)
  end
  Cint(0)
end

# TriCG / TriMR: two-RHS + τ and ν (quasi-definite diagonal parameters).
# NaN sentinel → use Krylov.jl defaults (τ=1.0, ν=-1.0).  M/N ignored.
function _typed_solve_tau_nu!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  c  = unsafe_wrap(Vector{FC}, Ptr{FC}(c_ptr), ws.n)
  kw = _opts_kw(opts, T)
  τ  = isnan(opts.tau) ? T(1)  : T(opts.tau)
  ν  = isnan(opts.nu)  ? T(-1) : T(opts.nu)
  Krylov.krylov_solve!(ws, A, b, c; τ=τ, ν=ν, kw...)
  Cint(0)
end

# Basic two-RHS solvers (BiLQR / TriLQR / USYMLQ / USYMQR / USYMLQR).  M/N ignored.
function _typed_solve_two_rhs!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, fptr_At, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  c  = unsafe_wrap(Vector{FC}, Ptr{FC}(c_ptr), ws.n)
  kw = _opts_kw(opts, T)
  Krylov.krylov_solve!(ws, A, b, c; kw...)
  Cint(0)
end

# GPMR — fptr_At slot is repurposed as B (n×m), distinct from A (m×n).
# GPMR has its own preconditioner family (C, D, E, F), not exposed: M/N ignored.
# It does accept reorthogonalization.
function _typed_solve_gpmr!(ws::Krylov.KrylovWorkspace{T, FC, S}, fptr_A, fptr_B, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts) where {T, FC, S}
  A  = COperator{FC}(ws.m, ws.n, fptr_A, C_NULL, userdata)
  B  = COperator{FC}(ws.n, ws.m, fptr_B, C_NULL, userdata)
  b  = unsafe_wrap(Vector{FC}, Ptr{FC}(b_ptr), ws.m)
  c  = unsafe_wrap(Vector{FC}, Ptr{FC}(c_ptr), ws.n)
  kw = _opts_kw(opts, T)
  Krylov.krylov_solve!(ws, A, B, b, c; reorthogonalization=(opts.reorthogonalization != 0), kw...)
  Cint(0)
end

# ---------------------------------------------------------------------------
# Dispatch functions — generated if-elseif chains over all 136 combos.
# Each branch has a statically known concrete type: compatible with --trim=safe.
# ---------------------------------------------------------------------------

function _do_niter(ws_ptr :: Ptr{Cvoid})
  haskey(ws_key_store, ws_ptr) || return Cint(-1)
  k = ws_key_store[ws_ptr]
  if k == 0x00; _typed_niter(store_cg_f32[ws_ptr])
  elseif k == 0x01; _typed_niter(store_cg_f64[ws_ptr])
  elseif k == 0x02; _typed_niter(store_cg_cf32[ws_ptr])
  elseif k == 0x03; _typed_niter(store_cg_cf64[ws_ptr])
  elseif k == 0x04; _typed_niter(store_cr_f32[ws_ptr])
  elseif k == 0x05; _typed_niter(store_cr_f64[ws_ptr])
  elseif k == 0x06; _typed_niter(store_cr_cf32[ws_ptr])
  elseif k == 0x07; _typed_niter(store_cr_cf64[ws_ptr])
  elseif k == 0x08; _typed_niter(store_symmlq_f32[ws_ptr])
  elseif k == 0x09; _typed_niter(store_symmlq_f64[ws_ptr])
  elseif k == 0x0a; _typed_niter(store_symmlq_cf32[ws_ptr])
  elseif k == 0x0b; _typed_niter(store_symmlq_cf64[ws_ptr])
  elseif k == 0x0c; _typed_niter(store_minres_f32[ws_ptr])
  elseif k == 0x0d; _typed_niter(store_minres_f64[ws_ptr])
  elseif k == 0x0e; _typed_niter(store_minres_cf32[ws_ptr])
  elseif k == 0x0f; _typed_niter(store_minres_cf64[ws_ptr])
  elseif k == 0x10; _typed_niter(store_minres_qlp_f32[ws_ptr])
  elseif k == 0x11; _typed_niter(store_minres_qlp_f64[ws_ptr])
  elseif k == 0x12; _typed_niter(store_minres_qlp_cf32[ws_ptr])
  elseif k == 0x13; _typed_niter(store_minres_qlp_cf64[ws_ptr])
  elseif k == 0x14; _typed_niter(store_diom_f32[ws_ptr])
  elseif k == 0x15; _typed_niter(store_diom_f64[ws_ptr])
  elseif k == 0x16; _typed_niter(store_diom_cf32[ws_ptr])
  elseif k == 0x17; _typed_niter(store_diom_cf64[ws_ptr])
  elseif k == 0x18; _typed_niter(store_dqgmres_f32[ws_ptr])
  elseif k == 0x19; _typed_niter(store_dqgmres_f64[ws_ptr])
  elseif k == 0x1a; _typed_niter(store_dqgmres_cf32[ws_ptr])
  elseif k == 0x1b; _typed_niter(store_dqgmres_cf64[ws_ptr])
  elseif k == 0x1c; _typed_niter(store_fom_f32[ws_ptr])
  elseif k == 0x1d; _typed_niter(store_fom_f64[ws_ptr])
  elseif k == 0x1e; _typed_niter(store_fom_cf32[ws_ptr])
  elseif k == 0x1f; _typed_niter(store_fom_cf64[ws_ptr])
  elseif k == 0x20; _typed_niter(store_gmres_f32[ws_ptr])
  elseif k == 0x21; _typed_niter(store_gmres_f64[ws_ptr])
  elseif k == 0x22; _typed_niter(store_gmres_cf32[ws_ptr])
  elseif k == 0x23; _typed_niter(store_gmres_cf64[ws_ptr])
  elseif k == 0x24; _typed_niter(store_fgmres_f32[ws_ptr])
  elseif k == 0x25; _typed_niter(store_fgmres_f64[ws_ptr])
  elseif k == 0x26; _typed_niter(store_fgmres_cf32[ws_ptr])
  elseif k == 0x27; _typed_niter(store_fgmres_cf64[ws_ptr])
  elseif k == 0x28; _typed_niter(store_bicgstab_f32[ws_ptr])
  elseif k == 0x29; _typed_niter(store_bicgstab_f64[ws_ptr])
  elseif k == 0x2a; _typed_niter(store_bicgstab_cf32[ws_ptr])
  elseif k == 0x2b; _typed_niter(store_bicgstab_cf64[ws_ptr])
  elseif k == 0x2c; _typed_niter(store_cgs_f32[ws_ptr])
  elseif k == 0x2d; _typed_niter(store_cgs_f64[ws_ptr])
  elseif k == 0x2e; _typed_niter(store_cgs_cf32[ws_ptr])
  elseif k == 0x2f; _typed_niter(store_cgs_cf64[ws_ptr])
  elseif k == 0x30; _typed_niter(store_bilq_f32[ws_ptr])
  elseif k == 0x31; _typed_niter(store_bilq_f64[ws_ptr])
  elseif k == 0x32; _typed_niter(store_bilq_cf32[ws_ptr])
  elseif k == 0x33; _typed_niter(store_bilq_cf64[ws_ptr])
  elseif k == 0x34; _typed_niter(store_qmr_f32[ws_ptr])
  elseif k == 0x35; _typed_niter(store_qmr_f64[ws_ptr])
  elseif k == 0x36; _typed_niter(store_qmr_cf32[ws_ptr])
  elseif k == 0x37; _typed_niter(store_qmr_cf64[ws_ptr])
  elseif k == 0x38; _typed_niter(store_usymlq_f32[ws_ptr])
  elseif k == 0x39; _typed_niter(store_usymlq_f64[ws_ptr])
  elseif k == 0x3a; _typed_niter(store_usymlq_cf32[ws_ptr])
  elseif k == 0x3b; _typed_niter(store_usymlq_cf64[ws_ptr])
  elseif k == 0x3c; _typed_niter(store_usymqr_f32[ws_ptr])
  elseif k == 0x3d; _typed_niter(store_usymqr_f64[ws_ptr])
  elseif k == 0x3e; _typed_niter(store_usymqr_cf32[ws_ptr])
  elseif k == 0x3f; _typed_niter(store_usymqr_cf64[ws_ptr])
  elseif k == 0x40; _typed_niter(store_tricg_f32[ws_ptr])
  elseif k == 0x41; _typed_niter(store_tricg_f64[ws_ptr])
  elseif k == 0x42; _typed_niter(store_tricg_cf32[ws_ptr])
  elseif k == 0x43; _typed_niter(store_tricg_cf64[ws_ptr])
  elseif k == 0x44; _typed_niter(store_trimr_f32[ws_ptr])
  elseif k == 0x45; _typed_niter(store_trimr_f64[ws_ptr])
  elseif k == 0x46; _typed_niter(store_trimr_cf32[ws_ptr])
  elseif k == 0x47; _typed_niter(store_trimr_cf64[ws_ptr])
  elseif k == 0x48; _typed_niter(store_trilqr_f32[ws_ptr])
  elseif k == 0x49; _typed_niter(store_trilqr_f64[ws_ptr])
  elseif k == 0x4a; _typed_niter(store_trilqr_cf32[ws_ptr])
  elseif k == 0x4b; _typed_niter(store_trilqr_cf64[ws_ptr])
  elseif k == 0x4c; _typed_niter(store_bilqr_f32[ws_ptr])
  elseif k == 0x4d; _typed_niter(store_bilqr_f64[ws_ptr])
  elseif k == 0x4e; _typed_niter(store_bilqr_cf32[ws_ptr])
  elseif k == 0x4f; _typed_niter(store_bilqr_cf64[ws_ptr])
  elseif k == 0x50; _typed_niter(store_lslq_f32[ws_ptr])
  elseif k == 0x51; _typed_niter(store_lslq_f64[ws_ptr])
  elseif k == 0x52; _typed_niter(store_lslq_cf32[ws_ptr])
  elseif k == 0x53; _typed_niter(store_lslq_cf64[ws_ptr])
  elseif k == 0x54; _typed_niter(store_lsqr_f32[ws_ptr])
  elseif k == 0x55; _typed_niter(store_lsqr_f64[ws_ptr])
  elseif k == 0x56; _typed_niter(store_lsqr_cf32[ws_ptr])
  elseif k == 0x57; _typed_niter(store_lsqr_cf64[ws_ptr])
  elseif k == 0x58; _typed_niter(store_lsmr_f32[ws_ptr])
  elseif k == 0x59; _typed_niter(store_lsmr_f64[ws_ptr])
  elseif k == 0x5a; _typed_niter(store_lsmr_cf32[ws_ptr])
  elseif k == 0x5b; _typed_niter(store_lsmr_cf64[ws_ptr])
  elseif k == 0x5c; _typed_niter(store_usymlqr_f32[ws_ptr])
  elseif k == 0x5d; _typed_niter(store_usymlqr_f64[ws_ptr])
  elseif k == 0x5e; _typed_niter(store_usymlqr_cf32[ws_ptr])
  elseif k == 0x5f; _typed_niter(store_usymlqr_cf64[ws_ptr])
  elseif k == 0x60; _typed_niter(store_cgls_f32[ws_ptr])
  elseif k == 0x61; _typed_niter(store_cgls_f64[ws_ptr])
  elseif k == 0x62; _typed_niter(store_cgls_cf32[ws_ptr])
  elseif k == 0x63; _typed_niter(store_cgls_cf64[ws_ptr])
  elseif k == 0x64; _typed_niter(store_crls_f32[ws_ptr])
  elseif k == 0x65; _typed_niter(store_crls_f64[ws_ptr])
  elseif k == 0x66; _typed_niter(store_crls_cf32[ws_ptr])
  elseif k == 0x67; _typed_niter(store_crls_cf64[ws_ptr])
  elseif k == 0x68; _typed_niter(store_cgne_f32[ws_ptr])
  elseif k == 0x69; _typed_niter(store_cgne_f64[ws_ptr])
  elseif k == 0x6a; _typed_niter(store_cgne_cf32[ws_ptr])
  elseif k == 0x6b; _typed_niter(store_cgne_cf64[ws_ptr])
  elseif k == 0x6c; _typed_niter(store_crmr_f32[ws_ptr])
  elseif k == 0x6d; _typed_niter(store_crmr_f64[ws_ptr])
  elseif k == 0x6e; _typed_niter(store_crmr_cf32[ws_ptr])
  elseif k == 0x6f; _typed_niter(store_crmr_cf64[ws_ptr])
  elseif k == 0x70; _typed_niter(store_craig_f32[ws_ptr])
  elseif k == 0x71; _typed_niter(store_craig_f64[ws_ptr])
  elseif k == 0x72; _typed_niter(store_craig_cf32[ws_ptr])
  elseif k == 0x73; _typed_niter(store_craig_cf64[ws_ptr])
  elseif k == 0x74; _typed_niter(store_craigmr_f32[ws_ptr])
  elseif k == 0x75; _typed_niter(store_craigmr_f64[ws_ptr])
  elseif k == 0x76; _typed_niter(store_craigmr_cf32[ws_ptr])
  elseif k == 0x77; _typed_niter(store_craigmr_cf64[ws_ptr])
  elseif k == 0x78; _typed_niter(store_lnlq_f32[ws_ptr])
  elseif k == 0x79; _typed_niter(store_lnlq_f64[ws_ptr])
  elseif k == 0x7a; _typed_niter(store_lnlq_cf32[ws_ptr])
  elseif k == 0x7b; _typed_niter(store_lnlq_cf64[ws_ptr])
  elseif k == 0x7c; _typed_niter(store_gpmr_f32[ws_ptr])
  elseif k == 0x7d; _typed_niter(store_gpmr_f64[ws_ptr])
  elseif k == 0x7e; _typed_niter(store_gpmr_cf32[ws_ptr])
  elseif k == 0x7f; _typed_niter(store_gpmr_cf64[ws_ptr])
  elseif k == 0x80; _typed_niter(store_car_f32[ws_ptr])
  elseif k == 0x81; _typed_niter(store_car_f64[ws_ptr])
  elseif k == 0x82; _typed_niter(store_car_cf32[ws_ptr])
  elseif k == 0x83; _typed_niter(store_car_cf64[ws_ptr])
  elseif k == 0x84; _typed_niter(store_minares_f32[ws_ptr])
  elseif k == 0x85; _typed_niter(store_minares_f64[ws_ptr])
  elseif k == 0x86; _typed_niter(store_minares_cf32[ws_ptr])
  elseif k == 0x87; _typed_niter(store_minares_cf64[ws_ptr])
  else; Cint(-1); end
end

function _do_is_solved(ws_ptr :: Ptr{Cvoid})
  haskey(ws_key_store, ws_ptr) || return Cint(-1)
  k = ws_key_store[ws_ptr]
  if k == 0x00; _typed_is_solved(store_cg_f32[ws_ptr])
  elseif k == 0x01; _typed_is_solved(store_cg_f64[ws_ptr])
  elseif k == 0x02; _typed_is_solved(store_cg_cf32[ws_ptr])
  elseif k == 0x03; _typed_is_solved(store_cg_cf64[ws_ptr])
  elseif k == 0x04; _typed_is_solved(store_cr_f32[ws_ptr])
  elseif k == 0x05; _typed_is_solved(store_cr_f64[ws_ptr])
  elseif k == 0x06; _typed_is_solved(store_cr_cf32[ws_ptr])
  elseif k == 0x07; _typed_is_solved(store_cr_cf64[ws_ptr])
  elseif k == 0x08; _typed_is_solved(store_symmlq_f32[ws_ptr])
  elseif k == 0x09; _typed_is_solved(store_symmlq_f64[ws_ptr])
  elseif k == 0x0a; _typed_is_solved(store_symmlq_cf32[ws_ptr])
  elseif k == 0x0b; _typed_is_solved(store_symmlq_cf64[ws_ptr])
  elseif k == 0x0c; _typed_is_solved(store_minres_f32[ws_ptr])
  elseif k == 0x0d; _typed_is_solved(store_minres_f64[ws_ptr])
  elseif k == 0x0e; _typed_is_solved(store_minres_cf32[ws_ptr])
  elseif k == 0x0f; _typed_is_solved(store_minres_cf64[ws_ptr])
  elseif k == 0x10; _typed_is_solved(store_minres_qlp_f32[ws_ptr])
  elseif k == 0x11; _typed_is_solved(store_minres_qlp_f64[ws_ptr])
  elseif k == 0x12; _typed_is_solved(store_minres_qlp_cf32[ws_ptr])
  elseif k == 0x13; _typed_is_solved(store_minres_qlp_cf64[ws_ptr])
  elseif k == 0x14; _typed_is_solved(store_diom_f32[ws_ptr])
  elseif k == 0x15; _typed_is_solved(store_diom_f64[ws_ptr])
  elseif k == 0x16; _typed_is_solved(store_diom_cf32[ws_ptr])
  elseif k == 0x17; _typed_is_solved(store_diom_cf64[ws_ptr])
  elseif k == 0x18; _typed_is_solved(store_dqgmres_f32[ws_ptr])
  elseif k == 0x19; _typed_is_solved(store_dqgmres_f64[ws_ptr])
  elseif k == 0x1a; _typed_is_solved(store_dqgmres_cf32[ws_ptr])
  elseif k == 0x1b; _typed_is_solved(store_dqgmres_cf64[ws_ptr])
  elseif k == 0x1c; _typed_is_solved(store_fom_f32[ws_ptr])
  elseif k == 0x1d; _typed_is_solved(store_fom_f64[ws_ptr])
  elseif k == 0x1e; _typed_is_solved(store_fom_cf32[ws_ptr])
  elseif k == 0x1f; _typed_is_solved(store_fom_cf64[ws_ptr])
  elseif k == 0x20; _typed_is_solved(store_gmres_f32[ws_ptr])
  elseif k == 0x21; _typed_is_solved(store_gmres_f64[ws_ptr])
  elseif k == 0x22; _typed_is_solved(store_gmres_cf32[ws_ptr])
  elseif k == 0x23; _typed_is_solved(store_gmres_cf64[ws_ptr])
  elseif k == 0x24; _typed_is_solved(store_fgmres_f32[ws_ptr])
  elseif k == 0x25; _typed_is_solved(store_fgmres_f64[ws_ptr])
  elseif k == 0x26; _typed_is_solved(store_fgmres_cf32[ws_ptr])
  elseif k == 0x27; _typed_is_solved(store_fgmres_cf64[ws_ptr])
  elseif k == 0x28; _typed_is_solved(store_bicgstab_f32[ws_ptr])
  elseif k == 0x29; _typed_is_solved(store_bicgstab_f64[ws_ptr])
  elseif k == 0x2a; _typed_is_solved(store_bicgstab_cf32[ws_ptr])
  elseif k == 0x2b; _typed_is_solved(store_bicgstab_cf64[ws_ptr])
  elseif k == 0x2c; _typed_is_solved(store_cgs_f32[ws_ptr])
  elseif k == 0x2d; _typed_is_solved(store_cgs_f64[ws_ptr])
  elseif k == 0x2e; _typed_is_solved(store_cgs_cf32[ws_ptr])
  elseif k == 0x2f; _typed_is_solved(store_cgs_cf64[ws_ptr])
  elseif k == 0x30; _typed_is_solved(store_bilq_f32[ws_ptr])
  elseif k == 0x31; _typed_is_solved(store_bilq_f64[ws_ptr])
  elseif k == 0x32; _typed_is_solved(store_bilq_cf32[ws_ptr])
  elseif k == 0x33; _typed_is_solved(store_bilq_cf64[ws_ptr])
  elseif k == 0x34; _typed_is_solved(store_qmr_f32[ws_ptr])
  elseif k == 0x35; _typed_is_solved(store_qmr_f64[ws_ptr])
  elseif k == 0x36; _typed_is_solved(store_qmr_cf32[ws_ptr])
  elseif k == 0x37; _typed_is_solved(store_qmr_cf64[ws_ptr])
  elseif k == 0x38; _typed_is_solved(store_usymlq_f32[ws_ptr])
  elseif k == 0x39; _typed_is_solved(store_usymlq_f64[ws_ptr])
  elseif k == 0x3a; _typed_is_solved(store_usymlq_cf32[ws_ptr])
  elseif k == 0x3b; _typed_is_solved(store_usymlq_cf64[ws_ptr])
  elseif k == 0x3c; _typed_is_solved(store_usymqr_f32[ws_ptr])
  elseif k == 0x3d; _typed_is_solved(store_usymqr_f64[ws_ptr])
  elseif k == 0x3e; _typed_is_solved(store_usymqr_cf32[ws_ptr])
  elseif k == 0x3f; _typed_is_solved(store_usymqr_cf64[ws_ptr])
  elseif k == 0x40; _typed_is_solved(store_tricg_f32[ws_ptr])
  elseif k == 0x41; _typed_is_solved(store_tricg_f64[ws_ptr])
  elseif k == 0x42; _typed_is_solved(store_tricg_cf32[ws_ptr])
  elseif k == 0x43; _typed_is_solved(store_tricg_cf64[ws_ptr])
  elseif k == 0x44; _typed_is_solved(store_trimr_f32[ws_ptr])
  elseif k == 0x45; _typed_is_solved(store_trimr_f64[ws_ptr])
  elseif k == 0x46; _typed_is_solved(store_trimr_cf32[ws_ptr])
  elseif k == 0x47; _typed_is_solved(store_trimr_cf64[ws_ptr])
  elseif k == 0x48; _typed_is_solved(store_trilqr_f32[ws_ptr])
  elseif k == 0x49; _typed_is_solved(store_trilqr_f64[ws_ptr])
  elseif k == 0x4a; _typed_is_solved(store_trilqr_cf32[ws_ptr])
  elseif k == 0x4b; _typed_is_solved(store_trilqr_cf64[ws_ptr])
  elseif k == 0x4c; _typed_is_solved(store_bilqr_f32[ws_ptr])
  elseif k == 0x4d; _typed_is_solved(store_bilqr_f64[ws_ptr])
  elseif k == 0x4e; _typed_is_solved(store_bilqr_cf32[ws_ptr])
  elseif k == 0x4f; _typed_is_solved(store_bilqr_cf64[ws_ptr])
  elseif k == 0x50; _typed_is_solved(store_lslq_f32[ws_ptr])
  elseif k == 0x51; _typed_is_solved(store_lslq_f64[ws_ptr])
  elseif k == 0x52; _typed_is_solved(store_lslq_cf32[ws_ptr])
  elseif k == 0x53; _typed_is_solved(store_lslq_cf64[ws_ptr])
  elseif k == 0x54; _typed_is_solved(store_lsqr_f32[ws_ptr])
  elseif k == 0x55; _typed_is_solved(store_lsqr_f64[ws_ptr])
  elseif k == 0x56; _typed_is_solved(store_lsqr_cf32[ws_ptr])
  elseif k == 0x57; _typed_is_solved(store_lsqr_cf64[ws_ptr])
  elseif k == 0x58; _typed_is_solved(store_lsmr_f32[ws_ptr])
  elseif k == 0x59; _typed_is_solved(store_lsmr_f64[ws_ptr])
  elseif k == 0x5a; _typed_is_solved(store_lsmr_cf32[ws_ptr])
  elseif k == 0x5b; _typed_is_solved(store_lsmr_cf64[ws_ptr])
  elseif k == 0x5c; _typed_is_solved(store_usymlqr_f32[ws_ptr])
  elseif k == 0x5d; _typed_is_solved(store_usymlqr_f64[ws_ptr])
  elseif k == 0x5e; _typed_is_solved(store_usymlqr_cf32[ws_ptr])
  elseif k == 0x5f; _typed_is_solved(store_usymlqr_cf64[ws_ptr])
  elseif k == 0x60; _typed_is_solved(store_cgls_f32[ws_ptr])
  elseif k == 0x61; _typed_is_solved(store_cgls_f64[ws_ptr])
  elseif k == 0x62; _typed_is_solved(store_cgls_cf32[ws_ptr])
  elseif k == 0x63; _typed_is_solved(store_cgls_cf64[ws_ptr])
  elseif k == 0x64; _typed_is_solved(store_crls_f32[ws_ptr])
  elseif k == 0x65; _typed_is_solved(store_crls_f64[ws_ptr])
  elseif k == 0x66; _typed_is_solved(store_crls_cf32[ws_ptr])
  elseif k == 0x67; _typed_is_solved(store_crls_cf64[ws_ptr])
  elseif k == 0x68; _typed_is_solved(store_cgne_f32[ws_ptr])
  elseif k == 0x69; _typed_is_solved(store_cgne_f64[ws_ptr])
  elseif k == 0x6a; _typed_is_solved(store_cgne_cf32[ws_ptr])
  elseif k == 0x6b; _typed_is_solved(store_cgne_cf64[ws_ptr])
  elseif k == 0x6c; _typed_is_solved(store_crmr_f32[ws_ptr])
  elseif k == 0x6d; _typed_is_solved(store_crmr_f64[ws_ptr])
  elseif k == 0x6e; _typed_is_solved(store_crmr_cf32[ws_ptr])
  elseif k == 0x6f; _typed_is_solved(store_crmr_cf64[ws_ptr])
  elseif k == 0x70; _typed_is_solved(store_craig_f32[ws_ptr])
  elseif k == 0x71; _typed_is_solved(store_craig_f64[ws_ptr])
  elseif k == 0x72; _typed_is_solved(store_craig_cf32[ws_ptr])
  elseif k == 0x73; _typed_is_solved(store_craig_cf64[ws_ptr])
  elseif k == 0x74; _typed_is_solved(store_craigmr_f32[ws_ptr])
  elseif k == 0x75; _typed_is_solved(store_craigmr_f64[ws_ptr])
  elseif k == 0x76; _typed_is_solved(store_craigmr_cf32[ws_ptr])
  elseif k == 0x77; _typed_is_solved(store_craigmr_cf64[ws_ptr])
  elseif k == 0x78; _typed_is_solved(store_lnlq_f32[ws_ptr])
  elseif k == 0x79; _typed_is_solved(store_lnlq_f64[ws_ptr])
  elseif k == 0x7a; _typed_is_solved(store_lnlq_cf32[ws_ptr])
  elseif k == 0x7b; _typed_is_solved(store_lnlq_cf64[ws_ptr])
  elseif k == 0x7c; _typed_is_solved(store_gpmr_f32[ws_ptr])
  elseif k == 0x7d; _typed_is_solved(store_gpmr_f64[ws_ptr])
  elseif k == 0x7e; _typed_is_solved(store_gpmr_cf32[ws_ptr])
  elseif k == 0x7f; _typed_is_solved(store_gpmr_cf64[ws_ptr])
  elseif k == 0x80; _typed_is_solved(store_car_f32[ws_ptr])
  elseif k == 0x81; _typed_is_solved(store_car_f64[ws_ptr])
  elseif k == 0x82; _typed_is_solved(store_car_cf32[ws_ptr])
  elseif k == 0x83; _typed_is_solved(store_car_cf64[ws_ptr])
  elseif k == 0x84; _typed_is_solved(store_minares_f32[ws_ptr])
  elseif k == 0x85; _typed_is_solved(store_minares_f64[ws_ptr])
  elseif k == 0x86; _typed_is_solved(store_minares_cf32[ws_ptr])
  elseif k == 0x87; _typed_is_solved(store_minares_cf64[ws_ptr])
  else; Cint(-1); end
end

function _do_elapsed_time(ws_ptr :: Ptr{Cvoid})
  haskey(ws_key_store, ws_ptr) || return Cdouble(-1.0)
  k = ws_key_store[ws_ptr]
  if k == 0x00; _typed_elapsed_time(store_cg_f32[ws_ptr])
  elseif k == 0x01; _typed_elapsed_time(store_cg_f64[ws_ptr])
  elseif k == 0x02; _typed_elapsed_time(store_cg_cf32[ws_ptr])
  elseif k == 0x03; _typed_elapsed_time(store_cg_cf64[ws_ptr])
  elseif k == 0x04; _typed_elapsed_time(store_cr_f32[ws_ptr])
  elseif k == 0x05; _typed_elapsed_time(store_cr_f64[ws_ptr])
  elseif k == 0x06; _typed_elapsed_time(store_cr_cf32[ws_ptr])
  elseif k == 0x07; _typed_elapsed_time(store_cr_cf64[ws_ptr])
  elseif k == 0x08; _typed_elapsed_time(store_symmlq_f32[ws_ptr])
  elseif k == 0x09; _typed_elapsed_time(store_symmlq_f64[ws_ptr])
  elseif k == 0x0a; _typed_elapsed_time(store_symmlq_cf32[ws_ptr])
  elseif k == 0x0b; _typed_elapsed_time(store_symmlq_cf64[ws_ptr])
  elseif k == 0x0c; _typed_elapsed_time(store_minres_f32[ws_ptr])
  elseif k == 0x0d; _typed_elapsed_time(store_minres_f64[ws_ptr])
  elseif k == 0x0e; _typed_elapsed_time(store_minres_cf32[ws_ptr])
  elseif k == 0x0f; _typed_elapsed_time(store_minres_cf64[ws_ptr])
  elseif k == 0x10; _typed_elapsed_time(store_minres_qlp_f32[ws_ptr])
  elseif k == 0x11; _typed_elapsed_time(store_minres_qlp_f64[ws_ptr])
  elseif k == 0x12; _typed_elapsed_time(store_minres_qlp_cf32[ws_ptr])
  elseif k == 0x13; _typed_elapsed_time(store_minres_qlp_cf64[ws_ptr])
  elseif k == 0x14; _typed_elapsed_time(store_diom_f32[ws_ptr])
  elseif k == 0x15; _typed_elapsed_time(store_diom_f64[ws_ptr])
  elseif k == 0x16; _typed_elapsed_time(store_diom_cf32[ws_ptr])
  elseif k == 0x17; _typed_elapsed_time(store_diom_cf64[ws_ptr])
  elseif k == 0x18; _typed_elapsed_time(store_dqgmres_f32[ws_ptr])
  elseif k == 0x19; _typed_elapsed_time(store_dqgmres_f64[ws_ptr])
  elseif k == 0x1a; _typed_elapsed_time(store_dqgmres_cf32[ws_ptr])
  elseif k == 0x1b; _typed_elapsed_time(store_dqgmres_cf64[ws_ptr])
  elseif k == 0x1c; _typed_elapsed_time(store_fom_f32[ws_ptr])
  elseif k == 0x1d; _typed_elapsed_time(store_fom_f64[ws_ptr])
  elseif k == 0x1e; _typed_elapsed_time(store_fom_cf32[ws_ptr])
  elseif k == 0x1f; _typed_elapsed_time(store_fom_cf64[ws_ptr])
  elseif k == 0x20; _typed_elapsed_time(store_gmres_f32[ws_ptr])
  elseif k == 0x21; _typed_elapsed_time(store_gmres_f64[ws_ptr])
  elseif k == 0x22; _typed_elapsed_time(store_gmres_cf32[ws_ptr])
  elseif k == 0x23; _typed_elapsed_time(store_gmres_cf64[ws_ptr])
  elseif k == 0x24; _typed_elapsed_time(store_fgmres_f32[ws_ptr])
  elseif k == 0x25; _typed_elapsed_time(store_fgmres_f64[ws_ptr])
  elseif k == 0x26; _typed_elapsed_time(store_fgmres_cf32[ws_ptr])
  elseif k == 0x27; _typed_elapsed_time(store_fgmres_cf64[ws_ptr])
  elseif k == 0x28; _typed_elapsed_time(store_bicgstab_f32[ws_ptr])
  elseif k == 0x29; _typed_elapsed_time(store_bicgstab_f64[ws_ptr])
  elseif k == 0x2a; _typed_elapsed_time(store_bicgstab_cf32[ws_ptr])
  elseif k == 0x2b; _typed_elapsed_time(store_bicgstab_cf64[ws_ptr])
  elseif k == 0x2c; _typed_elapsed_time(store_cgs_f32[ws_ptr])
  elseif k == 0x2d; _typed_elapsed_time(store_cgs_f64[ws_ptr])
  elseif k == 0x2e; _typed_elapsed_time(store_cgs_cf32[ws_ptr])
  elseif k == 0x2f; _typed_elapsed_time(store_cgs_cf64[ws_ptr])
  elseif k == 0x30; _typed_elapsed_time(store_bilq_f32[ws_ptr])
  elseif k == 0x31; _typed_elapsed_time(store_bilq_f64[ws_ptr])
  elseif k == 0x32; _typed_elapsed_time(store_bilq_cf32[ws_ptr])
  elseif k == 0x33; _typed_elapsed_time(store_bilq_cf64[ws_ptr])
  elseif k == 0x34; _typed_elapsed_time(store_qmr_f32[ws_ptr])
  elseif k == 0x35; _typed_elapsed_time(store_qmr_f64[ws_ptr])
  elseif k == 0x36; _typed_elapsed_time(store_qmr_cf32[ws_ptr])
  elseif k == 0x37; _typed_elapsed_time(store_qmr_cf64[ws_ptr])
  elseif k == 0x38; _typed_elapsed_time(store_usymlq_f32[ws_ptr])
  elseif k == 0x39; _typed_elapsed_time(store_usymlq_f64[ws_ptr])
  elseif k == 0x3a; _typed_elapsed_time(store_usymlq_cf32[ws_ptr])
  elseif k == 0x3b; _typed_elapsed_time(store_usymlq_cf64[ws_ptr])
  elseif k == 0x3c; _typed_elapsed_time(store_usymqr_f32[ws_ptr])
  elseif k == 0x3d; _typed_elapsed_time(store_usymqr_f64[ws_ptr])
  elseif k == 0x3e; _typed_elapsed_time(store_usymqr_cf32[ws_ptr])
  elseif k == 0x3f; _typed_elapsed_time(store_usymqr_cf64[ws_ptr])
  elseif k == 0x40; _typed_elapsed_time(store_tricg_f32[ws_ptr])
  elseif k == 0x41; _typed_elapsed_time(store_tricg_f64[ws_ptr])
  elseif k == 0x42; _typed_elapsed_time(store_tricg_cf32[ws_ptr])
  elseif k == 0x43; _typed_elapsed_time(store_tricg_cf64[ws_ptr])
  elseif k == 0x44; _typed_elapsed_time(store_trimr_f32[ws_ptr])
  elseif k == 0x45; _typed_elapsed_time(store_trimr_f64[ws_ptr])
  elseif k == 0x46; _typed_elapsed_time(store_trimr_cf32[ws_ptr])
  elseif k == 0x47; _typed_elapsed_time(store_trimr_cf64[ws_ptr])
  elseif k == 0x48; _typed_elapsed_time(store_trilqr_f32[ws_ptr])
  elseif k == 0x49; _typed_elapsed_time(store_trilqr_f64[ws_ptr])
  elseif k == 0x4a; _typed_elapsed_time(store_trilqr_cf32[ws_ptr])
  elseif k == 0x4b; _typed_elapsed_time(store_trilqr_cf64[ws_ptr])
  elseif k == 0x4c; _typed_elapsed_time(store_bilqr_f32[ws_ptr])
  elseif k == 0x4d; _typed_elapsed_time(store_bilqr_f64[ws_ptr])
  elseif k == 0x4e; _typed_elapsed_time(store_bilqr_cf32[ws_ptr])
  elseif k == 0x4f; _typed_elapsed_time(store_bilqr_cf64[ws_ptr])
  elseif k == 0x50; _typed_elapsed_time(store_lslq_f32[ws_ptr])
  elseif k == 0x51; _typed_elapsed_time(store_lslq_f64[ws_ptr])
  elseif k == 0x52; _typed_elapsed_time(store_lslq_cf32[ws_ptr])
  elseif k == 0x53; _typed_elapsed_time(store_lslq_cf64[ws_ptr])
  elseif k == 0x54; _typed_elapsed_time(store_lsqr_f32[ws_ptr])
  elseif k == 0x55; _typed_elapsed_time(store_lsqr_f64[ws_ptr])
  elseif k == 0x56; _typed_elapsed_time(store_lsqr_cf32[ws_ptr])
  elseif k == 0x57; _typed_elapsed_time(store_lsqr_cf64[ws_ptr])
  elseif k == 0x58; _typed_elapsed_time(store_lsmr_f32[ws_ptr])
  elseif k == 0x59; _typed_elapsed_time(store_lsmr_f64[ws_ptr])
  elseif k == 0x5a; _typed_elapsed_time(store_lsmr_cf32[ws_ptr])
  elseif k == 0x5b; _typed_elapsed_time(store_lsmr_cf64[ws_ptr])
  elseif k == 0x5c; _typed_elapsed_time(store_usymlqr_f32[ws_ptr])
  elseif k == 0x5d; _typed_elapsed_time(store_usymlqr_f64[ws_ptr])
  elseif k == 0x5e; _typed_elapsed_time(store_usymlqr_cf32[ws_ptr])
  elseif k == 0x5f; _typed_elapsed_time(store_usymlqr_cf64[ws_ptr])
  elseif k == 0x60; _typed_elapsed_time(store_cgls_f32[ws_ptr])
  elseif k == 0x61; _typed_elapsed_time(store_cgls_f64[ws_ptr])
  elseif k == 0x62; _typed_elapsed_time(store_cgls_cf32[ws_ptr])
  elseif k == 0x63; _typed_elapsed_time(store_cgls_cf64[ws_ptr])
  elseif k == 0x64; _typed_elapsed_time(store_crls_f32[ws_ptr])
  elseif k == 0x65; _typed_elapsed_time(store_crls_f64[ws_ptr])
  elseif k == 0x66; _typed_elapsed_time(store_crls_cf32[ws_ptr])
  elseif k == 0x67; _typed_elapsed_time(store_crls_cf64[ws_ptr])
  elseif k == 0x68; _typed_elapsed_time(store_cgne_f32[ws_ptr])
  elseif k == 0x69; _typed_elapsed_time(store_cgne_f64[ws_ptr])
  elseif k == 0x6a; _typed_elapsed_time(store_cgne_cf32[ws_ptr])
  elseif k == 0x6b; _typed_elapsed_time(store_cgne_cf64[ws_ptr])
  elseif k == 0x6c; _typed_elapsed_time(store_crmr_f32[ws_ptr])
  elseif k == 0x6d; _typed_elapsed_time(store_crmr_f64[ws_ptr])
  elseif k == 0x6e; _typed_elapsed_time(store_crmr_cf32[ws_ptr])
  elseif k == 0x6f; _typed_elapsed_time(store_crmr_cf64[ws_ptr])
  elseif k == 0x70; _typed_elapsed_time(store_craig_f32[ws_ptr])
  elseif k == 0x71; _typed_elapsed_time(store_craig_f64[ws_ptr])
  elseif k == 0x72; _typed_elapsed_time(store_craig_cf32[ws_ptr])
  elseif k == 0x73; _typed_elapsed_time(store_craig_cf64[ws_ptr])
  elseif k == 0x74; _typed_elapsed_time(store_craigmr_f32[ws_ptr])
  elseif k == 0x75; _typed_elapsed_time(store_craigmr_f64[ws_ptr])
  elseif k == 0x76; _typed_elapsed_time(store_craigmr_cf32[ws_ptr])
  elseif k == 0x77; _typed_elapsed_time(store_craigmr_cf64[ws_ptr])
  elseif k == 0x78; _typed_elapsed_time(store_lnlq_f32[ws_ptr])
  elseif k == 0x79; _typed_elapsed_time(store_lnlq_f64[ws_ptr])
  elseif k == 0x7a; _typed_elapsed_time(store_lnlq_cf32[ws_ptr])
  elseif k == 0x7b; _typed_elapsed_time(store_lnlq_cf64[ws_ptr])
  elseif k == 0x7c; _typed_elapsed_time(store_gpmr_f32[ws_ptr])
  elseif k == 0x7d; _typed_elapsed_time(store_gpmr_f64[ws_ptr])
  elseif k == 0x7e; _typed_elapsed_time(store_gpmr_cf32[ws_ptr])
  elseif k == 0x7f; _typed_elapsed_time(store_gpmr_cf64[ws_ptr])
  elseif k == 0x80; _typed_elapsed_time(store_car_f32[ws_ptr])
  elseif k == 0x81; _typed_elapsed_time(store_car_f64[ws_ptr])
  elseif k == 0x82; _typed_elapsed_time(store_car_cf32[ws_ptr])
  elseif k == 0x83; _typed_elapsed_time(store_car_cf64[ws_ptr])
  elseif k == 0x84; _typed_elapsed_time(store_minares_f32[ws_ptr])
  elseif k == 0x85; _typed_elapsed_time(store_minares_f64[ws_ptr])
  elseif k == 0x86; _typed_elapsed_time(store_minares_cf32[ws_ptr])
  elseif k == 0x87; _typed_elapsed_time(store_minares_cf64[ws_ptr])
  else; Cdouble(-1.0); end
end

function _do_get_x!(ws_ptr :: Ptr{Cvoid}, x_ptr :: Ptr{Cvoid}, n :: Cint)
  haskey(ws_key_store, ws_ptr) || return Cint(-1)
  k = ws_key_store[ws_ptr]
  if k == 0x00; _typed_get_x!(store_cg_f32[ws_ptr], x_ptr, n)
  elseif k == 0x01; _typed_get_x!(store_cg_f64[ws_ptr], x_ptr, n)
  elseif k == 0x02; _typed_get_x!(store_cg_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x03; _typed_get_x!(store_cg_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x04; _typed_get_x!(store_cr_f32[ws_ptr], x_ptr, n)
  elseif k == 0x05; _typed_get_x!(store_cr_f64[ws_ptr], x_ptr, n)
  elseif k == 0x06; _typed_get_x!(store_cr_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x07; _typed_get_x!(store_cr_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x08; _typed_get_x!(store_symmlq_f32[ws_ptr], x_ptr, n)
  elseif k == 0x09; _typed_get_x!(store_symmlq_f64[ws_ptr], x_ptr, n)
  elseif k == 0x0a; _typed_get_x!(store_symmlq_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x0b; _typed_get_x!(store_symmlq_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x0c; _typed_get_x!(store_minres_f32[ws_ptr], x_ptr, n)
  elseif k == 0x0d; _typed_get_x!(store_minres_f64[ws_ptr], x_ptr, n)
  elseif k == 0x0e; _typed_get_x!(store_minres_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x0f; _typed_get_x!(store_minres_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x10; _typed_get_x!(store_minres_qlp_f32[ws_ptr], x_ptr, n)
  elseif k == 0x11; _typed_get_x!(store_minres_qlp_f64[ws_ptr], x_ptr, n)
  elseif k == 0x12; _typed_get_x!(store_minres_qlp_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x13; _typed_get_x!(store_minres_qlp_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x14; _typed_get_x!(store_diom_f32[ws_ptr], x_ptr, n)
  elseif k == 0x15; _typed_get_x!(store_diom_f64[ws_ptr], x_ptr, n)
  elseif k == 0x16; _typed_get_x!(store_diom_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x17; _typed_get_x!(store_diom_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x18; _typed_get_x!(store_dqgmres_f32[ws_ptr], x_ptr, n)
  elseif k == 0x19; _typed_get_x!(store_dqgmres_f64[ws_ptr], x_ptr, n)
  elseif k == 0x1a; _typed_get_x!(store_dqgmres_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x1b; _typed_get_x!(store_dqgmres_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x1c; _typed_get_x!(store_fom_f32[ws_ptr], x_ptr, n)
  elseif k == 0x1d; _typed_get_x!(store_fom_f64[ws_ptr], x_ptr, n)
  elseif k == 0x1e; _typed_get_x!(store_fom_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x1f; _typed_get_x!(store_fom_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x20; _typed_get_x!(store_gmres_f32[ws_ptr], x_ptr, n)
  elseif k == 0x21; _typed_get_x!(store_gmres_f64[ws_ptr], x_ptr, n)
  elseif k == 0x22; _typed_get_x!(store_gmres_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x23; _typed_get_x!(store_gmres_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x24; _typed_get_x!(store_fgmres_f32[ws_ptr], x_ptr, n)
  elseif k == 0x25; _typed_get_x!(store_fgmres_f64[ws_ptr], x_ptr, n)
  elseif k == 0x26; _typed_get_x!(store_fgmres_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x27; _typed_get_x!(store_fgmres_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x28; _typed_get_x!(store_bicgstab_f32[ws_ptr], x_ptr, n)
  elseif k == 0x29; _typed_get_x!(store_bicgstab_f64[ws_ptr], x_ptr, n)
  elseif k == 0x2a; _typed_get_x!(store_bicgstab_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x2b; _typed_get_x!(store_bicgstab_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x2c; _typed_get_x!(store_cgs_f32[ws_ptr], x_ptr, n)
  elseif k == 0x2d; _typed_get_x!(store_cgs_f64[ws_ptr], x_ptr, n)
  elseif k == 0x2e; _typed_get_x!(store_cgs_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x2f; _typed_get_x!(store_cgs_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x30; _typed_get_x!(store_bilq_f32[ws_ptr], x_ptr, n)
  elseif k == 0x31; _typed_get_x!(store_bilq_f64[ws_ptr], x_ptr, n)
  elseif k == 0x32; _typed_get_x!(store_bilq_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x33; _typed_get_x!(store_bilq_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x34; _typed_get_x!(store_qmr_f32[ws_ptr], x_ptr, n)
  elseif k == 0x35; _typed_get_x!(store_qmr_f64[ws_ptr], x_ptr, n)
  elseif k == 0x36; _typed_get_x!(store_qmr_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x37; _typed_get_x!(store_qmr_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x38; _typed_get_x!(store_usymlq_f32[ws_ptr], x_ptr, n)
  elseif k == 0x39; _typed_get_x!(store_usymlq_f64[ws_ptr], x_ptr, n)
  elseif k == 0x3a; _typed_get_x!(store_usymlq_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x3b; _typed_get_x!(store_usymlq_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x3c; _typed_get_x!(store_usymqr_f32[ws_ptr], x_ptr, n)
  elseif k == 0x3d; _typed_get_x!(store_usymqr_f64[ws_ptr], x_ptr, n)
  elseif k == 0x3e; _typed_get_x!(store_usymqr_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x3f; _typed_get_x!(store_usymqr_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x40; _typed_get_x!(store_tricg_f32[ws_ptr], x_ptr, n)
  elseif k == 0x41; _typed_get_x!(store_tricg_f64[ws_ptr], x_ptr, n)
  elseif k == 0x42; _typed_get_x!(store_tricg_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x43; _typed_get_x!(store_tricg_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x44; _typed_get_x!(store_trimr_f32[ws_ptr], x_ptr, n)
  elseif k == 0x45; _typed_get_x!(store_trimr_f64[ws_ptr], x_ptr, n)
  elseif k == 0x46; _typed_get_x!(store_trimr_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x47; _typed_get_x!(store_trimr_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x48; _typed_get_x!(store_trilqr_f32[ws_ptr], x_ptr, n)
  elseif k == 0x49; _typed_get_x!(store_trilqr_f64[ws_ptr], x_ptr, n)
  elseif k == 0x4a; _typed_get_x!(store_trilqr_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x4b; _typed_get_x!(store_trilqr_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x4c; _typed_get_x!(store_bilqr_f32[ws_ptr], x_ptr, n)
  elseif k == 0x4d; _typed_get_x!(store_bilqr_f64[ws_ptr], x_ptr, n)
  elseif k == 0x4e; _typed_get_x!(store_bilqr_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x4f; _typed_get_x!(store_bilqr_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x50; _typed_get_x!(store_lslq_f32[ws_ptr], x_ptr, n)
  elseif k == 0x51; _typed_get_x!(store_lslq_f64[ws_ptr], x_ptr, n)
  elseif k == 0x52; _typed_get_x!(store_lslq_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x53; _typed_get_x!(store_lslq_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x54; _typed_get_x!(store_lsqr_f32[ws_ptr], x_ptr, n)
  elseif k == 0x55; _typed_get_x!(store_lsqr_f64[ws_ptr], x_ptr, n)
  elseif k == 0x56; _typed_get_x!(store_lsqr_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x57; _typed_get_x!(store_lsqr_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x58; _typed_get_x!(store_lsmr_f32[ws_ptr], x_ptr, n)
  elseif k == 0x59; _typed_get_x!(store_lsmr_f64[ws_ptr], x_ptr, n)
  elseif k == 0x5a; _typed_get_x!(store_lsmr_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x5b; _typed_get_x!(store_lsmr_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x5c; _typed_get_x!(store_usymlqr_f32[ws_ptr], x_ptr, n)
  elseif k == 0x5d; _typed_get_x!(store_usymlqr_f64[ws_ptr], x_ptr, n)
  elseif k == 0x5e; _typed_get_x!(store_usymlqr_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x5f; _typed_get_x!(store_usymlqr_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x60; _typed_get_x!(store_cgls_f32[ws_ptr], x_ptr, n)
  elseif k == 0x61; _typed_get_x!(store_cgls_f64[ws_ptr], x_ptr, n)
  elseif k == 0x62; _typed_get_x!(store_cgls_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x63; _typed_get_x!(store_cgls_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x64; _typed_get_x!(store_crls_f32[ws_ptr], x_ptr, n)
  elseif k == 0x65; _typed_get_x!(store_crls_f64[ws_ptr], x_ptr, n)
  elseif k == 0x66; _typed_get_x!(store_crls_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x67; _typed_get_x!(store_crls_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x68; _typed_get_x!(store_cgne_f32[ws_ptr], x_ptr, n)
  elseif k == 0x69; _typed_get_x!(store_cgne_f64[ws_ptr], x_ptr, n)
  elseif k == 0x6a; _typed_get_x!(store_cgne_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x6b; _typed_get_x!(store_cgne_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x6c; _typed_get_x!(store_crmr_f32[ws_ptr], x_ptr, n)
  elseif k == 0x6d; _typed_get_x!(store_crmr_f64[ws_ptr], x_ptr, n)
  elseif k == 0x6e; _typed_get_x!(store_crmr_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x6f; _typed_get_x!(store_crmr_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x70; _typed_get_x!(store_craig_f32[ws_ptr], x_ptr, n)
  elseif k == 0x71; _typed_get_x!(store_craig_f64[ws_ptr], x_ptr, n)
  elseif k == 0x72; _typed_get_x!(store_craig_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x73; _typed_get_x!(store_craig_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x74; _typed_get_x!(store_craigmr_f32[ws_ptr], x_ptr, n)
  elseif k == 0x75; _typed_get_x!(store_craigmr_f64[ws_ptr], x_ptr, n)
  elseif k == 0x76; _typed_get_x!(store_craigmr_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x77; _typed_get_x!(store_craigmr_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x78; _typed_get_x!(store_lnlq_f32[ws_ptr], x_ptr, n)
  elseif k == 0x79; _typed_get_x!(store_lnlq_f64[ws_ptr], x_ptr, n)
  elseif k == 0x7a; _typed_get_x!(store_lnlq_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x7b; _typed_get_x!(store_lnlq_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x7c; _typed_get_x!(store_gpmr_f32[ws_ptr], x_ptr, n)
  elseif k == 0x7d; _typed_get_x!(store_gpmr_f64[ws_ptr], x_ptr, n)
  elseif k == 0x7e; _typed_get_x!(store_gpmr_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x7f; _typed_get_x!(store_gpmr_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x80; _typed_get_x!(store_car_f32[ws_ptr], x_ptr, n)
  elseif k == 0x81; _typed_get_x!(store_car_f64[ws_ptr], x_ptr, n)
  elseif k == 0x82; _typed_get_x!(store_car_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x83; _typed_get_x!(store_car_cf64[ws_ptr], x_ptr, n)
  elseif k == 0x84; _typed_get_x!(store_minares_f32[ws_ptr], x_ptr, n)
  elseif k == 0x85; _typed_get_x!(store_minares_f64[ws_ptr], x_ptr, n)
  elseif k == 0x86; _typed_get_x!(store_minares_cf32[ws_ptr], x_ptr, n)
  elseif k == 0x87; _typed_get_x!(store_minares_cf64[ws_ptr], x_ptr, n)
  else; Cint(-1); end
end

function _do_get_y!(ws_ptr :: Ptr{Cvoid}, y_ptr :: Ptr{Cvoid}, m :: Cint)
  haskey(ws_key_store, ws_ptr) || return Cint(-1)
  k = ws_key_store[ws_ptr]
  if k == 0x00; _typed_get_y!(store_cg_f32[ws_ptr], y_ptr, m)
  elseif k == 0x01; _typed_get_y!(store_cg_f64[ws_ptr], y_ptr, m)
  elseif k == 0x02; _typed_get_y!(store_cg_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x03; _typed_get_y!(store_cg_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x04; _typed_get_y!(store_cr_f32[ws_ptr], y_ptr, m)
  elseif k == 0x05; _typed_get_y!(store_cr_f64[ws_ptr], y_ptr, m)
  elseif k == 0x06; _typed_get_y!(store_cr_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x07; _typed_get_y!(store_cr_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x08; _typed_get_y!(store_symmlq_f32[ws_ptr], y_ptr, m)
  elseif k == 0x09; _typed_get_y!(store_symmlq_f64[ws_ptr], y_ptr, m)
  elseif k == 0x0a; _typed_get_y!(store_symmlq_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x0b; _typed_get_y!(store_symmlq_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x0c; _typed_get_y!(store_minres_f32[ws_ptr], y_ptr, m)
  elseif k == 0x0d; _typed_get_y!(store_minres_f64[ws_ptr], y_ptr, m)
  elseif k == 0x0e; _typed_get_y!(store_minres_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x0f; _typed_get_y!(store_minres_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x10; _typed_get_y!(store_minres_qlp_f32[ws_ptr], y_ptr, m)
  elseif k == 0x11; _typed_get_y!(store_minres_qlp_f64[ws_ptr], y_ptr, m)
  elseif k == 0x12; _typed_get_y!(store_minres_qlp_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x13; _typed_get_y!(store_minres_qlp_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x14; _typed_get_y!(store_diom_f32[ws_ptr], y_ptr, m)
  elseif k == 0x15; _typed_get_y!(store_diom_f64[ws_ptr], y_ptr, m)
  elseif k == 0x16; _typed_get_y!(store_diom_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x17; _typed_get_y!(store_diom_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x18; _typed_get_y!(store_dqgmres_f32[ws_ptr], y_ptr, m)
  elseif k == 0x19; _typed_get_y!(store_dqgmres_f64[ws_ptr], y_ptr, m)
  elseif k == 0x1a; _typed_get_y!(store_dqgmres_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x1b; _typed_get_y!(store_dqgmres_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x1c; _typed_get_y!(store_fom_f32[ws_ptr], y_ptr, m)
  elseif k == 0x1d; _typed_get_y!(store_fom_f64[ws_ptr], y_ptr, m)
  elseif k == 0x1e; _typed_get_y!(store_fom_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x1f; _typed_get_y!(store_fom_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x20; _typed_get_y!(store_gmres_f32[ws_ptr], y_ptr, m)
  elseif k == 0x21; _typed_get_y!(store_gmres_f64[ws_ptr], y_ptr, m)
  elseif k == 0x22; _typed_get_y!(store_gmres_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x23; _typed_get_y!(store_gmres_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x24; _typed_get_y!(store_fgmres_f32[ws_ptr], y_ptr, m)
  elseif k == 0x25; _typed_get_y!(store_fgmres_f64[ws_ptr], y_ptr, m)
  elseif k == 0x26; _typed_get_y!(store_fgmres_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x27; _typed_get_y!(store_fgmres_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x28; _typed_get_y!(store_bicgstab_f32[ws_ptr], y_ptr, m)
  elseif k == 0x29; _typed_get_y!(store_bicgstab_f64[ws_ptr], y_ptr, m)
  elseif k == 0x2a; _typed_get_y!(store_bicgstab_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x2b; _typed_get_y!(store_bicgstab_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x2c; _typed_get_y!(store_cgs_f32[ws_ptr], y_ptr, m)
  elseif k == 0x2d; _typed_get_y!(store_cgs_f64[ws_ptr], y_ptr, m)
  elseif k == 0x2e; _typed_get_y!(store_cgs_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x2f; _typed_get_y!(store_cgs_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x30; _typed_get_y!(store_bilq_f32[ws_ptr], y_ptr, m)
  elseif k == 0x31; _typed_get_y!(store_bilq_f64[ws_ptr], y_ptr, m)
  elseif k == 0x32; _typed_get_y!(store_bilq_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x33; _typed_get_y!(store_bilq_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x34; _typed_get_y!(store_qmr_f32[ws_ptr], y_ptr, m)
  elseif k == 0x35; _typed_get_y!(store_qmr_f64[ws_ptr], y_ptr, m)
  elseif k == 0x36; _typed_get_y!(store_qmr_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x37; _typed_get_y!(store_qmr_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x38; _typed_get_y!(store_usymlq_f32[ws_ptr], y_ptr, m)
  elseif k == 0x39; _typed_get_y!(store_usymlq_f64[ws_ptr], y_ptr, m)
  elseif k == 0x3a; _typed_get_y!(store_usymlq_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x3b; _typed_get_y!(store_usymlq_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x3c; _typed_get_y!(store_usymqr_f32[ws_ptr], y_ptr, m)
  elseif k == 0x3d; _typed_get_y!(store_usymqr_f64[ws_ptr], y_ptr, m)
  elseif k == 0x3e; _typed_get_y!(store_usymqr_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x3f; _typed_get_y!(store_usymqr_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x40; _typed_get_y!(store_tricg_f32[ws_ptr], y_ptr, m)
  elseif k == 0x41; _typed_get_y!(store_tricg_f64[ws_ptr], y_ptr, m)
  elseif k == 0x42; _typed_get_y!(store_tricg_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x43; _typed_get_y!(store_tricg_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x44; _typed_get_y!(store_trimr_f32[ws_ptr], y_ptr, m)
  elseif k == 0x45; _typed_get_y!(store_trimr_f64[ws_ptr], y_ptr, m)
  elseif k == 0x46; _typed_get_y!(store_trimr_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x47; _typed_get_y!(store_trimr_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x48; _typed_get_y!(store_trilqr_f32[ws_ptr], y_ptr, m)
  elseif k == 0x49; _typed_get_y!(store_trilqr_f64[ws_ptr], y_ptr, m)
  elseif k == 0x4a; _typed_get_y!(store_trilqr_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x4b; _typed_get_y!(store_trilqr_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x4c; _typed_get_y!(store_bilqr_f32[ws_ptr], y_ptr, m)
  elseif k == 0x4d; _typed_get_y!(store_bilqr_f64[ws_ptr], y_ptr, m)
  elseif k == 0x4e; _typed_get_y!(store_bilqr_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x4f; _typed_get_y!(store_bilqr_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x50; _typed_get_y!(store_lslq_f32[ws_ptr], y_ptr, m)
  elseif k == 0x51; _typed_get_y!(store_lslq_f64[ws_ptr], y_ptr, m)
  elseif k == 0x52; _typed_get_y!(store_lslq_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x53; _typed_get_y!(store_lslq_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x54; _typed_get_y!(store_lsqr_f32[ws_ptr], y_ptr, m)
  elseif k == 0x55; _typed_get_y!(store_lsqr_f64[ws_ptr], y_ptr, m)
  elseif k == 0x56; _typed_get_y!(store_lsqr_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x57; _typed_get_y!(store_lsqr_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x58; _typed_get_y!(store_lsmr_f32[ws_ptr], y_ptr, m)
  elseif k == 0x59; _typed_get_y!(store_lsmr_f64[ws_ptr], y_ptr, m)
  elseif k == 0x5a; _typed_get_y!(store_lsmr_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x5b; _typed_get_y!(store_lsmr_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x5c; _typed_get_y!(store_usymlqr_f32[ws_ptr], y_ptr, m)
  elseif k == 0x5d; _typed_get_y!(store_usymlqr_f64[ws_ptr], y_ptr, m)
  elseif k == 0x5e; _typed_get_y!(store_usymlqr_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x5f; _typed_get_y!(store_usymlqr_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x60; _typed_get_y!(store_cgls_f32[ws_ptr], y_ptr, m)
  elseif k == 0x61; _typed_get_y!(store_cgls_f64[ws_ptr], y_ptr, m)
  elseif k == 0x62; _typed_get_y!(store_cgls_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x63; _typed_get_y!(store_cgls_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x64; _typed_get_y!(store_crls_f32[ws_ptr], y_ptr, m)
  elseif k == 0x65; _typed_get_y!(store_crls_f64[ws_ptr], y_ptr, m)
  elseif k == 0x66; _typed_get_y!(store_crls_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x67; _typed_get_y!(store_crls_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x68; _typed_get_y!(store_cgne_f32[ws_ptr], y_ptr, m)
  elseif k == 0x69; _typed_get_y!(store_cgne_f64[ws_ptr], y_ptr, m)
  elseif k == 0x6a; _typed_get_y!(store_cgne_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x6b; _typed_get_y!(store_cgne_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x6c; _typed_get_y!(store_crmr_f32[ws_ptr], y_ptr, m)
  elseif k == 0x6d; _typed_get_y!(store_crmr_f64[ws_ptr], y_ptr, m)
  elseif k == 0x6e; _typed_get_y!(store_crmr_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x6f; _typed_get_y!(store_crmr_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x70; _typed_get_y!(store_craig_f32[ws_ptr], y_ptr, m)
  elseif k == 0x71; _typed_get_y!(store_craig_f64[ws_ptr], y_ptr, m)
  elseif k == 0x72; _typed_get_y!(store_craig_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x73; _typed_get_y!(store_craig_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x74; _typed_get_y!(store_craigmr_f32[ws_ptr], y_ptr, m)
  elseif k == 0x75; _typed_get_y!(store_craigmr_f64[ws_ptr], y_ptr, m)
  elseif k == 0x76; _typed_get_y!(store_craigmr_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x77; _typed_get_y!(store_craigmr_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x78; _typed_get_y!(store_lnlq_f32[ws_ptr], y_ptr, m)
  elseif k == 0x79; _typed_get_y!(store_lnlq_f64[ws_ptr], y_ptr, m)
  elseif k == 0x7a; _typed_get_y!(store_lnlq_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x7b; _typed_get_y!(store_lnlq_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x7c; _typed_get_y!(store_gpmr_f32[ws_ptr], y_ptr, m)
  elseif k == 0x7d; _typed_get_y!(store_gpmr_f64[ws_ptr], y_ptr, m)
  elseif k == 0x7e; _typed_get_y!(store_gpmr_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x7f; _typed_get_y!(store_gpmr_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x80; _typed_get_y!(store_car_f32[ws_ptr], y_ptr, m)
  elseif k == 0x81; _typed_get_y!(store_car_f64[ws_ptr], y_ptr, m)
  elseif k == 0x82; _typed_get_y!(store_car_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x83; _typed_get_y!(store_car_cf64[ws_ptr], y_ptr, m)
  elseif k == 0x84; _typed_get_y!(store_minares_f32[ws_ptr], y_ptr, m)
  elseif k == 0x85; _typed_get_y!(store_minares_f64[ws_ptr], y_ptr, m)
  elseif k == 0x86; _typed_get_y!(store_minares_cf32[ws_ptr], y_ptr, m)
  elseif k == 0x87; _typed_get_y!(store_minares_cf64[ws_ptr], y_ptr, m)
  else; Cint(-1); end
end

function _do_warm_start!(ws_ptr :: Ptr{Cvoid}, x0_ptr :: Ptr{Cvoid}, n :: Cint)
  haskey(ws_key_store, ws_ptr) || return Cint(-1)
  k = ws_key_store[ws_ptr]
  if k == 0x00; _typed_warm_start!(store_cg_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x01; _typed_warm_start!(store_cg_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x02; _typed_warm_start!(store_cg_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x03; _typed_warm_start!(store_cg_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x04; _typed_warm_start!(store_cr_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x05; _typed_warm_start!(store_cr_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x06; _typed_warm_start!(store_cr_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x07; _typed_warm_start!(store_cr_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x08; _typed_warm_start!(store_symmlq_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x09; _typed_warm_start!(store_symmlq_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x0a; _typed_warm_start!(store_symmlq_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x0b; _typed_warm_start!(store_symmlq_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x0c; _typed_warm_start!(store_minres_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x0d; _typed_warm_start!(store_minres_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x0e; _typed_warm_start!(store_minres_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x0f; _typed_warm_start!(store_minres_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x10; _typed_warm_start!(store_minres_qlp_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x11; _typed_warm_start!(store_minres_qlp_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x12; _typed_warm_start!(store_minres_qlp_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x13; _typed_warm_start!(store_minres_qlp_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x14; _typed_warm_start!(store_diom_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x15; _typed_warm_start!(store_diom_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x16; _typed_warm_start!(store_diom_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x17; _typed_warm_start!(store_diom_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x18; _typed_warm_start!(store_dqgmres_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x19; _typed_warm_start!(store_dqgmres_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x1a; _typed_warm_start!(store_dqgmres_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x1b; _typed_warm_start!(store_dqgmres_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x1c; _typed_warm_start!(store_fom_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x1d; _typed_warm_start!(store_fom_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x1e; _typed_warm_start!(store_fom_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x1f; _typed_warm_start!(store_fom_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x20; _typed_warm_start!(store_gmres_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x21; _typed_warm_start!(store_gmres_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x22; _typed_warm_start!(store_gmres_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x23; _typed_warm_start!(store_gmres_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x24; _typed_warm_start!(store_fgmres_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x25; _typed_warm_start!(store_fgmres_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x26; _typed_warm_start!(store_fgmres_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x27; _typed_warm_start!(store_fgmres_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x28; _typed_warm_start!(store_bicgstab_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x29; _typed_warm_start!(store_bicgstab_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x2a; _typed_warm_start!(store_bicgstab_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x2b; _typed_warm_start!(store_bicgstab_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x2c; _typed_warm_start!(store_cgs_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x2d; _typed_warm_start!(store_cgs_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x2e; _typed_warm_start!(store_cgs_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x2f; _typed_warm_start!(store_cgs_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x30; _typed_warm_start!(store_bilq_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x31; _typed_warm_start!(store_bilq_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x32; _typed_warm_start!(store_bilq_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x33; _typed_warm_start!(store_bilq_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x34; _typed_warm_start!(store_qmr_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x35; _typed_warm_start!(store_qmr_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x36; _typed_warm_start!(store_qmr_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x37; _typed_warm_start!(store_qmr_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x38; _typed_warm_start!(store_usymlq_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x39; _typed_warm_start!(store_usymlq_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x3a; _typed_warm_start!(store_usymlq_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x3b; _typed_warm_start!(store_usymlq_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x3c; _typed_warm_start!(store_usymqr_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x3d; _typed_warm_start!(store_usymqr_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x3e; _typed_warm_start!(store_usymqr_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x3f; _typed_warm_start!(store_usymqr_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x40; _typed_warm_start!(store_tricg_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x41; _typed_warm_start!(store_tricg_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x42; _typed_warm_start!(store_tricg_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x43; _typed_warm_start!(store_tricg_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x44; _typed_warm_start!(store_trimr_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x45; _typed_warm_start!(store_trimr_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x46; _typed_warm_start!(store_trimr_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x47; _typed_warm_start!(store_trimr_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x48; _typed_warm_start!(store_trilqr_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x49; _typed_warm_start!(store_trilqr_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x4a; _typed_warm_start!(store_trilqr_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x4b; _typed_warm_start!(store_trilqr_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x4c; _typed_warm_start!(store_bilqr_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x4d; _typed_warm_start!(store_bilqr_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x4e; _typed_warm_start!(store_bilqr_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x4f; _typed_warm_start!(store_bilqr_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x50; _typed_warm_start!(store_lslq_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x51; _typed_warm_start!(store_lslq_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x52; _typed_warm_start!(store_lslq_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x53; _typed_warm_start!(store_lslq_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x54; _typed_warm_start!(store_lsqr_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x55; _typed_warm_start!(store_lsqr_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x56; _typed_warm_start!(store_lsqr_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x57; _typed_warm_start!(store_lsqr_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x58; _typed_warm_start!(store_lsmr_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x59; _typed_warm_start!(store_lsmr_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x5a; _typed_warm_start!(store_lsmr_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x5b; _typed_warm_start!(store_lsmr_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x5c; _typed_warm_start!(store_usymlqr_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x5d; _typed_warm_start!(store_usymlqr_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x5e; _typed_warm_start!(store_usymlqr_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x5f; _typed_warm_start!(store_usymlqr_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x60; _typed_warm_start!(store_cgls_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x61; _typed_warm_start!(store_cgls_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x62; _typed_warm_start!(store_cgls_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x63; _typed_warm_start!(store_cgls_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x64; _typed_warm_start!(store_crls_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x65; _typed_warm_start!(store_crls_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x66; _typed_warm_start!(store_crls_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x67; _typed_warm_start!(store_crls_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x68; _typed_warm_start!(store_cgne_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x69; _typed_warm_start!(store_cgne_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x6a; _typed_warm_start!(store_cgne_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x6b; _typed_warm_start!(store_cgne_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x6c; _typed_warm_start!(store_crmr_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x6d; _typed_warm_start!(store_crmr_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x6e; _typed_warm_start!(store_crmr_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x6f; _typed_warm_start!(store_crmr_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x70; _typed_warm_start!(store_craig_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x71; _typed_warm_start!(store_craig_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x72; _typed_warm_start!(store_craig_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x73; _typed_warm_start!(store_craig_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x74; _typed_warm_start!(store_craigmr_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x75; _typed_warm_start!(store_craigmr_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x76; _typed_warm_start!(store_craigmr_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x77; _typed_warm_start!(store_craigmr_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x78; _typed_warm_start!(store_lnlq_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x79; _typed_warm_start!(store_lnlq_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x7a; _typed_warm_start!(store_lnlq_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x7b; _typed_warm_start!(store_lnlq_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x7c; _typed_warm_start!(store_gpmr_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x7d; _typed_warm_start!(store_gpmr_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x7e; _typed_warm_start!(store_gpmr_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x7f; _typed_warm_start!(store_gpmr_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x80; _typed_warm_start!(store_car_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x81; _typed_warm_start!(store_car_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x82; _typed_warm_start!(store_car_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x83; _typed_warm_start!(store_car_cf64[ws_ptr], x0_ptr, n)
  elseif k == 0x84; _typed_warm_start!(store_minares_f32[ws_ptr], x0_ptr, n)
  elseif k == 0x85; _typed_warm_start!(store_minares_f64[ws_ptr], x0_ptr, n)
  elseif k == 0x86; _typed_warm_start!(store_minares_cf32[ws_ptr], x0_ptr, n)
  elseif k == 0x87; _typed_warm_start!(store_minares_cf64[ws_ptr], x0_ptr, n)
  else; Cint(-1); end
end

function _do_warm_start2!(ws_ptr :: Ptr{Cvoid}, x0_ptr :: Ptr{Cvoid}, y0_ptr :: Ptr{Cvoid}, nx :: Cint, ny :: Cint)
  haskey(ws_key_store, ws_ptr) || return Cint(-1)
  k = ws_key_store[ws_ptr]
  if k == 0x00; _typed_warm_start2!(store_cg_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x01; _typed_warm_start2!(store_cg_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x02; _typed_warm_start2!(store_cg_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x03; _typed_warm_start2!(store_cg_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x04; _typed_warm_start2!(store_cr_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x05; _typed_warm_start2!(store_cr_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x06; _typed_warm_start2!(store_cr_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x07; _typed_warm_start2!(store_cr_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x08; _typed_warm_start2!(store_symmlq_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x09; _typed_warm_start2!(store_symmlq_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x0a; _typed_warm_start2!(store_symmlq_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x0b; _typed_warm_start2!(store_symmlq_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x0c; _typed_warm_start2!(store_minres_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x0d; _typed_warm_start2!(store_minres_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x0e; _typed_warm_start2!(store_minres_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x0f; _typed_warm_start2!(store_minres_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x10; _typed_warm_start2!(store_minres_qlp_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x11; _typed_warm_start2!(store_minres_qlp_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x12; _typed_warm_start2!(store_minres_qlp_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x13; _typed_warm_start2!(store_minres_qlp_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x14; _typed_warm_start2!(store_diom_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x15; _typed_warm_start2!(store_diom_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x16; _typed_warm_start2!(store_diom_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x17; _typed_warm_start2!(store_diom_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x18; _typed_warm_start2!(store_dqgmres_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x19; _typed_warm_start2!(store_dqgmres_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x1a; _typed_warm_start2!(store_dqgmres_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x1b; _typed_warm_start2!(store_dqgmres_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x1c; _typed_warm_start2!(store_fom_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x1d; _typed_warm_start2!(store_fom_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x1e; _typed_warm_start2!(store_fom_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x1f; _typed_warm_start2!(store_fom_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x20; _typed_warm_start2!(store_gmres_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x21; _typed_warm_start2!(store_gmres_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x22; _typed_warm_start2!(store_gmres_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x23; _typed_warm_start2!(store_gmres_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x24; _typed_warm_start2!(store_fgmres_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x25; _typed_warm_start2!(store_fgmres_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x26; _typed_warm_start2!(store_fgmres_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x27; _typed_warm_start2!(store_fgmres_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x28; _typed_warm_start2!(store_bicgstab_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x29; _typed_warm_start2!(store_bicgstab_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x2a; _typed_warm_start2!(store_bicgstab_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x2b; _typed_warm_start2!(store_bicgstab_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x2c; _typed_warm_start2!(store_cgs_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x2d; _typed_warm_start2!(store_cgs_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x2e; _typed_warm_start2!(store_cgs_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x2f; _typed_warm_start2!(store_cgs_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x30; _typed_warm_start2!(store_bilq_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x31; _typed_warm_start2!(store_bilq_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x32; _typed_warm_start2!(store_bilq_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x33; _typed_warm_start2!(store_bilq_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x34; _typed_warm_start2!(store_qmr_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x35; _typed_warm_start2!(store_qmr_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x36; _typed_warm_start2!(store_qmr_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x37; _typed_warm_start2!(store_qmr_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x38; _typed_warm_start2!(store_usymlq_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x39; _typed_warm_start2!(store_usymlq_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x3a; _typed_warm_start2!(store_usymlq_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x3b; _typed_warm_start2!(store_usymlq_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x3c; _typed_warm_start2!(store_usymqr_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x3d; _typed_warm_start2!(store_usymqr_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x3e; _typed_warm_start2!(store_usymqr_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x3f; _typed_warm_start2!(store_usymqr_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x40; _typed_warm_start2!(store_tricg_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x41; _typed_warm_start2!(store_tricg_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x42; _typed_warm_start2!(store_tricg_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x43; _typed_warm_start2!(store_tricg_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x44; _typed_warm_start2!(store_trimr_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x45; _typed_warm_start2!(store_trimr_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x46; _typed_warm_start2!(store_trimr_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x47; _typed_warm_start2!(store_trimr_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x48; _typed_warm_start2!(store_trilqr_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x49; _typed_warm_start2!(store_trilqr_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x4a; _typed_warm_start2!(store_trilqr_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x4b; _typed_warm_start2!(store_trilqr_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x4c; _typed_warm_start2!(store_bilqr_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x4d; _typed_warm_start2!(store_bilqr_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x4e; _typed_warm_start2!(store_bilqr_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x4f; _typed_warm_start2!(store_bilqr_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x50; _typed_warm_start2!(store_lslq_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x51; _typed_warm_start2!(store_lslq_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x52; _typed_warm_start2!(store_lslq_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x53; _typed_warm_start2!(store_lslq_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x54; _typed_warm_start2!(store_lsqr_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x55; _typed_warm_start2!(store_lsqr_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x56; _typed_warm_start2!(store_lsqr_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x57; _typed_warm_start2!(store_lsqr_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x58; _typed_warm_start2!(store_lsmr_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x59; _typed_warm_start2!(store_lsmr_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x5a; _typed_warm_start2!(store_lsmr_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x5b; _typed_warm_start2!(store_lsmr_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x5c; _typed_warm_start2!(store_usymlqr_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x5d; _typed_warm_start2!(store_usymlqr_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x5e; _typed_warm_start2!(store_usymlqr_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x5f; _typed_warm_start2!(store_usymlqr_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x60; _typed_warm_start2!(store_cgls_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x61; _typed_warm_start2!(store_cgls_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x62; _typed_warm_start2!(store_cgls_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x63; _typed_warm_start2!(store_cgls_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x64; _typed_warm_start2!(store_crls_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x65; _typed_warm_start2!(store_crls_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x66; _typed_warm_start2!(store_crls_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x67; _typed_warm_start2!(store_crls_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x68; _typed_warm_start2!(store_cgne_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x69; _typed_warm_start2!(store_cgne_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x6a; _typed_warm_start2!(store_cgne_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x6b; _typed_warm_start2!(store_cgne_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x6c; _typed_warm_start2!(store_crmr_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x6d; _typed_warm_start2!(store_crmr_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x6e; _typed_warm_start2!(store_crmr_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x6f; _typed_warm_start2!(store_crmr_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x70; _typed_warm_start2!(store_craig_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x71; _typed_warm_start2!(store_craig_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x72; _typed_warm_start2!(store_craig_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x73; _typed_warm_start2!(store_craig_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x74; _typed_warm_start2!(store_craigmr_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x75; _typed_warm_start2!(store_craigmr_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x76; _typed_warm_start2!(store_craigmr_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x77; _typed_warm_start2!(store_craigmr_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x78; _typed_warm_start2!(store_lnlq_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x79; _typed_warm_start2!(store_lnlq_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x7a; _typed_warm_start2!(store_lnlq_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x7b; _typed_warm_start2!(store_lnlq_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x7c; _typed_warm_start2!(store_gpmr_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x7d; _typed_warm_start2!(store_gpmr_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x7e; _typed_warm_start2!(store_gpmr_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x7f; _typed_warm_start2!(store_gpmr_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x80; _typed_warm_start2!(store_car_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x81; _typed_warm_start2!(store_car_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x82; _typed_warm_start2!(store_car_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x83; _typed_warm_start2!(store_car_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x84; _typed_warm_start2!(store_minares_f32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x85; _typed_warm_start2!(store_minares_f64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x86; _typed_warm_start2!(store_minares_cf32[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  elseif k == 0x87; _typed_warm_start2!(store_minares_cf64[ws_ptr], x0_ptr, y0_ptr, nx, ny)
  else; Cint(-1); end
end

function _do_solve!(ws_ptr :: Ptr{Cvoid}, fptr_A :: Ptr{Cvoid}, fptr_At :: Ptr{Cvoid}, fptr_M :: Ptr{Cvoid}, fptr_N :: Ptr{Cvoid}, b_ptr :: Ptr{Cvoid}, c_ptr :: Ptr{Cvoid}, userdata :: Ptr{Cvoid}, opts_ptr :: Ptr{Cvoid})
  haskey(ws_key_store, ws_ptr) || return Cint(-1)
  opts = opts_ptr == C_NULL ? KrylovOptionsC(NaN, NaN, Cint(0), Cint(0), 0.0, NaN, NaN, NaN, 0.0, Cint(0), Cint(0), Cint(0)) : unsafe_load(Ptr{KrylovOptionsC}(opts_ptr))
  k = ws_key_store[ws_ptr]
  if k == 0x00; _typed_solve_cg!(store_cg_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x01; _typed_solve_cg!(store_cg_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x02; _typed_solve_cg!(store_cg_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x03; _typed_solve_cg!(store_cg_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x04; _typed_solve_cg!(store_cr_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x05; _typed_solve_cg!(store_cr_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x06; _typed_solve_cg!(store_cr_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x07; _typed_solve_cg!(store_cr_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x08; _typed_solve_sym_lambda!(store_symmlq_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x09; _typed_solve_sym_lambda!(store_symmlq_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x0a; _typed_solve_sym_lambda!(store_symmlq_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x0b; _typed_solve_sym_lambda!(store_symmlq_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x0c; _typed_solve_minres!(store_minres_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x0d; _typed_solve_minres!(store_minres_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x0e; _typed_solve_minres!(store_minres_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x0f; _typed_solve_minres!(store_minres_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x10; _typed_solve_minres!(store_minres_qlp_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x11; _typed_solve_minres!(store_minres_qlp_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x12; _typed_solve_minres!(store_minres_qlp_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x13; _typed_solve_minres!(store_minres_qlp_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x14; _typed_solve_mn_reorth!(store_diom_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x15; _typed_solve_mn_reorth!(store_diom_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x16; _typed_solve_mn_reorth!(store_diom_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x17; _typed_solve_mn_reorth!(store_diom_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x18; _typed_solve_mn_reorth!(store_dqgmres_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x19; _typed_solve_mn_reorth!(store_dqgmres_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x1a; _typed_solve_mn_reorth!(store_dqgmres_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x1b; _typed_solve_mn_reorth!(store_dqgmres_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x1c; _typed_solve_gmres!(store_fom_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x1d; _typed_solve_gmres!(store_fom_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x1e; _typed_solve_gmres!(store_fom_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x1f; _typed_solve_gmres!(store_fom_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x20; _typed_solve_gmres!(store_gmres_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x21; _typed_solve_gmres!(store_gmres_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x22; _typed_solve_gmres!(store_gmres_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x23; _typed_solve_gmres!(store_gmres_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x24; _typed_solve_gmres!(store_fgmres_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x25; _typed_solve_gmres!(store_fgmres_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x26; _typed_solve_gmres!(store_fgmres_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x27; _typed_solve_gmres!(store_fgmres_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x28; _typed_solve_mn!(store_bicgstab_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x29; _typed_solve_mn!(store_bicgstab_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x2a; _typed_solve_mn!(store_bicgstab_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x2b; _typed_solve_mn!(store_bicgstab_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x2c; _typed_solve_mn!(store_cgs_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x2d; _typed_solve_mn!(store_cgs_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x2e; _typed_solve_mn!(store_cgs_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x2f; _typed_solve_mn!(store_cgs_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x30; _typed_solve_mn!(store_bilq_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x31; _typed_solve_mn!(store_bilq_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x32; _typed_solve_mn!(store_bilq_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x33; _typed_solve_mn!(store_bilq_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x34; _typed_solve_mn!(store_qmr_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x35; _typed_solve_mn!(store_qmr_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x36; _typed_solve_mn!(store_qmr_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x37; _typed_solve_mn!(store_qmr_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x38; _typed_solve_two_rhs!(store_usymlq_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x39; _typed_solve_two_rhs!(store_usymlq_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x3a; _typed_solve_two_rhs!(store_usymlq_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x3b; _typed_solve_two_rhs!(store_usymlq_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x3c; _typed_solve_two_rhs!(store_usymqr_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x3d; _typed_solve_two_rhs!(store_usymqr_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x3e; _typed_solve_two_rhs!(store_usymqr_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x3f; _typed_solve_two_rhs!(store_usymqr_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x40; _typed_solve_tau_nu!(store_tricg_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x41; _typed_solve_tau_nu!(store_tricg_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x42; _typed_solve_tau_nu!(store_tricg_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x43; _typed_solve_tau_nu!(store_tricg_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x44; _typed_solve_tau_nu!(store_trimr_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x45; _typed_solve_tau_nu!(store_trimr_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x46; _typed_solve_tau_nu!(store_trimr_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x47; _typed_solve_tau_nu!(store_trimr_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x48; _typed_solve_two_rhs!(store_trilqr_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x49; _typed_solve_two_rhs!(store_trilqr_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x4a; _typed_solve_two_rhs!(store_trilqr_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x4b; _typed_solve_two_rhs!(store_trilqr_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x4c; _typed_solve_two_rhs!(store_bilqr_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x4d; _typed_solve_two_rhs!(store_bilqr_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x4e; _typed_solve_two_rhs!(store_bilqr_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x4f; _typed_solve_two_rhs!(store_bilqr_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x50; _typed_solve_ls_mn!(store_lslq_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x51; _typed_solve_ls_mn!(store_lslq_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x52; _typed_solve_ls_mn!(store_lslq_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x53; _typed_solve_ls_mn!(store_lslq_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x54; _typed_solve_ls_mn_radius!(store_lsqr_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x55; _typed_solve_ls_mn_radius!(store_lsqr_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x56; _typed_solve_ls_mn_radius!(store_lsqr_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x57; _typed_solve_ls_mn_radius!(store_lsqr_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x58; _typed_solve_ls_mn_radius!(store_lsmr_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x59; _typed_solve_ls_mn_radius!(store_lsmr_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x5a; _typed_solve_ls_mn_radius!(store_lsmr_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x5b; _typed_solve_ls_mn_radius!(store_lsmr_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x5c; _typed_solve_two_rhs!(store_usymlqr_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x5d; _typed_solve_two_rhs!(store_usymlqr_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x5e; _typed_solve_two_rhs!(store_usymlqr_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x5f; _typed_solve_two_rhs!(store_usymlqr_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x60; _typed_solve_ls_m_radius!(store_cgls_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x61; _typed_solve_ls_m_radius!(store_cgls_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x62; _typed_solve_ls_m_radius!(store_cgls_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x63; _typed_solve_ls_m_radius!(store_cgls_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x64; _typed_solve_ls_m_radius!(store_crls_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x65; _typed_solve_ls_m_radius!(store_crls_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x66; _typed_solve_ls_m_radius!(store_crls_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x67; _typed_solve_ls_m_radius!(store_crls_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x68; _typed_solve_ls_n!(store_cgne_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x69; _typed_solve_ls_n!(store_cgne_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x6a; _typed_solve_ls_n!(store_cgne_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x6b; _typed_solve_ls_n!(store_cgne_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x6c; _typed_solve_ls_n!(store_crmr_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x6d; _typed_solve_ls_n!(store_crmr_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x6e; _typed_solve_ls_n!(store_crmr_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x6f; _typed_solve_ls_n!(store_crmr_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x70; _typed_solve_ls_mn!(store_craig_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x71; _typed_solve_ls_mn!(store_craig_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x72; _typed_solve_ls_mn!(store_craig_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x73; _typed_solve_ls_mn!(store_craig_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x74; _typed_solve_ls_mn!(store_craigmr_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x75; _typed_solve_ls_mn!(store_craigmr_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x76; _typed_solve_ls_mn!(store_craigmr_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x77; _typed_solve_ls_mn!(store_craigmr_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x78; _typed_solve_ls_mn!(store_lnlq_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x79; _typed_solve_ls_mn!(store_lnlq_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x7a; _typed_solve_ls_mn!(store_lnlq_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x7b; _typed_solve_ls_mn!(store_lnlq_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x7c; _typed_solve_gpmr!(store_gpmr_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x7d; _typed_solve_gpmr!(store_gpmr_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x7e; _typed_solve_gpmr!(store_gpmr_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x7f; _typed_solve_gpmr!(store_gpmr_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x80; _typed_solve!(store_car_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x81; _typed_solve!(store_car_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x82; _typed_solve!(store_car_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x83; _typed_solve!(store_car_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x84; _typed_solve_sym_lambda!(store_minares_f32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x85; _typed_solve_sym_lambda!(store_minares_f64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x86; _typed_solve_sym_lambda!(store_minares_cf32[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  elseif k == 0x87; _typed_solve_sym_lambda!(store_minares_cf64[ws_ptr], fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts)
  else; Cint(-1); end
end

function _do_free!(ws_ptr :: Ptr{Cvoid})
  haskey(ws_key_store, ws_ptr) || return Cint(1)
  k = ws_key_store[ws_ptr]
  delete!(ws_key_store, ws_ptr)
  if k == 0x00; delete!(store_cg_f32, ws_ptr)
  elseif k == 0x01; delete!(store_cg_f64, ws_ptr)
  elseif k == 0x02; delete!(store_cg_cf32, ws_ptr)
  elseif k == 0x03; delete!(store_cg_cf64, ws_ptr)
  elseif k == 0x04; delete!(store_cr_f32, ws_ptr)
  elseif k == 0x05; delete!(store_cr_f64, ws_ptr)
  elseif k == 0x06; delete!(store_cr_cf32, ws_ptr)
  elseif k == 0x07; delete!(store_cr_cf64, ws_ptr)
  elseif k == 0x08; delete!(store_symmlq_f32, ws_ptr)
  elseif k == 0x09; delete!(store_symmlq_f64, ws_ptr)
  elseif k == 0x0a; delete!(store_symmlq_cf32, ws_ptr)
  elseif k == 0x0b; delete!(store_symmlq_cf64, ws_ptr)
  elseif k == 0x0c; delete!(store_minres_f32, ws_ptr)
  elseif k == 0x0d; delete!(store_minres_f64, ws_ptr)
  elseif k == 0x0e; delete!(store_minres_cf32, ws_ptr)
  elseif k == 0x0f; delete!(store_minres_cf64, ws_ptr)
  elseif k == 0x10; delete!(store_minres_qlp_f32, ws_ptr)
  elseif k == 0x11; delete!(store_minres_qlp_f64, ws_ptr)
  elseif k == 0x12; delete!(store_minres_qlp_cf32, ws_ptr)
  elseif k == 0x13; delete!(store_minres_qlp_cf64, ws_ptr)
  elseif k == 0x14; delete!(store_diom_f32, ws_ptr)
  elseif k == 0x15; delete!(store_diom_f64, ws_ptr)
  elseif k == 0x16; delete!(store_diom_cf32, ws_ptr)
  elseif k == 0x17; delete!(store_diom_cf64, ws_ptr)
  elseif k == 0x18; delete!(store_dqgmres_f32, ws_ptr)
  elseif k == 0x19; delete!(store_dqgmres_f64, ws_ptr)
  elseif k == 0x1a; delete!(store_dqgmres_cf32, ws_ptr)
  elseif k == 0x1b; delete!(store_dqgmres_cf64, ws_ptr)
  elseif k == 0x1c; delete!(store_fom_f32, ws_ptr)
  elseif k == 0x1d; delete!(store_fom_f64, ws_ptr)
  elseif k == 0x1e; delete!(store_fom_cf32, ws_ptr)
  elseif k == 0x1f; delete!(store_fom_cf64, ws_ptr)
  elseif k == 0x20; delete!(store_gmres_f32, ws_ptr)
  elseif k == 0x21; delete!(store_gmres_f64, ws_ptr)
  elseif k == 0x22; delete!(store_gmres_cf32, ws_ptr)
  elseif k == 0x23; delete!(store_gmres_cf64, ws_ptr)
  elseif k == 0x24; delete!(store_fgmres_f32, ws_ptr)
  elseif k == 0x25; delete!(store_fgmres_f64, ws_ptr)
  elseif k == 0x26; delete!(store_fgmres_cf32, ws_ptr)
  elseif k == 0x27; delete!(store_fgmres_cf64, ws_ptr)
  elseif k == 0x28; delete!(store_bicgstab_f32, ws_ptr)
  elseif k == 0x29; delete!(store_bicgstab_f64, ws_ptr)
  elseif k == 0x2a; delete!(store_bicgstab_cf32, ws_ptr)
  elseif k == 0x2b; delete!(store_bicgstab_cf64, ws_ptr)
  elseif k == 0x2c; delete!(store_cgs_f32, ws_ptr)
  elseif k == 0x2d; delete!(store_cgs_f64, ws_ptr)
  elseif k == 0x2e; delete!(store_cgs_cf32, ws_ptr)
  elseif k == 0x2f; delete!(store_cgs_cf64, ws_ptr)
  elseif k == 0x30; delete!(store_bilq_f32, ws_ptr)
  elseif k == 0x31; delete!(store_bilq_f64, ws_ptr)
  elseif k == 0x32; delete!(store_bilq_cf32, ws_ptr)
  elseif k == 0x33; delete!(store_bilq_cf64, ws_ptr)
  elseif k == 0x34; delete!(store_qmr_f32, ws_ptr)
  elseif k == 0x35; delete!(store_qmr_f64, ws_ptr)
  elseif k == 0x36; delete!(store_qmr_cf32, ws_ptr)
  elseif k == 0x37; delete!(store_qmr_cf64, ws_ptr)
  elseif k == 0x38; delete!(store_usymlq_f32, ws_ptr)
  elseif k == 0x39; delete!(store_usymlq_f64, ws_ptr)
  elseif k == 0x3a; delete!(store_usymlq_cf32, ws_ptr)
  elseif k == 0x3b; delete!(store_usymlq_cf64, ws_ptr)
  elseif k == 0x3c; delete!(store_usymqr_f32, ws_ptr)
  elseif k == 0x3d; delete!(store_usymqr_f64, ws_ptr)
  elseif k == 0x3e; delete!(store_usymqr_cf32, ws_ptr)
  elseif k == 0x3f; delete!(store_usymqr_cf64, ws_ptr)
  elseif k == 0x40; delete!(store_tricg_f32, ws_ptr)
  elseif k == 0x41; delete!(store_tricg_f64, ws_ptr)
  elseif k == 0x42; delete!(store_tricg_cf32, ws_ptr)
  elseif k == 0x43; delete!(store_tricg_cf64, ws_ptr)
  elseif k == 0x44; delete!(store_trimr_f32, ws_ptr)
  elseif k == 0x45; delete!(store_trimr_f64, ws_ptr)
  elseif k == 0x46; delete!(store_trimr_cf32, ws_ptr)
  elseif k == 0x47; delete!(store_trimr_cf64, ws_ptr)
  elseif k == 0x48; delete!(store_trilqr_f32, ws_ptr)
  elseif k == 0x49; delete!(store_trilqr_f64, ws_ptr)
  elseif k == 0x4a; delete!(store_trilqr_cf32, ws_ptr)
  elseif k == 0x4b; delete!(store_trilqr_cf64, ws_ptr)
  elseif k == 0x4c; delete!(store_bilqr_f32, ws_ptr)
  elseif k == 0x4d; delete!(store_bilqr_f64, ws_ptr)
  elseif k == 0x4e; delete!(store_bilqr_cf32, ws_ptr)
  elseif k == 0x4f; delete!(store_bilqr_cf64, ws_ptr)
  elseif k == 0x50; delete!(store_lslq_f32, ws_ptr)
  elseif k == 0x51; delete!(store_lslq_f64, ws_ptr)
  elseif k == 0x52; delete!(store_lslq_cf32, ws_ptr)
  elseif k == 0x53; delete!(store_lslq_cf64, ws_ptr)
  elseif k == 0x54; delete!(store_lsqr_f32, ws_ptr)
  elseif k == 0x55; delete!(store_lsqr_f64, ws_ptr)
  elseif k == 0x56; delete!(store_lsqr_cf32, ws_ptr)
  elseif k == 0x57; delete!(store_lsqr_cf64, ws_ptr)
  elseif k == 0x58; delete!(store_lsmr_f32, ws_ptr)
  elseif k == 0x59; delete!(store_lsmr_f64, ws_ptr)
  elseif k == 0x5a; delete!(store_lsmr_cf32, ws_ptr)
  elseif k == 0x5b; delete!(store_lsmr_cf64, ws_ptr)
  elseif k == 0x5c; delete!(store_usymlqr_f32, ws_ptr)
  elseif k == 0x5d; delete!(store_usymlqr_f64, ws_ptr)
  elseif k == 0x5e; delete!(store_usymlqr_cf32, ws_ptr)
  elseif k == 0x5f; delete!(store_usymlqr_cf64, ws_ptr)
  elseif k == 0x60; delete!(store_cgls_f32, ws_ptr)
  elseif k == 0x61; delete!(store_cgls_f64, ws_ptr)
  elseif k == 0x62; delete!(store_cgls_cf32, ws_ptr)
  elseif k == 0x63; delete!(store_cgls_cf64, ws_ptr)
  elseif k == 0x64; delete!(store_crls_f32, ws_ptr)
  elseif k == 0x65; delete!(store_crls_f64, ws_ptr)
  elseif k == 0x66; delete!(store_crls_cf32, ws_ptr)
  elseif k == 0x67; delete!(store_crls_cf64, ws_ptr)
  elseif k == 0x68; delete!(store_cgne_f32, ws_ptr)
  elseif k == 0x69; delete!(store_cgne_f64, ws_ptr)
  elseif k == 0x6a; delete!(store_cgne_cf32, ws_ptr)
  elseif k == 0x6b; delete!(store_cgne_cf64, ws_ptr)
  elseif k == 0x6c; delete!(store_crmr_f32, ws_ptr)
  elseif k == 0x6d; delete!(store_crmr_f64, ws_ptr)
  elseif k == 0x6e; delete!(store_crmr_cf32, ws_ptr)
  elseif k == 0x6f; delete!(store_crmr_cf64, ws_ptr)
  elseif k == 0x70; delete!(store_craig_f32, ws_ptr)
  elseif k == 0x71; delete!(store_craig_f64, ws_ptr)
  elseif k == 0x72; delete!(store_craig_cf32, ws_ptr)
  elseif k == 0x73; delete!(store_craig_cf64, ws_ptr)
  elseif k == 0x74; delete!(store_craigmr_f32, ws_ptr)
  elseif k == 0x75; delete!(store_craigmr_f64, ws_ptr)
  elseif k == 0x76; delete!(store_craigmr_cf32, ws_ptr)
  elseif k == 0x77; delete!(store_craigmr_cf64, ws_ptr)
  elseif k == 0x78; delete!(store_lnlq_f32, ws_ptr)
  elseif k == 0x79; delete!(store_lnlq_f64, ws_ptr)
  elseif k == 0x7a; delete!(store_lnlq_cf32, ws_ptr)
  elseif k == 0x7b; delete!(store_lnlq_cf64, ws_ptr)
  elseif k == 0x7c; delete!(store_gpmr_f32, ws_ptr)
  elseif k == 0x7d; delete!(store_gpmr_f64, ws_ptr)
  elseif k == 0x7e; delete!(store_gpmr_cf32, ws_ptr)
  elseif k == 0x7f; delete!(store_gpmr_cf64, ws_ptr)
  elseif k == 0x80; delete!(store_car_f32, ws_ptr)
  elseif k == 0x81; delete!(store_car_f64, ws_ptr)
  elseif k == 0x82; delete!(store_car_cf32, ws_ptr)
  elseif k == 0x83; delete!(store_car_cf64, ws_ptr)
  elseif k == 0x84; delete!(store_minares_f32, ws_ptr)
  elseif k == 0x85; delete!(store_minares_f64, ws_ptr)
  elseif k == 0x86; delete!(store_minares_cf32, ws_ptr)
  elseif k == 0x87; delete!(store_minares_cf64, ws_ptr)
  end
  Cint(0)
end

function _do_create!(solver_int :: Cint, m :: Cint, n :: Cint,
                     dtype_int :: Cint, wopts :: KrylovWorkspaceOptionsC,
                     ws_out :: Ptr{Ptr{Cvoid}})
  mem = wopts.memory == 0 ? 20 : Int(wopts.memory)
  win = wopts.window == 0 ? 5 : Int(wopts.window)
  if solver_int == Cint(0) && dtype_int == Cint(0)
    ws = Krylov.CgWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_cg_f32[r] = ws; ws_key_store[r] = 0x00
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(0) && dtype_int == Cint(1)
    ws = Krylov.CgWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_cg_f64[r] = ws; ws_key_store[r] = 0x01
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(0) && dtype_int == Cint(2)
    ws = Krylov.CgWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_cg_cf32[r] = ws; ws_key_store[r] = 0x02
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(0) && dtype_int == Cint(3)
    ws = Krylov.CgWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_cg_cf64[r] = ws; ws_key_store[r] = 0x03
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(1) && dtype_int == Cint(0)
    ws = Krylov.CrWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_cr_f32[r] = ws; ws_key_store[r] = 0x04
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(1) && dtype_int == Cint(1)
    ws = Krylov.CrWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_cr_f64[r] = ws; ws_key_store[r] = 0x05
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(1) && dtype_int == Cint(2)
    ws = Krylov.CrWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_cr_cf32[r] = ws; ws_key_store[r] = 0x06
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(1) && dtype_int == Cint(3)
    ws = Krylov.CrWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_cr_cf64[r] = ws; ws_key_store[r] = 0x07
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(2) && dtype_int == Cint(0)
    ws = Krylov.SymmlqWorkspace(Int(m), Int(n), Vector{Float32}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_symmlq_f32[r] = ws; ws_key_store[r] = 0x08
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(2) && dtype_int == Cint(1)
    ws = Krylov.SymmlqWorkspace(Int(m), Int(n), Vector{Float64}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_symmlq_f64[r] = ws; ws_key_store[r] = 0x09
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(2) && dtype_int == Cint(2)
    ws = Krylov.SymmlqWorkspace(Int(m), Int(n), Vector{ComplexF32}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_symmlq_cf32[r] = ws; ws_key_store[r] = 0x0a
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(2) && dtype_int == Cint(3)
    ws = Krylov.SymmlqWorkspace(Int(m), Int(n), Vector{ComplexF64}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_symmlq_cf64[r] = ws; ws_key_store[r] = 0x0b
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(3) && dtype_int == Cint(0)
    ws = Krylov.MinresWorkspace(Int(m), Int(n), Vector{Float32}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_minres_f32[r] = ws; ws_key_store[r] = 0x0c
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(3) && dtype_int == Cint(1)
    ws = Krylov.MinresWorkspace(Int(m), Int(n), Vector{Float64}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_minres_f64[r] = ws; ws_key_store[r] = 0x0d
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(3) && dtype_int == Cint(2)
    ws = Krylov.MinresWorkspace(Int(m), Int(n), Vector{ComplexF32}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_minres_cf32[r] = ws; ws_key_store[r] = 0x0e
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(3) && dtype_int == Cint(3)
    ws = Krylov.MinresWorkspace(Int(m), Int(n), Vector{ComplexF64}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_minres_cf64[r] = ws; ws_key_store[r] = 0x0f
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(4) && dtype_int == Cint(0)
    ws = Krylov.MinresQlpWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_minres_qlp_f32[r] = ws; ws_key_store[r] = 0x10
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(4) && dtype_int == Cint(1)
    ws = Krylov.MinresQlpWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_minres_qlp_f64[r] = ws; ws_key_store[r] = 0x11
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(4) && dtype_int == Cint(2)
    ws = Krylov.MinresQlpWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_minres_qlp_cf32[r] = ws; ws_key_store[r] = 0x12
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(4) && dtype_int == Cint(3)
    ws = Krylov.MinresQlpWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_minres_qlp_cf64[r] = ws; ws_key_store[r] = 0x13
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(5) && dtype_int == Cint(0)
    ws = Krylov.DiomWorkspace(Int(m), Int(n), Vector{Float32}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_diom_f32[r] = ws; ws_key_store[r] = 0x14
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(5) && dtype_int == Cint(1)
    ws = Krylov.DiomWorkspace(Int(m), Int(n), Vector{Float64}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_diom_f64[r] = ws; ws_key_store[r] = 0x15
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(5) && dtype_int == Cint(2)
    ws = Krylov.DiomWorkspace(Int(m), Int(n), Vector{ComplexF32}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_diom_cf32[r] = ws; ws_key_store[r] = 0x16
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(5) && dtype_int == Cint(3)
    ws = Krylov.DiomWorkspace(Int(m), Int(n), Vector{ComplexF64}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_diom_cf64[r] = ws; ws_key_store[r] = 0x17
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(6) && dtype_int == Cint(0)
    ws = Krylov.DqgmresWorkspace(Int(m), Int(n), Vector{Float32}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_dqgmres_f32[r] = ws; ws_key_store[r] = 0x18
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(6) && dtype_int == Cint(1)
    ws = Krylov.DqgmresWorkspace(Int(m), Int(n), Vector{Float64}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_dqgmres_f64[r] = ws; ws_key_store[r] = 0x19
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(6) && dtype_int == Cint(2)
    ws = Krylov.DqgmresWorkspace(Int(m), Int(n), Vector{ComplexF32}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_dqgmres_cf32[r] = ws; ws_key_store[r] = 0x1a
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(6) && dtype_int == Cint(3)
    ws = Krylov.DqgmresWorkspace(Int(m), Int(n), Vector{ComplexF64}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_dqgmres_cf64[r] = ws; ws_key_store[r] = 0x1b
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(7) && dtype_int == Cint(0)
    ws = Krylov.FomWorkspace(Int(m), Int(n), Vector{Float32}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_fom_f32[r] = ws; ws_key_store[r] = 0x1c
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(7) && dtype_int == Cint(1)
    ws = Krylov.FomWorkspace(Int(m), Int(n), Vector{Float64}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_fom_f64[r] = ws; ws_key_store[r] = 0x1d
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(7) && dtype_int == Cint(2)
    ws = Krylov.FomWorkspace(Int(m), Int(n), Vector{ComplexF32}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_fom_cf32[r] = ws; ws_key_store[r] = 0x1e
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(7) && dtype_int == Cint(3)
    ws = Krylov.FomWorkspace(Int(m), Int(n), Vector{ComplexF64}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_fom_cf64[r] = ws; ws_key_store[r] = 0x1f
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(8) && dtype_int == Cint(0)
    ws = Krylov.GmresWorkspace(Int(m), Int(n), Vector{Float32}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_gmres_f32[r] = ws; ws_key_store[r] = 0x20
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(8) && dtype_int == Cint(1)
    ws = Krylov.GmresWorkspace(Int(m), Int(n), Vector{Float64}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_gmres_f64[r] = ws; ws_key_store[r] = 0x21
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(8) && dtype_int == Cint(2)
    ws = Krylov.GmresWorkspace(Int(m), Int(n), Vector{ComplexF32}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_gmres_cf32[r] = ws; ws_key_store[r] = 0x22
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(8) && dtype_int == Cint(3)
    ws = Krylov.GmresWorkspace(Int(m), Int(n), Vector{ComplexF64}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_gmres_cf64[r] = ws; ws_key_store[r] = 0x23
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(9) && dtype_int == Cint(0)
    ws = Krylov.FgmresWorkspace(Int(m), Int(n), Vector{Float32}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_fgmres_f32[r] = ws; ws_key_store[r] = 0x24
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(9) && dtype_int == Cint(1)
    ws = Krylov.FgmresWorkspace(Int(m), Int(n), Vector{Float64}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_fgmres_f64[r] = ws; ws_key_store[r] = 0x25
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(9) && dtype_int == Cint(2)
    ws = Krylov.FgmresWorkspace(Int(m), Int(n), Vector{ComplexF32}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_fgmres_cf32[r] = ws; ws_key_store[r] = 0x26
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(9) && dtype_int == Cint(3)
    ws = Krylov.FgmresWorkspace(Int(m), Int(n), Vector{ComplexF64}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_fgmres_cf64[r] = ws; ws_key_store[r] = 0x27
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(10) && dtype_int == Cint(0)
    ws = Krylov.BicgstabWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_bicgstab_f32[r] = ws; ws_key_store[r] = 0x28
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(10) && dtype_int == Cint(1)
    ws = Krylov.BicgstabWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_bicgstab_f64[r] = ws; ws_key_store[r] = 0x29
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(10) && dtype_int == Cint(2)
    ws = Krylov.BicgstabWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_bicgstab_cf32[r] = ws; ws_key_store[r] = 0x2a
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(10) && dtype_int == Cint(3)
    ws = Krylov.BicgstabWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_bicgstab_cf64[r] = ws; ws_key_store[r] = 0x2b
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(11) && dtype_int == Cint(0)
    ws = Krylov.CgsWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_cgs_f32[r] = ws; ws_key_store[r] = 0x2c
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(11) && dtype_int == Cint(1)
    ws = Krylov.CgsWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_cgs_f64[r] = ws; ws_key_store[r] = 0x2d
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(11) && dtype_int == Cint(2)
    ws = Krylov.CgsWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_cgs_cf32[r] = ws; ws_key_store[r] = 0x2e
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(11) && dtype_int == Cint(3)
    ws = Krylov.CgsWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_cgs_cf64[r] = ws; ws_key_store[r] = 0x2f
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(12) && dtype_int == Cint(0)
    ws = Krylov.BilqWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_bilq_f32[r] = ws; ws_key_store[r] = 0x30
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(12) && dtype_int == Cint(1)
    ws = Krylov.BilqWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_bilq_f64[r] = ws; ws_key_store[r] = 0x31
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(12) && dtype_int == Cint(2)
    ws = Krylov.BilqWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_bilq_cf32[r] = ws; ws_key_store[r] = 0x32
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(12) && dtype_int == Cint(3)
    ws = Krylov.BilqWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_bilq_cf64[r] = ws; ws_key_store[r] = 0x33
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(13) && dtype_int == Cint(0)
    ws = Krylov.QmrWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_qmr_f32[r] = ws; ws_key_store[r] = 0x34
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(13) && dtype_int == Cint(1)
    ws = Krylov.QmrWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_qmr_f64[r] = ws; ws_key_store[r] = 0x35
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(13) && dtype_int == Cint(2)
    ws = Krylov.QmrWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_qmr_cf32[r] = ws; ws_key_store[r] = 0x36
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(13) && dtype_int == Cint(3)
    ws = Krylov.QmrWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_qmr_cf64[r] = ws; ws_key_store[r] = 0x37
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(14) && dtype_int == Cint(0)
    ws = Krylov.UsymlqWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_usymlq_f32[r] = ws; ws_key_store[r] = 0x38
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(14) && dtype_int == Cint(1)
    ws = Krylov.UsymlqWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_usymlq_f64[r] = ws; ws_key_store[r] = 0x39
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(14) && dtype_int == Cint(2)
    ws = Krylov.UsymlqWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_usymlq_cf32[r] = ws; ws_key_store[r] = 0x3a
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(14) && dtype_int == Cint(3)
    ws = Krylov.UsymlqWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_usymlq_cf64[r] = ws; ws_key_store[r] = 0x3b
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(15) && dtype_int == Cint(0)
    ws = Krylov.UsymqrWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_usymqr_f32[r] = ws; ws_key_store[r] = 0x3c
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(15) && dtype_int == Cint(1)
    ws = Krylov.UsymqrWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_usymqr_f64[r] = ws; ws_key_store[r] = 0x3d
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(15) && dtype_int == Cint(2)
    ws = Krylov.UsymqrWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_usymqr_cf32[r] = ws; ws_key_store[r] = 0x3e
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(15) && dtype_int == Cint(3)
    ws = Krylov.UsymqrWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_usymqr_cf64[r] = ws; ws_key_store[r] = 0x3f
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(16) && dtype_int == Cint(0)
    ws = Krylov.TricgWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_tricg_f32[r] = ws; ws_key_store[r] = 0x40
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(16) && dtype_int == Cint(1)
    ws = Krylov.TricgWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_tricg_f64[r] = ws; ws_key_store[r] = 0x41
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(16) && dtype_int == Cint(2)
    ws = Krylov.TricgWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_tricg_cf32[r] = ws; ws_key_store[r] = 0x42
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(16) && dtype_int == Cint(3)
    ws = Krylov.TricgWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_tricg_cf64[r] = ws; ws_key_store[r] = 0x43
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(17) && dtype_int == Cint(0)
    ws = Krylov.TrimrWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_trimr_f32[r] = ws; ws_key_store[r] = 0x44
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(17) && dtype_int == Cint(1)
    ws = Krylov.TrimrWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_trimr_f64[r] = ws; ws_key_store[r] = 0x45
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(17) && dtype_int == Cint(2)
    ws = Krylov.TrimrWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_trimr_cf32[r] = ws; ws_key_store[r] = 0x46
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(17) && dtype_int == Cint(3)
    ws = Krylov.TrimrWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_trimr_cf64[r] = ws; ws_key_store[r] = 0x47
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(18) && dtype_int == Cint(0)
    ws = Krylov.TrilqrWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_trilqr_f32[r] = ws; ws_key_store[r] = 0x48
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(18) && dtype_int == Cint(1)
    ws = Krylov.TrilqrWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_trilqr_f64[r] = ws; ws_key_store[r] = 0x49
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(18) && dtype_int == Cint(2)
    ws = Krylov.TrilqrWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_trilqr_cf32[r] = ws; ws_key_store[r] = 0x4a
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(18) && dtype_int == Cint(3)
    ws = Krylov.TrilqrWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_trilqr_cf64[r] = ws; ws_key_store[r] = 0x4b
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(19) && dtype_int == Cint(0)
    ws = Krylov.BilqrWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_bilqr_f32[r] = ws; ws_key_store[r] = 0x4c
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(19) && dtype_int == Cint(1)
    ws = Krylov.BilqrWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_bilqr_f64[r] = ws; ws_key_store[r] = 0x4d
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(19) && dtype_int == Cint(2)
    ws = Krylov.BilqrWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_bilqr_cf32[r] = ws; ws_key_store[r] = 0x4e
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(19) && dtype_int == Cint(3)
    ws = Krylov.BilqrWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_bilqr_cf64[r] = ws; ws_key_store[r] = 0x4f
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(20) && dtype_int == Cint(0)
    ws = Krylov.LslqWorkspace(Int(m), Int(n), Vector{Float32}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_lslq_f32[r] = ws; ws_key_store[r] = 0x50
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(20) && dtype_int == Cint(1)
    ws = Krylov.LslqWorkspace(Int(m), Int(n), Vector{Float64}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_lslq_f64[r] = ws; ws_key_store[r] = 0x51
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(20) && dtype_int == Cint(2)
    ws = Krylov.LslqWorkspace(Int(m), Int(n), Vector{ComplexF32}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_lslq_cf32[r] = ws; ws_key_store[r] = 0x52
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(20) && dtype_int == Cint(3)
    ws = Krylov.LslqWorkspace(Int(m), Int(n), Vector{ComplexF64}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_lslq_cf64[r] = ws; ws_key_store[r] = 0x53
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(21) && dtype_int == Cint(0)
    ws = Krylov.LsqrWorkspace(Int(m), Int(n), Vector{Float32}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_lsqr_f32[r] = ws; ws_key_store[r] = 0x54
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(21) && dtype_int == Cint(1)
    ws = Krylov.LsqrWorkspace(Int(m), Int(n), Vector{Float64}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_lsqr_f64[r] = ws; ws_key_store[r] = 0x55
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(21) && dtype_int == Cint(2)
    ws = Krylov.LsqrWorkspace(Int(m), Int(n), Vector{ComplexF32}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_lsqr_cf32[r] = ws; ws_key_store[r] = 0x56
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(21) && dtype_int == Cint(3)
    ws = Krylov.LsqrWorkspace(Int(m), Int(n), Vector{ComplexF64}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_lsqr_cf64[r] = ws; ws_key_store[r] = 0x57
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(22) && dtype_int == Cint(0)
    ws = Krylov.LsmrWorkspace(Int(m), Int(n), Vector{Float32}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_lsmr_f32[r] = ws; ws_key_store[r] = 0x58
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(22) && dtype_int == Cint(1)
    ws = Krylov.LsmrWorkspace(Int(m), Int(n), Vector{Float64}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_lsmr_f64[r] = ws; ws_key_store[r] = 0x59
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(22) && dtype_int == Cint(2)
    ws = Krylov.LsmrWorkspace(Int(m), Int(n), Vector{ComplexF32}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_lsmr_cf32[r] = ws; ws_key_store[r] = 0x5a
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(22) && dtype_int == Cint(3)
    ws = Krylov.LsmrWorkspace(Int(m), Int(n), Vector{ComplexF64}; window = win)
    r  = Base.pointer_from_objref(ws)
    store_lsmr_cf64[r] = ws; ws_key_store[r] = 0x5b
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(23) && dtype_int == Cint(0)
    ws = Krylov.UsymlqrWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_usymlqr_f32[r] = ws; ws_key_store[r] = 0x5c
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(23) && dtype_int == Cint(1)
    ws = Krylov.UsymlqrWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_usymlqr_f64[r] = ws; ws_key_store[r] = 0x5d
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(23) && dtype_int == Cint(2)
    ws = Krylov.UsymlqrWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_usymlqr_cf32[r] = ws; ws_key_store[r] = 0x5e
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(23) && dtype_int == Cint(3)
    ws = Krylov.UsymlqrWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_usymlqr_cf64[r] = ws; ws_key_store[r] = 0x5f
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(24) && dtype_int == Cint(0)
    ws = Krylov.CglsWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_cgls_f32[r] = ws; ws_key_store[r] = 0x60
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(24) && dtype_int == Cint(1)
    ws = Krylov.CglsWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_cgls_f64[r] = ws; ws_key_store[r] = 0x61
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(24) && dtype_int == Cint(2)
    ws = Krylov.CglsWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_cgls_cf32[r] = ws; ws_key_store[r] = 0x62
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(24) && dtype_int == Cint(3)
    ws = Krylov.CglsWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_cgls_cf64[r] = ws; ws_key_store[r] = 0x63
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(25) && dtype_int == Cint(0)
    ws = Krylov.CrlsWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_crls_f32[r] = ws; ws_key_store[r] = 0x64
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(25) && dtype_int == Cint(1)
    ws = Krylov.CrlsWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_crls_f64[r] = ws; ws_key_store[r] = 0x65
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(25) && dtype_int == Cint(2)
    ws = Krylov.CrlsWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_crls_cf32[r] = ws; ws_key_store[r] = 0x66
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(25) && dtype_int == Cint(3)
    ws = Krylov.CrlsWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_crls_cf64[r] = ws; ws_key_store[r] = 0x67
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(26) && dtype_int == Cint(0)
    ws = Krylov.CgneWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_cgne_f32[r] = ws; ws_key_store[r] = 0x68
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(26) && dtype_int == Cint(1)
    ws = Krylov.CgneWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_cgne_f64[r] = ws; ws_key_store[r] = 0x69
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(26) && dtype_int == Cint(2)
    ws = Krylov.CgneWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_cgne_cf32[r] = ws; ws_key_store[r] = 0x6a
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(26) && dtype_int == Cint(3)
    ws = Krylov.CgneWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_cgne_cf64[r] = ws; ws_key_store[r] = 0x6b
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(27) && dtype_int == Cint(0)
    ws = Krylov.CrmrWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_crmr_f32[r] = ws; ws_key_store[r] = 0x6c
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(27) && dtype_int == Cint(1)
    ws = Krylov.CrmrWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_crmr_f64[r] = ws; ws_key_store[r] = 0x6d
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(27) && dtype_int == Cint(2)
    ws = Krylov.CrmrWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_crmr_cf32[r] = ws; ws_key_store[r] = 0x6e
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(27) && dtype_int == Cint(3)
    ws = Krylov.CrmrWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_crmr_cf64[r] = ws; ws_key_store[r] = 0x6f
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(28) && dtype_int == Cint(0)
    ws = Krylov.CraigWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_craig_f32[r] = ws; ws_key_store[r] = 0x70
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(28) && dtype_int == Cint(1)
    ws = Krylov.CraigWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_craig_f64[r] = ws; ws_key_store[r] = 0x71
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(28) && dtype_int == Cint(2)
    ws = Krylov.CraigWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_craig_cf32[r] = ws; ws_key_store[r] = 0x72
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(28) && dtype_int == Cint(3)
    ws = Krylov.CraigWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_craig_cf64[r] = ws; ws_key_store[r] = 0x73
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(29) && dtype_int == Cint(0)
    ws = Krylov.CraigmrWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_craigmr_f32[r] = ws; ws_key_store[r] = 0x74
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(29) && dtype_int == Cint(1)
    ws = Krylov.CraigmrWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_craigmr_f64[r] = ws; ws_key_store[r] = 0x75
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(29) && dtype_int == Cint(2)
    ws = Krylov.CraigmrWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_craigmr_cf32[r] = ws; ws_key_store[r] = 0x76
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(29) && dtype_int == Cint(3)
    ws = Krylov.CraigmrWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_craigmr_cf64[r] = ws; ws_key_store[r] = 0x77
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(30) && dtype_int == Cint(0)
    ws = Krylov.LnlqWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_lnlq_f32[r] = ws; ws_key_store[r] = 0x78
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(30) && dtype_int == Cint(1)
    ws = Krylov.LnlqWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_lnlq_f64[r] = ws; ws_key_store[r] = 0x79
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(30) && dtype_int == Cint(2)
    ws = Krylov.LnlqWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_lnlq_cf32[r] = ws; ws_key_store[r] = 0x7a
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(30) && dtype_int == Cint(3)
    ws = Krylov.LnlqWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_lnlq_cf64[r] = ws; ws_key_store[r] = 0x7b
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(31) && dtype_int == Cint(0)
    ws = Krylov.GpmrWorkspace(Int(m), Int(n), Vector{Float32}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_gpmr_f32[r] = ws; ws_key_store[r] = 0x7c
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(31) && dtype_int == Cint(1)
    ws = Krylov.GpmrWorkspace(Int(m), Int(n), Vector{Float64}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_gpmr_f64[r] = ws; ws_key_store[r] = 0x7d
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(31) && dtype_int == Cint(2)
    ws = Krylov.GpmrWorkspace(Int(m), Int(n), Vector{ComplexF32}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_gpmr_cf32[r] = ws; ws_key_store[r] = 0x7e
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(31) && dtype_int == Cint(3)
    ws = Krylov.GpmrWorkspace(Int(m), Int(n), Vector{ComplexF64}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_gpmr_cf64[r] = ws; ws_key_store[r] = 0x7f
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(32) && dtype_int == Cint(0)
    ws = Krylov.CarWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_car_f32[r] = ws; ws_key_store[r] = 0x80
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(32) && dtype_int == Cint(1)
    ws = Krylov.CarWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_car_f64[r] = ws; ws_key_store[r] = 0x81
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(32) && dtype_int == Cint(2)
    ws = Krylov.CarWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_car_cf32[r] = ws; ws_key_store[r] = 0x82
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(32) && dtype_int == Cint(3)
    ws = Krylov.CarWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_car_cf64[r] = ws; ws_key_store[r] = 0x83
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(33) && dtype_int == Cint(0)
    ws = Krylov.MinaresWorkspace(Int(m), Int(n), Vector{Float32})
    r  = Base.pointer_from_objref(ws)
    store_minares_f32[r] = ws; ws_key_store[r] = 0x84
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(33) && dtype_int == Cint(1)
    ws = Krylov.MinaresWorkspace(Int(m), Int(n), Vector{Float64})
    r  = Base.pointer_from_objref(ws)
    store_minares_f64[r] = ws; ws_key_store[r] = 0x85
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(33) && dtype_int == Cint(2)
    ws = Krylov.MinaresWorkspace(Int(m), Int(n), Vector{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_minares_cf32[r] = ws; ws_key_store[r] = 0x86
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(33) && dtype_int == Cint(3)
    ws = Krylov.MinaresWorkspace(Int(m), Int(n), Vector{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_minares_cf64[r] = ws; ws_key_store[r] = 0x87
    unsafe_store!(ws_out, r)
  else
    return Cint(-2)  # unknown (solver, dtype) combination
  end
  Cint(0)
end

# ---------------------------------------------------------------------------
# Block Krylov stores — 2 solvers × 4 precisions = 8 combos.
# SV = Vector{FC}, SM = Matrix{FC}.  Keyed separately from the scalar stores.
# ---------------------------------------------------------------------------

const store_block_gmres_f32 = Dict{Ptr{Cvoid}, Krylov.BlockGmresWorkspace{Float32, Float32, Vector{Float32}, Matrix{Float32}}}()
const store_block_gmres_f64 = Dict{Ptr{Cvoid}, Krylov.BlockGmresWorkspace{Float64, Float64, Vector{Float64}, Matrix{Float64}}}()
const store_block_gmres_cf32 = Dict{Ptr{Cvoid}, Krylov.BlockGmresWorkspace{Float32, ComplexF32, Vector{ComplexF32}, Matrix{ComplexF32}}}()
const store_block_gmres_cf64 = Dict{Ptr{Cvoid}, Krylov.BlockGmresWorkspace{Float64, ComplexF64, Vector{ComplexF64}, Matrix{ComplexF64}}}()

const store_block_minres_f32 = Dict{Ptr{Cvoid}, Krylov.BlockMinresWorkspace{Float32, Float32, Vector{Float32}, Matrix{Float32}}}()
const store_block_minres_f64 = Dict{Ptr{Cvoid}, Krylov.BlockMinresWorkspace{Float64, Float64, Vector{Float64}, Matrix{Float64}}}()
const store_block_minres_cf32 = Dict{Ptr{Cvoid}, Krylov.BlockMinresWorkspace{Float32, ComplexF32, Vector{ComplexF32}, Matrix{ComplexF32}}}()
const store_block_minres_cf64 = Dict{Ptr{Cvoid}, Krylov.BlockMinresWorkspace{Float64, ComplexF64, Vector{ComplexF64}, Matrix{ComplexF64}}}()

const block_ws_key_store = Dict{Ptr{Cvoid}, UInt8}()

# ---------------------------------------------------------------------------
# Generic typed helpers for block workspaces.
# ---------------------------------------------------------------------------
function _typed_block_niter(ws)
  Cint(ws.stats.niter)
end

function _typed_block_is_solved(ws)
  ws.stats.solved ? Cint(1) : Cint(0)
end

function _typed_block_elapsed_time(ws)
  Cdouble(ws.stats.timer)
end

function _typed_block_get_X!(ws::Krylov.BlockKrylovWorkspace{T, FC, SV, SM}, X_ptr, n, p) where {T, FC, SV, SM}
  copyto!(unsafe_wrap(Matrix{FC}, Ptr{FC}(X_ptr), (Int(n), Int(p))), ws.X)
  Cint(0)
end

function _typed_block_warm_start!(ws::Krylov.BlockKrylovWorkspace{T, FC, SV, SM}, X0_ptr, n, p) where {T, FC, SV, SM}
  X0 = unsafe_wrap(Matrix{FC}, Ptr{FC}(X0_ptr), (Int(n), Int(p)))
  if size(ws.ΔX) != (ws.n, ws.p)
    ws.ΔX = SM(undef, ws.n, ws.p)
  end
  copyto!(ws.ΔX, X0)
  ws.warm_start = true
  Cint(0)
end

# Block solve — uses the GENERIC krylov_solve! (dispatch on the workspace type
# picks block_gmres! / block_minres!).  Going through the generic interface is
# what makes the call trim-safe: it forwards every keyword with its default
# (restart=false, ldiv=false, …) as a literal, so allocate_if(restart, …) is
# constant-folded away — a direct block_gmres! call is NOT trim-safe.
# Supports an optional left preconditioner M (applied as Y = M⁻¹X).
# fptr_N is part of the shared signature but ignored: block_minres takes M only.
function _typed_block_solve!(ws::Krylov.BlockKrylovWorkspace{T, FC, SV, SM}, fptr_A, fptr_M, fptr_N, B_ptr, userdata, opts) where {T, FC, SV, SM}
  A  = CBlockOperator{FC}(ws.m, ws.n, fptr_A, userdata)
  B  = unsafe_wrap(Matrix{FC}, Ptr{FC}(B_ptr), (ws.m, ws.p))
  kw = _opts_kw(opts, T)
  if fptr_M != C_NULL
    M = CBlockOperator{FC}(ws.n, ws.n, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, B; M=M, kw...)
  else
    Krylov.krylov_solve!(ws, A, B; kw...)
  end
  Cint(0)
end

# block_gmres accepts BOTH a left (M) and right (N) preconditioner.  As for the
# single-vector _typed_solve_mn!, the four combinations are spelled out to keep
# each krylov_solve! call site concretely typed for --trim=safe.
function _typed_block_solve_mn!(ws::Krylov.BlockKrylovWorkspace{T, FC, SV, SM}, fptr_A, fptr_M, fptr_N, B_ptr, userdata, opts) where {T, FC, SV, SM}
  A  = CBlockOperator{FC}(ws.m, ws.n, fptr_A, userdata)
  B  = unsafe_wrap(Matrix{FC}, Ptr{FC}(B_ptr), (ws.m, ws.p))
  kw = _opts_kw(opts, T)
  rs = opts.restart != 0; ro = opts.reorthogonalization != 0
  if fptr_M != C_NULL && fptr_N != C_NULL
    M = CBlockOperator{FC}(ws.m, ws.m, fptr_M, userdata)
    N = CBlockOperator{FC}(ws.n, ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, B; M=M, N=N, restart=rs, reorthogonalization=ro, kw...)
  elseif fptr_M != C_NULL
    M = CBlockOperator{FC}(ws.m, ws.m, fptr_M, userdata)
    Krylov.krylov_solve!(ws, A, B; M=M, restart=rs, reorthogonalization=ro, kw...)
  elseif fptr_N != C_NULL
    N = CBlockOperator{FC}(ws.n, ws.n, fptr_N, userdata)
    Krylov.krylov_solve!(ws, A, B; N=N, restart=rs, reorthogonalization=ro, kw...)
  else
    Krylov.krylov_solve!(ws, A, B; restart=rs, reorthogonalization=ro, kw...)
  end
  Cint(0)
end

function _do_block_niter(ws_ptr :: Ptr{Cvoid})
  haskey(block_ws_key_store, ws_ptr) || return Cint(-1)
  k = block_ws_key_store[ws_ptr]
  if k == 0x00; _typed_block_niter(store_block_gmres_f32[ws_ptr])
  elseif k == 0x01; _typed_block_niter(store_block_gmres_f64[ws_ptr])
  elseif k == 0x02; _typed_block_niter(store_block_gmres_cf32[ws_ptr])
  elseif k == 0x03; _typed_block_niter(store_block_gmres_cf64[ws_ptr])
  elseif k == 0x04; _typed_block_niter(store_block_minres_f32[ws_ptr])
  elseif k == 0x05; _typed_block_niter(store_block_minres_f64[ws_ptr])
  elseif k == 0x06; _typed_block_niter(store_block_minres_cf32[ws_ptr])
  elseif k == 0x07; _typed_block_niter(store_block_minres_cf64[ws_ptr])
  else; Cint(-1); end
end

function _do_block_is_solved(ws_ptr :: Ptr{Cvoid})
  haskey(block_ws_key_store, ws_ptr) || return Cint(-1)
  k = block_ws_key_store[ws_ptr]
  if k == 0x00; _typed_block_is_solved(store_block_gmres_f32[ws_ptr])
  elseif k == 0x01; _typed_block_is_solved(store_block_gmres_f64[ws_ptr])
  elseif k == 0x02; _typed_block_is_solved(store_block_gmres_cf32[ws_ptr])
  elseif k == 0x03; _typed_block_is_solved(store_block_gmres_cf64[ws_ptr])
  elseif k == 0x04; _typed_block_is_solved(store_block_minres_f32[ws_ptr])
  elseif k == 0x05; _typed_block_is_solved(store_block_minres_f64[ws_ptr])
  elseif k == 0x06; _typed_block_is_solved(store_block_minres_cf32[ws_ptr])
  elseif k == 0x07; _typed_block_is_solved(store_block_minres_cf64[ws_ptr])
  else; Cint(-1); end
end

function _do_block_elapsed_time(ws_ptr :: Ptr{Cvoid})
  haskey(block_ws_key_store, ws_ptr) || return Cdouble(-1.0)
  k = block_ws_key_store[ws_ptr]
  if k == 0x00; _typed_block_elapsed_time(store_block_gmres_f32[ws_ptr])
  elseif k == 0x01; _typed_block_elapsed_time(store_block_gmres_f64[ws_ptr])
  elseif k == 0x02; _typed_block_elapsed_time(store_block_gmres_cf32[ws_ptr])
  elseif k == 0x03; _typed_block_elapsed_time(store_block_gmres_cf64[ws_ptr])
  elseif k == 0x04; _typed_block_elapsed_time(store_block_minres_f32[ws_ptr])
  elseif k == 0x05; _typed_block_elapsed_time(store_block_minres_f64[ws_ptr])
  elseif k == 0x06; _typed_block_elapsed_time(store_block_minres_cf32[ws_ptr])
  elseif k == 0x07; _typed_block_elapsed_time(store_block_minres_cf64[ws_ptr])
  else; Cdouble(-1.0); end
end

function _do_block_get_X!(ws_ptr :: Ptr{Cvoid}, X_ptr :: Ptr{Cvoid}, n :: Cint, p :: Cint)
  haskey(block_ws_key_store, ws_ptr) || return Cint(-1)
  k = block_ws_key_store[ws_ptr]
  if k == 0x00; _typed_block_get_X!(store_block_gmres_f32[ws_ptr], X_ptr, n, p)
  elseif k == 0x01; _typed_block_get_X!(store_block_gmres_f64[ws_ptr], X_ptr, n, p)
  elseif k == 0x02; _typed_block_get_X!(store_block_gmres_cf32[ws_ptr], X_ptr, n, p)
  elseif k == 0x03; _typed_block_get_X!(store_block_gmres_cf64[ws_ptr], X_ptr, n, p)
  elseif k == 0x04; _typed_block_get_X!(store_block_minres_f32[ws_ptr], X_ptr, n, p)
  elseif k == 0x05; _typed_block_get_X!(store_block_minres_f64[ws_ptr], X_ptr, n, p)
  elseif k == 0x06; _typed_block_get_X!(store_block_minres_cf32[ws_ptr], X_ptr, n, p)
  elseif k == 0x07; _typed_block_get_X!(store_block_minres_cf64[ws_ptr], X_ptr, n, p)
  else; Cint(-1); end
end

function _do_block_warm_start!(ws_ptr :: Ptr{Cvoid}, X0_ptr :: Ptr{Cvoid}, n :: Cint, p :: Cint)
  haskey(block_ws_key_store, ws_ptr) || return Cint(-1)
  k = block_ws_key_store[ws_ptr]
  if k == 0x00; _typed_block_warm_start!(store_block_gmres_f32[ws_ptr], X0_ptr, n, p)
  elseif k == 0x01; _typed_block_warm_start!(store_block_gmres_f64[ws_ptr], X0_ptr, n, p)
  elseif k == 0x02; _typed_block_warm_start!(store_block_gmres_cf32[ws_ptr], X0_ptr, n, p)
  elseif k == 0x03; _typed_block_warm_start!(store_block_gmres_cf64[ws_ptr], X0_ptr, n, p)
  elseif k == 0x04; _typed_block_warm_start!(store_block_minres_f32[ws_ptr], X0_ptr, n, p)
  elseif k == 0x05; _typed_block_warm_start!(store_block_minres_f64[ws_ptr], X0_ptr, n, p)
  elseif k == 0x06; _typed_block_warm_start!(store_block_minres_cf32[ws_ptr], X0_ptr, n, p)
  elseif k == 0x07; _typed_block_warm_start!(store_block_minres_cf64[ws_ptr], X0_ptr, n, p)
  else; Cint(-1); end
end

function _do_block_solve!(ws_ptr :: Ptr{Cvoid}, fptr_A :: Ptr{Cvoid}, fptr_M :: Ptr{Cvoid}, fptr_N :: Ptr{Cvoid}, B_ptr :: Ptr{Cvoid}, userdata :: Ptr{Cvoid}, opts_ptr :: Ptr{Cvoid})
  haskey(block_ws_key_store, ws_ptr) || return Cint(-1)
  opts = opts_ptr == C_NULL ? KrylovOptionsC(NaN, NaN, Cint(0), Cint(0), 0.0, NaN, NaN, NaN, 0.0, Cint(0), Cint(0), Cint(0)) : unsafe_load(Ptr{KrylovOptionsC}(opts_ptr))
  k = block_ws_key_store[ws_ptr]
  if k == 0x00; _typed_block_solve_mn!(store_block_gmres_f32[ws_ptr], fptr_A, fptr_M, fptr_N, B_ptr, userdata, opts)
  elseif k == 0x01; _typed_block_solve_mn!(store_block_gmres_f64[ws_ptr], fptr_A, fptr_M, fptr_N, B_ptr, userdata, opts)
  elseif k == 0x02; _typed_block_solve_mn!(store_block_gmres_cf32[ws_ptr], fptr_A, fptr_M, fptr_N, B_ptr, userdata, opts)
  elseif k == 0x03; _typed_block_solve_mn!(store_block_gmres_cf64[ws_ptr], fptr_A, fptr_M, fptr_N, B_ptr, userdata, opts)
  elseif k == 0x04; _typed_block_solve!(store_block_minres_f32[ws_ptr], fptr_A, fptr_M, fptr_N, B_ptr, userdata, opts)
  elseif k == 0x05; _typed_block_solve!(store_block_minres_f64[ws_ptr], fptr_A, fptr_M, fptr_N, B_ptr, userdata, opts)
  elseif k == 0x06; _typed_block_solve!(store_block_minres_cf32[ws_ptr], fptr_A, fptr_M, fptr_N, B_ptr, userdata, opts)
  elseif k == 0x07; _typed_block_solve!(store_block_minres_cf64[ws_ptr], fptr_A, fptr_M, fptr_N, B_ptr, userdata, opts)
  else; Cint(-1); end
end

function _do_block_free!(ws_ptr :: Ptr{Cvoid})
  haskey(block_ws_key_store, ws_ptr) || return Cint(1)
  k = block_ws_key_store[ws_ptr]
  delete!(block_ws_key_store, ws_ptr)
  if k == 0x00; delete!(store_block_gmres_f32, ws_ptr)
  elseif k == 0x01; delete!(store_block_gmres_f64, ws_ptr)
  elseif k == 0x02; delete!(store_block_gmres_cf32, ws_ptr)
  elseif k == 0x03; delete!(store_block_gmres_cf64, ws_ptr)
  elseif k == 0x04; delete!(store_block_minres_f32, ws_ptr)
  elseif k == 0x05; delete!(store_block_minres_f64, ws_ptr)
  elseif k == 0x06; delete!(store_block_minres_cf32, ws_ptr)
  elseif k == 0x07; delete!(store_block_minres_cf64, ws_ptr)
  end
  Cint(0)
end

function _do_block_create!(solver_int :: Cint, m :: Cint, n :: Cint, p :: Cint,
                           dtype_int :: Cint, wopts :: KrylovWorkspaceOptionsC,
                           ws_out :: Ptr{Ptr{Cvoid}})
  mem = wopts.memory == 0 ? 5 : Int(wopts.memory)
  if solver_int == Cint(0) && dtype_int == Cint(0)
    ws = Krylov.BlockGmresWorkspace(Int(m), Int(n), Int(p), Vector{Float32}, Matrix{Float32}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_block_gmres_f32[r] = ws; block_ws_key_store[r] = 0x00
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(0) && dtype_int == Cint(1)
    ws = Krylov.BlockGmresWorkspace(Int(m), Int(n), Int(p), Vector{Float64}, Matrix{Float64}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_block_gmres_f64[r] = ws; block_ws_key_store[r] = 0x01
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(0) && dtype_int == Cint(2)
    ws = Krylov.BlockGmresWorkspace(Int(m), Int(n), Int(p), Vector{ComplexF32}, Matrix{ComplexF32}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_block_gmres_cf32[r] = ws; block_ws_key_store[r] = 0x02
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(0) && dtype_int == Cint(3)
    ws = Krylov.BlockGmresWorkspace(Int(m), Int(n), Int(p), Vector{ComplexF64}, Matrix{ComplexF64}; memory = mem)
    r  = Base.pointer_from_objref(ws)
    store_block_gmres_cf64[r] = ws; block_ws_key_store[r] = 0x03
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(1) && dtype_int == Cint(0)
    ws = Krylov.BlockMinresWorkspace(Int(m), Int(n), Int(p), Vector{Float32}, Matrix{Float32})
    r  = Base.pointer_from_objref(ws)
    store_block_minres_f32[r] = ws; block_ws_key_store[r] = 0x04
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(1) && dtype_int == Cint(1)
    ws = Krylov.BlockMinresWorkspace(Int(m), Int(n), Int(p), Vector{Float64}, Matrix{Float64})
    r  = Base.pointer_from_objref(ws)
    store_block_minres_f64[r] = ws; block_ws_key_store[r] = 0x05
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(1) && dtype_int == Cint(2)
    ws = Krylov.BlockMinresWorkspace(Int(m), Int(n), Int(p), Vector{ComplexF32}, Matrix{ComplexF32})
    r  = Base.pointer_from_objref(ws)
    store_block_minres_cf32[r] = ws; block_ws_key_store[r] = 0x06
    unsafe_store!(ws_out, r)
  elseif solver_int == Cint(1) && dtype_int == Cint(3)
    ws = Krylov.BlockMinresWorkspace(Int(m), Int(n), Int(p), Vector{ComplexF64}, Matrix{ComplexF64})
    r  = Base.pointer_from_objref(ws)
    store_block_minres_cf64[r] = ws; block_ws_key_store[r] = 0x07
    unsafe_store!(ws_out, r)
  else
    return Cint(-2)  # unknown (block solver, dtype) combination
  end
  Cint(0)
end

using BenchmarkTools
import IterativeSolvers
import KrylovKit
import KrylovMethods

using LinearAlgebra
using Printf
using SparseArrays

using Krylov
using MatrixMarket
using SuiteSparseMatrixCollection

krylov_problem = joinpath(dirname(pathof(Krylov)), "..", "test", "get_div_grad.jl")
include(krylov_problem)

ssmc = ssmc_db(verbose=false)
dataset = ssmc[(ssmc.numerical_symmetry .== 1) .& (ssmc.positive_definite.== true) .& (ssmc.real .== true) .& (3000 .≤ ssmc.nrows .≤ 5000), :]
paths = fetch_ssmc(dataset, format="MM")
names = dataset[!,:name]

const SUITE = BenchmarkGroup()

SUITE["Krylov"] = BenchmarkGroup()
SUITE["KrylovMethods"] = BenchmarkGroup()
SUITE["IterativeSolvers"] = BenchmarkGroup()
SUITE["KrylovKit"] = BenchmarkGroup()

for N in [32, 64, 128]
  A = get_div_grad(N, N, N)
  n, m = size(A)
  b = ones(n)
  rtol = 1.0e-6
  SUITE["Krylov"]["DivGrad N=$N"] = @benchmarkable cg($A, $b, atol=0.0, rtol=$rtol, itmax=$n)
  SUITE["KrylovMethods"]["DivGrad N=$N"] = @benchmarkable ($KrylovMethods.cg)($A, $b, tol=$rtol, maxIter=$n)
  SUITE["IterativeSolvers"]["DivGrad N=$N"] = @benchmarkable ($IterativeSolvers.cg)($A, $b, abstol=0.0, reltol=$rtol, maxiter=$n)
  SUITE["KrylovKit"]["DivGrad N=$N"] = @benchmarkable ($KrylovKit.linsolve)($A, $b, atol=0.0, rtol=$rtol, isposdef=true, krylovdim=$n, maxiter=1)
end

nb_pbs = length(paths)
for i = 1 : nb_pbs
  name = dataset[!,:name][i]
  path = paths[i]
  A = MatrixMarket.mmread(path * "/$name.mtx")
  n, m = size(A)
  if eltype(A) == Float64
    b = ones(n)
    rtol = 1.0e-6
    SUITE["Krylov"][name] = @benchmarkable cg($A, $b, atol=0.0, rtol=$rtol, itmax=$n)
    SUITE["KrylovMethods"][name] = @benchmarkable ($KrylovMethods.cg)($A, $b, tol=$rtol, maxIter=$n)
    SUITE["IterativeSolvers"][name] = @benchmarkable ($IterativeSolvers.cg)($A, $b, abstol=0.0, reltol=$rtol, maxiter=$n)
    SUITE["KrylovKit"][name] = @benchmarkable ($KrylovKit.linsolve)($A, $b, atol=0.0, rtol=$rtol, isposdef=true, krylovdim=$n, maxiter=1)
  end
end

using LinearAlgebra, SparseArrays, Test
using Krylov, ComponentArrays

@testset "ComponentArrays" begin
  n = 5

  for T in (Float32, Float64)
    A = rand(T, n, n)

    b = ComponentVector{T}(a=[1, 2, 3], b=[4, 5])
    @test Krylov.ktypeof(b) == Vector{T}
    x, stats = gmres(A, b)
    @test stats.solved
  end
end

function test_mp(FC)
  n = 5
  T = real(FC)
  for method in (:cg, :cgls, :usymqr, :cgne, :cgs, :crmr, :cg_lanczos, :dqgmres, :diom, :cr, :gpmr,
                 :lslq, :lsqr, :lsmr, :lnlq, :craig, :bicgstab, :craigmr, :crls, :symmlq, :minres,
                 :bilq, :minres_qlp, :qmr, :usymlq, :tricg, :trimr, :trilqr, :bilqr, :gmres, :fom,
                 :car, :minares, :fgmres, :usymlqr, :cg_lanczos_shift, :cgls_lanczos_shift)

    @testset "$method" begin
      A = spdiagm(-1 => -ones(FC,n-1), 0 => 3*ones(FC,n), 1 => -ones(FC,n-1))
      B = spdiagm(-1 => -ones(FC,n-1), 0 => 5*ones(FC,n), 1 => -ones(FC,n-1))
      b = ones(FC, n)
      c = -ones(FC, n)
      shifts = [-one(T), one(T)]
      if method in (:usymlq, :usymqr)
        x, _ = krylov_solve(Val{method}(), A, b, c, history=true)
      elseif method in (:trilqr, :bilqr)
        x, t, _ = krylov_solve(Val{method}(), A, b, c, history=true)
      elseif method in (:tricg, :trimr, :usymlqr)
        x, y, _ = krylov_solve(Val{method}(), A, b, c, history=true)
      elseif method == :gpmr
        x, y, _ = krylov_solve(Val{method}(), A, B, b, c, history=true)
      elseif method in (:lnlq, :craig, :craigmr)
        x, y, _ = krylov_solve(Val{method}(), A, b, history=true)
      elseif method in (:cg_lanczos_shift, :cgls_lanczos_shift)
        x, _ = krylov_solve(Val{method}(), A, b, shifts, history=true)
      else
        x, _ = krylov_solve(Val{method}(), A, b, history=true)
      end
      atol = √eps(T)
      rtol = √eps(T)
      Κ = (T == Float16 ? 10 : 1)
      if method in (:tricg, :trimr)
        @test norm(x + A * y - b) ≤ Κ * (atol + norm([b; c]) * rtol)
        @test norm(A' * x - y - c) ≤ Κ * (atol + norm([b; c]) * rtol)
        @test eltype(y) == FC
      elseif method == :usymlqr
        @test norm(x + A * y - b) ≤ Κ * (atol + norm([b; c]) * rtol)
        @test norm(A' * x - c) ≤ Κ * (atol + norm([b; c]) * rtol)
        @test eltype(y) == FC
      elseif method == :gpmr
        @test norm(x + A * y - b) ≤ Κ * (atol + norm([b; c]) * rtol)
        @test norm(B * x + y - c) ≤ Κ * (atol + norm([b; c]) * rtol)
        @test eltype(y) == FC
      elseif method == :cg_lanczos_shift
        @test norm((A - I) * x[1] - b) ≤ Κ * (atol + norm(b) * rtol)
        @test norm((A + I) * x[2] - b) ≤ Κ * (atol + norm(b) * rtol)
        @test eltype(x) == Vector{FC}
      elseif method == :cgls_lanczos_shift
        @test norm(A' * (b - A * x[1]) + x[1]) ≤ Κ * (atol + norm(A' * b) * rtol)
        @test norm(A' * (b - A * x[2]) - x[2]) ≤ Κ * (atol + norm(A' * b) * rtol)
        @test eltype(x) == Vector{FC}
      else
        @test norm(A * x - b) ≤ Κ * (atol + norm(b) * rtol)
        @test eltype(x) == FC
      end
      if method in (:trilqr, :bilqr)
        @test norm(A' * t - c) ≤ Κ * (atol + norm(c) * rtol)
        @test eltype(t) == FC
      end
      if method in (:lnlq, :craig, :craigmr)
        @test norm(A * A' * y - b) ≤ Κ * (atol + norm(b) * rtol)
        @test eltype(y) == FC
      end
    end
  end
end

@testset "mp" begin
  for FC in (Float16, Float32, Float64, BigFloat, Complex{Float16}, ComplexF32, ComplexF64, Complex{BigFloat})
    @testset "Data Type: $FC" begin
      test_mp(FC)
    end
  end
end

# An implementation of GPMR for the solution of unsymmetric partitioned linear systems.
#
# This method is described in
#
# A. Montoison and D. Orban
# GPMR: An Iterative Method for Unsymmetric Partitioned Linear Systems.
# SIAM Journal on Matrix Analysis and Applications, 44(1), pp. 293--311, 2023.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Montréal, August 2021.

export gpmr, gpmr!

"""
    (x, y, stats) = gpmr(A, B, b::AbstractVector{FC}, c::AbstractVector{FC};
                         memory::Int=20, C=I, D=I, E=I, F=I,
                         ldiv::Bool=false, gsp::Bool=false,
                         λ::FC=one(FC), μ::FC=one(FC),
                         reorthogonalization::Bool=false, atol::T=√eps(T),
                         rtol::T=√eps(T), itmax::Int=0,
                         timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                         callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, y, stats) = gpmr(A, B, b, c, x0::AbstractVector, y0::AbstractVector; kwargs...)

GPMR can be warm-started from initial guesses `x0` and `y0` where `kwargs` are the same keyword arguments as above.

Given matrices `A` of dimension m × n and `B` of dimension n × m,
GPMR solves the non-Hermitian partitioned linear system

    [ λIₘ   A  ] [ x ] = [ b ]
    [  B   μIₙ ] [ y ]   [ c ],

of size (n+m) × (n+m) where λ and μ are real or complex numbers.
`A` can have any shape and `B` has the shape of `Aᴴ`.
`A` and `B` must both be nonzero.

This implementation allows left and right block diagonal preconditioners

    [ C    ] [ λM   A ] [ E    ] [ E⁻¹x ] = [ Cb ]
    [    D ] [  B  μN ] [    F ] [ F⁻¹y ]   [ Dc ],

and can solve

    [ λM   A ] [ x ] = [ b ]
    [  B  μN ] [ y ]   [ c ]

when `CE = M⁻¹` and `DF = N⁻¹`.

By default, GPMR solves unsymmetric linear systems with `λ = 1` and `μ = 1`.

GPMR is based on the orthogonal Hessenberg reduction process and its relations with the block-Arnoldi process.
The residual norm ‖rₖ‖ is monotonically decreasing in GPMR.

GPMR stops when `itmax` iterations are reached or when `‖rₖ‖ ≤ atol + ‖r₀‖ * rtol`.
`atol` is an absolute tolerance and `rtol` is a relative tolerance.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :gpmr`.

For an in-place variant that reuses memory across solves, see [`gpmr!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `B`: a linear operator that models a matrix of dimension `n × m`;
* `b`: a vector of length `m`;
* `c`: a vector of length `n`.

#### Optional arguments

* `x0`: a vector of length `m` that represents an initial guess of the solution `x`;
* `y0`: a vector of length `n` that represents an initial guess of the solution `y`.

#### Keyword arguments

* `memory`: if `restart = true`, the restarted version GPMR(k) is used with `k = memory`. If `restart = false`, the parameter `memory` should be used as a hint of the number of iterations to limit dynamic memory allocations. Additional storage will be allocated if the number of iterations exceeds `memory`;
* `C`: linear operator that models a nonsingular matrix of size `m`, and represents the first term of the block-diagonal left preconditioner;
* `D`: linear operator that models a nonsingular matrix of size `n`, and represents the second term of the block-diagonal left preconditioner;
* `E`: linear operator that models a nonsingular matrix of size `m`, and represents the first term of the block-diagonal right preconditioner;
* `F`: linear operator that models a nonsingular matrix of size `n`, and represents the second term of the block-diagonal right preconditioner;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `gsp`: if `true`, set `λ = 1` and `μ = 0` for generalized saddle-point systems;
* `λ` and `μ`: diagonal scaling factors of the partitioned linear system;
* `reorthogonalization`: reorthogonalize the new vectors of the Krylov basis against all previous vectors;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `m+n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `m`;
* `y`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### Reference

* A. Montoison and D. Orban, [*GPMR: An Iterative Method for Unsymmetric Partitioned Linear Systems*](https://doi.org/10.1137/21M1459265), SIAM Journal on Matrix Analysis and Applications, 44(1), pp. 293--311, 2023.
"""
function gpmr end

"""
    workspace = gpmr!(workspace::GpmrWorkspace, A, B, b, c; kwargs...)
    workspace = gpmr!(workspace::GpmrWorkspace, A, B, b, c, x0, y0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`gpmr`](@ref).
The keyword argument `memory` is the only exception.
It is only supported by [`gpmr`](@ref) and is required to create a `GpmrWorkspace`.
It cannot be changed later.

See [`GpmrWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :gpmr` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function gpmr! end

def_args_gpmr = (:(A                    ),
                 :(B                    ),
                 :(b::AbstractVector{FC}),
                 :(c::AbstractVector{FC}))

def_optargs_gpmr = (:(x0 :: AbstractVector),
                    :(y0 :: AbstractVector))

def_kwargs_gpmr = (:(; C = I                            ),
                   :(; D = I                            ),
                   :(; E = I                            ),
                   :(; F = I                            ),
                   :(; ldiv::Bool = false               ),
                   :(; gsp::Bool = false                ),
                   :(; λ::FC = one(FC)                  ),
                   :(; μ::FC = one(FC)                  ),
                   :(; reorthogonalization::Bool = false),
                   :(; atol::T = √eps(T)                ),
                   :(; rtol::T = √eps(T)                ),
                   :(; itmax::Int = 0                   ),
                   :(; timemax::Float64 = Inf           ),
                   :(; verbose::Int = 0                 ),
                   :(; history::Bool = false            ),
                   :(; callback = workspace -> false    ),
                   :(; iostream::IO = kstdout           ))

def_kwargs_workspace_gpmr = (:(; memory::Int = 20),)

def_kwargs_gpmr = extract_parameters.(def_kwargs_gpmr)
def_kwargs_workspace_gpmr = extract_parameters.(def_kwargs_workspace_gpmr)

args_gpmr = (:A, :B, :b, :c)
optargs_gpmr = (:x0, :y0)
kwargs_gpmr = (:C, :D, :E, :F, :ldiv, :gsp, :λ, :μ, :reorthogonalization, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)
kwargs_workspace_gpmr = (:memory,)

@eval begin
  function gpmr!(workspace :: GpmrWorkspace{T,FC,Sm,Sn}, $(def_args_gpmr...); $(def_kwargs_gpmr...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    s, t = size(B)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == t         || error("Inconsistent problem size")
    s == n         || error("Inconsistent problem size")
    length(b) == m || error("Inconsistent problem size")
    length(c) == n || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "GPMR: system of %d equations in %d variables\n", m+n, m+n)

    # Check C = E = Iₘ and D = F = Iₙ
    CisI = (C === I)
    DisI = (D === I)
    EisI = (E === I)
    FisI = (F === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    eltype(B) == FC || @warn "eltype(B) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == Sm || error("ktypeof(b) must be equal to $Sm")
    ktypeof(c) == Sn || error("ktypeof(c) must be equal to $Sn")

    # Determine λ and μ associated to generalized saddle point systems.
    gsp && (λ = one(FC) ; μ = zero(FC))

    warm_start = workspace.warm_start
    warm_start && (λ ≠ 0) && !EisI && error("Warm-start with right preconditioners is not supported.")
    warm_start && (μ ≠ 0) && !FisI && error("Warm-start with right preconditioners is not supported.")

    # Set up workspace.
    allocate_if(!CisI, workspace, :q , Sm, workspace.x)  # The length of q is m
    allocate_if(!DisI, workspace, :p , Sn, workspace.y)  # The length of p is n
    allocate_if(!EisI, workspace, :wB, Sm, workspace.x)  # The length of wB is m
    allocate_if(!FisI, workspace, :wA, Sn, workspace.y)  # The length of wA is n
    wA, wB, dA, dB, Δx, Δy = workspace.wA, workspace.wB, workspace.dA, workspace.dB, workspace.Δx, workspace.Δy
    x, y, V, U, gs, gc = workspace.x, workspace.y, workspace.V, workspace.U, workspace.gs, workspace.gc
    zt, R, stats = workspace.zt, workspace.R, workspace.stats
    rNorms = stats.residuals
    reset!(stats)
    b₀ = warm_start ? dA : b
    c₀ = warm_start ? dB : c
    q  = CisI ? dA : workspace.q
    p  = DisI ? dB : workspace.p

    # Initial solutions x₀ and y₀.
    kfill!(x, zero(FC))
    kfill!(y, zero(FC))

    iter = 0
    itmax == 0 && (itmax = m+n)

    # Initialize workspace.
    nr = 0           # Number of coefficients stored in Rₖ
    mem = length(V)  # Memory
    ωₖ = zero(FC)    # Auxiliary variable to store fₖₖ
    for i = 1 : mem
      kfill!(V[i], zero(FC))
      kfill!(U[i], zero(FC))
    end
    kfill!(gs, zero(FC))  # Givens sines used for the factorization QₖRₖ = Sₖ₊₁.ₖ.
    kfill!(gc, zero(T))   # Givens cosines used for the factorization QₖRₖ = Sₖ₊₁.ₖ.
    kfill!(R , zero(FC))  # Upper triangular matrix Rₖ.
    kfill!(zt, zero(FC))  # Rₖzₖ = tₖ with (tₖ, τbar₂ₖ₊₁, τbar₂ₖ₊₂) = (Qₖ)ᴴ(βe₁ + γe₂).

    # Warm-start
    # If λ ≠ 0, Cb₀ = Cb - CAΔy - λΔx because CM = Iₘ and E = Iₘ
    # E ≠ Iₘ is only allowed when λ = 0 because E⁻¹Δx can't be computed to use CME = Iₘ
    # Compute C(b - AΔy) - λΔx
    warm_start && kmul!(b₀, A, Δy)
    warm_start && kaxpby!(m, one(FC), b, -one(FC), b₀)
    !CisI && mulorldiv!(q, C, b₀, ldiv)
    !CisI && (b₀ = q)
    warm_start && (λ ≠ 0) && kaxpy!(m, -λ, Δx, b₀)

    # If μ ≠ 0, Dc₀ = Dc - DBΔx - μΔy because DN = Iₙ and F = Iₙ
    # F ≠ Iₙ is only allowed when μ = 0 because F⁻¹Δy can't be computed to use DNF = Iₘ
    # Compute D(c - BΔx) - μΔy
    warm_start && kmul!(c₀, B, Δx)
    warm_start && kaxpby!(n, one(FC), c, -one(FC), c₀)
    !DisI && mulorldiv!(p, D, c₀, ldiv)
    !DisI && (c₀ = p)
    warm_start && (μ ≠ 0) && kaxpy!(n, -μ, Δy, c₀)

    # Initialize the orthogonal Hessenberg reduction process.
    # βv₁ = Cb
    β = knorm(m, b₀)
    if β ≠ 0
      kdivcopy!(m, V[1], b₀, β)
    else
      # β = ‖b₀‖₂ = 0
      kfill!(V[1], zero(FC))  # v₁ = 0 such that v₁ ⊥ Span{v₁, ..., vₖ}
    end

    # γu₁ = Dc
    γ = knorm(n, c₀)
    if γ ≠ 0
      kdivcopy!(n, U[1], c₀, γ)
    else
      # γ = ‖c₀‖₂ = 0
      kfill!(U[1], zero(FC))  # u₁ = 0 such that u₁ ⊥ Span{u₁, ..., uₖ}
    end

    # Compute ‖r₀‖² = γ² + β²
    rNorm = sqrt(γ^2 + β^2)
    history && push!(rNorms, rNorm)
    ε = atol + rtol * rNorm

    # Initialize t̄₀
    zt[1] = β
    zt[2] = γ

    (verbose > 0) && @printf(iostream, "%5s  %7s  %7s  %7s  %5s\n", "k", "‖rₖ‖", "hₖ₊₁.ₖ", "fₖ₊₁.ₖ", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7s  %7s  %.2fs\n", iter, rNorm, "✗ ✗ ✗ ✗", "✗ ✗ ✗ ✗", start_time |> ktimer)

    # Tolerance for breakdown detection.
    btol = eps(T)^(3/4)

    # Stopping criterion.
    breakdown = false
    inconsistent = false
    solved = rNorm ≤ ε
    tired = iter ≥ itmax
    status = "unknown"
    user_requested_exit = false
    overtimed = false

    while !(solved || tired || breakdown || user_requested_exit || overtimed)

      # Update iteration index.
      iter = iter + 1
      k = iter
      nr₂ₖ₋₁ = nr       # Position of the column 2k-1 in Rₖ.
      nr₂ₖ = nr + 2k-1  # Position of the column 2k in Rₖ.

      # Update workspace if more storage is required
      if iter > mem
        start_allocation_time = time_ns()
        for i = 1 : 4k-1
          push!(R, zero(FC))
        end
        for i = 1 : 4
          push!(gs, zero(FC))
          push!(gc, zero(T))
        end
        stats.allocation_timer += start_allocation_time |> ktimer
      end

      # Continue the orthogonal Hessenberg reduction process.
      # CAFUₖ = VₖHₖ + hₖ₊₁.ₖ * vₖ₊₁(eₖ)ᵀ = Vₖ₊₁Hₖ₊₁.ₖ
      # DBEVₖ = UₖFₖ + fₖ₊₁.ₖ * uₖ₊₁(eₖ)ᵀ = Uₖ₊₁Fₖ₊₁.ₖ
      wA = FisI ? U[iter] : workspace.wA
      wB = EisI ? V[iter] : workspace.wB
      FisI || mulorldiv!(wA, F, U[iter], ldiv)  # wA = Fuₖ
      EisI || mulorldiv!(wB, E, V[iter], ldiv)  # wB = Evₖ
      kmul!(dA, A, wA)                          # dA = AFuₖ
      kmul!(dB, B, wB)                          # dB = BEvₖ
      CisI || mulorldiv!(q, C, dA, ldiv)        # q  = CAFuₖ
      DisI || mulorldiv!(p, D, dB, ldiv)        # p  = DBEvₖ

      for i = 1 : iter
        hᵢₖ = kdot(m, V[i], q)    # hᵢ.ₖ = (vᵢ)ᴴq
        fᵢₖ = kdot(n, U[i], p)    # fᵢ.ₖ = (uᵢ)ᴴp
        kaxpy!(m, -hᵢₖ, V[i], q)  # q ← q - hᵢ.ₖvᵢ
        kaxpy!(n, -fᵢₖ, U[i], p)  # p ← p - fᵢ.ₖuᵢ
        R[nr₂ₖ + 2i-1] = hᵢₖ
        (i < iter) ? R[nr₂ₖ₋₁ + 2i] = fᵢₖ : ωₖ = fᵢₖ
      end

      # Reorthogonalization of the Krylov basis.
      if reorthogonalization
        for i = 1 : iter
          Htmp = kdot(m, V[i], q)    # hₜₘₚ = (vᵢ)ᴴq
          Ftmp = kdot(n, U[i], p)    # fₜₘₚ = (uᵢ)ᴴp
          kaxpy!(m, -Htmp, V[i], q)  # q ← q - hₜₘₚvᵢ
          kaxpy!(n, -Ftmp, U[i], p)  # p ← p - fₜₘₚuᵢ
          R[nr₂ₖ + 2i-1] += Htmp                            # hᵢ.ₖ = hᵢ.ₖ + hₜₘₚ
          (i < iter) ? R[nr₂ₖ₋₁ + 2i] += Ftmp : ωₖ += Ftmp  # fᵢ.ₖ = fᵢ.ₖ + fₜₘₚ
        end
      end

      Haux = knorm(m, q)   # hₖ₊₁.ₖ = ‖q‖₂
      Faux = knorm(n, p)   # fₖ₊₁.ₖ = ‖p‖₂

      # Add regularization terms.
      R[nr₂ₖ₋₁ + 2k-1] = λ  # S₂ₖ₋₁.₂ₖ₋₁ = λ
      R[nr₂ₖ + 2k]     = μ  # S₂ₖ.₂ₖ = μ

      # Notations : Wₖ = [w₁ ••• wₖ] = [v₁ 0  ••• vₖ 0 ]
      #                                [0  u₁ ••• 0  uₖ]
      #
      # rₖ = [ b ] - [ λI   A ] [ xₖ ] = [ b ] - [ λI   A ] Wₖzₖ
      #      [ c ]   [  B  μI ] [ yₖ ]   [ c ]   [  B  μI ]
      #
      # block-Arnoldi formulation : [ λI   A ] Wₖ = Wₖ₊₁Sₖ₊₁.ₖ
      #                             [  B  μI ]
      #
      # GPMR subproblem : min ‖ rₖ ‖ ↔ min ‖ Sₖ₊₁.ₖzₖ - βe₁ - γe₂ ‖
      #
      # Update the QR factorization of Sₖ₊₁.ₖ = Qₖ [ Rₖ ].
      #                                            [ Oᵀ ]
      #
      # Apply previous givens reflections when k ≥ 2
      # [ 1                ][ 1                ][ c₂.ᵢ  s₂.ᵢ       ][ c₁.ᵢ        s₁.ᵢ ] [ r̄₂ᵢ₋₁.₂ₖ₋₁  r̄₂ᵢ₋₁.₂ₖ ]   [ r₂ᵢ₋₁.₂ₖ₋₁  r₂ᵢ₋₁.₂ₖ ]
      # [    c₄.ᵢ  s₄.ᵢ    ][    c₃.ᵢ     s₃.ᵢ ][ s̄₂.ᵢ -c₂.ᵢ       ][       1          ] [ r̄₂ᵢ.₂ₖ₋₁    r̄₂ᵢ.₂ₖ   ] = [ r₂ᵢ.₂ₖ₋₁    r₂ᵢ.₂ₖ   ]
      # [    s̄₄.ᵢ -c₄.ᵢ    ][          1       ][             1    ][          1       ] [ ρ           hᵢ₊₁.ₖ   ]   [ r̄₂ᵢ₊₁.₂ₖ₋₁  r̄₂ᵢ₊₁.₂ₖ ]
      # [                1 ][    s̄₃.ᵢ    -c₃.ᵢ ][                1 ][ s̄₁.ᵢ       -c₁.ᵢ ] [ fᵢ₊₁.ₖ      δ        ]   [ r̄₂ᵢ₊₂.₂ₖ₋₁  r̄₂ᵢ₊₂.₂ₖ ]
      #
      # r̄₁.₂ₖ₋₁ = 0, r̄₁.₂ₖ = h₁.ₖ, r̄₂.₂ₖ₋₁ = f₁.ₖ and r̄₂.₂ₖ = 0.
      # (ρ, δ) = (λ, μ) if i == k-1, (ρ, δ) = (0, 0) otherwise.
      for i = 1 : iter-1
        for nrcol ∈ (nr₂ₖ₋₁, nr₂ₖ)
          flag = (i == iter-1 && nrcol == nr₂ₖ₋₁)
          αₖ = flag ? ωₖ : R[nrcol + 2i+2]

          c₁ᵢ = gc[4i-3]
          s₁ᵢ = gs[4i-3]
          rtmp            =      c₁ᵢ  * R[nrcol + 2i-1] + s₁ᵢ * αₖ
          αₖ              = conj(s₁ᵢ) * R[nrcol + 2i-1] - c₁ᵢ * αₖ
          R[nrcol + 2i-1] = rtmp

          c₂ᵢ = gc[4i-2]
          s₂ᵢ = gs[4i-2]
          rtmp            =      c₂ᵢ  * R[nrcol + 2i-1] + s₂ᵢ * R[nrcol + 2i]
          R[nrcol + 2i]   = conj(s₂ᵢ) * R[nrcol + 2i-1] - c₂ᵢ * R[nrcol + 2i]
          R[nrcol + 2i-1] = rtmp

          c₃ᵢ = gc[4i-1]
          s₃ᵢ = gs[4i-1]
          rtmp          =      c₃ᵢ  * R[nrcol + 2i] + s₃ᵢ * αₖ
          αₖ            = conj(s₃ᵢ) * R[nrcol + 2i] - c₃ᵢ * αₖ
          R[nrcol + 2i] = rtmp

          c₄ᵢ = gc[4i]
          s₄ᵢ = gs[4i]
          rtmp            =      c₄ᵢ  * R[nrcol + 2i] + s₄ᵢ * R[nrcol + 2i+1]
          R[nrcol + 2i+1] = conj(s₄ᵢ) * R[nrcol + 2i] - c₄ᵢ * R[nrcol + 2i+1]
          R[nrcol + 2i]   = rtmp

          flag ? ωₖ = αₖ : R[nrcol + 2i+2] = αₖ
        end
      end

      # Compute and apply current givens reflections
      # [ 1                ][ 1                ][ c₂.ₖ  s₂.ₖ       ][ c₁.ₖ        s₁.ₖ ] [ r̄₂ₖ₋₁.₂ₖ₋₁  r̄₂ₖ₋₁.₂ₖ ]    [ r₂ₖ₋₁.₂ₖ₋₁  r₂ₖ₋₁.₂ₖ ]
      # [    c₄.ₖ  s₄.ₖ    ][    c₃.ₖ     s₃.ₖ ][ s̄₂.ₖ -c₂.ₖ       ][       1          ] [ r̄₂ₖ.₂ₖ₋₁    r̄₂ₖ.₂ₖ   ] =  [             r₂ₖ.₂ₖ   ]
      # [    s̄₄.ₖ -c₄.ₖ    ][          1       ][             1    ][          1       ] [             hₖ₊₁.ₖ   ]    [                      ]
      # [                1 ][    s̄₃.ₖ    -c₃.ₖ ][                1 ][ s̄₁.ₖ       -c₁.ₖ ] [ fₖ₊₁.ₖ               ]    [                      ]
      (c₁ₖ, s₁ₖ, R[nr₂ₖ₋₁ + 2k-1]) = sym_givens(R[nr₂ₖ₋₁ + 2k-1], Faux)  # annihilate fₖ₊₁.ₖ
      θₖ             = conj(s₁ₖ) * R[nr₂ₖ + 2k-1]
      R[nr₂ₖ + 2k-1] =      c₁ₖ  * R[nr₂ₖ + 2k-1]

      (c₂ₖ, s₂ₖ, R[nr₂ₖ₋₁ + 2k-1]) = sym_givens(R[nr₂ₖ₋₁ + 2k-1], ωₖ)  # annihilate ωₖ = r̄₂ₖ.₂ₖ₋₁
      rtmp           =      c₂ₖ  * R[nr₂ₖ + 2k-1] + s₂ₖ * R[nr₂ₖ + 2k]
      R[nr₂ₖ + 2k]   = conj(s₂ₖ) * R[nr₂ₖ + 2k-1] - c₂ₖ * R[nr₂ₖ + 2k]
      R[nr₂ₖ + 2k-1] = rtmp

      (c₃ₖ, s₃ₖ, R[nr₂ₖ + 2k]) = sym_givens(R[nr₂ₖ + 2k], θₖ)  # annihilate Θₖ = r̄₂ₖ₊₂.₂ₖ

      (c₄ₖ, s₄ₖ, R[nr₂ₖ + 2k]) = sym_givens(R[nr₂ₖ + 2k], Haux)  # annihilate hₖ₊₁.ₖ

      # Update t̄ₖ = (τ₁, ..., τ₂ₖ, τbar₂ₖ₊₁, τbar₂ₖ₊₂).
      #
      # [ 1                ][ 1                ][ c₂.ₖ  s₂.ₖ       ][ c₁.ₖ        s₁.ₖ ] [ τbar₂ₖ₋₁ ]   [ τ₂ₖ₋₁    ]
      # [    c₄.ₖ  s₄.ₖ    ][    c₃.ₖ     s₃.ₖ ][ s̄₂.ₖ -c₂.ₖ       ][       1          ] [ τbar₂ₖ   ] = [ τ₂ₖ      ]
      # [    s̄₄.ₖ -c₄.ₖ    ][          1       ][             1    ][          1       ] [          ]   [ τbar₂ₖ₊₁ ]
      # [                1 ][    s̄₃.ₖ    -c₃.ₖ ][                1 ][ s̄₁.ₖ       -c₁.ₖ ] [          ]   [ τbar₂ₖ₊₂ ]
      τbar₂ₖ₊₂ = conj(s₁ₖ) * zt[2k-1]
      zt[2k-1] =      c₁ₖ  * zt[2k-1]

      τtmp     =      c₂ₖ  * zt[2k-1] + s₂ₖ * zt[2k]
      zt[2k]   = conj(s₂ₖ) * zt[2k-1] - c₂ₖ * zt[2k]
      zt[2k-1] = τtmp

      τtmp     =      c₃ₖ  * zt[2k] + s₃ₖ * τbar₂ₖ₊₂
      τbar₂ₖ₊₂ = conj(s₃ₖ) * zt[2k] - c₃ₖ * τbar₂ₖ₊₂
      zt[2k]   = τtmp

      τbar₂ₖ₊₁ = conj(s₄ₖ) * zt[2k]
      zt[2k]   =      c₄ₖ  * zt[2k]

      # Update gc and gs vectors
      gc[4k-3], gc[4k-2], gc[4k-1], gc[4k] = c₁ₖ, c₂ₖ, c₃ₖ, c₄ₖ
      gs[4k-3], gs[4k-2], gs[4k-1], gs[4k] = s₁ₖ, s₂ₖ, s₃ₖ, s₄ₖ

      # Compute ‖rₖ‖² = |τbar₂ₖ₊₁|² + |τbar₂ₖ₊₂|²
      rNorm = sqrt(abs2(τbar₂ₖ₊₁) + abs2(τbar₂ₖ₊₂))
      history && push!(rNorms, rNorm)

      # Update the number of coefficients in Rₖ.
      nr = nr + 4k-1

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      resid_decrease_mach = (rNorm + one(T) ≤ one(T))

      # Update stopping criterion.
      user_requested_exit = callback(workspace) :: Bool
      resid_decrease_lim = rNorm ≤ ε
      breakdown = Faux ≤ btol && Haux ≤ btol
      solved = resid_decrease_lim || resid_decrease_mach
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %.2fs\n", iter, rNorm, Haux, Faux, start_time |> ktimer)

      # Compute vₖ₊₁ and uₖ₊₁
      if !(solved || tired || breakdown || user_requested_exit || overtimed)
        if iter ≥ mem
          start_allocation_time = time_ns()
          push!(V, similar(workspace.x))
          push!(U, similar(workspace.y))
          push!(zt, zero(FC), zero(FC))
          stats.allocation_timer += start_allocation_time |> ktimer
        end

        # hₖ₊₁.ₖ ≠ 0
        if Haux > btol
          kdivcopy!(m, V[k+1], q, Haux)  # vₖ₊₁ = q / hₖ₊₁.ₖ
        else
          # Breakdown -- hₖ₊₁.ₖ = ‖q‖₂ = 0 and Auₖ ∈ Span{v₁, ..., vₖ}
          kfill!(V[k+1], zero(FC))  # vₖ₊₁ = 0 such that vₖ₊₁ ⊥ Span{v₁, ..., vₖ}
        end

        # fₖ₊₁.ₖ ≠ 0
        if Faux > btol
          kdivcopy!(n, U[k+1], p, Faux)  # fₖ₊₁.ₖuₖ₊₁ = p
        else
          # Breakdown -- fₖ₊₁.ₖ = ‖p‖₂ = 0 and Bvₖ ∈ Span{u₁, ..., uₖ}
          kfill!(U[k+1], zero(FC))  # uₖ₊₁ = 0 such that uₖ₊₁ ⊥ Span{u₁, ..., uₖ}
        end

        zt[2k+1] = τbar₂ₖ₊₁
        zt[2k+2] = τbar₂ₖ₊₂
      end
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Compute zₖ = (ζ₁, ..., ζ₂ₖ) by solving Rₖzₖ = tₖ with backward substitution.
    for i = 2iter : -1 : 1
      pos = nr + i - 2iter              # position of rᵢ.ₖ
      for j = 2iter : -1 : i+1
        zt[i] = zt[i] - R[pos] * zt[j]  # ζᵢ ← ζᵢ - rᵢ.ⱼζⱼ
        pos = pos - j + 1               # position of rᵢ.ⱼ₋₁
      end
      # Rₖ can be singular if the system is inconsistent
      if abs(R[pos]) ≤ btol
        zt[i] = zero(FC)
        inconsistent = true
      else
        zt[i] = zt[i] / R[pos]          # ζᵢ ← ζᵢ / rᵢ.ᵢ
      end
    end

    # Compute xₖ and yₖ
    for i = 1 : iter
      kaxpy!(m, zt[2i-1], V[i], x)  # xₖ = ζ₁v₁ + ζ₃v₂ + ••• + ζ₂ₖ₋₁vₖ
      kaxpy!(n, zt[2i]  , U[i], y)  # xₖ = ζ₂u₁ + ζ₄u₂ + ••• + ζ₂ₖuₖ
    end
    if !EisI
      kcopy!(m, wB, x)  # wB ← x
      mulorldiv!(x, E, wB, ldiv)
    end
    if !FisI
      kcopy!(n, wA, y)  # wA ← y
      mulorldiv!(y, F, wA, ldiv)
    end
    warm_start && kaxpy!(m, one(FC), Δx, x)
    warm_start && kaxpy!(n, one(FC), Δy, y)
    workspace.warm_start = false

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    solved              && (status = "solution good enough given atol and rtol")
    inconsistent        && (status = "found approximate least-squares solution")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = inconsistent
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

import Base.show, Base.sizeof, Base.format_bytes

function ksizeof(attribute)
  if isa(attribute, Vector{<:AbstractArray}) && !isempty(attribute)
    # A vector of arrays is a vector of pointers in Julia.
    # All arrays inside a vector have the same size in Krylov.jl
    size_attribute = sizeof(attribute) + length(attribute) * ksizeof(attribute[1])
  else
    size_attribute = sizeof(attribute)
  end
  return size_attribute
end

function sizeof(stats_workspace :: Union{KrylovStats, KrylovWorkspace, BlockKrylovWorkspace})
  type = typeof(stats_workspace)
  nfields = fieldcount(type)
  storage = 0
  for i = 1:nfields
    field_i = getfield(stats_workspace, i)
    size_i = ksizeof(field_i)
    storage += size_i
  end
  return storage
end

special_fields = Dict(
  :residualscg => "residuals (cg)",
  :errorscg => "errors (cg)",
  :Anorm => "‖A‖F",
  :Acond => "κ₂(A)",
  :err_ubnds_lq => "error bound LQ",
  :err_ubnds_cg => "error bound CG",
)

function show(io :: IO, stats :: KrylovStats)
  kst = typeof(stats)
  s = string(kst.name.name) * "\n"
  nfield = fieldcount(kst)
  for i = 1 : nfield
    field = fieldname(kst, i)
    field_name = if field ∈ keys(special_fields)
      special_fields[field]
    else
      replace(string(field), "_" => " ")
    end
    s *=  " " * field_name * ":"
    statfield = getfield(stats, field)
    if isa(statfield, AbstractVector) && eltype(statfield) <: Union{Missing, AbstractFloat}
      s *= @sprintf " %s\n" vec2str(statfield)
    elseif field_name == "allocation timer" || field_name == "timer"
      (statfield < 1e-3) && (s *= @sprintf " %.2fμs\n" 1e6*statfield)
      (1e-3 ≤ statfield < 1.00) && (s *= @sprintf " %.2fms\n" 1e3*statfield)
      (statfield ≥ 1.00) && (s *= @sprintf " %.2fs\n" statfield)
    else
      s *= @sprintf " %s\n" statfield
    end
  end
  print(io, s)
end

"""
    show(io, workspace; show_stats=true)

Statistics of `workspace` are displayed if `show_stats` is set to true.
"""
function show(io :: IO, workspace :: _KrylovWorkspace{T,FC,Sm,Sn}; show_stats :: Bool=true) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}
  type_workspace = typeof(workspace)
  name_workspace = string(type_workspace.name.name)
  name_stats = string(typeof(workspace.stats).name.name)
  nbytes = sizeof(workspace)
  storage = format_bytes(nbytes)
  lS = max(string(Sm) |> length, string(Sn) |> length)
  lT = string(T) |> length
  lFC = string(FC) |> length
  if Sm <: Vector && Sn <: Vector
    architecture = "CPU"
  elseif Sm.name.name in (:CuArray, :ROCArray, :oneArray, :MtlArray) && Sn.name.name in (:CuArray, :ROCArray, :oneArray, :MtlArray)
    architecture = "GPU"
  else
    architecture = "CPU / GPU"
  end
  l1 = max(length(name_workspace), lFC + 11)  # length("Precision: ") = 11
  nchar = type_workspace <: Union{CgLanczosShiftWorkspace, CglsLanczosShiftWorkspace, FomWorkspace, DiomWorkspace, DqgmresWorkspace, GmresWorkspace, FgmresWorkspace, GpmrWorkspace, BlockGmresWorkspace} ? 8 : 0  # length("Vector{}") = 8
  l2 = max(ndigits(workspace.m) + 7, length(architecture) + 14, lS + nchar)  # length("nrows: ") = 7 and length("Architecture: ") = 14
  l2 = max(l2, length(name_stats) + 2 + lT)  # length("{}") = 2
  l3 = max(ndigits(workspace.n) + 7, length(storage) + 9)  # length("Storage: ") = 9 and length("cols: ") = 7
  format = Printf.Format("│%$(l1)s│%$(l2)s│%$(l3)s│\n")
  format2 = Printf.Format("│%$(l1+1)s│%$(l2)s│%$(l3)s│\n")
  @printf(io, "┌%s┬%s┬%s┐\n", "─"^l1, "─"^l2, "─"^l3)
  Printf.format(io, format, "$(name_workspace)", "nrows: $(workspace.m)", "ncols: $(workspace.n)")
  @printf(io, "├%s┼%s┼%s┤\n", "─"^l1, "─"^l2, "─"^l3)
  Printf.format(io, format, "Precision: $FC", "Architecture: $architecture","Storage: $storage")
  @printf(io, "├%s┼%s┼%s┤\n", "─"^l1, "─"^l2, "─"^l3)
  Printf.format(io, format, "Attribute", "Type", "Size")
  @printf(io, "├%s┼%s┼%s┤\n", "─"^l1, "─"^l2, "─"^l3)
  for i=1:fieldcount(type_workspace)
    name_i = fieldname(type_workspace, i)
    type_i = fieldtype(type_workspace, i)
    field_i = getfield(workspace, name_i)
    size_i = ksizeof(field_i)
    (size_i ≠ 0) && Printf.format(io, format, string(name_i), type_i, format_bytes(size_i))
  end
  @printf(io, "└%s┴%s┴%s┘\n","─"^l1,"─"^l2,"─"^l3)
  if show_stats
    @printf(io, "\n")
    show(io, workspace.stats)
  end
  return nothing
end

function show(io :: IO, workspace :: BlockKrylovWorkspace{T,FC,SV,SM}; show_stats :: Bool=true) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, SV <: AbstractVector{FC}, SM <: AbstractMatrix{FC}}
  type_workspace = typeof(workspace)
  name_workspace = string(type_workspace.name.name)
  name_stats = string(typeof(workspace.stats).name.name)
  nbytes = sizeof(workspace)
  storage = format_bytes(nbytes)
  lS = max(string(SV) |> length, string(SM) |> length)
  lT = string(T) |> length
  lFC = string(FC) |> length
  if SV <: Vector && SM <: Matrix
    architecture = "CPU"
  elseif SV.name.name in (:CuArray, :ROCArray, :oneArray, :MtlArray) && SM.name.name in (:CuArray, :ROCArray, :oneArray, :MtlArray)
    architecture = "GPU"
  else
    architecture = "CPU / GPU"
  end
  l1 = max(length(name_workspace), length(string(FC)) + 11)  # length("Precision: ") = 11
  nchar = type_workspace <: BlockGmresWorkspace ? 8 : 0  # length("Vector{}") = 8
  l2 = max(ndigits(workspace.m) + 7, length(architecture) + 14, lS + nchar)  # length("nrows: ") = 7 and length("Architecture: ") = 14
  l2 = max(l2, length(name_stats) + 2 + lT)  # length("{}") = 2
  l3 = max(ndigits(workspace.n) + 7, length(storage) + 9)  # length("Storage: ") = 9 and length("cols: ") = 7
  format = Printf.Format("│%$(l1)s│%$(l2)s│%$(l3)s│\n")
  format2 = Printf.Format("│%$(l1+1)s│%$(l2)s│%$(l3)s│\n")
  @printf(io, "┌%s┬%s┬%s┐\n", "─"^l1, "─"^l2, "─"^l3)
  Printf.format(io, format, "$(name_workspace)", "nrows: $(workspace.m)", "ncols: $(workspace.n)")
  @printf(io, "├%s┼%s┼%s┤\n", "─"^l1, "─"^l2, "─"^l3)
  Printf.format(io, format, "Precision: $FC", "Architecture: $architecture","Storage: $storage")
  @printf(io, "├%s┼%s┼%s┤\n", "─"^l1, "─"^l2, "─"^l3)
  Printf.format(io, format, "Attribute", "Type", "Size")
  @printf(io, "├%s┼%s┼%s┤\n", "─"^l1, "─"^l2, "─"^l3)
  for i=1:fieldcount(type_workspace)
    name_i = fieldname(type_workspace, i)
    type_i = fieldtype(type_workspace, i)
    field_i = getfield(workspace, name_i)
    size_i = ksizeof(field_i)
    (size_i ≠ 0) && Printf.format(io, format, string(name_i), type_i, format_bytes(size_i))
  end
  @printf(io, "└%s┴%s┴%s┘\n","─"^l1,"─"^l2,"─"^l3)
  if show_stats
    @printf(io, "\n")
    show(io, workspace.stats)
  end
  return nothing
end

# A test problem coming from LSQR.
function lstp(nrow :: Int, ncol :: Int, ndupl :: Int, npower :: Int, λ :: Real, x :: Array)

  # LSTP  generates a sparse least-squares test problem of the form
  #
  #   minimize ‖ [A ] x - [b] ‖
  #            ‖ [λI]     [0] ‖
  #
  # having a specified solution x.  The matrix A is constructed
  # in the form A = HY*D*HZ, where D is an nrow by ncol diagonal matrix,
  # and HY and HZ are Householder transformations.

  @assert(nrow ≥ ncol)

  # Construct two unit vectors for the Householder transformations.
  # fourpi = 4π
  fourpi = 4 * 3.141592  # This is the approximation used in Mike's original subroutine.
  α = fourpi / nrow  # 4π / nrow
  β = fourpi / ncol  # 4π / ncol
  hy = map(sin, [1:nrow;] * α)
  hz = map(cos, [1:ncol;] * β)

  α = norm(hy)
  hy /= α
  HY = I - 2 * hy' * hy  # HY is nrow x nrow.
  β = norm(hz)
  hz /= β
  HZ = I - 2 * hz' * hz  # HZ is ncol x ncol.

  # Set the diagonal matrix D containing the singular values of A.
  d = (div.(([0:ncol-1;] .+ ndupl), ndupl) * ndupl / ncol).^npower  # Integer div!
  D = diagm(nrow, ncol, d)
  A = HY * D * HZ

  Acond = abs(d[ncol] / d[1])

  # Compute residual vector.
  r = zeros(nrow)
  x = Float64.(x)
  r[1:ncol]  = HZ * x ./ d
  t = 1.0
  for i = ncol + 1 : nrow
    j = i - ncol
    r[i] = t * j / nrow
    t = -t
  end
  r = HY * r

  # Compute right-hand side b = r + Ax.
  rnorm = norm(r)
  b = r + A * x

  return (b, A, D, HY, HZ, Acond, rnorm)
end


function test(nrow, ncol, ndupl, npower, damp)

  x = ncol .- [1:ncol;]  # Desired solution.
  return lstp(nrow, ncol, ndupl, npower, damp, x)
end


function testall()
  damp = 0  # Must be zero for this problem to be consistent.
  test(40, 40, 4, 1, damp)
  test(40, 40, 4, 2, damp)
  test(40, 40, 4, 3, damp)
  test(40, 40, 4, 4, damp)
end

using LinearAlgebra, SparseArrays, Test
using Krylov, StaticArrays

@testset "StaticArrays" begin
  n = 5

  for T in (Float32, Float64)
    A = rand(T, n, n)

    b = SVector{n}(rand(T, n))
    @test Krylov.ktypeof(b) == Vector{T}
    x, stats = gmres(A, b)
    @test stats.solved

    b = MVector{n}(rand(T, n))
    @test Krylov.ktypeof(b) == Vector{T}
    x, stats = gmres(A, b)
    @test stats.solved

    b = SizedVector{n}(rand(T, n))
    @test Krylov.ktypeof(b) == Vector{T}
    x, stats = gmres(A, b)
    @test stats.solved
  end
end

using LinearOperators, CUDA, CUDA.CUSPARSE, CUDA.CUSOLVER

include("gpu.jl")

@testset "Nvidia -- CUDA.jl" begin

  @test CUDA.functional()
  CUDA.allowscalar(false)

  @testset "documentation" begin
    A_cpu = rand(20, 20)
    b_cpu = rand(20)
    A_gpu = CuMatrix(A_cpu)
    b_gpu = CuVector(b_cpu)
    x, stats = bilq(A_gpu, b_gpu)
    r_gpu = b_gpu - A_gpu * x
    @test norm(r_gpu) ≤ 1e-4

    A_cpu = sprand(200, 100, 0.3)
    b_cpu = rand(200)
    A_csc_gpu = CuSparseMatrixCSC(A_cpu)
    A_csr_gpu = CuSparseMatrixCSR(A_cpu)
    A_coo_gpu = CuSparseMatrixCOO(A_cpu)
    b_gpu = CuVector(b_cpu)
    b_gpu = CuVector(b_cpu)
    x_csc, stats_csc = lslq(A_csc_gpu, b_gpu)
    x_csr, stats_csr = lsqr(A_csr_gpu, b_gpu)
    x_coo, stats_coo = lsmr(A_coo_gpu, b_gpu)
    Aᴴr_csc = A_csc_gpu' * (b_gpu - A_csc_gpu * x_csc)
    Aᴴr_csr = A_csr_gpu' * (b_gpu - A_csr_gpu * x_csr)
    Aᴴr_coo = A_coo_gpu' * (b_gpu - A_coo_gpu * x_coo)
    @test norm(Aᴴr_csc) ≤ 1e-4
    @test norm(Aᴴr_csr) ≤ 1e-4
    @test norm(Aᴴr_coo) ≤ 1e-4


    @testset "ic0" begin
      A_cpu, b_cpu = sparse_laplacian()
      @test mapreduce(Aᵢᵢ -> Aᵢᵢ != 0, &, diag(A_cpu)) == true

      b_gpu = CuVector(b_cpu)
      n = length(b_gpu)
      T = eltype(b_gpu)
      z = CUDA.zeros(T, n)
      symmetric = hermitian = true

      A_gpu = CuSparseMatrixCSC(A_cpu)
      P = ic02(A_gpu)
      function ldiv_ic0!(P::CuSparseMatrixCSC, x, y, z)
        ldiv!(z, UpperTriangular(P)', x)
        ldiv!(y, UpperTriangular(P), z)
        return y
      end
      opM = LinearOperator(T, n, n, symmetric, hermitian, (y, x) -> ldiv_ic0!(P, x, y, z))
      x, stats = cg(A_gpu, b_gpu, M=opM)
      @test norm(b_gpu - A_gpu * x) ≤ 1e-6
      @test stats.niter ≤ 19

      A_gpu = CuSparseMatrixCSR(A_gpu)
      P = ic02(A_gpu)
      function ldiv_ic0!(P::CuSparseMatrixCSR, x, y, z)
        ldiv!(z, LowerTriangular(P), x)
        ldiv!(y, LowerTriangular(P)', z)
        return y
      end
      opM = LinearOperator(T, n, n, symmetric, hermitian, (y, x) -> ldiv_ic0!(P, x, y, z))
      x, stats = cg(A_gpu, b_gpu, M=opM)
      @test norm(b_gpu - A_gpu * x) ≤ 1e-6
      @test stats.niter ≤ 19
    end

    @testset "ilu0" begin
      A_cpu = Float64[1  0 0  4;
                      0  0 7  8;
                      9  0 0 12;
                      0 14 0 16]
      A_cpu = sparse(A_cpu)
      b_cpu = ones(4)
      @test mapreduce(Aᵢᵢ -> Aᵢᵢ != 0, &, diag(A_cpu)) == false

      p = zfd(A_cpu)
      p .+= 1
      invp = invperm(p)
      @test reduce(&, invp .== p) == false

      b_gpu = CuVector(b_cpu)
      n = length(b_gpu)
      T = eltype(b_gpu)
      z = CUDA.zeros(T, n)
      symmetric = hermitian = false

      A_gpu = CuSparseMatrixCSC(A_cpu[:,p])
      P = ilu02(A_gpu)
      function ldiv_ilu0!(P::CuSparseMatrixCSC, x, y, z)
        ldiv!(z, LowerTriangular(P), x)
        ldiv!(y, UnitUpperTriangular(P), z)
        return y
      end
      opM = LinearOperator(T, n, n, symmetric, hermitian, (y, x) -> ldiv_ilu0!(P, x, y, z))
      x̄, stats = gmres(A_gpu, b_gpu, M=opM)
      x = Vector(x̄)[invp]
      @test norm(b_gpu - A_gpu * x̄) ≤ 1e-6
      @test norm(b_cpu - A_cpu * x) ≤ 1e-6

      A_gpu = CuSparseMatrixCSR(A_cpu[:,p])
      P = ilu02(A_gpu)
      function ldiv_ilu0!(P::CuSparseMatrixCSR, x, y, z)
        ldiv!(z, UnitLowerTriangular(P), x)
        ldiv!(y, UpperTriangular(P), z)
        return y
      end
      opM = LinearOperator(T, n, n, symmetric, hermitian, (y, x) -> ldiv_ilu0!(P, x, y, z))
      x̄, stats = gmres(A_gpu, b_gpu, M=opM)
      x = Vector(x̄)[invp]
      @test norm(b_gpu - A_gpu * x̄) ≤ 1e-6
      @test norm(b_cpu - A_cpu * x) ≤ 1e-6
    end
  end

  for FC in (Float32, Float64, ComplexF32, ComplexF64)
    S = CuVector{FC}
    V = CuSparseVector{FC}
    M = CuMatrix{FC}
    T = real(FC)
    n = 10
    x = rand(FC, n)
    x = S(x)
    y = rand(FC, n)
    y = S(y)
    a = rand(FC)
    b = rand(FC)
    s = rand(FC)
    a2 = rand(T)
    b2 = rand(T)
    c = rand(T)

    @testset "kdot -- $FC" begin
      Krylov.kdot(n, x, y)
    end

    @testset "kdotr -- $FC" begin
      Krylov.kdotr(n, x, y)
    end

    @testset "knorm -- $FC" begin
      Krylov.knorm(n, x)
    end

    @testset "kaxpy! -- $FC" begin
      Krylov.kaxpy!(n, a, x, y)
      Krylov.kaxpy!(n, a2, x, y)
    end

    @testset "kaxpby! -- $FC" begin
      Krylov.kaxpby!(n, a, x, b, y)
      Krylov.kaxpby!(n, a2, x, b, y)
      Krylov.kaxpby!(n, a, x, b2, y)
      Krylov.kaxpby!(n, a2, x, b2, y)
    end

    @testset "kcopy! -- $FC" begin
      Krylov.kcopy!(n, y, x)
    end

    @testset "kswap! -- $FC" begin
      Krylov.@kswap!(x, y)
    end

    @testset "kref! -- $FC" begin
      Krylov.kref!(n, x, y, c, s)
    end

    @testset "conversion -- $FC" begin
      test_conversion(S, M)
    end

    ε = eps(T)
    atol = √ε
    rtol = √ε

    @testset "GMRES -- $FC" begin
      A, b = nonsymmetric_indefinite(FC=FC)
      A = M(A)
      b = S(b)
      x, stats = gmres(A, b)
      @test norm(b - A * x) ≤ atol + rtol * norm(b)
    end

    @testset "block-MINRES -- $FC" begin
      A, b = symmetric_indefinite(FC=FC)
      B = hcat(b, -b)
      A = M(A)
      B = M(B)
      X, stats = block_minres(A, B)
      @test norm(B - A * X) ≤ atol + rtol * norm(B)
    end

    @testset "block-GMRES -- $FC" begin
      A, b = nonsymmetric_indefinite(FC=FC)
      B = hcat(b, -b)
      A = M(A)
      B = M(B)
      X, stats = block_gmres(A, B, reorthogonalization=true)
      @test norm(B - A * X) ≤ atol + rtol * norm(B)
    end

    @testset "CG -- $FC" begin
      A, b = symmetric_definite(FC=FC)
      A = M(A)
      b = S(b)
      x, stats = cg(A, b)
      @test norm(b - A * x) ≤ atol + rtol * norm(b)
    end

    @testset "MINRES-QLP -- $FC" begin
      A, b = symmetric_indefinite(FC=FC)
      A = M(A)
      b = S(b)
      x, stats = minres_qlp(A, b)
      @test norm(b - A * x) ≤ atol + rtol * norm(b)
    end

    @testset "processes -- $FC" begin
      test_processes(S, M)
    end

    @testset "solver -- $FC" begin
      test_solver(S, M)
    end

    @testset "ktypeof -- $FC" begin
      dv = S(rand(FC, 10))
      b = view(dv, 4:8)
      @test Krylov.ktypeof(dv) <: S
      @test Krylov.ktypeof(b) <: S

      dm = M(rand(FC, 10, 10))
      b = view(dm, :, 3)
      @test Krylov.ktypeof(b) <: S

      sv = V(sprand(FC, 10, 0.5))
      b = view(sv, 4:8)
      @test Krylov.ktypeof(sv) <: S
      @test Krylov.ktypeof(b) <: S
    end
  end
end

export SimpleStats, LsmrStats, LanczosStats, LanczosShiftStats, SymmlqStats, AdjointStats, LNLQStats, LSLQStats

import Base.copyto!

"Abstract type for statistics returned by (block) Krylov solvers."
abstract type KrylovStats{T} end

"""
Type for storing statistics returned by the majority of (block) Krylov solvers.

The fields are as follows:
- `niter`: The total number of iterations completed by the solver;
- `solved`: Indicates whether the solver successfully reached convergence (`true` if solved, `false` otherwise);
- `inconsistent`: Flags whether the system was detected as inconsistent (i.e., when `b` is not in the range of `A`);
- `indefinite`: Flags whether the system was detected as indefinite (i.e., when `A` is not positive definite);
- `npcCount`: The number of nonpositive curvature directions encountered during the solve;
- `residuals`: A vector containing the residual norms at each iteration;
- `Aresiduals`: A vector of `A'`-residual norms at each iteration;
- `Acond`: An estimate of the condition number of matrix `A`.
- `allocation_timer`: The elapsed time (in seconds) spent on allocations;
- `timer`: The elapsed time (in seconds) taken by the solver to complete all iterations;
- `status`: A string indicating the outcome of the solve, providing additional details beyond `solved`.
"""
mutable struct SimpleStats{T} <: KrylovStats{T}
  niter            :: Int
  solved           :: Bool
  inconsistent     :: Bool
  indefinite       :: Bool
  npcCount         :: Int
  residuals        :: Vector{T}
  Aresiduals       :: Vector{T}
  Acond            :: Vector{T}
  allocation_timer :: Float64
  timer            :: Float64
  status           :: String
end

function reset!(stats :: SimpleStats)
  empty!(stats.residuals)
  empty!(stats.Aresiduals)
  empty!(stats.Acond)
  stats.indefinite = false
  stats.npcCount = 0
end

function copyto!(dest :: SimpleStats, src :: SimpleStats)
  dest.niter            = src.niter
  dest.solved           = src.solved
  dest.inconsistent     = src.inconsistent
  dest.indefinite       = src.indefinite
  dest.npcCount         = src.npcCount
  dest.residuals        = copy(src.residuals)
  dest.Aresiduals       = copy(src.Aresiduals)
  dest.Acond            = copy(src.Acond)
  dest.allocation_timer = src.allocation_timer
  dest.timer            = src.timer
  dest.status           = src.status
  return dest
end

"""
Type for storing statistics returned by LSMR.
The fields are as follows:
- niter
- solved
- inconsistent
- residuals
- Aresiduals
- Acond
- Anorm
- xNorm
- allocation_timer
- timer
- status
"""
mutable struct LsmrStats{T} <: KrylovStats{T}
  niter            :: Int
  solved           :: Bool
  inconsistent     :: Bool
  residuals        :: Vector{T}
  Aresiduals       :: Vector{T}
  residual         :: T
  Aresidual        :: T
  Acond            :: T
  Anorm            :: T
  xNorm            :: T
  allocation_timer :: Float64
  timer            :: Float64
  status           :: String
end

function reset!(stats :: LsmrStats)
  empty!(stats.residuals)
  empty!(stats.Aresiduals)
end

function copyto!(dest :: LsmrStats, src :: LsmrStats)
  dest.niter            = src.niter
  dest.solved           = src.solved
  dest.inconsistent     = src.inconsistent
  dest.residuals        = copy(src.residuals)
  dest.Aresiduals       = copy(src.Aresiduals)
  dest.residual         = src.residual
  dest.Aresidual        = src.Aresidual
  dest.Acond            = src.Acond
  dest.Anorm            = src.Anorm
  dest.xNorm            = src.xNorm
  dest.allocation_timer = src.allocation_timer
  dest.timer            = src.timer
  dest.status           = src.status
  return dest
end

"""
Type for storing statistics returned by CG-LANCZOS.
The fields are as follows:
- niter
- solved
- residuals
- indefinite
- Anorm
- Acond
- allocation_timer
- timer
- status
"""
mutable struct LanczosStats{T} <: KrylovStats{T}
  niter            :: Int
  solved           :: Bool
  residuals        :: Vector{T}
  indefinite       :: Bool
  Anorm            :: T
  Acond            :: T
  allocation_timer :: Float64
  timer            :: Float64
  status           :: String
end

function reset!(stats :: LanczosStats)
  empty!(stats.residuals)
end

function copyto!(dest :: LanczosStats, src :: LanczosStats)
  dest.niter            = src.niter
  dest.solved           = src.solved
  dest.residuals        = copy(src.residuals)
  dest.indefinite       = src.indefinite
  dest.Anorm            = src.Anorm
  dest.Acond            = src.Acond
  dest.allocation_timer = src.allocation_timer
  dest.timer            = src.timer
  dest.status           = src.status
  return dest
end

"""
Type for storing statistics returned by CG-LANCZOS-SHIFT and CGLS-LANCZOS-SHIFT.
The fields are as follows:
- niter
- solved
- residuals
- indefinite
- Anorm
- Acond
- allocation_timer
- timer
- status
"""
mutable struct LanczosShiftStats{T} <: KrylovStats{T}
  niter            :: Int
  solved           :: Bool
  residuals        :: Vector{Vector{T}}
  indefinite       :: BitVector
  Anorm            :: T
  Acond            :: T
  allocation_timer :: Float64
  timer            :: Float64
  status           :: String
end

function reset!(stats :: LanczosShiftStats)
  for vec in stats.residuals
    empty!(vec)
  end
end

function copyto!(dest :: LanczosShiftStats, src :: LanczosShiftStats)
  dest.niter            = src.niter
  dest.solved           = src.solved
  dest.residuals        = deepcopy(src.residuals)
  dest.indefinite       = src.indefinite
  dest.Anorm            = src.Anorm
  dest.Acond            = src.Acond
  dest.allocation_timer = src.allocation_timer
  dest.timer            = src.timer
  dest.status           = src.status
  return dest
end

"""
Type for storing statistics returned by SYMMLQ.
The fields are as follows:
- niter
- solved
- residuals
- residualscg
- errors
- errorscg
- Anorm
- Acond
- allocation_timer
- timer
- status
"""
mutable struct SymmlqStats{T} <: KrylovStats{T}
  niter            :: Int
  solved           :: Bool
  residuals        :: Vector{T}
  residualscg      :: Vector{Union{T, Missing}}
  errors           :: Vector{T}
  errorscg         :: Vector{Union{T, Missing}}
  Anorm            :: T
  Acond            :: T
  allocation_timer :: Float64
  timer            :: Float64
  status           :: String
end

function reset!(stats :: SymmlqStats)
  empty!(stats.residuals)
  empty!(stats.residualscg)
  empty!(stats.errors)
  empty!(stats.errorscg)
end

function copyto!(dest :: SymmlqStats, src :: SymmlqStats)
  dest.niter            = src.niter
  dest.solved           = src.solved
  dest.residuals        = copy(src.residuals)
  dest.residualscg      = copy(src.residualscg)
  dest.errors           = copy(src.errors)
  dest.errorscg         = copy(src.errorscg)
  dest.Anorm            = src.Anorm
  dest.Acond            = src.Acond
  dest.allocation_timer = src.allocation_timer
  dest.timer            = src.timer
  dest.status           = src.status
  return dest
end

"""
Type for storing statistics returned by adjoint systems solvers BiLQR and TriLQR.
The fields are as follows:
- niter
- solved_primal
- solved_dual
- residuals_primal
- residuals_dual
- allocation_timer
- timer
- status
"""
mutable struct AdjointStats{T} <: KrylovStats{T}
  niter            :: Int
  solved_primal    :: Bool
  solved_dual      :: Bool
  residuals_primal :: Vector{T}
  residuals_dual   :: Vector{T}
  allocation_timer :: Float64
  timer            :: Float64
  status           :: String
end

function reset!(stats :: AdjointStats)
  empty!(stats.residuals_primal)
  empty!(stats.residuals_dual)
end

function copyto!(dest :: AdjointStats, src :: AdjointStats)
  dest.niter            = src.niter
  dest.solved_primal    = src.solved_primal
  dest.solved_dual      = src.solved_dual
  dest.residuals_primal = copy(src.residuals_primal)
  dest.residuals_dual   = copy(src.residuals_dual)
  dest.allocation_timer = src.allocation_timer
  dest.timer            = src.timer
  dest.status           = src.status
  return dest
end


"""
Type for storing statistics returned by the LNLQ method.
The fields are as follows:
- niter
- solved
- residuals
- error_with_bnd
- error_bnd_x
- error_bnd_y
- allocation_timer
- timer
- status
"""
mutable struct LNLQStats{T} <: KrylovStats{T}
  niter            :: Int
  solved           :: Bool
  residuals        :: Vector{T}
  error_with_bnd   :: Bool
  error_bnd_x      :: Vector{T}
  error_bnd_y      :: Vector{T}
  allocation_timer :: Float64
  timer            :: Float64
  status           :: String
end

function reset!(stats :: LNLQStats)
  empty!(stats.residuals)
  empty!(stats.error_bnd_x)
  empty!(stats.error_bnd_y)
end

function copyto!(dest :: LNLQStats, src :: LNLQStats)
  dest.niter            = src.niter
  dest.solved           = src.solved
  dest.residuals        = copy(src.residuals)
  dest.error_with_bnd   = src.error_with_bnd
  dest.error_bnd_x      = copy(src.error_bnd_x)
  dest.error_bnd_y      = copy(src.error_bnd_y)
  dest.allocation_timer = src.allocation_timer
  dest.timer            = src.timer
  dest.status           = src.status
  return dest
end

"""
Type for storing statistics returned by the LSLQ method.
The fields are as follows:
- niter
- solved
- inconsistent
- residuals
- Aresiduals
- err_lbnds
- error_with_bnd
- err_ubnds_lq
- err_ubnds_cg
- allocation_timer
- timer
- status
"""
mutable struct LSLQStats{T} <: KrylovStats{T}
  niter            :: Int
  solved           :: Bool
  inconsistent     :: Bool
  residuals        :: Vector{T}
  Aresiduals       :: Vector{T}
  err_lbnds        :: Vector{T}
  error_with_bnd   :: Bool
  err_ubnds_lq     :: Vector{T}
  err_ubnds_cg     :: Vector{T}
  allocation_timer :: Float64
  timer            :: Float64
  status           :: String
end

function reset!(stats :: LSLQStats)
  empty!(stats.residuals)
  empty!(stats.Aresiduals)
  empty!(stats.err_lbnds)
  empty!(stats.err_ubnds_lq)
  empty!(stats.err_ubnds_cg)
end

function copyto!(dest :: LSLQStats, src :: LSLQStats)
  dest.niter            = src.niter
  dest.solved           = src.solved
  dest.inconsistent     = src.inconsistent
  dest.residuals        = copy(src.residuals)
  dest.Aresiduals       = copy(src.Aresiduals)
  dest.err_lbnds        = copy(src.err_lbnds)
  dest.error_with_bnd   = src.error_with_bnd
  dest.err_ubnds_lq     = copy(src.err_ubnds_lq)
  dest.err_ubnds_cg     = copy(src.err_ubnds_cg)
  dest.allocation_timer = src.allocation_timer
  dest.timer            = src.timer
  dest.status           = src.status
  return dest
end

using AMDGPU, AMDGPU.rocSPARSE

include("gpu.jl")

@testset "AMD -- AMDGPU.jl" begin

  @test AMDGPU.functional()
  AMDGPU.allowscalar(false)

  @testset "documentation" begin
    A_cpu = rand(ComplexF64, 20, 20)
    A_cpu = A_cpu + A_cpu'
    b_cpu = rand(ComplexF64, 20)
    A_gpu = ROCMatrix(A_cpu)
    b_gpu = ROCVector(b_cpu)
    x, stats = minres(A_gpu, b_gpu)
    r_gpu = b_gpu - A_gpu * x
    @test norm(r_gpu) ≤ 1e-4

    A_cpu = sprand(100, 200, 0.3)
    b_cpu = rand(100)
    A_csc_gpu = ROCSparseMatrixCSC(A_cpu)
    A_csr_gpu = ROCSparseMatrixCSR(A_cpu)
    A_coo_gpu = ROCSparseMatrixCOO(A_cpu)
    b_gpu = ROCVector(b_cpu)
    x_csc, y_csc, stats_csc = lnlq(A_csc_gpu, b_gpu)
    x_csr, y_csr, stats_csr = craig(A_csr_gpu, b_gpu)
    x_coo, y_coo, stats_coo = craigmr(A_coo_gpu, b_gpu)
    r_csc = b_gpu - A_csc_gpu * x_csc
    r_csr = b_gpu - A_csr_gpu * x_csr
    r_coo = b_gpu - A_coo_gpu * x_coo
    @test norm(r_csc) ≤ 1e-4
    @test norm(r_csr) ≤ 1e-4
    @test norm(r_coo) ≤ 1e-4
  end

  for FC in (Float32, Float64, ComplexF32, ComplexF64)
    S = ROCVector{FC}
    V = ROCSparseVector{FC}
    M = ROCMatrix{FC}
    T = real(FC)
    n = 10
    x = rand(FC, n)
    x = S(x)
    y = rand(FC, n)
    y = S(y)
    a = rand(FC)
    b = rand(FC)
    s = rand(FC)
    a2 = rand(T)
    b2 = rand(T)
    c = rand(T)

    @testset "kdot -- $FC" begin
      Krylov.kdot(n, x, y)
    end

    @testset "kdotr -- $FC" begin
      Krylov.kdotr(n, x, y)
    end

    @testset "knorm -- $FC" begin
      Krylov.knorm(n, x)
    end

    @testset "kaxpy! -- $FC" begin
      Krylov.kaxpy!(n, a, x, y)
      Krylov.kaxpy!(n, a2, x, y)
    end

    @testset "kaxpby! -- $FC" begin
      Krylov.kaxpby!(n, a, x, b, y)
      Krylov.kaxpby!(n, a2, x, b, y)
      Krylov.kaxpby!(n, a, x, b2, y)
      Krylov.kaxpby!(n, a2, x, b2, y)
    end

    @testset "kcopy! -- $FC" begin
      Krylov.kcopy!(n, y, x)
    end

    @testset "kswap! -- $FC" begin
      Krylov.@kswap!(x, y)
    end

    @testset "kref! -- $FC" begin
      Krylov.kref!(n, x, y, c, s)
    end

    @testset "conversion -- $FC" begin
      test_conversion(S, M)
    end

    ε = eps(T)
    atol = √ε
    rtol = √ε

    @testset "GMRES -- $FC" begin
      A, b = nonsymmetric_indefinite(FC=FC)
      A = M(A)
      b = S(b)
      x, stats = gmres(A, b)
      @test norm(b - A * x) ≤ atol + rtol * norm(b)
    end

    @testset "block-MINRES -- $FC" begin
      A, b = symmetric_indefinite(FC=FC)
      B = hcat(b, -b)
      A = M(A)
      B = M(B)
      X, stats = block_minres(A, B)
      @test norm(B - A * X) ≤ atol + rtol * norm(B)
    end

    @testset "block-GMRES -- $FC" begin
      A, b = nonsymmetric_indefinite(FC=FC)
      B = hcat(b, -b)
      A = M(A)
      B = M(B)
      X, stats = block_gmres(A, B)
      @test norm(B - A * X) ≤ atol + rtol * norm(B)
    end

    @testset "CG -- $FC" begin
      A, b = symmetric_definite(FC=FC)
      A = M(A)
      b = S(b)
      x, stats = cg(A, b)
      @test norm(b - A * x) ≤ atol + rtol * norm(b)
    end

    @testset "MINRES-QLP -- $FC" begin
      A, b = symmetric_indefinite(FC=FC)
      A = M(A)
      b = S(b)
      x, stats = minres_qlp(A, b)
      @test norm(b - A * x) ≤ atol + rtol * norm(b)
    end

    @testset "processes -- $FC" begin
      test_processes(S, M)
    end

    @testset "solver -- $FC" begin
      test_solver(S, M)
    end

    @testset "ktypeof -- $FC" begin
      dv = S(rand(FC, 10))
      b = view(dv, 4:8)
      @test Krylov.ktypeof(dv) <: S
      @test Krylov.ktypeof(b) <: S

      dm = M(rand(FC, 10, 10))
      b = view(dm, :, 3)
      @test Krylov.ktypeof(b) <: S

      sv = V(sprand(FC, 10, 0.5))
      b = view(sv, 4:8)
      @test Krylov.ktypeof(sv) <: S
      @test Krylov.ktypeof(b) <: S
    end
  end
end

function residuals(A, b, shifts, x)
  nshifts = length(shifts)
  r = [ (b - A * x[i] - shifts[i] * x[i]) for i = 1 : nshifts ]
  return r
end

@testset "cg_lanczos_shift" begin
  cg_lanczos_shift_tol = 1.0e-6
  n = 10

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      # Cubic splines matrix.
      A, b = symmetric_definite(FC=FC)
      shifts = [1.0; 2.0; 3.0; 4.0; 5.0; 6.0]
      (x, stats) = cg_lanczos_shift(A, b, shifts, itmax=n)
      r = residuals(A, b, shifts, x)
      resids = map(norm, r) / norm(b)
      @test(all(resids .≤ cg_lanczos_shift_tol))
      @test(stats.solved)

      # Test negative curvature detection.
      shifts = [-4.0; -3.0; 2.0]
      (x, stats) = cg_lanczos_shift(A, b, shifts, check_curvature=true, itmax=n)
      @test(stats.indefinite == [true, true, false])

      # Test b == 0
      A, b = zero_rhs(FC=FC)
      (x, stats) = cg_lanczos_shift(A, b, shifts)
      for xi ∈ x
        @test norm(xi) == 0
      end
      @test stats.status == "x is a zero-residual solution"

      # Test with Jacobi (or diagonal) preconditioner
      A, b, M = square_preconditioned(FC=FC)
      shifts = [1.0; 2.0; 3.0; 4.0; 5.0; 6.0]
      (x, stats) = cg_lanczos_shift(A, b, shifts, M=M)
      r = residuals(A, b, shifts, x)
      resids = map(norm, r) / norm(b)
      @test(all(resids .≤ cg_lanczos_shift_tol))
      @test(stats.solved)

      # test callback function
      A, b = symmetric_definite(FC=FC)
      shifts = [1.0; 2.0; 3.0; 4.0; 5.0; 6.0]
      workspace = CgLanczosShiftWorkspace(A, b, length(shifts))
      tol = 1.0e-1
      cb_n2 = TestCallbackN2Shifts(A, b, shifts, tol = tol)
      cg_lanczos_shift!(workspace, A, b, shifts, atol = 0.0, rtol = 0.0, callback = cb_n2)
      @test workspace.stats.status == "user-requested exit"
      @test cb_n2(workspace)

      @test_throws TypeError cg_lanczos_shift(A, b, shifts, callback = workspace -> "string", history = true)
    end
  end
end

@testset "bilqr" begin
  bilqr_tol = 1.0e-6

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      # Test square adjoint systems.
      A, b, c = square_adjoint(FC=FC)
      (x, t, stats) = bilqr(A, b, c)

      r = b - A * x
      resid_primal = norm(r) / norm(b)
      @test(resid_primal ≤ bilqr_tol)
      @test(stats.solved_primal)

      s = c - A' * t
      resid_dual = norm(s) / norm(c)
      @test(resid_dual ≤ bilqr_tol)
      @test(stats.solved_dual)

      # Test adjoint ODEs.
      A, b, c = adjoint_ode(FC=FC)
      (x, t, stats) = bilqr(A, b, c)

      r = b - A * x
      resid_primal = norm(r) / norm(b)
      @test(resid_primal ≤ bilqr_tol)
      @test(stats.solved_primal)

      s = c - A' * t
      resid_dual = norm(s) / norm(c)
      @test(resid_dual ≤ bilqr_tol)
      @test(stats.solved_dual)

      # Test adjoint PDEs.
      A, b, c = adjoint_pde(FC=FC)
      (x, t, stats) = bilqr(A, b, c)

      r = b - A * x
      resid_primal = norm(r) / norm(b)
      @test(resid_primal ≤ bilqr_tol)
      @test(stats.solved_primal)

      s = c - A' * t
      resid_dual = norm(s) / norm(c)
      @test(resid_dual ≤ bilqr_tol)
      @test(stats.solved_dual)

      # Test bᴴc == 0
      A, b, c = bc_breakdown(FC=FC)
      (x, t, stats) = bilqr(A, b, c)
      @test stats.status == "Breakdown bᴴc = 0"

      # test callback function
      A, b, c = adjoint_pde(FC=FC)
      workspace = BilqrWorkspace(A, b)
      tol = 1.0e-1
      cb_n2 = TestCallbackN2Adjoint(A, b, c, tol = tol)
      bilqr!(workspace, A, b, c, atol = 0.0, rtol = 0.0, callback = cb_n2)
      @test workspace.stats.status == "user-requested exit"
      @test cb_n2(workspace)

      @test_throws TypeError bilqr(A, b, c, callback = workspace -> "string", history = true)
    end
  end
end

gist_json = JSON.parse("""
    {
        "description": "A benchmark for Krylov repository",
        "public": true,
        "files": {
            "judgement.md": {
                "content": "$(escape_string(sprint(export_markdown, judgement)))"
            },
            "main.md": {
                "content": "$(escape_string(sprint(export_markdown, main)))"
            },
            "commit.md": {
                "content": "$(escape_string(sprint(export_markdown, commit)))"
            }
        }
    }""")

# Need to add GITHUB_AUTH to your .bashrc
myauth = GitHub.authenticate(ENV["GITHUB_AUTH"])
posted_gist = create_gist(params = gist_json, auth = myauth)
println(posted_gist.html_url)

@testset "lsmr" begin
  lsmr_tol = 1.0e-5

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      for npower = 1 : 4
        (b, A, D, HY, HZ, Acond, rnorm) = test(40, 40, 4, npower, 0)  # No regularization.

        (x, stats) = lsmr(A, b)
        r = b - A * x
        resid = norm(A' * r) / norm(b)
        @test(resid ≤ lsmr_tol)
        @test(stats.solved)

        λ = 1.0e-3
        (x, stats) = lsmr(A, b, λ=λ)
        r = b - A * x
        resid = norm(A' * r - λ * λ * x) / norm(b)
        @test(resid ≤ lsmr_tol)
        @test(stats.solved)
      end

      A = [i/j - j/i for i=1:10, j=1:6]
      b = A * ones(6)

      # test trust-region constraint
      (x, stats) = lsmr(A, b)

      radius = 0.75 * norm(x)
      (x, stats) = lsmr(A, b, radius=radius)
      @test(stats.solved)
      @test(abs(radius - norm(x)) ≤ lsmr_tol * radius)

      # Test b == 0
      A, b = zero_rhs(FC=FC)
      (x, stats) = lsmr(A, b)
      @test norm(x) == 0
      @test stats.status == "x is a zero-residual solution"

      # Test with preconditioners
      A, b, M, N = two_preconditioners(FC=FC)
      (x, stats) = lsmr(A, b, M=M, N=N)
      r = b - A * x
      resid = sqrt(real(dot(r, M * r))) / norm(b)
      @test(resid ≤ lsmr_tol)
      @test(stats.solved)

      # Test regularization
      A, b, λ = regularization(FC=FC)
      (x, stats) = lsmr(A, b, λ=λ)
      r = b - A * x
      resid = norm(A' * r - λ^2 * x) / norm(b)
      @test(resid ≤ lsmr_tol)

      # Test saddle-point systems
      A, b, D = saddle_point(FC=FC)
      D⁻¹ = inv(D)
      (x, stats) = lsmr(A, b, M=D⁻¹)
      r = D⁻¹ * (b - A * x)
      resid = norm(A' * r) / norm(b)
      @test(resid ≤ lsmr_tol)

      # Test symmetric and quasi-definite systems
      A, b, M, N = sqd(FC=FC)
      M⁻¹ = inv(M)
      N⁻¹ = inv(N)
      (x, stats) = lsmr(A, b, M=M⁻¹, N=N⁻¹, sqd=true)
      r = M⁻¹ * (b - A * x)
      resid = norm(A' * r - N * x) / norm(b)
      @test(resid ≤ lsmr_tol)

      λ = 4.0
      (x, stats) = lsmr(A, b, M=M⁻¹, N=N⁻¹, λ=λ)
      r = M⁻¹ * (b - A * x)
      resid = norm(A' * r - λ^2 * N * x) / norm(b)
      @test(resid ≤ lsmr_tol)

      # Test dimension of additional vectors
      for transpose ∈ (false, true)
        A, b, c, D = small_sp(transpose, FC=FC)
        D⁻¹ = inv(D)
        (x, stats) = lsmr(A, b, M=D⁻¹)

        A, b, c, M, N = small_sqd(transpose, FC=FC)
        M⁻¹ = inv(M)
        N⁻¹ = inv(N)
        (x, stats) = lsmr(A, b, M=M⁻¹, N=N⁻¹, sqd=true)
      end

      # Test different types for input and output
      A, b, c, D = small_sp(false, FC=FC)
      workspace = LsmrWorkspace(KrylovConstructor(TestVector(b), c))
      lsmr!(workspace, A, TestVector(b), M=inv(D), λ=1.0)
      @test typeof(workspace.x) === typeof(c)
      workspace = LsmrWorkspace(KrylovConstructor(b, TestVector(c)))
      lsmr!(workspace, A, b, M=inv(D), λ=1.0)
      @test typeof(workspace.x) === typeof(TestVector(c))

      # test callback function
      A, b, M = saddle_point(FC=FC)
      M⁻¹ = inv(M)
      workspace = LsmrWorkspace(A, b)
      tol = 1.0e-1
      cb_n2 = TestCallbackN2LS(A, b, zero(eltype(b)), tol = tol)
      lsmr!(workspace, A, b, M=M⁻¹, callback = cb_n2)
      @test workspace.stats.status == "user-requested exit"
      @test cb_n2(workspace)

      @test_throws TypeError lsmr(A, b, M=M⁻¹, callback = workspace -> "string", history = true)
    end
  end
end

using SparseArrays, Random, Test
using LinearAlgebra, Krylov, KernelAbstractions

if VERSION < v"1.11"
  @kernel function copy_triangle_kernel!(dest, src)
    i, j = @index(Global, NTuple)
    if j >= i
      @inbounds dest[i, j] = src[i, j]
    end
  end

  function Krylov.copy_triangle(Q::AbstractMatrix{FC}, R::AbstractMatrix{FC}, k::Int) where FC <: Krylov.FloatOrComplex
    backend = get_backend(Q)
    ndrange = (k, k)
    copy_triangle_kernel!(backend)(R, Q; ndrange=ndrange)
    KernelAbstractions.synchronize(backend)
  end
end

Random.seed!(666)

include("../test_utils.jl")

function test_processes(S, M)
  m = 250
  n = 500
  k = 20
  FC = eltype(S)

  cpu_A, cpu_b = symmetric_indefinite(n, FC=FC)
  gpu_A, gpu_b = M(cpu_A), S(cpu_b)
  V, β, T = hermitian_lanczos(gpu_A, gpu_b, k)

  cpu_A, cpu_b = nonsymmetric_definite(n, FC=FC)
  cpu_c = -cpu_b
  gpu_A, gpu_b, gpu_c = M(cpu_A), S(cpu_b), S(cpu_c)
  V, β, T, U, γᴴ, Tᴴ = nonhermitian_lanczos(gpu_A, gpu_b, gpu_c, k)

  cpu_A, cpu_b = nonsymmetric_indefinite(n, FC=FC)
  gpu_A, gpu_b = M(cpu_A), S(cpu_b)
  V, β, H = arnoldi(gpu_A, gpu_b, k)

  cpu_A, cpu_b = under_consistent(m, n, FC=FC)
  gpu_A, gpu_b = M(cpu_A), S(cpu_b)
  V, U, β, L = golub_kahan(gpu_A, gpu_b, k)

  cpu_A, cpu_b = under_consistent(m, n, FC=FC)
  _, cpu_c = over_consistent(n, m, FC=FC)
  gpu_A, gpu_b, gpu_c = M(cpu_A), S(cpu_b), S(cpu_c)
  V, β, T, U, γᴴ, Tᴴ = saunders_simon_yip(gpu_A, gpu_b, gpu_c, k)

  cpu_A, cpu_b = under_consistent(m, n, FC=FC)
  cpu_B, cpu_c = over_consistent(n, m, FC=FC)
  gpu_A, gpu_B, gpu_b, gpu_c = M(cpu_A), M(cpu_B), S(cpu_b), S(cpu_c)
  V, β, H, U, γ, F = montoison_orban(gpu_A, gpu_B, gpu_b, gpu_c, k)
end

function test_solver(S, M)
  n = 10
  memory = 5
  A = M(undef, n, n)
  b = S(undef, n)
  workspace = GmresWorkspace(n, n, S; memory)
  krylov_solve!(workspace, A, b)  # Test that we don't have errors
end

function test_conversion(S, M)
  @test Krylov.vector_to_matrix(S) <: M
  @test Krylov.matrix_to_vector(M) <: S
end

import LinearAlgebra.mul!

mutable struct FlexiblePreconditioner{T,S}
  D::Diagonal{T, S}
  ω::T
end

function mul!(y::Vector, P::FlexiblePreconditioner, x::Vector)
  P.ω = -P.ω
  mul!(y, P.D, x)
  y .*= P.ω
end

@testset "fgmres" begin
  fgmres_tol = 1.0e-6

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      # Symmetric and positive definite system.
      A, b = symmetric_definite(FC=FC)
      (x, stats) = fgmres(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ fgmres_tol)
      @test(stats.solved)

      # Symmetric indefinite variant.
      A, b = symmetric_indefinite(FC=FC)
      (x, stats) = fgmres(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ fgmres_tol)
      @test(stats.solved)

      # Nonsymmetric and positive definite systems.
      A, b = nonsymmetric_definite(FC=FC)
      (x, stats) = fgmres(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ fgmres_tol)
      @test(stats.solved)

      # Nonsymmetric indefinite variant.
      A, b = nonsymmetric_indefinite(FC=FC)
      (x, stats) = fgmres(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ fgmres_tol)
      @test(stats.solved)

      # Symmetric indefinite variant, almost singular.
      A, b = almost_singular(FC=FC)
      (x, stats) = fgmres(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ 100 * fgmres_tol)
      @test(stats.solved)

      # Singular system.
      A, b = square_inconsistent(FC=FC)
      (x, stats) = fgmres(A, b)
      r = b - A * x
      Aresid = norm(A' * r) / norm(A' * b)
      @test(Aresid ≤ fgmres_tol)
      @test(stats.inconsistent)

      # Test b == 0
      A, b = zero_rhs(FC=FC)
      (x, stats) = fgmres(A, b)
      @test norm(x) == 0
      @test stats.status == "x is a zero-residual solution"

      # Poisson equation in polar coordinates.
      A, b = polar_poisson(FC=FC)
      (x, stats) = fgmres(A, b, reorthogonalization=true)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ fgmres_tol)
      @test(stats.solved)

      # Left preconditioning
      A, b, M = square_preconditioned(FC=FC)
      (x, stats) = fgmres(A, b, M=M)
      r = b - A * x
      resid = norm(M * r) / norm(M * b)
      @test(resid ≤ fgmres_tol)
      @test(stats.solved)

      # Right preconditioning
      A, b, N = square_preconditioned(FC=FC)
      (x, stats) = fgmres(A, b, N=N)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ fgmres_tol)
      @test(stats.solved)

      # Split preconditioning
      A, b, M, N = two_preconditioners(FC=FC)
      (x, stats) = fgmres(A, b, M=M, N=N)
      r = b - A * x
      resid = norm(M * r) / norm(M * b)
      @test(resid ≤ fgmres_tol)
      @test(stats.solved)

      # Restart
      for restart ∈ (false, true)
        memory = 10

        A, b = sparse_laplacian(FC=FC)
        (x, stats) = fgmres(A, b, restart=restart, memory=memory)
        r = b - A * x
        resid = norm(r) / norm(b)
        @test(resid ≤ fgmres_tol)
        @test(stats.niter > memory)
        @test(stats.solved)

        M = Diagonal(1 ./ diag(A))
        (x, stats) = fgmres(A, b, M=M, restart=restart, memory=memory)
        r = b - A * x
        resid = norm(M * r) / norm(M * b)
        @test(resid ≤ fgmres_tol)
        @test(stats.niter > memory)
        @test(stats.solved)

        N = Diagonal(1 ./ diag(A))
        (x, stats) = fgmres(A, b, N=N, restart=restart, memory=memory)
        r = b - A * x
        resid = norm(r) / norm(b)
        @test(resid ≤ fgmres_tol)
        @test(stats.niter > memory)
        @test(stats.solved)

        N = Diagonal(1 ./ sqrt.(diag(A)))
        N = Diagonal(1 ./ sqrt.(diag(A)))
        (x, stats) = fgmres(A, b, M=M, N=N, restart=restart, memory=memory)
        r = b - A * x
        resid = norm(M * r) / norm(M * b)
        @test(resid ≤ fgmres_tol)
        @test(stats.niter > memory)
        @test(stats.solved)
      end

      A, b = polar_poisson(FC=FC)
      J = inv(Diagonal(A))  # Jacobi preconditioner
      N = FlexiblePreconditioner(J, 1.0)
      (x, stats) = fgmres(A, b, N=N)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ fgmres_tol)
      @test(stats.solved)
    end
  end
end

# Identity matrix.
eye(n::Int; FC=Float64) = sparse(one(FC) * I, n, n)

# Compute the energy norm ‖r‖ₚ = √(rᴴPr) where P is a symmetric and positive definite matrix.
metric(r, P) = sqrt(real(dot(r, P * r)))

# Based on Lars Ruthotto's initial implementation.
function get_div_grad(n1 :: Int, n2 :: Int, n3 :: Int)

  # Divergence
  D1 = kron(eye(n3), kron(eye(n2), ddx(n1)))
  D2 = kron(eye(n3), kron(ddx(n2), eye(n1)))
  D3 = kron(ddx(n3), kron(eye(n2), eye(n1)))

  # DIV from faces to cell-centers
  Div = [D1 D2 D3]

  return Div * Div'
end

# 1D finite difference on staggered grid
function ddx(n :: Int)
  e = ones(n)
  return sparse([1:n; 1:n], [1:n; 2:n+1], [-e; e])
end

# Primal and dual ODEs discretized with central second order finite differences.
function ODE(n, f, g, ode_coefs; dim_x=[0.0, 1.0])
  # Ω = ]xₗ, xᵣ[
  # Ω ∪ ∂Ω = [xₗ, xᵣ]
  xₗ = dim_x[1]
  xᵣ = dim_x[2]

  # Uniform grid of Ω with n points
  Δx = (xᵣ - xₗ) / (n + 1)
  grid = [i * Δx for i = 1 : n]

  χ₁ = ode_coefs[1]
  χ₂ = ode_coefs[2]
  χ₃ = ode_coefs[3]

  # Model problems with Au = b and Aᵀv = c
  #
  # A ∈ ℜⁿ*ⁿ, u ∈ ℜⁿ, b ∈ ℜⁿ, v ∈ ℜⁿ, c ∈ ℜⁿ
  #
  # ∂²z(xᵢ) / ∂x² ≈ (zᵢ₋₁ -2zᵢ + zᵢ₊₁) / (Δx)²
  #
  # ∂z(xᵢ) / ∂x ≈ (zᵢ₊₁ - zᵢ₋₁) / (2 * Δx)
  A = spzeros(n, n)
  for i = 1 : n
    if i ≠ 1
      A[i, i-1] = χ₁ / (Δx * Δx) - χ₂ / (2 * Δx)
    end
    A[i, i] = -2 * χ₁ / (Δx * Δx) + χ₃
    if i ≠ n
      A[i, i+1] = χ₁ / (Δx * Δx) + χ₂ / (2 * Δx)
    end
  end

  b = f(grid)
  c = g(grid)
  return A, b, c
end

# Primal and dual PDEs discretized with central second order finite differences.
function PDE(n, m, f, g, pde_coefs; dim_x=[0.0, 1.0], dim_y=[0.0, 1.0])
  # Ω = ]xₗ,xᵣ[ × ]yₗ,yᵣ[
  # Ω ∪ ∂Ω = [xₗ,xᵣ] × [yₗ,yᵣ]
  xₗ = dim_x[1]
  xᵣ = dim_x[2]

  yₗ = dim_y[1]
  yᵣ = dim_y[2]

  # Uniform grid of Ω with n × m points
  Δx = (xᵣ - xₗ) / (n + 1)
  x = [xₗ + i * Δx for i = 1 : n]

  Δy = (yᵣ - yₗ) / (m + 1)
  y = [yₗ + j * Δy for j = 1 : m]

  a = pde_coefs[1]
  b = pde_coefs[2]
  c = pde_coefs[3]
  d = pde_coefs[4]
  e = pde_coefs[5]

  # Model problems with Au = b and Aᵀv = c
  #
  # A ∈ ℜᵐⁿ*ᵐⁿ, u ∈ ℜᵐⁿ, b ∈ ℜᵐⁿ, v ∈ ℜᵐⁿ, c ∈ ℜᵐⁿ
  # xᵢ = i * Δx, yⱼ = j * Δy and zᵢ.ⱼ = z(xᵢ, yⱼ)
  #
  # ∂²z(xᵢ, yⱼ) / ∂x² ≈ (zᵢ₋₁.ⱼ -2zᵢ.ⱼ + zᵢ₊₁.ⱼ) / (Δx)²
  # ∂²z(xᵢ, yⱼ) / ∂y² ≈ (zᵢ.ⱼ₋₁ -2zᵢ.ⱼ + zᵢ.ⱼ₊₁) / (Δy)²
  #
  # ∂z(xᵢ, yⱼ) / ∂x ≈ (zᵢ₊₁.ⱼ - zᵢ₋₁.ⱼ) / (2 * Δx)
  # ∂z(xᵢ, yⱼ) / ∂y ≈ (zᵢ.ⱼ₊₁ - zᵢ.ⱼ₋₁) / (2 * Δy)
  #
  # uᵢ.ⱼ = u[i + n * (j-1)]
  # bᵢ.ⱼ = f[i + n * (j-1)]
  #
  # vᵢ.ⱼ = v[i + n * (j-1)]
  # cᵢ.ⱼ = g[i + n * (j-1)]
  A = spzeros(n * m, n * m)
  for i = 1 : n
    for j = 1 : m
      A[i + n*(j-1), i + n*(j-1)] = - 2*a / (Δx * Δx) - 2*b / (Δy * Δy) + e
      if i ≥ 2
        A[i + n*(j-1), (i-1) + n*(j-1)] = a / (Δx * Δx) - c / (2 * Δx)
      end
      if i ≤ n-1
        A[i + n*(j-1), (i+1) + n*(j-1)] = a / (Δx * Δx) + c / (2 * Δx)
      end
      if j ≥ 2
        A[i + n*(j-1), i + n*(j-2)] = b / (Δy * Δy) - d / (2 * Δy)
      end
      if j ≤ m-1
        A[i + n*(j-1), i + n*j] = b / (Δy * Δy) + d / (2 * Δy)
      end
    end
  end

  b = zeros(n * m)
  for i = 1 : n
    for j = 1 : m
      b[i + n*(j-1)] = f(x[i], y[j])
    end
  end

  c = zeros(n * m)
  for i = 1 : n
    for j = 1 : m
      c[i + n*(j-1)] = g(x[i], y[j])
    end
  end

  return A, b, c
end

# Model Poisson equation in polar coordinates
function polar_poisson(n, m, f, g; R=1.0)
  Δr = 2 * R / (2*n + 1)
  r = [(i - 1/2) * Δr for i = 1 : n+1]

  Δθ = 2 * π / m
  θ = [(j - 1) * Δθ for j = 1 : m+1]

  λ = [1 / (2 * (k - 1/2)) for k = 1 : n]
  β = [1 / ((k - 1/2)^2 * Δθ^2) for k = 1 : n]

  D = spdiagm(0 => β)
  T = spdiagm(-1 => 1.0 .- λ[2:n], 0 => -2.0 * ones(n), 1 => 1.0 .+ λ[1:n-1])

  A = spzeros(n * m, n * m)
  for k = 1 : m
    A[1+(k-1)*n : k*n, 1+(k-1)*n : k*n] = T - 2*D
    if k ≤ m-1
      A[1+k*n : (k+1)*n, 1+(k-1)*n : k*n] = D
      A[1+(k-1)*n : k*n, 1+k*n : (k+1)*n] = D
    end
  end
  A[1+(m-1)*n : m*n, 1 : n] = D
  A[1 : n, 1+(m-1)*n : m*n] = D

  b = zeros(n * m)
  for i = 1 : n
    for j = 1 : m
      b[i + n*(j-1)] = Δr * Δr * f(r[i], θ[j])
      if i == n
        b[i + n*(j-1)] -= (1.0 + λ[n]) * g(R, θ[j])
      end
    end
  end

  return A, b
end

# Model Poisson equation in cartesian coordinates
function cartesian_poisson(n, m, f, g; dim_x=[0.0, 1.0], dim_y=[0.0, 1.0])
  # Ω = ]xₗ,xᵣ[ × ]yₗ,yᵣ[
  # Ω ∪ ∂Ω = [xₗ,xᵣ] × [yₗ,yᵣ]
  xₗ = dim_x[1]
  xᵣ = dim_x[2]

  yₗ = dim_y[1]
  yᵣ = dim_y[2]

  # Uniform grid of Ω with n × m points
  Δx = (xᵣ - xₗ) / (n + 1)
  x = [xₗ + i * Δx for i = 1 : n]

  Δy = (yᵣ - yₗ) / (m + 1)
  y = [yₗ + j * Δy for j = 1 : m]

  A = spzeros(n * m, n * m)
  for i = 1 : n
    for j = 1 : m
      A[i + (j-1)*n, i + (j-1)*n] = - 2.0 / (Δx * Δx) - 2.0 / (Δy * Δy)
      if i ≥ 2
        A[i + (j-1)*n, i-1 + (j-1)*n] = 1.0 / (Δx * Δx)
      end
      if i ≤ n-1
        A[i + (j-1)*n, i+1 + (j-1)*n] = 1.0 / (Δx * Δx)
      end
      if j ≥ 2
        A[i + (j-1)*n, i + (j-2)*n] = 1.0 / (Δy * Δy)
      end
      if j ≤ m-1
        A[i + (j-1)*n, i + j*n] = 1.0 / (Δy * Δy)
      end
    end
  end

  b = zeros(n * m)
  for i = 1 : n
    for j = 1 : m
      b[i + (j-1)*n] = f(x[i], y[j])
      if i == 1
        b[i + (j-1)*n] -= g(xₗ, y[j]) / (Δx * Δx)
      end
      if i == n
        b[i + (j-1)*n] -= g(xᵣ, y[j]) / (Δx * Δx)
      end
      if j == 1
        b[i + (j-1)*n] -= g(x[i], yₗ) / (Δy * Δy)
      end
      if j == m
        b[i + (j-1)*n] -= g(x[i], yᵣ) / (Δy * Δy)
      end
    end
  end

  return A, b
end

# An implementation of USYMLQR for the solution of symmetric saddle-point systems.
#
# This method is described in
#
# M. A. Saunders, H. D. Simon, and E. L. Yip
# Two Conjugate-Gradient-Type Methods for Unsymmetric Linear Equations.
# SIAM Journal on Numerical Analysis, 25(4), pp. 927--940, 1988.
#
# A. Buttari, D. Orban, D. Ruiz and D. Titley-Peloquin
# A tridiagonalization method for symmetric saddle-point systems.
# SIAM Journal on Scientific Computing, 41(5), pp. 409--432, 2019
#
# Dominique Orban, <dominique.orban@gerad.ca>
# Alexis Montoison, <alexis.montoison@polymtl.ca> -- <amontoison@anl.gov>
# Montréal, November 2021 -- Chicago, January 2026.

export usymlqr, usymlqr!

"""
    (x, y, stats) = usymlqr(A, b::AbstractVector{FC}, c::AbstractVector{FC};
                            ls::Bool=true, ln::Bool=true, ldiv::Bool=false,
                            atol::T=√eps(T), rtol::T=√eps(T), itmax::Int=0,
                            timemax::Float64=Inf, verbose::Int=0,
                            history::Bool=false, callback=workspace->false,
                            iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, y, stats) = usymlqr(A, b, c, x0::AbstractVector, y0::AbstractVector; kwargs...)

USYMLQR can be warm-started from initial guesses `x0` and `y0` where `kwargs` are the same keyword arguments as above.

Solve the symmetric saddle-point system

    [ I   A ] [ x ] = [ b ]
    [ Aᴴ    ] [ y ]   [ c ]

by way of the Saunders-Simon-Yip tridiagonalization using USYMLQ and USYMQR methods.

The method solves the least-squares problem when `ls = true`

    [ I   A ] [ r ] = [ b ]
    [ Aᴴ    ] [ s ]   [ 0 ]

and the least-norm problem when `ln = true`

    [ I   A ] [ w ] = [ 0 ]
    [ Aᴴ    ] [ z ]   [ c ]

and simply adds the solutions.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :usymlqr`.

For an in-place variant that reuses memory across solves, see [`usymlqr!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`;
* `c`: a vector of length `n`.

#### Optional arguments

* `x0`: a vector of length `m` that represents an initial guess of the solution `x`;
* `y0`: a vector of length `n` that represents an initial guess of the solution `y`.

#### Keyword arguments

* `ls`: define whether the least-squares problem is solved;
* `ln`: define whether the least-norm problem is solved;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `m+n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be kdisplayed if verbose mode is enabled (verbose > 0). Information will be kdisplayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `m`;
* `y`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### References

* M. A. Saunders, H. D. Simon, and E. L. Yip, [*Two Conjugate-Gradient-Type Methods for Unsymmetric Linear Equations*](https://doi.org/10.1137/0725052), SIAM Journal on Numerical Analysis, 25(4), pp. 927--940, 1988.
* A. Buttari, D. Orban, D. Ruiz and D. Titley-Peloquin, [*A tridiagonalization method for symmetric saddle-point and quasi-definite systems*](https://doi.org/10.1137/18M1194900), SIAM Journal on Scientific Computing, 41(5), pp. 409--432, 2019.
"""
function usymlqr end

"""
    workspace = usymlqr!(workspace::UsymlqrWorkspace, A, b, c; kwargs...)
    workspace = usymlqr!(workspace::UsymlqrWorkspace, A, b, c, x0, y0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`usymlqr`](@ref).

See [`UsymlqrWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) `method = :usymlqr` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function usymlqr! end

def_args_usymlqr = (:(A                    ),
                    :(b::AbstractVector{FC}),
                    :(c::AbstractVector{FC}))

def_optargs_usymlqr = (:(x0::AbstractVector),
                       :(y0::AbstractVector))

def_kwargs_usymlqr = (:(; ls::Bool = true              ),
                      :(; ln::Bool = true              ),
                      :(; ldiv::Bool = false           ),
                      :(; atol::T = √eps(T)            ),
                      :(; rtol::T = √eps(T)            ),
                      :(; itmax::Int = 0               ),
                      :(; timemax::Float64 = Inf       ),
                      :(; verbose::Int = 0             ),
                      :(; history::Bool = false        ),
                      :(; callback = workspace -> false),
                      :(; iostream::IO = kstdout       ))

def_kwargs_usymlqr = extract_parameters.(def_kwargs_usymlqr)

args_usymlqr = (:A, :b, :c)
optargs_usymlqr = (:x0, :y0)
kwargs_usymlqr = (:ls, :ln, :ldiv, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function usymlqr!(workspace :: UsymlqrWorkspace{T,FC,Sm,Sn}, $(def_args_usymlqr...); $(def_kwargs_usymlqr...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}
    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    length(b) == m || error("Inconsistent problem size")
    length(c) == n || error("Inconsistent problem size")
    (ls || ln) || error("The keyword arguments `ls` and `ln` can't be both `false`.")
    (verbose > 0) && @printf(iostream, "USYMLQR: system of %d equations in %d variables\n", m+n, m+n)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == Sm || error("ktypeof(b) is not a subtype of $Sm")
    ktypeof(c) == Sn || error("ktypeof(c) is not a subtype of $Sn")

    # Compute the adjoint of A
    Aᴴ = A'

    # Set up workspace.
    Δx, Δy = workspace.Δx, workspace.Δy
    vₖ₋₁, vₖ, q, xₖ, rₖ = workspace.vₖ₋₁, workspace.vₖ, workspace.q, workspace.x, workspace.r
    uₖ₋₁, uₖ, p, yₖ, zₖ = workspace.uₖ₋₁, workspace.uₖ, workspace.p, workspace.y, workspace.z
    d̅, wₖ₋₂, wₖ₋₁ = workspace.d̅, workspace.wₖ₋₂, workspace.wₖ₋₁
    warm_start = workspace.warm_start
    b₀ = warm_start ? q : b
    c₀ = warm_start ? p : c

    stats = workspace.stats
    rNorms, AᴴrNorms = stats.residuals, stats.Aresiduals
    reset!(stats)

    iter = 0
    itmax == 0 && (itmax = n+m)

    # Initialize orthogonal tridiagonalization process.
    kfill!(vₖ₋₁, zero(FC))  # v₀ = 0
    kfill!(uₖ₋₁, zero(FC))  # u₀ = 0

    # [ I   A ] [ xₖ ] = [ b -   Δx - AΔy ] = [ b₀ ]
    # [ Aᴴ    ] [ yₖ ]   [ c - AᴴΔx       ]   [ c₀ ]
    if warm_start
      mul!(b₀, A, Δy)
      kaxpy!(m, one(T), Δx, b₀)
      kaxpby!(m, one(T), b, -one(T), b₀)
      mul!(c₀, Aᴴ, Δx)
      kaxpby!(n, one(T), c, -one(T), c₀)
    end

    # Initial solutions r₀ , x₀, y₀ and z₀.
    ls ? kcopy!(m, rₖ, b₀) : kfill!(rₖ, zero(FC))
    kfill!(xₖ, zero(FC))
    kfill!(yₖ, zero(FC))
    kfill!(zₖ, zero(FC))

    # β₁v₁ = b ↔ β₁v₁ = b
    kcopy!(m, vₖ, b₀)
    βₖ = knorm(m, vₖ)  # β₁ = ‖v₁‖
    if βₖ ≠ 0
      kdiv!(m, vₖ, βₖ)
    else
      # v₁ = 0 such that v₁ ⊥ Span{v₁, ..., vₖ}
      kfill!(vₖ, zero(FC))
    end

    # γ₁u₁ = c ↔ γ₁u₁ = c
    kcopy!(n, uₖ, c₀)
    γₖ = knorm(n, uₖ)  # γ₁ = ‖u₁‖
    if γₖ ≠ 0
      kdiv!(n, uₖ, γₖ)
    else
      # u₁ = 0 such that u₁ ⊥ Span{u₁, ..., uₖ}
      kfill!(uₖ, zero(FC))
    end

    cₖ₋₂ = cₖ₋₁ = cₖ = -one(T)      # Givens cosines used for the QR factorization of Tₖ₊₁.ₖ
    sₖ₋₂ = sₖ₋₁ = sₖ = zero(FC)     # Givens sines used for the QR factorization of Tₖ₊₁.ₖ
    kfill!(wₖ₋₂, zero(FC))          # Column k-2 of Wₖ = Uₖ(Rₖ)⁻¹
    kfill!(wₖ₋₁, zero(FC))          # Column k-1 of Wₖ = Uₖ(Rₖ)⁻¹
    kfill!(d̅, zero(FC))             # Last column of D̅ₖ = Vₖ(Qₖ₋₁)ᴴ
    ϕbarₖ = βₖ                      # ϕbarₖ is the last component of f̄ₖ = (Qₖ)ᴴβ₁e₁
    ζₖ₋₂ = ζₖ₋₁ = ζbarₖ = zero(FC)  # ζₖ₋₂, ζₖ₋₁ and ζbarₖ are the last components of h̄ₖ = (R̅ₖ)⁻ᴴγ₁e₁
    ηₖ₋₁ = zero(FC)                 # ηₖ₋₁ is used to update ζₖ₋₁ and ζbarₖ
    δₖ₋₁ = δbarₖ = zero(FC)         # Coefficients of Rₖ₋₁ and Rₖ modified over the course of two iterations

    # Stopping criterion.
    κ = zero(T)
    AᴴrNorm = Inf
    rNorm_ls = bNorm = βₖ
    rNorm_ln = cNorm = γₖ
    ε_ls = atol + rtol * rNorm_ls
    ε_ln = atol + rtol * rNorm_ln
    solved_ls = !ls || rNorm_ls ≤ ε_ls
    solved_ln = !ln || rNorm_ln ≤ ε_ln
    solved = solved_ls && solved_ln
    inconsistent = false
    tired = iter ≥ itmax
    status = "unknown"
    ill_cond = false
    user_requested_exit = false
    overtimed = false

    (verbose > 0) && @printf(iostream, "%5s  %7s  %7s  %7s  %7s  %5s\n", "k", "βₖ₊₁", "γₖ₊₁", "‖rₖ‖_LS", "‖rₖ‖_LN", "timer")
    !ls &&  ln && kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7s  %7.1e  %.2fs\n", iter, βₖ, γₖ, "✗ ✗ ✗ ✗", rNorm_ln, start_time |> ktimer)
     ls && !ln && kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %7s  %.2fs\n", iter, βₖ, γₖ, rNorm_ls, "✗ ✗ ✗ ✗", start_time |> ktimer)
     ls &&  ln && kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %7.1e  %.2fs\n", iter, βₖ, γₖ, rNorm_ls, rNorm_ln, start_time |> ktimer)

    while !(solved || tired || ill_cond || inconsistent || user_requested_exit || overtimed)
      # Update iteration index.
      iter = iter + 1

      # Continue the orthogonal tridiagonalization process.
      # AUₖ  = VₖTₖ    + βₖ₊₁vₖ₊₁(eₖ)ᵀ = Vₖ₊₁Tₖ₊₁.ₖ
      # AᴴVₖ = Uₖ(Tₖ)ᴴ + γₖ₊₁uₖ₊₁(eₖ)ᵀ = Uₖ₊₁(Tₖ.ₖ₊₁)ᴴ

      mul!(q, A , uₖ)  # Forms vₖ₊₁ : q ← Auₖ
      mul!(p, Aᴴ, vₖ)  # Forms uₖ₊₁ : p ← Aᴴvₖ

      if iter ≥ 2
        kaxpy!(m, -γₖ, vₖ₋₁, q)  # q ← q - γₖ * vₖ₋₁
        kaxpy!(n, -βₖ, uₖ₋₁, p)  # p ← p - βₖ * uₖ₋₁
      end

      αₖ = kdot(m, vₖ, q)  # αₖ = ⟨uₖ,q⟩

      kaxpy!(m, -     αₖ , vₖ, q)  # q ← q - αₖ * vₖ
      kaxpy!(n, -conj(αₖ), uₖ, p)  # p ← p - ᾱₖ * uₖ

      # Update vₖ₋₁ and uₖ₋₁
      kcopy!(m, vₖ₋₁, vₖ)
      kcopy!(n, uₖ₋₁, uₖ)

      # Compute βₖ₊₁ and γₖ₊₁
      βₖ₊₁ = knorm(m, q)  # βₖ₊₁ = ‖vₖ₊₁‖
      γₖ₊₁ = knorm(n, p)  # γₖ₊₁ = ‖uₖ₊₁‖

      # Update the QR factorization of Tₖ₊₁.ₖ = Qₖ [ Rₖ ].
      #                                            [ Oᵀ ]
      #
      # [ α₁ γ₂ 0  •  •  •   0  ]      [ δ₁ λ₁ ϵ₁ 0  •  •  0  ]
      # [ β₂ α₂ γ₃ •         •  ]      [ 0  δ₂ λ₂ •  •     •  ]
      # [ 0  •  •  •  •      •  ]      [ •  •  δ₃ •  •  •  •  ]
      # [ •  •  •  •  •  •   •  ] = Qₖ [ •     •  •  •  •  0  ]
      # [ •     •  •  •  •   0  ]      [ •        •  •  • ϵₖ₋₂]
      # [ •        •  •  •   γₖ ]      [ •           •  • λₖ₋₁]
      # [ •           •  βₖ  αₖ ]      [ 0  •  •  •  •  0  δₖ ]
      # [ 0  •  •  •  •  0  βₖ₊₁]      [ 0  •  •  •  •  •  0  ]
      #
      # If k = 1, we don't have any previous reflexion.
      # If k = 2, we apply the last reflexion.
      # If k ≥ 3, we only apply the two previous reflexions.

      # Apply previous Givens reflections Qₖ₋₂.ₖ₋₁
      if iter ≥ 3
        # [cₖ₋₂  sₖ₋₂] [0 ] = [  ϵₖ₋₂ ]
        # [s̄ₖ₋₂ -cₖ₋₂] [γₖ]   [λbarₖ₋₁]
        ϵₖ₋₂    =  sₖ₋₂ * γₖ
        λbarₖ₋₁ = -cₖ₋₂ * γₖ
      end

      # Apply previous Givens reflections Qₖ₋₁.ₖ
      if iter ≥ 2
        iter == 2 && (λbarₖ₋₁ = γₖ)
        # [cₖ₋₁  sₖ₋₁] [λbarₖ₋₁] = [λₖ₋₁ ]
        # [s̄ₖ₋₁ -cₖ₋₁] [   αₖ  ]   [δbarₖ]
        λₖ₋₁  =      cₖ₋₁  * λbarₖ₋₁ + sₖ₋₁ * αₖ
        δbarₖ = conj(sₖ₋₁) * λbarₖ₋₁ - cₖ₋₁ * αₖ
      end

      # Compute and apply current Givens reflection Qₖ.ₖ₊₁
      iter == 1 && (δbarₖ = αₖ)
      # [cₖ  sₖ] [δbarₖ] = [δₖ]
      # [s̄ₖ -cₖ] [βₖ₊₁ ]   [0 ]
      (cₖ, sₖ, δₖ) = sym_givens(δbarₖ, βₖ₊₁)

      # Compute the direction wₖ, the last column of Wₖ = Uₖ(Rₖ)⁻¹ ⟷ (Rₖ)ᵀ(Wₖ)ᵀ = (Uₖ)ᵀ.
      # w₁ = u₁ / δ₁
      if iter == 1
        wₖ = wₖ₋₁
        kdivcopy!(n, wₖ, uₖ, δₖ)
      end
      # w₂ = (u₂ - λ₁w₁) / δ₂
      if iter == 2
        wₖ = wₖ₋₂
        kaxpy!(n, -λₖ₋₁, wₖ₋₁, wₖ)
        kaxpy!(n, one(FC), uₖ, wₖ)
        kdiv!(n, wₖ, δₖ)
      end
      # wₖ = (uₖ - λₖ₋₁wₖ₋₁ - ϵₖ₋₂wₖ₋₂) / δₖ
      if iter ≥ 3
        kscal!(n, -ϵₖ₋₂, wₖ₋₂)
        wₖ = wₖ₋₂
        kaxpy!(n, -λₖ₋₁, wₖ₋₁, wₖ)
        kaxpy!(n, one(FC), uₖ, wₖ)
        kdiv!(n, wₖ, δₖ)
      end

      if ls && !solved_ls
        # Compute f̄ₖ₊₁ = [   fₖ  ] = (Qₖ)ᴴβ₁e₁
        #                [ϕbarₖ₊₁]
        #
        # [cₖ  sₖ] [ϕbarₖ] = [   ϕₖ  ]
        # [s̄ₖ -cₖ] [  0  ]   [ϕbarₖ₊₁]
        ϕₖ      =      cₖ  * ϕbarₖ
        ϕbarₖ₊₁ = conj(sₖ) * ϕbarₖ

        # Update the solution yₖ = Wₖfₖ.
        # yₖ ← yₖ₋₁ + ϕₖ * wₖ
        kaxpy!(n, ϕₖ, wₖ, yₖ)

        # Update the residual rₖ.
        # rₖ ← |sₖ|² * rₖ₋₁ - cₖ * ϕbarₖ₊₁ * vₖ₊₁
        # Note: vₖ₊₁ = q / βₖ₊₁
        kaxpby!(m, -cₖ * ϕbarₖ₊₁ / βₖ₊₁, q, abs2(sₖ), rₖ)

        # Compute ‖rₖ‖ = ‖ b - Ayₖ‖ = |ϕbarₖ₊₁|.
        rNorm_ls = abs(ϕbarₖ₊₁)
        history && push!(rNorms, rNorm_ls)

        # Compute ‖Aᴴrₖ₋₁‖ = |ϕbarₖ| * √(|δbarₖ|² + |λbarₖ|²).
        AᴴrNorm = abs(ϕbarₖ) * √(abs2(δbarₖ) + abs2(cₖ₋₁ * γₖ₊₁))
        history && push!(AᴴrNorms, AᴴrNorm)

        # Update ϕbarₖ₊₁
        ϕbarₖ = ϕbarₖ₊₁

        # Update solved_ls
        solved_ls = rNorm_ls ≤ ε_ls
        iter == 1 && (κ = atol + rtol * AᴴrNorm)
        inconsistent = !solved_ls && AᴴrNorm ≤ κ
      end

      if ln && !solved_ln
        # Update the solution of (R̅ₖ)ᴴh̄ₖ = γ₁e₁.
        #
        # [ δ₁  0   •   •   •   •   0  ] [ ζ₁ ]   [ γ₁ ]
        # [ λ₁  δ₂  •               •  ] [ ζ₂ ]   [ 0  ]
        # [ ϵ₁  λ₂  δ₃  •           •  ] [ ζ₃ ]   [ •  ]
        # [ 0   •   •   •   •       •  ] [ •  ] = [ •  ]
        # [ •   •   •   •   •   •   •  ] [ •  ]   [ •  ]
        # [ •       •   •   •   •   0  ] [ •  ]   [ •  ]
        # [ 0   •   •   0 ϵₖ₋₂ λₖ₋₁ δ̄ₖ ] [ ζ̄ₖ ]   [ 0  ]

        # Compute ζₖ₋₁ and ζbarₖ, the last components of the h̄ₖ.
        # [δbar₁] [ζbar₁] = [γ₁]
        if iter == 1
          ηₖ = γₖ
        end
        # [δ₁    0  ] [  ζ₁ ] = [γ₁]
        # [λ₁  δbar₂] [ζbar₂]   [0 ]
        if iter == 2
          ζₖ₋₁ = ηₖ₋₁ / conj(δₖ₋₁)
          ηₖ   = -conj(λₖ₋₁) * ζₖ₋₁
        end
        # [λₖ₋₂  δₖ₋₁    0  ] [ζₖ₋₂ ] = [0]
        # [ϵₖ₋₂  λₖ₋₁  δbarₖ] [ζₖ₋₁ ]   [0]
        #                     [ζbarₖ]
        if iter ≥ 3
          ζₖ₋₂ = ζₖ₋₁
          ζₖ₋₁ = ηₖ₋₁ / conj(δₖ₋₁)
          ηₖ   = -conj(ϵₖ₋₂) * ζₖ₋₂ - conj(λₖ₋₁) * ζₖ₋₁
        end

        # Relations for the directions dₖ₋₁ and d̅ₖ, the last two columns of D̅ₖ = Vₖ(Qₖ₋₁)ᴴ.
        # Note: D̄ₖ represents the matrix P̄ₖ in the paper of USYMLQR.
        # [d̅ₖ₋₁ vₖ] [cₖ₋₁  sₖ₋₁] = [dₖ₋₁ d̅ₖ] ⟷ dₖ₋₁ = cₖ₋₁ * d̅ₖ₋₁ + s̄ₖ₋₁ * vₖ
        #           [s̄ₖ₋₁ -cₖ₋₁]             ⟷ d̅ₖ   = sₖ₋₁ * d̅ₖ₋₁ - cₖ₋₁ * vₖ
        if iter == 1
          # d̅₁ = v₁
          kcopy!(m, d̅, vₖ)  # d̅ ← vₖ
        else
          # Compute solution xₖ.
          # (xᴸ)ₖ ← (xᴸ)ₖ₋₁ + ζₖ₋₁ * dₖ₋₁
          kaxpy!(m, ζₖ₋₁ *      cₖ₋₁,  d̅ , xₖ)
          kaxpy!(m, ζₖ₋₁ * conj(sₖ₋₁), vₖ, xₖ)

          # Compute solution zₖ.
          # (zᴸ)ₖ ← (zᴸ)ₖ₋₁ - ζₖ₋₁ * wₖ₋₁
          kaxpy!(n, -ζₖ₋₁, wₖ₋₁, zₖ)

          # Compute the direction d̅ₖ.
          # d̅ₖ = sₖ₋₁ * d̅ₖ₋₁ - cₖ₋₁ * vₖ
          kaxpby!(m, -cₖ₋₁, vₖ, sₖ₋₁, d̅)
        end

        # Compute USYMLQ residual norm
        # ‖rₖ‖ = √(|μₖ|² + |ωₖ|²)
        if iter == 1
          rNorm_ln = cNorm
        else
          μₖ = γₖ * (conj(sₖ₋₂) * ζₖ₋₂ - cₖ₋₂ * cₖ₋₁ * ζₖ₋₁) + conj(αₖ * sₖ₋₁) * ζₖ₋₁
          ωₖ = γₖ₊₁ * conj(sₖ₋₁) * ζₖ₋₁
          rNorm_ln = sqrt(abs2(μₖ) + abs2(ωₖ))
        end
        history && push!(rNorms, rNorm_ln)

        # Update ηₖ₋₁
        ηₖ₋₁ = ηₖ

        # Update solved_ln
        solved_ln = rNorm_ln ≤ ε_ln
      end

      # Compute vₖ₊₁ and uₖ₊₁.
      if βₖ₊₁ ≠ zero(T)
        kdivcopy!(m, vₖ, q, βₖ₊₁)  # vₖ₊₁ = q / βₖ₊₁
      else
        # If βₖ₊₁ == 0 then vₖ₊₁ = 0 and Auₖ ∈ Span{v₁, ..., vₖ}
        # We can keep vₖ₊₁ = 0 such that vₖ₊₁ ⊥ Span{v₁, ..., vₖ}
        kfill!(vₖ, zero(FC))
      end

      if γₖ₊₁ ≠ zero(T)
        kdivcopy!(n, uₖ, p, γₖ₊₁)  # uₖ₊₁ = p / γₖ₊₁
      else
        # If γₖ₊₁ == 0 then uₖ₊₁ = 0 and Aᴴvₖ ∈ Span{u₁, ..., uₖ}
        # We can keep uₖ₊₁ = 0 such that uₖ₊₁ ⊥ Span{u₁, ..., uₖ}
        kfill!(uₖ, zero(FC))
      end

      # Swap the pointers for wₖ₋₂ and wₖ₋₁
      if iter ≥ 2
        @kswap!(wₖ₋₂, wₖ₋₁)
      end

      # Update sₖ₋₂, cₖ₋₂, sₖ₋₁, cₖ₋₁, γₖ, βₖ and δₖ₋₁
      if iter ≥ 2
        sₖ₋₂ = sₖ₋₁
        cₖ₋₂ = cₖ₋₁
      end
      sₖ₋₁ = sₖ
      cₖ₋₁ = cₖ
      δₖ₋₁ = δₖ
      γₖ   = γₖ₊₁
      βₖ   = βₖ₊₁

      # Update stopping criterion.
      user_requested_exit = callback(workspace) :: Bool
      solved = solved_ls && solved_ln
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      !ls &&  ln && kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7s  %7.1e  %.2fs\n", iter, βₖ₊₁, γₖ₊₁, "✗ ✗ ✗ ✗", rNorm_ln, start_time |> ktimer)
       ls && !ln && kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %7s  %.2fs\n", iter, βₖ₊₁, γₖ₊₁, rNorm_ls, "✗ ✗ ✗ ✗", start_time |> ktimer)
       ls &&  ln && kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %7.1e  %.2fs\n", iter, βₖ₊₁, γₖ₊₁, rNorm_ls, rNorm_ln, start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    solved              && (status = "solution good enough given atol and rtol")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Compute the solution of the saddle point system
    # xₖ ← xₖ + rₖ
    # yₖ ← yₖ + zₖ
    kaxpy!(m, one(FC), rₖ, xₖ)
    kaxpy!(n, one(FC), zₖ, yₖ)

    # Update xₖ and yₖ
    warm_start && kaxpy!(m, one(FC), Δx, xₖ)
    warm_start && kaxpy!(n, one(FC), Δy, yₖ)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = false
    stats.timer = ktimer(start_time)
    stats.status = status
    return workspace
  end
end

# A standard implementation of the Conjugate Gradient method.
# The only non-standard point about it is that it does not check
# that the operator is definite.
# It is possible to check that the system is inconsistent by
# monitoring ‖p‖, which would cost an extra norm computation per
# iteration.
#
# This method is described in
#
# M. R. Hestenes and E. Stiefel. Methods of conjugate gradients for solving linear systems.
# Journal of Research of the National Bureau of Standards, 49(6), pp. 409--436, 1952.
#
# Dominique Orban, <dominique.orban@gerad.ca>
# Salt Lake City, UT, March 2015.

export cg, cg!

"""
    (x, stats) = cg(A, b::AbstractVector{FC};
                    M=I, ldiv::Bool=false, radius::T=zero(T),
                    linesearch::Bool=false, atol::T=√eps(T),
                    rtol::T=√eps(T), itmax::Int=0,
                    timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                    callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = cg(A, b, x0::AbstractVector; kwargs...)

CG can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above.

The conjugate gradient method to solve the Hermitian linear system Ax = b of size n.

The method does _not_ abort if A is not definite.
M also indicates the weighted norm in which residuals are measured.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :cg`.

For an in-place variant that reuses memory across solves, see [`cg!`](@ref).

#### Input arguments

* `A`: a linear operator that models a Hermitian positive definite matrix of dimension `n`;
* `b`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning;
* `ldiv`: define whether the preconditioner uses `ldiv!` or `mul!`;
* `radius`: add the trust-region constraint ‖x‖ ≤ `radius` if `radius > 0`. Useful to compute a step in a trust-region method for optimization.
  - If `radius > 0`, and nonpositive curvature is detected along the current search direction, we take the step to the trust-region boundary, the search direction is stored in `stats.npc_dir`, and `stats.npcCount` is set to 1.
* `linesearch`: when `true`, assume that CG is used within an inexact Newton method with line search.
  - If nonpositive curvature occurs at k = 0, the solver instead takes the right-hand side (i.e., the preconditioned negative gradient) as the current solution. The same search direction is returned in `workspace.npc_dir`, and `stats.npcCount` is set to 1.;
  - If nonpositive curvature is detected at iteration k > 0, the method rolls back to the solution from iteration k – 1. The search direction computed at iteration k is stored in `stats.npc_dir`, and `stats.npcCount` is set to 1.
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### Reference

* M. R. Hestenes and E. Stiefel, [*Methods of conjugate gradients for solving linear systems*](https://doi.org/10.6028/jres.049.044), Journal of Research of the National Bureau of Standards, 49(6), pp. 409--436, 1952.
"""
function cg end

"""
    workspace = cg!(workspace::CgWorkspace, A, b; kwargs...)
    workspace = cg!(workspace::CgWorkspace, A, b, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`cg`](@ref).

See [`CgWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :cg` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function cg! end

def_args_cg = (:(A                    ),
               :(b::AbstractVector{FC}))

def_optargs_cg = (:(x0::AbstractVector),)

def_kwargs_cg = (:(; M = I                        ),
                 :(; ldiv::Bool = false           ),
                 :(; radius::T = zero(T)          ),
                 :(; linesearch::Bool = false     ),
                 :(; atol::T = √eps(T)            ),
                 :(; rtol::T = √eps(T)            ),
                 :(; itmax::Int = 0               ),
                 :(; timemax::Float64 = Inf       ),
                 :(; verbose::Int = 0             ),
                 :(; history::Bool = false        ),
                 :(; callback = workspace -> false),
                 :(; iostream::IO = kstdout       ))

def_kwargs_cg = extract_parameters.(def_kwargs_cg)

args_cg = (:A, :b)
optargs_cg = (:x0,)
kwargs_cg = (:M, :ldiv, :radius, :linesearch, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function cg!(workspace :: CgWorkspace{T,FC,S}, $(def_args_cg...); $(def_kwargs_cg...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("System must be square")
    length(b) == n || error("Inconsistent problem size")
    linesearch && (radius > 0) && error("`linesearch` set to `true` but trust-region radius > 0")
    (workspace.warm_start && linesearch) && error("warm_start and linesearch cannot be used together")
    (verbose > 0) && @printf(iostream, "CG: system of %d equations in %d variables\n", n, n)

    # Tests M = Iₙ
    MisI = (M === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")

    # Set up workspace.
    allocate_if(!MisI, workspace, :z, S, workspace.x)  # The length of z is n
    allocate_if(linesearch || (radius > 0), workspace, :npc_dir , S, workspace.x)  # The length of npc_dir is n
    Δx, x, r, p, Ap, stats = workspace.Δx, workspace.x, workspace.r, workspace.p, workspace.Ap, workspace.stats
    warm_start = workspace.warm_start
    rNorms = stats.residuals
    reset!(stats)
    z = MisI ? r : workspace.z
    if linesearch || (radius > 0)
      npc_dir = workspace.npc_dir
    end

    kfill!(x, zero(FC))
    if warm_start
      kmul!(r, A, Δx)
      kaxpby!(n, one(FC), b, -one(FC), r)
    else
      kcopy!(n, r, b)  # r ← b
    end
    MisI || mulorldiv!(z, M, r, ldiv)
    kcopy!(n, p, z)  # p ← z
    γ = kdotr(n, r, z)
    γ ≥ 0 || error("The linear operator `A` or the preconditioner `M` is not symmetric positive definite.")
    rNorm = sqrt(γ)
    history && push!(rNorms, rNorm)
    if γ == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    iter = 0
    itmax == 0 && (itmax = 2 * n)

    pAp = zero(T)
    pNorm² = γ
    ε = atol + rtol * rNorm
    (verbose > 0) && @printf(iostream, "%5s  %7s  %8s  %8s  %8s  %5s\n", "k", "‖r‖", "pAp", "α", "σ", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e", iter, rNorm)

    solved = rNorm ≤ ε
    tired = iter ≥ itmax
    inconsistent = false
    on_boundary = false
    zero_curvature = false
    user_requested_exit = false
    overtimed = false

    status = "unknown"

    while !(solved || tired || zero_curvature || user_requested_exit || overtimed)
      kmul!(Ap, A, p)
      pAp = kdotr(n, p, Ap)
      if (pAp ≤ eps(T) * pNorm²) && (radius == 0)
        if abs(pAp) ≤ eps(T) * pNorm²
          zero_curvature = true
          inconsistent = !linesearch
        end
        if linesearch
          iter == 0 && kcopy!(n, x, p)  # x ← p
          kcopy!(n, npc_dir, p)  # npc_dir ← p
          stats.npcCount = 1
          stats.indefinite = true
          solved = true
        end
      end
      (zero_curvature || solved) && continue

      α = γ / pAp
 
      # Compute step size to boundary if applicable.
      if radius == 0
         σ = α
      elseif MisI 
         σ = maximum(to_boundary(n, x, p, z, radius, dNorm2=pNorm²))
      else
         σ = maximum(to_boundary(n, x, p, z, radius, M=M, ldiv=!ldiv)) 
      end

      kdisplay(iter, verbose) && @printf(iostream, "  %8.1e  %8.1e  %8.1e  %.2fs\n", pAp, α, σ, start_time |> ktimer)

      # Move along p from x to the boundary if either
      # the next step leads outside the trust region or
      # we have nonpositive curvature.
      if (radius > 0) && ((pAp ≤ 0) || (α > σ))
        α = σ
        if pAp ≤ 0
          kcopy!(n, npc_dir, p)  # npc_dir ← p
          stats.npcCount = 1
          stats.indefinite = true
        end
        on_boundary = true
      end

      kaxpy!(n,  α,  p, x)
      kaxpy!(n, -α, Ap, r)
      MisI || mulorldiv!(z, M, r, ldiv)
      γ_next = kdotr(n, r, z)
      γ_next ≥ 0 || error("The linear operator `A` or the preconditioner `M` is not symmetric positive definite.")
      rNorm = sqrt(γ_next)
      history && push!(rNorms, rNorm)

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      resid_decrease_mach = (rNorm + one(T) ≤ one(T))

      resid_decrease_lim = rNorm ≤ ε
      resid_decrease = resid_decrease_lim || resid_decrease_mach
      solved = resid_decrease || on_boundary

      if !solved
        β = γ_next / γ
        pNorm² = γ_next + β^2 * pNorm²
        γ = γ_next
        kaxpby!(n, one(FC), z, β, p)
      end

      iter = iter + 1
      tired = iter ≥ itmax
      user_requested_exit = callback(workspace) :: Bool
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e", iter, rNorm)
    end
    (verbose > 0) && @printf(iostream, "\n\n")

    # Termination status
    solved && on_boundary             && (status = "on trust-region boundary")
    solved && stats.indefinite        && (status = "nonpositive curvature")
    solved && (status == "unknown")   && (status = "solution good enough given atol and rtol")
    zero_curvature                    && (status = "zero curvature detected")
    tired                             && (status = "maximum number of iterations exceeded")
    user_requested_exit               && (status = "user-requested exit")
    overtimed                         && (status = "time limit exceeded")

    # Update x
    warm_start && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = inconsistent
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

@testset "aux" begin

  @testset "sym_givens" begin
    # test Givens reflector corner cases
    (c, s, ρ) = Krylov.sym_givens(0.0, 0.0)
    @test (c == 1.0) && (s == 0.0) && (ρ == 0.0)

    a = 3.14
    (c, s, ρ) = Krylov.sym_givens(a, 0.0)
    @test (c == 1.0) && (s == 0.0) && (ρ == a)
    (c, s, ρ) = Krylov.sym_givens(-a, 0.0)
    @test (c == -1.0) && (s == 0.0) && (ρ == a)

    b = 3.14
    (c, s, ρ) = Krylov.sym_givens(0.0, b)
    @test (c == 0.0) && (s == 1.0) && (ρ == b)
    (c, s, ρ) = Krylov.sym_givens(0.0, -b)
    @test (c == 0.0) && (s == -1.0) && (ρ == b)

    (c, s, ρ) = Krylov.sym_givens(Complex(0.0), Complex(0.0))
    @test (c == 1.0) && (s == Complex(0.0)) && (ρ == Complex(0.0))

    a = Complex(1.0, 1.0)
    (c, s, ρ) = Krylov.sym_givens(a, Complex(0.0))
    @test (c == 1.0) && (s == Complex(0.0)) && (ρ == a)
    (c, s, ρ) = Krylov.sym_givens(-a, Complex(0.0))
    @test (c == 1.0) && (s == Complex(0.0)) && (ρ == -a)

    b = Complex(1.0, 1.0)
    (c, s, ρ) = Krylov.sym_givens(Complex(0.0), b)
    @test (c == 0.0) && (s == Complex(1.0)) && (ρ == b)
    (c, s, ρ) = Krylov.sym_givens(Complex(0.0), -b)
    @test (c == 0.0) && (s == Complex(1.0)) && (ρ == -b)
  end

  @testset "roots_quadratic" begin
    # test roots of a quadratic
    roots = Krylov.roots_quadratic(0.0, 0.0, 0.0)
    @test roots[1] == 0.0
    @test roots[2] == 0.0

    @test_throws ErrorException Krylov.roots_quadratic(0.0, 0.0, 1.0)

    roots = Krylov.roots_quadratic(0.0, 3.14, -1.0)
    @test roots[1] == 1.0 / 3.14
    @test roots[2] == 1.0 / 3.14

    @test_throws ErrorException Krylov.roots_quadratic(1.0, 0.0, 1.0)

    roots = Krylov.roots_quadratic(1.0, 0.0, 0.0)
    @test roots[1] == 0.0
    @test roots[2] == 0.0

    roots = Krylov.roots_quadratic(1.0, 3.0, 2.0)
    @test roots[1] ≈ -2.0
    @test roots[2] ≈ -1.0

    @test_throws ErrorException Krylov.roots_quadratic(1.0e+8, 1.0, 1.0)

    # ill-conditioned quadratic
    roots = Krylov.roots_quadratic(-1.0e-8, 1.0e+5, 1.0, nitref=0)
    @test roots[1] == 1.0e+13
    @test roots[2] == 0.0

    # iterative refinement is crucial!
    roots = Krylov.roots_quadratic(-1.0e-8, 1.0e+5, 1.0, nitref=1)
    @test roots[1] == 1.0e+13
    @test roots[2] == -1.0e-05

    # not ill-conditioned quadratic
    roots = Krylov.roots_quadratic(-1.0e-7, 1.0, 1.0, nitref=0)
    @test isapprox(roots[1],  1.0e+7, rtol=1.0e-6)
    @test isapprox(roots[2], -1.0, rtol=1.0e-6)

    roots = Krylov.roots_quadratic(-1.0e-7, 1.0, 1.0, nitref=1)
    @test isapprox(roots[1], 1.0e+7, rtol=1.0e-6)
    @test isapprox(roots[2], -1.0, rtol=1.0e-6)

    allocations = @allocated Krylov.roots_quadratic(0.0, 0.0, 0.0)
    @test allocations == 0

    allocations = @allocated Krylov.roots_quadratic(0.0, 3.14, -1.0)
    @test allocations == 0

    allocations = @allocated Krylov.roots_quadratic(1.0, 0.0, 0.0)
    @test allocations == 0

    allocations = @allocated Krylov.roots_quadratic(1.0, 3.0, 2.0)
    @test allocations == 0

    allocations = @allocated Krylov.roots_quadratic(-1.0e-8, 1.0e+5, 1.0, nitref=0)
    @test allocations == 0

    allocations = @allocated Krylov.roots_quadratic(-1.0e-8, 1.0e+5, 1.0, nitref=1)
    @test allocations == 0

    allocations = @allocated Krylov.roots_quadratic(-1.0e-7, 1.0, 1.0, nitref=0)
    @test allocations == 0

    allocations = @allocated Krylov.roots_quadratic(-1.0e-7, 1.0, 1.0, nitref=1)
    @test allocations == 0
  end

  @testset "to_boundary" begin
    # test trust-region boundary
    n = 5
    x = ones(n)
    d = ones(n); d[1:2:n] .= -1
    z = similar(d) # <-- placeholder for preconditioning storage
    @test_throws ErrorException Krylov.to_boundary(n, x, d, z, -1.0)
    @test_throws ErrorException Krylov.to_boundary(n, x, d, z, 0.5)
    @test_throws ErrorException Krylov.to_boundary(n, x, zeros(n), z, 1.0)
    @test maximum(Krylov.to_boundary(n, x, d, z, 5.0)) ≈ 2.209975124224178
    @test minimum(Krylov.to_boundary(n, x, d, z, 5.0)) ≈ -1.8099751242241782
    @test maximum(Krylov.to_boundary(n, x, d, z, 5.0, flip=true)) ≈ 1.8099751242241782
    @test minimum(Krylov.to_boundary(n, x, d, z, 5.0, flip=true)) ≈ -2.209975124224178
  end

  @testset "ktypeof" begin
    # test ktypeof
    for FC in (Float32, Float64, ComplexF32, ComplexF64)
      dv = rand(FC, 10)
      b = view(dv, 4:8)
      @test Krylov.ktypeof(dv) == Vector{FC}
      @test Krylov.ktypeof(b)  == Vector{FC}

      dm = rand(FC, 10, 10)
      b = view(dm, :, 3)
      @test Krylov.ktypeof(b) == Vector{FC}

      sv = sprand(FC, 10, 0.5)
      b = view(sv, 4:8)
      @test Krylov.ktypeof(sv) == Vector{FC}
      @test Krylov.ktypeof(b)  == Vector{FC}
    end
  end

  @testset "vector_to_matrix" begin
    # test vector_to_matrix
    for FC in (Float32, Float64, ComplexF32, ComplexF64)
      S = Vector{FC}
      M = Krylov.vector_to_matrix(S)
      @test M == Matrix{FC}
    end
  end

  @testset "matrix_to_vector" begin
    # test matrix_to_vector
    for FC in (Float32, Float64, ComplexF32, ComplexF64)
      M = Matrix{FC}
      S = Krylov.matrix_to_vector(M)
      @test S == Vector{FC}
    end
  end

  @testset "macros" begin
    # test macros
    for FC ∈ (Float16, Float32, Float64, ComplexF16, ComplexF32, ComplexF64)
      n = 10
      x = rand(FC, n)
      y = rand(FC, n)
      a = rand(FC)
      b = rand(FC)
      c = rand(FC)
      s = rand(FC)

      T = real(FC)
      a2 = rand(T)
      b2 = rand(T)

      Krylov.kdot(n, x, y)

      Krylov.kdotr(n, x, y)

      Krylov.knorm(n, x)

      Krylov.kaxpy!(n, a, x, y)
      Krylov.kaxpy!(n, a2, x, y)

      Krylov.kaxpby!(n, a, x, b, y)
      Krylov.kaxpby!(n, a2, x, b, y)
      Krylov.kaxpby!(n, a, x, b2, y)
      Krylov.kaxpby!(n, a2, x, b2, y)

      Krylov.kcopy!(n, y, x)

      Krylov.kfill!(x, a)

      Krylov.@kswap!(x, y)

      Krylov.kref!(n, x, y, c, s)
    end
  end

  @testset "reduced QR (larfg! / geqrf! / orgqr! / ormqr!)" begin
    @testset "accuracy $FC" for FC in (Float32, Float64, ComplexF32, ComplexF64, Complex{BigFloat}, BigFloat)
      T = real(FC)
      tol = 100 * eps(T)
      for (m, k) in ((10, 4), (6, 6))
        A = rand(FC, m, k)

        # larfg!: Hᴴ [α; x] = [β; 0] with v = [1; tail]  (LAPACK convention)
        α = A[1,1]
        x = A[2:m, 1]
        xold = copy(x)
        β, τ = Krylov.larfg!(α, x)
        v = vcat(one(FC), x)
        u = vcat(α, xold)
        Hᴴu = u - conj(τ) * v * (v' * u)
        @test abs(β) ≈ norm(u) atol=tol
        @test Hᴴu[1] ≈ β atol=tol
        @test norm(Hᴴu[2:end]) ≤ tol

        # geqrf! + orgqr!: reduced QR factorization
        QR = copy(A)
        tau = zeros(FC, k)
        Krylov.geqr2!(QR, tau)
        R = triu(QR[1:k, 1:k])
        Krylov.ung2r!(QR, tau)
        Q = QR[:, 1:k]
        @test istriu(R)
        @test norm(Q' * Q - I) ≤ tol
        @test norm(Q * R - A) ≤ tol * norm(A)

        Aref = copy(A)
        tauref = zeros(FC, k)
        Krylov.geqr2!(Aref, tauref)
        Qfull = zeros(FC, m, m)
        Qfull[:, 1:k] .= Aref
        Krylov.ung2r!(Qfull, tauref)
        nc = 5
        for trans in (FC <: Complex ? ('N', 'C') : ('N', 'T', 'C'))
          op = trans == 'N' ? Qfull : Qfull'
          C = rand(FC, m, nc)
          @test norm(Krylov.unm2r!('L', trans, copy(Aref), tauref, copy(C)) - op * C) ≤ tol
          D = rand(FC, nc, m)
          @test norm(Krylov.unm2r!('R', trans, copy(Aref), tauref, copy(D)) - D * op) ≤ tol
        end
      end
    end

    @testset "matches LAPACK $FC" for FC in (Float32, Float64, ComplexF32, ComplexF64)
      m, k = 9, 4
      A = rand(FC, m, k)
      Qg = copy(A); tg = zeros(FC, k); Krylov.geqr2!(Qg, tg);  Krylov.ung2r!(Qg, tg)   # pure Julia
      Ql = copy(A); tl = zeros(FC, k); Krylov.kgeqrf!(Ql, tl); Krylov.kungqr!(Ql, tl)  # LAPACK
      # Q is defined up to a phase, so compare the (phase-invariant) projectors
      @test Qg[:, 1:k] * Qg[:, 1:k]' ≈ Ql[:, 1:k] * Ql[:, 1:k]'
    end

    @testset "no allocations $FC" for FC in (Float16, ComplexF16)
      m, k, nc = 12, 4, 5

      A = rand(FC, m, k); tau = zeros(FC, k)
      Krylov.geqr2!(copy(A), copy(tau))
      Ag = copy(A)
      taug = copy(tau)
      @test (@allocated Krylov.geqr2!(Ag, taug)) == 0

      Af = copy(A)
      tf = zeros(FC, k)
      Krylov.geqr2!(Af, tf)
      Krylov.ung2r!(copy(Af), tf)
      Ao = copy(Af)
      @test (@allocated Krylov.ung2r!(Ao, tf)) == 0

      CL = rand(FC, m, nc)   # left operand
      CR = rand(FC, nc, m)   # right operand
      Krylov.unm2r!('L', 'N', Af, tf, copy(CL))
      for trans in (FC <: Complex ? ('N', 'C') : ('N', 'T', 'C'))
        DL = copy(CL)
        @test (@allocated Krylov.unm2r!('L', trans, Af, tf, DL)) == 0
        DR = copy(CR)
        @test (@allocated Krylov.unm2r!('R', trans, Af, tf, DR)) == 0
      end

      if VERSION ≥ v"1.12"
        α = rand(FC); x = rand(FC, m-1)
        Krylov.larfg!(α, copy(x))
        xl = copy(x)
        @test (@allocated Krylov.larfg!(α, xl)) == 0
      end
    end
  end
end

# Enumerators for the LibKrylov C interface.
# Must match the values declared in krylov.h.
#
# GC roots are now managed by the typed store dicts in c_stores.jl.

# ---------------------------------------------------------------------------
# KrylovDataType  (must match krylov.h)
# ---------------------------------------------------------------------------
# KRYLOV_FLOAT32    = 0
# KRYLOV_FLOAT64    = 1
# KRYLOV_COMPLEX32  = 2
# KRYLOV_COMPLEX64  = 3

# ---------------------------------------------------------------------------
# KrylovDeviceType  (must match krylov.h)
# ---------------------------------------------------------------------------
# KRYLOV_CPU = 0   (only supported device for now)

# ---------------------------------------------------------------------------
# KrylovSolverType  (must match krylov.h, generated by generate_stores.jl)
# ---------------------------------------------------------------------------
# KRYLOV_CG = 0, KRYLOV_CR = 1, ..., KRYLOV_MINARES = 33

# ---------------------------------------------------------------------------
# KrylovWorkspaceOptionsC — Julia mirror of the KrylovWorkspaceOptions C struct.
#
# These are *construction-time* parameters, consumed by krylov_workspace_create
# (the workspace is allocated there).  Sentinel 0 means "use solver default".
# ---------------------------------------------------------------------------
struct KrylovWorkspaceOptionsC
    memory :: Cint   # 0 → 20 (GMRES / FGMRES / FOM / DIOM / DQGMRES / GPMR)
    window :: Cint   # 0 → 5  (MINRES / SYMMLQ / LSQR / LSMR / LSLQ)
end

# ---------------------------------------------------------------------------
# KrylovOptionsC — Julia mirror of the KrylovOptions C struct (must match krylov.h).
#
# These are *solve-time* parameters, consumed by krylov_solve.
# Sentinel values mean "use solver default":
#   NaN  for double fields  (atol, rtol, tau, nu, timemax)
#   0    for int fields     (itmax, restart, reorthogonalization, linesearch)
#   0.0  for lambda/radius  (0 = off, which IS the default)
#
# Fields after `nu` were added later; they sit at the end so the struct stays
# source-compatible (initialise with krylov_default_options and override).
# Each field is honoured only by the solvers that accept it (gated in
# c_stores.jl) and silently ignored by the rest.
# ---------------------------------------------------------------------------
struct KrylovOptionsC
    atol               :: Cdouble   # NaN  → √eps(T) per precision
    rtol               :: Cdouble   # NaN  → √eps(T) per precision
    itmax              :: Cint      # 0    → solver default
    verbose            :: Cint      # 0    = silent
    lambda             :: Cdouble   # 0.0  = no regularisation (LSQR / LSMR / CGLS / …)
    tau                :: Cdouble   # NaN  → solver default (TriCG / TriMR : 1.0)
    nu                 :: Cdouble   # NaN  → solver default (TriCG / TriMR : −1.0)
    timemax            :: Cdouble   # NaN  → Inf (no time limit), in seconds; every solver
    radius             :: Cdouble   # 0.0  = no trust-region constraint (CG / CR / CGLS / CRLS / LSQR / LSMR)
    restart            :: Cint      # 0/1  restart GMRES(k) / FGMRES / FOM / block_gmres (uses `memory`)
    reorthogonalization :: Cint     # 0/1  reorthogonalize the Krylov basis (GMRES family, GPMR, block_gmres)
    linesearch         :: Cint      # 0/1  detect negative curvature (CG / CR / MINRES / MINRES-QLP)
end

# An implementation of the Lanczos version of the conjugate gradient method
# for a family of shifted systems of the form (A + αI) x = b.
#
# The implementation follows
# A. Frommer and P. Maass, Fast CG-Based Methods for Tikhonov-Phillips Regularization,
# SIAM Journal on Scientific Computing, 20(5), pp. 1831--1850, 1999.
#
# C. C. Paige and M. A. Saunders, Solution of Sparse Indefinite Systems of Linear Equations,
# SIAM Journal on Numerical Analysis, 12(4), pp. 617--629, 1975.
#
# Dominique Orban, <dominique.orban@gerad.ca>
# Princeton, NJ, March 2015.

export cg_lanczos_shift, cg_lanczos_shift!

"""
    (x, stats) = cg_lanczos_shift(A, b::AbstractVector{FC}, shifts::AbstractVector{T};
                                  M=I, ldiv::Bool=false,
                                  check_curvature::Bool=false, atol::T=√eps(T),
                                  rtol::T=√eps(T), itmax::Int=0,
                                  timemax::Float64=Inf, verbose::Int=0,
                                  history::Bool=false, callback=workspace->false,
                                  iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

The Lanczos version of the conjugate gradient method to solve a family
of shifted systems

    (A + αI) x = b  (α = α₁, ..., αₚ)

of size n. The method does _not_ abort if A + αI is not definite.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :cg_lanczos_shift`.

For an in-place variant that reuses memory across solves, see [`cg_lanczos_shift!`](@ref).

#### Input arguments

* `A`: a linear operator that models a Hermitian matrix of dimension `n`;
* `b`: a vector of length `n`;
* `shifts`: a vector of length `p`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning;
* `ldiv`: define whether the preconditioner uses `ldiv!` or `mul!`;
* `check_curvature`: if `true`, check that the curvature of the quadratic along the search direction is positive, and abort if not;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a vector of `p` dense vectors, each one of length `n`;
* `stats`: statistics collected on the run in a [`LanczosShiftStats`](@ref) structure.

#### References

* A. Frommer and P. Maass, [*Fast CG-Based Methods for Tikhonov-Phillips Regularization*](https://doi.org/10.1137/S1064827596313310), SIAM Journal on Scientific Computing, 20(5), pp. 1831--1850, 1999.
* C. C. Paige and M. A. Saunders, [*Solution of Sparse Indefinite Systems of Linear Equations*](https://doi.org/10.1137/0712047), SIAM Journal on Numerical Analysis, 12(4), pp. 617--629, 1975.
"""
function cg_lanczos_shift end

"""
    workspace = cg_lanczos_shift!(workspace::CgLanczosShiftWorkspace, A, b, shifts; kwargs...)

In this call, `kwargs` are keyword arguments of [`cg_lanczos_shift`](@ref).

See [`CgLanczosShiftWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :cg_lanczos_shift` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function cg_lanczos_shift! end

def_args_cg_lanczos_shift = (:(A                        ),
                             :(b::AbstractVector{FC}    ),
                             :(shifts::AbstractVector{T}))

def_kwargs_cg_lanczos_shift = (:(; M = I                        ),
                               :(; ldiv::Bool = false           ),
                               :(; check_curvature::Bool = false),
                               :(; atol::T = √eps(T)            ),
                               :(; rtol::T = √eps(T)            ),
                               :(; itmax::Int = 0               ),
                               :(; timemax::Float64 = Inf       ),
                               :(; verbose::Int = 0             ),
                               :(; history::Bool = false        ),
                               :(; callback = workspace -> false),
                               :(; iostream::IO = kstdout       ))

def_kwargs_cg_lanczos_shift = extract_parameters.(def_kwargs_cg_lanczos_shift)

args_cg_lanczos_shift = (:A, :b, :shifts)
kwargs_cg_lanczos_shift = (:M, :ldiv, :check_curvature, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function cg_lanczos_shift!(workspace :: CgLanczosShiftWorkspace{T,FC,S}, $(def_args_cg_lanczos_shift...); $(def_kwargs_cg_lanczos_shift...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("System must be square")
    length(b) == n || error("Inconsistent problem size")

    nshifts = length(shifts)
    nshifts == workspace.nshifts || error("workspace.nshifts = $(workspace.nshifts) is inconsistent with length(shifts) = $nshifts")
    (verbose > 0) && @printf(iostream, "CG-LANCZOS-SHIFT: system of %d equations in %d variables with %d shifts\n", n, n, nshifts)

    # Tests M = Iₙ
    MisI = (M === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")

    # Set up workspace.
    allocate_if(!MisI, workspace, :v, S, workspace.Mv)  # The length of v is n
    Mv, Mv_prev, Mv_next = workspace.Mv, workspace.Mv_prev, workspace.Mv_next
    x, p, σ, δhat = workspace.x, workspace.p, workspace.σ, workspace.δhat
    ω, γ, rNorms, converged = workspace.ω, workspace.γ, workspace.rNorms, workspace.converged
    not_cv, stats = workspace.not_cv, workspace.stats
    rNorms_history, indefinite = stats.residuals, stats.indefinite
    reset!(stats)
    v = MisI ? Mv : workspace.v

    # Initial state.
    ## Distribute x similarly to shifts.
    for i = 1 : nshifts
      kfill!(x[i], zero(FC))  # x₀
    end
    kcopy!(n, Mv, b)                    # Mv₁ ← b
    MisI || mulorldiv!(v, M, Mv, ldiv)  # v₁ = M⁻¹ * Mv₁
    β = knorm_elliptic(n, v, Mv)        # β₁ = v₁ᴴ M v₁
    kfill!(rNorms, β)
    if history
      for i = 1 : nshifts
        push!(rNorms_history[i], rNorms[i])
      end
    end

    # Keep track of shifted systems with negative curvature if required.
    # We don't want to use kfill! here because "indefinite" is a BitVector.
    fill!(indefinite, false)

    if β == 0
      stats.niter = 0
      stats.solved = true
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      return workspace
    end

    # Initialize each p to v.
    for i = 1 : nshifts
      kcopy!(n, p[i], v)  # pᵢ ← v
    end

    # Initialize Lanczos process.
    # β₁Mv₁ = b
    kdiv!(n, v, β)           # v₁  ←  v₁ / β₁
    MisI || kdiv!(n, Mv, β)  # Mv₁ ← Mv₁ / β₁
    kcopy!(n, Mv_prev, Mv)   # Mv_prev ← Mv

    # Initialize some constants used in recursions below.
    ρ = one(T)
    kfill!(σ, β)
    kfill!(δhat, zero(T))
    kfill!(ω, zero(T))
    kfill!(γ, one(T))

    # Define stopping tolerance.
    ε = atol + rtol * β

    # Keep track of shifted systems that have converged.
    for i = 1 : nshifts
      converged[i] = rNorms[i] ≤ ε
      not_cv[i] = !converged[i]
    end
    iter = 0
    itmax == 0 && (itmax = 2 * n)

    # Build format strings for printing.
    (verbose > 0) && (fmt = Printf.Format("%5d" * repeat("  %8.1e", nshifts) * "  %.2fs\n"))
    kdisplay(iter, verbose) && Printf.format(iostream, fmt, iter, rNorms..., start_time |> ktimer)

    solved = !reduce(|, not_cv)
    tired = iter ≥ itmax
    status = "unknown"
    user_requested_exit = false
    overtimed = false

    # Main loop.
    while ! (solved || tired || user_requested_exit || overtimed)
      # Form next Lanczos vector.
      # βₖ₊₁Mvₖ₊₁ = Avₖ - δₖMvₖ - βₖMvₖ₋₁
      kmul!(Mv_next, A, v)                # Mvₖ₊₁ ← Avₖ
      δ = kdotr(n, v, Mv_next)            # δₖ = vₖᴴ A vₖ
      kaxpy!(n, -δ, Mv, Mv_next)          # Mvₖ₊₁ ← Mvₖ₊₁ - δₖMvₖ
      if iter > 0
        kaxpy!(n, -β, Mv_prev, Mv_next)   # Mvₖ₊₁ ← Mvₖ₊₁ - βₖMvₖ₋₁
        kcopy!(n, Mv_prev, Mv)            # Mvₖ₋₁ ← Mvₖ
      end
      kcopy!(n, Mv, Mv_next)              # Mvₖ ← Mvₖ₊₁
      MisI || mulorldiv!(v, M, Mv, ldiv)  # vₖ₊₁ = M⁻¹ * Mvₖ₊₁
      β = knorm_elliptic(n, v, Mv)        # βₖ₊₁ = vₖ₊₁ᴴ M vₖ₊₁
      kdiv!(n, v, β)                      # vₖ₊₁  ←  vₖ₊₁ / βₖ₊₁
      MisI || kdiv!(n, Mv, β)             # Mvₖ₊₁ ← Mvₖ₊₁ / βₖ₊₁

      # Check curvature: vₖᴴ(A + sᵢI)vₖ = vₖᴴAvₖ + sᵢ‖vₖ‖² = δₖ + ρₖ * sᵢ with ρₖ = ‖vₖ‖².
      # It is possible to show that σₖ² (δₖ + ρₖ * sᵢ - ωₖ₋₁ / γₖ₋₁) = pₖᴴ (A + sᵢ I) pₖ.
      MisI || (ρ = kdotr(n, v, v))
      for i = 1 : nshifts
        δhat[i] = δ + ρ * shifts[i]
        γ[i] = inv(δhat[i] - ω[i] / γ[i])
      end
      for i = 1 : nshifts
        indefinite[i] |= γ[i] ≤ 0
      end

      # Compute next CG iterate for each shifted system that has not yet converged.
      # Stop iterating on indefinite problems if requested.
      for i = 1 : nshifts
        not_cv[i] = check_curvature ? !(converged[i] || indefinite[i]) : !converged[i]
        if not_cv[i]
          kaxpy!(n, γ[i], p[i], x[i])
          ω[i] = β * γ[i]
          σ[i] *= -ω[i]
          ω[i] *= ω[i]
          kaxpby!(n, σ[i], v, ω[i], p[i])

          # Update list of systems that have not converged.
          rNorms[i] = abs(σ[i])
          converged[i] = rNorms[i] ≤ ε
        end
      end

      if length(not_cv) > 0 && history
        for i = 1 : nshifts
          not_cv[i] && push!(rNorms_history[i], rNorms[i])
        end
      end

      # Is there a better way than to update this array twice per iteration?
      for i = 1 : nshifts
        not_cv[i] = check_curvature ? !(converged[i] || indefinite[i]) : !converged[i]
      end
      iter = iter + 1
      kdisplay(iter, verbose) && Printf.format(iostream, fmt, iter, rNorms..., start_time |> ktimer)

      user_requested_exit = callback(workspace) :: Bool
      solved = !reduce(|, not_cv)
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    solved              && (status = "solution good enough given atol and rtol")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update stats. TODO: Estimate Anorm and Acond.
    stats.niter = iter
    stats.solved = solved
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

# An implementation of DIOM for the solution of the square linear system Ax = b.
#
# This method is described in
#
# Y. Saad, Practical use of some krylov subspace methods for solving indefinite and nonsymmetric linear systems.
# SIAM journal on scientific and statistical computing, 5(1), pp. 203--228, 1984.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Montreal, September 2018.

export diom, diom!

"""
    (x, stats) = diom(A, b::AbstractVector{FC};
                      memory::Int=20, M=I, N=I, ldiv::Bool=false,
                      reorthogonalization::Bool=false, atol::T=√eps(T),
                      rtol::T=√eps(T), itmax::Int=0,
                      timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                      callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = diom(A, b, x0::AbstractVector; kwargs...)

DIOM can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above.

Solve the consistent linear system Ax = b of size n using DIOM.

DIOM only orthogonalizes the new vectors of the Krylov basis against the `memory` most recent vectors.
If CG is well defined on `Ax = b` and `memory = 2`, DIOM is theoretically equivalent to CG.
If `k ≤ memory` where `k` is the number of iterations, DIOM is theoretically equivalent to FOM.
Otherwise, DIOM interpolates between CG and FOM and is similar to CG with partial reorthogonalization.

An advantage of DIOM is that non-Hermitian or Hermitian indefinite or both non-Hermitian
and indefinite systems of linear equations can be handled by this single algorithm.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :diom`.

For an in-place variant that reuses memory across solves, see [`diom!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `n`;
* `b`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `memory`: the number of most recent vectors of the Krylov basis against which to orthogonalize a new vector;
* `M`: linear operator that models a nonsingular matrix of size `n` used for left preconditioning;
* `N`: linear operator that models a nonsingular matrix of size `n` used for right preconditioning;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `reorthogonalization`: reorthogonalize the new vectors of the Krylov basis against the `memory` most recent vectors;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### Reference

* Y. Saad, [*Practical use of some krylov subspace methods for solving indefinite and nonsymmetric linear systems*](https://doi.org/10.1137/0905015), SIAM journal on scientific and statistical computing, 5(1), pp. 203--228, 1984.
"""
function diom end

"""
    workspace = diom!(workspace::DiomWorkspace, A, b; kwargs...)
    workspace = diom!(workspace::DiomWorkspace, A, b, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`diom`](@ref).
The keyword argument `memory` is the only exception.
It is only supported by `diom` and is required to create a `DiomWorkspace`.
It cannot be changed later.

See [`DiomWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :diom` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function diom! end

def_args_diom = (:(A                    ),
                 :(b::AbstractVector{FC}))

def_optargs_diom = (:(x0::AbstractVector),)

def_kwargs_diom = (:(; M = I                            ),
                   :(; N = I                            ),
                   :(; ldiv::Bool = false               ),
                   :(; reorthogonalization::Bool = false),
                   :(; atol::T = √eps(T)                ),
                   :(; rtol::T = √eps(T)                ),
                   :(; itmax::Int = 0                   ),
                   :(; timemax::Float64 = Inf           ),
                   :(; verbose::Int = 0                 ),
                   :(; history::Bool = false            ),
                   :(; callback = workspace -> false    ),
                   :(; iostream::IO = kstdout           ))

def_kwargs_workspace_diom = (:(; memory::Int = 20),)

def_kwargs_diom = extract_parameters.(def_kwargs_diom)
def_kwargs_workspace_diom = extract_parameters.(def_kwargs_workspace_diom)

args_diom = (:A, :b)
optargs_diom = (:x0,)
kwargs_diom = (:M, :N, :ldiv, :reorthogonalization, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)
kwargs_workspace_diom = (:memory,)

@eval begin
  function diom!(workspace :: DiomWorkspace{T,FC,S}, $(def_args_diom...); $(def_kwargs_diom...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("System must be square")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "DIOM: system of size %d\n", n)

    # Check M = Iₙ and N = Iₙ
    MisI = (M === I)
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")

    # Set up workspace.
    allocate_if(!MisI, workspace, :w, S, workspace.x)  # The length of w is n
    allocate_if(!NisI, workspace, :z, S, workspace.x)  # The length of z is n
    Δx, x, t, P, V = workspace.Δx, workspace.x, workspace.t, workspace.P, workspace.V
    L, H, stats = workspace.L, workspace.H, workspace.stats
    warm_start = workspace.warm_start
    rNorms = stats.residuals
    reset!(stats)
    w  = MisI ? t : workspace.w
    r₀ = MisI ? t : workspace.w

    # Initial solution x₀ and residual r₀.
    kfill!(x, zero(FC))  # x₀
    if warm_start
      kmul!(t, A, Δx)
      kaxpby!(n, one(FC), b, -one(FC), t)
    else
      kcopy!(n, t, b)  # t ← b
    end
    MisI || mulorldiv!(r₀, M, t, ldiv)  # M(b - Ax₀)
    rNorm = knorm(n, r₀)                # β = ‖r₀‖₂
    history && push!(rNorms, rNorm)
    if rNorm == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    iter = 0
    itmax == 0 && (itmax = 2*n)

    ε = atol + rtol * rNorm
    (verbose > 0) && @printf(iostream, "%5s  %7s  %5s\n", "k", "‖rₖ‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %.2fs\n", iter, rNorm, start_time |> ktimer)

    mem = length(V)  # Memory
    for i = 1 : mem
      kfill!(V[i], zero(FC))  # Orthogonal basis of Kₖ(MAN, Mr₀).
    end
    for i = 1 : mem-1
      kfill!(P[i], zero(FC))  # Directions Pₖ = NVₖ(Uₖ)⁻¹.
    end
    kfill!(H, zero(FC))  # Last column of the band hessenberg matrix Hₖ = LₖUₖ.
    # Each column has at most mem + 1 nonzero elements.
    # hᵢ.ₖ is stored as H[k-i+1], i ≤ k. hₖ₊₁.ₖ is not stored in H.
    # k-i+1 represents the index of the diagonal where hᵢ.ₖ is located.
    # In addition of that, the last column of Uₖ is stored in H.
    kfill!(L, zero(FC))  # Last mem-1 pivots of Lₖ.

    # Initial ξ₁ and v₁.
    ξ = rNorm
    kdivcopy!(n, V[1], r₀, rNorm)  # v₁ = r₀ / ‖r₀‖

    # Stopping criterion.
    solved = rNorm ≤ ε
    tired = iter ≥ itmax
    status = "unknown"
    user_requested_exit = false
    overtimed = false

    while !(solved || tired || user_requested_exit || overtimed)

      # Update iteration index.
      iter = iter + 1

      # Set position in circulars stacks.
      pos = mod(iter-1, mem) + 1     # Position corresponding to vₖ in the circular stack V.
      next_pos = mod(iter, mem) + 1  # Position corresponding to vₖ₊₁ in the circular stack V.

      # Incomplete Arnoldi procedure.
      z = NisI ? V[pos] : workspace.z
      NisI || mulorldiv!(z, N, V[pos], ldiv)  # Nvₖ, forms pₖ
      kmul!(t, A, z)                          # ANvₖ
      MisI || mulorldiv!(w, M, t, ldiv)       # MANvₖ, forms vₖ₊₁
      for i = max(1, iter-mem+1) : iter
        ipos = mod(i-1, mem) + 1  # Position corresponding to vᵢ in the circular stack V.
        diag = iter - i + 1
        H[diag] = kdot(n, w, V[ipos])    # hᵢ.ₖ = ⟨MANvₖ, vᵢ⟩
        kaxpy!(n, -H[diag], V[ipos], w)  # w ← w - hᵢ.ₖvᵢ
      end

      # Partial reorthogonalization of the Krylov basis.
      if reorthogonalization
        for i = max(1, iter-mem+1) : iter
          ipos = mod(i-1, mem) + 1
          diag = iter - i + 1
          Htmp = kdot(n, w, V[ipos])
          H[diag] += Htmp
          kaxpy!(n, -Htmp, V[ipos], w)
        end
      end

      # Compute hₖ₊₁.ₖ and vₖ₊₁.
      Haux = knorm(n, w)  # hₖ₊₁.ₖ = ‖vₖ₊₁‖₂
      if Haux ≠ 0   # hₖ₊₁.ₖ = 0 ⇒ "lucky breakdown"
        kdivcopy!(n, V[next_pos], w, Haux)  # vₖ₊₁ = w / hₖ₊₁.ₖ
      end

      # Update the LU factorization of Hₖ.
      # Compute the last column of Uₖ.
      if iter ≥ 2
        # u₁.ₖ ← h₁.ₖ             if iter ≤ mem
        # uₖ₋ₘₑₘ₊₁.ₖ ← hₖ₋ₘₑₘ₊₁.ₖ if iter ≥ mem + 1
        for i = max(2,iter-mem+2) : iter
          lpos = mod(i-1, mem-1) + 1  # Position corresponding to lᵢ.ᵢ₋₁ in the circular stack L.
          diag = iter - i + 1
          next_diag = diag + 1
          # uᵢ.ₖ ← hᵢ.ₖ - lᵢ.ᵢ₋₁ * uᵢ₋₁.ₖ
          H[diag] = H[diag] - L[lpos] * H[next_diag]
          if i == iter
            # Compute ξₖ the last component of zₖ = β(Lₖ)⁻¹e₁.
            # ξₖ = -lₖ.ₖ₋₁ * ξₖ₋₁
            ξ = - L[lpos] * ξ
          end
        end
      end
      # Compute next pivot lₖ₊₁.ₖ = hₖ₊₁.ₖ / uₖ.ₖ
      next_lpos = mod(iter, mem-1) + 1
      L[next_lpos] = Haux / H[1]

      ppos = mod(iter-1, mem-1) + 1 # Position corresponding to pₖ in the circular stack P.

      # Compute the direction pₖ, the last column of Pₖ = NVₖ(Uₖ)⁻¹.
      # u₁.ₖp₁ + ... + uₖ.ₖpₖ = Nvₖ             if k ≤ mem
      # uₖ₋ₘₑₘ₊₁.ₖpₖ₋ₘₑₘ₊₁ + ... + uₖ.ₖpₖ = Nvₖ if k ≥ mem + 1
      for i = max(1,iter-mem+1) : iter-1
        ipos = mod(i-1, mem-1) + 1  # Position corresponding to pᵢ in the circular stack P.
        diag = iter - i + 1
        if ipos == ppos
          # pₖ ← -uₖ₋ₘₑₘ₊₁.ₖ * pₖ₋ₘₑₘ₊₁
          kscal!(n, -H[diag], P[ppos])
        else
          # pₖ ← pₖ - uᵢ.ₖ * pᵢ
          kaxpy!(n, -H[diag], P[ipos], P[ppos])
        end
      end
      # pₐᵤₓ ← pₐᵤₓ + Nvₖ
      kaxpy!(n, one(FC), z, P[ppos])
      # pₖ = pₐᵤₓ / uₖ.ₖ
      kdiv!(n, P[ppos], H[1])

      # Update solution xₖ.
      # xₖ = xₖ₋₁ + ξₖ * pₖ
      kaxpy!(n, ξ, P[ppos], x)

      # Compute residual norm.
      # ‖ M(b - Axₖ) ‖₂ = hₖ₊₁.ₖ * |ξₖ / uₖ.ₖ|
      rNorm = Haux * abs(ξ / H[1])
      history && push!(rNorms, rNorm)

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      resid_decrease_mach = (rNorm + one(T) ≤ one(T))

      # Update stopping criterion.
      user_requested_exit = callback(workspace) :: Bool
      resid_decrease_lim = rNorm ≤ ε
      solved = resid_decrease_lim || resid_decrease_mach
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %.2fs\n", iter, rNorm, start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    solved              && (status = "solution good enough given atol and rtol")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update x
    warm_start && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = false
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

! block_gmres.f90 — solve A X = B with several right-hand sides at once.
!
! A = tridiag(-1, 8, -1) (SPD),  B = A * X_true  with independent columns.
! Blocks are natural Fortran 2D arrays (column-major).  Switch
! KRYLOV_BLOCK_GMRES to KRYLOV_BLOCK_MINRES below to use block MINRES.
!
! Compile (after building libkrylov):
!   gfortran -o block_gmres interfaces/examples/Fortran/block_gmres.f90 \
!       interfaces/build/lib/libkrylov.so
!
! Expected output:
!   Block solved: T   niter: ...   max error: ...

program block_gmres
  use iso_c_binding
  implicit none
  include '../../include/krylov.f90'

  integer, parameter :: n = 16    ! operator dimension
  integer, parameter :: p = 3     ! number of right-hand sides (block width)

  real(c_double), target :: Xtrue(n,p), B(n,p), X(n,p)
  type(KrylovOptions), target :: opts
  type(c_ptr)    :: ws
  integer(c_int) :: ret
  integer        :: i, j
  real(c_double) :: t

  ! X_true with independent columns, then B = A * X_true.
  do j = 1, p
    do i = 1, n
      t = real(i, c_double) / n
      if (j == 1) then
        Xtrue(i,j) = 1.0_c_double
      else if (j == 2) then
        Xtrue(i,j) = t
      else
        Xtrue(i,j) = t*t
      end if
    end do
  end do
  call apply_A(Xtrue, B, p)

  ! Create a block workspace, solve, retrieve the n x p solution block.
  ret = krylov_block_workspace_create(KRYLOV_BLOCK_GMRES, n, n, p,        &
                                      KRYLOV_FLOAT64, KRYLOV_CPU,          &
                                      c_null_ptr, ws)

  opts = krylov_default_options()
  opts%atol = 1.0d-10 ; opts%rtol = 1.0d-10
  ret = krylov_block_solve(ws, c_funloc(cb_block_A), c_null_funptr,       &
                           c_null_funptr, c_loc(B), c_null_ptr, c_loc(opts))
  ret = krylov_block_get_X(ws, c_loc(X), int(n, c_int), int(p, c_int))

  write(*,'(A,L1,A,I0,A,ES8.1)')                                          &
    "Block solved: ", (krylov_block_is_solved(ws) == 1),                  &
    "   niter: ", krylov_block_niter(ws),                                 &
    "   max error: ", maxval(abs(X - Xtrue))

  ret = krylov_block_workspace_free(ws)

contains

  ! Y = A * X for a p-column block, A = tridiag(-1, 8, -1).
  subroutine apply_A(Xin, Yout, pp)
    integer, intent(in)         :: pp
    real(c_double), intent(in)  :: Xin(:,:)
    real(c_double), intent(out) :: Yout(:,:)
    integer :: ii, jj
    do jj = 1, pp
      do ii = 1, n
        Yout(ii,jj) = 8.0_c_double * Xin(ii,jj)
        if (ii > 1) Yout(ii,jj) = Yout(ii,jj) - Xin(ii-1,jj)
        if (ii < n) Yout(ii,jj) = Yout(ii,jj) - Xin(ii+1,jj)
      end do
    end do
  end subroutine apply_A

  ! Block matvec callback: Y = A*X for a block of p columns.
  subroutine cb_block_A(x_ptr, y_ptr, pblk, userdata) bind(c)
    type(c_ptr),    value :: x_ptr, y_ptr, userdata
    integer(c_int), value :: pblk
    real(c_double), pointer :: xx(:,:), yy(:,:)
    call c_f_pointer(x_ptr, xx, [n, int(pblk)])
    call c_f_pointer(y_ptr, yy, [n, int(pblk)])
    call apply_A(xx, yy, int(pblk))
  end subroutine cb_block_A

end program block_gmres

@testset "minares" begin
  minares_tol = 1.0e-6

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      # Cubic spline matrix.
      A, b = symmetric_definite(FC=FC)
      (x, stats) = minares(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ minares_tol * norm(A) * norm(x))
      @test(stats.solved)

      # Symmetric indefinite variant.
      A, b = symmetric_indefinite(FC=FC)
      (x, stats) = minares(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ minares_tol * norm(A) * norm(x))
      @test(stats.solved)

      # Sparse Laplacian.
      A, b = sparse_laplacian(FC=FC)
      (x, stats) = minares(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ minares_tol * norm(A) * norm(x))
      @test(stats.solved)

      # Symmetric indefinite variant, almost singular.
      A, b = almost_singular(FC=FC)
      (x, stats) = minares(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ minares_tol * norm(A) * norm(x))
      @test(stats.solved)

      # Test b == 0
      A, b = zero_rhs(FC=FC)
      (x, stats) = minares(A, b)
      @test norm(x) == 0
      @test stats.status == "x is a zero-residual solution"

      # Singular inconsistent system
      A, b = square_inconsistent(FC=FC)
      (x, stats) = minares(A, b)
      r = b - A * x
      Aresid = norm(A*r) / norm(A*b)
      @test(Aresid ≤ minares_tol)
      # @test stats.inconsistent

      # Symmetric inconsistent system
      A, b = symmetric_inconsistent()
      (x, stats) = minares(A, b)
      r = b - A * x
      Aresid = norm(A*r) / norm(A*b)
      @test(Aresid ≤ minares_tol)
      # @test stats.inconsistent

      # Shifted system
      A, b = symmetric_indefinite(FC=FC)
      λ = 2.0
      (x, stats) = minares(A, b, λ=λ)
      r = b - (A + λ*I) * x
      resid = norm(r) / norm(b)
      @test(resid ≤ minares_tol * norm(A) * norm(x))
      @test(stats.solved)

      # Test with Jacobi (or diagonal) preconditioner
      # A, b, M = square_preconditioned(FC=FC)
      # (x, stats) = minares(A, b, M=M)
      # r = b - A * x
      # resid = sqrt(real(dot(r, M * r))) / sqrt(real(dot(b, M * b)))
      # @test(resid ≤ minares_tol * norm(A) * norm(x))
      # @test(stats.solved)

      # test callback function
      A, b = sparse_laplacian(FC=FC)
      workspace = MinaresWorkspace(A, b)
      tol = 1.0
      cb_n2 = TestCallbackN2(A, b, tol = tol)
      minares!(workspace, A, b, atol = 0.0, rtol = 0.0, Artol = 0.0, callback = cb_n2)
      @test workspace.stats.status == "user-requested exit"
      @test cb_n2(workspace)

      @test_throws TypeError minares(A, b, callback = workspace -> "string", history = true)
    end
  end
end

mutable struct StorageGetxRestartedGmres{S}
  x::S
  y::S
  p::S
end
StorageGetxRestartedGmres(workspace::GmresWorkspace; N = I) =
  StorageGetxRestartedGmres(similar(workspace.x), similar(workspace.z), (N === I) ? similar(workspace.p) : similar(workspace.x))

function get_x_restarted_gmres!(workspace::GmresWorkspace{T,FC,S}, A,
                                stor::StorageGetxRestartedGmres{S}, N) where {T,FC,S}
  NisI = (N === I)
  x2, y2, p2 = stor.x, stor.y, stor.p
  n = size(A, 2)
  # Compute yₖ by solving Rₖyₖ = zₖ with backward substitution.
  nr = sum(1:workspace.inner_iter)
  y = workspace.z  # yᵢ = zᵢ
  y2 .= y
  R = workspace.R
  V = workspace.V
  x2 .= workspace.Δx
  for i = workspace.inner_iter : -1 : 1
    pos = nr + i - workspace.inner_iter      # position of rᵢ.ₖ
    for j = workspace.inner_iter : -1 : i+1
      y2[i] = y2[i] - R[pos] * y2[j]  # yᵢ ← yᵢ - rᵢⱼyⱼ
      pos = pos - j + 1            # position of rᵢ.ⱼ₋₁
    end
    # Rₖ can be singular if the system is inconsistent
    if abs(R[pos]) ≤ eps(T)^(3/4)
      y2[i] = zero(FC)
      inconsistent = true
    else
      y2[i] = y2[i] / R[pos]  # yᵢ ← yᵢ / rᵢᵢ
    end
  end

  # Form xₖ = N⁻¹Vₖyₖ
  for i = 1 : workspace.inner_iter
    Krylov.kaxpy!(n, y2[i], V[i], x2)
  end
  if !NisI
    p2 .= workspace.p
    p2 .= x2
    mul!(x2, N, p2)
  end
  x2 .+= workspace.x
end

mutable struct TestCallbackN2{T, S, M}
  A::M
  b::S
  storage_vec::S
  tol::T
end
TestCallbackN2(A, b; tol = 0.1) = TestCallbackN2(A, b, similar(b), tol)

function (cb_n2::TestCallbackN2)(workspace)
  mul!(cb_n2.storage_vec, cb_n2.A, workspace.x)
  cb_n2.storage_vec .-= cb_n2.b
  return norm(cb_n2.storage_vec) ≤ cb_n2.tol
end

mutable struct TestCallbackN2Adjoint{T, S, M}
  A::M
  b::S
  c::S
  storage_vec1::S
  storage_vec2::S
  tol::T
end
TestCallbackN2Adjoint(A, b, c; tol = 0.1) = TestCallbackN2Adjoint(A, b, c, similar(b), similar(c), tol)

function (cb_n2::TestCallbackN2Adjoint)(workspace)
  mul!(cb_n2.storage_vec1, cb_n2.A, workspace.x)
  cb_n2.storage_vec1 .-= cb_n2.b
  mul!(cb_n2.storage_vec2, cb_n2.A', workspace.y)
  cb_n2.storage_vec2 .-= cb_n2.c
  return (norm(cb_n2.storage_vec1) ≤ cb_n2.tol && norm(cb_n2.storage_vec2) ≤ cb_n2.tol)
end

mutable struct TestCallbackN2Shifts{T, S, M}
  A::M
  b::S
  shifts::Vector{T}
  tol::T
end
TestCallbackN2Shifts(A, b, shifts; tol = 0.1) = TestCallbackN2Shifts(A, b, shifts, tol)

function (cb_n2::TestCallbackN2Shifts)(workspace)
  r = residuals(cb_n2.A, cb_n2.b, cb_n2.shifts, workspace.x)
  return all(map(norm, r) .≤ cb_n2.tol)
end

mutable struct TestCallbackN2LS{T, S, M}
  A::M
  b::S
  λ::T
  storage_vec1::S
  storage_vec2::S
  tol::T
end
TestCallbackN2LS(A, b, λ; tol = 0.1) = TestCallbackN2LS(A, b, λ, similar(b), similar(b, size(A, 2)), tol)

function (cb_n2::TestCallbackN2LS)(workspace)
  mul!(cb_n2.storage_vec1, cb_n2.A, workspace.x)
  cb_n2.storage_vec1 .-= cb_n2.b
  mul!(cb_n2.storage_vec2, cb_n2.A', cb_n2.storage_vec1)
  cb_n2.storage_vec2 .+= cb_n2.λ .* workspace.x
  return norm(cb_n2.storage_vec2) ≤ cb_n2.tol
end

mutable struct TestCallbackN2LN{T, S, M}
  A::M
  b::S
  λ::T
  storage_vec::S
  tol::T
end
TestCallbackN2LN(A, b, λ; tol = 0.1) = TestCallbackN2LN(A, b, λ, similar(b), tol)

function (cb_n2::TestCallbackN2LN)(workspace)
  mul!(cb_n2.storage_vec, cb_n2.A, workspace.x)
  cb_n2.storage_vec .-= cb_n2.b
  cb_n2.λ != 0 && (cb_n2.storage_vec .+= cb_n2.λ .* workspace.x)
  return norm(cb_n2.storage_vec) ≤ cb_n2.tol
end

mutable struct TestCallbackN2SaddlePts{T, S, M}
  A::M
  b::S
  c::S
  storage_vec1::S
  storage_vec2::S
  tol::T
end
TestCallbackN2SaddlePts(A, b, c; tol = 0.1) = 
  TestCallbackN2SaddlePts(A, b, c, similar(b), similar(c), tol)

function (cb_n2::TestCallbackN2SaddlePts)(workspace)
  mul!(cb_n2.storage_vec1, cb_n2.A, workspace.y)
  cb_n2.storage_vec1 .+= workspace.x .- cb_n2.b
  mul!(cb_n2.storage_vec2, cb_n2.A', workspace.x)
  cb_n2.storage_vec2 .-= workspace.y .+ cb_n2.c
  return (norm(cb_n2.storage_vec1) ≤ cb_n2.tol && norm(cb_n2.storage_vec2) ≤ cb_n2.tol)
end

function restarted_gmres_callback_n2(workspace::GmresWorkspace, A, b, stor, N, storage_vec, tol)
  get_x_restarted_gmres!(workspace, A, stor, N)
  x = stor.x
  mul!(storage_vec, A, x)
  storage_vec .-= b
  return (norm(storage_vec) ≤ tol)
end

mutable struct TestCallbackN2LSShifts{T, S, M}
  A::M
  b::S
  shifts::Vector{T}
  tol::T
end
TestCallbackN2LSShifts(A, b, shifts; tol = 0.1) = TestCallbackN2LSShifts(A, b, shifts, tol)

function (cb_n2::TestCallbackN2LSShifts)(workspace)
  r = residuals_ls(cb_n2.A, cb_n2.b, cb_n2.shifts, workspace.x)
  return all(map(norm, r) .≤ cb_n2.tol)
end

"""
    solution(workspace)

Return the solution(s) stored in the `workspace`.

Optionally you can specify which solution you want to recover,
`solution(workspace, 1)` returns `x` and `solution(workspace, 2)` returns `y`.
"""
function solution end

"""
    statistics(workspace)

Return the statistics stored in `workspace`.
"""
function statistics end

"""
    results(workspace)

Return a tuple containing the solution(s) and the statistics associated with `workspace`.
This allows retrieving the output arguments of an out-of-place method from an in-place method.

For example, instead of `x, stats = cg(A, b)`, you can use:
```julia
workspace = CgWorkspace(A, b)
cg!(workspace, A, b)
x, stats = results(workspace)
```
"""
function results end

"""
    issolved(workspace)

Return a boolean indicating whether the Krylov method associated with `workspace` has succeeded.

For the Krylov methods [`bilqr`](@ref) and [`trilqr`](@ref), you can use `issolved_primal(workspace)`
and `issolved_dual(workspace)` to separately check whether the solver has converged on the primal or dual system.
"""
function issolved end

"""
    elapsed_allocation_time(workspace)

Return the total time (in seconds) spent on allocations in the `workspace`.
This timer is cumulative and is not reset between calls.
"""
function elapsed_allocation_time end

"""
    elapsed_time(workspace)

Return the elapsed time (in seconds) during the last call to the Krylov method associated with `workspace`.
"""
function elapsed_time end

"""
    solution_count(workspace)

Return the number of outputs of `solution(workspace)`.
"""
function solution_count end

"""
    iteration_count(workspace)

Return the number of iterations performed by the Krylov method associated with `workspace`.

The number of iterations alone is not a reliable basis for comparing different Krylov methods,
since the work performed in each iteration can vary significantly.
For a fairer performance comparison, use the total number of operator-vector products with `A` and `A'` (see [Aprod_count](@ref) and [Atprod_count](@ref)).
"""
function iteration_count end

"""
    Aprod_count(workspace)

Return the number of operator-vector products with `A` performed by the Krylov method associated with `workspace`.

This function can also be used to determine the number of operator-vector products with `B` in [`gpmr`](@ref), since it is the same as for `A`.
"""
function Aprod_count end

"""
    Atprod_count(workspace)

Return the number of operator-vector products with `A'` performed by the Krylov method associated with `workspace`.
"""
function Atprod_count end

"""
  warm_start!(workspace, x0)
  warm_start!(workspace, x0, y0)

Warm-start the Krylov method associated with `workspace` using a user-provided initial guess, instead of starting from zero.
"""
function warm_start! end

# Krylov methods
for (KS, fun, nsol, nA, nAt, warm_start) in [
  (:CarWorkspace      , :car!       , 1, 1, 0, true )
  (:LsmrWorkspace     , :lsmr!      , 1, 1, 1, false)
  (:CgsWorkspace      , :cgs!       , 1, 2, 0, true )
  (:UsymlqWorkspace   , :usymlq!    , 1, 1, 1, true )
  (:LnlqWorkspace     , :lnlq!      , 2, 1, 1, false)
  (:BicgstabWorkspace , :bicgstab!  , 1, 2, 0, true )
  (:CrlsWorkspace     , :crls!      , 1, 1, 1, false)
  (:LsqrWorkspace     , :lsqr!      , 1, 1, 1, false)
  (:MinresWorkspace   , :minres!    , 1, 1, 0, true )
  (:MinaresWorkspace  , :minares!   , 1, 1, 0, true )
  (:CgneWorkspace     , :cgne!      , 1, 1, 1, false)
  (:DqgmresWorkspace  , :dqgmres!   , 1, 1, 0, true )
  (:SymmlqWorkspace   , :symmlq!    , 1, 1, 0, true )
  (:TrimrWorkspace    , :trimr!     , 2, 1, 1, true )
  (:UsymqrWorkspace   , :usymqr!    , 1, 1, 1, true )
  (:BilqrWorkspace    , :bilqr!     , 2, 1, 1, true )
  (:CrWorkspace       , :cr!        , 1, 1, 0, true )
  (:CraigmrWorkspace  , :craigmr!   , 2, 1, 1, false)
  (:TricgWorkspace    , :tricg!     , 2, 1, 1, true )
  (:CraigWorkspace    , :craig!     , 2, 1, 1, false)
  (:DiomWorkspace     , :diom!      , 1, 1, 0, true )
  (:LslqWorkspace     , :lslq!      , 1, 1, 1, false)
  (:TrilqrWorkspace   , :trilqr!    , 2, 1, 1, true )
  (:CrmrWorkspace     , :crmr!      , 1, 1, 1, false)
  (:CgWorkspace       , :cg!        , 1, 1, 0, true )
  (:CglsWorkspace     , :cgls!      , 1, 1, 1, false)
  (:CgLanczosWorkspace, :cg_lanczos!, 1, 1, 0, true )
  (:BilqWorkspace     , :bilq!      , 1, 1, 1, true )
  (:MinresQlpWorkspace, :minres_qlp!, 1, 1, 0, true )
  (:QmrWorkspace      , :qmr!       , 1, 1, 1, true )
  (:GmresWorkspace    , :gmres!     , 1, 1, 0, true )
  (:FgmresWorkspace   , :fgmres!    , 1, 1, 0, true )
  (:FomWorkspace      , :fom!       , 1, 1, 0, true )
  (:GpmrWorkspace     , :gpmr!      , 2, 1, 0, true )
  (:UsymlqrWorkspace  , :usymlqr!   , 2, 1, 1, true )
  (:CgLanczosShiftWorkspace  , :cg_lanczos_shift!  , 1, 1, 0, false)
  (:CglsLanczosShiftWorkspace, :cgls_lanczos_shift!, 1, 1, 1, false)
]
  @eval begin
    elapsed_time(workspace :: $KS) = workspace.stats.timer
    elapsed_allocation_time(workspace :: $KS) = workspace.stats.allocation_timer
    statistics(workspace :: $KS) = workspace.stats
    solution_count(workspace :: $KS) = $nsol
    iteration_count(workspace :: $KS) = workspace.stats.niter
    Aprod_count(workspace :: $KS) = $nA * workspace.stats.niter
    Atprod_count(workspace :: $KS) = $nAt * workspace.stats.niter
    if $nsol == 1
      solution(workspace :: $KS) = workspace.x
      solution(workspace :: $KS, p :: Integer) = (p == 1) ? solution(workspace) : error("solution(workspace) has only one output.")
      results(workspace :: $KS) = (workspace.x, workspace.stats)
    end
    if $nsol == 2
      solution(workspace :: $KS) = (workspace.x, workspace.y)
      solution(workspace :: $KS, p :: Integer) = (1 ≤ p ≤ 2) ? solution(workspace)[p] : error("solution(workspace) has only two outputs.")
      results(workspace :: $KS) = (workspace.x, workspace.y, workspace.stats)
    end
    if $KS ∈ (BilqrWorkspace, TrilqrWorkspace)
      issolved_primal(workspace :: $KS) = workspace.stats.solved_primal
      issolved_dual(workspace :: $KS) = workspace.stats.solved_dual
      issolved(workspace :: $KS) = issolved_primal(workspace) && issolved_dual(workspace)
    else
      issolved(workspace :: $KS) = workspace.stats.solved
    end
    if $warm_start
      if $KS in (BilqrWorkspace, TrilqrWorkspace)
        function warm_start!(workspace :: $KS, x0, y0)
          length(x0) == workspace.n || error("x0 should have size $(workspace.n)")
          length(y0) == workspace.m || error("y0 should have size $(workspace.m)")
          Sm = typeof(workspace.y)
          Sn = typeof(workspace.x)
          allocate_if(true, workspace, :Δx, Sn, workspace.x)  # The length of Δx is n
          allocate_if(true, workspace, :Δy, Sm, workspace.y)  # The length of Δy is m
          kcopy!(workspace.n, workspace.Δx, x0)
          kcopy!(workspace.m, workspace.Δy, y0)
          workspace.warm_start = true
          return workspace
        end
      elseif $KS in (UsymlqrWorkspace, TricgWorkspace, TrimrWorkspace, GpmrWorkspace)
        function warm_start!(workspace :: $KS, x0, y0)
          length(x0) == workspace.m || error("x0 should have size $(workspace.m)")
          length(y0) == workspace.n || error("y0 should have size $(workspace.n)")
          Sm = typeof(workspace.x)
          Sn = typeof(workspace.y)
          allocate_if(true, workspace, :Δx, Sm, workspace.x)  # The length of Δx is m
          allocate_if(true, workspace, :Δy, Sn, workspace.y)  # The length of Δy is n
          kcopy!(workspace.m, workspace.Δx, x0)
          kcopy!(workspace.n, workspace.Δy, y0)
          workspace.warm_start = true
          return workspace
        end
      else
        function warm_start!(workspace :: $KS, x0)
          S = typeof(workspace.x)
          length(x0) == workspace.n || error("x0 should have size $(workspace.n)")
          allocate_if(true, workspace, :Δx, S, workspace.x)  # The length of Δx is n
          kcopy!(workspace.n, workspace.Δx, x0)
          workspace.warm_start = true
          return workspace
        end
      end
    end
  end
end

# Block Krylov methods
for (KS, fun, nsol, nA, nAt, warm_start) in [
  (:BlockMinresWorkspace, :block_minres!, 1, 1, 0, true)
  (:BlockGmresWorkspace , :block_gmres! , 1, 1, 0, true)
]
  @eval begin
    elapsed_time(workspace :: $KS) = workspace.stats.timer
    elapsed_allocation_time(workspace :: $KS) = workspace.stats.allocation_timer
    statistics(workspace :: $KS) = workspace.stats
    solution_count(workspace :: $KS) = $nsol
    iteration_count(workspace :: $KS) = workspace.stats.niter
    Aprod_count(workspace :: $KS) = $nA * workspace.stats.niter
    Atprod_count(workspace :: $KS) = $nAt * workspace.stats.niter
    if $nsol == 1
      solution(workspace :: $KS) = workspace.X
      solution(workspace :: $KS, p :: Integer) = (p == 1) ? solution(workspace) : error("solution(workspace) has only one output.")
      results(workspace :: $KS) = (workspace.X, workspace.stats)
    end
    issolved(workspace :: $KS) = workspace.stats.solved
    if $warm_start
      function warm_start!(workspace :: $KS, X0)
        n2, p2 = size(X0)
        SM = typeof(workspace.X)
        (workspace.n == n2 && workspace.p == p2) || error("X0 should have size ($(workspace.n), $(workspace.p))")
        allocate_if(true, workspace, :ΔX, SM, workspace.n, workspace.p)
        copyto!(workspace.ΔX, X0)
        workspace.warm_start = true
        return workspace
      end
    end
  end
end

using Documenter, Krylov

makedocs(
  modules = [Krylov],
  doctest = true,
  linkcheck = true,
  linkcheck_ignore = [r"https://www.emis.de/.*"],
  format = Documenter.HTML(assets = ["assets/style.css"],
                           ansicolor = true,
                           prettyurls = get(ENV, "CI", nothing) == "true",
                           collapselevel = 1),
  sitename = "Krylov.jl",
  pages = ["Home" => "index.md",
           "C and Fortran interfaces" => ["Overview" => "interfaces/overview.md",
                                          "Reference" => "interfaces/reference.md",
                                          "Building libkrylov" => "interfaces/building.md",
                                          "C interface" => "interfaces/c.md",
                                          "Fortran interface" => "interfaces/fortran.md"],
           "Krylov processes" => "processes.md",
           "Block Krylov processes" => "block_processes.md",
           "Krylov methods" => ["Hermitian positive definite linear systems" => "solvers/spd.md",
                                "Hermitian indefinite linear systems" => "solvers/sid.md",
                                "Non-Hermitian square linear systems" => "solvers/unsymmetric.md",
                                "Least-norm problems" => "solvers/ln.md",
                                "Least-squares problems" => "solvers/ls.md",
                                "Adjoint systems" => "solvers/as.md",
                                "Saddle-point and Hermitian quasi-definite systems" => "solvers/sp_sqd.md",
                                "Generalized saddle-point and non-Hermitian partitioned systems" => "solvers/gsp.md"],
           "Block Krylov methods" => "block_krylov.md",
           "In-place methods" => "inplace.md",
           "Generic interface" => "generic_interface.md",
           "Storage requirements" => "storage.md",
           "Preconditioners" => "preconditioners.md",
           "GPU support" => "gpu.md",
           "Warm-start" => "warm-start.md",
           "Matrix-free operators" => "matrix_free.md",
           "Callbacks" => "callbacks.md",
           "Custom workspaces" => "custom_workspaces.md",
           "Performance tips" => "tips.md",
           "Tutorials" => ["CG" => "examples/cg.md",
                           "CAR" => "examples/car.md",
                           "CG-LANCZOS-SHIFT" => "examples/cg_lanczos_shift.md",
                           "SYMMLQ" => "examples/symmlq.md",
                           "MINRES-QLP" => "examples/minres_qlp.md",
                           "MINARES" => "examples/minares.md",
                           "TriCG" => "examples/tricg.md",
                           "TriMR" => "examples/trimr.md",
                           "USYMLQR" => "examples/usymlqr.md",
                           "BICGSTAB" => "examples/bicgstab.md",
                           "DQGMRES" => "examples/dqgmres.md",
                           "BLOCK-GMRES" => "examples/block_gmres.md",
                           "CGNE" => "examples/cgne.md",
                           "CRMR" => "examples/crmr.md",
                           "CRAIG" => "examples/craig.md",
                           "CRAIGMR" => "examples/craigmr.md",
                           "CGLS" => "examples/cgls.md",
                           "CGLS-LANCZOS-SHIFT" => "examples/cgls_lanczos_shift.md",
                           "CRLS" => "examples/crls.md",
                           "LSQR" => "examples/lsqr.md",
                           "LSMR" => "examples/lsmr.md"],
           "API" => "api.md",
           "Reference" => "reference.md"
          ]
)

deploydocs(
  repo = "github.com/JuliaSmoothOptimizers/Krylov.jl.git",
  push_preview = true,
  devbranch = "main",
)

# The purpose of this file is to automatically define all variants of in-place and out-of-place methods for Krylov solvers using metaprogramming.
# For example, the file `cg.jl` only implements the in-place method `cg!(workspace, A, b; kwargs...)`.
# This file generates additional variants of this method automatically, such as:
#
# - `cg(A, b; kwargs...)`
# - `krylov_solve(Val(:cg), A, b; kwargs...)`
# - `krylov_solve!(workspace, A, b; kwargs...)`
#
# Since the conjugate gradient method also supports an optional argument `x0`, additional methods are generated:
#
# - `cg(A, b, x0; kwargs...)`
# - `cg!(workspace, A, b, x0; kwargs...)`
# - `krylov_solve(Val(:cg), A, b, x0; kwargs...)`
# - `krylov_solve!(workspace, A, b, x0; kwargs...)`
#
# Generic constructors for each `KrylovWorkspace` and `BlockKrylovWorkspace` are also defined using metaprogramming.
# The function `krylov_workspace` uses the first argument, `Val(method)`, where `method` is a symbol used to dispatch to the appropriate method.
# For example, the three constructors for `CgWorkspace` can be called using the following syntax:
#
# - `krylov_workspace(Val(:cg), kc)`
# - `krylov_workspace(Val(:cg), m, n, S)`
# - `krylov_workspace(Val(:cg), A, b)`
#
# Alexis Montoison, <alexis.montoison@polymtl.ca> -- <amontoison@anl.gov>
# Chicago, October 2024 -- Chicago, April 2025.

export krylov_workspace, krylov_solve, krylov_solve!

"""
    workspace = krylov_workspace(method, args...; kwargs...)
    workspace = krylov_workspace(Val(method), args...; kwargs...)

Generic function that dispatches to the appropriate workspace constructor for each subtype of [`KrylovWorkspace`](@ref) and [`BlockKrylovWorkspace`](@ref).
In both calls, `method` is a symbol (such as `:cg`, `:gmres` or `:block_minres`) that specifies the (block) Krylov method for which a workspace is desired.
The returned workspace can later be used by [`krylov_solve!`](@ref) to execute the (block) Krylov method in-place.

Pass the plain symbol `method` for convenience, or wrap it in `Val(method)` to enable full compile-time specialization, improve type inference, and achieve maximum performance.

Note that for each (block) Krylov method, you can use a workspace constructor that accepts exactly the same arguments as the corresponding solver and [`krylov_solve`](@ref), for convenience and consistency.
"""
function krylov_workspace end

krylov_workspace(method::Symbol, args...; kwargs...) = krylov_workspace(Val(method), args...; kwargs...)

"""
    krylov_solve(method, args...; kwargs...)
    krylov_solve(Val(method), args...; kwargs...)

Generic function that dispatches to the appropriate out-of-place (block) Krylov method specified by `method`.
In both calls, `method` is a symbol (such as `:cg`, `:gmres` or `:block_minres`).

Pass the plain symbol `method` for convenience, or wrap it in `Val(method)` to enable full compile-time specialization, improve type inference, and achieve maximum performance.
"""
function krylov_solve end

krylov_solve(method::Symbol, args...; kwargs...) = krylov_solve(Val(method), args...; kwargs...)

"""
    krylov_solve!(workspace, args...; kwargs...)

Generic function that dispatches to the appropriate in-place (block) Krylov method based on the type of `workspace`.
The argument `workspace` must be a subtype of [`KrylovWorkspace`](@ref) or [`BlockKrylovWorkspace`](@ref) (such as `CgWorkspace`, `GmresWorkspace` or `BlockMinresWorkspace`).
"""
function krylov_solve! end

# Krylov methods
for (workspace, krylov, is_extended_workspace, args, def_args, optargs, def_optargs, kwargs, def_kwargs, kwargs_workspace, def_kwargs_workspace) in [
  (:LsmrWorkspace     , :lsmr      , true , args_lsmr      , def_args_lsmr      , ()                , ()                    , kwargs_lsmr      , def_kwargs_lsmr      , kwargs_workspace_lsmr   , def_kwargs_workspace_lsmr   )
  (:CgsWorkspace      , :cgs       , false, args_cgs       , def_args_cgs       , optargs_cgs       , def_optargs_cgs       , kwargs_cgs       , def_kwargs_cgs       , ()                      , ()                          )
  (:UsymlqWorkspace   , :usymlq    , true , args_usymlq    , def_args_usymlq    , optargs_usymlq    , def_optargs_usymlq    , kwargs_usymlq    , def_kwargs_usymlq    , ()                      , ()                          )
  (:LnlqWorkspace     , :lnlq      , true , args_lnlq      , def_args_lnlq      , ()                , ()                    , kwargs_lnlq      , def_kwargs_lnlq      , ()                      , ()                          )
  (:BicgstabWorkspace , :bicgstab  , false, args_bicgstab  , def_args_bicgstab  , optargs_bicgstab  , def_optargs_bicgstab  , kwargs_bicgstab  , def_kwargs_bicgstab  , ()                      , ()                          )
  (:CrlsWorkspace     , :crls      , true , args_crls      , def_args_crls      , ()                , ()                    , kwargs_crls      , def_kwargs_crls      , ()                      , ()                          )
  (:LsqrWorkspace     , :lsqr      , true , args_lsqr      , def_args_lsqr      , ()                , ()                    , kwargs_lsqr      , def_kwargs_lsqr      , kwargs_workspace_lsqr   , def_kwargs_workspace_lsqr   )
  (:MinresWorkspace   , :minres    , false, args_minres    , def_args_minres    , optargs_minres    , def_optargs_minres    , kwargs_minres    , def_kwargs_minres    , kwargs_workspace_minres , def_kwargs_workspace_minres )
  (:MinaresWorkspace  , :minares   , false, args_minares   , def_args_minares   , optargs_minares   , def_optargs_minares   , kwargs_minares   , def_kwargs_minares   , ()                      , ()                          )
  (:CgneWorkspace     , :cgne      , true , args_cgne      , def_args_cgne      , ()                , ()                    , kwargs_cgne      , def_kwargs_cgne      , ()                      , ()                          )
  (:DqgmresWorkspace  , :dqgmres   , false, args_dqgmres   , def_args_dqgmres   , optargs_dqgmres   , def_optargs_dqgmres   , kwargs_dqgmres   , def_kwargs_dqgmres   , kwargs_workspace_dqgmres, def_kwargs_workspace_dqgmres)
  (:SymmlqWorkspace   , :symmlq    , false, args_symmlq    , def_args_symmlq    , optargs_symmlq    , def_optargs_symmlq    , kwargs_symmlq    , def_kwargs_symmlq    , kwargs_workspace_symmlq , def_kwargs_workspace_symmlq )
  (:TrimrWorkspace    , :trimr     , true , args_trimr     , def_args_trimr     , optargs_trimr     , def_optargs_trimr     , kwargs_trimr     , def_kwargs_trimr     , ()                      , ()                          )
  (:UsymqrWorkspace   , :usymqr    , true , args_usymqr    , def_args_usymqr    , optargs_usymqr    , def_optargs_usymqr    , kwargs_usymqr    , def_kwargs_usymqr    , ()                      , ()                          )
  (:BilqrWorkspace    , :bilqr     , false, args_bilqr     , def_args_bilqr     , optargs_bilqr     , def_optargs_bilqr     , kwargs_bilqr     , def_kwargs_bilqr     , ()                      , ()                          )
  (:CrWorkspace       , :cr        , false, args_cr        , def_args_cr        , optargs_cr        , def_optargs_cr        , kwargs_cr        , def_kwargs_cr        , ()                      , ()                          )
  (:CarWorkspace      , :car       , false, args_car       , def_args_car       , optargs_car       , def_optargs_car       , kwargs_car       , def_kwargs_car       , ()                      , ()                          )
  (:CraigmrWorkspace  , :craigmr   , true , args_craigmr   , def_args_craigmr   , ()                , ()                    , kwargs_craigmr   , def_kwargs_craigmr   , ()                      , ()                          )
  (:TricgWorkspace    , :tricg     , true , args_tricg     , def_args_tricg     , optargs_tricg     , def_optargs_tricg     , kwargs_tricg     , def_kwargs_tricg     , ()                      , ()                          )
  (:CraigWorkspace    , :craig     , true , args_craig     , def_args_craig     , ()                , ()                    , kwargs_craig     , def_kwargs_craig     , ()                      , ()                          )
  (:DiomWorkspace     , :diom      , false, args_diom      , def_args_diom      , optargs_diom      , def_optargs_diom      , kwargs_diom      , def_kwargs_diom      , kwargs_workspace_diom   , def_kwargs_workspace_diom   )
  (:LslqWorkspace     , :lslq      , true , args_lslq      , def_args_lslq      , ()                , ()                    , kwargs_lslq      , def_kwargs_lslq      , kwargs_workspace_lslq   , def_kwargs_workspace_lslq   )
  (:TrilqrWorkspace   , :trilqr    , true , args_trilqr    , def_args_trilqr    , optargs_trilqr    , def_optargs_trilqr    , kwargs_trilqr    , def_kwargs_trilqr    , ()                      , ()                          )
  (:CrmrWorkspace     , :crmr      , true , args_crmr      , def_args_crmr      , ()                , ()                    , kwargs_crmr      , def_kwargs_crmr      , ()                      , ()                          )
  (:CgWorkspace       , :cg        , false, args_cg        , def_args_cg        , optargs_cg        , def_optargs_cg        , kwargs_cg        , def_kwargs_cg        , ()                      , ()                          )
  (:CglsWorkspace     , :cgls      , true , args_cgls      , def_args_cgls      , ()                , ()                    , kwargs_cgls      , def_kwargs_cgls      , ()                      , ()                          )
  (:CgLanczosWorkspace, :cg_lanczos, false, args_cg_lanczos, def_args_cg_lanczos, optargs_cg_lanczos, def_optargs_cg_lanczos, kwargs_cg_lanczos, def_kwargs_cg_lanczos, ()                      , ()                          )
  (:BilqWorkspace     , :bilq      , false, args_bilq      , def_args_bilq      , optargs_bilq      , def_optargs_bilq      , kwargs_bilq      , def_kwargs_bilq      , ()                      , ()                          )
  (:MinresQlpWorkspace, :minres_qlp, false, args_minres_qlp, def_args_minres_qlp, optargs_minres_qlp, def_optargs_minres_qlp, kwargs_minres_qlp, def_kwargs_minres_qlp, ()                      , ()                          )
  (:QmrWorkspace      , :qmr       , false, args_qmr       , def_args_qmr       , optargs_qmr       , def_optargs_qmr       , kwargs_qmr       , def_kwargs_qmr       , ()                      , ()                          )
  (:GmresWorkspace    , :gmres     , false, args_gmres     , def_args_gmres     , optargs_gmres     , def_optargs_gmres     , kwargs_gmres     , def_kwargs_gmres     , kwargs_workspace_gmres  , def_kwargs_workspace_gmres  )
  (:FgmresWorkspace   , :fgmres    , false, args_fgmres    , def_args_fgmres    , optargs_fgmres    , def_optargs_fgmres    , kwargs_fgmres    , def_kwargs_fgmres    , kwargs_workspace_fgmres , def_kwargs_workspace_fgmres )
  (:FomWorkspace      , :fom       , false, args_fom       , def_args_fom       , optargs_fom       , def_optargs_fom       , kwargs_fom       , def_kwargs_fom       , kwargs_workspace_fom    , def_kwargs_workspace_fom    )
  (:GpmrWorkspace     , :gpmr      , true , args_gpmr      , def_args_gpmr      , optargs_gpmr      , def_optargs_gpmr      , kwargs_gpmr      , def_kwargs_gpmr      , kwargs_workspace_gpmr   , def_kwargs_workspace_gpmr   )
  (:UsymlqrWorkspace  , :usymlqr   , true , args_usymlqr   , def_args_usymlqr   , optargs_usymlqr   , def_optargs_usymlqr   , kwargs_usymlqr   , def_kwargs_usymlqr   , ()                      , ()                          )
  (:CgLanczosShiftWorkspace  , :cg_lanczos_shift  , false, args_cg_lanczos_shift  , def_args_cg_lanczos_shift  , (), (), kwargs_cg_lanczos_shift  , def_kwargs_cg_lanczos_shift  , (), ())
  (:CglsLanczosShiftWorkspace, :cgls_lanczos_shift, true , args_cgls_lanczos_shift, def_args_cgls_lanczos_shift, (), (), kwargs_cgls_lanczos_shift, def_kwargs_cgls_lanczos_shift, (), ())
]
  # Create the symbol for the in-place method
  krylov! = Symbol(krylov, :!)

  ## Generic constructors for each subtype of KrylovWorkspace
  if krylov in (:cg_lanczos_shift, :cgls_lanczos_shift)
    @eval krylov_workspace(::Val{Symbol($krylov)}, kc::KrylovConstructor, nshifts::Integer) = $workspace(kc, nshifts)
    @eval krylov_workspace(::Val{Symbol($krylov)}, m::Integer, n::Integer, nshifts::Integer, S::Type) = $workspace(m, n, nshifts, S)
    @eval krylov_workspace(::Val{Symbol($krylov)}, A, b, nshifts::Integer) = $workspace(A, b, nshifts)
    @eval krylov_workspace(::Val{Symbol($krylov)}, A, b, shifts::AbstractVector) = $workspace(A, b, shifts)
    if is_extended_workspace
      @eval krylov_workspace(::Val{Symbol($krylov)}, m::Integer, n::Integer, nshifts::Integer, Sm::Type, Sn::Type) = $workspace(m, n, nshifts, Sm, Sn)
    end
  else
    if isempty(kwargs_workspace)
      @eval krylov_workspace(::Val{Symbol($krylov)}, kc::KrylovConstructor) = $workspace(kc)
      @eval krylov_workspace(::Val{Symbol($krylov)}, m::Integer, n::Integer, S::Type) = $workspace(m, n, S)
      @eval krylov_workspace(::Val{Symbol($krylov)}, A, b) = $workspace(A, b)
      if is_extended_workspace
        @eval krylov_workspace(::Val{Symbol($krylov)}, m::Integer, n::Integer, Sm::Type, Sn::Type) = $workspace(m, n, Sm, Sn)
      end
      if krylov in (:usymlq, :usymqr, :usymlqr, :tricg, :trimr, :bilqr, :trilqr)
        @eval krylov_workspace(::Val{Symbol($krylov)}, A, b, c) = $workspace(A, b, c)
      end
    else
      @eval krylov_workspace(::Val{Symbol($krylov)}, kc::KrylovConstructor; $(def_kwargs_workspace...)) = $workspace(kc; $(kwargs_workspace...))
      @eval krylov_workspace(::Val{Symbol($krylov)}, m::Integer, n::Integer, S::Type; $(def_kwargs_workspace...)) = $workspace(m, n, S; $(kwargs_workspace...))
      @eval krylov_workspace(::Val{Symbol($krylov)}, A, b; $(def_kwargs_workspace...)) = $workspace(A, b; $(kwargs_workspace...))
      if is_extended_workspace
        @eval krylov_workspace(::Val{Symbol($krylov)}, m::Integer, n::Integer, Sm::Type, Sn::Type; $(def_kwargs_workspace...)) = $workspace(m, n, Sm, Sn; $(kwargs_workspace...))
      end
      if krylov == :gpmr
        @eval krylov_workspace(::Val{Symbol($krylov)}, A, b, c; $(def_kwargs_workspace...)) = $workspace(A, b, c; $(kwargs_workspace...))
        @eval krylov_workspace(::Val{Symbol($krylov)}, A, B, b, c; $(def_kwargs_workspace...)) = $workspace(A, B, b, c; $(kwargs_workspace...))
      end
    end
  end

  ## Out-of-place
  if isempty(kwargs_workspace)
    @eval begin
      function $(krylov)($(def_args...); $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}}
        start_time = time_ns()
        workspace = $workspace($(args...))
        elapsed_time = start_time |> ktimer
        timemax -= elapsed_time
        $(krylov!)(workspace, $(args...); $(kwargs...))
        workspace.stats.timer += elapsed_time
        return results(workspace)
      end

      krylov_solve(::Val{Symbol($krylov)}, $(def_args...); $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}} = $(krylov)($(args...); $(kwargs...))
    end

    if !isempty(optargs)
      @eval begin
        function $(krylov)($(def_args...), $(def_optargs...); $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}}
          start_time = time_ns()
          workspace = $workspace($(args...))
          warm_start!(workspace, $(optargs...))
          elapsed_time = start_time |> ktimer
          timemax -= elapsed_time
          $(krylov!)(workspace, $(args...); $(kwargs...))
          workspace.stats.timer += elapsed_time
          return results(workspace)
        end

        krylov_solve(::Val{Symbol($krylov)}, $(def_args...), $(def_optargs...); $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}} = $(krylov)($(args...), $(optargs...); $(kwargs...))
      end
    end
  else  # --> !isempty(kwargs_workspace)
    @eval begin
      function $(krylov)($(def_args...); $(def_kwargs_workspace...), $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}}
        start_time = time_ns()
        workspace = $workspace($(args...); $(kwargs_workspace...))
        elapsed_time = start_time |> ktimer
        timemax -= elapsed_time
        $(krylov!)(workspace, $(args...); $(kwargs...))
        workspace.stats.timer += elapsed_time
        return results(workspace)
      end

      krylov_solve(::Val{Symbol($krylov)}, $(def_args...); $(def_kwargs_workspace...), $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}} = $(krylov)($(args...); $(kwargs_workspace...), $(kwargs...))
    end

    if !isempty(optargs)
      @eval begin
        function $(krylov)($(def_args...), $(def_optargs...); $(def_kwargs_workspace...), $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}}
          start_time = time_ns()
          workspace = $workspace($(args...); $(kwargs_workspace...))
          warm_start!(workspace, $(optargs...))
          elapsed_time = start_time |> ktimer
          timemax -= elapsed_time
          $(krylov!)(workspace, $(args...); $(kwargs...))
          workspace.stats.timer += elapsed_time
          return results(workspace)
        end

        krylov_solve(::Val{Symbol($krylov)}, $(def_args...), $(def_optargs...); $(def_kwargs_workspace...), $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}} = $(krylov)($(args...), $(optargs...); $(kwargs_workspace...), $(kwargs...))
      end
    end
  end

  ## In-place
  if is_extended_workspace  # workspace --> KrylovWorkspace{T,FC,Sm,Sn}
    @eval krylov_solve!(workspace :: $workspace{T,FC,Sm,Sn}, $(def_args...); $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}} = $(krylov!)(workspace, $(args...); $(kwargs...))

    if !isempty(optargs)
      for krylov_ip in (:krylov_solve!, krylov!)
        @eval begin
          function $(krylov_ip)(workspace :: $workspace{T,FC,Sm,Sn}, $(def_args...), $(def_optargs...); $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}
            start_time = time_ns()
            warm_start!(workspace, $(optargs...))
            elapsed_time = start_time |> ktimer
            timemax -= elapsed_time
            $(krylov!)(workspace, $(args...); $(kwargs...))
            workspace.stats.timer += elapsed_time
            return workspace
          end
        end
      end
    end
  else  # workspace --> KrylovWorkspace{T,FC,S,S}
    @eval krylov_solve!(workspace :: $workspace{T,FC,S}, $(def_args...); $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}} = $(krylov!)(workspace, $(args...); $(kwargs...))

    if !isempty(optargs)
      for krylov_ip in (:krylov_solve!, krylov!)
        @eval begin
          function $(krylov_ip)(workspace :: $workspace{T,FC,S}, $(def_args...), $(def_optargs...); $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}
            start_time = time_ns()
            warm_start!(workspace, $(optargs...))
            elapsed_time = start_time |> ktimer
            timemax -= elapsed_time
            $(krylov!)(workspace, $(args...); $(kwargs...))
            workspace.stats.timer += elapsed_time
            return workspace
          end
        end
      end
    end
  end
end

# Block Krylov methods
for (workspace, krylov, args, def_args, optargs, def_optargs, kwargs, def_kwargs, kwargs_workspace, def_kwargs_workspace) in [
  (:BlockMinresWorkspace, :block_minres, args_block_minres, def_args_block_minres, optargs_block_minres, def_optargs_block_minres, kwargs_block_minres, def_kwargs_block_minres, ()                          , ()                              )
  (:BlockGmresWorkspace , :block_gmres , args_block_gmres , def_args_block_gmres , optargs_block_gmres , def_optargs_block_gmres , kwargs_block_gmres , def_kwargs_block_gmres , kwargs_workspace_block_gmres, def_kwargs_workspace_block_gmres)
]
  # Create the symbol for the in-place method
  krylov! = Symbol(krylov, :!)

  ## Generic constructors for each subtype of BlockKrylovWorkspace
  if isempty(kwargs_workspace)
      @eval krylov_workspace(::Val{Symbol($krylov)}, m::Integer, n::Integer, p::Integer, SV::Type, SM::Type) = $workspace(m, n, p, SV, SM)
      @eval krylov_workspace(::Val{Symbol($krylov)}, A, B) = $workspace(A, B)
  else
      @eval krylov_workspace(::Val{Symbol($krylov)}, m::Integer, n::Integer, p::Integer, SV::Type, SM::Type; $(def_kwargs_workspace...)) = $workspace(m, n, p, SV, SM; $(kwargs_workspace...))
      @eval krylov_workspace(::Val{Symbol($krylov)}, A, B; $(def_kwargs_workspace...)) = $workspace(A, B; $(kwargs_workspace...))
  end

  ## Out-of-place
  if isempty(kwargs_workspace)
    @eval begin
      function $(krylov)($(def_args...); $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}}
        start_time = time_ns()
        workspace = $workspace($(args...))
        elapsed_time = ktimer(start_time)
        timemax -= elapsed_time
        $(krylov!)(workspace, $(args...); $(kwargs...))
        workspace.stats.timer += elapsed_time
        return results(workspace)
      end

      krylov_solve(::Val{Symbol($krylov)}, $(def_args...); $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}} = $(krylov)($(args...); $(kwargs...))
    end

    if !isempty(optargs)
      @eval begin
        function $(krylov)($(def_args...), $(def_optargs...); $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}}
          start_time = time_ns()
          workspace = $workspace($(args...))
          warm_start!(workspace, $(optargs...))
          elapsed_time = ktimer(start_time)
          timemax -= elapsed_time
          $(krylov!)(workspace, $(args...); $(kwargs...))
          workspace.stats.timer += elapsed_time
          return results(workspace)
        end

        krylov_solve(::Val{Symbol($krylov)}, $(def_args...), $(def_optargs...); $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}} = $(krylov)($(args...), $(optargs...); $(kwargs...))
      end
    end
  else  # --> !isempty(kwargs_workspace)
    @eval begin
      function $(krylov)($(def_args...); $(def_kwargs_workspace...), $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}}
        start_time = time_ns()
        workspace = $workspace($(args...); $(kwargs_workspace...))
        elapsed_time = ktimer(start_time)
        timemax -= elapsed_time
        $(krylov!)(workspace, $(args...); $(kwargs...))
        workspace.stats.timer += elapsed_time
        return results(workspace)
      end

      krylov_solve(::Val{Symbol($krylov)}, $(def_args...); $(def_kwargs_workspace...), $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}} = $(krylov)($(args...); $(kwargs_workspace...), $(kwargs...))
    end

    if !isempty(optargs)
      @eval begin
        function $(krylov)($(def_args...), $(def_optargs...); $(def_kwargs_workspace...), $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}}
          start_time = time_ns()
          workspace = $workspace($(args...); $(kwargs_workspace...))
          warm_start!(workspace, $(optargs...))
          elapsed_time = ktimer(start_time)
          timemax -= elapsed_time
          $(krylov!)(workspace, $(args...); $(kwargs...))
          workspace.stats.timer += elapsed_time
          return results(workspace)
        end

        krylov_solve(::Val{Symbol($krylov)}, $(def_args...), $(def_optargs...); $(def_kwargs_workspace...), $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}} = $(krylov)($(args...), $(optargs...); $(kwargs_workspace...), $(kwargs...))
      end
    end
  end

  ## In-place
  @eval krylov_solve!(workspace :: $workspace{T,FC,SV,SM}, $(def_args...); $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, SV <: AbstractVector{FC}, SM <: AbstractMatrix{FC}} = $(krylov!)(workspace, $(args...); $(kwargs...))

  if !isempty(optargs)
    for krylov_ip in (:krylov_solve!, krylov!)
      @eval begin
        function $(krylov_ip)(workspace :: $workspace{T,FC,SV,SM}, $(def_args...), $(def_optargs...); $(def_kwargs...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, SV <: AbstractVector{FC}, SM <: AbstractMatrix{FC}}
          start_time = time_ns()
          warm_start!(workspace, $(optargs...))
          elapsed_time = start_time |> ktimer
          timemax -= elapsed_time
          $(krylov!)(workspace, $(args...); $(kwargs...))
          workspace.stats.timer += elapsed_time
          return workspace
        end
      end
    end
  end
end

# An implementation of the Lanczos version of the conjugate gradient method.
#
# The implementation follows
# A. Frommer and P. Maass, Fast CG-Based Methods for Tikhonov-Phillips Regularization,
# SIAM Journal on Scientific Computing, 20(5), pp. 1831--1850, 1999.
#
# C. C. Paige and M. A. Saunders, Solution of Sparse Indefinite Systems of Linear Equations,
# SIAM Journal on Numerical Analysis, 12(4), pp. 617--629, 1975.
#
# Dominique Orban, <dominique.orban@gerad.ca>
# Princeton, NJ, March 2015.

export cg_lanczos, cg_lanczos!

"""
    (x, stats) = cg_lanczos(A, b::AbstractVector{FC};
                            M=I, ldiv::Bool=false,
                            check_curvature::Bool=false, atol::T=√eps(T),
                            rtol::T=√eps(T), itmax::Int=0,
                            timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                            callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = cg_lanczos(A, b, x0::AbstractVector; kwargs...)

CG-LANCZOS can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above.

The Lanczos version of the conjugate gradient method to solve the
Hermitian linear system Ax = b of size n.

The method does _not_ abort if A is not definite.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :cg_lanczos`.

For an in-place variant that reuses memory across solves, see [`cg_lanczos!`](@ref).

#### Input arguments

* `A`: a linear operator that models a Hermitian matrix of dimension `n`;
* `b`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning;
* `ldiv`: define whether the preconditioner uses `ldiv!` or `mul!`;
* `check_curvature`: if `true`, check that the curvature of the quadratic along the search direction is positive, and abort if not;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`LanczosStats`](@ref) structure.

#### References

* A. Frommer and P. Maass, [*Fast CG-Based Methods for Tikhonov-Phillips Regularization*](https://doi.org/10.1137/S1064827596313310), SIAM Journal on Scientific Computing, 20(5), pp. 1831--1850, 1999.
* C. C. Paige and M. A. Saunders, [*Solution of Sparse Indefinite Systems of Linear Equations*](https://doi.org/10.1137/0712047), SIAM Journal on Numerical Analysis, 12(4), pp. 617--629, 1975.
"""
function cg_lanczos end

"""
    workspace = cg_lanczos!(workspace::CgLanczosWorkspace, A, b; kwargs...)
    workspace = cg_lanczos!(workspace::CgLanczosWorkspace, A, b, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`cg_lanczos`](@ref).

See [`CgLanczosWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :cg_lanczos` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function cg_lanczos! end

def_args_cg_lanczos = (:(A                    ),
                       :(b::AbstractVector{FC}))

def_optargs_cg_lanczos = (:(x0::AbstractVector),)

def_kwargs_cg_lanczos = (:(; M = I                        ),
                         :(; ldiv::Bool = false           ),
                         :(; check_curvature::Bool = false),
                         :(; atol::T = √eps(T)            ),
                         :(; rtol::T = √eps(T)            ),
                         :(; itmax::Int = 0               ),
                         :(; timemax::Float64 = Inf       ),
                         :(; verbose::Int = 0             ),
                         :(; history::Bool = false        ),
                         :(; callback = workspace -> false),
                         :(; iostream::IO = kstdout       ))

def_kwargs_cg_lanczos = extract_parameters.(def_kwargs_cg_lanczos)

args_cg_lanczos = (:A, :b)
optargs_cg_lanczos = (:x0,)
kwargs_cg_lanczos = (:M, :ldiv, :check_curvature, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function cg_lanczos!(workspace :: CgLanczosWorkspace{T,FC,S}, $(def_args_cg_lanczos...); $(def_kwargs_cg_lanczos...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("System must be square")
    length(b) == n || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "CG-LANCZOS: system of %d equations in %d variables\n", n, n)

    # Tests M = Iₙ
    MisI = (M === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")

    # Set up workspace.
    allocate_if(!MisI, workspace, :v, S, workspace.x)  # The length of v is n
    Δx, x, Mv, Mv_prev = workspace.Δx, workspace.x, workspace.Mv, workspace.Mv_prev
    p, Mv_next, stats = workspace.p, workspace.Mv_next, workspace.stats
    warm_start = workspace.warm_start
    rNorms = stats.residuals
    reset!(stats)
    v = MisI ? Mv : workspace.v

    # Initial state.
    kfill!(x, zero(FC))
    if warm_start
      kmul!(Mv, A, Δx)
      kaxpby!(n, one(FC), b, -one(FC), Mv)
    else
      kcopy!(n, Mv, b)  # Mv ← b
    end
    MisI || mulorldiv!(v, M, Mv, ldiv)  # v₁ = M⁻¹r₀
    β = knorm_elliptic(n, v, Mv)        # β₁ = v₁ᴴ M v₁
    σ = β
    rNorm = σ
    history && push!(rNorms, rNorm)
    if β == 0
      stats.niter = 0
      stats.solved = true
      stats.Anorm = zero(T)
      stats.indefinite = false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end
    kcopy!(n, p, v)  # p ← v

    # Initialize Lanczos process.
    # β₁Mv₁ = b
    kdiv!(n, v, β)           # v₁  ←  v₁ / β₁
    MisI || kdiv!(n, Mv, β)  # Mv₁ ← Mv₁ / β₁
    kcopy!(n, Mv_prev, Mv)   # Mv_prev ← Mv

    iter = 0
    itmax == 0 && (itmax = 2 * n)

    # Initialize some constants used in recursions below.
    ω = zero(T)
    γ = one(T)
    Anorm2 = zero(T)
    β_prev = zero(T)

    # Define stopping tolerance.
    ε = atol + rtol * rNorm
    (verbose > 0) && @printf(iostream, "%5s  %7s  %5s\n", "k", "‖rₖ‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %.2fs\n", iter, rNorm, start_time |> ktimer)

    indefinite = false
    solved = rNorm ≤ ε
    tired = iter ≥ itmax
    status = "unknown"
    user_requested_exit = false
    overtimed = false

    # Main loop.
    while ! (solved || tired || (check_curvature & indefinite) || user_requested_exit || overtimed)
      # Form next Lanczos vector.
      # βₖ₊₁Mvₖ₊₁ = Avₖ - δₖMvₖ - βₖMvₖ₋₁
      kmul!(Mv_next, A, v)      # Mvₖ₊₁ ← Avₖ
      δ = kdotr(n, v, Mv_next)  # δₖ = vₖᴴ A vₖ

      # Check curvature. Exit fast if requested.
      # It is possible to show that σₖ² (δₖ - ωₖ₋₁ / γₖ₋₁) = pₖᴴ A pₖ.
      γ = inv(δ - ω / γ)  # γₖ = 1 / (δₖ - ωₖ₋₁ / γₖ₋₁)
      indefinite |= (γ ≤ 0)
      (check_curvature & indefinite) && continue

      kaxpy!(n, -δ, Mv, Mv_next)          # Mvₖ₊₁ ← Mvₖ₊₁ - δₖMvₖ
      if iter > 0
        kaxpy!(n, -β, Mv_prev, Mv_next)   # Mvₖ₊₁ ← Mvₖ₊₁ - βₖMvₖ₋₁
        kcopy!(n, Mv_prev, Mv)            # Mvₖ₋₁ ← Mvₖ
      end
      kcopy!(n, Mv, Mv_next)              # Mvₖ ← Mvₖ₊₁
      MisI || mulorldiv!(v, M, Mv, ldiv)  # vₖ₊₁ = M⁻¹ * Mvₖ₊₁
      β = knorm_elliptic(n, v, Mv)        # βₖ₊₁ = vₖ₊₁ᴴ M vₖ₊₁
      kdiv!(n, v, β)                      # vₖ₊₁  ←  vₖ₊₁ / βₖ₊₁
      MisI || kdiv!(n, Mv, β)             # Mvₖ₊₁ ← Mvₖ₊₁ / βₖ₊₁
      Anorm2 += β_prev^2 + β^2 + δ^2      # Use ‖Tₖ₊₁‖₂ as increasing approximation of ‖A‖₂.
      β_prev = β

      # Compute next CG iterate.
      kaxpy!(n, γ, p, x)      # xₖ₊₁ = xₖ + γₖ * pₖ
      ω = β * γ
      σ = -ω * σ              # σₖ₊₁ = - βₖ₊₁ * γₖ * σₖ
      ω = ω * ω               # ωₖ = (βₖ₊₁ * γₖ)²
      kaxpby!(n, σ, v, ω, p)  # pₖ₊₁ = σₖ₊₁ * vₖ₊₁ + ωₖ * pₖ
      rNorm = abs(σ)          # ‖rₖ₊₁‖_M = |σₖ₊₁| because rₖ₊₁ = σₖ₊₁ * vₖ₊₁ and ‖vₖ₊₁‖_M = 1
      history && push!(rNorms, rNorm)
      iter = iter + 1
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %.2fs\n", iter, rNorm, start_time |> ktimer)

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      resid_decrease_mach = (rNorm + one(T) ≤ one(T))
      
      user_requested_exit = callback(workspace) :: Bool
      resid_decrease_lim = rNorm ≤ ε
      solved = resid_decrease_lim || resid_decrease_mach
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired                          && (status = "maximum number of iterations exceeded")
    (check_curvature & indefinite) && (status = "negative curvature")
    solved                         && (status = "solution good enough given atol and rtol")
    user_requested_exit            && (status = "user-requested exit")
    overtimed                      && (status = "time limit exceeded")

    # Update x
    warm_start && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

    # Update stats. TODO: Estimate Acond.
    stats.niter = iter
    stats.solved = solved
    stats.Anorm = sqrt(Anorm2)
    stats.indefinite = indefinite
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

   # An implementation of LSMR for the solution of the
# over-determined linear least-squares problem
#
#  minimize ‖Ax - b‖₂
#
# equivalently, of the normal equations
#
#  AᴴAx = Aᴴb.
#
# LSMR is formally equivalent to applying MINRES to the normal equations
# but should be more stable. It is also formally equivalent to CRLS though
# LSMR should be expected to be more stable on ill-conditioned or poorly
# scaled problems.
#
# This implementation follows the original implementation by
# Michael Saunders described in
#
# D. C.-L. Fong and M. A. Saunders, LSMR: An Iterative Algorithm for Sparse
# Least Squares Problems, SIAM Journal on Scientific Computing, 33(5),
# pp. 2950--2971, 2011.
#
# Dominique Orban, <dominique.orban@gerad.ca>
# Montreal, QC, May 2015.

export lsmr, lsmr!

"""
    (x, stats) = lsmr(A, b::AbstractVector{FC};
                      M=I, N=I, ldiv::Bool=false,
                      window::Int=5, sqd::Bool=false, λ::T=zero(T),
                      radius::T=zero(T), etol::T=√eps(T),
                      axtol::T=√eps(T), btol::T=√eps(T),
                      conlim::T=1/√eps(T), atol::T=zero(T),
                      rtol::T=zero(T), itmax::Int=0,
                      timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                      callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

Solve the regularized linear least-squares problem

    minimize ‖b - Ax‖₂² + λ²‖x‖₂²

of size m × n using the LSMR method, where λ ≥ 0 is a regularization parameter.
LSMR is formally equivalent to applying MINRES to the normal equations

    (AᴴA + λ²I) x = Aᴴb

(and therefore to CRLS) but is more stable.

LSMR produces monotonic residuals ‖r‖₂ and optimality residuals ‖Aᴴr‖₂.
It is formally equivalent to CRLS, though can be substantially more accurate.

LSMR can be also used to find a null vector of a singular matrix A
by solving the problem `min ‖Aᴴx - b‖` with any nonzero vector `b`.
At a minimizer, the residual vector `r = b - Aᴴx` will satisfy `Ar = 0`.

If `λ > 0`, we solve the symmetric and quasi-definite system

    [ E      A ] [ r ]   [ b ]
    [ Aᴴ  -λ²F ] [ x ] = [ 0 ],

where E and F are symmetric and positive definite.
Preconditioners M = E⁻¹ ≻ 0 and N = F⁻¹ ≻ 0 may be provided in the form of linear operators.
If `sqd=true`, `λ` is set to the common value `1`.

The system above represents the optimality conditions of

    minimize ‖b - Ax‖²_E⁻¹ + λ²‖x‖²_F.

For a symmetric and positive definite matrix `K`, the K-norm of a vector `x` is `‖x‖²_K = xᴴKx`.
LSMR is then equivalent to applying MINRES to `(AᴴE⁻¹A + λ²F)x = AᴴE⁻¹b` with `r = E⁻¹(b - Ax)`.

If `λ = 0`, we solve the symmetric and indefinite system

    [ E    A ] [ r ]   [ b ]
    [ Aᴴ   0 ] [ x ] = [ 0 ].

The system above represents the optimality conditions of

    minimize ‖b - Ax‖²_E⁻¹.

In this case, `N` can still be specified and indicates the weighted norm in which `x` and `Aᴴr` should be measured.
`r` can be recovered by computing `E⁻¹(b - Ax)`.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :lsmr`.

For an in-place variant that reuses memory across solves, see [`lsmr!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `m` used for centered preconditioning of the augmented system;
* `N`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning of the augmented system;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `window`: number of iterations used to accumulate a lower bound on the error;
* `sqd`: if `true`, set `λ=1` for Hermitian quasi-definite systems;
* `λ`: regularization parameter;
* `radius`: add the trust-region constraint ‖x‖ ≤ `radius` if `radius > 0`. Useful to compute a step in a trust-region method for optimization;
* `etol`: stopping tolerance based on the lower bound on the error;
* `axtol`: tolerance on the backward error;
* `btol`: stopping tolerance used to detect zero-residual problems;
* `conlim`: limit on the estimated condition number of `A` beyond which the solution will be abandoned;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `m+n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`LsmrStats`](@ref) structure.

#### Reference

* D. C.-L. Fong and M. A. Saunders, [*LSMR: An Iterative Algorithm for Sparse Least Squares Problems*](https://doi.org/10.1137/10079687X), SIAM Journal on Scientific Computing, 33(5), pp. 2950--2971, 2011.
"""
function lsmr end

"""
    workspace = lsmr!(workspace::LsmrWorkspace, A, b; kwargs...)

In this call, `kwargs` are keyword arguments of [`lsmr`](@ref).
The keyword argument `window` is the only exception.
It is only supported by [`lsmr`](@ref) and is required to create a `LsmrWorkspace`.
It cannot be changed later.

See [`LsmrWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :lsmr` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function lsmr! end

def_args_lsmr = (:(A                    ),
                 :(b::AbstractVector{FC}))

def_kwargs_lsmr = (:(; M = I                        ),
                   :(; N = I                        ),
                   :(; ldiv::Bool = false           ),
                   :(; sqd::Bool = false            ),
                   :(; λ::T = zero(T)               ),
                   :(; radius::T = zero(T)          ),
                   :(; etol::T = √eps(T)            ),
                   :(; axtol::T = √eps(T)           ),
                   :(; btol::T = √eps(T)            ),
                   :(; conlim::T = 1/√eps(T)        ),
                   :(; atol::T = zero(T)            ),
                   :(; rtol::T = zero(T)            ),
                   :(; itmax::Int = 0               ),
                   :(; timemax::Float64 = Inf       ),
                   :(; verbose::Int = 0             ),
                   :(; history::Bool = false        ),
                   :(; callback = workspace -> false),
                   :(; iostream::IO = kstdout       ))

def_kwargs_workspace_lsmr = (:(; window::Int = 5),)

def_kwargs_lsmr = extract_parameters.(def_kwargs_lsmr)
def_kwargs_workspace_lsmr = extract_parameters.(def_kwargs_workspace_lsmr)

args_lsmr = (:A, :b)
kwargs_lsmr = (:M, :N, :ldiv, :sqd, :λ, :radius, :etol, :axtol, :btol, :conlim, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)
kwargs_workspace_lsmr = (:window,)

@eval begin
  function lsmr!(workspace :: LsmrWorkspace{T,FC,Sm,Sn}, $(def_args_lsmr...); $(def_kwargs_lsmr...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "LSMR: system of %d equations in %d variables\n", m, n)

    # Check sqd and λ parameters
    sqd && (λ ≠ 0) && error("sqd cannot be set to true if λ ≠ 0 !")
    sqd && (λ = one(T))

    # Tests M = Iₙ and N = Iₘ
    MisI = (M === I)
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == Sm || error("ktypeof(b) must be equal to $Sm")

    # Compute the adjoint of A
    Aᴴ = A'

    # Set up workspace.
    allocate_if(!MisI, workspace, :u, Sm, workspace.Av)  # The length of u is m
    allocate_if(!NisI, workspace, :v, Sn, workspace.x)   # The length of v is n
    x, Nv, Aᴴu, h, hbar = workspace.x, workspace.Nv, workspace.Aᴴu, workspace.h, workspace.hbar
    Mu, Av, err_vec, stats = workspace.Mu, workspace.Av, workspace.err_vec, workspace.stats
    rNorms, ArNorms = stats.residuals, stats.Aresiduals
    reset!(stats)
    u = MisI ? Mu : workspace.u
    v = NisI ? Nv : workspace.v

    ctol = conlim > 0 ? 1/conlim : zero(T)
    kfill!(x, zero(FC))

    # Initialize Golub-Kahan process.
    # β₁ M u₁ = b.
    kcopy!(m, Mu, b)  # Mu ← b
    MisI || mulorldiv!(u, M, Mu, ldiv)
    β₁ = knorm_elliptic(m, u, Mu)
    if β₁ == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      history && push!(rNorms, zero(T))
      history && push!(ArNorms, zero(T))
      return workspace
    end
    β = β₁

    kdiv!(m, u, β₁)
    MisI || kdiv!(m, Mu, β₁)
    kmul!(Aᴴu, Aᴴ, u)
    kcopy!(n, Nv, Aᴴu)  # Nv ← Aᴴu
    NisI || mulorldiv!(v, N, Nv, ldiv)
    α = knorm_elliptic(n, v, Nv)

    ζbar = α * β
    αbar = α
    ρ = one(T)
    ρbar = one(T)
    cbar = one(T)
    sbar = zero(T)

    # Initialize variables for estimation of ‖r‖.
    βdd = β
    βd = zero(T)
    ρdold = one(T)
    τtildeold = zero(T)
    θtilde = zero(T)
    ζ = zero(T)
    d = zero(T)

    # Initialize variables for estimation of ‖A‖, cond(A) and xNorm.
    Anorm² = α * α
    maxrbar = zero(T)
    minrbar = min(floatmax(T), T(1.0e+100))
    Acond = maxrbar / minrbar
    Anorm = sqrt(Anorm²)
    xNorm = zero(T)

    # Items for use in stopping rules.
    ctol = conlim > 0 ? inv(conlim) : zero(T)
    rNorm = β
    history && push!(rNorms, rNorm)
    ArNorm = ArNorm0 = α * β
    history && push!(ArNorms, ArNorm)

    xENorm² = zero(T)
    err_lbnd = zero(T)
    window = length(err_vec)
    kfill!(err_vec, zero(T))

    iter = 0
    itmax == 0 && (itmax = m + n)

    (verbose > 0) && @printf(iostream, "%5s  %7s  %7s  %7s  %7s  %8s  %8s  %7s  %5s\n", "k", "‖r‖", "‖Aᴴr‖", "β", "α", "cos", "sin", "‖A‖²", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %7.1e  %8.1e  %8.1e  %7.1e  %.2fs\n", iter, β₁, α, β₁, α, 0, 1, Anorm², start_time |> ktimer)

    # Aᴴb = 0 so x = 0 is a minimum least-squares solution
    if α == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a minimum least-squares solution"
      return workspace
    end
    kdiv!(n, v, α)
    NisI || kdiv!(n, Nv, α)

    kcopy!(n, h, v)  # h ← v
    kfill!(hbar, zero(FC))

    status = "unknown"
    on_boundary = false
    solved = solved_mach = solved_lim = (rNorm ≤ axtol)
    tired  = iter ≥ itmax
    ill_cond = ill_cond_mach = ill_cond_lim = false
    zero_resid = zero_resid_mach = zero_resid_lim = false
    fwd_err = false
    user_requested_exit = false
    overtimed = false

    while ! (solved || tired || ill_cond || user_requested_exit || overtimed)
      iter = iter + 1

      # Generate next Golub-Kahan vectors.
      # 1. βₖ₊₁Muₖ₊₁ = Avₖ - αₖMuₖ
      kmul!(Av, A, v)
      kaxpby!(m, one(FC), Av, -α, Mu)
      MisI || mulorldiv!(u, M, Mu, ldiv)
      β = knorm_elliptic(m, u, Mu)
      if β ≠ 0
        kdiv!(m, u, β)
        MisI || kdiv!(m, Mu, β)

        # 2. αₖ₊₁Nvₖ₊₁ = Aᴴuₖ₊₁ - βₖ₊₁Nvₖ
        kmul!(Aᴴu, Aᴴ, u)
        kaxpby!(n, one(FC), Aᴴu, -β, Nv)
        NisI || mulorldiv!(v, N, Nv, ldiv)
        α = knorm_elliptic(n, v, Nv)
        if α ≠ 0
          kdiv!(n, v, α)
          NisI || kdiv!(n, Nv, α)
        end
      end

      # Continue QR factorization
      (chat, shat, αhat) = sym_givens(αbar, λ)

      ρold = ρ
      (c, s, ρ) = sym_givens(αhat, β)
      θnew = s * α
      αbar = c * α

      ρbarold = ρbar
      ζold = ζ
      θbar = sbar * ρ
      ρtemp = cbar * ρ
      (cbar, sbar, ρbar) = sym_givens(ρtemp, θnew)
      ζ = cbar * ζbar
      ζbar = -sbar * ζbar

      xENorm² = xENorm² + ζ * ζ
      err_vec[mod(iter, window) + 1] = ζ
      iter ≥ window && (err_lbnd = knorm(window, err_vec))

      # Update h, hbar and x.
      δ = θbar * ρ / (ρold * ρbarold)   # δₖ = θbarₖ * ρₖ / (ρₖ₋₁ * ρbarₖ₋₁)
      kaxpby!(n, one(FC), h, -δ, hbar)  # ĥₖ = hₖ - δₖ * ĥₖ₋₁

      # if a trust-region constraint is given, compute step to the boundary
      # the step ϕ/ρ is not necessarily positive
      σ = ζ / (ρ * ρbar)
      if radius > 0
        t1, t2 = to_boundary(n, x, hbar, v, radius)
        tmax, tmin = max(t1, t2), min(t1, t2)
        on_boundary = σ > tmax || σ < tmin
        σ = σ > 0 ? min(σ, tmax) : max(σ, tmin)
      end

      kaxpy!(n, σ, hbar, x)                 # xₖ = xₖ₋₁ + σₖ * ĥₖ
      kaxpby!(n, one(FC), v, -θnew / ρ, h)  # hₖ₊₁ = vₖ₊₁ - (θₖ₊₁/ρₖ) * hₖ

      # Estimate ‖r‖.
      βacute =  chat * βdd
      βcheck = -shat * βdd

      βhat =  c * βacute
      βdd  = -s * βacute

      θtildeold = θtilde
      (ctildeold, stildeold, ρtildeold) = sym_givens(ρdold, θbar)
      θtilde = stildeold * ρbar
      ρdold = ctildeold * ρbar
      βd = -stildeold * βd + ctildeold * βhat

      τtildeold = (ζold - θtildeold * τtildeold) / ρtildeold
      τd = (ζ - θtilde * τtildeold) / ρdold
      d = d + βcheck * βcheck
      rNorm = sqrt(d + (βd - τd)^2 + βdd * βdd)
      history && push!(rNorms, rNorm)

      # Estimate ‖A‖.
      Anorm² += β * β
      Anorm   = sqrt(Anorm²)
      Anorm² += α * α

      # Estimate cond(A).
      maxrbar = max(maxrbar, ρbarold)
      iter > 1 && (minrbar = min(minrbar, ρbarold))
      Acond = max(maxrbar, ρtemp) / min(minrbar, ρtemp)

      # Test for convergence.
      ArNorm = abs(ζbar)
      history && push!(ArNorms, ArNorm)
      xNorm = knorm(n, x)

      test1 = rNorm / β₁
      test2 = ArNorm / (Anorm * rNorm)
      test3 = inv(Acond)
      t1    = test1 / (one(T) + Anorm * xNorm / β₁)
      rNormtol  = btol + axtol * Anorm * xNorm / β₁

      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %7.1e  %8.1e  %8.1e  %7.1e  %.2fs\n", iter, rNorm, ArNorm, β, α, c, s, Anorm², start_time |> ktimer)

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      ill_cond_mach = (one(T) + test3 ≤ one(T))
      solved_mach = (one(T) + test2 ≤ one(T))
      zero_resid_mach = (one(T) + t1 ≤ one(T))

      # Stopping conditions based on user-provided tolerances.
      user_requested_exit = callback(workspace) :: Bool
      tired  = iter ≥ itmax
      ill_cond_lim = (test3 ≤ ctol)
      solved_lim = (test2 ≤ axtol)
      solved_opt = ArNorm ≤ atol + rtol * ArNorm0
      zero_resid_lim = (test1 ≤ rNormtol)
      iter ≥ window && (fwd_err = err_lbnd ≤ etol * sqrt(xENorm²))

      ill_cond = ill_cond_mach || ill_cond_lim
      zero_resid = zero_resid_mach || zero_resid_lim
      solved = solved_mach || solved_lim || solved_opt || zero_resid || fwd_err || on_boundary
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    ill_cond_mach       && (status = "condition number seems too large for this machine")
    ill_cond_lim        && (status = "condition number exceeds tolerance")
    solved              && (status = "found approximate minimum least-squares solution")
    zero_resid          && (status = "found approximate zero-residual solution")
    fwd_err             && (status = "truncated forward error small enough")
    on_boundary         && (status = "on trust-region boundary")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update stats
    stats.residual = rNorm
    stats.Aresidual = ArNorm
    stats.Acond = Acond
    stats.Anorm = Anorm
    stats.xNorm = xNorm
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = !zero_resid
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

# An implementation of LNLQ for the solution of the consistent linear system
#
#  Ax = b.
#
# The method seeks to solve the minimum-norm problem
#
#  min ‖x‖  s.t.  Ax = b,
#
# and is equivalent to applying the SYMMLQ method
# to the linear system
#
#  AAᴴy = b with x = Aᴴy and can be reformulated as
#
#  [ -I  Aᴴ ][ x ] = [ 0 ]
#  [  A     ][ y ]   [ b ].
#
# This method is based on the Golub-Kahan bidiagonalization process and is described in
#
# R. Estrin, D. Orban, M.A. Saunders, LNLQ: An Iterative Method for Least-Norm Problems with an Error Minimization Property,
# SIAM Journal on Matrix Analysis and Applications, 40(3), pp. 1102--1124, 2019.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Montréal, March 2019 -- Alès, January 2020.

export lnlq, lnlq!

"""
    (x, y, stats) = lnlq(A, b::AbstractVector{FC};
                         M=I, N=I, ldiv::Bool=false,
                         transfer_to_craig::Bool=true,
                         sqd::Bool=false, λ::T=zero(T),
                         σ::T=zero(T), utolx::T=√eps(T),
                         utoly::T=√eps(T), atol::T=√eps(T),
                         rtol::T=√eps(T), itmax::Int=0,
                         timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                         callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

Find the least-norm solution of the consistent linear system

    Ax + λ²y = b

of size m × n using the LNLQ method, where λ ≥ 0 is a regularization parameter.

For a system in the form Ax = b, LNLQ method is equivalent to applying
SYMMLQ to AAᴴy = b and recovering x = Aᴴy but is more stable.
Note that y are the Lagrange multipliers of the least-norm problem

    minimize ‖x‖  s.t.  Ax = b.

If `λ > 0`, LNLQ solves the symmetric and quasi-definite system

    [ -F    Aᴴ ] [ x ]   [ 0 ]
    [  A  λ²E  ] [ y ] = [ b ],

where E and F are symmetric and positive definite.
Preconditioners M = E⁻¹ ≻ 0 and N = F⁻¹ ≻ 0 may be provided in the form of linear operators.
If `sqd=true`, `λ` is set to the common value `1`.

The system above represents the optimality conditions of

    min ‖x‖²_F + λ²‖y‖²_E  s.t.  Ax + λ²Ey = b.

For a symmetric and positive definite matrix `K`, the K-norm of a vector `x` is `‖x‖²_K = xᴴKx`.
LNLQ is then equivalent to applying SYMMLQ to `(AF⁻¹Aᴴ + λ²E)y = b` with `Fx = Aᴴy`.

If `λ = 0`, LNLQ solves the symmetric and indefinite system

    [ -F   Aᴴ ] [ x ]   [ 0 ]
    [  A   0  ] [ y ] = [ b ].

The system above represents the optimality conditions of

    minimize ‖x‖²_F  s.t.  Ax = b.

In this case, `M` can still be specified and indicates the weighted norm in which residuals are measured.

In this implementation, both the x and y-parts of the solution are returned.

`utolx` and `utoly` are tolerances on the upper bound of the distance to the solution ‖x-x*‖ and ‖y-y*‖, respectively.
The bound is valid if λ>0 or σ>0 where σ should be strictly smaller than the smallest positive singular value.
For instance σ:=(1-1e-7)σₘᵢₙ .

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :lnlq`.

For an in-place variant that reuses memory across solves, see [`lnlq!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `m` used for centered preconditioning of the augmented system;
* `N`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning of the augmented system;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `transfer_to_craig`: transfer from the LNLQ point to the CRAIG point, when it exists. The transfer is based on the residual norm;
* `sqd`: if `true`, set `λ=1` for Hermitian quasi-definite systems;
* `λ`: regularization parameter;
* `σ`: strict lower bound on the smallest positive singular value `σₘᵢₙ` such as `σ = (1-10⁻⁷)σₘᵢₙ`;
* `utolx`: tolerance on the upper bound on the distance to the solution `‖x-x*‖`;
* `utoly`: tolerance on the upper bound on the distance to the solution `‖y-y*‖`;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `m+n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `y`: a dense vector of length `m`;
* `stats`: statistics collected on the run in a [`LNLQStats`](@ref) structure.

#### Reference

* R. Estrin, D. Orban, M.A. Saunders, [*LNLQ: An Iterative Method for Least-Norm Problems with an Error Minimization Property*](https://doi.org/10.1137/18M1194948), SIAM Journal on Matrix Analysis and Applications, 40(3), pp. 1102--1124, 2019.
"""
function lnlq end

"""
    workspace = lnlq!(workspace::LnlqWorkspace, A, b; kwargs...)

In this call, `kwargs` are keyword arguments of [`lnlq`](@ref).

See [`LnlqWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :lnlq` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function lnlq! end

def_args_lnlq = (:(A                    ),
                 :(b::AbstractVector{FC}))

def_kwargs_lnlq = (:(; M = I                         ),
                   :(; N = I                         ),
                   :(; ldiv::Bool = false            ),
                   :(; transfer_to_craig::Bool = true),
                   :(; sqd::Bool = false             ),
                   :(; λ::T = zero(T)                ),
                   :(; σ::T = zero(T)                ),
                   :(; utolx::T = √eps(T)            ),
                   :(; utoly::T = √eps(T)            ),
                   :(; atol::T = √eps(T)             ),
                   :(; rtol::T = √eps(T)             ),
                   :(; itmax::Int = 0                ),
                   :(; timemax::Float64 = Inf        ),
                   :(; verbose::Int = 0              ),
                   :(; history::Bool = false         ),
                   :(; callback = workspace -> false ),
                   :(; iostream::IO = kstdout        ))

def_kwargs_lnlq = extract_parameters.(def_kwargs_lnlq)

args_lnlq = (:A, :b)
kwargs_lnlq = (:M, :N, :ldiv, :transfer_to_craig, :sqd, :λ, :σ, :utolx, :utoly, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function lnlq!(workspace :: LnlqWorkspace{T,FC,Sm,Sn}, $(def_args_lnlq...); $(def_kwargs_lnlq...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "LNLQ: system of %d equations in %d variables\n", m, n)

    # Check sqd and λ parameters
    sqd && (λ ≠ 0) && error("sqd cannot be set to true if λ ≠ 0 !")
    sqd && (λ = one(T))

    # Tests M = Iₘ and N = Iₙ
    MisI = (M === I)
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == Sm || error("ktypeof(b) must be equal to $Sm")

    # Compute the adjoint of A
    Aᴴ = A'

    # Set up workspace.
    allocate_if(!MisI, workspace, :u, Sm, workspace.y)  # The length of u is m
    allocate_if(!NisI, workspace, :v, Sn, workspace.x)  # The length of v is n
    allocate_if(λ > 0, workspace, :q, Sn, workspace.x)  # The length of q is n
    x, Nv, Aᴴu, y, w̄ = workspace.x, workspace.Nv, workspace.Aᴴu, workspace.y, workspace.w̄
    Mu, Av, q, stats = workspace.Mu, workspace.Av, workspace.q, workspace.stats
    rNorms, xNorms, yNorms = stats.residuals, stats.error_bnd_x, stats.error_bnd_y
    reset!(stats)
    u = MisI ? Mu : workspace.u
    v = NisI ? Nv : workspace.v

    # Set up parameter σₑₛₜ for the error estimate on x and y
    σₑₛₜ = √(σ^2 + λ^2)
    complex_error_bnd = false

    # Initial solutions (x₀, y₀) and residual norm ‖r₀‖.
    kfill!(x, zero(FC))
    kfill!(y, zero(FC))

    bNorm = knorm(m, b)
    if bNorm == 0
      stats.niter = 0
      stats.solved = true
      stats.error_with_bnd = false
      history && push!(rNorms, bNorm)
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      return workspace
    end

    history && push!(rNorms, bNorm)
    ε = atol + rtol * bNorm

    iter = 0
    itmax == 0 && (itmax = m + n)

    (verbose > 0) && @printf(iostream, "%5s  %7s  %5s\n", "k", "‖rₖ‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %.2fs\n", iter, bNorm, start_time |> ktimer)

    # Update iteration index.
    iter = iter + 1

    # Initialize generalized Golub-Kahan bidiagonalization.
    # β₁Mu₁ = b.
    kcopy!(m, Mu, b)  # Mu ← b
    MisI || mulorldiv!(u, M, Mu, ldiv)  # u₁ = M⁻¹ * Mu₁
    βₖ = knorm_elliptic(m, u, Mu)       # β₁ = ‖u₁‖_M
    if βₖ ≠ 0
      kdiv!(m, u, βₖ)
      MisI || kdiv!(m, Mu, βₖ)
    end

    # α₁Nv₁ = Aᴴu₁.
    kmul!(Aᴴu, Aᴴ, u)
    kcopy!(n, Nv, Aᴴu)  # Nv ← Aᴴu
    NisI || mulorldiv!(v, N, Nv, ldiv)  # v₁ = N⁻¹ * Nv₁
    αₖ = knorm_elliptic(n, v, Nv)       # α₁ = ‖v₁‖_N
    if αₖ ≠ 0
      kdiv!(n, v, αₖ)
      NisI || kdiv!(n, Nv, αₖ)
    end

    kcopy!(m, w̄, u)       # Direction w̄₁
    cₖ = zero(T)          # Givens cosines used for the LQ factorization of (Lₖ)ᴴ
    sₖ = zero(FC)         # Givens sines used for the LQ factorization of (Lₖ)ᴴ
    ζₖ₋₁ = zero(FC)       # ζₖ₋₁ and ζbarₖ are the last components of z̅ₖ
    θₖ = θₖ₊₁ = zero(FC)  # θₖ and θₖ₊₁ are used to update ζₖ and ζbarₖ₊₁
    ηₖ = zero(FC)         # Coefficient of M̅ₖ

    # Variable used for the regularization.
    λₖ  = λ              # λ₁ = λ
    cpₖ = spₖ = one(T)   # Givens sines and cosines used to zero out λₖ
    cdₖ = sdₖ = one(FC)  # Givens sines and cosines used to define λₖ₊₁
    λ > 0 && kcopy!(n, q, v)  # Additional vector needed to update x, by definition q₀ = 0

    # Initialize the regularization.
    if λ > 0
      #        k    2k      k   2k           k      2k
      # k   [  αₖ   λₖ ] [ cpₖ  spₖ ] = [  αhatₖ    0   ]
      # k+1 [ βₖ₊₁  0  ] [ spₖ -cpₖ ]   [ βhatₖ₊₁  θₖ₊₁ ]
      (cpₖ, spₖ, αhatₖ) = sym_givens(αₖ, λₖ)

      # q̄₁ = sp₁ * v₁
      kscal!(n, spₖ, q)
    else
      αhatₖ = αₖ
    end

    # Begin the LQ factorization of (Lₖ)ᴴ = M̅ₖQₖ.
    # [ α₁ β₂ 0  •  •  •  0 ]   [ ϵ₁  0   •   •   •   •   0   ]
    # [ 0  α₂ •  •        • ]   [ η₂  ϵ₂  •               •   ]
    # [ •  •  •  •  •     • ]   [ 0   •   •   •           •   ]
    # [ •     •  •  •  •  • ] = [ •   •   •   •   •       •   ] Qₖ
    # [ •        •  •  •  0 ]   [ •       •   •   •   •   •   ]
    # [ •           •  •  βₖ]   [ •           •   •   •   0   ]
    # [ 0  •  •  •  •  0  αₖ]   [ 0   •   •   •   0   ηₖ ϵbarₖ]

    ϵbarₖ = αhatₖ  # ϵbar₁ = αhat₁

    # Hₖ = Bₖ(Lₖ)ᴴ = [   Lₖ(Lₖ)ᴴ   ] ⟹ (Hₖ₋₁)ᴴ = [Lₖ₋₁Mₖ₋₁  0] Qₖ
    #                [ αₖβₖ₊₁(eₖ)ᵀ ]
    #
    # Solve Lₖtₖ = β₁e₁ and M̅ₖz̅ₖ = tₖ
    # tₖ = (τ₁, •••, τₖ)
    # z̅ₖ = (zₖ₋₁, ζbarₖ) = (ζ₁, •••, ζₖ₋₁, ζbarₖ)

    τₖ    = βₖ / αhatₖ  # τ₁ = β₁ / αhat₁
    ζbarₖ = τₖ / ϵbarₖ  # ζbar₁ = τ₁ / ϵbar₁
    θₖ    = τₖ

    # Stopping criterion.
    solved_lq = false
    solved_cg = false
    tired = false
    status = "unknown"
    user_requested_exit = false
    overtimed = false

    if σₑₛₜ > 0
      τtildeₖ = βₖ / σₑₛₜ
      ζtildeₖ = τtildeₖ / σₑₛₜ
      err_x = τtildeₖ
      err_y = ζtildeₖ

      solved_lq = err_x ≤ utolx || err_y ≤ utoly
      history && push!(xNorms, err_x)
      history && push!(yNorms, err_y)

      ρbar = -σₑₛₜ
      csig = -one(T)
    end

    while !(solved_lq || solved_cg || tired || user_requested_exit || overtimed)
      # Update of (xᵃᵘˣ)ₖ = Vₖtₖ
      if λ > 0
        # (xᵃᵘˣ)ₖ ← (xᵃᵘˣ)ₖ₋₁ + τₖ * (cpₖvₖ + spₖqₖ₋₁)
        kaxpy!(n, τₖ * cpₖ, v, x)
        if iter ≥ 2
          kaxpy!(n, τₖ * spₖ, q, x)
          # q̄ₖ ← spₖ * vₖ - cpₖ * qₖ₋₁
          kaxpby!(n, spₖ, v, -cpₖ, q)
        end
      else
        # (xᵃᵘˣ)ₖ ← (xᵃᵘˣ)ₖ₋₁ + τₖ * vₖ
        kaxpy!(n, τₖ, v, x)
      end

      # Continue the generalized Golub-Kahan bidiagonalization.
      # AVₖ    = MUₖ₊₁Bₖ
      # AᴴUₖ₊₁ = NVₖ(Bₖ)ᴴ + αₖ₊₁Nvₖ₊₁(eₖ₊₁)ᴴ = NVₖ₊₁(Lₖ₊₁)ᴴ
      #
      #      [ α₁ 0  •  •  •  •  0 ]
      #      [ β₂ α₂ •           • ]
      #      [ 0  •  •  •        • ]
      # Lₖ = [ •  •  •  •  •     • ]
      #      [ •     •  •  •  •  • ]
      #      [ •        •  •  •  0 ]
      #      [ 0  •  •  •  0  βₖ αₖ]
      #
      # Bₖ = [    Lₖ     ]
      #      [ βₖ₊₁(eₖ)ᵀ ]

      # βₖ₊₁Muₖ₊₁ = Avₖ - αₖMuₖ
      kmul!(Av, A, v)
      kaxpby!(m, one(FC), Av, -αₖ, Mu)
      MisI || mulorldiv!(u, M, Mu, ldiv)  # uₖ₊₁ = M⁻¹ * Muₖ₊₁
      βₖ₊₁ = knorm_elliptic(m, u, Mu)     # βₖ₊₁ = ‖uₖ₊₁‖_M
      if βₖ₊₁ ≠ 0
        kdiv!(m, u, βₖ₊₁)
        MisI || kdiv!(m, Mu, βₖ₊₁)
      end

      # αₖ₊₁Nvₖ₊₁ = Aᴴuₖ₊₁ - βₖ₊₁Nvₖ
      kmul!(Aᴴu, Aᴴ, u)
      kaxpby!(n, one(FC), Aᴴu, -βₖ₊₁, Nv)
      NisI || mulorldiv!(v, N, Nv, ldiv)  # vₖ₊₁ = N⁻¹ * Nvₖ₊₁
      αₖ₊₁ = knorm_elliptic(n, v, Nv)     # αₖ₊₁ = ‖vₖ₊₁‖_N
      if αₖ₊₁ ≠ 0
        kdiv!(n, v, αₖ₊₁)
        NisI || kdiv!(n, Nv, αₖ₊₁)
      end

      # Continue the regularization.
      if λ > 0
        #        k    2k      k   2k           k      2k
        # k   [  αₖ   λₖ ] [ cpₖ  spₖ ] = [  αhatₖ    0   ]
        # k+1 [ βₖ₊₁  0  ] [ spₖ -cpₖ ]   [ βhatₖ₊₁  θₖ₊₁ ]
        βhatₖ₊₁ = cpₖ * βₖ₊₁
        θₖ₊₁    = spₖ * βₖ₊₁

        #       2k  2k+1     2k  2k+1       2k  2k+1
        # k   [  0    0 ] [ -cdₖ  sdₖ ] = [ 0    0  ]
        # k+1 [ θₖ₊₁  λ ] [  sdₖ  cdₖ ]   [ 0  λₖ₊₁ ]
        (cdₖ, sdₖ, λₖ₊₁) = sym_givens(λ, θₖ₊₁)

        # qₖ ← sdₖ * q̄ₖ
        kscal!(n, sdₖ, q)

        #       k+1   2k+1      k+1    2k+1        k+1     2k+1
        # k+1 [ αₖ₊₁  λₖ₊₁ ] [ cpₖ₊₁  spₖ₊₁ ] = [ αhatₖ₊₁   0   ]
        # k+2 [ βₖ₊₂   0   ] [ spₖ₊₁ -cpₖ₊₁ ]   [  γₖ₊₂    θₖ₊₂ ]
        (cpₖ₊₁, spₖ₊₁, αhatₖ₊₁) = sym_givens(αₖ₊₁, λₖ₊₁)
      else
        βhatₖ₊₁ = βₖ₊₁
        αhatₖ₊₁ = αₖ₊₁
      end

      if σₑₛₜ > 0 && !complex_error_bnd
        μbar = -csig * αhatₖ
        ρ = √(ρbar^2 + αhatₖ^2)
        csig = ρbar / ρ
        ssig = αhatₖ / ρ
        ρbar = ssig * μbar + csig * σₑₛₜ
        μbar = -csig * βhatₖ₊₁
        θ = βhatₖ₊₁ * csig / ρbar
        ωdisc = σₑₛₜ^2 - σₑₛₜ * βhatₖ₊₁ * θ
        if ωdisc < 0
          complex_error_bnd = true
        else
          ω = √ωdisc
          τtildeₖ = - τₖ * βhatₖ₊₁ / ω
        end

        ρ = √(ρbar^2 + βhatₖ₊₁^2)
        csig = ρbar / ρ
        ssig = βhatₖ₊₁ / ρ
        ρbar = ssig * μbar + csig * σₑₛₜ
      end

      # Update the solution of Lₖ₊₁tₖ₊₁ = β₁e₁.
      # [βhatₖ₊₁  αhatₖ₊₁] [τₖ  ] = [0]
      #                    [τₖ₊₁]
      τₖ₊₁ = - βhatₖ₊₁ * τₖ / αhatₖ₊₁

      # Continue the LQ factorization of (Lₖ₊₁)ᴴ.
      # [ηₖ  ϵbarₖ  βₖ₊₁] [1     0     0 ] = [ηₖ  ϵₖ     0    ]
      # [0     0    αₖ₊₁] [0   cₖ₊₁  sₖ₊₁]   [0  ηₖ₊₁  ϵbarₖ₊₁]
      #                   [0   sₖ₊₁ -cₖ₊₁]
      (cₖ₊₁, sₖ₊₁, ϵₖ) = sym_givens(ϵbarₖ, βhatₖ₊₁)
      ηₖ₊₁    =  αhatₖ₊₁ * sₖ₊₁
      ϵbarₖ₊₁ = -αhatₖ₊₁ * cₖ₊₁

      # Update the solution of M̅ₖ₊₁z̅ₖ₊₁ = tₖ₊₁.
      # [ηₖ  ϵₖ       0   ] [ζₖ₋₁   ] = [τₖ  ]
      # [0   ηₖ₊₁  ϵbarₖ₊₁] [ζₖ     ]   [τₖ₊₁]
      #                     [ζbarₖ₊₁]
      ζₖ      = θₖ / ϵₖ
      θₖ₊₁    = τₖ₊₁ - ηₖ₊₁ * ζₖ
      ζbarₖ₊₁ = θₖ₊₁ / ϵbarₖ₊₁

      # Relations for the directions wₖ and w̄ₖ₊₁
      # [w̄ₖ uₖ₊₁] [cₖ₊₁  sₖ₊₁] = [wₖ w̄ₖ₊₁] → wₖ   = cₖ₊₁ * w̄ₖ + sₖ₊₁ * uₖ₊₁
      #           [sₖ₊₁ -cₖ₊₁]             → w̄ₖ₊₁ = sₖ₊₁ * w̄ₖ - cₖ₊₁ * uₖ₊₁

      # (yᴸ)ₖ₊₁ ← (yᴸ)ₖ + ζₖ * wₖ
      kaxpy!(m, ζₖ * cₖ₊₁, w̄, y)
      kaxpy!(m, ζₖ * sₖ₊₁, u, y)

      # Compute w̄ₖ₊₁
      kaxpby!(m, -cₖ₊₁, u, sₖ₊₁, w̄)

      if σₑₛₜ > 0 && !complex_error_bnd
        if transfer_to_craig
          disc_x = τtildeₖ^2 - τₖ₊₁^2
          disc_x < 0 ? complex_error_bnd = true : err_x = √disc_x
        else
          disc_xL = τtildeₖ^2 - τₖ₊₁^2 + (τₖ₊₁ - ηₖ₊₁ * ζₖ)^2
          disc_xL < 0 ? complex_error_bnd = true : err_x = √disc_xL
        end
        ηtildeₖ = ω * sₖ₊₁
        ϵtildeₖ = -ω * cₖ₊₁
        ζtildeₖ = (τtildeₖ - ηtildeₖ * ζₖ) / ϵtildeₖ
        
        if transfer_to_craig
          disc_y = ζtildeₖ^2 - ζbarₖ₊₁^2
          disc_y < 0 ? complex_error_bnd = true : err_y = √disc_y
        else
          err_y = abs(ζtildeₖ)
        end

        history && push!(xNorms, err_x)
        history && push!(yNorms, err_y)
      end

      # Compute residual norm ‖(rᴸ)ₖ‖ = |αₖ| * √(|ϵbarₖζbarₖ|² + |βₖ₊₁sₖζₖ₋₁|²)
      if iter == 1
        rNorm_lq = bNorm
      else
        rNorm_lq = abs(αhatₖ) * √(abs2(ϵbarₖ * ζbarₖ) + abs2(βhatₖ₊₁ * sₖ * ζₖ₋₁))
      end
      history && push!(rNorms, rNorm_lq)

      # Compute residual norm ‖(rᶜ)ₖ‖ = |βₖ₊₁ * τₖ|
      if transfer_to_craig
        rNorm_cg = abs(βhatₖ₊₁ * τₖ)
      end

      # Update stopping criterion.
      user_requested_exit = callback(workspace) :: Bool
      tired = iter ≥ itmax
      solved_lq = rNorm_lq ≤ ε
      solved_cg = transfer_to_craig && (abs(ζbarₖ) > eps(T)) && (rNorm_cg ≤ ε)
      if σₑₛₜ > 0
        solved_lq = solved_lq || err_x ≤ utolx || err_y ≤ utoly
        solved_cg = transfer_to_craig && (solved_cg || err_x ≤ utolx || err_y ≤ utoly)
      end
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %.2fs\n", iter, rNorm_lq, start_time |> ktimer)

      # Update sₖ, cₖ, αₖ, βₖ, ηₖ, θₖ, ϵbarₖ, τₖ, ζₖ₋₁ and ζbarₖ.
      cₖ    = cₖ₊₁
      sₖ    = sₖ₊₁
      αₖ    = αₖ₊₁
      αhatₖ = αhatₖ₊₁
      βₖ    = βₖ₊₁
      ηₖ    = ηₖ₊₁
      θₖ    = θₖ₊₁
      ϵbarₖ = ϵbarₖ₊₁
      τₖ    = τₖ₊₁
      ζₖ₋₁  = ζₖ
      ζbarₖ = ζbarₖ₊₁

      # Update regularization variables.
      if λ > 0
        cpₖ = cpₖ₊₁
        spₖ = spₖ₊₁
      end

      # Update iteration index.
      iter = iter + 1
    end
    (verbose > 0) && @printf(iostream, "\n")

    if solved_cg && (ζbarₖ > eps(T))
      if λ > 0
        # (xᶜ)ₖ ← (xᵃᵘˣ)ₖ₋₁ + τₖ * (cpₖvₖ + spₖqₖ₋₁)
        kaxpy!(n, τₖ * cpₖ, v, x)
        if iter ≥ 2
          kaxpy!(n, τₖ * spₖ, q, x)
        end
      else
        # (xᶜ)ₖ ← (xᵃᵘˣ)ₖ₋₁ + τₖ * vₖ
        kaxpy!(n, τₖ, v, x)
      end
      # (yᶜ)ₖ ← (yᴸ)ₖ₋₁ + ζbarₖ * w̄ₖ
      kaxpy!(m, ζbarₖ, w̄, y)
    else
      if λ > 0
        # (xᴸ)ₖ ← (xᵃᵘˣ)ₖ₋₁ + ηₖζₖ₋₁ * (cpₖvₖ + spₖqₖ₋₁)
        kaxpy!(n, ηₖ * ζₖ₋₁ * cpₖ, v, x)
        if iter ≥ 2
          kaxpy!(n, ηₖ * ζₖ₋₁ * spₖ, q, x)
        end
      else
        # (xᴸ)ₖ ← (xᵃᵘˣ)ₖ₋₁ + ηₖζₖ₋₁ * vₖ
        kaxpy!(n, ηₖ * ζₖ₋₁, v, x)
      end
    end

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    solved_lq           && (status = "solutions (xᴸ, yᴸ) good enough for the tolerances given")
    solved_cg           && (status = "solutions (xᶜ, yᶜ) good enough for the tolerances given")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update stats
    stats.niter = iter
    stats.solved = solved_lq || solved_cg
    stats.error_with_bnd = complex_error_bnd
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

# An implementation of MINARES.
#
# This method is described in
#
# A. Montoison, D. Orban and M. A. Saunders
# MinAres: An Iterative Solver for Symmetric Linear Systems
# SIAM Journal on Matrix Analysis and Applications, 46(1), pp. 509--529, 2025.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Palo Alto, March 2022.

export minares, minares!

"""
    (x, stats) = minares(A, b::AbstractVector{FC};
                         M=I, ldiv::Bool=false,
                         λ::T = zero(T), atol::T=√eps(T),
                         rtol::T=√eps(T), Artol::T = √eps(T),
                         itmax::Int=0, timemax::Float64=Inf,
                         verbose::Int=0, history::Bool=false,
                         callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = minares(A, b, x0::AbstractVector; kwargs...)

MINARES can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above.

MINARES solves the Hermitian linear system Ax = b of size n.
MINARES minimizes ‖Arₖ‖₂ when M = Iₙ and ‖AMrₖ‖_M otherwise.
The estimates computed every iteration are ‖Mrₖ‖₂ and ‖AMrₖ‖_M.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :minares`.

For an in-place variant that reuses memory across solves, see [`minares!`](@ref).

#### Input arguments

* `A`: a linear operator that models a Hermitian (possibly singular) matrix of dimension `n`;
* `b`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning;
* `ldiv`: define whether the preconditioner uses `ldiv!` or `mul!`;
* `λ`: regularization parameter;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `Artol`: relative stopping tolerance based on the Aᴴ-residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### Reference

* A. Montoison, D. Orban and M. A. Saunders, [*MinAres: An Iterative Solver for Symmetric Linear Systems*](https://doi.org/10.1137/23M1605454), SIAM Journal on Matrix Analysis and Applications, 46(1), pp. 509--529, 2025.
"""
function minares end

"""
    workspace = minares!(workspace::MinaresWorkspace, A, b; kwargs...)
    workspace = minares!(workspace::MinaresWorkspace, A, b, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`minares`](@ref).

See [`MinaresWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :minares` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function minares! end

def_args_minares = (:(A                    ),
                    :(b::AbstractVector{FC}))

def_optargs_minares = (:(x0::AbstractVector),)

def_kwargs_minares = (:(; M = I                        ),
                      :(; ldiv::Bool = false           ),
                      :(; λ::T = zero(T)               ),
                      :(; atol::T = √eps(T)            ),
                      :(; rtol::T = √eps(T)            ),
                      :(; Artol::T = √eps(T)           ),
                      :(; itmax::Int = 0               ),
                      :(; timemax::Float64 = Inf       ),
                      :(; verbose::Int = 0             ),
                      :(; history::Bool = false        ),
                      :(; callback = workspace -> false),
                      :(; iostream::IO = kstdout       ))

def_kwargs_minares = extract_parameters.(def_kwargs_minares)

args_minares = (:A, :b)
optargs_minares = (:x0,)
kwargs_minares = (:M, :ldiv, :λ, :atol, :rtol, :Artol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function minares!(workspace :: MinaresWorkspace{T,FC,S}, $(def_args_minares...); $(def_kwargs_minares...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    n, m = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("System must be square")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "MINARES: system of size %d\n", n)

    # Tests M = Iₙ
    MisI = (M === I)
    !MisI && error("Preconditioners are not yet supported")

    # Check type consistency
    eltype(A) == FC || error("eltype(A) ≠ $FC")
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")

    # Set up workspace.
    Δx, vₖ, vₖ₊₁, x, q, stats = workspace.Δx, workspace.vₖ, workspace.vₖ₊₁, workspace.x, workspace.q, workspace.stats
    wₖ₋₂, wₖ₋₁ = workspace.wₖ₋₂, workspace.wₖ₋₁
    dₖ₋₂, dₖ₋₁ = workspace.dₖ₋₂, workspace.dₖ₋₁
    warm_start = workspace.warm_start
    rNorms, ArNorms = stats.residuals, stats.Aresiduals
    reset!(stats)

    iter = 0
    itmax == 0 && (itmax = 2*n)

    kfill!(x, zero(FC))  # x₀

    # Initialize the Lanczos process.
    # β₁v₁ = r₀
    if warm_start
      kmul!(vₖ, A, Δx)  # r₀ = b - Ax₀
      (λ ≠ 0) && kaxpy!(n, λ, Δx, vₖ)
      kaxpby!(n, one(FC), b, -one(FC), vₖ)
    else
      kcopy!(n, vₖ, b)  # r₀ = b
    end
    βₖ = knorm(n, vₖ)  # β₁ = ‖v₁‖
    if βₖ ≠ 0
      kdiv!(n, vₖ, βₖ)
    end
    β₁ = βₖ

    # β₂v₂ = (A + λI)v₁ - α₁v₁
    kmul!(vₖ₊₁, A, vₖ)
    if λ ≠ 0
      kaxpy!(n, λ, vₖ, vₖ₊₁)
    end
    αₖ = kdotr(n, vₖ, vₖ₊₁)   # α₁ = (vₖ)ᵀ(A + λI)vₖ
    kaxpy!(n, -αₖ, vₖ, vₖ₊₁)
    βₖ₊₁ = knorm(n, vₖ₊₁)    # β₂ = ‖v₂‖
    if βₖ₊₁ ≠ 0
      kdiv!(n, vₖ₊₁, βₖ₊₁)
    end

    ξₖ₋₁ = zero(T)
    τₖ₋₂ = τₖ₋₁ = τₖ = zero(T)
    θbarₖ₋₂ = zero(T)
    ψbisₖ₋₂ = ψbarₖ₋₁ = zero(T)
    πₖ₋₂ = πₖ₋₁ = πₖ = zero(T)
    χbarₖ = zero(T)
    ζbisₖ = ζbarₖ₊₁ = γbarₖ = zero(T)
    λbarₖ = γₖ₋₁ = zero(T)
    c̃₂ₖ₋₄ = s̃₂ₖ₋₄ = zero(T)
    c̃₂ₖ₋₃ = s̃₂ₖ₋₃ = zero(T)
    c̃₂ₖ₋₂ = s̃₂ₖ₋₂ = zero(T)
    c̃₂ₖ₋₁ = s̃₂ₖ₋₁ = zero(T)
    c̃₂ₖ   = s̃₂ₖ   = zero(T)
    kfill!(wₖ₋₂, zero(FC))  # Column k-2 of Wₖ = Vₖ(Rₖ)⁻¹
    kfill!(wₖ₋₁, zero(FC))  # Column k-1 of Wₖ = Vₖ(Rₖ)⁻¹
    kfill!(dₖ₋₂, zero(FC))  # Column k-2 of Dₖ = Wₖ(Uₖ)⁻¹
    kfill!(dₖ₋₁, zero(FC))  # Column k-1 of Dₖ = Wₖ(Uₖ)⁻¹
    β₁α₁ = βₖ * αₖ           # Variable used to update zₖ
    β₁β₂ = βₖ * βₖ₊₁         # Variable used to update zₖ
    ϵₖ₋₂ = ϵₖ₋₁ = zero(T)
    ℓ = itmax + 2

    rNorm = β₁
    ε = atol + rtol * rNorm
    history && push!(rNorms, rNorm)

    ArNorm = sqrt(β₁α₁^2 + β₁β₂^2)
    κ = atol + Artol * ArNorm
    history && push!(ArNorms, ArNorm)

    if rNorm == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    (verbose > 0) && @printf(iostream, "%5s  %7s  %7s  %7s  %8s  %5s\n", "k", "‖rₖ‖", "‖Arₖ‖", "βₖ₊₁", "ζₖ", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %8s  %.2fs\n", iter, rNorm, ArNorm, β₁, " ✗ ✗ ✗ ✗", start_time |> ktimer)

    # Tolerance for breakdown detection.
    btol = eps(T)^(3/4)

    # Stopping criterion.
    solved = (rNorm ≤ ε) || (ArNorm ≤ κ)
    breakdown = false
    tired = iter ≥ itmax
    user_requested_exit = false
    status = "unknown"
    overtimed = false

    while !(solved || tired || breakdown || user_requested_exit || overtimed)
      # Update iteration index.
      iter = iter + 1

      # Update the QR factorization Tₖ₊₁.ₖ = Qₖ [ Rₖ ].
      #                                         [ Oᵀ ]
      #
      # [ α₁ β₂ 0  •  •  •   0  ]      [ λ₁ γ₁ ϵ₁ 0  •  •  0  ]
      # [ β₂ α₂ β₃ •         •  ]      [ 0  λ₂ γ₂ •  •     •  ]
      # [ 0  •  •  •  •      •  ]      [ •  •  λ₃ •  •  •  •  ]
      # [ •  •  •  •  •  •   •  ] = Qₖ [ •     •  •  •  •  0  ]
      # [ •     •  •  •  •   0  ]      [ •        •  •  • ϵₖ₋₂]
      # [ •        •  •  •   βₖ ]      [ •           •  • γₖ₋₁]
      # [ •           •  βₖ  αₖ ]      [ 0  •  •  •  •  0  λₖ ]
      # [ 0  •  •  •  •  0  βₖ₊₁]      [ 0  •  •  •  •  •  0  ]

      (iter == 1) && (λbarₖ = αₖ)
      (iter == 1) && (γbarₖ = βₖ₊₁)

      # Compute the Givens reflection Qₖ.ₖ₊₁
      # [ cₖ  sₖ ] [ λbarₖ γbarₖ   0  ] = [ λₖ    γₖ      ϵₖ   ]
      # [ sₖ -cₖ ] [ βₖ₊₁  αₖ₊₁  βₖ₊₂ ]   [ 0  λbarₖ₊₁ γbarₖ₊₁ ]
      (cₖ, sₖ, λₖ) = sym_givens(λbarₖ, βₖ₊₁)

      # Compute the direction wₖ, the last column of Wₖ = Vₖ(Rₖ)⁻¹ ⟷ (Rₖ)ᵀ(Wₖ)ᵀ = (Vₖ)ᵀ.
      # w₁ = v₁ / λ₁
      if iter == 1
        wₖ = wₖ₋₁
        kdivcopy!(n, wₖ, vₖ, λₖ)
      end
      # w₂ = (v₂ - γ₁w₁) / λ₂
      if iter == 2
        wₖ = wₖ₋₂
        kaxpy!(n, -γₖ₋₁, wₖ₋₁, wₖ)
        kaxpy!(n, one(T), vₖ, wₖ)
        kdiv!(n, wₖ, λₖ)
      end
      # wₖ = (vₖ - γₖ₋₁wₖ₋₁ - ϵₖ₋₂wₖ₋₂) / λₖ
      if iter ≥ 3
        kscal!(n, -ϵₖ₋₂, wₖ₋₂)
        wₖ = wₖ₋₂
        kaxpy!(n, -γₖ₋₁, wₖ₋₁, wₖ)
        kaxpy!(n, one(T), vₖ, wₖ)
        kdiv!(n, wₖ, λₖ)
      end

      # Continue the Lanczos process.
      # M(A + λI)Vₖ₊₁ = Vₖ₊₂Tₖ₊₂.ₖ₊₁
      # βₖ₊₂vₖ₊₂ = M(A + λI)vₖ₊₁ - αₖ₊₁vₖ₊₁ - βₖ₊₁vₖ
      if iter ≤ ℓ-1
        kmul!(q, A, vₖ₊₁)  # q ← Avₖ
        kaxpby!(n, one(T), q, -βₖ₊₁, vₖ)  # Forms vₖ₊₂ : vₖ ← Avₖ₊₁ - βₖ₊₁vₖ
        if λ ≠ 0
          kaxpy!(n, λ, vₖ₊₁, vₖ)          # vₖ ← vₖ + λvₖ₊₁
        end
        αₖ₊₁ = kdotr(n, vₖ, vₖ₊₁)         # αₖ₊₁ = ⟨(A + λI)vₖ₊₁ - βₖ₊₁vₖ , vₖ₊₁⟩
        kaxpy!(n, -αₖ₊₁, vₖ₊₁, vₖ)        # vₖ ← vₖ - αₖ₊₁vₖ₊₁
        βₖ₊₂ = knorm(n, vₖ)               # βₖ₊₂ = ‖vₖ₊₂‖
      
        # Detection of early termination
        if βₖ₊₂ ≤ btol
          ℓ = iter + 1
        else
          kdiv!(n, vₖ, βₖ₊₂)
        end
      end

      # Apply the Givens reflection Qₖ.ₖ₊₁
      if iter ≤ ℓ-2
        ϵₖ      =  sₖ * βₖ₊₂
        γbarₖ₊₁ = -cₖ * βₖ₊₂
      end
      if iter ≤ ℓ-1
        γₖ      = cₖ * γbarₖ + sₖ * αₖ₊₁
        λbarₖ₊₁ = sₖ * γbarₖ - cₖ * αₖ₊₁
      end

      # Update the QR factorization Nₖ = Q̃ₖ [ Uₖ ].
      #                                     [ Oᵀ ]
      #
      # [ λ₁  0   •   •   •    •   0  ]      [ μ₁  ϕ₁  ρ₁  0   •    •   0    ]
      # [ γ₁  λ₂  •                •  ]      [ 0   μ₂  ϕ₂  •   •        •    ]
      # [ ϵ₁  γ₂  λ₃  •            •  ]      [ •   •   μ₃  •   •    •   •    ]
      # [ 0   •   •   •   •        •  ]      [ •       •   •   •    •   0    ]
      # [ •   •   •   •   •    •   •  ] = Q̃ₖ [ •           •  μₖ₋₂ ϕₖ₋₂ ρₖ₋₂ ]
      # [ •       •   •   •    •   0  ]      [ •               •   μₖ₋₁ ϕₖ₋₁ ]
      # [ •           •  ϵₖ₋₂ γₖ₋₁ λₖ ]      [ •                    •   μₖ   ]
      # [ •               •   ϵₖ₋₁ γₖ ]      [ 0   •   •   •   •    •   0    ]
      # [ 0  •    •   •   •    0   ϵₖ ]      [ 0   •   •   •   •    •   0    ]

      # If k = 1, we don't have any previous reflection.
      # If k = 2, we apply the reflections Q̃ₖ₊₁.ₖ₋₁ and Q̃ₖ.ₖ₋₁.
      # If k ≥ 3, we apply the reflections Q̃ₖ.ₖ₋₁, Q̃ₖ₊₁.ₖ₋₁ and Q̃ₖ.ₖ₋₂.

      if iter ≥ 3
        # Apply previous reflection Q̃ₖ.ₖ₋₂
        # [ c̃₂ₖ₋₄      s̃₂ₖ₋₄ ] [   0   ]   [ ρₖ₋₂  ] 
        # [        1         ] [   0   ] = [   0   ]
        # [ s̃₂ₖ₋₄     -c̃₂ₖ₋₄ ] [   λₖ  ]   [ λhatₖ ]
        ρₖ₋₂  =  s̃₂ₖ₋₄ * λₖ
        λhatₖ = -c̃₂ₖ₋₄ * λₖ
      end
   
      iter == 2 && (λhatₖ = λₖ)
      if iter ≥ 2
        # Apply previous reflection Q̃ₖ.ₖ₋₁
        # [ c̃₂ₖ₋₃   s̃₂ₖ₋₃    ] [   0   ]   [ ϕbarₖ₋₁ ]
        # [ s̃₂ₖ₋₃  -c̃₂ₖ₋₃    ] [ λhatₖ ] = [  μbarₖ  ]
        # [                1 ] [   γₖ  ]   [    γₖ   ]
        ϕbarₖ₋₁ =  s̃₂ₖ₋₃ * λhatₖ
        μbarₖ   = -c̃₂ₖ₋₃ * λhatₖ

        if iter ≤ ℓ-1
          # Apply previous reflection Q̃ₖ₊₁.ₖ₋₁
          # [ c̃₂ₖ₋₂      s̃₂ₖ₋₂ ] [ ϕbarₖ₋₁ ]   [  ϕₖ₋₁  ]
          # [        1         ] [  μbarₖ  ] = [  μbarₖ ]
          # [ s̃₂ₖ₋₂     -c̃₂ₖ₋₂ ] [    γₖ   ]   [  γhatₖ ]
          ϕₖ₋₁  = c̃₂ₖ₋₂ * ϕbarₖ₋₁ + s̃₂ₖ₋₂ * γₖ
          γhatₖ = s̃₂ₖ₋₂ * ϕbarₖ₋₁ - c̃₂ₖ₋₂ * γₖ
        else
          ϕₖ₋₁ = ϕbarₖ₋₁
        end
      end

      iter == 1 && (μbarₖ = λₖ)
      iter == 1 && (γhatₖ = γₖ)
      if iter ≤ ℓ-1
        # Compute and apply current Givens reflection Q̃ₖ₊₁.ₖ
        # [ c̃₂ₖ₋₁   s̃₂ₖ₋₁    ] [ μbarₖ ] = [ μbisₖ ]
        # [ s̃₂ₖ₋₁  -c̃₂ₖ₋₁    ] [ γhatₖ ]   [   0   ]
        # [                1 ] [  ϵₖ   ]   [   ϵₖ  ]
        (c̃₂ₖ₋₁, s̃₂ₖ₋₁, μbisₖ) = sym_givens(μbarₖ, γhatₖ)
      else
        μbisₖ = μbarₖ
      end

      if iter ≤ ℓ-2
        # Compute and apply current Givens reflection Q̃ₖ₊₂.ₖ
        # [ c̃₂ₖ      s̃₂ₖ ] [ μbisₖ ] = [ μₖ ] 
        # [      1       ] [   0   ]   [ 0  ]
        # [ s̃₂ₖ     -c̃₂ₖ ] [   ϵₖ  ]   [ 0  ]
        (c̃₂ₖ, s̃₂ₖ, μₖ) = sym_givens(μbisₖ, ϵₖ)
      else
        μₖ = μbisₖ
      end

      # Update zₖ = (Q̃ₖ)ᵀ(β₁α₁e₁ + β₁β₂e₂)
      iter == 1 && (ζbisₖ   = β₁α₁)
      iter == 1 && (ζbarₖ₊₁ = β₁β₂)

      if iter ≤ ℓ-1
        # [ c̃₂ₖ₋₁   s̃₂ₖ₋₁    ] [  ζbisₖ  ] = [ ζringₖ  ]
        # [ s̃₂ₖ₋₁  -c̃₂ₖ₋₁    ] [ ζbarₖ₊₁ ]   [ ζbisₖ₊₁ ]
        # [                1 ] [    0    ]   [    0    ]
        ζringₖ  = c̃₂ₖ₋₁ * ζbisₖ + s̃₂ₖ₋₁ * ζbarₖ₊₁
        ζbisₖ₊₁ = s̃₂ₖ₋₁ * ζbisₖ - c̃₂ₖ₋₁ * ζbarₖ₊₁
      else
        ζringₖ = ζbisₖ
      end

      if iter ≤ ℓ-2
        # [ c̃₂ₖ      s̃₂ₖ ] [ ζringₖ  ] = [   ζₖ    ]
        # [      1       ] [ ζbisₖ₊₁ ]   [ ζbisₖ₊₁ ]
        # [ s̃₂ₖ     -c̃₂ₖ ] [    0    ]   [ ζbarₖ₊₂ ]
        ζₖ      = c̃₂ₖ * ζringₖ
        ζbarₖ₊₂ = s̃₂ₖ * ζringₖ
      else
        ζₖ = ζringₖ
      end

      # Compute the direction dₖ, the last column of Dₖ = Wₖ(Uₖ)⁻¹ ⟷ (Uₖ)ᵀ(Dₖ)ᵀ = (Wₖ)ᵀ.
      # d₁ = w₁ / μ₁
      if iter == 1
        dₖ = dₖ₋₁
        kdivcopy!(n, dₖ, wₖ, μₖ)
      end
      # d₂ = (w₂ - ϕ₁d₁) / μ₂
      if iter == 2
        dₖ = dₖ₋₂
        kaxpy!(n, -ϕₖ₋₁, dₖ₋₁, dₖ)
        kaxpy!(n, one(T), wₖ, dₖ)
        kdiv!(n, dₖ, μₖ)
      end
      # dₖ = (wₖ - ϕₖ₋₁dₖ₋₁ - ρₖ₋₂dₖ₋₂) / μₖ
      if iter ≥ 3
        kscal!(n, -ρₖ₋₂, dₖ₋₂)
        dₖ = dₖ₋₂
        kaxpy!(n, -ϕₖ₋₁, dₖ₋₁, dₖ)
        kaxpy!(n, one(T), wₖ, dₖ)
        kdiv!(n, dₖ, μₖ)
      end

      # x = Vₖyₖ = Dₖzₖ = x₋₁ + ζₖdₖ
      kaxpy!(n, ζₖ, dₖ, x)

      # Update ‖Arₖ‖ estimate
      (iter ≤ ℓ-2)  && (ArNorm = sqrt(ζbisₖ₊₁^2 + ζbarₖ₊₂^2))
      (iter == ℓ-1) && (ArNorm = abs(ζbisₖ₊₁))
      (iter == ℓ)   && (ArNorm = zero(T))
      history && push!(ArNorms, ArNorm)

      # Update the LQ factorization Uₖ = L̂ₖP̂ₖ.
      #
      # [ μ₁  ϕ₁  ρ₁  0   •    •   0    ]   [ ψ₁   0    •    •     •      •      0  ]
      # [ 0   μ₂  ϕ₂  •   •        •    ]   [ θ₁   ψ₂   •                        •  ] 
      # [ •   •   μ₃  •   •    •   •    ]   [ ω₁   θ₂   ψ₃   •                   •  ]
      # [ •       •   •   •    •   0    ] = [ 0    •    •    •     •             •  ] Pₖ
      # [ •           •  μₖ₋₂ ϕₖ₋₂ ρₖ₋₂ ]   [ •    •    •    •   ψₖ₋₂     •      •  ]
      # [ •                   μₖ₋₁ ϕₖ₋₁ ]   [ •         •    •   θₖ₋₂  ψbisₖ₋₁   0  ]
      # [ •                        μₖ   ]   [ 0    •    •    0   ωₖ₋₂  θbarₖ₋₁ ψbarₖ]

      if iter == 1
        ψbarₖ = μₖ
      elseif iter == 2
        # [ ψbar₁  ϕ₁ ] [ ĉ₁   ŝ₁ ] = [ ψbis₁    0   ]
        # [   0    μ₂ ] [ ŝ₁  -ĉ₁ ]   [ θbar₁  ψbar₂ ]
        (ĉ₂ₖ₋₃, ŝ₂ₖ₋₃, ψbisₖ₋₁) = sym_givens(ψbarₖ₋₁, ϕₖ₋₁)
        θbarₖ₋₁ =  ŝ₂ₖ₋₃ * μₖ
        ψbarₖ   = -ĉ₂ₖ₋₃ * μₖ
      else
        # [ ψbisₖ₋₂   0     ρₖ₋₂ ] [ ĉ₂ₖ₋₄      ŝ₂ₖ₋₄ ]   [ ψₖ₋₂     0     0  ]
        # [ θbarₖ₋₂ ψbarₖ₋₁ ϕₖ₋₁ ] [        1         ] = [ θₖ₋₂  ψbarₖ₋₁  δₖ ]
        # [   0       0      μₖ  ] [ ŝ₂ₖ₋₄     -ĉ₂ₖ₋₄ ]   [ ωₖ₋₂     0     ηₖ ]
        (ĉ₂ₖ₋₄, ŝ₂ₖ₋₄, ψₖ₋₂) = sym_givens(ψbisₖ₋₂, ρₖ₋₂)
        θₖ₋₂ =  ĉ₂ₖ₋₄ * θbarₖ₋₂ + ŝ₂ₖ₋₄ * ϕₖ₋₁
        δₖ   =  ŝ₂ₖ₋₄ * θbarₖ₋₂ - ĉ₂ₖ₋₄ * ϕₖ₋₁
        ωₖ₋₂ =  ŝ₂ₖ₋₄ * μₖ
        ηₖ   = -ĉ₂ₖ₋₄ * μₖ

        # [ ψₖ₋₂     0     0  ] [ 1                ]   [ ψₖ₋₂    0        0   ]
        # [ θₖ₋₂  ψbarₖ₋₁  δₖ ] [    ĉ₂ₖ₋₃   ŝ₂ₖ₋₃ ] = [ θₖ₋₂  ψbisₖ₋₁    0   ]
        # [ ωₖ₋₂     0     ηₖ ] [    ŝ₂ₖ₋₃  -ĉ₂ₖ₋₃ ]   [ ωₖ₋₂  θbarₖ₋₁  ψbarₖ ]
        (ĉ₂ₖ₋₃, ŝ₂ₖ₋₃, ψbisₖ₋₁) = sym_givens(ψbarₖ₋₁, δₖ)
        θbarₖ₋₁ =  ŝ₂ₖ₋₃ * ηₖ
        ψbarₖ   = -ĉ₂ₖ₋₃ * ηₖ
      end

      # Solve L̂ₖtₖ = zₖ
      # [ ψ₁   0    •    •     •      •      0  ] [τ₁]   [ζ₁]
      # [ θ₁   ψ₂   •                        •  ] [τ₂]   [ζ₂]
      # [ ω₁   θ₂   ψ₃   •                   •  ] [τ₃]   [ζ₃]
      # [ 0    •    •    •     •             •  ] [••] = [••]
      # [ •    •    •    •   ψₖ₋₂     •      •  ] [••]   [••]
      # [ •         •    •   θₖ₋₂  ψbisₖ₋₁   0  ] [••]   [••]
      # [ 0    •    •    0   ωₖ₋₂  θbarₖ₋₁ ψbarₖ] [τₖ]   [ζₖ]
      if iter == 1
        τₖ = ζₖ / ψbarₖ
      elseif iter == 2
        τₖ₋₁ = τₖ
        τₖ₋₁ = τₖ₋₁ * ψbarₖ₋₁ / ψbisₖ₋₁
        ξₖ   = ζₖ
        τₖ   = (ξₖ - θbarₖ₋₁ * τₖ₋₁) / ψbarₖ
      else
        τₖ₋₂ = τₖ₋₁
        τₖ₋₂ = τₖ₋₂ * ψbisₖ₋₂ / ψₖ₋₂
        τₖ₋₁ = (ξₖ₋₁ - θₖ₋₂ * τₖ₋₂) / ψbisₖ₋₁
        ξₖ   = ζₖ - ωₖ₋₂ * τₖ₋₂
        τₖ   = (ξₖ - θbarₖ₋₁ * τₖ₋₁) / ψbarₖ
      end

      # The components of (Qₖ)ᵀβ₁e₁ are (χ₁, ..., χₖ, χbarₖ₊₁)
      (iter == 1) && (χbarₖ = β₁)

      # [ cₖ  sₖ ] [ χbarₖ ] = [    χₖ   ]
      # [ sₖ -cₖ ] [   0   ]   [ χbarₖ₊₁ ]
      χₖ      = cₖ * χbarₖ
      χbarₖ₊₁ = sₖ * χbarₖ

      # Update pₖ₊₁ = [ P̂ₖ  0 ](Qₖ)ᵀβ₁e₁
      #               [ 0   1 ]
      if iter == 1
        πₖ = χₖ
      elseif iter == 2
        # [ ĉ₁   ŝ₁ ] [ π₁ ] = [ π₁ ]
        # [ ŝ₁  -ĉ₁ ] [ χ₂ ]   [ π₂ ]
        πaux₋₁ = πₖ₋₁
        πₖ₋₁ = ĉ₂ₖ₋₃ * πaux₋₁ + ŝ₂ₖ₋₃ * χₖ
        πₖ   = ŝ₂ₖ₋₃ * πaux₋₁ - ĉ₂ₖ₋₃ * χₖ
      else
        # [ ĉ₂ₖ₋₄      ŝ₂ₖ₋₄ ] [ πₖ₋₂ ]   [ πₖ₋₂ ]
        # [        1         ] [ πₖ₋₁ ] = [ πₖ₋₁ ]
        # [ ŝ₂ₖ₋₄     -ĉ₂ₖ₋₄ ] [  χₖ  ]   [  πₖ  ]
        πaux₋₂ = πₖ₋₂
        πₖ₋₂ = ĉ₂ₖ₋₄ * πaux₋₂ + ŝ₂ₖ₋₄ * χₖ
        πₖ   = ŝ₂ₖ₋₄ * πaux₋₂ - ĉ₂ₖ₋₄ * χₖ

        # [ 1                ] [ πₖ₋₂ ]   [ πₖ₋₂ ]
        # [    ĉ₂ₖ₋₃   ŝ₂ₖ₋₃ ] [ πₖ₋₁ ] = [ πₖ₋₁ ]
        # [    ŝ₂ₖ₋₃  -ĉ₂ₖ₋₃ ] [  πₖ  ]   [  πₖ  ]
        πaux₋₁ = πₖ₋₁
        πₖ₋₁ = ĉ₂ₖ₋₃ * πaux₋₁ + ŝ₂ₖ₋₃ * πₖ
        πₖ   = ŝ₂ₖ₋₃ * πaux₋₁ - ĉ₂ₖ₋₃ * πₖ
      end
      πₖ₊₁ = χbarₖ₊₁

      # Update ‖rₖ‖ estimate
      # ‖ rₖ ‖ = √((πₖ₋₁ - τₖ₋₁)² + (πₖ - τₖ)² + (πₖ₊₁)²)
      if iter == 1
        rNorm = sqrt((πₖ - τₖ)^2 + πₖ₊₁^2)
      else
        rNorm = sqrt((πₖ₋₁ - τₖ₋₁)^2 + (πₖ - τₖ)^2 + πₖ₊₁^2)
      end
      history && push!(rNorms, rNorm)

      # Update stopping criterion.
      breakdown = βₖ₊₁ ≤ btol
      solved = (rNorm ≤ ε) || (ArNorm ≤ κ)
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      user_requested_exit = callback(workspace) :: Bool

      # Update variables
      @kswap!(vₖ, vₖ₊₁)
      if iter ≥ 2
        @kswap!(wₖ₋₂, wₖ₋₁)
        @kswap!(dₖ₋₂, dₖ₋₁)
        ϵₖ₋₂ = ϵₖ₋₁
        c̃₂ₖ₋₄ = c̃₂ₖ₋₂
        s̃₂ₖ₋₄ = s̃₂ₖ₋₂
        ξₖ₋₁ = ξₖ
        ψbisₖ₋₂ = ψbisₖ₋₁
        θbarₖ₋₂ = θbarₖ₋₁
        πₖ₋₂ = πₖ₋₁
      end
      c̃₂ₖ₋₃ = c̃₂ₖ₋₁
      s̃₂ₖ₋₃ = s̃₂ₖ₋₁
      c̃₂ₖ₋₂ = c̃₂ₖ
      s̃₂ₖ₋₂ = s̃₂ₖ
      βₖ = βₖ₊₁
      χbarₖ = χbarₖ₊₁
      ψbarₖ₋₁ = ψbarₖ
      πₖ₋₁ = πₖ
      if iter ≤ ℓ-1
        αₖ = αₖ₊₁
        βₖ₊₁ = βₖ₊₂
        γₖ₋₁ = γₖ
        λbarₖ = λbarₖ₊₁
        ζbisₖ = ζbisₖ₊₁
      end
      if iter ≤ ℓ-2
        ϵₖ₋₁ = ϵₖ
        γbarₖ = γbarₖ₊₁
        ζbarₖ₊₁ = ζbarₖ₊₂
      end

      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %8.1e  %.2fs\n", iter, rNorm, ArNorm, βₖ, ζₖ, start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    solved              && (status = "solution good enough given atol, rtol and Artol")
    tired               && (status = "maximum number of iterations exceeded")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update x
    warm_start && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    # stats.inconsistent = inconsistent
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

function test_lnlq(A, b,transfer_to_craig)
  (x, y, stats) = lnlq(A, b, transfer_to_craig=transfer_to_craig, utolx=0.0, utoly=0.0)
  r = b - A * x
  resid = norm(r) / norm(b)
  return (x, y, stats, resid)
end

@testset "lnlq" begin
  lnlq_tol = 1.0e-6

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      # Code coverage.
      A, b = kron_unsymmetric(4)
      (x, y, stats) = lnlq(A, b, transfer_to_craig=false)

      # Test b == 0
      A, b = zero_rhs(FC=FC)
      (x, y, stats) = lnlq(A, b)
      @test norm(x) == 0
      @test norm(y) == 0
      @test stats.status == "x is a zero-residual solution"

      for transfer_to_craig ∈ (false, true)
        # Underdetermined consistent.
        A, b = under_consistent(FC=FC)
        (x, y, stats, resid) = test_lnlq(A, b, transfer_to_craig)
        @test(norm(x - A' * y) ≤ lnlq_tol * norm(x))
        @test(resid ≤ lnlq_tol)
        @test(stats.solved)
        (xI, xmin, xmin_norm) = check_min_norm(A, b, x)
        @test(norm(xI - xmin) ≤ cond(A) * lnlq_tol * xmin_norm)
        (xₛ, yₛ, stats) = lnlq(A, b, transfer_to_craig=transfer_to_craig, atol=0.0, rtol=0.0, σ=0.5)
        (xI, xmin, xmin_norm) = check_min_norm(A, b, xₛ)
        @test(norm(xI - xmin) ≤ cond(A) * lnlq_tol * xmin_norm)

        # Square consistent.
        A, b = square_consistent(FC=FC)
        (x, y, stats, resid) = test_lnlq(A, b, transfer_to_craig)
        @test(norm(x - A' * y) ≤ lnlq_tol * norm(x))
        @test(resid ≤ lnlq_tol)
        @test(stats.solved)
        (xI, xmin, xmin_norm) = check_min_norm(A, b, x)
        @test(norm(xI - xmin) ≤ cond(A) * lnlq_tol * xmin_norm)
        (xₛ, yₛ, stats) = lnlq(A, b, transfer_to_craig=transfer_to_craig, atol=0.0, rtol=0.0, σ=0.5)
        (xI, xmin, xmin_norm) = check_min_norm(A, b, xₛ)
        @test(norm(xI - xmin) ≤ cond(A) * lnlq_tol * xmin_norm)

        # Overdetermined consistent.
        A, b = over_consistent(FC=FC)
        (x, y, stats, resid) = test_lnlq(A, b, transfer_to_craig)
        @test(norm(x - A' * y) ≤ lnlq_tol * norm(x))
        @test(resid ≤ lnlq_tol)
        @test(stats.solved)
        (xI, xmin, xmin_norm) = check_min_norm(A, b, x)
        @test(norm(xI - xmin) ≤ cond(A) * lnlq_tol * xmin_norm)
        (xₛ, yₛ, stats) = lnlq(A, b, transfer_to_craig=transfer_to_craig, atol=0.0, rtol=0.0, σ=0.5)
        (xI, xmin, xmin_norm) = check_min_norm(A, b, xₛ)
        @test(norm(xI - xmin) ≤ cond(A) * lnlq_tol * xmin_norm)

        # Test regularization
        A, b, λ = regularization(FC=FC)
        (x, y, stats) = lnlq(A, b, λ=λ, transfer_to_craig=transfer_to_craig, utolx=0.0, utoly=0.0)
        (xₛ, yₛ, stats) = lnlq(A, b, transfer_to_craig=transfer_to_craig, atol=0.0, rtol=0.0, utolx=1e-10, utoly=1e-10, λ=λ)
        for (x, y) in ((x, y), (xₛ, yₛ))
          s = λ * y
          r = b - (A * x + λ * s)
          resid = norm(r) / norm(b)
          @test(resid ≤ lnlq_tol)
          r2 = b - (A * A' + λ^2 * I) * y
          resid2 = norm(r2) / norm(b)
          @test(resid2 ≤ lnlq_tol)
        end

        # Test saddle-point systems
        A, b, D = saddle_point(FC=FC)
        D⁻¹ = inv(D)
        (x, y, stats) = lnlq(A, b, N=D⁻¹, transfer_to_craig=transfer_to_craig)
        (xₛ, yₛ, stats) = lnlq(A, b, N=D⁻¹, transfer_to_craig=transfer_to_craig, atol=0.0, rtol=0.0, σ=0.001)
        for (x, y) in ((x, y), (xₛ, yₛ))
          r = b - A * x
          resid = norm(r) / norm(b)
          @test(resid ≤ lnlq_tol)
          r2 = b - (A * D⁻¹ * A') * y
          resid2 = norm(r2) / norm(b)
          @test(resid2 ≤ lnlq_tol)
        end

        # Test with preconditioners
        A, b, M⁻¹, N⁻¹ = two_preconditioners(FC=FC)
        (x, y, stats) = lnlq(A, b, M=M⁻¹, N=N⁻¹, sqd=false, transfer_to_craig=transfer_to_craig)
        (xₛ, yₛ, stats) = lnlq(A, b, M=M⁻¹, N=N⁻¹, sqd=false, transfer_to_craig=transfer_to_craig, atol=0.0, rtol=0.0, σ=0.5)
        for (x, y) in ((x, y), (xₛ, yₛ))
          r = b - A * x
          resid = sqrt(real(dot(r, M⁻¹ * r))) / norm(b)
          @test(resid ≤ lnlq_tol)
          @test(norm(x - N⁻¹ * A' * y) ≤ lnlq_tol * norm(x))
        end

        # Test symmetric and quasi-definite systems
        A, b, M, N = sqd(FC=FC)
        M⁻¹ = inv(M)
        N⁻¹ = inv(N)
        (x, y, stats) = lnlq(A, b, M=M⁻¹, N=N⁻¹, sqd=true, transfer_to_craig=transfer_to_craig)
        (xₛ, yₛ, stats) = lnlq(A, b, M=M⁻¹, N=N⁻¹, sqd=true, transfer_to_craig=transfer_to_craig, atol=0.0, rtol=0.0, σ=0.5)
        for (x, y) in ((x, y), (xₛ, yₛ))
          r = b - (A * x + M * y)
          resid = norm(r) / norm(b)
          @test(resid ≤ lnlq_tol)
          r2 = b - (A * N⁻¹ * A' + M) * y
          resid2 = norm(r2) / norm(b)
          @test(resid2 ≤ lnlq_tol)
        end

        λ = 4.0
        (x, y, stats) = lnlq(A, b, M=M⁻¹, N=N⁻¹, λ=λ, transfer_to_craig=transfer_to_craig)
        (xₛ, yₛ, stats) = lnlq(A, b, M=M⁻¹, N=N⁻¹, λ=λ, transfer_to_craig=transfer_to_craig, atol=0.0, rtol=0.0, σ=0.5)
        for (x, y) in ((x, y), (xₛ, yₛ))
          r = b - (A * x + λ^2 * M * y)
          resid = norm(r) / norm(b)
          @test(resid ≤ lnlq_tol)
          r2 = b - (A * N⁻¹ * A' + λ^2 * M) * y
          resid2 = norm(r2) / norm(b)
          @test(resid2 ≤ lnlq_tol)
        end

        # Test dimension of additional vectors
        for transpose ∈ (false, true)
          A, b, c, D = small_sp(transpose, FC=FC)
          D⁻¹ = inv(D)
          (x, y, stats) = lnlq(A', c, N=D⁻¹, transfer_to_craig=transfer_to_craig)

          A, b, c, M, N = small_sqd(transpose, FC=FC)
          M⁻¹ = inv(M)
          N⁻¹ = inv(N)
          (x, y, stats) = lnlq(A, b, M=M⁻¹, N=N⁻¹, sqd=true, transfer_to_craig=transfer_to_craig)
        end

        # Test different types for input and output
        A, b = small_ln(FC=FC)
        m, n = size(A)
        workspace = LnlqWorkspace(KrylovConstructor(b, TestVector(similar(b, n))))
        lnlq!(workspace, A, b)
        @test workspace.stats.solved
        @test typeof(workspace.x) === TestVector{FC}
        @test typeof(workspace.y) === Vector{FC}

        # test callback function
        A, b = over_consistent(FC=FC)
        workspace = LnlqWorkspace(A, b)
        tol = 1.0e-1
        cb_n2 = TestCallbackN2LN(A, b, real(zero(eltype(b))), tol = tol)
        lnlq!(workspace, A, b, callback = cb_n2)
        @test workspace.stats.status == "user-requested exit"
        @test cb_n2(workspace)

        @test_throws TypeError lnlq(A, b, callback = workspace -> "string", history = true)

        # Test small least-norm problem
        A, b = small_ln(FC=FC)
        x, y, stats = lnlq(A, b)
        r = b - A * x
        resid = norm(r) / norm(b)
        @test resid ≤ lnlq_tol
        @test norm(x - A' * y) ≤ lnlq_tol * norm(x)
      end
    end
  end
end

# An implementation of LSQR for the solution of the
# over-determined linear least-squares problem
#
#  minimize ‖Ax - b‖₂
#
# equivalently, of the normal equations
#
#  AᴴAx = Aᴴb.
#
# LSQR is formally equivalent to applying the conjugate gradient method
# to the normal equations but should be more stable. It is also formally
# equivalent to CGLS though LSQR should be expected to be more stable on
# ill-conditioned or poorly scaled problems.
#
# This implementation follows the original implementation by
# Michael Saunders described in
#
# C. C. Paige and M. A. Saunders, LSQR: An Algorithm for Sparse Linear
# Equations and Sparse Least Squares, ACM Transactions on Mathematical
# Software, 8(1), pp. 43--71, 1982.
#
# Dominique Orban, <dominique.orban@gerad.ca>
# Montreal, QC, May 2015.

export lsqr, lsqr!

"""
    (x, stats) = lsqr(A, b::AbstractVector{FC};
                      M=I, N=I, ldiv::Bool=false,
                      window::Int=5, sqd::Bool=false, λ::T=zero(T),
                      radius::T=zero(T), etol::T=√eps(T),
                      axtol::T=√eps(T), btol::T=√eps(T),
                      conlim::T=1/√eps(T), atol::T=zero(T),
                      rtol::T=zero(T), itmax::Int=0,
                      timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                      callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

Solve the regularized linear least-squares problem

    minimize ‖b - Ax‖₂² + λ²‖x‖₂²

of size m × n using the LSQR method, where λ ≥ 0 is a regularization parameter.
LSQR is formally equivalent to applying CG to the normal equations

    (AᴴA + λ²I) x = Aᴴb

(and therefore to CGLS) but is more stable.

LSQR produces monotonic residuals ‖r‖₂ but not optimality residuals ‖Aᴴr‖₂.
It is formally equivalent to CGLS, though can be slightly more accurate.

If `λ > 0`, LSQR solves the symmetric and quasi-definite system

    [ E      A ] [ r ]   [ b ]
    [ Aᴴ  -λ²F ] [ x ] = [ 0 ],

where E and F are symmetric and positive definite.
Preconditioners M = E⁻¹ ≻ 0 and N = F⁻¹ ≻ 0 may be provided in the form of linear operators.
If `sqd=true`, `λ` is set to the common value `1`.

The system above represents the optimality conditions of

    minimize ‖b - Ax‖²_E⁻¹ + λ²‖x‖²_F.

For a symmetric and positive definite matrix `K`, the K-norm of a vector `x` is `‖x‖²_K = xᴴKx`.
LSQR is then equivalent to applying CG to `(AᴴE⁻¹A + λ²F)x = AᴴE⁻¹b` with `r = E⁻¹(b - Ax)`.

If `λ = 0`, we solve the symmetric and indefinite system

    [ E    A ] [ r ]   [ b ]
    [ Aᴴ   0 ] [ x ] = [ 0 ].

The system above represents the optimality conditions of

    minimize ‖b - Ax‖²_E⁻¹.

In this case, `N` can still be specified and indicates the weighted norm in which `x` and `Aᴴr` should be measured.
`r` can be recovered by computing `E⁻¹(b - Ax)`.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :lsqr`.

For an in-place variant that reuses memory across solves, see [`lsqr!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `m` used for centered preconditioning of the augmented system;
* `N`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning of the augmented system;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `window`: number of iterations used to accumulate a lower bound on the error;
* `sqd`: if `true`, set `λ=1` for Hermitian quasi-definite systems;
* `λ`: regularization parameter;
* `radius`: add the trust-region constraint ‖x‖ ≤ `radius` if `radius > 0`. Useful to compute a step in a trust-region method for optimization;
* `etol`: stopping tolerance based on the lower bound on the error;
* `axtol`: tolerance on the backward error;
* `btol`: stopping tolerance used to detect zero-residual problems;
* `conlim`: limit on the estimated condition number of `A` beyond which the solution will be abandoned;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `m+n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### Reference

* C. C. Paige and M. A. Saunders, [*LSQR: An Algorithm for Sparse Linear Equations and Sparse Least Squares*](https://doi.org/10.1145/355984.355989), ACM Transactions on Mathematical Software, 8(1), pp. 43--71, 1982.
"""
function lsqr end

"""
    workspace = lsqr!(workspace::LsqrWorkspace, A, b; kwargs...)

In this call, `kwargs` are keyword arguments of [`lsqr`](@ref).
The keyword argument `window` is the only exception.
It is only supported by [`lsqr`](@ref) and is required to create a `LsqrWorkspace`.
It cannot be changed later.

See [`LsqrWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :lsqr` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function lsqr! end

def_args_lsqr = (:(A                    ),
                 :(b::AbstractVector{FC}))

def_kwargs_lsqr = (:(; M = I                        ),
                   :(; N = I                        ),
                   :(; ldiv::Bool = false           ),
                   :(; sqd::Bool = false            ),
                   :(; λ::T = zero(T)               ),
                   :(; radius::T = zero(T)          ),
                   :(; etol::T = √eps(T)            ),
                   :(; axtol::T = √eps(T)           ),
                   :(; btol::T = √eps(T)            ),
                   :(; conlim::T = 1/√eps(T)        ),
                   :(; atol::T = zero(T)            ),
                   :(; rtol::T = zero(T)            ),
                   :(; itmax::Int = 0               ),
                   :(; timemax::Float64 = Inf       ),
                   :(; verbose::Int = 0             ),
                   :(; history::Bool = false        ),
                   :(; callback = workspace -> false),
                   :(; iostream::IO = kstdout       ))

def_kwargs_workspace_lsqr = (:(; window::Int = 5),)

def_kwargs_lsqr = extract_parameters.(def_kwargs_lsqr)
def_kwargs_workspace_lsqr = extract_parameters.(def_kwargs_workspace_lsqr)

args_lsqr = (:A, :b)
kwargs_lsqr = (:M, :N, :ldiv, :sqd, :λ, :radius, :etol, :axtol, :btol, :conlim, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)
kwargs_workspace_lsqr = (:window,)

@eval begin
  function lsqr!(workspace :: LsqrWorkspace{T,FC,Sm,Sn}, $(def_args_lsqr...); $(def_kwargs_lsqr...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "LSQR: system of %d equations in %d variables\n", m, n)

    # Check sqd and λ parameters
    sqd && (λ ≠ 0) && error("sqd cannot be set to true if λ ≠ 0 !")
    sqd && (λ = one(T))

    # Tests M = Iₙ and N = Iₘ
    MisI = (M === I)
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == Sm || error("ktypeof(b) must be equal to $Sm")

    # Compute the adjoint of A
    Aᴴ = A'

    # Set up workspace.
    allocate_if(!MisI, workspace, :u, Sm, workspace.Av)  # The length of u is m
    allocate_if(!NisI, workspace, :v, Sn, workspace.x)   # The length of v is n
    x, Nv, Aᴴu, w = workspace.x, workspace.Nv, workspace.Aᴴu, workspace.w
    Mu, Av, err_vec, stats = workspace.Mu, workspace.Av, workspace.err_vec, workspace.stats
    rNorms, ArNorms = stats.residuals, stats.Aresiduals
    reset!(stats)
    u = MisI ? Mu : workspace.u
    v = NisI ? Nv : workspace.v

    λ² = λ * λ
    ctol = conlim > 0 ? 1/conlim : zero(T)
    kfill!(x, zero(FC))

    # Initialize Golub-Kahan process.
    # β₁ M u₁ = b.
    kcopy!(m, Mu, b)  # Mu ← b
    MisI || mulorldiv!(u, M, Mu, ldiv)
    β₁ = knorm_elliptic(m, u, Mu)
    if β₁ == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      history && push!(rNorms, zero(T))
      history && push!(ArNorms, zero(T))
      return workspace
    end
    β = β₁

    kdiv!(m, u, β₁)
    MisI || kdiv!(m, Mu, β₁)
    kmul!(Aᴴu, Aᴴ, u)
    kcopy!(n, Nv, Aᴴu)  # Nv ← Aᴴu
    NisI || mulorldiv!(v, N, Nv, ldiv)
    Anorm² = kdotr(n, v, Nv)
    Anorm = sqrt(Anorm²)
    α = Anorm
    Acond  = zero(T)
    xNorm  = zero(T)
    xNorm² = zero(T)
    dNorm² = zero(T)
    c2 = -one(T)
    s2 = zero(T)
    z  = zero(T)

    xENorm² = zero(T)
    err_lbnd = zero(T)
    window = length(err_vec)
    kfill!(err_vec, zero(T))

    iter = 0
    itmax == 0 && (itmax = m + n)

    (verbose > 0) && @printf(iostream, "%5s  %7s  %7s  %7s  %7s  %7s  %7s  %7s  %7s  %5s\n", "k", "α", "β", "‖r‖", "‖Aᴴr‖", "compat", "backwrd", "‖A‖", "κ(A)", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %7.1e  %7.1e  %7.1e  %7.1e  %7.1e  %.2fs\n", iter, β₁, α, β₁, α, 0, 1, Anorm, Acond, start_time |> ktimer)

    rNorm = β₁
    r1Norm = rNorm
    r2Norm = rNorm
    res2   = zero(T)
    history && push!(rNorms, r2Norm)
    ArNorm = ArNorm0 = α * β
    history && push!(ArNorms, ArNorm)
    # Aᴴb = 0 so x = 0 is a minimum least-squares solution
    if α == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a minimum least-squares solution"
      return workspace
    end
    kdiv!(n, v, α)
    NisI || kdiv!(n, Nv, α)
    kcopy!(n, w, v)  # w ← v

    # Initialize other constants.
    ϕbar = β₁
    ρbar = α

    status = "unknown"
    on_boundary = false
    solved_lim = ArNorm / (Anorm * rNorm) ≤ axtol
    solved_mach = one(T) + ArNorm / (Anorm * rNorm) ≤ one(T)
    solved = solved_mach | solved_lim
    tired  = iter ≥ itmax
    ill_cond = ill_cond_mach = ill_cond_lim = false
    zero_resid_lim = rNorm / β₁ ≤ axtol
    zero_resid_mach = one(T) + rNorm / β₁ ≤ one(T)
    zero_resid = zero_resid_mach | zero_resid_lim
    fwd_err = false
    user_requested_exit = false
    overtimed = false

    while ! (solved || tired || ill_cond || user_requested_exit || overtimed)
      iter = iter + 1

      # Generate next Golub-Kahan vectors.
      # 1. βₖ₊₁Muₖ₊₁ = Avₖ - αₖMuₖ
      kmul!(Av, A, v)
      kaxpby!(m, one(FC), Av, -α, Mu)
      MisI || mulorldiv!(u, M, Mu, ldiv)
      β = knorm_elliptic(m, u, Mu)
      if β ≠ 0
        kdiv!(m, u, β)
        MisI || kdiv!(m, Mu, β)
        Anorm² = Anorm² + α * α + β * β  # = ‖B_{k-1}‖²
        λ > 0 && (Anorm² += λ²)

        # 2. αₖ₊₁Nvₖ₊₁ = Aᴴuₖ₊₁ - βₖ₊₁Nvₖ
        kmul!(Aᴴu, Aᴴ, u)
        kaxpby!(n, one(FC), Aᴴu, -β, Nv)
        NisI || mulorldiv!(v, N, Nv, ldiv)
        α = knorm_elliptic(n, v, Nv)
        if α ≠ 0
          kdiv!(n, v, α)
          NisI || kdiv!(n, Nv, α)
        end
      end

      # Continue QR factorization
      # 1. Eliminate the regularization parameter.
      (c1, s1, ρbar1) = sym_givens(ρbar, λ)
      ψ = s1 * ϕbar
      ϕbar = c1 * ϕbar

      # 2. Eliminate β.
      # Q [ Lₖ  β₁ e₁ ] = [ Rₖ   zₖ  ] :
      #   [ β    0    ]   [ 0   ζbar ]
      #
      #       k  k+1    k    k+1      k  k+1
      # k   [ c   s ] [ ρbar    ] = [ ρ  θ⁺    ]
      # k+1 [ s  -c ] [ β    α⁺ ]   [    ρbar⁺ ]
      #
      # so that we obtain
      #
      # [ c  s ] [ ζbar ] = [ ζ     ]
      # [ s -c ] [  0   ]   [ ζbar⁺ ]
      (c, s, ρ) = sym_givens(ρbar1, β)
      ϕ = c * ϕbar
      ϕbar = s * ϕbar

      xENorm² = xENorm² + ϕ * ϕ
      err_vec[mod(iter, window) + 1] = ϕ
      iter ≥ window && (err_lbnd = knorm(window, err_vec))

      τ = s * ϕ
      θ = s * α
      ρbar = -c * α
      dNorm² += kdotr(n, w, w) / ρ^2

      # if a trust-region constraint is give, compute step to the boundary
      # the step ϕ/ρ is not necessarily positive
      σ = ϕ / ρ
      if radius > 0
        t1, t2 = to_boundary(n, x, w, v, radius)
        tmax, tmin = max(t1, t2), min(t1, t2)
        on_boundary = σ > tmax || σ < tmin
        σ = σ > 0 ? min(σ, tmax) : max(σ, tmin)
      end

      kaxpy!(n, σ, w, x)  # x = x + ϕ / ρ * w
      kaxpby!(n, one(FC), v, -θ/ρ, w)  # w = v - θ / ρ * w

      # Use a plane rotation on the right to eliminate the super-diagonal
      # element (θ) of the upper-bidiagonal matrix.
      # Use the result to estimate norm(x).
      δ = s2 * ρ
      γbar = -c2 * ρ
      rhs = ϕ - δ * z
      zbar = rhs / γbar
      xNorm = sqrt(xNorm² + zbar * zbar)
      (c2, s2, γ) = sym_givens(γbar, θ)
      z = rhs / γ
      xNorm² += z * z

      Anorm = sqrt(Anorm²)
      Acond = Anorm * sqrt(dNorm²)
      res1  = ϕbar * ϕbar
      res2 += ψ * ψ
      rNorm = sqrt(res1 + res2)

      ArNorm = α * abs(τ)
      history && push!(ArNorms, ArNorm)

      r1sq = rNorm * rNorm - λ² * xNorm²
      r1Norm = sqrt(abs(r1sq))
      r1sq < 0 && (r1Norm = -r1Norm)
      r2Norm = rNorm
      history && push!(rNorms, r2Norm)

      test1 = rNorm / β₁
      test2 = ArNorm / (Anorm * rNorm)
      test3 = inv(Acond)
      t1    = test1 / (one(T) + Anorm * xNorm / β₁)
      rNormtol = btol + axtol * Anorm * xNorm / β₁

      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %7.1e  %7.1e  %7.1e  %7.1e  %7.1e  %.2fs\n", iter, α, β, rNorm, ArNorm, test1, test2, Anorm, Acond, start_time |> ktimer)

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      ill_cond_mach = (one(T) + test3 ≤ one(T))
      solved_mach = (one(T) + test2 ≤ one(T))
      zero_resid_mach = (one(T) + t1 ≤ one(T))

      # Stopping conditions based on user-provided tolerances.
      user_requested_exit = callback(workspace) :: Bool
      tired  = iter ≥ itmax
      ill_cond_lim = (test3 ≤ ctol)
      solved_lim = (test2 ≤ axtol)
      solved_opt = ArNorm ≤ atol + rtol * ArNorm0
      zero_resid_lim = (test1 ≤ rNormtol)
      iter ≥ window && (fwd_err = err_lbnd ≤ etol * sqrt(xENorm²))

      ill_cond = ill_cond_mach || ill_cond_lim
      zero_resid = zero_resid_mach || zero_resid_lim
      solved = solved_mach || solved_lim || solved_opt || zero_resid || fwd_err || on_boundary
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    ill_cond_mach       && (status = "condition number seems too large for this machine")
    ill_cond_lim        && (status = "condition number exceeds tolerance")
    solved              && (status = "found approximate minimum least-squares solution")
    zero_resid          && (status = "found approximate zero-residual solution")
    fwd_err             && (status = "truncated forward error small enough")
    on_boundary         && (status = "on trust-region boundary")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = !zero_resid
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

@testset "cgls" begin
  cgls_tol = 1.0e-5

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      for npower = 1 : 4
        (b, A, D, HY, HZ, Acond, rnorm) = test(40, 40, 4, npower, 0)  # No regularization.

        (x, stats) = cgls(A, b)
        resid = norm(A' * (A*x - b)) / norm(b)
        @test(resid ≤ cgls_tol)
        @test(stats.solved)

        λ = 1.0e-3
        (x, stats) = cgls(A, b, λ=λ)
        resid = norm(A' * (A*x - b) + λ * x) / norm(b)
        @test(resid ≤ cgls_tol)
        @test(stats.solved)
      end

      # Test with preconditioning.
      A, b, M = saddle_point(FC=FC)
      M⁻¹ = inv(M)
      (x, stats) = cgls(A, b, M=M⁻¹)
      resid = norm(A' * M⁻¹ * (A * x - b)) / sqrt(dot(b, M⁻¹ * b))
      @test resid ≤ cgls_tol

      # test trust-region constraint
      (x, stats) = cgls(A, b)

      radius = 0.75 * norm(x)
      (x, stats) = cgls(A, b, radius=radius)
      @test(stats.solved)
      @test(abs(radius - norm(x)) ≤ cgls_tol * radius)

      # Test b == 0
      A, b = zero_rhs(FC=FC)
      (x, stats) = cgls(A, b)
      @test norm(x) == 0
      @test stats.status == "x is a zero-residual solution"

      # Test dimension of additional vectors
      for transpose ∈ (false, true)
        A, b, c, D = small_sp(transpose, FC=FC)
        D⁻¹ = inv(D)
        (x, stats) = cgls(A, b, M=D⁻¹, λ=1.0)
      end

      # Test different types for input and output
      A, b, c, D = small_sp(false, FC=FC)
      workspace = CglsWorkspace(KrylovConstructor(TestVector(b), c))
      cgls!(workspace, A, TestVector(b), M=inv(D), λ=1.0)
      @test typeof(workspace.x) === typeof(c)
      workspace = CglsWorkspace(KrylovConstructor(b, TestVector(c)))
      cgls!(workspace, A, b, M=inv(D), λ=1.0)
      @test typeof(workspace.x) === typeof(TestVector(c))

      # test callback function
      A, b, M = saddle_point(FC=FC)
      M⁻¹ = inv(M)
      workspace = CglsWorkspace(A, b)
      tol = 1.0e-1
      cb_n2 = TestCallbackN2LS(A, b, zero(eltype(b)), tol = tol)
      cgls!(workspace, A, b, M=M⁻¹, callback = cb_n2)
      @test workspace.stats.status == "user-requested exit"
      @test cb_n2(workspace)

      @test_throws TypeError cgls(A, b, M=M⁻¹, callback = workspace -> "string", history = true)
    end
  end
end

# An implementation of TriMR for the solution of symmetric and quasi-definite systems.
#
# This method is described in
#
# A. Montoison and D. Orban
# TriCG and TriMR: Two Iterative Methods for Symmetric Quasi-Definite Systems.
# SIAM Journal on Scientific Computing, 43(4), pp. 2502--2525, 2021.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Montréal, June 2020.

export trimr, trimr!

"""
    (x, y, stats) = trimr(A, b::AbstractVector{FC}, c::AbstractVector{FC};
                          M=I, N=I, ldiv::Bool=false,
                          spd::Bool=false, snd::Bool=false,
                          flip::Bool=false, sp::Bool=false,
                          τ::T=one(T), ν::T=-one(T), atol::T=√eps(T),
                          rtol::T=√eps(T), itmax::Int=0,
                          timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                          callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, y, stats) = trimr(A, b, c, x0::AbstractVector, y0::AbstractVector; kwargs...)

TriMR can be warm-started from initial guesses `x0` and `y0` where `kwargs` are the same keyword arguments as above.

Given a matrix `A` of dimension m × n, TriMR solves the symmetric linear system

    [ τE    A ] [ x ] = [ b ]
    [  Aᴴ  νF ] [ y ]   [ c ],

of size (n+m) × (n+m) where `τ` and `ν` are real numbers, `E` = `M⁻¹` ≻ 0, `F` = `N⁻¹` ≻ 0.
TriMR handles saddle-point systems (`τ = 0` or `ν = 0`) and adjoint systems (`τ = 0` and `ν = 0`) without any risk of breakdown.

By default, TriMR solves symmetric and quasi-definite linear systems with `τ` = 1 and `ν` = -1.

TriMR is based on the preconditioned orthogonal tridiagonalization process
and its relation with the preconditioned block-Lanczos process.

The matrix

    [ M   0 ]
    [ 0   N ]

indicates the weighted norm in which residuals are measured, here denoted `‖·‖`.
It's the Euclidean norm when `M` and `N` are identity operators.

TriMR stops when `itmax` iterations are reached or when `‖rₖ‖ ≤ atol + ‖r₀‖ * rtol`.
`atol` is an absolute tolerance and `rtol` is a relative tolerance.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :trimr`.

For an in-place variant that reuses memory across solves, see [`trimr!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`;
* `c`: a vector of length `n`.

#### Optional arguments

* `x0`: a vector of length `m` that represents an initial guess of the solution `x`;
* `y0`: a vector of length `n` that represents an initial guess of the solution `y`.

Warm-starting is supported only when `M` and `N` are either `I` or the corresponding coefficient (`τ` or `ν`) is zero.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `m` used for centered preconditioning of the partitioned system;
* `N`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning of the partitioned system;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `spd`: if `true`, set `τ = 1` and `ν = 1` for Hermitian and positive-definite linear system;
* `snd`: if `true`, set `τ = -1` and `ν = -1` for Hermitian and negative-definite linear systems;
* `flip`: if `true`, set `τ = -1` and `ν = 1` for another known variant of Hermitian quasi-definite systems;
* `sp`: if `true`, set `τ = 1` and `ν = 0` for saddle-point systems;
* `τ` and `ν`: diagonal scaling factors of the partitioned Hermitian linear system;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `m+n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `m`;
* `y`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### Reference

* A. Montoison and D. Orban, [*TriCG and TriMR: Two Iterative Methods for Symmetric Quasi-Definite Systems*](https://doi.org/10.1137/20M1363030), SIAM Journal on Scientific Computing, 43(4), pp. 2502--2525, 2021.
"""
function trimr end

"""
    workspace = trimr!(workspace::TrimrWorkspace, A, b, c; kwargs...)
    workspace = trimr!(workspace::TrimrWorkspace, A, b, c, x0, y0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`trimr`](@ref).

See [`TrimrWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :trimr` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function trimr! end

def_args_trimr = (:(A                    ),
                  :(b::AbstractVector{FC}),
                  :(c::AbstractVector{FC}))

def_optargs_trimr = (:(x0::AbstractVector),
                     :(y0::AbstractVector))

def_kwargs_trimr = (:(; M = I                        ),
                    :(; N = I                        ),
                    :(; ldiv::Bool = false           ),
                    :(; spd::Bool = false            ),
                    :(; snd::Bool = false            ),
                    :(; flip::Bool = false           ),
                    :(; sp::Bool = false             ),
                    :(; τ::T = one(T)                ),
                    :(; ν::T = -one(T)               ),
                    :(; atol::T = √eps(T)            ),
                    :(; rtol::T = √eps(T)            ),
                    :(; itmax::Int = 0               ),
                    :(; timemax::Float64 = Inf       ),
                    :(; verbose::Int = 0             ),
                    :(; history::Bool = false        ),
                    :(; callback = workspace -> false),
                    :(; iostream::IO = kstdout       ))

def_kwargs_trimr = extract_parameters.(def_kwargs_trimr)

args_trimr = (:A, :b, :c)
optargs_trimr = (:x0, :y0)
kwargs_trimr = (:M, :N, :ldiv, :spd, :snd, :flip, :sp, :τ, :ν, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function trimr!(workspace :: TrimrWorkspace{T,FC,Sm,Sn}, $(def_args_trimr...); $(def_kwargs_trimr...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    length(b) == m || error("Inconsistent problem size")
    length(c) == n || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "TriMR: system of %d equations in %d variables\n", m+n, m+n)

    # Check flip, sp, spd and snd parameters
    spd && flip && error("The matrix cannot be symmetric positive definite and symmetric quasi-definite !")
    spd && snd  && error("The matrix cannot be symmetric positive definite and symmetric negative definite !")
    spd && sp   && error("The matrix cannot be symmetric positive definite and a saddle-point !")
    snd && flip && error("The matrix cannot be symmetric negative definite and symmetric quasi-definite !")
    snd && sp   && error("The matrix cannot be symmetric negative definite and a saddle-point !")
    sp  && flip && error("The matrix cannot be symmetric quasi-definite and a saddle-point !")

    # Check M = Iₘ and N = Iₙ
    MisI = (M === I)
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == Sm || error("ktypeof(b) must be equal to $Sm")
    ktypeof(c) == Sn || error("ktypeof(c) must be equal to $Sn")

    # Determine τ and ν associated to SQD, SPD or SND systems.
    flip && (τ = -one(T) ; ν =  one(T))
    spd  && (τ =  one(T) ; ν =  one(T))
    snd  && (τ = -one(T) ; ν = -one(T))
    sp   && (τ =  one(T) ; ν = zero(T))

    warm_start = workspace.warm_start
    warm_start && (τ ≠ 0) && !MisI && error("Warm-start with preconditioners is not supported.")
    warm_start && (ν ≠ 0) && !NisI && error("Warm-start with preconditioners is not supported.")

    # Compute the adjoint of A
    Aᴴ = A'

    # Set up workspace.
    allocate_if(!MisI, workspace, :vₖ, Sm, workspace.x)  # The length of vₖ is m
    allocate_if(!NisI, workspace, :uₖ, Sn, workspace.y)  # The length of uₖ is n
    Δy, yₖ, N⁻¹uₖ₋₁, N⁻¹uₖ, p = workspace.Δy, workspace.y, workspace.N⁻¹uₖ₋₁, workspace.N⁻¹uₖ, workspace.p
    Δx, xₖ, M⁻¹vₖ₋₁, M⁻¹vₖ, q = workspace.Δx, workspace.x, workspace.M⁻¹vₖ₋₁, workspace.M⁻¹vₖ, workspace.q
    gy₂ₖ₋₃, gy₂ₖ₋₂, gy₂ₖ₋₁, gy₂ₖ = workspace.gy₂ₖ₋₃, workspace.gy₂ₖ₋₂, workspace.gy₂ₖ₋₁, workspace.gy₂ₖ
    gx₂ₖ₋₃, gx₂ₖ₋₂, gx₂ₖ₋₁, gx₂ₖ = workspace.gx₂ₖ₋₃, workspace.gx₂ₖ₋₂, workspace.gx₂ₖ₋₁, workspace.gx₂ₖ
    vₖ = MisI ? M⁻¹vₖ : workspace.vₖ
    uₖ = NisI ? N⁻¹uₖ : workspace.uₖ
    vₖ₊₁ = MisI ? q : M⁻¹vₖ₋₁
    uₖ₊₁ = NisI ? p : N⁻¹uₖ₋₁
    b₀ = warm_start ? q : b
    c₀ = warm_start ? p : c

    stats = workspace.stats
    rNorms = stats.residuals
    reset!(stats)

    # Initial solutions x₀ and y₀.
    kfill!(xₖ, zero(FC))
    kfill!(yₖ, zero(FC))

    iter = 0
    itmax == 0 && (itmax = m+n)

    # Initialize preconditioned orthogonal tridiagonalization process.
    kfill!(M⁻¹vₖ₋₁, zero(FC))  # v₀ = 0
    kfill!(N⁻¹uₖ₋₁, zero(FC))  # u₀ = 0

    # [ τI    A ] [ xₖ ] = [ b -  τΔx - AΔy ] = [ b₀ ]
    # [  Aᴴ  νI ] [ yₖ ]   [ c - AᴴΔx - νΔy ]   [ c₀ ]
    if warm_start
      kmul!(b₀, A, Δy)
      (τ ≠ 0) && kaxpy!(m, τ, Δx, b₀)
      kaxpby!(m, one(FC), b, -one(FC), b₀)
      kmul!(c₀, Aᴴ, Δx)
      (ν ≠ 0) && kaxpy!(n, ν, Δy, c₀)
      kaxpby!(n, one(FC), c, -one(FC), c₀)
    end

    # β₁Ev₁ = b ↔ β₁v₁ = Mb
    kcopy!(m, M⁻¹vₖ, b₀)  # M⁻¹vₖ ← b₀
    MisI || mulorldiv!(vₖ, M, M⁻¹vₖ, ldiv)
    βₖ = knorm_elliptic(m, vₖ, M⁻¹vₖ)  # β₁ = ‖v₁‖_E
    if βₖ ≠ 0
      kdiv!(m, M⁻¹vₖ, βₖ)
      MisI || kdiv!(m, vₖ, βₖ)
    else
      # v₁ = 0 such that v₁ ⊥ Span{v₁, ..., vₖ}
      kfill!(M⁻¹vₖ, zero(FC))
      MisI || kfill!(vₖ, zero(FC))
    end

    # γ₁Fu₁ = c ↔ γ₁u₁ = Nc
    kcopy!(n, N⁻¹uₖ, c₀)  # N⁻¹uₖ ← c₀
    NisI || mulorldiv!(uₖ, N, N⁻¹uₖ, ldiv)
    γₖ = knorm_elliptic(n, uₖ, N⁻¹uₖ)  # γ₁ = ‖u₁‖_F
    if γₖ ≠ 0
      # u₁ = 0 such that u₁ ⊥ Span{u₁, ..., uₖ}
      kdiv!(n, N⁻¹uₖ, γₖ)
      NisI || kdiv!(n, uₖ, γₖ)
    else
      kfill!(N⁻¹uₖ, zero(FC))
      NisI || kfill!(uₖ, zero(FC))
    end

    # Initialize directions Gₖ such that (GₖRₖ)ᵀ = (Wₖ)ᵀ.
    kfill!(gx₂ₖ₋₃, zero(FC))
    kfill!(gy₂ₖ₋₃, zero(FC))
    kfill!(gx₂ₖ₋₂, zero(FC))
    kfill!(gy₂ₖ₋₂, zero(FC))
    kfill!(gx₂ₖ₋₁, zero(FC))
    kfill!(gy₂ₖ₋₁, zero(FC))
    kfill!(gx₂ₖ  , zero(FC))
    kfill!(gy₂ₖ  , zero(FC))

    # Compute ‖r₀‖² = (γ₁)² + (β₁)²
    rNorm = sqrt(γₖ^2 + βₖ^2)
    history && push!(rNorms, rNorm)
    ε = atol + rtol * rNorm

    (verbose > 0) && @printf(iostream, "%5s  %7s  %7s  %7s  %5s\n", "k", "‖rₖ‖", "βₖ₊₁", "γₖ₊₁", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %.2fs\n", iter, rNorm, βₖ, γₖ, start_time |> ktimer)

    # Set up workspace.
    old_c₁ₖ = old_c₂ₖ = old_c₃ₖ = old_c₄ₖ = zero(T)
    old_s₁ₖ = old_s₂ₖ = old_s₃ₖ = old_s₄ₖ = zero(FC)
    σbar₂ₖ₋₂ = ηbar₂ₖ₋₃ = λbar₂ₖ₋₃ = μ₂ₖ₋₅ = λ₂ₖ₋₄ = μ₂ₖ₋₄ = zero(FC)
    πbar₂ₖ₋₁ = βₖ
    πbar₂ₖ = γₖ

    # Tolerance for breakdown detection.
    btol = eps(T)^(3/4)

    # Stopping criterion.
    breakdown = false
    solved = rNorm ≤ ε
    tired = iter ≥ itmax
    status = "unknown"
    user_requested_exit = false
    overtimed = false

    θbarₖ = δbar₂ₖ₋₁ = δbar₂ₖ = σbar₂ₖ₋₁ = σbar₂ₖ = λbar₂ₖ₋₁ = ηbar₂ₖ₋₁ = zero(FC)

    while !(solved || tired || breakdown || user_requested_exit || overtimed)
      # Update iteration index.
      iter = iter + 1

      # Continue the orthogonal tridiagonalization process.
      # AUₖ  = EVₖTₖ    + βₖ₊₁Evₖ₊₁(eₖ)ᵀ = EVₖ₊₁Tₖ₊₁.ₖ
      # AᴴVₖ = FUₖ(Tₖ)ᴴ + γₖ₊₁Fuₖ₊₁(eₖ)ᵀ = FUₖ₊₁(Tₖ.ₖ₊₁)ᴴ

      kmul!(q, A , uₖ)  # Forms Evₖ₊₁ : q ← Auₖ
      kmul!(p, Aᴴ, vₖ)  # Forms Fuₖ₊₁ : p ← Aᴴvₖ

      if iter ≥ 2
        kaxpy!(m, -γₖ, M⁻¹vₖ₋₁, q)  # q ← q - γₖ * M⁻¹vₖ₋₁
        kaxpy!(n, -βₖ, N⁻¹uₖ₋₁, p)  # p ← p - βₖ * N⁻¹uₖ₋₁
      end

      αₖ = kdot(m, vₖ, q)  # αₖ = ⟨vₖ,q⟩

      kaxpy!(m, -     αₖ , M⁻¹vₖ, q)  # q ← q - αₖ * M⁻¹vₖ
      kaxpy!(n, -conj(αₖ), N⁻¹uₖ, p)  # p ← p - ᾱₖ * N⁻¹uₖ

      # Compute vₖ₊₁ and uₖ₊₁
      MisI || mulorldiv!(vₖ₊₁, M, q, ldiv)  # βₖ₊₁vₖ₊₁ = MAuₖ  - γₖvₖ₋₁ - αₖvₖ
      NisI || mulorldiv!(uₖ₊₁, N, p, ldiv)  # γₖ₊₁uₖ₊₁ = NAᴴvₖ - βₖuₖ₋₁ - ᾱₖuₖ

      βₖ₊₁ = knorm_elliptic(m, vₖ₊₁, q)  # βₖ₊₁ = ‖vₖ₊₁‖_E
      γₖ₊₁ = knorm_elliptic(n, uₖ₊₁, p)  # γₖ₊₁ = ‖uₖ₊₁‖_F

      # βₖ₊₁ ≠ 0
      if βₖ₊₁ > btol
        kdiv!(m, q, βₖ₊₁)
        MisI || kdiv!(m, vₖ₊₁, βₖ₊₁)
      end
      # Note that if βₖ₊₁ == 0 then vₖ₊₁ = 0 and Auₖ ∈ Span{v₁, ..., vₖ}
      # We can keep vₖ₊₁ = 0 such that vₖ₊₁ ⊥ Span{v₁, ..., vₖ}

      # γₖ₊₁ ≠ 0
      if γₖ₊₁ > btol
        kdiv!(n, p, γₖ₊₁)
        NisI || kdiv!(n, uₖ₊₁, γₖ₊₁)
      end
      # Note that if γₖ₊₁ == 0 then uₖ₊₁ = 0 and Aᴴvₖ ∈ Span{u₁, ..., uₖ}
      # We can keep uₖ₊₁ = 0 such that uₖ₊₁ ⊥ Span{u₁, ..., uₖ}

      # Notations : Wₖ = [w₁ ••• wₖ] = [v₁ 0  ••• vₖ 0 ]
      #                                [0  u₁ ••• 0  uₖ]
      #
      # rₖ = [ b ] - [ τE    A ] [ xₖ ] = [ b ] - [ τE    A ] Wₖzₖ
      #      [ c ]   [  Aᴴ  νF ] [ yₖ ]   [ c ]   [  Aᴴ  νF ]
      #
      # block-Lanczos formulation : [ τE    A ] Wₖ = [ E   0 ] Wₖ₊₁Sₖ₊₁.ₖ
      #                             [  Aᴴ  νF ]      [ 0   F ]
      #
      # TriMR subproblem : min ‖ rₖ ‖ ↔ min ‖ Sₖ₊₁.ₖzₖ - β₁e₁ - γ₁e₂ ‖
      #
      # Update the QR factorization of Sₖ₊₁.ₖ = Qₖ [ Rₖ ].
      #                                            [ Oᵀ ]
      if iter == 1
        θbarₖ    = conj(αₖ)
        δbar₂ₖ₋₁ = τ
        δbar₂ₖ   = ν
        σbar₂ₖ₋₁ = αₖ
        σbar₂ₖ   = βₖ₊₁
        λbar₂ₖ₋₁ = γₖ₊₁
        ηbar₂ₖ₋₁ = zero(FC)
      else
        # Apply previous reflections
        #        [ 1                    ][ 1                    ][ c₂.ₖ₋₁  s₂.ₖ₋₁       ][ 1                    ]
        # Ζₖ₋₁ = [    c₄.ₖ₋₁  s₄.ₖ₋₁    ][    c₃.ₖ₋₁     s₃.ₖ₋₁ ][ s̄₂.ₖ₋₁ -c₂.ₖ₋₁       ][    c₁.ₖ₋₁     s₁.ₖ₋₁ ]
        #        [    s̄₄.ₖ₋₁ -c₄.ₖ₋₁    ][            1         ][                 1    ][            1         ]
        #        [                    1 ][    s̄₃.ₖ₋₁    -c₃.ₖ₋₁ ][                    1 ][    s̄₁.ₖ₋₁    -c₁.ₖ₋₁ ]
        #
        #        [ δbar₂ₖ₋₃  σbar₂ₖ₋₃ ηbar₂ₖ₋₃ λbar₂ₖ₋₃  0      0  ]   [ δ₂ₖ₋₃   σ₂ₖ₋₃  η₂ₖ₋₃     λ₂ₖ₋₃     μ₂ₖ₋₃       0      ]
        # Ζₖ₋₁ * [ θbarₖ₋₁   δbar₂ₖ₋₂ σbar₂ₖ₋₂    0      0      0  ] = [  0      δ₂ₖ₋₂  σ₂ₖ₋₂     η₂ₖ₋₂     λ₂ₖ₋₂     μ₂ₖ₋₂    ]
        #        [    0         βₖ       τ        αₖ     0    γₖ₊₁ ]   [  0        0    δbar₂ₖ₋₁  σbar₂ₖ₋₁  ηbar₂ₖ₋₁  λbar₂ₖ₋₁ ]
        #        [    γₖ        0        ᾱₖ       ν     βₖ₊₁    0  ]   [  0        0    θbarₖ     δbar₂ₖ    σbar₂ₖ      0      ]
        #
        # [ 1                    ] [ ηbar₂ₖ₋₃ λbar₂ₖ₋₃  0      0  ]   [ ηbar₂ₖ₋₃  λbar₂ₖ₋₃    0        0   ]
        # [    c₁.ₖ₋₁     s₁.ₖ₋₁ ] [ σbar₂ₖ₋₂    0      0      0  ] = [ σbis₂ₖ₋₂  ηbis₂ₖ₋₂  λbis₂ₖ₋₂   0   ]
        # [            1         ] [    τ        αₖ     0    γₖ₊₁ ]   [   τ        αₖ         0       γₖ₊₁ ]
        # [    s̄₁.ₖ₋₁    -c₁.ₖ₋₁ ] [    ᾱₖ       ν     βₖ₊₁    0  ]   [  θbisₖ    δbis₂ₖ    σbis₂ₖ     0   ]
        σbis₂ₖ₋₂ =      old_c₁ₖ  * σbar₂ₖ₋₂ + old_s₁ₖ * conj(αₖ)
        ηbis₂ₖ₋₂ =                            old_s₁ₖ * ν
        λbis₂ₖ₋₂ =                            old_s₁ₖ * βₖ₊₁
        θbisₖ    = conj(old_s₁ₖ) * σbar₂ₖ₋₂ - old_c₁ₖ * conj(αₖ)
        δbis₂ₖ   =                          - old_c₁ₖ * ν
        σbis₂ₖ   =                          - old_c₁ₖ * βₖ₊₁
        # [ c₂.ₖ₋₁  s₂.ₖ₋₁       ] [ ηbar₂ₖ₋₃  λbar₂ₖ₋₃    0        0   ]   [ η₂ₖ₋₃     λ₂ₖ₋₃     μ₂ₖ₋₃      0   ]
        # [ s̄₂.ₖ₋₁ -c₂.ₖ₋₁       ] [ σbis₂ₖ₋₂  ηbis₂ₖ₋₂  λbis₂ₖ₋₂   0   ] = [ σhat₂ₖ₋₂  ηhat₂ₖ₋₂  λhat₂ₖ₋₂   0   ]
        # [                 1    ] [   τ        αₖ         0       γₖ₊₁ ]   [   τ        αₖ         0       γₖ₊₁ ]
        # [                    1 ] [  θbisₖ    δbis₂ₖ    σbis₂ₖ     0   ]   [  θbisₖ    δbis₂ₖ    σbis₂ₖ     0   ]
        η₂ₖ₋₃    =      old_c₂ₖ  * ηbar₂ₖ₋₃ + old_s₂ₖ * σbis₂ₖ₋₂
        λ₂ₖ₋₃    =      old_c₂ₖ  * λbar₂ₖ₋₃ + old_s₂ₖ * ηbis₂ₖ₋₂
        μ₂ₖ₋₃    =                            old_s₂ₖ * λbis₂ₖ₋₂
        σhat₂ₖ₋₂ = conj(old_s₂ₖ) * ηbar₂ₖ₋₃ - old_c₂ₖ * σbis₂ₖ₋₂
        ηhat₂ₖ₋₂ = conj(old_s₂ₖ) * λbar₂ₖ₋₃ - old_c₂ₖ * ηbis₂ₖ₋₂
        λhat₂ₖ₋₂ =                          - old_c₂ₖ * λbis₂ₖ₋₂
        # [ 1                    ] [ η₂ₖ₋₃     λ₂ₖ₋₃     μ₂ₖ₋₃      0   ]   [ η₂ₖ₋₃     λ₂ₖ₋₃     μ₂ₖ₋₃      0   ]
        # [    c₃.ₖ₋₁     s₃.ₖ₋₁ ] [ σhat₂ₖ₋₂  ηhat₂ₖ₋₂  λhat₂ₖ₋₂   0   ] = [ σtmp₂ₖ₋₂  ηtmp₂ₖ₋₂  λtmp₂ₖ₋₂   0   ]
        # [            1         ] [   τ        αₖ         0       γₖ₊₁ ]   [   τ        αₖ         0       γₖ₊₁ ]
        # [    s̄₃.ₖ₋₁    -c₃.ₖ₋₁ ] [  θbisₖ    δbis₂ₖ    σbis₂ₖ     0   ]   [  θbarₖ    δbar₂ₖ    σbar₂ₖ     0   ]
        σtmp₂ₖ₋₂ =      old_c₃ₖ  * σhat₂ₖ₋₂ + old_s₃ₖ * θbisₖ
        ηtmp₂ₖ₋₂ =      old_c₃ₖ  * ηhat₂ₖ₋₂ + old_s₃ₖ * δbis₂ₖ
        λtmp₂ₖ₋₂ =      old_c₃ₖ  * λhat₂ₖ₋₂ + old_s₃ₖ * σbis₂ₖ
        θbarₖ    = conj(old_s₃ₖ) * σhat₂ₖ₋₂ - old_c₃ₖ * θbisₖ
        δbar₂ₖ   = conj(old_s₃ₖ) * ηhat₂ₖ₋₂ - old_c₃ₖ * δbis₂ₖ
        σbar₂ₖ   = conj(old_s₃ₖ) * λhat₂ₖ₋₂ - old_c₃ₖ * σbis₂ₖ
        # [ 1                    ] [ η₂ₖ₋₃     λ₂ₖ₋₃     μ₂ₖ₋₃      0   ]   [ η₂ₖ₋₃     λ₂ₖ₋₃     μ₂ₖ₋₃       0      ]
        # [    c₄.ₖ₋₁  s₄.ₖ₋₁    ] [ σtmp₂ₖ₋₂  ηtmp₂ₖ₋₂  λtmp₂ₖ₋₂   0   ] = [ σ₂ₖ₋₂     η₂ₖ₋₂     λ₂ₖ₋₂     μ₂ₖ₋₂    ]
        # [    s̄₄.ₖ₋₁ -c₄.ₖ₋₁    ] [   τ        αₖ         0       γₖ₊₁ ]   [ δbar₂ₖ₋₁  σbar₂ₖ₋₁  ηbar₂ₖ₋₁  λbar₂ₖ₋₁ ]
        # [                    1 ] [  θbarₖ    δbar₂ₖ    σbar₂ₖ     0   ]   [ θbarₖ     δbar₂ₖ    σbar₂ₖ      0      ]
        σ₂ₖ₋₂    =      old_c₄ₖ  * σtmp₂ₖ₋₂ + old_s₄ₖ * τ
        η₂ₖ₋₂    =      old_c₄ₖ  * ηtmp₂ₖ₋₂ + old_s₄ₖ * αₖ
        λ₂ₖ₋₂    =      old_c₄ₖ  * λtmp₂ₖ₋₂
        μ₂ₖ₋₂    =                            old_s₄ₖ * γₖ₊₁
        δbar₂ₖ₋₁ = conj(old_s₄ₖ) * σtmp₂ₖ₋₂ - old_c₄ₖ * τ
        σbar₂ₖ₋₁ = conj(old_s₄ₖ) * ηtmp₂ₖ₋₂ - old_c₄ₖ * αₖ
        ηbar₂ₖ₋₁ = conj(old_s₄ₖ) * λtmp₂ₖ₋₂
        λbar₂ₖ₋₁ =                          - old_c₄ₖ * γₖ₊₁
      end

      # [ 1                ] [ δbar₂ₖ₋₁  σbar₂ₖ₋₁ ]   [ δbar₂ₖ₋₁  σbar₂ₖ₋₁ ]
      # [    c₁.ₖ     s₁.ₖ ] [  θbarₖ     δbar₂ₖ  ] = [   θₖ       δbar₂ₖ  ]
      # [          1       ] [   0         βₖ₊₁   ]   [   0         βₖ₊₁   ]
      # [    s̄₁.ₖ    -c₁.ₖ ] [  γₖ₊₁        0     ]   [   0         gₖ     ]
      (c₁ₖ, s₁ₖ, θₖ) = sym_givens(θbarₖ, γₖ₊₁)
      gₖ     = conj(s₁ₖ) * δbar₂ₖ
      δbar₂ₖ =      c₁ₖ  * δbar₂ₖ

      # [ c₂.ₖ  s₂.ₖ       ] [ δbar₂ₖ₋₁  σbar₂ₖ₋₁ ]   [ δ₂ₖ₋₁  σ₂ₖ₋₁  ]
      # [ s̄₂.ₖ -c₂.ₖ       ] [   θₖ       δbar₂ₖ  ] = [  0     δbis₂ₖ ]
      # [             1    ] [   0         βₖ₊₁   ]   [  0      βₖ₊₁  ]
      # [                1 ] [   0         gₖ     ]   [  0       gₖ   ]
      (c₂ₖ, s₂ₖ, δ₂ₖ₋₁) = sym_givens(δbar₂ₖ₋₁, θₖ)
      σ₂ₖ₋₁  =      c₂ₖ  * σbar₂ₖ₋₁ + s₂ₖ * δbar₂ₖ
      δbis₂ₖ = conj(s₂ₖ) * σbar₂ₖ₋₁ - c₂ₖ * δbar₂ₖ

      # [ 1                ] [ δ₂ₖ₋₁  σ₂ₖ₋₁  ]   [ δ₂ₖ₋₁  σ₂ₖ₋₁  ]
      # [    c₃.ₖ     s₃.ₖ ] [  0     δbis₂ₖ ] = [  0     δhat₂ₖ ]
      # [          1       ] [  0      βₖ₊₁  ]   [  0      βₖ₊₁  ]
      # [    s̄₃.ₖ    -c₃.ₖ ] [  0       gₖ   ]   [  0       0    ]
      (c₃ₖ, s₃ₖ, δhat₂ₖ) = sym_givens(δbis₂ₖ, gₖ)

      # [ 1                ] [ δ₂ₖ₋₁  σ₂ₖ₋₁  ]   [ δ₂ₖ₋₁  σ₂ₖ₋₁ ]
      # [    c₄.ₖ  s₄.ₖ    ] [  0     δhat₂ₖ ] = [  0      δ₂ₖ  ]
      # [    s̄₄.ₖ -c₄.ₖ    ] [  0      βₖ₊₁  ]   [  0       0   ]
      # [                1 ] [  0       0    ]   [  0       0   ]
      (c₄ₖ, s₄ₖ, δ₂ₖ) = sym_givens(δhat₂ₖ, βₖ₊₁)

      # Solve Gₖ = Wₖ(Rₖ)⁻¹ ⟷ (Rₖ)ᵀ(Gₖ)ᵀ = (Wₖ)ᵀ.
      if iter == 1
        # [ δ₁  0  ] [ gx₁ gy₁ ] = [ v₁ 0  ]
        # [ σ₁  δ₂ ] [ gx₂ gy₂ ]   [ 0  u₁ ]
        kdivcopy!(m, gx₂ₖ₋₁, vₖ, δ₂ₖ₋₁)
        kscalcopy!(m, gx₂ₖ, -σ₂ₖ₋₁ / δ₂ₖ, gx₂ₖ₋₁)
        kdivcopy!(n, gy₂ₖ, uₖ, δ₂ₖ)
      elseif iter == 2
        # [ η₁ σ₂ δ₃ 0  ] [ gx₁ gy₁ ] = [ v₂ 0  ]
        # [ λ₁ η₂ σ₃ δ₄ ] [ gx₂ gy₂ ]   [ 0  u₂ ]
        #                 [ gx₃ gy₃ ]
        #                 [ gx₄ gy₄ ]
        @kswap!(gx₂ₖ₋₃, gx₂ₖ₋₁)
        @kswap!(gx₂ₖ₋₂, gx₂ₖ)
        @kswap!(gy₂ₖ₋₂, gy₂ₖ)
        gx₂ₖ₋₁ .= (vₖ .- η₂ₖ₋₃ .* gx₂ₖ₋₃ .- σ₂ₖ₋₂ .* gx₂ₖ₋₂                   ) ./ δ₂ₖ₋₁
        gx₂ₖ   .= (   .- λ₂ₖ₋₃ .* gx₂ₖ₋₃ .- η₂ₖ₋₂ .* gx₂ₖ₋₂ .- σ₂ₖ₋₁ .* gx₂ₖ₋₁) ./ δ₂ₖ
        gy₂ₖ₋₁ .= (   .- η₂ₖ₋₃ .* gy₂ₖ₋₃ .- σ₂ₖ₋₂ .* gy₂ₖ₋₂                   ) ./ δ₂ₖ₋₁
        gy₂ₖ   .= (uₖ .- λ₂ₖ₋₃ .* gy₂ₖ₋₃ .- η₂ₖ₋₂ .* gy₂ₖ₋₂ .- σ₂ₖ₋₁ .* gy₂ₖ₋₁) ./ δ₂ₖ
      else
        # μ₂ₖ₋₅ * gx₂ₖ₋₅ + λ₂ₖ₋₄ * gx₂ₖ₋₄ + η₂ₖ₋₃ * gx₂ₖ₋₃ + σ₂ₖ₋₂ * gx₂ₖ₋₂ + δ₂ₖ₋₁ * gx₂ₖ₋₁              = vₖ
        #                  μ₂ₖ₋₄ * gx₂ₖ₋₄ + λ₂ₖ₋₃ * gx₂ₖ₋₃ + η₂ₖ₋₂ * gx₂ₖ₋₂ + σ₂ₖ₋₁ * gx₂ₖ₋₁ + δ₂ₖ * gx₂ₖ = 0
        g₂ₖ₋₁ = g₂ₖ₋₅ = gx₂ₖ₋₃; g₂ₖ = g₂ₖ₋₄ = gx₂ₖ₋₂; g₂ₖ₋₃ = gx₂ₖ₋₁; g₂ₖ₋₂ = gx₂ₖ
        g₂ₖ₋₁ .= (vₖ .- μ₂ₖ₋₅ .* g₂ₖ₋₅ .- λ₂ₖ₋₄ .* g₂ₖ₋₄ .- η₂ₖ₋₃ .* g₂ₖ₋₃ .- σ₂ₖ₋₂ .* g₂ₖ₋₂                  ) ./ δ₂ₖ₋₁
        g₂ₖ   .= (                     .- μ₂ₖ₋₄ .* g₂ₖ₋₄ .- λ₂ₖ₋₃ .* g₂ₖ₋₃ .- η₂ₖ₋₂ .* g₂ₖ₋₂ .- σ₂ₖ₋₁ .* g₂ₖ₋₁) ./ δ₂ₖ
        @kswap!(gx₂ₖ₋₃, gx₂ₖ₋₁)
        @kswap!(gx₂ₖ₋₂, gx₂ₖ)
        # μ₂ₖ₋₅ * gy₂ₖ₋₅ + λ₂ₖ₋₄ * gy₂ₖ₋₄ + η₂ₖ₋₃ * gy₂ₖ₋₃ + σ₂ₖ₋₂ * gy₂ₖ₋₂ + δ₂ₖ₋₁ * gy₂ₖ₋₁              = 0
        #                  μ₂ₖ₋₄ * gy₂ₖ₋₄ + λ₂ₖ₋₃ * gy₂ₖ₋₃ + η₂ₖ₋₂ * gy₂ₖ₋₂ + σ₂ₖ₋₁ * gy₂ₖ₋₁ + δ₂ₖ * gy₂ₖ = uₖ
        g₂ₖ₋₁ = g₂ₖ₋₅ = gy₂ₖ₋₃; g₂ₖ = g₂ₖ₋₄ = gy₂ₖ₋₂; g₂ₖ₋₃ = gy₂ₖ₋₁; g₂ₖ₋₂ = gy₂ₖ
        g₂ₖ₋₁ .= (     .- μ₂ₖ₋₅ .* g₂ₖ₋₅ .- λ₂ₖ₋₄ .* g₂ₖ₋₄ .- η₂ₖ₋₃ .* g₂ₖ₋₃ .- σ₂ₖ₋₂ .* g₂ₖ₋₂                  ) ./ δ₂ₖ₋₁
        g₂ₖ   .= (uₖ                     .- μ₂ₖ₋₄ .* g₂ₖ₋₄ .- λ₂ₖ₋₃ .* g₂ₖ₋₃ .- η₂ₖ₋₂ .* g₂ₖ₋₂ .- σ₂ₖ₋₁ .* g₂ₖ₋₁) ./ δ₂ₖ
        @kswap!(gy₂ₖ₋₃, gy₂ₖ₋₁)
        @kswap!(gy₂ₖ₋₂, gy₂ₖ)
      end

      # Update p̅ₖ = (Qₖ)ᴴ * (β₁e₁ + γ₁e₂)
      πbis₂ₖ   =      c₁ₖ  * πbar₂ₖ
      πbis₂ₖ₊₂ = conj(s₁ₖ) * πbar₂ₖ
      #
      π₂ₖ₋₁  =      c₂ₖ  * πbar₂ₖ₋₁ + s₂ₖ * πbis₂ₖ
      πhat₂ₖ = conj(s₂ₖ) * πbar₂ₖ₋₁ - c₂ₖ * πbis₂ₖ
      #
      πtmp₂ₖ   =      c₃ₖ  * πhat₂ₖ + s₃ₖ * πbis₂ₖ₊₂
      πbar₂ₖ₊₂ = conj(s₃ₖ) * πhat₂ₖ - c₃ₖ * πbis₂ₖ₊₂
      #
      π₂ₖ      =      c₄ₖ  * πtmp₂ₖ
      πbar₂ₖ₊₁ = conj(s₄ₖ) * πtmp₂ₖ

      # Update xₖ = Gxₖ * pₖ
      kaxpy!(m, π₂ₖ₋₁, gx₂ₖ₋₁, xₖ)
      kaxpy!(m, π₂ₖ  , gx₂ₖ  , xₖ)

      # Update yₖ = Gyₖ * pₖ
      kaxpy!(n, π₂ₖ₋₁, gy₂ₖ₋₁, yₖ)
      kaxpy!(n, π₂ₖ  , gy₂ₖ  , yₖ)

      # Compute ‖rₖ‖² = |πbar₂ₖ₊₁|² + |πbar₂ₖ₊₂|²
      rNorm = sqrt(abs2(πbar₂ₖ₊₁) + abs2(πbar₂ₖ₊₂))
      history && push!(rNorms, rNorm)

      # Update vₖ and uₖ
      MisI || kcopy!(m, vₖ, vₖ₊₁)  # vₖ ← vₖ₊₁
      NisI || kcopy!(n, uₖ, uₖ₊₁)  # uₖ ← uₖ₊₁

      # Update M⁻¹vₖ₋₁ and N⁻¹uₖ₋₁
      kcopy!(m, M⁻¹vₖ₋₁, M⁻¹vₖ)  # M⁻¹vₖ₋₁ ← M⁻¹vₖ
      kcopy!(n, N⁻¹uₖ₋₁, N⁻¹uₖ)  # N⁻¹uₖ₋₁ ← N⁻¹uₖ

      # Update M⁻¹vₖ and N⁻¹uₖ
      kcopy!(m, M⁻¹vₖ, q)  # M⁻¹vₖ ← q
      kcopy!(n, N⁻¹uₖ, p)  # N⁻¹uₖ ← p

      # Update cosines and sines
      old_s₁ₖ = s₁ₖ
      old_s₂ₖ = s₂ₖ
      old_s₃ₖ = s₃ₖ
      old_s₄ₖ = s₄ₖ
      old_c₁ₖ = c₁ₖ
      old_c₂ₖ = c₂ₖ
      old_c₃ₖ = c₃ₖ
      old_c₄ₖ = c₄ₖ

      # Update workspace
      βₖ = βₖ₊₁
      γₖ = γₖ₊₁
      σbar₂ₖ₋₂ = σbar₂ₖ
      ηbar₂ₖ₋₃ = ηbar₂ₖ₋₁
      λbar₂ₖ₋₃ = λbar₂ₖ₋₁
      if iter ≥ 2
        μ₂ₖ₋₅ = μ₂ₖ₋₃
        μ₂ₖ₋₄ = μ₂ₖ₋₂
        λ₂ₖ₋₄ = λ₂ₖ₋₂
      end
      πbar₂ₖ₋₁ = πbar₂ₖ₊₁
      πbar₂ₖ   = πbar₂ₖ₊₂

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      resid_decrease_mach = (rNorm + one(T) ≤ one(T))

      # Update stopping criterion.
      user_requested_exit = callback(workspace) :: Bool
      resid_decrease_lim = rNorm ≤ ε
      breakdown = βₖ₊₁ ≤ btol && γₖ₊₁ ≤ btol
      solved = resid_decrease_lim || resid_decrease_mach
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %.2fs\n", iter, rNorm, βₖ₊₁, γₖ₊₁, start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    breakdown           && (status = "inconsistent linear system")
    solved              && (status = "solution good enough given atol and rtol")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update x and y
    warm_start && kaxpy!(m, one(FC), Δx, xₖ)
    warm_start && kaxpy!(n, one(FC), Δy, yₖ)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = !solved && breakdown
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

using oneAPI

include("gpu.jl")

@testset "Intel -- oneAPI.jl" begin

  @test oneAPI.functional()
  oneAPI.allowscalar(false)

  @testset "documentation" begin
    T = Float32
    m = 20
    n = 10
    A_cpu = rand(T, m, n)
    b_cpu = rand(T, m)
    A_gpu = oneMatrix(A_cpu)
    b_gpu = oneVector(b_cpu)
    x, stats = lsqr(A_gpu, b_gpu)
  end

  for FC ∈ (Float32, ) # ComplexF32)
    S = oneVector{FC}
    M = oneMatrix{FC}
    T = real(FC)
    n = 10
    x = rand(FC, n)
    x = S(x)
    y = rand(FC, n)
    y = S(y)
    a = rand(FC)
    b = rand(FC)
    s = rand(FC)
    a2 = rand(T)
    b2 = rand(T)
    c = rand(T)

    @testset "kdot -- $FC" begin
      Krylov.kdot(n, x, y)
    end

    @testset "kdotr -- $FC" begin
      Krylov.kdotr(n, x, y)
    end

    @testset "knorm -- $FC" begin
      Krylov.knorm(n, x)
    end

    @testset "kaxpy! -- $FC" begin
      Krylov.kaxpy!(n, a, x, y)
      Krylov.kaxpy!(n, a2, x, y)
    end

    @testset "kaxpby! -- $FC" begin
      Krylov.kaxpby!(n, a, x, b, y)
      Krylov.kaxpby!(n, a2, x, b, y)
      Krylov.kaxpby!(n, a, x, b2, y)
      Krylov.kaxpby!(n, a2, x, b2, y)
    end

    @testset "kcopy! -- $FC" begin
      Krylov.kcopy!(n, y, x)
    end

    @testset "kswap! -- $FC" begin
      Krylov.@kswap!(x, y)
    end

    @testset "kref! -- $FC" begin
      Krylov.kref!(n, x, y, c, s)
    end

    @testset "conversion -- $FC" begin
      test_conversion(S, M)
    end

    ε = eps(T)
    atol = √ε
    rtol = √ε

    @testset "GMRES -- $FC" begin
      A, b = symmetric_definite(FC=FC)
      A = M(A)
      b = S(b)
      x, stats = gmres(A, b)
      @test norm(b - A * x) ≤ atol + rtol * norm(b)
    end

    @testset "block-MINRES -- $FC" begin
      A, b = symmetric_indefinite(FC=FC)
      B = hcat(b, -b)
      A = M(A)
      B = M(B)
      X, stats = block_minres(A, B)
      @test norm(B - A * X) ≤ atol + rtol * norm(B)
    end

    @testset "block-GMRES -- $FC" begin
      A, b = nonsymmetric_definite(FC=FC)
      B = hcat(b, -b)
      A = M(A)
      B = M(B)
      X, stats = block_gmres(A, B)
      @test norm(B - A * X) ≤ atol + rtol * norm(B)
    end

    @testset "CG -- $FC" begin
      A, b = symmetric_definite(FC=FC)
      A = M(A)
      b = S(b)
      x, stats = cg(A, b)
      @test norm(b - A * x) ≤ atol + rtol * norm(b)
    end

    # @testset "MINRES-QLP -- $FC" begin
    #   A, b = symmetric_indefinite(FC=FC)
    #   A = M(A)
    #   b = S(b)
    #   x, stats = minres_qlp(A, b)
    #   @test norm(b - A * x) ≤ atol + rtol * norm(b)
    # end

    # @testset "processes -- $FC" begin
    #   test_processes(S, M)
    # end

    @testset "solver -- $FC" begin
      test_solver(S, M)
    end
  end
end

# An implementation of CGLS for the solution of the
# over-determined linear least-squares problem
#
#  minimize ‖Ax - b‖₂
#
# equivalently, of the normal equations
#
#  AᴴAx = Aᴴb.
#
# CGLS is formally equivalent to applying the conjugate gradient method
# to the normal equations but should be more stable. It is also formally
# equivalent to LSQR though LSQR should be expected to be more stable on
# ill-conditioned or poorly scaled problems.
#
# This method is described in
#
# M. R. Hestenes and E. Stiefel. Methods of conjugate gradients for solving linear systems.
# Journal of Research of the National Bureau of Standards, 49(6), pp. 409--436, 1952.
#
# This implementation is the standard formulation, as recommended by
#
# A. Björck, T. Elfving and Z. Strakos, Stability of Conjugate Gradient
# and Lanczos Methods for Linear Least Squares Problems.
# SIAM Journal on Matrix Analysis and Applications, 19(3), pp. 720--736, 1998.
#
# Dominique Orban, <dominique.orban@gerad.ca>
# Princeton, NJ, March 2015.

export cgls, cgls!

"""
    (x, stats) = cgls(A, b::AbstractVector{FC};
                      M=I, ldiv::Bool=false, radius::T=zero(T),
                      λ::T=zero(T), atol::T=√eps(T), rtol::T=√eps(T),
                      itmax::Int=0, timemax::Float64=Inf,
                      verbose::Int=0, history::Bool=false,
                      callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

Solve the regularized linear least-squares problem

    minimize ‖b - Ax‖₂² + λ‖x‖₂²

of size m × n using the Conjugate Gradient (CG) method, where λ ≥ 0 is a regularization
parameter. This method is equivalent to applying CG to the normal equations

    (AᴴA + λI) x = Aᴴb

but is more stable.

CGLS produces monotonic residuals ‖r‖₂ but not optimality residuals ‖Aᴴr‖₂.
It is formally equivalent to LSQR, though can be slightly less accurate,
but simpler to implement.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :cgls`.

For an in-place variant that reuses memory across solves, see [`cgls!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `n` used for preconditioning;
* `ldiv`: define whether the preconditioner uses `ldiv!` or `mul!`;
* `radius`: add the trust-region constraint ‖x‖ ≤ `radius` if `radius > 0`. Useful to compute a step in a trust-region method for optimization;
* `λ`: regularization parameter;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `m+n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### References

* M. R. Hestenes and E. Stiefel. [*Methods of conjugate gradients for solving linear systems*](https://doi.org/10.6028/jres.049.044), Journal of Research of the National Bureau of Standards, 49(6), pp. 409--436, 1952.
* A. Björck, T. Elfving and Z. Strakos, [*Stability of Conjugate Gradient and Lanczos Methods for Linear Least Squares Problems*](https://doi.org/10.1137/S089547989631202X), SIAM Journal on Matrix Analysis and Applications, 19(3), pp. 720--736, 1998.
"""
function cgls end

"""
    workspace = cgls!(workspace::CglsWorkspace, A, b; kwargs...)

In this call, `kwargs` are keyword arguments of [`cgls`](@ref).

See [`CglsWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :cgls` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function cgls! end

def_args_cgls = (:(A                    ),
                 :(b::AbstractVector{FC}))

def_kwargs_cgls = (:(; M = I                        ),
                   :(; ldiv::Bool = false           ),
                   :(; radius::T = zero(T)          ),
                   :(; λ::T = zero(T)               ),
                   :(; atol::T = √eps(T)            ),
                   :(; rtol::T = √eps(T)            ),
                   :(; itmax::Int = 0               ),
                   :(; timemax::Float64 = Inf       ),
                   :(; verbose::Int = 0             ),
                   :(; history::Bool = false        ),
                   :(; callback = workspace -> false),
                   :(; iostream::IO = kstdout       ))

def_kwargs_cgls = extract_parameters.(def_kwargs_cgls)

args_cgls = (:A, :b)
kwargs_cgls = (:M, :ldiv, :radius, :λ, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function cgls!(workspace :: CglsWorkspace{T,FC,Sm,Sn}, $(def_args_cgls...); $(def_kwargs_cgls...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "CGLS: system of %d equations in %d variables\n", m, n)

    # Tests M = Iₙ
    MisI = (M === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == Sm || error("ktypeof(b) must be equal to $Sm")

    # Compute the adjoint of A
    Aᴴ = A'

    # Set up workspace.
    allocate_if(!MisI, workspace, :Mr, Sm, workspace.r)  # The length of Mr is m
    x, p, s, r, q, stats = workspace.x, workspace.p, workspace.s, workspace.r, workspace.q, workspace.stats
    rNorms, ArNorms = stats.residuals, stats.Aresiduals
    reset!(stats)
    Mr = MisI ? r : workspace.Mr
    Mq = MisI ? q : workspace.Mr

    kfill!(x, zero(FC))
    kcopy!(m, r, b)      # r ← b
    bNorm = knorm(m, r)  # Marginally faster than norm(b)
    if bNorm == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      history && push!(rNorms, zero(T))
      history && push!(ArNorms, zero(T))
      return workspace
    end
    MisI || mulorldiv!(Mr, M, r, ldiv)
    kmul!(s, Aᴴ, Mr)
    kcopy!(n, p, s)     # p ← s
    γ = kdotr(n, s, s)  # γ = sᴴs
    iter = 0
    itmax == 0 && (itmax = m + n)

    rNorm  = bNorm
    ArNorm = sqrt(γ)
    history && push!(rNorms, rNorm)
    history && push!(ArNorms, ArNorm)
    ε = atol + rtol * ArNorm
    (verbose > 0) && @printf(iostream, "%5s  %8s  %8s  %5s\n", "k", "‖Aᴴr‖", "‖r‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %8.2e  %8.2e  %.2fs\n", iter, ArNorm, rNorm, start_time |> ktimer)

    status = "unknown"
    on_boundary = false
    solved = ArNorm ≤ ε
    tired = iter ≥ itmax
    user_requested_exit = false
    overtimed = false

    while ! (solved || tired || user_requested_exit || overtimed)
      kmul!(q, A, p)
      MisI || mulorldiv!(Mq, M, q, ldiv)
      δ = kdotr(m, q, Mq)  # δ = qᴴMq
      λ > 0 && (δ += λ * kdotr(n, p, p))  # δ = δ + pᴴp
      α = γ / δ

      # if a trust-region constraint is give, compute step to the boundary
      σ = radius > 0 ? maximum(to_boundary(n, x, p, Mr, radius)) : α
      if (radius > 0) & (α > σ)
        α = σ
        on_boundary = true
      end

      kaxpy!(n,  α, p, x)  # Faster than x = x + α * p
      kaxpy!(m, -α, q, r)  # Faster than r = r - α * q
      MisI || mulorldiv!(Mr, M, r, ldiv)
      kmul!(s, Aᴴ, Mr)
      λ > 0 && kaxpy!(n, -λ, x, s)  # s = A' * r - λ * x
      γ_next = kdotr(n, s, s)  # γ_next = sᴴs
      β = γ_next / γ
      kaxpby!(n, one(FC), s, β, p) # p = s + βp
      γ = γ_next
      rNorm = knorm(m, r)  # Marginally faster than norm(r)
      ArNorm = sqrt(γ)
      history && push!(rNorms, rNorm)
      history && push!(ArNorms, ArNorm)
      iter = iter + 1
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %8.2e  %8.2e  %.2fs\n", iter, ArNorm, rNorm, start_time |> ktimer)
      user_requested_exit = callback(workspace) :: Bool
      solved = (ArNorm ≤ ε) || on_boundary
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    solved              && (status = "solution good enough given atol and rtol")
    on_boundary         && (status = "on trust-region boundary")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = false
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

@testset "usymlq" begin
  usymlq_tol = 1.0e-6

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      # Symmetric and positive definite system.
      A, b = symmetric_definite(FC=FC)
      c = copy(b)
      (x, stats) = usymlq(A, b, c)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ usymlq_tol)
      @test(stats.solved)

      # Symmetric indefinite variant.
      A, b = symmetric_indefinite(FC=FC)
      c = copy(b)
      (x, stats) = usymlq(A, b, c)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ usymlq_tol)
      @test(stats.solved)

      # Nonsymmetric and positive definite systems.
      A, b = nonsymmetric_definite(FC=FC)
      c = copy(b)
      (x, stats) = usymlq(A, b, c)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ usymlq_tol)
      @test(stats.solved)

      # Nonsymmetric indefinite variant.
      A, b = nonsymmetric_indefinite(FC=FC)
      c = copy(b)
      (x, stats) = usymlq(A, b, c)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ usymlq_tol)
      @test(stats.solved)

      # Sparse Laplacian.
      A, b = sparse_laplacian(FC=FC)
      c = copy(b)
      (x, stats) = usymlq(A, b, c)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ usymlq_tol)
      @test(stats.solved)

      # Symmetric indefinite variant, almost singular.
      A, b = almost_singular(FC=FC)
      c = copy(b)
      (x, stats) = usymlq(A, b, c)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ usymlq_tol)
      @test(stats.solved)

      # Test b == 0
      A, b = zero_rhs(FC=FC)
      c = copy(b)
      (x, stats) = usymlq(A, b, c)
      @test norm(x) == 0
      @test stats.status == "x is a zero-residual solution"

      # Underdetermined and consistent systems.
      A, b = under_consistent(FC=FC)
      c = ones(FC, 25)
      (x, stats) = usymlq(A, b, c)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ usymlq_tol)

      # Square and consistent systems.
      A, b = square_consistent(FC=FC)
      c = ones(FC, 10)
      (x, stats) = usymlq(A, b, c)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ usymlq_tol)

      # Overdetermined and consistent systems.
      A, b = over_consistent(FC=FC)
      c = ones(FC, 10)
      (x, stats) = usymlq(A, b, c)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ usymlq_tol)

      # System that cause a breakdown with the orthogonal tridiagonalization process.
      A, b, c = unsymmetric_breakdown(FC=FC)
      (x, stats) = usymlq(A, b, c)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ usymlq_tol)
      @test(stats.solved)

      # Test different types for input and output
      A, b = square_consistent(FC=FC)
      c = TestVector(b)
      workspace = UsymlqWorkspace(KrylovConstructor(b, c))
      usymlq!(workspace, A, b, c)
      @test typeof(workspace.x) === typeof(c)
      @test workspace.stats.solved

      # test callback function
      A, b = sparse_laplacian(FC=FC)
      c = copy(b)
      workspace = UsymlqWorkspace(A, b)
      tol = 1.0
      cb_n2 = TestCallbackN2(A, b, tol = tol)
      usymlq!(workspace, A, b, c, atol = 0.0, rtol = 0.0, callback = cb_n2)
      @test workspace.stats.status == "user-requested exit"
      @test cb_n2(workspace)

      @test_throws TypeError usymlq(A, b, c, callback = workspace -> "string", history = true)
    end
  end
end

@testset "stats" begin
  stats = Krylov.SimpleStats(0, true, true, false, 0,Float64[1.0], Float64[2.0], Float64[], 0.542, 1.234, "unknown")
  stats2 = Krylov.SimpleStats(1, true, true, false, 0,Float64[1.0], Float64[2.0], Float64[], 0.542, 1.234, "unknown")
  copyto!(stats2, stats)
  io = IOBuffer()
  show(io, stats)
  showed = String(take!(io))
  storage_type = typeof(stats)
  expected = """SimpleStats
  niter: 0
  solved: true
  inconsistent: true
  indefinite: false
  npcCount: 0
  residuals: [ 1.0e+00 ]
  Aresiduals: [ 2.0e+00 ]
  κ₂(A): []
  allocation timer: 542.00ms
  timer: 1.23s
  status: unknown"""
  @test strip.(split(chomp(showed), "\n")) == strip.(split(chomp(expected), "\n"))
  Krylov.reset!(stats)
  check_reset(stats)
  nbytes_allocated = @allocated Krylov.reset!(stats)
  @test nbytes_allocated == 0

  stats = Krylov.LsmrStats(0, true, true, Float64[1.0], Float64[2.0], Float64(3.0), Float64(4.0), Float64(5.0), Float64(6.0), Float64(7.0), 0.542, 0.1234, "unknown")
  stats2 = Krylov.LsmrStats(1, true, true, Float64[1.0], Float64[2.0], Float64(3.0), Float64(4.0), Float64(5.0), Float64(6.0), Float64(7.0), 0.542, 0.1234, "unknown")
  copyto!(stats2, stats)
  io = IOBuffer()
  show(io, stats)
  showed = String(take!(io))
  storage_type = typeof(stats)
  expected = """LsmrStats
  niter: 0
  solved: true
  inconsistent: true
  residuals: [ 1.0e+00 ]
  Aresiduals: [ 2.0e+00 ]
  residual: 3.0
  Aresidual: 4.0
  κ₂(A): 5.0
  ‖A‖F: 6.0
  xNorm: 7.0
  allocation timer: 542.00ms
  timer: 123.40ms
  status: unknown"""
  @test strip.(split(chomp(showed), "\n")) == strip.(split(chomp(expected), "\n"))
  Krylov.reset!(stats)
  check_reset(stats)
  nbytes_allocated = @allocated Krylov.reset!(stats)
  @test nbytes_allocated == 0

  stats = Krylov.LanczosStats(0, true, Float64[3.0], true, NaN, NaN, 0.542, 1.234, "unknown")
  stats2 = Krylov.LanczosStats(1, true, Float64[3.0], true, NaN, NaN, 0.542, 1.234, "unknown")
  copyto!(stats2, stats)
  io = IOBuffer()
  show(io, stats)
  showed = String(take!(io))
  storage_type = typeof(stats)
  expected = """LanczosStats
  niter: 0
  solved: true
  residuals: [ 3.0e+00 ]
  indefinite: true
  ‖A‖F: NaN
  κ₂(A): NaN
  allocation timer: 542.00ms
  timer: 1.23s
  status: unknown"""
  @test strip.(split(chomp(showed), "\n")) == strip.(split(chomp(expected), "\n"))
  Krylov.reset!(stats)
  check_reset(stats)
  nbytes_allocated = @allocated Krylov.reset!(stats)
  @test nbytes_allocated == 0

  stats = Krylov.LanczosShiftStats(0, true, [Float64[0.9, 0.5], Float64[0.6, 0.4, 0.1]], BitVector([false, true]), NaN, NaN, 0.542, 0.00056789, "unknown")
  stats2 = Krylov.LanczosShiftStats(1, true, [Float64[0.9, 0.5], Float64[0.6, 0.4, 0.1]], BitVector([false, true]), NaN, NaN, 0.542, 0.00056789, "unknown")
  copyto!(stats2, stats)
  io = IOBuffer()
  show(io, stats)
  showed = String(take!(io))
  storage_type = typeof(stats)
  expected = """LanczosShiftStats
  niter: 0
  solved: true
  residuals: [[0.9, 0.5], [0.6, 0.4, 0.1]]
  indefinite: Bool[0, 1]
  ‖A‖F: NaN
  κ₂(A): NaN
  allocation timer: 542.00ms
  timer: 567.89μs
  status: unknown"""
  @test strip.(split(chomp(showed), "\n")) == strip.(split(chomp(expected), "\n"))
  Krylov.reset!(stats)
  nbytes_allocated = @allocated Krylov.reset!(stats)
  @test nbytes_allocated == 0

  stats = Krylov.SymmlqStats(0, true, Float64[4.0], Union{Float64,Missing}[5.0, missing], Float64[6.0], Union{Float64,Missing}[7.0, missing], NaN, NaN, 0.542, 1.234, "unknown")
  stats2 = Krylov.SymmlqStats(1, true, Float64[4.0], Union{Float64,Missing}[5.0, missing], Float64[6.0], Union{Float64,Missing}[7.0, missing], NaN, NaN, 0.542, 1.234, "unknown")
  copyto!(stats2, stats)
  io = IOBuffer()
  show(io, stats)
  showed = String(take!(io))
  storage_type = typeof(stats)
  expected = """SymmlqStats
  niter: 0
  solved: true
  residuals: [ 4.0e+00 ]
  residuals (cg): [ 5.0e+00  ✗✗✗✗ ]
  errors: [ 6.0e+00 ]
  errors (cg): [ 7.0e+00  ✗✗✗✗ ]
  ‖A‖F: NaN
  κ₂(A): NaN
  allocation timer: 542.00ms
  timer: 1.23s
  status: unknown"""
  @test strip.(split(chomp(showed), "\n")) == strip.(split(chomp(expected), "\n"))
  Krylov.reset!(stats)
  check_reset(stats)
  nbytes_allocated = @allocated Krylov.reset!(stats)
  @test nbytes_allocated == 0

  stats = Krylov.AdjointStats(0, true, true, Float64[8.0], Float64[9.0], 0.542, 1.234, "unknown")
  stats2 = Krylov.AdjointStats(1, true, true, Float64[8.0], Float64[9.0], 0.542, 1.234, "unknown")
  copyto!(stats2, stats)
  io = IOBuffer()
  show(io, stats)
  showed = String(take!(io))
  storage_type = typeof(stats)
  expected = """AdjointStats
  niter: 0
  solved primal: true
  solved dual: true
  residuals primal: [ 8.0e+00 ]
  residuals dual: [ 9.0e+00 ]
  allocation timer: 542.00ms
  timer: 1.23s
  status: unknown"""
  @test strip.(split(chomp(showed), "\n")) == strip.(split(chomp(expected), "\n"))
  Krylov.reset!(stats)
  check_reset(stats)
  nbytes_allocated = @allocated Krylov.reset!(stats)
  @test nbytes_allocated == 0

  stats = Krylov.LNLQStats(0, true, Float64[10.0], false, Float64[11.0], Float64[12.0], 0.542, 1.234, "unknown")
  stats2 = Krylov.LNLQStats(1, true, Float64[10.0], false, Float64[11.0], Float64[12.0], 0.542, 1.234, "unknown")
  copyto!(stats2, stats)
  io = IOBuffer()
  show(io, stats)
  showed = String(take!(io))
  storage_type = typeof(stats)
  expected = """LNLQStats
  niter: 0
  solved: true
  residuals: [ 1.0e+01 ]
  error with bnd: false
  error bnd x: [ 1.1e+01 ]
  error bnd y: [ 1.2e+01 ]
  allocation timer: 542.00ms
  timer: 1.23s
  status: unknown"""
  @test strip.(split(chomp(showed), "\n")) == strip.(split(chomp(expected), "\n"))
  Krylov.reset!(stats)
  check_reset(stats)
  nbytes_allocated = @allocated Krylov.reset!(stats)
  @test nbytes_allocated == 0

  stats = Krylov.LSLQStats(0, true, false, Float64[13.0], Float64[14.0], Float64[15.0], false, Float64[16.0], Float64[17.0], 0.542, 1.234, "unknown")
  stats2 = Krylov.LSLQStats(1, true, false, Float64[13.0], Float64[14.0], Float64[15.0], false, Float64[16.0], Float64[17.0], 0.542, 1.234, "unknown")
  copyto!(stats2, stats)
  io = IOBuffer()
  show(io, stats)
  showed = String(take!(io))
  storage_type = typeof(stats)
  expected = """LSLQStats
  niter: 0
  solved: true
  inconsistent: false
  residuals: [ 1.3e+01 ]
  Aresiduals: [ 1.4e+01 ]
  err lbnds: [ 1.5e+01 ]
  error with bnd: false
  error bound LQ: [ 1.6e+01 ]
  error bound CG: [ 1.7e+01 ]
  allocation timer: 542.00ms
  timer: 1.23s
  status: unknown"""
  @test strip.(split(chomp(showed), "\n")) == strip.(split(chomp(expected), "\n"))
  Krylov.reset!(stats)
  check_reset(stats)
  nbytes_allocated = @allocated Krylov.reset!(stats)
  @test nbytes_allocated == 0
end

@testset "car" begin
  car_tol = 1.0e-6

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      # Symmetric and positive definite system.
      A, b = symmetric_definite(FC=FC)
      (x, stats) = car(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ car_tol)
      @test(stats.solved)

      # Sparse Laplacian.
      A, b = sparse_laplacian(FC=FC)
      (x, stats) = car(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ car_tol)
      @test(stats.solved)

      # Test b == 0
      A, b = zero_rhs(FC=FC)
      (x, stats) = car(A, b)
      @test norm(x) == 0
      @test stats.status == "x is a zero-residual solution"

      # Test with Jacobi (or diagonal) preconditioner
      A, b, M = square_preconditioned(FC=FC)
      (x, stats) = car(A, b, M=M)
      r = b - A * x
      resid = norm(M * r) / norm(M * b)
      @test(resid ≤ car_tol)
      @test(stats.solved)

      # Test singular and consistent system
      A, b = singular_consistent(FC=FC)
      x, stats = car(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ car_tol)
      @test !stats.inconsistent

      # Poisson equation in cartesian coordinates.
      A, b = cartesian_poisson(FC=FC)
      (x, stats) = car(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ car_tol)
      @test(stats.solved)

      # test callback function
      A, b = cartesian_poisson(FC=FC)
      workspace = CarWorkspace(A, b)
      tol = 1.0e-1
      cb_n2 = TestCallbackN2(A, b, tol = tol)
      car!(workspace, A, b, callback = cb_n2)
      @test workspace.stats.status == "user-requested exit"
      @test cb_n2(workspace)

      @test_throws TypeError car(A, b, callback = workspace -> "string", history = true)
    end
  end
end

module Krylov

using LinearAlgebra, SparseArrays, Printf
import LinearAlgebra.BLAS: BlasInt, @blasfunc, libblastrampoline

include("krylov_stats.jl")

include("krylov_utils.jl")
include("block_krylov_utils.jl")

include("krylov_processes.jl")
include("block_krylov_processes.jl")

include("krylov_workspaces.jl")
include("block_krylov_workspaces.jl")
include("workspace_accessors.jl")

include("krylov_show.jl")

include("block_minres.jl")
include("block_gmres.jl")

include("cg.jl")
include("cr.jl")
include("car.jl")

include("symmlq.jl")
include("cg_lanczos.jl")
include("minres.jl")
include("minres_qlp.jl")
include("minares.jl")

include("diom.jl")
include("fom.jl")
include("dqgmres.jl")
include("gmres.jl")
include("fgmres.jl")

include("gpmr.jl")

include("usymlq.jl")
include("usymqr.jl")
include("usymlqr.jl")
include("tricg.jl")
include("trimr.jl")
include("trilqr.jl")

include("cgs.jl")
include("bicgstab.jl")

include("bilq.jl")
include("qmr.jl")
include("bilqr.jl")

include("cgls.jl")
include("crls.jl")

include("cgne.jl")
include("crmr.jl")

include("lslq.jl")
include("lsqr.jl")
include("lsmr.jl")

include("lnlq.jl")
include("craig.jl")
include("craigmr.jl")

include("cg_lanczos_shift.jl")
include("cgls_lanczos_shift.jl")

include("interface.jl")
end

using Krylov

include("get_div_grad.jl")
include("gen_lsq.jl")
include("check_min_norm.jl")
include("callback_utils.jl")

struct TestVector{T} <: AbstractVector{T}
    data::Vector{T}
end
TestVector{T}(::UndefInitializer, n::Integer) where {T} = TestVector{T}(Vector{T}(undef, n))
Base.size(v::TestVector) = size(v.data)
Base.getindex(v::TestVector, i::Int) = v.data[i]
Base.setindex!(v::TestVector, val, i::Int) = (v.data[i] = val)
Base.similar(v::TestVector, ::Type{S}, dims::Dims) where {S} = TestVector{S}(similar(v.data, S, dims))

# Symmetric and positive definite systems.
function symmetric_definite(n :: Int=10; FC=Float64)
  α = FC <: Complex ? FC(im) : one(FC)
  A = spdiagm(-1 => α * ones(FC, n-1), 0 => 4 * ones(FC, n), 1 => conj(α) * ones(FC, n-1))
  b = A * FC[1:n;]
  return A, b
end

# Symmetric and indefinite systems.
function symmetric_indefinite(n :: Int=10; FC=Float64,  shift=0)
  α = FC <: Complex ? FC(im) : one(FC)
  A = spdiagm(-1 => α * ones(FC, n-1), 0 => ones(FC, n), 1 => conj(α) * ones(FC, n-1))- shift * eye(n)
  b = A * FC[1:n;]
  return A, b
end

"""
    system_zero_quad(n::Int=2; FC=Float64)

Creates an n×n symmetric matrix `A` and vector `b` (with n ≥ 2) such that:
- `A ≠ 0` and `b ≠ 0`
- `b^T * A * b == 0`

The construction embeds a 2×2 block in the upper-left corner where

    A[1,1] = 1   and   A[2,2] = -1,

and defines

    b[1] = 1   and   b[2] = 1,

with all other entries equal to zero.

Example usage:
    A, b = system_zero_quad(5, FC=Float64)
    println("A =")
    println(Matrix(A))
    println("b = ", b)
    println("b^T * A * b = ", b' * A * b)
"""
function system_zero_quad(n::Int=2; FC=Float64)
    if n < 2
        error("n must be at least 2")
    end
    A = zeros(FC, n, n)
    # Define a 2×2 nontrivial block that is symmetric and indefinite.
    A[1, 1] = one(FC)
    A[2, 2] = -one(FC)
    b = zeros(FC, n)
    b[1] = one(FC)
    b[2] = one(FC)
    return A, b
end

# Nonsymmetric and positive definite systems.
function nonsymmetric_definite(n :: Int=10; FC=Float64)
  if FC <: Complex
    A = [i == j ? n * one(FC) : FC(im) * one(FC) for i=1:n, j=1:n]
  else
    A = [i == j ? n * one(FC) : i < j ? one(FC) : -one(FC) for i=1:n, j=1:n]
  end
  b = A * FC[1:n;]
  return A, b
end

# Nonsymmetric and indefinite systems.
function nonsymmetric_indefinite(n :: Int=10; FC=Float64)
  if FC <: Complex
    A = [i == j ? n * (-one(FC))^(i*j) : FC(im) * one(FC) for i=1:n, j=1:n]
  else
    A = [i == j ? n * (-one(FC))^(i*j) : i < j ? one(FC) : -one(FC) for i=1:n, j=1:n]
  end
  b = A * FC[1:n;]
  return A, b
end

# Underdetermined and consistent systems.
function under_consistent(n :: Int=10, m :: Int=25; FC=Float64)
  n < m || error("Square or overdetermined system!")
  α = FC <: Complex ? FC(im) : one(FC)
  A = FC[i/j - α * j/i for i=1:n, j=1:m]
  b = A * ones(FC, m)
  return A, b
end

# Underdetermined and inconsistent systems.
function under_inconsistent(n :: Int=10, m :: Int=25; FC=Float64)
  n < m || error("Square or overdetermined system!")
  α = FC <: Complex ? FC(1 + im) : one(FC)
  A = α * ones(FC, n, m)
  b = [i == 1 ? -one(FC) : i * one(FC) for i=1:n]
  return A, b
end

# Square and consistent systems.
function square_consistent(n :: Int=10; FC=Float64)
  α = FC <: Complex ? im : 1
  A = FC[i/j - α * j/i for i=1:n, j=1:n]
  b = A * ones(FC, n)
  return A, b
end

# Square and inconsistent systems.
function square_inconsistent(n :: Int=10; FC=Float64)
  A = Diagonal(ones(FC, n))
  A[1, 1] = zero(FC)
  b = ones(FC, n)
  return A, b
end

# Symmetric and inconsistent system.
function symmetric_inconsistent()
  A = [3.0 2.0 -1.0 5.0; 2.0 -2.0 4.0 0.0; -1.0 4.0 1.0 3.0; 5.0 0.0 3.0 5.0]
  b = [1.0; -8.0; 5.0; 2.0]
  return A, b
end

# Overdetermined and consistent systems.
function over_consistent(n :: Int=25, m :: Int=10; FC=Float64)
  n > m || error("Underdetermined or square system!")
  α = FC <: Complex ? FC(im) : one(FC)
  A = FC[i/j - α * j/i for i=1:n, j=1:m]
  b = A * ones(FC, m)
  return A, b
end

# Overdetermined and inconsistent systems.
function over_inconsistent(n :: Int=25, m :: Int=10; FC=Float64)
  n > m || error("Underdetermined or square system!")
  α = FC <: Complex ? FC(1 + im) : one(FC)
  A = α * ones(FC, n, m)
  b = [i == 1 ? -one(FC) : i * one(FC) for i=1:n]
  return A, b
end

# Sparse Laplacian.
function sparse_laplacian(n :: Int=16; FC=Float64)
  A = get_div_grad(n, n, n)
  b = ones(n^3)
  return A, b
end

# Large-scale unsymmetric systems generated with Kronecker products.
function kron_unsymmetric(n :: Int=64; FC=Float64)
  N = n^3
  A = spdiagm(-1 => fill(-one(FC), n - 1), 0 => fill(FC(3.0), n), 1 => fill(FC(-2.0), n - 1))
  Id = eye(n)
  A = kron(A, Id) + kron(Id, A)
  A = kron(A, Id) + kron(Id, A)
  x = ones(N)
  b = A * x
  return A, b
end

# Symmetric, indefinite and almost singular systems.
function almost_singular(n :: Int=16; FC=Float64)
  A = get_div_grad(n, n, n)
  A = FC.(A) - 5 * I
  b = A * ones(FC, n^3)
  return A, b
end

# Symmetric, singular and consistent systems.
function singular_consistent(n :: Int=10; FC=Float64)
  A = [FC(i*j) for i=1:n, j=1:n] + 5 * eye(n)
  A[:,1] .= A[:,2] .= A[2,:] .= A[1,:] .= one(FC)
  b = A * ones(FC, n)
  return A, b
end

# System that cause a breakdown with the symmetric Lanczos process.
function symmetric_breakdown(; FC=Float64)
  A = [0.0 1.0; 1.0 0.0]
  b = [1.0; 0.0]
  return A, b
end

# System that cause a breakdown with the Lanczos biorthogonalization
# and the orthogonal tridiagonalization processes.
function unsymmetric_breakdown(; FC=Float64)
  A = [0.0 1.0; -1.0 0.0]
  b = [1.0; 0.0]
  c = [-1.0; 0.0]
  return A, b, c
end

# Initial vectors that cause a breakdown with the Lanczos biorthogonalization process.
function bc_breakdown(; FC=Float64)
  A = [1.0 2.0; 3.0 4.0]
  b = [0.0; 1.0]
  c = [1.0; 0.0]
  return A, b, c
end

# Underdetermined consistent adjoint systems.
function underdetermined_adjoint(n :: Int=100, m :: Int=200; FC=Float64)
  n < m || error("Square or overdetermined system!")
  A = [i == j ? FC(10.0) : i < j ? one(FC) : -one(FC) for i=1:n, j=1:m]
  b = A * FC[1:m;]
  c = A' * FC[-n:-1;]
  return A, b, c
end

# Square consistent adjoint systems.
function square_adjoint(n :: Int=100; FC=Float64)
  A = [i == j ? FC(10.0) : i < j ? one(FC) : -one(FC) for i=1:n, j=1:n]
  b = A * FC[1:n;]
  c = A' * FC[-n:-1;]
  return A, b, c
end

# Adjoint systems with Ax = b underdetermined consistent and Aᴴt = c overdetermined inconsistent.
function rectangular_adjoint(n :: Int=10, m :: Int=25; FC=Float64)
  Aᴴ, c = over_inconsistent(m, n; FC=FC)
  A = adjoint(Aᴴ)
  b = A * ones(FC, m)
  return A, b, c
end

# Overdetermined consistent adjoint systems.
function overdetermined_adjoint(n :: Int=200, m :: Int=100; FC=Float64)
  n > m || error("Underdetermined or square system!")
  A = [i == j ? FC(10.0) : i < j ? one(FC) : -one(FC) for i=1:n, j=1:m]
  b = A * FC[1:m;]
  c = A' * FC[-n:-1;]
  return A, b, c
end

# Adjoint ODEs.
function adjoint_ode(n :: Int=50; FC=Float64)
  χ₁ = χ₂ = χ₃ = 1.0
  # Primal ODE
  # χ₁ * d²U(x)/dx² + χ₂ * dU(x)/dx + χ₃ * U(x) = f(x)
  # U(0) = U(1) = 0
  function f(x)
    return (- χ₁ * π * π + χ₃) .* sin.(π.*x) .+ (χ₂ * π) .* cos.(π.*x)
  end
  # Dual ODE
  # χ₁ * d²V(x)/dx² - χ₂ * dV(x)/dx + χ₃ *  V(x) = g(x)
  # V(0) = V(1) = 0
  function g(x)
    exp.(x)
  end
  A, b, c = ODE(n, f, g, [χ₁, χ₂, χ₃])
  return A, b, c
end

# Adjoint PDEs.
function adjoint_pde(n :: Int=50, m :: Int=50; FC=Float64)
  κ₁ = 5.0
  κ₂ = 20.0
  κ₃ = 0.0
  # Primal PDE
  # κ₁ * ( ∂²u(x,y)/∂x² + ∂²u(x,y)/∂y² )  + κ₂ * ( ∂u(x,y)/∂x + ∂u(x,y)/∂y ) = f(x,y), (x,y) ∈ Ω
  # u(x,y) = 0, (x,y) ∈ ∂Ω
  function f(x, y)
    return (-2 * κ₁ * π * π + κ₃) * sin(π * x) * sin(π * y) + κ₂ * π * cos(π * x) * sin(π * y) + κ₂ * π * sin(π * x) * cos(π * y)
  end
  # Dual PDE
  # κ₁ * ( ∂²v(x,y)/∂x² + ∂²v(x,y)/∂y² )  - κ₂ * ( ∂v(x,y)/∂x + ∂v(x,y)/∂y ) = g(x,y), (x,y) ∈ Ω
  # v(x,y) = 0, (x,y) ∈ ∂Ω
  function g(x, y)
    return exp(x + y)
  end
  A, b, c = PDE(n, m, f, g, [κ₁, κ₁, κ₂, κ₂, κ₃])
  return A, b, c
end

# Poisson equation in polar coordinates with homogeneous boundary conditions.
function polar_poisson(n :: Int=50, m :: Int=50; FC=Float64)
  f(r, θ) = -3.0 * cos(θ)
  g(r, θ) = 0.0
  A, b = polar_poisson(n, m, f, g)
  return A, b
end

# Poisson equation in cartesian coordinates with homogeneous boundary conditions.
function cartesian_poisson(n :: Int=50, m :: Int=50; FC=Float64)
  f(x, y) = - 2.0 * π * π * sin(π * x) * sin(π * y)
  g(x, y) = 0.0
  A, b = cartesian_poisson(n, m, f, g)
  return A, b
end

# Square and preconditioned problems.
function square_preconditioned(n :: Int=10; FC=Float64)
  A   = ones(FC, n, n) + (n-1) * eye(n)
  b   = 10 * FC[1:n;]
  M⁻¹ = FC(1/n) * eye(n)
  return A, b, M⁻¹
end

# Square problems with two preconditioners.
function two_preconditioners(n :: Int=10, m :: Int=20; FC=Float64)
  A   = ones(FC, n, n) + (n-1) * eye(n)
  b   = ones(FC, n)
  M⁻¹ = FC(1/√n) * eye(n)
  N⁻¹ = FC(1/√m) * eye(n)
  return A, b, M⁻¹, N⁻¹
end

# Random Ax = b with b == 0.
function zero_rhs(n :: Int=10; FC=Float64)
  A = rand(FC, n, n)
  b = zeros(FC, n)
  return A, b
end

# Regularized problems.
function regularization(n :: Int=5; FC=Float64)
  A = FC[2^(i/j)*j + (-1)^(i-j) * n*(i-1) for i = 1:n, j = 1:n]
  b = ones(FC, n)
  λ = 4.0
  return A, b, λ
end

# Saddle-point systems with square A.
function saddle_point(n :: Int=5; FC=Float64)
  A = [2^(i/j)*j + (-1)^(i-j) * n*(i-1) for i = 1:n, j = 1:n]
  b = ones(n)
  D = diagm(0 => [2.0 * i for i = 1:n])
  return A, b, D
end

# Saddle-point systems with rectangular A.
function small_sp(transpose :: Bool=false; FC=Float64)
  A = [1.0 0.0; 0.0 -1.0; 3.0 0.0]
  A = transpose ? Matrix(A') : A
  n, m = size(A)
  b = ones(n)
  c = -ones(m)
  D = diagm(0 => [2.0 * i for i = 1:n])
  return A, b, c, D
end

# Generalized saddle-point systems with rectangular A and B.
function gsp(transpose :: Bool=false; FC=Float64)
  A = [1.0 0.0; 0.0 -1.0; 3.0 0.0]
  A = transpose ? Matrix(A') : A
  B = [0.0 2.0 4.0; -3.0 0.0 0.0]
  B = transpose ? Matrix(B') : B
  n, m = size(A)
  b = ones(n)
  c = -ones(m)
  M = diagm(0 => [2.0 * i for i = 1:n])
  N = diagm(0 => [16.0 * i for i = 1:m])
  return A, B, b, c, M, N
end

# Symmetric and quasi-definite systems with square A.
function sqd(n :: Int=5; FC=Float64)
  A = [2^(i/j)*j + (-1)^(i-j) * n*(i-1) for i = 1:n, j = 1:n]
  b = ones(n)
  M = diagm(0 => [3.0 * i for i = 1:n])
  N = diagm(0 => [5.0 * i for i = 1:n])
  return A, b, M, N
end

# Symmetric and quasi-definite systems with rectangular A.
function small_sqd(transpose :: Bool=false; FC=Float64)
  A = [1.0 0.0; 0.0 -1.0; 3.0 0.0]
  A = transpose ? Matrix(A') : A
  n, m = size(A)
  b = ones(n)
  c = -ones(m)
  M = diagm(0 => [3.0 * i for i = 1:n])
  N = diagm(0 => [5.0 * i for i = 1:m])
  return A, b, c, M, N
end

# Test warm-start feature with linear systems of size n³.
function warm_start(n :: Int=8; FC=Float64)
  A = get_div_grad(n, n, n)
  A = FC.(A)
  b = A * ones(FC, n^3)
  return A, b
end

# Generate a breakdown in the orthogonal tridiagonalization process and the orthogonal Hessenberg reduction process.
function ssy_mo_breakdown(transpose :: Bool=false; FC=Float64)
  if transpose
    A = FC[1 -1; 0 1; -1 0]
  else
    A = FC[1 0 -1; -1 1 0]
  end
  n, m = size(A)
  b = ones(FC, n)
  c = ones(FC, m)
  return A, b, c
end

function ssy_mo_breakdown2(FC=Float64)
  A = FC[-1 2 0; 1 -1 1; 0 0 -1]
  b = FC[1; 0; 0]
  c = FC[1; 0; 0]
  return A, b, c
end

function ssy_mo_breakdown3(FC=Float64)
  A = FC[-1 1 0; 3 -1 0; 0 1 -1]
  b = FC[1; 0; 0]
  c = FC[1; 0; 0]
  return A, b, c
end

function small_ln(; FC=Float64)
  A = FC[0 1]
  b = FC[1]
  return A, b
end

# Check that a KrylovStats is reset.
function check_reset(stats :: KS) where KS <: Krylov.KrylovStats
  for field in fieldnames(KS)
    statsfield = getfield(stats, field)
    if isa(statsfield, AbstractVector)
      @test isempty(statsfield)
    end
  end
end

# An implementation of CRLS for the solution of the
# over-determined linear least-squares problem
#
#  minimize ‖Ax - b‖₂
#
# equivalently, of the linear system
#
#  AᴴAx = Aᴴb.
#
# This implementation follows the formulation given in
#
# D. C.-L. Fong, Minimum-Residual Methods for Sparse
# Least-Squares using Golubg-Kahan Bidiagonalization,
# Ph.D. Thesis, Stanford University, 2011.
#
# with the difference that it also recurs r = b - Ax.
#
# Dominique Orban, <dominique.orban@gerad.ca>
# Princeton, NJ, March 2015.

export crls, crls!

"""
    (x, stats) = crls(A, b::AbstractVector{FC};
                      M=I, ldiv::Bool=false, radius::T=zero(T),
                      λ::T=zero(T), atol::T=√eps(T), rtol::T=√eps(T),
                      itmax::Int=0, timemax::Float64=Inf,
                      verbose::Int=0, history::Bool=false,
                      callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

Solve the linear least-squares problem

    minimize ‖b - Ax‖₂² + λ‖x‖₂²

of size m × n using the Conjugate Residuals (CR) method.
This method is equivalent to applying MINRES to the normal equations

    (AᴴA + λI) x = Aᴴb.

This implementation recurs the residual r := b - Ax.

CRLS produces monotonic residuals ‖r‖₂ and optimality residuals ‖Aᴴr‖₂.
It is formally equivalent to LSMR, though can be substantially less accurate,
but simpler to implement.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :crls`.

For an in-place variant that reuses memory across solves, see [`crls!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `n` used for preconditioning;
* `ldiv`: define whether the preconditioner uses `ldiv!` or `mul!`;
* `radius`: add the trust-region constraint ‖x‖ ≤ `radius` if `radius > 0`. Useful to compute a step in a trust-region method for optimization;
* `λ`: regularization parameter;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `m+n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### Reference

* D. C.-L. Fong, *Minimum-Residual Methods for Sparse, Least-Squares using Golubg-Kahan Bidiagonalization*, Ph.D. Thesis, Stanford University, 2011.
"""
function crls end

"""
    workspace = crls!(workspace::CrlsWorkspace, A, b; kwargs...)

In this call, `kwargs` are keyword arguments of [`crls`](@ref).

See [`CrlsWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :crls` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function crls! end

def_args_crls = (:(A                    ),
                 :(b::AbstractVector{FC}))

def_kwargs_crls = (:(; M = I                        ),
                   :(; ldiv::Bool = false           ),
                   :(; radius::T = zero(T)          ),
                   :(; λ::T = zero(T)               ),
                   :(; atol::T = √eps(T)            ),
                   :(; rtol::T = √eps(T)            ),
                   :(; itmax::Int = 0               ),
                   :(; timemax::Float64 = Inf       ),
                   :(; verbose::Int = 0             ),
                   :(; history::Bool = false        ),
                   :(; callback = workspace -> false),
                   :(; iostream::IO = kstdout       ))

def_kwargs_crls = extract_parameters.(def_kwargs_crls)

args_crls = (:A, :b)
kwargs_crls = (:M, :ldiv, :radius, :λ, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function crls!(workspace :: CrlsWorkspace{T,FC,Sm,Sn}, $(def_args_crls...); $(def_kwargs_crls...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "CRLS: system of %d equations in %d variables\n", m, n)

    # Tests M = Iₙ
    MisI = (M === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == Sm || error("ktypeof(b) must be equal to $Sm")

    # Compute the adjoint of A
    Aᴴ = A'

    # Set up workspace.
    allocate_if(!MisI, workspace, :Ms, Sm, workspace.r)  # The length of Ms is m
    x, p, Ar, q = workspace.x, workspace.p, workspace.Ar, workspace.q
    r, Ap, s, stats = workspace.r, workspace.Ap, workspace.s, workspace.stats
    rNorms, ArNorms = stats.residuals, stats.Aresiduals
    reset!(stats)
    Ms  = MisI ? s  : workspace.Ms
    Mr  = MisI ? r  : workspace.Ms
    MAp = MisI ? Ap : workspace.Ms

    kfill!(x, zero(FC))
    kcopy!(m, r, b)      # r ← b
    bNorm = knorm(m, r)  # norm(b - A * x0) if x0 ≠ 0.
    rNorm = bNorm        # + λ * ‖x0‖ if x0 ≠ 0 and λ > 0.
    history && push!(rNorms, rNorm)
    if bNorm == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      history && push!(ArNorms, zero(T))
      return workspace
    end

    MisI || mulorldiv!(Mr, M, r, ldiv)
    kmul!(Ar, Aᴴ, Mr)  # - λ * x0 if x0 ≠ 0.
    kmul!(s, A, Ar)
    MisI || mulorldiv!(Ms, M, s, ldiv)

    kcopy!(n, p, Ar)  # p ← Ar
    kcopy!(m, Ap, s)  # Ap ← s
    kmul!(q, Aᴴ, Ms)  # Ap
    λ > 0 && kaxpy!(n, λ, p, q)  # q = q + λ * p
    γ  = kdotr(m, s, Ms)  # Faster than γ = dot(s, Ms)
    iter = 0
    itmax == 0 && (itmax = m + n)

    ArNorm = knorm(n, Ar)  # Marginally faster than norm(Ar)
    λ > 0 && (γ += λ * ArNorm * ArNorm)
    history && push!(ArNorms, ArNorm)
    ε = atol + rtol * ArNorm
    (verbose > 0) && @printf(iostream, "%5s  %8s  %8s  %5s\n", "k", "‖Aᴴr‖", "‖r‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %8.2e  %8.2e  %.2fs\n", iter, ArNorm, rNorm, start_time |> ktimer)

    status = "unknown"
    on_boundary = false
    solved = ArNorm ≤ ε
    tired = iter ≥ itmax
    psd = false
    user_requested_exit = false
    overtimed = false

    while ! (solved || tired || user_requested_exit || overtimed)
      qNorm² = kdotr(n, q, q) # dot(q, q)
      α = γ / qNorm²

      # if a trust-region constraint is give, compute step to the boundary
      # (note that α > 0 in CRLS)
      if radius > 0
        pNorm = knorm(n, p)
        if kdotr(m, Ap, Ap) ≤ ε * sqrt(qNorm²) * pNorm # the quadratic is constant in the direction p
          psd = true # det(AᴴA) = 0
          p = Ar # p = Aᴴr
          pNorm² = ArNorm * ArNorm
          kmul!(q, Aᴴ, s)
          α = min(ArNorm^2 / γ, maximum(to_boundary(n, x, p, Ms, radius, flip = false, dNorm2 = pNorm²))) # the quadratic is minimal in the direction Aᴴr for α = ‖Ar‖²/γ
        else
          pNorm² = pNorm * pNorm
          σ = maximum(to_boundary(n, x, p, Ms, radius, flip = false, dNorm2 = pNorm²))
          if α ≥ σ
            α = σ
            on_boundary = true
          end
        end
      end

      kaxpy!(n,  α, p,   x)  # Faster than  x =  x + α *  p
      kaxpy!(n, -α, q,  Ar)  # Faster than Ar = Ar - α *  q
      ArNorm = knorm(n, Ar)
      solved = psd || on_boundary
      solved && continue
      kaxpy!(m, -α, Ap,  r)  # Faster than  r =  r - α * Ap
      kmul!(s, A, Ar)
      MisI || mulorldiv!(Ms, M, s, ldiv)
      γ_next = kdotr(m, s, Ms)  # Faster than γ_next = dot(s, s)
      λ > 0 && (γ_next += λ * ArNorm * ArNorm)
      β = γ_next / γ

      kaxpby!(n, one(FC), Ar, β, p)  # Faster than  p = Ar + β *  p
      kaxpby!(m, one(FC), s, β, Ap)  # Faster than Ap =  s + β * Ap
      MisI || mulorldiv!(MAp, M, Ap, ldiv)
      kmul!(q, Aᴴ, MAp)
      λ > 0 && kaxpy!(n, λ, p, q)  # q = q + λ * p

      γ = γ_next
      if λ > 0
        rNorm = sqrt(kdotr(m, r, r) + λ * kdotr(n, x, x))
      else
        rNorm = knorm(m, r)
      end
      history && push!(rNorms, rNorm)
      history && push!(ArNorms, ArNorm)
      iter = iter + 1
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %8.2e  %8.2e  %.2fs\n", iter, ArNorm, rNorm, start_time |> ktimer)
      user_requested_exit = callback(workspace) :: Bool
      solved = (ArNorm ≤ ε) || on_boundary
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    solved              && (status = "solution good enough given atol and rtol")
    psd                 && (status = "zero-curvature encountered")
    on_boundary         && (status = "on trust-region boundary")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = false
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

# solver_table.jl — single source of truth for the LibKrylov solver list.
# Included by both generate_stores.jl and generate_header.jl.
#
# Each entry: (c_name, workspace_type_name, enum_constant)
# The enum value equals the 0-based index in this list (must stay stable).

const SOLVERS = [
  ("cg",         "CgWorkspace",       "KRYLOV_CG"),
  ("cr",         "CrWorkspace",       "KRYLOV_CR"),
  ("symmlq",     "SymmlqWorkspace",   "KRYLOV_SYMMLQ"),
  ("minres",     "MinresWorkspace",   "KRYLOV_MINRES"),
  ("minres_qlp", "MinresQlpWorkspace","KRYLOV_MINRES_QLP"),
  ("diom",       "DiomWorkspace",     "KRYLOV_DIOM"),
  ("dqgmres",    "DqgmresWorkspace",  "KRYLOV_DQGMRES"),
  ("fom",        "FomWorkspace",      "KRYLOV_FOM"),
  ("gmres",      "GmresWorkspace",    "KRYLOV_GMRES"),
  ("fgmres",     "FgmresWorkspace",   "KRYLOV_FGMRES"),
  ("bicgstab",   "BicgstabWorkspace", "KRYLOV_BICGSTAB"),
  ("cgs",        "CgsWorkspace",      "KRYLOV_CGS"),
  ("bilq",       "BilqWorkspace",     "KRYLOV_BILQ"),
  ("qmr",        "QmrWorkspace",      "KRYLOV_QMR"),
  ("usymlq",     "UsymlqWorkspace",   "KRYLOV_USYMLQ"),
  ("usymqr",     "UsymqrWorkspace",   "KRYLOV_USYMQR"),
  ("tricg",      "TricgWorkspace",    "KRYLOV_TRICG"),
  ("trimr",      "TrimrWorkspace",    "KRYLOV_TRIMR"),
  ("trilqr",     "TrilqrWorkspace",   "KRYLOV_TRILQR"),
  ("bilqr",      "BilqrWorkspace",    "KRYLOV_BILQR"),
  ("lslq",       "LslqWorkspace",     "KRYLOV_LSLQ"),
  ("lsqr",       "LsqrWorkspace",     "KRYLOV_LSQR"),
  ("lsmr",       "LsmrWorkspace",     "KRYLOV_LSMR"),
  ("usymlqr",    "UsymlqrWorkspace",  "KRYLOV_USYMLQR"),
  ("cgls",       "CglsWorkspace",     "KRYLOV_CGLS"),
  ("crls",       "CrlsWorkspace",     "KRYLOV_CRLS"),
  ("cgne",       "CgneWorkspace",     "KRYLOV_CGNE"),
  ("crmr",       "CrmrWorkspace",     "KRYLOV_CRMR"),
  ("craig",      "CraigWorkspace",    "KRYLOV_CRAIG"),
  ("craigmr",    "CraigmrWorkspace",  "KRYLOV_CRAIGMR"),
  ("lnlq",       "LnlqWorkspace",     "KRYLOV_LNLQ"),
  ("gpmr",       "GpmrWorkspace",     "KRYLOV_GPMR"),
  ("car",        "CarWorkspace",      "KRYLOV_CAR"),
  ("minares",    "MinaresWorkspace",  "KRYLOV_MINARES"),
]

# Block Krylov solvers — a separate, matrix-based API (m×p block right-hand side).
# Each entry: (c_name, workspace_type_name, enum_constant).
# The enum value equals the 0-based index in this list.
const BLOCK_SOLVERS = [
  ("block_gmres",  "BlockGmresWorkspace",  "KRYLOV_BLOCK_GMRES"),
  ("block_minres", "BlockMinresWorkspace", "KRYLOV_BLOCK_MINRES"),
]

export BlockKrylovWorkspace, BlockMinresWorkspace, BlockGmresWorkspace

"Abstract type for using block Krylov solvers in-place."
abstract type BlockKrylovWorkspace{T,FC,SV,SM} end

"""
Workspace for the in-place methods [`block_minres!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = BlockMinresWorkspace(m, n, p, SV, SM)
    workspace = BlockMinresWorkspace(A, B)

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
`p` denotes the number of columns of the right-hand side `B` passed to the in-place methods.
`SV` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.
`SM` is the storage type of the matrices in the workspace, such as `Matrix{Float64}`.
"""
mutable struct BlockMinresWorkspace{T,FC,SV,SM} <: BlockKrylovWorkspace{T,FC,SV,SM}
  m          :: Int
  n          :: Int
  p          :: Int
  ΔX         :: SM
  X          :: SM
  P          :: SM
  Q          :: SM
  C          :: SM
  D          :: SM
  Φ          :: SM
  Ψₖ         :: SM
  Ωₖ         :: SM
  Ψₖ₊₁       :: SM
  Πₖ₋₂       :: SM
  Γbarₖ₋₁    :: SM
  Γₖ₋₁       :: SM
  Λbarₖ      :: SM
  Λₖ         :: SM
  Vₖ₋₁       :: SM
  Vₖ         :: SM
  wₖ₋₂       :: SM
  wₖ₋₁       :: SM
  wₖ         :: SM
  Hₖ₋₂       :: SM
  Hₖ₋₁       :: SM
  τₖ₋₂       :: SV
  τₖ₋₁       :: SV
  buffer     :: Vector{FC}
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function BlockMinresWorkspace(m::Integer, n::Integer, p::Integer, SV::Type, SM::Type)
  start_allocation_time = time_ns()
  FC   = eltype(SV)
  T    = real(FC)
  ΔX   = SM(undef, 0, 0)
  X    = SM(undef, n, p)
  P    = SM(undef, 0, 0)
  Q    = SM(undef, n, p)
  C    = SM(undef, p, p)
  D    = SM(undef, 2p, p)
  Φ    = SM(undef, p, p)
  Ψₖ   = SM(undef, p, p)
  Ωₖ   = SM(undef, p, p)
  Ψₖ₊₁ = SM(undef, p, p)
  Πₖ₋₂ = SM(undef, p, p)
  Γbarₖ₋₁ = SM(undef, p, p)
  Γₖ₋₁ = SM(undef, p, p)
  Λbarₖ = SM(undef, p, p)
  Λₖ   = SM(undef, p, p)
  Vₖ₋₁ = SM(undef, n, p)
  Vₖ   = SM(undef, n, p)
  wₖ₋₂ = SM(undef, n, p)
  wₖ₋₁ = SM(undef, n, p)
  wₖ   = SM(undef, n, p)
  Hₖ₋₂ = SM(undef, 2p, p)
  Hₖ₋₁ = SM(undef, 2p, p)
  τₖ₋₂ = SV(undef, p)
  τₖ₋₁ = SV(undef, p)
  SV = isconcretetype(SV) ? SV : typeof(τₖ₋₁)
  SM = isconcretetype(SM) ? SM : typeof(X)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  size_buffer = C isa Matrix ? max(kgeqrf_buffer!(Vₖ, τₖ₋₁), kgeqrf_buffer!(Hₖ₋₁, τₖ₋₁),
                                   korgqr_buffer!(Vₖ, τₖ₋₁), korgqr_buffer!(Hₖ₋₁, τₖ₋₁),
                                   kormqr_buffer!('L', FC <: AbstractFloat ? 'T' : 'C', Hₖ₋₁, τₖ₋₁, D)) : 0
  buffer = SV(undef, size_buffer)
  workspace = BlockMinresWorkspace{T,FC,SV,SM}(m, n, p, ΔX, X, P, Q, C, D, Φ, Ψₖ, Ωₖ, Ψₖ₊₁, Πₖ₋₂, Γbarₖ₋₁, Γₖ₋₁, Λbarₖ, Λₖ,
                                               Vₖ₋₁, Vₖ, wₖ₋₂, wₖ₋₁, wₖ, Hₖ₋₂, Hₖ₋₁, τₖ₋₂, τₖ₋₁, buffer, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function BlockMinresWorkspace(A, B)
  m, n = size(A)
  s, p = size(B)
  SM = typeof(B)
  SV = matrix_to_vector(SM)
  BlockMinresWorkspace(m, n, p, SV, SM)
end

"""
Workspace for the in-place methods [`block_gmres!`](@ref) and [`krylov_solve!`](@ref).

The following outer constructors can be used to initialize this workspace:

    workspace = BlockGmresWorkspace(m, n, p, SV, SM; memory = 5)
    workspace = BlockGmresWorkspace(A, B; memory = 5)

`m` and `n` denote the dimensions of the linear operator `A` passed to the in-place methods.
`p` denotes the number of columns of the right-hand side `B` passed to the in-place methods.
`SV` is the storage type of the vectors in the workspace, such as `Vector{Float64}`.
`SM` is the storage type of the matrices in the workspace, such as `Matrix{Float64}`.
`memory` is set to `div(n,p)` if the value given is larger than `div(n,p)`.
"""
mutable struct BlockGmresWorkspace{T,FC,SV,SM} <: BlockKrylovWorkspace{T,FC,SV,SM}
  m          :: Int
  n          :: Int
  p          :: Int
  ΔX         :: SM
  X          :: SM
  W          :: SM
  P          :: SM
  Q          :: SM
  C          :: SM
  D          :: SM
  V          :: Vector{SM}
  Z          :: Vector{SM}
  R          :: Vector{SM}
  H          :: Vector{SM}
  τ          :: Vector{SV}
  buffer     :: Vector{FC}
  warm_start :: Bool
  stats      :: SimpleStats{T}
end

function BlockGmresWorkspace(m::Integer, n::Integer, p::Integer, SV::Type, SM::Type; memory::Int = 5)
  start_allocation_time = time_ns()
  memory = min(div(n,p), memory)
  FC = eltype(SV)
  T  = real(FC)
  ΔX = SM(undef, 0, 0)
  X  = SM(undef, n, p)
  W  = SM(undef, n, p)
  P  = SM(undef, 0, 0)
  Q  = SM(undef, 0, 0)
  C  = SM(undef, p, p)
  D  = SM(undef, 2p, p)
  V  = SM[SM(undef, n, p) for i = 1 : memory]
  Z  = SM[SM(undef, p, p) for i = 1 : memory]
  R  = SM[SM(undef, p, p) for i = 1 : div(memory * (memory+1), 2)]
  H  = SM[SM(undef, 2p, p) for i = 1 : memory]
  τ  = SV[SV(undef, p) for i = 1 : memory]
  SV = isconcretetype(SV) ? SV : typeof(τ)
  SM = isconcretetype(SM) ? SM : typeof(X)
  size_buffer = C isa Matrix ? max(kgeqrf_buffer!(V[1], τ[1]), kgeqrf_buffer!(H[1], τ[1]),
                                   korgqr_buffer!(V[1], τ[1]), korgqr_buffer!(H[1], τ[1]),
                                   kormqr_buffer!('L', FC <: AbstractFloat ? 'T' : 'C', H[1], τ[1], D)) : 0
  buffer = SV(undef, size_buffer)
  stats = SimpleStats(0, false, false, false, 0, T[], T[], T[], 0.0, 0.0, "unknown")
  workspace = BlockGmresWorkspace{T,FC,SV,SM}(m, n, p, ΔX, X, W, P, Q, C, D, V, Z, R, H, τ, buffer, false, stats)
  workspace.stats.allocation_timer = start_allocation_time |> ktimer
  return workspace
end

function BlockGmresWorkspace(A, B; memory::Int = 5)
  m, n = size(A)
  s, p = size(B)
  SM = typeof(B)
  SV = matrix_to_vector(SM)
  BlockGmresWorkspace(m, n, p, SV, SM; memory)
end

@testset "cgs" begin
  cgs_tol = 1.0e-6

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      # Symmetric and positive definite system.
      A, b = symmetric_definite(FC=FC)
      (x, stats) = cgs(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ cgs_tol)
      @test(stats.solved)

      # Symmetric indefinite variant.
      A, b = symmetric_indefinite(FC=FC)
      (x, stats) = cgs(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ cgs_tol)
      @test(stats.solved)

      # Nonsymmetric and positive definite systems.
      A, b = nonsymmetric_definite(FC=FC)
      (x, stats) = cgs(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ cgs_tol)
      @test(stats.solved)

      # Nonsymmetric indefinite variant.
      A, b = nonsymmetric_indefinite(FC=FC)
      (x, stats) = cgs(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ cgs_tol)
      @test(stats.solved)

      # Sparse Laplacian.
      A, b = sparse_laplacian(FC=FC)
      (x, stats) = cgs(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ cgs_tol)
      @test(stats.solved)

      # Test b == 0
      A, b = zero_rhs(FC=FC)
      (x, stats) = cgs(A, b)
      @test norm(x) == 0
      @test stats.status == "x is a zero-residual solution"

      # Left preconditioning
      A, b, M = square_preconditioned(FC=FC)
      (x, stats) = cgs(A, b, M=M)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ cgs_tol)
      @test(stats.solved)

      # Right preconditioning
      A, b, N = square_preconditioned(FC=FC)
      (x, stats) = cgs(A, b, N=N)
      r = b - A * x
      resid = norm(M * r) / norm(M * b)
      @test(resid ≤ cgs_tol)
      @test(stats.solved)

      # Split preconditioning
      A, b, M, N = two_preconditioners(FC=FC)
      (x, stats) = cgs(A, b, M=M, N=N)
      r = b - A * x
      resid = norm(M * r) / norm(M * b)
      @test(resid ≤ cgs_tol)
      @test(stats.solved)

      # Test bᴴc == 0
      A, b, c = bc_breakdown(FC=FC)
      (x, stats) = cgs(A, b, c=c)
      @test stats.status == "Breakdown bᴴc = 0"

      # test callback function
      A, b = sparse_laplacian(FC=FC)
      workspace = CgsWorkspace(A, b)
      tol = 1.0e-1
      cb_n2 = TestCallbackN2(A, b, tol = tol)
      cgs!(workspace, A, b, atol = 0.0, rtol = 0.0, callback = cb_n2)
      @test workspace.stats.status == "user-requested exit"
      @test cb_n2(workspace)

      @test_throws TypeError cgs(A, b, callback = workspace -> "string", history = true)
    end
  end
end

using PkgBenchmark
using BenchmarkTools
using MatrixMarket

using LinearAlgebra
using SparseArrays

using CUDA
using CUDA.CUSPARSE

using Krylov
using LinearOperators
using SuiteSparseMatrixCollection

ufl_bicgstab = filter(p -> p.structure == "unsymmetric" && p.type == "real" && (10000 ≤ p.rows ≤ 20000), ssmc)
ufl_cg = filter(p -> p.structure == "symmetric" && p.posDef == "yes" && p.type == "real" && (10000 ≤ p.rows ≤ 20000), ssmc)

# fetch_ssmc(ufl_cg, format="MM")
# fetch_ssmc(ufl_bicgstab, format="MM")

const SUITE = BenchmarkGroup()

SUITE["GPU"] = BenchmarkGroup(["CG", "BICGSTAB"])

SUITE["GPU"]["CG"] = BenchmarkGroup()
for matrix in ufl_cg
  name = matrix.name
  A = MatrixMarket.mmread(joinpath(matrix_path(matrix, format="MM"), "$(name).mtx"))
  A = CuSparseMatrixCSC{Float64}(A)
  n = size(A, 1)
  b = ones(n)
  b = CuVector(b)
  rtol = 1.0e-8
  SUITE["GPU"]["CG"][name] = @benchmarkable CUDA.@sync cg($A, $b, atol=0.0, rtol=$rtol, itmax=$n)
end

SUITE["GPU"]["BICGSTAB"] = BenchmarkGroup()
for matrix in ufl_bicgstab
  name = matrix.name
  A = MatrixMarket.mmread(joinpath(matrix_path(matrix, format="MM"), "$(name).mtx"))
  A = CuSparseMatrixCSC{Float64}(A)
  n = size(A, 1)
  b = ones(n)
  b = CuVector(b)
  rtol = 1.0e-8
  SUITE["GPU"]["BICGSTAB"][name] = @benchmarkable CUDA.@sync bicgstab($A, $b, atol=0.0, rtol=$rtol, itmax=$n)
end

# An implementation of TriCG for the solution of symmetric and quasi-definite systems.
#
# This method is described in
#
# A. Montoison and D. Orban
# TriCG and TriMR: Two Iterative Methods for Symmetric Quasi-Definite Systems.
# SIAM Journal on Scientific Computing, 43(4), pp. 2502--2525, 2021.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Montréal, April 2020.

export tricg, tricg!

"""
    (x, y, stats) = tricg(A, b::AbstractVector{FC}, c::AbstractVector{FC};
                          M=I, N=I, ldiv::Bool=false,
                          spd::Bool=false, snd::Bool=false,
                          flip::Bool=false, τ::T=one(T),
                          ν::T=-one(T), atol::T=√eps(T),
                          rtol::T=√eps(T), itmax::Int=0,
                          timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                          callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, y, stats) = tricg(A, b, c, x0::AbstractVector, y0::AbstractVector; kwargs...)

TriCG can be warm-started from initial guesses `x0` and `y0` where `kwargs` are the same keyword arguments as above.

Given a matrix `A` of dimension m × n, TriCG solves the Hermitian linear system

    [ τE    A ] [ x ] = [ b ]
    [  Aᴴ  νF ] [ y ]   [ c ],

of size (n+m) × (n+m) where `τ` and `ν` are real numbers, `E` = `M⁻¹` ≻ 0 and `F` = `N⁻¹` ≻ 0.
TriCG could breakdown if `τ = 0` or `ν = 0`.
It's recommended to use TriMR in these cases.

By default, TriCG solves Hermitian and quasi-definite linear systems with `τ = 1` and `ν = -1`.

TriCG is based on the preconditioned orthogonal tridiagonalization process
and its relation with the preconditioned block-Lanczos process.

The matrix

    [ M   0 ]
    [ 0   N ]

indicates the weighted norm in which residuals are measured, here denoted `‖·‖`.
It's the Euclidean norm when `M` and `N` are identity operators.

TriCG stops when `itmax` iterations are reached or when `‖rₖ‖ ≤ atol + ‖r₀‖ * rtol`.
`atol` is an absolute tolerance and `rtol` is a relative tolerance.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :tricg`.

For an in-place variant that reuses memory across solves, see [`tricg!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`;
* `c`: a vector of length `n`.

#### Optional arguments

* `x0`: a vector of length `m` that represents an initial guess of the solution `x`;
* `y0`: a vector of length `n` that represents an initial guess of the solution `y`.

Warm-starting is supported only when `M` and `N` are either `I` or the corresponding coefficient (`τ` or `ν`) is zero.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `m` used for centered preconditioning of the partitioned system;
* `N`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning of the partitioned system;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `spd`: if `true`, set `τ = 1` and `ν = 1` for Hermitian and positive-definite linear system;
* `snd`: if `true`, set `τ = -1` and `ν = -1` for Hermitian and negative-definite linear systems;
* `flip`: if `true`, set `τ = -1` and `ν = 1` for another known variant of Hermitian quasi-definite systems;
* `τ` and `ν`: diagonal scaling factors of the partitioned Hermitian linear system;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `m+n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `m`;
* `y`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### Reference

* A. Montoison and D. Orban, [*TriCG and TriMR: Two Iterative Methods for Symmetric Quasi-Definite Systems*](https://doi.org/10.1137/20M1363030), SIAM Journal on Scientific Computing, 43(4), pp. 2502--2525, 2021.
"""
function tricg end

"""
    workspace = tricg!(workspace::TricgWorkspace, A, b, c; kwargs...)
    workspace = tricg!(workspace::TricgWorkspace, A, b, c, x0, y0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`tricg`](@ref).

See [`TricgWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :tricg` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function tricg! end

def_args_tricg = (:(A                    ),
                  :(b::AbstractVector{FC}),
                  :(c::AbstractVector{FC}))

def_optargs_tricg = (:(x0::AbstractVector),
                     :(y0::AbstractVector))

def_kwargs_tricg = (:(; M = I                        ),
                    :(; N = I                        ),
                    :(; ldiv::Bool = false           ),
                    :(; spd::Bool = false            ),
                    :(; snd::Bool = false            ),
                    :(; flip::Bool = false           ),
                    :(; τ::T = one(T)                ),
                    :(; ν::T = -one(T)               ),
                    :(; atol::T = √eps(T)            ),
                    :(; rtol::T = √eps(T)            ),
                    :(; itmax::Int = 0               ),
                    :(; timemax::Float64 = Inf       ),
                    :(; verbose::Int = 0             ),
                    :(; history::Bool = false        ),
                    :(; callback = workspace -> false),
                    :(; iostream::IO = kstdout       ))

def_kwargs_tricg = extract_parameters.(def_kwargs_tricg)

args_tricg = (:A, :b, :c)
optargs_tricg = (:x0, :y0)
kwargs_tricg = (:M, :N, :ldiv, :spd, :snd, :flip, :τ, :ν, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function tricg!(workspace :: TricgWorkspace{T,FC,Sm,Sn}, $(def_args_tricg...); $(def_kwargs_tricg...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    length(b) == m || error("Inconsistent problem size")
    length(c) == n || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "TriCG: system of %d equations in %d variables\n", m+n, m+n)

    # Check flip, spd and snd parameters
    spd && flip && error("The matrix cannot be SPD and SQD")
    snd && flip && error("The matrix cannot be SND and SQD")
    spd && snd  && error("The matrix cannot be SPD and SND")

    # Check M = Iₘ and N = Iₙ
    MisI = (M === I)
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == Sm || error("ktypeof(b) must be equal to $Sm")
    ktypeof(c) == Sn || error("ktypeof(c) must be equal to $Sn")

    # Determine τ and ν associated to SQD, SPD or SND systems.
    flip && (τ = -one(T) ; ν =  one(T))
    spd  && (τ =  one(T) ; ν =  one(T))
    snd  && (τ = -one(T) ; ν = -one(T))

    warm_start = workspace.warm_start
    warm_start && (τ ≠ 0) && !MisI && error("Warm-start with preconditioners is not supported.")
    warm_start && (ν ≠ 0) && !NisI && error("Warm-start with preconditioners is not supported.")

    # Compute the adjoint of A
    Aᴴ = A'

    # Set up workspace.
    allocate_if(!MisI, workspace, :vₖ, Sm, workspace.x)  # The length of vₖ is m
    allocate_if(!NisI, workspace, :uₖ, Sn, workspace.y)  # The length of uₖ is n
    Δy, yₖ, N⁻¹uₖ₋₁, N⁻¹uₖ, p = workspace.Δy, workspace.y, workspace.N⁻¹uₖ₋₁, workspace.N⁻¹uₖ, workspace.p
    Δx, xₖ, M⁻¹vₖ₋₁, M⁻¹vₖ, q = workspace.Δx, workspace.x, workspace.M⁻¹vₖ₋₁, workspace.M⁻¹vₖ, workspace.q
    gy₂ₖ₋₁, gy₂ₖ, gx₂ₖ₋₁, gx₂ₖ = workspace.gy₂ₖ₋₁, workspace.gy₂ₖ, workspace.gx₂ₖ₋₁, workspace.gx₂ₖ
    vₖ = MisI ? M⁻¹vₖ : workspace.vₖ
    uₖ = NisI ? N⁻¹uₖ : workspace.uₖ
    vₖ₊₁ = MisI ? q : vₖ
    uₖ₊₁ = NisI ? p : uₖ
    b₀ = warm_start ? q : b
    c₀ = warm_start ? p : c

    stats = workspace.stats
    rNorms = stats.residuals
    reset!(stats)

    # Initial solutions x₀ and y₀.
    kfill!(xₖ, zero(FC))
    kfill!(yₖ, zero(FC))

    iter = 0
    itmax == 0 && (itmax = m+n)

    # Initialize preconditioned orthogonal tridiagonalization process.
    kfill!(M⁻¹vₖ₋₁, zero(FC))  # v₀ = 0
    kfill!(N⁻¹uₖ₋₁, zero(FC))  # u₀ = 0

    # [ τI    A ] [ xₖ ] = [ b -  τΔx - AΔy ] = [ b₀ ]
    # [  Aᴴ  νI ] [ yₖ ]   [ c - AᴴΔx - νΔy ]   [ c₀ ]
    if warm_start
      kmul!(b₀, A, Δy)
      (τ ≠ 0) && kaxpy!(m, τ, Δx, b₀)
      kaxpby!(m, one(FC), b, -one(FC), b₀)
      kmul!(c₀, Aᴴ, Δx)
      (ν ≠ 0) && kaxpy!(n, ν, Δy, c₀)
      kaxpby!(n, one(FC), c, -one(FC), c₀)
    end

    # β₁Ev₁ = b ↔ β₁v₁ = Mb
    kcopy!(m, M⁻¹vₖ, b₀)  # M⁻¹vₖ ← b₀
    MisI || mulorldiv!(vₖ, M, M⁻¹vₖ, ldiv)
    βₖ = knorm_elliptic(m, vₖ, M⁻¹vₖ)  # β₁ = ‖v₁‖_E
    if βₖ ≠ 0
      kdiv!(m, M⁻¹vₖ, βₖ)
      MisI || kdiv!(m, vₖ, βₖ)
    else
      # v₁ = 0 such that v₁ ⊥ Span{v₁, ..., vₖ}
      kfill!(M⁻¹vₖ, zero(FC))
      MisI || kfill!(vₖ, zero(FC))
    end

    # γ₁Fu₁ = c ↔ γ₁u₁ = Nc
    kcopy!(n, N⁻¹uₖ, c₀)  # M⁻¹uₖ ← c₀
    NisI || mulorldiv!(uₖ, N, N⁻¹uₖ, ldiv)
    γₖ = knorm_elliptic(n, uₖ, N⁻¹uₖ)  # γ₁ = ‖u₁‖_F
    if γₖ ≠ 0
      kdiv!(n, N⁻¹uₖ, γₖ)
      NisI || kdiv!(n, uₖ, γₖ)
    else
      # u₁ = 0 such that u₁ ⊥ Span{u₁, ..., uₖ}
      kfill!(N⁻¹uₖ, zero(FC))
      NisI || kfill!(uₖ, zero(FC))
    end

    # Initialize directions Gₖ such that L̄ₖ(Gₖ)ᵀ = (Wₖ)ᵀ
    kfill!(gx₂ₖ₋₁, zero(FC))
    kfill!(gy₂ₖ₋₁, zero(FC))
    kfill!(gx₂ₖ  , zero(FC))
    kfill!(gy₂ₖ  , zero(FC))

    # Compute ‖r₀‖² = (γ₁)² + (β₁)²
    rNorm = sqrt(γₖ^2 + βₖ^2)
    history && push!(rNorms, rNorm)
    ε = atol + rtol * rNorm

    (verbose > 0) && @printf(iostream, "%5s  %7s  %7s  %7s  %5s\n", "k", "‖rₖ‖", "βₖ₊₁", "γₖ₊₁", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %.2fs\n", iter, rNorm, βₖ, γₖ, start_time |> ktimer)

    # Set up workspace.
    d₂ₖ₋₃ = d₂ₖ₋₂ = zero(T)
    π₂ₖ₋₃ = π₂ₖ₋₂ = zero(FC)
    δₖ₋₁ = zero(FC)

    # Tolerance for breakdown detection.
    btol = eps(T)^(3/4)

    # Stopping criterion.
    breakdown = false
    solved = rNorm ≤ ε
    tired = iter ≥ itmax
    status = "unknown"
    user_requested_exit = false
    overtimed = false

    while !(solved || tired || breakdown || user_requested_exit || overtimed)
      # Update iteration index.
      iter = iter + 1

      # Continue the orthogonal tridiagonalization process.
      # AUₖ  = EVₖTₖ    + βₖ₊₁Evₖ₊₁(eₖ)ᵀ = EVₖ₊₁Tₖ₊₁.ₖ
      # AᴴVₖ = FUₖ(Tₖ)ᴴ + γₖ₊₁Fuₖ₊₁(eₖ)ᵀ = FUₖ₊₁(Tₖ.ₖ₊₁)ᴴ

      kmul!(q, A , uₖ)  # Forms Evₖ₊₁ : q ← Auₖ
      kmul!(p, Aᴴ, vₖ)  # Forms Fuₖ₊₁ : p ← Aᴴvₖ

      if iter ≥ 2
        kaxpy!(m, -γₖ, M⁻¹vₖ₋₁, q)  # q ← q - γₖ * M⁻¹vₖ₋₁
        kaxpy!(n, -βₖ, N⁻¹uₖ₋₁, p)  # p ← p - βₖ * N⁻¹uₖ₋₁
      end

      αₖ = kdot(m, vₖ, q)  # αₖ = ⟨vₖ,q⟩

      kaxpy!(m, -     αₖ , M⁻¹vₖ, q)  # q ← q - αₖ * M⁻¹vₖ
      kaxpy!(n, -conj(αₖ), N⁻¹uₖ, p)  # p ← p - ᾱₖ * N⁻¹uₖ

      # Update M⁻¹vₖ₋₁ and N⁻¹uₖ₋₁
      kcopy!(m, M⁻¹vₖ₋₁, M⁻¹vₖ)  # M⁻¹vₖ₋₁ ← M⁻¹vₖ
      kcopy!(n, N⁻¹uₖ₋₁, N⁻¹uₖ)  # N⁻¹uₖ₋₁ ← N⁻¹uₖ

      # Notations : Wₖ = [w₁ ••• wₖ] = [v₁ 0  ••• vₖ 0 ]
      #                                [0  u₁ ••• 0  uₖ]
      #
      # rₖ = [ b ] - [ τE    A ] [ xₖ ] = [ b ] - [ τE    A ] Wₖzₖ
      #      [ c ]   [  Aᴴ  νF ] [ yₖ ]   [ c ]   [  Aᴴ  νF ]
      #
      # block-Lanczos formulation : [ τE    A ] Wₖ = [ E   0 ] Wₖ₊₁Sₖ₊₁.ₖ
      #                             [  Aᴴ  νF ]      [ 0   F ]
      #
      # TriCG subproblem : (Wₖ)ᴴ * rₖ = 0 ↔ Sₖ.ₖzₖ = β₁e₁ + γ₁e₂
      #
      # Update the LDLᴴ factorization of Sₖ.ₖ.
      #
      # [ τ  α₁    γ₂ 0  •  •  •  •  0  ]
      # [ ᾱ₁ ν  β₂       •           •  ]
      # [    β₂ τ  α₂    γ₃ •        •  ]
      # [ γ₂    ᾱ₂ ν  β₃       •     •  ]
      # [ 0        β₃ •  •     •  •  •  ]
      # [ •  •  γ₃    •  •  •        0  ]
      # [ •     •        •  •  •     γₖ ]
      # [ •        •  •     •  •  βₖ    ]
      # [ •           •        βₖ τ  αₖ ]
      # [ 0  •  •  •  •  0  γₖ    ᾱₖ ν  ]
      if iter == 1
        d₂ₖ₋₁ = τ
        δₖ    = conj(αₖ) / d₂ₖ₋₁
        d₂ₖ   = ν - abs2(δₖ) * d₂ₖ₋₁
      else
        σₖ    = βₖ / d₂ₖ₋₂
        ηₖ    = γₖ / d₂ₖ₋₃
        λₖ    = -(ηₖ * conj(δₖ₋₁) * d₂ₖ₋₃) / d₂ₖ₋₂
        d₂ₖ₋₁ = τ - abs2(σₖ) * d₂ₖ₋₂
        δₖ    = (conj(αₖ) - λₖ * conj(σₖ) * d₂ₖ₋₂) / d₂ₖ₋₁
        d₂ₖ   = ν - abs2(ηₖ) * d₂ₖ₋₃ - abs2(λₖ) * d₂ₖ₋₂ - abs2(δₖ) * d₂ₖ₋₁
      end

      # Solve LₖDₖpₖ = (β₁e₁ + γ₁e₂)
      #
      # [ 1  0  •  •  •  •  •  •  •  0 ] [ d₁                        ]      [ β₁ ]
      # [ δ₁ 1  •                    • ] [    d₂                     ]      [ γ₁ ]
      # [    σ₂ 1  •                 • ] [       •                   ]      [ 0  ]
      # [ η₂ λ₂ δ₂ 1  •              • ] [         •                 ]      [ •  ]
      # [ 0        σ₃ 1  •           • ] [           •               ] zₖ = [ •  ]
      # [ •  •  η₃ λ₃ δ₃ 1  •        • ] [             •             ]      [ •  ]
      # [ •     •        •  •  •     • ] [               •           ]      [ •  ]
      # [ •        •  •  •  •  •  •  • ] [                 •         ]      [ •  ]
      # [ •           •        σₖ 1  0 ] [                   d₂ₖ₋₁   ]      [ •  ]
      # [ 0  •  •  •  •  0  ηₖ λₖ δₖ 1 ] [                        d₂ₖ]      [ 0  ]
      if iter == 1
        π₂ₖ₋₁ = βₖ / d₂ₖ₋₁
        π₂ₖ   = (γₖ - δₖ * βₖ) / d₂ₖ
      else
        π₂ₖ₋₁ = -(σₖ * d₂ₖ₋₂ * π₂ₖ₋₂) / d₂ₖ₋₁
        π₂ₖ   = -(δₖ * d₂ₖ₋₁ * π₂ₖ₋₁ + λₖ * d₂ₖ₋₂ * π₂ₖ₋₂ + ηₖ * d₂ₖ₋₃ * π₂ₖ₋₃) / d₂ₖ
      end

      # Solve Gₖ = Wₖ(Lₖ)⁻ᴴ ⟷ L̄ₖ(Gₖ)ᵀ = (Wₖ)ᵀ.
      if iter == 1
        # [ 1  0 ] [ gx₁ gy₁ ] = [ v₁ 0  ]
        # [ δ̄₁ 1 ] [ gx₂ gy₂ ]   [ 0  u₁ ]
        kcopy!(m, gx₂ₖ₋₁, vₖ)                   # gx₂ₖ₋₁ = vₖ
        kscalcopy!(m, gx₂ₖ, -conj(δₖ), gx₂ₖ₋₁)  # gx₂ₖ = -conj(δₖ) * gx₂ₖ₋₁
        kcopy!(n, gy₂ₖ, uₖ)                     # gy₂ₖ = uₖ
      else
        # [ 0  σ̄ₖ 1  0 ] [ gx₂ₖ₋₃ gy₂ₖ₋₃ ] = [ vₖ 0  ]
        # [ η̄ₖ λ̄ₖ δ̄ₖ 1 ] [ gx₂ₖ₋₂ gy₂ₖ₋₂ ]   [ 0  uₖ ]
        #                [ gx₂ₖ₋₁ gy₂ₖ₋₁ ]
        #                [ gx₂ₖ   gy₂ₖ   ]
        #
        # gx₂ₖ₋₁ = vₖ - σ̄ₖ * gx₂ₖ₋₂
        # gy₂ₖ₋₁ =    - σ̄ₖ * gy₂ₖ₋₂
        # gx₂ₖ   =    - η̄ₖ * gx₂ₖ₋₃ - λ̄ₖ * gx₂ₖ₋₂ - δ̄ₖ * gx₂ₖ₋₁
        # gy₂ₖ   = uₖ - η̄ₖ * gy₂ₖ₋₃ - λ̄ₖ * gy₂ₖ₋₂ - δ̄ₖ * gy₂ₖ₋₁
        #
        # gx₂ₖ and gy₂ₖ will reuse the same storage as gx₂ₖ₋₃ and gy₂ₖ₋₃
        # gx₂ₖ₋₁ and gy₂ₖ₋₁ will reuse the same storage as gx₂ₖ₋₂ and gy₂ₖ₋₂

        kaxpby!(m, conj(λₖ), gx₂ₖ, conj(ηₖ), gx₂ₖ₋₁)  # gx₂ₖ₋₁ = conj(ηₖ) * gx₂ₖ₋₃ + conj(λₖ) * gx₂ₖ₋₂
        kaxpby!(n, conj(λₖ), gy₂ₖ, conj(ηₖ), gy₂ₖ₋₁)  # gy₂ₖ₋₁ = conj(ηₖ) * gy₂ₖ₋₃ + conj(λₖ) * gy₂ₖ₋₂

        kaxpby!(m, one(FC), vₖ, -conj(σₖ), gx₂ₖ)  # gx₂ₖ = vₖ - conj(σₖ) * gx₂ₖ₋₂
        kscal!(n, -conj(σₖ), gy₂ₖ)                # gy₂ₖ =    - conj(σₖ) * gy₂ₖ₋₂

        kaxpby!(m, -conj(δₖ), gx₂ₖ, -one(FC), gx₂ₖ₋₁)  # gx₂ₖ₋₁ = -gx₂ₖ₋₁ - conj(δₖ) * gx₂ₖ
        kaxpby!(n, one(FC), uₖ, -one(FC), gy₂ₖ₋₁)      # gy₂ₖ₋₁ = uₖ - gy₂ₖ₋₁
        kaxpy!(n, -conj(δₖ), gy₂ₖ, gy₂ₖ₋₁)             # gy₂ₖ₋₁ = gy₂ₖ₋₁ - conj(δₖ) * gy₂ₖ

        # gx₂ₖ₋₁ ↔ gx₂ₖ and gy₂ₖ₋₁ ↔ gy₂ₖ
        @kswap!(gx₂ₖ₋₁, gx₂ₖ)
        @kswap!(gy₂ₖ₋₁, gy₂ₖ)
      end

      # Update xₖ = Gxₖ * pₖ
      kaxpy!(m, π₂ₖ₋₁, gx₂ₖ₋₁, xₖ)
      kaxpy!(m, π₂ₖ  , gx₂ₖ  , xₖ)

      # Update yₖ = Gyₖ * pₖ
      kaxpy!(n, π₂ₖ₋₁, gy₂ₖ₋₁, yₖ)
      kaxpy!(n, π₂ₖ  , gy₂ₖ  , yₖ)

      # Compute vₖ₊₁ and uₖ₊₁
      MisI || mulorldiv!(vₖ₊₁, M, q, ldiv)  # βₖ₊₁vₖ₊₁ = MAuₖ  - γₖvₖ₋₁ - αₖvₖ
      NisI || mulorldiv!(uₖ₊₁, N, p, ldiv)  # γₖ₊₁uₖ₊₁ = NAᴴvₖ - βₖuₖ₋₁ - ᾱₖuₖ

      βₖ₊₁ = knorm_elliptic(m, vₖ₊₁, q)  # βₖ₊₁ = ‖vₖ₊₁‖_E
      γₖ₊₁ = knorm_elliptic(n, uₖ₊₁, p)  # γₖ₊₁ = ‖uₖ₊₁‖_F

      # βₖ₊₁ ≠ 0
      if βₖ₊₁ > btol
        kdiv!(m, q, βₖ₊₁)
        MisI || kdiv!(m, vₖ₊₁, βₖ₊₁)
      end
      # Note that if βₖ₊₁ == 0 then vₖ₊₁ = 0 and Auₖ ∈ Span{v₁, ..., vₖ}
      # We can keep vₖ₊₁ = 0 such that vₖ₊₁ ⊥ Span{v₁, ..., vₖ}

      # γₖ₊₁ ≠ 0
      if γₖ₊₁ > btol
        kdiv!(n, p, γₖ₊₁)
        NisI || kdiv!(n, uₖ₊₁, γₖ₊₁)
      end
      # Note that if γₖ₊₁ == 0 then uₖ₊₁ = 0 and Aᴴvₖ ∈ Span{u₁, ..., uₖ}
      # We can keep uₖ₊₁ = 0 such that uₖ₊₁ ⊥ Span{u₁, ..., uₖ}

      # Update M⁻¹vₖ and N⁻¹uₖ
      kcopy!(m, M⁻¹vₖ, q)  # M⁻¹vₖ ← q
      kcopy!(n, N⁻¹uₖ, p)  # N⁻¹uₖ ← p

      # Compute ‖rₖ‖² = |γₖ₊₁ζ₂ₖ₋₁|² + |βₖ₊₁ζ₂ₖ|²
      ζ₂ₖ₋₁ = π₂ₖ₋₁ - conj(δₖ) * π₂ₖ
      ζ₂ₖ   = π₂ₖ
      rNorm = sqrt(abs2(γₖ₊₁ * ζ₂ₖ₋₁) + abs2(βₖ₊₁ * ζ₂ₖ))
      history && push!(rNorms, rNorm)

      # Update βₖ, γₖ, π₂ₖ₋₃, π₂ₖ₋₂, d₂ₖ₋₃, d₂ₖ₋₂, δₖ₋₁, vₖ, uₖ.
      βₖ    = βₖ₊₁
      γₖ    = γₖ₊₁
      π₂ₖ₋₃ = π₂ₖ₋₁
      π₂ₖ₋₂ = π₂ₖ
      d₂ₖ₋₃ = d₂ₖ₋₁
      d₂ₖ₋₂ = d₂ₖ
      δₖ₋₁  = δₖ

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      resid_decrease_mach = (rNorm + one(T) ≤ one(T))

      # Update stopping criterion.
      user_requested_exit = callback(workspace) :: Bool
      resid_decrease_lim = rNorm ≤ ε
      breakdown = βₖ₊₁ ≤ btol && γₖ₊₁ ≤ btol
      solved = resid_decrease_lim || resid_decrease_mach
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %.2fs\n", iter, rNorm, βₖ₊₁, γₖ₊₁, start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    breakdown           && (status = "inconsistent linear system")
    solved              && (status = "solution good enough given atol and rtol")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update x and y
    warm_start && kaxpy!(m, one(FC), Δx, xₖ)
    warm_start && kaxpy!(n, one(FC), Δy, yₖ)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = !solved && breakdown
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

! test_all_solvers.f90 — tests all solvers accessible via the Fortran interface.
!
! Three problem families (Float64 only; the C layer is tested for all precisions
! in test_libkrylov.jl):
!   SPD    : A = tridiag(-1, 2, -1),  b = A * ones,  x_true = ones
!   NONSYM : A = tridiag(-1, n, -1),  b = A * ones,  x_true = ones
!   LS     : A = tridiag(-1, n, -1) rectangular m x n,  b = A * ones
!
! Compile (after building libkrylov):
!   gfortran -O2 -o test_all_solvers interfaces/test/Fortran/test_all_solvers.f90 \
!       interfaces/build/lib/libkrylov.so
!
! Exit code: 0 if all tests pass, 1 otherwise.

program test_all_solvers
  use iso_c_binding
  implicit none
  include '../../include/krylov.f90'

  integer, parameter :: N = 20
  integer, parameter :: M = 30

  ! -------------------------------------------------------------------------
  ! Problem matrices (flat row-major)
  ! -------------------------------------------------------------------------
  real(c_double), target :: spd_A(N*N), spd_At(N*N), spd_b(N), spd_c(N)
  real(c_double), target :: spd_qd_b(N), spd_qd_c(N)   ! quasi-definite RHS for tricg/trimr
  real(c_double), target :: nsym_A(N*N), nsym_At(N*N), nsym_b(N), nsym_c(N)
  real(c_double), target :: gpmr_b(N), gpmr_c(N)       ! gpmr RHS: [I A; B I][x;y]=[b;c]
  real(c_double), target :: ls_A(M*N), ls_At(N*M), ls_b(M)

  integer :: n_pass, n_fail, i

  ! Callback state — set before each test, read by cb_matvec_A / cb_matvec_At
  real(c_double), pointer :: cur_A(:)
  real(c_double), pointer :: cur_At(:)
  integer :: cur_m, cur_n

  ! -------------------------------------------------------------------------
  nullify(cur_A, cur_At)
  cur_m = 0; cur_n = 0

  ! Build matrices and right-hand sides
  ! -------------------------------------------------------------------------
  call make_tridiag(spd_A, N, N, 2.0_c_double, -1.0_c_double)
  call do_transpose(spd_A, spd_At, N, N)
  call matvec(spd_A,  N, N, [(1.0_c_double, i=1,N)], spd_b)
  call matvec(spd_At, N, N, [(1.0_c_double, i=1,N)], spd_c)  ! = spd_b (A symmetric)
  ! Quasi-definite RHS for tricg/trimr: x_true = y_true = ones
  ! System [I  A; A' -I][x; y] = [ones + A*ones; A'*ones - ones]
  spd_qd_b = 1.0_c_double + spd_b   ! ones + A*ones
  spd_qd_c = spd_b - 1.0_c_double   ! A*ones - ones  (A symmetric so A'*ones = A*ones)

  call make_tridiag(nsym_A, N, N, real(N, c_double), -1.0_c_double)
  call do_transpose(nsym_A, nsym_At, N, N)
  call matvec(nsym_A,  N, N, [(1.0_c_double, i=1,N)], nsym_b)
  call matvec(nsym_At, N, N, [(1.0_c_double, i=1,N)], nsym_c)  ! c = A^T * ones
  ! GPMR RHS: [I A; B I][x;y]=[b;c] with B=A^T, x_true=y_true=ones
  ! b = ones + A*ones,  c = A^T*ones + ones
  gpmr_b = 1.0_c_double + nsym_b
  gpmr_c = nsym_c + 1.0_c_double

  call make_tridiag_rect(ls_A, M, N, real(N, c_double), -1.0_c_double)
  call do_transpose(ls_A, ls_At, M, N)
  call matvec(ls_A, M, N, [(1.0_c_double, i=1,N)], ls_b)

  ! -------------------------------------------------------------------------
  ! Run tests
  ! -------------------------------------------------------------------------
  n_pass = 0
  n_fail = 0

  ! --- symmetric / Hermitian ---
  !                                                  need_At  has_y  y_size  need_c  c_vec
  call run(KRYLOV_CG,         "cg        ", .false., .false., 0, .false., spd_c,  spd_A,  spd_At,  spd_b,  N, N)
  call run(KRYLOV_CR,         "cr        ", .false., .false., 0, .false., spd_c,  spd_A,  spd_At,  spd_b,  N, N)
  call run(KRYLOV_SYMMLQ,     "symmlq    ", .false., .false., 0, .false., spd_c,  spd_A,  spd_At,  spd_b,  N, N)
  call run(KRYLOV_MINRES,     "minres    ", .false., .false., 0, .false., spd_c,  spd_A,  spd_At,  spd_b,  N, N)
  call run(KRYLOV_MINRES_QLP, "minres_qlp", .false., .false., 0, .false., spd_c,  spd_A,  spd_At,  spd_b,  N, N)
  call run(KRYLOV_CAR,        "car       ", .false., .false., 0, .false., spd_c,  spd_A,  spd_At,  spd_b,  N, N)
  call run(KRYLOV_MINARES,    "minares   ", .false., .false., 0, .false., spd_c,  spd_A,  spd_At,  spd_b,  N, N)
  call run(KRYLOV_TRICG,      "tricg     ", .true.,  .true.,  N, .true.,  spd_qd_c, spd_A, spd_At, spd_qd_b, N, N)
  call run(KRYLOV_TRIMR,      "trimr     ", .true.,  .true.,  N, .true.,  spd_qd_c, spd_A, spd_At, spd_qd_b, N, N)
  ! --- non-symmetric square ---
  call run(KRYLOV_BICGSTAB,   "bicgstab  ", .false., .false., 0, .false., nsym_c, nsym_A, nsym_At, nsym_b, N, N)
  call run(KRYLOV_CGS,        "cgs       ", .false., .false., 0, .false., nsym_c, nsym_A, nsym_At, nsym_b, N, N)
  call run(KRYLOV_BILQ,       "bilq      ", .true.,  .false., 0, .false., nsym_c, nsym_A, nsym_At, nsym_b, N, N)
  call run(KRYLOV_QMR,        "qmr       ", .true.,  .false., 0, .false., nsym_c, nsym_A, nsym_At, nsym_b, N, N)
  call run(KRYLOV_DIOM,       "diom      ", .false., .false., 0, .false., nsym_c, nsym_A, nsym_At, nsym_b, N, N)
  call run(KRYLOV_DQGMRES,    "dqgmres   ", .false., .false., 0, .false., nsym_c, nsym_A, nsym_At, nsym_b, N, N)
  call run(KRYLOV_FOM,        "fom       ", .false., .false., 0, .false., nsym_c, nsym_A, nsym_At, nsym_b, N, N)
  call run(KRYLOV_GMRES,      "gmres     ", .false., .false., 0, .false., nsym_c, nsym_A, nsym_At, nsym_b, N, N)
  call run(KRYLOV_FGMRES,     "fgmres    ", .false., .false., 0, .false., nsym_c, nsym_A, nsym_At, nsym_b, N, N)
  call run(KRYLOV_BILQR,      "bilqr     ", .true.,  .true.,  N, .true.,  nsym_c, nsym_A, nsym_At, nsym_b, N, N)
  call run(KRYLOV_TRILQR,     "trilqr    ", .true.,  .true.,  N, .true.,  nsym_c, nsym_A, nsym_At, nsym_b, N, N)
  call run(KRYLOV_USYMLQ,     "usymlq    ", .true.,  .false., 0, .true.,  nsym_c, nsym_A, nsym_At, nsym_b, N, N)
  call run(KRYLOV_USYMQR,     "usymqr    ", .true.,  .false., 0, .true.,  nsym_c, nsym_A, nsym_At, nsym_b, N, N)
  call run(KRYLOV_USYMLQR,    "usymlqr   ", .true.,  .true.,  N, .true.,  nsym_c, nsym_A, nsym_At, nsym_b, N, N)
  ! gpmr: matvec_At slot carries B (n×m)
  call run(KRYLOV_GPMR,       "gpmr      ", .true.,  .true.,  N, .true.,  gpmr_c, nsym_A, nsym_At, gpmr_b, N, N)
  ! --- least-squares / least-norm ---
  call run(KRYLOV_LSLQ,       "lslq      ", .true.,  .false., 0, .false., spd_c,  ls_A,   ls_At,   ls_b,   M, N)
  call run(KRYLOV_LSQR,       "lsqr      ", .true.,  .false., 0, .false., spd_c,  ls_A,   ls_At,   ls_b,   M, N)
  call run(KRYLOV_LSMR,       "lsmr      ", .true.,  .false., 0, .false., spd_c,  ls_A,   ls_At,   ls_b,   M, N)
  call run(KRYLOV_CGLS,       "cgls      ", .true.,  .false., 0, .false., spd_c,  ls_A,   ls_At,   ls_b,   M, N)
  call run(KRYLOV_CRLS,       "crls      ", .true.,  .false., 0, .false., spd_c,  ls_A,   ls_At,   ls_b,   M, N)
  call run(KRYLOV_CGNE,       "cgne      ", .true.,  .false., 0, .false., spd_c,  ls_A,   ls_At,   ls_b,   M, N)
  call run(KRYLOV_CRMR,       "crmr      ", .true.,  .false., 0, .false., spd_c,  ls_A,   ls_At,   ls_b,   M, N)
  call run(KRYLOV_CRAIG,      "craig     ", .true.,  .false., 0, .false., spd_c,  ls_A,   ls_At,   ls_b,   M, N)
  call run(KRYLOV_CRAIGMR,    "craigmr   ", .true.,  .false., 0, .false., spd_c,  ls_A,   ls_At,   ls_b,   M, N)
  call run(KRYLOV_LNLQ,       "lnlq      ", .true.,  .false., 0, .false., spd_c,  ls_A,   ls_At,   ls_b,   M, N)

  write(*,'(/,I0,A,I0,A)') n_pass, "/", n_pass + n_fail, " passed"
  if (n_fail > 0) stop 1

contains

  ! ---------------------------------------------------------------------------
  ! Run one solver test.
  !   solver   : KrylovSolverType constant
  !   name     : label for output
  !   need_At  : pass cb_At (otherwise c_null_funptr)
  !   has_y    : call krylov_get_y and check finiteness
  !   y_size   : size of dual vector y (ignored when has_y=.false.)
  !   need_c   : pass second RHS c (size n), for two-RHS solvers
  !   c_vec    : second RHS array of length n (only used when need_c=.true.)
  !   A_flat   : row-major operator matrix (m × n)
  !   At_flat  : row-major adjoint matrix  (n × m)
  !   b_vec    : right-hand side of length m
  !   m, n     : dimensions
  ! ---------------------------------------------------------------------------
  subroutine run(solver, name, need_At, has_y, y_size, need_c, c_vec, A_flat, At_flat, b_vec, m, n)
    integer(c_int),  intent(in) :: solver
    character(*),    intent(in) :: name
    logical,         intent(in) :: need_At, has_y, need_c
    integer,         intent(in) :: y_size, m, n
    real(c_double),  intent(in), target :: c_vec(*), A_flat(*), At_flat(*), b_vec(*)

    type(c_ptr)    :: ws
    integer(c_int) :: ret
    real(c_double), allocatable, target :: x(:), y(:)
    real(c_double) :: err
    integer        :: i

    write(*,'(A,A)', advance='no') name, " ... "

    ! Expose pointers to the callbacks
    call c_f_pointer(c_loc(A_flat),  cur_A,  [m*n])
    call c_f_pointer(c_loc(At_flat), cur_At, [n*m])
    cur_m = m
    cur_n = n

    ret = krylov_workspace_create(solver, int(m, c_int), int(n, c_int), &
                                  KRYLOV_FLOAT64, KRYLOV_CPU, c_null_ptr, ws)
    if (ret /= 0) then
      write(*,'(A,I0)') "FAIL  workspace_create returned ", ret
      n_fail = n_fail + 1; return
    end if

    block
      type(KrylovOptions), target :: opts
      opts = krylov_default_options()
      opts%atol = 1.0d-8
      opts%rtol = 1.0d-8

      ret = krylov_solve(ws,                                    &
                         c_funloc(cb_matvec_A),               &
                         merge(c_funloc(cb_matvec_At),        &
                               c_null_funptr, need_At),        &
                         c_null_funptr,                       &  ! no left preconditioner
                         c_null_funptr,                       &  ! no right preconditioner
                         c_loc(b_vec),                        &
                         merge(c_loc(c_vec), c_null_ptr, need_c), &
                         c_null_ptr,                          &
                         c_loc(opts))
    end block
    if (ret /= 0) then
      write(*,'(A,I0)') "FAIL  krylov_solve returned ", ret
      ret = krylov_workspace_free(ws)
      n_fail = n_fail + 1; return
    end if

    if (krylov_is_solved(ws) /= 1) then
      write(*,'(A,I0,A)') "FAIL  did not converge (niter=", krylov_niter(ws), ")"
      ret = krylov_workspace_free(ws)
      n_fail = n_fail + 1; return
    end if

    ! Check x ≈ ones
    allocate(x(n))
    ret = krylov_get_x(ws, c_loc(x), int(n, c_int))
    err = 0.0_c_double
    do i = 1, n
      err = err + (x(i) - 1.0_c_double)**2
    end do
    err = sqrt(err / real(n, c_double))
    deallocate(x)

    if (err > 1.0d-6) then
      write(*,'(A,ES10.3)') "FAIL  ||x - x_true||/sqrt(n) = ", err
      ret = krylov_workspace_free(ws)
      n_fail = n_fail + 1; return
    end if

    ! Check y is finite when expected
    if (has_y) then
      allocate(y(y_size))
      ret = krylov_get_y(ws, c_loc(y), int(y_size, c_int))
      if (ret /= 0) then
        write(*,'(A,I0)') "FAIL  krylov_get_y returned ", ret
        deallocate(y)
        ret = krylov_workspace_free(ws)
        n_fail = n_fail + 1; return
      end if
      if (any(.not. ieee_is_finite(y))) then
        write(*,*) "FAIL  y contains non-finite values"
        deallocate(y)
        ret = krylov_workspace_free(ws)
        n_fail = n_fail + 1; return
      end if
      deallocate(y)
    end if

    ret = krylov_workspace_free(ws)
    write(*,*) "PASS"
    n_pass = n_pass + 1
  end subroutine run

  subroutine cb_matvec_A(x_ptr, y_ptr, userdata) bind(c)
    use iso_c_binding
    type(c_ptr), value :: x_ptr, y_ptr, userdata
    real(c_double), pointer :: x(:), y(:)
    call c_f_pointer(x_ptr, x, [cur_n])
    call c_f_pointer(y_ptr, y, [cur_m])
    call matvec(cur_A, cur_m, cur_n, x, y)
  end subroutine cb_matvec_A

  subroutine cb_matvec_At(x_ptr, y_ptr, userdata) bind(c)
    use iso_c_binding
    type(c_ptr), value :: x_ptr, y_ptr, userdata
    real(c_double), pointer :: x(:), y(:)
    call c_f_pointer(x_ptr, x, [cur_m])
    call c_f_pointer(y_ptr, y, [cur_n])
    call matvec(cur_At, cur_n, cur_m, x, y)
  end subroutine cb_matvec_At

  ! ---------------------------------------------------------------------------
  ! Dense matrix-vector product: y = A(m x n, row-major) * x(n)
  ! ---------------------------------------------------------------------------
  subroutine matvec(A, m, n, x, y)
    real(c_double), intent(in)  :: A(*), x(n)
    real(c_double), intent(out) :: y(m)
    integer,        intent(in)  :: m, n
    integer :: i, j
    do i = 1, m
      y(i) = 0.0_c_double
      do j = 1, n
        y(i) = y(i) + A((i-1)*n + j) * x(j)
      end do
    end do
  end subroutine matvec

  ! Build an n×n tridiagonal into a flat row-major array (1-indexed Fortran)
  subroutine make_tridiag(A, rows, cols, diag_val, off_val)
    real(c_double), intent(out) :: A(rows*cols)
    integer,        intent(in)  :: rows, cols
    real(c_double), intent(in)  :: diag_val, off_val
    integer :: i
    A = 0.0_c_double
    do i = 1, rows
      A((i-1)*cols + i) = diag_val
      if (i > 1)    A((i-1)*cols + (i-1)) = off_val
      if (i < cols) A((i-1)*cols + (i+1)) = off_val
    end do
  end subroutine make_tridiag

  ! Build an m×n rectangular tridiagonal
  subroutine make_tridiag_rect(A, m, n, diag_val, off_val)
    real(c_double), intent(out) :: A(m*n)
    integer,        intent(in)  :: m, n
    real(c_double), intent(in)  :: diag_val, off_val
    integer :: i
    A = 0.0_c_double
    do i = 1, m
      if (i <= n) A((i-1)*n + i) = diag_val
      if (i > 1 .and. i-1 <= n) A((i-1)*n + (i-1)) = off_val
      if (i < n)                 A((i-1)*n + (i+1)) = off_val
    end do
  end subroutine make_tridiag_rect

  ! Transpose m×n → n×m (both row-major)
  subroutine do_transpose(A, At, m, n)
    real(c_double), intent(in)  :: A(m*n)
    real(c_double), intent(out) :: At(n*m)
    integer,        intent(in)  :: m, n
    integer :: i, j
    do i = 1, m
      do j = 1, n
        At((j-1)*m + i) = A((i-1)*n + j)
      end do
    end do
  end subroutine do_transpose

  ! IEEE finiteness helper (avoids ieee_arithmetic dependency on old compilers)
  elemental function ieee_is_finite(x) result(r)
    real(c_double), intent(in) :: x
    logical :: r
    r = .not. (x /= x) .and. abs(x) < huge(x)
  end function ieee_is_finite

end program test_all_solvers

function test_craig(A, b; λ=0.0)
  (x, y, stats) = craig(A, b, λ=λ)
  r = b - A * x
  # if λ > 0
  #   s = r / sqrt(λ)
  #   r = r - sqrt(λ) * s
  # end
  resid = norm(r) / norm(b)
  return (x, y, stats, resid)
end

@testset "craig" begin
  craig_tol = 1.0e-6

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      # Underdetermined consistent.
      A, b = under_consistent(FC=FC)
      (x, y, stats, resid) = test_craig(A, b)
      @test(norm(x - A' * y) ≤ craig_tol * norm(x))
      @test(resid ≤ craig_tol)
      @test(stats.solved)
      (xI, xmin, xmin_norm) = check_min_norm(A, b, x)
      @test(norm(xI - xmin) ≤ cond(A) * craig_tol * xmin_norm)

      # Underdetermined inconsistent.
      A, b = under_inconsistent(FC=FC)
      (x, y, stats, resid) = test_craig(A, b)
      # @test(norm(x - A' * y) ≤ craig_tol * norm(x))
      @test(stats.inconsistent || stats.status == "condition number exceeds tolerance")

      # Square consistent.
      A, b = square_consistent(FC=FC)
      (x, y, stats, resid) = test_craig(A, b)
      @test(norm(x - A' * y) ≤ craig_tol * norm(x))
      @test(resid ≤ craig_tol)
      @test(stats.solved)
      (xI, xmin, xmin_norm) = check_min_norm(A, b, x)
      @test(norm(xI - xmin) ≤ cond(A) * craig_tol * xmin_norm)

      # Square inconsistent.
      A, b = square_inconsistent(FC=FC)
      (x, y, stats, resid) = test_craig(A, b)
      # @test(norm(x - A' * y) ≤ craig_tol * norm(x))
      @test(stats.inconsistent || stats.status == "condition number exceeds tolerance")

      # Overdetermined consistent.
      A, b = over_consistent(FC=FC)
      (x, y, stats, resid) = test_craig(A, b)
      @test(norm(x - A' * y) ≤ craig_tol * norm(x))
      @test(resid ≤ craig_tol)
      @test(stats.solved)
      (xI, xmin, xmin_norm) = check_min_norm(A, b, x)
      @test(norm(xI - xmin) ≤ cond(A) * craig_tol * xmin_norm)

      # Overdetermined inconsistent.
      A, b = over_inconsistent(FC=FC)
      (x, y, stats, resid) = test_craig(A, b)
      # @test(norm(x - A' * y) ≤ craig_tol * norm(x))
      @test(stats.inconsistent || stats.status == "condition number exceeds tolerance")

      # With regularization, all systems are underdetermined and consistent.
      # (x, y, stats, resid) = test_craig(A, b, λ=1.0e-3)
      # @test(norm(x - A' * y) ≤ craig_tol * norm(x))
      # @test(resid ≤ craig_tol)
      # @test(stats.solved)
      # (xI, xmin, xmin_norm) = check_min_norm(A, b, x, λ=1.0e-3)
      # @test(norm(xI - xmin) ≤ cond(A) * craig_tol * xmin_norm)

      # Test b == 0
      A, b = zero_rhs(FC=FC)
      (x, y, stats) = craig(A, b, λ=1.0e-3)
      @test norm(x) == 0
      @test norm(y) == 0
      @test stats.status == "x is a zero-residual solution"

      # Test regularization
      A, b, λ = regularization(FC=FC)
      (x, y, stats) = craig(A, b, λ=λ)
      s = λ * y
      r = b - (A * x + λ * s)
      resid = norm(r) / norm(b)
      @test(resid ≤ craig_tol)
      r2 = b - (A * A' + λ^2 * I) * y
      resid2 = norm(r2) / norm(b)
      @test(resid2 ≤ craig_tol)

      # Test saddle-point systems
      A, b, D = saddle_point(FC=FC)
      D⁻¹ = inv(D)
      (x, y, stats) = craig(A, b, N=D⁻¹)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ craig_tol)
      r2 = b - (A * D⁻¹ * A') * y
      resid2 = norm(r2) / norm(b)
      @test(resid2 ≤ craig_tol)

      # Test with preconditioners
      A, b, M⁻¹, N⁻¹ = two_preconditioners(FC=FC)
      (x, y, stats) = craig(A, b, M=M⁻¹, N=N⁻¹, sqd=false)
      r = b - A * x
      resid = sqrt(real(dot(r, M⁻¹ * r))) / norm(b)
      @test(resid ≤ craig_tol)
      @test(norm(x - N⁻¹ * A' * y) ≤ craig_tol * norm(x))

      # Test symmetric and quasi-definite systems
      A, b, M, N = sqd(FC=FC)
      M⁻¹ = inv(M)
      N⁻¹ = inv(N)
      (x, y, stats) = craig(A, b, M=M⁻¹, N=N⁻¹, sqd=true)
      r = b - (A * x + M * y)
      resid = norm(r) / norm(b)
      @test(resid ≤ craig_tol)
      r2 = b - (A * N⁻¹ * A' + M) * y
      resid2 = norm(r2) / norm(b)
      @test(resid2 ≤ craig_tol)

      λ = 4.0
      (x, y, stats) = craig(A, b, M=M⁻¹, N=N⁻¹, λ=λ)
      r = b - (A * x + λ^2 * M * y)
      resid = norm(r) / norm(b)
      @test(resid ≤ craig_tol)
      r2 = b - (A * N⁻¹ * A' + λ^2 * M) * y
      resid2 = norm(r2) / norm(b)
      @test(resid2 ≤ craig_tol)

      # Test dimension of additional vectors
      for transpose ∈ (false, true)
        A, b, c, D = small_sp(transpose, FC=FC)
        D⁻¹ = inv(D)
        (x, y, stats) = craig(A', c, N=D⁻¹)

        A, b, c, M, N = small_sqd(transpose, FC=FC)
        M⁻¹ = inv(M)
        N⁻¹ = inv(N)
        (x, y, stats) = craig(A, b, M=M⁻¹, N=N⁻¹, sqd=true)
      end

      # Test different types for input and output
      A, b = small_ln(FC=FC)
      m, n = size(A)
      workspace = CraigWorkspace(KrylovConstructor(b, TestVector(similar(b, n))))
      craig!(workspace, A, b)
      @test workspace.stats.solved
      @test typeof(workspace.x) === TestVector{FC}
      @test typeof(workspace.y) === Vector{FC}

      # test callback function
      A, b = over_consistent(FC=FC)
      workspace = CraigWorkspace(A, b)
      tol = 1.0e-1
      cb_n2 = TestCallbackN2LN(A, b, real(zero(eltype(b))), tol = tol)
      craig!(workspace, A, b, callback = cb_n2)
      @test workspace.stats.status == "user-requested exit"
      @test cb_n2(workspace)

      @test_throws TypeError craig(A, b, callback = workspace -> "string", history = true)

      # Test small least-norm problem
      A, b = small_ln(FC=FC)
      x, y, stats = craig(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test resid ≤ craig_tol
      @test norm(x - A' * y) ≤ craig_tol * norm(x)
    end
  end
end

# An implementation of BILQR for the solution of square
# consistent linear adjoint systems Ax = b and Aᴴy = c.
#
# This method is described in
#
# A. Montoison and D. Orban
# BiLQ: An Iterative Method for Nonsymmetric Linear Systems with a Quasi-Minimum Error Property.
# SIAM Journal on Matrix Analysis and Applications, 41(3), pp. 1145--1166, 2020.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Montreal, July 2019.

export bilqr, bilqr!

"""
    (x, y, stats) = bilqr(A, b::AbstractVector{FC}, c::AbstractVector{FC};
                          transfer_to_bicg::Bool=true, atol::T=√eps(T),
                          rtol::T=√eps(T), itmax::Int=0,
                          timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                          callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, y, stats) = bilqr(A, b, c, x0::AbstractVector, y0::AbstractVector; kwargs...)

BiLQR can be warm-started from initial guesses `x0` and `y0` where `kwargs` are the same keyword arguments as above.

Combine BiLQ and QMR to solve adjoint systems.

    [0  A] [y] = [b]
    [Aᴴ 0] [x]   [c]

The relation `bᴴc ≠ 0` must be satisfied.
BiLQ is used for solving primal system `Ax = b` of size n.
QMR is used for solving dual system `Aᴴy = c` of size n.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :bilqr`.

For an in-place variant that reuses memory across solves, see [`bilqr!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `n`;
* `b`: a vector of length `n`;
* `c`: a vector of length `n`.

#### Optional arguments

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`;
* `y0`: a vector of length `n` that represents an initial guess of the solution `y`.

#### Keyword arguments

* `transfer_to_bicg`: transfer from the BiLQ point to the BiCG point, when it exists. The transfer is based on the residual norm;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `y`: a dense vector of length `n`;
* `stats`: statistics collected on the run in an [`AdjointStats`](@ref) structure.

#### Reference

* A. Montoison and D. Orban, [*BiLQ: An Iterative Method for Nonsymmetric Linear Systems with a Quasi-Minimum Error Property*](https://doi.org/10.1137/19M1290991), SIAM Journal on Matrix Analysis and Applications, 41(3), pp. 1145--1166, 2020.
"""
function bilqr end

"""
    workspace = bilqr!(workspace::BilqrWorkspace, A, b, c; kwargs...)
    workspace = bilqr!(workspace::BilqrWorkspace, A, b, c, x0, y0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`bilqr`](@ref).

See [`BilqrWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :bilqr` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function bilqr! end

def_args_bilqr = (:(A                    ),
                  :(b::AbstractVector{FC}),
                  :(c::AbstractVector{FC}))

def_optargs_bilqr = (:(x0 :: AbstractVector),
                     :(y0 :: AbstractVector))

def_kwargs_bilqr = (:(; transfer_to_bicg::Bool = true),
                    :(; atol::T = √eps(T)            ),
                    :(; rtol::T = √eps(T)            ),
                    :(; itmax::Int = 0               ),
                    :(; timemax::Float64 = Inf       ),
                    :(; verbose::Int = 0             ),
                    :(; history::Bool = false        ),
                    :(; callback = workspace -> false),
                    :(; iostream::IO = kstdout       ))

def_kwargs_bilqr = extract_parameters.(def_kwargs_bilqr)

args_bilqr = (:A, :b, :c)
optargs_bilqr = (:x0, :y0)
kwargs_bilqr = (:transfer_to_bicg, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function bilqr!(workspace :: BilqrWorkspace{T,FC,S}, $(def_args_bilqr...); $(def_kwargs_bilqr...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("Systems must be square")
    length(b) == m || error("Inconsistent problem size")
    length(c) == n || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "BILQR: systems of size %d\n", n)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")
    ktypeof(c) == S || error("ktypeof(c) must be equal to $S")

    # Compute the adjoint of A
    Aᴴ = A'

    # Set up workspace.
    uₖ₋₁, uₖ, q, vₖ₋₁, vₖ = workspace.uₖ₋₁, workspace.uₖ, workspace.q, workspace.vₖ₋₁, workspace.vₖ
    p, Δx, Δy, x, t = workspace.p, workspace.Δx, workspace.Δy, workspace.x, workspace.y
    d̅, wₖ₋₃, wₖ₋₂, stats = workspace.d̅, workspace.wₖ₋₃, workspace.wₖ₋₂, workspace.stats
    warm_start = workspace.warm_start
    rNorms, sNorms = stats.residuals_primal, stats.residuals_dual
    reset!(stats)
    r₀ = warm_start ? q : b
    s₀ = warm_start ? p : c

    if warm_start
      kmul!(r₀, A, Δx)
      kaxpby!(n, one(FC), b, -one(FC), r₀)
      kmul!(s₀, Aᴴ, Δy)
      kaxpby!(n, one(FC), c, -one(FC), s₀)
    end

    # Initial solution x₀ and residual norm ‖r₀‖ = ‖b - Ax₀‖.
    kfill!(x, zero(FC))   # x₀
    bNorm = knorm(n, r₀)  # rNorm = ‖r₀‖

    # Initial solution t₀ and residual norm ‖s₀‖ = ‖c - Aᴴy₀‖.
    kfill!(t, zero(FC))   # t₀
    cNorm = knorm(n, s₀)  # sNorm = ‖s₀‖

    iter = 0
    itmax == 0 && (itmax = 2*n)

    history && push!(rNorms, bNorm)
    history && push!(sNorms, cNorm)
    εL = atol + rtol * bNorm
    εQ = atol + rtol * cNorm
    (verbose > 0) && @printf(iostream, "%5s  %7s  %7s  %5s\n", "k", "‖rₖ‖", "‖sₖ‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %.2fs\n", iter, bNorm, cNorm, start_time |> ktimer)

    # Initialize the Lanczos biorthogonalization process.
    cᴴb = kdot(n, s₀, r₀)  # ⟨s₀,r₀⟩ = ⟨c - Aᴴy₀,b - Ax₀⟩
    if cᴴb == 0
      stats.niter = 0
      stats.solved_primal = false
      stats.solved_dual = false
      stats.timer = start_time |> ktimer
      stats.status = "Breakdown bᴴc = 0"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      warm_start && kaxpy!(n, one(FC), Δy, t)
      workspace.warm_start = false
      return workspace
    end

    # Set up workspace.
    βₖ = √(abs(cᴴb))                # β₁γ₁ = (c - Aᴴy₀)ᴴ(b - Ax₀)
    γₖ = cᴴb / βₖ                   # β₁γ₁ = (c - Aᴴy₀)ᴴ(b - Ax₀)
    kfill!(vₖ₋₁, zero(FC))          # v₀ = 0
    kfill!(uₖ₋₁, zero(FC))          # u₀ = 0
    kdivcopy!(n, vₖ, r₀, βₖ)        # v₁ = (b - Ax₀) / β₁
    kdivcopy!(n, uₖ, s₀, conj(γₖ))  # u₁ = (c - Aᴴy₀) / γ̄₁
    cₖ₋₁ = cₖ = -one(T)             # Givens cosines used for the LQ factorization of Tₖ
    sₖ₋₁ = sₖ = zero(FC)            # Givens sines used for the LQ factorization of Tₖ
    kfill!(d̅, zero(FC))             # Last column of D̅ₖ = Vₖ(Qₖ)ᴴ
    ζₖ₋₁ = ζbarₖ = zero(FC)         # ζₖ₋₁ and ζbarₖ are the last components of z̅ₖ = (L̅ₖ)⁻¹β₁e₁
    ζₖ₋₂ = ηₖ = zero(FC)            # ζₖ₋₂ and ηₖ are used to update ζₖ₋₁ and ζbarₖ
    δbarₖ₋₁ = δbarₖ = zero(FC)      # Coefficients of Lₖ₋₁ and L̅ₖ modified over the course of two iterations
    ψbarₖ₋₁ = ψₖ₋₁ = zero(FC)       # ψₖ₋₁ and ψbarₖ are the last components of h̅ₖ = Qₖγ̄₁e₁
    norm_vₖ = bNorm / βₖ            # ‖vₖ‖ is used for residual norm estimates
    ϵₖ₋₃ = λₖ₋₂ = zero(FC)          # Components of Lₖ₋₁
    kfill!(wₖ₋₃, zero(FC))          # Column k-3 of Wₖ = Uₖ(Lₖ)⁻ᴴ
    kfill!(wₖ₋₂, zero(FC))          # Column k-2 of Wₖ = Uₖ(Lₖ)⁻ᴴ
    τₖ = zero(T)                    # τₖ is used for the dual residual norm estimate

    # Stopping criterion.
    solved_lq = bNorm == 0
    solved_lq_tol = solved_lq_mach = false
    solved_cg = solved_cg_tol = solved_cg_mach = false
    solved_primal = solved_lq || solved_cg
    solved_qr_tol = solved_qr_mach = false
    solved_dual = cNorm == 0
    tired = iter ≥ itmax
    breakdown = false
    status = "unknown"
    user_requested_exit = false
    overtimed = false

    while !((solved_primal && solved_dual) || tired || breakdown || user_requested_exit || overtimed)
      # Update iteration index.
      iter = iter + 1

      # Continue the Lanczos biorthogonalization process.
      # AVₖ  = VₖTₖ    + βₖ₊₁vₖ₊₁(eₖ)ᵀ = Vₖ₊₁Tₖ₊₁.ₖ
      # AᴴUₖ = Uₖ(Tₖ)ᴴ + γ̄ₖ₊₁uₖ₊₁(eₖ)ᵀ = Uₖ₊₁(Tₖ.ₖ₊₁)ᴴ

      kmul!(q, A , vₖ)  # Forms vₖ₊₁ : q ← Avₖ
      kmul!(p, Aᴴ, uₖ)  # Forms uₖ₊₁ : p ← Aᴴuₖ

      kaxpy!(n, -γₖ, vₖ₋₁, q)  # q ← q - γₖ * vₖ₋₁
      kaxpy!(n, -βₖ, uₖ₋₁, p)  # p ← p - β̄ₖ * uₖ₋₁

      αₖ = kdot(n, uₖ, q)  # αₖ = ⟨uₖ,q⟩

      kaxpy!(n, -     αₖ , vₖ, q)  # q ← q - αₖ * vₖ
      kaxpy!(n, -conj(αₖ), uₖ, p)  # p ← p - ᾱₖ * uₖ

      pᴴq = kdot(n, p, q)  # pᴴq  = ⟨p,q⟩
      βₖ₊₁ = √(abs(pᴴq))   # βₖ₊₁ = √(|pᴴq|)
      γₖ₊₁ = pᴴq / βₖ₊₁    # γₖ₊₁ = pᴴq / βₖ₊₁

      # Update the LQ factorization of Tₖ = L̅ₖQₖ.
      # [ α₁ γ₂ 0  •  •  •  0 ]   [ δ₁   0    •   •   •    •    0   ]
      # [ β₂ α₂ γ₃ •        • ]   [ λ₁   δ₂   •                 •   ]
      # [ 0  •  •  •  •     • ]   [ ϵ₁   λ₂   δ₃  •             •   ]
      # [ •  •  •  •  •  •  • ] = [ 0    •    •   •   •         •   ] Qₖ
      # [ •     •  •  •  •  0 ]   [ •    •    •   •   •    •    •   ]
      # [ •        •  •  •  γₖ]   [ •         •   •  λₖ₋₂ δₖ₋₁  0   ]
      # [ 0  •  •  •  0  βₖ αₖ]   [ •    •    •   0  ϵₖ₋₂ λₖ₋₁ δbarₖ]

      if iter == 1
        δbarₖ = αₖ
      elseif iter == 2
        # [δbar₁ γ₂] [c₂  s̄₂] = [δ₁   0  ]
        # [ β₂   α₂] [s₂ -c₂]   [λ₁ δbar₂]
        (cₖ, sₖ, δₖ₋₁) = sym_givens(δbarₖ₋₁, γₖ)
        λₖ₋₁  =      cₖ  * βₖ + sₖ * αₖ
        δbarₖ = conj(sₖ) * βₖ - cₖ * αₖ
      else
        # [0  βₖ  αₖ] [cₖ₋₁   s̄ₖ₋₁   0] = [sₖ₋₁βₖ  -cₖ₋₁βₖ  αₖ]
        #             [sₖ₋₁  -cₖ₋₁   0]
        #             [ 0      0     1]
        #
        # [ λₖ₋₂   δbarₖ₋₁  γₖ] [1   0   0 ] = [λₖ₋₂  δₖ₋₁    0  ]
        # [sₖ₋₁βₖ  -cₖ₋₁βₖ  αₖ] [0   cₖ  s̄ₖ]   [ϵₖ₋₂  λₖ₋₁  δbarₖ]
        #                       [0   sₖ -cₖ]
        (cₖ, sₖ, δₖ₋₁) = sym_givens(δbarₖ₋₁, γₖ)
        ϵₖ₋₂  =  sₖ₋₁ * βₖ
        λₖ₋₁  = -cₖ₋₁ *      cₖ  * βₖ + sₖ * αₖ
        δbarₖ = -cₖ₋₁ * conj(sₖ) * βₖ - cₖ * αₖ
      end

      if !solved_primal
        # Compute ζₖ₋₁ and ζbarₖ, last components of the solution of L̅ₖz̅ₖ = β₁e₁
        # [δbar₁] [ζbar₁] = [β₁]
        if iter == 1
          ηₖ = βₖ
        end
        # [δ₁    0  ] [  ζ₁ ] = [β₁]
        # [λ₁  δbar₂] [ζbar₂]   [0 ]
        if iter == 2
          ηₖ₋₁ = ηₖ
          ζₖ₋₁ = ηₖ₋₁ / δₖ₋₁
          ηₖ   = -λₖ₋₁ * ζₖ₋₁
        end
        # [λₖ₋₂  δₖ₋₁    0  ] [ζₖ₋₂ ] = [0]
        # [ϵₖ₋₂  λₖ₋₁  δbarₖ] [ζₖ₋₁ ]   [0]
        #                     [ζbarₖ]
        if iter ≥ 3
          ζₖ₋₂ = ζₖ₋₁
          ηₖ₋₁ = ηₖ
          ζₖ₋₁ = ηₖ₋₁ / δₖ₋₁
          ηₖ   = -ϵₖ₋₂ * ζₖ₋₂ - λₖ₋₁ * ζₖ₋₁
        end

        # Relations for the directions dₖ₋₁ and d̅ₖ, the last two columns of D̅ₖ = Vₖ(Qₖ)ᴴ.
        # [d̅ₖ₋₁ vₖ] [cₖ  s̄ₖ] = [dₖ₋₁ d̅ₖ] ⟷ dₖ₋₁ = cₖ * d̅ₖ₋₁ + sₖ * vₖ
        #           [sₖ -cₖ]             ⟷ d̅ₖ   = s̄ₖ * d̅ₖ₋₁ - cₖ * vₖ
        if iter == 1
          # d̅₁ = v₁
          kcopy!(n, d̅, vₖ)  # d̅ ← vₖ
        else
          # Compute solution xₖ.
          # (xᴸ)ₖ ← (xᴸ)ₖ + ζₖ₋₁ * dₖ₋₁
          kaxpy!(n, ζₖ₋₁ * cₖ,  d̅, x)
          kaxpy!(n, ζₖ₋₁ * sₖ, vₖ, x)

          # Compute d̅ₖ.
          # d̅ₖ = s̄ₖ * d̅ₖ₋₁ - cₖ * vₖ
          kaxpby!(n, -cₖ, vₖ, conj(sₖ), d̅)
        end

        # Compute ⟨vₖ,vₖ₊₁⟩ and ‖vₖ₊₁‖
        vₖᴴvₖ₊₁ = kdot(n, vₖ, q) / βₖ₊₁
        norm_vₖ₊₁ = knorm(n, q) / βₖ₊₁

        # Compute BiLQ residual norm
        # ‖rₖ‖ = √(|μₖ|²‖vₖ‖² + |ωₖ|²‖vₖ₊₁‖² + μ̄ₖωₖ⟨vₖ,vₖ₊₁⟩ + μₖω̄ₖ⟨vₖ₊₁,vₖ⟩)
        if iter == 1
          rNorm_lq = bNorm
        else
          μₖ = βₖ * (sₖ₋₁ * ζₖ₋₂ - cₖ₋₁ * cₖ * ζₖ₋₁) + αₖ * sₖ * ζₖ₋₁
          ωₖ = βₖ₊₁ * sₖ * ζₖ₋₁
          θₖ = conj(μₖ) * ωₖ * vₖᴴvₖ₊₁
          rNorm_lq = sqrt(abs2(μₖ) * norm_vₖ^2 + abs2(ωₖ) * norm_vₖ₊₁^2 + 2 * real(θₖ))
        end
        history && push!(rNorms, rNorm_lq)

        # Update ‖vₖ‖
        norm_vₖ = norm_vₖ₊₁

        # Compute BiCG residual norm
        # ‖rₖ‖ = |ρₖ| * ‖vₖ₊₁‖
        if transfer_to_bicg && (abs(δbarₖ) > eps(T))
          ζbarₖ = ηₖ / δbarₖ
          ρₖ = βₖ₊₁ * (sₖ * ζₖ₋₁ - cₖ * ζbarₖ)
          rNorm_cg = abs(ρₖ) * norm_vₖ₊₁
        end

        # Update primal stopping criterion
        solved_lq_tol = rNorm_lq ≤ εL
        solved_lq_mach = rNorm_lq + 1 ≤ 1
        solved_lq = solved_lq_tol || solved_lq_mach
        solved_cg_tol = transfer_to_bicg && (abs(δbarₖ) > eps(T)) && (rNorm_cg ≤ εL)
        solved_cg_mach = transfer_to_bicg && (abs(δbarₖ) > eps(T)) && (rNorm_cg + 1 ≤ 1)
        solved_cg = solved_cg_tol || solved_cg_mach
        solved_primal = solved_lq || solved_cg
      end

      if !solved_dual
        # Compute ψₖ₋₁ and ψbarₖ the last coefficients of h̅ₖ = Qₖγ̄₁e₁.
        if iter == 1
          ψbarₖ = conj(γₖ)
        else
          # [cₖ  s̄ₖ] [ψbarₖ₋₁] = [ ψₖ₋₁ ]
          # [sₖ -cₖ] [   0   ]   [ ψbarₖ]
          ψₖ₋₁  = cₖ * ψbarₖ₋₁
          ψbarₖ = sₖ * ψbarₖ₋₁
        end

        # Compute the direction wₖ₋₁, the last column of Wₖ₋₁ = (Uₖ₋₁)(Lₖ₋₁)⁻ᴴ ⟷ (L̄ₖ₋₁)(Wₖ₋₁)ᵀ = (Uₖ₋₁)ᵀ.
        # w₁ = u₁ / δ̄₁
        if iter == 2
          wₖ₋₁ = wₖ₋₂
          kdivcopy!(n, wₖ₋₁, uₖ₋₁, conj(δₖ₋₁))
        end
        # w₂ = (u₂ - λ̄₁w₁) / δ̄₂
        if iter == 3
          wₖ₋₁ = wₖ₋₃
          kaxpy!(n, one(FC), uₖ₋₁, wₖ₋₁)
          kaxpy!(n, -conj(λₖ₋₂), wₖ₋₂, wₖ₋₁)
          kdiv!(n, wₖ₋₁, conj(δₖ₋₁))
        end
        # wₖ₋₁ = (uₖ₋₁ - λ̄ₖ₋₂wₖ₋₂ - ϵ̄ₖ₋₃wₖ₋₃) / δ̄ₖ₋₁
        if iter ≥ 4
          kscal!(n, -conj(ϵₖ₋₃), wₖ₋₃)
          wₖ₋₁ = wₖ₋₃
          kaxpy!(n, one(FC), uₖ₋₁, wₖ₋₁)
          kaxpy!(n, -conj(λₖ₋₂), wₖ₋₂, wₖ₋₁)
          kdiv!(n, wₖ₋₁, conj(δₖ₋₁))
        end

        if iter ≥ 3
          # Swap pointers.
          @kswap!(wₖ₋₃, wₖ₋₂)
        end

        if iter ≥ 2
          # Compute solution tₖ₋₁.
          # tₖ₋₁ ← tₖ₋₂ + ψₖ₋₁ * wₖ₋₁
          kaxpy!(n, ψₖ₋₁, wₖ₋₁, t)
        end

        # Update ψbarₖ₋₁
        ψbarₖ₋₁ = ψbarₖ

        # Compute τₖ = τₖ₋₁ + ‖uₖ‖²
        τₖ += kdotr(n, uₖ, uₖ)

        # Compute QMR residual norm ‖sₖ₋₁‖ ≤ |ψbarₖ| * √τₖ
        sNorm = abs(ψbarₖ) * √τₖ
        history && push!(sNorms, sNorm)

        # Update dual stopping criterion
        solved_qr_tol = sNorm ≤ εQ
        solved_qr_mach = sNorm + 1 ≤ 1
        solved_dual = solved_qr_tol || solved_qr_mach
      end

      # Compute vₖ₊₁ and uₖ₊₁.
      kcopy!(n, vₖ₋₁, vₖ)  # vₖ₋₁ ← vₖ
      kcopy!(n, uₖ₋₁, uₖ)  # uₖ₋₁ ← uₖ


      if pᴴq ≠ zero(FC)
        kdivcopy!(n, vₖ, q, βₖ₊₁)        # vₖ₊₁ = q / βₖ₊₁
        kdivcopy!(n, uₖ, p, conj(γₖ₊₁))  # uₖ₊₁ = p / γ̄ₖ₊₁
      end

      # Update ϵₖ₋₃, λₖ₋₂, δbarₖ₋₁, cₖ₋₁, sₖ₋₁, γₖ and βₖ.
      if iter ≥ 3
        ϵₖ₋₃ = ϵₖ₋₂
      end
      if iter ≥ 2
        λₖ₋₂ = λₖ₋₁
      end
      δbarₖ₋₁ = δbarₖ
      cₖ₋₁    = cₖ
      sₖ₋₁    = sₖ
      γₖ      = γₖ₊₁
      βₖ      = βₖ₊₁

      user_requested_exit = callback(workspace) :: Bool
      tired = iter ≥ itmax
      breakdown = !solved_lq && !solved_cg && (pᴴq == 0)
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns

      kdisplay(iter, verbose) &&  solved_primal && !solved_dual && @printf(iostream, "%5d  %7s  %7.1e  %.2fs\n", iter, "✗ ✗ ✗ ✗", sNorm, start_time |> ktimer)
      kdisplay(iter, verbose) && !solved_primal &&  solved_dual && @printf(iostream, "%5d  %7.1e  %7s  %.2fs\n", iter, rNorm_lq, "✗ ✗ ✗ ✗", start_time |> ktimer)
      kdisplay(iter, verbose) && !solved_primal && !solved_dual && @printf(iostream, "%5d  %7.1e  %7.1e  %.2fs\n", iter, rNorm_lq, sNorm, start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Compute BICG point
    # (xᶜ)ₖ ← (xᴸ)ₖ + ζbarₖ * d̅ₖ
    if solved_cg
      kaxpy!(n, ζbarₖ, d̅, x)
    end

    # Termination status
    tired                            && (status = "maximum number of iterations exceeded")
    breakdown                        && (status = "Breakdown ⟨uₖ₊₁,vₖ₊₁⟩ = 0")
    solved_lq_tol  && !solved_dual   && (status = "Only the primal solution xᴸ is good enough given atol and rtol")
    solved_cg_tol  && !solved_dual   && (status = "Only the primal solution xᶜ is good enough given atol and rtol")
    !solved_primal && solved_qr_tol  && (status = "Only the dual solution t is good enough given atol and rtol")
    solved_lq_tol  && solved_qr_tol  && (status = "Both primal and dual solutions (xᴸ, t) are good enough given atol and rtol")
    solved_cg_tol  && solved_qr_tol  && (status = "Both primal and dual solutions (xᶜ, t) are good enough given atol and rtol")
    solved_lq_mach && !solved_dual   && (status = "Only found approximate zero-residual primal solution xᴸ")
    solved_cg_mach && !solved_dual   && (status = "Only found approximate zero-residual primal solution xᶜ")
    !solved_primal && solved_qr_mach && (status = "Only found approximate zero-residual dual solution t")
    solved_lq_mach && solved_qr_mach && (status = "Found approximate zero-residual primal and dual solutions (xᴸ, t)")
    solved_cg_mach && solved_qr_mach && (status = "Found approximate zero-residual primal and dual solutions (xᶜ, t)")
    solved_lq_mach && solved_qr_tol  && (status = "Found approximate zero-residual primal solutions xᴸ and a dual solution t good enough given atol and rtol")
    solved_cg_mach && solved_qr_tol  && (status = "Found approximate zero-residual primal solutions xᶜ and a dual solution t good enough given atol and rtol")
    solved_lq_tol  && solved_qr_mach && (status = "Found a primal solution xᴸ good enough given atol and rtol and an approximate zero-residual dual solutions t")
    solved_cg_tol  && solved_qr_mach && (status = "Found a primal solution xᶜ good enough given atol and rtol and an approximate zero-residual dual solutions t")
    user_requested_exit              && (status = "user-requested exit")
    overtimed                        && (status = "time limit exceeded")

    # Update x and y
    warm_start && kaxpy!(n, one(FC), Δx, x)
    warm_start && kaxpy!(n, one(FC), Δy, t)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved_primal = solved_primal
    stats.solved_dual = solved_dual
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

using PkgBenchmark

using SolverBenchmark

using Plots
pyplot()  # recommended!
using PlotThemes
theme(:juno)

common_plot_args = Dict{Symbol,Any}(
  :linewidth => 2,
  :alpha => .75,
  :titlefontsize => 8,
  :legendfontsize => 8,
  :xtickfontsize => 6,
  :ytickfontsize => 6,
  :guidefontsize => 8,
)
Plots.default(; common_plot_args...)

# perform benchmarks
results = PkgBenchmark.benchmarkpkg("Krylov", script="benchmark/cg_bmark.jl")

# process benchmark results and post gist
p = profile_solvers(results)
posted_gist = to_gist(results, p)
println(posted_gist.html_url)

module LibKrylov

using LinearAlgebra
using Krylov

# Krylov.jl version compiled into this library (matches the KRYLOV_VERSION_*
# macros in krylov.h; queryable at run time via krylov_get_version).
const _KRYLOV_VERSION = pkgversion(Krylov)

include("c_enums.jl")
include("c_operator.jl")
include("c_stores.jl")   # 136 typed stores + dispatch helpers (generated)

# ---------------------------------------------------------------------------
# Function signatures exported to the generated C header.
# Each entry: (c_name, return_type, [(arg_name, c_type), ...])
# This vector is read by scripts/generate_header.jl.
# ---------------------------------------------------------------------------
const function_sigs = Tuple{String, String, Vector{Tuple{String,String}}}[]

macro export_sig(name, ret, args...)
  arg_pairs = [(string(a.args[1]), string(a.args[2])) for a in args]
  push!(function_sigs, (string(name), string(ret), arg_pairs))
  esc(:(nothing))
end

# ---------------------------------------------------------------------------
# krylov_workspace_create
#
# Creates a typed Krylov workspace and writes its opaque pointer into *ws_out.
#
#   solver  : KrylovSolverType enum value (e.g. KRYLOV_CG, KRYLOV_GMRES)
#   m, n    : operator dimensions (m rows, n columns)
#   dtype   : KrylovDataType enum value
#   device  : KrylovDeviceType enum value (currently only KRYLOV_CPU = 0)
#   wopts   : pointer to a KrylovWorkspaceOptions struct, or NULL for defaults
#             (controls memory for GMRES-family solvers and window for MINRES/LS)
#   ws_out  : address of a pointer that receives the workspace handle
#
# Returns 0 on success, -1 on error, -2 on unknown (solver, dtype) combination.
# ---------------------------------------------------------------------------
@export_sig krylov_workspace_create "int" (solver, "KrylovSolverType") (m, "int") (n, "int") (dtype, "KrylovDataType") (device, "KrylovDeviceType") (wopts, "const KrylovWorkspaceOptions*") (ws_out, "void**")

Base.@ccallable function krylov_workspace_create(
    solver   :: Cint,
    m        :: Cint,
    n        :: Cint,
    dtype    :: Cint,
    device   :: Cint,
    wopts_ptr :: Ptr{Cvoid},
    ws_out   :: Ptr{Ptr{Cvoid}},
) :: Cint
  try
    wopts = wopts_ptr == C_NULL ? KrylovWorkspaceOptionsC(Cint(0), Cint(0)) :
                                  unsafe_load(Ptr{KrylovWorkspaceOptionsC}(wopts_ptr))
    _do_create!(solver, m, n, dtype, wopts, ws_out)
  catch e
    @error "krylov_workspace_create" exception=e
    Cint(-1)
  end
end

# ---------------------------------------------------------------------------
# krylov_default_workspace_options — returns a KrylovWorkspaceOptions with all
# fields set to their "use solver default" sentinel (0).  Call this to
# initialise the struct before overriding memory / window.
# ---------------------------------------------------------------------------
@export_sig krylov_default_workspace_options "KrylovWorkspaceOptions"

Base.@ccallable function krylov_default_workspace_options() :: KrylovWorkspaceOptionsC
    KrylovWorkspaceOptionsC(Cint(0), Cint(0))
end

# ---------------------------------------------------------------------------
# krylov_default_options — returns a KrylovOptions with all fields set to
# their "use solver default" sentinels (NaN for doubles, 0 for ints).
# Always call this to initialise an options struct before overriding fields.
# ---------------------------------------------------------------------------
@export_sig krylov_default_options "KrylovOptions"

Base.@ccallable function krylov_default_options() :: KrylovOptionsC
    KrylovOptionsC(NaN, NaN, Cint(0), Cint(0), 0.0, NaN, NaN,
                   NaN, 0.0, Cint(0), Cint(0), Cint(0))
end

# ---------------------------------------------------------------------------
# krylov_get_version — write the Krylov.jl version of this library into
# *major, *minor, *patch (the same values as the KRYLOV_VERSION_* macros).
# ---------------------------------------------------------------------------
@export_sig krylov_get_version "void" (major, "int*") (minor, "int*") (patch, "int*")

Base.@ccallable function krylov_get_version(
    major :: Ptr{Cint},
    minor :: Ptr{Cint},
    patch :: Ptr{Cint},
) :: Cvoid
  unsafe_store!(major, Cint(_KRYLOV_VERSION.major))
  unsafe_store!(minor, Cint(_KRYLOV_VERSION.minor))
  unsafe_store!(patch, Cint(_KRYLOV_VERSION.patch))
  nothing
end

# ---------------------------------------------------------------------------
# krylov_solve
#
#   ws       : workspace handle (from krylov_workspace_create)
#   matvec_A : C callback  void(*)(const void *x, void *y, void *ud)
#              computes y = A*x
#   matvec_At: C callback for y = A'*x, or NULL for CG/GMRES/MINRES/...
#              (required for LSQR, LSMR, CGLS, CRAIG, ...)
#   matvec_M : left preconditioner callback (y = M⁻¹x), or NULL
#   matvec_N : right preconditioner callback (y = N⁻¹x), or NULL
#              (only used by the non-symmetric solvers that accept both:
#               GMRES, FGMRES, FOM, DIOM, DQGMRES, BiCGSTAB, CGS, BiLQ, QMR;
#               ignored by the others)
#   b        : right-hand side array of length m
#   c        : second right-hand side (NULL if not needed)
#   userdata : opaque pointer forwarded to every callback
#   opts     : pointer to a KrylovOptions struct, or NULL for all defaults
#
# Returns 0 on success, nonzero on error.
# ---------------------------------------------------------------------------
@export_sig krylov_solve "int" (ws, "void*") (matvec_A, "KrylovMatvec") (matvec_At, "KrylovMatvec") (matvec_M, "KrylovMatvec") (matvec_N, "KrylovMatvec") (b, "const void*") (c, "const void*") (userdata, "void*") (opts, "const KrylovOptions*")

Base.@ccallable function krylov_solve(
    ws_ptr   :: Ptr{Cvoid},
    fptr_A   :: Ptr{Cvoid},
    fptr_At  :: Ptr{Cvoid},
    fptr_M   :: Ptr{Cvoid},
    fptr_N   :: Ptr{Cvoid},
    b_ptr    :: Ptr{Cvoid},
    c_ptr    :: Ptr{Cvoid},
    userdata :: Ptr{Cvoid},
    opts_ptr :: Ptr{Cvoid},
) :: Cint
  try
    _do_solve!(ws_ptr, fptr_A, fptr_At, fptr_M, fptr_N, b_ptr, c_ptr, userdata, opts_ptr)
  catch e
    @error "krylov_solve" exception=e
    Cint(-1)
  end
end

# ---------------------------------------------------------------------------
# krylov_get_x — copies the primal solution into a user-provided buffer
# ---------------------------------------------------------------------------
@export_sig krylov_get_x "int" (ws, "void*") (x, "void*") (n, "int")

Base.@ccallable function krylov_get_x(
    ws_ptr :: Ptr{Cvoid},
    x_ptr  :: Ptr{Cvoid},
    n      :: Cint,
) :: Cint
  try
    _do_get_x!(ws_ptr, x_ptr, n)
  catch e
    @error "krylov_get_x" exception=e
    Cint(-1)
  end
end

# ---------------------------------------------------------------------------
# krylov_get_y — dual solution (TriCG, TriMR, GPMR, BiLQR, TriLQR)
# Returns -2 if the solver has only one solution vector.
# ---------------------------------------------------------------------------
@export_sig krylov_get_y "int" (ws, "void*") (y, "void*") (m, "int")

Base.@ccallable function krylov_get_y(
    ws_ptr :: Ptr{Cvoid},
    y_ptr  :: Ptr{Cvoid},
    m      :: Cint,
) :: Cint
  try
    _do_get_y!(ws_ptr, y_ptr, m)
  catch e
    @error "krylov_get_y" exception=e
    Cint(-1)
  end
end

# ---------------------------------------------------------------------------
# Scalar statistics
# ---------------------------------------------------------------------------
@export_sig krylov_is_solved    "int"    (ws, "void*")
@export_sig krylov_niter        "int"    (ws, "void*")
@export_sig krylov_elapsed_time "double" (ws, "void*")

Base.@ccallable function krylov_is_solved(ws_ptr :: Ptr{Cvoid}) :: Cint
  _do_is_solved(ws_ptr)
end

Base.@ccallable function krylov_niter(ws_ptr :: Ptr{Cvoid}) :: Cint
  _do_niter(ws_ptr)
end

Base.@ccallable function krylov_elapsed_time(ws_ptr :: Ptr{Cvoid}) :: Cdouble
  _do_elapsed_time(ws_ptr)
end

# ---------------------------------------------------------------------------
# krylov_warm_start — sets the initial guess for the next krylov_solve call
# ---------------------------------------------------------------------------
@export_sig krylov_warm_start "int" (ws, "void*") (x0, "const void*") (n, "int")

Base.@ccallable function krylov_warm_start(
    ws_ptr :: Ptr{Cvoid},
    x0_ptr :: Ptr{Cvoid},
    n      :: Cint,
) :: Cint
  try
    _do_warm_start!(ws_ptr, x0_ptr, n)
  catch e
    @error "krylov_warm_start" exception=e
    Cint(-1)
  end
end

# ---------------------------------------------------------------------------
# krylov_warm_start2 — sets BOTH initial guesses for the next krylov_solve call,
# for the two-solution solvers (TriCG, TriMR, GPMR, BiLQR, TriLQR, USYMLQR).
#   x0 : primal guess, length nx (same size as krylov_get_x)
#   y0 : dual guess,   length ny (same size as krylov_get_y)
# Returns 0 on success, -1 on error, -2 if the solver has a single solution.
# ---------------------------------------------------------------------------
@export_sig krylov_warm_start2 "int" (ws, "void*") (x0, "const void*") (y0, "const void*") (nx, "int") (ny, "int")

Base.@ccallable function krylov_warm_start2(
    ws_ptr :: Ptr{Cvoid},
    x0_ptr :: Ptr{Cvoid},
    y0_ptr :: Ptr{Cvoid},
    nx     :: Cint,
    ny     :: Cint,
) :: Cint
  try
    _do_warm_start2!(ws_ptr, x0_ptr, y0_ptr, nx, ny)
  catch e
    @error "krylov_warm_start2" exception=e
    Cint(-1)
  end
end

# ---------------------------------------------------------------------------
# krylov_workspace_free — releases the workspace (handle invalid after this)
# Returns 0 on success, 1 if handle was not found.
# ---------------------------------------------------------------------------
@export_sig krylov_workspace_free "int" (ws, "void*")

Base.@ccallable function krylov_workspace_free(ws_ptr :: Ptr{Cvoid}) :: Cint
  _do_free!(ws_ptr)
end

# ===========================================================================
# Block Krylov interface (block_gmres / block_minres)
#
# The right-hand side is an m×p block B and the solution an n×p block X, both
# column-major.  The operator is applied to a whole block via a KrylovBlockMatvec
# callback:  void(*)(const void *X, void *Y, int p, void *userdata).
# ===========================================================================

# ---------------------------------------------------------------------------
# krylov_block_workspace_create
#
#   solver : KrylovBlockSolverType (KRYLOV_BLOCK_GMRES, KRYLOV_BLOCK_MINRES)
#   m, n   : operator dimensions
#   p      : block size (number of right-hand sides / columns)
#   dtype  : KrylovDataType
#   device : KrylovDeviceType (KRYLOV_CPU)
#   wopts  : KrylovWorkspaceOptions (memory used by block_gmres), or NULL
#   ws_out : receives the workspace handle
#
# Returns 0 on success, -1 on error, -2 on unknown (solver, dtype) combination.
# ---------------------------------------------------------------------------
@export_sig krylov_block_workspace_create "int" (solver, "KrylovBlockSolverType") (m, "int") (n, "int") (p, "int") (dtype, "KrylovDataType") (device, "KrylovDeviceType") (wopts, "const KrylovWorkspaceOptions*") (ws_out, "void**")

Base.@ccallable function krylov_block_workspace_create(
    solver    :: Cint,
    m         :: Cint,
    n         :: Cint,
    p         :: Cint,
    dtype     :: Cint,
    device    :: Cint,
    wopts_ptr :: Ptr{Cvoid},
    ws_out    :: Ptr{Ptr{Cvoid}},
) :: Cint
  try
    wopts = wopts_ptr == C_NULL ? KrylovWorkspaceOptionsC(Cint(0), Cint(0)) :
                                  unsafe_load(Ptr{KrylovWorkspaceOptionsC}(wopts_ptr))
    _do_block_create!(solver, m, n, p, dtype, wopts, ws_out)
  catch e
    @error "krylov_block_workspace_create" exception=e
    Cint(-1)
  end
end

# ---------------------------------------------------------------------------
# krylov_block_solve
#
#   ws       : block workspace handle
#   matvec_A : KrylovBlockMatvec computing Y = A*X for a block of p columns
#   matvec_M : left preconditioner block matvec (Y = M⁻¹X), or NULL
#   matvec_N : right preconditioner block matvec (Y = N⁻¹X), or NULL
#              (only used by block_gmres; ignored by block_minres)
#   B        : right-hand side block, m×p column-major
#   userdata : forwarded to every callback
#   opts     : KrylovOptions (atol/rtol/itmax/verbose used), or NULL
# ---------------------------------------------------------------------------
@export_sig krylov_block_solve "int" (ws, "void*") (matvec_A, "KrylovBlockMatvec") (matvec_M, "KrylovBlockMatvec") (matvec_N, "KrylovBlockMatvec") (B, "const void*") (userdata, "void*") (opts, "const KrylovOptions*")

Base.@ccallable function krylov_block_solve(
    ws_ptr   :: Ptr{Cvoid},
    fptr_A   :: Ptr{Cvoid},
    fptr_M   :: Ptr{Cvoid},
    fptr_N   :: Ptr{Cvoid},
    B_ptr    :: Ptr{Cvoid},
    userdata :: Ptr{Cvoid},
    opts_ptr :: Ptr{Cvoid},
) :: Cint
  try
    _do_block_solve!(ws_ptr, fptr_A, fptr_M, fptr_N, B_ptr, userdata, opts_ptr)
  catch e
    @error "krylov_block_solve" exception=e
    Cint(-1)
  end
end

# ---------------------------------------------------------------------------
# krylov_block_get_X — copies the n×p solution block into a user buffer
# ---------------------------------------------------------------------------
@export_sig krylov_block_get_X "int" (ws, "void*") (X, "void*") (n, "int") (p, "int")

Base.@ccallable function krylov_block_get_X(
    ws_ptr :: Ptr{Cvoid},
    X_ptr  :: Ptr{Cvoid},
    n      :: Cint,
    p      :: Cint,
) :: Cint
  try
    _do_block_get_X!(ws_ptr, X_ptr, n, p)
  catch e
    @error "krylov_block_get_X" exception=e
    Cint(-1)
  end
end

# ---------------------------------------------------------------------------
# Block scalar statistics
# ---------------------------------------------------------------------------
@export_sig krylov_block_is_solved    "int"    (ws, "void*")
@export_sig krylov_block_niter        "int"    (ws, "void*")
@export_sig krylov_block_elapsed_time "double" (ws, "void*")

Base.@ccallable function krylov_block_is_solved(ws_ptr :: Ptr{Cvoid}) :: Cint
  _do_block_is_solved(ws_ptr)
end

Base.@ccallable function krylov_block_niter(ws_ptr :: Ptr{Cvoid}) :: Cint
  _do_block_niter(ws_ptr)
end

Base.@ccallable function krylov_block_elapsed_time(ws_ptr :: Ptr{Cvoid}) :: Cdouble
  _do_block_elapsed_time(ws_ptr)
end

# ---------------------------------------------------------------------------
# krylov_block_warm_start — initial guess (n×p block) for the next solve
# ---------------------------------------------------------------------------
@export_sig krylov_block_warm_start "int" (ws, "void*") (x0, "const void*") (n, "int") (p, "int")

Base.@ccallable function krylov_block_warm_start(
    ws_ptr :: Ptr{Cvoid},
    x0_ptr :: Ptr{Cvoid},
    n      :: Cint,
    p      :: Cint,
) :: Cint
  try
    _do_block_warm_start!(ws_ptr, x0_ptr, n, p)
  catch e
    @error "krylov_block_warm_start" exception=e
    Cint(-1)
  end
end

# ---------------------------------------------------------------------------
# krylov_block_workspace_free — releases a block workspace
# ---------------------------------------------------------------------------
@export_sig krylov_block_workspace_free "int" (ws, "void*")

Base.@ccallable function krylov_block_workspace_free(ws_ptr :: Ptr{Cvoid}) :: Cint
  _do_block_free!(ws_ptr)
end

end  # module LibKrylov

function test_krylov_workspaces(FC; krylov_constructor::Bool=false, use_val::Bool=true)
  A   = FC.(get_div_grad(4, 4, 4))  # Dimension n x n
  n   = size(A, 1)
  m   = div(n, 2)
  Au  = A[1:m,:]  # Dimension m x n
  Ao  = A[:,1:m]  # Dimension n x m
  b   = Ao * ones(FC, m) # Dimension n
  c   = Au * ones(FC, n) # Dimension m
  mem = 10
  shifts = [1.0; 2.0; 3.0; 4.0; 5.0]
  nshifts = 5
  T = real(FC)
  S = Vector{FC}

  workspaces = Dict{Symbol, KrylovWorkspace}()
  if use_val
    if krylov_constructor
      kc_nn = KrylovConstructor(b)
      kc_mn = KrylovConstructor(c, b)
      kc_nm = KrylovConstructor(b, c)
      workspaces[:cg] = @inferred krylov_workspace(Val(:cg), kc_nn)
      workspaces[:car] = @inferred krylov_workspace(Val(:car), kc_nn)
      workspaces[:symmlq] = @inferred krylov_workspace(Val(:symmlq), kc_nn)
      workspaces[:minres] = @inferred krylov_workspace(Val(:minres), kc_nn)
      workspaces[:minares] = @inferred krylov_workspace(Val(:minares), kc_nn)
      workspaces[:cg_lanczos] = @inferred krylov_workspace(Val(:cg_lanczos), kc_nn)
      workspaces[:diom] = @inferred krylov_workspace(Val(:diom), kc_nn; memory=mem)
      workspaces[:fom] = @inferred krylov_workspace(Val(:fom), kc_nn; memory=mem)
      workspaces[:dqgmres] = @inferred krylov_workspace(Val(:dqgmres), kc_nn; memory=mem)
      workspaces[:gmres] = @inferred krylov_workspace(Val(:gmres), kc_nn; memory=mem)
      workspaces[:gpmr] = @inferred krylov_workspace(Val(:gpmr), kc_nm; memory=mem)
      workspaces[:fgmres] = @inferred krylov_workspace(Val(:fgmres), kc_nn; memory=mem)
      workspaces[:cr] = @inferred krylov_workspace(Val(:cr), kc_nn)
      workspaces[:crmr] = @inferred krylov_workspace(Val(:crmr), kc_mn)
      workspaces[:cgs] = @inferred krylov_workspace(Val(:cgs), kc_nn)
      workspaces[:bicgstab] = @inferred krylov_workspace(Val(:bicgstab), kc_nn)
      workspaces[:craigmr] = @inferred krylov_workspace(Val(:craigmr), kc_mn)
      workspaces[:cgne] = @inferred krylov_workspace(Val(:cgne), kc_mn)
      workspaces[:lnlq] = @inferred krylov_workspace(Val(:lnlq), kc_mn)
      workspaces[:craig] = @inferred krylov_workspace(Val(:craig), kc_mn)
      workspaces[:lslq] = @inferred krylov_workspace(Val(:lslq), kc_nm)
      workspaces[:cgls] = @inferred krylov_workspace(Val(:cgls), kc_nm)
      workspaces[:lsqr] = @inferred krylov_workspace(Val(:lsqr), kc_nm)
      workspaces[:crls] = @inferred krylov_workspace(Val(:crls), kc_nm)
      workspaces[:lsmr] = @inferred krylov_workspace(Val(:lsmr), kc_nm)
      workspaces[:usymqr] = @inferred krylov_workspace(Val(:usymqr), kc_nm)
      workspaces[:trilqr] = @inferred krylov_workspace(Val(:trilqr), kc_nn)
      workspaces[:bilq] = @inferred krylov_workspace(Val(:bilq), kc_nn)
      workspaces[:bilqr] = @inferred krylov_workspace(Val(:bilqr), kc_nn)
      workspaces[:minres_qlp] = @inferred krylov_workspace(Val(:minres_qlp), kc_nn)
      workspaces[:qmr] = @inferred krylov_workspace(Val(:qmr), kc_nn)
      workspaces[:usymlq] = @inferred krylov_workspace(Val(:usymlq), kc_mn)
      workspaces[:tricg] = @inferred krylov_workspace(Val(:tricg), kc_mn)
      workspaces[:trimr] = @inferred krylov_workspace(Val(:trimr), kc_mn)
      workspaces[:usymlqr] = @inferred krylov_workspace(Val(:usymlqr), kc_mn)
      workspaces[:cg_lanczos_shift] = @inferred krylov_workspace(Val(:cg_lanczos_shift), kc_nn, nshifts)
      workspaces[:cgls_lanczos_shift] = @inferred krylov_workspace(Val(:cgls_lanczos_shift), kc_nm, nshifts)
    else
      workspaces[:cg] = @inferred krylov_workspace(Val(:cg), n, n, S)
      workspaces[:car] = @inferred krylov_workspace(Val(:car), n, n, S)
      workspaces[:symmlq] = @inferred krylov_workspace(Val(:symmlq), n, n, S)
      workspaces[:minres] = @inferred krylov_workspace(Val(:minres), n, n, S)
      workspaces[:minares] = @inferred krylov_workspace(Val(:minares), n, n, S)
      workspaces[:cg_lanczos] = @inferred krylov_workspace(Val(:cg_lanczos), n, n, S)
      workspaces[:diom] = @inferred krylov_workspace(Val(:diom), n, n, S; memory=mem)
      workspaces[:fom] = @inferred krylov_workspace(Val(:fom), n, n, S; memory=mem)
      workspaces[:dqgmres] = @inferred krylov_workspace(Val(:dqgmres), n, n, S; memory=mem)
      workspaces[:gmres] = @inferred krylov_workspace(Val(:gmres), n, n, S; memory=mem)
      workspaces[:gpmr] = @inferred krylov_workspace(Val(:gpmr), n, m, S; memory=mem)
      workspaces[:fgmres] = @inferred krylov_workspace(Val(:fgmres), n, n, S; memory=mem)
      workspaces[:cr] = @inferred krylov_workspace(Val(:cr), n, n, S)
      workspaces[:crmr] = @inferred krylov_workspace(Val(:crmr), m, n, S)
      workspaces[:cgs] = @inferred krylov_workspace(Val(:cgs), n, n, S)
      workspaces[:bicgstab] = @inferred krylov_workspace(Val(:bicgstab), n, n, S)
      workspaces[:craigmr] = @inferred krylov_workspace(Val(:craigmr), m, n, S)
      workspaces[:cgne] = @inferred krylov_workspace(Val(:cgne), m, n, S)
      workspaces[:lnlq] = @inferred krylov_workspace(Val(:lnlq), m, n, S)
      workspaces[:craig] = @inferred krylov_workspace(Val(:craig), m, n, S)
      workspaces[:lslq] = @inferred krylov_workspace(Val(:lslq), n, m, S)
      workspaces[:cgls] = @inferred krylov_workspace(Val(:cgls), n, m, S)
      workspaces[:lsqr] = @inferred krylov_workspace(Val(:lsqr), n, m, S)
      workspaces[:crls] = @inferred krylov_workspace(Val(:crls), n, m, S)
      workspaces[:lsmr] = @inferred krylov_workspace(Val(:lsmr), n, m, S)
      workspaces[:usymqr] = @inferred krylov_workspace(Val(:usymqr), n, m, S)
      workspaces[:trilqr] = @inferred krylov_workspace(Val(:trilqr), n, n, S)
      workspaces[:bilq] = @inferred krylov_workspace(Val(:bilq), n, n, S)
      workspaces[:bilqr] = @inferred krylov_workspace(Val(:bilqr), n, n, S)
      workspaces[:minres_qlp] = @inferred krylov_workspace(Val(:minres_qlp), n, n, S)
      workspaces[:qmr] = @inferred krylov_workspace(Val(:qmr), n, n, S)
      workspaces[:usymlq] = @inferred krylov_workspace(Val(:usymlq), m, n, S)
      workspaces[:tricg] = @inferred krylov_workspace(Val(:tricg), m, n, S)
      workspaces[:trimr] = @inferred krylov_workspace(Val(:trimr), m, n, S)
      workspaces[:usymlqr] = @inferred krylov_workspace(Val(:usymlqr), m, n, S)
      workspaces[:cg_lanczos_shift] = @inferred krylov_workspace(Val(:cg_lanczos_shift), n, n, nshifts, S)
      workspaces[:cgls_lanczos_shift] = @inferred krylov_workspace(Val(:cgls_lanczos_shift), n, m, nshifts, S)
    end
  else
    if krylov_constructor
      kc_nn = KrylovConstructor(b)
      kc_mn = KrylovConstructor(c, b)
      kc_nm = KrylovConstructor(b, c)
      workspaces[:cg] = krylov_workspace(:cg, kc_nn)
      workspaces[:car] = krylov_workspace(:car, kc_nn)
      workspaces[:symmlq] = krylov_workspace(:symmlq, kc_nn)
      workspaces[:minres] = krylov_workspace(:minres, kc_nn)
      workspaces[:minares] = krylov_workspace(:minares, kc_nn)
      workspaces[:cg_lanczos] = krylov_workspace(:cg_lanczos, kc_nn)
      workspaces[:diom] = krylov_workspace(:diom, kc_nn; memory=mem)
      workspaces[:fom] = krylov_workspace(:fom, kc_nn; memory=mem)
      workspaces[:dqgmres] = krylov_workspace(:dqgmres, kc_nn; memory=mem)
      workspaces[:gmres] = krylov_workspace(:gmres, kc_nn; memory=mem)
      workspaces[:gpmr] = krylov_workspace(:gpmr, kc_nm; memory=mem)
      workspaces[:fgmres] = krylov_workspace(:fgmres, kc_nn; memory=mem)
      workspaces[:cr] = krylov_workspace(:cr, kc_nn)
      workspaces[:crmr] = krylov_workspace(:crmr, kc_mn)
      workspaces[:cgs] = krylov_workspace(:cgs, kc_nn)
      workspaces[:bicgstab] = krylov_workspace(:bicgstab, kc_nn)
      workspaces[:craigmr] = krylov_workspace(:craigmr, kc_mn)
      workspaces[:cgne] = krylov_workspace(:cgne, kc_mn)
      workspaces[:lnlq] = krylov_workspace(:lnlq, kc_mn)
      workspaces[:craig] = krylov_workspace(:craig, kc_mn)
      workspaces[:lslq] = krylov_workspace(:lslq, kc_nm)
      workspaces[:cgls] = krylov_workspace(:cgls, kc_nm)
      workspaces[:lsqr] = krylov_workspace(:lsqr, kc_nm)
      workspaces[:crls] = krylov_workspace(:crls, kc_nm)
      workspaces[:lsmr] = krylov_workspace(:lsmr, kc_nm)
      workspaces[:usymqr] = krylov_workspace(:usymqr, kc_nm)
      workspaces[:trilqr] = krylov_workspace(:trilqr, kc_nn)
      workspaces[:bilq] = krylov_workspace(:bilq, kc_nn)
      workspaces[:bilqr] = krylov_workspace(:bilqr, kc_nn)
      workspaces[:minres_qlp] = krylov_workspace(:minres_qlp, kc_nn)
      workspaces[:qmr] = krylov_workspace(:qmr, kc_nn)
      workspaces[:usymlq] = krylov_workspace(:usymlq, kc_mn)
      workspaces[:tricg] = krylov_workspace(:tricg, kc_mn)
      workspaces[:trimr] = krylov_workspace(:trimr, kc_mn)
      workspaces[:usymlqr] = krylov_workspace(:usymlqr, kc_mn)
      workspaces[:cg_lanczos_shift] = krylov_workspace(:cg_lanczos_shift, kc_nn, nshifts)
      workspaces[:cgls_lanczos_shift] = krylov_workspace(:cgls_lanczos_shift, kc_nm, nshifts)
    else
      workspaces[:cg] = krylov_workspace(:cg, n, n, S)
      workspaces[:car] = krylov_workspace(:car, n, n, S)
      workspaces[:symmlq] = krylov_workspace(:symmlq, n, n, S)
      workspaces[:minres] = krylov_workspace(:minres, n, n, S)
      workspaces[:minares] = krylov_workspace(:minares, n, n, S)
      workspaces[:cg_lanczos] = krylov_workspace(:cg_lanczos, n, n, S)
      workspaces[:diom] = krylov_workspace(:diom, n, n, S; memory=mem)
      workspaces[:fom] = krylov_workspace(:fom, n, n, S; memory=mem)
      workspaces[:dqgmres] = krylov_workspace(:dqgmres, n, n, S; memory=mem)
      workspaces[:gmres] = krylov_workspace(:gmres, n, n, S; memory=mem)
      workspaces[:gpmr] = krylov_workspace(:gpmr, n, m, S; memory=mem)
      workspaces[:fgmres] = krylov_workspace(:fgmres, n, n, S; memory=mem)
      workspaces[:cr] = krylov_workspace(:cr, n, n, S)
      workspaces[:crmr] = krylov_workspace(:crmr, m, n, S)
      workspaces[:cgs] = krylov_workspace(:cgs, n, n, S)
      workspaces[:bicgstab] = krylov_workspace(:bicgstab, n, n, S)
      workspaces[:craigmr] = krylov_workspace(:craigmr, m, n, S)
      workspaces[:cgne] = krylov_workspace(:cgne, m, n, S)
      workspaces[:lnlq] = krylov_workspace(:lnlq, m, n, S)
      workspaces[:craig] = krylov_workspace(:craig, m, n, S)
      workspaces[:lslq] = krylov_workspace(:lslq, n, m, S)
      workspaces[:cgls] = krylov_workspace(:cgls, n, m, S)
      workspaces[:lsqr] = krylov_workspace(:lsqr, n, m, S)
      workspaces[:crls] = krylov_workspace(:crls, n, m, S)
      workspaces[:lsmr] = krylov_workspace(:lsmr, n, m, S)
      workspaces[:usymqr] = krylov_workspace(:usymqr, n, m, S)
      workspaces[:trilqr] = krylov_workspace(:trilqr, n, n, S)
      workspaces[:bilq] = krylov_workspace(:bilq, n, n, S)
      workspaces[:bilqr] = krylov_workspace(:bilqr, n, n, S)
      workspaces[:minres_qlp] = krylov_workspace(:minres_qlp, n, n, S)
      workspaces[:qmr] = krylov_workspace(:qmr, n, n, S)
      workspaces[:usymlq] = krylov_workspace(:usymlq, m, n, S)
      workspaces[:tricg] = krylov_workspace(:tricg, m, n, S)
      workspaces[:trimr] = krylov_workspace(:trimr, m, n, S)
      workspaces[:usymlqr] = krylov_workspace(:usymlqr, m, n, S)
      workspaces[:cg_lanczos_shift] = krylov_workspace(:cg_lanczos_shift, n, n, nshifts, S)
      workspaces[:cgls_lanczos_shift] = krylov_workspace(:cgls_lanczos_shift, n, m, nshifts, S)
    end
  end

  @testset "Code coverage workspaces" begin
    @inferred krylov_workspace(Val(:cg_lanczos_shift), A, b, nshifts)
    @inferred krylov_workspace(Val(:cgls_lanczos_shift), A, b, nshifts)
    @inferred krylov_workspace(Val(:cgls_lanczos_shift), m, n, nshifts, S, S)
    @inferred krylov_workspace(Val(:bilqr), A, b)
    for solver in (:lslq, :lsqr, :lsmr, :symmlq, :minres)
      @inferred krylov_workspace(Val(solver), A, b; window=10)
    end
    for solver in (:dqgmres, :gmres, :fgmres, :diom, :fom, :gpmr)
      @inferred krylov_workspace(Val(solver), A, b; memory=10)
    end
    @inferred krylov_workspace(Val(:gpmr), A, b, b; memory=10)
    @inferred krylov_workspace(Val(:gpmr), A, A', b, b; memory=10)
  end

  @testset "Check compatibility between each KrylovWorkspace and the dimension of the linear problem" begin
    A2  = FC.(get_div_grad(2, 2, 2))
    n2  = size(A2, 1)
    m2  = div(n2, 2)
    Au2 = A2[1:m2,:]
    Ao2 = A2[:,1:m2]
    b2  = Ao2 * ones(FC, m2)
    c2  = Au2 * ones(FC, n2)
    shifts2 = [1.0; 2.0; 3.0; 4.0; 5.0; 6.0]
    for (method, workspace) in workspaces
      if method ∈ (:cg, :cr, :car, :symmlq, :minares, :minres, :minres_qlp, :cg_lanczos, :diom, :fom, :dqgmres, :gmres, :fgmres, :cgs, :bicgstab, :bilq, :qmr)
        @test_throws ErrorException("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($n2, $n2)") krylov_solve!(workspace, A2, b2)
      end
      method == :cg_lanczos_shift && @test_throws ErrorException("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($n2, $n2)") krylov_solve!(workspace, A2, b2, shifts2)
      method == :cg_lanczos_shift && @test_throws ErrorException("workspace.nshifts = $(workspace.nshifts) is inconsistent with length(shifts) = $(length(shifts2))") krylov_solve!(workspace, A, b, shifts2)
      method ∈ (:cgne, :crmr, :lnlq, :craig, :craigmr) && @test_throws ErrorException("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m2, $n2)") krylov_solve!(workspace, Au2, c2)
      method ∈ (:cgls, :crls, :lslq, :lsqr, :lsmr) && @test_throws ErrorException("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($n2, $m2)") krylov_solve!(workspace, Ao2, b2)
      method == :cgls_lanczos_shift && @test_throws ErrorException("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($n2, $m2)") krylov_solve!(workspace, Ao2, b2, shifts2)
      method == :cgls_lanczos_shift && @test_throws ErrorException("workspace.nshifts = $(workspace.nshifts) is inconsistent with length(shifts) = $(length(shifts2))") krylov_solve!(workspace, Ao, b, shifts2)
      method ∈ (:bilqr, :trilqr) && @test_throws ErrorException("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($n2, $n2)") krylov_solve!(workspace, A2, b2, b2)
      method == :gpmr && @test_throws ErrorException("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($n2, $m2)") krylov_solve!(workspace, Ao2, Au2, b2, c2)
      method ∈ (:tricg, :trimr, :usymlqr) && @test_throws ErrorException("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($n2, $m2)") krylov_solve!(workspace, Ao2, b2, c2)
      method == :usymlq && @test_throws ErrorException("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m2, $n2)") krylov_solve!(workspace, Au2, c2, b2)
      method == :usymqr && @test_throws ErrorException("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($n2, $m2)") krylov_solve!(workspace, Ao2, b2, c2)
    end
  end

  @testset "Test the keyword argument timemax" begin
    timemax = 0.0
    for (method, workspace) in workspaces
      method ∈ (:cg, :cr, :car, :symmlq, :minares, :minres, :minres_qlp, :cg_lanczos, :diom, :fom, :dqgmres, :gmres, :fgmres, :cgs, :bicgstab, :bilq, :qmr) && krylov_solve!(workspace, A, b, timemax=timemax)
      method == :cg_lanczos_shift && krylov_solve!(workspace, A, b, shifts, timemax=timemax)
      method ∈ (:cgne, :crmr, :lnlq, :craig, :craigmr) && krylov_solve!(workspace, Au, c, timemax=timemax)
      method ∈ (:cgls, :crls, :lslq, :lsqr, :lsmr) && krylov_solve!(workspace, Ao, b, timemax=timemax)
      method == :cgls_lanczos_shift && krylov_solve!(workspace, Ao, b, shifts, timemax=timemax)
      method ∈ (:bilqr, :trilqr) && krylov_solve!(workspace, A, b, b, timemax=timemax)
      method == :gpmr && krylov_solve!(workspace, Ao, Au, b, c, timemax=timemax)
      method ∈ (:tricg, :trimr, :usymlqr) && krylov_solve!(workspace, Au, c, b, timemax=timemax)
      method == :usymlq && krylov_solve!(workspace, Au, c, b, timemax=timemax)
      method == :usymqr && krylov_solve!(workspace, Ao, b, c, timemax=timemax)
      @test workspace.stats.status == "time limit exceeded"
    end
  end

  for (method, workspace) in workspaces
    @testset "$(method)" begin
      for i = 1 : 3
        A  = i * A
        Au = i * Au
        Ao = i * Ao
        b  = 5 * b
        c  = 3 * c

        if method ∈ (:cg, :cr, :car, :symmlq, :minares, :minres, :minres_qlp, :cg_lanczos, :diom, :fom,
                     :dqgmres, :gmres, :fgmres, :cgs, :bicgstab, :bilq, :qmr, :cg_lanczos_shift)
          if method == :cg_lanczos_shift
            use_val ? @inferred(krylov_solve(Val(method), A, b, shifts)) : krylov_solve(method, A, b, shifts)
            @inferred krylov_solve!(workspace, A, b, shifts)
          else
            use_val ? @inferred(krylov_solve(Val(method), A, b)) : krylov_solve(method, A, b)
            @inferred krylov_solve!(workspace, A, b)
          end
          niter = iteration_count(workspace)
          @test Aprod_count(workspace) == (method ∈ (:cgs, :bicgstab) ? 2 * niter : niter)
          @test Atprod_count(workspace) == (method ∈ (:bilq, :qmr) ? niter : 0)
          @test solution(workspace) === workspace.x
          @test solution_count(workspace) == 1
        end

        if method ∈ (:cgne, :crmr, :lnlq, :craig, :craigmr)
          use_val ? @inferred(krylov_solve(Val(method), Au, c)) : krylov_solve(method, Au, c)
          @inferred krylov_solve!(workspace, Au, c)
          niter = iteration_count(workspace)
          @test Aprod_count(workspace) == niter
          @test Atprod_count(workspace) == niter
          @test solution(workspace, 1) === workspace.x
          @test solution_count(workspace) == (method ∈ (:cgne, :crmr) ? 1 : 2)
          (solution_count(workspace) == 2) && (@test solution(workspace, 2) == workspace.y)
        end

        if method ∈ (:cgls, :crls, :lslq, :lsqr, :lsmr, :cgls_lanczos_shift)
          if method == :cgls_lanczos_shift
            use_val ? @inferred(krylov_solve(Val(method), Ao, b, shifts)) : krylov_solve(method, Ao, b, shifts)
            @inferred krylov_solve!(workspace, Ao, b, shifts)
          else
            use_val ? @inferred(krylov_solve(Val(method), Ao, b)) : krylov_solve(method, Ao, b)
            @inferred krylov_solve!(workspace, Ao, b)
          end
          niter = iteration_count(workspace)
          @test Aprod_count(workspace) == niter
          @test Atprod_count(workspace) == niter
          @test solution(workspace) === workspace.x
          @test solution_count(workspace) == 1
        end

        if method ∈ (:bilqr, :trilqr)
          use_val ? @inferred(krylov_solve(Val(method), A, b, b)) : krylov_solve(method, A, b, b)
          @inferred krylov_solve!(workspace, A, b, b)
          niter = iteration_count(workspace)
          @test Aprod_count(workspace) == niter
          @test Atprod_count(workspace) == niter
          @test solution(workspace, 1) === workspace.x
          @test solution(workspace, 2) === workspace.y
          @test solution_count(workspace) == 2
          @test issolved_primal(workspace)
          @test issolved_dual(workspace)
        end

        if method ∈ (:tricg, :trimr, :usymlqr, :gpmr)
          if method == :gpmr
            use_val ? @inferred(krylov_solve(Val(method), Ao, Au, b, c)) : krylov_solve(method, Ao, Au, b, c)
            @inferred krylov_solve!(workspace, Ao, Au, b, c)
          else
            use_val ? @inferred(krylov_solve(Val(method), Au, c, b)) : krylov_solve(method, Au, c, b)
            @inferred krylov_solve!(workspace, Au, c, b)
          end
          niter = iteration_count(workspace)
          @test Aprod_count(workspace) == niter
          method != :gpmr && (@test Atprod_count(workspace) == niter)
          method == :gpmr && (@test Atprod_count(workspace) == 0)
          @test solution(workspace, 1) === workspace.x
          @test solution(workspace, 2) === workspace.y
          @test solution_count(workspace) == 2

          if method == :gpmr
            x, y, stats = use_val ? @inferred(krylov_solve(Val(method), Ao, Au, TestVector(b), c)) : krylov_solve(method, Ao, Au, TestVector(b), c)
            @test typeof(x) === typeof(TestVector(b))
          else
            x, y, stats = use_val ? @inferred(krylov_solve(Val(method), Au, TestVector(c), b)) : krylov_solve(method, Au, TestVector(c), b)
            @test typeof(x) === typeof(TestVector(c))
          end
        end

        if method ∈ (:usymlq, :usymqr)
          if method == :usymlq
            use_val ? @inferred(krylov_solve(Val(method), Au, c, b)) : krylov_solve(method, Au, c, b)
            @inferred krylov_solve!(workspace, Au, c, b)
          else
            use_val ? @inferred(krylov_solve(Val(method), Ao, b, c)) : krylov_solve(method, Ao, b, c)
            @inferred krylov_solve!(workspace, Ao, b, c)
          end
          niter = iteration_count(workspace)
          @test Aprod_count(workspace) == niter
          @test Atprod_count(workspace) == niter
          @test solution(workspace) === workspace.x
          @test solution_count(workspace) == 1
        end

        @test niter > 0
        @test statistics(workspace) === workspace.stats
        @test issolved(workspace)
        @test elapsed_allocation_time(workspace) > 0
        @test elapsed_time(workspace) > 0
      end

      test_show(workspace)
    end
  end
end

function test_block_krylov_workspaces(FC; use_val::Bool=true)
  A = FC.(get_div_grad(4, 4, 4))  # Dimension n x n
  m, n = size(A)
  p = 8
  B = rand(FC, m, p)
  mem = 4
  T = real(FC)
  SV = Vector{FC}
  SM = Matrix{FC}

  workspaces = Dict{Symbol, BlockKrylovWorkspace}()
  if use_val
    workspaces[:block_minres] = @inferred krylov_workspace(Val(:block_minres), m, n, p, SV, SM)
    workspaces[:block_gmres] = @inferred krylov_workspace(Val(:block_gmres), m, n, p, SV, SM; memory=mem)
  else
    workspaces[:block_minres] = krylov_workspace(:block_minres, m, n, p, SV, SM)
    workspaces[:block_gmres] = krylov_workspace(:block_gmres, m, n, p, SV, SM; memory=mem)
  end

  for (method, workspace) in workspaces
    @testset "$(method)" begin
      for i = 1 : 3
        B = 5 * B
        use_val ? @inferred(krylov_solve(Val(method), A, B)) : krylov_solve(method, A, B)
        @inferred krylov_solve!(workspace, A, B)
        niter = iteration_count(workspace)
        @test Aprod_count(workspace) == niter
        @test Atprod_count(workspace) == 0
        @test solution(workspace) === workspace.X
        @test solution_count(workspace) == 1
        @test niter > 0
        @test statistics(workspace) === workspace.stats
        @test issolved(workspace)
        @test elapsed_allocation_time(workspace) > 0
        @test elapsed_time(workspace) > 0
      end

      test_show(workspace)
    end
  end
end

function test_show(workspace)
  io = IOBuffer()
  show(io, workspace, show_stats=false)
  showed = String(take!(io))

  # Test that the lines have the same length
  str = split(showed, '\n', keepempty=false)
  len_row = length(str[1])
  @test mapreduce(x -> length(x) - mapreduce(y -> occursin(y, x), |, ["w̅","w̄","d̅"]) == len_row, &, str)

  # Test that the columns have the same length
  str2 = split(showed, ['│','┌','┬','┐','├','┼','┤','└','┴','┴','┘','\n'], keepempty=false)
  len_col1 = length(str2[1])
  len_col2 = length(str2[2])
  len_col3 = length(str2[3])
  @test mapreduce(x -> length(x) - mapreduce(y -> occursin(y, x), |, ["w̅","w̄","d̅"]) == len_col1, &, str2[1:3:end-2])
  @test mapreduce(x -> length(x) - mapreduce(y -> occursin(y, x), |, ["w̅","w̄","d̅"]) == len_col2, &, str2[2:3:end-1])
  @test mapreduce(x -> length(x) - mapreduce(y -> occursin(y, x), |, ["w̅","w̄","d̅"]) == len_col3, &, str2[3:3:end])

  # Code coverage
  show(io, workspace, show_stats=true)
end

@testset "Krylov solvers" begin
  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin
      for krylov_constructor in (false, true)
        for use_val in (false, true)
          test_krylov_workspaces(FC; krylov_constructor, use_val)
          test_krylov_workspaces(FC; krylov_constructor, use_val)
        end
      end
    end
  end
end

@testset "Block Krylov solvers" begin
  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin
      for use_val in (false, true)
        test_block_krylov_workspaces(FC; use_val)
      end
    end
  end
end

#!/usr/bin/env julia
# Generate interfaces/include/krylov.h from the function_sigs table in LibKrylov.jl
# and the SOLVERS table in generate_stores.jl (single source of truth).
# Usage:  julia interfaces/scripts/generate_header.jl

using Krylov

# Krylov.jl version this header is generated from (kept in sync with Project.toml;
# CI checks both krylov.h and krylov.f90 against it).
const _KV = pkgversion(Krylov)

include(joinpath(@__DIR__, "solver_table.jl"))
include(joinpath(@__DIR__, "..", "src", "LibKrylov.jl"))

# Grab the signature table that LibKrylov.jl populated inside its module
function_sigs = LibKrylov.function_sigs

# ---------------------------------------------------------------------------
# Per-function documentation, emitted as a C comment before each prototype.
# Keep these in sync with the doc comments in include/krylov.f90.
# ---------------------------------------------------------------------------
const FUNCTION_DOCS = Dict{String,String}(
  "krylov_workspace_create" =>
    "Create a workspace for `solver` on an m-by-n operator in precision `dtype`.\n" *
    "`device` is KRYLOV_CPU.  `wopts` may be NULL to use the defaults; the opaque\n" *
    "handle is written to *ws_out.\n" *
    "Returns 0 on success, -1 on error, -2 on an unknown (solver, dtype) pair.",
  "krylov_default_workspace_options" =>
    "Return a KrylovWorkspaceOptions with every field at its 0 \"use default\" sentinel.",
  "krylov_default_options" =>
    "Return a KrylovOptions with every field at its NaN/0 \"use default\" sentinel.",
  "krylov_get_version" =>
    "Write the Krylov.jl version of this library into *major, *minor, *patch\n" *
    "(the same values as the KRYLOV_VERSION_* macros).",
  "krylov_solve" =>
    "Solve the linear system with the workspace's solver.\n" *
    "  matvec_A  : computes y = A*x        (required)\n" *
    "  matvec_At : computes y = A^H x      (NULL unless the solver uses the adjoint,\n" *
    "                                       e.g. BiLQ, QMR, LSQR, LSMR, CGLS, CRAIG)\n" *
    "  matvec_M  : preconditioner (centered for symmetric solvers, left otherwise);\n" *
    "              must compute y = M^-1 x, i.e. solve M y = x  (NULL = none)\n" *
    "  matvec_N  : right preconditioner; must compute y = N^-1 x (solve N y = x).\n" *
    "              Used only by solvers that accept both sides (GMRES, FGMRES, FOM,\n" *
    "              DIOM, DQGMRES, BiCGSTAB, CGS, BiLQ, QMR); ignored otherwise.\n" *
    "              (NULL = no right preconditioner)\n" *
    "  b         : right-hand side, length m\n" *
    "  c         : second right-hand side, length n (NULL if not needed)\n" *
    "  userdata  : forwarded unchanged to every callback\n" *
    "  opts      : solve-time options, or NULL for the defaults\n" *
    "Returns 0 on success, -1 on error.",
  "krylov_get_x" =>
    "Copy the primal solution (length n) into `x`.  Returns 0, or -1 on error.",
  "krylov_get_y" =>
    "Copy the second (dual) solution into `y`, for the two-solution solvers\n" *
    "(TriCG, TriMR, USYMLQR, GPMR, BiLQR, TriLQR, CRAIG, CRAIGMR, LNLQ).\n" *
    "Its length is the dual-solution size: n for TriCG/TriMR/USYMLQR, m otherwise.\n" *
    "Returns 0, -1 on error, or -2 if the solver has a single solution.",
  "krylov_is_solved" =>
    "Return 1 if the last solve converged, 0 if it did not, or -1 on error.",
  "krylov_niter" =>
    "Return the number of iterations performed, or -1 on error.",
  "krylov_elapsed_time" =>
    "Return the solve time in seconds, or -1.0 on error.",
  "krylov_warm_start" =>
    "Set the initial guess (length n) for the next krylov_solve.\n" *
    "Returns 0, -1 on error, or -2 if the solver does not support warm starting.",
  "krylov_warm_start2" =>
    "Set both initial guesses for the next krylov_solve, for the two-solution\n" *
    "solvers (TriCG, TriMR, GPMR, BiLQR, TriLQR, USYMLQR).\n" *
    "  x0 : primal guess, length nx (same size as krylov_get_x)\n" *
    "  y0 : dual guess,   length ny (same size as krylov_get_y)\n" *
    "Returns 0, -1 on error, or -2 if the solver has a single solution.",
  "krylov_workspace_free" =>
    "Release the workspace; the handle must not be used afterwards.\n" *
    "Returns 0 on success, or 1 if the handle was not found.",
  "krylov_block_workspace_create" =>
    "Create a block workspace for `solver` (KRYLOV_BLOCK_GMRES / KRYLOV_BLOCK_MINRES)\n" *
    "with block size p (number of right-hand sides).  `wopts` may be NULL.\n" *
    "Returns 0 on success, -1 on error, -2 on an unknown (solver, dtype) pair.",
  "krylov_block_solve" =>
    "Solve A X = B for the m-by-p block B.\n" *
    "  matvec_A : computes Y = A*X for a block of p columns (required)\n" *
    "  matvec_M : preconditioner; must compute Y = M^-1 X (solve M Y = X).\n" *
    "             Left for block_gmres, centered for block_minres  (NULL = none)\n" *
    "  matvec_N : right preconditioner; must compute Y = N^-1 X (solve N Y = X).\n" *
    "             Used only by block_gmres; ignored by block_minres.\n" *
    "             (NULL = no right preconditioner)\n" *
    "  B        : right-hand side block, m*p, column-major\n" *
    "  opts     : solve-time options, or NULL for the defaults\n" *
    "Returns 0 on success, -1 on error.",
  "krylov_block_get_X" =>
    "Copy the n-by-p solution block (column-major) into `X`.  Returns 0, or -1 on error.",
  "krylov_block_is_solved" =>
    "Return 1 if the last block solve converged, 0 if it did not, or -1 on error.",
  "krylov_block_niter" =>
    "Return the number of iterations performed, or -1 on error.",
  "krylov_block_elapsed_time" =>
    "Return the block solve time in seconds, or -1.0 on error.",
  "krylov_block_warm_start" =>
    "Set the initial guess (n-by-p block) for the next block solve.\n" *
    "Returns 0, -1 on error, or -2 if the solver does not support warm starting.",
  "krylov_block_workspace_free" =>
    "Release the block workspace.  Returns 0, or 1 if the handle was not found.",
)

# Emit a C comment block (single line as /* ... */, multi-line as a /* * */ block).
function emit_doc(io, text)
  lines = split(text, '\n')
  if length(lines) == 1
    println(io, "/* $(lines[1]) */")
  else
    println(io, "/*")
    for l in lines
      println(io, isempty(l) ? " *" : " * $l")
    end
    println(io, " */")
  end
end

# ---------------------------------------------------------------------------
# Build KrylovSolverType enum entries from solver_table.jl (single source of truth)
# ---------------------------------------------------------------------------
solver_enum_entries = join(
  ["  $(enum_name) = $(si-1)" for (si, (_, _, enum_name)) in enumerate(SOLVERS)],
  ",\n"
)

block_solver_enum_entries = join(
  ["  $(enum_name) = $(si-1)" for (si, (_, _, enum_name)) in enumerate(BLOCK_SOLVERS)],
  ",\n"
)

# ---------------------------------------------------------------------------
# Write krylov.h
# ---------------------------------------------------------------------------
out_path = joinpath(@__DIR__, "..", "include", "krylov.h")
mkpath(dirname(out_path))

open(out_path, "w") do io
  println(io, """
#ifndef KRYLOV_H
#define KRYLOV_H

/* Version */
#define KRYLOV_VERSION_MAJOR $(_KV.major)
#define KRYLOV_VERSION_MINOR $(_KV.minor)
#define KRYLOV_VERSION_PATCH $(_KV.patch)

#ifdef __cplusplus
extern "C" {
#endif

/* -------------------------------------------------------------------------
 * libkrylov — C interface to Krylov.jl
 *
 * Typical use:
 *
 *   void *ws;
 *   krylov_workspace_create(KRYLOV_CG, n, n, KRYLOV_FLOAT64, KRYLOV_CPU, NULL, &ws);
 *
 *   KrylovOptions opts = krylov_default_options();
 *   opts.atol = 1e-10; opts.rtol = 1e-10;
 *   krylov_solve(ws, matvec_A, NULL, NULL, NULL, b, NULL, userdata, &opts);
 *
 *   krylov_get_x(ws, x, n);
 *   krylov_workspace_free(ws);
 *
 * Vectors (b, c, x, x0, and the callback buffers) are plain C arrays of the
 * element type selected by KrylovDataType: float, double, float _Complex or
 * double _Complex.  Full guide: https://jso.dev/Krylov.jl/dev/interfaces/overview/
 * ------------------------------------------------------------------------- */

/* -------------------------------------------------------------------------
 * Enumerators
 * ------------------------------------------------------------------------- */

typedef enum {
  KRYLOV_FLOAT32   = 0,
  KRYLOV_FLOAT64   = 1,
  KRYLOV_COMPLEX32 = 2,
  KRYLOV_COMPLEX64 = 3,
} KrylovDataType;

typedef enum {
  KRYLOV_CPU = 0,
} KrylovDeviceType;

typedef enum {
$(solver_enum_entries),
} KrylovSolverType;

typedef enum {
$(block_solver_enum_entries),
} KrylovBlockSolverType;

/* -------------------------------------------------------------------------
 * Callback types
 *
 * KrylovMatvec: computes y = A*x, y = A^H x, or applies the preconditioner
 *   y = M^-1 x (i.e. solves M y = x).
 *   x        : input vector  (read-only, length n)
 *   y        : output vector (write, length m)
 *   userdata : opaque pointer forwarded from krylov_solve
 *
 * KrylovBlockMatvec: block variant for block_gmres / block_minres.
 *   X        : input  block (read-only, n*p, column-major)
 *   Y        : output block (write,      m*p, column-major)
 *   p        : block size (number of columns)
 *   userdata : opaque pointer forwarded from krylov_block_solve
 * ------------------------------------------------------------------------- */

typedef void (*KrylovMatvec)(const void *x, void *y, void *userdata);
typedef void (*KrylovBlockMatvec)(const void *X, void *Y, int p, void *userdata);

/* -------------------------------------------------------------------------
 * API functions
 * ------------------------------------------------------------------------- */
""")

  # Option structs must appear before any function that references them.
  println(io, """
/* -------------------------------------------------------------------------
 * Workspace options (construction-time)
 *
 * Passed to krylov_workspace_create.  These control how the workspace is
 * allocated, so they belong to creation rather than to the solve call.
 * Initialise with krylov_default_workspace_options() before overriding.
 * Sentinel 0 means "use solver default".
 *
 * Fields ignored by a given solver are silently disregarded.
 * ------------------------------------------------------------------------- */

typedef struct {
  int memory;  /* 0 → 20  (GMRES / FGMRES / FOM / DIOM / DQGMRES / GPMR)      */
  int window;  /* 0 → 5   (MINRES / SYMMLQ / LSQR / LSMR / LSLQ)              */
} KrylovWorkspaceOptions;

/* -------------------------------------------------------------------------
 * Solver options (solve-time)
 *
 * Passed to krylov_solve.  Initialise with krylov_default_options() before
 * overriding individual fields.  Sentinel values mean "use solver default":
 *   NaN  for double fields  (atol, rtol, tau, nu, timemax)
 *   0    for int fields     (itmax, restart, reorthogonalization, linesearch)
 *   0.0  for lambda/radius  (off, which is the default)
 *
 * Fields ignored by a given solver are silently disregarded.
 * ------------------------------------------------------------------------- */

typedef struct {
  double atol;                /* NaN → sqrt(eps(T)) per precision                              */
  double rtol;                /* NaN → sqrt(eps(T)) per precision                              */
  int    itmax;               /* 0   → solver default                                          */
  int    verbose;             /* 0   = silent                                                  */
  double lambda;              /* 0.0 = no regularisation/shift (LSQR/LSMR/CGLS/MINRES/...)     */
  double tau;                 /* NaN → solver default (TriCG / TriMR : 1.0)                    */
  double nu;                  /* NaN → solver default (TriCG / TriMR : -1.0)                   */
  double timemax;             /* NaN → Inf (no time limit), seconds; every solver             */
  double radius;              /* 0.0 = no trust region (CG/CR/CGLS/CRLS/LSQR/LSMR)             */
  int    restart;             /* 0/1 restart GMRES(k)/FGMRES/FOM/block_gmres (uses memory)     */
  int    reorthogonalization; /* 0/1 reorthogonalize basis (GMRES family, GPMR, block_gmres)   */
  int    linesearch;          /* 0/1 detect negative curvature (CG/CR/MINRES/MINRES-QLP)       */
} KrylovOptions;
""")

  block_section_emitted = false
  for (name, ret, args) in function_sigs
    if startswith(name, "krylov_block_") && !block_section_emitted
      println(io)
      println(io, "/* -------------------------------------------------------------------------")
      println(io, " * Block Krylov interface (block_gmres / block_minres)")
      println(io, " *")
      println(io, " * The right-hand side B and the solution X are m-by-p / n-by-p blocks,")
      println(io, " * stored column-major.  Otherwise the workflow matches the single-vector")
      println(io, " * interface above (create -> solve -> get_X -> free).")
      println(io, " * ------------------------------------------------------------------------- */")
      println(io)
      block_section_emitted = true
    end
    haskey(FUNCTION_DOCS, name) && emit_doc(io, FUNCTION_DOCS[name])
    arg_str = isempty(args) ? "void" : join(["$(ctype) $(aname)" for (aname, ctype) in args], ", ")
    println(io, "$ret $name($arg_str);")
    println(io)
  end

  println(io, """

#ifdef __cplusplus
}
#endif

#endif /* KRYLOV_H */""")
end

println("Generated $out_path")

# A truncated version of Stiefel’s Conjugate Residual method described in
#
# M. R. Hestenes and E. Stiefel, Methods of conjugate gradients for solving linear systems.
# Journal of Research of the National Bureau of Standards, 49(6), pp. 409--436, 1952.
#
# E. Stiefel, Relaxationsmethoden bester Strategie zur Losung linearer Gleichungssysteme.
# Commentarii Mathematici Helvetici, 29(1), pp. 157--179, 1955.
#
# D. G. Luenberger, The conjugate residual method for constrained minimization problems.
# SIAM Journal on Numerical Analysis, 7(3), pp. 390--398, 1970.
#
# M-A. Dahito and D. Orban, The Conjugate Residual Method in Linesearch and Trust-Region Methods.
# SIAM Journal on Optimization, 29(3), pp. 1988--2025, 2019.
#
# Marie-Ange Dahito, <marie-ange.dahito@polymtl.ca>
# Montreal, QC, June 2017

export cr, cr!

"""
    (x, stats) = cr(A, b::AbstractVector{FC};
                    M=I, ldiv::Bool=false, radius::T=zero(T),
                    linesearch::Bool=false, γ::T=√eps(T),
                    atol::T=√eps(T), rtol::T=√eps(T), itmax::Int=0,
                    timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                    callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = cr(A, b, x0::AbstractVector; kwargs...)

CR can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above.

A truncated version of Stiefel’s Conjugate Residual method to solve the Hermitian linear system Ax = b
of size n or the least-squares problem min ‖b - Ax‖ if A is singular.
The matrix A must be Hermitian semi-definite.
M also indicates the weighted norm in which residuals are measured.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :cr`.

For an in-place variant that reuses memory across solves, see [`cr!`](@ref).

#### Input arguments

* `A`: a linear operator that models a Hermitian positive definite matrix of dimension `n`;
* `b`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning;
* `ldiv`: define whether the preconditioner uses `ldiv!` or `mul!`;
* `radius`: add the trust-region constraint ‖x‖ ≤ `radius` if `radius > 0`. Useful to compute a step in a trust-region method for optimization; If `radius > 0` and nonpositive curvature is detected, the behavior depends on the iteration and follow similar logic as linesearch;
* `linesearch`: if `true` and nonpositive curvature is detected, the behavior depends on the iteration:
 – at iteration k = 0, return the preconditioned initial search direction in `workspace.npc_dir`;
 – at iteration k > 0,
   - if the residual from iteration k-1 is a nonpositive curvature direction but `workspace.p`, the search direction at iteration k, is not, the residual is stored in `stats.npc_dir` and `stats.npcCount` is set to 1;
   - if `workspace.p` is a nonpositive curvature direction but the residual is not, `workspace.p` is copied into `stats.npc_dir` and `stats.npcCount` is set to 1;
   - if both are nonpositive curvature directions, the residual is stored in `stats.npc_dir` and `stats.npcCount` is set to 2.
* `γ`: tolerance to determine that the curvature of the quadratic model is nonpositive;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### References

* M. R. Hestenes and E. Stiefel, [*Methods of conjugate gradients for solving linear systems*](https://doi.org/10.6028/jres.049.044), Journal of Research of the National Bureau of Standards, 49(6), pp. 409--436, 1952.
* E. Stiefel, [*Relaxationsmethoden bester Strategie zur Losung linearer Gleichungssysteme*](https://doi.org/10.1007/BF02564277), Commentarii Mathematici Helvetici, 29(1), pp. 157--179, 1955.
* D. G. Luenberger, [*The conjugate residual method for constrained minimization problems*](https://doi.org/10.1137/0707032), SIAM Journal on Numerical Analysis, 7(3), pp. 390--398, 1970.
* M-A. Dahito and D. Orban, [*The Conjugate Residual Method in Linesearch and Trust-Region Methods*](https://doi.org/10.1137/18M1204255), SIAM Journal on Optimization, 29(3), pp. 1988--2025, 2019.
"""
function cr end

"""
    workspace = cr!(workspace::CrWorkspace, A, b; kwargs...)
    workspace = cr!(workspace::CrWorkspace, A, b, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`cr`](@ref).

See [`CrWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :cr` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function cr! end

def_args_cr = (:(A                    ),
               :(b::AbstractVector{FC}))

def_optargs_cr = (:(x0::AbstractVector),)

def_kwargs_cr = (:(; M = I                        ),
                 :(; ldiv::Bool = false           ),
                 :(; radius::T = zero(T)          ),
                 :(; linesearch::Bool = false     ),
                 :(; γ::T = √eps(T)               ),
                 :(; atol::T = √eps(T)            ),
                 :(; rtol::T = √eps(T)            ),
                 :(; itmax::Int = 0               ),
                 :(; timemax::Float64 = Inf       ),
                 :(; verbose::Int = 0             ),
                 :(; history::Bool = false        ),
                 :(; callback = workspace -> false),
                 :(; iostream::IO = kstdout       ))

def_kwargs_cr = extract_parameters.(def_kwargs_cr)

args_cr = (:A, :b)
optargs_cr = (:x0,)
kwargs_cr = (:M, :ldiv, :radius, :linesearch, :γ, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function cr!(workspace :: CrWorkspace{T,FC,S}, $(def_args_cr...); $(def_kwargs_cr...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("System must be square")
    length(b) == n || error("Inconsistent problem size")
    linesearch && (radius > 0) && error("'linesearch' set to 'true' but radius > 0")
    (verbose > 0) && @printf(iostream, "CR: system of %d equations in %d variables\n", n, n)
    (workspace.warm_start && linesearch) && error("warm_start and linesearch cannot be used together")

    # Tests M = Iₙ
    MisI = (M === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")

    # Set up workspace
    allocate_if(!MisI, workspace, :Mq, S, workspace.x)  # The length of Mq is n
    allocate_if(linesearch || (radius > 0), workspace, :npc_dir , S, workspace.x)  # The length of npc_dir is n
    Δx, x, r, p, q, Ar, stats = workspace.Δx, workspace.x, workspace.r, workspace.p, workspace.q, workspace.Ar, workspace.stats
    warm_start = workspace.warm_start
    rNorms, ArNorms = stats.residuals, stats.Aresiduals
    reset!(stats)
    Mq = MisI ? q : workspace.Mq
    if linesearch || (radius > 0)
      npc_dir = workspace.npc_dir
    end

    # Initial state.
    kfill!(x, zero(FC))
    if warm_start
      kmul!(p, A, Δx)
      kaxpby!(n, one(FC), b, -one(FC), p)
    else
      kcopy!(n, p, b)  # p ← b
    end
    MisI && kcopy!(n, r, p)  # r ← p
    MisI || mulorldiv!(r, M, p, ldiv)
    
    rNorm = knorm_elliptic(n, r, p)  # ‖r‖
    history && push!(rNorms, rNorm)  # Values of ‖r‖

    if rNorm == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      history && push!(ArNorms, zero(T))
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    kmul!(Ar, A, r)
    ρ = kdotr(n, r, Ar)
    
    if ρ == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "b is a zero-curvature direction"
      history && push!(ArNorms, zero(T))
      workspace.warm_start = false
      if linesearch || (radius > 0)
        kcopy!(n, x, p)  # x ← M⁻¹ b
        kcopy!(n, npc_dir, p)
        stats.npcCount = 1
        stats.indefinite = true
      end
      return workspace
    end

    kcopy!(n, p, r)   # p ← r
    kcopy!(n, q, Ar)  # q ← Ar
    (verbose > 0) && (m = zero(T))  # quadratic model

    iter = 0
    itmax == 0 && (itmax = 2 * n)

    rNorm² = rNorm * rNorm
    pNorm = rNorm
    pNorm² = rNorm²
    pr = rNorm²
    abspr = pr
    pAp = ρ
    abspAp = abs(pAp)
    xNorm = zero(T)
    ArNorm = knorm(n, Ar) # ‖Ar‖
    history && push!(ArNorms, ArNorm)
    ε = atol + rtol * rNorm
    (verbose > 0) && @printf(iostream, "%5s  %8s  %8s  %8s  %5s\n", "k", "‖x‖", "‖r‖", "quad", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %8.1e  %8.1e  %8.1e  %.2fs\n", iter, xNorm, rNorm, m, start_time |> ktimer)

    descent = pr > 0 # pᴴr > 0 means p is a descent direction
    solved = rNorm ≤ ε
    tired = iter ≥ itmax
    on_boundary = false
    npcurv = false
    status = "unknown"
    user_requested_exit = false
    overtimed = false

    while ! (solved || tired || user_requested_exit || overtimed)
      if linesearch
        p_curv = pAp ≤ γ * pNorm^2
        r_curv = ρ   ≤ γ * rNorm^2
        if p_curv || r_curv
          npcurv = true
          (verbose > 0) && @printf(iostream, "nonpositive curvature detected: pᴴAp = %8.1e and rᴴAr = %8.1e\n", pAp, ρ)
          stats.solved = true
          stats.niter = iter
          stats.inconsistent = false
          stats.timer = start_time |> ktimer
          stats.status = "nonpositive curvature"
          workspace.warm_start = false
          stats.indefinite = true
          if iter == 0
            kcopy!(n, npc_dir, p)
            kcopy!(n, x, p)  # x ← M⁻¹ b
            stats.npcCount = 1
          else
            if r_curv
              kcopy!(n, npc_dir, r)
              stats.npcCount += 1
            end
            if p_curv
              stats.npcCount += 1
              r_curv || kcopy!(n, npc_dir, p)
            end
          end
          return workspace
        end
      elseif pAp ≤ 0 && radius == 0
        error("Indefinite system and no trust region")
      end
      MisI || mulorldiv!(Mq, M, q, ldiv)

      if radius > 0
        (verbose > 0) && @printf(iostream, "radius = %8.1e > 0 and ‖x‖ = %8.1e\n", radius, xNorm)
        # find t1 > 0 and t2 < 0 such that ‖x + ti * p‖² = radius²  (i = 1, 2)
        xNorm² = xNorm * xNorm
        t = to_boundary(n, x, p, Mq, radius; flip = false, xNorm2 = xNorm², dNorm2 = pNorm²)
        t1 = maximum(t) # > 0
        t2 = minimum(t) # < 0
        tr = maximum(to_boundary(n, x, r, Mq, radius; flip = false, xNorm2 = xNorm², dNorm2 = rNorm²))
        (verbose > 0) && @printf(iostream, "t1 = %8.1e, t2 = %8.1e and tr = %8.1e\n", t1, t2, tr)

        if abspAp ≤ γ * pNorm * knorm(n, q)  # pᴴAp ≃ 0
          npcurv = true  # nonpositive curvature
          stats.indefinite = true
          stats.npcCount = 1
          kcopy!(n, npc_dir, p)
          (verbose > 0) && @printf(iostream, "pᴴAp = %8.1e ≃ 0\n", pAp)
          if abspr ≤ γ * pNorm * rNorm  # pᴴr ≃ 0
            (verbose > 0) && @printf(iostream, "pᴴr = %8.1e ≃ 0, redefining p := r\n", pr)
            p = r  # - ∇q(x)
            q = Ar
            # q(x + αr) = q(x) - α ‖r‖² + ½ α² rᴴAr
            # 1) if rᴴAr > 0, the quadratic decreases from α = 0 to α = ‖r‖² / rᴴAr
            # 2) if rᴴAr ≤ 0, the quadratic decreases to -∞ in the direction r
            if ρ > 0 # case 1
              (verbose > 0) && @printf(iostream, "quadratic is convex in direction r, curv = %8.1e\n", ρ)
              α = min(tr, rNorm² / ρ)
            else # case 2
              (verbose > 0) && @printf(iostream, "r is a direction of nonpositive curvature: %8.1e\n", ρ)
              α = tr
              if iter > 0
                stats.npcCount = 2
                kcopy!(n, npc_dir, r)
              end
            end
          else
            # q_p = q(x + α_p * p) - q(x) = -α_p * rᴴp + ½ (α_p)² * pᴴAp
            # q_r = q(x + α_r * r) - q(x) = -α_r * ‖r‖² + ½ (α_r)² * rᴴAr
            # Δ = q_p - q_r. If Δ > 0, r is followed, else p is followed
            α = descent ? t1 : t2
            ρ > 0 && (tr = min(tr, rNorm² / ρ))
            Δ = -α * pr + tr * rNorm² - (tr)^2 * ρ / 2 # as pᴴAp = 0
            if Δ > 0  # direction r engenders a better decrease
              (verbose > 0) && @printf(iostream, "direction r engenders a bigger decrease. q_p - q_r = %8.1e > 0\n", Δ)
              (verbose > 0) && @printf(iostream, "redefining p := r\n")
              p = r
              q = Ar
              α = tr
            else
              (verbose > 0) && @printf(iostream, "direction p engenders an equal or a bigger decrease. q_p - q_r = %8.1e ≤ 0\n", Δ)
            end
          end

        elseif pAp > 0 && ρ > 0  # no negative curvature
          (verbose > 0) && @printf(iostream, "positive curvature along p and r. pᴴAp = %8.1e and rᴴAr = %8.1e\n", pAp, ρ)
          α = ρ / kdotr(n, q, Mq)
          if α ≥ t1
            α = t1
            on_boundary = true
          end

        elseif pAp > 0 && ρ < 0
          npcurv = true
          stats.indefinite = true
          stats.npcCount = 1
          kcopy!(n, npc_dir, r)
          (verbose > 0) && @printf(iostream, "pᴴAp = %8.1e > 0 and rᴴAr = %8.1e < 0\n", pAp, ρ)
          # q_p is minimal for α_p = rᴴp / pᴴAp
          α = descent ?  min(t1, pr / pAp) : max(t2, pr / pAp)
          Δ = -α * pr + tr * rNorm² + (α^2 * pAp - (tr)^2 * ρ) / 2
          if Δ > 0
            (verbose > 0) && @printf(iostream, "direction r engenders a bigger decrease. q_p - q_r = %8.1e > 0\n", Δ)
            (verbose > 0) && @printf(iostream, "redefining p := r\n")
            p = r
            q = Ar
            α = tr
          else
            (verbose > 0) && @printf(iostream, "direction p engenders an equal or a bigger decrease. q_p - q_r = %8.1e ≤ 0\n", Δ)
          end

        elseif pAp < 0 && ρ > 0
          npcurv = true
          stats.indefinite = true
          stats.npcCount = 1
          kcopy!(n, npc_dir, p)
          (verbose > 0) && @printf(iostream, "pᴴAp = %8.1e < 0 and rᴴAr = %8.1e > 0\n", pAp, ρ)
          α = descent ? t1 : t2
          tr = min(tr, rNorm² / ρ)
          Δ = -α * pr + tr * rNorm² + (α^2 * pAp - (tr)^2 * ρ) / 2
          if Δ > 0
            (verbose > 0) && @printf(iostream, "direction r engenders a bigger decrease. q_p - q_r = %8.1e > 0\n", Δ)
            (verbose > 0) && @printf(iostream, "redefining p := r\n")
            p = r
            q = Ar
            α = tr
          else
            (verbose > 0) && @printf(iostream, "direction p engenders an equal or a bigger decrease. q_p - q_r = %8.1e ≤ 0\n", Δ)
          end

        elseif pAp < 0 && ρ < 0
          npcurv = true
          stats.indefinite = true
          stats.npcCount = 2
          kcopy!(n, npc_dir, r)
          (verbose > 0) && @printf(iostream, "negative curvature along p and r. pᴴAp = %8.1e and rᴴAr = %8.1e\n", pAp, ρ)
          α = descent ? t1 : t2
          Δ = -α * pr + tr * rNorm² + (α^2 * pAp - (tr)^2 * ρ) / 2
          if Δ > 0
            (verbose > 0) && @printf(iostream, "direction r engenders a bigger decrease. q_p - q_r = %8.1e > 0\n", Δ)
            (verbose > 0) && @printf(iostream, "redefining p := r\n")
            p = r
            q = Ar
            α = tr
          else
            (verbose > 0) && @printf(iostream, "direction p engenders an equal or a bigger decrease. q_p - q_r = %8.1e ≤ 0\n", Δ)
          end
        end

      elseif radius == 0
        α = ρ / kdotr(n, q, Mq)  # step
      end

      kaxpy!(n, α, p, x)
      xNorm = knorm(n, x)
      xNorm ≈ radius > 0 && (on_boundary = true)
      kaxpy!(n, -α, Mq, r)  # residual
      if MisI
        rNorm² = kdotr(n, r, r)
        rNorm = sqrt(rNorm²)
      else
        ω = sqrt(α) * sqrt(ρ)
        rNorm = sqrt(abs(rNorm + ω)) * sqrt(abs(rNorm - ω))
        rNorm² = rNorm * rNorm  # rNorm² = rNorm² - α * ρ
      end
      history && push!(rNorms, rNorm)
      kmul!(Ar, A, r)
      ArNorm = knorm(n, Ar)
      history && push!(ArNorms, ArNorm)

      iter = iter + 1
      if kdisplay(iter, verbose)
        m = m - α * pr + α^2 * pAp / 2
        @printf(iostream, "%5d  %8.1e  %8.1e  %8.1e  %.2fs\n", iter, xNorm, rNorm, m, start_time |> ktimer)
      end

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      resid_decrease_mach = (rNorm + one(T) ≤ one(T))

      user_requested_exit = callback(workspace) :: Bool
      resid_decrease_lim = rNorm ≤ ε
      resid_decrease = resid_decrease_lim || resid_decrease_mach
      solved = resid_decrease || npcurv || on_boundary
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns

      (solved || tired || user_requested_exit || overtimed) && continue
      ρbar = ρ
      ρ = kdotr(n, r, Ar)
      β = ρ / ρbar # step for the direction computation
      kaxpby!(n, one(FC), r, β, p)
      kaxpby!(n, one(FC), Ar, β, q)

      pNorm² = rNorm² + 2 * β * pr - 2 * β * α * pAp + β^2 * pNorm²
      if pNorm² > sqrt(eps(T))
        pNorm = sqrt(pNorm²)
      elseif abs(pNorm²) ≤ sqrt(eps(T))
        pNorm = zero(T)
      else
        stats.niter = iter
        stats.solved = solved
        stats.inconsistent = false
        stats.timer = start_time |> ktimer
        stats.status = "solver encountered numerical issues"
        warm_start && kaxpy!(n, one(FC), Δx, x)
        workspace.warm_start = false
        return workspace
      end
      pr = rNorm² + β * pr - β * α * pAp  # pᴴr
      abspr = abs(pr)
      pAp = ρ + β^2 * pAp  # pᴴq
      abspAp = abs(pAp)
      descent = pr > 0

    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    solved              && (status = "solution good enough given atol and rtol")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")
    npcurv              && (status = "nonpositive curvature")
    on_boundary         && (status = "on trust-region boundary")

    # Update x
    warm_start && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = false
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

# An implementation of GMRES for the solution of the square linear system Ax = b.
#
# This method is described in
#
# Y. Saad and M. H. Schultz, GMRES: A Generalized Minimal Residual Algorithm for Solving Nonsymmetric Linear Systems.
# SIAM Journal on Scientific and Statistical Computing, Vol. 7(3), pp. 856--869, 1986.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Montreal, December 2018.

export gmres, gmres!

"""
    (x, stats) = gmres(A, b::AbstractVector{FC};
                       memory::Int=20, M=I, N=I, ldiv::Bool=false,
                       restart::Bool=false, reorthogonalization::Bool=false,
                       atol::T=√eps(T), rtol::T=√eps(T), itmax::Int=0,
                       timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                       callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = gmres(A, b, x0::AbstractVector; kwargs...)

GMRES can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above.

Solve the linear system Ax = b of size n using GMRES.

GMRES algorithm is based on the Arnoldi process and computes a sequence of approximate solutions with the minimum residual.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :gmres`.

For an in-place variant that reuses memory across solves, see [`gmres!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `n`;
* `b`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `memory`: if `restart = true`, the restarted version GMRES(k) is used with `k = memory`. If `restart = false`, the parameter `memory` should be used as a hint of the number of iterations to limit dynamic memory allocations. Additional storage will be allocated if the number of iterations exceeds `memory`;
* `M`: linear operator that models a nonsingular matrix of size `n` used for left preconditioning;
* `N`: linear operator that models a nonsingular matrix of size `n` used for right preconditioning;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `restart`: restart the method after `memory` iterations;
* `reorthogonalization`: reorthogonalize the new vectors of the Krylov basis against all previous vectors;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### Reference

* Y. Saad and M. H. Schultz, [*GMRES: A Generalized Minimal Residual Algorithm for Solving Nonsymmetric Linear Systems*](https://doi.org/10.1137/0907058), SIAM Journal on Scientific and Statistical Computing, Vol. 7(3), pp. 856--869, 1986.
"""
function gmres end

"""
    workspace = gmres!(workspace::GmresWorkspace, A, b; kwargs...)
    workspace = gmres!(workspace::GmresWorkspace, A, b, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`gmres`](@ref).
The keyword argument `memory` is the only exception.
It is only supported by [`gmres`](@ref) and is required to create a `GmresWorkspace`.
It cannot be changed later.

See [`GmresWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :gmres` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function gmres! end

def_args_gmres = (:(A                    ),
                  :(b::AbstractVector{FC}))

def_optargs_gmres = (:(x0::AbstractVector),)

def_kwargs_gmres = (:(; M = I                            ),
                    :(; N = I                            ),
                    :(; ldiv::Bool = false               ),
                    :(; restart::Bool = false            ),
                    :(; reorthogonalization::Bool = false),
                    :(; atol::T = √eps(T)                ),
                    :(; rtol::T = √eps(T)                ),
                    :(; itmax::Int = 0                   ),
                    :(; timemax::Float64 = Inf           ),
                    :(; verbose::Int = 0                 ),
                    :(; history::Bool = false            ),
                    :(; callback = workspace -> false    ),
                    :(; iostream::IO = kstdout           ))

def_kwargs_workspace_gmres = (:(; memory::Int = 20),)

def_kwargs_gmres = extract_parameters.(def_kwargs_gmres)
def_kwargs_workspace_gmres = extract_parameters.(def_kwargs_workspace_gmres)

args_gmres = (:A, :b)
optargs_gmres = (:x0,)
kwargs_gmres = (:M, :N, :ldiv, :restart, :reorthogonalization, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)
kwargs_workspace_gmres = (:memory,)

@eval begin
  function gmres!(workspace :: GmresWorkspace{T,FC,S}, $(def_args_gmres...); $(def_kwargs_gmres...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("System must be square")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "GMRES: system of size %d\n", n)

    # Check M = Iₙ and N = Iₙ
    MisI = (M === I)
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")

    # Set up workspace.
    allocate_if(!MisI  , workspace, :q , S, workspace.x)  # The length of q is n
    allocate_if(!NisI  , workspace, :p , S, workspace.x)  # The length of p is n
    allocate_if(restart, workspace, :Δx, S, workspace.x)  # The length of Δx is n
    Δx, x, w, V, z = workspace.Δx, workspace.x, workspace.w, workspace.V, workspace.z
    c, s, R, stats = workspace.c, workspace.s, workspace.R, workspace.stats
    warm_start = workspace.warm_start
    rNorms = stats.residuals
    reset!(stats)
    q  = MisI ? w : workspace.q
    r₀ = MisI ? w : workspace.q
    xr = restart ? Δx : x

    # Initial solution x₀.
    kfill!(x, zero(FC))

    # Initial residual r₀.
    if warm_start
      kmul!(w, A, Δx)
      kaxpby!(n, one(FC), b, -one(FC), w)
      restart && kaxpy!(n, one(FC), Δx, x)
    else
      kcopy!(n, w, b)  # w ← b
    end
    MisI || mulorldiv!(r₀, M, w, ldiv)  # r₀ = M(b - Ax₀)
    β = knorm(n, r₀)                    # β = ‖r₀‖₂

    rNorm = β
    history && push!(rNorms, β)
    ε = atol + rtol * rNorm

    if β == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    mem = length(c)  # Memory
    npass = 0        # Number of pass

    iter = 0        # Cumulative number of iterations
    inner_iter = 0  # Number of iterations in a pass

    itmax == 0 && (itmax = 2*n)
    inner_itmax = itmax

    (verbose > 0) && @printf(iostream, "%5s  %5s  %7s  %7s  %5s\n", "pass", "k", "‖rₖ‖", "hₖ₊₁.ₖ", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %5d  %7.1e  %7s  %.2fs\n", npass, iter, rNorm, "✗ ✗ ✗ ✗", start_time |> ktimer)

    # Tolerance for breakdown detection.
    btol = eps(T)^(3/4)

    # Stopping criterion
    breakdown = false
    inconsistent = false
    solved = rNorm ≤ ε
    tired = iter ≥ itmax
    inner_tired = inner_iter ≥ inner_itmax
    status = "unknown"
    user_requested_exit = false
    overtimed = false

    while !(solved || tired || breakdown || user_requested_exit || overtimed)

      # Initialize workspace.
      nr = 0  # Number of coefficients stored in Rₖ.
      for i = 1 : mem
        kfill!(V[i], zero(FC))  # Orthogonal basis of Kₖ(MAN, Mr₀).
      end
      kfill!(s, zero(FC))  # Givens sines used for the factorization QₖRₖ = Hₖ₊₁.ₖ.
      kfill!(c, zero(T))   # Givens cosines used for the factorization QₖRₖ = Hₖ₊₁.ₖ.
      kfill!(R, zero(FC))  # Upper triangular matrix Rₖ.
      kfill!(z, zero(FC))  # Right-hand of the least squares problem min ‖Hₖ₊₁.ₖyₖ - βe₁‖₂.

      if restart
        kfill!(xr, zero(FC))  # xr === Δx when restart is set to true
        if npass ≥ 1
          kmul!(w, A, x)
          kaxpby!(n, one(FC), b, -one(FC), w)
          MisI || mulorldiv!(r₀, M, w, ldiv)
        end
      end

      # Initial ζ₁ and v₁
      β = knorm(n, r₀)
      z[1] = β
      kdivcopy!(n, V[1], r₀, rNorm)  # v₁ = r₀ / ‖r₀‖

      npass = npass + 1
      workspace.inner_iter = 0
      inner_tired = false

      while !(solved || inner_tired || breakdown || user_requested_exit || overtimed)

        # Update iteration index
        workspace.inner_iter = workspace.inner_iter + 1
        inner_iter = workspace.inner_iter

        # Update workspace if more storage is required and restart is set to false
        if !restart && (inner_iter > mem)
          start_allocation_time = time_ns()
          for i = 1 : inner_iter
            push!(R, zero(FC))
          end
          push!(s, zero(FC))
          push!(c, zero(T))
          stats.allocation_timer += start_allocation_time |> ktimer
        end

        # Continue the Arnoldi process.
        p = NisI ? V[inner_iter] : workspace.p
        NisI || mulorldiv!(p, N, V[inner_iter], ldiv)  # p ← Nvₖ
        kmul!(w, A, p)                                 # w ← ANvₖ
        MisI || mulorldiv!(q, M, w, ldiv)              # q ← MANvₖ
        for i = 1 : inner_iter
          R[nr+i] = kdot(n, V[i], q)    # hᵢₖ = (vᵢ)ᴴq
          kaxpy!(n, -R[nr+i], V[i], q)  # q ← q - hᵢₖvᵢ
        end

        # Reorthogonalization of the Krylov basis.
        if reorthogonalization
          for i = 1 : inner_iter
            Htmp = kdot(n, V[i], q)
            R[nr+i] += Htmp
            kaxpy!(n, -Htmp, V[i], q)
          end
        end

        # Compute hₖ₊₁.ₖ
        Hbis = knorm(n, q)  # hₖ₊₁.ₖ = ‖vₖ₊₁‖₂

        # Update the QR factorization of Hₖ₊₁.ₖ.
        # Apply previous Givens reflections Ωᵢ.
        # [cᵢ  sᵢ] [ r̄ᵢ.ₖ ] = [ rᵢ.ₖ ]
        # [s̄ᵢ -cᵢ] [rᵢ₊₁.ₖ]   [r̄ᵢ₊₁.ₖ]
        for i = 1 : inner_iter-1
          Rtmp      =      c[i]  * R[nr+i] + s[i] * R[nr+i+1]
          R[nr+i+1] = conj(s[i]) * R[nr+i] - c[i] * R[nr+i+1]
          R[nr+i]   = Rtmp
        end

        # Compute and apply current Givens reflection Ωₖ.
        # [cₖ  sₖ] [ r̄ₖ.ₖ ] = [rₖ.ₖ]
        # [s̄ₖ -cₖ] [hₖ₊₁.ₖ]   [ 0  ]
        (c[inner_iter], s[inner_iter], R[nr+inner_iter]) = sym_givens(R[nr+inner_iter], Hbis)

        # Update zₖ = (Qₖ)ᴴβe₁
        ζₖ₊₁          = conj(s[inner_iter]) * z[inner_iter]
        z[inner_iter] =      c[inner_iter]  * z[inner_iter]

        # Update residual norm estimate.
        # ‖ M(b - Axₖ) ‖₂ = |ζₖ₊₁|
        rNorm = abs(ζₖ₊₁)
        history && push!(rNorms, rNorm)

        # Update the number of coefficients in Rₖ
        nr = nr + inner_iter

        # Stopping conditions that do not depend on user input.
        # This is to guard against tolerances that are unreasonably small.
        resid_decrease_mach = (rNorm + one(T) ≤ one(T))
        
        # Update stopping criterion.
        user_requested_exit = callback(workspace) :: Bool
        resid_decrease_lim = rNorm ≤ ε
        breakdown = Hbis ≤ btol
        solved = resid_decrease_lim || resid_decrease_mach
        inner_tired = restart ? inner_iter ≥ min(mem, inner_itmax) : inner_iter ≥ inner_itmax
        timer = time_ns() - start_time
        overtimed = timer > timemax_ns
        kdisplay(iter+inner_iter, verbose) && @printf(iostream, "%5d  %5d  %7.1e  %7.1e  %.2fs\n", npass, iter+inner_iter, rNorm, Hbis, start_time |> ktimer)

        # Compute vₖ₊₁.
        if !(solved || inner_tired || breakdown || user_requested_exit || overtimed)
          if !restart && (inner_iter ≥ mem)
            start_allocation_time = time_ns()
            push!(V, similar(workspace.x))
            push!(z, zero(FC))
            stats.allocation_timer += start_allocation_time |> ktimer
          end
          kdivcopy!(n, V[inner_iter+1], q, Hbis)  # vₖ₊₁ = q / hₖ₊₁.ₖ
          z[inner_iter+1] = ζₖ₊₁
        end
      end

      # Compute yₖ by solving Rₖyₖ = zₖ with backward substitution.
      y = z  # yᵢ = zᵢ
      for i = inner_iter : -1 : 1
        pos = nr + i - inner_iter      # position of rᵢ.ₖ
        for j = inner_iter : -1 : i+1
          y[i] = y[i] - R[pos] * y[j]  # yᵢ ← yᵢ - rᵢⱼyⱼ
          pos = pos - j + 1            # position of rᵢ.ⱼ₋₁
        end
        # Rₖ can be singular if the system is inconsistent
        if abs(R[pos]) ≤ btol
          y[i] = zero(FC)
          inconsistent = true
        else
          y[i] = y[i] / R[pos]  # yᵢ ← yᵢ / rᵢᵢ
        end
      end

      # Form xₖ = NVₖyₖ
      for i = 1 : inner_iter
        kaxpy!(n, y[i], V[i], xr)
      end
      if !NisI
        kcopy!(n, workspace.p, xr)  # p ← xr
        mulorldiv!(xr, N, workspace.p, ldiv)
      end
      restart && kaxpy!(n, one(FC), xr, x)

      # Update inner_itmax, iter, tired and overtimed variables.
      inner_itmax = inner_itmax - inner_iter
      iter = iter + inner_iter
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    solved              && (status = "solution good enough given atol and rtol")
    inconsistent        && (status = "found approximate least-squares solution")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update x
    warm_start && !restart && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = inconsistent
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

using BenchmarkTools
using LinearAlgebra, SparseArrays, Krylov
using MatrixMarket, SuiteSparseMatrixCollection

krylov_problem = joinpath(dirname(pathof(Krylov)), "..", "test", "get_div_grad.jl")
include(krylov_problem)

ssmc = ssmc_db()
ufl_posdef = ssmc[(ssmc.numerical_symmetry .== 1) .& (ssmc.positive_definite .== true) .& (ssmc.real .== true) .& (ssmc.binary .== false) .& (ssmc.nrows .≤ 500), :]
paths = fetch_ssmc(ufl_posdef, format="MM")

const SUITE = BenchmarkGroup()

SUITE["DivGrad"] = BenchmarkGroup()
for N in [32, 64, 128]
  A = get_div_grad(N, N, N)
  n, m = size(A)
  b = ones(n)
  rtol = 1.0e-8
  SUITE["DivGrad"]["DivGrad N=$N"] = @benchmarkable cg($A, $b, atol=0.0, rtol=$rtol, itmax=$n)
end

SUITE["UFL"] = BenchmarkGroup()
for path in paths
  name = split(path, '/')[end]
  A = MatrixMarket.mmread(path * "/$name.mtx")
  n, m = size(A)
  if eltype(A) == Float64
    b = ones(n)
    rtol = 1.0e-8
    SUITE["UFL"][name] = @benchmarkable cg($A, $b, atol=0.0, rtol=$rtol, itmax=$n)
  end
end

@testset "lslq" begin
  lslq_tol = 1.0e-5

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      for npower = 1 : 4
        (b, A, D, HY, HZ, Acond, rnorm) = test(40, 40, 4, npower, 0)  # No regularization.

        (x, stats) = lslq(A, b)
        r = b - A * x
        resid = norm(A' * r) / norm(b)
        @test(resid ≤ lslq_tol)
        @test(stats.solved)

        λ = 1.0e-3
        (x, stats) = lslq(A, b, λ=λ)
        r = b - A * x
        resid = norm(A' * r - λ * λ * x) / norm(b)
        @test(resid ≤ lslq_tol)
        @test(stats.solved)
      end

      # Test error in upper bound computation
      (x, stats) = lslq(A, b, σ=1.0)
      @test stats.error_with_bnd

      # Test b == 0
      A, b = zero_rhs(FC=FC)
      (x, stats) = lslq(A, b)
      @test norm(x) == 0
      @test stats.status == "x is a zero-residual solution"

      for transfer_to_lsqr ∈ (false, true)
        # Test with smallest singular value estimate
        Σ = diagm(0 => 1:4)
        U, _ = qr(rand(6, 6))
        V, _ = qr(rand(4, 4))
        A = U * [Σ ; zeros(2, 4)] * V'
        b = ones(6)
        (x, stats) = lslq(A, b, σ=1.0 - 1.0e-10, history=true, transfer_to_lsqr=transfer_to_lsqr)
        @test isapprox(stats.err_ubnds_lq[end], 0.0, atol=sqrt(eps(Float64)))
        @test isapprox(stats.err_ubnds_cg[end], 0.0, atol=sqrt(eps(Float64)))
        x_exact = A \ b
        @test norm(x - x_exact) ≤ sqrt(eps(Float64)) * norm(x_exact)

        # Test with preconditioners
        A, b, M, N = two_preconditioners(FC=FC)
        (x_lq, stats) = lslq(A, b, M=M, N=N, transfer_to_lsqr=transfer_to_lsqr)
        r = b - A * x_lq
        resid = sqrt(real(dot(r, M * r))) / norm(b)
        @test(resid ≤ lslq_tol)
        @test(stats.solved)

        # Test regularization
        A, b, λ = regularization(FC=FC)
        (x_lq, stats) = lslq(A, b, λ=λ, transfer_to_lsqr=transfer_to_lsqr)
        r = b - A * x_lq
        resid = norm(A' * r - λ^2 * x_lq) / norm(b)
        @test(resid ≤ lslq_tol)

        # Test saddle-point systems
        A, b, D = saddle_point(FC=FC)
        D⁻¹ = inv(D)
        (x_lq, stats) = lslq(A, b, M=D⁻¹, transfer_to_lsqr=transfer_to_lsqr)
        r = D⁻¹ * (b - A * x_lq)
        resid = norm(A' * r) / norm(b)
        @test(resid ≤ lslq_tol)

        # Test symmetric and quasi-definite systems
        A, b, M, N = sqd(FC=FC)
        M⁻¹ = inv(M)
        N⁻¹ = inv(N)
        (x_lq, stats) = lslq(A, b, M=M⁻¹, N=N⁻¹, sqd=true, transfer_to_lsqr=transfer_to_lsqr)
        r = M⁻¹ * (b - A * x_lq)
        resid = norm(A' * r - N * x_lq) / norm(b)
        @test(resid ≤ lslq_tol)

        λ = 4.0
        (x_lq, stats) = lslq(A, b, M=M⁻¹, N=N⁻¹, λ=λ, transfer_to_lsqr=transfer_to_lsqr)
        r = M⁻¹ * (b - A * x_lq)
        resid = norm(A' * r - λ^2 * N * x_lq) / norm(b)
        @test(resid ≤ lslq_tol)

        # Test dimension of additional vectors
        for transpose ∈ (false, true)
          A, b, c, D = small_sp(transpose, FC=FC)
          D⁻¹ = inv(D)
          (x_lq, stats) = lslq(A, b, M=D⁻¹, transfer_to_lsqr=transfer_to_lsqr)

          A, b, c, M, N = small_sqd(transpose, FC=FC)
          M⁻¹ = inv(M)
          N⁻¹ = inv(N)
          (x_lq, stats) = lslq(A, b, M=M⁻¹, N=N⁻¹, sqd=true, transfer_to_lsqr=transfer_to_lsqr)
        end

        # Test different types for input and output
        A, b, c, D = small_sp(false, FC=FC)
        workspace = LslqWorkspace(KrylovConstructor(TestVector(b), c))
        lslq!(workspace, A, TestVector(b), M=inv(D), λ=1.0)
        @test typeof(workspace.x) === typeof(c)
        workspace = LslqWorkspace(KrylovConstructor(b, TestVector(c)))
        lslq!(workspace, A, b, M=inv(D), λ=1.0)
        @test typeof(workspace.x) === typeof(TestVector(c))

        # test callback function
        A, b, M = saddle_point(FC=FC)
        M⁻¹ = inv(M)
        workspace = LslqWorkspace(A, b)
        tol = 1.0e-1
        cb_n2 = TestCallbackN2LS(A, b, zero(eltype(b)), tol = tol)
        lslq!(workspace, A, b, M=M⁻¹, callback = cb_n2)
        @test workspace.stats.status == "user-requested exit"
        @test cb_n2(workspace)

        @test_throws TypeError lslq(A, b, M=M⁻¹, callback = workspace -> "string", history = true)
      end
    end
  end
end

# test_libkrylov.jl — validates the C interface logic by loading LibKrylov.jl as a
# regular Julia module and calling its @ccallable functions directly.
#
# This avoids loading the juliac-compiled libkrylov.so from within a Julia
# process (which would trigger a second Julia runtime via ijl_adopt_thread
# and crash immediately).
#
# The compiled libkrylov.so is validated separately by the C and Fortran tests
# (test_all_solvers.c / test_all_solvers.f90) which load it from a native
# C/Fortran process with no prior Julia runtime.
#
# Usage (from the Krylov.jl root):
#   julia --startup-file=no --project=. interfaces/test/test_libkrylov.jl

using Test
using LinearAlgebra
using Random
using Krylov

const RNG = MersenneTwister(42)

# ============================================================================
# Load LibKrylov as a plain Julia module (no dlopen)
# ============================================================================

# Load the LibKrylov module sources directly (no dlopen, no juliac-compiled lib)
include(joinpath(@__DIR__, "..", "src", "LibKrylov.jl"))
using .LibKrylov

# Include the solver table to get the SOLVERS list
include(joinpath(@__DIR__, "..", "scripts", "solver_table.jl"))

# Bring the @ccallable entry points into scope as plain Julia functions
const krylov_workspace_create  = LibKrylov.krylov_workspace_create
const krylov_workspace_free    = LibKrylov.krylov_workspace_free
const krylov_default_options   = LibKrylov.krylov_default_options
const krylov_solve             = LibKrylov.krylov_solve
const krylov_get_x             = LibKrylov.krylov_get_x
const krylov_get_y             = LibKrylov.krylov_get_y
const krylov_warm_start        = LibKrylov.krylov_warm_start
const krylov_warm_start2       = LibKrylov.krylov_warm_start2
const krylov_get_version       = LibKrylov.krylov_get_version
const krylov_is_solved         = LibKrylov.krylov_is_solved
const krylov_niter             = LibKrylov.krylov_niter

# ============================================================================
# Enums (must match krylov.h / solver_table.jl)
# ============================================================================

# KrylovDataType
const KRYLOV_FLOAT32   = Cint(0)
const KRYLOV_FLOAT64   = Cint(1)
const KRYLOV_COMPLEX32 = Cint(2)
const KRYLOV_COMPLEX64 = Cint(3)

# KrylovDeviceType
const KRYLOV_CPU = Cint(0)

# KrylovSolverType — derived from solver_table.jl (single source of truth)
for (si, (cname, _, enum_name)) in enumerate(SOLVERS)
    @eval const $(Symbol(enum_name)) = Cint($(si - 1))
end

# KrylovBlockSolverType — derived from BLOCK_SOLVERS (solver_table.jl)
for (si, (cname, _, enum_name)) in enumerate(BLOCK_SOLVERS)
    @eval const $(Symbol(enum_name)) = Cint($(si - 1))
end

dtype_enum(::Type{Float32})    = KRYLOV_FLOAT32
dtype_enum(::Type{Float64})    = KRYLOV_FLOAT64
dtype_enum(::Type{ComplexF32}) = KRYLOV_COMPLEX32
dtype_enum(::Type{ComplexF64}) = KRYLOV_COMPLEX64

solver_enum(name::String) = begin
    idx = findfirst(t -> t[1] == name, SOLVERS)
    idx === nothing && error("unknown solver: $name")
    Cint(idx - 1)
end

# ============================================================================
# Thin wrappers that mirror the old ccall-based API
# ============================================================================

function c_workspace_create(solver::Cint, m::Int, n::Int, dtype::Cint)
    ws = Ref{Ptr{Cvoid}}(C_NULL)
    ret = GC.@preserve ws begin
        krylov_workspace_create(solver, Cint(m), Cint(n), dtype, KRYLOV_CPU,
                                C_NULL,   # workspace options (defaults)
                                Base.unsafe_convert(Ptr{Ptr{Cvoid}}, ws))
    end
    ret == 0 || error("workspace_create(solver=$solver, dtype=$dtype) returned $ret")
    ws[]
end

function c_workspace_free(ws::Ptr{Cvoid})
    krylov_workspace_free(ws)
end

function c_solve(ws::Ptr{Cvoid}, cb_A::Ptr{Cvoid}, cb_At::Ptr{Cvoid},
                 b::Vector; c::Union{Vector,Nothing}=nothing,
                 atol=1e-8, rtol=1e-8, itmax=0, verbose=0)
    opts = Ref(LibKrylov.KrylovOptionsC(atol, rtol, Cint(itmax), Cint(verbose),
                                        0.0, NaN, NaN, NaN, 0.0, Cint(0), Cint(0), Cint(0)))
    GC.@preserve b opts begin
        b_ptr    = Base.unsafe_convert(Ptr{Cvoid}, pointer(b))
        opts_ptr = Base.unsafe_convert(Ptr{Cvoid}, opts)
        if c !== nothing
            GC.@preserve c begin
                c_ptr = Base.unsafe_convert(Ptr{Cvoid}, pointer(c))
                ret = krylov_solve(ws, cb_A, cb_At, C_NULL, C_NULL, b_ptr, c_ptr, C_NULL, opts_ptr)
            end
        else
            ret = krylov_solve(ws, cb_A, cb_At, C_NULL, C_NULL, b_ptr, C_NULL, C_NULL, opts_ptr)
        end
    end
    ret == 0 || error("krylov_solve returned $ret")
end

function c_get_x(ws::Ptr{Cvoid}, ::Type{T}, n::Int) where T
    x = Vector{T}(undef, n)
    GC.@preserve x begin
        ret = krylov_get_x(ws, Base.unsafe_convert(Ptr{Cvoid}, pointer(x)), Cint(n))
        ret == 0 || error("get_x returned $ret")
    end
    x
end

function c_get_y(ws::Ptr{Cvoid}, ::Type{T}, m::Int) where T
    y = Vector{T}(undef, m)
    GC.@preserve y begin
        ret = krylov_get_y(ws, Base.unsafe_convert(Ptr{Cvoid}, pointer(y)), Cint(m))
        ret == 0 || error("get_y returned $ret")
    end
    y
end

function c_warm_start(ws::Ptr{Cvoid}, x0::Vector)
    GC.@preserve x0 begin
        ret = krylov_warm_start(ws, Base.unsafe_convert(Ptr{Cvoid}, pointer(x0)), Cint(length(x0)))
        ret == 0 || error("warm_start returned $ret")
    end
end

function c_warm_start2(ws::Ptr{Cvoid}, x0::Vector, y0::Vector)
    GC.@preserve x0 y0 begin
        krylov_warm_start2(ws,
            Base.unsafe_convert(Ptr{Cvoid}, pointer(x0)),
            Base.unsafe_convert(Ptr{Cvoid}, pointer(y0)),
            Cint(length(x0)), Cint(length(y0)))
    end
end

# Solve with explicit left (M) and/or right (N) preconditioner callbacks.
function c_solve_mn(ws::Ptr{Cvoid}, cb_A::Ptr{Cvoid}, cb_M::Ptr{Cvoid}, cb_N::Ptr{Cvoid},
                    b::Vector; atol=1e-8, rtol=1e-8)
    opts = Ref(LibKrylov.KrylovOptionsC(atol, rtol, Cint(0), Cint(0), 0.0, NaN, NaN, NaN, 0.0, Cint(0), Cint(0), Cint(0)))
    GC.@preserve b opts begin
        b_ptr    = Base.unsafe_convert(Ptr{Cvoid}, pointer(b))
        opts_ptr = Base.unsafe_convert(Ptr{Cvoid}, opts)
        ret = krylov_solve(ws, cb_A, C_NULL, cb_M, cb_N, b_ptr, C_NULL, C_NULL, opts_ptr)
    end
    ret == 0 || error("krylov_solve (M/N) returned $ret")
end

# Solve with arbitrary KrylovOptions fields (covers the optional scalar options).
function solve_with(ws::Ptr{Cvoid}, cb_A::Ptr{Cvoid}, b::Vector;
                    cb_At::Ptr{Cvoid}=C_NULL, cb_M::Ptr{Cvoid}=C_NULL, cb_N::Ptr{Cvoid}=C_NULL,
                    atol=1e-10, rtol=1e-10, itmax=0, lambda=0.0, radius=0.0,
                    timemax=NaN, restart=0, reorth=0, linesearch=0)
    opts = Ref(LibKrylov.KrylovOptionsC(atol, rtol, Cint(itmax), Cint(0), lambda, NaN, NaN,
                                        timemax, radius, Cint(restart), Cint(reorth), Cint(linesearch)))
    GC.@preserve b opts begin
        krylov_solve(ws, cb_A, cb_At, cb_M, cb_N,
                     Base.unsafe_convert(Ptr{Cvoid}, pointer(b)), C_NULL, C_NULL,
                     Base.unsafe_convert(Ptr{Cvoid}, opts))
    end
end

c_is_solved(ws::Ptr{Cvoid}) = krylov_is_solved(ws) == Cint(1)
c_niter(ws::Ptr{Cvoid})     = Int(krylov_niter(ws))

# ============================================================================
# Matvec callbacks — one @cfunction per precision, matrix set via global refs
# ============================================================================

# Global matrix refs (one pair per precision — not thread-safe, fine for tests)
const _A_f32  = Ref{Matrix{Float32}}()
const _At_f32 = Ref{Matrix{Float32}}()
const _A_f64  = Ref{Matrix{Float64}}()
const _At_f64 = Ref{Matrix{Float64}}()
const _A_c32  = Ref{Matrix{ComplexF32}}()
const _At_c32 = Ref{Matrix{ComplexF32}}()
const _A_c64  = Ref{Matrix{ComplexF64}}()
const _At_c64 = Ref{Matrix{ComplexF64}}()

function _cb!(xp::Ptr{Cvoid}, yp::Ptr{Cvoid}, A::Matrix{T}) where T
    m, n = size(A)
    x = unsafe_wrap(Vector{T}, Ptr{T}(xp), n)
    y = unsafe_wrap(Vector{T}, Ptr{T}(yp), m)
    mul!(y, A, x)
    nothing
end

_mv_A_f32(xp::Ptr{Cvoid},  yp::Ptr{Cvoid}, ud::Ptr{Cvoid}) = (_cb!(xp, yp, _A_f32[]);  nothing)
_mv_At_f32(xp::Ptr{Cvoid}, yp::Ptr{Cvoid}, ud::Ptr{Cvoid}) = (_cb!(xp, yp, _At_f32[]); nothing)
_mv_A_f64(xp::Ptr{Cvoid},  yp::Ptr{Cvoid}, ud::Ptr{Cvoid}) = (_cb!(xp, yp, _A_f64[]);  nothing)
_mv_At_f64(xp::Ptr{Cvoid}, yp::Ptr{Cvoid}, ud::Ptr{Cvoid}) = (_cb!(xp, yp, _At_f64[]); nothing)
_mv_A_c32(xp::Ptr{Cvoid},  yp::Ptr{Cvoid}, ud::Ptr{Cvoid}) = (_cb!(xp, yp, _A_c32[]);  nothing)
_mv_At_c32(xp::Ptr{Cvoid}, yp::Ptr{Cvoid}, ud::Ptr{Cvoid}) = (_cb!(xp, yp, _At_c32[]); nothing)
_mv_A_c64(xp::Ptr{Cvoid},  yp::Ptr{Cvoid}, ud::Ptr{Cvoid}) = (_cb!(xp, yp, _A_c64[]);  nothing)
_mv_At_c64(xp::Ptr{Cvoid}, yp::Ptr{Cvoid}, ud::Ptr{Cvoid}) = (_cb!(xp, yp, _At_c64[]); nothing)

const CB_A_F32  = @cfunction(_mv_A_f32,  Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}))
const CB_At_F32 = @cfunction(_mv_At_f32, Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}))
const CB_A_F64  = @cfunction(_mv_A_f64,  Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}))
const CB_At_F64 = @cfunction(_mv_At_f64, Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}))
const CB_A_C32  = @cfunction(_mv_A_c32,  Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}))
const CB_At_C32 = @cfunction(_mv_At_c32, Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}))
const CB_A_C64  = @cfunction(_mv_A_c64,  Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}))
const CB_At_C64 = @cfunction(_mv_At_c64, Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}))

set_matrices!(::Type{Float32},    A, At) = (_A_f32[]  = A; _At_f32[]  = At)
set_matrices!(::Type{Float64},    A, At) = (_A_f64[]  = A; _At_f64[]  = At)
set_matrices!(::Type{ComplexF32}, A, At) = (_A_c32[]  = A; _At_c32[]  = At)
set_matrices!(::Type{ComplexF64}, A, At) = (_A_c64[]  = A; _At_c64[]  = At)

get_callbacks(::Type{Float32})    = (CB_A_F32,  CB_At_F32)
get_callbacks(::Type{Float64})    = (CB_A_F64,  CB_At_F64)
get_callbacks(::Type{ComplexF32}) = (CB_A_C32,  CB_At_C32)
get_callbacks(::Type{ComplexF64}) = (CB_A_C64,  CB_At_C64)

# Block matvec callback (Float64) — Y = A * X for an n×p block
const _BA_f64 = Ref{Matrix{Float64}}()
function _block_mv_f64(Xp::Ptr{Cvoid}, Yp::Ptr{Cvoid}, p::Cint, ud::Ptr{Cvoid})
    A = _BA_f64[]
    m, n = size(A)
    X = unsafe_wrap(Matrix{Float64}, Ptr{Float64}(Xp), (n, Int(p)))
    Y = unsafe_wrap(Matrix{Float64}, Ptr{Float64}(Yp), (m, Int(p)))
    mul!(Y, A, X)
    nothing
end
const BCB_A_F64 = @cfunction(_block_mv_f64, Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Cint, Ptr{Cvoid}))

# Diagonal (Jacobi) preconditioner callback (Float64): y = M⁻¹ x = x ./ diag.
const _Minv_f64 = Ref{Vector{Float64}}()
function _precond_f64(xp::Ptr{Cvoid}, yp::Ptr{Cvoid}, ud::Ptr{Cvoid})
    d = _Minv_f64[]
    x = unsafe_wrap(Vector{Float64}, Ptr{Float64}(xp), length(d))
    y = unsafe_wrap(Vector{Float64}, Ptr{Float64}(yp), length(d))
    @. y = x / d
    nothing
end
const CB_M_F64 = @cfunction(_precond_f64, Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}))

# Second diagonal preconditioner callback (independent buffer) so a solve can use
# a left (M) and a right (N) preconditioner of different sizes at once.
const _Ninv_f64 = Ref{Vector{Float64}}()
function _precond_n_f64(xp::Ptr{Cvoid}, yp::Ptr{Cvoid}, ud::Ptr{Cvoid})
    d = _Ninv_f64[]
    x = unsafe_wrap(Vector{Float64}, Ptr{Float64}(xp), length(d))
    y = unsafe_wrap(Vector{Float64}, Ptr{Float64}(yp), length(d))
    @. y = x / d
    nothing
end
const CB_N_F64 = @cfunction(_precond_n_f64, Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}))

# ============================================================================
# Test problems
# ============================================================================

# Symmetric positive definite: A = tridiag(-1, 2, -1), x_true = ones
function spd_problem(::Type{T}, n=20) where T
    A = Matrix{T}(SymTridiagonal(fill(T(2), n), fill(T(-1), n-1)))
    x_true = ones(T, n)
    b = A * x_true
    A, b, x_true
end

# Same but complex (Hermitian)
function hermitian_problem(::Type{T}, n=20) where T<:Complex
    R = real(T)
    A = Matrix{T}(SymTridiagonal(fill(R(2), n), fill(R(-1), n-1)))
    x_true = ones(T, n)
    b = A * x_true
    A, b, x_true
end

# Square non-symmetric, diagonally dominant
function nonsym_problem(::Type{T}, n=20) where T
    R = real(T)
    rng = RNG  # reproducible
    A = T.(randn(rng, R, n, n)) + T(n) * I
    x_true = ones(T, n)
    b = A * x_true
    A, b, x_true
end

# Rectangular (m > n), consistent least-squares
function ls_problem(::Type{T}, m=30, n=20) where T
    R = real(T)
    rng = RNG
    A = T.(randn(rng, R, m, n))
    x_true = ones(T, n)
    b = A * x_true
    A, b, x_true
end

# ============================================================================
# Solver metadata (names must match generate_stores.jl SOLVERS table)
# ============================================================================

# Solvers that require matvec_At
const NEED_AT = Set([
    "lslq", "lsqr", "lsmr",
    "cgls", "crls", "cgne", "crmr",
    "craig", "craigmr", "lnlq",
    "bilq", "qmr",
    "bilqr", "trilqr",
    "usymlq", "usymqr", "usymlqr",
    "tricg", "trimr",
])

# Solvers that return a dual solution via krylov_get_y
const HAS_Y = Set(["tricg", "trimr", "gpmr", "bilqr", "trilqr"])

# Solvers that require a second RHS vector c (size n)
const NEED_C = Set(["tricg", "trimr", "bilqr", "trilqr", "usymlq", "usymqr", "usymlqr"])


# All 34 solver names
const ALL_SOLVERS = [
    "cg", "cr", "symmlq", "minres", "minres_qlp",
    "diom", "dqgmres", "fom", "gmres", "fgmres",
    "bicgstab", "cgs", "bilq", "qmr",
    "usymlq", "usymqr",
    "tricg", "trimr", "trilqr", "bilqr",
    "lslq", "lsqr", "lsmr", "usymlqr",
    "cgls", "crls", "cgne", "crmr",
    "craig", "craigmr", "lnlq",
    "gpmr", "car", "minares",
]

# Solvers that use a square non-symmetric problem (even if they also need At)
const NONSYM_SQUARE = Set(["bilq", "qmr",
                           "bicgstab", "cgs", "diom", "dqgmres",
                           "fom", "gmres", "fgmres",
                           "bilqr", "trilqr", "gpmr"])

function make_problem(solver::String, ::Type{T}) where T
    if solver in NONSYM_SQUARE
        nonsym_problem(T)
    elseif solver in NEED_AT
        ls_problem(T)
    elseif T <: Complex
        hermitian_problem(T)
    else
        spd_problem(T)
    end
end

# ============================================================================
# Core test function
# ============================================================================

function test_solver(solver::String, ::Type{T}) where T
    tol = 1000 * sqrt(eps(real(T)))

    A, b, x_true = make_problem(solver, T)
    m, n = size(A)
    At = Matrix(A')

    set_matrices!(T, A, At)
    cb_A, cb_At = get_callbacks(T)
    cb_At_arg = solver in NEED_AT ? cb_At : C_NULL

    # For two-RHS solvers: c = A'*ones_m (size n), so that y_true = ones_m
    c_rhs = solver in NEED_C ? At * ones(T, m) : nothing

    # Special RHS for tricg/trimr quasi-definite system [τI A; Aᴴ νI][x;y]=[b;c]
    # With τ=1, ν=-1, x=y=ones: b=A*ones_n+ones_m, c=Aᴴ*ones_m-ones_n
    if solver in ("tricg", "trimr")
        b     = b + ones(T, m)             # b = A*ones_n + ones_m
        c_rhs = At * ones(T, m) - ones(T, n) # c = Aᴴ*ones_m - ones_n
    end

    # gpmr: uses matvec_At slot for B (n×m).
    # System [I A; B -I][x;y]=[b;c] with x=y=ones needs b=A*ones+ones, c=B*ones-ones=At*ones-ones
    if solver == "gpmr"
        cb_At_arg = cb_At  # B = At repurposed
        c_rhs = At * x_true - ones(T, n)
        b = b + ones(T, m)
    end

    ws = c_workspace_create(solver_enum(solver), m, n, dtype_enum(T))
    try
        atol_use = real(T) == Float32 ? 1e-4 : 1e-8
        c_solve(ws, cb_A, cb_At_arg, b; c=c_rhs, atol=atol_use, rtol=atol_use)

        # tricg/trimr quasi-definite systems may not set solved flag in all precisions
        if !(solver in ("tricg", "trimr"))
            @test c_is_solved(ws)
        end
        @test c_niter(ws) > 0

        # Two-solution layout depends on solver convention:
        # tricg/trimr/usymlqr: solution(1) has size m, solution(2) has size n
        # gpmr/bilqr/trilqr:   solution(1) has size n, solution(2) has size m
        m_first = solver in ("tricg", "trimr", "usymlqr")
        x_size = m_first ? m : n
        x = c_get_x(ws, T, x_size)
        # block system solvers: just check finiteness
        if solver in ("tricg", "trimr", "gpmr", "usymlqr")
            @test all(isfinite, x)
        else
            @test norm(x - x_true) / norm(x_true) < tol
        end

        if solver in HAS_Y
            y_size = m_first ? n : m
            y = c_get_y(ws, T, y_size)
            @test all(isfinite, y)
        end
    finally
        c_workspace_free(ws)
    end
end

# ============================================================================
# warm_start test (CG only, Float64)
# ============================================================================

function test_warm_start()
    n = 20
    A, b, x_true = spd_problem(Float64, n)
    set_matrices!(Float64, A, Matrix(A'))
    cb_A, _ = get_callbacks(Float64)

    ws = c_workspace_create(KRYLOV_CG, n, n, KRYLOV_FLOAT64)
    try
        # First solve from zero
        c_solve(ws, cb_A, C_NULL, b; atol=1e-8, rtol=1e-8)
        niter_cold = c_niter(ws)

        # Warm start with exact solution — should converge in 1 iteration
        x0 = c_get_x(ws, Float64, n)
        c_warm_start(ws, x0)
        c_solve(ws, cb_A, C_NULL, b; atol=1e-8, rtol=1e-8)
        niter_warm = c_niter(ws)

        @test niter_warm < niter_cold
    finally
        c_workspace_free(ws)
    end
end

# ============================================================================
# krylov_get_version — runtime version matches Project.toml
# ============================================================================

function test_version()
    maj = Ref{Cint}(-1); mn = Ref{Cint}(-1); pt = Ref{Cint}(-1)
    GC.@preserve maj mn pt begin
        krylov_get_version(Base.unsafe_convert(Ptr{Cint}, maj),
                           Base.unsafe_convert(Ptr{Cint}, mn),
                           Base.unsafe_convert(Ptr{Cint}, pt))
    end
    v = pkgversion(Krylov)
    @test Int(maj[]) == v.major
    @test Int(mn[])  == v.minor
    @test Int(pt[])  == v.patch
end

# ============================================================================
# warm_start2 — two-solution warm start (x0, y0)
# ============================================================================

function test_warm_start2()
    n = 12

    # A single-solution solver must reject warm_start2 with -2.
    ws = c_workspace_create(KRYLOV_CG, n, n, KRYLOV_FLOAT64)
    try
        @test c_warm_start2(ws, ones(n), ones(n)) == -2
    finally
        c_workspace_free(ws)
    end

    # BiLQR has two solutions (primal x of size n, dual y of size m).  Seed both
    # with the exact solution: warm_start2 must be accepted and the solve succeed.
    A, b, x_true = nonsym_problem(Float64, n)
    m, _ = size(A)
    At = Matrix(A')
    set_matrices!(Float64, A, At)
    cb_A, cb_At = get_callbacks(Float64)
    c_rhs = At * ones(Float64, m)          # dual solution is ones(m)

    ws = c_workspace_create(solver_enum("bilqr"), m, n, KRYLOV_FLOAT64)
    try
        # Seeding with the exact (x, y) makes the solve converge immediately,
        # which is exactly what proves both guesses were consumed.
        @test c_warm_start2(ws, x_true, ones(Float64, m)) == 0
        c_solve(ws, cb_A, cb_At, b; c=c_rhs, atol=1e-8, rtol=1e-8)
        x = c_get_x(ws, Float64, n)
        @test norm(x - x_true) / norm(x_true) < 1e-6
    finally
        c_workspace_free(ws)
    end
end

# ============================================================================
# Right / split preconditioning — exercises the _typed_solve_mn! branches
# ============================================================================

function test_mn_preconditioner()
    n = 20
    A, b, x_true = nonsym_problem(Float64, n)
    set_matrices!(Float64, A, Matrix(A'))
    cb_A, _ = get_callbacks(Float64)
    _Minv_f64[] = [A[i, i] for i in 1:n]   # Jacobi: M = N = diag(A)
    tol = 1e-6

    # left only, right only, and split (M and N) — all on GMRES.
    for (cb_M, cb_N, label) in ((CB_M_F64, C_NULL,   "left"),
                                (C_NULL,   CB_M_F64, "right"),
                                (CB_M_F64, CB_M_F64, "split"))
        ws = c_workspace_create(KRYLOV_GMRES, n, n, KRYLOV_FLOAT64)
        try
            c_solve_mn(ws, cb_A, cb_M, cb_N, b; atol=1e-10, rtol=1e-10)
            @test c_is_solved(ws)
            x = c_get_x(ws, Float64, n)
            @test norm(x - x_true) / norm(x_true) < tol
        finally
            c_workspace_free(ws)
        end
    end
end

# ============================================================================
# Least-squares / least-norm preconditioning (M on the m-space, N on the n-space;
# normal-equations methods take a single n-space preconditioner)
# ============================================================================

function test_ls_preconditioner()
    A, b, x_true = ls_problem(Float64)        # m=30 > n=20, consistent (b = A*ones)
    m, n = size(A)
    set_matrices!(Float64, A, Matrix(A'))
    cb_A, cb_At = get_callbacks(Float64)
    tol = 1e-5

    # LSQR: M = E⁻¹ on the m-space, N = F⁻¹ on the n-space. Non-trivial positive
    # diagonals; the consistent full-rank solution is x_true regardless of M/N.
    _Minv_f64[] = fill(2.0, m)
    _Ninv_f64[] = fill(3.0, n)
    ws = c_workspace_create(solver_enum("lsqr"), m, n, KRYLOV_FLOAT64)
    try
        @test solve_with(ws, cb_A, b; cb_At=cb_At, cb_M=CB_M_F64, cb_N=CB_N_F64) == 0
        @test c_is_solved(ws)
        @test norm(c_get_x(ws, Float64, n) - x_true) / norm(x_true) < tol
    finally
        c_workspace_free(ws)
    end

    # CGLS: single preconditioner on the n-space (normal equations), via matvec_M.
    _Minv_f64[] = fill(2.0, n)
    ws = c_workspace_create(solver_enum("cgls"), m, n, KRYLOV_FLOAT64)
    try
        @test solve_with(ws, cb_A, b; cb_At=cb_At, cb_M=CB_M_F64) == 0
        @test norm(c_get_x(ws, Float64, n) - x_true) / norm(x_true) < tol
    finally
        c_workspace_free(ws)
    end

    # CGNE: single preconditioner on the n-space, via matvec_N.
    _Ninv_f64[] = fill(2.0, n)
    ws = c_workspace_create(solver_enum("cgne"), m, n, KRYLOV_FLOAT64)
    try
        @test solve_with(ws, cb_A, b; cb_At=cb_At, cb_N=CB_N_F64) == 0
        @test norm(c_get_x(ws, Float64, n) - x_true) / norm(x_true) < tol
    finally
        c_workspace_free(ws)
    end
end

# ============================================================================
# Optional solve-time options: timemax, restart, reorthogonalization,
# radius (trust region), linesearch, λ-shift for symmetric solvers
# ============================================================================

function test_extra_options()
    n = 24
    A, b, x_true = spd_problem(Float64, n)
    set_matrices!(Float64, A, Matrix(A'))
    cb_A, _ = get_callbacks(Float64)
    tol = 1e-6

    # GMRES with restart + reorthogonalization (small memory forces restarts).
    ws = create_with_wopts(KRYLOV_GMRES, n; memory=5)
    try
        @test solve_with(ws, cb_A, b; restart=1, reorth=1, itmax=500) == 0
        @test c_is_solved(ws)
        @test norm(c_get_x(ws, Float64, n) - x_true) / norm(x_true) < tol
    finally
        c_workspace_free(ws)
    end

    # DIOM with reorthogonalization.
    ws = c_workspace_create(KRYLOV_DIOM, n, n, KRYLOV_FLOAT64)
    try
        @test solve_with(ws, cb_A, b; reorth=1) == 0
        @test norm(c_get_x(ws, Float64, n) - x_true) / norm(x_true) < tol
    finally
        c_workspace_free(ws)
    end

    # CG with linesearch (SPD ⇒ positive curvature, full solve) and timemax set.
    ws = c_workspace_create(KRYLOV_CG, n, n, KRYLOV_FLOAT64)
    try
        @test solve_with(ws, cb_A, b; linesearch=1, timemax=3600.0) == 0
        @test norm(c_get_x(ws, Float64, n) - x_true) / norm(x_true) < tol
    finally
        c_workspace_free(ws)
    end

    # CG with a trust-region radius: the step must stop on the boundary ‖x‖ = radius.
    ws = c_workspace_create(KRYLOV_CG, n, n, KRYLOV_FLOAT64)
    try
        r = 0.5 * norm(x_true)
        @test solve_with(ws, cb_A, b; radius=r) == 0
        x = c_get_x(ws, Float64, n)
        @test norm(x) ≤ r * (1 + 1e-6)
        @test isapprox(norm(x), r; rtol=1e-3)
    finally
        c_workspace_free(ws)
    end

    # MINRES with a shift λ: solves (A + λI) x = b.
    λ = 0.5
    bshift = (A + λ*I) * x_true
    ws = c_workspace_create(KRYLOV_MINRES, n, n, KRYLOV_FLOAT64)
    try
        @test solve_with(ws, cb_A, bshift; lambda=λ) == 0
        @test c_is_solved(ws)
        @test norm(c_get_x(ws, Float64, n) - x_true) / norm(x_true) < tol
    finally
        c_workspace_free(ws)
    end
end

# ============================================================================
# Workspace options (memory / window) — white-box: confirm the value passed
# through KrylovWorkspaceOptions actually reaches the workspace constructor.
# ============================================================================

function create_with_wopts(solver::Cint, n::Int; memory::Int=0, window::Int=0)
    ws    = Ref{Ptr{Cvoid}}(C_NULL)
    wopts = Ref(LibKrylov.KrylovWorkspaceOptionsC(Cint(memory), Cint(window)))
    ret = GC.@preserve ws wopts begin
        krylov_workspace_create(solver, Cint(n), Cint(n), KRYLOV_FLOAT64, KRYLOV_CPU,
                                Base.unsafe_convert(Ptr{Cvoid}, wopts),
                                Base.unsafe_convert(Ptr{Ptr{Cvoid}}, ws))
    end
    ret == 0 || error("create_with_wopts returned $ret")
    ws[]
end

ws_object(store::String, ws::Ptr{Cvoid}) = getfield(LibKrylov, Symbol(store))[ws]

function test_workspace_options()
    n = 12

    # memory → number of Krylov basis vectors (field :V)
    for (solver, store) in ((KRYLOV_GMRES,   "store_gmres_f64"),
                            (KRYLOV_FGMRES,  "store_fgmres_f64"),
                            (KRYLOV_FOM,     "store_fom_f64"),
                            (KRYLOV_DIOM,    "store_diom_f64"),
                            (KRYLOV_DQGMRES, "store_dqgmres_f64"))
        ws = create_with_wopts(solver, n; memory=4)
        try
            @test length(ws_object(store, ws).V) == 4
        finally
            c_workspace_free(ws)
        end
        # memory = 0 falls back to the default (20, clamped to n here)
        ws = create_with_wopts(solver, n; memory=0)
        try
            @test length(ws_object(store, ws).V) == min(20, n)
        finally
            c_workspace_free(ws)
        end
    end

    # window → residual-estimation history (field :err_vec, or :clist for SYMMLQ)
    for (solver, store, field) in ((KRYLOV_MINRES, "store_minres_f64", :err_vec),
                                   (KRYLOV_LSQR,   "store_lsqr_f64",   :err_vec),
                                   (KRYLOV_LSMR,   "store_lsmr_f64",   :err_vec),
                                   (KRYLOV_LSLQ,   "store_lslq_f64",   :err_vec),
                                   (KRYLOV_SYMMLQ, "store_symmlq_f64", :clist))
        ws = create_with_wopts(solver, n; window=3)
        try
            @test length(getfield(ws_object(store, ws), field)) == 3
        finally
            c_workspace_free(ws)
        end
    end
end

# ============================================================================
# Block Krylov interface (block_gmres / block_minres)
# ============================================================================

function block_create(solver::Cint, n::Int, p::Int, dtype::Cint; memory::Int=0)
    ws    = Ref{Ptr{Cvoid}}(C_NULL)
    wopts = Ref(LibKrylov.KrylovWorkspaceOptionsC(Cint(memory), Cint(0)))
    ret = GC.@preserve ws wopts begin
        LibKrylov.krylov_block_workspace_create(solver, Cint(n), Cint(n), Cint(p),
            dtype, KRYLOV_CPU, Base.unsafe_convert(Ptr{Cvoid}, wopts),
            Base.unsafe_convert(Ptr{Ptr{Cvoid}}, ws))
    end
    (ret, ws[])
end

function test_block_solve()
    n, p = 16, 3
    A = Matrix{Float64}(SymTridiagonal(fill(8.0, n), fill(-1.0, n-1)))  # diag-dominant SPD
    _BA_f64[] = A
    Xtrue = zeros(Float64, n, p)
    for i in 1:n, j in 1:p
        t = i / n
        Xtrue[i, j] = j == 1 ? 1.0 : (j == 2 ? t : t^2)   # independent columns
    end
    B = A * Xtrue
    for solver in (KRYLOV_BLOCK_GMRES, KRYLOV_BLOCK_MINRES)
        ret, ws = block_create(solver, n, p, KRYLOV_FLOAT64)
        @test ret == 0
        try
            opts = Ref(LibKrylov.KrylovOptionsC(1e-10, 1e-10, Cint(200), Cint(0), 0.0, NaN, NaN, NaN, 0.0, Cint(0), Cint(0), Cint(0)))
            r = GC.@preserve B opts begin
                LibKrylov.krylov_block_solve(ws, BCB_A_F64, C_NULL, C_NULL,
                    Base.unsafe_convert(Ptr{Cvoid}, pointer(B)), C_NULL,
                    Base.unsafe_convert(Ptr{Cvoid}, opts))
            end
            @test r == 0
            @test LibKrylov.krylov_block_is_solved(ws) == 1
            @test LibKrylov.krylov_block_niter(ws) > 0
            X = zeros(Float64, n, p)
            GC.@preserve X LibKrylov.krylov_block_get_X(ws,
                Base.unsafe_convert(Ptr{Cvoid}, pointer(X)), Cint(n), Cint(p))
            @test maximum(abs.(X .- Xtrue)) < 1e-6
        finally
            LibKrylov.krylov_block_workspace_free(ws)
        end
    end
end

function test_block_workspace_options()
    n, p = 12, 3   # div(n, p) = 4, so memory=3 is not clamped
    for (suffix, dtype) in (("f32", KRYLOV_FLOAT32), ("f64", KRYLOV_FLOAT64),
                            ("cf32", KRYLOV_COMPLEX32), ("cf64", KRYLOV_COMPLEX64))
        ret, ws = block_create(KRYLOV_BLOCK_GMRES, n, p, dtype; memory=3)
        @test ret == 0
        store = getfield(LibKrylov, Symbol("store_block_gmres_$(suffix)"))
        try
            @test length(store[ws].V) == min(3, div(n, p))
        finally
            LibKrylov.krylov_block_workspace_free(ws)
        end
    end
end

function test_block_errors()
    # unknown block solver → -2
    ret, _ = block_create(Cint(99), 8, 2, KRYLOV_FLOAT64)
    @test ret == -2
    # double free → 0 then 1
    _, ws = block_create(KRYLOV_BLOCK_GMRES, 8, 2, KRYLOV_FLOAT64)
    @test LibKrylov.krylov_block_workspace_free(ws) == 0
    @test LibKrylov.krylov_block_workspace_free(ws) == 1
end

# ============================================================================
# Run all tests
# ============================================================================

@testset "LibKrylov C interface" begin
    @testset "$T" for T in (Float32, Float64, ComplexF32, ComplexF64)
        @testset "$solver" for solver in ALL_SOLVERS
            test_solver(solver, T)
        end
    end

    @testset "version" begin
        test_version()
    end

    @testset "warm_start" begin
        test_warm_start()
    end

    @testset "warm_start2" begin
        test_warm_start2()
    end

    @testset "preconditioning (M/N)" begin
        test_mn_preconditioner()
    end

    @testset "preconditioning (least-squares)" begin
        test_ls_preconditioner()
    end

    @testset "extra options" begin
        test_extra_options()
    end

    @testset "workspace_options" begin
        test_workspace_options()
    end

    @testset "block solvers" begin
        test_block_solve()
        test_block_workspace_options()
        test_block_errors()
    end
end

# An implementation of SYMMLQ for the solution of the
# linear system Ax = b, where A is Hermitian.
#
# This implementation follows the original implementation by
# Michael Saunders described in
#
# C. C. Paige and M. A. Saunders, Solution of Sparse Indefinite Systems of Linear Equations,
# SIAM Journal on Numerical Analysis, 12(4), pp. 617--629, 1975.
#
# Ron Estrin, <ronestrin756@gmail.com>

export symmlq, symmlq!

"""
    (x, stats) = symmlq(A, b::AbstractVector{FC};
                        M=I, ldiv::Bool=false, window::Int=5,
                        transfer_to_cg::Bool=true, λ::T=zero(T),
                        λest::T=zero(T), etol::T=√eps(T),
                        conlim::T=1/√eps(T), atol::T=√eps(T),
                        rtol::T=√eps(T), itmax::Int=0,
                        timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                        callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = symmlq(A, b, x0::AbstractVector; kwargs...)

SYMMLQ can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above

Solve the shifted linear system

    (A + λI) x = b

of size n using the SYMMLQ method, where λ is a shift parameter, and A is Hermitian.

SYMMLQ produces monotonic errors ‖x* - x‖₂.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :symmlq`.

For an in-place variant that reuses memory across solves, see [`symmlq!`](@ref).

#### Input arguments

* `A`: a linear operator that models a Hermitian matrix of dimension `n`;
* `b`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning;
* `ldiv`: define whether the preconditioner uses `ldiv!` or `mul!`;
* `window`: number of iterations used to accumulate a lower bound on the error;
* `transfer_to_cg`: transfer from the SYMMLQ point to the CG point, when it exists. The transfer is based on the residual norm;
* `λ`: regularization parameter;
* `λest`: positive strict lower bound on the smallest eigenvalue `λₘᵢₙ` when solving a positive-definite system, such as `λest = (1-10⁻⁷)λₘᵢₙ`;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `etol`: stopping tolerance based on the lower bound on the error;
* `conlim`: limit on the estimated condition number of `A` beyond which the solution will be abandoned;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SymmlqStats`](@ref) structure.

#### Reference

* C. C. Paige and M. A. Saunders, [*Solution of Sparse Indefinite Systems of Linear Equations*](https://doi.org/10.1137/0712047), SIAM Journal on Numerical Analysis, 12(4), pp. 617--629, 1975.
"""
function symmlq end

"""
    workspace = symmlq!(workspace::SymmlqWorkspace, A, b; kwargs...)
    workspace = symmlq!(workspace::SymmlqWorkspace, A, b, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`symmlq`](@ref).
The keyword argument `window` is the only exception.
It is only supported by [`symmlq`](@ref) and is required to create a `SymmlqWorkspace`.
It cannot be changed later.

See [`SymmlqWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :symmlq` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function symmlq! end

def_args_symmlq = (:(A                    ),
                   :(b::AbstractVector{FC}))

def_optargs_symmlq = (:(x0::AbstractVector),)

def_kwargs_symmlq = (:(; M = I                         ),
                     :(; ldiv::Bool = false            ),
                     :(; transfer_to_cg::Bool = true   ),
                     :(; λ::T = zero(T)                ),
                     :(; λest::T = zero(T)             ),
                     :(; atol::T = √eps(T)             ),
                     :(; rtol::T = √eps(T)             ),
                     :(; etol::T = √eps(T)             ),
                     :(; conlim::T = 1/√eps(T)         ),
                     :(; itmax::Int = 0                ),
                     :(; timemax::Float64 = Inf        ),
                     :(; verbose::Int = 0              ),
                     :(; history::Bool = false         ),
                     :(; callback = workspace -> false ),
                     :(; iostream::IO = kstdout        ))

def_kwargs_workspace_symmlq = (:(; window::Int = 5),)

def_kwargs_symmlq = extract_parameters.(def_kwargs_symmlq)
def_kwargs_workspace_symmlq = extract_parameters.(def_kwargs_workspace_symmlq)

args_symmlq = (:A, :b)
optargs_symmlq = (:x0,)
kwargs_symmlq = (:M, :ldiv, :transfer_to_cg, :λ, :λest, :atol, :rtol, :etol, :conlim, :itmax, :timemax, :verbose, :history, :callback, :iostream)
kwargs_workspace_symmlq = (:window,)

@eval begin
  function symmlq!(workspace :: SymmlqWorkspace{T,FC,S}, $(def_args_symmlq...); $(def_kwargs_symmlq...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("System must be square")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "SYMMLQ: system of size %d\n", n)

    # Tests M = Iₙ
    MisI = (M === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")

    # Set up workspace.
    allocate_if(!MisI, workspace, :v, S, workspace.x)  # The length of v is n
    x, Mvold, Mv, Mv_next, w̅ = workspace.x, workspace.Mvold, workspace.Mv, workspace.Mv_next, workspace.w̅
    Δx, clist, zlist, sprod, stats = workspace.Δx, workspace.clist, workspace.zlist, workspace.sprod, workspace.stats
    warm_start = workspace.warm_start
    rNorms, rcgNorms = stats.residuals, stats.residualscg
    errors, errorscg = stats.errors, stats.errorscg
    reset!(stats)
    v = MisI ? Mv : workspace.v
    vold = MisI ? Mvold : workspace.v

    ϵM = eps(T)
    ctol = conlim > 0 ? inv(conlim) : zero(T)

    # Initial solution x₀
    kfill!(x, zero(FC))

    if warm_start
      kmul!(Mvold, A, Δx)
      (λ ≠ 0) && kaxpy!(n, λ, Δx, Mvold)
      kaxpby!(n, one(FC), b, -one(FC), Mvold)
    else
      kcopy!(n, Mvold, b)  # Mvold ← b
    end

    # Initialize Lanczos process.
    # β₁ M v₁ = b.
    MisI || mulorldiv!(vold, M, Mvold, ldiv)
    β₁ = kdotr(m, vold, Mvold)
    if β₁ == 0
      stats.niter = 0
      stats.solved = true
      stats.Anorm = T(NaN)
      stats.Acond = T(NaN)
      history && push!(rNorms, zero(T))
      history && push!(rcgNorms, zero(T))
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end
    β₁ = sqrt(β₁)
    β = β₁
    kdiv!(m, vold, β)
    MisI || kdiv!(m, Mvold, β)

    kcopy!(n, w̅, vold)  # w̅ ← vold

    kmul!(Mv, A, vold)
    α = kdotr(m, vold, Mv) + λ
    kaxpy!(m, -α, Mvold, Mv)  # Mv = Mv - α * Mvold
    MisI || mulorldiv!(v, M, Mv, ldiv)
    β = kdotr(m, v, Mv)
    β < 0 && error("Preconditioner is not positive definite")
    β = sqrt(β)
    kdiv!(m, v, β)
    MisI || kdiv!(m, Mv, β)

    # Start QR factorization
    γbar = α
    δbar = β
    ϵold = zero(T)
    cold = one(T)
    sold = zero(T)

    ηold = zero(T)
    η    = β₁
    ζold = zero(T)

    ANorm² = α * α + β * β

    γmax = T(-Inf)
    γmin = T(Inf)
    ANorm = zero(T)
    Acond = zero(T)

    xNorm = zero(T)
    rNorm = β₁
    history && push!(rNorms, rNorm)

    if γbar ≠ 0
      ζbar = η / γbar
      xcgNorm = abs(ζbar)
      rcgNorm = β₁ * abs(ζbar)
      history && push!(rcgNorms, rcgNorm)
    else
      history && push!(rcgNorms, missing)
    end

    err = T(Inf)
    errcg = T(Inf)

    window = length(clist)
    kfill!(clist, zero(T))
    kfill!(zlist, zero(T))
    kfill!(sprod, one(T))

    if λest ≠ 0
      # Start QR factorization of Tₖ - λest I
      ρbar = α - λest
      σbar = β
      ρ = sqrt(ρbar * ρbar + β * β)
      cwold = -one(T)
      cw = ρbar / ρ
      sw = β / ρ

      history && push!(errors, abs(β₁ / λest))
      if γbar ≠ 0
        history && push!(errorscg, sqrt(errors[1]^2 - ζbar^2))
      else
        history && push!(errorscg, missing)
      end
    end

    iter = 0
    itmax == 0 && (itmax = 2 * n)

    (verbose > 0) && @printf(iostream, "%5s  %7s  %7s  %8s  %8s  %7s  %7s  %7s  %5s\n", "k", "‖r‖", "β", "cos", "sin", "‖A‖", "κ(A)", "test1", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %8.1e  %8.1e  %7.1e  %7.1e  %7s  %.2fs\n", iter, rNorm, β, cold, sold, ANorm, Acond, "✗ ✗ ✗ ✗", start_time |> ktimer)

    tol = atol + rtol * β₁
    status = "unknown"
    solved_lq = solved_mach = solved_lim = (rNorm ≤ tol)
    solved_cg = (γbar ≠ 0) && transfer_to_cg && rcgNorm ≤ tol
    tired = iter ≥ itmax
    ill_cond = ill_cond_mach = ill_cond_lim = false
    solved = zero_resid = solved_lq || solved_cg
    fwd_err = false
    user_requested_exit = false
    overtimed = false

    while ! (solved || tired || ill_cond || user_requested_exit || overtimed)
      iter = iter + 1

      # Continue QR factorization
      (c, s, γ) = sym_givens(γbar, β)

      # Update SYMMLQ point
      ηold = η
      ζ = ηold / γ
      kaxpy!(n, c * ζ, w̅, x)
      kaxpy!(n, s * ζ, v, x)
      # Update w̅
      kaxpby!(n, -c, v, s, w̅)

      # Generate next Lanczos vector
      oldβ = β
      kmul!(Mv_next, A, v)
      α = kdotr(m, v, Mv_next) + λ
      kaxpy!(m, -oldβ, Mvold, Mv_next)
      kcopy!(m, Mvold, Mv)  # Mvold ← Mv
      kaxpy!(m, -α, Mv, Mv_next)
      kcopy!(m, Mv, Mv_next)  # Mv ← Mv_next
      MisI || mulorldiv!(v, M, Mv, ldiv)
      β = kdotr(m, v, Mv)
      β < 0 && error("Preconditioner is not positive definite")
      β = sqrt(β)
      kdiv!(m, v, β)
      MisI || kdiv!(m, Mv, β)

      # Continue A norm estimate
      ANorm² = ANorm² + α * α + oldβ * oldβ + β * β

      if λest ≠ 0
        η = -oldβ * oldβ * cwold / ρbar
        ω = λest + η
        ψ = c * δbar + s * ω
        ωbar = s * δbar - c * ω
      end

      # Continue QR factorization
      δ = δbar * c + α * s
      γbar = δbar * s - α * c
      ϵ = β * s
      δbar = -β * c
      η = -ϵold * ζold - δ * ζ

      rNorm = sqrt(γ * γ * ζ * ζ + ϵold * ϵold * ζold * ζold)
      xNorm = xNorm + ζ * ζ
      history && push!(rNorms, rNorm)

      if γbar ≠ 0
        ζbar = η / γbar
        rcgNorm = β * abs(s * ζ - c * ζbar)
        xcgNorm = xNorm + ζbar * ζbar
        history && push!(rcgNorms, rcgNorm)
      else
        history && push!(rcgNorms, missing)
      end

      if window > 0 && λest ≠ 0
        if iter < window && window > 1
          for i = iter+1 : window
            sprod[i] = s * sprod[i]
          end
        end

        ix = ((iter-1) % window) + 1
        clist[ix] = c
        zlist[ix] = ζ

        if iter ≥ window
            jx = mod(iter, window) + 1
            zetabark = zlist[jx] / clist[jx]

            if γbar ≠ 0
              theta = zero(T)
              for i = 1 : window
                theta += clist[i] * sprod[i] * zlist[i]
              end
              theta = zetabark * abs(theta) + abs(zetabark * ζbar * sprod[ix] * s) - zetabark^2
              history && (errorscg[iter-window+1] = sqrt(abs(errorscg[iter-window+1]^2 - 2*theta)))
            else
              history && (errorscg[iter-window+1] = missing)
            end
        end

        ix = (iter % window) + 1
        if iter ≥ window && window > 1
          kdiv!(window, sprod, sprod[(ix % window) + 1])
          sprod[ix] = sprod[mod(ix-2, window)+1] * s
        end
      end

      if λest ≠ 0
        err = abs((ϵold * ζold + ψ * ζ) / ωbar)
        history && push!(errors, err)

        if γbar ≠ 0
          errcg = sqrt(abs(err * err - ζbar * ζbar))
          history && push!(errorscg, errcg)
        else
          history && push!(errorscg, missing)
        end

        ρbar = sw * σbar - cw * (α - λest)
        σbar = -cw * β
        ρ = sqrt(ρbar * ρbar + β * β)

        cwold = cw

        cw = ρbar / ρ
        sw = β / ρ
      end

      # TODO: Use γ or γbar?
      γmax = max(γmax, γ)
      γmin = min(γmin, γ)

      Acond = γmax / γmin
      ANorm = sqrt(ANorm²)
      test1 = rNorm / (ANorm * xNorm)

      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %8.1e  %8.1e  %7.1e  %7.1e  %7.1e  %.2fs\n", iter, rNorm, β, c, s, ANorm, Acond, test1, start_time |> ktimer)

      # Reset variables
      ϵold = ϵ
      ζold = ζ
      cold = c

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      resid_decrease_mach = (one(T) + rNorm ≤ one(T))
      ill_cond_mach = (one(T) + inv(Acond) ≤ one(T))
      zero_resid_mach = (one(T) + test1 ≤ one(T))
      # solved_mach = (ϵx ≥ β₁)

      # Stopping conditions based on user-provided tolerances.
      tired = iter ≥ itmax
      ill_cond_lim = (inv(Acond) ≤ ctol)
      zero_resid_lim = (test1 ≤ tol)
      fwd_err = (err ≤ etol) || ((γbar ≠ 0) && (errcg ≤ etol))
      solved_lq = rNorm ≤ tol
      solved_cg = transfer_to_cg && (γbar ≠ 0) && rcgNorm ≤ tol
      
      user_requested_exit = callback(workspace) :: Bool
      zero_resid = solved_lq || solved_cg
      ill_cond = ill_cond_mach || ill_cond_lim
      solved = solved_mach || zero_resid || zero_resid_mach || zero_resid_lim || fwd_err || resid_decrease_mach
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Compute CG point
    # (xᶜ)ₖ ← (xᴸ)ₖ₋₁ + ζbarₖ * w̅ₖ
    if solved_cg
      kaxpy!(m, ζbar, w̅, x)
    end

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    ill_cond_mach       && (status = "condition number seems too large for this machine")
    ill_cond_lim        && (status = "condition number exceeds tolerance")
    solved              && (status = "found approximate solution")
    solved_lq           && (status = "solution xᴸ good enough given atol and rtol")
    solved_cg           && (status = "solution xᶜ good enough given atol and rtol")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update x
    warm_start && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.Anorm = ANorm
    stats.Acond = Acond
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

# An implementation of USYMLQ for the solution of linear system Ax = b.
#
# This method is described in
#
# M. A. Saunders, H. D. Simon, and E. L. Yip
# Two Conjugate-Gradient-Type Methods for Unsymmetric Linear Equations.
# SIAM Journal on Numerical Analysis, 25(4), pp. 927--940, 1988.
#
# A. Buttari, D. Orban, D. Ruiz and D. Titley-Peloquin
# A tridiagonalization method for symmetric saddle-point and quasi-definite systems.
# SIAM Journal on Scientific Computing, 41(5), pp. 409--432, 2019.
#
# A. Montoison and D. Orban
# BiLQ: An Iterative Method for Nonsymmetric Linear Systems with a Quasi-Minimum Error Property.
# SIAM Journal on Matrix Analysis and Applications, 41(3), pp. 1145--1166, 2020.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Montreal, November 2018.

export usymlq, usymlq!

"""
    (x, stats) = usymlq(A, b::AbstractVector{FC}, c::AbstractVector{FC};
                        transfer_to_usymcg::Bool=true, atol::T=√eps(T),
                        rtol::T=√eps(T), itmax::Int=0,
                        timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                        callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = usymlq(A, b, c, x0::AbstractVector; kwargs...)

USYMLQ can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above.

USYMLQ determines the least-norm solution of the consistent linear system Ax = b of size m × n.

USYMLQ is based on the orthogonal tridiagonalization process and requires two initial nonzero vectors `b` and `c`.
The vector `c` is only used to initialize the process and a default value can be `b` or `Aᴴb` depending on the shape of `A`.
The error norm ‖x - x*‖ monotonously decreases in USYMLQ.
When `A` is Hermitian and `b = c`, USYMLQ is equivalent to SYMMLQ.
USYMLQ is considered as a generalization of SYMMLQ.

It can also be applied to under-determined and over-determined problems.
In all cases, problems must be consistent.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :usymlq`.

For an in-place variant that reuses memory across solves, see [`usymlq!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`;
* `c`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `transfer_to_usymcg`: transfer from the USYMLQ point to the USYMCG point, when it exists. The transfer is based on the residual norm;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `m+n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### References

* M. A. Saunders, H. D. Simon, and E. L. Yip, [*Two Conjugate-Gradient-Type Methods for Unsymmetric Linear Equations*](https://doi.org/10.1137/0725052), SIAM Journal on Numerical Analysis, 25(4), pp. 927--940, 1988.
* A. Buttari, D. Orban, D. Ruiz and D. Titley-Peloquin, [*A tridiagonalization method for symmetric saddle-point and quasi-definite systems*](https://doi.org/10.1137/18M1194900), SIAM Journal on Scientific Computing, 41(5), pp. 409--432, 2019.
* A. Montoison and D. Orban, [*BiLQ: An Iterative Method for Nonsymmetric Linear Systems with a Quasi-Minimum Error Property*](https://doi.org/10.1137/19M1290991), SIAM Journal on Matrix Analysis and Applications, 41(3), pp. 1145--1166, 2020.
"""
function usymlq end

"""
    workspace = usymlq!(workspace::UsymlqWorkspace, A, b, c; kwargs...)
    workspace = usymlq!(workspace::UsymlqWorkspace, A, b, c, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`usymlq`](@ref).

See [`UsymlqWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :usymlq` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function usymlq! end

def_args_usymlq = (:(A                    ),
                   :(b::AbstractVector{FC}),
                   :(c::AbstractVector{FC}))

def_optargs_usymlq = (:(x0::AbstractVector),)

def_kwargs_usymlq = (:(; transfer_to_usymcg::Bool = true),
                     :(; atol::T = √eps(T)              ),
                     :(; rtol::T = √eps(T)              ),
                     :(; itmax::Int = 0                 ),
                     :(; timemax::Float64 = Inf         ),
                     :(; verbose::Int = 0               ),
                     :(; history::Bool = false          ),
                     :(; callback = workspace -> false  ),
                     :(; iostream::IO = kstdout         ))

def_kwargs_usymlq = extract_parameters.(def_kwargs_usymlq)

args_usymlq = (:A, :b, :c)
optargs_usymlq = (:x0,)
kwargs_usymlq = (:transfer_to_usymcg, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function usymlq!(workspace :: UsymlqWorkspace{T,FC,Sm,Sn}, $(def_args_usymlq...); $(def_kwargs_usymlq...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    length(b) == m || error("Inconsistent problem size")
    length(c) == n || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "USYMLQ: system of %d equations in %d variables\n", m, n)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == Sm || error("ktypeof(b) must be equal to $Sm")
    ktypeof(c) == Sn || error("ktypeof(c) must be equal to $Sn")

    # Compute the adjoint of A
    Aᴴ = A'

    # Set up workspace.
    uₖ₋₁, uₖ, p, Δx, x = workspace.uₖ₋₁, workspace.uₖ, workspace.p, workspace.Δx, workspace.x
    vₖ₋₁, vₖ, q, d̅, stats = workspace.vₖ₋₁, workspace.vₖ, workspace.q, workspace.d̅, workspace.stats
    warm_start = workspace.warm_start
    rNorms = stats.residuals
    reset!(stats)
    r₀ = warm_start ? q : b

    if warm_start
      kmul!(r₀, A, Δx)
      kaxpby!(n, one(FC), b, -one(FC), r₀)
    end

    # Initial solution x₀ and residual norm ‖r₀‖.
    kfill!(x, zero(FC))
    bNorm = knorm(m, r₀)
    history && push!(rNorms, bNorm)
    if bNorm == 0
      stats.niter = 0
      stats.solved = true
      stats.inconsistent = false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    iter = 0
    itmax == 0 && (itmax = m+n)

    ε = atol + rtol * bNorm
    (verbose > 0) && @printf(iostream, "%5s  %7s  %5s\n", "k", "‖rₖ‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %.2fs\n", iter, bNorm, start_time |> ktimer)

    βₖ = knorm(m, r₀)            # β₁ = ‖v₁‖ = ‖r₀‖
    γₖ = knorm(n, c)             # γ₁ = ‖u₁‖ = ‖c‖
    kfill!(vₖ₋₁, zero(FC))       # v₀ = 0
    kfill!(uₖ₋₁, zero(FC))       # u₀ = 0
    kdivcopy!(m, vₖ, r₀, βₖ)     # v₁ = (b - Ax₀) / β₁
    kdivcopy!(n, uₖ, c, γₖ)      # u₁ = c / γ₁
    cₖ₋₁ = cₖ = -one(T)          # Givens cosines used for the LQ factorization of Tₖ
    sₖ₋₁ = sₖ = zero(FC)         # Givens sines used for the LQ factorization of Tₖ
    kfill!(d̅, zero(FC))          # Last column of D̅ₖ = Uₖ(Qₖ)ᴴ
    ζₖ₋₁ = ζbarₖ = zero(FC)      # ζₖ₋₁ and ζbarₖ are the last components of z̅ₖ = (L̅ₖ)⁻¹β₁e₁
    ηₖ₋₁ = ηₖ = ζₖ₋₂ = zero(FC)  # ηₖ₋₁, ηₖ and ζₖ₋₂ are used to update ζₖ₋₁ and ζbarₖ
    δbarₖ₋₁ = δbarₖ = zero(FC)   # Coefficients of Lₖ₋₁ and Lₖ modified over the course of two iterations

    # Stopping criterion.
    solved_lq = bNorm ≤ ε
    solved_cg = false
    tired     = iter ≥ itmax
    status    = "unknown"
    user_requested_exit = false
    overtimed = false

    while !(solved_lq || solved_cg || tired || user_requested_exit || overtimed)
      # Update iteration index.
      iter = iter + 1

      # Continue the SSY tridiagonalization process.
      # AUₖ  = VₖTₖ    + βₖ₊₁vₖ₊₁(eₖ)ᵀ = Vₖ₊₁Tₖ₊₁.ₖ
      # AᴴVₖ = Uₖ(Tₖ)ᴴ + γₖ₊₁uₖ₊₁(eₖ)ᵀ = Uₖ₊₁(Tₖ.ₖ₊₁)ᴴ

      kmul!(q, A , uₖ)  # Forms vₖ₊₁ : q ← Auₖ
      kmul!(p, Aᴴ, vₖ)  # Forms uₖ₊₁ : p ← Aᴴvₖ

      if iter ≥ 2
        kaxpy!(m, -γₖ, vₖ₋₁, q)  # q ← q - γₖ * vₖ₋₁
        kaxpy!(n, -βₖ, uₖ₋₁, p)  # p ← p - βₖ * uₖ₋₁
      end

      αₖ = kdot(m, vₖ, q)      # αₖ = ⟨vₖ,q⟩

      kaxpy!(m, -     αₖ , vₖ, q)    # q ← q - αₖ * vₖ
      kaxpy!(n, -conj(αₖ), uₖ, p)    # p ← p - ᾱₖ * uₖ

      βₖ₊₁ = knorm(m, q)       # βₖ₊₁ = ‖q‖
      γₖ₊₁ = knorm(n, p)       # γₖ₊₁ = ‖p‖

      # Update the LQ factorization of Tₖ = L̅ₖQₖ.
      #
      # [ α₁ γ₂ 0  •  •  •  0 ]   [ δ₁   0    •   •   •    •    0   ]
      # [ β₂ α₂ γ₃ •        • ]   [ λ₁   δ₂   •                 •   ]
      # [ 0  •  •  •  •     • ]   [ ϵ₁   λ₂   δ₃  •             •   ]
      # [ •  •  •  •  •  •  • ] = [ 0    •    •   •   •         •   ] Qₖ
      # [ •     •  •  •  •  0 ]   [ •    •    •   •   •    •    •   ]
      # [ •        •  •  •  γₖ]   [ •         •   •   •    •    0   ]
      # [ 0  •  •  •  0  βₖ αₖ]   [ •    •    •   0  ϵₖ₋₂ λₖ₋₁ δbarₖ]

      if iter == 1
        δbarₖ = αₖ
      elseif iter == 2
        # [δbar₁ γ₂] [c₂  s̄₂] = [δ₁   0  ]
        # [ β₂   α₂] [s₂ -c₂]   [λ₁ δbar₂]
        (cₖ, sₖ, δₖ₋₁) = sym_givens(δbarₖ₋₁, γₖ)
        λₖ₋₁  =      cₖ  * βₖ + sₖ * αₖ
        δbarₖ = conj(sₖ) * βₖ - cₖ * αₖ
      else
        # [0  βₖ  αₖ] [cₖ₋₁   s̄ₖ₋₁   0] = [sₖ₋₁βₖ  -cₖ₋₁βₖ  αₖ]
        #             [sₖ₋₁  -cₖ₋₁   0]
        #             [ 0      0     1]
        #
        # [ λₖ₋₂   δbarₖ₋₁  γₖ] [1   0   0 ] = [λₖ₋₂  δₖ₋₁    0  ]
        # [sₖ₋₁βₖ  -cₖ₋₁βₖ  αₖ] [0   cₖ  s̄ₖ]   [ϵₖ₋₂  λₖ₋₁  δbarₖ]
        #                       [0   sₖ -cₖ]
        (cₖ, sₖ, δₖ₋₁) = sym_givens(δbarₖ₋₁, γₖ)
        ϵₖ₋₂  =  sₖ₋₁ * βₖ
        λₖ₋₁  = -cₖ₋₁ *      cₖ  * βₖ + sₖ * αₖ
        δbarₖ = -cₖ₋₁ * conj(sₖ) * βₖ - cₖ * αₖ
      end

      # Compute ζₖ₋₁ and ζbarₖ, last components of the solution of L̅ₖz̅ₖ = β₁e₁
      # [δbar₁] [ζbar₁] = [β₁]
      if iter == 1
        ηₖ = βₖ
      end
      # [δ₁    0  ] [  ζ₁ ] = [β₁]
      # [λ₁  δbar₂] [ζbar₂]   [0 ]
      if iter == 2
        ζₖ₋₁ = ηₖ₋₁ / δₖ₋₁
        ηₖ   = -λₖ₋₁ * ζₖ₋₁
      end
      # [λₖ₋₂  δₖ₋₁    0  ] [ζₖ₋₂ ] = [0]
      # [ϵₖ₋₂  λₖ₋₁  δbarₖ] [ζₖ₋₁ ]   [0]
      #                     [ζbarₖ]
      if iter ≥ 3
        ζₖ₋₂ = ζₖ₋₁
        ζₖ₋₁ = ηₖ₋₁ / δₖ₋₁
        ηₖ   = -ϵₖ₋₂ * ζₖ₋₂ - λₖ₋₁ * ζₖ₋₁
      end

      # Relations for the directions dₖ₋₁ and d̅ₖ, the last two columns of D̅ₖ = Uₖ(Qₖ)ᴴ.
      # [d̅ₖ₋₁ uₖ] [cₖ  s̄ₖ] = [dₖ₋₁ d̅ₖ] ⟷ dₖ₋₁ = cₖ * d̅ₖ₋₁ + sₖ * uₖ
      #           [sₖ -cₖ]             ⟷ d̅ₖ   = s̄ₖ * d̅ₖ₋₁ - cₖ * uₖ
      if iter == 1
        # d̅₁ = u₁
        kcopy!(n, d̅, uₖ)  # d̅ ← uₖ
      else
        # Compute solution xₖ.
        # (xᴸ)ₖ ← (xᴸ)ₖ₋₁ + ζₖ₋₁ * dₖ₋₁
        kaxpy!(n, ζₖ₋₁ * cₖ,  d̅, x)
        kaxpy!(n, ζₖ₋₁ * sₖ, uₖ, x)

        # Compute d̅ₖ.
        # d̅ₖ = s̄ₖ * d̅ₖ₋₁ - cₖ * uₖ
        kaxpby!(n, -cₖ, uₖ, conj(sₖ), d̅)
      end

      # Compute vₖ₊₁ and uₖ₊₁.
      kcopy!(m, vₖ₋₁, vₖ)  # vₖ₋₁ ← vₖ
      kcopy!(n, uₖ₋₁, uₖ)  # uₖ₋₁ ← uₖ

      if βₖ₊₁ ≠ zero(T)
        kdivcopy!(m, vₖ, q, βₖ₊₁)  # vₖ₊₁ = q / βₖ₊₁
      end
      if γₖ₊₁ ≠ zero(T)
        kdivcopy!(n, uₖ, p, γₖ₊₁)  # uₖ₊₁ = p / γₖ₊₁
      end

      # Compute USYMLQ residual norm
      # ‖rₖ‖ = √(|μₖ|² + |ωₖ|²)
      if iter == 1
        rNorm_lq = bNorm
      else
        μₖ = βₖ * (sₖ₋₁ * ζₖ₋₂ - cₖ₋₁ * cₖ * ζₖ₋₁) + αₖ * sₖ * ζₖ₋₁
        ωₖ = βₖ₊₁ * sₖ * ζₖ₋₁
        rNorm_lq = sqrt(abs2(μₖ) + abs2(ωₖ))
      end
      history && push!(rNorms, rNorm_lq)

      # Compute USYMCG residual norm
      # ‖rₖ‖ = |ρₖ|
      if transfer_to_usymcg && (abs(δbarₖ) > eps(T))
        ζbarₖ = ηₖ / δbarₖ
        ρₖ = βₖ₊₁ * (sₖ * ζₖ₋₁ - cₖ * ζbarₖ)
        rNorm_cg = abs(ρₖ)
      end

      # Update sₖ₋₁, cₖ₋₁, ηₖ₋₁, γₖ, βₖ and δbarₖ₋₁.
      sₖ₋₁    = sₖ
      cₖ₋₁    = cₖ
      ηₖ₋₁    = ηₖ
      γₖ      = γₖ₊₁
      βₖ      = βₖ₊₁
      δbarₖ₋₁ = δbarₖ

      # Update stopping criterion.
      user_requested_exit = callback(workspace) :: Bool
      solved_lq = rNorm_lq ≤ ε
      solved_cg = transfer_to_usymcg && (abs(δbarₖ) > eps(T)) && (rNorm_cg ≤ ε)
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %.2fs\n", iter, rNorm_lq, start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Compute USYMCG point
    # (xᶜ)ₖ ← (xᴸ)ₖ + ζbarₖ * d̅ₖ
    if solved_cg
      kaxpy!(n, ζbarₖ, d̅, x)
    end

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    solved_lq           && (status = "solution xᴸ good enough given atol and rtol")
    solved_cg           && (status = "solution xᶜ good enough given atol and rtol")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update x
    warm_start && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved_lq || solved_cg
    stats.inconsistent = false
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

function test_verbose(FC)
  A   = FC.(get_div_grad(4, 4, 4))  # Dimension m x n
  m,n = size(A)
  k   = div(n, 2)
  Au  = A[1:k,:]          # Dimension k x n
  Ao  = A[:,1:k]          # Dimension m x k
  b   = Ao * ones(FC, k)  # Dimension m
  c   = Au * ones(FC, n)  # Dimension k
  mem = 10

  T = real(FC)
  shifts  = T[1; 2; 3; 4; 5]
  nshifts = 5

  for method in (:cg, :cgls, :usymqr, :cgne, :cgs, :crmr, :cg_lanczos, :dqgmres, :diom, :cr, :gpmr,
                 :lslq, :lsqr, :lsmr, :lnlq, :craig, :bicgstab, :craigmr, :crls, :symmlq, :minres,
                 :bilq, :minres_qlp, :qmr, :usymlq, :tricg, :trimr, :trilqr, :bilqr, :gmres, :fom,
                 :car, :minares, :fgmres, :usymlqr, :cg_lanczos_shift, :cgls_lanczos_shift)

    @testset "$method" begin
      io = IOBuffer()
      if method in (:trilqr, :bilqr)
        krylov_solve(Val{method}(), A, b, b, verbose=1, iostream=io)
      elseif method in (:tricg, :trimr, :usymlqr)
        krylov_solve(Val{method}(), Au, c, b, verbose=1, iostream=io)
      elseif method in (:lnlq, :craig, :craigmr, :cgne, :crmr)
        krylov_solve(Val{method}(), Au, c, verbose=1, iostream=io)
      elseif method in (:lslq, :lsqr, :lsmr, :cgls, :crls)
        krylov_solve(Val{method}(), Ao, b, verbose=1, iostream=io)
      elseif method == :usymlq
        krylov_solve(Val{method}(), Au, c, b, verbose=1, iostream=io)
      elseif method == :usymqr
        krylov_solve(Val{method}(), Ao, b, c, verbose=1, iostream=io)
      elseif method == :gpmr
        krylov_solve(Val{method}(), Ao, Au, b, c, verbose=1, iostream=io)
      elseif method in (:cg_lanczos_shift, :cgls_lanczos_shift)
        krylov_solve(Val{method}(), A, b, shifts, verbose=1, iostream=io)
      else
        krylov_solve(Val{method}(), A, b, verbose=1, iostream=io)
      end

      showed = String(take!(io))
      str = split(showed, '\n', keepempty=false)
      nrows = length(str)
      first_row = method in (:bilqr, :trilqr) ? 3 : 2
      last_row = method == :cg ? nrows-1 : nrows
      str = str[first_row:last_row]
      len_header = length(str[1])
      @test mapreduce(x -> length(x) == len_header, &, str)
    end
  end
end

@testset "verbose" begin
  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin
      test_verbose(FC)
    end
  end
end

# Strip SparseArrays (and therefore SuiteSparse) from the libkrylov build.
#
# The C/Fortran interface only exposes the Krylov solvers, never the processes
# (hermitian_lanczos, golub_kahan, ...), so SparseArrays is dead weight here.
# This script edits the working tree in place before the bundle is built:
#
#   * Project.toml      : drop the SparseArrays dep and compat entry
#   * src/Krylov.jl     : drop `using SparseArrays`, disable the *_processes.jl
#   * src/krylov_utils.jl : remove the two SparseVector ktypeof methods
#
# Every edit is anchored on a stable string/signature rather than on line
# numbers or surrounding context, so it survives code moving around. If an
# anchor is ever missing the script errors out loudly instead of silently
# leaving SparseArrays in the build.

const ROOT = normpath(joinpath(@__DIR__, "..", ".."))

"Apply `f` to the file, asserting that it actually changed the content."
function edit(f, relpath)
    path = joinpath(ROOT, relpath)
    old = read(path, String)
    new = f(old)
    new == old && error("trim_sparsearrays: no change in $relpath — an anchor is missing, refusing to build with SparseArrays still in.")
    write(path, new)
    println("  patched $relpath")
end

println("Trimming SparseArrays from the build...")

# --- Project.toml: remove the dep uuid line and the compat line ---------------
edit("Project.toml") do s
    replace(s, r"^SparseArrays = .*\n"m => "")
end

# --- src/Krylov.jl: drop the using and disable the two process files ----------
edit("src/Krylov.jl") do s
    s = replace(s, "using LinearAlgebra, SparseArrays, Printf" =>
                   "using LinearAlgebra, Printf")
    s = replace(s, "include(\"krylov_processes.jl\")" =>
                   "# include(\"krylov_processes.jl\")        # disabled: pulls SparseArrays -> SuiteSparse")
    s = replace(s, "include(\"block_krylov_processes.jl\")" =>
                   "# include(\"block_krylov_processes.jl\")  # disabled: pulls SparseArrays -> SuiteSparse")
    return s
end

# --- src/krylov_utils.jl: remove the two SparseVector ktypeof methods ---------
# Anchored on the method signatures; `.*?\r?\nend\r?\n` matches the (brace-free)
# body up to the first closing `end`, regardless of where the methods sit in the
# file. `\r?` keeps it working on Windows checkouts that use CRLF line endings.
edit("src/krylov_utils.jl") do s
    s = replace(s, r"function ktypeof\(v::S\) where S <: SparseVector.*?\r?\nend\r?\n"s => "")
    s = replace(s, r"function ktypeof\(v::S\) where S <: AbstractSparseVector.*?\r?\nend\r?\n"s => "")
    return s
end

println("Done.")
println()
println("NOTE: this edited the working tree in place (Project.toml, src/Krylov.jl,")
println("      src/krylov_utils.jl). In CI the checkout is throwaway. For a LOCAL")
println("      build, restore your sources once the bundle is built with:")
println("          git restore Project.toml src/Krylov.jl src/krylov_utils.jl")

@testset "cg" begin
  cg_tol = 1.0e-6

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      # Cubic spline matrix.
      A, b = symmetric_definite(FC=FC)
      (x, stats) = cg(A, b, itmax=10)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ cg_tol)
      @test(stats.solved)

      if FC == Float64
        radius = 0.75 * norm(x)
        (x, stats) = cg(A, b, radius=radius, itmax=10)
        @test(stats.solved)
        @test(abs(radius - norm(x)) ≤ cg_tol * radius)
      end

      # Sparse Laplacian.
      A, b = sparse_laplacian(FC=FC)
      (x, stats) = cg(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ cg_tol)
      @test(stats.solved)

      if FC == Float64
        radius = 0.75 * norm(x)
        (x, stats) = cg(A, b, radius=radius, itmax=10)
        @test(stats.solved)
        @test(abs(radius - norm(x)) ≤ cg_tol * radius)
      end

      # Test b == 0
      A, b = zero_rhs(FC=FC)
      (x, stats) = cg(A, b)
      @test norm(x) == 0
      @test stats.status == "x is a zero-residual solution"

      # Test with Jacobi (or diagonal) preconditioner
      A, b, M = square_preconditioned(FC=FC)
      (x, stats) = cg(A, b, M=M)
      r = b - A * x
      resid = sqrt(real(dot(r, M * r))) / sqrt(real(dot(b, M * b)))
      @test(resid ≤ cg_tol)
      @test(stats.solved)

      # Test line search with A indefinite; in this example, CG should stop at the first iteration
      A, b = symmetric_indefinite(FC = FC; shift = 10)
      solver = CgWorkspace(A, b)
      cg!(solver,A, b, linesearch=true)
      x, stats, npc_dir = solver.x, solver.stats, solver.npc_dir
      @test stats.status == "nonpositive curvature"
      @test !stats.inconsistent
      @test stats.niter == 0
      @test stats.indefinite == true
      @test stats.npcCount == 1
      @test real(dot(npc_dir, A * npc_dir)) <= 0
      @test all(npc_dir .== b)

      # Test when b^TAb=0 and linesearch is true
      A, b = zero_rhs(FC=FC)
      solver = CgWorkspace(A, b)
      cg!(solver, A, b, linesearch=true)
      x, stats, npc_dir = solver.x, solver.stats, solver.npc_dir
      @test stats.status == "x is a zero-residual solution"
      @test norm(x) == zero(FC)
      @test stats.niter == 0

      # Test radius > 0  and b^TAb=0
      A, b = zero_rhs(FC=FC)
      solver = CgWorkspace(A, b)
      cg!(solver, A, b,radius = 10 * real(one(FC)))
      x, stats, npc_dir = solver.x, solver.stats, solver.npc_dir
      @test stats.status == "x is a zero-residual solution"
      @test norm(x) == zero(FC)
      @test stats.niter == 0

      # Test radius > 0 and pᵀAp < 0
      A = FC[
        10.0 0.0 0.0 0.0;
        0.0 8.0 0.0 0.0;
        0.0 0.0 5.0 0.0;
        0.0 0.0 0.0 -1.0
      ]
      b = FC[1.0, 1.0, 1.0, 0.1]
      solver = CgWorkspace(A, b)
      cg!(solver, A, b; radius = 10 * real(one(FC)))
      x, stats, npc_dir = solver.x, solver.stats, solver.npc_dir
      @test stats.npcCount == 1
      @test stats.status == "nonpositive curvature"
      @test stats.indefinite == true
      @test real(dot(npc_dir, A * npc_dir)) <= 0.01 

      # Test singular and consistent system
      A, b = singular_consistent(FC=FC)
      x, stats = cg(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ cg_tol)
      @test !stats.inconsistent

      # Test inconsistent system
      if FC == Float64
        A, b = square_inconsistent(FC=FC)
        x, stats = cg(A, b)
        @test stats.inconsistent
      end

      # Poisson equation in cartesian coordinates.
      A, b = cartesian_poisson(FC=FC)
      (x, stats) = cg(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ cg_tol)
      @test(stats.solved)

      # test callback function
      A, b = cartesian_poisson(FC=FC)
      workspace = CgWorkspace(A, b)
      tol = 1.0e-1
      cb_n2 = TestCallbackN2(A, b, tol = tol)
      cg!(workspace, A, b, callback = cb_n2)
      @test workspace.stats.status == "user-requested exit"
      @test cb_n2(workspace)

      @test_throws TypeError cg(A, b, callback = workspace -> "string", history = true)
      
      # Test that the cg workspace throws an error when radius > 0 and linesearch is true
      A, b = symmetric_indefinite(FC = FC, shift = 5)
      @test_throws ErrorException cg(A, b, radius = real(one(FC)), linesearch = true)
      
      # Test: Ensure stats are reset when reusing workspace
      # (pᵀAp < 0)
      A = FC[
        10.0 0.0 0.0 0.0;
        0.0 8.0 0.0 0.0;
        0.0 0.0 5.0 0.0;
        0.0 0.0 0.0 -1.0
      ]
      b = FC[1.0, 1.0, 1.0, 0.1]
      
      # Initialize workspace and solve
      solver = CgWorkspace(A, b)
      cg!(solver, A, b; linesearch=true)
      
      # Verify the "npc" state was recorded
      @test solver.stats.npcCount == 1
      @test solver.stats.indefinite == true
      @test solver.stats.status == "nonpositive curvature"

      # Reuse the SAME solver on a Positive Definite System

      A = FC[
        10.0 0.0 0.0 0.0;
        0.0 8.0 0.0 0.0;
        0.0 0.0 5.0 0.0;
        0.0 0.0 0.0 1.0
      ]
      b = FC[1.0, 1.0, 1.0, 1.0]

      # Run the solver again on the same workspace
      cg!(solver, A, b; linesearch=true)
      # Verify the RESET works
      @test solver.stats.npcCount == 0
      @test solver.stats.indefinite == false
      @test solver.stats.solved == true
      
    end
  end
end

# An implementation of LSLQ for the solution of the
# over-determined linear least-squares problem
#
#  minimize ‖Ax - b‖₂
#
# equivalently, of the normal equations
#
#  AᴴAx = Aᴴb.
#
# LSLQ is formally equivalent to applying SYMMLQ to the normal equations
# but should be more stable.
#
# This method is described in
#
# R. Estrin, D. Orban and M.A. Saunders
# LSLQ: An Iterative Method for Linear Least-Squares with an Error Minimization Property
# SIAM Journal on Matrix Analysis and Applications, 40(1), pp. 254--275, 2019.
#
# Dominique Orban, <dominique.orban@gerad.ca>
# Montreal, QC, November 2016-January 2017.

export lslq, lslq!

"""
    (x, stats) = lslq(A, b::AbstractVector{FC};
                      M=I, N=I, ldiv::Bool=false,
                      window::Int=5, transfer_to_lsqr::Bool=false,
                      sqd::Bool=false, λ::T=zero(T),
                      σ::T=zero(T), etol::T=√eps(T),
                      utol::T=√eps(T), btol::T=√eps(T),
                      conlim::T=1/√eps(T), atol::T=√eps(T),
                      rtol::T=√eps(T), itmax::Int=0,
                      timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                      callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

Solve the regularized linear least-squares problem

    minimize ‖b - Ax‖₂² + λ²‖x‖₂²

of size m × n using the LSLQ method, where λ ≥ 0 is a regularization parameter.
LSLQ is formally equivalent to applying SYMMLQ to the normal equations

    (AᴴA + λ²I) x = Aᴴb

but is more stable.

If `λ > 0`, we solve the symmetric and quasi-definite system

    [ E      A ] [ r ]   [ b ]
    [ Aᴴ  -λ²F ] [ x ] = [ 0 ],

where E and F are symmetric and positive definite.
Preconditioners M = E⁻¹ ≻ 0 and N = F⁻¹ ≻ 0 may be provided in the form of linear operators.
If `sqd=true`, `λ` is set to the common value `1`.

The system above represents the optimality conditions of

    minimize ‖b - Ax‖²_E⁻¹ + λ²‖x‖²_F.

For a symmetric and positive definite matrix `K`, the K-norm of a vector `x` is `‖x‖²_K = xᴴKx`.
LSLQ is then equivalent to applying SYMMLQ to `(AᴴE⁻¹A + λ²F)x = AᴴE⁻¹b` with `r = E⁻¹(b - Ax)`.

If `λ = 0`, we solve the symmetric and indefinite system

    [ E    A ] [ r ]   [ b ]
    [ Aᴴ   0 ] [ x ] = [ 0 ].

The system above represents the optimality conditions of

    minimize ‖b - Ax‖²_E⁻¹.

In this case, `N` can still be specified and indicates the weighted norm in which `x` and `Aᴴr` should be measured.
`r` can be recovered by computing `E⁻¹(b - Ax)`.

#### Main features

* the solution estimate is updated along orthogonal directions
* the norm of the solution estimate ‖xᴸₖ‖₂ is increasing
* the error ‖eₖ‖₂ := ‖xᴸₖ - x*‖₂ is decreasing
* it is possible to transition cheaply from the LSLQ iterate to the LSQR iterate if there is an advantage (there always is in terms of error)
* if `A` is rank deficient, identify the minimum least-squares solution

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :lslq`.

For an in-place variant that reuses memory across solves, see [`lslq!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `m` used for centered preconditioning of the augmented system;
* `N`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning of the augmented system;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `window`: number of iterations used to accumulate a lower bound on the error;
* `transfer_to_lsqr`: transfer from the LSLQ point to the LSQR point, when it exists. The transfer is based on the residual norm;
* `sqd`: if `true`, set `λ=1` for Hermitian quasi-definite systems;
* `λ`: regularization parameter;
* `σ`: strict lower bound on the smallest positive singular value `σₘᵢₙ` such as `σ = (1-10⁻⁷)σₘᵢₙ`;
* `etol`: stopping tolerance based on the lower bound on the error;
* `utol`: stopping tolerance based on the upper bound on the error;
* `btol`: stopping tolerance used to detect zero-residual problems;
* `conlim`: limit on the estimated condition number of `A` beyond which the solution will be abandoned;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `m+n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`LSLQStats`](@ref) structure.

* `stats.err_lbnds` is a vector of lower bounds on the LQ error---the vector is empty if `window` is set to zero
* `stats.err_ubnds_lq` is a vector of upper bounds on the LQ error---the vector is empty if `σ == 0` is left at zero
* `stats.err_ubnds_cg` is a vector of upper bounds on the CG error---the vector is empty if `σ == 0` is left at zero
* `stats.error_with_bnd` is a boolean indicating whether there was an error in the upper bounds computation (cancellation errors, too large σ ...)

#### Stopping conditions

The iterations stop as soon as one of the following conditions holds true:

* the optimality residual is sufficiently small (`stats.status = "found approximate minimum least-squares solution"`) in the sense that either
  * ‖Aᴴr‖ / (‖A‖ ‖r‖) ≤ atol, or
  * 1 + ‖Aᴴr‖ / (‖A‖ ‖r‖) ≤ 1
* an approximate zero-residual solution has been found (`stats.status = "found approximate zero-residual solution"`) in the sense that either
  * ‖r‖ / ‖b‖ ≤ btol + atol ‖A‖ * ‖xᴸ‖ / ‖b‖, or
  * 1 + ‖r‖ / ‖b‖ ≤ 1
* the estimated condition number of `A` is too large in the sense that either
  * 1/cond(A) ≤ 1/conlim (`stats.status = "condition number exceeds tolerance"`), or
  * 1 + 1/cond(A) ≤ 1 (`stats.status = "condition number seems too large for this machine"`)
* the lower bound on the LQ forward error is less than etol * ‖xᴸ‖
* the upper bound on the CG forward error is less than utol * ‖xᶜ‖

#### References

* R. Estrin, D. Orban and M. A. Saunders, [*Euclidean-norm error bounds for SYMMLQ and CG*](https://doi.org/10.1137/16M1094816), SIAM Journal on Matrix Analysis and Applications, 40(1), pp. 235--253, 2019.
* R. Estrin, D. Orban and M. A. Saunders, [*LSLQ: An Iterative Method for Linear Least-Squares with an Error Minimization Property*](https://doi.org/10.1137/17M1113552), SIAM Journal on Matrix Analysis and Applications, 40(1), pp. 254--275, 2019.
"""
function lslq end

"""
    workspace = lslq!(workspace::LslqWorkspace, A, b; kwargs...)

In this call, `kwargs` are keyword arguments of [`lslq`](@ref).
The keyword argument `window` is the only exception.
It is only supported by [`lslq`](@ref) and is required to create a `LslqWorkspace`.
It cannot be changed later.

See [`LslqWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :lslq` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function lslq! end

def_args_lslq = (:(A                    ),
                 :(b::AbstractVector{FC}))

def_kwargs_lslq = (:(; M = I                         ),
                   :(; N = I                         ),
                   :(; ldiv::Bool = false            ),
                   :(; transfer_to_lsqr::Bool = false),
                   :(; sqd::Bool = false             ),
                   :(; λ::T = zero(T)                ),
                   :(; σ::T = zero(T)                ),
                   :(; etol::T = √eps(T)             ),
                   :(; utol::T = √eps(T)             ),
                   :(; btol::T = √eps(T)             ),
                   :(; conlim::T = 1/√eps(T)         ),
                   :(; atol::T = √eps(T)             ),
                   :(; rtol::T = √eps(T)             ),
                   :(; itmax::Int = 0                ),
                   :(; timemax::Float64 = Inf        ),
                   :(; verbose::Int = 0              ),
                   :(; history::Bool = false         ),
                   :(; callback = workspace -> false ),
                   :(; iostream::IO = kstdout        ))

def_kwargs_workspace_lslq = (:(; window::Int = 5),)

def_kwargs_lslq = extract_parameters.(def_kwargs_lslq)
def_kwargs_workspace_lslq = extract_parameters.(def_kwargs_workspace_lslq)

args_lslq = (:A, :b)
kwargs_lslq = (:M, :N, :ldiv, :transfer_to_lsqr, :sqd, :λ, :σ, :etol, :utol, :btol, :conlim, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)
kwargs_workspace_lslq = (:window,)

@eval begin
  function lslq!(workspace :: LslqWorkspace{T,FC,Sm,Sn}, $(def_args_lslq...); $(def_kwargs_lslq...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "LSLQ: system of %d equations in %d variables\n", m, n)

    # Check sqd and λ parameters
    sqd && (λ ≠ 0) && error("sqd cannot be set to true if λ ≠ 0 !")
    sqd && (λ = one(T))

    # Tests M = Iₙ and N = Iₘ
    MisI = (M === I)
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == Sm || error("ktypeof(b) must be equal to $Sm")

    # Compute the adjoint of A
    Aᴴ = A'

    # Set up workspace.
    allocate_if(!MisI, workspace, :u, Sm, workspace.Av)  # The length of u is m
    allocate_if(!NisI, workspace, :v, Sn, workspace.x)   # The length of v is n
    x, Nv, Aᴴu, w̄ = workspace.x, workspace.Nv, workspace.Aᴴu, workspace.w̄
    Mu, Av, err_vec, stats = workspace.Mu, workspace.Av, workspace.err_vec, workspace.stats
    rNorms, ArNorms, err_lbnds = stats.residuals, stats.Aresiduals, stats.err_lbnds
    err_ubnds_lq, err_ubnds_cg = stats.err_ubnds_lq, stats.err_ubnds_cg
    reset!(stats)
    u = MisI ? Mu : workspace.u
    v = NisI ? Nv : workspace.v

    λ² = λ * λ
    ctol = conlim > 0 ? 1/conlim : zero(T)

    kfill!(x, zero(FC))  # LSLQ point

    # Initialize Golub-Kahan process.
    # β₁ M u₁ = b.
    kcopy!(m, Mu, b)  # Mu ← b
    MisI || mulorldiv!(u, M, Mu, ldiv)
    β₁ = knorm_elliptic(m, u, Mu)
    if β₁ == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.error_with_bnd = false
      history && push!(rNorms, zero(T))
      history && push!(ArNorms, zero(T))
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      return workspace
    end
    β = β₁

    kdiv!(m, u, β₁)
    MisI || kdiv!(m, Mu, β₁)
    kmul!(Aᴴu, Aᴴ, u)
    kcopy!(n, Nv, Aᴴu)  # Nv ← Aᴴu
    NisI || mulorldiv!(v, N, Nv, ldiv)
    α = knorm_elliptic(n, v, Nv)  # = α₁

    # Aᴴb = 0 so x = 0 is a minimum least-squares solution
    if α == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.error_with_bnd = false
      history && push!(rNorms, β₁)
      history && push!(ArNorms, zero(T))
      stats.timer = start_time |> ktimer
      stats.status = "x is a minimum least-squares solution"
      return workspace
    end
    kdiv!(n, v, α)
    NisI || kdiv!(n, Nv, α)

    Anorm = α
    Anorm² = α * α

    # condition number estimate
    σmax = zero(T)
    σmin = Inf
    Acond  = zero(T)

    xlqNorm  = zero(T)
    xlqNorm² = zero(T)
    xcgNorm  = zero(T)
    xcgNorm² = zero(T)

    kcopy!(n, w̄, v)  # w̄₁ = v₁

    err_lbnd = zero(T)
    window = length(err_vec)
    kfill!(err_vec, zero(T))
    complex_error_bnd = false

    # Initialize other constants.
    αL = α
    βL = β
    ρ̄ = -σ
    γ̄ = α
    ψ = β₁
    c = -one(T)
    s = zero(T)
    δ = -one(T)
    τ = α * β₁
    ζ = zero(T)
    ζ̄  = zero(T)
    ζ̃  = zero(T)
    csig = -one(T)

    rNorm = β₁
    history && push!(rNorms, rNorm)
    ArNorm = α * β
    history && push!(ArNorms, ArNorm)

    iter = 0
    itmax == 0 && (itmax = m + n)

    (verbose > 0) && @printf(iostream, "%5s  %7s  %7s  %7s  %7s  %8s  %8s  %7s  %7s  %7s  %5s\n", "k", "‖r‖", "‖Aᴴr‖", "β", "α", "cos", "sin", "‖A‖²", "κ(A)", "‖xL‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %7.1e  %8.1e  %8.1e  %7.1e  %7.1e  %7.1e  %.2fs\n", iter, rNorm, ArNorm, β, α, c, s, Anorm², Acond, xlqNorm, start_time |> ktimer)

    status = "unknown"
    ε = atol + rtol * β₁
    solved = solved_mach = solved_lim = (rNorm ≤ ε)
    tired  = iter ≥ itmax
    ill_cond = ill_cond_mach = ill_cond_lim = false
    zero_resid = zero_resid_mach = zero_resid_lim = false
    fwd_err_lbnd = false
    fwd_err_ubnd = false
    user_requested_exit = false
    overtimed = false

    while ! (solved || tired || ill_cond || user_requested_exit || overtimed)

      # Generate next Golub-Kahan vectors.
      # 1. βₖ₊₁Muₖ₊₁ = Avₖ - αₖMuₖ
      kmul!(Av, A, v)
      kaxpby!(m, one(FC), Av, -α, Mu)
      MisI || mulorldiv!(u, M, Mu, ldiv)
      β = knorm_elliptic(m, u, Mu)
      if β ≠ 0
        kdiv!(m, u, β)
        MisI || kdiv!(m, Mu, β)

        # 2. αₖ₊₁Nvₖ₊₁ = Aᴴuₖ₊₁ - βₖ₊₁Nvₖ
        kmul!(Aᴴu, Aᴴ, u)
        kaxpby!(n, one(FC), Aᴴu, -β, Nv)
        NisI || mulorldiv!(v, N, Nv, ldiv)
        α = knorm_elliptic(n, v, Nv)
        if α ≠ 0
          kdiv!(n, v, α)
          NisI || kdiv!(n, Nv, α)
        end

        # rotate out regularization term if present
        αL = α
        βL = β
        if λ ≠ 0
          (cL, sL, βL) = sym_givens(β, λ)
          αL = cL * α

          # the rotation updates the next regularization parameter
          λ = sqrt(λ² + (sL * α)^2)
        end
        Anorm² = Anorm² + αL * αL + βL * βL  # = ‖Lₖ‖²
        Anorm = sqrt(Anorm²)
      end

      # Continue QR factorization of Bₖ
      #
      #       k   k+1     k   k+1      k  k+1
      # k   [ c'   s' ] [ γ̄      ] = [ γ   δ  ]
      # k+1 [ s'  -c' ] [ β   α⁺ ]   [     γ̄  ]
      (cp, sp, γ) = sym_givens(γ̄, βL)
      τ = -τ * δ / γ  # forward substitution for t
      δ = sp * αL
      γ̄ = -cp * αL

      if σ > 0 && !complex_error_bnd
        # Continue QR factorization for error estimate
        μ̄ = -csig * γ
        (csig, ssig, ρ) = sym_givens(ρ̄, γ)
        ρ̄ = ssig * μ̄ + csig * σ
        μ̄ = -csig * δ

        # determine component of eigenvector and Gauss-Radau parameter
        h = δ * csig / ρ̄
        disc = σ * (σ - δ * h)
        disc < 0 ? complex_error_bnd = true : ω = sqrt(disc)
        (csig, ssig, ρ) = sym_givens(ρ̄, δ)
        ρ̄ = ssig * μ̄ + csig * σ
      end

      # Continue LQ factorization of Rₖ
      ϵ̄ = -γ * c
      η = γ * s
      (c, s, ϵ) = sym_givens(ϵ̄, δ)

      # condition number estimate
      # the QLP factorization suggests that the diagonal of M̄ approximates
      # the singular values of B.
      σmax = max(σmax, ϵ, abs(ϵ̄))
      σmin = min(σmin, ϵ, abs(ϵ̄))
      Acond = σmax / σmin

      # forward substitution for z, ζ̄
      ζold = ζ
      ζ = (τ - ζ * η) / ϵ
      ζ̄ = ζ / c

      # residual norm estimate
      rNorm = sqrt((ψ * cp - ζold * η)^2 + (ψ * sp)^2)
      history && push!(rNorms, rNorm)

      ArNorm = sqrt((γ * ϵ * ζ)^2 + (δ * η * ζold)^2)
      history && push!(ArNorms, ArNorm)

      # Compute ψₖ
      ψ = ψ * sp

      # Compute ‖x_cg‖₂
      xcgNorm² = xlqNorm² + ζ̄ * ζ̄

      if σ > 0 && iter > 0 && !complex_error_bnd
        disc = ζ̃ * ζ̃ - ζ̄  * ζ̄ 
        if disc < 0
          complex_error_bnd = true
        else
          err_ubnd_cg = sqrt(disc)
          history && push!(err_ubnds_cg, err_ubnd_cg)
          fwd_err_ubnd = err_ubnd_cg ≤ utol * sqrt(xcgNorm²)
        end
      end

      test1 = rNorm
      test2 = ArNorm / (Anorm * rNorm)
      test3 = inv(Acond)
      t1    = test1 / (one(T) + Anorm * xlqNorm)
      tol   = btol + atol * Anorm * xlqNorm / β₁

      # update LSLQ point for next iteration
      kaxpy!(n, c * ζ, w̄, x)
      kaxpy!(n, s * ζ, v, x)

      # compute w̄
      kaxpby!(n, -c, v, s, w̄)

      xlqNorm² += ζ * ζ
      xlqNorm = sqrt(xlqNorm²)

      # check stopping condition based on forward error lower bound
      err_vec[mod(iter, window) + 1] = ζ
      if iter ≥ window
        err_lbnd = knorm(window, err_vec)
        history && push!(err_lbnds, err_lbnd)
        fwd_err_lbnd = err_lbnd ≤ etol * xlqNorm
      end

      # compute LQ forward error upper bound
      if σ > 0 && !complex_error_bnd
        η̃ = ω * s
        ϵ̃ = -ω * c
        τ̃ = -τ * δ / ω
        ζ̃ = (τ̃ - ζ * η̃) / ϵ̃
        history && push!(err_ubnds_lq, abs(ζ̃ ))
      end

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      ill_cond_mach = (one(T) + test3 ≤ one(T))
      solved_mach = (one(T) + test2 ≤ one(T))
      zero_resid_mach = (one(T) + t1 ≤ one(T))

      # Stopping conditions based on user-provided tolerances.
      user_requested_exit = callback(workspace) :: Bool
      tired  = iter ≥ itmax
      ill_cond_lim = (test3 ≤ ctol)
      solved_lim = (test2 ≤ atol)
      zero_resid_lim = (test1 ≤ ε)

      ill_cond = ill_cond_mach || ill_cond_lim
      zero_resid = zero_resid_mach || zero_resid_lim
      solved = solved_mach || solved_lim || zero_resid || fwd_err_lbnd || fwd_err_ubnd
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns

      iter = iter + 1
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %7.1e  %8.1e  %8.1e  %7.1e  %7.1e  %7.1e  %.2fs\n", iter, rNorm, ArNorm, β, α, c, s, Anorm, Acond, xlqNorm, start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    if transfer_to_lsqr  # compute LSQR point
      kaxpy!(n, ζ̄ , w̄, x)
    end

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    ill_cond_mach       && (status = "condition number seems too large for this machine")
    ill_cond_lim        && (status = "condition number exceeds tolerance")
    solved              && (status = "found approximate minimum least-squares solution")
    zero_resid          && (status = "found approximate zero-residual solution")
    fwd_err_lbnd        && (status = "forward error lower bound small enough")
    fwd_err_ubnd        && (status = "forward error upper bound small enough")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = !zero_resid
    stats.error_with_bnd = complex_error_bnd
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

@testset "minres" begin
  minres_tol = 1.0e-6

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      # Cubic spline matrix.
      A, b = symmetric_definite(FC=FC)
      (x, stats) = minres(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ minres_tol * norm(A) * norm(x))
      @test(stats.solved)

      # Symmetric indefinite variant.
      A, b = symmetric_indefinite(FC=FC)
      (x, stats) = minres(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ minres_tol * norm(A) * norm(x))
      @test(stats.solved)

      # Sparse Laplacian.
      A, b = sparse_laplacian(FC=FC)
      (x, stats) = minres(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ minres_tol * norm(A) * norm(x))
      @test(stats.solved)

      # Symmetric indefinite variant, almost singular.
      A, b = almost_singular(FC=FC)
      (x, stats) = minres(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ minres_tol * norm(A) * norm(x))
      @test(stats.solved)

      # Test b == 0
      A, b = zero_rhs(FC=FC)
      (x, stats) = minres(A, b)
      @test norm(x) == 0
      @test stats.status == "x is a zero-residual solution"

      # Shifted system
      A, b = symmetric_indefinite(FC=FC)
      λ = 2.0
      (x, stats) = minres(A, b, λ=λ)
      r = b - (A + λ*I) * x
      resid = norm(r) / norm(b)
      @test(resid ≤ minres_tol * norm(A) * norm(x))
      @test(stats.solved)

      # test with Jacobi (or diagonal) preconditioner and history = true
      A, b, M = square_preconditioned(FC=FC)
      (x, stats) = minres(A, b, M=M, history=true)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ minres_tol * norm(A) * norm(x))
      @test(stats.solved)
      @test(length(stats.residuals) > 0)

      # in-place minres (minres!) with Jacobi (or diagonal) preconditioner
      A, b, M = square_preconditioned(FC=FC)
      workspace = MinresWorkspace(A, b)
      minres!(workspace, A, b, M=M)
      r = b - A * workspace.x
      resid = norm(r) / norm(b)
      @test(resid ≤ minres_tol * norm(A) * norm(x))
      @test(stats.solved)
      @test stats.indefinite == false

      # Test: Ensure stats are reset when reusing workspace
      # (pᵀAp < 0)
      A = FC[
        10.0 0.0 0.0 0.0;
        0.0 8.0 0.0 0.0;
        0.0 0.0 5.0 0.0;
        0.0 0.0 0.0 -1.0
      ]
      b = FC[1.0, 1.0, 1.0, 0.1]
      
      # Initialize workspace and solve
      solver = MinresWorkspace(A, b)
      minres!(solver, A, b; linesearch=true)
      
      # Verify the "npc" state was recorded
      @test solver.stats.npcCount == 2
      @test solver.stats.indefinite == true
      @test solver.stats.status == "nonpositive curvature"

      # Reuse the SAME solver on a Positive Definite System

      A = FC[
        10.0 0.0 0.0 0.0;
        0.0 8.0 0.0 0.0;
        0.0 0.0 5.0 0.0;
        0.0 0.0 0.0 1.0
      ]
      b = FC[1.0, 1.0, 1.0, 1.0]

      # Run the solver again on the same workspace
      minres!(solver, A, b; linesearch=true)

      # Verify the RESET works
      @test solver.stats.npcCount == 0
      @test solver.stats.indefinite == false
      @test solver.stats.solved == true

      # Test linesearch
      A, b = symmetric_indefinite(FC=FC)
      workspace = MinresWorkspace(A, b)
      minres!(workspace, A, b, linesearch=true)
      x, stats, npc_dir = workspace.x, workspace.stats, workspace.npc_dir
      @test stats.status == "nonpositive curvature"
      @test stats.indefinite == true
      # Verify that the returned direction indeed exhibits nonpositive curvature.
      # For both real and complex cases, ensure to take the real part.
      @test real(dot(npc_dir, A * npc_dir)) <= 0

      # Test Linesearch which would stop on the first call since A is negative definite
      A, b = symmetric_indefinite(FC=FC; shift = 5)
      workspace = MinresWorkspace(A, b)
      minres!(workspace, A, b, linesearch=true)
      x, stats, npc_dir = workspace.x, workspace.stats, workspace.npc_dir
      @test stats.status == "nonpositive curvature"
      @test stats.niter == 1 # in Minres they add 1 to the number of iterations first step
      @test all(x .== b)
      @test stats.solved == true
      @test stats.indefinite == true
      @test stats.npcCount == 1
      @test real(dot(npc_dir, A * npc_dir)) <= 0

      # Test when b^TAb=0 and linesearch is true
      A, b = system_zero_quad(FC=FC)
      workspace = MinresWorkspace(A, b)
      minres!(workspace, A, b, linesearch=true)
      x, stats, npc_dir = workspace.x, workspace.stats, workspace.npc_dir
      @test stats.status == "nonpositive curvature"
      @test all(x .== b)
      @test stats.solved == true
      @test stats.indefinite == true
      @test real(dot(npc_dir, A * npc_dir)) ≈ 0.0

      # negative curvature
      A = FC[
        10.0 0.0 0.0 0.0;
        0.0 8.0 0.0 0.0;
        0.0 0.0 5.0 0.0;
        0.0 0.0 0.0 -1.0
      ]
      b = FC[1.0, 1.0, 1.0, 0.1]
      solver = MinresWorkspace(A, b)
      minres!(solver, A, b; linesearch = true)
      x, stats, npc_dir, w1 = solver.x, solver.stats, solver.npc_dir, solver.w1
      @test stats.npcCount == 2
      @test real(dot(npc_dir, A*npc_dir)) ≤ norm(npc_dir)^2 + minres_tol
      @test real(dot(w1, A*w1)) < minres_tol

      # Test if warm_start and linesearch are both true, it should throw an error
      A, b = symmetric_indefinite(FC=FC)
      @test_throws MethodError minres(A, b, warm_start = true, linesearch = true)          

      # test callback function
      workspace = MinresWorkspace(A, b)
      storage_vec = similar(b, size(A, 1))
      tol = 1.0e-1
      cb_n2 = TestCallbackN2(A, b, tol = tol)
      x, stats = minres(A, b, callback = workspace -> cb_n2(workspace)) # n = 10
      minres!(workspace, A, b, callback = cb_n2)
      @test workspace.stats.status == "user-requested exit"
      @test cb_n2(workspace)

      @test_throws TypeError minres(A, b, callback = workspace -> "string", history = true)
    end
  end
end

# An implementation of CRAIG-MR for the solution of the
# (under/over-determined or square) linear system
#
#  Ax = b.
#
# The method seeks to solve the minimum-norm problem
#
#  min ‖x‖  s.t.  x ∈ argmin ‖Ax - b‖,
#
# and is equivalent to applying the conjugate residual method
# to the linear system
#
#  AAᴴy = b.
#
# This method is equivalent to CRMR, and is described in
#
# D. Orban and M. Arioli. Iterative Solution of Symmetric Quasi-Definite Linear Systems,
# Volume 3 of Spotlights. SIAM, Philadelphia, PA, 2017.
#
# D. Orban, The Projected Golub-Kahan Process for Constrained
# Linear Least-Squares Problems. Cahier du GERAD G-2014-15,
# GERAD, Montreal QC, Canada, 2014.
#
# Dominique Orban, <dominique.orban@gerad.ca>
# Montreal, QC, May 2015.

export craigmr, craigmr!

"""
    (x, y, stats) = craigmr(A, b::AbstractVector{FC};
                            M=I, N=I, ldiv::Bool=false,
                            sqd::Bool=false, λ::T=zero(T), atol::T=√eps(T),
                            rtol::T=√eps(T), itmax::Int=0,
                            timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                            callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

Solve the consistent linear system

    Ax + λ²y = b

of size m × n using the CRAIGMR method, where λ ≥ 0 is a regularization parameter.
This method is equivalent to applying the Conjugate Residuals method
to the normal equations of the second kind

    (AAᴴ + λ²I) y = b

but is more stable. When λ = 0, this method solves the minimum-norm problem

    min ‖x‖  s.t.  x ∈ argmin ‖Ax - b‖.

If `λ > 0`, CRAIGMR solves the symmetric and quasi-definite system

    [ -F    Aᴴ ] [ x ]   [ 0 ]
    [  A  λ²E  ] [ y ] = [ b ],

where E and F are symmetric and positive definite.
Preconditioners M = E⁻¹ ≻ 0 and N = F⁻¹ ≻ 0 may be provided in the form of linear operators.
If `sqd=true`, `λ` is set to the common value `1`.

The system above represents the optimality conditions of

    min ‖x‖²_F + λ²‖y‖²_E  s.t.  Ax + λ²Ey = b.

For a symmetric and positive definite matrix `K`, the K-norm of a vector `x` is `‖x‖²_K = xᴴKx`.
CRAIGMR is then equivalent to applying MINRES to `(AF⁻¹Aᴴ + λ²E)y = b` with `Fx = Aᴴy`.

If `λ = 0`, CRAIGMR solves the symmetric and indefinite system

    [ -F   Aᴴ ] [ x ]   [ 0 ]
    [  A   0  ] [ y ] = [ b ].

The system above represents the optimality conditions of

    min ‖x‖²_F  s.t.  Ax = b.

In this case, `M` can still be specified and indicates the weighted norm in which residuals are measured.

CRAIGMR produces monotonic residuals ‖r‖₂.
It is formally equivalent to CRMR, though can be slightly more accurate,
and intricate to implement. Both the x- and y-parts of the solution are
returned.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :craigmr`.

For an in-place variant that reuses memory across solves, see [`craigmr!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `m` used for centered preconditioning of the augmented system;
* `N`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning of the augmented system;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `sqd`: if `true`, set `λ=1` for Hermitian quasi-definite systems;
* `λ`: regularization parameter;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `m+n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `y`: a dense vector of length `m`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### References

* D. Orban and M. Arioli. [*Iterative Solution of Symmetric Quasi-Definite Linear Systems*](https://doi.org/10.1137/1.9781611974737), Volume 3 of Spotlights. SIAM, Philadelphia, PA, 2017.
* D. Orban, [*The Projected Golub-Kahan Process for Constrained, Linear Least-Squares Problems*](https://dx.doi.org/10.13140/RG.2.2.17443.99360). Cahier du GERAD G-2014-15, 2014.
"""
function craigmr end

"""
    workspace = craigmr!(workspace::CraigmrWorkspace, A, b; kwargs...)

In this call, `kwargs` are keyword arguments of [`craigmr`](@ref).

See [`CraigmrWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :craigmr` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function craigmr! end

def_args_craigmr = (:(A                    ),
                    :(b::AbstractVector{FC}))

def_kwargs_craigmr = (:(; M = I                        ),
                      :(; N = I                        ),
                      :(; ldiv::Bool = false           ),
                      :(; sqd::Bool = false            ),
                      :(; λ::T = zero(T)               ),
                      :(; atol::T = √eps(T)            ),
                      :(; rtol::T = √eps(T)            ),
                      :(; itmax::Int = 0               ),
                      :(; timemax::Float64 = Inf       ),
                      :(; verbose::Int = 0             ),
                      :(; history::Bool = false        ),
                      :(; callback = workspace -> false),
                      :(; iostream::IO = kstdout       ))

def_kwargs_craigmr = extract_parameters.(def_kwargs_craigmr)

args_craigmr = (:A, :b)
kwargs_craigmr = (:M, :N, :ldiv, :sqd, :λ, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function craigmr!(workspace :: CraigmrWorkspace{T,FC,Sm,Sn}, $(def_args_craigmr...); $(def_kwargs_craigmr...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "CRAIGMR: system of %d equations in %d variables\n", m, n)

    # Check sqd and λ parameters
    sqd && (λ ≠ 0) && error("sqd cannot be set to true if λ ≠ 0 !")
    sqd && (λ = one(T))

    # Tests M = Iₘ and N = Iₙ
    MisI = (M === I)
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == Sm || error("ktypeof(b) must be equal to $Sm")

    # Compute the adjoint of A
    Aᴴ = A'

    # Set up workspace.
    allocate_if(!MisI, workspace, :u, Sm, workspace.y)  # The length of u is m
    allocate_if(!NisI, workspace, :v, Sn, workspace.x)  # The length of v is n
    allocate_if(λ > 0, workspace, :q, Sn, workspace.x)  # The length of q is n
    x, Nv, Aᴴu, d, y, Mu = workspace.x, workspace.Nv, workspace.Aᴴu, workspace.d, workspace.y, workspace.Mu
    w, wbar, Av, q, stats = workspace.w, workspace.wbar, workspace.Av, workspace.q, workspace.stats
    rNorms, ArNorms = stats.residuals, stats.Aresiduals
    reset!(stats)
    u = MisI ? Mu : workspace.u
    v = NisI ? Nv : workspace.v

    # Compute y such that AAᴴy = b. Then recover x = Aᴴy.
    kfill!(x, zero(FC))
    kfill!(y, zero(FC))
    kcopy!(m, Mu, b)  # Mu ← b
    MisI || mulorldiv!(u, M, Mu, ldiv)
    β = knorm_elliptic(m, u, Mu)
    if β == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      history && push!(rNorms, β)
      history && push!(ArNorms, zero(T))
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      return workspace
    end

    # Initialize Golub-Kahan process.
    # β₁Mu₁ = b.
    kdiv!(m, u, β)
    MisI || kdiv!(m, Mu, β)
    # α₁Nv₁ = Aᴴu₁.
    kmul!(Aᴴu, Aᴴ, u)
    kcopy!(n, Nv, Aᴴu)  # Nv ← Aᴴu
    NisI || mulorldiv!(v, N, Nv, ldiv)
    α = knorm_elliptic(n, v, Nv)
    Anorm² = α * α

    iter = 0
    itmax == 0 && (itmax = m + n)

    (verbose > 0) && @printf(iostream, "%5s  %7s  %7s  %7s  %7s  %8s  %8s  %7s  %5s\n", "k", "‖r‖", "‖Aᴴr‖", "β", "α", "cos", "sin", "‖A‖²", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %7.1e  %8.1e  %8.1e  %7.1e  %.2fs\n", iter, β, α, β, α, 0, 1, Anorm², start_time |> ktimer)

    # Aᴴb = 0 so x = 0 is a minimum least-squares solution
    if α == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      history && push!(rNorms, β)
      history && push!(ArNorms, zero(T))
      stats.timer = start_time |> ktimer
      stats.status = "x is a minimum least-squares solution"
      return workspace
    end
    kdiv!(n, v, α)
    NisI || kdiv!(n, Nv, α)

    # Regularization.
    λₖ  = λ                   # λ₁ = λ
    cpₖ = spₖ = one(T)        # Givens sines and cosines used to zero out λₖ
    cdₖ = sdₖ = one(T)        # Givens sines and cosines used to define λₖ₊₁
    λ > 0 && kcopy!(n, q, v)  # Additional vector needed to update x, by definition q₀ = 0

    if λ > 0
      (cpₖ, spₖ, αhat) = sym_givens(α, λₖ)
      kscal!(n, spₖ, q)  # q̄₁ = sp₁ * v₁
    else
      αhat = α
    end

    # Initialize other constants.
    ζbar = β
    ρbar = αhat
    θ = zero(T)
    rNorm = ζbar
    history && push!(rNorms, rNorm)
    ArNorm = α
    history && push!(ArNorms, ArNorm)

    ɛ_c = atol + rtol * rNorm   # Stopping tolerance for consistent systems.
    ɛ_i = atol + rtol * ArNorm  # Stopping tolerance for inconsistent systems.

    kdivcopy!(m, wbar, u, αhat)
    kfill!(w, zero(FC))
    kfill!(d, zero(FC))

    status = "unknown"
    solved = rNorm ≤ ɛ_c
    inconsistent = (rNorm > 100 * ɛ_c) & (ArNorm ≤ ɛ_i)
    tired  = iter ≥ itmax
    user_requested_exit = false
    overtimed = false

    while ! (solved || inconsistent || tired || user_requested_exit || overtimed)
      iter = iter + 1

      # Generate next Golub-Kahan vectors.
      # 1. βₖ₊₁Muₖ₊₁ = Avₖ - αₖMuₖ
      kmul!(Av, A, v)
      kaxpby!(m, one(FC), Av, -α, Mu)
      MisI || mulorldiv!(u, M, Mu, ldiv)
      β = knorm_elliptic(m, u, Mu)
      if β ≠ 0
        kdiv!(m, u, β)
        MisI || kdiv!(m, Mu, β)
      end

      Anorm² = Anorm² + β * β  # = ‖B_{k-1}‖²

      if λ > 0
        βhat = cpₖ * β
        λₐᵤₓ = spₖ * β
      else
        βhat = β
      end

      # Continue QR factorization
      #
      # Q [ Lₖ  β₁ e₁ ] = [ Rₖ   zₖ  ] :
      #   [ β    0    ]   [ 0   ζbar ]
      #
      #       k  k+1    k    k+1      k  k+1
      # k   [ c   s ] [ ρbar    ] = [ ρ  θ⁺    ]
      # k+1 [ s  -c ] [ β    α⁺ ]   [    ρbar⁺ ]
      #
      # so that we obtain
      #
      # [ c  s ] [ ζbar ] = [ ζ     ]
      # [ s -c ] [  0   ]   [ ζbar⁺ ]
      (c, s, ρ) = sym_givens(ρbar, βhat)
      ζ = c * ζbar
      ζbar = s * ζbar
      rNorm = abs(ζbar)
      history && push!(rNorms, rNorm)

      kaxpby!(m, one(FC)/ρ, wbar, -θ/ρ, w)  # w = (wbar - θ * w) / ρ
      kaxpy!(m, ζ, w, y)                    # y = y + ζ * w

      if λ > 0
        # DₖRₖ = V̅ₖ with v̅ₖ = cpₖvₖ + spₖqₖ₋₁
        if iter == 1
          kaxpy!(n, cpₖ/ρ, v, d)
        else
          kaxpby!(n, cpₖ/ρ, v, -θ/ρ, d)
          kaxpy!(n, spₖ/ρ, q, d)
          kaxpby!(n, spₖ, v, -cpₖ, q)  # q̄ₖ ← spₖ * vₖ - cpₖ * qₖ₋₁
        end
      else
        # DₖRₖ = Vₖ
        if iter == 1
          kdivcopy!(n, d, v, ρ)
        else
          kaxpby!(n, one(FC)/ρ, v, -θ/ρ, d)
        end
      end

      # xₖ = Dₖzₖ
      kaxpy!(n, ζ, d, x)

      # 2. αₖ₊₁Nvₖ₊₁ = Aᴴuₖ₊₁ - βₖ₊₁Nvₖ
      kmul!(Aᴴu, Aᴴ, u)
      kaxpby!(n, one(FC), Aᴴu, -β, Nv)
      NisI || mulorldiv!(v, N, Nv, ldiv)
      α = knorm_elliptic(n, v, Nv)
      Anorm² = Anorm² + α * α  # = ‖Lₖ‖
      ArNorm = α * β * abs(ζ/ρ)
      history && push!(ArNorms, ArNorm)

      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %7.1e  %8.1e  %8.1e  %7.1e  %.2fs\n", iter, rNorm, ArNorm, β, α, c, s, Anorm², start_time |> ktimer)

      if λ > 0
        (cdₖ, sdₖ, λₖ₊₁) = sym_givens(λ, λₐᵤₓ)
        kscal!(n, sdₖ, q)  # qₖ ← sdₖ * q̄ₖ
        (cpₖ, spₖ, αhat) = sym_givens(α, λₖ₊₁)
      else
        αhat = α
      end

      if α ≠ 0
        kdiv!(n, v, α)
        NisI || kdiv!(n, Nv, α)
        kaxpby!(m, one(FC)/αhat, u, -βhat / αhat, wbar)  # wbar = (u - beta * wbar) / alpha
      end
      θ    =  s * αhat
      ρbar = -c * αhat

      user_requested_exit = callback(workspace) :: Bool
      solved = rNorm ≤ ɛ_c
      inconsistent = (rNorm > 100 * ɛ_c) & (ArNorm ≤ ɛ_i)
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    solved              && (status = "found approximate minimum-norm solution")
    !tired && !solved   && (status = "found approximate minimum least-squares solution")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = inconsistent
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

@testset "cr" begin
  cr_tol = 1.0e-6

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin
      # Symmetric and positive definite system.
      A, b = symmetric_definite(FC = FC)
      (x, stats) = cr(A, b)
      r = b - A * x
      resid = norm(r) / norm(b)
      @test(resid ≤ cr_tol)
      @test(stats.solved)
      @test stats.indefinite == false

      # Code coverage
      (x, stats) = cr(Matrix(A), b)

      if FC == Float64
        radius = 0.75 * norm(x)
        (x, stats) = cr(A, b, radius = radius)
        @test(stats.solved)
        @test abs(norm(x) - radius) ≤ cr_tol * radius

        # Sparse Laplacian
        A, _ = sparse_laplacian(FC = FC)
        b = randn(size(A, 1))
        itmax = 0
        # case: ‖x*‖ > Δ
        radius = 10.0
        (x, stats) = cr(A, b, radius = radius)
        xNorm = norm(x)
        r = b - A * x
        resid = norm(r) / norm(b)
        @test abs(xNorm - radius) ≤ cr_tol * radius
        @test(stats.solved)
        # case: ‖x*‖ < Δ
        radius = 30.0
        (x, stats) = cr(A, b, radius = radius)
        xNorm = norm(x)
        r = b - A * x
        resid = norm(r) / norm(b)
        @test(resid ≤ cr_tol)
        @test(stats.solved)

        radius = 0.75 * xNorm
        (x, stats) = cr(A, b, radius = radius)
        @test(stats.solved)
        @test(abs(radius - norm(x)) ≤ cr_tol * radius)
      end

      # Test b == 0
      A, b = zero_rhs(FC = FC)
      (x, stats) = cr(A, b)
      @test norm(x) == 0
      @test stats.status == "x is a zero-residual solution"

      # Test with Jacobi (or diagonal) preconditioner
      A, b, M = square_preconditioned(FC = FC)
      (x, stats) = cr(A, b, M = M, atol = 1e-5, rtol = 0.0)
      r = b - A * x
      resid = sqrt(real(dot(r, M * r))) / sqrt(real(dot(b, M * b)))
      @test(resid ≤ 10 * cr_tol)
      @test(stats.solved)

      # Test linesearch
      # Iter=0: bᵀ Ab = 0 → zero-curvature at k=0
      A, b = system_zero_quad(FC = Float64)   # ensures bᵀ A b == 0
      solver = CrWorkspace(A, b)
      cr!(solver, A, b; linesearch = true)
      x, stats, npc_dir = solver.x, solver.stats, solver.npc_dir
      @test stats.niter == 0
      @test stats.status == "b is a zero-curvature direction"
      @test real(dot(npc_dir, A * npc_dir)) ≈ 0

      # Test Linesearch which would stop on the first call since A is indefinite
      A, b = symmetric_indefinite(FC = FC; shift = 10)
      solver = CrWorkspace(A, b)
      cr!(solver, A, b, linesearch = true)
      x, stats, npc_dir = solver.x, solver.stats, solver.npc_dir
      @test stats.status == "nonpositive curvature"
      @test stats.niter == 0
      @test stats.solved == true
      @test stats.indefinite == true
      @test real(dot(npc_dir, A * npc_dir)) <= 0
      @test all(x .== b)

      # Test when b^TAb=0 and linesearch is false
      A, b = system_zero_quad(FC = FC)
      x, stats = cr(A, b, linesearch = false)
      @test stats.status == "b is a zero-curvature direction"
      @test norm(x) == zero(FC)
      @test stats.solved == true
      @test stats.niter == 0

      # test callback function
      A, b = symmetric_definite(FC = FC)
      workspace = CrWorkspace(A, b)
      tol = 1.0e-1
      cb_n2 = TestCallbackN2(A, b, tol = tol)
      cr!(workspace, A, b, callback = cb_n2)
      @test workspace.stats.status == "user-requested exit"
      @test cb_n2(workspace)

      @test_throws TypeError cr(A, b, callback = workspace -> "string", history = true)

      # 2 negative curvature
      A = FC[
        1.0 0.0;
        0.0 0.0
      ]
      b = ones(FC, 2)
      solver = CrWorkspace(A, b)
      cr!(solver, A, b; linesearch = true)
      x, stats, npc_dir, p = solver.x, solver.stats, solver.npc_dir, solver.p
      @test stats.npcCount == 2
      @test real(dot(npc_dir, A*npc_dir)) ≤ norm(npc_dir)^2 + cr_tol
      @test real(dot(p, A*p)) < cr_tol

      # Only -p negative curvature
      A = FC(-1.0)*I(2)
      b = ones(FC, 2)
      solver = CrWorkspace(A, b)
      cr!(solver, A, b; linesearch = true)
      x, stats, npc_dir, p = solver.x, solver.stats, solver.npc_dir, solver.p
      @test stats.status == "nonpositive curvature"
      @test stats.npcCount == 1
      @test real(dot(npc_dir, A*npc_dir)) ≤ cr_tol

      @test real(dot(p, A*p)) < 0

      # Warm-start + linesearch must error
      A, b = symmetric_indefinite(FC = Float64)
      @test_throws MethodError cr(A, b; warm_start = true, linesearch = true)

      # radius > 0
      # bᵀ Ab ≈  0 at first iteration
      A = FC[
        1.0 1e-10;
        1e-10 1e-10
      ]
      b = FC[0.0, 0.99]
      solver = CrWorkspace(A, b)
      cr!(solver, A, b; radius = 10 * real(one(FC)), γ = 10 * real(one(FC)))
      x, stats, npc_dir = solver.x, solver.stats, solver.npc_dir

      @test stats.npcCount == 1
      @test stats.status == "on trust-region boundary"
      @test stats.indefinite == true
      @test real(dot(npc_dir, A * npc_dir)) <= 0.01 # almost zero curvature
      @test stats.solved == true

      # pᵀAp < 0 and rᵀAr > 0 after the second iteration
      A = FC[
        10.0 0.0 0.0 0.0;
        0.0 8.0 0.0 0.0;
        0.0 0.0 5.0 0.0;
        0.0 0.0 0.0 -1.0
      ]
      b = FC[1.0, 1.0, 1.0, 0.1]
      solver = CrWorkspace(A, b)
      cr!(solver, A, b; radius = 10 * real(one(FC)))
      x, stats, npc_dir, p = solver.x, solver.stats, solver.npc_dir, solver.p
      @test stats.npcCount == 2
      @test stats.status == "on trust-region boundary"
      @test stats.indefinite == true
      @test stats.solved == true
      @test real(dot(npc_dir, A * npc_dir)) <= 0.01 # almost zero curvature
      @test real(dot(p, A * p)) < 0 # negative curvature

      # pᵀAp < 0 and rᵀAr > 0 after the second iteration
      A = FC[
        5.0 0.0 0.0;
        0.0 4.0 0.0;
        0.0 0.0 -1.0
      ]
      b = FC[1.0, 1.0, 0.1]
      solver = CrWorkspace(A, b)
      cr!(solver, A, b; radius = 10 * real(one(FC)))
      x, stats, npc_dir, p = solver.x, solver.stats, solver.npc_dir, solver.p
      @test stats.npcCount == 2
      @test stats.status == "on trust-region boundary"
      @test stats.indefinite == true
      @test stats.solved == true
      @test real(dot(npc_dir, A * npc_dir)) <= 0.01 # almost zero curvature

      # pᵀ Ap ≈  0 after first iteration
      A = FC[
        1.0 1e-10;
        1e-10 1e-10
      ]
      b = FC[0.002, 1.0]
      solver = CrWorkspace(A, b)
      cr!(solver, A, b; radius = 10 * real(one(FC)), γ = 10 * real(one(FC)))
      x, stats, npc_dir = solver.x, solver.stats, solver.npc_dir
      @test stats.npcCount == 1
      @test stats.solved == true
      @test stats.status == "on trust-region boundary"
      @test stats.indefinite == true
      @test real(dot(npc_dir, A * npc_dir)) <= 0.01

      # Iter=0: bᵀ Ab = 0 → zero-curvature at k=0
      A, b = system_zero_quad(FC = Float64)   # ensures bᵀ A b == 0
      solver = CrWorkspace(A, b)
      cr!(solver, A, b; radius = 10 * real(one(FC)))
      x, stats, npc_dir = solver.x, solver.stats, solver.npc_dir
      @test stats.niter == 0
      @test stats.status == "b is a zero-curvature direction"
      @test real(dot(npc_dir, A * npc_dir)) ≈ 0

      # Test stop since A is indefinite
      A, b = symmetric_indefinite(FC = FC; shift = 5)
      solver = CrWorkspace(A, b)
      cr!(solver, A, b, radius = 10 * real(one(FC)))
      x, stats, npc_dir = solver.x, solver.stats, solver.npc_dir
      @test stats.status == "on trust-region boundary"
      @test stats.solved == true
      @test stats.indefinite == true
      @test real(dot(npc_dir, A * npc_dir)) <= 0
      @test stats.solved == true

      # negative curvature
      A = FC[
        1.0 0.0;
        0.0 0.0
      ]
      b = ones(FC, 2)
      solver = CrWorkspace(A, b)
      cr!(solver, A, b; radius = 10 * real(one(FC)))
      x, stats, npc_dir = solver.x, solver.stats, solver.npc_dir
      @test stats.npcCount == 1
      @test real(dot(npc_dir, A*npc_dir)) ≤ 0.0

      # p negative curvature
      A = FC(-1.0)*I(2)
      b = ones(FC, 2)
      solver = CrWorkspace(A, b)
      cr!(solver, A, b; radius = 10 * real(one(FC)))
      x, stats, npc_dir, p = solver.x, solver.stats, solver.npc_dir, solver.p
      @test stats.status == "on trust-region boundary"
      @test stats.npcCount == 2
      @test real(dot(npc_dir, A*npc_dir)) ≤ cr_tol
      @test real(dot(p, A*p)) < 0

      # Test on trust-region boundary when radius > 0
      A, b = symmetric_indefinite(FC = FC, shift = 5)
      solver = CrWorkspace(A, b)
      cr!(solver, A, b, radius = real(one(FC)))
      x, stats, npc_dir = solver.x, solver.stats, solver.npc_dir
      @test stats.status == "on trust-region boundary"
      @test norm(x) ≈ 1.0
      @test real(dot(x, A * x)) <= 0

      # Test on trust-region boundary when radius = 1 and linesearch is true
      A, b = symmetric_indefinite(FC = FC, shift = 5)
      @test_throws ErrorException cr(A, b, radius = real(one(FC)), linesearch = true)

      # Test: Ensure stats are reset when reusing workspace
      # (pᵀAp < 0)
      A = FC[
        10.0 0.0 0.0 0.0;
        0.0 8.0 0.0 0.0;
        0.0 0.0 5.0 0.0;
        0.0 0.0 0.0 -1.0
      ]
      b = FC[1.0, 1.0, 1.0, 0.1]
      
      # Initialize workspace and solve
      solver = CrWorkspace(A, b)
      cr!(solver, A, b; linesearch=true)
      
      # Verify the "npc" state was recorded
      @test solver.stats.npcCount == 2
      @test solver.stats.indefinite == true
      @test solver.stats.status == "nonpositive curvature"

      # Reuse the SAME solver on a Positive Definite System

      A = FC[
        10.0 0.0 0.0 0.0;
        0.0 8.0 0.0 0.0;
        0.0 0.0 5.0 0.0;
        0.0 0.0 0.0 1.0
      ]
      b = FC[1.0, 1.0, 1.0, 1.0]

      # Run the solver again on the same workspace
      cr!(solver, A, b; linesearch=true)
      # Verify the RESET works
      @test solver.stats.npcCount == 0
      @test solver.stats.indefinite == false
      @test solver.stats.solved == true

    end
  end
end

# An implementation of CAR for the solution of hermitian positive definite linear systems.
#
# This method is described in
#
# A. Montoison, D. Orban and M. A. Saunders
# MinAres: An Iterative Solver for Symmetric Linear Systems
# SIAM Journal on Matrix Analysis and Applications, 46(1), pp. 509--529, 2025.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Osaka -- Tokyo, August 2023.

export car, car!

"""
    (x, stats) = car(A, b::AbstractVector{FC};
                     M=I, ldiv::Bool=false,
                     atol::T=√eps(T), rtol::T=√eps(T),
                     itmax::Int=0, timemax::Float64=Inf,
                     verbose::Int=0, history::Bool=false,
                     callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = car(A, b, x0::AbstractVector; kwargs...)

CAR can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above.

CAR solves the Hermitian and positive definite linear system Ax = b of size n.
CAR minimizes ‖Arₖ‖₂ when M = Iₙ and ‖AMrₖ‖_M otherwise.
The estimates computed every iteration are ‖Mrₖ‖₂ and ‖AMrₖ‖_M.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :car`.

For an in-place variant that reuses memory across solves, see [`car!`](@ref).

#### Input arguments

* `A`: a linear operator that models a Hermitian positive definite matrix of dimension `n`;
* `b`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning;
* `ldiv`: define whether the preconditioner uses `ldiv!` or `mul!`;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### Reference

* A. Montoison, D. Orban and M. A. Saunders, [*MinAres: An Iterative Solver for Symmetric Linear Systems*](https://doi.org/10.1137/23M1605454), SIAM Journal on Matrix Analysis and Applications, 46(1), pp. 509--529, 2025.
"""
function car end

"""
    workspace = car!(workspace::CarWorkspace, A, b; kwargs...)
    workspace = car!(workspace::CarWorkspace, A, b, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`car`](@ref).

See [`CarWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :car` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function car! end

def_args_car = (:(A                    ),
                :(b::AbstractVector{FC}))

def_optargs_car = (:(x0::AbstractVector),)

def_kwargs_car = (:(; M = I                        ),
                  :(; ldiv::Bool = false           ),
                  :(; atol::T = √eps(T)            ),
                  :(; rtol::T = √eps(T)            ),
                  :(; itmax::Int = 0               ),
                  :(; timemax::Float64 = Inf       ),
                  :(; verbose::Int = 0             ),
                  :(; history::Bool = false        ),
                  :(; callback = workspace -> false),
                  :(; iostream::IO = kstdout       ))

def_kwargs_car = extract_parameters.(def_kwargs_car)

args_car = (:A, :b)
optargs_car = (:x0,)
kwargs_car = (:M, :ldiv, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function car!(workspace :: CarWorkspace{T,FC,S}, $(def_args_car...); $(def_kwargs_car...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("System must be square")
    length(b) == n || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "CAR: system of %d equations in %d variables\n", n, n)

    # Tests M = Iₙ
    MisI = (M === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")

    # Set up workspace.
    allocate_if(!MisI, workspace, :Mu, S, workspace.x)  # The length of Mu is n
    Δx, x, r, p, s, q, t, u, stats = workspace.Δx, workspace.x, workspace.r, workspace.p, workspace.s, workspace.q, workspace.t, workspace.u, workspace.stats
    Mu = MisI ? u : workspace.Mu
    warm_start = workspace.warm_start
    rNorms, ArNorms = stats.residuals, stats.Aresiduals
    reset!(stats)

    kfill!(x, zero(FC))
    if warm_start
      kmul!(r, A, Δx)
      kaxpby!(n, one(FC), b, -one(FC), r)
    else
      kcopy!(n, r, b)  # r ← b
    end

    # p₀ = r₀ = M(b - Ax₀)
    if MisI
      kcopy!(n, p, r)  # p ← r
    else
      mulorldiv!(p, M, r, ldiv)
      kcopy!(n, r, p)  # r ← p
    end

    kmul!(s, A, r)  # s₀ = Ar₀

    # q₀ = MAp₀ and s₀ = MAr₀
    if MisI
      kcopy!(n, q, s)  # q ← s
    else
      mulorldiv!(q, M, s, ldiv)
      kcopy!(n, s, q)  # s ← q
    end

    kmul!(t, A, s)      # t₀ = As₀
    kcopy!(n, u, t)     # u₀ = Aq₀
    ρ = kdotr(n, t, s)  # ρ₀ = ⟨t₀ , s₀⟩

    # Compute ‖r₀‖
    rNorm = knorm(n, r)
    history && push!(rNorms, rNorm)

    # Compute ‖Ar₀‖
    ArNorm = MisI ? knorm(n, s) : knorm_elliptic(n, r, u)
    history && push!(ArNorms, ArNorm)

    if rNorm == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    iter = 0
    itmax == 0 && (itmax = 2 * n)

    ε = atol + rtol * rNorm
    (verbose > 0) && @printf(iostream, "%5s  %7s  %7s  %7s  %7s  %5s\n", "k", "‖rₖ‖", "‖Arₖ‖", "α", "β", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %7.1e  %7s  %7s  %.2fs\n", iter, rNorm, ArNorm, "✗ ✗ ✗ ✗", "✗ ✗ ✗ ✗", start_time |> ktimer)

    solved = rNorm ≤ ε
    tired = iter ≥ itmax
    inconsistent = false
    user_requested_exit = false
    overtimed = false
    status = "unknown"

    while !(solved || tired || user_requested_exit || overtimed)
      MisI || mulorldiv!(Mu, M, u, ldiv)
      α = ρ / kdotr(n, u, Mu)  # αₖ = ρₖ / ⟨uₖ, Muₖ⟩
      kaxpy!(n,  α, p, x)      # xₖ₊₁ = xₖ + αₖ * pₖ
      kaxpy!(n, -α, q, r)      # rₖ₊₁ = rₖ - αₖ * qₖ
      kaxpy!(n, -α, Mu, s)     # sₖ₊₁ = sₖ - αₖ * Muₖ

      # Compute ‖rₖ‖
      rNorm = knorm(n, r)
      history && push!(rNorms, rNorm)

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      resid_decrease_mach = (rNorm + one(T) ≤ one(T))
      resid_decrease_lim = rNorm ≤ ε
      solved = resid_decrease_lim || resid_decrease_mach

      if !solved
        kmul!(t, A, s)                # tₖ₊₁ = A * sₖ₊₁
        ρ_next = kdotr(n, t, s)       # ρₖ₊₁ = ⟨tₖ₊₁ , sₖ₊₁⟩
        β = ρ_next / ρ                # βₖ = ρₖ₊₁ / ρₖ
        ρ = ρ_next
        kaxpby!(n, one(FC), r, β, p)  # pₖ₊₁ = rₖ₊₁ + βₖ * pₖ
        kaxpby!(n, one(FC), s, β, q)  # qₖ₊₁ = sₖ₊₁ + βₖ * qₖ
        kaxpby!(n, one(FC), t, β, u)  # uₖ₊₁ = tₖ₊₁ + βₖ * uₖ

        # Compute ‖Arₖ‖
        ArNorm = MisI ? knorm(n, s) : knorm_elliptic(n, r, u)
        history && push!(ArNorms, ArNorm)
      end

      iter = iter + 1
      tired = iter ≥ itmax
      user_requested_exit = callback(workspace) :: Bool
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      kdisplay(iter, verbose) && !solved && @printf(iostream, "%5d  %7.1e  %7.1e  %7.1e  %7.1e  %.2fs\n", iter, rNorm, ArNorm, α, β, start_time |> ktimer)
      kdisplay(iter, verbose) &&  solved && @printf(iostream, "%5d  %7.1e  %7s  %7.1e  %7s  %.2fs\n", iter, rNorm, "✗ ✗ ✗ ✗", α, "✗ ✗ ✗ ✗", start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    solved              && (status = "solution good enough given atol and rtol")
    tired               && (status = "maximum number of iterations exceeded")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update x
    warm_start && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = inconsistent
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

@testset "tricg" begin
  tricg_tol = 1.0e-6

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      # Test saddle-point systems
      A, b, D = saddle_point(FC=FC)
      m, n = size(A)
      c = -b
      D⁻¹ = sparse(inv(D))
      N⁻¹ = eye(n)
      H⁻¹ = blockdiag(D⁻¹, N⁻¹)

      (x, y, stats) = tricg(A, b, c, τ=1.0, ν=0.0, M=D⁻¹)
      K = [D A; A' zeros(n, n)]
      B = [b; c]
      r =  B - K * [x; y]
      resid = sqrt(dot(r, H⁻¹ * r)) / sqrt(dot(B, H⁻¹ * B))
      @test(resid ≤ tricg_tol)

      (x, y, stats) = tricg(A, b, c, τ=1.0, ν=0.0)
      K = [eye(m) A; A' zeros(n, n)]
      B = [b; c]
      r =  B - K * [x; y]
      resid = norm(r) / norm(B)
      @test(resid ≤ tricg_tol)

      # Test symmetric and quasi-definite systems
      A, b, M, N = sqd(FC=FC)
      m, n = size(A)
      c = -b
      M⁻¹ = sparse(inv(M))
      N⁻¹ = sparse(inv(N))
      H⁻¹ = blockdiag(M⁻¹, N⁻¹)

      (x, y, stats) = tricg(A, b, c, M=M⁻¹, N=N⁻¹)
      K = [M A; A' -N]
      B = [b; c]
      r =  B - K * [x; y]
      resid = sqrt(dot(r, H⁻¹ * r)) / sqrt(dot(B, H⁻¹ * B))
      @test(resid ≤ tricg_tol)

      (x, y, stats) = tricg(A, b, c)
      K = [eye(m) A; A' -eye(n)]
      B = [b; c]
      r =  B - K * [x; y]
      resid = norm(r) / norm(B)
      @test(resid ≤ tricg_tol)

      (x, y, stats) = tricg(A, b, c, M=M⁻¹, N=N⁻¹, flip=true)
      K = [-M A; A' N]
      B = [b; c]
      r =  B - K * [x; y]
      resid = sqrt(dot(r, H⁻¹ * r)) / sqrt(dot(B, H⁻¹ * B))
      @test(resid ≤ tricg_tol)

      (x, y, stats) = tricg(A, b, c, flip=true)
      K = [-eye(m) A; A' eye(n)]
      B = [b; c]
      r =  B - K * [x; y]
      resid = norm(r) / norm(B)
      @test(resid ≤ tricg_tol)

      τ = 12.0; ν =-0.7
      (x, y, stats) = tricg(A, b, c, M=M⁻¹, N=N⁻¹, τ=τ, ν=ν)
      K = [τ*M A; A' ν*N]
      B = [b; c]
      r =  B - K * [x; y]
      resid = sqrt(dot(r, H⁻¹ * r)) / sqrt(dot(B, H⁻¹ * B))
      @test(resid ≤ tricg_tol)

      (x, y, stats) = tricg(A, b, c, τ=τ, ν=ν)
      K = [τ*eye(m) A; A' ν*eye(n)]
      B = [b; c]
      r =  B - K * [x; y]
      resid = norm(r) / norm(B)
      @test(resid ≤ tricg_tol)

      τ = -1e-6; ν =1e-8
      (x, y, stats) = tricg(A, b, c, M=M⁻¹, N=N⁻¹, τ=τ, ν=ν)
      K = [τ*M A; A' ν*N]
      B = [b; c]
      r =  B - K * [x; y]
      resid = sqrt(dot(r, H⁻¹ * r)) / sqrt(dot(B, H⁻¹ * B))
      @test(resid ≤ tricg_tol)

      (x, y, stats) = tricg(A, b, c, τ=τ, ν=ν)
      K = [τ*eye(m) A; A' ν*eye(n)]
      B = [b; c]
      r =  B - K * [x; y]
      resid = norm(r) / norm(B)
      @test(resid ≤ tricg_tol)

      # Test symmetric positive definite systems
      (x, y, stats) = tricg(A, b, c, M=M⁻¹, N=N⁻¹, spd=true)
      K = [M A; A' N]
      B = [b; c]
      r =  B - K * [x; y]
      resid = sqrt(dot(r, H⁻¹ * r)) / sqrt(dot(B, H⁻¹ * B))
      @test(resid ≤ tricg_tol)

      (x, y, stats) = tricg(A, b, c, spd=true)
      K = [eye(m) A; A' eye(n)]
      B = [b; c]
      r =  B - K * [x; y]
      resid = norm(r) / norm(B)
      @test(resid ≤ tricg_tol)

      # Test symmetric negative definite systems
      (x, y, stats) = tricg(A, b, c, M=M⁻¹, N=N⁻¹, snd=true)
      K = [-M A; A' -N]
      B = [b; c]
      r =  B - K * [x; y]
      resid = sqrt(dot(r, H⁻¹ * r)) / sqrt(dot(B, H⁻¹ * B))
      @test(resid ≤ tricg_tol)

      (x, y, stats) = tricg(A, b, c, snd=true)
      K = [-eye(m) A; A' -eye(n)]
      B = [b; c]
      r =  B - K * [x; y]
      resid = norm(r) / norm(B)
      @test(resid ≤ tricg_tol)

      # Test b == 0 or c == 0
      b_zero = zeros(m)
      x, y, stats = tricg(A, b_zero, c)
      rhs = [b_zero; c]
      r =  rhs - [I A; A' -I] * [x; y]
      resid = norm(r) / norm(rhs)
      @test(resid ≤ tricg_tol)

      c_zero = zeros(n)
      x, y, stats = tricg(A, b, c_zero)
      rhs = [b; c_zero]
      r =  rhs - [I A; A' -I] * [x; y]
      resid = norm(r) / norm(rhs)
      @test(resid ≤ tricg_tol)

      # Test specific breakdowns
      A, b, c = ssy_mo_breakdown2(FC)
      K = [I A; A' -I]
      d = [b; c]
      x, y, stats = tricg(A, b, c)
      r = d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ tricg_tol)

      A, b, c = ssy_mo_breakdown3(FC)
      K = [I A; A' -I]
      d = [b; c]
      x, y, stats = tricg(A, b, c)
      r = d - K * [x; y]
      resid = norm(r) / norm(d)
      @test(resid ≤ tricg_tol)

      # Test dimension of additional vectors
      for transpose ∈ (false, true)
        A, b, c, M, N = small_sqd(transpose, FC=FC)
        M⁻¹ = inv(M)
        N⁻¹ = inv(N)
        (x, y, stats) = tricg(A, b, c, M=M⁻¹, N=N⁻¹)
        K = [M A; A' -N]
        r = [b; c] - K * [x; y]
        H = [M zeros(size(M, 1), size(N, 2)); zeros(size(N, 1), size(M, 2)) N]
        @test sqrt(dot(r, inv(H) * r)) / sqrt(dot([b; c], inv(H) * [b; c])) ≤ tricg_tol
      end

      # Test different types for b and c
      A, b, _ = saddle_point(FC=FC)
      (x, y, stats) = tricg(A, b, -b)
      c = TestVector(-b)
      workspace = TricgWorkspace(KrylovConstructor(b, c))
      @test typeof(workspace.x) === typeof(b)
      @test typeof(workspace.y) === typeof(c)
      tricg!(workspace, A, b, c)
      xt, yt = workspace.x, workspace.y
      @test typeof(xt) === typeof(b)
      @test typeof(yt) === typeof(c)

      for transpose ∈ (false, true)
        A, b, c = ssy_mo_breakdown(transpose)

        # Test breakdowns
        K = [I A; A' -I]
        d = [b; c]
        x, y, stats = tricg(A, b, c)
        r = d - K * [x; y]
        resid = norm(r) / norm(d)
        @test(resid ≤ tricg_tol)

        # Test inconsistent linear systems
        K = [I A; A' I]
        n, m = size(K)
        p = rank(K)
        @test(p < n)
        τ = ν = 1.0
        x, y, stats = tricg(A, b, c, τ=τ, ν=ν)
        @test(stats.inconsistent)

        # test callback function
        A, b, D = saddle_point(FC=FC)
        c = -b
        workspace = TricgWorkspace(A, b)
        tol = 1.0e-1
        cb_n2 = TestCallbackN2SaddlePts(A, b, c, tol = tol)
        tricg!(workspace, A, b, c, callback = cb_n2)
        @test workspace.stats.status == "user-requested exit"
        @test cb_n2(workspace)

        @test_throws TypeError tricg(A, b, c, callback = workspace -> "string", history = true)
      end
    end
  end
end

# An implementation of CRMR for the solution of the
# (under/over-determined or square) linear system
#
#  Ax = b.
#
# The method seeks to solve the minimum-norm problem
#
#  min ‖x‖²  s.t. Ax = b,
#
# and is equivalent to applying the conjugate residual method
# to the linear system
#
#  AAᴴy = b.
#
# This method is equivalent to CRAIGMR, described in
#
# D. Orban and M. Arioli. Iterative Solution of Symmetric Quasi-Definite Linear Systems,
# Volume 3 of Spotlights. SIAM, Philadelphia, PA, 2017.
#
# D. Orban, The Projected Golub-Kahan Process for Constrained
# Linear Least-Squares Problems. Cahier du GERAD G-2014-15,
# GERAD, Montreal QC, Canada, 2014.
#
# Dominique Orban, <dominique.orban@gerad.ca>
# Montreal, QC, April 2015.

export crmr, crmr!

"""
    (x, stats) = crmr(A, b::AbstractVector{FC};
                      N=I, ldiv::Bool=false,
                      λ::T=zero(T), atol::T=√eps(T),
                      rtol::T=√eps(T), itmax::Int=0,
                      timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                      callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

Solve the consistent linear system

    Ax + √λs = b

of size m × n using the Conjugate Residual (CR) method, where λ ≥ 0 is a regularization
parameter. This method is equivalent to applying CR to the normal equations
of the second kind

    (AAᴴ + λI) y = b

but is more stable. When λ = 0, this method solves the minimum-norm problem

    min ‖x‖₂  s.t.  x ∈ argmin ‖Ax - b‖₂.

When λ > 0, this method solves the problem

    min ‖(x,s)‖₂  s.t. Ax + √λs = b.

CRMR produces monotonic residuals ‖r‖₂.
It is formally equivalent to CRAIG-MR, though can be slightly less accurate,
but simpler to implement. Only the x-part of the solution is returned.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :crmr`.

For an in-place variant that reuses memory across solves, see [`crmr!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`.

#### Keyword arguments

* `N`: linear operator that models a Hermitian positive-definite matrix of size `n` used for preconditioning;
* `ldiv`: define whether the preconditioner uses `ldiv!` or `mul!`;
* `λ`: regularization parameter;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `m+n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### References

* D. Orban and M. Arioli, [*Iterative Solution of Symmetric Quasi-Definite Linear Systems*](https://doi.org/10.1137/1.9781611974737), Volume 3 of Spotlights. SIAM, Philadelphia, PA, 2017.
* D. Orban, [*The Projected Golub-Kahan Process for Constrained Linear Least-Squares Problems*](https://dx.doi.org/10.13140/RG.2.2.17443.99360). Cahier du GERAD G-2014-15, 2014.
"""
function crmr end

"""
    workspace = crmr!(workspace::CrmrWorkspace, A, b; kwargs...)

In this call, `kwargs` are keyword arguments of [`crmr`](@ref).

See [`CrmrWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :crmr` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function crmr! end

def_args_crmr = (:(A                    ),
                 :(b::AbstractVector{FC}))

def_kwargs_crmr = (:(; N = I                        ),
                   :(; ldiv::Bool = false           ),
                   :(; λ::T = zero(T)               ),
                   :(; atol::T = √eps(T)            ),
                   :(; rtol::T = √eps(T)            ),
                   :(; itmax::Int = 0               ),
                   :(; timemax::Float64 = Inf       ),
                   :(; verbose::Int = 0             ),
                   :(; history::Bool = false        ),
                   :(; callback = workspace -> false),
                   :(; iostream::IO = kstdout       ))

def_kwargs_crmr = extract_parameters.(def_kwargs_crmr)

args_crmr = (:A, :b)
kwargs_crmr = (:N, :ldiv, :λ, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function crmr!(workspace :: CrmrWorkspace{T,FC,Sm,Sn}, $(def_args_crmr...); $(def_kwargs_crmr...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "CRMR: system of %d equations in %d variables\n", m, n)

    # Tests N = Iₙ
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == Sm || error("ktypeof(b) must be equal to $Sm")

    # Compute the adjoint of A
    Aᴴ = A'

    # Set up workspace.
    allocate_if(!NisI, workspace, :Nq, Sm, workspace.r)  # The length of Nq is m
    allocate_if(λ > 0, workspace, :s , Sm, workspace.r)  # The length of s is m
    x, p, Aᴴr, r = workspace.x, workspace.p, workspace.Aᴴr, workspace.r
    q, s, stats = workspace.q, workspace.s, workspace.stats
    rNorms, ArNorms = stats.residuals, stats.Aresiduals
    reset!(stats)
    Nq = NisI ? q : workspace.Nq

    kfill!(x, zero(FC))        # initial estimation x = 0
    mulorldiv!(r, N, b, ldiv)  # initial residual r = N * (b - Ax) = N * b
    bNorm = knorm(m, r)        # norm(b - A * x0) if x0 ≠ 0.
    rNorm = bNorm              # + λ * ‖x0‖ if x0 ≠ 0 and λ > 0.
    history && push!(rNorms, rNorm)
    if bNorm == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      history && push!(ArNorms, zero(T))
      return workspace
    end
    λ > 0 && kcopy!(m, s, r)  # s ← r
    kmul!(Aᴴr, Aᴴ, r)         # - λ * x0 if x0 ≠ 0.
    kcopy!(n, p, Aᴴr)         # p ← Aᴴr
    γ = kdotr(n, Aᴴr, Aᴴr)    # Faster than γ = dot(Aᴴr, Aᴴr)
    λ > 0 && (γ += λ * rNorm * rNorm)
    iter = 0
    itmax == 0 && (itmax = m + n)

    ArNorm = sqrt(γ)
    history && push!(ArNorms, ArNorm)
    ɛ_c = atol + rtol * rNorm   # Stopping tolerance for consistent systems.
    ɛ_i = atol + rtol * ArNorm  # Stopping tolerance for inconsistent systems.
    (verbose > 0) && @printf(iostream, "%5s  %8s  %8s  %5s\n", "k", "‖Aᴴr‖", "‖r‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %8.2e  %8.2e  %.2fs\n", iter, ArNorm, rNorm, start_time |> ktimer)

    status = "unknown"
    solved = rNorm ≤ ɛ_c
    inconsistent = (rNorm > 100 * ɛ_c) && (ArNorm ≤ ɛ_i)
    tired = iter ≥ itmax
    user_requested_exit = false
    overtimed = false

    while ! (solved || inconsistent || tired || user_requested_exit || overtimed)
      kmul!(q, A, p)
      λ > 0 && kaxpy!(m, λ, s, q)  # q = q + λ * s
      NisI || mulorldiv!(Nq, N, q, ldiv)
      α = γ / kdotr(m, q, Nq)  # Compute qᴴ * N * q
      kaxpy!(n,  α, p, x)      # Faster than  x =  x + α *  p
      kaxpy!(m, -α, Nq, r)     # Faster than  r =  r - α * Nq
      rNorm = knorm(m, r)      # norm(r)
      kmul!(Aᴴr, Aᴴ, r)
      γ_next = kdotr(n, Aᴴr, Aᴴr)  # Faster than γ_next = dot(Aᴴr, Aᴴr)
      λ > 0 && (γ_next += λ * rNorm * rNorm)
      β = γ_next / γ

      kaxpby!(n, one(FC), Aᴴr, β, p)  # Faster than  p = Aᴴr + β * p
      if λ > 0
        kaxpby!(m, one(FC), r, β, s)  # s = r + β * s
      end

      γ = γ_next
      ArNorm = sqrt(γ)
      history && push!(rNorms, rNorm)
      history && push!(ArNorms, ArNorm)
      iter = iter + 1
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %8.2e  %8.2e  %.2fs\n", iter, ArNorm, rNorm, start_time |> ktimer)
      user_requested_exit = callback(workspace) :: Bool
      solved = rNorm ≤ ɛ_c
      inconsistent = (rNorm > 100 * ɛ_c) && (ArNorm ≤ ɛ_i)
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    solved              && (status = "solution good enough given atol and rtol")
    inconsistent        && (status = "system probably inconsistent but least squares/norm solution found")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = inconsistent
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

using Krylov, LinearAlgebra, SparseArrays, Printf, Random, Test

import Krylov: solution, statistics, results, elapsed_time, elapsed_allocation_time,
               solution_count, iteration_count, Aprod_count, Atprod_count,
               issolved, issolved_primal, issolved_dual

Random.seed!(666)

include("test_utils.jl")
include("test_aux.jl")
include("test_stats.jl")
include("test_block_processes.jl")
include("test_processes.jl")

include("test_usymlqr.jl")
include("test_minares.jl")
include("test_car.jl")
include("test_fgmres.jl")
include("test_gpmr.jl")
include("test_fom.jl")
include("test_gmres.jl")
include("test_bicgstab.jl")
include("test_usymlq.jl")
include("test_tricg.jl")
include("test_bilqr.jl")
include("test_trimr.jl")
include("test_trilqr.jl")
include("test_usymqr.jl")
include("test_qmr.jl")
include("test_lnlq.jl")
include("test_diom.jl")
include("test_cgs.jl")
include("test_dqgmres.jl")
include("test_cg.jl")
include("test_cg_lanczos.jl")
include("test_cg_lanczos_shift.jl")
include("test_minres.jl")
include("test_minres_qlp.jl")
include("test_symmlq.jl")
include("test_bilq.jl")
include("test_cgls.jl")
include("test_cgls_lanczos_shift.jl")
include("test_crls.jl")
include("test_cgne.jl")
include("test_crmr.jl")
include("test_lslq.jl")
include("test_lsqr.jl")
include("test_lsmr.jl")
include("test_craig.jl")
include("test_craigmr.jl")
include("test_cr.jl")

include("test_allocations.jl")
include("test_mp.jl")
include("test_interface.jl")
include("test_warm_start.jl")
include("test_verbose.jl")

! test_block.f90 — tests the block Krylov interface (block_gmres / block_minres).
!
! Problem: A = tridiag(-1, 8, -1) (SPD, strongly diagonally dominant), n x n.
! The right-hand side is an n x p block B = A * X_true, where X_true has
! linearly independent columns (block Krylov methods require a full-rank block).
! Fortran arrays are column-major, matching the block layout expected by the API.
!
! Compile (after building libkrylov):
!   gfortran -O2 -o test_block interfaces/test/Fortran/test_block.f90 \
!       interfaces/build/lib/libkrylov.so
!
! Exit code: 0 if all tests pass, 1 otherwise.

program test_block
  use iso_c_binding
  implicit none
  include '../../include/krylov.f90'

  integer, parameter :: N = 20
  integer, parameter :: P = 3

  real(c_double), target :: Xt(N,P), B(N,P), X(N,P)
  type(KrylovOptions), target :: opts
  type(c_ptr)    :: ws
  integer(c_int) :: ret
  integer        :: n_pass, n_fail, i, j, k, niter_cold
  real(c_double) :: t

  integer(c_int)    :: solvers(2)
  character(len=12) :: names(2)

  ! Dimension shared with the bind(c) callbacks via host association.
  integer :: n_glob

  n_pass = 0; n_fail = 0
  n_glob = N

  ! -------------------------------------------------------------------------
  ! X_true with independent columns, then B = A * X_true.
  ! -------------------------------------------------------------------------
  do j = 1, P
    do i = 1, N
      t = real(i, c_double) / N
      if (j == 1) then
        Xt(i,j) = 1.0_c_double
      else if (j == 2) then
        Xt(i,j) = t
      else
        Xt(i,j) = t*t
      end if
    end do
  end do
  call apply_A(Xt, B, P)

  solvers = [KRYLOV_BLOCK_GMRES, KRYLOV_BLOCK_MINRES]
  names   = [character(len=12) :: "block_gmres", "block_minres"]

  ! -------------------------------------------------------------------------
  ! Solve A X = B with each block solver and check the solution.
  ! -------------------------------------------------------------------------
  do k = 1, 2
    write(*,'(2A)') names(k), " ..."
    ret = krylov_block_workspace_create(solvers(k), int(N,c_int), int(N,c_int), &
                                        int(P,c_int), KRYLOV_FLOAT64, KRYLOV_CPU, &
                                        c_null_ptr, ws)
    call check(ret == 0, "workspace created")

    opts = krylov_default_options()
    opts%atol = 1.0d-10 ; opts%rtol = 1.0d-10 ; opts%itmax = 200_c_int

    ret = krylov_block_solve(ws, c_funloc(cb_block_A), c_null_funptr, c_null_funptr, &
                             c_loc(B), c_null_ptr, c_loc(opts))
    call check(ret == 0,                          "block solve returns 0")
    call check(krylov_block_is_solved(ws) == 1,   "block solve converged")
    call check(krylov_block_niter(ws) > 0,        "block niter is positive")
    call check(krylov_block_elapsed_time(ws) >= 0.0_c_double, "elapsed_time non-negative")

    ret = krylov_block_get_X(ws, c_loc(X), int(N,c_int), int(P,c_int))
    call check(ret == 0,                          "block_get_X returns 0")
    call check(maxval(abs(X - Xt)) < 1.0d-6,      "block solution is correct")

    ret = krylov_block_workspace_free(ws)
  end do

  ! -------------------------------------------------------------------------
  ! Preconditioner (Jacobi: M = diag(A) = 8*I, so M^-1 X = X / 8).
  ! -------------------------------------------------------------------------
  write(*,'(A)') "block_gmres + Jacobi preconditioner ..."
  ret = krylov_block_workspace_create(KRYLOV_BLOCK_GMRES, int(N,c_int), int(N,c_int), &
                                      int(P,c_int), KRYLOV_FLOAT64, KRYLOV_CPU, c_null_ptr, ws)
  opts = krylov_default_options()
  opts%atol = 1.0d-10 ; opts%rtol = 1.0d-10 ; opts%itmax = 200_c_int
  ret = krylov_block_solve(ws, c_funloc(cb_block_A), c_funloc(cb_block_M), c_null_funptr, &
                           c_loc(B), c_null_ptr, c_loc(opts))
  call check(krylov_block_is_solved(ws) == 1, "preconditioned block solve converged")
  ret = krylov_block_get_X(ws, c_loc(X), int(N,c_int), int(P,c_int))
  call check(maxval(abs(X - Xt)) < 1.0d-6, "preconditioned block solution is correct")
  ret = krylov_block_workspace_free(ws)

  ! -------------------------------------------------------------------------
  ! Right preconditioner (block_gmres accepts matvec_N).
  ! -------------------------------------------------------------------------
  write(*,'(A)') "block_gmres + right Jacobi preconditioner ..."
  ret = krylov_block_workspace_create(KRYLOV_BLOCK_GMRES, int(N,c_int), int(N,c_int), &
                                      int(P,c_int), KRYLOV_FLOAT64, KRYLOV_CPU, c_null_ptr, ws)
  opts = krylov_default_options()
  opts%atol = 1.0d-10 ; opts%rtol = 1.0d-10 ; opts%itmax = 200_c_int
  ret = krylov_block_solve(ws, c_funloc(cb_block_A), c_null_funptr, c_funloc(cb_block_M), &
                           c_loc(B), c_null_ptr, c_loc(opts))
  call check(krylov_block_is_solved(ws) == 1, "right-preconditioned block solve converged")
  ret = krylov_block_get_X(ws, c_loc(X), int(N,c_int), int(P,c_int))
  call check(maxval(abs(X - Xt)) < 1.0d-6, "right-preconditioned block solution is correct")
  ret = krylov_block_workspace_free(ws)

  ! -------------------------------------------------------------------------
  ! Warm start (block_gmres): seeding with the exact solution cuts iterations.
  ! -------------------------------------------------------------------------
  write(*,'(A)') "block_gmres warm start ..."
  ret = krylov_block_workspace_create(KRYLOV_BLOCK_GMRES, int(N,c_int), int(N,c_int), &
                                      int(P,c_int), KRYLOV_FLOAT64, KRYLOV_CPU, c_null_ptr, ws)
  opts = krylov_default_options()
  opts%atol = 1.0d-10 ; opts%rtol = 1.0d-10 ; opts%itmax = 200_c_int
  ret = krylov_block_solve(ws, c_funloc(cb_block_A), c_null_funptr, c_null_funptr, &
                           c_loc(B), c_null_ptr, c_loc(opts))
  niter_cold = krylov_block_niter(ws)
  ret = krylov_block_workspace_free(ws)

  ret = krylov_block_workspace_create(KRYLOV_BLOCK_GMRES, int(N,c_int), int(N,c_int), &
                                      int(P,c_int), KRYLOV_FLOAT64, KRYLOV_CPU, c_null_ptr, ws)
  ret = krylov_block_warm_start(ws, c_loc(Xt), int(N,c_int), int(P,c_int))
  call check(ret == 0, "block warm_start accepted")
  ret = krylov_block_solve(ws, c_funloc(cb_block_A), c_null_funptr, c_null_funptr, &
                           c_loc(B), c_null_ptr, c_loc(opts))
  call check(krylov_block_is_solved(ws) == 1,         "warm-started block solve converged")
  call check(krylov_block_niter(ws) < niter_cold,     "warm start reduces iterations")
  ret = krylov_block_workspace_free(ws)

  ! -------------------------------------------------------------------------
  ! Error codes.
  ! -------------------------------------------------------------------------
  write(*,'(A)') "block error codes ..."
  ret = krylov_block_workspace_create(99_c_int, int(N,c_int), int(N,c_int), &
                                      int(P,c_int), KRYLOV_FLOAT64, KRYLOV_CPU, c_null_ptr, ws)
  call check(ret == -2, "unknown block solver returns -2")
  ret = krylov_block_workspace_create(KRYLOV_BLOCK_GMRES, int(N,c_int), int(N,c_int), &
                                      int(P,c_int), KRYLOV_FLOAT64, KRYLOV_CPU, c_null_ptr, ws)
  call check(krylov_block_workspace_free(ws) == 0, "first block free returns 0")
  call check(krylov_block_workspace_free(ws) == 1, "second block free returns 1")

  ! -------------------------------------------------------------------------
  write(*,'(/,I0,A,I0,A)') n_pass, " checks passed, ", n_fail, " failed"
  if (n_fail > 0) stop 1

contains

  ! Y = A * X for an n x p block, A = tridiag(-1, 8, -1).
  subroutine apply_A(Xin, Yout, pp)
    integer, intent(in)         :: pp
    real(c_double), intent(in)  :: Xin(:,:)
    real(c_double), intent(out) :: Yout(:,:)
    integer :: ii, jj, nn
    nn = size(Xin, 1)
    do jj = 1, pp
      do ii = 1, nn
        Yout(ii,jj) = 8.0_c_double * Xin(ii,jj)
        if (ii > 1)  Yout(ii,jj) = Yout(ii,jj) - Xin(ii-1,jj)
        if (ii < nn) Yout(ii,jj) = Yout(ii,jj) - Xin(ii+1,jj)
      end do
    end do
  end subroutine apply_A

  ! Block matvec callback:  Y = A * X
  subroutine cb_block_A(x_ptr, y_ptr, p_in, userdata) bind(c)
    type(c_ptr),    value :: x_ptr, y_ptr, userdata
    integer(c_int), value :: p_in
    real(c_double), pointer :: xx(:,:), yy(:,:)
    call c_f_pointer(x_ptr, xx, [n_glob, int(p_in)])
    call c_f_pointer(y_ptr, yy, [n_glob, int(p_in)])
    call apply_A(xx, yy, int(p_in))
  end subroutine cb_block_A

  ! Block preconditioner callback:  Y = M^-1 X  with M = 8*I
  subroutine cb_block_M(x_ptr, y_ptr, p_in, userdata) bind(c)
    type(c_ptr),    value :: x_ptr, y_ptr, userdata
    integer(c_int), value :: p_in
    real(c_double), pointer :: xx(:,:), yy(:,:)
    call c_f_pointer(x_ptr, xx, [n_glob, int(p_in)])
    call c_f_pointer(y_ptr, yy, [n_glob, int(p_in)])
    yy = xx / 8.0_c_double
  end subroutine cb_block_M

  subroutine check(cond, msg)
    logical,      intent(in) :: cond
    character(*), intent(in) :: msg
    if (cond) then
      n_pass = n_pass + 1
    else
      n_fail = n_fail + 1
      write(*,'(A,A)') "  FAIL  ", msg
    end if
  end subroutine check

end program test_block

# An implementation of DQGMRES for the solution of the square linear system Ax = b.
#
# This method is described in
#
# Y. Saad and K. Wu, DQGMRES: a quasi minimal residual algorithm based on incomplete orthogonalization.
# Numerical Linear Algebra with Applications, Vol. 3(4), pp. 329--343, 1996.
#
# Alexis Montoison, <alexis.montoison@polymtl.ca>
# Montreal, August 2018.

export dqgmres, dqgmres!

"""
    (x, stats) = dqgmres(A, b::AbstractVector{FC};
                         memory::Int=20, M=I, N=I, ldiv::Bool=false,
                         reorthogonalization::Bool=false, atol::T=√eps(T),
                         rtol::T=√eps(T), itmax::Int=0,
                         timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                         callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

    (x, stats) = dqgmres(A, b, x0::AbstractVector; kwargs...)

DQGMRES can be warm-started from an initial guess `x0` where `kwargs` are the same keyword arguments as above.

Solve the consistent linear system Ax = b of size n using DQGMRES.

DQGMRES algorithm is based on the incomplete Arnoldi orthogonalization process
and computes a sequence of approximate solutions with the quasi-minimal residual property.

DQGMRES only orthogonalizes the new vectors of the Krylov basis against the `memory` most recent vectors.
If MINRES is well defined on `Ax = b` and `memory = 2`, DQGMRES is theoretically equivalent to MINRES.
If `k ≤ memory` where `k` is the number of iterations, DQGMRES is theoretically equivalent to GMRES.
Otherwise, DQGMRES interpolates between MINRES and GMRES and is similar to MINRES with partial reorthogonalization.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :dqgmres`.

For an in-place variant that reuses memory across solves, see [`dqgmres!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `n`;
* `b`: a vector of length `n`.

#### Optional argument

* `x0`: a vector of length `n` that represents an initial guess of the solution `x`.

#### Keyword arguments

* `memory`: the number of most recent vectors of the Krylov basis against which to orthogonalize a new vector;
* `M`: linear operator that models a nonsingular matrix of size `n` used for left preconditioning;
* `N`: linear operator that models a nonsingular matrix of size `n` used for right preconditioning;
* `reorthogonalization`: reorthogonalize the new vectors of the Krylov basis against the `memory` most recent vectors;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `2n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### Reference

* Y. Saad and K. Wu, [*DQGMRES: a quasi minimal residual algorithm based on incomplete orthogonalization*](https://doi.org/10.1002/(SICI)1099-1506(199607/08)3:4%3C329::AID-NLA86%3E3.0.CO;2-8), Numerical Linear Algebra with Applications, Vol. 3(4), pp. 329--343, 1996.
"""
function dqgmres end

"""
    workspace = dqgmres!(workspace::DqgmresWorkspace, A, b; kwargs...)
    workspace = dqgmres!(workspace::DqgmresWorkspace, A, b, x0; kwargs...)

In these calls, `kwargs` are keyword arguments of [`dqgmres`](@ref).
The keyword argument `memory` is the only exception.
It is only supported by [`dqgmres`](@ref) and is required to create a `DqgmresWorkspace`.
It cannot be changed later.

See [`DqgmresWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :dqgmres` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function dqgmres! end

def_args_dqgmres = (:(A                    ),
                    :(b::AbstractVector{FC}))

def_optargs_dqgmres = (:(x0::AbstractVector),)

def_kwargs_dqgmres = (:(; M = I                            ),
                      :(; N = I                            ),
                      :(; ldiv::Bool = false               ),
                      :(; reorthogonalization::Bool = false),
                      :(; atol::T = √eps(T)                ),
                      :(; rtol::T = √eps(T)                ),
                      :(; itmax::Int = 0                   ),
                      :(; timemax::Float64 = Inf           ),
                      :(; verbose::Int = 0                 ),
                      :(; history::Bool = false            ),
                      :(; callback = workspace -> false    ),
                      :(; iostream::IO = kstdout           ))

def_kwargs_workspace_dqgmres = (:(; memory::Int = 20),)

def_kwargs_dqgmres = extract_parameters.(def_kwargs_dqgmres)
def_kwargs_workspace_dqgmres = extract_parameters.(def_kwargs_workspace_dqgmres)

args_dqgmres = (:A, :b)
optargs_dqgmres = (:x0,)
kwargs_dqgmres = (:M, :N, :ldiv, :reorthogonalization, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)
kwargs_workspace_dqgmres = (:memory,)

@eval begin
  function dqgmres!(workspace :: DqgmresWorkspace{T,FC,S}, $(def_args_dqgmres...); $(def_kwargs_dqgmres...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, S <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    m == n || error("System must be square")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "DQGMRES: system of size %d\n", n)

    # Check M = Iₙ and N = Iₙ
    MisI = (M === I)
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == S || error("ktypeof(b) must be equal to $S")

    # Set up workspace.
    allocate_if(!MisI, workspace, :w, S, workspace.x)  # The length of w is n
    allocate_if(!NisI, workspace, :z, S, workspace.x)  # The length of z is n
    Δx, x, t, P, V = workspace.Δx, workspace.x, workspace.t, workspace.P, workspace.V
    c, s, H, stats = workspace.c, workspace.s, workspace.H, workspace.stats
    warm_start = workspace.warm_start
    rNorms = stats.residuals
    reset!(stats)
    w  = MisI ? t : workspace.w
    r₀ = MisI ? t : workspace.w

    # Initial solution x₀ and residual r₀.
    kfill!(x, zero(FC))  # x₀
    if warm_start
      kmul!(t, A, Δx)
      kaxpby!(n, one(FC), b, -one(FC), t)
    else
      kcopy!(n, t, b)  # t ← b
    end
    MisI || mulorldiv!(r₀, M, t, ldiv)  # M(b - Ax₀)
    rNorm = knorm(n, r₀)                # β = ‖r₀‖₂
    history && push!(rNorms, rNorm)
    if rNorm == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      warm_start && kaxpy!(n, one(FC), Δx, x)
      workspace.warm_start = false
      return workspace
    end

    iter = 0
    itmax == 0 && (itmax = 2*n)

    ε = atol + rtol * rNorm
    (verbose > 0) && @printf(iostream, "%5s  %7s  %5s\n", "k", "‖rₖ‖", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %.2fs\n", iter, rNorm, start_time |> ktimer)

    # Set up workspace.
    mem = length(V)  # Memory.
    for i = 1 : mem
      kfill!(V[i], zero(FC))  # Orthogonal basis of Kₖ(MAN, Mr₀).
      kfill!(P[i], zero(FC))  # Directions for x : Pₖ = NVₖ(Rₖ)⁻¹.
    end
    kfill!(c, zero(T))   # Last mem Givens cosines used for the factorization QₖRₖ = Hₖ.
    kfill!(s, zero(FC))  # Last mem Givens sines used for the factorization QₖRₖ = Hₖ.
    kfill!(H, zero(FC))  # Last column of the band hessenberg matrix Hₖ.
    # Each column has at most mem + 1 nonzero elements.
    # hᵢ.ₖ is stored as H[k-i+1], i ≤ k. hₖ₊₁.ₖ is not stored in H.
    # k-i+1 represents the index of the diagonal where hᵢ.ₖ is located.
    # In addition of that, the last column of Rₖ is also stored in H.

    # Initial γ₁ and v₁.
    γₖ = rNorm # γₖ and γₖ₊₁ are the last components of gₖ, right-hand of the least squares problem min ‖ Hₖyₖ - gₖ ‖₂.
    kdivcopy!(n, V[1], r₀, rNorm)  # v₁ = r₀ / ‖r₀‖

    # The following stopping criterion compensates for the lag in the
    # residual, but usually increases the number of iterations.
    # solved = sqrt(max(1, iter-mem+1)) * |γₖ₊₁| ≤ ε
    solved = rNorm ≤ ε # less accurate, but acceptable.
    tired = iter ≥ itmax
    status = "unknown"
    user_requested_exit = false
    overtimed = false

    while !(solved || tired || user_requested_exit || overtimed)

      # Update iteration index.
      iter = iter + 1

      # Set position in circulars stacks.
      pos = mod(iter-1, mem) + 1     # Position corresponding to pₖ and vₖ in circular stacks P and V.
      next_pos = mod(iter, mem) + 1  # Position corresponding to vₖ₊₁ in the circular stack V.

      # Incomplete Arnoldi procedure.
      z = NisI ? V[pos] : workspace.z
      NisI || mulorldiv!(z, N, V[pos], ldiv)  # Nvₖ, forms pₖ
      kmul!(t, A, z)                          # ANvₖ
      MisI || mulorldiv!(w, M, t, ldiv)       # MANvₖ, forms vₖ₊₁
      for i = max(1, iter-mem+1) : iter
        ipos = mod(i-1, mem) + 1  # Position corresponding to vᵢ in the circular stack V.
        diag = iter - i + 1
        H[diag] = kdot(n, w, V[ipos])    # hᵢ.ₖ = ⟨MANvₖ, vᵢ⟩
        kaxpy!(n, -H[diag], V[ipos], w)  # w ← w - hᵢ.ₖvᵢ
      end

      # Partial reorthogonalization of the Krylov basis.
      if reorthogonalization
        for i = max(1, iter-mem+1) : iter
          ipos = mod(i-1, mem) + 1
          diag = iter - i + 1
          Htmp = kdot(n, w, V[ipos])
          H[diag] += Htmp
          kaxpy!(n, -Htmp, V[ipos], w)
        end
      end

      # Compute hₖ₊₁.ₖ and vₖ₊₁.
      Haux = knorm(n, w)  # hₖ₊₁.ₖ = ‖vₖ₊₁‖₂
      if Haux ≠ 0   # hₖ₊₁.ₖ = 0 ⇒ "lucky breakdown"
        kdivcopy!(n, V[next_pos], w, Haux)  # vₖ₊₁ = w / hₖ₊₁.ₖ
      end

      # rₖ₋ₘₑₘ.ₖ ≠ 0 when k ≥ mem + 1
      # We don't want to use rₖ₋₁₋ₘₑₘ.ₖ₋₁ when we compute rₖ₋ₘₑₘ.ₖ
      if iter ≥ mem + 2
        H[mem+1] = zero(FC)  # rₖ₋ₘₑₘ.ₖ = 0
      end

      # Update the QR factorization of Hₖ.
      # Apply mem previous Givens reflections Ωᵢ.
      for i = max(1,iter-mem) : iter-1
        irot_pos = mod(i-1, mem) + 1  # Position corresponding to cᵢ and sᵢ in circular stacks c and s.
        diag = iter - i
        next_diag = diag + 1
        Htmp         =      c[irot_pos]  * H[next_diag] + s[irot_pos] * H[diag]
        H[diag]      = conj(s[irot_pos]) * H[next_diag] - c[irot_pos] * H[diag]
        H[next_diag] = Htmp
      end

      # Compute and apply current Givens reflection Ωₖ.
      # [cₖ  sₖ] [ hₖ.ₖ ] = [ρₖ]
      # [sₖ -cₖ] [hₖ₊₁.ₖ]   [0 ]
      (c[pos], s[pos], H[1]) = sym_givens(H[1], Haux)
      γₖ₊₁ = conj(s[pos]) * γₖ
      γₖ   =      c[pos]  * γₖ

      # Compute the direction pₖ, the last column of Pₖ = NVₖ(Rₖ)⁻¹.
      for i = max(1,iter-mem) : iter-1
        ipos = mod(i-1, mem) + 1  # Position corresponding to pᵢ in the circular stack P.
        diag = iter - i + 1
        if ipos == pos
          # pₐᵤₓ ← -hₖ₋ₘₑₘ.ₖ * pₖ₋ₘₑₘ
          kscal!(n, -H[diag], P[pos])
        else
          # pₐᵤₓ ← pₐᵤₓ - hᵢ.ₖ * pᵢ
          kaxpy!(n, -H[diag], P[ipos], P[pos])
        end
      end
      # pₐᵤₓ ← pₐᵤₓ + Nvₖ
      kaxpy!(n, one(FC), z, P[pos])
      # pₖ = pₐᵤₓ / hₖ.ₖ
      kdiv!(n, P[pos], H[1])

      # Compute solution xₖ.
      # xₖ ← xₖ₋₁ + γₖ * pₖ
      kaxpy!(n, γₖ, P[pos], x)

      # Update residual norm estimate.
      # ‖ M(b - Axₖ) ‖₂ ≈ |γₖ₊₁|
      rNorm = abs(γₖ₊₁)
      history && push!(rNorms, rNorm)

      # Update γₖ.
      γₖ = γₖ₊₁

      # Stopping conditions that do not depend on user input.
      # This is to guard against tolerances that are unreasonably small.
      resid_decrease_mach = (rNorm + one(T) ≤ one(T))

      # Update stopping criterion.
      user_requested_exit = callback(workspace) :: Bool
      resid_decrease_lim = rNorm ≤ ε
      solved = resid_decrease_lim || resid_decrease_mach
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
      kdisplay(iter, verbose) && @printf(iostream, "%5d  %7.1e  %.2fs\n", iter, rNorm, start_time |> ktimer)
    end
    (verbose > 0) && @printf(iostream, "\n")

    # Termination status
    solved              && (status = "solution good enough given atol and rtol")
    tired               && (status = "maximum number of iterations exceeded")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update x
    warm_start && kaxpy!(n, one(FC), Δx, x)
    workspace.warm_start = false

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = false
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

function test_cgne(A, b; λ=0.0, N=I, history=false)
  (nrow, ncol) = size(A)
  (x, stats) = cgne(A, b, λ=λ, N=N, history=history)
  r = b - A * x
  if λ > 0
    s = r / sqrt(λ)
    r = r - sqrt(λ) * s
  end
  resid = norm(r) / norm(b)
  return (x, stats, resid)
end
      
@testset "cgne" begin
  cgne_tol = 1.0e-6

  for FC in (Float64, ComplexF64)
    @testset "Data Type: $FC" begin

      # Underdetermined consistent.
      A, b = under_consistent(FC=FC)
      (x, stats, resid) = test_cgne(A, b)
      @test(resid ≤ cgne_tol)
      @test(stats.solved)
      (xI, xmin, xmin_norm) = check_min_norm(A, b, x)
      @test(norm(xI - xmin) ≤ cond(A) * cgne_tol * xmin_norm)

      # Underdetermined inconsistent.
      A, b = under_inconsistent(FC=FC)
      (x, stats, resid) = test_cgne(A, b)
      @test(stats.inconsistent)

      # Square consistent.
      A, b = square_consistent(FC=FC)
      (x, stats, resid) = test_cgne(A, b)
      @test(resid ≤ cgne_tol)
      @test(stats.solved)
      (xI, xmin, xmin_norm) = check_min_norm(A, b, x)
      @test(norm(xI - xmin) ≤ cond(A) * cgne_tol * xmin_norm)

      # Square inconsistent.
      A, b = square_inconsistent(FC=FC)
      (x, stats, resid) = test_cgne(A, b)
      @test(stats.inconsistent)

      # Overdetermined consistent.
      A, b = over_consistent(FC=FC)
      (x, stats, resid) = test_cgne(A, b)
      @test(resid ≤ cgne_tol)
      @test(stats.solved)
      (xI, xmin, xmin_norm) = check_min_norm(A, b, x)
      @test(norm(xI - xmin) ≤ cond(A) * cgne_tol * xmin_norm)

      # Overdetermined inconsistent.
      A, b = over_inconsistent(FC=FC)
      (x, stats, resid) = test_cgne(A, b)
      @test(stats.inconsistent)

      # With regularization, all systems are underdetermined and consistent.
      (x, stats, resid) = test_cgne(A, b, λ=1.0e-3)
      @test(resid ≤ cgne_tol)
      @test(stats.solved)
      (xI, xmin, xmin_norm) = check_min_norm(A, b, x, λ=1.0e-3)
      @test(norm(xI - xmin) ≤ cond(A) * cgne_tol * xmin_norm)

      # Test b == 0
      A, b = zero_rhs(FC=FC)
      (x, stats) = cgne(A, b, λ=1.0e-3)
      @test norm(x) == 0
      @test stats.status == "x is a zero-residual solution"

      # Test with Jacobi (or diagonal) preconditioner
      A, b, N = square_preconditioned(FC=FC)
      (x, stats, resid) = test_cgne(A, b, N=N)
      @test(resid ≤ cgne_tol)
      @test(stats.solved)
      (xI, xmin, xmin_norm) = check_min_norm(A, b, x)
      @test(norm(xI - xmin) ≤ cond(A) * cgne_tol * xmin_norm)

      # Test preconditioner with an under-determined problem:
      # Find the least norm force that transfers mass unit distance with zero final velocity
      A = 0.5 * [19.0 17.0 15.0 13.0 11.0 9.0 7.0 5.0 3.0 1.0;
                 2.0  2.0  2.0  2.0  2.0 2.0 2.0 2.0 2.0 2.0]
      b = [1.0; 0.0]
      N = Diagonal(1 ./ (A * A'))
      (x, stats, resid) = test_cgne(A, b, N=N)
      @test(resid ≤ cgne_tol)
      @test(stats.solved)
      (xI, xmin, xmin_norm) = check_min_norm(A, b, x)
      @test(norm(xI - xmin) ≤ cond(A) * cgne_tol * xmin_norm)

      # Test dimension of additional vectors
      for transpose ∈ (false, true)
        A, b, c, D = small_sp(transpose, FC=FC)
        D⁻¹ = inv(D)
        (x, stats) = cgne(A, b, N=D⁻¹, λ=1.0)
      end

      # Test different types for input and output
      A, b = over_consistent(FC=FC)
      m, n = size(A)
      workspace = CgneWorkspace(KrylovConstructor(b, TestVector(similar(b, n))))
      cgne!(workspace, A, b)
      @test workspace.stats.solved
      @test typeof(workspace.x) === TestVector{FC}

      # test callback function
      A, b = over_consistent(FC=FC)
      workspace = CgneWorkspace(A, b)
      tol = 1.0e-1
      cb_n2 = TestCallbackN2LN(A, b, real(zero(eltype(b))), tol = tol)
      cgne!(workspace, A, b, callback = cb_n2)
      @test workspace.stats.status == "user-requested exit"
      @test cb_n2(workspace)

      @test_throws TypeError cgne(A, b, callback = workspace -> "string", history = true)
    end
  end
end

# An implementation of the Golub-Kahan version of Craig's method
# for the solution of the consistent (under/over-determined or square)
# linear system
#
#  Ax = b.
#
# The method seeks to solve the minimum-norm problem
#
#  min ‖x‖  s.t.  Ax = b,
#
# and is equivalent to applying the conjugate gradient method
# to the linear system
#
#  AAᴴy = b.
#
# This method, sometimes known under the name CRAIG, is the
# Golub-Kahan implementation of CGNE, and is described in
#
# J. E. Craig, The N-step iteration procedures,
# Journal of Mathematics and Physics, 34(1-4), pp. 64--73, 1955.
#
# C. C. Paige and M. A. Saunders, LSQR: An Algorithm for Sparse
# Linear Equations and Sparse Least Squares, ACM Transactions on
# Mathematical Software, 8(1), pp. 43--71, 1982.
#
# M. A. Saunders, Solutions of Sparse Rectangular Systems Using LSQR and CRAIG,
# BIT Numerical Mathematics, 35(4), pp. 588--604, 1995.
#
# Dominique Orban, <dominique.orban@gerad.ca>
# Montréal, QC, April 2015.
#
# This implementation is strongly inspired from Mike Saunders's.

export craig, craig!

"""
    (x, y, stats) = craig(A, b::AbstractVector{FC};
                          M=I, N=I, ldiv::Bool=false,
                          transfer_to_lsqr::Bool=false, sqd::Bool=false,
                          λ::T=zero(T), btol::T=√eps(T),
                          conlim::T=1/√eps(T), atol::T=√eps(T),
                          rtol::T=√eps(T), itmax::Int=0,
                          timemax::Float64=Inf, verbose::Int=0, history::Bool=false,
                          callback=workspace->false, iostream::IO=kstdout)

`T` is an `AbstractFloat` such as `Float32`, `Float64` or `BigFloat`.
`FC` is `T` or `Complex{T}`.

Find the least-norm solution of the consistent linear system

    Ax + λ²y = b

of size m × n using the Golub-Kahan implementation of Craig's method, where λ ≥ 0 is a
regularization parameter. This method is equivalent to CGNE but is more
stable.

For a system in the form Ax = b, Craig's method is equivalent to applying
CG to AAᴴy = b and recovering x = Aᴴy. Note that y are the Lagrange
multipliers of the least-norm problem

    minimize ‖x‖  s.t.  Ax = b.

If `λ > 0`, CRAIG solves the symmetric and quasi-definite system

    [ -F     Aᴴ ] [ x ]   [ 0 ]
    [  A   λ²E  ] [ y ] = [ b ],

where E and F are symmetric and positive definite.
Preconditioners M = E⁻¹ ≻ 0 and N = F⁻¹ ≻ 0 may be provided in the form of linear operators.
If `sqd=true`, `λ` is set to the common value `1`.

The system above represents the optimality conditions of

    min ‖x‖²_F + λ²‖y‖²_E  s.t.  Ax + λ²Ey = b.

For a symmetric and positive definite matrix `K`, the K-norm of a vector `x` is `‖x‖²_K = xᴴKx`.
CRAIG is then equivalent to applying CG to `(AF⁻¹Aᴴ + λ²E)y = b` with `Fx = Aᴴy`.

If `λ = 0`, CRAIG solves the symmetric and indefinite system

    [ -F   Aᴴ ] [ x ]   [ 0 ]
    [  A   0  ] [ y ] = [ b ].

The system above represents the optimality conditions of

    minimize ‖x‖²_F  s.t.  Ax = b.

In this case, `M` can still be specified and indicates the weighted norm in which residuals are measured.

In this implementation, both the x and y-parts of the solution are returned.

#### Interface

To easily switch between Krylov methods, use the generic interface [`krylov_solve`](@ref) with `method = :craig`.

For an in-place variant that reuses memory across solves, see [`craig!`](@ref).

#### Input arguments

* `A`: a linear operator that models a matrix of dimension `m × n`;
* `b`: a vector of length `m`.

#### Keyword arguments

* `M`: linear operator that models a Hermitian positive-definite matrix of size `m` used for centered preconditioning of the augmented system;
* `N`: linear operator that models a Hermitian positive-definite matrix of size `n` used for centered preconditioning of the augmented system;
* `ldiv`: define whether the preconditioners use `ldiv!` or `mul!`;
* `transfer_to_lsqr`: transfer from the LSLQ point to the LSQR point, when it exists. The transfer is based on the residual norm;
* `sqd`: if `true`, set `λ=1` for Hermitian quasi-definite systems;
* `λ`: regularization parameter;
* `btol`: stopping tolerance used to detect zero-residual problems;
* `conlim`: limit on the estimated condition number of `A` beyond which the solution will be abandoned;
* `atol`: absolute stopping tolerance based on the residual norm;
* `rtol`: relative stopping tolerance based on the residual norm;
* `itmax`: the maximum number of iterations. If `itmax=0`, the default number of iterations is set to `m+n`;
* `timemax`: the time limit in seconds;
* `verbose`: additional details can be displayed if verbose mode is enabled (verbose > 0). Information will be displayed every `verbose` iterations;
* `history`: collect additional statistics on the run such as residual norms, or Aᴴ-residual norms;
* `callback`: function or functor called as `callback(workspace)` that returns `true` if the Krylov method should terminate, and `false` otherwise;
* `iostream`: stream to which output is logged.

#### Output arguments

* `x`: a dense vector of length `n`;
* `y`: a dense vector of length `m`;
* `stats`: statistics collected on the run in a [`SimpleStats`](@ref) structure.

#### References

* J. E. Craig, [*The N-step iteration procedures*](https://doi.org/10.1002/sapm195534164), Journal of Mathematics and Physics, 34(1-4), pp. 64--73, 1955.
* C. C. Paige and M. A. Saunders, [*LSQR: An Algorithm for Sparse Linear Equations and Sparse Least Squares*](https://doi.org/10.1145/355984.355989), ACM Transactions on Mathematical Software, 8(1), pp. 43--71, 1982.
* M. A. Saunders, [*Solutions of Sparse Rectangular Systems Using LSQR and CRAIG*](https://doi.org/10.1007/BF01739829), BIT Numerical Mathematics, 35(4), pp. 588--604, 1995.
"""
function craig end

"""
    workspace = craig!(workspace::CraigWorkspace, A, b; kwargs...)

In this call, `kwargs` are keyword arguments of [`craig`](@ref).

See [`CraigWorkspace`](@ref) for instructions on how to create the `workspace`.

For a more generic interface, you can use [`krylov_workspace`](@ref) with `method = :craig` to allocate the workspace,
and [`krylov_solve!`](@ref) to run the Krylov method in-place.
"""
function craig! end

def_args_craig = (:(A                    ),
                  :(b::AbstractVector{FC}))

def_kwargs_craig = (:(; M = I                         ),
                    :(; N = I                         ),
                    :(; ldiv::Bool = false            ),
                    :(; transfer_to_lsqr::Bool = false),
                    :(; sqd::Bool = false             ),
                    :(; λ::T = zero(T)                ),
                    :(; btol::T = √eps(T)             ),
                    :(; conlim::T = 1/√eps(T)         ),
                    :(; atol::T = √eps(T)             ),
                    :(; rtol::T = √eps(T)             ),
                    :(; itmax::Int = 0                ),
                    :(; timemax::Float64 = Inf        ),
                    :(; verbose::Int = 0              ),
                    :(; history::Bool = false         ),
                    :(; callback = workspace -> false ),
                    :(; iostream::IO = kstdout        ))

def_kwargs_craig = extract_parameters.(def_kwargs_craig)

args_craig = (:A, :b)
kwargs_craig = (:M, :N, :ldiv, :transfer_to_lsqr, :sqd, :λ, :btol, :conlim, :atol, :rtol, :itmax, :timemax, :verbose, :history, :callback, :iostream)

@eval begin
  function craig!(workspace :: CraigWorkspace{T,FC,Sm,Sn}, $(def_args_craig...); $(def_kwargs_craig...)) where {T <: AbstractFloat, FC <: FloatOrComplex{T}, Sm <: AbstractVector{FC}, Sn <: AbstractVector{FC}}

    # Timer
    start_time = time_ns()
    timemax_ns = 1e9 * timemax

    m, n = size(A)
    (m == workspace.m && n == workspace.n) || error("(workspace.m, workspace.n) = ($(workspace.m), $(workspace.n)) is inconsistent with size(A) = ($m, $n)")
    length(b) == m || error("Inconsistent problem size")
    (verbose > 0) && @printf(iostream, "CRAIG: system of %d equations in %d variables\n", m, n)

    # Check sqd and λ parameters
    sqd && (λ ≠ 0) && error("sqd cannot be set to true if λ ≠ 0 !")
    sqd && (λ = one(T))

    # Tests M = Iₘ and N = Iₙ
    MisI = (M === I)
    NisI = (N === I)

    # Check type consistency
    eltype(A) == FC || @warn "eltype(A) ≠ $FC. This could lead to errors or additional allocations in operator-vector products."
    ktypeof(b) == Sm || error("ktypeof(b) must be equal to $Sm")

    # Compute the adjoint of A
    Aᴴ = A'

    # Set up workspace.
    allocate_if(!MisI, workspace, :u , Sm, workspace.y)  # The length of u is m
    allocate_if(!NisI, workspace, :v , Sn, workspace.x)  # The length of v is n
    allocate_if(λ > 0, workspace, :w2, Sn, workspace.x)  # The length of w2 is n
    x, Nv, Aᴴu, y, w = workspace.x, workspace.Nv, workspace.Aᴴu, workspace.y, workspace.w
    Mu, Av, w2, stats = workspace.Mu, workspace.Av, workspace.w2, workspace.stats
    rNorms = stats.residuals
    reset!(stats)
    u = MisI ? Mu : workspace.u
    v = NisI ? Nv : workspace.v

    kfill!(x, zero(FC))
    kfill!(y, zero(FC))

    kcopy!(m, Mu, b)  # Mu ← b
    MisI || mulorldiv!(u, M, Mu, ldiv)
    β₁ = knorm_elliptic(m, u, Mu)
    rNorm  = β₁
    history && push!(rNorms, rNorm)
    if β₁ == 0
      stats.niter = 0
      stats.solved, stats.inconsistent = true, false
      stats.timer = start_time |> ktimer
      stats.status = "x is a zero-residual solution"
      return workspace
    end
    β₁² = β₁^2
    β = β₁
    θ = β₁      # θ will differ from β when there is regularization (λ > 0).
    ξ = -one(T) # Most recent component of x in Range(V).
    δ = λ
    ρ_prev = one(T)

    # Initialize Golub-Kahan process.
    # β₁Mu₁ = b.
    kdiv!(m, u, β₁)
    MisI || kdiv!(m, Mu, β₁)

    kfill!(Nv, zero(FC))
    kfill!(w, zero(FC))  # Used to update y.

    λ > 0 && kfill!(w2, zero(FC))

    Anorm² = zero(T) # Estimate of ‖A‖²_F.
    Anorm  = zero(T)
    Dnorm² = zero(T) # Estimate of ‖(AᴴA)⁻¹‖².
    Acond  = zero(T) # Estimate of cond(A).
    xNorm² = zero(T) # Estimate of ‖x‖².
    xNorm  = zero(T)

    iter = 0
    itmax == 0 && (itmax = m + n)

    ɛ_c = atol + rtol * rNorm   # Stopping tolerance for consistent systems.
    ɛ_i = atol                  # Stopping tolerance for inconsistent systems.
    ctol = conlim > 0 ? 1/conlim : zero(T)  # Stopping tolerance for ill-conditioned operators.
    (verbose > 0) && @printf(iostream, "%5s  %8s  %8s  %8s  %8s  %8s  %7s  %5s\n", "k", "‖r‖", "‖x‖", "‖A‖", "κ(A)", "α", "β", "timer")
    kdisplay(iter, verbose) && @printf(iostream, "%5d  %8.2e  %8.2e  %8.2e  %8.2e  %8s  %7s  %.2fs\n", iter, rNorm, xNorm, Anorm, Acond, " ✗ ✗ ✗ ✗", "✗ ✗ ✗ ✗", start_time |> ktimer)

    bkwerr = one(T)  # initial value of the backward error ‖r‖ / √(‖b‖² + ‖A‖² ‖x‖²)

    status = "unknown"

    solved_lim = bkwerr ≤ btol
    solved_mach = one(T) + bkwerr ≤ one(T)
    solved_resid_tol = rNorm ≤ ɛ_c
    solved_resid_lim = rNorm ≤ btol + atol * Anorm * xNorm / β₁
    solved = solved_mach | solved_lim | solved_resid_tol | solved_resid_lim

    ill_cond = ill_cond_mach = ill_cond_lim = false

    inconsistent = false
    tired = iter ≥ itmax
    user_requested_exit = false
    overtimed = false

    while ! (solved || inconsistent || ill_cond || tired || user_requested_exit || overtimed)
      # Generate the next Golub-Kahan vectors
      # 1. αₖ₊₁Nvₖ₊₁ = Aᴴuₖ₊₁ - βₖ₊₁Nvₖ
      kmul!(Aᴴu, Aᴴ, u)
      kaxpby!(n, one(FC), Aᴴu, -β, Nv)
      NisI || mulorldiv!(v, N, Nv, ldiv)
      α = knorm_elliptic(n, v, Nv)
      if α == 0
        inconsistent = true
        continue
      end
      kdiv!(n, v, α)
      NisI || kdiv!(n, Nv, α)

      Anorm² += α * α + λ * λ

      if λ > 0
        # Givens rotation to zero out the δ in position (k, 2k):
        #      k-1  k   2k     k   2k      k-1  k   2k
        # k   [ θ   α   δ ] [ c₁   s₁ ] = [ θ   ρ      ]
        # k+1 [     β     ] [ s₁  -c₁ ]   [     θ+   γ ]
        (c₁, s₁, ρ) = sym_givens(α, δ)
      else
        ρ = α
      end

      ξ = -θ / ρ * ξ

      if λ > 0
        # w1 = c₁ * v + s₁ * w2
        # w2 = s₁ * v - c₁ * w2
        # x  = x + ξ * w1
        kaxpy!(n, ξ * c₁, v, x)
        kaxpy!(n, ξ * s₁, w2, x)
        kaxpby!(n, s₁, v, -c₁, w2)
      else
        kaxpy!(n, ξ, v, x)  # x = x + ξ * v
      end

      # Recur y.
      kaxpby!(m, one(FC), u, -θ/ρ_prev, w)  # w = u - θ/ρ_prev * w
      kaxpy!(m, ξ/ρ, w, y)                  # y = y + ξ/ρ * w

      Dnorm² += knorm(m, w)

      # 2. βₖ₊₁Muₖ₊₁ = Avₖ - αₖMuₖ
      kmul!(Av, A, v)
      kaxpby!(m, one(FC), Av, -α, Mu)
      MisI || mulorldiv!(u, M, Mu, ldiv)
      β = knorm_elliptic(m, u, Mu)
      if β ≠ 0
        kdiv!(m, u, β)
        MisI || kdiv!(m, Mu, β)
      end

      # Finish  updates from the first Givens rotation.
      if λ > 0
        θ =  β * c₁
        γ =  β * s₁
      else
        θ = β
      end

      if λ > 0
        # Givens rotation to zero out the γ in position (k+1, 2k)
        #       2k  2k+1     2k  2k+1      2k  2k+1
        # k+1 [  γ    λ ] [ -c₂   s₂ ] = [  0    δ ]
        # k+2 [  0    0 ] [  s₂   c₂ ]   [  0    0 ]
        c₂, s₂, δ = sym_givens(λ, γ)
        kscal!(n, s₂, w2)
      end

      Anorm² += β * β
      Anorm = sqrt(Anorm²)
      Acond = Anorm * sqrt(Dnorm²)
      xNorm² += ξ * ξ
      xNorm = sqrt(xNorm²)
      rNorm = β * abs(ξ)           # r = - β * ξ * u
      λ > 0 && (rNorm *= abs(c₁))  # r = -c₁ * β * ξ * u when λ > 0.
      history && push!(rNorms, rNorm)
      iter = iter + 1

      bkwerr = rNorm / sqrt(β₁² + Anorm² * xNorm²)

      ρ_prev = ρ   # Only differs from α if λ > 0.

      kdisplay(iter, verbose) && @printf(iostream, "%5d  %8.2e  %8.2e  %8.2e  %8.2e  %8.1e  %7.1e  %.2fs\n", iter, rNorm, xNorm, Anorm, Acond, α, β, start_time |> ktimer)

      solved_lim = bkwerr ≤ btol
      solved_mach = one(T) + bkwerr ≤ one(T)
      solved_resid_tol = rNorm ≤ ɛ_c
      solved_resid_lim = rNorm ≤ btol + atol * Anorm * xNorm / β₁
      solved = solved_mach | solved_lim | solved_resid_tol | solved_resid_lim

      ill_cond_mach = one(T) + inv(Acond) ≤ one(T)
      ill_cond_lim = inv(Acond) ≤ ctol
      ill_cond = ill_cond_mach | ill_cond_lim

      user_requested_exit = callback(workspace) :: Bool
      inconsistent = false
      tired = iter ≥ itmax
      timer = time_ns() - start_time
      overtimed = timer > timemax_ns
    end
    (verbose > 0) && @printf(iostream, "\n")

    # transfer to LSQR point if requested
    if λ > 0 && transfer_to_lsqr
      ξ *= -θ / δ
      kaxpy!(n, ξ, w2, x)
      # TODO: update y
    end

    # Termination status
    tired               && (status = "maximum number of iterations exceeded")
    solved              && (status = "solution good enough for the tolerances given")
    ill_cond_mach       && (status = "condition number seems too large for this machine")
    ill_cond_lim        && (status = "condition number exceeds tolerance")
    inconsistent        && (status = "system may be inconsistent")
    user_requested_exit && (status = "user-requested exit")
    overtimed           && (status = "time limit exceeded")

    # Update stats
    stats.niter = iter
    stats.solved = solved
    stats.inconsistent = inconsistent
    stats.timer = start_time |> ktimer
    stats.status = status
    return workspace
  end
end

# [C and Fortran interfaces](@id overview-interfaces)

!!! warning "Prototype"
    This interface is still in early development. Not all Krylov.jl features are exposed yet (for example shifts and GPU devices). The API may change in future releases.

Krylov.jl ships `libkrylov`, a native shared library that exposes its solvers to languages that can call C code.

Pre-built artifacts for Linux (x86-64, aarch64), macOS (arm64, x86-64) and Windows (x86-64) are available on the [Releases](https://github.com/JuliaSmoothOptimizers/Krylov.jl/releases) page.
To build the library yourself, see [Building libkrylov](@ref building-libkrylov).

## How it works

`libkrylov` is the whole of Krylov.jl compiled ahead of time into a shared library, with the Julia runtime embedded in the bundle.
From the caller's point of view it is an ordinary C library.
There is no Julia process to start and no `.jl` file to ship, only `libkrylov.so` (or `.dylib` / `.dll`) and the two headers `krylov.h` / `krylov.f90`.

The design rests on three ideas:

- **Opaque workspace handle.** `krylov_workspace_create` allocates a *typed* Krylov workspace and hands back a `void *`. The workspace holds all the internal vectors a solver needs. You never dereference the pointer; you pass it to the other functions. The library keeps it alive (rooted against the Julia garbage collector) until you call `krylov_workspace_free`.

- **Matrix-free by callbacks.** Krylov methods only touch the operator through products `A * x` (and possibly `Aᴴ * x` or `M⁻¹ * x`). You never pass a matrix. You pass C function pointers that compute those products. The same interface drives a dense matrix, a sparse matrix, a stencil, or a fully matrix-free operator, in any language with a C ABI.

- **Concrete types, no dynamic dispatch.** A workspace is created for one `(solver, precision)` pair. Every product, dot, and axpy then runs through statically-typed, fully specialised Julia code.

The lifecycle is always the same, regardless of the solver:

1. **Create** a workspace with `krylov_workspace_create`.
2. **Solve** with `krylov_solve`, passing matrix-vector product callbacks.
3. **Retrieve** the solution with `krylov_get_x` (and `krylov_get_y` for two-solution solvers).
4. **Free** the workspace with `krylov_workspace_free`.

## Quickstart

A complete C program solving a small SPD system with CG (the Fortran equivalent is on the [Fortran interface](@ref fortran-interface) page):

```c
#include <stdio.h>
#include "krylov.h"

/* y = A*x for A = tridiag(-1, 2, -1); userdata carries the dimension n */
static void matvec_A(const void *xv, void *yv, void *userdata)
{
  const double *x = (const double *)xv;
  double       *y = (double *)yv;
  int n = *(const int *)userdata;
  for (int i = 0; i < n; i++) {
    y[i] = 2.0 * x[i];
    if (i > 0)     y[i] -= x[i-1];
    if (i < n - 1) y[i] -= x[i+1];
  }
}

int main(void)
{
  int n = 5;
  double b[5] = {1, 0, 0, 0, 1}, x[5];

  void *ws = NULL;
  krylov_workspace_create(KRYLOV_CG, n, n, KRYLOV_FLOAT64, KRYLOV_CPU, NULL, &ws);
  krylov_solve(ws, matvec_A, NULL, NULL, NULL, b, NULL, &n, NULL);  /* NULL opts = defaults */
  krylov_get_x(ws, x, n);

  printf("converged: %s   niter: %d\n",
         krylov_is_solved(ws) ? "yes" : "no", krylov_niter(ws));
  krylov_workspace_free(ws);
  return 0;
}
```

## Where to go next

The [Reference](@ref reference-interfaces) page documents the full API:

- [API overview](@ref ref-api-overview), the complete list of functions, and the [workspace lifetime](@ref ref-lifetime).
- [The matvec callbacks](@ref ref-callbacks), how the operator and preconditioners are passed.
- [Data types and precision](@ref ref-datatypes).
- [Choosing a solver](@ref ref-choosing): does it need the adjoint, a second right-hand side, or produce a second solution?
- [Options](@ref ref-options) and [return codes](@ref ref-return-codes).
- [Error handling and safety](@ref ref-errors), including thread safety.
- [Warm start](@ref ref-warm-start), [preconditioning](@ref ref-preconditioning), and [block Krylov solvers](@ref ref-block).

For runnable programs, see the [C interface](@ref c-interface) and [Fortran interface](@ref fortran-interface) pages.

## Statistics

```@docs
Krylov.KrylovStats
Krylov.SimpleStats
Krylov.LanczosStats
Krylov.LanczosShiftStats
Krylov.SymmlqStats
Krylov.AdjointStats
Krylov.LNLQStats
Krylov.LSLQStats
Krylov.LsmrStats
```

## Workspaces

```@docs
KrylovWorkspace
BlockKrylovWorkspace
```

## Utilities

```@docs
Krylov.roots_quadratic
Krylov.sym_givens
Krylov.to_boundary
Krylov.vec2str
Krylov.ktypeof
Krylov.vector_to_matrix
Krylov.matrix_to_vector
```

# [Preconditioners](@id preconditioners)

The solvers in Krylov.jl support preconditioners, i.e., transformations that modify a linear system $Ax = b$ into an equivalent form that may yield faster convergence in finite-precision arithmetic.
Preconditioning can be used to reduce the condition number of the problem or cluster its eigenvalues or singular values for instance.

The design of preconditioners is highly dependent on the origin of the problem and most preconditioners need to take application-dependent information and structure into account.
Specialized preconditioners generally outperform generic preconditioners such as incomplete factorizations.

The construction of a preconditioner necessitates trade-offs because we need to apply it at least once per iteration within a Krylov method.
Hence, a preconditioner must be constructed such that it is cheap to apply, while also capturing the characteristics of the original system in some sense.

There exist three variants of preconditioning:

| Left preconditioning               | Two-sided preconditioning                                              | Right preconditioning                        |
|:----------------------------------:|:----------------------------------------------------------------------:|:--------------------------------------------:|
| $P_{\ell}^{-1}Ax = P_{\ell}^{-1}b$ | $P_{\ell}^{-1}AP_r^{-1}y = P_{\ell}^{-1}b~~\text{with}~~x = P_r^{-1}y$ | $AP_r^{-1}y = b~~\text{with}~~x = P_r^{-1}y$ |

where $P_{\ell}$ and $P_r$ are square and nonsingular.

The left preconditioning preserves the error $x_k - x^{\star}$ whereas the right preconditioning keeps invariant the residual $b - A x_k$.
Two-sided preconditioning is the only variant that allows to preserve the hermicity of a linear system.

!!! note
    Because det$(P^{-1}A - \lambda I)$ = det$(A - \lambda P)$ det$(P^{-1})$ = det$(AP^{-1} - \lambda I)$, the eigenvalues of $P^{-1}A$ and $AP^{-1}$ are identical. If $P = LL^{H}$, $L^{-1}AL^{-H}$ also has the same spectrum.

In Krylov.jl, we call $P_{\ell}^{-1}$ and $P_r^{-1}$ the preconditioners and we assume that we can apply them with the operation $y \leftarrow P^{-1} * x$.
It is also common to call $P_{\ell}$ and $P_r$ the preconditioners if the equivalent operation $y \leftarrow P~\backslash~x$ is available.
Krylov.jl supports both approaches thanks to the argument `ldiv` of the Krylov solvers.

## How to use preconditioners in Krylov.jl?

!!! info
    - A preconditioner only needs to support the operation `mul!(y, P⁻¹, x)` when `ldiv=false` or `ldiv!(y, P, x)` when `ldiv=true` to be used in Krylov.jl.
    - Additional support for `adjoint` with preconditioners is required in the methods [`BILQ`](@ref bilq) and [`QMR`](@ref qmr).
    - The default value of a preconditioner in Krylov.jl is the identity operator `I`.

### Square non-Hermitian linear systems

Methods concerned: [`CGS`](@ref cgs), [`BILQ`](@ref bilq), [`QMR`](@ref qmr), [`BiCGSTAB`](@ref bicgstab), [`DQGMRES`](@ref dqgmres), [`GMRES`](@ref gmres), [`BLOCK-GMRES`](@ref block_gmres), [`FGMRES`](@ref fgmres), [`DIOM`](@ref diom) and [`FOM`](@ref fom).

A Krylov method dedicated to non-Hermitian linear systems allows the three variants of preconditioning.

| Preconditioners | $P_{\ell}^{-1}$       | $P_{\ell}$           | $P_r^{-1}$            | $P_r$                |
|:---------------:|:---------------------:|:--------------------:|:---------------------:|:--------------------:|
| Arguments       | `M` with `ldiv=false` | `M` with `ldiv=true` | `N` with `ldiv=false` | `N` with `ldiv=true` |

### Hermitian linear systems

Methods concerned: [`SYMMLQ`](@ref symmlq), [`CG`](@ref cg), [`CG-LANCZOS`](@ref cg_lanczos), [`CG-LANCZOS-SHIFT`](@ref cg_lanczos_shift), [`CR`](@ref cr), [`CAR`](@ref car), [`MINRES`](@ref minres), [`BLOCK-MINRES`](@ref block_minres), [`MINRES-QLP`](@ref minres_qlp) and [`MINARES`](@ref minares).

When $A$ is Hermitian, we can only use centered preconditioning $L^{-1}AL^{-H}y = L^{-1}b$ with $x = L^{-H}y$.
Centered preconditioning is a special case of two-sided preconditioning with $P_{\ell} = L = P_r^H$ that maintains hermicity.
However, there is no need to specify $L$ and one may specify $P_c = LL^H$ or its inverse directly.

| Preconditioners | $P_c^{-1}$                | $P_c$                |
|:---------------:|:-------------------------:|:--------------------:|
| Arguments       | `M` with `ldiv=false`     | `M` with `ldiv=true` |

!!! warning
    The preconditioner `M` must be hermitian and positive definite.

### Linear least-squares problems

Methods concerned: [`CGLS`](@ref cgls), [`CGLS-LANCZOS-SHIFT`](@ref cgls_lanczos_shift), [`CRLS`](@ref crls), [`LSLQ`](@ref lslq), [`LSQR`](@ref lsqr) and [`LSMR`](@ref lsmr).

| Formulation           | Without preconditioning              | With preconditioning                        |
|:---------------------:|:------------------------------------:|:-------------------------------------------:|
| least-squares problem | $\min \tfrac{1}{2} \\|b - Ax\\|^2_2$ | $\min \tfrac{1}{2} \\|b - Ax\\|^2_{E^{-1}}$ |
| Normal equation       | $A^HAx = A^Hb$                       | $A^HE^{-1}Ax = A^HE^{-1}b$                  |
| Augmented system      | $\begin{bmatrix} I & A \\ A^H & 0 \end{bmatrix} \begin{bmatrix} r \\ x \end{bmatrix} = \begin{bmatrix} b \\ 0 \end{bmatrix}$ | $\begin{bmatrix} E & A \\ A^H & 0 \end{bmatrix} \begin{bmatrix} r \\ x \end{bmatrix} = \begin{bmatrix} b \\ 0 \end{bmatrix}$ |

[`LSLQ`](@ref lslq), [`LSQR`](@ref lsqr) and [`LSMR`](@ref lsmr) also handle regularized least-squares problems.

| Formulation           | Without preconditioning                                                   | With preconditioning                                                             |
|:---------------------:|:-------------------------------------------------------------------------:|:--------------------------------------------------------------------------------:|
| least-squares problem | $\min \tfrac{1}{2} \\|b - Ax\\|^2_2 + \tfrac{1}{2} \lambda^2 \\|x\\|^2_2$ | $\min \tfrac{1}{2} \\|b - Ax\\|^2_{E^{-1}} + \tfrac{1}{2} \lambda^2 \\|x\\|^2_F$ |
| Normal equation       | $(A^HA + \lambda^2 I)x = A^Hb$                                            | $(A^HE^{-1}A + \lambda^2 F)x = A^HE^{-1}b$                                       |
| Augmented system      | $\begin{bmatrix} I & A \\ A^H & -\lambda^2 I \end{bmatrix} \begin{bmatrix} r \\ x \end{bmatrix} = \begin{bmatrix} b \\ 0 \end{bmatrix}$ | $\begin{bmatrix} E & A \\ A^H & -\lambda^2 F \end{bmatrix} \begin{bmatrix} r \\ x \end{bmatrix} = \begin{bmatrix} b \\ 0 \end{bmatrix}$ |

| Preconditioners | $E^{-1}$                | $E$                  | $F^{-1}$                | $F$                  |
|:---------------:|:-----------------------:|:--------------------:|:-----------------------:|:--------------------:|
| Arguments       | `M` with `ldiv=false`   | `M` with `ldiv=true` | `N` with `ldiv=false`   | `N` with `ldiv=true` |

!!! warning
    The preconditioners `M` and `N` must be hermitian and positive definite.

### Linear least-norm problems

Methods concerned: [`CGNE`](@ref cgne), [`CRMR`](@ref crmr), [`LNLQ`](@ref lnlq), [`CRAIG`](@ref craig) and [`CRAIGMR`](@ref craigmr).

| Formulation          | Without preconditioning                              | With preconditioning                                 |
|:--------------------:|:----------------------------------------------------:|:----------------------------------------------------:|
| minimum-norm problem | $\min \tfrac{1}{2} \\|x\\|^2_2~~\text{s.t.}~~Ax = b$ | $\min \tfrac{1}{2} \\|x\\|^2_F~~\text{s.t.}~~Ax = b$ |
| Normal equation      | $AA^Hy = b~~\text{with}~~x = A^Hy$                   | $AF^{-1}A^Hy = b~~\text{with}~~x = F^{-1}A^Hy$       |
| Augmented system     | $\begin{bmatrix} -I & A^H \\ \phantom{-}A & 0 \end{bmatrix} \begin{bmatrix} x \\ y \end{bmatrix} = \begin{bmatrix} 0 \\ b \end{bmatrix}$ | $\begin{bmatrix} -F & A^H \\ \phantom{-}A & 0 \end{bmatrix} \begin{bmatrix} x \\ y \end{bmatrix} = \begin{bmatrix} 0 \\ b \end{bmatrix}$ |

[`LNLQ`](@ref lslq), [`CRAIG`](@ref lsqr) and [`CRAIGMR`](@ref lsmr) also handle penalized minimum-norm problems.

| Formulation          | Without preconditioning                                                                       | With preconditioning                                                                           |
|:--------------------:|:---------------------------------------------------------------------------------------------:|:----------------------------------------------------------------------------------------------:|
| minimum-norm problem | $\min \tfrac{1}{2} \\|x\\|^2_2 + \tfrac{1}{2} \\|y\\|^2_2~~\text{s.t.}~~Ax + \lambda^2 y = b$ | $\min \tfrac{1}{2} \\|x\\|^2_F + \tfrac{1}{2} \\|y\\|^2_E~~\text{s.t.}~~Ax + \lambda^2 Ey = b$ |
| Normal equation      | $(AA^H + \lambda^2 I)y = b~~\text{with}~~x = A^Hy$                                            | $(AF^{-1}A^H + \lambda^2 E)y = b~~\text{with}~~x = F^{-1}A^Hy$                                 |
| Augmented system     | $\begin{bmatrix} -I & A^H \\ \phantom{-}A & \lambda^2 I \end{bmatrix} \begin{bmatrix} x \\ y \end{bmatrix} = \begin{bmatrix} 0 \\ b \end{bmatrix}$ | $\begin{bmatrix} -F & A^H \\ \phantom{-}A & \lambda^2 E \end{bmatrix} \begin{bmatrix} x \\ y \end{bmatrix} = \begin{bmatrix} 0 \\ b \end{bmatrix}$ |

| Preconditioners | $E^{-1}$                | $E$                  | $F^{-1}$                | $F$                  |
|:---------------:|:-----------------------:|:--------------------:|:-----------------------:|:--------------------:|
| Arguments       | `M` with `ldiv=false`   | `M` with `ldiv=true` | `N` with `ldiv=false`   | `N` with `ldiv=true` |

!!! warning
    The preconditioners `M` and `N` must be hermitian and positive definite.

### Saddle-point and symmetric quasi-definite systems

[`TriCG`](@ref tricg) and [`TriMR`](@ref trimr) can take advantage of the structure of Hermitian systems $Kz = d$ with the 2x2 block structure
```math
  \begin{bmatrix} \tau E & \phantom{-}A \\ A^H & \nu F \end{bmatrix} \begin{bmatrix} x \\ y \end{bmatrix} = \begin{bmatrix} b \\ c \end{bmatrix},
```
| Preconditioners | $E^{-1}$              | $E$                  | $F^{-1}$              | $F$                  |
|:---------------:|:---------------------:|:--------------------:|:---------------------:|:--------------------:|
| Arguments       | `M` with `ldiv=false` | `M` with `ldiv=true` | `N` with `ldiv=false` | `N` with `ldiv=true` |

!!! warning
    The preconditioners `M` and `N` must be hermitian and positive definite.

### Generalized saddle-point and unsymmetric partitioned systems

[`GPMR`](@ref gpmr) can take advantage of the structure of general square systems $Kz = d$ with the 2x2 block structure
```math
  \begin{bmatrix} \lambda M & A \\ B & \mu N \end{bmatrix} \begin{bmatrix} x \\ y \end{bmatrix} = \begin{bmatrix} b \\ c \end{bmatrix},
```
| Relations       | $CE = M^{-1}$                 | $EC = M$                     | $DF = N^{-1}$                 | $FD = N$                     |
|:---------------:|:-----------------------------:|:----------------------------:|:-----------------------------:|:----------------------------:|
| Arguments       | `C` and `E` with `ldiv=false` | `C` and `E` with `ldiv=true` | `D` and `F` with `ldiv=false` | `D` and `F` with `ldiv=true` |

!!! note
    Our implementations of [`BiLQ`](@ref bilq), [`QMR`](@ref qmr), [`BiLQR`](@ref bilqr), [`USYMLQ`](@ref usymlq), [`USYMQR`](@ref usymqr), [`USYMLQR`](@ref usymlqr) and [`TriLQR`](@ref trilqr) don't support preconditioning.

## Packages that provide preconditioners

- [KrylovPreconditioners.jl](https://github.com/JuliaSmoothOptimizers/KrylovPreconditioners.jl) implements block-Jacobi, IC(0) and ILU(0) preconditioners.
- [ILUZero.jl](https://github.com/mcovalt/ILUZero.jl) is a Julia implementation of incomplete LU factorization with zero level of fill-in. 
- [LimitedLDLFactorizations.jl](https://github.com/JuliaSmoothOptimizers/LimitedLDLFactorizations.jl) for limited-memory LDLᵀ factorization of symmetric matrices.
- [AlgebraicMultigrid.jl](https://github.com/JuliaLinearAlgebra/AlgebraicMultigrid.jl) provides two algebraic multigrid (AMG) preconditioners.
- [RandomizedPreconditioners.jl](https://github.com/tjdiamandis/RandomizedPreconditioners.jl) uses randomized numerical linear algebra to construct approximate inverses of matrices.
- [BasicLU.jl](https://github.com/JuliaSmoothOptimizers/BasicLU.jl) uses a sparse LU factorization to compute a maximum volume basis that can be used as a preconditioner for least-norm and least-squares problems.

## Examples

```julia
using KrylovPreconditioners, Krylov

P⁻¹ = BlockJacobiPreconditioner(A)  # Block-Jacobi preconditioner
x, stats = gmres(A, b, M=P⁻¹)
```

```julia
using Krylov
n, m = size(A)
d = [A[i,i] ≠ 0 ? 1 / abs(A[i,i]) : 1 for i=1:n]  # Jacobi preconditioner
P⁻¹ = diagm(d)
x, stats = symmlq(A, b, M=P⁻¹)
```

```julia
using Krylov
n, m = size(A)
d = [1 / norm(A[:,i]) for i=1:m]  # diagonal preconditioner
P⁻¹ = diagm(d)
x, stats = minres(A, b, M=P⁻¹)
```

```julia
using KrylovPreconditioners, Krylov
Pℓ = ilu(A)
x, stats = gmres(A, b, M=Pℓ, ldiv=true)  # left preconditioning
```

```julia
using LimitedLDLFactorizations, Krylov
P = lldl(A)
P.D .= abs.(P.D)
x, stats = cg(A, b, M=P, ldiv=true)  # centered preconditioning
```

```julia
using ILUZero, Krylov
Pᵣ = ilu0(A)
x, stats = bicgstab(A, b, N=Pᵣ, ldiv=true)  # right preconditioning
```

```julia
using LDLFactorizations, Krylov

M = ldl(E)
N = ldl(F)

# [E   A] [x] = [b]
# [Aᴴ -F] [y]   [c]
x, y, stats = tricg(A, b, c, M=M, N=N, ldiv=true)
```

```julia
using RandomizedPreconditioners, Krylov

Â = NystromSketch(A, k, r)

P = NystromPreconditioner(Â, μ)
x, stats = cg(A + μ*I, b; M=P, ldiv=true)

P⁻¹ = NystromPreconditionerInverse(Â, μ)
x, stats = cg(A + μ*I, b; M=P⁻¹)
```

```julia
using SuiteSparse, Krylov
import LinearAlgebra.ldiv!

M = cholesky(E)

# ldiv! is not implemented for the sparse Cholesky factorization (SuiteSparse.CHOLMOD)
ldiv!(y::Vector{T}, F::SuiteSparse.CHOLMOD.Factor{T}, x::Vector{T}) where T = (y .= F \ x)

# [E  A] [x] = [b]
# [Aᴴ 0] [y]   [c]
x, y, stats = trimr(A, b, c, M=M, sp=true, ldiv=true)
```

```julia
using Krylov

C = lu(M)

# [M  A] [x] = [b]
# [B  0] [y]   [c]
x, y, stats = gpmr(A, B, b, c, C=C, gsp=true, ldiv=true)
```

```julia
import BasicLU
using LinearOperators, Krylov

# Least-squares problem
m, n = size(A)
Aᴴ = sparse(A')
basis, B = BasicLU.maxvolbasis(Aᴴ)
opA = LinearOperator(A)
B⁻ᴴ = LinearOperator(Float64, n, n, false, false, (y, v) -> (y .= v ; BasicLU.solve!(B, y, 'T')),
                                                  (y, v) -> (y .= v ; BasicLU.solve!(B, y, 'N')),
                                                  (y, v) -> (y .= v ; BasicLU.solve!(B, y, 'N')))

d, stats = lsmr(opA * B⁻ᴴ, b)  # min ‖AB⁻ᴴd - b‖₂
x = B⁻ᴴ * d                    # recover the solution of min ‖Ax - b‖₂

# Least-norm problem
m, n = size(A)
basis, B = maxvolbasis(A)
opA = LinearOperator(A)
B⁻¹ = LinearOperator(Float64, m, m, false, false, (y, v) -> (y .= v ; BasicLU.solve!(B, y, 'N')),
                                                  (y, v) -> (y .= v ; BasicLU.solve!(B, y, 'T')),
                                                  (y, v) -> (y .= v ; BasicLU.solve!(B, y, 'T')))

x, y, stats = craigmr(B⁻¹ * opA, B⁻¹ * b)  # min ‖x‖₂  s.t.  B⁻¹Ax = B⁻¹b
```

# [Building libkrylov](@id building-libkrylov)

Pre-built, self-contained bundles for Linux (x86-64, aarch64), macOS (arm64, x86-64) and Windows (x86-64) are attached to every [release](https://github.com/JuliaSmoothOptimizers/Krylov.jl/releases) starting from `v0.10.7`.
This page describes how to build the library from source and how to compile and link a C or Fortran program against it.

## Requirements

| Tool | Version |
|------|---------|
| Julia | ≥ 1.12 |
| JuliaC.jl | ≥ 0.3.8 |
| C / Fortran compiler | gcc / clang, gfortran |

[JuliaC.jl](https://github.com/JuliaLang/JuliaC.jl) wraps Julia's `juliac` compiler and adds `--bundle`. This produces a self-contained library that embeds the Julia runtime, so no separate Julia installation is required at run time.

## Build from source

All commands run from the root of the Krylov.jl repository.

```bash
# Install JuliaC.jl once (it installs juliac into ~/.julia/bin)
julia -e 'import Pkg; Pkg.Apps.add(url="https://github.com/JuliaLang/JuliaC.jl", rev="v0.3.8")'
export PATH="$HOME/.julia/bin:$PATH"   # add to ~/.bashrc to make it permanent

# Build the bundle (library + embedded Julia runtime)
juliac \
    --project . \
    --compile-ccallable \
    --trim=safe \
    --bundle interfaces/build \
    --output-lib interfaces/build/lib/libkrylov.so \
    interfaces/src/LibKrylov.jl

# Generate the headers and copy them next to the library
julia --startup-file=no --project=. interfaces/scripts/generate_header.jl
cp interfaces/include/krylov.h   interfaces/build/include/
cp interfaces/include/krylov.f90 interfaces/build/include/

# Copy the SuiteSparse libraries into the bundle (see the note below)
JLIB="$(julia --startup-file=no -e 'print(joinpath(Sys.BINDIR, "..", "lib", "julia"))')"
for name in amd btf camd ccolamd cholmod colamd klu ldl rbio spqr suitesparseconfig umfpack; do
  cp -a "$JLIB"/lib"$name".* interfaces/build/lib/julia/
done
```

!!! warning "SuiteSparse must be copied manually"
    `juliac --bundle` only copies the libraries it can trace statically. The
    SuiteSparse stack (`libbtf`, `libcholmod`, `libumfpack`, ...) is loaded
    dynamically by Julia at startup (`SparseArrays` is a dependency of Krylov),
    so `juliac` does not see it. Without the copy step above, the bundle runs
    fine on a machine that has Julia installed. On a clean machine it fails with
    `could not load library "libbtf.so.2"`. On Windows the libraries live in
    `Sys.BINDIR` (the `bin/` folder) instead of `lib/julia`.

The `--bundle` flag produces a relocatable directory:

```
interfaces/build/
├── lib/
│   ├── libkrylov.so     ← the library
│   └── julia/           ← embedded Julia runtime (no system Julia needed)
└── include/
    ├── krylov.h
    └── krylov.f90
```

The `--trim=safe` flag is what keeps the bundle small by discarding unreachable code:

| Build | Size (Linux x86-64, all solvers × 4 precisions) |
|-------|------|
| No trim | ~269 MB |
| `--trim=safe` | ~19 MB |

!!! note "Platform differences"
    - **Windows:** use `--output-lib interfaces/build/bin/libkrylov.dll`; the bundle lands in `build/bin/`.
    - **macOS:** replace `.so` with `.dylib`.

## Compiling and linking a C program

Link against the bundled `libkrylov`, and point the runtime loader at the embedded Julia runtime with an `-rpath`:

```bash
gcc -O2 -o basic_cg interfaces/examples/C/basic_cg.c \
    -I interfaces/build/include \
    interfaces/build/lib/libkrylov.so \
    -Wl,-rpath,'$ORIGIN/../lib/julia'
```

On macOS, use `-Wl,-rpath,@loader_path/../lib/julia` instead. Add `-lm` if your program uses the math library.

## Compiling and linking a Fortran program

```bash
gfortran -O2 -o basic_cg interfaces/examples/Fortran/basic_cg.f90 \
    interfaces/build/lib/libkrylov.so
```

The `include 'krylov.f90'` line resolves relative to the source file. So either keep `krylov.f90` next to your program, or pass `-I interfaces/build/include` and adjust the `include` path accordingly.

## Running

```bash
./basic_cg
# Solved: yes   niter: 3   time: 3.2e-05 s
# x = [ 1.00 1.00 1.00 1.00 1.00 ]
```

If the loader cannot find `libkrylov` or the embedded Julia runtime at run time, add the bundle directories to the library search path, for example on Linux:

```bash
export LD_LIBRARY_PATH="$PWD/interfaces/build/lib:$PWD/interfaces/build/lib/julia:$LD_LIBRARY_PATH"
```

(use `DYLD_LIBRARY_PATH` on macOS and `PATH` on Windows).

```@meta
# Thanks Morten Piibeleht for the hack with the tables!
```

```@raw html
<style>
.content table td {
    border-right-width: 1px;
}
.content table th {
    border-right-width: 1px;
}
.content table td:last-child {
    border-right-width: 0px;
}
.content table th:last-child {
    border-right-width: 0px;
}
html.theme--documenter-dark .content table td {
    border-right-width: 1px;
}
html.theme--documenter-dark .content table th {
    border-right-width: 1px;
}
html.theme--documenter-dark .content table td:last-child {
    border-right-width: 0px;
}
html.theme--documenter-dark .content table th:last-child {
    border-right-width: 0px;
}
</style>
```

# [Storage requirements](@id storage-requirements)

This section provides the storage requirements of all Krylov methods available in Krylov.jl.

### Notation

We denote by $m$ and $n$ the number of rows and columns of the linear problem.
The memory parameter of DIOM, FOM, DQGMRES, GMRES, FGMRES and GPMR is $k$.
The numbers of shifts of CG-LANCZOS-SHIFT and CGLS-LANCZOS-SHIFT is $p$.

## Theoretical storage requirements

The following tables provide the number of coefficients that must be allocated for each Krylov method.
The coefficients have the same type as those that compose the linear problem we seek to solve.
Each table summarizes the storage requirements of Krylov methods recommended to a specific linear problem.

#### Hermitian positive definite linear systems

| Methods | [`CG`](@ref cg) | [`CR`](@ref cr) | [`CAR`](@ref car) | [`CG-LANCZOS`](@ref cg_lanczos) | [`CG-LANCZOS-SHIFT`](@ref cg_lanczos_shift) |
|:-------:|:---------------:|:---------------:|:-----------------:|:-------------------------------:|:-------------------------------------------:|
 Storage  | $4n$            | $5n$            | $7n$              | $5n$                            | $3n + 2np + 5p$                             |

#### Hermitian indefinite linear systems

| Methods | [`SYMMLQ`](@ref symmlq) | [`MINRES`](@ref minres) | [`MINRES-QLP`](@ref minres_qlp) | [`MINARES`](@ref minares) |
|:-------:|:-----------------------:|:-----------------------:|:-------------------------------:|:-------------------------:|
| Storage | $5n$                    | $6n$                    | $6n$                            | $8n$                      |

#### Non-Hermitian square linear systems

| Methods | [`CGS`](@ref cgs) | [`BICGSTAB`](@ref bicgstab) | [`BiLQ`](@ref bilq) | [`QMR`](@ref qmr) |
|:-------:|:-----------------:|:---------------------------:|:-------------------:|:-----------------:|
| Storage | $6n$              | $6n$                        | $8n$                | $9n$              |

| Methods | [`DIOM`](@ref diom) | [`DQGMRES`](@ref dqgmres) |
|:-------:|:-------------------:|:-------------------------:|
| Storage | $n(2k+1) + 2k - 1$  | $n(2k+2) + 3k + 1$        |

| Methods | [`FOM`](@ref fom)                                  | [`GMRES`](@ref gmres)                   | [`FGMRES`](@ref fgmres)                  |
|:-------:|:--------------------------------------------------:|:---------------------------------------:|:----------------------------------------:|
| Storage$\dfrac{}{}$ | $\!n(2+k) +2k + \dfrac{k(k + 1)}{2}\!$ | $\!n(2+k) + 3k + \dfrac{k(k + 1)}{2}\!$ | $\!n(2+2k) + 3k + \dfrac{k(k + 1)}{2}\!$ |

#### Least-norm problems

| Methods | [`USYMLQ`](@ref usymlq) | [`CGNE`](@ref cgne) | [`CRMR`](@ref crmr) | [`LNLQ`](@ref lnlq) | [`CRAIG`](@ref craig) | [`CRAIGMR`](@ref craigmr) |
|:-------:|:-----------------------:|:-------------------:|:-------------------:|:-------------------:|:---------------------:|:-------------------------:|
| Storage | $5n + 3m$               | $3n + 2m$           | $3n + 2m$           | $3n + 4m$           | $3n + 4m$             | $4n + 5m$                 |

#### Least-squares problems

| Methods | [`USYMQR`](@ref usymqr) | [`CGLS`](@ref cgls) | [`CGLS-LANCZOS-SHIFT`](@ref cgls_lanczos_shift) | [`CRLS`](@ref crls) | [`LSLQ`](@ref lslq) | [`LSQR`](@ref lsqr) | [`LSMR`](@ref lsmr) |
|:-------:|:-----------------------:|:-------------------:|:-----------------------------------------------:|:-------------------:|:-------------------:|:-------------------:|:-------------------:|
| Storage | $6n + 3m$               | $3n + 2m$           | $3n + 2m + 5p + 2np$                            | $4n + 3m$           | $4n + 2m$           | $4n + 2m$           | $5n + 2m$           |

#### Adjoint systems

| Methods | [`BiLQR`](@ref bilqr) | [`TriLQR`](@ref trilqr) |
|:-------:|:---------------------:|:-----------------------:|
| Storage | $11n$                 | $6m + 5n$               |

#### Saddle-point and Hermitian quasi-definite systems

| Methods  | [`TriCG`](@ref tricg) | [`TriMR`](@ref trimr) | [`USYMLQR`](@ref usymlqr) |
|:--------:|:---------------------:|:---------------------:|:-------------------------:|
| Storage  | $6n + 6m$             | $8n + 8m$             | $7n + 6m$                 |

#### Generalized saddle-point and non-Hermitian partitioned systems

| Method  | [`GPMR`](@ref gpmr)       |
|:-------:|:-------------------------:|
| Storage | $(2+k)(n+m) + 2k^2 + 11k$ |

## Practical storage requirements

Each method has its own `KrylovWorkspace` that contains all the storage needed by the method.
In the REPL, the size in bytes of each attribute and the total amount of memory allocated by the solver are displayed when we show a `KrylovWorkspace`.

```@example storage
using Krylov

m = 5000
n = 12000
A = rand(Float64, m, n)
b = rand(Float64, m)
workspace = LsmrWorkspace(A, b)
show(stdout, workspace, show_stats=false)
```

If we want the total number of bytes used by the workspace, we can call `nbytes = sizeof(workspace)`.

```@example storage
nbytes = sizeof(workspace)
```

Thereafter, we can use `Base.format_bytes(nbytes)` to recover what is displayed in the REPL.

```@example storage
Base.format_bytes(nbytes)
```

To verify that we match the theoretical results, we just need to multiply the storage requirement of a method by the number of bytes associated to the precision of the linear problem.
For instance, we need 4 bytes for the precision `Float32`, 8 bytes for precisions `Float64` and `ComplexF32`, and 16 bytes for the precision `ComplexF64`.

```@example storage
FC = Float64                            # precision of the least-squares problem
ncoefs_lsmr = 5*n + 2*m                 # number of coefficients
nbytes_lsmr = sizeof(FC) * ncoefs_lsmr  # number of bytes
```

Therefore, you can check that you have enough memory in RAM to allocate a `KrylovWorkspace`.

```@example storage
free_nbytes = Sys.free_memory()
Base.format_bytes(free_nbytes)  # Total free memory in RAM in bytes.
```

!!! note
    - Beyond having faster operations, using low precisions, such as simple precision, allows to store more coefficients in RAM and solve larger linear problems.
    - In the file [test_allocations.jl](https://github.com/JuliaSmoothOptimizers/Krylov.jl/blob/main/test/test_allocations.jl), we use the macro `@allocated` to verify that the storage requirements of each Krylov solver match the expected values, within a tolerance of 2% (and 5% for block Krylov solvers). These tests are performed across the four main precisions: `Float32`, `Float64`, `ComplexF32`, and `ComplexF64`.

## [Generic interface](@id generic-interface)

Krylov.jl provides a generic interface for solving linear systems using (block) Krylov methods.
The interface is designed to be common for all methods and contains three routines [`krylov_workspace`](@ref krylov_workspace), [`krylov_solve`](@ref krylov_solve) and [`krylov_solve!`](@ref krylov_solve!).
They allow to build Krylov workspaces and call both in-place and out-of-place variants of the solvers with a unified API.

```@docs
krylov_workspace
krylov_solve
krylov_solve!
```

The section on [workspace accessors](@ref workspace-accessors) describes how to retrieve the solution, statistics, and other results from a workspace after calling `krylov_solve!`.

## Examples

```@example op_interface
using Krylov, SparseArrays, LinearAlgebra

# Define a symmetric positive definite matrix A and a right-hand side vector b
n = 1000
A = sprandn(n, n, 0.005)
A = A * A' + I
b = randn(n)

# Out-of-place interface
for method in (:cg, :cr, :car)
    x, stats = krylov_solve(Val(method), A, b)
    r = b - A * x
    println("Residual norm for $(method): ", norm(r))
end
```

```@example ip_interface
using Krylov, SparseArrays, LinearAlgebra

# Define a square nonsymmetric matrix A and a right-hand side vector b
n = 100
A = sprand(n, n, 0.05) + I
b = rand(n)

# In-place interface
for method in (:bicgstab, :gmres, :qmr)
    # Create a workspace for the Krylov method
    workspace = krylov_workspace(Val(method), A, b)

    # Solve the system in-place
    krylov_solve!(workspace, A, b)

    # Get the statistics
    stats = Krylov.statistics(workspace)

    # Retrieve the solution
    x = Krylov.solution(workspace)

    # Check if the solver converged
    solved = Krylov.issolved(workspace)
    println("Convergence of $method: ", solved)

    # Display the number of iterations
    niter = Krylov.iteration_count(workspace)
    println("Number of iterations for $method: ", niter)

    # Display the allocation timer
    allocation_timer = Krylov.elapsed_allocation_time(workspace)
    println("Elapsed allocation time for $method: ", allocation_timer, " seconds")

    # Display the computation timer
    computation_timer = Krylov.elapsed_time(workspace)
    println("Elapsed time for $method: ", computation_timer, " seconds")

    # Display the number of operator-vector products with A and A'
    nAprod = Krylov.Aprod_count(workspace)
    nAtprod = Krylov.Atprod_count(workspace)
    println("Number of operator-vector products with A and A' for $method: ", (nAprod, nAtprod))

    println()
end
```

```@raw html
<style>
.content table td {
    border-right-width: 1px;
}
.content table th {
    border-right-width: 1px;
}
.content table td:last-child {
    border-right-width: 0px;
}
.content table th:last-child {
    border-right-width: 0px;
}
html.theme--documenter-dark .content table td {
    border-right-width: 1px;
}
html.theme--documenter-dark .content table th {
    border-right-width: 1px;
}
html.theme--documenter-dark .content table td:last-child {
    border-right-width: 0px;
}
html.theme--documenter-dark .content table th:last-child {
    border-right-width: 0px;
}
</style>
```

# [Krylov processes](@id krylov-processes)

Krylov processes are the foundation of Krylov methods, they generate bases of Krylov subspaces.
Depending on the Krylov subspaces generated, Krylov processes are more or less specialized for a subset of linear problems.
The following table summarizes the most relevant processes for each linear problem.

| Linear problems                                                |  Processes                        |
|:--------------------------------------------------------------:|:---------------------------------:|
| Hermitian linear systems                                       | Hermitian Lanczos                 |
| Square Non-Hermitian linear systems                            | Non-Hermitian Lanczos -- Arnoldi  |
| Least-squares problems                                         | Golub-Kahan -- Saunders-Simon-Yip |
| Least-norm problems                                            | Golub-Kahan -- Saunders-Simon-Yip |
| Saddle-point and Hermitian quasi-definite systems              | Golub-Kahan -- Saunders-Simon-Yip |
| Generalized saddle-point and non-Hermitian partitioned systems | Montoison-Orban                   |

### Notation

For a matrix $A$, $A^H$ denotes the conjugate transpose of $A$.
It coincides with $A^T$, the transpose of $A$, for real matrices.
Define $V_k := \begin{bmatrix} v_1 & \ldots & v_k \end{bmatrix} \enspace$ and $\enspace U_k := \begin{bmatrix} u_1 & \ldots & u_k \end{bmatrix}$.

For a matrix $C \in \mathbb{C}^{n \times n}$ and a vector $t \in \mathbb{C}^{n}$, the $k$-th Krylov subspace generated by $C$ and $t$ is
```math
\mathcal{K}_k(C, t) :=
\left\{\sum_{i=0}^{k-1} \omega_i C^i t \, \middle \vert \, \omega_i \in \mathbb{C},~0 \le i \le k-1 \right\}.
```

For matrices $C \in \mathbb{C}^{n \times n} \enspace$ and $\enspace T \in \mathbb{C}^{n \times p}$, the $k$-th block Krylov subspace generated by $C$ and $T$ is
```math
\mathcal{K}_k^{\square}(C, T) :=
\left\{\sum_{i=0}^{k-1} C^i T \, \Omega_i \, \middle \vert \, \Omega_i \in \mathbb{C}^{p \times p},~0 \le i \le k-1 \right\}.
```

## [Hermitian Lanczos](@id hermitian-lanczos)

![hermitian_lanczos](./graphics/hermitian_lanczos.png)

After $k$ iterations of the Hermitian Lanczos process, the situation may be summarized as
```math
\begin{align*}
  A V_k &= V_k T_k + \beta_{k+1,k} v_{k+1} e_k^T = V_{k+1} T_{k+1,k}, \\
  V_k^H V_k &= I_k,
\end{align*}
```
where $V_k$ is an orthonormal basis of the Krylov subspace $\mathcal{K}_k(A,b)$,
```math
T_k =
\begin{bmatrix}
  \alpha_1 & \bar{\beta}_2 &         &               \\
  \beta_2  & \alpha_2      & \ddots  &               \\
           & \ddots        & \ddots  & \bar{\beta}_k \\
           &               & \beta_k & \alpha_k
\end{bmatrix}
, \qquad
T_{k+1,k} =
\begin{bmatrix}
  T_{k} \\
  \beta_{k+1} e_{k}^T
\end{bmatrix}.
```
Note that depending on how we normalize the vectors that compose $V_k$, $T_{k+1,k}$ can be a real tridiagonal matrix even if $A$ is a complex matrix.

The function [`hermitian_lanczos`](@ref hermitian_lanczos(::Any, ::AbstractVector{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)) returns $V_{k+1}$, $\beta_1$ and $T_{k+1,k}$.

Related methods: [`SYMMLQ`](@ref symmlq), [`CG`](@ref cg), [`CR`](@ref cr), [`CAR`](@ref car), [`MINRES`](@ref minres), [`MINRES-QLP`](@ref minres_qlp), [`MINARES`](@ref minares), [`CGLS`](@ref cgls), [`CGLS-LANCZOS-SHIFT`](@ref cgls_lanczos_shift), [`CRLS`](@ref crls), [`CGNE`](@ref cgne), [`CRMR`](@ref crmr), [`CG-LANCZOS`](@ref cg_lanczos) and [`CG-LANCZOS-SHIFT`](@ref cg_lanczos_shift).

```@docs
hermitian_lanczos(::Any, ::AbstractVector{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)
```

## [Non-Hermitian Lanczos](@id nonhermitian-lanczos)

![nonhermitian_lanczos](./graphics/nonhermitian_lanczos.png)

After $k$ iterations of the non-Hermitian Lanczos process (also named the Lanczos biorthogonalization process), the situation may be summarized as
```math
\begin{align*}
  A V_k &= V_k T_k + \beta_{k+1} v_{k+1} e_k^T = V_{k+1} T_{k+1,k}, \\
  A^H U_k &= U_k T_k^H + \bar{\gamma}_{k+1} u_{k+1} e_k^T = U_{k+1} T_{k,k+1}^H, \\
  V_k^H U_k &= U_k^H V_k = I_k,
\end{align*}
```
where $V_k$ and $U_k$ are bases of the Krylov subspaces $\mathcal{K}_k (A,b)$ and $\mathcal{K}_k (A^H,c)$, respectively,
```math
T_k = 
\begin{bmatrix}
  \alpha_1 & \gamma_2 &          &          \\
  \beta_2  & \alpha_2 & \ddots   &          \\
           & \ddots   & \ddots   & \gamma_k \\
           &          & \beta_k  & \alpha_k
\end{bmatrix}
, \qquad
T_{k+1,k} =
\begin{bmatrix}
  T_{k} \\
  \beta_{k+1} e_{k}^T
\end{bmatrix}
, \qquad
T_{k,k+1} =
\begin{bmatrix}
  T_{k} & \gamma_{k+1} e_k
\end{bmatrix}.
```

The function [`nonhermitian_lanczos`](@ref nonhermitian_lanczos(::Any, ::AbstractVector{FC}, ::AbstractVector{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)) returns $V_{k+1}$, $\beta_1$, $T_{k+1,k}$, $U_{k+1}$, $\bar{\gamma}_1$ and $T_{k,k+1}^H$.

Related methods: [`BiLQ`](@ref bilq), [`QMR`](@ref qmr), [`BiLQR`](@ref bilqr), [`CGS`](@ref cgs) and [`BICGSTAB`](@ref bicgstab).

!!! note
    The scaling factors used in our implementation are $\beta_k = |u_k^H v_k|^{\tfrac{1}{2}}$ and $\gamma_k = (u_k^H v_k) / \beta_k$.
    With these scaling factors, the non-Hermitian Lanczos process coincides with the Hermitian Lanczos process when $A = A^H$ and $b = c$.

```@docs
nonhermitian_lanczos(::Any, ::AbstractVector{FC}, ::AbstractVector{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)
```

The non-Hermitian Lanczos process can be also implemented without $A^H$ (transpose-free variant).
To derive it, we can observe that $\beta_{k+1} v_{k+1} = P_k(A) b~~$ and $\bar{\gamma}_{k+1} u_{k+1} = Q_k(A^H) c~~$ where $P_k$ and $Q_k$ are polynomials of degree $k$.
The polynomials are defined from the recursions:
```math
\begin{align*}
  P_0(A)   &= I_n, \\
  P_1(A)   &= \left(\dfrac{A - \alpha_1 I_n}{\beta_1}\right) P_0(A), \\
  P_k(A)   &= \left(\dfrac{A - \alpha_k I_n}{\beta_k}\right) P_{k-1}(A) - \dfrac{\gamma_k}{\beta_{k-1}} P_{k-2}(A), \quad k \ge 2, \\
           & \\
  Q_0(A^H) &= I_n, \\
  Q_1(A^H) &= \left(\dfrac{A^H - \bar{\alpha}_1 I_n}{\bar{\gamma}_1}\right) Q_0(A^H), \\
  Q_k(A^H) &= \left(\dfrac{A^H - \bar{\alpha}_k I_n}{\bar{\gamma}_k}\right) Q_{k-1}(A^H) - \dfrac{\bar{\beta}_k}{\bar{\gamma}_{k-1}} Q_{k-2}(A^H), \quad k \ge 2.
\end{align*}
```

Because $\alpha_k = u_k^H A v_k$ and $(\bar{\gamma}_{k+1} u_{k+1})^H (\beta_{k+1} v_{k+1}) = \gamma_{k+1} \beta_{k+1}$, we can determine the coefficients of $T_{k+1,k}$ and $T_{k,k+1}^H$ as follows:
```math
\begin{align*}
  \alpha_k &= \dfrac{1}{\gamma_k \beta_k} \langle~Q_{k-1}(A^H) c \, , \, A P_{k-1}(A) b~\rangle \\
           &= \dfrac{1}{\gamma_k \beta_k} \langle~c \, , \, \bar{Q}_{k-1}(A) A P_{k-1}(A) b~\rangle, \\
           & \\
  \beta_{k+1} \gamma_{k+1} &= \langle~Q_k(A^H) c \, , \, P_k(A) b~\rangle \\
                           &= \langle~c \, , \, \bar{Q}_k(A) P_k(A) b~\rangle.
\end{align*}
```

## [Arnoldi](@id arnoldi)

![arnoldi](./graphics/arnoldi.png)

After $k$ iterations of the Arnoldi process, the situation may be summarized as
```math
\begin{align*}
  A V_k &= V_k H_k + h_{k+1,k} v_{k+1} e_k^T = V_{k+1} H_{k+1,k}, \\
  V_k^H V_k &= I_k,
\end{align*}
```
where $V_k$ is an orthonormal basis of the Krylov subspace $\mathcal{K}_k (A,b)$,
```math
H_k =
\begin{bmatrix}
  h_{1,1}~ & h_{1,2}~ & \ldots    & h_{1,k}   \\
  h_{2,1}~ & \ddots~  & \ddots    & \vdots    \\
           & \ddots~  & \ddots    & h_{k-1,k} \\
           &          & h_{k,k-1} & h_{k,k}
\end{bmatrix}
, \qquad
H_{k+1,k} =
\begin{bmatrix}
  H_{k} \\
  h_{k+1,k} e_{k}^T
\end{bmatrix}.
```

The function [`arnoldi`](@ref arnoldi(::Any, ::AbstractVector{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)) returns $V_{k+1}$, $\beta$ and $H_{k+1,k}$.

Related methods: [`DIOM`](@ref diom), [`FOM`](@ref fom), [`DQGMRES`](@ref dqgmres), [`GMRES`](@ref gmres) and [`FGMRES`](@ref fgmres).

!!! note
    The Arnoldi process coincides with the Hermitian Lanczos process when $A$ is Hermitian.

```@docs
arnoldi(::Any, ::AbstractVector{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)
```

## [Golub-Kahan](@id golub-kahan)

![golub_kahan](./graphics/golub_kahan.png)

After $k$ iterations of the Golub-Kahan bidiagonalization process, the situation may be summarized as
```math
\begin{align*}
  A V_k &= U_{k+1} B_k, \\
  A^H U_{k+1} &= V_k B_k^H + \bar{\alpha}_{k+1} v_{k+1} e_{k+1}^T = V_{k+1} L_{k+1}^H, \\
  V_k^H V_k &= U_k^H U_k = I_k,
\end{align*}
```
where $V_k$ and $U_k$ are bases of the Krylov subspaces $\mathcal{K}_k (A^HA,A^Hb)$ and $\mathcal{K}_k (AA^H,b)$, respectively,
```math
L_k =
\begin{bmatrix}
  \alpha_1 &          &          &          \\
  \beta_2  & \alpha_2 &          &          \\
           & \ddots   & \ddots   &          \\
           &          & \beta_k  & \alpha_k
\end{bmatrix}
, \qquad
B_k =
\begin{bmatrix}
  \alpha_1 &          &          &             \\
  \beta_2  & \alpha_2 &          &             \\
           & \ddots   & \ddots   &             \\
           &          & \beta_k  & \alpha_k    \\
           &          &          & \beta_{k+1} \\
\end{bmatrix}
=
\begin{bmatrix}
  L_{k} \\
  \beta_{k+1} e_{k}^T
\end{bmatrix}.
```
Note that depending on how we normalize the vectors that compose $V_k$ and $U_k$, $L_k$ can be a real bidiagonal matrix even if $A$ is a complex matrix.

The function [`golub_kahan`](@ref golub_kahan(::Any, ::AbstractVector{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)) returns $V_{k+1}$, $U_{k+1}$, $\beta_1$ and $L_{k+1}$.

Related methods: [`LNLQ`](@ref lnlq), [`CRAIG`](@ref craig), [`CRAIGMR`](@ref craigmr), [`LSLQ`](@ref lslq), [`LSQR`](@ref lsqr) and [`LSMR`](@ref lsmr).

!!! note
    The Golub-Kahan process coincides with the Hermitian Lanczos process applied to the normal equations $A^HA x = A^Hb$ and $AA^H x = b$.
    It is also related to the Hermitian Lanczos process applied to $\begin{bmatrix} 0 & A \\ A^H & 0 \end{bmatrix}$ with initial vector $\begin{bmatrix} b \\ 0 \end{bmatrix}$.

```@docs
golub_kahan(::Any, ::AbstractVector{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)
```

## [Saunders-Simon-Yip](@id saunders-simon-yip)

![saunders_simon_yip](./graphics/saunders_simon_yip.png)

After $k$ iterations of the Saunders-Simon-Yip process (also named the orthogonal tridiagonalization process), the situation may be summarized as
```math
\begin{align*}
  A U_k &= V_k T_k + \beta_{k+1} v_{k+1} e_k^T = V_{k+1} T_{k+1,k}, \\
  A^H V_k &= U_k T_k^H + \bar{\gamma}_{k+1} u_{k+1} e_k^T = U_{k+1} T_{k,k+1}^H, \\
  V_k^H V_k &= U_k^H U_k = I_k,
\end{align*}
```
where $\begin{bmatrix} V_k & 0 \\ 0 & U_k \end{bmatrix}$ is an orthonormal basis of the block Krylov subspace $\mathcal{K}^{\square}_k \left(\begin{bmatrix} 0 & A \\ A^H & 0 \end{bmatrix}, \begin{bmatrix} b & 0 \\ 0 & c \end{bmatrix}\right)$,
```math
T_k = 
\begin{bmatrix}
  \alpha_1 & \gamma_2 &          &          \\
  \beta_2  & \alpha_2 & \ddots   &          \\
           & \ddots   & \ddots   & \gamma_k \\
           &          & \beta_k  & \alpha_k
\end{bmatrix}
, \qquad
T_{k+1,k} =
\begin{bmatrix}
  T_{k} \\
  \beta_{k+1} e_{k}^T
\end{bmatrix}
, \qquad
T_{k,k+1} =
\begin{bmatrix}
  T_{k} & \gamma_{k+1} e_{k}
\end{bmatrix}.
```

The function [`saunders_simon_yip`](@ref saunders_simon_yip(::Any, ::AbstractVector{FC}, ::AbstractVector{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)) returns $V_{k+1}$, $\beta_1$, $T_{k+1,k}$, $U_{k+1}$, $\bar{\gamma}_1$ and $T_{k,k+1}^H$.

Related methods: [`USYMLQ`](@ref usymlq), [`USYMQR`](@ref usymqr), [`USYMLQR`](@ref usymlqr), [`TriLQR`](@ref trilqr), [`TriCG`](@ref tricg) and [`TriMR`](@ref trimr).

!!! note
    The Saunders-Simon-Yip is equivalent to the block-Lanczos process applied to $\begin{bmatrix} 0 & A \\ A^H & 0 \end{bmatrix}$ with initial matrix $\begin{bmatrix} b & 0 \\ 0 & c \end{bmatrix}$.

```@docs
saunders_simon_yip(::Any, ::AbstractVector{FC}, ::AbstractVector{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)
```

## [Montoison-Orban](@id montoison-orban)

![montoison_orban](./graphics/montoison_orban.png)

After $k$ iterations of the Montoison-Orban process (also named the orthogonal Hessenberg reduction process), the situation may be summarized as
```math
\begin{align*}
  A U_k &= V_k H_k + h_{k+1,k} v_{k+1} e_k^T = V_{k+1} H_{k+1,k}, \\
  B V_k &= U_k F_k + f_{k+1,k} u_{k+1} e_k^T = U_{k+1} F_{k+1,k}, \\
  V_k^H V_k &= U_k^H U_k = I_k,
\end{align*}
```
where $\begin{bmatrix} V_k & 0 \\ 0 & U_k \end{bmatrix}$ is an orthonormal basis of the block Krylov subspace $\mathcal{K}^{\square}_k \left(\begin{bmatrix} 0 & A \\ B & 0 \end{bmatrix}, \begin{bmatrix} b & 0 \\ 0 & c \end{bmatrix}\right)$,
```math
H_k =
\begin{bmatrix}
  h_{1,1}~ & h_{1,2}~ & \ldots    & h_{1,k}   \\
  h_{2,1}~ & \ddots~  & \ddots    & \vdots    \\
           & \ddots~  & \ddots    & h_{k-1,k} \\
           &          & h_{k,k-1} & h_{k,k}
\end{bmatrix}
, \qquad
F_k =
\begin{bmatrix}
  f_{1,1}~ & f_{1,2}~ & \ldots    & f_{1,k}   \\
  f_{2,1}~ & \ddots~  & \ddots    & \vdots    \\
           & \ddots~  & \ddots    & f_{k-1,k} \\
           &          & f_{k,k-1} & f_{k,k}
\end{bmatrix},
```
```math
H_{k+1,k} =
\begin{bmatrix}
  H_{k} \\
  h_{k+1,k} e_{k}^T
\end{bmatrix}
, \qquad
F_{k+1,k} =
\begin{bmatrix}
  F_{k} \\
  f_{k+1,k} e_{k}^T
\end{bmatrix}.
```

The function [`montoison_orban`](@ref montoison_orban(::Any, ::Any, ::AbstractVector{FC}, ::AbstractVector{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)) returns $V_{k+1}$, $\beta$, $H_{k+1,k}$, $U_{k+1}$, $\gamma$ and $F_{k+1,k}$.

Related methods: [`GPMR`](@ref gpmr).

!!! note
    The Montoison-Orban is equivalent to the block-Arnoldi process applied to $\begin{bmatrix} 0 & A \\ B & 0 \end{bmatrix}$ with initial matrix $\begin{bmatrix} b & 0 \\ 0 & c \end{bmatrix}$.
    It also coincides with the Saunders-Simon-Yip process when $B = A^H$.

```@docs
montoison_orban(::Any, ::Any, ::AbstractVector{FC}, ::AbstractVector{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)
```

```@raw html
<style>
.content table td {
    border-right-width: 1px;
}
.content table th {
    border-right-width: 1px;
}
.content table td:last-child {
    border-right-width: 0px;
}
.content table th:last-child {
    border-right-width: 0px;
}
html.theme--documenter-dark .content table td {
    border-right-width: 1px;
}
html.theme--documenter-dark .content table th {
    border-right-width: 1px;
}
html.theme--documenter-dark .content table td:last-child {
    border-right-width: 0px;
}
html.theme--documenter-dark .content table th:last-child {
    border-right-width: 0px;
}
</style>
```

## [Matrix-free operators](@id matrix-free)

All methods are matrix-free, which means that you only need to provide operator-vector products.

The `A` or `B` input arguments of Krylov.jl solvers can be any object that represents a linear operator. That object must implement `mul!`, for multiplication with a vector, `size()` and `eltype()`. For certain methods it must also implement `adjoint()`.

Some methods only require `A * v` products, whereas other ones also require `A' * u` products. In the latter case, `adjoint(A)` must also be implemented.

| A * v                                           | A * v and A' * u                         |
|:-----------------------------------------------:|:----------------------------------------:|
| CG, CR, CAR                                     | CGLS, CRLS, CGNE, CRMR                   |
| SYMMLQ, CG-LANCZOS, MINRES, MINRES-QLP, MINARES | LSLQ, LSQR, LSMR, LNLQ, CRAIG, CRAIGMR   |
| DIOM, FOM, DQGMRES, GMRES, FGMRES, BLOCK-GMRES  | BiLQ, QMR, BiLQR, USYMLQ, USYMQR, TriLQR |
| CGS, BICGSTAB                                   | TriCG, TriMR, USYMLQR                    |
| CG-LANCZOS-SHIFT                                | CGLS-LANCZOS-SHIFT                       |

!!! info
    GPMR is the only method that requires `A * v` and `B * w` products.

Preconditioners `M`, `N`, `C`, `D`, `E` or `F` can be also linear operators and must implement `mul!` or `ldiv!`.

We strongly recommend [LinearOperators.jl](https://github.com/JuliaSmoothOptimizers/LinearOperators.jl) to model matrix-free operators, but other packages such as [LinearMaps.jl](https://github.com/JuliaLinearAlgebra/LinearMaps.jl), [DiffEqOperators.jl](https://github.com/SciML/DiffEqOperators.jl) or your own operator can be used as well.

With `LinearOperators.jl`, operators are defined as

```julia
A = LinearOperator(type, nrows, ncols, symmetric, hermitian, prod, tprod, ctprod)
```

where
* `type` is the operator element type;
* `nrow` and `ncol` are its dimensions;
* `symmetric` and `hermitian` should be set to `true` or `false`;
* `prod(y, v)`, `tprod(y, w)` and `ctprod(u, w)` are called when writing `mul!(y, A, v)`, `mul!(y, transpose(A), w)`, and `mul!(y, A', u)`, respectively.

See the [tutorial](https://jso.dev/tutorials/introduction-to-linear-operators/) and the detailed [documentation](https://jso.dev/LinearOperators.jl/dev/) for more information on `LinearOperators.jl`.

## Examples with automatic differentiation

In the field of nonlinear optimization, finding critical points of a continuous function frequently involves linear systems with a Hessian or Jacobian as coefficient. Materializing such operators as matrices is expensive in terms of operations and memory consumption and is unreasonable for high-dimensional problems. However, it is often possible to implement efficient Hessian-vector and Jacobian-vector products, for example with the help of automatic differentiation tools, and used within Krylov solvers. We now illustrate variants with explicit matrices and with matrix-free operators for two well-known optimization methods.

### Example 1: Newton's Method for convex optimization

At each iteration of Newton's method applied to a $\mathcal{C}^2$ strictly convex function $f : \mathbb{R}^n \rightarrow \mathbb{R}$, a descent direction direction is determined by minimizing the quadratic Taylor model of $f$:

```math
\min_{d \in \mathbb{R}^n}~~f(x_k) + \nabla f(x_k)^T d + \tfrac{1}{2}~d^T \nabla^2 f(x_k) d
```
which is equivalent to solving the symmetric and positive-definite system
```math
\nabla^2 f(x_k) d  = -\nabla f(x_k).
```
The system above can be solved with the conjugate gradient method as follows, using the explicit Hessian:

```@nlp
using ForwardDiff, Krylov

xk = -ones(4)

f(x) = (x[1] - 1)^2 + (x[2] - 2)^2 + (x[3] - 3)^2 + (x[4] - 4)^2

g(x) = ForwardDiff.gradient(f, x)

H(x) = ForwardDiff.hessian(f, x)

d, stats = cg(H(xk), -g(xk))
```

The explicit Hessian can be replaced by a linear operator that only computes Hessian-vector products:

```@example hessian_operator
using ForwardDiff, LinearOperators, Krylov

xk = -ones(4)

f(x) = (x[1] - 1)^2 + (x[2] - 2)^2 + (x[3] - 3)^2 + (x[4] - 4)^2

g(x) = ForwardDiff.gradient(f, x)

H(y, v) = ForwardDiff.derivative!(y, t -> g(xk + t * v), 0)
opH = LinearOperator(Float64, 4, 4, true, true, (y, v) -> H(y, v))

cg(opH, -g(xk))
```

### Example 2: The Gauss-Newton Method for Nonlinear Least Squares

At each iteration of the Gauss-Newton method applied to a nonlinear least-squares objective $f(x) = \tfrac{1}{2}\| F(x)\|^2$ where $F : \mathbb{R}^n \rightarrow \mathbb{R}^m$ is $\mathcal{C}^1$, we solve the subproblem:

```math
\min_{d \in \mathbb{R}^n}~~\tfrac{1}{2}~\|J(x_k) d + F(x_k)\|^2,
```
where $J(x)$ is the Jacobian of $F$ at $x$.

An appropriate iterative method to solve the above linear least-squares problems is LSMR. We could pass the explicit Jacobian to LSMR as follows:

```@nls
using ForwardDiff, Krylov

xk = ones(2)

F(x) = [x[1]^4 - 3; exp(x[2]) - 2; log(x[1]) - x[2]^2]

J(x) = ForwardDiff.jacobian(F, x)

d, stats = lsmr(J(xk), -F(xk))
```

However, the explicit Jacobian can be replaced by a linear operator that only computes Jacobian-vector and transposed Jacobian-vector products:

```@example jacobian_operator
using LinearAlgebra, ForwardDiff, LinearOperators, Krylov

xk = ones(2)

F(x) = [x[1]^4 - 3; exp(x[2]) - 2; log(x[1]) - x[2]^2]

J(y, v) = ForwardDiff.derivative!(y, t -> F(xk + t * v), 0)
Jᵀ(y, u) = ForwardDiff.gradient!(y, x -> dot(F(x), u), xk)
opJ = LinearOperator(Float64, 3, 2, false, false, (y, v) -> J(y, v),
                                                  (y, w) -> Jᵀ(y, w),
                                                  (y, u) -> Jᵀ(y, u))

lsmr(opJ, -F(xk))
```

## Example with FFT and IFFT

### Example 3: Solving the Poisson equation with FFT and IFFT

In applications related to partial differential equations (PDEs), linear systems can arise from discretizing differential operators.
Storing such operators as explicit matrices is computationally expensive and unnecessary when matrix-free methods can be used, particularly with structured grids.

The FFT is an algorithm that computes the discrete Fourier transform (DFT) of a sequence, transforming data from the spatial domain to the frequency domain.
In the context of solving PDEs, it simplifies the application of differential operators like the Laplacian by converting derivatives into algebraic operations.

For a function $u(x)$ discretized on a periodic grid with $n$ points, the FFT of $u$ is:

```math
\hat{u}_k = \sum_{j=0}^{n-1} u_j e^{-i k x_j},
```

where $\hat{u}_k$ represents the Fourier coefficients for the frequency $k$, and $u_j$ is the value of $u$ at the grid point $x_j$ defined as $x_j = \frac{2 \pi j}{L}$ with period $L$.
The inverse FFT (IFFT) reconstructs $u$ from its Fourier coefficients:

```math
u_j = \frac{1}{n} \sum_{k=0}^{n-1} \hat{u}_k e^{i k x_j}.
```

In Fourier space, the Laplacian operator $\frac{d^2}{dx^2}$ becomes a simple multiplication by $-k^2$, where $k$ is the wavenumber derived from the grid size.
This transforms the Poisson equation $\frac{d^2 u(x)}{dx^2} = f(x)$ into an algebraic equation in the frequency domain:

```math
-k^2 \hat{u}_k = \hat{f}_k.
```

By solving for $\hat{u}_k$ and applying the IFFT, we can recover the solution $u(x)$ efficiently.

The inverse FFT is used to convert data from the frequency domain back to the spatial domain.
Once the solution in frequency space is obtained by dividing the Fourier coefficients $\hat{f}_k$ by $-k^2$ for $k \neq 0$,
the IFFT is applied to transform the result back to the original grid points in the spatial domain.
At $k = 0$, the equation $-k^2 \hat{u}_0 = \hat{f}_0$ becomes indeterminate since $k^2 = 0$.
This situation corresponds to the zero-frequency component $\hat{f}_0$, which represents the mean of $f(x)$.
In such cases, $\hat{u}_0$ is treated separately.
It is typically set to 0 to remove the constant mode, or adjusted based on boundary conditions or other constraints.

In some cases, even though the FFT provides an efficient way to apply differential operators (such as the Laplacian)
in the frequency domain, a direct solution may not be feasible due to complex boundary conditions,
variable coefficients, or grid irregularities.
In these situations, the FFT must be coupled with a Krylov method to iteratively solve the problem.

This example consists of solving the 1D Poisson equation on a periodic domain $[0, 4\pi]$:

```math
\frac{d^2 u(x)}{dx^2} = f(x),
```

where $u(x)$ is the unknown solution, and $f(x)$ is the given source term.
We solve this equation using [FFTW.jl](https://github.com/JuliaMath/FFTW.jl) to compute the matrix-free action of the Laplacian within the conjugate gradient solver.

Note that while a direct FFT-based approach can be used here due to the simplicity of the periodic boundary conditions,
this example illustrates how a Krylov method can be employed to solve more challenging problems.

```@example fft_poisson
using FFTW, Krylov, LinearAlgebra

# Define the problem size and domain
n = 32768                         # Number of grid points (2^15)
L = 4π                            # Length of the domain
x = LinRange(0, L, n+1)[1:end-1]  # Periodic grid (excluding the last point)

# Define the source term f(x)
f = sin.(x)

# Define a matrix-free operator using FFT and IFFT
struct FFTPoissonOperator
    n::Int
    L::Float64
    complex::Bool
    k::Vector{Float64}  # Store Fourier wave numbers
end

function FFTPoissonOperator(n::Int, L::Float64, complex::Bool)
    if complex
        k = Vector{Float64}(undef, n)
    else
        k = Vector{Float64}(undef, n÷2 + 1)
    end
    k[1] = sum(f) / n  # average value of f(x) over the domain
    for j in 1:(n÷2)
        k[j+1] = 2 * π * j / L  # Positive wave numbers
    end
    if complex
        for j in 1:(n÷2 - 1)
            k[n-j+1] = -2 * π * j / L  # Negative wave numbers
        end
    end
    return FFTPoissonOperator(n, L, complex, k)
end

Base.size(A::FFTPoissonOperator) = (n, n)

function Base.eltype(A::FFTPoissonOperator)
    type = A.complex ? ComplexF64 : Float64
    return type
end

function LinearAlgebra.mul!(y::Vector, A::FFTPoissonOperator, u::Vector)
    # Transform the input vector `u` to the frequency domain using `fft` or `rfft`.
    # If the operator is complex, use the full FFT; otherwise, use the real FFT.
    if A.complex
        u_hat = fft(u)
    else
        u_hat = rfft(u)
    end

    # In Fourier space, solve the system by multiplying with -k^2 (corresponding to the second derivative).
    # This step applies the Laplacian operator in the frequency domain.
    u_hat .= -u_hat .* (A.k .^ 2)

    # Transform the result back to the spatial domain using `ifft` or `irfft`.
    # If the operator is complex, use the full inverse FFT; otherwise, use the inverse real FFT.
    if A.complex
        y .= ifft(u_hat)
    else
        y .= irfft(u_hat, A.n)
    end

    return y
end

# Create the matrix-free operator for the Poisson equation
complex = false
A = FFTPoissonOperator(n, L, complex)

# Solve the linear system using CG
u_sol, stats = cg(A, f, atol=1e-10, rtol=0.0, verbose=1)
```

```@example fft_poisson
# The exact solution is u(x) = -sin(x)
u_star = -sin.(x)
u_star ≈ u_sol
```

## Example with discretized PDE

### Example 4: Solving the 3D Helmholtz equation

The Helmholtz equation in 3D is a fundamental equation used in various fields like acoustics, electromagnetism, and quantum mechanics to model stationary wave phenomena.

The equation is given by:
```math
\nabla^2 u(x,y,z) + k^2 u(x,y,z) = f(x,y,z)
```
In this equation, $u(x, y, z)$ represents the unknown function, which could describe a pressure field in acoustics, a scalar potential in electromagnetism, or a wave function in quantum mechanics.
The operator $\nabla^2$ denotes the Laplacian in three dimensions. The wave number $k$ is related to the frequency of the wave through the equation $k = \frac{2\pi}{\lambda}$, where $\lambda$ is the wavelength.
Finally, $f(x,y,z)$ is a source term that drives the wave phenomena, acting as a forcing function or external influence.

To discretize the Helmholtz equation, we use finite differences on a uniform 3D grid with grid spacings $\Delta x$, $\Delta y$, and $\Delta z$.
For a grid point $(i, j, k)$, the second derivatives are approximated as follows:

- In the $x$-direction:
```math
\frac{\partial^2 u}{\partial x^2} \approx \frac{u_{i+1,j,k} - 2u_{i,j,k} + u_{i-1,j,k}}{\Delta x^2}
```
- In the $y$-direction:
```math
\frac{\partial^2 u}{\partial y^2} \approx \frac{u_{i,j+1,k} - 2u_{i,j,k} + u_{i,j-1,k}}{\Delta y^2}
```
- In the $z$-direction:
```math
\frac{\partial^2 u}{\partial z^2} \approx \frac{u_{i,j,k+1} - 2u_{i,j,k} + u_{i,j,k-1}}{\Delta z^2}
```
Combining these, the discretized Helmholtz equation becomes:
```math
\frac{u_{i+1,j,k} - 2u_{i,j,k} + u_{i-1,j,k}}{\Delta x^2} + \frac{u_{i,j+1,k} - 2u_{i,j,k} + u_{i,j-1,k}}{\Delta y^2} + \frac{u_{i,j,k+1} - 2u_{i,j,k} + u_{i,j,k-1}}{\Delta z^2} + k^2 u_{i,j,k} = f_{i,j,k}
```

This discretization results in an equation at each grid point, resulting in a large and sparse linear system when assembled across the entire 3D grid.
To simplify the example, we impose Dirichlet boundary conditions with the solution $u(x, y, z) = 0$ on the boundary of the cubic domain.

Explicitly constructing this large sparse matrix is often impractical and unnecessary.
Instead, we can define a function that directly applies the Helmholtz operator to the 3D grid, avoiding the need to form the matrix explicitly.

Krylov.jl operates on vectors, so we must vectorize both the solution and the computational domain.
However, we can still maintain the structure of the original 3D operator by using `reshape` and `vec`.
This approach enables a simpler and efficient application of the operator in 3D while leveraging the vectorized framework for linear algebra operations.

```@example helmholtz
using Krylov, LinearAlgebra

# Parameters
L = 1.0                 # Length of the cubic domain
Nx = 200                # Number of interior grid points in x
Ny = 200                # Number of interior grid points in y
Nz = 200                # Number of interior grid points in z
Δx = L / (Nx + 1)       # Grid spacing in x
Δy = L / (Ny + 1)       # Grid spacing in y
Δz = L / (Nz + 1)       # Grid spacing in z
wavelength = 0.5        # Wavelength of the wave
k = 2 * π / wavelength  # Wave number

# Create the grid points
x = 0:Δx:L  # Points in x dimension (Nx + 2)
y = 0:Δy:L  # Points in y dimension (Ny + 2)
z = 0:Δz:L  # Points in z dimension (Nz + 2)

# Define a matrix-free Helmholtz operator
struct HelmholtzOperator
    Nx::Int
    Ny::Int
    Nz::Int
    Δx::Float64
    Δy::Float64
    Δz::Float64
    k::Float64
end

Base.size(A::HelmholtzOperator) = (A.Nx * A.Ny * A.Nz, A.Nx * A.Ny * A.Nz)

Base.eltype(A::HelmholtzOperator) = Float64

function LinearAlgebra.mul!(y::Vector, A::HelmholtzOperator, u::Vector)
    # Reshape vectors y and u into 3D arrays
    U = reshape(u, A.Nx, A.Ny, A.Nz)
    Y = reshape(y, A.Nx, A.Ny, A.Nz)

    # Apply the discrete Laplacian in 3D with k^2 * u
    for i in 1:A.Nx
        for j in 1:A.Ny
            for k in 1:A.Nz
                if i == 1
                    dx2 = (U[i+1,j,k] -2 * U[i,j,k]) / (A.Δx)^2
                elseif i == A.Nx
                    dx2 = (-2 * U[i,j,k] + U[i-1,j,k]) / (A.Δx)^2
                else
                    dx2 = (U[i+1,j,k] -2 * U[i,j,k] + U[i-1,j,k]) / (A.Δx)^2
                end

                if j == 1
                    dy2 = (U[i,j+1,k] -2 * U[i,j,k]) / (A.Δy)^2
                elseif j == A.Ny
                    dy2 = (-2 * U[i,j,k] + U[i,j-1,k]) / (A.Δy)^2
                else
                    dy2 = (U[i,j+1,k] -2 * U[i,j,k] + U[i,j-1,k]) / (A.Δy)^2
                end

                if k == 1
                    dz2 = (U[i,j,k+1] -2 * U[i,j,k]) / (A.Δz)^2
                elseif k == A.Nz
                    dz2 = (-2 * U[i,j,k] + U[i,j,k-1]) / (A.Δz)^2
                else
                    dz2 = (U[i,j,k+1] -2 * U[i,j,k] + U[i,j,k-1]) / (A.Δz)^2
                end

                Y[i,j,k] = dx2 + dy2 + dz2 + (A.k)^2 * U[i,j,k]
            end
        end
    end

    return y
end

# Create the matrix-free operator for the Helmholtz equation
A = HelmholtzOperator(Nx, Ny, Nz, Δx, Δy, Δz, k)

# Source term f(x, y, z) = -2k² * sin(kx) * sin(ky) * sin(kz)
F = [-2 * k^2 * sin(k * x[ii+1]) * sin(k * y[jj+1]) * sin(k * z[kk+1]) for ii in 1:Nx, jj in 1:Ny, kk in 1:Nz]
f = vec(F)

# Solve the linear system using MinAres
u_sol, stats = minares(A, f, atol=1e-10, rtol=0.0, verbose=1)
```

```@example helmholtz
# Solution as 3D array
U_sol = reshape(u_sol, Nx, Ny, Nz)

# Exact solution u(x,y,z) = sin(kx) * sin(ky) * sin(kz)
U_star = [sin(k * x[ii+1]) * sin(k * y[jj+1]) * sin(k * z[kk+1]) for ii in 1:Nx, jj in 1:Ny, kk in 1:Nz]

# Compute the maximum error between the numerical solution U_sol and the exact solution U_star
norm(U_sol - U_star, Inf)
```

Note that preconditioners can be also implemented as abstract operators.
For instance, we could compute the Cholesky factorization of $M$ and $N$ and create linear operators that perform the forward and backsolves.

Krylov methods combined with factorization free operators allow to reduce computation time and memory requirements considerably by avoiding building and storing the system matrix.
In the field of partial differential equations, the implementation of high-performance factorization free operators and assembly free preconditioning is a subject of active research.

## [In-place methods](@id in-place)

All solvers in Krylov.jl have an in-place variant implemented in a method whose name ends with `!`.
A workspace (`KrylovWorkspace` or `BlockKrylovWorkspace`), which contains the storage needed by a Krylov method, can be used to solve multiple linear systems with the same dimensions and the same floating-point precision.
It should also be the same number of right-hand sides in block Krylov methods.
The section [storage requirements](@ref storage-requirements) specifies the memory needed for each Krylov method.

Each `KrylovWorkspace` has at least three constructors with consistent argument patterns:

```@constructors
XyzWorkspace(A, b)
XyzWorkspace(m, n, S)
XyzWorkspace(kc::KrylovConstructor)
```
The only exceptions are [`CgLanczosShiftWorkspace`](@ref) and [`CglsLanczosShiftWorkspace`](@ref), which require an additional argument `nshifts`.

Depending on the method, some workspaces may also be constructed as:

```@constructors_extended
XyzWorkspace(A, b, c)
XyzWorkspace(m, n, Sm, Sn)
```

Additionally, some constructors accept keyword arguments.

`Xyz` represents the name of the Krylov method, written in lowercase except for its first letter (such as `Cg`, `Minres`, `Lsmr` or `Bicgstab`).
If the name of the Krylov method contains an underscore (e.g., `minres_qlp` or `cgls_lanczos_shift`), the workspace constructor transforms it by capitalizing each word and removing underscores, resulting in names like `MinresQlpWorkspace` or `CglsLanczosShiftWorkspace`.

Given an operator `A` and a right-hand side `b`, you can create a `KrylovWorkspace` based on the size of `A` and the type of `b`, or explicitly provide the dimensions `(m, n)` and the storage type `S`.

We assume that `S(undef, 0)`, `S(undef, n)`, and `S(undef, m)` are well-defined for the storage type `S`.
For more advanced vector types, workspaces can also be created with the help of a `KrylovConstructor`.
```@docs
KrylovConstructor
```
See the section [custom workspaces](@ref custom_workspaces) for an example where this constructor is the only applicable option.

For example, use `S = Vector{Float64}` if you want to solve linear systems in double precision on the CPU and `S = CuVector{Float32}` if you want to solve linear systems in single precision on an Nvidia GPU.

The workspace is always the first argument of the in-place methods:

```@solvers
minres_workspace = MinresWorkspace(m, n, Vector{Float64})
minres!(minres_workspace, A1, b1)

bicgstab_workspace = BicgstabWorkspace(m, n, Vector{ComplexF64})
bicgstab!(bicgstab_workspace, A2, b2)

gmres_workspace = GmresWorkspace(m, n, Vector{BigFloat})
gmres!(gmres_workspace, A3, b3)

lsqr_workspace = LsqrWorkspace(m, n, CuVector{Float32})
lsqr!(lsqr_workspace, A4, b4)
```

## [Workspace accessors](@id workspace-accessors)

In-place solvers update the workspace, from which solutions and statistics can be retrieved.
The following functions are available for post-solve analysis.

These functions are not exported and must be accessed using the prefix `Krylov.`, e.g. `Krylov.solution(workspace)`.

```@docs
Krylov.results
Krylov.solution
Krylov.statistics
Krylov.elapsed_time
Krylov.elapsed_allocation_time
Krylov.issolved
Krylov.solution_count
Krylov.iteration_count
Krylov.Aprod_count
Krylov.Atprod_count
```

## Examples

We illustrate the use of in-place Krylov solvers with two well-known optimization methods.
The details of the optimization methods are described in the section about [Factorization-free operators](@ref matrix-free).

### Example 1: Newton's method for convex optimization without linesearch

```@newton
using Krylov
import Krylov: solution

function newton(∇f, ∇²f, x₀; itmax = 200, tol = 1e-8)

    n = length(x₀)
    x = copy(x₀)
    gx = ∇f(x)
    
    iter = 0
    S = typeof(x)
    workspace = CgWorkspace(n, n, S)

    solved = false
    tired = false

    while !(solved || tired)
 
        Hx = ∇²f(x)              # Compute ∇²f(xₖ)
        cg!(workspace, Hx, -gx)  # Solve ∇²f(xₖ)Δx = -∇f(xₖ)
        Δx = solution(workspace) # Recover Δx from the workspace
        x = x + Δx               # Update xₖ₊₁ = xₖ + Δx
        gx = ∇f(x)               # ∇f(xₖ₊₁)
        
        iter += 1
        solved = norm(gx) ≤ tol
        tired = iter ≥ itmax
    end
    return x
end
```

### Example 2: The Gauss-Newton method for nonlinear least squares without linesearch

```@gauss_newton
using Krylov
import Krylov: solution

function gauss_newton(F, JF, x₀; itmax = 200, tol = 1e-8)

    n = length(x₀)
    x = copy(x₀)
    Fx = F(x)
    m = length(Fx)
    
    iter = 0
    S = typeof(x)
    workspace = LsmrWorkspace(m, n, S)

    solved = false
    tired = false

    while !(solved || tired)
 
        Jx = JF(x)                 # Compute J(xₖ)
        lsmr!(workspace, Jx, -Fx)  # Minimize ‖J(xₖ)Δx + F(xₖ)‖
        Δx = solution(workspace)   # Recover Δx from the workspace
        x = x + Δx                 # Update xₖ₊₁ = xₖ + Δx
        Fx_old = Fx                # F(xₖ)
        Fx = F(x)                  # F(xₖ₊₁)
        
        iter += 1
        solved = norm(Fx - Fx_old) / norm(Fx) ≤ tol
        tired = iter ≥ itmax
    end
    return x
end
```

```@meta
# Hermitian positive definite linear systems
```

## CG

```@docs
cg
cg!
CgWorkspace
```

## CR

```@docs
cr
cr!
CrWorkspace
```

## CAR

```@docs
car
car!
CarWorkspace
```

## CG-LANCZOS

```@docs
cg_lanczos
cg_lanczos!
CgLanczosWorkspace
```

## CG-LANCZOS-SHIFT

```@docs
cg_lanczos_shift
cg_lanczos_shift!
CgLanczosShiftWorkspace
```

# [Callbacks](@id callbacks)

Each Krylov method is able to call a callback function as `callback(workspace)` at each iteration.
The callback should return `true` if the main loop should terminate, and `false` otherwise.
If the method terminated because of the callback, the output status will be `"user-requested exit"`.
For example, if the user defines `minres_callback(workspace::MinresWorkspace)`, it can be passed to the solver using

```julia
(x, stats) = minres(A, b, callback = minres_callback)
```

If you need to write a callback that uses variables that are not in a `KrylovWorkspace`, use a closure:

```julia
function custom_stopping_condition(workspace::KrylovWorkspace, A, b, r, tol)
  mul!(r, A, workspace.x)
  r .-= b               # r := b - Ax
  bool = norm(r) ≤ tol  # tolerance based on the 2-norm of the residual
  return bool
end

cg_callback(workspace) = custom_stopping_condition(workspace, A, b, r, tol)
(x, stats) = cg(A, b, callback = cg_callback)
```

Alternatively, use a structure and make it callable:

```julia
mutable struct CallbackWorkspace{T}
  A::Matrix{T}
  b::Vector{T}
  r::Vector{T}
  tol::T
end

function (callback::CallbackWorkspace)(workspace::KrylovWorkspace)
  mul!(callback.r, callback.A, workspace.x)
  callback.r .-= callback.b
  bool = norm(callback.r) ≤ callback.tol
  return bool
end

bicgstab_callback = CallbackWorkspace(A, b, r, tol)
(x, stats) = bicgstab(A, b, callback = bicgstab_callback)
```

Although the main goal of a callback is to add new stopping conditions, it can also retrieve information from the workspace of a Krylov method along the iterations.
We now illustrate how to store all iterates $x_k$ of the GMRES method.

```julia
S = Krylov.ktypeof(b)
global X = S[]  # Storage for GMRES iterates

function gmres_callback(workspace)
  z = workspace.z
  k = workspace.inner_iter
  nr = sum(1:k)
  V = workspace.V
  R = workspace.R
  y = copy(z)

  # Solve Rk * yk = zk
  for i = k : -1 : 1
    pos = nr + i - k
    for j = k : -1 : i+1
      y[i] = y[i] - R[pos] * y[j]
      pos = pos - j + 1
    end
    y[i] = y[i] / R[pos]
  end

  # xk = Vk * yk
  xk = sum(V[i] * y[i] for i = 1:k)
  push!(X, xk)

  return false  # We don't want to add new stopping conditions
end

(x, stats) = gmres(A, b, callback = gmres_callback)
```

The most expensive procedures in Krylov methods are matrix-vector products (y ← Ax) and vector operations (dot products, vector norms, y ← αx + βy).
Therefore they directly affect the efficiency of the methods provided by `Krylov.jl`.  
In this section, we present various optimizations based on multithreading to speed up these procedures. 
Multithreading is a form of shared memory parallelism that makes use of multiple cores to perform tasks.

## Multi-threaded BLAS and LAPACK operations

```shell
OPENBLAS_NUM_THREADS=N julia  # Set the number of OpenBLAS threads to N
MKL_NUM_THREADS=N julia       # Set the number of MKL threads to N
```

If you don't know the maximum number of threads available on your computer, you can obtain it with

```julia
NMAX = Sys.CPU_THREADS
```

and define the number of OpenBLAS/MKL threads at runtime with

```julia
BLAS.set_num_threads(N)  # 1 ≤ N ≤ NMAX
BLAS.get_num_threads()
```

The recommended number of BLAS threads is the number of physical and not logical cores, which is in general `N = NMAX / 2` if your CPU supports simultaneous multithreading (SMT).

By default Julia ships with OpenBLAS but it's also possible to use Intel MKL BLAS and LAPACK with [MKL.jl](https://github.com/JuliaLinearAlgebra/MKL.jl).
If your operating system is MacOS 13.4 or later, it's recommended to use Accelerate BLAS and LAPACK with [AppleAccelerate.jl](https://github.com/JuliaLinearAlgebra/AppleAccelerate.jl).

```julia
using LinearAlgebra
BLAS.get_config()  # BLAS.vendor() for Julia 1.6
```

## Multi-threaded sparse matrix-vector products

For sparse matrices, the Julia implementation of `mul!` of [SparseArrays](https://docs.julialang.org/en/v1/stdlib/SparseArrays/) library is not parallelized.
A significant speed-up can be observed with the multithreaded `mul!` of [MKLSparse.jl](https://github.com/JuliaSparse/MKLSparse.jl) or [ThreadedSparseCSR.jl](https://github.com/BacAmorim/ThreadedSparseCSR.jl).

It's also possible to implement a generic multithreaded julia version.
For instance, the following function can be used for symmetric matrices

```julia
using Base.Threads

function threaded_mul!(y::Vector{T}, A::SparseMatrixCSC{T}, x::Vector{T}) where T <: Number
  A.m == A.n || error("A is not a square matrix!")
  @threads for i = 1 : A.n
    tmp = zero(T)
    @inbounds for j = A.colptr[i] : (A.colptr[i+1] - 1)
      tmp += A.nzval[j] * x[A.rowval[j]]
    end
    @inbounds y[i] = tmp
  end
  return y
end
```

and wrapped inside a linear operator to solve symmetric linear systems

```julia
using LinearOperators

n, m = size(A)
sym = herm = true
T = eltype(A)
opA = LinearOperator(T, n, m, sym, herm, (y, v) -> threaded_mul!(y, A, v))
```

To enable multi-threading with Julia, you can start julia with the environment variable `JULIA_NUM_THREADS` or the options `-t` and `--threads`

```shell
julia -t auto  # alternative: --threads auto
julia -t N     # alternative: --threads N

JULIA_NUM_THREADS=N julia
```

Thereafter, you can verify the number of threads usable by Julia

```julia
using Base.Threads
nthreads()
```

The following benchmarks illustrate the time required in seconds to compute 1000 sparse matrix-vector products with symmetric matrices of the SuiteSparse Matrix Collection.
The computer used for the benchmarks has 2 physical cores and Julia was launched with `JULIA_NUM_THREADS=2`.

![benchmarks](./graphics/julia_vs_mkl.svg)

# [GPU support](@id gpu)

Krylov methods are well suited for GPU computations because they only require matrix-vector products ($u \leftarrow Av$, $u \leftarrow A^{H}w$) and vector operations ($\|v\|$, $u^H v$, $v \leftarrow \alpha u + \beta v$), which are highly parallelizable.

The implementations in Krylov.jl are generic so as to take advantage of the multiple dispatch and broadcast features of Julia.
Those allow the implementations to be specialized automatically by the compiler for both CPU and GPU.
Thus, Krylov.jl works with GPU backends that build on [GPUArrays.jl](https://github.com/JuliaGPU/GPUArrays.jl), such as [CUDA.jl](https://github.com/JuliaGPU/CUDA.jl), [AMDGPU.jl](https://github.com/JuliaGPU/AMDGPU.jl), [oneAPI.jl](https://github.com/JuliaGPU/oneAPI.jl) or [Metal.jl](https://github.com/JuliaGPU/Metal.jl).

## Nvidia GPUs

All solvers in Krylov.jl can be used with [CUDA.jl](https://github.com/JuliaGPU/CUDA.jl) and allow computations on Nvidia GPUs.
Problems stored in CPU format (`Matrix` and `Vector`) must first be converted to the related GPU format (`CuMatrix` and `CuVector`).

```julia
using CUDA, Krylov

if CUDA.functional()
  # CPU Arrays
  A_cpu = rand(20, 20)
  b_cpu = rand(20)

  # GPU Arrays
  A_gpu = CuMatrix(A_cpu)
  b_gpu = CuVector(b_cpu)

  # Solve a square and dense system on an Nivida GPU
  x, stats = bilq(A_gpu, b_gpu)
end
```

Sparse matrices have a specific storage on Nvidia GPUs (`CuSparseMatrixCSC`, `CuSparseMatrixCSR` or `CuSparseMatrixCOO`):

```julia
using CUDA, Krylov
using CUDA.CUSPARSE, SparseArrays

if CUDA.functional()
  # CPU Arrays
  A_cpu = sprand(200, 100, 0.3)
  b_cpu = rand(200)

  # GPU Arrays
  A_csc_gpu = CuSparseMatrixCSC(A_cpu)
  A_csr_gpu = CuSparseMatrixCSR(A_cpu)
  A_coo_gpu = CuSparseMatrixCOO(A_cpu)
  b_gpu = CuVector(b_cpu)

  # Solve a rectangular and sparse system on an Nvidia GPU
  x_csc, stats_csc = lslq(A_csc_gpu, b_gpu)
  x_csr, stats_csr = lsqr(A_csr_gpu, b_gpu)
  x_coo, stats_coo = lsmr(A_coo_gpu, b_gpu)
end
```

If you use a Krylov method that only requires `A * v` products (see [here](@ref matrix-free)), the most efficient format is `CuSparseMatrixCSR`.
Optimized operator-vector and operator-matrix products that exploit GPU features can be also used by means of linear operators.

For instance, when executing sparse matrix products on NVIDIA GPUs, the `mul!` function utilized by Krylov.jl internally calls three routines from CUSPARSE.
The first one conducts an analysis of the sparse matrix's structure, the second one determines the size of the buffer that needs to be allocated, and the last one handles the product using the allocated buffer.
To circumvent the need for repeated analysis computations and buffer allocation/deallocation with each product, we introduce a `KrylovOperator` in [KrylovPreconditioners.jl](https://github.com/JuliaSmoothOptimizers/KrylovPreconditioners.jl).
This operator performs the analysis and allocates the buffer only once.

```julia
using Krylov, KrylovPreconditioners

# A_gpu can be a sparse COO, CSC or CSR matrix
opA_gpu = KrylovOperator(A_gpu)
x_gpu, stats = gmres(opA_gpu, b_gpu)
```

Preconditioners, especially incomplete Cholesky or incomplete LU factorizations that involve sparse triangular solves,
can be applied directly on GPU thanks to efficient operators (like `TriangularOperator`) that take advantage of CUSPARSE routines.

### Example with a symmetric positive-definite system

```julia
using SparseArrays, Krylov, LinearOperators
using CUDA, CUDA.CUSPARSE

if CUDA.functional()
  # Transfer the linear system from the CPU to the GPU
  A_gpu = CuSparseMatrixCSR(A_cpu)  # A_gpu = CuSparseMatrixCSC(A_cpu)
  b_gpu = CuVector(b_cpu)

  # IC(0) decomposition LLᴴ ≈ A for CuSparseMatrixCSC or CuSparseMatrixCSR matrices
  P = ic02(A_gpu)

  # Additional vector required for solving triangular systems
  n = length(b_gpu)
  T = eltype(b_gpu)
  z = CUDA.zeros(T, n)

  # Solve Py = x
  function ldiv_ic0!(P::CuSparseMatrixCSR, x, y, z)
    ldiv!(z, LowerTriangular(P), x)   # Forward substitution with L
    ldiv!(y, LowerTriangular(P)', z)  # Backward substitution with Lᴴ
    return y
  end

  function ldiv_ic0!(P::CuSparseMatrixCSC, x, y, z)
    ldiv!(z, UpperTriangular(P)', x)  # Forward substitution with L
    ldiv!(y, UpperTriangular(P), z)   # Backward substitution with Lᴴ
    return y
  end

  # Operator that model P⁻¹
  symmetric = hermitian = true
  opM = LinearOperator(T, n, n, symmetric, hermitian, (y, x) -> ldiv_ic0!(P, x, y, z))

  # Solve a Hermitian positive definite system with an IC(0) preconditioner on GPU
  x, stats = cg(A_gpu, b_gpu, M=opM)
end
```

### Example with a general square system

```julia
using SparseArrays, Krylov, LinearOperators
using CUDA, CUDA.CUSPARSE, CUDA.CUSOLVER

if CUDA.functional()
  # Optional -- Compute a permutation vector p such that A[:,p] has no zero diagonal
  p = zfd(A_cpu)
  p .+= 1
  A_cpu = A_cpu[:,p]

  # Transfer the linear system from the CPU to the GPU
  A_gpu = CuSparseMatrixCSR(A_cpu)  # A_gpu = CuSparseMatrixCSC(A_cpu)
  b_gpu = CuVector(b_cpu)

  # ILU(0) decomposition LU ≈ A for CuSparseMatrixCSC or CuSparseMatrixCSR matrices
  P = ilu02(A_gpu)

  # Additional vector required for solving triangular systems
  n = length(b_gpu)
  T = eltype(b_gpu)
  z = CUDA.zeros(T, n)

  # Solve Py = x
  function ldiv_ilu0!(P::CuSparseMatrixCSR, x, y, z)
    ldiv!(z, UnitLowerTriangular(P), x)  # Forward substitution with L
    ldiv!(y, UpperTriangular(P), z)      # Backward substitution with U
    return y
  end

  function ldiv_ilu0!(P::CuSparseMatrixCSC, x, y, z)
    ldiv!(z, LowerTriangular(P), x)      # Forward substitution with L
    ldiv!(y, UnitUpperTriangular(P), z)  # Backward substitution with U
    return y
  end

  # Operator that model P⁻¹
  symmetric = hermitian = false
  opM = LinearOperator(T, n, n, symmetric, hermitian, (y, x) -> ldiv_ilu0!(P, x, y, z))

  # Solve a non-Hermitian system with an ILU(0) preconditioner on GPU
  x̄, stats = bicgstab(A_gpu, b_gpu, M=opM)

  # Recover the solution of Ax = b with the solution of A[:,p]x̄ = b
  invp = invperm(p)
  x = x̄[invp]
end
```

## AMD GPUs

All solvers in Krylov.jl can be used with [AMDGPU.jl](https://github.com/JuliaGPU/AMDGPU.jl) and allow computations on AMD GPUs.
Problems stored in CPU format (`Matrix` and `Vector`) must first be converted to the related GPU format (`ROCMatrix` and `ROCVector`).

```julia
using Krylov, AMDGPU

if AMDGPU.functional()
  # CPU Arrays
  A_cpu = rand(ComplexF64, 20, 20)
  A_cpu = A_cpu + A_cpu'
  b_cpu = rand(ComplexF64, 20)

  A_gpu = ROCMatrix(A_cpu)
  b_gpu = ROCVector(b_cpu)

  # Solve a dense Hermitian system on an AMD GPU
  x, stats = minres(A_gpu, b_gpu)
end
```

Sparse matrices have a specific storage on AMD GPUs (`ROCSparseMatrixCSC`, `ROCSparseMatrixCSR` or `ROCSparseMatrixCOO`):

```julia
using AMDGPU, Krylov
using AMDGPU.rocSPARSE, SparseArrays

if AMDGPU.functional()
  # CPU Arrays
  A_cpu = sprand(100, 200, 0.3)
  b_cpu = rand(100)

  # GPU Arrays
  A_csc_gpu = ROCSparseMatrixCSC(A_cpu)
  A_csr_gpu = ROCSparseMatrixCSR(A_cpu)
  A_coo_gpu = ROCSparseMatrixCOO(A_cpu)
  b_gpu = ROCVector(b_cpu)

  # Solve a rectangular and sparse system on an AMD GPU
  x_csc, y_csc, stats_csc = lnlq(A_csc_gpu, b_gpu)
  x_csr, y_csr, stats_csr = craig(A_csr_gpu, b_gpu)
  x_coo, y_coo, stats_coo = craigmr(A_coo_gpu, b_gpu)
end
```

When executing sparse products on AMD GPUs, the `mul!` function utilized by Krylov.jl internally calls three routines from rocSPARSE.
The first one conducts an analysis of the sparse matrix's structure, the second one determines the size of the buffer that needs to be allocated, and the last one handles the product using the allocated buffer.
To circumvent the need for repeated analysis computations and buffer allocation/deallocation with each product, we introduce a `KrylovOperator` in [KrylovPreconditioners.jl](https://github.com/JuliaSmoothOptimizers/KrylovPreconditioners.jl).
This operator performs the analysis and allocates the buffer only once.

```julia
using Krylov, KrylovPreconditioners

# A_gpu can be a sparse COO, CSC or CSR matrix
opA_gpu = KrylovOperator(A_gpu)
x_gpu, stats = bicgstab(opA_gpu, b_gpu)
```

Preconditioners, especially incomplete Cholesky or incomplete LU factorizations that involve sparse triangular solves,
can be applied directly on GPU thanks to efficient operators (like `TriangularOperator`) that take advantage of rocSPARSE routines.


## Intel GPUs

All solvers in Krylov.jl can be used with [oneAPI.jl](https://github.com/JuliaGPU/oneAPI.jl) and allow computations on Intel GPUs.
Problems stored in CPU format (`Matrix` and `Vector`) must first be converted to the related GPU format (`oneMatrix` and `oneVector`).

```julia
using Krylov, oneAPI

if oneAPI.functional()
  T = Float32  # oneAPI.jl also works with ComplexF32
  m = 20
  n = 10

  # CPU Arrays
  A_cpu = rand(T, m, n)
  b_cpu = rand(T, m)

  # GPU Arrays
  A_gpu = oneMatrix(A_cpu)
  b_gpu = oneVector(b_cpu)

  # Solve a dense least-squares problem on an Intel GPU
  x, stats = lsqr(A_gpu, b_gpu)
end
```

!!! note
    The library `oneMKL` is interfaced in oneAPI.jl and accelerates linear algebra operations on Intel GPUs. Only dense linear systems are supported for the time being because sparse linear algebra routines are not interfaced yet.

## Apple M1 GPUs

All solvers in Krylov.jl can be used with [Metal.jl](https://github.com/JuliaGPU/Metal.jl) and allow computations on Apple M1 GPUs.
Problems stored in CPU format (`Matrix` and `Vector`) must first be converted to the related GPU format (`MtlMatrix` and `MtlVector`).

```julia
using Krylov, Metal

T = Float32  # Metal.jl also works with ComplexF32
n = 10
m = 20

# CPU Arrays
A_cpu = rand(T, n, m)
b_cpu = rand(T, n)

# GPU Arrays
A_gpu = MtlMatrix(A_cpu)
b_gpu = MtlVector(b_cpu)

# Solve a dense least-norm problem on an Apple M1 GPU
x, stats = craig(A_gpu, b_gpu)
```

!!! warning
    Metal.jl is under heavy development and is considered experimental for now.

# [Krylov.jl documentation](@id Home)

This package provides implementations of certain of the most useful Krylov method for a variety of problems:

1 - Square or rectangular full-rank systems

```math
  Ax = b
```

should be solved when **_b_** lies in the range space of **_A_**. This situation occurs when
  * **_A_** is square and nonsingular,
  * **_A_** is tall and has full column rank and **_b_** lies in the range of **_A_**.

2 - Linear least-squares problems

```math
  \min \|b - Ax\|
```

should be solved when **_b_** is not in the range of **_A_** (inconsistent systems), regardless of the shape and rank of **_A_**. This situation mainly occurs when
  * **_A_** is square and singular,
  * **_A_** is tall and thin.

Underdetermined systems are less common but also occur.

If there are infinitely many such **_x_** (because **_A_** is column rank-deficient), one with minimum norm is identified

```math
  \min \|x\| \quad \text{subject to} \quad x \in \argmin \|b - Ax\|.
```

3 - Linear least-norm problems

```math
  \min \|x\| \quad \text{subject to} \quad Ax = b
```

should be solved when **_A_** is column rank-deficient but **_b_** is in the range of **_A_** (consistent systems), regardless of the shape of **_A_**.
This situation mainly occurs when
  * **_A_** is square and singular,
  * **_A_** is short and wide.

Overdetermined systems are less common but also occur.

4 - Adjoint systems

```math
  Ax = b \quad \text{and} \quad A^H y = c
```

where **_A_** can have any shape.

5 - Saddle-point and Hermitian quasi-definite systems

```math
  \begin{bmatrix} M & \phantom{-}A \\ A^H & -N \end{bmatrix} \begin{bmatrix} x \\ y \end{bmatrix} = \left(\begin{bmatrix} b \\ 0 \end{bmatrix},\begin{bmatrix} 0 \\ c \end{bmatrix},\begin{bmatrix} b \\ c \end{bmatrix}\right)
```

where **_A_** can have any shape.

6 - Generalized saddle-point and non-Hermitian partitioned systems

```math
  \begin{bmatrix} M & A \\ B & N \end{bmatrix} \begin{bmatrix} x \\ y \end{bmatrix} = \begin{bmatrix} b \\ c \end{bmatrix}
```

where **_A_** can have any shape and **_B_** has the shape of **_Aᴴ_**.
**_A_**, **_B_**, **_b_** and **_c_** must be all nonzero.

Krylov solvers are particularly appropriate in situations where such problems must be solved but a factorization is not possible, either because:
* **_A_** is not available explicitly,
* **_A_** would be dense or would consume an excessive amount of memory if it were materialized,
* factors would consume an excessive amount of memory.

Iterative methods are recommended in either of the following situations:
* the problem is sufficiently large that a factorization is not feasible or would be slow,
* an effective preconditioner is known in cases where the problem has unfavorable spectral structure,
* the operator can be represented efficiently as a sparse matrix,
* the operator is *fast*, i.e., can be applied with better complexity than if it were materialized as a matrix. Certain fast operators would materialize as *dense* matrices.

## Features

All solvers in Krylov.jl have in-place version, are compatible with **GPU** and work in any floating-point data type.

## How to Install

Krylov can be installed and tested through the Julia package manager:

```julia
julia> ]
pkg> add Krylov
pkg> test Krylov
```

# Bug reports and discussions

If you think you found a bug, feel free to open an [issue](https://github.com/JuliaSmoothOptimizers/Krylov.jl/issues).
Focused suggestions and requests can also be opened as issues. Before opening a pull request, start an issue or a discussion on the topic, please.

If you want to ask a question not suited for a bug report, feel free to start a discussion [here](https://github.com/JuliaSmoothOptimizers/Organization/discussions). This forum is for general discussion about this repository and the [JuliaSmoothOptimizers](https://github.com/JuliaSmoothOptimizers) organization, so questions about any of our packages are welcome.

# [Custom workspaces](@id custom_workspaces)

## Custom workspaces for the Poisson equation with halo regions

### Introduction

The Poisson equation is a fundamental partial differential equation (PDE) in physics and mathematics, modeling phenomena like temperature distribution and incompressible fluid flow.
In a 2D Cartesian domain, it can be expressed as:

```math
\nabla^2 u(x, y) = f(x, y)
```

Here, $u(x, y)$ is the potential function and $f(x, y)$ represents the source term within the domain.

This page explains how to use a Krylov method to solve the Poisson equation over a rectangular region with specified boundary conditions, detailing the use of a Laplacian operator within a data structure that incorporates **halo regions**.

### Finite difference discretization

We solve the Poisson equation numerically by discretizing the 2D domain using a finite difference method.
For a square domain $[0, L] \times [0, L]$, divided into a grid of points, each point approximates the solution $u$ at that position.

With grid spacings $h_x = \frac{L}{N_x + 1}$ and $h_y = \frac{L}{N_y + 1}$, let $u_{i,j}$ denote the approximation of $u(x_i, y_j)$ at grid point $(x_i, y_j) = (ih, jh)$.
The 2D Laplacian can be approximated at each interior grid point $(i, j)$ by combining the following central difference formulas:

```math
\frac{\partial^2 u}{\partial x^2} \approx \frac{u_{i+1,j} - 2u_{i,j} + u_{i-1,j}}{h^2}
```

```math
\frac{\partial^2 u}{\partial y^2} \approx \frac{u_{i,j+1} - 2u_{i,j} + u_{i,j-1}}{h^2}
```

This yields the discrete Poisson equation:

```math
\frac{u_{i+1,j} - 2u_{i,j} + u_{i-1,j}}{h^2} + \frac{u_{i,j+1} - 2u_{i,j} + u_{i,j-1}}{h^2} = f_{i,j}
```

resulting in a system of linear equations for the $N^2$ unknowns $u_{i,j}$ at each interior grid point.

### Boundary conditions

Boundary conditions complete the system. Common choices are:

- **Dirichlet**: Specifies values of $u$ on the boundary.
- **Neumann**: Specifies the normal derivative (or flux) of $u$ on the boundary.

### Implementing halo regions with HaloVector

In parallel computing, **halo regions** (or ghost cells) around the grid store boundary values from neighboring subdomains, allowing independent stencil computation near boundaries.
This setup streamlines boundary management in distributed environments.

For specialized applications, Krylov.jl’s internal storage expects an `AbstractVector`, which can benefit from a structured data layout.
A **`HaloVector`** provides this structure, using halo regions to enable finite difference stencils without boundary condition checks.
The `OffsetArray` type from [OffsetArrays.jl](https://github.com/JuliaArrays/OffsetArrays.jl) facilitates custom indexing, making it ideal for grids with halo regions.
By embedding an `OffsetArray` within `HaloVector`, we achieve seamless grid alignment, allowing **"if-less"** stencil application.

This setup reduces boundary condition checks in the core loop, yielding clearer and faster code.
The flexible design of `HaloVector` supports 1D, 2D, or 3D configurations, adapting easily to different grid layouts.

### Definition and usage of the HaloVector

`HaloVector` is a specialized vector for grid-based computations, especially finite difference methods with halo regions.
It is parameterized by:

- **`FC`**: The element type of the vector.
- **`D`**: The data array type, which uses `OffsetArray` to enable custom indexing.

```@example halo-regions; continued = true
using OffsetArrays

struct HaloVector{FC, D} <: AbstractVector{FC}
    data::D

    function HaloVector(data::D) where {D}
        FC = eltype(data)
        return new{FC, D}(data)
    end
end

function Base.similar(v::HaloVector)
    data = similar(v.data)
    fill!(data, zero(eltype(data)))
    return HaloVector(data)
end

function Base.length(v::HaloVector)
    m, n = size(v.data)
    l = (m - 2) * (n - 2)
    return l
end

function Base.size(v::HaloVector)
    l = length(v)
    return (l,)
end

function Base.getindex(v::HaloVector, idx)
    m, n = size(v.data)
    row = div(idx - 1, n - 2) + 1
    col = mod(idx - 1, n - 2) + 1
    return v.data[row, col]
end
```

The functions `similar` and `length` are mandatory and must be implemented for custom vector types.
The functions `size` and `getindex` support REPL display, aiding interaction, though they are optional for Krylov.jl’s functionality.

### Efficient stencil implementation

Using `HaloVector` with `OffsetArray`, we can apply the discrete Laplacian operator in a matrix-free approach with a 5-point stencil, managing halo regions effectively.
This layout allows **clean and efficient Laplacian computation** without boundary checks within the core loop.
For the multiplication between the Laplacian operator and vectors, `Krylov.jl` dispatches to `LinearAlgebra.mul!` by default.
If you prefer to use a custom implementation only within `Krylov.jl`, or if you have a specialized routine that benefits repeated products, you can overload `Krylov.kmul!` instead.

```@example halo-regions; continued = true
using Krylov

# Define a matrix-free Laplacian operator
struct LaplacianOperator
    Nx::Int        # Number of grid points in the x-direction
    Ny::Int        # Number of grid points in the y-direction
    Δx::Float64    # Grid spacing in the x-direction
    Δy::Float64    # Grid spacing in the y-direction
end

# Define size and element type for the operator
Base.size(A::LaplacianOperator) = (A.Nx * A.Ny, A.Nx * A.Ny)
Base.eltype(A::LaplacianOperator) = Float64

function Krylov.kmul!(y::HaloVector{Float64}, A::LaplacianOperator, u::HaloVector{Float64})
    # Apply the discrete Laplacian in 2D
    for i in 1:A.Nx
        for j in 1:A.Ny
            # Calculate second derivatives using finite differences
            # We use -Laplacian (SPD) so that CG can be applied
            dx2 = -(u.data[i-1,j] - 2 * u.data[i,j] + u.data[i+1,j]) / (A.Δx)^2
            dy2 = -(u.data[i,j-1] - 2 * u.data[i,j] + u.data[i,j+1]) / (A.Δy)^2
            
            # Add a tiny value ε to the diagonal to ensure the operator is
            # strictly symmetric positive definite (SPD) and to avoid numerical issues
            y.data[i,j] = dx2 + dy2 + 1e-12 * u.data[i,j]
        end
    end

    return y
end
```

### Methods to overload for compatibility with Krylov.jl

To integrate `HaloVector` with Krylov.jl, we define essential vector operations, including dot products, norms, scalar multiplication, and element-wise updates.
These implementations allow Krylov.jl to leverage custom vector types, enhancing both solver flexibility and performance.

```@example halo-regions; continued = true
using Krylov
import Krylov.FloatOrComplex

function Krylov.kdot(n::Integer, x::HaloVector{T}, y::HaloVector{T}) where T <: FloatOrComplex
    mx, nx = size(x.data)
    _x = x.data
    _y = y.data
    res = zero(real(T))
    for j = 1:nx-2
        for i = 1:mx-2
            res += _x[i,j] * conj(_y[i,j])
        end
    end
    return res
end

function Krylov.knorm(n::Integer, x::HaloVector{T}) where T <: FloatOrComplex
    mx, nx = size(x.data)
    _x = x.data
    res = zero(real(T))
    for j = 1:nx-2
        for i = 1:mx-2
            res += abs2(_x[i,j])
        end
    end
    return sqrt(res)
end

function Krylov.kscal!(n::Integer, s::T, x::HaloVector{T}) where T <: FloatOrComplex
    mx, nx = size(x.data)
    _x = x.data
    for j = 1:nx-2
        for i = 1:mx-2
            _x[i,j] = s * _x[i,j]
        end
    end
    return x
end

function Krylov.kdiv!(n::Integer, x::HaloVector{T}, s::T) where T <: FloatOrComplex
    mx, nx = size(x.data)
    _x = x.data
    for j = 1:nx-2
        for i = 1:mx-2
            _x[i,j] = _x[i,j] / s
        end
    end
    return x
end

function Krylov.kaxpy!(n::Integer, s::T, x::HaloVector{T}, y::HaloVector{T}) where T <: FloatOrComplex
    mx, nx = size(x.data)
    _x = x.data
    _y = y.data
    for j = 1:nx-2
        for i = 1:mx-2
            _y[i,j] += s * _x[i,j]
        end
    end
    return y
end

function Krylov.kaxpby!(n::Integer, s::T, x::HaloVector{T}, t::T, y::HaloVector{T}) where T <: FloatOrComplex
    mx, nx = size(x.data)
    _x = x.data
    _y = y.data
    for j = 1:nx-2
        for i = 1:mx-2
            _y[i,j] = s * _x[i,j] + t * _y[i,j]
        end
    end
    return y
end

function Krylov.kcopy!(n::Integer, y::HaloVector{T}, x::HaloVector{T}) where T <: FloatOrComplex
    mx, nx = size(x.data)
    _x = x.data
    _y = y.data
    for j = 1:nx-2
        for i = 1:mx-2
            _y[i,j] = _x[i,j]
        end
    end
    return y
end

function Krylov.kscalcopy!(n::Integer, y::HaloVector{T}, s::T, x::HaloVector{T}) where T <: FloatOrComplex
    mx, nx = size(x.data)
    _x = x.data
    _y = y.data
    for j = 1:nx-2
        for i = 1:mx-2
            _y[i,j] = s * _x[i,j]
        end
    end
    return y
end

function Krylov.kdivcopy!(n::Integer, y::HaloVector{T}, x::HaloVector{T}, s::T) where T <: FloatOrComplex
    mx, nx = size(x.data)
    _x = x.data
    _y = y.data
    for j = 1:nx-2
        for i = 1:mx-2
            _y[i,j] = _x[i,j] / s
        end
    end
    return y
end

function Krylov.kfill!(x::HaloVector{T}, val::T) where T <: FloatOrComplex
    mx, nx = size(x.data)
    _x = x.data
    for j = 1:nx-2
        for i = 1:mx-2
            _x[i,j] = val
        end
    end
    return x
end

function Krylov.kref!(n::Integer, x::HaloVector{T}, y::HaloVector{T}, c::T, s::T) where T <: FloatOrComplex
    mx, nx = size(x.data)
    _x = x.data
    _y = y.data
    for j = 1:nx-2
        for i = 1:mx-2
            x_ij = _x[i,j]
            y_ij = _y[i,j]
            _x[i,j] = c       * x_ij + s * y_ij
            _y[i,j] = conj(s) * x_ij - c * y_ij
        end
    end
    return x, y
end
```

By default, `kdiv!(n, y, x, s)` calls `kscal!(n, y, t, x)` with `t = 1/s`, so a separate implementation isn't required.
However, this approach may introduce numerical issues when `s` is very small.
We do this because computing $y \leftarrow t \times x$ can often leverage SIMD or fused multiply-add (FMA) instructions on certain architectures, capabilities that a direct element-wise division $y \leftarrow x/s$ typically lacks.
Thus, the implementation of `kdiv!` provides flexibility, allowing users to choose a trade-off between speed and numerical precision by overloading the function if needed.
The operations provided by `kdivcopy!` and `kscalcopy!` could be implemented directly by using `kcopy!`, `kscal!`, and `kdiv!` but require two separate memory passes, which can be suboptimal for performance.
To address this limitation, `kdivcopy!` and `kscalcopy!` fuse the copy and scaling/division operations into a single memory pass.
Note that `Krylov.kref!` is only required for the function `minres_qlp`.

### 2D Poisson equation solver with Krylov methods

```@example halo-regions
using Krylov, OffsetArrays
import Krylov: solution, statistics

# Parameters
L = 1.0            # Length of the square domain
Nx = 200           # Number of interior grid points in x
Ny = 200           # Number of interior grid points in y
Δx = L / (Nx + 1)  # Grid spacing in x
Δy = L / (Ny + 1)  # Grid spacing in y

# Define the source term f(x,y) of the Poisson equation ∇²u = f
f(x,y) = -2 * π * π * sin(π * x) * sin(π * y)

# Create the matrix-free Laplacian operator
A = LaplacianOperator(Nx, Ny, Δx, Δy)

# Create the right-hand side
# We solve (-∇²)u = -f since the operator is -Laplacian (SPD)
rhs = zeros(Float64, Nx+2, Ny+2)
data = OffsetArray(rhs, 0:Nx+1, 0:Ny+1)
for j in 1:Ny
    for i in 1:Nx
        xi = i * Δx
        yj = j * Δy
        data[i,j] = -f(xi, yj)
    end
end
b = HaloVector(data)

# Allocate the workspace
kc = KrylovConstructor(b)
workspace = CgWorkspace(kc)

# Solve the system with CG
Krylov.cg!(workspace, A, b, atol=1e-10, rtol=0.0, verbose=1)
u_sol = solution(workspace)
stats = statistics(workspace)
```

```@example halo-regions
using LinearAlgebra

# The exact solution is u(x,y) = sin(πx) * sin(πy)
u_star = [sin(π * i * Δx) * sin(π * j * Δy) for i=1:Nx, j=1:Ny]
norm(u_sol.data[1:Nx, 1:Ny] - u_star, Inf)
```

!!! note
    Only the in-place version of the Krylov methods is supported for custom vector types.

### Conclusion

Implementing a 2D Poisson equation solver with `HaloVector` improves code clarity and efficiency.
Custom indexing with `OffsetArray` streamlines halo region management, eliminating boundary checks within the core loop.
This approach reduces branching, yielding faster execution, especially on large grids.
`HaloVector`'s flexibility also makes it easy to extend to 3D grids or more complex stencils.

!!! info
    [Oceananigans.jl](https://github.com/CliMA/Oceananigans.jl) uses a similar strategy with its type `KrylovField`, efficiently solving large linear systems with Krylov.jl.

## Solving saddle point systems with BlockArrays.jl and Krylov.jl

[BlockArrays.jl](https://github.com/JuliaArrays/BlockArrays.jl) simplifies working with structured matrices, making it an ideal tool for solving saddle point systems.
In this example, we solve a structured linear system $Ax = b$ of the form:

```math
\begin{bmatrix}
   K & B^T \\
   B & 0
\end{bmatrix}
\begin{bmatrix}
   y \\
   z
\end{bmatrix} =
\begin{bmatrix}
   c \\
   d
\end{bmatrix}.
```

We first define the matrix $A$ and the vector $b$ using `BlockArrays.jl`:

```@example block-arrays; continued = true
using LinearAlgebra
using BlockArrays

nK = 10
nB = 2
K = rand(nK, nK)
K = K * K' + I
B = rand(nB, nK)
c = rand(nK)
d = rand(nB)

# Create the saddle point matrix A
A = BlockArray{Float64}(undef, [nK, nB], [nK, nB])
A[Block(1, 1)] = K
A[Block(1, 2)] = B'
A[Block(2, 1)] = B
A[Block(2, 2)] = zeros(nB, nB)

# Create the right-hand side vector b
b = BlockVector{Float64}(undef, [nK, nB])
b[Block(1)] = c
b[Block(2)] = d
```

For saddle point systems, a well-known preconditioner is the "ideal preconditioner'' $P^{-1}$, as described in the paper ["A Note on Preconditioning for Indefinite Linear Systems"](https://doi.org/10.1137/S1064827599355153).
It is defined as:

```math
P^{-1} =
\begin{bmatrix}
   K^{-1} & 0
\\ 0      & (B K^{-1} B^T)^{-1}
\end{bmatrix}.
```

This preconditioner guarantees convergence in exactly three iterations, as $P^{-1}A$ has only three distinct eigenvalues.
However, this preconditioner is expensive, as it requires $K^{-1}$ and the inverse of the Schur complement $B K^{-1} B^T$.
One common approach is to replace $K^{-1}$ with $\mathrm{diag}(K)^{-1}$, creating a cheaper preconditioner.

```@example block-arrays; continued = true
using Krylov
using LinearAlgebra

struct IdealPreconditioner{T1, T2}
    BD1::T1
    BD2::T2
end

function Krylov.kmul!(y::BlockVector, P::IdealPreconditioner, x::BlockVector)
    mul!(y.blocks[1], P.BD1, x.blocks[1])
    mul!(y.blocks[2], P.BD2, x.blocks[2])
    return y
end

# Create the ideal preconditioner
BD1 = inv(K)
BD2 = inv(B * BD1 * B')
P = IdealPreconditioner(BD1, BD2)
```

We now solve the system $Ax = b$ using `minres` with our preconditioner:

```@example block-arrays
using Krylov
import Krylov: solution, iteration_count

kc = KrylovConstructor(b)
workspace = MinresWorkspace(kc)
minres!(workspace, A, b; M=P)

x = solution(workspace)
niter = iteration_count(workspace)
```

This example demonstrates how `BlockArrays.jl` and `Krylov.jl` can be effectively combined to solve structured saddle point systems.

## Distributed Krylov solvers with MPI.jl

Krylov.jl supports distributed-memory computations through [MPI.jl](https://github.com/JuliaParallel/MPI.jl), enabling Krylov solvers to scale across multiple processes and compute nodes.
This makes them suitable for solving large-scale linear systems in high-performance computing (HPC) environments.

To get started, you need to install the `mpiexecjl` binary using the function `MPI.install_mpiexecjl`.
If you wish to change the underlying MPI implementation, you can use the package `MPIPreferences.jl` and its functions `MPIPreferences.use_binary_binary` and `MPIPreferences.use_jll_binary`.

Next, define an `MPIVector` to be used as the storage type for Krylov workspaces, replacing the standard `Vector`.

```julia
using MPI

struct MPIVector{T, V<:AbstractVector{T}} <: AbstractVector{T}
    data::V
    comm::MPI.Comm
    global_len::Int
    data_range::UnitRange{Int}
end

Base.similar(v::MPIVector) = MPIVector(similar(v.data), v.comm, v.global_len, v.data_range)
Base.length(v::MPIVector) = v.global_len
Base.eltype(v::MPIVector{T}) where T = T

function MPIVector(global_vec::V, comm::MPI.Comm = MPI.COMM_WORLD) where V
    T = eltype(V)
    size, rank = MPI.Comm_size(comm), MPI.Comm_rank(comm)
    n = length(global_vec)
    chunk = div(n + size - 1, size)
    istart = rank * chunk + 1
    iend = min((rank + 1) * chunk, n)
    data = global_vec[istart:iend]
    return MPIVector{T, V}(data, comm, n, istart:iend)
end

function MPIVector(::Type{V}, global_len::Int, comm::MPI.Comm = MPI.COMM_WORLD) where V
    size, rank = MPI.Comm_size(comm), MPI.Comm_rank(comm)
    chunk = div(global_len + size - 1, size)
    istart = rank * chunk + 1
    iend = min((rank + 1) * chunk, global_len)
    data = V(undef, iend-istart+1)
    return MPIVector{T, V}(data, comm, global_len, istart:iend)
end
```

To integrate `MPIVector` with Krylov.jl, you need to define the essential vector operations.
These implementations enable Krylov.jl to operate with MPI-based vectors on both CPU and GPU.

```julia
using Krylov
import Krylov.FloatOrComplex


function Krylov.kdot(n::Integer, x::MPIVector{T}, y::MPIVector{T}) where T <: FloatOrComplex
    data_dot = sum(x.data .* conj.(y.data))
    res = MPI.Allreduce(data_dot, +, x.comm)
    return res
end

function Krylov.knorm(n::Integer, x::MPIVector{T}) where T <: FloatOrComplex
    res = Krylov.kdot(n, x, x)
    return sqrt(res)
end

function Krylov.kscal!(n::Integer, s::T, x::MPIVector{T}) where T <: FloatOrComplex
    x.data .*= s
    return x
end

function Krylov.kdiv!(n::Integer, x::MPIVector{T}, s::T) where T <: FloatOrComplex
    x.data ./= s
    return x
end

function Krylov.kaxpy!(n::Integer, s::T, x::MPIVector{T}, y::MPIVector{T}) where T <: FloatOrComplex
    y.data .+= s .* x.data
    return y
end

function Krylov.kaxpby!(n::Integer, s::T, x::MPIVector{T}, t::T, y::MPIVector{T}) where T <: FloatOrComplex
    y.data .= s .* x.data .+ t .* y.data
    return y
end

function Krylov.kcopy!(n::Integer, y::MPIVector{T}, x::MPIVector{T}) where T <: FloatOrComplex
    y.data .= x.data
    return y
end

function Krylov.kscalcopy!(n::Integer, y::MPIVector{T}, s::T, x::MPIVector{T}) where T <: FloatOrComplex
    y.data .= x.data .* s
    return y
end

function Krylov.kdivcopy!(n::Integer, y::MPIVector{T}, x::MPIVector{T}, s::T) where T <: FloatOrComplex
    y.data .= x.data ./ s
    return y
end

function Krylov.kfill!(x::MPIVector{T}, val::T) where T <: FloatOrComplex
    x.data .= val
    return x
end
```

The next step is to create a distributed linear operator.
As a simple example, we define a diagonal operator with `1:n` on its diagonal by implementing an `MPIOperator`:

```julia
using Krylov

struct MPIOperator{T}
    m::Int
    n::Int
end

Base.size(A::MPIOperator) = (A.m, A.n)
Base.eltype(A::MPIOperator{T}) where T = T

function Krylov.kmul!(y::MPIVector{Float64}, A::MPIOperator{Float64}, u::MPIVector{Float64})
    y.data .= u.data_range .* u.data
    return y
end
```

With all the previous definitions in place, you can now assemble a script `mpi_krylov.jl` that includes them, along with a small driver code provided below.
This script can be executed with multiple processes using the binary `mpiexecjl`.

```julia
MPI.Init()

comm = MPI.COMM_WORLD
rank = MPI.Comm_rank(comm)
n = 10  # global_len in MPIVector
T = Float64
method = :cg

# Version without MPI
A_global = Diagonal(1:n) .|> T
b_global = collect(n:-1:1) .|> T
x_global, _ = krylov_solve(Val(method), A_global, b_global)

# Version with MPI
A_mpi = MPIOperator{T}(n, n)
b_mpi = MPIVector(b_global)

kc = KrylovConstructor(b_mpi)
workspace = krylov_workspace(Val(method), kc)
krylov_solve!(workspace, A_mpi, b_mpi)
x_mpi = Krylov.solution(workspace)

# Check the solution
for i = 0:MPI.Comm_size(comm)-1
    if i == rank
        println("Local data: ", x_mpi.data)
        println("Global data: ", x_global)
    end
    MPI.Barrier(comm)
end

MPI.Finalize()
```

To launch this script on four processes:
```shell
mpiexecjl -n 4 julia mpi_krylov.jl
```

The example above runs on CPU but also works on GPU.
It can target supercomputers such as Frontier or Aurora with various GPU backends (NVIDIA, AMD, or Intel).
See the section on [GPU support](@ref gpu) for details on the GPU-enabled vectors usable in an `MPIVector`.

!!! note
    Make sure to use an MPI implementation that is GPU-aware if you intend to run distributed Krylov solvers on GPUs.

# [C interface](@id c-interface)

Include `krylov.h` and link against `libkrylov` (see [Building libkrylov](@ref building-libkrylov)).
The concepts (callbacks, data types, options, return codes, block solvers) are described in the [reference](@ref reference-interfaces).
This page collects runnable C programs.

## Example

Solve a 5×5 tridiagonal SPD system with CG in double precision
([`examples/C/basic_cg.c`](https://github.com/JuliaSmoothOptimizers/Krylov.jl/blob/main/interfaces/examples/C/basic_cg.c)):

```c
#include <stdio.h>
#include "krylov.h"

#define N 5

typedef struct { int n; double diag[N]; double off[N-1]; } TriDiag;

static void matvec_A(const void *xv, void *yv, void *userdata)
{
  const double *x  = (const double *)xv;
  double       *y  = (double *)yv;
  const TriDiag *A = (const TriDiag *)userdata;
  for (int i = 0; i < A->n; i++) {
    y[i] = A->diag[i] * x[i];
    if (i > 0)      y[i] += A->off[i-1] * x[i-1];
    if (i < A->n-1) y[i] += A->off[i]   * x[i+1];
  }
}

int main(void)
{
  TriDiag A = { .n = N };
  for (int i = 0; i < N;   i++) A.diag[i] =  2.0;
  for (int i = 0; i < N-1; i++) A.off[i]  = -1.0;

  double b[N] = {1.0, 0.0, 0.0, 0.0, 1.0};
  double x[N];

  void *ws = NULL;
  krylov_workspace_create(KRYLOV_CG, N, N, KRYLOV_FLOAT64, KRYLOV_CPU, NULL, &ws);

  KrylovOptions opts = krylov_default_options();
  opts.atol = 1e-10;
  opts.rtol = 1e-10;
  krylov_solve(ws, matvec_A, NULL, NULL, NULL, b, NULL, &A, &opts);
  krylov_get_x(ws, x, N);

  printf("Solved: %s   niter: %d\n",
         krylov_is_solved(ws) ? "yes" : "no", krylov_niter(ws));
  for (int i = 0; i < N; i++) printf(" %.2f", x[i]);
  printf("\n");

  krylov_workspace_free(ws);
  return 0;
}
```

## Block example

Solve `A X = B` with several right-hand sides at once using block GMRES. The block `B` is `n×p`, column-major, and must have full column rank (see [Block Krylov solvers](@ref block-krylov-methods)). Switch `KRYLOV_BLOCK_GMRES` to `KRYLOV_BLOCK_MINRES` for block MINRES
([`examples/C/block_gmres.c`](https://github.com/JuliaSmoothOptimizers/Krylov.jl/blob/main/interfaces/examples/C/block_gmres.c)):

```c
#include <math.h>
#include <stdio.h>
#include <stddef.h>
#include "krylov.h"

#define N 16    /* operator dimension */
#define P 3     /* number of right-hand sides (block width) */

/* Block matvec:  Y = A * X  for a block of p columns (column-major). */
static void block_A(const void *Xv, void *Yv, int p, void *userdata)
{
  const double *X = (const double *)Xv;
  double       *Y = (double *)Yv;
  int n = *(const int *)userdata;
  for (int j = 0; j < p; j++) {
    const double *x = X + (size_t)j * n;
    double       *y = Y + (size_t)j * n;
    for (int i = 0; i < n; i++) {
      y[i] = 8.0 * x[i];
      if (i > 0)     y[i] -= x[i-1];
      if (i < n - 1) y[i] -= x[i+1];
    }
  }
}

int main(void)
{
  int n = N, p = P;

  /* X_true with independent columns, then B = A * X_true (column-major). */
  double Xtrue[N*P], B[N*P], X[N*P];
  for (int j = 0; j < p; j++)
    for (int i = 0; i < n; i++) {
      double t = (double)(i + 1) / n;
      Xtrue[i + (size_t)j*n] = (j == 0) ? 1.0 : (j == 1 ? t : t*t);
    }
  block_A(Xtrue, B, p, &n);

  void *ws = NULL;
  krylov_block_workspace_create(KRYLOV_BLOCK_GMRES, n, n, p,
                                KRYLOV_FLOAT64, KRYLOV_CPU, NULL, &ws);

  KrylovOptions opts = krylov_default_options();
  opts.atol = 1e-10;
  opts.rtol = 1e-10;
  krylov_block_solve(ws, block_A, NULL, NULL, B, &n, &opts);
  krylov_block_get_X(ws, X, n, p);

  double err = 0.0;
  for (int k = 0; k < n*p; k++) {
    double d = fabs(X[k] - Xtrue[k]);
    if (d > err) err = d;
  }
  printf("Block solved: %s   niter: %d   max error: %.1e\n",
         krylov_block_is_solved(ws) ? "yes" : "no",
         krylov_block_niter(ws), err);

  krylov_block_workspace_free(ws);
  return 0;
}
```

## Preconditioning

A preconditioner is just another matrix-free callback. But it applies the **action of the inverse**: it must compute `y = M⁻¹ x` (solve `M y = x`), never `y = M x`. The symmetric solvers (CG, CR, CAR, MINRES, …) take a single **centered** preconditioner `M`, which preserves the symmetry of the system. Only the non-symmetric solvers split it into a left `M` and a right `N`. Here is preconditioned CAR (a recent solver for symmetric systems) with a Jacobi preconditioner `M = diag(A)`, so `M⁻¹ x` is just `xᵢ / dᵢ`
([`examples/C/preconditioning.c`](https://github.com/JuliaSmoothOptimizers/Krylov.jl/blob/main/interfaces/examples/C/preconditioning.c)):

```c
#include <stdio.h>
#include "krylov.h"

#define N 8

typedef struct { int n; double diag[N]; double off; } Tri;

static void matvec_A(const void *xv, void *yv, void *userdata)
{
  const double *x = (const double *)xv;
  double       *y = (double *)yv;
  const Tri    *A = (const Tri *)userdata;
  for (int i = 0; i < A->n; i++) {
    y[i] = A->diag[i] * x[i];
    if (i > 0)        y[i] += A->off * x[i-1];
    if (i < A->n - 1) y[i] += A->off * x[i+1];
  }
}

/* y = M⁻¹ x with M = diag(A): apply the INVERSE, i.e. divide by the diagonal. */
static void precond_M(const void *xv, void *yv, void *userdata)
{
  const double *x = (const double *)xv;
  double       *y = (double *)yv;
  const Tri    *A = (const Tri *)userdata;
  for (int i = 0; i < A->n; i++) y[i] = x[i] / A->diag[i];
}

int main(void)
{
  Tri A = { .n = N, .off = -1.0 };
  for (int i = 0; i < N; i++) A.diag[i] = 2.0 + (double)i;

  double x_true[N], b[N], x[N];
  for (int i = 0; i < N; i++) x_true[i] = 1.0;
  matvec_A(x_true, b, &A);

  void *ws = NULL;
  krylov_workspace_create(KRYLOV_CAR, N, N, KRYLOV_FLOAT64, KRYLOV_CPU, NULL, &ws);

  KrylovOptions opts = krylov_default_options();
  opts.atol = 1e-10; opts.rtol = 1e-10;

  // matvec_M = centered preconditioner (symmetric solvers use a single M); matvec_N is NULL.
  // GMRES, BiCGSTAB, QMR, ... instead use matvec_M as a left and matvec_N as a right preconditioner.
  krylov_solve(ws, matvec_A, NULL, precond_M, NULL, b, NULL, &A, &opts);
  krylov_get_x(ws, x, N);

  printf("Solved: %s   niter: %d\n",
         krylov_is_solved(ws) ? "yes" : "no", krylov_niter(ws));
  krylov_workspace_free(ws);
  return 0;
}
```

## Least-squares (rectangular operator)

Least-squares and least-norm solvers (LSMR, LSQR, CGLS, CRAIG, …) reach the operator through **both** `A` and its adjoint `Aᴴ`, so they need a second callback. With a rectangular `A` of size `m × n` the buffer lengths differ: `matvec_A` maps length `n` to length `m`, while `matvec_At` maps length `m` to length `n`
([`examples/C/least_squares.c`](https://github.com/JuliaSmoothOptimizers/Krylov.jl/blob/main/interfaces/examples/C/least_squares.c)):

```c
#include <stdio.h>
#include "krylov.h"

#define M 5   /* rows */
#define N 3   /* columns */

typedef struct { int m, n; const double *A; } Mat;  /* A row-major, m x n */

/* y = A * x   (x length n, y length m) */
static void matvec_A(const void *xv, void *yv, void *ud)
{
  const double *x = (const double *)xv; double *y = (double *)yv;
  const Mat *A = (const Mat *)ud;
  for (int i = 0; i < A->m; i++) {
    double s = 0.0;
    for (int j = 0; j < A->n; j++) s += A->A[i*A->n + j] * x[j];
    y[i] = s;
  }
}

/* y = Aᴴ x = Aᵀ x   (x length m, y length n) */
static void matvec_At(const void *xv, void *yv, void *ud)
{
  const double *x = (const double *)xv; double *y = (double *)yv;
  const Mat *A = (const Mat *)ud;
  for (int j = 0; j < A->n; j++) {
    double s = 0.0;
    for (int i = 0; i < A->m; i++) s += A->A[i*A->n + j] * x[i];
    y[j] = s;
  }
}

int main(void)
{
  static const double A[M*N] = { 1,0,0,  0,1,0,  0,0,1,  1,1,0,  0,1,1 };
  Mat mat = { M, N, A };

  double x_true[N] = {1.0, 2.0, 3.0}, b[M], x[N];
  matvec_A(x_true, b, &mat);                 // consistent RHS

  void *ws = NULL;
  krylov_workspace_create(KRYLOV_LSMR, M, N, KRYLOV_FLOAT64, KRYLOV_CPU, NULL, &ws);

  KrylovOptions opts = krylov_default_options();
  opts.atol = 1e-12; opts.rtol = 1e-12;

  // LSMR needs the adjoint: pass matvec_At in the second slot.
  krylov_solve(ws, matvec_A, matvec_At, NULL, NULL, b, NULL, &mat, &opts);
  krylov_get_x(ws, x, N);                     // solution has length n

  printf("Solved: %s   niter: %d\n",
         krylov_is_solved(ws) ? "yes" : "no", krylov_niter(ws));
  krylov_workspace_free(ws);
  return 0;
}
```

## More examples

The repository keeps several complete C programs, all compiled and run in CI:

- [`test/C/test_all_solvers.c`](https://github.com/JuliaSmoothOptimizers/Krylov.jl/blob/main/interfaces/test/C/test_all_solvers.c), every solver, on SPD, non-symmetric and least-squares problems.
- [`test/C/test_api.c`](https://github.com/JuliaSmoothOptimizers/Krylov.jl/blob/main/interfaces/test/C/test_api.c), options, preconditioner, warm start, workspace reuse, error codes, `Float32`.
- [`test/C/test_block.c`](https://github.com/JuliaSmoothOptimizers/Krylov.jl/blob/main/interfaces/test/C/test_block.c), `block_gmres` and `block_minres`.

```@meta
# Non-Hermitian square linear systems
```

## BiLQ

```@docs
bilq
bilq!
BilqWorkspace
```

## QMR

```@docs
qmr
qmr!
QmrWorkspace
```

## CGS

```@docs
cgs
cgs!
CgsWorkspace
```

## BiCGSTAB

```@docs
bicgstab
bicgstab!
BicgstabWorkspace
```

## DIOM

```@docs
diom
diom!
DiomWorkspace
```

## FOM

```@docs
fom
fom!
FomWorkspace
```

## DQGMRES

```@docs
dqgmres
dqgmres!
DqgmresWorkspace
```

## GMRES

```@docs
gmres
gmres!
GmresWorkspace
```

## FGMRES

```@docs
fgmres
fgmres!
FgmresWorkspace
```

# [Reference](@id reference-interfaces)

Detailed reference for the `libkrylov` C and Fortran API. See the [overview](@ref overview-interfaces) for the big picture and a quickstart, and the [C interface](@ref c-interface) / [Fortran interface](@ref fortran-interface) pages for runnable programs.

## [API overview](@id ref-api-overview)

```c
// Callback signature: computes y = A * x, y = Aᴴ * x, or y = M \ x
typedef void (*KrylovMatvec)(const void *x, void *y, void *userdata);

// Library version (same values as the KRYLOV_VERSION_* macros)
void krylov_get_version(int *major, int *minor, int *patch);

// Construction-time options (memory / window); NULL = solver defaults
KrylovWorkspaceOptions krylov_default_workspace_options(void);

int krylov_workspace_create(KrylovSolverType solver,   // KRYLOV_CG, KRYLOV_GMRES, ...
                            int m, int n,
                            KrylovDataType precision,  // KRYLOV_FLOAT64, ...
                            KrylovDeviceType device,   // KRYLOV_CPU
                            const KrylovWorkspaceOptions *wopts, // NULL = defaults
                            void **ws_out);

// Solve-time options (atol, rtol, itmax, verbose, lambda, tau, nu); NULL = defaults
KrylovOptions krylov_default_options(void);

int krylov_solve(void *ws,
                 KrylovMatvec matvec_A,   // required
                 KrylovMatvec matvec_At,  // NULL if not needed
                 KrylovMatvec matvec_M,   // left/centered preconditioner, NULL = none
                 KrylovMatvec matvec_N,   // right preconditioner,         NULL = none
                 const void *b,           // right-hand side
                 const void *c,           // second RHS, NULL if not needed
                 void *userdata,
                 const KrylovOptions *opts); // NULL = solver defaults

int    krylov_get_x(void *ws, void *x, int n);
int    krylov_get_y(void *ws, void *y, int m);
int    krylov_is_solved(void *ws);         // 1 = converged
int    krylov_niter(void *ws);
double krylov_elapsed_time(void *ws);
int    krylov_warm_start(void *ws, const void *x0, int n);
int    krylov_warm_start2(void *ws, const void *x0, const void *y0, int nx, int ny);
int    krylov_workspace_free(void *ws);
```

## [Workspace lifetime](@id ref-lifetime)

`krylov_workspace_create` is the only allocating call, and `krylov_workspace_free` the only releasing one. Between them you may call `krylov_solve` and the accessors as many times as you like. For example, solve `A x = b₁` then `A x = b₂` with the same operator, reusing all the internal vectors. The handle becomes invalid the moment you free it; do not touch it afterwards. Free each workspace exactly once to avoid leaking the (potentially large) internal storage.

## [The matvec callbacks](@id ref-callbacks)

A callback receives three raw pointers and returns nothing:

```c
void matvec(const void *x, void *y, void *userdata);
```

- `x` is the input vector (read-only). `y` is the output vector you must fill. `userdata` is the opaque pointer you handed to `krylov_solve`, forwarded unchanged to every callback; use it to carry whatever your product needs (the matrix, problem sizes, scratch buffers).
- Both vectors point to arrays of the element type you chose at creation (`double`, `float`, `double _Complex`, `float _Complex`). Cast them accordingly before use.
- The library owns `x` and `y`. Do not keep, free, or resize them. They are valid only for the duration of the call.

The four slots play different roles, and their vector lengths follow the operator shape (`m` rows, `n` columns):

| Slot        | Computes      | `x` length | `y` length | When to pass |
|-------------|---------------|:----------:|:----------:|--------------|
| `matvec_A`  | `y = A * x`   | `n`        | `m`        | always (required) |
| `matvec_At` | `y = Aᴴ * x`  | `m`        | `n`        | solvers that use the adjoint |
| `matvec_M`  | `y = M⁻¹ * x` | `m`        | `m`        | preconditioning (centered for symmetric solvers, left otherwise) |
| `matvec_N`  | `y = N⁻¹ * x` | `n`        | `n`        | right preconditioning (non-symmetric solvers) |

For square systems `m == n`, so all these lengths coincide. This is the common case (CG, GMRES). The distinction matters for least-squares and least-norm solvers, where `A` is rectangular.

!!! note "GPMR is special"
    For `KRYLOV_GPMR` the second callback slot is not the adjoint of `A`. It is a separate operator `B` (size `n × m`) used by the block formulation `[0 A; B 0]`. Pass the product of `B` where `matvec_At` would normally go.

## [Data types and precision](@id ref-datatypes)

A workspace is created for exactly one element type, selected with `KrylovDataType`:

| Enum               | Julia type   | C element type    |
|--------------------|--------------|-------------------|
| `KRYLOV_FLOAT32`   | `Float32`    | `float`           |
| `KRYLOV_FLOAT64`   | `Float64`    | `double`          |
| `KRYLOV_COMPLEX32` | `ComplexF32` | `float _Complex`  |
| `KRYLOV_COMPLEX64` | `ComplexF64` | `double _Complex` |

Every buffer that crosses the boundary (`b`, `c`, the callback's `x` and `y`, `x0`, and the destinations of `krylov_get_x` / `krylov_get_y`) must be an array of that element type. The complex layout is the standard interleaved real/imaginary one. It is identical to C99 `_Complex` and to Julia's `Complex{T}`, so no conversion is needed. The only device currently available is `KRYLOV_CPU = 0`.

## [Choosing a solver](@id ref-choosing)

`KrylovSolverType` lists every exposed solver (`KRYLOV_CG`, `KRYLOV_GMRES`, and so on). Three properties decide how you call `krylov_solve`.

**Does it need `matvec_At`?** Pass `NULL` for the left column, a real callback for the right one:

| Pass `NULL` for `matvec_At` | Provide `matvec_At` |
|-----------------------------|---------------------|
| CG, CR, CAR, MINRES, MINRES-QLP, MINARES, SYMMLQ, GMRES, FGMRES, FOM, DIOM, DQGMRES, BiCGSTAB, CGS | BiLQ, QMR, BiLQR, TriLQR, USYMLQ, USYMQR, USYMLQR, TriCG, TriMR, LSLQ, LSQR, LSMR, CGLS, CRLS, CGNE, CRMR, CRAIG, CRAIGMR, LNLQ, GPMR\* |

\* GPMR uses that slot for `B`, not `Aᴴ` (see the note above).

**Does it take a second right-hand side `c`?** Required by TriCG, TriMR, BiLQR, TriLQR, USYMLQ, USYMQR, USYMLQR and GPMR. Pass `NULL` for `c` otherwise.

**Does it produce a second solution `y`?** Retrieve it with `krylov_get_y` for the two-solution solvers TriCG, TriMR, USYMLQR, GPMR, BiLQR, TriLQR, CRAIG, CRAIGMR and LNLQ (its length is the size of the dual solution: `n` for TriCG/TriMR/USYMLQR, `m` for the others). For every other solver `krylov_get_y` returns `-2`.

## [Options](@id ref-options)

Options are split by *when* they are consumed:

| Struct | Passed to | Fields |
|--------|-----------|--------|
| `KrylovWorkspaceOptions` | `krylov_workspace_create` | `memory`, `window` |
| `KrylovOptions` | `krylov_solve` | `atol`, `rtol`, `itmax`, `verbose`, `lambda`, `tau`, `nu`, `timemax`, `radius`, `restart`, `reorthogonalization`, `linesearch` |

Always initialise a struct from its `krylov_default_*` helper, then override only the fields you need. Every field has a sentinel (`0` for ints, `NaN` for doubles) meaning *use the solver default*. Fields irrelevant to a given solver are silently ignored, so it is safe to set, say, `lambda` even when running CG.

**Construction-time** (`KrylovWorkspaceOptions`). These size internal storage, so they belong to creation rather than to the solve:

- `memory`, default `20`. Its meaning depends on the solver:
  - **DIOM** and **DQGMRES** are genuinely limited-memory: `memory` is the number of recent basis vectors a new vector is orthogonalized against (the truncation parameter), so it directly changes the algorithm.
  - **GMRES**, **FGMRES**, **FOM** and **GPMR** are full methods here: `memory` only sizes the initial storage and the basis grows on demand, so it is a performance hint, not an algorithmic knob (use `restart` for the restarted GMRES(k) variant).
- `window`, the number of past residuals used by the residual-norm estimate of MINRES, SYMMLQ, LSQR, LSMR and LSLQ, default `5`.

**Solve-time** (`KrylovOptions`):

- `atol`, `rtol`, the absolute and relative stopping tolerances. `NaN` falls back to `√eps(T)` for the chosen precision.
- `itmax`, the iteration cap. `0` falls back to the solver default (a small multiple of the problem size).
- `timemax`, a wall-clock budget in seconds; the solve stops once it is exceeded. `NaN` means no limit (`Inf`). Honoured by every solver.
- `verbose`. `0` is silent, a positive value prints convergence information every `verbose` iterations.
- `lambda`, a shift or regularisation; `0.0` means none. For the least-squares and least-norm solvers (LSQR, LSMR, CGLS, CRLS, LNLQ, LSLQ, CRAIG, CRAIGMR) it is the Tikhonov parameter. For the symmetric solvers (MINRES, MINRES-QLP, SYMMLQ, MINARES) it shifts the system to `(A + lambda·I) x = b`.
- `radius`, a trust-region constraint `‖x‖ ≤ radius` for CG, CR, CGLS, CRLS, LSQR and LSMR. `0.0` (default) means unconstrained; with `radius > 0` the step stops on the trust-region boundary. Useful inside optimization solvers.
- `linesearch`, set to `1` to detect nonpositive curvature and stop on it (CG, CR, MINRES, MINRES-QLP). Cannot be combined with `radius > 0`.
- `restart`, set to `1` to restart GMRES, FGMRES, FOM (and `block_gmres`) every `memory` iterations, i.e. the restarted GMRES(k) variant, with `k = memory` from `KrylovWorkspaceOptions`.
- `reorthogonalization`, set to `1` to reorthogonalize the Krylov basis (GMRES, FGMRES, FOM, DIOM, DQGMRES, GPMR, `block_gmres`), trading work for numerical robustness.
- `tau`, `nu`, the diagonal scalings of the saddle-point system solved by TriCG and TriMR. `NaN` falls back to `1.0` and `-1.0` respectively.

```c
// DQGMRES truncated to the 10 most recent Krylov basis vectors
KrylovWorkspaceOptions wopts = krylov_default_workspace_options();
wopts.memory = 10;
krylov_workspace_create(KRYLOV_DQGMRES, n, n, KRYLOV_FLOAT64, KRYLOV_CPU, &wopts, &ws);
```

## [Return codes](@id ref-return-codes)

Every function returns an `int` status (`krylov_elapsed_time` returns a `double`). The conventions are:

| Function | Success | Other values |
|----------|:-------:|--------------|
| `krylov_workspace_create` | `0` | `-1` internal error, `-2` unknown `(solver, precision)` combination |
| `krylov_solve` | `0` | `-1` internal error (for example a callback threw) |
| `krylov_get_x` | `0` | `-1` error (bad handle or size) |
| `krylov_get_y` | `0` | `-1` error, `-2` solver has a single solution |
| `krylov_warm_start` | `0` | `-1` error, `-2` solver does not support warm start |
| `krylov_warm_start2` | `0` | `-1` error, `-2` solver has a single solution |
| `krylov_workspace_free` | `0` | `1` handle not found |
| `krylov_is_solved` | `1` converged | `0` not converged, `-1` error |
| `krylov_niter` | iteration count | `-1` error |
| `krylov_elapsed_time` | seconds (`double`) | `-1.0` error |

Always check the status of `krylov_workspace_create` and `krylov_solve` before reading results, and use `krylov_is_solved` to confirm convergence. A non-zero `krylov_solve` means the run failed, whereas `krylov_is_solved == 0` means it ran but did not reach the tolerance within `itmax`.

## [Error handling and safety](@id ref-errors)

The return code is the reliable signal, so always check it. Any exception raised on the Julia side during a call is caught and converted to `-1`; it is never propagated across the C boundary. The offending call is logged to `stderr`. After a solve, `krylov_is_solved` separates a genuine failure (`krylov_solve` returned nonzero) from a run that did not converge within `itmax` (`krylov_solve` returned `0`, but `krylov_is_solved` is `0`).

Two classes of mistakes are the caller's responsibility and are **not** caught:

- **Wrong buffer sizes.** The library trusts the sizes you pass: `krylov_solve` reads `b` and the callback buffers assuming the dimensions given at creation. A buffer shorter than expected is an out-of-bounds access (undefined behavior), not a clean error.
- **A crash inside a callback.** The matvec and preconditioner callbacks are your own native code; a segfault or out-of-bounds write there takes down the whole process, and Julia cannot intercept it.

**Thread safety.** The library is not thread-safe; workspaces are tracked in shared global tables. So `krylov_workspace_create` and `krylov_workspace_free` must not run concurrently with each other or with any other `libkrylov` call. Solving on separate workspaces from separate threads is safe only if no workspace is being created or freed at the same time (and if your own callbacks are thread-safe).

## [Warm start](@id ref-warm-start)

To seed a solve with an initial guess `x0`, call `krylov_warm_start(ws, x0, n)` *before* `krylov_solve`. The guess is copied into the workspace and consumed by the next solve. Solvers that do not support warm starting return `-2`.

The two-solution solvers (TriCG, TriMR, GPMR, BiLQR, TriLQR, USYMLQR) take a guess for *both* unknowns through `krylov_warm_start2(ws, x0, y0, nx, ny)`. Here `x0` has the size of the primal solution (`krylov_get_x`) and `y0` the size of the dual one (`krylov_get_y`). Calling it on a single-solution solver returns `-2`. See [Warm-start](@ref warm-start) for the underlying mechanism.

## [Preconditioning](@id ref-preconditioning)

A preconditioner is passed through the `matvec_M` / `matvec_N` slots. A preconditioner callback applies the *action of the inverse*: it computes `y = M⁻¹ x` (that is, solves `M y = x`), never the forward product. Pass `NULL` in a slot for no preconditioner. Like the operator, preconditioners are matrix-free: they can be an incomplete factorization, a sparse approximate inverse, a multigrid V-cycle, or anything else you can evaluate. How the slots are interpreted depends on the solver:

- **Symmetric solvers** (CG, CR, CAR, MINRES, MINRES-QLP, SYMMLQ, MINARES) take a single **centered** preconditioner in `matvec_M`, a symmetric positive-definite `M` that preserves the symmetry of the system. `matvec_N` is ignored, so pass `NULL`. The callback sees vectors of length `n` (`= m`, the system is square).
- **Non-symmetric solvers** (GMRES, FGMRES, FOM, DIOM, DQGMRES, BiCGSTAB, CGS, BiLQ, QMR; and `block_gmres`) take a **left** preconditioner in `matvec_M` and a **right** one in `matvec_N` (both length `n`, the system is square). Supplying both gives a split preconditioner.

### Least-squares and least-norm solvers

These rectangular solvers follow Krylov.jl's convention of two preconditioners `M = E⁻¹` (acting on the `m`-dimensional data space) and `N = F⁻¹` (the `n`-dimensional solution space):

| Solvers | `matvec_M` | `matvec_N` |
|---------|-----------|-----------|
| LSQR, LSMR, LSLQ, CRAIG, CRAIGMR, LNLQ | `E⁻¹`, length `m` | `F⁻¹`, length `n` |
| CGLS, CRLS (normal equations) | single precond., length `n` | — |
| CGNE, CRMR (normal equations) | — | single precond., length `n` |

For LSQR/LSMR/LSLQ/CRAIG/CRAIGMR/LNLQ, `M` weights the residual norm and `N` the solution norm. The normal-equations methods (CGLS/CRLS, CGNE/CRMR) operate directly on `AᴴA` or `AAᴴ`. They take a single preconditioner on the `n`-space: through `matvec_M` for CGLS/CRLS, through `matvec_N` for CGNE/CRMR.

!!! note "GPMR and the two-RHS solvers"
    Preconditioning for GPMR (which has its own `C, D, E, F` operators) and for the two-RHS solvers (TriCG, TriMR, BiLQR, TriLQR, USYMLQ, USYMQR, USYMLQR) is not exposed through `matvec_M` / `matvec_N` yet; those slots are ignored for them.

See [Preconditioners](@ref preconditioners) for guidance on choosing one.

## [Block Krylov solvers](@id ref-block)

`block_gmres` and `block_minres` solve a system with several right-hand sides at once, `A X = B`, where `B` and `X` are `m×p` and `n×p` blocks. They have their own parallel API, mirroring the single-vector one:

```c
typedef enum { KRYLOV_BLOCK_GMRES = 0, KRYLOV_BLOCK_MINRES = 1 } KrylovBlockSolverType;

// Block matvec: computes Y = A*X (or Y = M\X) for a block of p columns.
//   X : input  block (n*p, column-major)
//   Y : output block (m*p, column-major)
//   p : number of columns
typedef void (*KrylovBlockMatvec)(const void *X, void *Y, int p, void *userdata);

int    krylov_block_workspace_create(KrylovBlockSolverType solver, int m, int n, int p,
                                     KrylovDataType dtype, KrylovDeviceType device,
                                     const KrylovWorkspaceOptions *wopts, void **ws_out);
int    krylov_block_solve(void *ws, KrylovBlockMatvec matvec_A,
                          KrylovBlockMatvec matvec_M,  // left preconditioner,  NULL = none
                          KrylovBlockMatvec matvec_N,  // right preconditioner, NULL = none
                          const void *B, void *userdata, const KrylovOptions *opts);
int    krylov_block_get_X(void *ws, void *X, int n, int p);
int    krylov_block_is_solved(void *ws);
int    krylov_block_niter(void *ws);
double krylov_block_elapsed_time(void *ws);
int    krylov_block_warm_start(void *ws, const void *X0, int n, int p);
int    krylov_block_workspace_free(void *ws);
```

Key differences from the single-vector API:

- **Blocks are column-major**, exactly like a Fortran or LAPACK matrix: entry `(i, j)` of an `n×p` block is at offset `i + j*n`. `B`, `X`, `X0`, and the callback's `X` and `Y` all use this layout.
- **The callback receives the block width `p`**, so it can apply `A` to all columns in one call (`Y = A·X`).
- **`B` must have full column rank.** Block methods orthonormalize the right-hand side, so linearly dependent columns (for example a duplicated RHS) lead to a breakdown. Give each column a distinct RHS.
- `memory` (in `KrylovWorkspaceOptions`) applies to `block_gmres` only. The solve-time tolerances (`atol`, `rtol`, `itmax`, `verbose`) come from `KrylovOptions` as usual.
- `matvec_M` (left preconditioner) is available for both block solvers; `matvec_N` (right) is used by `block_gmres` only and ignored by `block_minres`. Pass `NULL` for an unpreconditioned side.

Runnable block programs are shown on the [C interface](@ref c-interface) and [Fortran interface](@ref fortran-interface) pages.
See [Block Krylov methods](@ref block-krylov-methods) for the underlying algorithms.

```@meta
# Least-norm problems
```

## CGNE

```@docs
cgne
cgne!
CgneWorkspace
```

## CRMR

```@docs
crmr
crmr!
CrmrWorkspace
```

## LNLQ

```@docs
lnlq
lnlq!
LnlqWorkspace
```

## CRAIG

```@docs
craig
craig!
CraigWorkspace
```

## CRAIGMR

```@docs
craigmr
craigmr!
CraigmrWorkspace
```

## USYMLQ

```@docs
usymlq
usymlq!
UsymlqWorkspace
```

# [Fortran interface](@id fortran-interface)

Add `use iso_c_binding` and `include 'krylov.f90'` after `implicit none`, then link against `libkrylov` (see [Building libkrylov](@ref building-libkrylov)).
The concepts (callbacks, data types, options, return codes, block solvers) are described in the [reference](@ref reference-interfaces).
This page collects runnable Fortran programs.

## Example

The same 5×5 tridiagonal SPD system as the [C example](@ref c-interface), now in Fortran ([`examples/Fortran/basic_cg.f90`](https://github.com/JuliaSmoothOptimizers/Krylov.jl/blob/main/interfaces/examples/Fortran/basic_cg.f90)):

```fortran
program basic_cg
  use iso_c_binding
  implicit none
  include 'krylov.f90'

  integer, parameter    :: n = 5
  real(c_double), target :: diag(n), off(n-1), b(n), x(n)
  type(KrylovOptions), target :: opts
  type(c_ptr)           :: ws
  integer(c_int)        :: ret

  diag = 2.0_c_double ; off = -1.0_c_double
  b = 0.0_c_double ; b(1) = 1.0_c_double ; b(n) = 1.0_c_double

  ret = krylov_workspace_create(KRYLOV_CG, n, n, KRYLOV_FLOAT64, KRYLOV_CPU, &
                                c_null_ptr, ws)

  opts = krylov_default_options()
  opts%atol = 1d-10 ; opts%rtol = 1d-10
  ret = krylov_solve(ws, c_funloc(matvec_A), c_null_funptr, c_null_funptr, &
                     c_null_funptr, c_loc(b), c_null_ptr, c_loc(diag), c_loc(opts))
  ret = krylov_get_x(ws, c_loc(x), int(n, c_int))

  write(*,*) "Solved:", krylov_is_solved(ws) == 1, "  niter:", krylov_niter(ws)
  write(*,'(5F6.2)') x

  ret = krylov_workspace_free(ws)

contains
  subroutine matvec_A(x_ptr, y_ptr, userdata) bind(c)
    type(c_ptr), value :: x_ptr, y_ptr, userdata
    real(c_double), pointer :: xv(:), yv(:), dg(:)
    integer :: i
    call c_f_pointer(x_ptr, xv, [n]) ; call c_f_pointer(y_ptr, yv, [n])
    call c_f_pointer(userdata, dg, [n])
    do i = 1, n
      yv(i) = dg(i)*xv(i)
      if (i > 1) yv(i) = yv(i) - xv(i-1)
      if (i < n) yv(i) = yv(i) - xv(i+1)
    end do
  end subroutine
end program
```

## Block example

Solve `A X = B` with several right-hand sides at once using block GMRES. Blocks are natural Fortran 2D arrays (column-major); `B` must have full column rank (see [Block Krylov solvers](@ref block-krylov-methods)). Switch `KRYLOV_BLOCK_GMRES` to `KRYLOV_BLOCK_MINRES` for block MINRES
([`examples/Fortran/block_gmres.f90`](https://github.com/JuliaSmoothOptimizers/Krylov.jl/blob/main/interfaces/examples/Fortran/block_gmres.f90)):

```fortran
program block_gmres
  use iso_c_binding
  implicit none
  include 'krylov.f90'

  integer, parameter :: n = 16    ! operator dimension
  integer, parameter :: p = 3     ! number of right-hand sides (block width)

  real(c_double), target :: Xtrue(n,p), B(n,p), X(n,p)
  type(KrylovOptions), target :: opts
  type(c_ptr)    :: ws
  integer(c_int) :: ret
  integer        :: i, j
  real(c_double) :: t

  ! X_true with independent columns, then B = A * X_true.
  do j = 1, p
    do i = 1, n
      t = real(i, c_double) / n
      if (j == 1) then
        Xtrue(i,j) = 1.0_c_double
      else if (j == 2) then
        Xtrue(i,j) = t
      else
        Xtrue(i,j) = t*t
      end if
    end do
  end do
  call apply_A(Xtrue, B, p)

  ret = krylov_block_workspace_create(KRYLOV_BLOCK_GMRES, n, n, p,        &
                                      KRYLOV_FLOAT64, KRYLOV_CPU,          &
                                      c_null_ptr, ws)

  opts = krylov_default_options()
  opts%atol = 1.0d-10 ; opts%rtol = 1.0d-10
  ret = krylov_block_solve(ws, c_funloc(cb_block_A), c_null_funptr,       &
                           c_null_funptr, c_loc(B), c_null_ptr, c_loc(opts))
  ret = krylov_block_get_X(ws, c_loc(X), int(n, c_int), int(p, c_int))

  write(*,'(A,L1,A,I0,A,ES8.1)')                                          &
    "Block solved: ", (krylov_block_is_solved(ws) == 1),                  &
    "   niter: ", krylov_block_niter(ws),                                 &
    "   max error: ", maxval(abs(X - Xtrue))

  ret = krylov_block_workspace_free(ws)

contains

  ! Y = A * X for a p-column block, A = tridiag(-1, 8, -1).
  subroutine apply_A(Xin, Yout, pp)
    integer, intent(in)         :: pp
    real(c_double), intent(in)  :: Xin(:,:)
    real(c_double), intent(out) :: Yout(:,:)
    integer :: ii, jj
    do jj = 1, pp
      do ii = 1, n
        Yout(ii,jj) = 8.0_c_double * Xin(ii,jj)
        if (ii > 1) Yout(ii,jj) = Yout(ii,jj) - Xin(ii-1,jj)
        if (ii < n) Yout(ii,jj) = Yout(ii,jj) - Xin(ii+1,jj)
      end do
    end do
  end subroutine apply_A

  ! Block matvec callback: Y = A*X for a block of p columns.
  subroutine cb_block_A(x_ptr, y_ptr, pblk, userdata) bind(c)
    type(c_ptr),    value :: x_ptr, y_ptr, userdata
    integer(c_int), value :: pblk
    real(c_double), pointer :: xx(:,:), yy(:,:)
    call c_f_pointer(x_ptr, xx, [n, int(pblk)])
    call c_f_pointer(y_ptr, yy, [n, int(pblk)])
    call apply_A(xx, yy, int(pblk))
  end subroutine cb_block_A

end program block_gmres
```

## Fortran specifics

A few rules make the binding work:

- `include 'krylov.f90'` goes after `implicit none`. It declares the enum parameters, the `KrylovOptions` and `KrylovWorkspaceOptions` derived types (both `bind(c)`), and the `interface` blocks for every function.
- Anything whose address you take with `c_loc` must have the `target` attribute, including the option structs (`type(KrylovOptions), target :: opts`).
- Vectors and structs are passed as `c_loc(array)` and `c_loc(opts)`; pass `c_null_ptr` for an absent `b`, `c`, `opts` or `wopts`.
- Callbacks are passed as `c_funloc(my_sub)` and must be `bind(c)` subroutines with three `type(c_ptr), value` arguments (the block callback takes an extra `integer(c_int), value :: p`). Pass `c_null_funptr` for an unused slot. Inside, recover Fortran arrays with `c_f_pointer`.
- Block right-hand sides and solutions are natural Fortran 2D arrays (column-major), passed with `c_loc`.

## More examples

The repository keeps complete Fortran programs, compiled and run in CI:

- [`test/Fortran/test_all_solvers.f90`](https://github.com/JuliaSmoothOptimizers/Krylov.jl/blob/main/interfaces/test/Fortran/test_all_solvers.f90), every solver.
- [`test/Fortran/test_block.f90`](https://github.com/JuliaSmoothOptimizers/Krylov.jl/blob/main/interfaces/test/Fortran/test_block.f90), `block_gmres` and `block_minres`.

# [Warm-start](@id warm-start)

Most Krylov methods accept a user-provided initial guess instead of starting from zero.

```julia
workspace = CgWorkspace(A, b)
cg!(workspace, A, b, itmax=100)
if !issolved(workspace)
  # Use the approximate solution `workspace.x` as starting point
  cg!(workspace, A, b, workspace.x, itmax=100)
end
```

If the user has an initial guess `x0`, it can be provided directly.

```julia
cg(A, b, x0)
```

If a Krylov method doesn't have the option to warm start, it can still be done explicitly.
We provide an example with `cg_lanczos!`.

```julia
workspace = CgLanczosWorkspace(A, b)

cg_lanczos!(workspace, A, b)
x₀ = workspace.x  # Ax₀ ≈ b
r = b - A * x₀    # r = b - Ax₀

cg_lanczos!(workspace, A, r)
Δx = workspace.x  # AΔx = r
x = x₀ + Δx       # Ax = b
```

Explicit restarts cannot be avoided in certain block methods, such as TriMR, due to the preconditioners.

```julia
# [E  A] [x] = [b]
# [Aᴴ F] [y]   [c]
M = inv(E)
N = inv(F)
x₀, y₀, stats = trimr(A, b, c, M=M, N=N)

# E and F are not available inside TriMR
b₀ = b -  Ex₀ - Ay
c₀ = c - Aᴴx₀ - Fy

Δx, Δy, stats = trimr(A, b₀, c₀, M=M, N=N)
x = x₀ + Δx
y = y₀ + Δy
```
```@meta
# ## Restarted methods
#
# The storage requirements of Krylov methods based on the Arnoldi process, such as FOM and GMRES, increase as the iteration progresses.
# For very large problems, the storage costs become prohibitive after only few iterations and restarted variants FOM(k) and GMRES(k) are preferred.
# In this section, we show how to use warm starts to implement GMRES(k) and FOM(k).
#
# ```julia
# k = 50
# workspace = GmresWorkspace(A, b, k)  # FomWorkspace(A, b, k)
# workspace.x .= 0                     # workspace.x .= x₀
# nrestart = 0
# while !issolved(workspace) || nrestart ≤ 10
#   solve!(workspace, A, b, workspace.x, itmax=k)
#   nrestart += 1
# end
# ```
```

```@meta
# Saddle-point and Hermitian quasi-definite systems
```

## TriCG

```@docs
tricg
tricg!
TricgWorkspace
```

## TriMR

```@docs
trimr
trimr!
TrimrWorkspace
```

## USYMLQR

```@docs
usymlqr
usymlqr!
UsymlqrWorkspace
```

# [Block Krylov processes](@id block-krylov-processes)

## [Block Hermitian Lanczos](@id block-hermitian-lanczos)

If the vector $b$ in the [Hermitian Lanczos](@ref hermitian-lanczos) process is replaced by a matrix $B$ with $p$ columns, we can derive the block Hermitian Lanczos process.

![block_hermitian_lanczos](./graphics/block_hermitian_lanczos.png)

After $k$ iterations of the block Hermitian Lanczos process, the situation may be summarized as
```math
\begin{align*}
  A V_k &= V_{k+1} T_{k+1,k}, \\
  V_k^H V_k &= I_{pk},
\end{align*}
```
where $V_k$ is an orthonormal basis of the block Krylov subspace $\mathcal{K}_k^{\square}(A,B)$,
```math
T_{k+1,k} =
\begin{bmatrix}
  \Omega_1 & \Psi_2^H &        &          \\
  \Psi_2   & \Omega_2 & \ddots &          \\
           & \ddots   & \ddots & \Psi_k^H \\
           &          & \Psi_k & \Omega_k \\
           &          &        & \Psi_{k+1}
\end{bmatrix}.
```

The function [`hermitian_lanczos`](@ref hermitian_lanczos(::Any, ::AbstractMatrix{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)) returns $V_{k+1}$, $\Psi_1$ and $T_{k+1,k}$.

Related method: [`BLOCK-MINRES`](@ref block_minres).

```@docs
hermitian_lanczos(::Any, ::AbstractMatrix{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)
```

## [Block Non-Hermitian Lanczos](@id block-nonhermitian-lanczos)

If the vectors $b$ and $c$ in the [non-Hermitian Lanczos](@ref nonhermitian-lanczos) process are replaced by matrices $B$ and $C$ with both $p$ columns, we can derive the block non-Hermitian Lanczos process.

![block_nonhermitian_lanczos](./graphics/block_nonhermitian_lanczos.png)

After $k$ iterations of the block non-Hermitian Lanczos process, the situation may be summarized as
```math
\begin{align*}
  A V_k &= V_{k+1} T_{k+1,k}, \\
  A^H U_k &= U_{k+1} T_{k,k+1}^H, \\
  V_k^H U_k &= U_k^H V_k = I_{pk},
\end{align*}
```
where $V_k$ and $U_k$ are bases of the block Krylov subspaces $\mathcal{K}^{\square}_k(A,B)$ and $\mathcal{K}^{\square}_k (A^H,C)$, respectively,
```math
T_{k+1,k} =
\begin{bmatrix}
  \Omega_1 & \Phi_2   &        &          \\
  \Psi_2   & \Omega_2 & \ddots &          \\
           & \ddots   & \ddots & \Phi_k   \\
           &          & \Psi_k & \Omega_k \\
           &          &        & \Psi_{k+1}
\end{bmatrix}
, \qquad
T_{k,k+1}^H =
\begin{bmatrix}
  \Omega_1^H & \Psi_2^H   &          &            \\
  \Phi_2^H   & \Omega_2^H & \ddots   &            \\
             & \ddots     & \ddots   & \Psi_k^H   \\
             &            & \Phi_k^H & \Omega_k^H \\
             &            &          & \Phi_{k+1}^H
\end{bmatrix}.
```

The function [`nonhermitian_lanczos`](@ref nonhermitian_lanczos(::Any, ::AbstractMatrix{FC}, ::AbstractMatrix{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)) returns $V_{k+1}$, $\Psi_1$, $T_{k+1,k}$, $U_{k+1}$ $\Phi_1^H$ and $T_{k,k+1}^H$.

```@docs
nonhermitian_lanczos(::Any, ::AbstractMatrix{FC}, ::AbstractMatrix{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)
```

## [Block Arnoldi](@id block-arnoldi)

If the vector $b$ in the [Arnoldi](@ref arnoldi) process is replaced by a matrix $B$ with $p$ columns, we can derive the block Arnoldi process.

![block_arnoldi](./graphics/block_arnoldi.png)

After $k$ iterations of the block Arnoldi process, the situation may be summarized as
```math
\begin{align*}
  A V_k &= V_{k+1} H_{k+1,k}, \\
  V_k^H V_k &= I_{pk},
\end{align*}
```
where $V_k$ is an orthonormal basis of the block Krylov subspace $\mathcal{K}_k^{\square}(A,B)$,
```math
H_{k+1,k} =
\begin{bmatrix}
  \Psi_{1,1}~ & \Psi_{1,2}~ & \ldots       & \Psi_{1,k}   \\
  \Psi_{2,1}~ & \ddots~     & \ddots       & \vdots       \\
              & \ddots~     & \ddots       & \Psi_{k-1,k} \\
              &             & \Psi_{k,k-1} & \Psi_{k,k}   \\
              &             &              & \Psi_{k+1,k}
\end{bmatrix}.
```

The function [`arnoldi`](@ref arnoldi(::Any, ::AbstractMatrix{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)) returns $V_{k+1}$, $\Gamma$, and $H_{k+1,k}$.

Related method: [`BLOCK-GMRES`](@ref block_gmres).

```@docs
arnoldi(::Any, ::AbstractMatrix{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)
```

## [Block Golub-Kahan](@id block-golub-kahan)

If the vector $b$ in the [Golub-Kahan](@ref golub-kahan) process is replaced by a matrix $B$ with $p$ columns, we can derive the block Golub-Kahan process.

![block_golub_kahan](./graphics/block_golub_kahan.png)

After $k$ iterations of the block Golub-Kahan process, the situation may be summarized as
```math
\begin{align*}
  A V_k &= U_{k+1} B_k, \\
  A^H U_{k+1} &= V_{k+1} L_{k+1}^H, \\
  V_k^H V_k &= U_k^H U_k = I_{pk},
\end{align*}
```
where $V_k$ and $U_k$ are bases of the block Krylov subspaces $\mathcal{K}_k^{\square}(A^HA,A^HB)$ and $\mathcal{K}_k^{\square}(AA^H,B)$, respectively,
```math
B_k =
\begin{bmatrix}
  \Omega_1 &          &        &            \\
  \Psi_2   & \Omega_2 &        &            \\
           & \ddots   & \ddots &            \\
           &          & \Psi_k & \Omega_k   \\
           &          &        & \Psi_{k+1} \\
\end{bmatrix}
, \qquad
L_{k+1}^H =
\begin{bmatrix}
  \Omega_1^H & \Psi_2^H   &        &            &                \\
             & \Omega_2^H & \ddots &            &                \\
             &            & \ddots & \Psi_k^H   &                \\
             &            &        & \Omega_k^H & \Psi_{k+1}^H   \\
             &            &        &            & \Omega_{k+1}^H \\
\end{bmatrix}.
```

The function [`golub_kahan`](@ref golub_kahan(::Any, ::AbstractMatrix{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)) returns $V_{k+1}$, $U_{k+1}$, $\Psi_1$ and $L_{k+1}$.

```@docs
golub_kahan(::Any, ::AbstractMatrix{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)
```

## [Block Saunders-Simon-Yip](@id block-saunders-simon-yip)

If the vectors $b$ and $c$ in the [Saunders-Simon-Yip](@ref saunders-simon-yip) process are replaced by matrices $B$ and $C$ with both $p$ columns, we can derive the block Saunders-Simon-Yip process.

![block_saunders_simon_yip](./graphics/block_saunders_simon_yip.png)

After $k$ iterations of the block Saunders-Simon-Yip process, the situation may be summarized as
```math
\begin{align*}
  A U_k &= V_{k+1} T_{k+1,k}, \\
  A^H V_k &= U_{k+1} T_{k,k+1}^H, \\
  V_k^H V_k &= U_k^H U_k = I_{pk},
\end{align*}
```
where $\begin{bmatrix} V_k & 0 \\ 0 & U_k \end{bmatrix}$ is an orthonormal basis of the block Krylov subspace $\mathcal{K}^{\square}_k \left(\begin{bmatrix} 0 & A \\ A^H & 0 \end{bmatrix}, \begin{bmatrix} B & 0 \\ 0 & C \end{bmatrix}\right)$,
```math
T_{k+1,k} =
\begin{bmatrix}
  \Omega_1 & \Phi_2   &        &          \\
  \Psi_2   & \Omega_2 & \ddots &          \\
           & \ddots   & \ddots & \Phi_k   \\
           &          & \Psi_k & \Omega_k \\
           &          &        & \Psi_{k+1}
\end{bmatrix}
, \qquad
T_{k,k+1}^H =
\begin{bmatrix}
  \Omega_1^H & \Psi_2^H   &          &            \\
  \Phi_2^H   & \Omega_2^H & \ddots   &            \\
             & \ddots     & \ddots   & \Psi_k^H   \\
             &            & \Phi_k^H & \Omega_k^H \\
             &            &          & \Phi_{k+1}^H
\end{bmatrix}.
```

The function [`saunders_simon_yip`](@ref saunders_simon_yip(::Any, ::AbstractMatrix{FC}, ::AbstractMatrix{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)) returns $V_{k+1}$, $\Psi_1$, $T_{k+1,k}$, $U_{k+1}$, $\Phi_1^H$ and $T_{k,k+1}^H$.

```@docs
saunders_simon_yip(::Any, ::AbstractMatrix{FC}, ::AbstractMatrix{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)
```

## [Block Montoison-Orban](@id block-montoison-orban)

If the vectors $b$ and $c$ in the [Montoison-Orban](@ref montoison-orban) process are replaced by matrices $D$ and $C$ with both $p$ columns, we can derive the block Montoison-Orban process.

![block_montoison_orban](./graphics/block_montoison_orban.png)

After $k$ iterations of the block Montoison-Orban process, the situation may be summarized as
```math
\begin{align*}
  A U_k &= V_{k+1} H_{k+1,k}, \\
  B V_k &= U_{k+1} F_{k+1,k}, \\
  V_k^H V_k &= U_k^H U_k = I_{pk},
\end{align*}
```
where $\begin{bmatrix} V_k & 0 \\ 0 & U_k \end{bmatrix}$ is an orthonormal basis of the block Krylov subspace $\mathcal{K}^{\square}_k \left(\begin{bmatrix} 0 & A \\ B & 0 \end{bmatrix}, \begin{bmatrix} D & 0 \\ 0 & C \end{bmatrix}\right)$,
```math
H_{k+1,k} =
\begin{bmatrix}
  \Psi_{1,1}~ & \Psi_{1,2}~ & \ldots       & \Psi_{1,k}   \\
  \Psi_{2,1}~ & \ddots~     & \ddots       & \vdots       \\
              & \ddots~     & \ddots       & \Psi_{k-1,k} \\
              &             & \Psi_{k,k-1} & \Psi_{k,k}   \\
              &             &              & \Psi_{k+1,k}
\end{bmatrix}
, \qquad
F_{k+1,k} =
\begin{bmatrix}
  \Phi_{1,1}~ & \Phi_{1,2}~ & \ldots       & \Phi_{1,k}   \\
  \Phi_{2,1}~ & \ddots~     & \ddots       & \vdots       \\
              & \ddots~     & \ddots       & \Phi_{k-1,k} \\
              &             & \Phi_{k,k-1} & \Phi_{k,k}   \\
              &             &              & \Phi_{k+1,k}
\end{bmatrix}.
```

The function [`montoison_orban`](@ref montoison_orban(::Any, ::Any, ::AbstractMatrix{FC}, ::AbstractMatrix{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)) returns $V_{k+1}$, $\Gamma$, $H_{k+1,k}$, $U_{k+1}$, $\Lambda$, and $F_{k+1,k}$.

```@docs
montoison_orban(::Any, ::Any, ::AbstractMatrix{FC}, ::AbstractMatrix{FC}, ::Int) where FC <: (Union{Complex{T}, T} where T <: AbstractFloat)
```

```@meta
# Hermitian indefinite linear systems
```

## SYMMLQ

```@docs
symmlq
symmlq!
SymmlqWorkspace
```

## MINRES

```@docs
minres
minres!
MinresWorkspace
```

## MINRES-QLP

```@docs
minres_qlp
minres_qlp!
MinresQlpWorkspace
```

## MINARES

```@docs
minares
minares!
MinaresWorkspace
```

```@meta
# Least-squares problems
```

## CGLS

```@docs
cgls
cgls!
CglsWorkspace
```

## CGLS-LANCZOS-SHIFT

```@docs
cgls_lanczos_shift
cgls_lanczos_shift!
CglsLanczosShiftWorkspace
```

## CRLS

```@docs
crls
crls!
CrlsWorkspace
```

## LSLQ

```@docs
lslq
lslq!
LslqWorkspace
```

## LSQR

```@docs
lsqr
lsqr!
LsqrWorkspace
```

## LSMR

```@docs
lsmr
lsmr!
LsmrWorkspace
```

## USYMQR

```@docs
usymqr
usymqr!
UsymqrWorkspace
```

# [Block Krylov methods](@id block-krylov-methods)

!!! note
    `block_minres` and `block_gmres` work on GPUs with Julia 1.11. Version 11.2.0 or later of `GPUArrays.jl` is also required.

If you want to use `block_minres` and `block_gmres` on previous Julia versions, you can overload the function `Krylov.copy_triangle` with the following code:
```julia
using KernelAbstractions, Krylov

@kernel function copy_triangle_kernel!(dest, src)
  i, j = @index(Global, NTuple)
  if j >= i
    @inbounds dest[i, j] = src[i, j]
  end
end

function Krylov.copy_triangle(Q::AbstractMatrix{FC}, R::AbstractMatrix{FC}, k::Int) where FC <: Krylov.FloatOrComplex
  backend = get_backend(Q)
  ndrange = (k, k)
  copy_triangle_kernel!(backend)(R, Q; ndrange=ndrange)
  KernelAbstractions.synchronize(backend)
end
```

## Block-MINRES

```@docs
block_minres
block_minres!
BlockMinresWorkspace
```

## Block-GMRES

```@docs
block_gmres
block_gmres!
BlockGmresWorkspace
```

```@example cgls_lanczos_shift
using MatrixMarket, SuiteSparseMatrixCollection
using Krylov, LinearOperators
using LinearAlgebra, Printf

function residuals(A, b, shifts, x)
  nshifts = length(shifts)
  r = [ A' * (A * x[i] - b) + shifts[i] * x[i] for i = 1 : nshifts ]
  return r
end
ssmc = ssmc_db(verbose=false)
matrix = ssmc_matrices(ssmc, "HB", "well1033")
path = fetch_ssmc(matrix, format="MM")

A = MatrixMarket.mmread(joinpath(path[1], "$(matrix.name[1]).mtx"))
b = MatrixMarket.mmread(joinpath(path[1], "$(matrix.name[1])_b.mtx"))[:]
(m, n) = size(A)
@printf("System size: %d rows and %d columns\n", m, n)

# Define regularization parameters.
shifts = [1.0, 2.0, 3.0, 4.0]

(x, stats) = cgls_lanczos_shift(A, b, shifts)
show(stats)
r = residuals(A, b, shifts, x)

resids = map(norm, r) / norm(b)
@printf("CGLS: Relative residuals with shifts:\n")
for resid in resids
  @printf(" %8.1e", resid)
end
@printf("\n")
```

```@example block_gmres
using Krylov, MatrixMarket, SuiteSparseMatrixCollection
using LinearAlgebra, Printf

ssmc = ssmc_db(verbose=false)
matrix = ssmc_matrices(ssmc, "HB", "sherman2")
path = fetch_ssmc(matrix, format="MM")

n = matrix.nrows[1]
A = MatrixMarket.mmread(joinpath(path[1], "$(matrix.name[1]).mtx"))
B = Matrix{Float64}(I, n, 5)
B_norm = norm(B)

# Solve Ax = B
X, stats = block_gmres(A, B)
show(stats)
R = B - A * X
@printf("Relative residual: %8.1e\n", norm(R) / B_norm)
```

```@example craigmr
using Krylov, HarwellRutherfordBoeing, SuiteSparseMatrixCollection
using LinearAlgebra, Printf

ssmc = ssmc_db(verbose=false)
matrix = ssmc_matrices(ssmc, "HB", "wm1")
path = fetch_ssmc(matrix, format="RB")

A = RutherfordBoeingData(joinpath(path[1], "$(matrix.name[1]).rb")).data
(m, n) = size(A)
@printf("System size: %d rows and %d columns\n", m, n)

x_exact = A' * ones(m)
x_exact_norm = norm(x_exact)
x_exact /= x_exact_norm
b = A * x_exact
(x, y, stats) = craigmr(A, b)
show(stats)
resid = norm(A * x - b) / norm(b)
@printf("CRAIGMR: Relative residual: %7.1e\n", resid)
@printf("CRAIGMR: ‖x - x*‖₂: %7.1e\n", norm(x - x_exact))
@printf("CRAIGMR: %d iterations\n", length(stats.residuals))
```

```@example craig
using Krylov
using LinearAlgebra, Printf

m = 5
n = 8
λ = 1.0e-3
A = rand(m, n)
b = A * ones(n)
xy_exact = [A  λ*I] \ b # In Julia, this is the min-norm solution!

(x, y, stats) = craig(A, b, λ=λ, atol=0.0, rtol=1.0e-20, verbose=1)
show(stats)

# Check that we have a minimum-norm solution.
# When λ > 0 we solve min ‖(x,s)‖  s.t. Ax + λs = b, and we get s = λy.
@printf("Primal feasibility: %7.1e\n", norm(b - A * x - λ^2 * y) / norm(b))
@printf("Dual   feasibility: %7.1e\n", norm(x - A' * y) / norm(x))
@printf("Error in x: %7.1e\n", norm(x - xy_exact[1:n]) / norm(xy_exact[1:n]))
if λ > 0.0
  @printf("Error in y: %7.1e\n", norm(λ * y - xy_exact[n+1:n+m]) / norm(xy_exact[n+1:n+m]))
end
```

```@example cg_lanczos_shift
using Krylov, MatrixMarket, SuiteSparseMatrixCollection
using LinearAlgebra, Printf

function residuals(A, b, shifts, x)
  nshifts = length(shifts)
  r = [ (b - A * x[i] - shifts[i] * x[i]) for i = 1 : nshifts ]
  return r
end
ssmc = ssmc_db(verbose=false)
matrix = ssmc_matrices(ssmc, "HB", "1138_bus")
path = fetch_ssmc(matrix, format="MM")

A = MatrixMarket.mmread(joinpath(path[1], "$(matrix.name[1]).mtx"))
n, m = size(A)
b = ones(n)

# Solve (A + αI)x = b.
shifts = [1.0, 2.0, 3.0, 4.0]
(x, stats) = cg_lanczos_shift(A, b, shifts)
show(stats)
r = residuals(A, b, shifts, x)
resids = map(norm, r) / norm(b)
@printf("Relative residuals with shifts:\n")
for resid in resids
  @printf(" %8.1e", resid)
end
@printf("\n")
```

```@example tricg
using Krylov, LinearOperators
using LinearAlgebra, Printf, SparseArrays

# Identity matrix.
eye(n::Int) = sparse(1.0 * I, n, n)

# Symmetric quasi-definite systems and variants
n = m = 5
A = [2^(i/j)*j + (-1)^(i-j) * n*(i-1) for i = 1:n, j = 1:n]
b = ones(n)
M = diagm(0 => [3.0 * i for i = 1:n])
N = diagm(0 => [5.0 * i for i = 1:n])
c = -b

# [I   A] [x] = [b]
# [Aᴴ -I] [y]   [c]
(x, y, stats) = tricg(A, b, c)
K = [eye(m) A; A' -eye(n)]
B = [b; c]
r = B - K * [x; y]
resid = norm(r)
@printf("TriCG: Relative residual: %8.1e\n", resid)

# [-I   A] [x] = [b]
# [ Aᴴ  I] [y]   [c]
(x, y, stats) = tricg(A, b, c, flip=true)
K = [-eye(m) A; A' eye(n)]
B = [b; c]
r = B - K * [x; y]
resid = norm(r)
@printf("TriCG: Relative residual: %8.1e\n", resid)

# [I   A] [x] = [b]
# [Aᴴ  I] [y]   [c]
(x, y, stats) = tricg(A, b, c, spd=true)
K = [eye(m) A; A' eye(n)]
B = [b; c]
r = B - K * [x; y]
resid = norm(r)
@printf("TriCG: Relative residual: %8.1e\n", resid)

# [-I    A] [x] = [b]
# [ Aᴴ  -I] [y]   [c]
(x, y, stats) = tricg(A, b, c, snd=true)
K = [-eye(m) A; A' -eye(n)]
B = [b; c]
r = B - K * [x; y]
resid = norm(r)
@printf("TriCG: Relative residual: %8.1e\n", resid)

# [τI    A] [x] = [b]
# [ Aᴴ  νI] [y]   [c]
(τ, ν) = (1e-4, 1e2)
(x, y, stats) = tricg(A, b, c, τ=τ, ν=ν)
K = [τ*eye(m) A; A' ν*eye(n)]
B = [b; c]
r = B - K * [x; y]
resid = norm(r)
@printf("TriCG: Relative residual: %8.1e\n", resid)

# [M⁻¹  A  ] [x] = [b]
# [Aᴴ  -N⁻¹] [y]   [c]
(x, y, stats) = tricg(A, b, c, M=M, N=N, verbose=1)
K = [inv(M) A; A' -inv(N)]
H = BlockDiagonalOperator(M, N)
B = [b; c]
r = B - K * [x; y]
resid = sqrt(dot(r, H * r))
@printf("TriCG: Relative residual: %8.1e\n", resid)
```

```@example cgls
using MatrixMarket, SuiteSparseMatrixCollection
using Krylov, LinearOperators
using LinearAlgebra, Printf

ssmc = ssmc_db(verbose=false)
matrix = ssmc_matrices(ssmc, "HB", "well1033")
path = fetch_ssmc(matrix, format="MM")

A = MatrixMarket.mmread(joinpath(path[1], "$(matrix.name[1]).mtx"))
b = MatrixMarket.mmread(joinpath(path[1], "$(matrix.name[1])_b.mtx"))[:]
(m, n) = size(A)
@printf("System size: %d rows and %d columns\n", m, n)

# Define a regularization parameter.
λ = 1.0e-3

(x, stats) = cgls(A, b, λ=λ)
show(stats)
resid = norm(A' * (A * x - b) + λ * x) / norm(b)
@printf("CGLS: Relative residual: %8.1e\n", resid)
@printf("CGLS: ‖x‖: %8.1e\n", norm(x))
```

```@example symmlq
using Krylov
using LinearAlgebra, Printf

A = diagm([1.0; 2.0; 3.0; 0.0])
n = size(A, 1)
b = [1.0; 2.0; 3.0; 0.0]
b_norm = norm(b)

# SYMMLQ returns the minimum-norm solution of symmetric, singular and consistent systems
(x, stats) = symmlq(A, b, transfer_to_cg=false);
r = b - A * x;

@printf("Residual r: %s\n", Krylov.vec2str(r))
@printf("Relative residual norm ‖r‖: %8.1e\n", norm(r) / b_norm)
@printf("Solution x: %s\n", Krylov.vec2str(x))
@printf("Minimum-norm solution? %s\n", x ≈ [1.0; 1.0; 1.0; 0.0])
```

```@example dqgmres
using Krylov, LinearOperators, ILUZero, MatrixMarket
using LinearAlgebra, Printf, SuiteSparseMatrixCollection

ssmc = ssmc_db(verbose=false)
matrix = ssmc_matrices(ssmc, "Simon", "raefsky1")
path = fetch_ssmc(matrix, format="MM")

n = matrix.nrows[1]
A = MatrixMarket.mmread(joinpath(path[1], "$(matrix.name[1]).mtx"))
b = A * ones(n)

F = ilu0(A)

@printf("nnz(ILU) / nnz(A): %7.1e\n", nnz(F) / nnz(A))

# Solve Ax = b with DQGMRES and an ILU(0) preconditioner
# Remark: DIOM, FOM and GMRES can be used in the same way
opM = LinearOperator(Float64, n, n, false, false, (y, v) -> forward_substitution!(y, F, v))
opN = LinearOperator(Float64, n, n, false, false, (y, v) -> backward_substitution!(y, F, v))
opP = LinearOperator(Float64, n, n, false, false, (y, v) -> ldiv!(y, F, v))

# Without preconditioning
x, stats = dqgmres(A, b, memory=50, history=true)
r = b - A * x
@printf("[Without preconditioning] Residual norm: %8.1e\n", norm(r))
@printf("[Without preconditioning] Number of iterations: %3d\n", length(stats.residuals) - 1)

# Split preconditioning
x, stats = dqgmres(A, b, memory=50, history=true, M=opM, N=opN)
r = b - A * x
@printf("[Split preconditioning] Residual norm: %8.1e\n", norm(r))
@printf("[Split preconditioning] Number of iterations: %3d\n", length(stats.residuals) - 1)

# Left preconditioning
x, stats = dqgmres(A, b, memory=50, history=true, M=opP)
r = b - A * x
@printf("[Left preconditioning] Residual norm: %8.1e\n", norm(r))
@printf("[Left preconditioning] Number of iterations: %3d\n", length(stats.residuals) - 1)

# Right preconditioning
x, stats = dqgmres(A, b, memory=50, history=true, N=opP)
r = b - A * x
@printf("[Right preconditioning] Residual norm: %8.1e\n", norm(r))
@printf("[Right preconditioning] Number of iterations: %3d\n", length(stats.residuals) - 1)
```

```@example car
using Krylov, MatrixMarket, SuiteSparseMatrixCollection
using LinearAlgebra, Printf

ssmc = ssmc_db(verbose=false)
matrix = ssmc_matrices(ssmc, "Nasa", "nasa2146")
path = fetch_ssmc(matrix, format="MM")

n = matrix.nrows[1]
A = MatrixMarket.mmread(joinpath(path[1], "$(matrix.name[1]).mtx"))
b = ones(n)
b_norm = norm(b)

# Solve Ax = b.
(x, stats) = car(A, b)
show(stats)
r = b - A * x
@printf("Relative residual: %8.1e\n", norm(r) / b_norm)
```

```@example usymlqr
using LinearAlgebra, Printf, SparseArrays
using Krylov

# Identity matrix.
eye(n::Int) = sparse(1.0 * I, n, n)

# Saddle-point systems
n = m = 5
A = [2^(i/j)*j + (-1)^(i-j) * n*(i-1) for i = 1:n, j = 1:n]
b = ones(n)
D = diagm(0 => [2.0 * i for i = 1:n])
m, n = size(A)
c = -3*b

# [I   A] [x] = [b]
# [Aᴴ  0] [y]   [c]
(x, y, stats) = usymlqr(A, b, c)
K = [I A; A' zeros(n,n)]
d = [b; c]
r = d - K * [x; y]
resid = norm(r)
@printf("USYMLQR: Relative residual: %8.1e\n", resid)

# [I   A] [x] = [b]
# [Aᴴ  0] [y]   [0]
(x, y, stats) = usymlqr(A, b, c, ln=false)
K = [I A; A' zeros(n,n)]
d = [b; 0*c]
r = d - K * [x; y]
resid = norm(r)
@printf("USYMLQR: Relative residual: %8.1e\n", resid)

# [I   A] [x] = [0]
# [Aᴴ  0] [y]   [c]
(x, y, stats) = usymlqr(A, b, c, ls=false)
K = [I A; A' zeros(n,n)]
d = [0*b; c]
r = d - K * [x; y]
resid = norm(r)
@printf("USYMLQR: Relative residual: %8.1e\n", resid)
```

```@example minares
using Krylov, MatrixMarket, SuiteSparseMatrixCollection
using LinearAlgebra, Printf

ssmc = ssmc_db(verbose=false)
matrix = ssmc_matrices(ssmc, "GHS_indef", "laser")
path = fetch_ssmc(matrix, format="MM")

n = matrix.nrows[1]
A = MatrixMarket.mmread(joinpath(path[1], "$(matrix.name[1]).mtx"))
b = ones(n)

# Solve Ax = b.
x, stats = minares(A, b)
show(stats)
r = b - A * x
Ar = A * r
@printf("Relative A-residual: %8.1e\n", norm(A * r) / norm(A * b))
```

```@example trimr
using Krylov, LinearOperators, LDLFactorizations
using LinearAlgebra, Printf, SparseArrays

# Identity matrix.
eye(n::Int) = sparse(1.0 * I, n, n)

# Saddle-point systems
n = m = 5
A = [2^(i/j)*j + (-1)^(i-j) * n*(i-1) for i = 1:n, j = 1:n]
b = ones(n)
D = diagm(0 => [2.0 * i for i = 1:n])
m, n = size(A)
c = -b

# [D   A] [x] = [b]
# [Aᴴ  0] [y]   [c]
llt_D = cholesky(D)
opD⁻¹ = LinearOperator(Float64, 5, 5, true, true, (y, v) -> ldiv!(y, llt_D, v))
opH⁻¹ = BlockDiagonalOperator(opD⁻¹, eye(n))
(x, y, stats) = trimr(A, b, c, M=opD⁻¹, sp=true)
K = [D A; A' zeros(n,n)]
B = [b; c]
r = B - K * [x; y]
resid = sqrt(dot(r, opH⁻¹ * r))
@printf("TriMR: Relative residual: %8.1e\n", resid)

# Symmetric quasi-definite systems
n = m = 5
A = [2^(i/j)*j + (-1)^(i-j) * n*(i-1) for i = 1:n, j = 1:n]
b = ones(n)
M = diagm(0 => [3.0 * i for i = 1:n])
N = diagm(0 => [5.0 * i for i = 1:n])
c = -b

# [I   A] [x] = [b]
# [Aᴴ -I] [y]   [c]
(x, y, stats) = trimr(A, b, c)
K = [eye(m) A; A' -eye(n)]
B = [b; c]
r = B - K * [x; y]
resid = norm(r)
@printf("TriMR: Relative residual: %8.1e\n", resid)

# [M   A] [x] = [b]
# [Aᴴ -N] [y]   [c]
ldlt_M = ldl(M)
ldlt_N = ldl(N)
opM⁻¹ = LinearOperator(Float64, size(M,1), size(M,2), true, true, (y, v) -> ldiv!(y, ldlt_M, v))
opN⁻¹ = LinearOperator(Float64, size(N,1), size(N,2), true, true, (y, v) -> ldiv!(y, ldlt_N, v))
opH⁻¹ = BlockDiagonalOperator(opM⁻¹, opN⁻¹)
(x, y, stats) = trimr(A, b, c, M=opM⁻¹, N=opN⁻¹, verbose=1)
K = [M A; A' -N]
B = [b; c]
r = B - K * [x; y]
resid = sqrt(dot(r, opH⁻¹ * r))
@printf("TriMR: Relative residual: %8.1e\n", resid)
```
